(function (global, factory) {
	typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('@project-serum/anchor'), require('@solana/web3.js'), require('buffer'), require('util'), require('bs58'), require('process'), require('fs'), require('assert'), require('@project-serum/serum'), require('@pythnetwork/client'), require('big.js'), require('@solana/spl-token'), require('@switchboard-xyz/sbv2-lite'), require('cross-fetch')) :
	typeof define === 'function' && define.amd ? define(['exports', '@project-serum/anchor', '@solana/web3.js', 'buffer', 'util', 'bs58', 'process', 'fs', 'assert', '@project-serum/serum', '@pythnetwork/client', 'big.js', '@solana/spl-token', '@switchboard-xyz/sbv2-lite', 'cross-fetch'], factory) :
	(global = typeof globalThis !== 'undefined' ? globalThis : global || self, factory(global.mangoV4 = {}, global.Anchor, global.Web3, global.require$$0, global.require$$1$1, global.bs58, global.require$$2$1, global.require$$3$1, global.require$$0$2, global.Serum, global.PythClient, global.BigJs, global.SplToken, global.Switchboard, global.CrossFetch));
})(this, (function (exports, anchor, require$$0$1, require$$0, require$$1$1, bs58$1, require$$2$1, require$$3$1, require$$0$2, serum, client, Big, splToken$1, SwitchboardProgram, fetch) { 'use strict';

	var commonjsGlobal = typeof globalThis !== 'undefined' ? globalThis : typeof window !== 'undefined' ? window : typeof global !== 'undefined' ? global : typeof self !== 'undefined' ? self : {};

	function getAugmentedNamespace(n) {
	  if (n.__esModule) return n;
	  var f = n.default;
		if (typeof f == "function") {
			var a = function a () {
				if (this instanceof a) {
					var args = [null];
					args.push.apply(args, arguments);
					var Ctor = Function.bind.apply(f, args);
					return new Ctor();
				}
				return f.apply(this, arguments);
			};
			a.prototype = f.prototype;
	  } else a = {};
	  Object.defineProperty(a, '__esModule', {value: true});
		Object.keys(n).forEach(function (k) {
			var d = Object.getOwnPropertyDescriptor(n, k);
			Object.defineProperty(a, k, d.get ? d : {
				enumerable: true,
				get: function () {
					return n[k];
				}
			});
		});
		return a;
	}

	var token$1 = {};

	var program = {};

	var pako = {};

	var deflate$4 = {};

	var deflate$3 = {};

	var trees = {};

	// (C) 1995-2013 Jean-loup Gailly and Mark Adler
	// (C) 2014-2017 Vitaly Puzrin and Andrey Tupitsin
	//
	// This software is provided 'as-is', without any express or implied
	// warranty. In no event will the authors be held liable for any damages
	// arising from the use of this software.
	//
	// Permission is granted to anyone to use this software for any purpose,
	// including commercial applications, and to alter it and redistribute it
	// freely, subject to the following restrictions:
	//
	// 1. The origin of this software must not be misrepresented; you must not
	//   claim that you wrote the original software. If you use this software
	//   in a product, an acknowledgment in the product documentation would be
	//   appreciated but is not required.
	// 2. Altered source versions must be plainly marked as such, and must not be
	//   misrepresented as being the original software.
	// 3. This notice may not be removed or altered from any source distribution.

	/* eslint-disable space-unary-ops */

	/* Public constants ==========================================================*/
	/* ===========================================================================*/


	//const Z_FILTERED          = 1;
	//const Z_HUFFMAN_ONLY      = 2;
	//const Z_RLE               = 3;
	const Z_FIXED$1               = 4;
	//const Z_DEFAULT_STRATEGY  = 0;

	/* Possible values of the data_type field (though see inflate()) */
	const Z_BINARY              = 0;
	const Z_TEXT                = 1;
	//const Z_ASCII             = 1; // = Z_TEXT
	const Z_UNKNOWN$1             = 2;

	/*============================================================================*/


	function zero$1(buf) { let len = buf.length; while (--len >= 0) { buf[len] = 0; } }

	// From zutil.h

	const STORED_BLOCK = 0;
	const STATIC_TREES = 1;
	const DYN_TREES    = 2;
	/* The three kinds of block type */

	const MIN_MATCH$1    = 3;
	const MAX_MATCH$1    = 258;
	/* The minimum and maximum match lengths */

	// From deflate.h
	/* ===========================================================================
	 * Internal compression state.
	 */

	const LENGTH_CODES$1  = 29;
	/* number of length codes, not counting the special END_BLOCK code */

	const LITERALS$1      = 256;
	/* number of literal bytes 0..255 */

	const L_CODES$1       = LITERALS$1 + 1 + LENGTH_CODES$1;
	/* number of Literal or Length codes, including the END_BLOCK code */

	const D_CODES$1       = 30;
	/* number of distance codes */

	const BL_CODES$1      = 19;
	/* number of codes used to transfer the bit lengths */

	const HEAP_SIZE$1     = 2 * L_CODES$1 + 1;
	/* maximum heap size */

	const MAX_BITS$1      = 15;
	/* All codes must not exceed MAX_BITS bits */

	const Buf_size      = 16;
	/* size of bit buffer in bi_buf */


	/* ===========================================================================
	 * Constants
	 */

	const MAX_BL_BITS = 7;
	/* Bit length codes must not exceed MAX_BL_BITS bits */

	const END_BLOCK   = 256;
	/* end of block literal code */

	const REP_3_6     = 16;
	/* repeat previous bit length 3-6 times (2 bits of repeat count) */

	const REPZ_3_10   = 17;
	/* repeat a zero length 3-10 times  (3 bits of repeat count) */

	const REPZ_11_138 = 18;
	/* repeat a zero length 11-138 times  (7 bits of repeat count) */

	/* eslint-disable comma-spacing,array-bracket-spacing */
	const extra_lbits =   /* extra bits for each length code */
	  new Uint8Array([0,0,0,0,0,0,0,0,1,1,1,1,2,2,2,2,3,3,3,3,4,4,4,4,5,5,5,5,0]);

	const extra_dbits =   /* extra bits for each distance code */
	  new Uint8Array([0,0,0,0,1,1,2,2,3,3,4,4,5,5,6,6,7,7,8,8,9,9,10,10,11,11,12,12,13,13]);

	const extra_blbits =  /* extra bits for each bit length code */
	  new Uint8Array([0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,3,7]);

	const bl_order =
	  new Uint8Array([16,17,18,0,8,7,9,6,10,5,11,4,12,3,13,2,14,1,15]);
	/* eslint-enable comma-spacing,array-bracket-spacing */

	/* The lengths of the bit length codes are sent in order of decreasing
	 * probability, to avoid transmitting the lengths for unused bit length codes.
	 */

	/* ===========================================================================
	 * Local data. These are initialized only once.
	 */

	// We pre-fill arrays with 0 to avoid uninitialized gaps

	const DIST_CODE_LEN = 512; /* see definition of array dist_code below */

	// !!!! Use flat array instead of structure, Freq = i*2, Len = i*2+1
	const static_ltree  = new Array((L_CODES$1 + 2) * 2);
	zero$1(static_ltree);
	/* The static literal tree. Since the bit lengths are imposed, there is no
	 * need for the L_CODES extra codes used during heap construction. However
	 * The codes 286 and 287 are needed to build a canonical tree (see _tr_init
	 * below).
	 */

	const static_dtree  = new Array(D_CODES$1 * 2);
	zero$1(static_dtree);
	/* The static distance tree. (Actually a trivial tree since all codes use
	 * 5 bits.)
	 */

	const _dist_code    = new Array(DIST_CODE_LEN);
	zero$1(_dist_code);
	/* Distance codes. The first 256 values correspond to the distances
	 * 3 .. 258, the last 256 values correspond to the top 8 bits of
	 * the 15 bit distances.
	 */

	const _length_code  = new Array(MAX_MATCH$1 - MIN_MATCH$1 + 1);
	zero$1(_length_code);
	/* length code for each normalized match length (0 == MIN_MATCH) */

	const base_length   = new Array(LENGTH_CODES$1);
	zero$1(base_length);
	/* First normalized length for each code (0 = MIN_MATCH) */

	const base_dist     = new Array(D_CODES$1);
	zero$1(base_dist);
	/* First normalized distance for each code (0 = distance of 1) */


	function StaticTreeDesc(static_tree, extra_bits, extra_base, elems, max_length) {

	  this.static_tree  = static_tree;  /* static tree or NULL */
	  this.extra_bits   = extra_bits;   /* extra bits for each code or NULL */
	  this.extra_base   = extra_base;   /* base index for extra_bits */
	  this.elems        = elems;        /* max number of elements in the tree */
	  this.max_length   = max_length;   /* max bit length for the codes */

	  // show if `static_tree` has data or dummy - needed for monomorphic objects
	  this.has_stree    = static_tree && static_tree.length;
	}


	let static_l_desc;
	let static_d_desc;
	let static_bl_desc;


	function TreeDesc(dyn_tree, stat_desc) {
	  this.dyn_tree = dyn_tree;     /* the dynamic tree */
	  this.max_code = 0;            /* largest code with non zero frequency */
	  this.stat_desc = stat_desc;   /* the corresponding static tree */
	}



	const d_code = (dist) => {

	  return dist < 256 ? _dist_code[dist] : _dist_code[256 + (dist >>> 7)];
	};


	/* ===========================================================================
	 * Output a short LSB first on the stream.
	 * IN assertion: there is enough room in pendingBuf.
	 */
	const put_short = (s, w) => {
	//    put_byte(s, (uch)((w) & 0xff));
	//    put_byte(s, (uch)((ush)(w) >> 8));
	  s.pending_buf[s.pending++] = (w) & 0xff;
	  s.pending_buf[s.pending++] = (w >>> 8) & 0xff;
	};


	/* ===========================================================================
	 * Send a value on a given number of bits.
	 * IN assertion: length <= 16 and value fits in length bits.
	 */
	const send_bits = (s, value, length) => {

	  if (s.bi_valid > (Buf_size - length)) {
	    s.bi_buf |= (value << s.bi_valid) & 0xffff;
	    put_short(s, s.bi_buf);
	    s.bi_buf = value >> (Buf_size - s.bi_valid);
	    s.bi_valid += length - Buf_size;
	  } else {
	    s.bi_buf |= (value << s.bi_valid) & 0xffff;
	    s.bi_valid += length;
	  }
	};


	const send_code = (s, c, tree) => {

	  send_bits(s, tree[c * 2]/*.Code*/, tree[c * 2 + 1]/*.Len*/);
	};


	/* ===========================================================================
	 * Reverse the first len bits of a code, using straightforward code (a faster
	 * method would use a table)
	 * IN assertion: 1 <= len <= 15
	 */
	const bi_reverse = (code, len) => {

	  let res = 0;
	  do {
	    res |= code & 1;
	    code >>>= 1;
	    res <<= 1;
	  } while (--len > 0);
	  return res >>> 1;
	};


	/* ===========================================================================
	 * Flush the bit buffer, keeping at most 7 bits in it.
	 */
	const bi_flush = (s) => {

	  if (s.bi_valid === 16) {
	    put_short(s, s.bi_buf);
	    s.bi_buf = 0;
	    s.bi_valid = 0;

	  } else if (s.bi_valid >= 8) {
	    s.pending_buf[s.pending++] = s.bi_buf & 0xff;
	    s.bi_buf >>= 8;
	    s.bi_valid -= 8;
	  }
	};


	/* ===========================================================================
	 * Compute the optimal bit lengths for a tree and update the total bit length
	 * for the current block.
	 * IN assertion: the fields freq and dad are set, heap[heap_max] and
	 *    above are the tree nodes sorted by increasing frequency.
	 * OUT assertions: the field len is set to the optimal bit length, the
	 *     array bl_count contains the frequencies for each bit length.
	 *     The length opt_len is updated; static_len is also updated if stree is
	 *     not null.
	 */
	const gen_bitlen = (s, desc) =>
	//    deflate_state *s;
	//    tree_desc *desc;    /* the tree descriptor */
	{
	  const tree            = desc.dyn_tree;
	  const max_code        = desc.max_code;
	  const stree           = desc.stat_desc.static_tree;
	  const has_stree       = desc.stat_desc.has_stree;
	  const extra           = desc.stat_desc.extra_bits;
	  const base            = desc.stat_desc.extra_base;
	  const max_length      = desc.stat_desc.max_length;
	  let h;              /* heap index */
	  let n, m;           /* iterate over the tree elements */
	  let bits;           /* bit length */
	  let xbits;          /* extra bits */
	  let f;              /* frequency */
	  let overflow = 0;   /* number of elements with bit length too large */

	  for (bits = 0; bits <= MAX_BITS$1; bits++) {
	    s.bl_count[bits] = 0;
	  }

	  /* In a first pass, compute the optimal bit lengths (which may
	   * overflow in the case of the bit length tree).
	   */
	  tree[s.heap[s.heap_max] * 2 + 1]/*.Len*/ = 0; /* root of the heap */

	  for (h = s.heap_max + 1; h < HEAP_SIZE$1; h++) {
	    n = s.heap[h];
	    bits = tree[tree[n * 2 + 1]/*.Dad*/ * 2 + 1]/*.Len*/ + 1;
	    if (bits > max_length) {
	      bits = max_length;
	      overflow++;
	    }
	    tree[n * 2 + 1]/*.Len*/ = bits;
	    /* We overwrite tree[n].Dad which is no longer needed */

	    if (n > max_code) { continue; } /* not a leaf node */

	    s.bl_count[bits]++;
	    xbits = 0;
	    if (n >= base) {
	      xbits = extra[n - base];
	    }
	    f = tree[n * 2]/*.Freq*/;
	    s.opt_len += f * (bits + xbits);
	    if (has_stree) {
	      s.static_len += f * (stree[n * 2 + 1]/*.Len*/ + xbits);
	    }
	  }
	  if (overflow === 0) { return; }

	  // Trace((stderr,"\nbit length overflow\n"));
	  /* This happens for example on obj2 and pic of the Calgary corpus */

	  /* Find the first bit length which could increase: */
	  do {
	    bits = max_length - 1;
	    while (s.bl_count[bits] === 0) { bits--; }
	    s.bl_count[bits]--;      /* move one leaf down the tree */
	    s.bl_count[bits + 1] += 2; /* move one overflow item as its brother */
	    s.bl_count[max_length]--;
	    /* The brother of the overflow item also moves one step up,
	     * but this does not affect bl_count[max_length]
	     */
	    overflow -= 2;
	  } while (overflow > 0);

	  /* Now recompute all bit lengths, scanning in increasing frequency.
	   * h is still equal to HEAP_SIZE. (It is simpler to reconstruct all
	   * lengths instead of fixing only the wrong ones. This idea is taken
	   * from 'ar' written by Haruhiko Okumura.)
	   */
	  for (bits = max_length; bits !== 0; bits--) {
	    n = s.bl_count[bits];
	    while (n !== 0) {
	      m = s.heap[--h];
	      if (m > max_code) { continue; }
	      if (tree[m * 2 + 1]/*.Len*/ !== bits) {
	        // Trace((stderr,"code %d bits %d->%d\n", m, tree[m].Len, bits));
	        s.opt_len += (bits - tree[m * 2 + 1]/*.Len*/) * tree[m * 2]/*.Freq*/;
	        tree[m * 2 + 1]/*.Len*/ = bits;
	      }
	      n--;
	    }
	  }
	};


	/* ===========================================================================
	 * Generate the codes for a given tree and bit counts (which need not be
	 * optimal).
	 * IN assertion: the array bl_count contains the bit length statistics for
	 * the given tree and the field len is set for all tree elements.
	 * OUT assertion: the field code is set for all tree elements of non
	 *     zero code length.
	 */
	const gen_codes = (tree, max_code, bl_count) =>
	//    ct_data *tree;             /* the tree to decorate */
	//    int max_code;              /* largest code with non zero frequency */
	//    ushf *bl_count;            /* number of codes at each bit length */
	{
	  const next_code = new Array(MAX_BITS$1 + 1); /* next code value for each bit length */
	  let code = 0;              /* running code value */
	  let bits;                  /* bit index */
	  let n;                     /* code index */

	  /* The distribution counts are first used to generate the code values
	   * without bit reversal.
	   */
	  for (bits = 1; bits <= MAX_BITS$1; bits++) {
	    next_code[bits] = code = (code + bl_count[bits - 1]) << 1;
	  }
	  /* Check that the bit counts in bl_count are consistent. The last code
	   * must be all ones.
	   */
	  //Assert (code + bl_count[MAX_BITS]-1 == (1<<MAX_BITS)-1,
	  //        "inconsistent bit counts");
	  //Tracev((stderr,"\ngen_codes: max_code %d ", max_code));

	  for (n = 0;  n <= max_code; n++) {
	    let len = tree[n * 2 + 1]/*.Len*/;
	    if (len === 0) { continue; }
	    /* Now reverse the bits */
	    tree[n * 2]/*.Code*/ = bi_reverse(next_code[len]++, len);

	    //Tracecv(tree != static_ltree, (stderr,"\nn %3d %c l %2d c %4x (%x) ",
	    //     n, (isgraph(n) ? n : ' '), len, tree[n].Code, next_code[len]-1));
	  }
	};


	/* ===========================================================================
	 * Initialize the various 'constant' tables.
	 */
	const tr_static_init = () => {

	  let n;        /* iterates over tree elements */
	  let bits;     /* bit counter */
	  let length;   /* length value */
	  let code;     /* code value */
	  let dist;     /* distance index */
	  const bl_count = new Array(MAX_BITS$1 + 1);
	  /* number of codes at each bit length for an optimal tree */

	  // do check in _tr_init()
	  //if (static_init_done) return;

	  /* For some embedded targets, global variables are not initialized: */
	/*#ifdef NO_INIT_GLOBAL_POINTERS
	  static_l_desc.static_tree = static_ltree;
	  static_l_desc.extra_bits = extra_lbits;
	  static_d_desc.static_tree = static_dtree;
	  static_d_desc.extra_bits = extra_dbits;
	  static_bl_desc.extra_bits = extra_blbits;
	#endif*/

	  /* Initialize the mapping length (0..255) -> length code (0..28) */
	  length = 0;
	  for (code = 0; code < LENGTH_CODES$1 - 1; code++) {
	    base_length[code] = length;
	    for (n = 0; n < (1 << extra_lbits[code]); n++) {
	      _length_code[length++] = code;
	    }
	  }
	  //Assert (length == 256, "tr_static_init: length != 256");
	  /* Note that the length 255 (match length 258) can be represented
	   * in two different ways: code 284 + 5 bits or code 285, so we
	   * overwrite length_code[255] to use the best encoding:
	   */
	  _length_code[length - 1] = code;

	  /* Initialize the mapping dist (0..32K) -> dist code (0..29) */
	  dist = 0;
	  for (code = 0; code < 16; code++) {
	    base_dist[code] = dist;
	    for (n = 0; n < (1 << extra_dbits[code]); n++) {
	      _dist_code[dist++] = code;
	    }
	  }
	  //Assert (dist == 256, "tr_static_init: dist != 256");
	  dist >>= 7; /* from now on, all distances are divided by 128 */
	  for (; code < D_CODES$1; code++) {
	    base_dist[code] = dist << 7;
	    for (n = 0; n < (1 << (extra_dbits[code] - 7)); n++) {
	      _dist_code[256 + dist++] = code;
	    }
	  }
	  //Assert (dist == 256, "tr_static_init: 256+dist != 512");

	  /* Construct the codes of the static literal tree */
	  for (bits = 0; bits <= MAX_BITS$1; bits++) {
	    bl_count[bits] = 0;
	  }

	  n = 0;
	  while (n <= 143) {
	    static_ltree[n * 2 + 1]/*.Len*/ = 8;
	    n++;
	    bl_count[8]++;
	  }
	  while (n <= 255) {
	    static_ltree[n * 2 + 1]/*.Len*/ = 9;
	    n++;
	    bl_count[9]++;
	  }
	  while (n <= 279) {
	    static_ltree[n * 2 + 1]/*.Len*/ = 7;
	    n++;
	    bl_count[7]++;
	  }
	  while (n <= 287) {
	    static_ltree[n * 2 + 1]/*.Len*/ = 8;
	    n++;
	    bl_count[8]++;
	  }
	  /* Codes 286 and 287 do not exist, but we must include them in the
	   * tree construction to get a canonical Huffman tree (longest code
	   * all ones)
	   */
	  gen_codes(static_ltree, L_CODES$1 + 1, bl_count);

	  /* The static distance tree is trivial: */
	  for (n = 0; n < D_CODES$1; n++) {
	    static_dtree[n * 2 + 1]/*.Len*/ = 5;
	    static_dtree[n * 2]/*.Code*/ = bi_reverse(n, 5);
	  }

	  // Now data ready and we can init static trees
	  static_l_desc = new StaticTreeDesc(static_ltree, extra_lbits, LITERALS$1 + 1, L_CODES$1, MAX_BITS$1);
	  static_d_desc = new StaticTreeDesc(static_dtree, extra_dbits, 0,          D_CODES$1, MAX_BITS$1);
	  static_bl_desc = new StaticTreeDesc(new Array(0), extra_blbits, 0,         BL_CODES$1, MAX_BL_BITS);

	  //static_init_done = true;
	};


	/* ===========================================================================
	 * Initialize a new block.
	 */
	const init_block = (s) => {

	  let n; /* iterates over tree elements */

	  /* Initialize the trees. */
	  for (n = 0; n < L_CODES$1;  n++) { s.dyn_ltree[n * 2]/*.Freq*/ = 0; }
	  for (n = 0; n < D_CODES$1;  n++) { s.dyn_dtree[n * 2]/*.Freq*/ = 0; }
	  for (n = 0; n < BL_CODES$1; n++) { s.bl_tree[n * 2]/*.Freq*/ = 0; }

	  s.dyn_ltree[END_BLOCK * 2]/*.Freq*/ = 1;
	  s.opt_len = s.static_len = 0;
	  s.last_lit = s.matches = 0;
	};


	/* ===========================================================================
	 * Flush the bit buffer and align the output on a byte boundary
	 */
	const bi_windup = (s) =>
	{
	  if (s.bi_valid > 8) {
	    put_short(s, s.bi_buf);
	  } else if (s.bi_valid > 0) {
	    //put_byte(s, (Byte)s->bi_buf);
	    s.pending_buf[s.pending++] = s.bi_buf;
	  }
	  s.bi_buf = 0;
	  s.bi_valid = 0;
	};

	/* ===========================================================================
	 * Copy a stored block, storing first the length and its
	 * one's complement if requested.
	 */
	const copy_block = (s, buf, len, header) =>
	//DeflateState *s;
	//charf    *buf;    /* the input data */
	//unsigned len;     /* its length */
	//int      header;  /* true if block header must be written */
	{
	  bi_windup(s);        /* align on byte boundary */

	  if (header) {
	    put_short(s, len);
	    put_short(s, ~len);
	  }
	//  while (len--) {
	//    put_byte(s, *buf++);
	//  }
	  s.pending_buf.set(s.window.subarray(buf, buf + len), s.pending);
	  s.pending += len;
	};

	/* ===========================================================================
	 * Compares to subtrees, using the tree depth as tie breaker when
	 * the subtrees have equal frequency. This minimizes the worst case length.
	 */
	const smaller = (tree, n, m, depth) => {

	  const _n2 = n * 2;
	  const _m2 = m * 2;
	  return (tree[_n2]/*.Freq*/ < tree[_m2]/*.Freq*/ ||
	         (tree[_n2]/*.Freq*/ === tree[_m2]/*.Freq*/ && depth[n] <= depth[m]));
	};

	/* ===========================================================================
	 * Restore the heap property by moving down the tree starting at node k,
	 * exchanging a node with the smallest of its two sons if necessary, stopping
	 * when the heap property is re-established (each father smaller than its
	 * two sons).
	 */
	const pqdownheap = (s, tree, k) =>
	//    deflate_state *s;
	//    ct_data *tree;  /* the tree to restore */
	//    int k;               /* node to move down */
	{
	  const v = s.heap[k];
	  let j = k << 1;  /* left son of k */
	  while (j <= s.heap_len) {
	    /* Set j to the smallest of the two sons: */
	    if (j < s.heap_len &&
	      smaller(tree, s.heap[j + 1], s.heap[j], s.depth)) {
	      j++;
	    }
	    /* Exit if v is smaller than both sons */
	    if (smaller(tree, v, s.heap[j], s.depth)) { break; }

	    /* Exchange v with the smallest son */
	    s.heap[k] = s.heap[j];
	    k = j;

	    /* And continue down the tree, setting j to the left son of k */
	    j <<= 1;
	  }
	  s.heap[k] = v;
	};


	// inlined manually
	// const SMALLEST = 1;

	/* ===========================================================================
	 * Send the block data compressed using the given Huffman trees
	 */
	const compress_block = (s, ltree, dtree) =>
	//    deflate_state *s;
	//    const ct_data *ltree; /* literal tree */
	//    const ct_data *dtree; /* distance tree */
	{
	  let dist;           /* distance of matched string */
	  let lc;             /* match length or unmatched char (if dist == 0) */
	  let lx = 0;         /* running index in l_buf */
	  let code;           /* the code to send */
	  let extra;          /* number of extra bits to send */

	  if (s.last_lit !== 0) {
	    do {
	      dist = (s.pending_buf[s.d_buf + lx * 2] << 8) | (s.pending_buf[s.d_buf + lx * 2 + 1]);
	      lc = s.pending_buf[s.l_buf + lx];
	      lx++;

	      if (dist === 0) {
	        send_code(s, lc, ltree); /* send a literal byte */
	        //Tracecv(isgraph(lc), (stderr," '%c' ", lc));
	      } else {
	        /* Here, lc is the match length - MIN_MATCH */
	        code = _length_code[lc];
	        send_code(s, code + LITERALS$1 + 1, ltree); /* send the length code */
	        extra = extra_lbits[code];
	        if (extra !== 0) {
	          lc -= base_length[code];
	          send_bits(s, lc, extra);       /* send the extra length bits */
	        }
	        dist--; /* dist is now the match distance - 1 */
	        code = d_code(dist);
	        //Assert (code < D_CODES, "bad d_code");

	        send_code(s, code, dtree);       /* send the distance code */
	        extra = extra_dbits[code];
	        if (extra !== 0) {
	          dist -= base_dist[code];
	          send_bits(s, dist, extra);   /* send the extra distance bits */
	        }
	      } /* literal or match pair ? */

	      /* Check that the overlay between pending_buf and d_buf+l_buf is ok: */
	      //Assert((uInt)(s->pending) < s->lit_bufsize + 2*lx,
	      //       "pendingBuf overflow");

	    } while (lx < s.last_lit);
	  }

	  send_code(s, END_BLOCK, ltree);
	};


	/* ===========================================================================
	 * Construct one Huffman tree and assigns the code bit strings and lengths.
	 * Update the total bit length for the current block.
	 * IN assertion: the field freq is set for all tree elements.
	 * OUT assertions: the fields len and code are set to the optimal bit length
	 *     and corresponding code. The length opt_len is updated; static_len is
	 *     also updated if stree is not null. The field max_code is set.
	 */
	const build_tree = (s, desc) =>
	//    deflate_state *s;
	//    tree_desc *desc; /* the tree descriptor */
	{
	  const tree     = desc.dyn_tree;
	  const stree    = desc.stat_desc.static_tree;
	  const has_stree = desc.stat_desc.has_stree;
	  const elems    = desc.stat_desc.elems;
	  let n, m;          /* iterate over heap elements */
	  let max_code = -1; /* largest code with non zero frequency */
	  let node;          /* new node being created */

	  /* Construct the initial heap, with least frequent element in
	   * heap[SMALLEST]. The sons of heap[n] are heap[2*n] and heap[2*n+1].
	   * heap[0] is not used.
	   */
	  s.heap_len = 0;
	  s.heap_max = HEAP_SIZE$1;

	  for (n = 0; n < elems; n++) {
	    if (tree[n * 2]/*.Freq*/ !== 0) {
	      s.heap[++s.heap_len] = max_code = n;
	      s.depth[n] = 0;

	    } else {
	      tree[n * 2 + 1]/*.Len*/ = 0;
	    }
	  }

	  /* The pkzip format requires that at least one distance code exists,
	   * and that at least one bit should be sent even if there is only one
	   * possible code. So to avoid special checks later on we force at least
	   * two codes of non zero frequency.
	   */
	  while (s.heap_len < 2) {
	    node = s.heap[++s.heap_len] = (max_code < 2 ? ++max_code : 0);
	    tree[node * 2]/*.Freq*/ = 1;
	    s.depth[node] = 0;
	    s.opt_len--;

	    if (has_stree) {
	      s.static_len -= stree[node * 2 + 1]/*.Len*/;
	    }
	    /* node is 0 or 1 so it does not have extra bits */
	  }
	  desc.max_code = max_code;

	  /* The elements heap[heap_len/2+1 .. heap_len] are leaves of the tree,
	   * establish sub-heaps of increasing lengths:
	   */
	  for (n = (s.heap_len >> 1/*int /2*/); n >= 1; n--) { pqdownheap(s, tree, n); }

	  /* Construct the Huffman tree by repeatedly combining the least two
	   * frequent nodes.
	   */
	  node = elems;              /* next internal node of the tree */
	  do {
	    //pqremove(s, tree, n);  /* n = node of least frequency */
	    /*** pqremove ***/
	    n = s.heap[1/*SMALLEST*/];
	    s.heap[1/*SMALLEST*/] = s.heap[s.heap_len--];
	    pqdownheap(s, tree, 1/*SMALLEST*/);
	    /***/

	    m = s.heap[1/*SMALLEST*/]; /* m = node of next least frequency */

	    s.heap[--s.heap_max] = n; /* keep the nodes sorted by frequency */
	    s.heap[--s.heap_max] = m;

	    /* Create a new node father of n and m */
	    tree[node * 2]/*.Freq*/ = tree[n * 2]/*.Freq*/ + tree[m * 2]/*.Freq*/;
	    s.depth[node] = (s.depth[n] >= s.depth[m] ? s.depth[n] : s.depth[m]) + 1;
	    tree[n * 2 + 1]/*.Dad*/ = tree[m * 2 + 1]/*.Dad*/ = node;

	    /* and insert the new node in the heap */
	    s.heap[1/*SMALLEST*/] = node++;
	    pqdownheap(s, tree, 1/*SMALLEST*/);

	  } while (s.heap_len >= 2);

	  s.heap[--s.heap_max] = s.heap[1/*SMALLEST*/];

	  /* At this point, the fields freq and dad are set. We can now
	   * generate the bit lengths.
	   */
	  gen_bitlen(s, desc);

	  /* The field len is now set, we can generate the bit codes */
	  gen_codes(tree, max_code, s.bl_count);
	};


	/* ===========================================================================
	 * Scan a literal or distance tree to determine the frequencies of the codes
	 * in the bit length tree.
	 */
	const scan_tree = (s, tree, max_code) =>
	//    deflate_state *s;
	//    ct_data *tree;   /* the tree to be scanned */
	//    int max_code;    /* and its largest code of non zero frequency */
	{
	  let n;                     /* iterates over all tree elements */
	  let prevlen = -1;          /* last emitted length */
	  let curlen;                /* length of current code */

	  let nextlen = tree[0 * 2 + 1]/*.Len*/; /* length of next code */

	  let count = 0;             /* repeat count of the current code */
	  let max_count = 7;         /* max repeat count */
	  let min_count = 4;         /* min repeat count */

	  if (nextlen === 0) {
	    max_count = 138;
	    min_count = 3;
	  }
	  tree[(max_code + 1) * 2 + 1]/*.Len*/ = 0xffff; /* guard */

	  for (n = 0; n <= max_code; n++) {
	    curlen = nextlen;
	    nextlen = tree[(n + 1) * 2 + 1]/*.Len*/;

	    if (++count < max_count && curlen === nextlen) {
	      continue;

	    } else if (count < min_count) {
	      s.bl_tree[curlen * 2]/*.Freq*/ += count;

	    } else if (curlen !== 0) {

	      if (curlen !== prevlen) { s.bl_tree[curlen * 2]/*.Freq*/++; }
	      s.bl_tree[REP_3_6 * 2]/*.Freq*/++;

	    } else if (count <= 10) {
	      s.bl_tree[REPZ_3_10 * 2]/*.Freq*/++;

	    } else {
	      s.bl_tree[REPZ_11_138 * 2]/*.Freq*/++;
	    }

	    count = 0;
	    prevlen = curlen;

	    if (nextlen === 0) {
	      max_count = 138;
	      min_count = 3;

	    } else if (curlen === nextlen) {
	      max_count = 6;
	      min_count = 3;

	    } else {
	      max_count = 7;
	      min_count = 4;
	    }
	  }
	};


	/* ===========================================================================
	 * Send a literal or distance tree in compressed form, using the codes in
	 * bl_tree.
	 */
	const send_tree = (s, tree, max_code) =>
	//    deflate_state *s;
	//    ct_data *tree; /* the tree to be scanned */
	//    int max_code;       /* and its largest code of non zero frequency */
	{
	  let n;                     /* iterates over all tree elements */
	  let prevlen = -1;          /* last emitted length */
	  let curlen;                /* length of current code */

	  let nextlen = tree[0 * 2 + 1]/*.Len*/; /* length of next code */

	  let count = 0;             /* repeat count of the current code */
	  let max_count = 7;         /* max repeat count */
	  let min_count = 4;         /* min repeat count */

	  /* tree[max_code+1].Len = -1; */  /* guard already set */
	  if (nextlen === 0) {
	    max_count = 138;
	    min_count = 3;
	  }

	  for (n = 0; n <= max_code; n++) {
	    curlen = nextlen;
	    nextlen = tree[(n + 1) * 2 + 1]/*.Len*/;

	    if (++count < max_count && curlen === nextlen) {
	      continue;

	    } else if (count < min_count) {
	      do { send_code(s, curlen, s.bl_tree); } while (--count !== 0);

	    } else if (curlen !== 0) {
	      if (curlen !== prevlen) {
	        send_code(s, curlen, s.bl_tree);
	        count--;
	      }
	      //Assert(count >= 3 && count <= 6, " 3_6?");
	      send_code(s, REP_3_6, s.bl_tree);
	      send_bits(s, count - 3, 2);

	    } else if (count <= 10) {
	      send_code(s, REPZ_3_10, s.bl_tree);
	      send_bits(s, count - 3, 3);

	    } else {
	      send_code(s, REPZ_11_138, s.bl_tree);
	      send_bits(s, count - 11, 7);
	    }

	    count = 0;
	    prevlen = curlen;
	    if (nextlen === 0) {
	      max_count = 138;
	      min_count = 3;

	    } else if (curlen === nextlen) {
	      max_count = 6;
	      min_count = 3;

	    } else {
	      max_count = 7;
	      min_count = 4;
	    }
	  }
	};


	/* ===========================================================================
	 * Construct the Huffman tree for the bit lengths and return the index in
	 * bl_order of the last bit length code to send.
	 */
	const build_bl_tree = (s) => {

	  let max_blindex;  /* index of last bit length code of non zero freq */

	  /* Determine the bit length frequencies for literal and distance trees */
	  scan_tree(s, s.dyn_ltree, s.l_desc.max_code);
	  scan_tree(s, s.dyn_dtree, s.d_desc.max_code);

	  /* Build the bit length tree: */
	  build_tree(s, s.bl_desc);
	  /* opt_len now includes the length of the tree representations, except
	   * the lengths of the bit lengths codes and the 5+5+4 bits for the counts.
	   */

	  /* Determine the number of bit length codes to send. The pkzip format
	   * requires that at least 4 bit length codes be sent. (appnote.txt says
	   * 3 but the actual value used is 4.)
	   */
	  for (max_blindex = BL_CODES$1 - 1; max_blindex >= 3; max_blindex--) {
	    if (s.bl_tree[bl_order[max_blindex] * 2 + 1]/*.Len*/ !== 0) {
	      break;
	    }
	  }
	  /* Update opt_len to include the bit length tree and counts */
	  s.opt_len += 3 * (max_blindex + 1) + 5 + 5 + 4;
	  //Tracev((stderr, "\ndyn trees: dyn %ld, stat %ld",
	  //        s->opt_len, s->static_len));

	  return max_blindex;
	};


	/* ===========================================================================
	 * Send the header for a block using dynamic Huffman trees: the counts, the
	 * lengths of the bit length codes, the literal tree and the distance tree.
	 * IN assertion: lcodes >= 257, dcodes >= 1, blcodes >= 4.
	 */
	const send_all_trees = (s, lcodes, dcodes, blcodes) =>
	//    deflate_state *s;
	//    int lcodes, dcodes, blcodes; /* number of codes for each tree */
	{
	  let rank;                    /* index in bl_order */

	  //Assert (lcodes >= 257 && dcodes >= 1 && blcodes >= 4, "not enough codes");
	  //Assert (lcodes <= L_CODES && dcodes <= D_CODES && blcodes <= BL_CODES,
	  //        "too many codes");
	  //Tracev((stderr, "\nbl counts: "));
	  send_bits(s, lcodes - 257, 5); /* not +255 as stated in appnote.txt */
	  send_bits(s, dcodes - 1,   5);
	  send_bits(s, blcodes - 4,  4); /* not -3 as stated in appnote.txt */
	  for (rank = 0; rank < blcodes; rank++) {
	    //Tracev((stderr, "\nbl code %2d ", bl_order[rank]));
	    send_bits(s, s.bl_tree[bl_order[rank] * 2 + 1]/*.Len*/, 3);
	  }
	  //Tracev((stderr, "\nbl tree: sent %ld", s->bits_sent));

	  send_tree(s, s.dyn_ltree, lcodes - 1); /* literal tree */
	  //Tracev((stderr, "\nlit tree: sent %ld", s->bits_sent));

	  send_tree(s, s.dyn_dtree, dcodes - 1); /* distance tree */
	  //Tracev((stderr, "\ndist tree: sent %ld", s->bits_sent));
	};


	/* ===========================================================================
	 * Check if the data type is TEXT or BINARY, using the following algorithm:
	 * - TEXT if the two conditions below are satisfied:
	 *    a) There are no non-portable control characters belonging to the
	 *       "black list" (0..6, 14..25, 28..31).
	 *    b) There is at least one printable character belonging to the
	 *       "white list" (9 {TAB}, 10 {LF}, 13 {CR}, 32..255).
	 * - BINARY otherwise.
	 * - The following partially-portable control characters form a
	 *   "gray list" that is ignored in this detection algorithm:
	 *   (7 {BEL}, 8 {BS}, 11 {VT}, 12 {FF}, 26 {SUB}, 27 {ESC}).
	 * IN assertion: the fields Freq of dyn_ltree are set.
	 */
	const detect_data_type = (s) => {
	  /* black_mask is the bit mask of black-listed bytes
	   * set bits 0..6, 14..25, and 28..31
	   * 0xf3ffc07f = binary 11110011111111111100000001111111
	   */
	  let black_mask = 0xf3ffc07f;
	  let n;

	  /* Check for non-textual ("black-listed") bytes. */
	  for (n = 0; n <= 31; n++, black_mask >>>= 1) {
	    if ((black_mask & 1) && (s.dyn_ltree[n * 2]/*.Freq*/ !== 0)) {
	      return Z_BINARY;
	    }
	  }

	  /* Check for textual ("white-listed") bytes. */
	  if (s.dyn_ltree[9 * 2]/*.Freq*/ !== 0 || s.dyn_ltree[10 * 2]/*.Freq*/ !== 0 ||
	      s.dyn_ltree[13 * 2]/*.Freq*/ !== 0) {
	    return Z_TEXT;
	  }
	  for (n = 32; n < LITERALS$1; n++) {
	    if (s.dyn_ltree[n * 2]/*.Freq*/ !== 0) {
	      return Z_TEXT;
	    }
	  }

	  /* There are no "black-listed" or "white-listed" bytes:
	   * this stream either is empty or has tolerated ("gray-listed") bytes only.
	   */
	  return Z_BINARY;
	};


	let static_init_done = false;

	/* ===========================================================================
	 * Initialize the tree data structures for a new zlib stream.
	 */
	const _tr_init$1 = (s) =>
	{

	  if (!static_init_done) {
	    tr_static_init();
	    static_init_done = true;
	  }

	  s.l_desc  = new TreeDesc(s.dyn_ltree, static_l_desc);
	  s.d_desc  = new TreeDesc(s.dyn_dtree, static_d_desc);
	  s.bl_desc = new TreeDesc(s.bl_tree, static_bl_desc);

	  s.bi_buf = 0;
	  s.bi_valid = 0;

	  /* Initialize the first block of the first file: */
	  init_block(s);
	};


	/* ===========================================================================
	 * Send a stored block
	 */
	const _tr_stored_block$1 = (s, buf, stored_len, last) =>
	//DeflateState *s;
	//charf *buf;       /* input block */
	//ulg stored_len;   /* length of input block */
	//int last;         /* one if this is the last block for a file */
	{
	  send_bits(s, (STORED_BLOCK << 1) + (last ? 1 : 0), 3);    /* send block type */
	  copy_block(s, buf, stored_len, true); /* with header */
	};


	/* ===========================================================================
	 * Send one empty static block to give enough lookahead for inflate.
	 * This takes 10 bits, of which 7 may remain in the bit buffer.
	 */
	const _tr_align$1 = (s) => {
	  send_bits(s, STATIC_TREES << 1, 3);
	  send_code(s, END_BLOCK, static_ltree);
	  bi_flush(s);
	};


	/* ===========================================================================
	 * Determine the best encoding for the current block: dynamic trees, static
	 * trees or store, and output the encoded block to the zip file.
	 */
	const _tr_flush_block$1 = (s, buf, stored_len, last) =>
	//DeflateState *s;
	//charf *buf;       /* input block, or NULL if too old */
	//ulg stored_len;   /* length of input block */
	//int last;         /* one if this is the last block for a file */
	{
	  let opt_lenb, static_lenb;  /* opt_len and static_len in bytes */
	  let max_blindex = 0;        /* index of last bit length code of non zero freq */

	  /* Build the Huffman trees unless a stored block is forced */
	  if (s.level > 0) {

	    /* Check if the file is binary or text */
	    if (s.strm.data_type === Z_UNKNOWN$1) {
	      s.strm.data_type = detect_data_type(s);
	    }

	    /* Construct the literal and distance trees */
	    build_tree(s, s.l_desc);
	    // Tracev((stderr, "\nlit data: dyn %ld, stat %ld", s->opt_len,
	    //        s->static_len));

	    build_tree(s, s.d_desc);
	    // Tracev((stderr, "\ndist data: dyn %ld, stat %ld", s->opt_len,
	    //        s->static_len));
	    /* At this point, opt_len and static_len are the total bit lengths of
	     * the compressed block data, excluding the tree representations.
	     */

	    /* Build the bit length tree for the above two trees, and get the index
	     * in bl_order of the last bit length code to send.
	     */
	    max_blindex = build_bl_tree(s);

	    /* Determine the best encoding. Compute the block lengths in bytes. */
	    opt_lenb = (s.opt_len + 3 + 7) >>> 3;
	    static_lenb = (s.static_len + 3 + 7) >>> 3;

	    // Tracev((stderr, "\nopt %lu(%lu) stat %lu(%lu) stored %lu lit %u ",
	    //        opt_lenb, s->opt_len, static_lenb, s->static_len, stored_len,
	    //        s->last_lit));

	    if (static_lenb <= opt_lenb) { opt_lenb = static_lenb; }

	  } else {
	    // Assert(buf != (char*)0, "lost buf");
	    opt_lenb = static_lenb = stored_len + 5; /* force a stored block */
	  }

	  if ((stored_len + 4 <= opt_lenb) && (buf !== -1)) {
	    /* 4: two words for the lengths */

	    /* The test buf != NULL is only necessary if LIT_BUFSIZE > WSIZE.
	     * Otherwise we can't have processed more than WSIZE input bytes since
	     * the last block flush, because compression would have been
	     * successful. If LIT_BUFSIZE <= WSIZE, it is never too late to
	     * transform a block into a stored block.
	     */
	    _tr_stored_block$1(s, buf, stored_len, last);

	  } else if (s.strategy === Z_FIXED$1 || static_lenb === opt_lenb) {

	    send_bits(s, (STATIC_TREES << 1) + (last ? 1 : 0), 3);
	    compress_block(s, static_ltree, static_dtree);

	  } else {
	    send_bits(s, (DYN_TREES << 1) + (last ? 1 : 0), 3);
	    send_all_trees(s, s.l_desc.max_code + 1, s.d_desc.max_code + 1, max_blindex + 1);
	    compress_block(s, s.dyn_ltree, s.dyn_dtree);
	  }
	  // Assert (s->compressed_len == s->bits_sent, "bad compressed size");
	  /* The above check is made mod 2^32, for files larger than 512 MB
	   * and uLong implemented on 32 bits.
	   */
	  init_block(s);

	  if (last) {
	    bi_windup(s);
	  }
	  // Tracev((stderr,"\ncomprlen %lu(%lu) ", s->compressed_len>>3,
	  //       s->compressed_len-7*last));
	};

	/* ===========================================================================
	 * Save the match info and tally the frequency counts. Return true if
	 * the current block must be flushed.
	 */
	const _tr_tally$1 = (s, dist, lc) =>
	//    deflate_state *s;
	//    unsigned dist;  /* distance of matched string */
	//    unsigned lc;    /* match length-MIN_MATCH or unmatched char (if dist==0) */
	{
	  //let out_length, in_length, dcode;

	  s.pending_buf[s.d_buf + s.last_lit * 2]     = (dist >>> 8) & 0xff;
	  s.pending_buf[s.d_buf + s.last_lit * 2 + 1] = dist & 0xff;

	  s.pending_buf[s.l_buf + s.last_lit] = lc & 0xff;
	  s.last_lit++;

	  if (dist === 0) {
	    /* lc is the unmatched char */
	    s.dyn_ltree[lc * 2]/*.Freq*/++;
	  } else {
	    s.matches++;
	    /* Here, lc is the match length - MIN_MATCH */
	    dist--;             /* dist = match distance - 1 */
	    //Assert((ush)dist < (ush)MAX_DIST(s) &&
	    //       (ush)lc <= (ush)(MAX_MATCH-MIN_MATCH) &&
	    //       (ush)d_code(dist) < (ush)D_CODES,  "_tr_tally: bad match");

	    s.dyn_ltree[(_length_code[lc] + LITERALS$1 + 1) * 2]/*.Freq*/++;
	    s.dyn_dtree[d_code(dist) * 2]/*.Freq*/++;
	  }

	// (!) This block is disabled in zlib defaults,
	// don't enable it for binary compatibility

	//#ifdef TRUNCATE_BLOCK
	//  /* Try to guess if it is profitable to stop the current block here */
	//  if ((s.last_lit & 0x1fff) === 0 && s.level > 2) {
	//    /* Compute an upper bound for the compressed length */
	//    out_length = s.last_lit*8;
	//    in_length = s.strstart - s.block_start;
	//
	//    for (dcode = 0; dcode < D_CODES; dcode++) {
	//      out_length += s.dyn_dtree[dcode*2]/*.Freq*/ * (5 + extra_dbits[dcode]);
	//    }
	//    out_length >>>= 3;
	//    //Tracev((stderr,"\nlast_lit %u, in %ld, out ~%ld(%ld%%) ",
	//    //       s->last_lit, in_length, out_length,
	//    //       100L - out_length*100L/in_length));
	//    if (s.matches < (s.last_lit>>1)/*int /2*/ && out_length < (in_length>>1)/*int /2*/) {
	//      return true;
	//    }
	//  }
	//#endif

	  return (s.last_lit === s.lit_bufsize - 1);
	  /* We avoid equality with lit_bufsize because of wraparound at 64K
	   * on 16 bit machines and because stored blocks are restricted to
	   * 64K-1 bytes.
	   */
	};

	trees._tr_init  = _tr_init$1;
	trees._tr_stored_block = _tr_stored_block$1;
	trees._tr_flush_block  = _tr_flush_block$1;
	trees._tr_tally = _tr_tally$1;
	trees._tr_align = _tr_align$1;

	// Note: adler32 takes 12% for level 0 and 2% for level 6.
	// It isn't worth it to make additional optimizations as in original.
	// Small size is preferable.

	// (C) 1995-2013 Jean-loup Gailly and Mark Adler
	// (C) 2014-2017 Vitaly Puzrin and Andrey Tupitsin
	//
	// This software is provided 'as-is', without any express or implied
	// warranty. In no event will the authors be held liable for any damages
	// arising from the use of this software.
	//
	// Permission is granted to anyone to use this software for any purpose,
	// including commercial applications, and to alter it and redistribute it
	// freely, subject to the following restrictions:
	//
	// 1. The origin of this software must not be misrepresented; you must not
	//   claim that you wrote the original software. If you use this software
	//   in a product, an acknowledgment in the product documentation would be
	//   appreciated but is not required.
	// 2. Altered source versions must be plainly marked as such, and must not be
	//   misrepresented as being the original software.
	// 3. This notice may not be removed or altered from any source distribution.

	const adler32$2 = (adler, buf, len, pos) => {
	  let s1 = (adler & 0xffff) |0,
	      s2 = ((adler >>> 16) & 0xffff) |0,
	      n = 0;

	  while (len !== 0) {
	    // Set limit ~ twice less than 5552, to keep
	    // s2 in 31-bits, because we force signed ints.
	    // in other case %= will fail.
	    n = len > 2000 ? 2000 : len;
	    len -= n;

	    do {
	      s1 = (s1 + buf[pos++]) |0;
	      s2 = (s2 + s1) |0;
	    } while (--n);

	    s1 %= 65521;
	    s2 %= 65521;
	  }

	  return (s1 | (s2 << 16)) |0;
	};


	var adler32_1 = adler32$2;

	// Note: we can't get significant speed boost here.
	// So write code to minimize size - no pregenerated tables
	// and array tools dependencies.

	// (C) 1995-2013 Jean-loup Gailly and Mark Adler
	// (C) 2014-2017 Vitaly Puzrin and Andrey Tupitsin
	//
	// This software is provided 'as-is', without any express or implied
	// warranty. In no event will the authors be held liable for any damages
	// arising from the use of this software.
	//
	// Permission is granted to anyone to use this software for any purpose,
	// including commercial applications, and to alter it and redistribute it
	// freely, subject to the following restrictions:
	//
	// 1. The origin of this software must not be misrepresented; you must not
	//   claim that you wrote the original software. If you use this software
	//   in a product, an acknowledgment in the product documentation would be
	//   appreciated but is not required.
	// 2. Altered source versions must be plainly marked as such, and must not be
	//   misrepresented as being the original software.
	// 3. This notice may not be removed or altered from any source distribution.

	// Use ordinary array, since untyped makes no boost here
	const makeTable = () => {
	  let c, table = [];

	  for (var n = 0; n < 256; n++) {
	    c = n;
	    for (var k = 0; k < 8; k++) {
	      c = ((c & 1) ? (0xEDB88320 ^ (c >>> 1)) : (c >>> 1));
	    }
	    table[n] = c;
	  }

	  return table;
	};

	// Create table on load. Just 255 signed longs. Not a problem.
	const crcTable = new Uint32Array(makeTable());


	const crc32$2 = (crc, buf, len, pos) => {
	  const t = crcTable;
	  const end = pos + len;

	  crc ^= -1;

	  for (let i = pos; i < end; i++) {
	    crc = (crc >>> 8) ^ t[(crc ^ buf[i]) & 0xFF];
	  }

	  return (crc ^ (-1)); // >>> 0;
	};


	var crc32_1 = crc32$2;

	// (C) 1995-2013 Jean-loup Gailly and Mark Adler
	// (C) 2014-2017 Vitaly Puzrin and Andrey Tupitsin
	//
	// This software is provided 'as-is', without any express or implied
	// warranty. In no event will the authors be held liable for any damages
	// arising from the use of this software.
	//
	// Permission is granted to anyone to use this software for any purpose,
	// including commercial applications, and to alter it and redistribute it
	// freely, subject to the following restrictions:
	//
	// 1. The origin of this software must not be misrepresented; you must not
	//   claim that you wrote the original software. If you use this software
	//   in a product, an acknowledgment in the product documentation would be
	//   appreciated but is not required.
	// 2. Altered source versions must be plainly marked as such, and must not be
	//   misrepresented as being the original software.
	// 3. This notice may not be removed or altered from any source distribution.

	var messages = {
	  2:      'need dictionary',     /* Z_NEED_DICT       2  */
	  1:      'stream end',          /* Z_STREAM_END      1  */
	  0:      '',                    /* Z_OK              0  */
	  '-1':   'file error',          /* Z_ERRNO         (-1) */
	  '-2':   'stream error',        /* Z_STREAM_ERROR  (-2) */
	  '-3':   'data error',          /* Z_DATA_ERROR    (-3) */
	  '-4':   'insufficient memory', /* Z_MEM_ERROR     (-4) */
	  '-5':   'buffer error',        /* Z_BUF_ERROR     (-5) */
	  '-6':   'incompatible version' /* Z_VERSION_ERROR (-6) */
	};

	// (C) 1995-2013 Jean-loup Gailly and Mark Adler
	// (C) 2014-2017 Vitaly Puzrin and Andrey Tupitsin
	//
	// This software is provided 'as-is', without any express or implied
	// warranty. In no event will the authors be held liable for any damages
	// arising from the use of this software.
	//
	// Permission is granted to anyone to use this software for any purpose,
	// including commercial applications, and to alter it and redistribute it
	// freely, subject to the following restrictions:
	//
	// 1. The origin of this software must not be misrepresented; you must not
	//   claim that you wrote the original software. If you use this software
	//   in a product, an acknowledgment in the product documentation would be
	//   appreciated but is not required.
	// 2. Altered source versions must be plainly marked as such, and must not be
	//   misrepresented as being the original software.
	// 3. This notice may not be removed or altered from any source distribution.

	var constants$1 = {

	  /* Allowed flush values; see deflate() and inflate() below for details */
	  Z_NO_FLUSH:         0,
	  Z_PARTIAL_FLUSH:    1,
	  Z_SYNC_FLUSH:       2,
	  Z_FULL_FLUSH:       3,
	  Z_FINISH:           4,
	  Z_BLOCK:            5,
	  Z_TREES:            6,

	  /* Return codes for the compression/decompression functions. Negative values
	  * are errors, positive values are used for special but normal events.
	  */
	  Z_OK:               0,
	  Z_STREAM_END:       1,
	  Z_NEED_DICT:        2,
	  Z_ERRNO:           -1,
	  Z_STREAM_ERROR:    -2,
	  Z_DATA_ERROR:      -3,
	  Z_MEM_ERROR:       -4,
	  Z_BUF_ERROR:       -5,
	  //Z_VERSION_ERROR: -6,

	  /* compression levels */
	  Z_NO_COMPRESSION:         0,
	  Z_BEST_SPEED:             1,
	  Z_BEST_COMPRESSION:       9,
	  Z_DEFAULT_COMPRESSION:   -1,


	  Z_FILTERED:               1,
	  Z_HUFFMAN_ONLY:           2,
	  Z_RLE:                    3,
	  Z_FIXED:                  4,
	  Z_DEFAULT_STRATEGY:       0,

	  /* Possible values of the data_type field (though see inflate()) */
	  Z_BINARY:                 0,
	  Z_TEXT:                   1,
	  //Z_ASCII:                1, // = Z_TEXT (deprecated)
	  Z_UNKNOWN:                2,

	  /* The deflate compression method */
	  Z_DEFLATED:               8
	  //Z_NULL:                 null // Use -1 or null inline, depending on var type
	};

	// (C) 1995-2013 Jean-loup Gailly and Mark Adler
	// (C) 2014-2017 Vitaly Puzrin and Andrey Tupitsin
	//
	// This software is provided 'as-is', without any express or implied
	// warranty. In no event will the authors be held liable for any damages
	// arising from the use of this software.
	//
	// Permission is granted to anyone to use this software for any purpose,
	// including commercial applications, and to alter it and redistribute it
	// freely, subject to the following restrictions:
	//
	// 1. The origin of this software must not be misrepresented; you must not
	//   claim that you wrote the original software. If you use this software
	//   in a product, an acknowledgment in the product documentation would be
	//   appreciated but is not required.
	// 2. Altered source versions must be plainly marked as such, and must not be
	//   misrepresented as being the original software.
	// 3. This notice may not be removed or altered from any source distribution.

	const { _tr_init, _tr_stored_block, _tr_flush_block, _tr_tally, _tr_align } = trees;
	const adler32$1 = adler32_1;
	const crc32$1   = crc32_1;
	const msg$2     = messages;

	/* Public constants ==========================================================*/
	/* ===========================================================================*/

	const {
	  Z_NO_FLUSH: Z_NO_FLUSH$2, Z_PARTIAL_FLUSH, Z_FULL_FLUSH: Z_FULL_FLUSH$1, Z_FINISH: Z_FINISH$3, Z_BLOCK: Z_BLOCK$1,
	  Z_OK: Z_OK$3, Z_STREAM_END: Z_STREAM_END$3, Z_STREAM_ERROR: Z_STREAM_ERROR$2, Z_DATA_ERROR: Z_DATA_ERROR$2, Z_BUF_ERROR: Z_BUF_ERROR$1,
	  Z_DEFAULT_COMPRESSION: Z_DEFAULT_COMPRESSION$1,
	  Z_FILTERED, Z_HUFFMAN_ONLY, Z_RLE, Z_FIXED, Z_DEFAULT_STRATEGY: Z_DEFAULT_STRATEGY$1,
	  Z_UNKNOWN,
	  Z_DEFLATED: Z_DEFLATED$2
	} = constants$1;

	/*============================================================================*/


	const MAX_MEM_LEVEL = 9;
	/* Maximum value for memLevel in deflateInit2 */
	const MAX_WBITS$1 = 15;
	/* 32K LZ77 window */
	const DEF_MEM_LEVEL = 8;


	const LENGTH_CODES  = 29;
	/* number of length codes, not counting the special END_BLOCK code */
	const LITERALS      = 256;
	/* number of literal bytes 0..255 */
	const L_CODES       = LITERALS + 1 + LENGTH_CODES;
	/* number of Literal or Length codes, including the END_BLOCK code */
	const D_CODES       = 30;
	/* number of distance codes */
	const BL_CODES      = 19;
	/* number of codes used to transfer the bit lengths */
	const HEAP_SIZE     = 2 * L_CODES + 1;
	/* maximum heap size */
	const MAX_BITS  = 15;
	/* All codes must not exceed MAX_BITS bits */

	const MIN_MATCH = 3;
	const MAX_MATCH = 258;
	const MIN_LOOKAHEAD = (MAX_MATCH + MIN_MATCH + 1);

	const PRESET_DICT = 0x20;

	const INIT_STATE = 42;
	const EXTRA_STATE = 69;
	const NAME_STATE = 73;
	const COMMENT_STATE = 91;
	const HCRC_STATE = 103;
	const BUSY_STATE = 113;
	const FINISH_STATE = 666;

	const BS_NEED_MORE      = 1; /* block not completed, need more input or more output */
	const BS_BLOCK_DONE     = 2; /* block flush performed */
	const BS_FINISH_STARTED = 3; /* finish started, need only more output at next deflate */
	const BS_FINISH_DONE    = 4; /* finish done, accept no more input or output */

	const OS_CODE = 0x03; // Unix :) . Don't detect, use this default.

	const err = (strm, errorCode) => {
	  strm.msg = msg$2[errorCode];
	  return errorCode;
	};

	const rank = (f) => {
	  return ((f) << 1) - ((f) > 4 ? 9 : 0);
	};

	const zero = (buf) => {
	  let len = buf.length; while (--len >= 0) { buf[len] = 0; }
	};


	/* eslint-disable new-cap */
	let HASH_ZLIB = (s, prev, data) => ((prev << s.hash_shift) ^ data) & s.hash_mask;
	// This hash causes less collisions, https://github.com/nodeca/pako/issues/135
	// But breaks binary compatibility
	//let HASH_FAST = (s, prev, data) => ((prev << 8) + (prev >> 8) + (data << 4)) & s.hash_mask;
	let HASH = HASH_ZLIB;

	/* =========================================================================
	 * Flush as much pending output as possible. All deflate() output goes
	 * through this function so some applications may wish to modify it
	 * to avoid allocating a large strm->output buffer and copying into it.
	 * (See also read_buf()).
	 */
	const flush_pending = (strm) => {
	  const s = strm.state;

	  //_tr_flush_bits(s);
	  let len = s.pending;
	  if (len > strm.avail_out) {
	    len = strm.avail_out;
	  }
	  if (len === 0) { return; }

	  strm.output.set(s.pending_buf.subarray(s.pending_out, s.pending_out + len), strm.next_out);
	  strm.next_out += len;
	  s.pending_out += len;
	  strm.total_out += len;
	  strm.avail_out -= len;
	  s.pending -= len;
	  if (s.pending === 0) {
	    s.pending_out = 0;
	  }
	};


	const flush_block_only = (s, last) => {
	  _tr_flush_block(s, (s.block_start >= 0 ? s.block_start : -1), s.strstart - s.block_start, last);
	  s.block_start = s.strstart;
	  flush_pending(s.strm);
	};


	const put_byte = (s, b) => {
	  s.pending_buf[s.pending++] = b;
	};


	/* =========================================================================
	 * Put a short in the pending buffer. The 16-bit value is put in MSB order.
	 * IN assertion: the stream state is correct and there is enough room in
	 * pending_buf.
	 */
	const putShortMSB = (s, b) => {

	  //  put_byte(s, (Byte)(b >> 8));
	//  put_byte(s, (Byte)(b & 0xff));
	  s.pending_buf[s.pending++] = (b >>> 8) & 0xff;
	  s.pending_buf[s.pending++] = b & 0xff;
	};


	/* ===========================================================================
	 * Read a new buffer from the current input stream, update the adler32
	 * and total number of bytes read.  All deflate() input goes through
	 * this function so some applications may wish to modify it to avoid
	 * allocating a large strm->input buffer and copying from it.
	 * (See also flush_pending()).
	 */
	const read_buf = (strm, buf, start, size) => {

	  let len = strm.avail_in;

	  if (len > size) { len = size; }
	  if (len === 0) { return 0; }

	  strm.avail_in -= len;

	  // zmemcpy(buf, strm->next_in, len);
	  buf.set(strm.input.subarray(strm.next_in, strm.next_in + len), start);
	  if (strm.state.wrap === 1) {
	    strm.adler = adler32$1(strm.adler, buf, len, start);
	  }

	  else if (strm.state.wrap === 2) {
	    strm.adler = crc32$1(strm.adler, buf, len, start);
	  }

	  strm.next_in += len;
	  strm.total_in += len;

	  return len;
	};


	/* ===========================================================================
	 * Set match_start to the longest match starting at the given string and
	 * return its length. Matches shorter or equal to prev_length are discarded,
	 * in which case the result is equal to prev_length and match_start is
	 * garbage.
	 * IN assertions: cur_match is the head of the hash chain for the current
	 *   string (strstart) and its distance is <= MAX_DIST, and prev_length >= 1
	 * OUT assertion: the match length is not greater than s->lookahead.
	 */
	const longest_match = (s, cur_match) => {

	  let chain_length = s.max_chain_length;      /* max hash chain length */
	  let scan = s.strstart; /* current string */
	  let match;                       /* matched string */
	  let len;                           /* length of current match */
	  let best_len = s.prev_length;              /* best match length so far */
	  let nice_match = s.nice_match;             /* stop if match long enough */
	  const limit = (s.strstart > (s.w_size - MIN_LOOKAHEAD)) ?
	      s.strstart - (s.w_size - MIN_LOOKAHEAD) : 0/*NIL*/;

	  const _win = s.window; // shortcut

	  const wmask = s.w_mask;
	  const prev  = s.prev;

	  /* Stop when cur_match becomes <= limit. To simplify the code,
	   * we prevent matches with the string of window index 0.
	   */

	  const strend = s.strstart + MAX_MATCH;
	  let scan_end1  = _win[scan + best_len - 1];
	  let scan_end   = _win[scan + best_len];

	  /* The code is optimized for HASH_BITS >= 8 and MAX_MATCH-2 multiple of 16.
	   * It is easy to get rid of this optimization if necessary.
	   */
	  // Assert(s->hash_bits >= 8 && MAX_MATCH == 258, "Code too clever");

	  /* Do not waste too much time if we already have a good match: */
	  if (s.prev_length >= s.good_match) {
	    chain_length >>= 2;
	  }
	  /* Do not look for matches beyond the end of the input. This is necessary
	   * to make deflate deterministic.
	   */
	  if (nice_match > s.lookahead) { nice_match = s.lookahead; }

	  // Assert((ulg)s->strstart <= s->window_size-MIN_LOOKAHEAD, "need lookahead");

	  do {
	    // Assert(cur_match < s->strstart, "no future");
	    match = cur_match;

	    /* Skip to next match if the match length cannot increase
	     * or if the match length is less than 2.  Note that the checks below
	     * for insufficient lookahead only occur occasionally for performance
	     * reasons.  Therefore uninitialized memory will be accessed, and
	     * conditional jumps will be made that depend on those values.
	     * However the length of the match is limited to the lookahead, so
	     * the output of deflate is not affected by the uninitialized values.
	     */

	    if (_win[match + best_len]     !== scan_end  ||
	        _win[match + best_len - 1] !== scan_end1 ||
	        _win[match]                !== _win[scan] ||
	        _win[++match]              !== _win[scan + 1]) {
	      continue;
	    }

	    /* The check at best_len-1 can be removed because it will be made
	     * again later. (This heuristic is not always a win.)
	     * It is not necessary to compare scan[2] and match[2] since they
	     * are always equal when the other bytes match, given that
	     * the hash keys are equal and that HASH_BITS >= 8.
	     */
	    scan += 2;
	    match++;
	    // Assert(*scan == *match, "match[2]?");

	    /* We check for insufficient lookahead only every 8th comparison;
	     * the 256th check will be made at strstart+258.
	     */
	    do {
	      /*jshint noempty:false*/
	    } while (_win[++scan] === _win[++match] && _win[++scan] === _win[++match] &&
	             _win[++scan] === _win[++match] && _win[++scan] === _win[++match] &&
	             _win[++scan] === _win[++match] && _win[++scan] === _win[++match] &&
	             _win[++scan] === _win[++match] && _win[++scan] === _win[++match] &&
	             scan < strend);

	    // Assert(scan <= s->window+(unsigned)(s->window_size-1), "wild scan");

	    len = MAX_MATCH - (strend - scan);
	    scan = strend - MAX_MATCH;

	    if (len > best_len) {
	      s.match_start = cur_match;
	      best_len = len;
	      if (len >= nice_match) {
	        break;
	      }
	      scan_end1  = _win[scan + best_len - 1];
	      scan_end   = _win[scan + best_len];
	    }
	  } while ((cur_match = prev[cur_match & wmask]) > limit && --chain_length !== 0);

	  if (best_len <= s.lookahead) {
	    return best_len;
	  }
	  return s.lookahead;
	};


	/* ===========================================================================
	 * Fill the window when the lookahead becomes insufficient.
	 * Updates strstart and lookahead.
	 *
	 * IN assertion: lookahead < MIN_LOOKAHEAD
	 * OUT assertions: strstart <= window_size-MIN_LOOKAHEAD
	 *    At least one byte has been read, or avail_in == 0; reads are
	 *    performed for at least two bytes (required for the zip translate_eol
	 *    option -- not supported here).
	 */
	const fill_window = (s) => {

	  const _w_size = s.w_size;
	  let p, n, m, more, str;

	  //Assert(s->lookahead < MIN_LOOKAHEAD, "already enough lookahead");

	  do {
	    more = s.window_size - s.lookahead - s.strstart;

	    // JS ints have 32 bit, block below not needed
	    /* Deal with !@#$% 64K limit: */
	    //if (sizeof(int) <= 2) {
	    //    if (more == 0 && s->strstart == 0 && s->lookahead == 0) {
	    //        more = wsize;
	    //
	    //  } else if (more == (unsigned)(-1)) {
	    //        /* Very unlikely, but possible on 16 bit machine if
	    //         * strstart == 0 && lookahead == 1 (input done a byte at time)
	    //         */
	    //        more--;
	    //    }
	    //}


	    /* If the window is almost full and there is insufficient lookahead,
	     * move the upper half to the lower one to make room in the upper half.
	     */
	    if (s.strstart >= _w_size + (_w_size - MIN_LOOKAHEAD)) {

	      s.window.set(s.window.subarray(_w_size, _w_size + _w_size), 0);
	      s.match_start -= _w_size;
	      s.strstart -= _w_size;
	      /* we now have strstart >= MAX_DIST */
	      s.block_start -= _w_size;

	      /* Slide the hash table (could be avoided with 32 bit values
	       at the expense of memory usage). We slide even when level == 0
	       to keep the hash table consistent if we switch back to level > 0
	       later. (Using level 0 permanently is not an optimal usage of
	       zlib, so we don't care about this pathological case.)
	       */

	      n = s.hash_size;
	      p = n;

	      do {
	        m = s.head[--p];
	        s.head[p] = (m >= _w_size ? m - _w_size : 0);
	      } while (--n);

	      n = _w_size;
	      p = n;

	      do {
	        m = s.prev[--p];
	        s.prev[p] = (m >= _w_size ? m - _w_size : 0);
	        /* If n is not on any hash chain, prev[n] is garbage but
	         * its value will never be used.
	         */
	      } while (--n);

	      more += _w_size;
	    }
	    if (s.strm.avail_in === 0) {
	      break;
	    }

	    /* If there was no sliding:
	     *    strstart <= WSIZE+MAX_DIST-1 && lookahead <= MIN_LOOKAHEAD - 1 &&
	     *    more == window_size - lookahead - strstart
	     * => more >= window_size - (MIN_LOOKAHEAD-1 + WSIZE + MAX_DIST-1)
	     * => more >= window_size - 2*WSIZE + 2
	     * In the BIG_MEM or MMAP case (not yet supported),
	     *   window_size == input_size + MIN_LOOKAHEAD  &&
	     *   strstart + s->lookahead <= input_size => more >= MIN_LOOKAHEAD.
	     * Otherwise, window_size == 2*WSIZE so more >= 2.
	     * If there was sliding, more >= WSIZE. So in all cases, more >= 2.
	     */
	    //Assert(more >= 2, "more < 2");
	    n = read_buf(s.strm, s.window, s.strstart + s.lookahead, more);
	    s.lookahead += n;

	    /* Initialize the hash value now that we have some input: */
	    if (s.lookahead + s.insert >= MIN_MATCH) {
	      str = s.strstart - s.insert;
	      s.ins_h = s.window[str];

	      /* UPDATE_HASH(s, s->ins_h, s->window[str + 1]); */
	      s.ins_h = HASH(s, s.ins_h, s.window[str + 1]);
	//#if MIN_MATCH != 3
	//        Call update_hash() MIN_MATCH-3 more times
	//#endif
	      while (s.insert) {
	        /* UPDATE_HASH(s, s->ins_h, s->window[str + MIN_MATCH-1]); */
	        s.ins_h = HASH(s, s.ins_h, s.window[str + MIN_MATCH - 1]);

	        s.prev[str & s.w_mask] = s.head[s.ins_h];
	        s.head[s.ins_h] = str;
	        str++;
	        s.insert--;
	        if (s.lookahead + s.insert < MIN_MATCH) {
	          break;
	        }
	      }
	    }
	    /* If the whole input has less than MIN_MATCH bytes, ins_h is garbage,
	     * but this is not important since only literal bytes will be emitted.
	     */

	  } while (s.lookahead < MIN_LOOKAHEAD && s.strm.avail_in !== 0);

	  /* If the WIN_INIT bytes after the end of the current data have never been
	   * written, then zero those bytes in order to avoid memory check reports of
	   * the use of uninitialized (or uninitialised as Julian writes) bytes by
	   * the longest match routines.  Update the high water mark for the next
	   * time through here.  WIN_INIT is set to MAX_MATCH since the longest match
	   * routines allow scanning to strstart + MAX_MATCH, ignoring lookahead.
	   */
	//  if (s.high_water < s.window_size) {
	//    const curr = s.strstart + s.lookahead;
	//    let init = 0;
	//
	//    if (s.high_water < curr) {
	//      /* Previous high water mark below current data -- zero WIN_INIT
	//       * bytes or up to end of window, whichever is less.
	//       */
	//      init = s.window_size - curr;
	//      if (init > WIN_INIT)
	//        init = WIN_INIT;
	//      zmemzero(s->window + curr, (unsigned)init);
	//      s->high_water = curr + init;
	//    }
	//    else if (s->high_water < (ulg)curr + WIN_INIT) {
	//      /* High water mark at or above current data, but below current data
	//       * plus WIN_INIT -- zero out to current data plus WIN_INIT, or up
	//       * to end of window, whichever is less.
	//       */
	//      init = (ulg)curr + WIN_INIT - s->high_water;
	//      if (init > s->window_size - s->high_water)
	//        init = s->window_size - s->high_water;
	//      zmemzero(s->window + s->high_water, (unsigned)init);
	//      s->high_water += init;
	//    }
	//  }
	//
	//  Assert((ulg)s->strstart <= s->window_size - MIN_LOOKAHEAD,
	//    "not enough room for search");
	};

	/* ===========================================================================
	 * Copy without compression as much as possible from the input stream, return
	 * the current block state.
	 * This function does not insert new strings in the dictionary since
	 * uncompressible data is probably not useful. This function is used
	 * only for the level=0 compression option.
	 * NOTE: this function should be optimized to avoid extra copying from
	 * window to pending_buf.
	 */
	const deflate_stored = (s, flush) => {

	  /* Stored blocks are limited to 0xffff bytes, pending_buf is limited
	   * to pending_buf_size, and each stored block has a 5 byte header:
	   */
	  let max_block_size = 0xffff;

	  if (max_block_size > s.pending_buf_size - 5) {
	    max_block_size = s.pending_buf_size - 5;
	  }

	  /* Copy as much as possible from input to output: */
	  for (;;) {
	    /* Fill the window as much as possible: */
	    if (s.lookahead <= 1) {

	      //Assert(s->strstart < s->w_size+MAX_DIST(s) ||
	      //  s->block_start >= (long)s->w_size, "slide too late");
	//      if (!(s.strstart < s.w_size + (s.w_size - MIN_LOOKAHEAD) ||
	//        s.block_start >= s.w_size)) {
	//        throw  new Error("slide too late");
	//      }

	      fill_window(s);
	      if (s.lookahead === 0 && flush === Z_NO_FLUSH$2) {
	        return BS_NEED_MORE;
	      }

	      if (s.lookahead === 0) {
	        break;
	      }
	      /* flush the current block */
	    }
	    //Assert(s->block_start >= 0L, "block gone");
	//    if (s.block_start < 0) throw new Error("block gone");

	    s.strstart += s.lookahead;
	    s.lookahead = 0;

	    /* Emit a stored block if pending_buf will be full: */
	    const max_start = s.block_start + max_block_size;

	    if (s.strstart === 0 || s.strstart >= max_start) {
	      /* strstart == 0 is possible when wraparound on 16-bit machine */
	      s.lookahead = s.strstart - max_start;
	      s.strstart = max_start;
	      /*** FLUSH_BLOCK(s, 0); ***/
	      flush_block_only(s, false);
	      if (s.strm.avail_out === 0) {
	        return BS_NEED_MORE;
	      }
	      /***/


	    }
	    /* Flush if we may have to slide, otherwise block_start may become
	     * negative and the data will be gone:
	     */
	    if (s.strstart - s.block_start >= (s.w_size - MIN_LOOKAHEAD)) {
	      /*** FLUSH_BLOCK(s, 0); ***/
	      flush_block_only(s, false);
	      if (s.strm.avail_out === 0) {
	        return BS_NEED_MORE;
	      }
	      /***/
	    }
	  }

	  s.insert = 0;

	  if (flush === Z_FINISH$3) {
	    /*** FLUSH_BLOCK(s, 1); ***/
	    flush_block_only(s, true);
	    if (s.strm.avail_out === 0) {
	      return BS_FINISH_STARTED;
	    }
	    /***/
	    return BS_FINISH_DONE;
	  }

	  if (s.strstart > s.block_start) {
	    /*** FLUSH_BLOCK(s, 0); ***/
	    flush_block_only(s, false);
	    if (s.strm.avail_out === 0) {
	      return BS_NEED_MORE;
	    }
	    /***/
	  }

	  return BS_NEED_MORE;
	};

	/* ===========================================================================
	 * Compress as much as possible from the input stream, return the current
	 * block state.
	 * This function does not perform lazy evaluation of matches and inserts
	 * new strings in the dictionary only for unmatched strings or for short
	 * matches. It is used only for the fast compression options.
	 */
	const deflate_fast = (s, flush) => {

	  let hash_head;        /* head of the hash chain */
	  let bflush;           /* set if current block must be flushed */

	  for (;;) {
	    /* Make sure that we always have enough lookahead, except
	     * at the end of the input file. We need MAX_MATCH bytes
	     * for the next match, plus MIN_MATCH bytes to insert the
	     * string following the next match.
	     */
	    if (s.lookahead < MIN_LOOKAHEAD) {
	      fill_window(s);
	      if (s.lookahead < MIN_LOOKAHEAD && flush === Z_NO_FLUSH$2) {
	        return BS_NEED_MORE;
	      }
	      if (s.lookahead === 0) {
	        break; /* flush the current block */
	      }
	    }

	    /* Insert the string window[strstart .. strstart+2] in the
	     * dictionary, and set hash_head to the head of the hash chain:
	     */
	    hash_head = 0/*NIL*/;
	    if (s.lookahead >= MIN_MATCH) {
	      /*** INSERT_STRING(s, s.strstart, hash_head); ***/
	      s.ins_h = HASH(s, s.ins_h, s.window[s.strstart + MIN_MATCH - 1]);
	      hash_head = s.prev[s.strstart & s.w_mask] = s.head[s.ins_h];
	      s.head[s.ins_h] = s.strstart;
	      /***/
	    }

	    /* Find the longest match, discarding those <= prev_length.
	     * At this point we have always match_length < MIN_MATCH
	     */
	    if (hash_head !== 0/*NIL*/ && ((s.strstart - hash_head) <= (s.w_size - MIN_LOOKAHEAD))) {
	      /* To simplify the code, we prevent matches with the string
	       * of window index 0 (in particular we have to avoid a match
	       * of the string with itself at the start of the input file).
	       */
	      s.match_length = longest_match(s, hash_head);
	      /* longest_match() sets match_start */
	    }
	    if (s.match_length >= MIN_MATCH) {
	      // check_match(s, s.strstart, s.match_start, s.match_length); // for debug only

	      /*** _tr_tally_dist(s, s.strstart - s.match_start,
	                     s.match_length - MIN_MATCH, bflush); ***/
	      bflush = _tr_tally(s, s.strstart - s.match_start, s.match_length - MIN_MATCH);

	      s.lookahead -= s.match_length;

	      /* Insert new strings in the hash table only if the match length
	       * is not too large. This saves time but degrades compression.
	       */
	      if (s.match_length <= s.max_lazy_match/*max_insert_length*/ && s.lookahead >= MIN_MATCH) {
	        s.match_length--; /* string at strstart already in table */
	        do {
	          s.strstart++;
	          /*** INSERT_STRING(s, s.strstart, hash_head); ***/
	          s.ins_h = HASH(s, s.ins_h, s.window[s.strstart + MIN_MATCH - 1]);
	          hash_head = s.prev[s.strstart & s.w_mask] = s.head[s.ins_h];
	          s.head[s.ins_h] = s.strstart;
	          /***/
	          /* strstart never exceeds WSIZE-MAX_MATCH, so there are
	           * always MIN_MATCH bytes ahead.
	           */
	        } while (--s.match_length !== 0);
	        s.strstart++;
	      } else
	      {
	        s.strstart += s.match_length;
	        s.match_length = 0;
	        s.ins_h = s.window[s.strstart];
	        /* UPDATE_HASH(s, s.ins_h, s.window[s.strstart+1]); */
	        s.ins_h = HASH(s, s.ins_h, s.window[s.strstart + 1]);

	//#if MIN_MATCH != 3
	//                Call UPDATE_HASH() MIN_MATCH-3 more times
	//#endif
	        /* If lookahead < MIN_MATCH, ins_h is garbage, but it does not
	         * matter since it will be recomputed at next deflate call.
	         */
	      }
	    } else {
	      /* No match, output a literal byte */
	      //Tracevv((stderr,"%c", s.window[s.strstart]));
	      /*** _tr_tally_lit(s, s.window[s.strstart], bflush); ***/
	      bflush = _tr_tally(s, 0, s.window[s.strstart]);

	      s.lookahead--;
	      s.strstart++;
	    }
	    if (bflush) {
	      /*** FLUSH_BLOCK(s, 0); ***/
	      flush_block_only(s, false);
	      if (s.strm.avail_out === 0) {
	        return BS_NEED_MORE;
	      }
	      /***/
	    }
	  }
	  s.insert = ((s.strstart < (MIN_MATCH - 1)) ? s.strstart : MIN_MATCH - 1);
	  if (flush === Z_FINISH$3) {
	    /*** FLUSH_BLOCK(s, 1); ***/
	    flush_block_only(s, true);
	    if (s.strm.avail_out === 0) {
	      return BS_FINISH_STARTED;
	    }
	    /***/
	    return BS_FINISH_DONE;
	  }
	  if (s.last_lit) {
	    /*** FLUSH_BLOCK(s, 0); ***/
	    flush_block_only(s, false);
	    if (s.strm.avail_out === 0) {
	      return BS_NEED_MORE;
	    }
	    /***/
	  }
	  return BS_BLOCK_DONE;
	};

	/* ===========================================================================
	 * Same as above, but achieves better compression. We use a lazy
	 * evaluation for matches: a match is finally adopted only if there is
	 * no better match at the next window position.
	 */
	const deflate_slow = (s, flush) => {

	  let hash_head;          /* head of hash chain */
	  let bflush;              /* set if current block must be flushed */

	  let max_insert;

	  /* Process the input block. */
	  for (;;) {
	    /* Make sure that we always have enough lookahead, except
	     * at the end of the input file. We need MAX_MATCH bytes
	     * for the next match, plus MIN_MATCH bytes to insert the
	     * string following the next match.
	     */
	    if (s.lookahead < MIN_LOOKAHEAD) {
	      fill_window(s);
	      if (s.lookahead < MIN_LOOKAHEAD && flush === Z_NO_FLUSH$2) {
	        return BS_NEED_MORE;
	      }
	      if (s.lookahead === 0) { break; } /* flush the current block */
	    }

	    /* Insert the string window[strstart .. strstart+2] in the
	     * dictionary, and set hash_head to the head of the hash chain:
	     */
	    hash_head = 0/*NIL*/;
	    if (s.lookahead >= MIN_MATCH) {
	      /*** INSERT_STRING(s, s.strstart, hash_head); ***/
	      s.ins_h = HASH(s, s.ins_h, s.window[s.strstart + MIN_MATCH - 1]);
	      hash_head = s.prev[s.strstart & s.w_mask] = s.head[s.ins_h];
	      s.head[s.ins_h] = s.strstart;
	      /***/
	    }

	    /* Find the longest match, discarding those <= prev_length.
	     */
	    s.prev_length = s.match_length;
	    s.prev_match = s.match_start;
	    s.match_length = MIN_MATCH - 1;

	    if (hash_head !== 0/*NIL*/ && s.prev_length < s.max_lazy_match &&
	        s.strstart - hash_head <= (s.w_size - MIN_LOOKAHEAD)/*MAX_DIST(s)*/) {
	      /* To simplify the code, we prevent matches with the string
	       * of window index 0 (in particular we have to avoid a match
	       * of the string with itself at the start of the input file).
	       */
	      s.match_length = longest_match(s, hash_head);
	      /* longest_match() sets match_start */

	      if (s.match_length <= 5 &&
	         (s.strategy === Z_FILTERED || (s.match_length === MIN_MATCH && s.strstart - s.match_start > 4096/*TOO_FAR*/))) {

	        /* If prev_match is also MIN_MATCH, match_start is garbage
	         * but we will ignore the current match anyway.
	         */
	        s.match_length = MIN_MATCH - 1;
	      }
	    }
	    /* If there was a match at the previous step and the current
	     * match is not better, output the previous match:
	     */
	    if (s.prev_length >= MIN_MATCH && s.match_length <= s.prev_length) {
	      max_insert = s.strstart + s.lookahead - MIN_MATCH;
	      /* Do not insert strings in hash table beyond this. */

	      //check_match(s, s.strstart-1, s.prev_match, s.prev_length);

	      /***_tr_tally_dist(s, s.strstart - 1 - s.prev_match,
	                     s.prev_length - MIN_MATCH, bflush);***/
	      bflush = _tr_tally(s, s.strstart - 1 - s.prev_match, s.prev_length - MIN_MATCH);
	      /* Insert in hash table all strings up to the end of the match.
	       * strstart-1 and strstart are already inserted. If there is not
	       * enough lookahead, the last two strings are not inserted in
	       * the hash table.
	       */
	      s.lookahead -= s.prev_length - 1;
	      s.prev_length -= 2;
	      do {
	        if (++s.strstart <= max_insert) {
	          /*** INSERT_STRING(s, s.strstart, hash_head); ***/
	          s.ins_h = HASH(s, s.ins_h, s.window[s.strstart + MIN_MATCH - 1]);
	          hash_head = s.prev[s.strstart & s.w_mask] = s.head[s.ins_h];
	          s.head[s.ins_h] = s.strstart;
	          /***/
	        }
	      } while (--s.prev_length !== 0);
	      s.match_available = 0;
	      s.match_length = MIN_MATCH - 1;
	      s.strstart++;

	      if (bflush) {
	        /*** FLUSH_BLOCK(s, 0); ***/
	        flush_block_only(s, false);
	        if (s.strm.avail_out === 0) {
	          return BS_NEED_MORE;
	        }
	        /***/
	      }

	    } else if (s.match_available) {
	      /* If there was no match at the previous position, output a
	       * single literal. If there was a match but the current match
	       * is longer, truncate the previous match to a single literal.
	       */
	      //Tracevv((stderr,"%c", s->window[s->strstart-1]));
	      /*** _tr_tally_lit(s, s.window[s.strstart-1], bflush); ***/
	      bflush = _tr_tally(s, 0, s.window[s.strstart - 1]);

	      if (bflush) {
	        /*** FLUSH_BLOCK_ONLY(s, 0) ***/
	        flush_block_only(s, false);
	        /***/
	      }
	      s.strstart++;
	      s.lookahead--;
	      if (s.strm.avail_out === 0) {
	        return BS_NEED_MORE;
	      }
	    } else {
	      /* There is no previous match to compare with, wait for
	       * the next step to decide.
	       */
	      s.match_available = 1;
	      s.strstart++;
	      s.lookahead--;
	    }
	  }
	  //Assert (flush != Z_NO_FLUSH, "no flush?");
	  if (s.match_available) {
	    //Tracevv((stderr,"%c", s->window[s->strstart-1]));
	    /*** _tr_tally_lit(s, s.window[s.strstart-1], bflush); ***/
	    bflush = _tr_tally(s, 0, s.window[s.strstart - 1]);

	    s.match_available = 0;
	  }
	  s.insert = s.strstart < MIN_MATCH - 1 ? s.strstart : MIN_MATCH - 1;
	  if (flush === Z_FINISH$3) {
	    /*** FLUSH_BLOCK(s, 1); ***/
	    flush_block_only(s, true);
	    if (s.strm.avail_out === 0) {
	      return BS_FINISH_STARTED;
	    }
	    /***/
	    return BS_FINISH_DONE;
	  }
	  if (s.last_lit) {
	    /*** FLUSH_BLOCK(s, 0); ***/
	    flush_block_only(s, false);
	    if (s.strm.avail_out === 0) {
	      return BS_NEED_MORE;
	    }
	    /***/
	  }

	  return BS_BLOCK_DONE;
	};


	/* ===========================================================================
	 * For Z_RLE, simply look for runs of bytes, generate matches only of distance
	 * one.  Do not maintain a hash table.  (It will be regenerated if this run of
	 * deflate switches away from Z_RLE.)
	 */
	const deflate_rle = (s, flush) => {

	  let bflush;            /* set if current block must be flushed */
	  let prev;              /* byte at distance one to match */
	  let scan, strend;      /* scan goes up to strend for length of run */

	  const _win = s.window;

	  for (;;) {
	    /* Make sure that we always have enough lookahead, except
	     * at the end of the input file. We need MAX_MATCH bytes
	     * for the longest run, plus one for the unrolled loop.
	     */
	    if (s.lookahead <= MAX_MATCH) {
	      fill_window(s);
	      if (s.lookahead <= MAX_MATCH && flush === Z_NO_FLUSH$2) {
	        return BS_NEED_MORE;
	      }
	      if (s.lookahead === 0) { break; } /* flush the current block */
	    }

	    /* See how many times the previous byte repeats */
	    s.match_length = 0;
	    if (s.lookahead >= MIN_MATCH && s.strstart > 0) {
	      scan = s.strstart - 1;
	      prev = _win[scan];
	      if (prev === _win[++scan] && prev === _win[++scan] && prev === _win[++scan]) {
	        strend = s.strstart + MAX_MATCH;
	        do {
	          /*jshint noempty:false*/
	        } while (prev === _win[++scan] && prev === _win[++scan] &&
	                 prev === _win[++scan] && prev === _win[++scan] &&
	                 prev === _win[++scan] && prev === _win[++scan] &&
	                 prev === _win[++scan] && prev === _win[++scan] &&
	                 scan < strend);
	        s.match_length = MAX_MATCH - (strend - scan);
	        if (s.match_length > s.lookahead) {
	          s.match_length = s.lookahead;
	        }
	      }
	      //Assert(scan <= s->window+(uInt)(s->window_size-1), "wild scan");
	    }

	    /* Emit match if have run of MIN_MATCH or longer, else emit literal */
	    if (s.match_length >= MIN_MATCH) {
	      //check_match(s, s.strstart, s.strstart - 1, s.match_length);

	      /*** _tr_tally_dist(s, 1, s.match_length - MIN_MATCH, bflush); ***/
	      bflush = _tr_tally(s, 1, s.match_length - MIN_MATCH);

	      s.lookahead -= s.match_length;
	      s.strstart += s.match_length;
	      s.match_length = 0;
	    } else {
	      /* No match, output a literal byte */
	      //Tracevv((stderr,"%c", s->window[s->strstart]));
	      /*** _tr_tally_lit(s, s.window[s.strstart], bflush); ***/
	      bflush = _tr_tally(s, 0, s.window[s.strstart]);

	      s.lookahead--;
	      s.strstart++;
	    }
	    if (bflush) {
	      /*** FLUSH_BLOCK(s, 0); ***/
	      flush_block_only(s, false);
	      if (s.strm.avail_out === 0) {
	        return BS_NEED_MORE;
	      }
	      /***/
	    }
	  }
	  s.insert = 0;
	  if (flush === Z_FINISH$3) {
	    /*** FLUSH_BLOCK(s, 1); ***/
	    flush_block_only(s, true);
	    if (s.strm.avail_out === 0) {
	      return BS_FINISH_STARTED;
	    }
	    /***/
	    return BS_FINISH_DONE;
	  }
	  if (s.last_lit) {
	    /*** FLUSH_BLOCK(s, 0); ***/
	    flush_block_only(s, false);
	    if (s.strm.avail_out === 0) {
	      return BS_NEED_MORE;
	    }
	    /***/
	  }
	  return BS_BLOCK_DONE;
	};

	/* ===========================================================================
	 * For Z_HUFFMAN_ONLY, do not look for matches.  Do not maintain a hash table.
	 * (It will be regenerated if this run of deflate switches away from Huffman.)
	 */
	const deflate_huff = (s, flush) => {

	  let bflush;             /* set if current block must be flushed */

	  for (;;) {
	    /* Make sure that we have a literal to write. */
	    if (s.lookahead === 0) {
	      fill_window(s);
	      if (s.lookahead === 0) {
	        if (flush === Z_NO_FLUSH$2) {
	          return BS_NEED_MORE;
	        }
	        break;      /* flush the current block */
	      }
	    }

	    /* Output a literal byte */
	    s.match_length = 0;
	    //Tracevv((stderr,"%c", s->window[s->strstart]));
	    /*** _tr_tally_lit(s, s.window[s.strstart], bflush); ***/
	    bflush = _tr_tally(s, 0, s.window[s.strstart]);
	    s.lookahead--;
	    s.strstart++;
	    if (bflush) {
	      /*** FLUSH_BLOCK(s, 0); ***/
	      flush_block_only(s, false);
	      if (s.strm.avail_out === 0) {
	        return BS_NEED_MORE;
	      }
	      /***/
	    }
	  }
	  s.insert = 0;
	  if (flush === Z_FINISH$3) {
	    /*** FLUSH_BLOCK(s, 1); ***/
	    flush_block_only(s, true);
	    if (s.strm.avail_out === 0) {
	      return BS_FINISH_STARTED;
	    }
	    /***/
	    return BS_FINISH_DONE;
	  }
	  if (s.last_lit) {
	    /*** FLUSH_BLOCK(s, 0); ***/
	    flush_block_only(s, false);
	    if (s.strm.avail_out === 0) {
	      return BS_NEED_MORE;
	    }
	    /***/
	  }
	  return BS_BLOCK_DONE;
	};

	/* Values for max_lazy_match, good_match and max_chain_length, depending on
	 * the desired pack level (0..9). The values given below have been tuned to
	 * exclude worst case performance for pathological files. Better values may be
	 * found for specific files.
	 */
	function Config(good_length, max_lazy, nice_length, max_chain, func) {

	  this.good_length = good_length;
	  this.max_lazy = max_lazy;
	  this.nice_length = nice_length;
	  this.max_chain = max_chain;
	  this.func = func;
	}

	const configuration_table = [
	  /*      good lazy nice chain */
	  new Config(0, 0, 0, 0, deflate_stored),          /* 0 store only */
	  new Config(4, 4, 8, 4, deflate_fast),            /* 1 max speed, no lazy matches */
	  new Config(4, 5, 16, 8, deflate_fast),           /* 2 */
	  new Config(4, 6, 32, 32, deflate_fast),          /* 3 */

	  new Config(4, 4, 16, 16, deflate_slow),          /* 4 lazy matches */
	  new Config(8, 16, 32, 32, deflate_slow),         /* 5 */
	  new Config(8, 16, 128, 128, deflate_slow),       /* 6 */
	  new Config(8, 32, 128, 256, deflate_slow),       /* 7 */
	  new Config(32, 128, 258, 1024, deflate_slow),    /* 8 */
	  new Config(32, 258, 258, 4096, deflate_slow)     /* 9 max compression */
	];


	/* ===========================================================================
	 * Initialize the "longest match" routines for a new zlib stream
	 */
	const lm_init = (s) => {

	  s.window_size = 2 * s.w_size;

	  /*** CLEAR_HASH(s); ***/
	  zero(s.head); // Fill with NIL (= 0);

	  /* Set the default configuration parameters:
	   */
	  s.max_lazy_match = configuration_table[s.level].max_lazy;
	  s.good_match = configuration_table[s.level].good_length;
	  s.nice_match = configuration_table[s.level].nice_length;
	  s.max_chain_length = configuration_table[s.level].max_chain;

	  s.strstart = 0;
	  s.block_start = 0;
	  s.lookahead = 0;
	  s.insert = 0;
	  s.match_length = s.prev_length = MIN_MATCH - 1;
	  s.match_available = 0;
	  s.ins_h = 0;
	};


	function DeflateState() {
	  this.strm = null;            /* pointer back to this zlib stream */
	  this.status = 0;            /* as the name implies */
	  this.pending_buf = null;      /* output still pending */
	  this.pending_buf_size = 0;  /* size of pending_buf */
	  this.pending_out = 0;       /* next pending byte to output to the stream */
	  this.pending = 0;           /* nb of bytes in the pending buffer */
	  this.wrap = 0;              /* bit 0 true for zlib, bit 1 true for gzip */
	  this.gzhead = null;         /* gzip header information to write */
	  this.gzindex = 0;           /* where in extra, name, or comment */
	  this.method = Z_DEFLATED$2; /* can only be DEFLATED */
	  this.last_flush = -1;   /* value of flush param for previous deflate call */

	  this.w_size = 0;  /* LZ77 window size (32K by default) */
	  this.w_bits = 0;  /* log2(w_size)  (8..16) */
	  this.w_mask = 0;  /* w_size - 1 */

	  this.window = null;
	  /* Sliding window. Input bytes are read into the second half of the window,
	   * and move to the first half later to keep a dictionary of at least wSize
	   * bytes. With this organization, matches are limited to a distance of
	   * wSize-MAX_MATCH bytes, but this ensures that IO is always
	   * performed with a length multiple of the block size.
	   */

	  this.window_size = 0;
	  /* Actual size of window: 2*wSize, except when the user input buffer
	   * is directly used as sliding window.
	   */

	  this.prev = null;
	  /* Link to older string with same hash index. To limit the size of this
	   * array to 64K, this link is maintained only for the last 32K strings.
	   * An index in this array is thus a window index modulo 32K.
	   */

	  this.head = null;   /* Heads of the hash chains or NIL. */

	  this.ins_h = 0;       /* hash index of string to be inserted */
	  this.hash_size = 0;   /* number of elements in hash table */
	  this.hash_bits = 0;   /* log2(hash_size) */
	  this.hash_mask = 0;   /* hash_size-1 */

	  this.hash_shift = 0;
	  /* Number of bits by which ins_h must be shifted at each input
	   * step. It must be such that after MIN_MATCH steps, the oldest
	   * byte no longer takes part in the hash key, that is:
	   *   hash_shift * MIN_MATCH >= hash_bits
	   */

	  this.block_start = 0;
	  /* Window position at the beginning of the current output block. Gets
	   * negative when the window is moved backwards.
	   */

	  this.match_length = 0;      /* length of best match */
	  this.prev_match = 0;        /* previous match */
	  this.match_available = 0;   /* set if previous match exists */
	  this.strstart = 0;          /* start of string to insert */
	  this.match_start = 0;       /* start of matching string */
	  this.lookahead = 0;         /* number of valid bytes ahead in window */

	  this.prev_length = 0;
	  /* Length of the best match at previous step. Matches not greater than this
	   * are discarded. This is used in the lazy match evaluation.
	   */

	  this.max_chain_length = 0;
	  /* To speed up deflation, hash chains are never searched beyond this
	   * length.  A higher limit improves compression ratio but degrades the
	   * speed.
	   */

	  this.max_lazy_match = 0;
	  /* Attempt to find a better match only when the current match is strictly
	   * smaller than this value. This mechanism is used only for compression
	   * levels >= 4.
	   */
	  // That's alias to max_lazy_match, don't use directly
	  //this.max_insert_length = 0;
	  /* Insert new strings in the hash table only if the match length is not
	   * greater than this length. This saves time but degrades compression.
	   * max_insert_length is used only for compression levels <= 3.
	   */

	  this.level = 0;     /* compression level (1..9) */
	  this.strategy = 0;  /* favor or force Huffman coding*/

	  this.good_match = 0;
	  /* Use a faster search when the previous match is longer than this */

	  this.nice_match = 0; /* Stop searching when current match exceeds this */

	              /* used by trees.c: */

	  /* Didn't use ct_data typedef below to suppress compiler warning */

	  // struct ct_data_s dyn_ltree[HEAP_SIZE];   /* literal and length tree */
	  // struct ct_data_s dyn_dtree[2*D_CODES+1]; /* distance tree */
	  // struct ct_data_s bl_tree[2*BL_CODES+1];  /* Huffman tree for bit lengths */

	  // Use flat array of DOUBLE size, with interleaved fata,
	  // because JS does not support effective
	  this.dyn_ltree  = new Uint16Array(HEAP_SIZE * 2);
	  this.dyn_dtree  = new Uint16Array((2 * D_CODES + 1) * 2);
	  this.bl_tree    = new Uint16Array((2 * BL_CODES + 1) * 2);
	  zero(this.dyn_ltree);
	  zero(this.dyn_dtree);
	  zero(this.bl_tree);

	  this.l_desc   = null;         /* desc. for literal tree */
	  this.d_desc   = null;         /* desc. for distance tree */
	  this.bl_desc  = null;         /* desc. for bit length tree */

	  //ush bl_count[MAX_BITS+1];
	  this.bl_count = new Uint16Array(MAX_BITS + 1);
	  /* number of codes at each bit length for an optimal tree */

	  //int heap[2*L_CODES+1];      /* heap used to build the Huffman trees */
	  this.heap = new Uint16Array(2 * L_CODES + 1);  /* heap used to build the Huffman trees */
	  zero(this.heap);

	  this.heap_len = 0;               /* number of elements in the heap */
	  this.heap_max = 0;               /* element of largest frequency */
	  /* The sons of heap[n] are heap[2*n] and heap[2*n+1]. heap[0] is not used.
	   * The same heap array is used to build all trees.
	   */

	  this.depth = new Uint16Array(2 * L_CODES + 1); //uch depth[2*L_CODES+1];
	  zero(this.depth);
	  /* Depth of each subtree used as tie breaker for trees of equal frequency
	   */

	  this.l_buf = 0;          /* buffer index for literals or lengths */

	  this.lit_bufsize = 0;
	  /* Size of match buffer for literals/lengths.  There are 4 reasons for
	   * limiting lit_bufsize to 64K:
	   *   - frequencies can be kept in 16 bit counters
	   *   - if compression is not successful for the first block, all input
	   *     data is still in the window so we can still emit a stored block even
	   *     when input comes from standard input.  (This can also be done for
	   *     all blocks if lit_bufsize is not greater than 32K.)
	   *   - if compression is not successful for a file smaller than 64K, we can
	   *     even emit a stored file instead of a stored block (saving 5 bytes).
	   *     This is applicable only for zip (not gzip or zlib).
	   *   - creating new Huffman trees less frequently may not provide fast
	   *     adaptation to changes in the input data statistics. (Take for
	   *     example a binary file with poorly compressible code followed by
	   *     a highly compressible string table.) Smaller buffer sizes give
	   *     fast adaptation but have of course the overhead of transmitting
	   *     trees more frequently.
	   *   - I can't count above 4
	   */

	  this.last_lit = 0;      /* running index in l_buf */

	  this.d_buf = 0;
	  /* Buffer index for distances. To simplify the code, d_buf and l_buf have
	   * the same number of elements. To use different lengths, an extra flag
	   * array would be necessary.
	   */

	  this.opt_len = 0;       /* bit length of current block with optimal trees */
	  this.static_len = 0;    /* bit length of current block with static trees */
	  this.matches = 0;       /* number of string matches in current block */
	  this.insert = 0;        /* bytes at end of window left to insert */


	  this.bi_buf = 0;
	  /* Output buffer. bits are inserted starting at the bottom (least
	   * significant bits).
	   */
	  this.bi_valid = 0;
	  /* Number of valid bits in bi_buf.  All bits above the last valid bit
	   * are always zero.
	   */

	  // Used for window memory init. We safely ignore it for JS. That makes
	  // sense only for pointers and memory check tools.
	  //this.high_water = 0;
	  /* High water mark offset in window for initialized bytes -- bytes above
	   * this are set to zero in order to avoid memory check warnings when
	   * longest match routines access bytes past the input.  This is then
	   * updated to the new high water mark.
	   */
	}


	const deflateResetKeep = (strm) => {

	  if (!strm || !strm.state) {
	    return err(strm, Z_STREAM_ERROR$2);
	  }

	  strm.total_in = strm.total_out = 0;
	  strm.data_type = Z_UNKNOWN;

	  const s = strm.state;
	  s.pending = 0;
	  s.pending_out = 0;

	  if (s.wrap < 0) {
	    s.wrap = -s.wrap;
	    /* was made negative by deflate(..., Z_FINISH); */
	  }
	  s.status = (s.wrap ? INIT_STATE : BUSY_STATE);
	  strm.adler = (s.wrap === 2) ?
	    0  // crc32(0, Z_NULL, 0)
	  :
	    1; // adler32(0, Z_NULL, 0)
	  s.last_flush = Z_NO_FLUSH$2;
	  _tr_init(s);
	  return Z_OK$3;
	};


	const deflateReset = (strm) => {

	  const ret = deflateResetKeep(strm);
	  if (ret === Z_OK$3) {
	    lm_init(strm.state);
	  }
	  return ret;
	};


	const deflateSetHeader = (strm, head) => {

	  if (!strm || !strm.state) { return Z_STREAM_ERROR$2; }
	  if (strm.state.wrap !== 2) { return Z_STREAM_ERROR$2; }
	  strm.state.gzhead = head;
	  return Z_OK$3;
	};


	const deflateInit2 = (strm, level, method, windowBits, memLevel, strategy) => {

	  if (!strm) { // === Z_NULL
	    return Z_STREAM_ERROR$2;
	  }
	  let wrap = 1;

	  if (level === Z_DEFAULT_COMPRESSION$1) {
	    level = 6;
	  }

	  if (windowBits < 0) { /* suppress zlib wrapper */
	    wrap = 0;
	    windowBits = -windowBits;
	  }

	  else if (windowBits > 15) {
	    wrap = 2;           /* write gzip wrapper instead */
	    windowBits -= 16;
	  }


	  if (memLevel < 1 || memLevel > MAX_MEM_LEVEL || method !== Z_DEFLATED$2 ||
	    windowBits < 8 || windowBits > 15 || level < 0 || level > 9 ||
	    strategy < 0 || strategy > Z_FIXED) {
	    return err(strm, Z_STREAM_ERROR$2);
	  }


	  if (windowBits === 8) {
	    windowBits = 9;
	  }
	  /* until 256-byte window bug fixed */

	  const s = new DeflateState();

	  strm.state = s;
	  s.strm = strm;

	  s.wrap = wrap;
	  s.gzhead = null;
	  s.w_bits = windowBits;
	  s.w_size = 1 << s.w_bits;
	  s.w_mask = s.w_size - 1;

	  s.hash_bits = memLevel + 7;
	  s.hash_size = 1 << s.hash_bits;
	  s.hash_mask = s.hash_size - 1;
	  s.hash_shift = ~~((s.hash_bits + MIN_MATCH - 1) / MIN_MATCH);

	  s.window = new Uint8Array(s.w_size * 2);
	  s.head = new Uint16Array(s.hash_size);
	  s.prev = new Uint16Array(s.w_size);

	  // Don't need mem init magic for JS.
	  //s.high_water = 0;  /* nothing written to s->window yet */

	  s.lit_bufsize = 1 << (memLevel + 6); /* 16K elements by default */

	  s.pending_buf_size = s.lit_bufsize * 4;

	  //overlay = (ushf *) ZALLOC(strm, s->lit_bufsize, sizeof(ush)+2);
	  //s->pending_buf = (uchf *) overlay;
	  s.pending_buf = new Uint8Array(s.pending_buf_size);

	  // It is offset from `s.pending_buf` (size is `s.lit_bufsize * 2`)
	  //s->d_buf = overlay + s->lit_bufsize/sizeof(ush);
	  s.d_buf = 1 * s.lit_bufsize;

	  //s->l_buf = s->pending_buf + (1+sizeof(ush))*s->lit_bufsize;
	  s.l_buf = (1 + 2) * s.lit_bufsize;

	  s.level = level;
	  s.strategy = strategy;
	  s.method = method;

	  return deflateReset(strm);
	};

	const deflateInit = (strm, level) => {

	  return deflateInit2(strm, level, Z_DEFLATED$2, MAX_WBITS$1, DEF_MEM_LEVEL, Z_DEFAULT_STRATEGY$1);
	};


	const deflate$2 = (strm, flush) => {

	  let beg, val; // for gzip header write only

	  if (!strm || !strm.state ||
	    flush > Z_BLOCK$1 || flush < 0) {
	    return strm ? err(strm, Z_STREAM_ERROR$2) : Z_STREAM_ERROR$2;
	  }

	  const s = strm.state;

	  if (!strm.output ||
	      (!strm.input && strm.avail_in !== 0) ||
	      (s.status === FINISH_STATE && flush !== Z_FINISH$3)) {
	    return err(strm, (strm.avail_out === 0) ? Z_BUF_ERROR$1 : Z_STREAM_ERROR$2);
	  }

	  s.strm = strm; /* just in case */
	  const old_flush = s.last_flush;
	  s.last_flush = flush;

	  /* Write the header */
	  if (s.status === INIT_STATE) {

	    if (s.wrap === 2) { // GZIP header
	      strm.adler = 0;  //crc32(0L, Z_NULL, 0);
	      put_byte(s, 31);
	      put_byte(s, 139);
	      put_byte(s, 8);
	      if (!s.gzhead) { // s->gzhead == Z_NULL
	        put_byte(s, 0);
	        put_byte(s, 0);
	        put_byte(s, 0);
	        put_byte(s, 0);
	        put_byte(s, 0);
	        put_byte(s, s.level === 9 ? 2 :
	                    (s.strategy >= Z_HUFFMAN_ONLY || s.level < 2 ?
	                     4 : 0));
	        put_byte(s, OS_CODE);
	        s.status = BUSY_STATE;
	      }
	      else {
	        put_byte(s, (s.gzhead.text ? 1 : 0) +
	                    (s.gzhead.hcrc ? 2 : 0) +
	                    (!s.gzhead.extra ? 0 : 4) +
	                    (!s.gzhead.name ? 0 : 8) +
	                    (!s.gzhead.comment ? 0 : 16)
	        );
	        put_byte(s, s.gzhead.time & 0xff);
	        put_byte(s, (s.gzhead.time >> 8) & 0xff);
	        put_byte(s, (s.gzhead.time >> 16) & 0xff);
	        put_byte(s, (s.gzhead.time >> 24) & 0xff);
	        put_byte(s, s.level === 9 ? 2 :
	                    (s.strategy >= Z_HUFFMAN_ONLY || s.level < 2 ?
	                     4 : 0));
	        put_byte(s, s.gzhead.os & 0xff);
	        if (s.gzhead.extra && s.gzhead.extra.length) {
	          put_byte(s, s.gzhead.extra.length & 0xff);
	          put_byte(s, (s.gzhead.extra.length >> 8) & 0xff);
	        }
	        if (s.gzhead.hcrc) {
	          strm.adler = crc32$1(strm.adler, s.pending_buf, s.pending, 0);
	        }
	        s.gzindex = 0;
	        s.status = EXTRA_STATE;
	      }
	    }
	    else // DEFLATE header
	    {
	      let header = (Z_DEFLATED$2 + ((s.w_bits - 8) << 4)) << 8;
	      let level_flags = -1;

	      if (s.strategy >= Z_HUFFMAN_ONLY || s.level < 2) {
	        level_flags = 0;
	      } else if (s.level < 6) {
	        level_flags = 1;
	      } else if (s.level === 6) {
	        level_flags = 2;
	      } else {
	        level_flags = 3;
	      }
	      header |= (level_flags << 6);
	      if (s.strstart !== 0) { header |= PRESET_DICT; }
	      header += 31 - (header % 31);

	      s.status = BUSY_STATE;
	      putShortMSB(s, header);

	      /* Save the adler32 of the preset dictionary: */
	      if (s.strstart !== 0) {
	        putShortMSB(s, strm.adler >>> 16);
	        putShortMSB(s, strm.adler & 0xffff);
	      }
	      strm.adler = 1; // adler32(0L, Z_NULL, 0);
	    }
	  }

	//#ifdef GZIP
	  if (s.status === EXTRA_STATE) {
	    if (s.gzhead.extra/* != Z_NULL*/) {
	      beg = s.pending;  /* start of bytes to update crc */

	      while (s.gzindex < (s.gzhead.extra.length & 0xffff)) {
	        if (s.pending === s.pending_buf_size) {
	          if (s.gzhead.hcrc && s.pending > beg) {
	            strm.adler = crc32$1(strm.adler, s.pending_buf, s.pending - beg, beg);
	          }
	          flush_pending(strm);
	          beg = s.pending;
	          if (s.pending === s.pending_buf_size) {
	            break;
	          }
	        }
	        put_byte(s, s.gzhead.extra[s.gzindex] & 0xff);
	        s.gzindex++;
	      }
	      if (s.gzhead.hcrc && s.pending > beg) {
	        strm.adler = crc32$1(strm.adler, s.pending_buf, s.pending - beg, beg);
	      }
	      if (s.gzindex === s.gzhead.extra.length) {
	        s.gzindex = 0;
	        s.status = NAME_STATE;
	      }
	    }
	    else {
	      s.status = NAME_STATE;
	    }
	  }
	  if (s.status === NAME_STATE) {
	    if (s.gzhead.name/* != Z_NULL*/) {
	      beg = s.pending;  /* start of bytes to update crc */
	      //int val;

	      do {
	        if (s.pending === s.pending_buf_size) {
	          if (s.gzhead.hcrc && s.pending > beg) {
	            strm.adler = crc32$1(strm.adler, s.pending_buf, s.pending - beg, beg);
	          }
	          flush_pending(strm);
	          beg = s.pending;
	          if (s.pending === s.pending_buf_size) {
	            val = 1;
	            break;
	          }
	        }
	        // JS specific: little magic to add zero terminator to end of string
	        if (s.gzindex < s.gzhead.name.length) {
	          val = s.gzhead.name.charCodeAt(s.gzindex++) & 0xff;
	        } else {
	          val = 0;
	        }
	        put_byte(s, val);
	      } while (val !== 0);

	      if (s.gzhead.hcrc && s.pending > beg) {
	        strm.adler = crc32$1(strm.adler, s.pending_buf, s.pending - beg, beg);
	      }
	      if (val === 0) {
	        s.gzindex = 0;
	        s.status = COMMENT_STATE;
	      }
	    }
	    else {
	      s.status = COMMENT_STATE;
	    }
	  }
	  if (s.status === COMMENT_STATE) {
	    if (s.gzhead.comment/* != Z_NULL*/) {
	      beg = s.pending;  /* start of bytes to update crc */
	      //int val;

	      do {
	        if (s.pending === s.pending_buf_size) {
	          if (s.gzhead.hcrc && s.pending > beg) {
	            strm.adler = crc32$1(strm.adler, s.pending_buf, s.pending - beg, beg);
	          }
	          flush_pending(strm);
	          beg = s.pending;
	          if (s.pending === s.pending_buf_size) {
	            val = 1;
	            break;
	          }
	        }
	        // JS specific: little magic to add zero terminator to end of string
	        if (s.gzindex < s.gzhead.comment.length) {
	          val = s.gzhead.comment.charCodeAt(s.gzindex++) & 0xff;
	        } else {
	          val = 0;
	        }
	        put_byte(s, val);
	      } while (val !== 0);

	      if (s.gzhead.hcrc && s.pending > beg) {
	        strm.adler = crc32$1(strm.adler, s.pending_buf, s.pending - beg, beg);
	      }
	      if (val === 0) {
	        s.status = HCRC_STATE;
	      }
	    }
	    else {
	      s.status = HCRC_STATE;
	    }
	  }
	  if (s.status === HCRC_STATE) {
	    if (s.gzhead.hcrc) {
	      if (s.pending + 2 > s.pending_buf_size) {
	        flush_pending(strm);
	      }
	      if (s.pending + 2 <= s.pending_buf_size) {
	        put_byte(s, strm.adler & 0xff);
	        put_byte(s, (strm.adler >> 8) & 0xff);
	        strm.adler = 0; //crc32(0L, Z_NULL, 0);
	        s.status = BUSY_STATE;
	      }
	    }
	    else {
	      s.status = BUSY_STATE;
	    }
	  }
	//#endif

	  /* Flush as much pending output as possible */
	  if (s.pending !== 0) {
	    flush_pending(strm);
	    if (strm.avail_out === 0) {
	      /* Since avail_out is 0, deflate will be called again with
	       * more output space, but possibly with both pending and
	       * avail_in equal to zero. There won't be anything to do,
	       * but this is not an error situation so make sure we
	       * return OK instead of BUF_ERROR at next call of deflate:
	       */
	      s.last_flush = -1;
	      return Z_OK$3;
	    }

	    /* Make sure there is something to do and avoid duplicate consecutive
	     * flushes. For repeated and useless calls with Z_FINISH, we keep
	     * returning Z_STREAM_END instead of Z_BUF_ERROR.
	     */
	  } else if (strm.avail_in === 0 && rank(flush) <= rank(old_flush) &&
	    flush !== Z_FINISH$3) {
	    return err(strm, Z_BUF_ERROR$1);
	  }

	  /* User must not provide more input after the first FINISH: */
	  if (s.status === FINISH_STATE && strm.avail_in !== 0) {
	    return err(strm, Z_BUF_ERROR$1);
	  }

	  /* Start a new block or continue the current one.
	   */
	  if (strm.avail_in !== 0 || s.lookahead !== 0 ||
	    (flush !== Z_NO_FLUSH$2 && s.status !== FINISH_STATE)) {
	    let bstate = (s.strategy === Z_HUFFMAN_ONLY) ? deflate_huff(s, flush) :
	      (s.strategy === Z_RLE ? deflate_rle(s, flush) :
	        configuration_table[s.level].func(s, flush));

	    if (bstate === BS_FINISH_STARTED || bstate === BS_FINISH_DONE) {
	      s.status = FINISH_STATE;
	    }
	    if (bstate === BS_NEED_MORE || bstate === BS_FINISH_STARTED) {
	      if (strm.avail_out === 0) {
	        s.last_flush = -1;
	        /* avoid BUF_ERROR next call, see above */
	      }
	      return Z_OK$3;
	      /* If flush != Z_NO_FLUSH && avail_out == 0, the next call
	       * of deflate should use the same flush parameter to make sure
	       * that the flush is complete. So we don't have to output an
	       * empty block here, this will be done at next call. This also
	       * ensures that for a very small output buffer, we emit at most
	       * one empty block.
	       */
	    }
	    if (bstate === BS_BLOCK_DONE) {
	      if (flush === Z_PARTIAL_FLUSH) {
	        _tr_align(s);
	      }
	      else if (flush !== Z_BLOCK$1) { /* FULL_FLUSH or SYNC_FLUSH */

	        _tr_stored_block(s, 0, 0, false);
	        /* For a full flush, this empty block will be recognized
	         * as a special marker by inflate_sync().
	         */
	        if (flush === Z_FULL_FLUSH$1) {
	          /*** CLEAR_HASH(s); ***/             /* forget history */
	          zero(s.head); // Fill with NIL (= 0);

	          if (s.lookahead === 0) {
	            s.strstart = 0;
	            s.block_start = 0;
	            s.insert = 0;
	          }
	        }
	      }
	      flush_pending(strm);
	      if (strm.avail_out === 0) {
	        s.last_flush = -1; /* avoid BUF_ERROR at next call, see above */
	        return Z_OK$3;
	      }
	    }
	  }
	  //Assert(strm->avail_out > 0, "bug2");
	  //if (strm.avail_out <= 0) { throw new Error("bug2");}

	  if (flush !== Z_FINISH$3) { return Z_OK$3; }
	  if (s.wrap <= 0) { return Z_STREAM_END$3; }

	  /* Write the trailer */
	  if (s.wrap === 2) {
	    put_byte(s, strm.adler & 0xff);
	    put_byte(s, (strm.adler >> 8) & 0xff);
	    put_byte(s, (strm.adler >> 16) & 0xff);
	    put_byte(s, (strm.adler >> 24) & 0xff);
	    put_byte(s, strm.total_in & 0xff);
	    put_byte(s, (strm.total_in >> 8) & 0xff);
	    put_byte(s, (strm.total_in >> 16) & 0xff);
	    put_byte(s, (strm.total_in >> 24) & 0xff);
	  }
	  else
	  {
	    putShortMSB(s, strm.adler >>> 16);
	    putShortMSB(s, strm.adler & 0xffff);
	  }

	  flush_pending(strm);
	  /* If avail_out is zero, the application will call deflate again
	   * to flush the rest.
	   */
	  if (s.wrap > 0) { s.wrap = -s.wrap; }
	  /* write the trailer only once! */
	  return s.pending !== 0 ? Z_OK$3 : Z_STREAM_END$3;
	};


	const deflateEnd = (strm) => {

	  if (!strm/*== Z_NULL*/ || !strm.state/*== Z_NULL*/) {
	    return Z_STREAM_ERROR$2;
	  }

	  const status = strm.state.status;
	  if (status !== INIT_STATE &&
	    status !== EXTRA_STATE &&
	    status !== NAME_STATE &&
	    status !== COMMENT_STATE &&
	    status !== HCRC_STATE &&
	    status !== BUSY_STATE &&
	    status !== FINISH_STATE
	  ) {
	    return err(strm, Z_STREAM_ERROR$2);
	  }

	  strm.state = null;

	  return status === BUSY_STATE ? err(strm, Z_DATA_ERROR$2) : Z_OK$3;
	};


	/* =========================================================================
	 * Initializes the compression dictionary from the given byte
	 * sequence without producing any compressed output.
	 */
	const deflateSetDictionary = (strm, dictionary) => {

	  let dictLength = dictionary.length;

	  if (!strm/*== Z_NULL*/ || !strm.state/*== Z_NULL*/) {
	    return Z_STREAM_ERROR$2;
	  }

	  const s = strm.state;
	  const wrap = s.wrap;

	  if (wrap === 2 || (wrap === 1 && s.status !== INIT_STATE) || s.lookahead) {
	    return Z_STREAM_ERROR$2;
	  }

	  /* when using zlib wrappers, compute Adler-32 for provided dictionary */
	  if (wrap === 1) {
	    /* adler32(strm->adler, dictionary, dictLength); */
	    strm.adler = adler32$1(strm.adler, dictionary, dictLength, 0);
	  }

	  s.wrap = 0;   /* avoid computing Adler-32 in read_buf */

	  /* if dictionary would fill window, just replace the history */
	  if (dictLength >= s.w_size) {
	    if (wrap === 0) {            /* already empty otherwise */
	      /*** CLEAR_HASH(s); ***/
	      zero(s.head); // Fill with NIL (= 0);
	      s.strstart = 0;
	      s.block_start = 0;
	      s.insert = 0;
	    }
	    /* use the tail */
	    // dictionary = dictionary.slice(dictLength - s.w_size);
	    let tmpDict = new Uint8Array(s.w_size);
	    tmpDict.set(dictionary.subarray(dictLength - s.w_size, dictLength), 0);
	    dictionary = tmpDict;
	    dictLength = s.w_size;
	  }
	  /* insert dictionary into window and hash */
	  const avail = strm.avail_in;
	  const next = strm.next_in;
	  const input = strm.input;
	  strm.avail_in = dictLength;
	  strm.next_in = 0;
	  strm.input = dictionary;
	  fill_window(s);
	  while (s.lookahead >= MIN_MATCH) {
	    let str = s.strstart;
	    let n = s.lookahead - (MIN_MATCH - 1);
	    do {
	      /* UPDATE_HASH(s, s->ins_h, s->window[str + MIN_MATCH-1]); */
	      s.ins_h = HASH(s, s.ins_h, s.window[str + MIN_MATCH - 1]);

	      s.prev[str & s.w_mask] = s.head[s.ins_h];

	      s.head[s.ins_h] = str;
	      str++;
	    } while (--n);
	    s.strstart = str;
	    s.lookahead = MIN_MATCH - 1;
	    fill_window(s);
	  }
	  s.strstart += s.lookahead;
	  s.block_start = s.strstart;
	  s.insert = s.lookahead;
	  s.lookahead = 0;
	  s.match_length = s.prev_length = MIN_MATCH - 1;
	  s.match_available = 0;
	  strm.next_in = next;
	  strm.input = input;
	  strm.avail_in = avail;
	  s.wrap = wrap;
	  return Z_OK$3;
	};


	deflate$3.deflateInit = deflateInit;
	deflate$3.deflateInit2 = deflateInit2;
	deflate$3.deflateReset = deflateReset;
	deflate$3.deflateResetKeep = deflateResetKeep;
	deflate$3.deflateSetHeader = deflateSetHeader;
	deflate$3.deflate = deflate$2;
	deflate$3.deflateEnd = deflateEnd;
	deflate$3.deflateSetDictionary = deflateSetDictionary;
	deflate$3.deflateInfo = 'pako deflate (from Nodeca project)';

	var common$3 = {};

	const _has = (obj, key) => {
	  return Object.prototype.hasOwnProperty.call(obj, key);
	};

	common$3.assign = function (obj /*from1, from2, from3, ...*/) {
	  const sources = Array.prototype.slice.call(arguments, 1);
	  while (sources.length) {
	    const source = sources.shift();
	    if (!source) { continue; }

	    if (typeof source !== 'object') {
	      throw new TypeError(source + 'must be non-object');
	    }

	    for (const p in source) {
	      if (_has(source, p)) {
	        obj[p] = source[p];
	      }
	    }
	  }

	  return obj;
	};


	// Join array of chunks to single array.
	common$3.flattenChunks = (chunks) => {
	  // calculate data length
	  let len = 0;

	  for (let i = 0, l = chunks.length; i < l; i++) {
	    len += chunks[i].length;
	  }

	  // join chunks
	  const result = new Uint8Array(len);

	  for (let i = 0, pos = 0, l = chunks.length; i < l; i++) {
	    let chunk = chunks[i];
	    result.set(chunk, pos);
	    pos += chunk.length;
	  }

	  return result;
	};

	var strings$2 = {};

	// Quick check if we can use fast array to bin string conversion
	//
	// - apply(Array) can fail on Android 2.2
	// - apply(Uint8Array) can fail on iOS 5.1 Safari
	//
	let STR_APPLY_UIA_OK = true;

	try { String.fromCharCode.apply(null, new Uint8Array(1)); } catch (__) { STR_APPLY_UIA_OK = false; }


	// Table with utf8 lengths (calculated by first byte of sequence)
	// Note, that 5 & 6-byte values and some 4-byte values can not be represented in JS,
	// because max possible codepoint is 0x10ffff
	const _utf8len = new Uint8Array(256);
	for (let q = 0; q < 256; q++) {
	  _utf8len[q] = (q >= 252 ? 6 : q >= 248 ? 5 : q >= 240 ? 4 : q >= 224 ? 3 : q >= 192 ? 2 : 1);
	}
	_utf8len[254] = _utf8len[254] = 1; // Invalid sequence start


	// convert string to array (typed, when possible)
	strings$2.string2buf = (str) => {
	  if (typeof TextEncoder === 'function' && TextEncoder.prototype.encode) {
	    return new TextEncoder().encode(str);
	  }

	  let buf, c, c2, m_pos, i, str_len = str.length, buf_len = 0;

	  // count binary size
	  for (m_pos = 0; m_pos < str_len; m_pos++) {
	    c = str.charCodeAt(m_pos);
	    if ((c & 0xfc00) === 0xd800 && (m_pos + 1 < str_len)) {
	      c2 = str.charCodeAt(m_pos + 1);
	      if ((c2 & 0xfc00) === 0xdc00) {
	        c = 0x10000 + ((c - 0xd800) << 10) + (c2 - 0xdc00);
	        m_pos++;
	      }
	    }
	    buf_len += c < 0x80 ? 1 : c < 0x800 ? 2 : c < 0x10000 ? 3 : 4;
	  }

	  // allocate buffer
	  buf = new Uint8Array(buf_len);

	  // convert
	  for (i = 0, m_pos = 0; i < buf_len; m_pos++) {
	    c = str.charCodeAt(m_pos);
	    if ((c & 0xfc00) === 0xd800 && (m_pos + 1 < str_len)) {
	      c2 = str.charCodeAt(m_pos + 1);
	      if ((c2 & 0xfc00) === 0xdc00) {
	        c = 0x10000 + ((c - 0xd800) << 10) + (c2 - 0xdc00);
	        m_pos++;
	      }
	    }
	    if (c < 0x80) {
	      /* one byte */
	      buf[i++] = c;
	    } else if (c < 0x800) {
	      /* two bytes */
	      buf[i++] = 0xC0 | (c >>> 6);
	      buf[i++] = 0x80 | (c & 0x3f);
	    } else if (c < 0x10000) {
	      /* three bytes */
	      buf[i++] = 0xE0 | (c >>> 12);
	      buf[i++] = 0x80 | (c >>> 6 & 0x3f);
	      buf[i++] = 0x80 | (c & 0x3f);
	    } else {
	      /* four bytes */
	      buf[i++] = 0xf0 | (c >>> 18);
	      buf[i++] = 0x80 | (c >>> 12 & 0x3f);
	      buf[i++] = 0x80 | (c >>> 6 & 0x3f);
	      buf[i++] = 0x80 | (c & 0x3f);
	    }
	  }

	  return buf;
	};

	// Helper
	const buf2binstring = (buf, len) => {
	  // On Chrome, the arguments in a function call that are allowed is `65534`.
	  // If the length of the buffer is smaller than that, we can use this optimization,
	  // otherwise we will take a slower path.
	  if (len < 65534) {
	    if (buf.subarray && STR_APPLY_UIA_OK) {
	      return String.fromCharCode.apply(null, buf.length === len ? buf : buf.subarray(0, len));
	    }
	  }

	  let result = '';
	  for (let i = 0; i < len; i++) {
	    result += String.fromCharCode(buf[i]);
	  }
	  return result;
	};


	// convert array to string
	strings$2.buf2string = (buf, max) => {
	  const len = max || buf.length;

	  if (typeof TextDecoder === 'function' && TextDecoder.prototype.decode) {
	    return new TextDecoder().decode(buf.subarray(0, max));
	  }

	  let i, out;

	  // Reserve max possible length (2 words per char)
	  // NB: by unknown reasons, Array is significantly faster for
	  //     String.fromCharCode.apply than Uint16Array.
	  const utf16buf = new Array(len * 2);

	  for (out = 0, i = 0; i < len;) {
	    let c = buf[i++];
	    // quick process ascii
	    if (c < 0x80) { utf16buf[out++] = c; continue; }

	    let c_len = _utf8len[c];
	    // skip 5 & 6 byte codes
	    if (c_len > 4) { utf16buf[out++] = 0xfffd; i += c_len - 1; continue; }

	    // apply mask on first byte
	    c &= c_len === 2 ? 0x1f : c_len === 3 ? 0x0f : 0x07;
	    // join the rest
	    while (c_len > 1 && i < len) {
	      c = (c << 6) | (buf[i++] & 0x3f);
	      c_len--;
	    }

	    // terminated by end of string?
	    if (c_len > 1) { utf16buf[out++] = 0xfffd; continue; }

	    if (c < 0x10000) {
	      utf16buf[out++] = c;
	    } else {
	      c -= 0x10000;
	      utf16buf[out++] = 0xd800 | ((c >> 10) & 0x3ff);
	      utf16buf[out++] = 0xdc00 | (c & 0x3ff);
	    }
	  }

	  return buf2binstring(utf16buf, out);
	};


	// Calculate max possible position in utf8 buffer,
	// that will not break sequence. If that's not possible
	// - (very small limits) return max size as is.
	//
	// buf[] - utf8 bytes array
	// max   - length limit (mandatory);
	strings$2.utf8border = (buf, max) => {

	  max = max || buf.length;
	  if (max > buf.length) { max = buf.length; }

	  // go back from last position, until start of sequence found
	  let pos = max - 1;
	  while (pos >= 0 && (buf[pos] & 0xC0) === 0x80) { pos--; }

	  // Very small and broken sequence,
	  // return max, because we should return something anyway.
	  if (pos < 0) { return max; }

	  // If we came to start of buffer - that means buffer is too small,
	  // return max too.
	  if (pos === 0) { return max; }

	  return (pos + _utf8len[buf[pos]] > max) ? pos : max;
	};

	// (C) 1995-2013 Jean-loup Gailly and Mark Adler
	// (C) 2014-2017 Vitaly Puzrin and Andrey Tupitsin
	//
	// This software is provided 'as-is', without any express or implied
	// warranty. In no event will the authors be held liable for any damages
	// arising from the use of this software.
	//
	// Permission is granted to anyone to use this software for any purpose,
	// including commercial applications, and to alter it and redistribute it
	// freely, subject to the following restrictions:
	//
	// 1. The origin of this software must not be misrepresented; you must not
	//   claim that you wrote the original software. If you use this software
	//   in a product, an acknowledgment in the product documentation would be
	//   appreciated but is not required.
	// 2. Altered source versions must be plainly marked as such, and must not be
	//   misrepresented as being the original software.
	// 3. This notice may not be removed or altered from any source distribution.

	function ZStream$2() {
	  /* next input byte */
	  this.input = null; // JS specific, because we have no pointers
	  this.next_in = 0;
	  /* number of bytes available at input */
	  this.avail_in = 0;
	  /* total number of input bytes read so far */
	  this.total_in = 0;
	  /* next output byte should be put there */
	  this.output = null; // JS specific, because we have no pointers
	  this.next_out = 0;
	  /* remaining free space at output */
	  this.avail_out = 0;
	  /* total number of bytes output so far */
	  this.total_out = 0;
	  /* last error message, NULL if no error */
	  this.msg = ''/*Z_NULL*/;
	  /* not visible by applications */
	  this.state = null;
	  /* best guess about the data type: binary or text */
	  this.data_type = 2/*Z_UNKNOWN*/;
	  /* adler32 value of the uncompressed data */
	  this.adler = 0;
	}

	var zstream = ZStream$2;

	const zlib_deflate = deflate$3;
	const utils$1        = common$3;
	const strings$1      = strings$2;
	const msg$1          = messages;
	const ZStream$1      = zstream;

	const toString$1 = Object.prototype.toString;

	/* Public constants ==========================================================*/
	/* ===========================================================================*/

	const {
	  Z_NO_FLUSH: Z_NO_FLUSH$1, Z_SYNC_FLUSH, Z_FULL_FLUSH, Z_FINISH: Z_FINISH$2,
	  Z_OK: Z_OK$2, Z_STREAM_END: Z_STREAM_END$2,
	  Z_DEFAULT_COMPRESSION,
	  Z_DEFAULT_STRATEGY,
	  Z_DEFLATED: Z_DEFLATED$1
	} = constants$1;

	/* ===========================================================================*/


	/**
	 * class Deflate
	 *
	 * Generic JS-style wrapper for zlib calls. If you don't need
	 * streaming behaviour - use more simple functions: [[deflate]],
	 * [[deflateRaw]] and [[gzip]].
	 **/

	/* internal
	 * Deflate.chunks -> Array
	 *
	 * Chunks of output data, if [[Deflate#onData]] not overridden.
	 **/

	/**
	 * Deflate.result -> Uint8Array
	 *
	 * Compressed result, generated by default [[Deflate#onData]]
	 * and [[Deflate#onEnd]] handlers. Filled after you push last chunk
	 * (call [[Deflate#push]] with `Z_FINISH` / `true` param).
	 **/

	/**
	 * Deflate.err -> Number
	 *
	 * Error code after deflate finished. 0 (Z_OK) on success.
	 * You will not need it in real life, because deflate errors
	 * are possible only on wrong options or bad `onData` / `onEnd`
	 * custom handlers.
	 **/

	/**
	 * Deflate.msg -> String
	 *
	 * Error message, if [[Deflate.err]] != 0
	 **/


	/**
	 * new Deflate(options)
	 * - options (Object): zlib deflate options.
	 *
	 * Creates new deflator instance with specified params. Throws exception
	 * on bad params. Supported options:
	 *
	 * - `level`
	 * - `windowBits`
	 * - `memLevel`
	 * - `strategy`
	 * - `dictionary`
	 *
	 * [http://zlib.net/manual.html#Advanced](http://zlib.net/manual.html#Advanced)
	 * for more information on these.
	 *
	 * Additional options, for internal needs:
	 *
	 * - `chunkSize` - size of generated data chunks (16K by default)
	 * - `raw` (Boolean) - do raw deflate
	 * - `gzip` (Boolean) - create gzip wrapper
	 * - `header` (Object) - custom header for gzip
	 *   - `text` (Boolean) - true if compressed data believed to be text
	 *   - `time` (Number) - modification time, unix timestamp
	 *   - `os` (Number) - operation system code
	 *   - `extra` (Array) - array of bytes with extra data (max 65536)
	 *   - `name` (String) - file name (binary string)
	 *   - `comment` (String) - comment (binary string)
	 *   - `hcrc` (Boolean) - true if header crc should be added
	 *
	 * ##### Example:
	 *
	 * ```javascript
	 * const pako = require('pako')
	 *   , chunk1 = new Uint8Array([1,2,3,4,5,6,7,8,9])
	 *   , chunk2 = new Uint8Array([10,11,12,13,14,15,16,17,18,19]);
	 *
	 * const deflate = new pako.Deflate({ level: 3});
	 *
	 * deflate.push(chunk1, false);
	 * deflate.push(chunk2, true);  // true -> last chunk
	 *
	 * if (deflate.err) { throw new Error(deflate.err); }
	 *
	 * console.log(deflate.result);
	 * ```
	 **/
	function Deflate$1(options) {
	  this.options = utils$1.assign({
	    level: Z_DEFAULT_COMPRESSION,
	    method: Z_DEFLATED$1,
	    chunkSize: 16384,
	    windowBits: 15,
	    memLevel: 8,
	    strategy: Z_DEFAULT_STRATEGY
	  }, options || {});

	  let opt = this.options;

	  if (opt.raw && (opt.windowBits > 0)) {
	    opt.windowBits = -opt.windowBits;
	  }

	  else if (opt.gzip && (opt.windowBits > 0) && (opt.windowBits < 16)) {
	    opt.windowBits += 16;
	  }

	  this.err    = 0;      // error code, if happens (0 = Z_OK)
	  this.msg    = '';     // error message
	  this.ended  = false;  // used to avoid multiple onEnd() calls
	  this.chunks = [];     // chunks of compressed data

	  this.strm = new ZStream$1();
	  this.strm.avail_out = 0;

	  let status = zlib_deflate.deflateInit2(
	    this.strm,
	    opt.level,
	    opt.method,
	    opt.windowBits,
	    opt.memLevel,
	    opt.strategy
	  );

	  if (status !== Z_OK$2) {
	    throw new Error(msg$1[status]);
	  }

	  if (opt.header) {
	    zlib_deflate.deflateSetHeader(this.strm, opt.header);
	  }

	  if (opt.dictionary) {
	    let dict;
	    // Convert data if needed
	    if (typeof opt.dictionary === 'string') {
	      // If we need to compress text, change encoding to utf8.
	      dict = strings$1.string2buf(opt.dictionary);
	    } else if (toString$1.call(opt.dictionary) === '[object ArrayBuffer]') {
	      dict = new Uint8Array(opt.dictionary);
	    } else {
	      dict = opt.dictionary;
	    }

	    status = zlib_deflate.deflateSetDictionary(this.strm, dict);

	    if (status !== Z_OK$2) {
	      throw new Error(msg$1[status]);
	    }

	    this._dict_set = true;
	  }
	}

	/**
	 * Deflate#push(data[, flush_mode]) -> Boolean
	 * - data (Uint8Array|ArrayBuffer|String): input data. Strings will be
	 *   converted to utf8 byte sequence.
	 * - flush_mode (Number|Boolean): 0..6 for corresponding Z_NO_FLUSH..Z_TREE modes.
	 *   See constants. Skipped or `false` means Z_NO_FLUSH, `true` means Z_FINISH.
	 *
	 * Sends input data to deflate pipe, generating [[Deflate#onData]] calls with
	 * new compressed chunks. Returns `true` on success. The last data block must
	 * have `flush_mode` Z_FINISH (or `true`). That will flush internal pending
	 * buffers and call [[Deflate#onEnd]].
	 *
	 * On fail call [[Deflate#onEnd]] with error code and return false.
	 *
	 * ##### Example
	 *
	 * ```javascript
	 * push(chunk, false); // push one of data chunks
	 * ...
	 * push(chunk, true);  // push last chunk
	 * ```
	 **/
	Deflate$1.prototype.push = function (data, flush_mode) {
	  const strm = this.strm;
	  const chunkSize = this.options.chunkSize;
	  let status, _flush_mode;

	  if (this.ended) { return false; }

	  if (flush_mode === ~~flush_mode) _flush_mode = flush_mode;
	  else _flush_mode = flush_mode === true ? Z_FINISH$2 : Z_NO_FLUSH$1;

	  // Convert data if needed
	  if (typeof data === 'string') {
	    // If we need to compress text, change encoding to utf8.
	    strm.input = strings$1.string2buf(data);
	  } else if (toString$1.call(data) === '[object ArrayBuffer]') {
	    strm.input = new Uint8Array(data);
	  } else {
	    strm.input = data;
	  }

	  strm.next_in = 0;
	  strm.avail_in = strm.input.length;

	  for (;;) {
	    if (strm.avail_out === 0) {
	      strm.output = new Uint8Array(chunkSize);
	      strm.next_out = 0;
	      strm.avail_out = chunkSize;
	    }

	    // Make sure avail_out > 6 to avoid repeating markers
	    if ((_flush_mode === Z_SYNC_FLUSH || _flush_mode === Z_FULL_FLUSH) && strm.avail_out <= 6) {
	      this.onData(strm.output.subarray(0, strm.next_out));
	      strm.avail_out = 0;
	      continue;
	    }

	    status = zlib_deflate.deflate(strm, _flush_mode);

	    // Ended => flush and finish
	    if (status === Z_STREAM_END$2) {
	      if (strm.next_out > 0) {
	        this.onData(strm.output.subarray(0, strm.next_out));
	      }
	      status = zlib_deflate.deflateEnd(this.strm);
	      this.onEnd(status);
	      this.ended = true;
	      return status === Z_OK$2;
	    }

	    // Flush if out buffer full
	    if (strm.avail_out === 0) {
	      this.onData(strm.output);
	      continue;
	    }

	    // Flush if requested and has data
	    if (_flush_mode > 0 && strm.next_out > 0) {
	      this.onData(strm.output.subarray(0, strm.next_out));
	      strm.avail_out = 0;
	      continue;
	    }

	    if (strm.avail_in === 0) break;
	  }

	  return true;
	};


	/**
	 * Deflate#onData(chunk) -> Void
	 * - chunk (Uint8Array): output data.
	 *
	 * By default, stores data blocks in `chunks[]` property and glue
	 * those in `onEnd`. Override this handler, if you need another behaviour.
	 **/
	Deflate$1.prototype.onData = function (chunk) {
	  this.chunks.push(chunk);
	};


	/**
	 * Deflate#onEnd(status) -> Void
	 * - status (Number): deflate status. 0 (Z_OK) on success,
	 *   other if not.
	 *
	 * Called once after you tell deflate that the input stream is
	 * complete (Z_FINISH). By default - join collected chunks,
	 * free memory and fill `results` / `err` properties.
	 **/
	Deflate$1.prototype.onEnd = function (status) {
	  // On success - join
	  if (status === Z_OK$2) {
	    this.result = utils$1.flattenChunks(this.chunks);
	  }
	  this.chunks = [];
	  this.err = status;
	  this.msg = this.strm.msg;
	};


	/**
	 * deflate(data[, options]) -> Uint8Array
	 * - data (Uint8Array|String): input data to compress.
	 * - options (Object): zlib deflate options.
	 *
	 * Compress `data` with deflate algorithm and `options`.
	 *
	 * Supported options are:
	 *
	 * - level
	 * - windowBits
	 * - memLevel
	 * - strategy
	 * - dictionary
	 *
	 * [http://zlib.net/manual.html#Advanced](http://zlib.net/manual.html#Advanced)
	 * for more information on these.
	 *
	 * Sugar (options):
	 *
	 * - `raw` (Boolean) - say that we work with raw stream, if you don't wish to specify
	 *   negative windowBits implicitly.
	 *
	 * ##### Example:
	 *
	 * ```javascript
	 * const pako = require('pako')
	 * const data = new Uint8Array([1,2,3,4,5,6,7,8,9]);
	 *
	 * console.log(pako.deflate(data));
	 * ```
	 **/
	function deflate$1(input, options) {
	  const deflator = new Deflate$1(options);

	  deflator.push(input, true);

	  // That will never happens, if you don't cheat with options :)
	  if (deflator.err) { throw deflator.msg || msg$1[deflator.err]; }

	  return deflator.result;
	}


	/**
	 * deflateRaw(data[, options]) -> Uint8Array
	 * - data (Uint8Array|String): input data to compress.
	 * - options (Object): zlib deflate options.
	 *
	 * The same as [[deflate]], but creates raw data, without wrapper
	 * (header and adler32 crc).
	 **/
	function deflateRaw$1(input, options) {
	  options = options || {};
	  options.raw = true;
	  return deflate$1(input, options);
	}


	/**
	 * gzip(data[, options]) -> Uint8Array
	 * - data (Uint8Array|String): input data to compress.
	 * - options (Object): zlib deflate options.
	 *
	 * The same as [[deflate]], but create gzip wrapper instead of
	 * deflate one.
	 **/
	function gzip$1(input, options) {
	  options = options || {};
	  options.gzip = true;
	  return deflate$1(input, options);
	}


	deflate$4.Deflate = Deflate$1;
	deflate$4.deflate = deflate$1;
	deflate$4.deflateRaw = deflateRaw$1;
	deflate$4.gzip = gzip$1;
	deflate$4.constants = constants$1;

	var inflate$4 = {};

	var inflate$3 = {};

	// (C) 1995-2013 Jean-loup Gailly and Mark Adler
	// (C) 2014-2017 Vitaly Puzrin and Andrey Tupitsin
	//
	// This software is provided 'as-is', without any express or implied
	// warranty. In no event will the authors be held liable for any damages
	// arising from the use of this software.
	//
	// Permission is granted to anyone to use this software for any purpose,
	// including commercial applications, and to alter it and redistribute it
	// freely, subject to the following restrictions:
	//
	// 1. The origin of this software must not be misrepresented; you must not
	//   claim that you wrote the original software. If you use this software
	//   in a product, an acknowledgment in the product documentation would be
	//   appreciated but is not required.
	// 2. Altered source versions must be plainly marked as such, and must not be
	//   misrepresented as being the original software.
	// 3. This notice may not be removed or altered from any source distribution.

	// See state defs from inflate.js
	const BAD$1 = 30;       /* got a data error -- remain here until reset */
	const TYPE$1 = 12;      /* i: waiting for type bits, including last-flag bit */

	/*
	   Decode literal, length, and distance codes and write out the resulting
	   literal and match bytes until either not enough input or output is
	   available, an end-of-block is encountered, or a data error is encountered.
	   When large enough input and output buffers are supplied to inflate(), for
	   example, a 16K input buffer and a 64K output buffer, more than 95% of the
	   inflate execution time is spent in this routine.

	   Entry assumptions:

	        state.mode === LEN
	        strm.avail_in >= 6
	        strm.avail_out >= 258
	        start >= strm.avail_out
	        state.bits < 8

	   On return, state.mode is one of:

	        LEN -- ran out of enough output space or enough available input
	        TYPE -- reached end of block code, inflate() to interpret next block
	        BAD -- error in block data

	   Notes:

	    - The maximum input bits used by a length/distance pair is 15 bits for the
	      length code, 5 bits for the length extra, 15 bits for the distance code,
	      and 13 bits for the distance extra.  This totals 48 bits, or six bytes.
	      Therefore if strm.avail_in >= 6, then there is enough input to avoid
	      checking for available input while decoding.

	    - The maximum bytes that a single length/distance pair can output is 258
	      bytes, which is the maximum length that can be coded.  inflate_fast()
	      requires strm.avail_out >= 258 for each loop to avoid checking for
	      output space.
	 */
	var inffast = function inflate_fast(strm, start) {
	  let _in;                    /* local strm.input */
	  let last;                   /* have enough input while in < last */
	  let _out;                   /* local strm.output */
	  let beg;                    /* inflate()'s initial strm.output */
	  let end;                    /* while out < end, enough space available */
	//#ifdef INFLATE_STRICT
	  let dmax;                   /* maximum distance from zlib header */
	//#endif
	  let wsize;                  /* window size or zero if not using window */
	  let whave;                  /* valid bytes in the window */
	  let wnext;                  /* window write index */
	  // Use `s_window` instead `window`, avoid conflict with instrumentation tools
	  let s_window;               /* allocated sliding window, if wsize != 0 */
	  let hold;                   /* local strm.hold */
	  let bits;                   /* local strm.bits */
	  let lcode;                  /* local strm.lencode */
	  let dcode;                  /* local strm.distcode */
	  let lmask;                  /* mask for first level of length codes */
	  let dmask;                  /* mask for first level of distance codes */
	  let here;                   /* retrieved table entry */
	  let op;                     /* code bits, operation, extra bits, or */
	                              /*  window position, window bytes to copy */
	  let len;                    /* match length, unused bytes */
	  let dist;                   /* match distance */
	  let from;                   /* where to copy match from */
	  let from_source;


	  let input, output; // JS specific, because we have no pointers

	  /* copy state to local variables */
	  const state = strm.state;
	  //here = state.here;
	  _in = strm.next_in;
	  input = strm.input;
	  last = _in + (strm.avail_in - 5);
	  _out = strm.next_out;
	  output = strm.output;
	  beg = _out - (start - strm.avail_out);
	  end = _out + (strm.avail_out - 257);
	//#ifdef INFLATE_STRICT
	  dmax = state.dmax;
	//#endif
	  wsize = state.wsize;
	  whave = state.whave;
	  wnext = state.wnext;
	  s_window = state.window;
	  hold = state.hold;
	  bits = state.bits;
	  lcode = state.lencode;
	  dcode = state.distcode;
	  lmask = (1 << state.lenbits) - 1;
	  dmask = (1 << state.distbits) - 1;


	  /* decode literals and length/distances until end-of-block or not enough
	     input data or output space */

	  top:
	  do {
	    if (bits < 15) {
	      hold += input[_in++] << bits;
	      bits += 8;
	      hold += input[_in++] << bits;
	      bits += 8;
	    }

	    here = lcode[hold & lmask];

	    dolen:
	    for (;;) { // Goto emulation
	      op = here >>> 24/*here.bits*/;
	      hold >>>= op;
	      bits -= op;
	      op = (here >>> 16) & 0xff/*here.op*/;
	      if (op === 0) {                          /* literal */
	        //Tracevv((stderr, here.val >= 0x20 && here.val < 0x7f ?
	        //        "inflate:         literal '%c'\n" :
	        //        "inflate:         literal 0x%02x\n", here.val));
	        output[_out++] = here & 0xffff/*here.val*/;
	      }
	      else if (op & 16) {                     /* length base */
	        len = here & 0xffff/*here.val*/;
	        op &= 15;                           /* number of extra bits */
	        if (op) {
	          if (bits < op) {
	            hold += input[_in++] << bits;
	            bits += 8;
	          }
	          len += hold & ((1 << op) - 1);
	          hold >>>= op;
	          bits -= op;
	        }
	        //Tracevv((stderr, "inflate:         length %u\n", len));
	        if (bits < 15) {
	          hold += input[_in++] << bits;
	          bits += 8;
	          hold += input[_in++] << bits;
	          bits += 8;
	        }
	        here = dcode[hold & dmask];

	        dodist:
	        for (;;) { // goto emulation
	          op = here >>> 24/*here.bits*/;
	          hold >>>= op;
	          bits -= op;
	          op = (here >>> 16) & 0xff/*here.op*/;

	          if (op & 16) {                      /* distance base */
	            dist = here & 0xffff/*here.val*/;
	            op &= 15;                       /* number of extra bits */
	            if (bits < op) {
	              hold += input[_in++] << bits;
	              bits += 8;
	              if (bits < op) {
	                hold += input[_in++] << bits;
	                bits += 8;
	              }
	            }
	            dist += hold & ((1 << op) - 1);
	//#ifdef INFLATE_STRICT
	            if (dist > dmax) {
	              strm.msg = 'invalid distance too far back';
	              state.mode = BAD$1;
	              break top;
	            }
	//#endif
	            hold >>>= op;
	            bits -= op;
	            //Tracevv((stderr, "inflate:         distance %u\n", dist));
	            op = _out - beg;                /* max distance in output */
	            if (dist > op) {                /* see if copy from window */
	              op = dist - op;               /* distance back in window */
	              if (op > whave) {
	                if (state.sane) {
	                  strm.msg = 'invalid distance too far back';
	                  state.mode = BAD$1;
	                  break top;
	                }

	// (!) This block is disabled in zlib defaults,
	// don't enable it for binary compatibility
	//#ifdef INFLATE_ALLOW_INVALID_DISTANCE_TOOFAR_ARRR
	//                if (len <= op - whave) {
	//                  do {
	//                    output[_out++] = 0;
	//                  } while (--len);
	//                  continue top;
	//                }
	//                len -= op - whave;
	//                do {
	//                  output[_out++] = 0;
	//                } while (--op > whave);
	//                if (op === 0) {
	//                  from = _out - dist;
	//                  do {
	//                    output[_out++] = output[from++];
	//                  } while (--len);
	//                  continue top;
	//                }
	//#endif
	              }
	              from = 0; // window index
	              from_source = s_window;
	              if (wnext === 0) {           /* very common case */
	                from += wsize - op;
	                if (op < len) {         /* some from window */
	                  len -= op;
	                  do {
	                    output[_out++] = s_window[from++];
	                  } while (--op);
	                  from = _out - dist;  /* rest from output */
	                  from_source = output;
	                }
	              }
	              else if (wnext < op) {      /* wrap around window */
	                from += wsize + wnext - op;
	                op -= wnext;
	                if (op < len) {         /* some from end of window */
	                  len -= op;
	                  do {
	                    output[_out++] = s_window[from++];
	                  } while (--op);
	                  from = 0;
	                  if (wnext < len) {  /* some from start of window */
	                    op = wnext;
	                    len -= op;
	                    do {
	                      output[_out++] = s_window[from++];
	                    } while (--op);
	                    from = _out - dist;      /* rest from output */
	                    from_source = output;
	                  }
	                }
	              }
	              else {                      /* contiguous in window */
	                from += wnext - op;
	                if (op < len) {         /* some from window */
	                  len -= op;
	                  do {
	                    output[_out++] = s_window[from++];
	                  } while (--op);
	                  from = _out - dist;  /* rest from output */
	                  from_source = output;
	                }
	              }
	              while (len > 2) {
	                output[_out++] = from_source[from++];
	                output[_out++] = from_source[from++];
	                output[_out++] = from_source[from++];
	                len -= 3;
	              }
	              if (len) {
	                output[_out++] = from_source[from++];
	                if (len > 1) {
	                  output[_out++] = from_source[from++];
	                }
	              }
	            }
	            else {
	              from = _out - dist;          /* copy direct from output */
	              do {                        /* minimum length is three */
	                output[_out++] = output[from++];
	                output[_out++] = output[from++];
	                output[_out++] = output[from++];
	                len -= 3;
	              } while (len > 2);
	              if (len) {
	                output[_out++] = output[from++];
	                if (len > 1) {
	                  output[_out++] = output[from++];
	                }
	              }
	            }
	          }
	          else if ((op & 64) === 0) {          /* 2nd level distance code */
	            here = dcode[(here & 0xffff)/*here.val*/ + (hold & ((1 << op) - 1))];
	            continue dodist;
	          }
	          else {
	            strm.msg = 'invalid distance code';
	            state.mode = BAD$1;
	            break top;
	          }

	          break; // need to emulate goto via "continue"
	        }
	      }
	      else if ((op & 64) === 0) {              /* 2nd level length code */
	        here = lcode[(here & 0xffff)/*here.val*/ + (hold & ((1 << op) - 1))];
	        continue dolen;
	      }
	      else if (op & 32) {                     /* end-of-block */
	        //Tracevv((stderr, "inflate:         end of block\n"));
	        state.mode = TYPE$1;
	        break top;
	      }
	      else {
	        strm.msg = 'invalid literal/length code';
	        state.mode = BAD$1;
	        break top;
	      }

	      break; // need to emulate goto via "continue"
	    }
	  } while (_in < last && _out < end);

	  /* return unused bytes (on entry, bits < 8, so in won't go too far back) */
	  len = bits >> 3;
	  _in -= len;
	  bits -= len << 3;
	  hold &= (1 << bits) - 1;

	  /* update state and return */
	  strm.next_in = _in;
	  strm.next_out = _out;
	  strm.avail_in = (_in < last ? 5 + (last - _in) : 5 - (_in - last));
	  strm.avail_out = (_out < end ? 257 + (end - _out) : 257 - (_out - end));
	  state.hold = hold;
	  state.bits = bits;
	  return;
	};

	// (C) 1995-2013 Jean-loup Gailly and Mark Adler
	// (C) 2014-2017 Vitaly Puzrin and Andrey Tupitsin
	//
	// This software is provided 'as-is', without any express or implied
	// warranty. In no event will the authors be held liable for any damages
	// arising from the use of this software.
	//
	// Permission is granted to anyone to use this software for any purpose,
	// including commercial applications, and to alter it and redistribute it
	// freely, subject to the following restrictions:
	//
	// 1. The origin of this software must not be misrepresented; you must not
	//   claim that you wrote the original software. If you use this software
	//   in a product, an acknowledgment in the product documentation would be
	//   appreciated but is not required.
	// 2. Altered source versions must be plainly marked as such, and must not be
	//   misrepresented as being the original software.
	// 3. This notice may not be removed or altered from any source distribution.

	const MAXBITS = 15;
	const ENOUGH_LENS$1 = 852;
	const ENOUGH_DISTS$1 = 592;
	//const ENOUGH = (ENOUGH_LENS+ENOUGH_DISTS);

	const CODES$1 = 0;
	const LENS$1 = 1;
	const DISTS$1 = 2;

	const lbase = new Uint16Array([ /* Length codes 257..285 base */
	  3, 4, 5, 6, 7, 8, 9, 10, 11, 13, 15, 17, 19, 23, 27, 31,
	  35, 43, 51, 59, 67, 83, 99, 115, 131, 163, 195, 227, 258, 0, 0
	]);

	const lext = new Uint8Array([ /* Length codes 257..285 extra */
	  16, 16, 16, 16, 16, 16, 16, 16, 17, 17, 17, 17, 18, 18, 18, 18,
	  19, 19, 19, 19, 20, 20, 20, 20, 21, 21, 21, 21, 16, 72, 78
	]);

	const dbase = new Uint16Array([ /* Distance codes 0..29 base */
	  1, 2, 3, 4, 5, 7, 9, 13, 17, 25, 33, 49, 65, 97, 129, 193,
	  257, 385, 513, 769, 1025, 1537, 2049, 3073, 4097, 6145,
	  8193, 12289, 16385, 24577, 0, 0
	]);

	const dext = new Uint8Array([ /* Distance codes 0..29 extra */
	  16, 16, 16, 16, 17, 17, 18, 18, 19, 19, 20, 20, 21, 21, 22, 22,
	  23, 23, 24, 24, 25, 25, 26, 26, 27, 27,
	  28, 28, 29, 29, 64, 64
	]);

	const inflate_table$1 = (type, lens, lens_index, codes, table, table_index, work, opts) =>
	{
	  const bits = opts.bits;
	      //here = opts.here; /* table entry for duplication */

	  let len = 0;               /* a code's length in bits */
	  let sym = 0;               /* index of code symbols */
	  let min = 0, max = 0;          /* minimum and maximum code lengths */
	  let root = 0;              /* number of index bits for root table */
	  let curr = 0;              /* number of index bits for current table */
	  let drop = 0;              /* code bits to drop for sub-table */
	  let left = 0;                   /* number of prefix codes available */
	  let used = 0;              /* code entries in table used */
	  let huff = 0;              /* Huffman code */
	  let incr;              /* for incrementing code, index */
	  let fill;              /* index for replicating entries */
	  let low;               /* low bits for current root entry */
	  let mask;              /* mask for low root bits */
	  let next;             /* next available space in table */
	  let base = null;     /* base value table to use */
	  let base_index = 0;
	//  let shoextra;    /* extra bits table to use */
	  let end;                    /* use base and extra for symbol > end */
	  const count = new Uint16Array(MAXBITS + 1); //[MAXBITS+1];    /* number of codes of each length */
	  const offs = new Uint16Array(MAXBITS + 1); //[MAXBITS+1];     /* offsets in table for each length */
	  let extra = null;
	  let extra_index = 0;

	  let here_bits, here_op, here_val;

	  /*
	   Process a set of code lengths to create a canonical Huffman code.  The
	   code lengths are lens[0..codes-1].  Each length corresponds to the
	   symbols 0..codes-1.  The Huffman code is generated by first sorting the
	   symbols by length from short to long, and retaining the symbol order
	   for codes with equal lengths.  Then the code starts with all zero bits
	   for the first code of the shortest length, and the codes are integer
	   increments for the same length, and zeros are appended as the length
	   increases.  For the deflate format, these bits are stored backwards
	   from their more natural integer increment ordering, and so when the
	   decoding tables are built in the large loop below, the integer codes
	   are incremented backwards.

	   This routine assumes, but does not check, that all of the entries in
	   lens[] are in the range 0..MAXBITS.  The caller must assure this.
	   1..MAXBITS is interpreted as that code length.  zero means that that
	   symbol does not occur in this code.

	   The codes are sorted by computing a count of codes for each length,
	   creating from that a table of starting indices for each length in the
	   sorted table, and then entering the symbols in order in the sorted
	   table.  The sorted table is work[], with that space being provided by
	   the caller.

	   The length counts are used for other purposes as well, i.e. finding
	   the minimum and maximum length codes, determining if there are any
	   codes at all, checking for a valid set of lengths, and looking ahead
	   at length counts to determine sub-table sizes when building the
	   decoding tables.
	   */

	  /* accumulate lengths for codes (assumes lens[] all in 0..MAXBITS) */
	  for (len = 0; len <= MAXBITS; len++) {
	    count[len] = 0;
	  }
	  for (sym = 0; sym < codes; sym++) {
	    count[lens[lens_index + sym]]++;
	  }

	  /* bound code lengths, force root to be within code lengths */
	  root = bits;
	  for (max = MAXBITS; max >= 1; max--) {
	    if (count[max] !== 0) { break; }
	  }
	  if (root > max) {
	    root = max;
	  }
	  if (max === 0) {                     /* no symbols to code at all */
	    //table.op[opts.table_index] = 64;  //here.op = (var char)64;    /* invalid code marker */
	    //table.bits[opts.table_index] = 1;   //here.bits = (var char)1;
	    //table.val[opts.table_index++] = 0;   //here.val = (var short)0;
	    table[table_index++] = (1 << 24) | (64 << 16) | 0;


	    //table.op[opts.table_index] = 64;
	    //table.bits[opts.table_index] = 1;
	    //table.val[opts.table_index++] = 0;
	    table[table_index++] = (1 << 24) | (64 << 16) | 0;

	    opts.bits = 1;
	    return 0;     /* no symbols, but wait for decoding to report error */
	  }
	  for (min = 1; min < max; min++) {
	    if (count[min] !== 0) { break; }
	  }
	  if (root < min) {
	    root = min;
	  }

	  /* check for an over-subscribed or incomplete set of lengths */
	  left = 1;
	  for (len = 1; len <= MAXBITS; len++) {
	    left <<= 1;
	    left -= count[len];
	    if (left < 0) {
	      return -1;
	    }        /* over-subscribed */
	  }
	  if (left > 0 && (type === CODES$1 || max !== 1)) {
	    return -1;                      /* incomplete set */
	  }

	  /* generate offsets into symbol table for each length for sorting */
	  offs[1] = 0;
	  for (len = 1; len < MAXBITS; len++) {
	    offs[len + 1] = offs[len] + count[len];
	  }

	  /* sort symbols by length, by symbol order within each length */
	  for (sym = 0; sym < codes; sym++) {
	    if (lens[lens_index + sym] !== 0) {
	      work[offs[lens[lens_index + sym]]++] = sym;
	    }
	  }

	  /*
	   Create and fill in decoding tables.  In this loop, the table being
	   filled is at next and has curr index bits.  The code being used is huff
	   with length len.  That code is converted to an index by dropping drop
	   bits off of the bottom.  For codes where len is less than drop + curr,
	   those top drop + curr - len bits are incremented through all values to
	   fill the table with replicated entries.

	   root is the number of index bits for the root table.  When len exceeds
	   root, sub-tables are created pointed to by the root entry with an index
	   of the low root bits of huff.  This is saved in low to check for when a
	   new sub-table should be started.  drop is zero when the root table is
	   being filled, and drop is root when sub-tables are being filled.

	   When a new sub-table is needed, it is necessary to look ahead in the
	   code lengths to determine what size sub-table is needed.  The length
	   counts are used for this, and so count[] is decremented as codes are
	   entered in the tables.

	   used keeps track of how many table entries have been allocated from the
	   provided *table space.  It is checked for LENS and DIST tables against
	   the constants ENOUGH_LENS and ENOUGH_DISTS to guard against changes in
	   the initial root table size constants.  See the comments in inftrees.h
	   for more information.

	   sym increments through all symbols, and the loop terminates when
	   all codes of length max, i.e. all codes, have been processed.  This
	   routine permits incomplete codes, so another loop after this one fills
	   in the rest of the decoding tables with invalid code markers.
	   */

	  /* set up for code type */
	  // poor man optimization - use if-else instead of switch,
	  // to avoid deopts in old v8
	  if (type === CODES$1) {
	    base = extra = work;    /* dummy value--not used */
	    end = 19;

	  } else if (type === LENS$1) {
	    base = lbase;
	    base_index -= 257;
	    extra = lext;
	    extra_index -= 257;
	    end = 256;

	  } else {                    /* DISTS */
	    base = dbase;
	    extra = dext;
	    end = -1;
	  }

	  /* initialize opts for loop */
	  huff = 0;                   /* starting code */
	  sym = 0;                    /* starting code symbol */
	  len = min;                  /* starting code length */
	  next = table_index;              /* current table to fill in */
	  curr = root;                /* current table index bits */
	  drop = 0;                   /* current bits to drop from code for index */
	  low = -1;                   /* trigger new sub-table when len > root */
	  used = 1 << root;          /* use root table entries */
	  mask = used - 1;            /* mask for comparing low */

	  /* check available table space */
	  if ((type === LENS$1 && used > ENOUGH_LENS$1) ||
	    (type === DISTS$1 && used > ENOUGH_DISTS$1)) {
	    return 1;
	  }

	  /* process all codes and make table entries */
	  for (;;) {
	    /* create table entry */
	    here_bits = len - drop;
	    if (work[sym] < end) {
	      here_op = 0;
	      here_val = work[sym];
	    }
	    else if (work[sym] > end) {
	      here_op = extra[extra_index + work[sym]];
	      here_val = base[base_index + work[sym]];
	    }
	    else {
	      here_op = 32 + 64;         /* end of block */
	      here_val = 0;
	    }

	    /* replicate for those indices with low len bits equal to huff */
	    incr = 1 << (len - drop);
	    fill = 1 << curr;
	    min = fill;                 /* save offset to next table */
	    do {
	      fill -= incr;
	      table[next + (huff >> drop) + fill] = (here_bits << 24) | (here_op << 16) | here_val |0;
	    } while (fill !== 0);

	    /* backwards increment the len-bit code huff */
	    incr = 1 << (len - 1);
	    while (huff & incr) {
	      incr >>= 1;
	    }
	    if (incr !== 0) {
	      huff &= incr - 1;
	      huff += incr;
	    } else {
	      huff = 0;
	    }

	    /* go to next symbol, update count, len */
	    sym++;
	    if (--count[len] === 0) {
	      if (len === max) { break; }
	      len = lens[lens_index + work[sym]];
	    }

	    /* create new sub-table if needed */
	    if (len > root && (huff & mask) !== low) {
	      /* if first time, transition to sub-tables */
	      if (drop === 0) {
	        drop = root;
	      }

	      /* increment past last table */
	      next += min;            /* here min is 1 << curr */

	      /* determine length of next table */
	      curr = len - drop;
	      left = 1 << curr;
	      while (curr + drop < max) {
	        left -= count[curr + drop];
	        if (left <= 0) { break; }
	        curr++;
	        left <<= 1;
	      }

	      /* check for enough space */
	      used += 1 << curr;
	      if ((type === LENS$1 && used > ENOUGH_LENS$1) ||
	        (type === DISTS$1 && used > ENOUGH_DISTS$1)) {
	        return 1;
	      }

	      /* point entry in root table to sub-table */
	      low = huff & mask;
	      /*table.op[low] = curr;
	      table.bits[low] = root;
	      table.val[low] = next - opts.table_index;*/
	      table[low] = (root << 24) | (curr << 16) | (next - table_index) |0;
	    }
	  }

	  /* fill in remaining table entry if code is incomplete (guaranteed to have
	   at most one remaining entry, since if the code is incomplete, the
	   maximum code length that was allowed to get this far is one bit) */
	  if (huff !== 0) {
	    //table.op[next + huff] = 64;            /* invalid code marker */
	    //table.bits[next + huff] = len - drop;
	    //table.val[next + huff] = 0;
	    table[next + huff] = ((len - drop) << 24) | (64 << 16) |0;
	  }

	  /* set return parameters */
	  //opts.table_index += used;
	  opts.bits = root;
	  return 0;
	};


	var inftrees = inflate_table$1;

	// (C) 1995-2013 Jean-loup Gailly and Mark Adler
	// (C) 2014-2017 Vitaly Puzrin and Andrey Tupitsin
	//
	// This software is provided 'as-is', without any express or implied
	// warranty. In no event will the authors be held liable for any damages
	// arising from the use of this software.
	//
	// Permission is granted to anyone to use this software for any purpose,
	// including commercial applications, and to alter it and redistribute it
	// freely, subject to the following restrictions:
	//
	// 1. The origin of this software must not be misrepresented; you must not
	//   claim that you wrote the original software. If you use this software
	//   in a product, an acknowledgment in the product documentation would be
	//   appreciated but is not required.
	// 2. Altered source versions must be plainly marked as such, and must not be
	//   misrepresented as being the original software.
	// 3. This notice may not be removed or altered from any source distribution.

	const adler32       = adler32_1;
	const crc32         = crc32_1;
	const inflate_fast  = inffast;
	const inflate_table = inftrees;

	const CODES = 0;
	const LENS = 1;
	const DISTS = 2;

	/* Public constants ==========================================================*/
	/* ===========================================================================*/

	const {
	  Z_FINISH: Z_FINISH$1, Z_BLOCK, Z_TREES,
	  Z_OK: Z_OK$1, Z_STREAM_END: Z_STREAM_END$1, Z_NEED_DICT: Z_NEED_DICT$1, Z_STREAM_ERROR: Z_STREAM_ERROR$1, Z_DATA_ERROR: Z_DATA_ERROR$1, Z_MEM_ERROR: Z_MEM_ERROR$1, Z_BUF_ERROR,
	  Z_DEFLATED
	} = constants$1;


	/* STATES ====================================================================*/
	/* ===========================================================================*/


	const    HEAD = 1;       /* i: waiting for magic header */
	const    FLAGS = 2;      /* i: waiting for method and flags (gzip) */
	const    TIME = 3;       /* i: waiting for modification time (gzip) */
	const    OS = 4;         /* i: waiting for extra flags and operating system (gzip) */
	const    EXLEN = 5;      /* i: waiting for extra length (gzip) */
	const    EXTRA = 6;      /* i: waiting for extra bytes (gzip) */
	const    NAME = 7;       /* i: waiting for end of file name (gzip) */
	const    COMMENT = 8;    /* i: waiting for end of comment (gzip) */
	const    HCRC = 9;       /* i: waiting for header crc (gzip) */
	const    DICTID = 10;    /* i: waiting for dictionary check value */
	const    DICT = 11;      /* waiting for inflateSetDictionary() call */
	const        TYPE = 12;      /* i: waiting for type bits, including last-flag bit */
	const        TYPEDO = 13;    /* i: same, but skip check to exit inflate on new block */
	const        STORED = 14;    /* i: waiting for stored size (length and complement) */
	const        COPY_ = 15;     /* i/o: same as COPY below, but only first time in */
	const        COPY = 16;      /* i/o: waiting for input or output to copy stored block */
	const        TABLE = 17;     /* i: waiting for dynamic block table lengths */
	const        LENLENS = 18;   /* i: waiting for code length code lengths */
	const        CODELENS = 19;  /* i: waiting for length/lit and distance code lengths */
	const            LEN_ = 20;      /* i: same as LEN below, but only first time in */
	const            LEN = 21;       /* i: waiting for length/lit/eob code */
	const            LENEXT = 22;    /* i: waiting for length extra bits */
	const            DIST = 23;      /* i: waiting for distance code */
	const            DISTEXT = 24;   /* i: waiting for distance extra bits */
	const            MATCH = 25;     /* o: waiting for output space to copy string */
	const            LIT = 26;       /* o: waiting for output space to write literal */
	const    CHECK = 27;     /* i: waiting for 32-bit check value */
	const    LENGTH = 28;    /* i: waiting for 32-bit length (gzip) */
	const    DONE = 29;      /* finished check, done -- remain here until reset */
	const    BAD = 30;       /* got a data error -- remain here until reset */
	const    MEM = 31;       /* got an inflate() memory error -- remain here until reset */
	const    SYNC = 32;      /* looking for synchronization bytes to restart inflate() */

	/* ===========================================================================*/



	const ENOUGH_LENS = 852;
	const ENOUGH_DISTS = 592;
	//const ENOUGH =  (ENOUGH_LENS+ENOUGH_DISTS);

	const MAX_WBITS = 15;
	/* 32K LZ77 window */
	const DEF_WBITS = MAX_WBITS;


	const zswap32 = (q) => {

	  return  (((q >>> 24) & 0xff) +
	          ((q >>> 8) & 0xff00) +
	          ((q & 0xff00) << 8) +
	          ((q & 0xff) << 24));
	};


	function InflateState() {
	  this.mode = 0;             /* current inflate mode */
	  this.last = false;          /* true if processing last block */
	  this.wrap = 0;              /* bit 0 true for zlib, bit 1 true for gzip */
	  this.havedict = false;      /* true if dictionary provided */
	  this.flags = 0;             /* gzip header method and flags (0 if zlib) */
	  this.dmax = 0;              /* zlib header max distance (INFLATE_STRICT) */
	  this.check = 0;             /* protected copy of check value */
	  this.total = 0;             /* protected copy of output count */
	  // TODO: may be {}
	  this.head = null;           /* where to save gzip header information */

	  /* sliding window */
	  this.wbits = 0;             /* log base 2 of requested window size */
	  this.wsize = 0;             /* window size or zero if not using window */
	  this.whave = 0;             /* valid bytes in the window */
	  this.wnext = 0;             /* window write index */
	  this.window = null;         /* allocated sliding window, if needed */

	  /* bit accumulator */
	  this.hold = 0;              /* input bit accumulator */
	  this.bits = 0;              /* number of bits in "in" */

	  /* for string and stored block copying */
	  this.length = 0;            /* literal or length of data to copy */
	  this.offset = 0;            /* distance back to copy string from */

	  /* for table and code decoding */
	  this.extra = 0;             /* extra bits needed */

	  /* fixed and dynamic code tables */
	  this.lencode = null;          /* starting table for length/literal codes */
	  this.distcode = null;         /* starting table for distance codes */
	  this.lenbits = 0;           /* index bits for lencode */
	  this.distbits = 0;          /* index bits for distcode */

	  /* dynamic table building */
	  this.ncode = 0;             /* number of code length code lengths */
	  this.nlen = 0;              /* number of length code lengths */
	  this.ndist = 0;             /* number of distance code lengths */
	  this.have = 0;              /* number of code lengths in lens[] */
	  this.next = null;              /* next available space in codes[] */

	  this.lens = new Uint16Array(320); /* temporary storage for code lengths */
	  this.work = new Uint16Array(288); /* work area for code table building */

	  /*
	   because we don't have pointers in js, we use lencode and distcode directly
	   as buffers so we don't need codes
	  */
	  //this.codes = new Int32Array(ENOUGH);       /* space for code tables */
	  this.lendyn = null;              /* dynamic table for length/literal codes (JS specific) */
	  this.distdyn = null;             /* dynamic table for distance codes (JS specific) */
	  this.sane = 0;                   /* if false, allow invalid distance too far */
	  this.back = 0;                   /* bits back of last unprocessed length/lit */
	  this.was = 0;                    /* initial length of match */
	}


	const inflateResetKeep = (strm) => {

	  if (!strm || !strm.state) { return Z_STREAM_ERROR$1; }
	  const state = strm.state;
	  strm.total_in = strm.total_out = state.total = 0;
	  strm.msg = ''; /*Z_NULL*/
	  if (state.wrap) {       /* to support ill-conceived Java test suite */
	    strm.adler = state.wrap & 1;
	  }
	  state.mode = HEAD;
	  state.last = 0;
	  state.havedict = 0;
	  state.dmax = 32768;
	  state.head = null/*Z_NULL*/;
	  state.hold = 0;
	  state.bits = 0;
	  //state.lencode = state.distcode = state.next = state.codes;
	  state.lencode = state.lendyn = new Int32Array(ENOUGH_LENS);
	  state.distcode = state.distdyn = new Int32Array(ENOUGH_DISTS);

	  state.sane = 1;
	  state.back = -1;
	  //Tracev((stderr, "inflate: reset\n"));
	  return Z_OK$1;
	};


	const inflateReset = (strm) => {

	  if (!strm || !strm.state) { return Z_STREAM_ERROR$1; }
	  const state = strm.state;
	  state.wsize = 0;
	  state.whave = 0;
	  state.wnext = 0;
	  return inflateResetKeep(strm);

	};


	const inflateReset2 = (strm, windowBits) => {
	  let wrap;

	  /* get the state */
	  if (!strm || !strm.state) { return Z_STREAM_ERROR$1; }
	  const state = strm.state;

	  /* extract wrap request from windowBits parameter */
	  if (windowBits < 0) {
	    wrap = 0;
	    windowBits = -windowBits;
	  }
	  else {
	    wrap = (windowBits >> 4) + 1;
	    if (windowBits < 48) {
	      windowBits &= 15;
	    }
	  }

	  /* set number of window bits, free window if different */
	  if (windowBits && (windowBits < 8 || windowBits > 15)) {
	    return Z_STREAM_ERROR$1;
	  }
	  if (state.window !== null && state.wbits !== windowBits) {
	    state.window = null;
	  }

	  /* update state and reset the rest of it */
	  state.wrap = wrap;
	  state.wbits = windowBits;
	  return inflateReset(strm);
	};


	const inflateInit2 = (strm, windowBits) => {

	  if (!strm) { return Z_STREAM_ERROR$1; }
	  //strm.msg = Z_NULL;                 /* in case we return an error */

	  const state = new InflateState();

	  //if (state === Z_NULL) return Z_MEM_ERROR;
	  //Tracev((stderr, "inflate: allocated\n"));
	  strm.state = state;
	  state.window = null/*Z_NULL*/;
	  const ret = inflateReset2(strm, windowBits);
	  if (ret !== Z_OK$1) {
	    strm.state = null/*Z_NULL*/;
	  }
	  return ret;
	};


	const inflateInit = (strm) => {

	  return inflateInit2(strm, DEF_WBITS);
	};


	/*
	 Return state with length and distance decoding tables and index sizes set to
	 fixed code decoding.  Normally this returns fixed tables from inffixed.h.
	 If BUILDFIXED is defined, then instead this routine builds the tables the
	 first time it's called, and returns those tables the first time and
	 thereafter.  This reduces the size of the code by about 2K bytes, in
	 exchange for a little execution time.  However, BUILDFIXED should not be
	 used for threaded applications, since the rewriting of the tables and virgin
	 may not be thread-safe.
	 */
	let virgin = true;

	let lenfix, distfix; // We have no pointers in JS, so keep tables separate


	const fixedtables = (state) => {

	  /* build fixed huffman tables if first call (may not be thread safe) */
	  if (virgin) {
	    lenfix = new Int32Array(512);
	    distfix = new Int32Array(32);

	    /* literal/length table */
	    let sym = 0;
	    while (sym < 144) { state.lens[sym++] = 8; }
	    while (sym < 256) { state.lens[sym++] = 9; }
	    while (sym < 280) { state.lens[sym++] = 7; }
	    while (sym < 288) { state.lens[sym++] = 8; }

	    inflate_table(LENS,  state.lens, 0, 288, lenfix,   0, state.work, { bits: 9 });

	    /* distance table */
	    sym = 0;
	    while (sym < 32) { state.lens[sym++] = 5; }

	    inflate_table(DISTS, state.lens, 0, 32,   distfix, 0, state.work, { bits: 5 });

	    /* do this just once */
	    virgin = false;
	  }

	  state.lencode = lenfix;
	  state.lenbits = 9;
	  state.distcode = distfix;
	  state.distbits = 5;
	};


	/*
	 Update the window with the last wsize (normally 32K) bytes written before
	 returning.  If window does not exist yet, create it.  This is only called
	 when a window is already in use, or when output has been written during this
	 inflate call, but the end of the deflate stream has not been reached yet.
	 It is also called to create a window for dictionary data when a dictionary
	 is loaded.

	 Providing output buffers larger than 32K to inflate() should provide a speed
	 advantage, since only the last 32K of output is copied to the sliding window
	 upon return from inflate(), and since all distances after the first 32K of
	 output will fall in the output data, making match copies simpler and faster.
	 The advantage may be dependent on the size of the processor's data caches.
	 */
	const updatewindow = (strm, src, end, copy) => {

	  let dist;
	  const state = strm.state;

	  /* if it hasn't been done already, allocate space for the window */
	  if (state.window === null) {
	    state.wsize = 1 << state.wbits;
	    state.wnext = 0;
	    state.whave = 0;

	    state.window = new Uint8Array(state.wsize);
	  }

	  /* copy state->wsize or less output bytes into the circular window */
	  if (copy >= state.wsize) {
	    state.window.set(src.subarray(end - state.wsize, end), 0);
	    state.wnext = 0;
	    state.whave = state.wsize;
	  }
	  else {
	    dist = state.wsize - state.wnext;
	    if (dist > copy) {
	      dist = copy;
	    }
	    //zmemcpy(state->window + state->wnext, end - copy, dist);
	    state.window.set(src.subarray(end - copy, end - copy + dist), state.wnext);
	    copy -= dist;
	    if (copy) {
	      //zmemcpy(state->window, end - copy, copy);
	      state.window.set(src.subarray(end - copy, end), 0);
	      state.wnext = copy;
	      state.whave = state.wsize;
	    }
	    else {
	      state.wnext += dist;
	      if (state.wnext === state.wsize) { state.wnext = 0; }
	      if (state.whave < state.wsize) { state.whave += dist; }
	    }
	  }
	  return 0;
	};


	const inflate$2 = (strm, flush) => {

	  let state;
	  let input, output;          // input/output buffers
	  let next;                   /* next input INDEX */
	  let put;                    /* next output INDEX */
	  let have, left;             /* available input and output */
	  let hold;                   /* bit buffer */
	  let bits;                   /* bits in bit buffer */
	  let _in, _out;              /* save starting available input and output */
	  let copy;                   /* number of stored or match bytes to copy */
	  let from;                   /* where to copy match bytes from */
	  let from_source;
	  let here = 0;               /* current decoding table entry */
	  let here_bits, here_op, here_val; // paked "here" denormalized (JS specific)
	  //let last;                   /* parent table entry */
	  let last_bits, last_op, last_val; // paked "last" denormalized (JS specific)
	  let len;                    /* length to copy for repeats, bits to drop */
	  let ret;                    /* return code */
	  const hbuf = new Uint8Array(4);    /* buffer for gzip header crc calculation */
	  let opts;

	  let n; // temporary variable for NEED_BITS

	  const order = /* permutation of code lengths */
	    new Uint8Array([ 16, 17, 18, 0, 8, 7, 9, 6, 10, 5, 11, 4, 12, 3, 13, 2, 14, 1, 15 ]);


	  if (!strm || !strm.state || !strm.output ||
	      (!strm.input && strm.avail_in !== 0)) {
	    return Z_STREAM_ERROR$1;
	  }

	  state = strm.state;
	  if (state.mode === TYPE) { state.mode = TYPEDO; }    /* skip check */


	  //--- LOAD() ---
	  put = strm.next_out;
	  output = strm.output;
	  left = strm.avail_out;
	  next = strm.next_in;
	  input = strm.input;
	  have = strm.avail_in;
	  hold = state.hold;
	  bits = state.bits;
	  //---

	  _in = have;
	  _out = left;
	  ret = Z_OK$1;

	  inf_leave: // goto emulation
	  for (;;) {
	    switch (state.mode) {
	      case HEAD:
	        if (state.wrap === 0) {
	          state.mode = TYPEDO;
	          break;
	        }
	        //=== NEEDBITS(16);
	        while (bits < 16) {
	          if (have === 0) { break inf_leave; }
	          have--;
	          hold += input[next++] << bits;
	          bits += 8;
	        }
	        //===//
	        if ((state.wrap & 2) && hold === 0x8b1f) {  /* gzip header */
	          state.check = 0/*crc32(0L, Z_NULL, 0)*/;
	          //=== CRC2(state.check, hold);
	          hbuf[0] = hold & 0xff;
	          hbuf[1] = (hold >>> 8) & 0xff;
	          state.check = crc32(state.check, hbuf, 2, 0);
	          //===//

	          //=== INITBITS();
	          hold = 0;
	          bits = 0;
	          //===//
	          state.mode = FLAGS;
	          break;
	        }
	        state.flags = 0;           /* expect zlib header */
	        if (state.head) {
	          state.head.done = false;
	        }
	        if (!(state.wrap & 1) ||   /* check if zlib header allowed */
	          (((hold & 0xff)/*BITS(8)*/ << 8) + (hold >> 8)) % 31) {
	          strm.msg = 'incorrect header check';
	          state.mode = BAD;
	          break;
	        }
	        if ((hold & 0x0f)/*BITS(4)*/ !== Z_DEFLATED) {
	          strm.msg = 'unknown compression method';
	          state.mode = BAD;
	          break;
	        }
	        //--- DROPBITS(4) ---//
	        hold >>>= 4;
	        bits -= 4;
	        //---//
	        len = (hold & 0x0f)/*BITS(4)*/ + 8;
	        if (state.wbits === 0) {
	          state.wbits = len;
	        }
	        else if (len > state.wbits) {
	          strm.msg = 'invalid window size';
	          state.mode = BAD;
	          break;
	        }

	        // !!! pako patch. Force use `options.windowBits` if passed.
	        // Required to always use max window size by default.
	        state.dmax = 1 << state.wbits;
	        //state.dmax = 1 << len;

	        //Tracev((stderr, "inflate:   zlib header ok\n"));
	        strm.adler = state.check = 1/*adler32(0L, Z_NULL, 0)*/;
	        state.mode = hold & 0x200 ? DICTID : TYPE;
	        //=== INITBITS();
	        hold = 0;
	        bits = 0;
	        //===//
	        break;
	      case FLAGS:
	        //=== NEEDBITS(16); */
	        while (bits < 16) {
	          if (have === 0) { break inf_leave; }
	          have--;
	          hold += input[next++] << bits;
	          bits += 8;
	        }
	        //===//
	        state.flags = hold;
	        if ((state.flags & 0xff) !== Z_DEFLATED) {
	          strm.msg = 'unknown compression method';
	          state.mode = BAD;
	          break;
	        }
	        if (state.flags & 0xe000) {
	          strm.msg = 'unknown header flags set';
	          state.mode = BAD;
	          break;
	        }
	        if (state.head) {
	          state.head.text = ((hold >> 8) & 1);
	        }
	        if (state.flags & 0x0200) {
	          //=== CRC2(state.check, hold);
	          hbuf[0] = hold & 0xff;
	          hbuf[1] = (hold >>> 8) & 0xff;
	          state.check = crc32(state.check, hbuf, 2, 0);
	          //===//
	        }
	        //=== INITBITS();
	        hold = 0;
	        bits = 0;
	        //===//
	        state.mode = TIME;
	        /* falls through */
	      case TIME:
	        //=== NEEDBITS(32); */
	        while (bits < 32) {
	          if (have === 0) { break inf_leave; }
	          have--;
	          hold += input[next++] << bits;
	          bits += 8;
	        }
	        //===//
	        if (state.head) {
	          state.head.time = hold;
	        }
	        if (state.flags & 0x0200) {
	          //=== CRC4(state.check, hold)
	          hbuf[0] = hold & 0xff;
	          hbuf[1] = (hold >>> 8) & 0xff;
	          hbuf[2] = (hold >>> 16) & 0xff;
	          hbuf[3] = (hold >>> 24) & 0xff;
	          state.check = crc32(state.check, hbuf, 4, 0);
	          //===
	        }
	        //=== INITBITS();
	        hold = 0;
	        bits = 0;
	        //===//
	        state.mode = OS;
	        /* falls through */
	      case OS:
	        //=== NEEDBITS(16); */
	        while (bits < 16) {
	          if (have === 0) { break inf_leave; }
	          have--;
	          hold += input[next++] << bits;
	          bits += 8;
	        }
	        //===//
	        if (state.head) {
	          state.head.xflags = (hold & 0xff);
	          state.head.os = (hold >> 8);
	        }
	        if (state.flags & 0x0200) {
	          //=== CRC2(state.check, hold);
	          hbuf[0] = hold & 0xff;
	          hbuf[1] = (hold >>> 8) & 0xff;
	          state.check = crc32(state.check, hbuf, 2, 0);
	          //===//
	        }
	        //=== INITBITS();
	        hold = 0;
	        bits = 0;
	        //===//
	        state.mode = EXLEN;
	        /* falls through */
	      case EXLEN:
	        if (state.flags & 0x0400) {
	          //=== NEEDBITS(16); */
	          while (bits < 16) {
	            if (have === 0) { break inf_leave; }
	            have--;
	            hold += input[next++] << bits;
	            bits += 8;
	          }
	          //===//
	          state.length = hold;
	          if (state.head) {
	            state.head.extra_len = hold;
	          }
	          if (state.flags & 0x0200) {
	            //=== CRC2(state.check, hold);
	            hbuf[0] = hold & 0xff;
	            hbuf[1] = (hold >>> 8) & 0xff;
	            state.check = crc32(state.check, hbuf, 2, 0);
	            //===//
	          }
	          //=== INITBITS();
	          hold = 0;
	          bits = 0;
	          //===//
	        }
	        else if (state.head) {
	          state.head.extra = null/*Z_NULL*/;
	        }
	        state.mode = EXTRA;
	        /* falls through */
	      case EXTRA:
	        if (state.flags & 0x0400) {
	          copy = state.length;
	          if (copy > have) { copy = have; }
	          if (copy) {
	            if (state.head) {
	              len = state.head.extra_len - state.length;
	              if (!state.head.extra) {
	                // Use untyped array for more convenient processing later
	                state.head.extra = new Uint8Array(state.head.extra_len);
	              }
	              state.head.extra.set(
	                input.subarray(
	                  next,
	                  // extra field is limited to 65536 bytes
	                  // - no need for additional size check
	                  next + copy
	                ),
	                /*len + copy > state.head.extra_max - len ? state.head.extra_max : copy,*/
	                len
	              );
	              //zmemcpy(state.head.extra + len, next,
	              //        len + copy > state.head.extra_max ?
	              //        state.head.extra_max - len : copy);
	            }
	            if (state.flags & 0x0200) {
	              state.check = crc32(state.check, input, copy, next);
	            }
	            have -= copy;
	            next += copy;
	            state.length -= copy;
	          }
	          if (state.length) { break inf_leave; }
	        }
	        state.length = 0;
	        state.mode = NAME;
	        /* falls through */
	      case NAME:
	        if (state.flags & 0x0800) {
	          if (have === 0) { break inf_leave; }
	          copy = 0;
	          do {
	            // TODO: 2 or 1 bytes?
	            len = input[next + copy++];
	            /* use constant limit because in js we should not preallocate memory */
	            if (state.head && len &&
	                (state.length < 65536 /*state.head.name_max*/)) {
	              state.head.name += String.fromCharCode(len);
	            }
	          } while (len && copy < have);

	          if (state.flags & 0x0200) {
	            state.check = crc32(state.check, input, copy, next);
	          }
	          have -= copy;
	          next += copy;
	          if (len) { break inf_leave; }
	        }
	        else if (state.head) {
	          state.head.name = null;
	        }
	        state.length = 0;
	        state.mode = COMMENT;
	        /* falls through */
	      case COMMENT:
	        if (state.flags & 0x1000) {
	          if (have === 0) { break inf_leave; }
	          copy = 0;
	          do {
	            len = input[next + copy++];
	            /* use constant limit because in js we should not preallocate memory */
	            if (state.head && len &&
	                (state.length < 65536 /*state.head.comm_max*/)) {
	              state.head.comment += String.fromCharCode(len);
	            }
	          } while (len && copy < have);
	          if (state.flags & 0x0200) {
	            state.check = crc32(state.check, input, copy, next);
	          }
	          have -= copy;
	          next += copy;
	          if (len) { break inf_leave; }
	        }
	        else if (state.head) {
	          state.head.comment = null;
	        }
	        state.mode = HCRC;
	        /* falls through */
	      case HCRC:
	        if (state.flags & 0x0200) {
	          //=== NEEDBITS(16); */
	          while (bits < 16) {
	            if (have === 0) { break inf_leave; }
	            have--;
	            hold += input[next++] << bits;
	            bits += 8;
	          }
	          //===//
	          if (hold !== (state.check & 0xffff)) {
	            strm.msg = 'header crc mismatch';
	            state.mode = BAD;
	            break;
	          }
	          //=== INITBITS();
	          hold = 0;
	          bits = 0;
	          //===//
	        }
	        if (state.head) {
	          state.head.hcrc = ((state.flags >> 9) & 1);
	          state.head.done = true;
	        }
	        strm.adler = state.check = 0;
	        state.mode = TYPE;
	        break;
	      case DICTID:
	        //=== NEEDBITS(32); */
	        while (bits < 32) {
	          if (have === 0) { break inf_leave; }
	          have--;
	          hold += input[next++] << bits;
	          bits += 8;
	        }
	        //===//
	        strm.adler = state.check = zswap32(hold);
	        //=== INITBITS();
	        hold = 0;
	        bits = 0;
	        //===//
	        state.mode = DICT;
	        /* falls through */
	      case DICT:
	        if (state.havedict === 0) {
	          //--- RESTORE() ---
	          strm.next_out = put;
	          strm.avail_out = left;
	          strm.next_in = next;
	          strm.avail_in = have;
	          state.hold = hold;
	          state.bits = bits;
	          //---
	          return Z_NEED_DICT$1;
	        }
	        strm.adler = state.check = 1/*adler32(0L, Z_NULL, 0)*/;
	        state.mode = TYPE;
	        /* falls through */
	      case TYPE:
	        if (flush === Z_BLOCK || flush === Z_TREES) { break inf_leave; }
	        /* falls through */
	      case TYPEDO:
	        if (state.last) {
	          //--- BYTEBITS() ---//
	          hold >>>= bits & 7;
	          bits -= bits & 7;
	          //---//
	          state.mode = CHECK;
	          break;
	        }
	        //=== NEEDBITS(3); */
	        while (bits < 3) {
	          if (have === 0) { break inf_leave; }
	          have--;
	          hold += input[next++] << bits;
	          bits += 8;
	        }
	        //===//
	        state.last = (hold & 0x01)/*BITS(1)*/;
	        //--- DROPBITS(1) ---//
	        hold >>>= 1;
	        bits -= 1;
	        //---//

	        switch ((hold & 0x03)/*BITS(2)*/) {
	          case 0:                             /* stored block */
	            //Tracev((stderr, "inflate:     stored block%s\n",
	            //        state.last ? " (last)" : ""));
	            state.mode = STORED;
	            break;
	          case 1:                             /* fixed block */
	            fixedtables(state);
	            //Tracev((stderr, "inflate:     fixed codes block%s\n",
	            //        state.last ? " (last)" : ""));
	            state.mode = LEN_;             /* decode codes */
	            if (flush === Z_TREES) {
	              //--- DROPBITS(2) ---//
	              hold >>>= 2;
	              bits -= 2;
	              //---//
	              break inf_leave;
	            }
	            break;
	          case 2:                             /* dynamic block */
	            //Tracev((stderr, "inflate:     dynamic codes block%s\n",
	            //        state.last ? " (last)" : ""));
	            state.mode = TABLE;
	            break;
	          case 3:
	            strm.msg = 'invalid block type';
	            state.mode = BAD;
	        }
	        //--- DROPBITS(2) ---//
	        hold >>>= 2;
	        bits -= 2;
	        //---//
	        break;
	      case STORED:
	        //--- BYTEBITS() ---// /* go to byte boundary */
	        hold >>>= bits & 7;
	        bits -= bits & 7;
	        //---//
	        //=== NEEDBITS(32); */
	        while (bits < 32) {
	          if (have === 0) { break inf_leave; }
	          have--;
	          hold += input[next++] << bits;
	          bits += 8;
	        }
	        //===//
	        if ((hold & 0xffff) !== ((hold >>> 16) ^ 0xffff)) {
	          strm.msg = 'invalid stored block lengths';
	          state.mode = BAD;
	          break;
	        }
	        state.length = hold & 0xffff;
	        //Tracev((stderr, "inflate:       stored length %u\n",
	        //        state.length));
	        //=== INITBITS();
	        hold = 0;
	        bits = 0;
	        //===//
	        state.mode = COPY_;
	        if (flush === Z_TREES) { break inf_leave; }
	        /* falls through */
	      case COPY_:
	        state.mode = COPY;
	        /* falls through */
	      case COPY:
	        copy = state.length;
	        if (copy) {
	          if (copy > have) { copy = have; }
	          if (copy > left) { copy = left; }
	          if (copy === 0) { break inf_leave; }
	          //--- zmemcpy(put, next, copy); ---
	          output.set(input.subarray(next, next + copy), put);
	          //---//
	          have -= copy;
	          next += copy;
	          left -= copy;
	          put += copy;
	          state.length -= copy;
	          break;
	        }
	        //Tracev((stderr, "inflate:       stored end\n"));
	        state.mode = TYPE;
	        break;
	      case TABLE:
	        //=== NEEDBITS(14); */
	        while (bits < 14) {
	          if (have === 0) { break inf_leave; }
	          have--;
	          hold += input[next++] << bits;
	          bits += 8;
	        }
	        //===//
	        state.nlen = (hold & 0x1f)/*BITS(5)*/ + 257;
	        //--- DROPBITS(5) ---//
	        hold >>>= 5;
	        bits -= 5;
	        //---//
	        state.ndist = (hold & 0x1f)/*BITS(5)*/ + 1;
	        //--- DROPBITS(5) ---//
	        hold >>>= 5;
	        bits -= 5;
	        //---//
	        state.ncode = (hold & 0x0f)/*BITS(4)*/ + 4;
	        //--- DROPBITS(4) ---//
	        hold >>>= 4;
	        bits -= 4;
	        //---//
	//#ifndef PKZIP_BUG_WORKAROUND
	        if (state.nlen > 286 || state.ndist > 30) {
	          strm.msg = 'too many length or distance symbols';
	          state.mode = BAD;
	          break;
	        }
	//#endif
	        //Tracev((stderr, "inflate:       table sizes ok\n"));
	        state.have = 0;
	        state.mode = LENLENS;
	        /* falls through */
	      case LENLENS:
	        while (state.have < state.ncode) {
	          //=== NEEDBITS(3);
	          while (bits < 3) {
	            if (have === 0) { break inf_leave; }
	            have--;
	            hold += input[next++] << bits;
	            bits += 8;
	          }
	          //===//
	          state.lens[order[state.have++]] = (hold & 0x07);//BITS(3);
	          //--- DROPBITS(3) ---//
	          hold >>>= 3;
	          bits -= 3;
	          //---//
	        }
	        while (state.have < 19) {
	          state.lens[order[state.have++]] = 0;
	        }
	        // We have separate tables & no pointers. 2 commented lines below not needed.
	        //state.next = state.codes;
	        //state.lencode = state.next;
	        // Switch to use dynamic table
	        state.lencode = state.lendyn;
	        state.lenbits = 7;

	        opts = { bits: state.lenbits };
	        ret = inflate_table(CODES, state.lens, 0, 19, state.lencode, 0, state.work, opts);
	        state.lenbits = opts.bits;

	        if (ret) {
	          strm.msg = 'invalid code lengths set';
	          state.mode = BAD;
	          break;
	        }
	        //Tracev((stderr, "inflate:       code lengths ok\n"));
	        state.have = 0;
	        state.mode = CODELENS;
	        /* falls through */
	      case CODELENS:
	        while (state.have < state.nlen + state.ndist) {
	          for (;;) {
	            here = state.lencode[hold & ((1 << state.lenbits) - 1)];/*BITS(state.lenbits)*/
	            here_bits = here >>> 24;
	            here_op = (here >>> 16) & 0xff;
	            here_val = here & 0xffff;

	            if ((here_bits) <= bits) { break; }
	            //--- PULLBYTE() ---//
	            if (have === 0) { break inf_leave; }
	            have--;
	            hold += input[next++] << bits;
	            bits += 8;
	            //---//
	          }
	          if (here_val < 16) {
	            //--- DROPBITS(here.bits) ---//
	            hold >>>= here_bits;
	            bits -= here_bits;
	            //---//
	            state.lens[state.have++] = here_val;
	          }
	          else {
	            if (here_val === 16) {
	              //=== NEEDBITS(here.bits + 2);
	              n = here_bits + 2;
	              while (bits < n) {
	                if (have === 0) { break inf_leave; }
	                have--;
	                hold += input[next++] << bits;
	                bits += 8;
	              }
	              //===//
	              //--- DROPBITS(here.bits) ---//
	              hold >>>= here_bits;
	              bits -= here_bits;
	              //---//
	              if (state.have === 0) {
	                strm.msg = 'invalid bit length repeat';
	                state.mode = BAD;
	                break;
	              }
	              len = state.lens[state.have - 1];
	              copy = 3 + (hold & 0x03);//BITS(2);
	              //--- DROPBITS(2) ---//
	              hold >>>= 2;
	              bits -= 2;
	              //---//
	            }
	            else if (here_val === 17) {
	              //=== NEEDBITS(here.bits + 3);
	              n = here_bits + 3;
	              while (bits < n) {
	                if (have === 0) { break inf_leave; }
	                have--;
	                hold += input[next++] << bits;
	                bits += 8;
	              }
	              //===//
	              //--- DROPBITS(here.bits) ---//
	              hold >>>= here_bits;
	              bits -= here_bits;
	              //---//
	              len = 0;
	              copy = 3 + (hold & 0x07);//BITS(3);
	              //--- DROPBITS(3) ---//
	              hold >>>= 3;
	              bits -= 3;
	              //---//
	            }
	            else {
	              //=== NEEDBITS(here.bits + 7);
	              n = here_bits + 7;
	              while (bits < n) {
	                if (have === 0) { break inf_leave; }
	                have--;
	                hold += input[next++] << bits;
	                bits += 8;
	              }
	              //===//
	              //--- DROPBITS(here.bits) ---//
	              hold >>>= here_bits;
	              bits -= here_bits;
	              //---//
	              len = 0;
	              copy = 11 + (hold & 0x7f);//BITS(7);
	              //--- DROPBITS(7) ---//
	              hold >>>= 7;
	              bits -= 7;
	              //---//
	            }
	            if (state.have + copy > state.nlen + state.ndist) {
	              strm.msg = 'invalid bit length repeat';
	              state.mode = BAD;
	              break;
	            }
	            while (copy--) {
	              state.lens[state.have++] = len;
	            }
	          }
	        }

	        /* handle error breaks in while */
	        if (state.mode === BAD) { break; }

	        /* check for end-of-block code (better have one) */
	        if (state.lens[256] === 0) {
	          strm.msg = 'invalid code -- missing end-of-block';
	          state.mode = BAD;
	          break;
	        }

	        /* build code tables -- note: do not change the lenbits or distbits
	           values here (9 and 6) without reading the comments in inftrees.h
	           concerning the ENOUGH constants, which depend on those values */
	        state.lenbits = 9;

	        opts = { bits: state.lenbits };
	        ret = inflate_table(LENS, state.lens, 0, state.nlen, state.lencode, 0, state.work, opts);
	        // We have separate tables & no pointers. 2 commented lines below not needed.
	        // state.next_index = opts.table_index;
	        state.lenbits = opts.bits;
	        // state.lencode = state.next;

	        if (ret) {
	          strm.msg = 'invalid literal/lengths set';
	          state.mode = BAD;
	          break;
	        }

	        state.distbits = 6;
	        //state.distcode.copy(state.codes);
	        // Switch to use dynamic table
	        state.distcode = state.distdyn;
	        opts = { bits: state.distbits };
	        ret = inflate_table(DISTS, state.lens, state.nlen, state.ndist, state.distcode, 0, state.work, opts);
	        // We have separate tables & no pointers. 2 commented lines below not needed.
	        // state.next_index = opts.table_index;
	        state.distbits = opts.bits;
	        // state.distcode = state.next;

	        if (ret) {
	          strm.msg = 'invalid distances set';
	          state.mode = BAD;
	          break;
	        }
	        //Tracev((stderr, 'inflate:       codes ok\n'));
	        state.mode = LEN_;
	        if (flush === Z_TREES) { break inf_leave; }
	        /* falls through */
	      case LEN_:
	        state.mode = LEN;
	        /* falls through */
	      case LEN:
	        if (have >= 6 && left >= 258) {
	          //--- RESTORE() ---
	          strm.next_out = put;
	          strm.avail_out = left;
	          strm.next_in = next;
	          strm.avail_in = have;
	          state.hold = hold;
	          state.bits = bits;
	          //---
	          inflate_fast(strm, _out);
	          //--- LOAD() ---
	          put = strm.next_out;
	          output = strm.output;
	          left = strm.avail_out;
	          next = strm.next_in;
	          input = strm.input;
	          have = strm.avail_in;
	          hold = state.hold;
	          bits = state.bits;
	          //---

	          if (state.mode === TYPE) {
	            state.back = -1;
	          }
	          break;
	        }
	        state.back = 0;
	        for (;;) {
	          here = state.lencode[hold & ((1 << state.lenbits) - 1)];  /*BITS(state.lenbits)*/
	          here_bits = here >>> 24;
	          here_op = (here >>> 16) & 0xff;
	          here_val = here & 0xffff;

	          if (here_bits <= bits) { break; }
	          //--- PULLBYTE() ---//
	          if (have === 0) { break inf_leave; }
	          have--;
	          hold += input[next++] << bits;
	          bits += 8;
	          //---//
	        }
	        if (here_op && (here_op & 0xf0) === 0) {
	          last_bits = here_bits;
	          last_op = here_op;
	          last_val = here_val;
	          for (;;) {
	            here = state.lencode[last_val +
	                    ((hold & ((1 << (last_bits + last_op)) - 1))/*BITS(last.bits + last.op)*/ >> last_bits)];
	            here_bits = here >>> 24;
	            here_op = (here >>> 16) & 0xff;
	            here_val = here & 0xffff;

	            if ((last_bits + here_bits) <= bits) { break; }
	            //--- PULLBYTE() ---//
	            if (have === 0) { break inf_leave; }
	            have--;
	            hold += input[next++] << bits;
	            bits += 8;
	            //---//
	          }
	          //--- DROPBITS(last.bits) ---//
	          hold >>>= last_bits;
	          bits -= last_bits;
	          //---//
	          state.back += last_bits;
	        }
	        //--- DROPBITS(here.bits) ---//
	        hold >>>= here_bits;
	        bits -= here_bits;
	        //---//
	        state.back += here_bits;
	        state.length = here_val;
	        if (here_op === 0) {
	          //Tracevv((stderr, here.val >= 0x20 && here.val < 0x7f ?
	          //        "inflate:         literal '%c'\n" :
	          //        "inflate:         literal 0x%02x\n", here.val));
	          state.mode = LIT;
	          break;
	        }
	        if (here_op & 32) {
	          //Tracevv((stderr, "inflate:         end of block\n"));
	          state.back = -1;
	          state.mode = TYPE;
	          break;
	        }
	        if (here_op & 64) {
	          strm.msg = 'invalid literal/length code';
	          state.mode = BAD;
	          break;
	        }
	        state.extra = here_op & 15;
	        state.mode = LENEXT;
	        /* falls through */
	      case LENEXT:
	        if (state.extra) {
	          //=== NEEDBITS(state.extra);
	          n = state.extra;
	          while (bits < n) {
	            if (have === 0) { break inf_leave; }
	            have--;
	            hold += input[next++] << bits;
	            bits += 8;
	          }
	          //===//
	          state.length += hold & ((1 << state.extra) - 1)/*BITS(state.extra)*/;
	          //--- DROPBITS(state.extra) ---//
	          hold >>>= state.extra;
	          bits -= state.extra;
	          //---//
	          state.back += state.extra;
	        }
	        //Tracevv((stderr, "inflate:         length %u\n", state.length));
	        state.was = state.length;
	        state.mode = DIST;
	        /* falls through */
	      case DIST:
	        for (;;) {
	          here = state.distcode[hold & ((1 << state.distbits) - 1)];/*BITS(state.distbits)*/
	          here_bits = here >>> 24;
	          here_op = (here >>> 16) & 0xff;
	          here_val = here & 0xffff;

	          if ((here_bits) <= bits) { break; }
	          //--- PULLBYTE() ---//
	          if (have === 0) { break inf_leave; }
	          have--;
	          hold += input[next++] << bits;
	          bits += 8;
	          //---//
	        }
	        if ((here_op & 0xf0) === 0) {
	          last_bits = here_bits;
	          last_op = here_op;
	          last_val = here_val;
	          for (;;) {
	            here = state.distcode[last_val +
	                    ((hold & ((1 << (last_bits + last_op)) - 1))/*BITS(last.bits + last.op)*/ >> last_bits)];
	            here_bits = here >>> 24;
	            here_op = (here >>> 16) & 0xff;
	            here_val = here & 0xffff;

	            if ((last_bits + here_bits) <= bits) { break; }
	            //--- PULLBYTE() ---//
	            if (have === 0) { break inf_leave; }
	            have--;
	            hold += input[next++] << bits;
	            bits += 8;
	            //---//
	          }
	          //--- DROPBITS(last.bits) ---//
	          hold >>>= last_bits;
	          bits -= last_bits;
	          //---//
	          state.back += last_bits;
	        }
	        //--- DROPBITS(here.bits) ---//
	        hold >>>= here_bits;
	        bits -= here_bits;
	        //---//
	        state.back += here_bits;
	        if (here_op & 64) {
	          strm.msg = 'invalid distance code';
	          state.mode = BAD;
	          break;
	        }
	        state.offset = here_val;
	        state.extra = (here_op) & 15;
	        state.mode = DISTEXT;
	        /* falls through */
	      case DISTEXT:
	        if (state.extra) {
	          //=== NEEDBITS(state.extra);
	          n = state.extra;
	          while (bits < n) {
	            if (have === 0) { break inf_leave; }
	            have--;
	            hold += input[next++] << bits;
	            bits += 8;
	          }
	          //===//
	          state.offset += hold & ((1 << state.extra) - 1)/*BITS(state.extra)*/;
	          //--- DROPBITS(state.extra) ---//
	          hold >>>= state.extra;
	          bits -= state.extra;
	          //---//
	          state.back += state.extra;
	        }
	//#ifdef INFLATE_STRICT
	        if (state.offset > state.dmax) {
	          strm.msg = 'invalid distance too far back';
	          state.mode = BAD;
	          break;
	        }
	//#endif
	        //Tracevv((stderr, "inflate:         distance %u\n", state.offset));
	        state.mode = MATCH;
	        /* falls through */
	      case MATCH:
	        if (left === 0) { break inf_leave; }
	        copy = _out - left;
	        if (state.offset > copy) {         /* copy from window */
	          copy = state.offset - copy;
	          if (copy > state.whave) {
	            if (state.sane) {
	              strm.msg = 'invalid distance too far back';
	              state.mode = BAD;
	              break;
	            }
	// (!) This block is disabled in zlib defaults,
	// don't enable it for binary compatibility
	//#ifdef INFLATE_ALLOW_INVALID_DISTANCE_TOOFAR_ARRR
	//          Trace((stderr, "inflate.c too far\n"));
	//          copy -= state.whave;
	//          if (copy > state.length) { copy = state.length; }
	//          if (copy > left) { copy = left; }
	//          left -= copy;
	//          state.length -= copy;
	//          do {
	//            output[put++] = 0;
	//          } while (--copy);
	//          if (state.length === 0) { state.mode = LEN; }
	//          break;
	//#endif
	          }
	          if (copy > state.wnext) {
	            copy -= state.wnext;
	            from = state.wsize - copy;
	          }
	          else {
	            from = state.wnext - copy;
	          }
	          if (copy > state.length) { copy = state.length; }
	          from_source = state.window;
	        }
	        else {                              /* copy from output */
	          from_source = output;
	          from = put - state.offset;
	          copy = state.length;
	        }
	        if (copy > left) { copy = left; }
	        left -= copy;
	        state.length -= copy;
	        do {
	          output[put++] = from_source[from++];
	        } while (--copy);
	        if (state.length === 0) { state.mode = LEN; }
	        break;
	      case LIT:
	        if (left === 0) { break inf_leave; }
	        output[put++] = state.length;
	        left--;
	        state.mode = LEN;
	        break;
	      case CHECK:
	        if (state.wrap) {
	          //=== NEEDBITS(32);
	          while (bits < 32) {
	            if (have === 0) { break inf_leave; }
	            have--;
	            // Use '|' instead of '+' to make sure that result is signed
	            hold |= input[next++] << bits;
	            bits += 8;
	          }
	          //===//
	          _out -= left;
	          strm.total_out += _out;
	          state.total += _out;
	          if (_out) {
	            strm.adler = state.check =
	                /*UPDATE(state.check, put - _out, _out);*/
	                (state.flags ? crc32(state.check, output, _out, put - _out) : adler32(state.check, output, _out, put - _out));

	          }
	          _out = left;
	          // NB: crc32 stored as signed 32-bit int, zswap32 returns signed too
	          if ((state.flags ? hold : zswap32(hold)) !== state.check) {
	            strm.msg = 'incorrect data check';
	            state.mode = BAD;
	            break;
	          }
	          //=== INITBITS();
	          hold = 0;
	          bits = 0;
	          //===//
	          //Tracev((stderr, "inflate:   check matches trailer\n"));
	        }
	        state.mode = LENGTH;
	        /* falls through */
	      case LENGTH:
	        if (state.wrap && state.flags) {
	          //=== NEEDBITS(32);
	          while (bits < 32) {
	            if (have === 0) { break inf_leave; }
	            have--;
	            hold += input[next++] << bits;
	            bits += 8;
	          }
	          //===//
	          if (hold !== (state.total & 0xffffffff)) {
	            strm.msg = 'incorrect length check';
	            state.mode = BAD;
	            break;
	          }
	          //=== INITBITS();
	          hold = 0;
	          bits = 0;
	          //===//
	          //Tracev((stderr, "inflate:   length matches trailer\n"));
	        }
	        state.mode = DONE;
	        /* falls through */
	      case DONE:
	        ret = Z_STREAM_END$1;
	        break inf_leave;
	      case BAD:
	        ret = Z_DATA_ERROR$1;
	        break inf_leave;
	      case MEM:
	        return Z_MEM_ERROR$1;
	      case SYNC:
	        /* falls through */
	      default:
	        return Z_STREAM_ERROR$1;
	    }
	  }

	  // inf_leave <- here is real place for "goto inf_leave", emulated via "break inf_leave"

	  /*
	     Return from inflate(), updating the total counts and the check value.
	     If there was no progress during the inflate() call, return a buffer
	     error.  Call updatewindow() to create and/or update the window state.
	     Note: a memory error from inflate() is non-recoverable.
	   */

	  //--- RESTORE() ---
	  strm.next_out = put;
	  strm.avail_out = left;
	  strm.next_in = next;
	  strm.avail_in = have;
	  state.hold = hold;
	  state.bits = bits;
	  //---

	  if (state.wsize || (_out !== strm.avail_out && state.mode < BAD &&
	                      (state.mode < CHECK || flush !== Z_FINISH$1))) {
	    if (updatewindow(strm, strm.output, strm.next_out, _out - strm.avail_out)) ;
	  }
	  _in -= strm.avail_in;
	  _out -= strm.avail_out;
	  strm.total_in += _in;
	  strm.total_out += _out;
	  state.total += _out;
	  if (state.wrap && _out) {
	    strm.adler = state.check = /*UPDATE(state.check, strm.next_out - _out, _out);*/
	      (state.flags ? crc32(state.check, output, _out, strm.next_out - _out) : adler32(state.check, output, _out, strm.next_out - _out));
	  }
	  strm.data_type = state.bits + (state.last ? 64 : 0) +
	                    (state.mode === TYPE ? 128 : 0) +
	                    (state.mode === LEN_ || state.mode === COPY_ ? 256 : 0);
	  if (((_in === 0 && _out === 0) || flush === Z_FINISH$1) && ret === Z_OK$1) {
	    ret = Z_BUF_ERROR;
	  }
	  return ret;
	};


	const inflateEnd = (strm) => {

	  if (!strm || !strm.state /*|| strm->zfree == (free_func)0*/) {
	    return Z_STREAM_ERROR$1;
	  }

	  let state = strm.state;
	  if (state.window) {
	    state.window = null;
	  }
	  strm.state = null;
	  return Z_OK$1;
	};


	const inflateGetHeader = (strm, head) => {

	  /* check state */
	  if (!strm || !strm.state) { return Z_STREAM_ERROR$1; }
	  const state = strm.state;
	  if ((state.wrap & 2) === 0) { return Z_STREAM_ERROR$1; }

	  /* save header structure */
	  state.head = head;
	  head.done = false;
	  return Z_OK$1;
	};


	const inflateSetDictionary = (strm, dictionary) => {
	  const dictLength = dictionary.length;

	  let state;
	  let dictid;
	  let ret;

	  /* check state */
	  if (!strm /* == Z_NULL */ || !strm.state /* == Z_NULL */) { return Z_STREAM_ERROR$1; }
	  state = strm.state;

	  if (state.wrap !== 0 && state.mode !== DICT) {
	    return Z_STREAM_ERROR$1;
	  }

	  /* check for correct dictionary identifier */
	  if (state.mode === DICT) {
	    dictid = 1; /* adler32(0, null, 0)*/
	    /* dictid = adler32(dictid, dictionary, dictLength); */
	    dictid = adler32(dictid, dictionary, dictLength, 0);
	    if (dictid !== state.check) {
	      return Z_DATA_ERROR$1;
	    }
	  }
	  /* copy dictionary to window using updatewindow(), which will amend the
	   existing dictionary if appropriate */
	  ret = updatewindow(strm, dictionary, dictLength, dictLength);
	  if (ret) {
	    state.mode = MEM;
	    return Z_MEM_ERROR$1;
	  }
	  state.havedict = 1;
	  // Tracev((stderr, "inflate:   dictionary set\n"));
	  return Z_OK$1;
	};


	inflate$3.inflateReset = inflateReset;
	inflate$3.inflateReset2 = inflateReset2;
	inflate$3.inflateResetKeep = inflateResetKeep;
	inflate$3.inflateInit = inflateInit;
	inflate$3.inflateInit2 = inflateInit2;
	inflate$3.inflate = inflate$2;
	inflate$3.inflateEnd = inflateEnd;
	inflate$3.inflateGetHeader = inflateGetHeader;
	inflate$3.inflateSetDictionary = inflateSetDictionary;
	inflate$3.inflateInfo = 'pako inflate (from Nodeca project)';

	// (C) 1995-2013 Jean-loup Gailly and Mark Adler
	// (C) 2014-2017 Vitaly Puzrin and Andrey Tupitsin
	//
	// This software is provided 'as-is', without any express or implied
	// warranty. In no event will the authors be held liable for any damages
	// arising from the use of this software.
	//
	// Permission is granted to anyone to use this software for any purpose,
	// including commercial applications, and to alter it and redistribute it
	// freely, subject to the following restrictions:
	//
	// 1. The origin of this software must not be misrepresented; you must not
	//   claim that you wrote the original software. If you use this software
	//   in a product, an acknowledgment in the product documentation would be
	//   appreciated but is not required.
	// 2. Altered source versions must be plainly marked as such, and must not be
	//   misrepresented as being the original software.
	// 3. This notice may not be removed or altered from any source distribution.

	function GZheader$1() {
	  /* true if compressed data believed to be text */
	  this.text       = 0;
	  /* modification time */
	  this.time       = 0;
	  /* extra flags (not used when writing a gzip file) */
	  this.xflags     = 0;
	  /* operating system */
	  this.os         = 0;
	  /* pointer to extra field or Z_NULL if none */
	  this.extra      = null;
	  /* extra field length (valid if extra != Z_NULL) */
	  this.extra_len  = 0; // Actually, we don't need it in JS,
	                       // but leave for few code modifications

	  //
	  // Setup limits is not necessary because in js we should not preallocate memory
	  // for inflate use constant limit in 65536 bytes
	  //

	  /* space at extra (only when reading header) */
	  // this.extra_max  = 0;
	  /* pointer to zero-terminated file name or Z_NULL */
	  this.name       = '';
	  /* space at name (only when reading header) */
	  // this.name_max   = 0;
	  /* pointer to zero-terminated comment or Z_NULL */
	  this.comment    = '';
	  /* space at comment (only when reading header) */
	  // this.comm_max   = 0;
	  /* true if there was or will be a header crc */
	  this.hcrc       = 0;
	  /* true when done reading gzip header (not used when writing a gzip file) */
	  this.done       = false;
	}

	var gzheader = GZheader$1;

	const zlib_inflate = inflate$3;
	const utils        = common$3;
	const strings      = strings$2;
	const msg          = messages;
	const ZStream      = zstream;
	const GZheader     = gzheader;

	const toString = Object.prototype.toString;

	/* Public constants ==========================================================*/
	/* ===========================================================================*/

	const {
	  Z_NO_FLUSH, Z_FINISH,
	  Z_OK, Z_STREAM_END, Z_NEED_DICT, Z_STREAM_ERROR, Z_DATA_ERROR, Z_MEM_ERROR
	} = constants$1;

	/* ===========================================================================*/


	/**
	 * class Inflate
	 *
	 * Generic JS-style wrapper for zlib calls. If you don't need
	 * streaming behaviour - use more simple functions: [[inflate]]
	 * and [[inflateRaw]].
	 **/

	/* internal
	 * inflate.chunks -> Array
	 *
	 * Chunks of output data, if [[Inflate#onData]] not overridden.
	 **/

	/**
	 * Inflate.result -> Uint8Array|String
	 *
	 * Uncompressed result, generated by default [[Inflate#onData]]
	 * and [[Inflate#onEnd]] handlers. Filled after you push last chunk
	 * (call [[Inflate#push]] with `Z_FINISH` / `true` param).
	 **/

	/**
	 * Inflate.err -> Number
	 *
	 * Error code after inflate finished. 0 (Z_OK) on success.
	 * Should be checked if broken data possible.
	 **/

	/**
	 * Inflate.msg -> String
	 *
	 * Error message, if [[Inflate.err]] != 0
	 **/


	/**
	 * new Inflate(options)
	 * - options (Object): zlib inflate options.
	 *
	 * Creates new inflator instance with specified params. Throws exception
	 * on bad params. Supported options:
	 *
	 * - `windowBits`
	 * - `dictionary`
	 *
	 * [http://zlib.net/manual.html#Advanced](http://zlib.net/manual.html#Advanced)
	 * for more information on these.
	 *
	 * Additional options, for internal needs:
	 *
	 * - `chunkSize` - size of generated data chunks (16K by default)
	 * - `raw` (Boolean) - do raw inflate
	 * - `to` (String) - if equal to 'string', then result will be converted
	 *   from utf8 to utf16 (javascript) string. When string output requested,
	 *   chunk length can differ from `chunkSize`, depending on content.
	 *
	 * By default, when no options set, autodetect deflate/gzip data format via
	 * wrapper header.
	 *
	 * ##### Example:
	 *
	 * ```javascript
	 * const pako = require('pako')
	 * const chunk1 = new Uint8Array([1,2,3,4,5,6,7,8,9])
	 * const chunk2 = new Uint8Array([10,11,12,13,14,15,16,17,18,19]);
	 *
	 * const inflate = new pako.Inflate({ level: 3});
	 *
	 * inflate.push(chunk1, false);
	 * inflate.push(chunk2, true);  // true -> last chunk
	 *
	 * if (inflate.err) { throw new Error(inflate.err); }
	 *
	 * console.log(inflate.result);
	 * ```
	 **/
	function Inflate$1(options) {
	  this.options = utils.assign({
	    chunkSize: 1024 * 64,
	    windowBits: 15,
	    to: ''
	  }, options || {});

	  const opt = this.options;

	  // Force window size for `raw` data, if not set directly,
	  // because we have no header for autodetect.
	  if (opt.raw && (opt.windowBits >= 0) && (opt.windowBits < 16)) {
	    opt.windowBits = -opt.windowBits;
	    if (opt.windowBits === 0) { opt.windowBits = -15; }
	  }

	  // If `windowBits` not defined (and mode not raw) - set autodetect flag for gzip/deflate
	  if ((opt.windowBits >= 0) && (opt.windowBits < 16) &&
	      !(options && options.windowBits)) {
	    opt.windowBits += 32;
	  }

	  // Gzip header has no info about windows size, we can do autodetect only
	  // for deflate. So, if window size not set, force it to max when gzip possible
	  if ((opt.windowBits > 15) && (opt.windowBits < 48)) {
	    // bit 3 (16) -> gzipped data
	    // bit 4 (32) -> autodetect gzip/deflate
	    if ((opt.windowBits & 15) === 0) {
	      opt.windowBits |= 15;
	    }
	  }

	  this.err    = 0;      // error code, if happens (0 = Z_OK)
	  this.msg    = '';     // error message
	  this.ended  = false;  // used to avoid multiple onEnd() calls
	  this.chunks = [];     // chunks of compressed data

	  this.strm   = new ZStream();
	  this.strm.avail_out = 0;

	  let status  = zlib_inflate.inflateInit2(
	    this.strm,
	    opt.windowBits
	  );

	  if (status !== Z_OK) {
	    throw new Error(msg[status]);
	  }

	  this.header = new GZheader();

	  zlib_inflate.inflateGetHeader(this.strm, this.header);

	  // Setup dictionary
	  if (opt.dictionary) {
	    // Convert data if needed
	    if (typeof opt.dictionary === 'string') {
	      opt.dictionary = strings.string2buf(opt.dictionary);
	    } else if (toString.call(opt.dictionary) === '[object ArrayBuffer]') {
	      opt.dictionary = new Uint8Array(opt.dictionary);
	    }
	    if (opt.raw) { //In raw mode we need to set the dictionary early
	      status = zlib_inflate.inflateSetDictionary(this.strm, opt.dictionary);
	      if (status !== Z_OK) {
	        throw new Error(msg[status]);
	      }
	    }
	  }
	}

	/**
	 * Inflate#push(data[, flush_mode]) -> Boolean
	 * - data (Uint8Array|ArrayBuffer): input data
	 * - flush_mode (Number|Boolean): 0..6 for corresponding Z_NO_FLUSH..Z_TREE
	 *   flush modes. See constants. Skipped or `false` means Z_NO_FLUSH,
	 *   `true` means Z_FINISH.
	 *
	 * Sends input data to inflate pipe, generating [[Inflate#onData]] calls with
	 * new output chunks. Returns `true` on success. If end of stream detected,
	 * [[Inflate#onEnd]] will be called.
	 *
	 * `flush_mode` is not needed for normal operation, because end of stream
	 * detected automatically. You may try to use it for advanced things, but
	 * this functionality was not tested.
	 *
	 * On fail call [[Inflate#onEnd]] with error code and return false.
	 *
	 * ##### Example
	 *
	 * ```javascript
	 * push(chunk, false); // push one of data chunks
	 * ...
	 * push(chunk, true);  // push last chunk
	 * ```
	 **/
	Inflate$1.prototype.push = function (data, flush_mode) {
	  const strm = this.strm;
	  const chunkSize = this.options.chunkSize;
	  const dictionary = this.options.dictionary;
	  let status, _flush_mode, last_avail_out;

	  if (this.ended) return false;

	  if (flush_mode === ~~flush_mode) _flush_mode = flush_mode;
	  else _flush_mode = flush_mode === true ? Z_FINISH : Z_NO_FLUSH;

	  // Convert data if needed
	  if (toString.call(data) === '[object ArrayBuffer]') {
	    strm.input = new Uint8Array(data);
	  } else {
	    strm.input = data;
	  }

	  strm.next_in = 0;
	  strm.avail_in = strm.input.length;

	  for (;;) {
	    if (strm.avail_out === 0) {
	      strm.output = new Uint8Array(chunkSize);
	      strm.next_out = 0;
	      strm.avail_out = chunkSize;
	    }

	    status = zlib_inflate.inflate(strm, _flush_mode);

	    if (status === Z_NEED_DICT && dictionary) {
	      status = zlib_inflate.inflateSetDictionary(strm, dictionary);

	      if (status === Z_OK) {
	        status = zlib_inflate.inflate(strm, _flush_mode);
	      } else if (status === Z_DATA_ERROR) {
	        // Replace code with more verbose
	        status = Z_NEED_DICT;
	      }
	    }

	    // Skip snyc markers if more data follows and not raw mode
	    while (strm.avail_in > 0 &&
	           status === Z_STREAM_END &&
	           strm.state.wrap > 0 &&
	           data[strm.next_in] !== 0)
	    {
	      zlib_inflate.inflateReset(strm);
	      status = zlib_inflate.inflate(strm, _flush_mode);
	    }

	    switch (status) {
	      case Z_STREAM_ERROR:
	      case Z_DATA_ERROR:
	      case Z_NEED_DICT:
	      case Z_MEM_ERROR:
	        this.onEnd(status);
	        this.ended = true;
	        return false;
	    }

	    // Remember real `avail_out` value, because we may patch out buffer content
	    // to align utf8 strings boundaries.
	    last_avail_out = strm.avail_out;

	    if (strm.next_out) {
	      if (strm.avail_out === 0 || status === Z_STREAM_END) {

	        if (this.options.to === 'string') {

	          let next_out_utf8 = strings.utf8border(strm.output, strm.next_out);

	          let tail = strm.next_out - next_out_utf8;
	          let utf8str = strings.buf2string(strm.output, next_out_utf8);

	          // move tail & realign counters
	          strm.next_out = tail;
	          strm.avail_out = chunkSize - tail;
	          if (tail) strm.output.set(strm.output.subarray(next_out_utf8, next_out_utf8 + tail), 0);

	          this.onData(utf8str);

	        } else {
	          this.onData(strm.output.length === strm.next_out ? strm.output : strm.output.subarray(0, strm.next_out));
	        }
	      }
	    }

	    // Must repeat iteration if out buffer is full
	    if (status === Z_OK && last_avail_out === 0) continue;

	    // Finalize if end of stream reached.
	    if (status === Z_STREAM_END) {
	      status = zlib_inflate.inflateEnd(this.strm);
	      this.onEnd(status);
	      this.ended = true;
	      return true;
	    }

	    if (strm.avail_in === 0) break;
	  }

	  return true;
	};


	/**
	 * Inflate#onData(chunk) -> Void
	 * - chunk (Uint8Array|String): output data. When string output requested,
	 *   each chunk will be string.
	 *
	 * By default, stores data blocks in `chunks[]` property and glue
	 * those in `onEnd`. Override this handler, if you need another behaviour.
	 **/
	Inflate$1.prototype.onData = function (chunk) {
	  this.chunks.push(chunk);
	};


	/**
	 * Inflate#onEnd(status) -> Void
	 * - status (Number): inflate status. 0 (Z_OK) on success,
	 *   other if not.
	 *
	 * Called either after you tell inflate that the input stream is
	 * complete (Z_FINISH). By default - join collected chunks,
	 * free memory and fill `results` / `err` properties.
	 **/
	Inflate$1.prototype.onEnd = function (status) {
	  // On success - join
	  if (status === Z_OK) {
	    if (this.options.to === 'string') {
	      this.result = this.chunks.join('');
	    } else {
	      this.result = utils.flattenChunks(this.chunks);
	    }
	  }
	  this.chunks = [];
	  this.err = status;
	  this.msg = this.strm.msg;
	};


	/**
	 * inflate(data[, options]) -> Uint8Array|String
	 * - data (Uint8Array): input data to decompress.
	 * - options (Object): zlib inflate options.
	 *
	 * Decompress `data` with inflate/ungzip and `options`. Autodetect
	 * format via wrapper header by default. That's why we don't provide
	 * separate `ungzip` method.
	 *
	 * Supported options are:
	 *
	 * - windowBits
	 *
	 * [http://zlib.net/manual.html#Advanced](http://zlib.net/manual.html#Advanced)
	 * for more information.
	 *
	 * Sugar (options):
	 *
	 * - `raw` (Boolean) - say that we work with raw stream, if you don't wish to specify
	 *   negative windowBits implicitly.
	 * - `to` (String) - if equal to 'string', then result will be converted
	 *   from utf8 to utf16 (javascript) string. When string output requested,
	 *   chunk length can differ from `chunkSize`, depending on content.
	 *
	 *
	 * ##### Example:
	 *
	 * ```javascript
	 * const pako = require('pako');
	 * const input = pako.deflate(new Uint8Array([1,2,3,4,5,6,7,8,9]));
	 * let output;
	 *
	 * try {
	 *   output = pako.inflate(input);
	 * } catch (err) {
	 *   console.log(err);
	 * }
	 * ```
	 **/
	function inflate$1(input, options) {
	  const inflator = new Inflate$1(options);

	  inflator.push(input);

	  // That will never happens, if you don't cheat with options :)
	  if (inflator.err) throw inflator.msg || msg[inflator.err];

	  return inflator.result;
	}


	/**
	 * inflateRaw(data[, options]) -> Uint8Array|String
	 * - data (Uint8Array): input data to decompress.
	 * - options (Object): zlib inflate options.
	 *
	 * The same as [[inflate]], but creates raw data, without wrapper
	 * (header and adler32 crc).
	 **/
	function inflateRaw$1(input, options) {
	  options = options || {};
	  options.raw = true;
	  return inflate$1(input, options);
	}


	/**
	 * ungzip(data[, options]) -> Uint8Array|String
	 * - data (Uint8Array): input data to decompress.
	 * - options (Object): zlib inflate options.
	 *
	 * Just shortcut to [[inflate]], because it autodetects format
	 * by header.content. Done for convenience.
	 **/


	inflate$4.Inflate = Inflate$1;
	inflate$4.inflate = inflate$1;
	inflate$4.inflateRaw = inflateRaw$1;
	inflate$4.ungzip = inflate$1;
	inflate$4.constants = constants$1;

	const { Deflate, deflate, deflateRaw, gzip } = deflate$4;

	const { Inflate, inflate, inflateRaw, ungzip } = inflate$4;

	const constants = constants$1;

	pako.Deflate = Deflate;
	pako.deflate = deflate;
	pako.deflateRaw = deflateRaw;
	pako.gzip = gzip;
	pako.Inflate = Inflate;
	pako.inflate = inflate;
	pako.inflateRaw = inflateRaw;
	pako.ungzip = ungzip;
	pako.constants = constants;

	var provider = {};

	var bytes = {};

	var hex = {};

	Object.defineProperty(hex, "__esModule", { value: true });
	hex.decode = hex.encode = void 0;
	const buffer_1$7 = require$$0;
	function encode$3(data) {
	    return data.reduce((str, byte) => str + byte.toString(16).padStart(2, "0"), "0x");
	}
	hex.encode = encode$3;
	function decode$3(data) {
	    if (data.indexOf("0x") === 0) {
	        data = data.substr(2);
	    }
	    if (data.length % 2 === 1) {
	        data = "0" + data;
	    }
	    let key = data.match(/.{2}/g);
	    if (key === null) {
	        return buffer_1$7.Buffer.from([]);
	    }
	    return buffer_1$7.Buffer.from(key.map((byte) => parseInt(byte, 16)));
	}
	hex.decode = decode$3;

	var utf8$1 = {};

	var common$2 = {};

	var _a;
	Object.defineProperty(common$2, "__esModule", { value: true });
	common$2.chunks = common$2.isBrowser = void 0;
	/**
	 * Returns true if being run inside a web browser,
	 * false if in a Node process or electron app.
	 */
	common$2.isBrowser = process.env.ANCHOR_BROWSER ||
	    (typeof window !== "undefined" && !((_a = window.process) === null || _a === void 0 ? void 0 : _a.hasOwnProperty("type")));
	/**
	 * Splits an array into chunks
	 *
	 * @param array Array of objects to chunk.
	 * @param size The max size of a chunk.
	 * @returns A two dimensional array where each T[] length is < the provided size.
	 */
	function chunks(array, size) {
	    return Array.apply(0, new Array(Math.ceil(array.length / size))).map((_, index) => array.slice(index * size, (index + 1) * size));
	}
	common$2.chunks = chunks;

	Object.defineProperty(utf8$1, "__esModule", { value: true });
	utf8$1.encode = utf8$1.decode = void 0;
	const common_1$1 = common$2;
	function decode$2(array) {
	    const decoder = common_1$1.isBrowser
	        ? new TextDecoder("utf-8") // Browser https://caniuse.com/textencoder.
	        : new (require$$1$1.TextDecoder)("utf-8"); // Node.
	    return decoder.decode(array);
	}
	utf8$1.decode = decode$2;
	function encode$2(input) {
	    const encoder = common_1$1.isBrowser
	        ? new TextEncoder() // Browser.
	        : new (require$$1$1.TextEncoder)("utf-8"); // Node.
	    return encoder.encode(input);
	}
	utf8$1.encode = encode$2;

	var bs58 = {};

	var __importDefault$8 = (commonjsGlobal && commonjsGlobal.__importDefault) || function (mod) {
	    return (mod && mod.__esModule) ? mod : { "default": mod };
	};
	Object.defineProperty(bs58, "__esModule", { value: true });
	bs58.decode = bs58.encode = void 0;
	const bs58_1 = __importDefault$8(bs58$1);
	function encode$1(data) {
	    return bs58_1.default.encode(data);
	}
	bs58.encode = encode$1;
	function decode$1(data) {
	    return bs58_1.default.decode(data);
	}
	bs58.decode = decode$1;

	var base64$2 = {};

	var base64Js = {};

	base64Js.byteLength = byteLength;
	base64Js.toByteArray = toByteArray;
	base64Js.fromByteArray = fromByteArray;

	var lookup = [];
	var revLookup = [];
	var Arr = typeof Uint8Array !== 'undefined' ? Uint8Array : Array;

	var code = 'ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/';
	for (var i = 0, len = code.length; i < len; ++i) {
	  lookup[i] = code[i];
	  revLookup[code.charCodeAt(i)] = i;
	}

	// Support decoding URL-safe base64 strings, as Node.js does.
	// See: https://en.wikipedia.org/wiki/Base64#URL_applications
	revLookup['-'.charCodeAt(0)] = 62;
	revLookup['_'.charCodeAt(0)] = 63;

	function getLens (b64) {
	  var len = b64.length;

	  if (len % 4 > 0) {
	    throw new Error('Invalid string. Length must be a multiple of 4')
	  }

	  // Trim off extra bytes after placeholder bytes are found
	  // See: https://github.com/beatgammit/base64-js/issues/42
	  var validLen = b64.indexOf('=');
	  if (validLen === -1) validLen = len;

	  var placeHoldersLen = validLen === len
	    ? 0
	    : 4 - (validLen % 4);

	  return [validLen, placeHoldersLen]
	}

	// base64 is 4/3 + up to two characters of the original data
	function byteLength (b64) {
	  var lens = getLens(b64);
	  var validLen = lens[0];
	  var placeHoldersLen = lens[1];
	  return ((validLen + placeHoldersLen) * 3 / 4) - placeHoldersLen
	}

	function _byteLength (b64, validLen, placeHoldersLen) {
	  return ((validLen + placeHoldersLen) * 3 / 4) - placeHoldersLen
	}

	function toByteArray (b64) {
	  var tmp;
	  var lens = getLens(b64);
	  var validLen = lens[0];
	  var placeHoldersLen = lens[1];

	  var arr = new Arr(_byteLength(b64, validLen, placeHoldersLen));

	  var curByte = 0;

	  // if there are placeholders, only get up to the last complete 4 chars
	  var len = placeHoldersLen > 0
	    ? validLen - 4
	    : validLen;

	  var i;
	  for (i = 0; i < len; i += 4) {
	    tmp =
	      (revLookup[b64.charCodeAt(i)] << 18) |
	      (revLookup[b64.charCodeAt(i + 1)] << 12) |
	      (revLookup[b64.charCodeAt(i + 2)] << 6) |
	      revLookup[b64.charCodeAt(i + 3)];
	    arr[curByte++] = (tmp >> 16) & 0xFF;
	    arr[curByte++] = (tmp >> 8) & 0xFF;
	    arr[curByte++] = tmp & 0xFF;
	  }

	  if (placeHoldersLen === 2) {
	    tmp =
	      (revLookup[b64.charCodeAt(i)] << 2) |
	      (revLookup[b64.charCodeAt(i + 1)] >> 4);
	    arr[curByte++] = tmp & 0xFF;
	  }

	  if (placeHoldersLen === 1) {
	    tmp =
	      (revLookup[b64.charCodeAt(i)] << 10) |
	      (revLookup[b64.charCodeAt(i + 1)] << 4) |
	      (revLookup[b64.charCodeAt(i + 2)] >> 2);
	    arr[curByte++] = (tmp >> 8) & 0xFF;
	    arr[curByte++] = tmp & 0xFF;
	  }

	  return arr
	}

	function tripletToBase64 (num) {
	  return lookup[num >> 18 & 0x3F] +
	    lookup[num >> 12 & 0x3F] +
	    lookup[num >> 6 & 0x3F] +
	    lookup[num & 0x3F]
	}

	function encodeChunk (uint8, start, end) {
	  var tmp;
	  var output = [];
	  for (var i = start; i < end; i += 3) {
	    tmp =
	      ((uint8[i] << 16) & 0xFF0000) +
	      ((uint8[i + 1] << 8) & 0xFF00) +
	      (uint8[i + 2] & 0xFF);
	    output.push(tripletToBase64(tmp));
	  }
	  return output.join('')
	}

	function fromByteArray (uint8) {
	  var tmp;
	  var len = uint8.length;
	  var extraBytes = len % 3; // if we have 1 byte left, pad 2 bytes
	  var parts = [];
	  var maxChunkLength = 16383; // must be multiple of 3

	  // go through the array every three bytes, we'll deal with trailing stuff later
	  for (var i = 0, len2 = len - extraBytes; i < len2; i += maxChunkLength) {
	    parts.push(encodeChunk(uint8, i, (i + maxChunkLength) > len2 ? len2 : (i + maxChunkLength)));
	  }

	  // pad the end with zeros, but make sure to not forget the extra bytes
	  if (extraBytes === 1) {
	    tmp = uint8[len - 1];
	    parts.push(
	      lookup[tmp >> 2] +
	      lookup[(tmp << 4) & 0x3F] +
	      '=='
	    );
	  } else if (extraBytes === 2) {
	    tmp = (uint8[len - 2] << 8) + uint8[len - 1];
	    parts.push(
	      lookup[tmp >> 10] +
	      lookup[(tmp >> 4) & 0x3F] +
	      lookup[(tmp << 2) & 0x3F] +
	      '='
	    );
	  }

	  return parts.join('')
	}

	var __createBinding$d = (commonjsGlobal && commonjsGlobal.__createBinding) || (Object.create ? (function(o, m, k, k2) {
	    if (k2 === undefined) k2 = k;
	    var desc = Object.getOwnPropertyDescriptor(m, k);
	    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
	      desc = { enumerable: true, get: function() { return m[k]; } };
	    }
	    Object.defineProperty(o, k2, desc);
	}) : (function(o, m, k, k2) {
	    if (k2 === undefined) k2 = k;
	    o[k2] = m[k];
	}));
	var __setModuleDefault$d = (commonjsGlobal && commonjsGlobal.__setModuleDefault) || (Object.create ? (function(o, v) {
	    Object.defineProperty(o, "default", { enumerable: true, value: v });
	}) : function(o, v) {
	    o["default"] = v;
	});
	var __importStar$d = (commonjsGlobal && commonjsGlobal.__importStar) || function (mod) {
	    if (mod && mod.__esModule) return mod;
	    var result = {};
	    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding$d(result, mod, k);
	    __setModuleDefault$d(result, mod);
	    return result;
	};
	Object.defineProperty(base64$2, "__esModule", { value: true });
	base64$2.decode = base64$2.encode = void 0;
	const buffer_1$6 = require$$0;
	const base64$1 = __importStar$d(base64Js);
	function encode(data) {
	    return base64$1.fromByteArray(data);
	}
	base64$2.encode = encode;
	function decode(data) {
	    return buffer_1$6.Buffer.from(base64$1.toByteArray(data));
	}
	base64$2.decode = decode;

	var __createBinding$c = (commonjsGlobal && commonjsGlobal.__createBinding) || (Object.create ? (function(o, m, k, k2) {
	    if (k2 === undefined) k2 = k;
	    var desc = Object.getOwnPropertyDescriptor(m, k);
	    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
	      desc = { enumerable: true, get: function() { return m[k]; } };
	    }
	    Object.defineProperty(o, k2, desc);
	}) : (function(o, m, k, k2) {
	    if (k2 === undefined) k2 = k;
	    o[k2] = m[k];
	}));
	var __setModuleDefault$c = (commonjsGlobal && commonjsGlobal.__setModuleDefault) || (Object.create ? (function(o, v) {
	    Object.defineProperty(o, "default", { enumerable: true, value: v });
	}) : function(o, v) {
	    o["default"] = v;
	});
	var __importStar$c = (commonjsGlobal && commonjsGlobal.__importStar) || function (mod) {
	    if (mod && mod.__esModule) return mod;
	    var result = {};
	    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding$c(result, mod, k);
	    __setModuleDefault$c(result, mod);
	    return result;
	};
	Object.defineProperty(bytes, "__esModule", { value: true });
	bytes.base64 = bytes.bs58 = utf8 = bytes.utf8 = bytes.hex = void 0;
	bytes.hex = __importStar$c(hex);
	var utf8 = bytes.utf8 = __importStar$c(utf8$1);
	bytes.bs58 = __importStar$c(bs58);
	bytes.base64 = __importStar$c(base64$2);

	var rpc$1 = {};

	var common$1 = {};

	Object.defineProperty(common$1, "__esModule", { value: true });
	common$1.translateAddress = common$1.validateAccounts = common$1.toInstruction = common$1.parseIdlErrors = void 0;
	const web3_js_1$b = require$$0$1;
	function parseIdlErrors(idl) {
	    const errors = new Map();
	    if (idl.errors) {
	        idl.errors.forEach((e) => {
	            var _a;
	            let msg = (_a = e.msg) !== null && _a !== void 0 ? _a : e.name;
	            errors.set(e.code, msg);
	        });
	    }
	    return errors;
	}
	common$1.parseIdlErrors = parseIdlErrors;
	// Allow either IdLInstruction or IdlStateMethod since the types share fields.
	function toInstruction(idlIx, ...args) {
	    if (idlIx.args.length != args.length) {
	        throw new Error("Invalid argument length");
	    }
	    const ix = {};
	    let idx = 0;
	    idlIx.args.forEach((ixArg) => {
	        ix[ixArg.name] = args[idx];
	        idx += 1;
	    });
	    return ix;
	}
	common$1.toInstruction = toInstruction;
	// Throws error if any account required for the `ix` is not given.
	function validateAccounts(ixAccounts, accounts = {}) {
	    ixAccounts.forEach((acc) => {
	        if ("accounts" in acc) {
	            validateAccounts(acc.accounts, accounts[acc.name]);
	        }
	        else {
	            if (accounts[acc.name] === undefined) {
	                throw new Error(`Invalid arguments: ${acc.name} not provided.`);
	            }
	        }
	    });
	}
	common$1.validateAccounts = validateAccounts;
	// Translates an address to a Pubkey.
	function translateAddress(address) {
	    return address instanceof web3_js_1$b.PublicKey ? address : new web3_js_1$b.PublicKey(address);
	}
	common$1.translateAddress = translateAddress;

	var lib$1 = {};

	Object.defineProperty(lib$1, '__esModule', { value: true });

	/**
	 * A `StructFailure` represents a single specific failure in validation.
	 */

	/**
	 * `StructError` objects are thrown (or returned) when validation fails.
	 *
	 * Validation logic is design to exit early for maximum performance. The error
	 * represents the first error encountered during validation. For more detail,
	 * the `error.failures` property is a generator function that can be run to
	 * continue validation and receive all the failures in the data.
	 */
	class StructError extends TypeError {
	  constructor(failure, failures) {
	    let cached;
	    const {
	      message,
	      ...rest
	    } = failure;
	    const {
	      path
	    } = failure;
	    const msg = path.length === 0 ? message : "At path: " + path.join('.') + " -- " + message;
	    super(msg);
	    this.value = void 0;
	    this.key = void 0;
	    this.type = void 0;
	    this.refinement = void 0;
	    this.path = void 0;
	    this.branch = void 0;
	    this.failures = void 0;
	    Object.assign(this, rest);
	    this.name = this.constructor.name;

	    this.failures = () => {
	      var _cached;

	      return (_cached = cached) != null ? _cached : cached = [failure, ...failures()];
	    };
	  }

	}

	/**
	 * Check if a value is an iterator.
	 */
	function isIterable(x) {
	  return isObject(x) && typeof x[Symbol.iterator] === 'function';
	}
	/**
	 * Check if a value is a plain object.
	 */


	function isObject(x) {
	  return typeof x === 'object' && x != null;
	}
	/**
	 * Check if a value is a plain object.
	 */

	function isPlainObject(x) {
	  if (Object.prototype.toString.call(x) !== '[object Object]') {
	    return false;
	  }

	  const prototype = Object.getPrototypeOf(x);
	  return prototype === null || prototype === Object.prototype;
	}
	/**
	 * Return a value as a printable string.
	 */

	function print(value) {
	  return typeof value === 'string' ? JSON.stringify(value) : "" + value;
	}
	/**
	 * Shifts (removes and returns) the first value from the `input` iterator.
	 * Like `Array.prototype.shift()` but for an `Iterator`.
	 */

	function shiftIterator(input) {
	  const {
	    done,
	    value
	  } = input.next();
	  return done ? undefined : value;
	}
	/**
	 * Convert a single validation result to a failure.
	 */

	function toFailure(result, context, struct, value) {
	  if (result === true) {
	    return;
	  } else if (result === false) {
	    result = {};
	  } else if (typeof result === 'string') {
	    result = {
	      message: result
	    };
	  }

	  const {
	    path,
	    branch
	  } = context;
	  const {
	    type
	  } = struct;
	  const {
	    refinement,
	    message = "Expected a value of type `" + type + "`" + (refinement ? " with refinement `" + refinement + "`" : '') + ", but received: `" + print(value) + "`"
	  } = result;
	  return {
	    value,
	    type,
	    refinement,
	    key: path[path.length - 1],
	    path,
	    branch,
	    ...result,
	    message
	  };
	}
	/**
	 * Convert a validation result to an iterable of failures.
	 */

	function* toFailures(result, context, struct, value) {
	  if (!isIterable(result)) {
	    result = [result];
	  }

	  for (const r of result) {
	    const failure = toFailure(r, context, struct, value);

	    if (failure) {
	      yield failure;
	    }
	  }
	}
	/**
	 * Check a value against a struct, traversing deeply into nested values, and
	 * returning an iterator of failures or success.
	 */

	function* run(value, struct, options) {
	  if (options === void 0) {
	    options = {};
	  }

	  const {
	    path = [],
	    branch = [value],
	    coerce = false,
	    mask = false
	  } = options;
	  const ctx = {
	    path,
	    branch
	  };

	  if (coerce) {
	    value = struct.coercer(value, ctx);

	    if (mask && struct.type !== 'type' && isObject(struct.schema) && isObject(value) && !Array.isArray(value)) {
	      for (const key in value) {
	        if (struct.schema[key] === undefined) {
	          delete value[key];
	        }
	      }
	    }
	  }

	  let valid = true;

	  for (const failure of struct.validator(value, ctx)) {
	    valid = false;
	    yield [failure, undefined];
	  }

	  for (let [k, v, s] of struct.entries(value, ctx)) {
	    const ts = run(v, s, {
	      path: k === undefined ? path : [...path, k],
	      branch: k === undefined ? branch : [...branch, v],
	      coerce,
	      mask
	    });

	    for (const t of ts) {
	      if (t[0]) {
	        valid = false;
	        yield [t[0], undefined];
	      } else if (coerce) {
	        v = t[1];

	        if (k === undefined) {
	          value = v;
	        } else if (value instanceof Map) {
	          value.set(k, v);
	        } else if (value instanceof Set) {
	          value.add(v);
	        } else if (isObject(value)) {
	          value[k] = v;
	        }
	      }
	    }
	  }

	  if (valid) {
	    for (const failure of struct.refiner(value, ctx)) {
	      valid = false;
	      yield [failure, undefined];
	    }
	  }

	  if (valid) {
	    yield [undefined, value];
	  }
	}

	/**
	 * `Struct` objects encapsulate the validation logic for a specific type of
	 * values. Once constructed, you use the `assert`, `is` or `validate` helpers to
	 * validate unknown input data against the struct.
	 */

	class Struct {
	  constructor(props) {
	    this.TYPE = void 0;
	    this.type = void 0;
	    this.schema = void 0;
	    this.coercer = void 0;
	    this.validator = void 0;
	    this.refiner = void 0;
	    this.entries = void 0;
	    const {
	      type,
	      schema,
	      validator,
	      refiner,
	      coercer = value => value,
	      entries = function* () {}
	    } = props;
	    this.type = type;
	    this.schema = schema;
	    this.entries = entries;
	    this.coercer = coercer;

	    if (validator) {
	      this.validator = (value, context) => {
	        const result = validator(value, context);
	        return toFailures(result, context, this, value);
	      };
	    } else {
	      this.validator = () => [];
	    }

	    if (refiner) {
	      this.refiner = (value, context) => {
	        const result = refiner(value, context);
	        return toFailures(result, context, this, value);
	      };
	    } else {
	      this.refiner = () => [];
	    }
	  }
	  /**
	   * Assert that a value passes the struct's validation, throwing if it doesn't.
	   */


	  assert(value) {
	    return assert$1(value, this);
	  }
	  /**
	   * Create a value with the struct's coercion logic, then validate it.
	   */


	  create(value) {
	    return create(value, this);
	  }
	  /**
	   * Check if a value passes the struct's validation.
	   */


	  is(value) {
	    return is(value, this);
	  }
	  /**
	   * Mask a value, coercing and validating it, but returning only the subset of
	   * properties defined by the struct's schema.
	   */


	  mask(value) {
	    return mask(value, this);
	  }
	  /**
	   * Validate a value with the struct's validation logic, returning a tuple
	   * representing the result.
	   *
	   * You may optionally pass `true` for the `withCoercion` argument to coerce
	   * the value before attempting to validate it. If you do, the result will
	   * contain the coerced result when successful.
	   */


	  validate(value, options) {
	    if (options === void 0) {
	      options = {};
	    }

	    return validate(value, this, options);
	  }

	}
	/**
	 * Assert that a value passes a struct, throwing if it doesn't.
	 */

	function assert$1(value, struct) {
	  const result = validate(value, struct);

	  if (result[0]) {
	    throw result[0];
	  }
	}
	/**
	 * Create a value with the coercion logic of struct and validate it.
	 */

	function create(value, struct) {
	  const result = validate(value, struct, {
	    coerce: true
	  });

	  if (result[0]) {
	    throw result[0];
	  } else {
	    return result[1];
	  }
	}
	/**
	 * Mask a value, returning only the subset of properties defined by a struct.
	 */

	function mask(value, struct) {
	  const result = validate(value, struct, {
	    coerce: true,
	    mask: true
	  });

	  if (result[0]) {
	    throw result[0];
	  } else {
	    return result[1];
	  }
	}
	/**
	 * Check if a value passes a struct.
	 */

	function is(value, struct) {
	  const result = validate(value, struct);
	  return !result[0];
	}
	/**
	 * Validate a value against a struct, returning an error if invalid, or the
	 * value (with potential coercion) if valid.
	 */

	function validate(value, struct, options) {
	  if (options === void 0) {
	    options = {};
	  }

	  const tuples = run(value, struct, options);
	  const tuple = shiftIterator(tuples);

	  if (tuple[0]) {
	    const error = new StructError(tuple[0], function* () {
	      for (const t of tuples) {
	        if (t[0]) {
	          yield t[0];
	        }
	      }
	    });
	    return [error, undefined];
	  } else {
	    const v = tuple[1];
	    return [undefined, v];
	  }
	}

	function assign() {
	  for (var _len = arguments.length, Structs = new Array(_len), _key = 0; _key < _len; _key++) {
	    Structs[_key] = arguments[_key];
	  }

	  const isType = Structs[0].type === 'type';
	  const schemas = Structs.map(s => s.schema);
	  const schema = Object.assign({}, ...schemas);
	  return isType ? type(schema) : object(schema);
	}
	/**
	 * Define a new struct type with a custom validation function.
	 */

	function define(name, validator) {
	  return new Struct({
	    type: name,
	    schema: null,
	    validator
	  });
	}
	/**
	 * Create a new struct based on an existing struct, but the value is allowed to
	 * be `undefined`. `log` will be called if the value is not `undefined`.
	 */

	function deprecated(struct, log) {
	  return new Struct({ ...struct,
	    refiner: (value, ctx) => value === undefined || struct.refiner(value, ctx),

	    validator(value, ctx) {
	      if (value === undefined) {
	        return true;
	      } else {
	        log(value, ctx);
	        return struct.validator(value, ctx);
	      }
	    }

	  });
	}
	/**
	 * Create a struct with dynamic validation logic.
	 *
	 * The callback will receive the value currently being validated, and must
	 * return a struct object to validate it with. This can be useful to model
	 * validation logic that changes based on its input.
	 */

	function dynamic(fn) {
	  return new Struct({
	    type: 'dynamic',
	    schema: null,

	    *entries(value, ctx) {
	      const struct = fn(value, ctx);
	      yield* struct.entries(value, ctx);
	    },

	    validator(value, ctx) {
	      const struct = fn(value, ctx);
	      return struct.validator(value, ctx);
	    },

	    coercer(value, ctx) {
	      const struct = fn(value, ctx);
	      return struct.coercer(value, ctx);
	    },

	    refiner(value, ctx) {
	      const struct = fn(value, ctx);
	      return struct.refiner(value, ctx);
	    }

	  });
	}
	/**
	 * Create a struct with lazily evaluated validation logic.
	 *
	 * The first time validation is run with the struct, the callback will be called
	 * and must return a struct object to use. This is useful for cases where you
	 * want to have self-referential structs for nested data structures to avoid a
	 * circular definition problem.
	 */

	function lazy(fn) {
	  let struct;
	  return new Struct({
	    type: 'lazy',
	    schema: null,

	    *entries(value, ctx) {
	      var _struct;

	      (_struct = struct) != null ? _struct : struct = fn();
	      yield* struct.entries(value, ctx);
	    },

	    validator(value, ctx) {
	      var _struct2;

	      (_struct2 = struct) != null ? _struct2 : struct = fn();
	      return struct.validator(value, ctx);
	    },

	    coercer(value, ctx) {
	      var _struct3;

	      (_struct3 = struct) != null ? _struct3 : struct = fn();
	      return struct.coercer(value, ctx);
	    },

	    refiner(value, ctx) {
	      var _struct4;

	      (_struct4 = struct) != null ? _struct4 : struct = fn();
	      return struct.refiner(value, ctx);
	    }

	  });
	}
	/**
	 * Create a new struct based on an existing object struct, but excluding
	 * specific properties.
	 *
	 * Like TypeScript's `Omit` utility.
	 */

	function omit(struct, keys) {
	  const {
	    schema
	  } = struct;
	  const subschema = { ...schema
	  };

	  for (const key of keys) {
	    delete subschema[key];
	  }

	  switch (struct.type) {
	    case 'type':
	      return type(subschema);

	    default:
	      return object(subschema);
	  }
	}
	/**
	 * Create a new struct based on an existing object struct, but with all of its
	 * properties allowed to be `undefined`.
	 *
	 * Like TypeScript's `Partial` utility.
	 */

	function partial(struct) {
	  const schema = struct instanceof Struct ? { ...struct.schema
	  } : { ...struct
	  };

	  for (const key in schema) {
	    schema[key] = optional(schema[key]);
	  }

	  return object(schema);
	}
	/**
	 * Create a new struct based on an existing object struct, but only including
	 * specific properties.
	 *
	 * Like TypeScript's `Pick` utility.
	 */

	function pick(struct, keys) {
	  const {
	    schema
	  } = struct;
	  const subschema = {};

	  for (const key of keys) {
	    subschema[key] = schema[key];
	  }

	  return object(subschema);
	}
	/**
	 * Define a new struct type with a custom validation function.
	 *
	 * @deprecated This function has been renamed to `define`.
	 */

	function struct(name, validator) {
	  console.warn('superstruct@0.11 - The `struct` helper has been renamed to `define`.');
	  return define(name, validator);
	}

	/**
	 * Ensure that any value passes validation.
	 */

	function any() {
	  return define('any', () => true);
	}
	function array(Element) {
	  return new Struct({
	    type: 'array',
	    schema: Element,

	    *entries(value) {
	      if (Element && Array.isArray(value)) {
	        for (const [i, v] of value.entries()) {
	          yield [i, v, Element];
	        }
	      }
	    },

	    coercer(value) {
	      return Array.isArray(value) ? value.slice() : value;
	    },

	    validator(value) {
	      return Array.isArray(value) || "Expected an array value, but received: " + print(value);
	    }

	  });
	}
	/**
	 * Ensure that a value is a bigint.
	 */

	function bigint() {
	  return define('bigint', value => {
	    return typeof value === 'bigint';
	  });
	}
	/**
	 * Ensure that a value is a boolean.
	 */

	function boolean() {
	  return define('boolean', value => {
	    return typeof value === 'boolean';
	  });
	}
	/**
	 * Ensure that a value is a valid `Date`.
	 *
	 * Note: this also ensures that the value is *not* an invalid `Date` object,
	 * which can occur when parsing a date fails but still returns a `Date`.
	 */

	function date() {
	  return define('date', value => {
	    return value instanceof Date && !isNaN(value.getTime()) || "Expected a valid `Date` object, but received: " + print(value);
	  });
	}
	function enums(values) {
	  const schema = {};
	  const description = values.map(v => print(v)).join();

	  for (const key of values) {
	    schema[key] = key;
	  }

	  return new Struct({
	    type: 'enums',
	    schema,

	    validator(value) {
	      return values.includes(value) || "Expected one of `" + description + "`, but received: " + print(value);
	    }

	  });
	}
	/**
	 * Ensure that a value is a function.
	 */

	function func() {
	  return define('func', value => {
	    return typeof value === 'function' || "Expected a function, but received: " + print(value);
	  });
	}
	/**
	 * Ensure that a value is an instance of a specific class.
	 */

	function instance(Class) {
	  return define('instance', value => {
	    return value instanceof Class || "Expected a `" + Class.name + "` instance, but received: " + print(value);
	  });
	}
	/**
	 * Ensure that a value is an integer.
	 */

	function integer() {
	  return define('integer', value => {
	    return typeof value === 'number' && !isNaN(value) && Number.isInteger(value) || "Expected an integer, but received: " + print(value);
	  });
	}
	/**
	 * Ensure that a value matches all of a set of types.
	 */

	function intersection(Structs) {
	  return new Struct({
	    type: 'intersection',
	    schema: null,

	    *entries(value, ctx) {
	      for (const S of Structs) {
	        yield* S.entries(value, ctx);
	      }
	    },

	    *validator(value, ctx) {
	      for (const S of Structs) {
	        yield* S.validator(value, ctx);
	      }
	    },

	    *refiner(value, ctx) {
	      for (const S of Structs) {
	        yield* S.refiner(value, ctx);
	      }
	    }

	  });
	}
	function literal(constant) {
	  const description = print(constant);
	  const t = typeof constant;
	  return new Struct({
	    type: 'literal',
	    schema: t === 'string' || t === 'number' || t === 'boolean' ? constant : null,

	    validator(value) {
	      return value === constant || "Expected the literal `" + description + "`, but received: " + print(value);
	    }

	  });
	}
	function map(Key, Value) {
	  return new Struct({
	    type: 'map',
	    schema: null,

	    *entries(value) {
	      if (Key && Value && value instanceof Map) {
	        for (const [k, v] of value.entries()) {
	          yield [k, k, Key];
	          yield [k, v, Value];
	        }
	      }
	    },

	    coercer(value) {
	      return value instanceof Map ? new Map(value) : value;
	    },

	    validator(value) {
	      return value instanceof Map || "Expected a `Map` object, but received: " + print(value);
	    }

	  });
	}
	/**
	 * Ensure that no value ever passes validation.
	 */

	function never() {
	  return define('never', () => false);
	}
	/**
	 * Augment an existing struct to allow `null` values.
	 */

	function nullable(struct) {
	  return new Struct({ ...struct,
	    validator: (value, ctx) => value === null || struct.validator(value, ctx),
	    refiner: (value, ctx) => value === null || struct.refiner(value, ctx)
	  });
	}
	/**
	 * Ensure that a value is a number.
	 */

	function number() {
	  return define('number', value => {
	    return typeof value === 'number' && !isNaN(value) || "Expected a number, but received: " + print(value);
	  });
	}
	function object(schema) {
	  const knowns = schema ? Object.keys(schema) : [];
	  const Never = never();
	  return new Struct({
	    type: 'object',
	    schema: schema ? schema : null,

	    *entries(value) {
	      if (schema && isObject(value)) {
	        const unknowns = new Set(Object.keys(value));

	        for (const key of knowns) {
	          unknowns.delete(key);
	          yield [key, value[key], schema[key]];
	        }

	        for (const key of unknowns) {
	          yield [key, value[key], Never];
	        }
	      }
	    },

	    validator(value) {
	      return isObject(value) || "Expected an object, but received: " + print(value);
	    },

	    coercer(value) {
	      return isObject(value) ? { ...value
	      } : value;
	    }

	  });
	}
	/**
	 * Augment a struct to allow `undefined` values.
	 */

	function optional(struct) {
	  return new Struct({ ...struct,
	    validator: (value, ctx) => value === undefined || struct.validator(value, ctx),
	    refiner: (value, ctx) => value === undefined || struct.refiner(value, ctx)
	  });
	}
	/**
	 * Ensure that a value is an object with keys and values of specific types, but
	 * without ensuring any specific shape of properties.
	 *
	 * Like TypeScript's `Record` utility.
	 */

	function record(Key, Value) {
	  return new Struct({
	    type: 'record',
	    schema: null,

	    *entries(value) {
	      if (isObject(value)) {
	        for (const k in value) {
	          const v = value[k];
	          yield [k, k, Key];
	          yield [k, v, Value];
	        }
	      }
	    },

	    validator(value) {
	      return isObject(value) || "Expected an object, but received: " + print(value);
	    }

	  });
	}
	/**
	 * Ensure that a value is a `RegExp`.
	 *
	 * Note: this does not test the value against the regular expression! For that
	 * you need to use the `pattern()` refinement.
	 */

	function regexp() {
	  return define('regexp', value => {
	    return value instanceof RegExp;
	  });
	}
	function set$1(Element) {
	  return new Struct({
	    type: 'set',
	    schema: null,

	    *entries(value) {
	      if (Element && value instanceof Set) {
	        for (const v of value) {
	          yield [v, v, Element];
	        }
	      }
	    },

	    coercer(value) {
	      return value instanceof Set ? new Set(value) : value;
	    },

	    validator(value) {
	      return value instanceof Set || "Expected a `Set` object, but received: " + print(value);
	    }

	  });
	}
	/**
	 * Ensure that a value is a string.
	 */

	function string() {
	  return define('string', value => {
	    return typeof value === 'string' || "Expected a string, but received: " + print(value);
	  });
	}
	/**
	 * Ensure that a value is a tuple of a specific length, and that each of its
	 * elements is of a specific type.
	 */

	function tuple(Structs) {
	  const Never = never();
	  return new Struct({
	    type: 'tuple',
	    schema: null,

	    *entries(value) {
	      if (Array.isArray(value)) {
	        const length = Math.max(Structs.length, value.length);

	        for (let i = 0; i < length; i++) {
	          yield [i, value[i], Structs[i] || Never];
	        }
	      }
	    },

	    validator(value) {
	      return Array.isArray(value) || "Expected an array, but received: " + print(value);
	    }

	  });
	}
	/**
	 * Ensure that a value has a set of known properties of specific types.
	 *
	 * Note: Unrecognized properties are allowed and untouched. This is similar to
	 * how TypeScript's structural typing works.
	 */

	function type(schema) {
	  const keys = Object.keys(schema);
	  return new Struct({
	    type: 'type',
	    schema,

	    *entries(value) {
	      if (isObject(value)) {
	        for (const k of keys) {
	          yield [k, value[k], schema[k]];
	        }
	      }
	    },

	    validator(value) {
	      return isObject(value) || "Expected an object, but received: " + print(value);
	    }

	  });
	}
	/**
	 * Ensure that a value matches one of a set of types.
	 */

	function union(Structs) {
	  const description = Structs.map(s => s.type).join(' | ');
	  return new Struct({
	    type: 'union',
	    schema: null,

	    coercer(value, ctx) {
	      const firstMatch = Structs.find(s => {
	        const [e] = s.validate(value, {
	          coerce: true
	        });
	        return !e;
	      }) || unknown();
	      return firstMatch.coercer(value, ctx);
	    },

	    validator(value, ctx) {
	      const failures = [];

	      for (const S of Structs) {
	        const [...tuples] = run(value, S, ctx);
	        const [first] = tuples;

	        if (!first[0]) {
	          return [];
	        } else {
	          for (const [failure] of tuples) {
	            if (failure) {
	              failures.push(failure);
	            }
	          }
	        }
	      }

	      return ["Expected the value to satisfy a union of `" + description + "`, but received: " + print(value), ...failures];
	    }

	  });
	}
	/**
	 * Ensure that any value passes validation, without widening its type to `any`.
	 */

	function unknown() {
	  return define('unknown', () => true);
	}

	/**
	 * Augment a `Struct` to add an additional coercion step to its input.
	 *
	 * This allows you to transform input data before validating it, to increase the
	 * likelihood that it passes validation—for example for default values, parsing
	 * different formats, etc.
	 *
	 * Note: You must use `create(value, Struct)` on the value to have the coercion
	 * take effect! Using simply `assert()` or `is()` will not use coercion.
	 */

	function coerce(struct, condition, coercer) {
	  return new Struct({ ...struct,
	    coercer: (value, ctx) => {
	      return is(value, condition) ? struct.coercer(coercer(value, ctx), ctx) : struct.coercer(value, ctx);
	    }
	  });
	}
	/**
	 * Augment a struct to replace `undefined` values with a default.
	 *
	 * Note: You must use `create(value, Struct)` on the value to have the coercion
	 * take effect! Using simply `assert()` or `is()` will not use coercion.
	 */

	function defaulted(struct, fallback, options) {
	  if (options === void 0) {
	    options = {};
	  }

	  return coerce(struct, unknown(), x => {
	    const f = typeof fallback === 'function' ? fallback() : fallback;

	    if (x === undefined) {
	      return f;
	    }

	    if (!options.strict && isPlainObject(x) && isPlainObject(f)) {
	      const ret = { ...x
	      };
	      let changed = false;

	      for (const key in f) {
	        if (ret[key] === undefined) {
	          ret[key] = f[key];
	          changed = true;
	        }
	      }

	      if (changed) {
	        return ret;
	      }
	    }

	    return x;
	  });
	}
	/**
	 * Augment a struct to trim string inputs.
	 *
	 * Note: You must use `create(value, Struct)` on the value to have the coercion
	 * take effect! Using simply `assert()` or `is()` will not use coercion.
	 */

	function trimmed(struct) {
	  return coerce(struct, string(), x => x.trim());
	}

	/**
	 * Ensure that a string, array, map, or set is empty.
	 */

	function empty(struct) {
	  return refine(struct, 'empty', value => {
	    const size = getSize(value);
	    return size === 0 || "Expected an empty " + struct.type + " but received one with a size of `" + size + "`";
	  });
	}

	function getSize(value) {
	  if (value instanceof Map || value instanceof Set) {
	    return value.size;
	  } else {
	    return value.length;
	  }
	}
	/**
	 * Ensure that a number or date is below a threshold.
	 */


	function max(struct, threshold, options) {
	  if (options === void 0) {
	    options = {};
	  }

	  const {
	    exclusive
	  } = options;
	  return refine(struct, 'max', value => {
	    return exclusive ? value < threshold : value <= threshold || "Expected a " + struct.type + " less than " + (exclusive ? '' : 'or equal to ') + threshold + " but received `" + value + "`";
	  });
	}
	/**
	 * Ensure that a number or date is above a threshold.
	 */

	function min(struct, threshold, options) {
	  if (options === void 0) {
	    options = {};
	  }

	  const {
	    exclusive
	  } = options;
	  return refine(struct, 'min', value => {
	    return exclusive ? value > threshold : value >= threshold || "Expected a " + struct.type + " greater than " + (exclusive ? '' : 'or equal to ') + threshold + " but received `" + value + "`";
	  });
	}
	/**
	 * Ensure that a string, array, map or set is not empty.
	 */

	function nonempty(struct) {
	  return refine(struct, 'nonempty', value => {
	    const size = getSize(value);
	    return size > 0 || "Expected a nonempty " + struct.type + " but received an empty one";
	  });
	}
	/**
	 * Ensure that a string matches a regular expression.
	 */

	function pattern(struct, regexp) {
	  return refine(struct, 'pattern', value => {
	    return regexp.test(value) || "Expected a " + struct.type + " matching `/" + regexp.source + "/` but received \"" + value + "\"";
	  });
	}
	/**
	 * Ensure that a string, array, number, date, map, or set has a size (or length, or time) between `min` and `max`.
	 */

	function size(struct, min, max) {
	  if (max === void 0) {
	    max = min;
	  }

	  const expected = "Expected a " + struct.type;
	  const of = min === max ? "of `" + min + "`" : "between `" + min + "` and `" + max + "`";
	  return refine(struct, 'size', value => {
	    if (typeof value === 'number' || value instanceof Date) {
	      return min <= value && value <= max || expected + " " + of + " but received `" + value + "`";
	    } else if (value instanceof Map || value instanceof Set) {
	      const {
	        size
	      } = value;
	      return min <= size && size <= max || expected + " with a size " + of + " but received one with a size of `" + size + "`";
	    } else {
	      const {
	        length
	      } = value;
	      return min <= length && length <= max || expected + " with a length " + of + " but received one with a length of `" + length + "`";
	    }
	  });
	}
	/**
	 * Augment a `Struct` to add an additional refinement to the validation.
	 *
	 * The refiner function is guaranteed to receive a value of the struct's type,
	 * because the struct's existing validation will already have passed. This
	 * allows you to layer additional validation on top of existing structs.
	 */

	function refine(struct, name, refiner) {
	  return new Struct({ ...struct,

	    *refiner(value, ctx) {
	      yield* struct.refiner(value, ctx);
	      const result = refiner(value, ctx);
	      const failures = toFailures(result, ctx, struct, value);

	      for (const failure of failures) {
	        yield { ...failure,
	          refinement: name
	        };
	      }
	    }

	  });
	}

	lib$1.Struct = Struct;
	lib$1.StructError = StructError;
	lib$1.any = any;
	lib$1.array = array;
	lib$1.assert = assert$1;
	lib$1.assign = assign;
	lib$1.bigint = bigint;
	lib$1.boolean = boolean;
	lib$1.coerce = coerce;
	lib$1.create = create;
	lib$1.date = date;
	lib$1.defaulted = defaulted;
	lib$1.define = define;
	lib$1.deprecated = deprecated;
	lib$1.dynamic = dynamic;
	lib$1.empty = empty;
	lib$1.enums = enums;
	lib$1.func = func;
	lib$1.instance = instance;
	lib$1.integer = integer;
	lib$1.intersection = intersection;
	lib$1.is = is;
	lib$1.lazy = lazy;
	lib$1.literal = literal;
	lib$1.map = map;
	lib$1.mask = mask;
	lib$1.max = max;
	lib$1.min = min;
	lib$1.never = never;
	lib$1.nonempty = nonempty;
	lib$1.nullable = nullable;
	lib$1.number = number;
	lib$1.object = object;
	lib$1.omit = omit;
	lib$1.optional = optional;
	lib$1.partial = partial;
	lib$1.pattern = pattern;
	lib$1.pick = pick;
	lib$1.record = record;
	lib$1.refine = refine;
	lib$1.regexp = regexp;
	lib$1.set = set$1;
	lib$1.size = size;
	lib$1.string = string;
	lib$1.struct = struct;
	lib$1.trimmed = trimmed;
	lib$1.tuple = tuple;
	lib$1.type = type;
	lib$1.union = union;
	lib$1.unknown = unknown;
	lib$1.validate = validate;

	var hasRequiredRpc;

	function requireRpc () {
		if (hasRequiredRpc) return rpc$1;
		hasRequiredRpc = 1;
		Object.defineProperty(rpc$1, "__esModule", { value: true });
		rpc$1.simulateTransaction = rpc$1.getMultipleAccounts = rpc$1.invoke = void 0;
		const web3_js_1 = require$$0$1;
		const common_js_1 = common$2;
		const common_js_2 = common$1;
		const provider_js_1 = requireProvider();
		const superstruct_1 = lib$1;
		/**
		 * Sends a transaction to a program with the given accounts and instruction
		 * data.
		 */
		async function invoke(programId, accounts, data, provider) {
		    programId = (0, common_js_2.translateAddress)(programId);
		    if (!provider) {
		        provider = (0, provider_js_1.getProvider)();
		    }
		    const tx = new web3_js_1.Transaction();
		    tx.add(new web3_js_1.TransactionInstruction({
		        programId,
		        keys: accounts !== null && accounts !== void 0 ? accounts : [],
		        data,
		    }));
		    if (provider.sendAndConfirm === undefined) {
		        throw new Error("This function requires 'Provider.sendAndConfirm' to be implemented.");
		    }
		    return await provider.sendAndConfirm(tx, []);
		}
		rpc$1.invoke = invoke;
		const GET_MULTIPLE_ACCOUNTS_LIMIT = 99;
		async function getMultipleAccounts(connection, publicKeys, commitment) {
		    if (publicKeys.length <= GET_MULTIPLE_ACCOUNTS_LIMIT) {
		        return await getMultipleAccountsCore(connection, publicKeys, commitment);
		    }
		    else {
		        const batches = (0, common_js_1.chunks)(publicKeys, GET_MULTIPLE_ACCOUNTS_LIMIT);
		        const results = await Promise.all(batches.map((batch) => getMultipleAccountsCore(connection, batch, commitment)));
		        return results.flat();
		    }
		}
		rpc$1.getMultipleAccounts = getMultipleAccounts;
		async function getMultipleAccountsCore(connection, publicKeys, commitmentOverride) {
		    const commitment = commitmentOverride !== null && commitmentOverride !== void 0 ? commitmentOverride : connection.commitment;
		    const accounts = await connection.getMultipleAccountsInfo(publicKeys, commitment);
		    return accounts.map((account, idx) => {
		        if (account === null) {
		            return null;
		        }
		        return {
		            publicKey: publicKeys[idx],
		            account,
		        };
		    });
		}
		// copy from @solana/web3.js that has a commitment param
		async function simulateTransaction(connection, transaction, signers, commitment, includeAccounts) {
		    if (signers && signers.length > 0) {
		        transaction.sign(...signers);
		    }
		    // @ts-expect-error
		    const message = transaction._compile();
		    const signData = message.serialize();
		    // @ts-expect-error
		    const wireTransaction = transaction._serialize(signData);
		    const encodedTransaction = wireTransaction.toString("base64");
		    const config = {
		        encoding: "base64",
		        commitment: commitment !== null && commitment !== void 0 ? commitment : connection.commitment,
		    };
		    if (includeAccounts) {
		        const addresses = (Array.isArray(includeAccounts) ? includeAccounts : message.nonProgramIds()).map((key) => key.toBase58());
		        config["accounts"] = {
		            encoding: "base64",
		            addresses,
		        };
		    }
		    if (signers) {
		        config.sigVerify = true;
		    }
		    const args = [encodedTransaction, config];
		    // @ts-expect-error
		    const unsafeRes = await connection._rpcRequest("simulateTransaction", args);
		    const res = (0, superstruct_1.create)(unsafeRes, SimulatedTransactionResponseStruct);
		    if ("error" in res) {
		        let logs;
		        if ("data" in res.error) {
		            logs = res.error.data.logs;
		            if (logs && Array.isArray(logs)) {
		                const traceIndent = "\n    ";
		                const logTrace = traceIndent + logs.join(traceIndent);
		                console.error(res.error.message, logTrace);
		            }
		        }
		        throw new web3_js_1.SendTransactionError("failed to simulate transaction: " + res.error.message, logs);
		    }
		    return res.result;
		}
		rpc$1.simulateTransaction = simulateTransaction;
		// copy from @solana/web3.js
		function jsonRpcResult(schema) {
		    return (0, superstruct_1.coerce)(createRpcResult(schema), UnknownRpcResult, (value) => {
		        if ("error" in value) {
		            return value;
		        }
		        else {
		            return {
		                ...value,
		                result: (0, superstruct_1.create)(value.result, schema),
		            };
		        }
		    });
		}
		// copy from @solana/web3.js
		const UnknownRpcResult = createRpcResult((0, superstruct_1.unknown)());
		// copy from @solana/web3.js
		function createRpcResult(result) {
		    return (0, superstruct_1.union)([
		        (0, superstruct_1.type)({
		            jsonrpc: (0, superstruct_1.literal)("2.0"),
		            id: (0, superstruct_1.string)(),
		            result,
		        }),
		        (0, superstruct_1.type)({
		            jsonrpc: (0, superstruct_1.literal)("2.0"),
		            id: (0, superstruct_1.string)(),
		            error: (0, superstruct_1.type)({
		                code: (0, superstruct_1.unknown)(),
		                message: (0, superstruct_1.string)(),
		                data: (0, superstruct_1.optional)((0, superstruct_1.any)()),
		            }),
		        }),
		    ]);
		}
		// copy from @solana/web3.js
		function jsonRpcResultAndContext(value) {
		    return jsonRpcResult((0, superstruct_1.type)({
		        context: (0, superstruct_1.type)({
		            slot: (0, superstruct_1.number)(),
		        }),
		        value,
		    }));
		}
		// copy from @solana/web3.js
		const SimulatedTransactionResponseStruct = jsonRpcResultAndContext((0, superstruct_1.type)({
		    err: (0, superstruct_1.nullable)((0, superstruct_1.union)([(0, superstruct_1.type)({}), (0, superstruct_1.string)()])),
		    logs: (0, superstruct_1.nullable)((0, superstruct_1.array)((0, superstruct_1.string)())),
		    accounts: (0, superstruct_1.optional)((0, superstruct_1.nullable)((0, superstruct_1.array)((0, superstruct_1.nullable)((0, superstruct_1.type)({
		        executable: (0, superstruct_1.boolean)(),
		        owner: (0, superstruct_1.string)(),
		        lamports: (0, superstruct_1.number)(),
		        data: (0, superstruct_1.array)((0, superstruct_1.string)()),
		        rentEpoch: (0, superstruct_1.optional)((0, superstruct_1.number)()),
		    }))))),
		    unitsConsumed: (0, superstruct_1.optional)((0, superstruct_1.number)()),
		}));
		
		return rpc$1;
	}

	var nodewallet = {};

	Object.defineProperty(nodewallet, "__esModule", { value: true });
	const buffer_1$5 = require$$0;
	const web3_js_1$a = require$$0$1;
	/**
	 * Node only wallet.
	 */
	class NodeWallet {
	    constructor(payer) {
	        this.payer = payer;
	    }
	    static local() {
	        const process = require$$2$1;
	        if (!process.env.ANCHOR_WALLET || process.env.ANCHOR_WALLET === "") {
	            throw new Error("expected environment variable `ANCHOR_WALLET` is not set.");
	        }
	        const payer = web3_js_1$a.Keypair.fromSecretKey(buffer_1$5.Buffer.from(JSON.parse(require$$3$1.readFileSync(process.env.ANCHOR_WALLET, {
	            encoding: "utf-8",
	        }))));
	        return new NodeWallet(payer);
	    }
	    async signTransaction(tx) {
	        tx.partialSign(this.payer);
	        return tx;
	    }
	    async signAllTransactions(txs) {
	        return txs.map((t) => {
	            t.partialSign(this.payer);
	            return t;
	        });
	    }
	    get publicKey() {
	        return this.payer.publicKey;
	    }
	}
	var _default = nodewallet.default = NodeWallet;

	var hasRequiredProvider;

	function requireProvider () {
		if (hasRequiredProvider) return provider;
		hasRequiredProvider = 1;
		Object.defineProperty(provider, "__esModule", { value: true });
		provider.getProvider = provider.setProvider = provider.AnchorProvider = void 0;
		const web3_js_1 = require$$0$1;
		const index_js_1 = bytes;
		const common_js_1 = common$2;
		const rpc_js_1 = requireRpc();
		/**
		 * The network and wallet context used to send transactions paid for and signed
		 * by the provider.
		 */
		class AnchorProvider {
		    /**
		     * @param connection The cluster connection where the program is deployed.
		     * @param wallet     The wallet used to pay for and sign all transactions.
		     * @param opts       Transaction confirmation options to use by default.
		     */
		    constructor(connection, wallet, opts) {
		        this.connection = connection;
		        this.wallet = wallet;
		        this.opts = opts;
		        this.publicKey = wallet.publicKey;
		    }
		    static defaultOptions() {
		        return {
		            preflightCommitment: "processed",
		            commitment: "processed",
		        };
		    }
		    /**
		     * Returns a `Provider` with a wallet read from the local filesystem.
		     *
		     * @param url  The network cluster url.
		     * @param opts The default transaction confirmation options.
		     *
		     * (This api is for Node only.)
		     */
		    static local(url, opts) {
		        if (common_js_1.isBrowser) {
		            throw new Error(`Provider local is not available on browser.`);
		        }
		        opts = opts !== null && opts !== void 0 ? opts : AnchorProvider.defaultOptions();
		        const connection = new web3_js_1.Connection(url !== null && url !== void 0 ? url : "http://localhost:8899", opts.preflightCommitment);
		        const NodeWallet = nodewallet.default;
		        const wallet = NodeWallet.local();
		        return new AnchorProvider(connection, wallet, opts);
		    }
		    /**
		     * Returns a `Provider` read from the `ANCHOR_PROVIDER_URL` environment
		     * variable
		     *
		     * (This api is for Node only.)
		     */
		    static env() {
		        if (common_js_1.isBrowser) {
		            throw new Error(`Provider env is not available on browser.`);
		        }
		        const process = require$$2$1;
		        const url = process.env.ANCHOR_PROVIDER_URL;
		        if (url === undefined) {
		            throw new Error("ANCHOR_PROVIDER_URL is not defined");
		        }
		        const options = AnchorProvider.defaultOptions();
		        const connection = new web3_js_1.Connection(url, options.commitment);
		        const NodeWallet = nodewallet.default;
		        const wallet = NodeWallet.local();
		        return new AnchorProvider(connection, wallet, options);
		    }
		    /**
		     * Sends the given transaction, paid for and signed by the provider's wallet.
		     *
		     * @param tx      The transaction to send.
		     * @param signers The signers of the transaction.
		     * @param opts    Transaction confirmation options.
		     */
		    async sendAndConfirm(tx, signers, opts) {
		        var _a;
		        if (opts === undefined) {
		            opts = this.opts;
		        }
		        tx.feePayer = this.wallet.publicKey;
		        tx.recentBlockhash = (await this.connection.getRecentBlockhash(opts.preflightCommitment)).blockhash;
		        tx = await this.wallet.signTransaction(tx);
		        (signers !== null && signers !== void 0 ? signers : []).forEach((kp) => {
		            tx.partialSign(kp);
		        });
		        const rawTx = tx.serialize();
		        try {
		            return await sendAndConfirmRawTransaction(this.connection, rawTx, opts);
		        }
		        catch (err) {
		            // thrown if the underlying 'confirmTransaction' encounters a failed tx
		            // the 'confirmTransaction' error does not return logs so we make another rpc call to get them
		            if (err instanceof ConfirmError) {
		                // choose the shortest available commitment for 'getTransaction'
		                // (the json RPC does not support any shorter than "confirmed" for 'getTransaction')
		                // because that will see the tx sent with `sendAndConfirmRawTransaction` no matter which
		                // commitment `sendAndConfirmRawTransaction` used
		                const failedTx = await this.connection.getTransaction(index_js_1.bs58.encode(tx.signature), { commitment: "confirmed" });
		                if (!failedTx) {
		                    throw err;
		                }
		                else {
		                    const logs = (_a = failedTx.meta) === null || _a === void 0 ? void 0 : _a.logMessages;
		                    throw !logs ? err : new web3_js_1.SendTransactionError(err.message, logs);
		                }
		            }
		            else {
		                throw err;
		            }
		        }
		    }
		    /**
		     * Similar to `send`, but for an array of transactions and signers.
		     */
		    async sendAll(txWithSigners, opts) {
		        if (opts === undefined) {
		            opts = this.opts;
		        }
		        const blockhash = await this.connection.getRecentBlockhash(opts.preflightCommitment);
		        let txs = txWithSigners.map((r) => {
		            var _a;
		            let tx = r.tx;
		            let signers = (_a = r.signers) !== null && _a !== void 0 ? _a : [];
		            tx.feePayer = this.wallet.publicKey;
		            tx.recentBlockhash = blockhash.blockhash;
		            signers.forEach((kp) => {
		                tx.partialSign(kp);
		            });
		            return tx;
		        });
		        const signedTxs = await this.wallet.signAllTransactions(txs);
		        const sigs = [];
		        for (let k = 0; k < txs.length; k += 1) {
		            const tx = signedTxs[k];
		            const rawTx = tx.serialize();
		            sigs.push(await sendAndConfirmRawTransaction(this.connection, rawTx, opts));
		        }
		        return sigs;
		    }
		    /**
		     * Simulates the given transaction, returning emitted logs from execution.
		     *
		     * @param tx      The transaction to send.
		     * @param signers The signers of the transaction.
		     * @param opts    Transaction confirmation options.
		     */
		    async simulate(tx, signers, commitment, includeAccounts) {
		        tx.feePayer = this.wallet.publicKey;
		        tx.recentBlockhash = (await this.connection.getLatestBlockhash(commitment !== null && commitment !== void 0 ? commitment : this.connection.commitment)).blockhash;
		        tx = await this.wallet.signTransaction(tx);
		        const result = await (0, rpc_js_1.simulateTransaction)(this.connection, tx, signers, commitment, includeAccounts);
		        if (result.value.err) {
		            throw new SimulateError(result.value);
		        }
		        return result.value;
		    }
		}
		provider.AnchorProvider = AnchorProvider;
		class SimulateError extends Error {
		    constructor(simulationResponse, message) {
		        super(message);
		        this.simulationResponse = simulationResponse;
		    }
		}
		// Copy of Connection.sendAndConfirmRawTransaction that throws
		// a better error if 'confirmTransaction` returns an error status
		async function sendAndConfirmRawTransaction(connection, rawTransaction, options) {
		    const sendOptions = options && {
		        skipPreflight: options.skipPreflight,
		        preflightCommitment: options.preflightCommitment || options.commitment,
		    };
		    const signature = await connection.sendRawTransaction(rawTransaction, sendOptions);
		    const status = (await connection.confirmTransaction(signature, options && options.commitment)).value;
		    if (status.err) {
		        throw new ConfirmError(`Raw transaction ${signature} failed (${JSON.stringify(status)})`);
		    }
		    return signature;
		}
		class ConfirmError extends Error {
		    constructor(message) {
		        super(message);
		    }
		}
		/**
		 * Sets the default provider on the client.
		 */
		function setProvider(provider) {
		    _provider = provider;
		}
		provider.setProvider = setProvider;
		/**
		 * Returns the default provider being used by the client.
		 */
		function getProvider() {
		    if (_provider === null) {
		        return AnchorProvider.local();
		    }
		    return _provider;
		}
		provider.getProvider = getProvider;
		// Global provider used as the default when a provider is not given.
		let _provider = null;
		
		return provider;
	}

	var idl$1 = {};

	var lib = {};

	var Layout$1 = {};

	/* The MIT License (MIT)
	 *
	 * Copyright 2015-2018 Peter A. Bigot
	 *
	 * Permission is hereby granted, free of charge, to any person obtaining a copy
	 * of this software and associated documentation files (the "Software"), to deal
	 * in the Software without restriction, including without limitation the rights
	 * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
	 * copies of the Software, and to permit persons to whom the Software is
	 * furnished to do so, subject to the following conditions:
	 *
	 * The above copyright notice and this permission notice shall be included in
	 * all copies or substantial portions of the Software.
	 *
	 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
	 * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
	 * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
	 * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
	 * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
	 * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
	 * THE SOFTWARE.
	 */

	/**
	 * Base class for layout objects.
	 *
	 * **NOTE** This is an abstract base class; you can create instances
	 * if it amuses you, but they won't support the {@link
	 * Layout#encode|encode} or {@link Layout#decode|decode} functions.
	 *
	 * @param {Number} span - Initializer for {@link Layout#span|span}.  The
	 * parameter must be an integer; a negative value signifies that the
	 * span is {@link Layout#getSpan|value-specific}.
	 *
	 * @param {string} [property] - Initializer for {@link
	 * Layout#property|property}.
	 *
	 * @abstract
	 */
	class Layout {
	  constructor(span, property) {
	    if (!Number.isInteger(span)) {
	      throw new TypeError('span must be an integer');
	    }

	    /** The span of the layout in bytes.
	     *
	     * Positive values are generally expected.
	     *
	     * Zero will only appear in {@link Constant}s and in {@link
	     * Sequence}s where the {@link Sequence#count|count} is zero.
	     *
	     * A negative value indicates that the span is value-specific, and
	     * must be obtained using {@link Layout#getSpan|getSpan}. */
	    this.span = span;

	    /** The property name used when this layout is represented in an
	     * Object.
	     *
	     * Used only for layouts that {@link Layout#decode|decode} to Object
	     * instances.  If left undefined the span of the unnamed layout will
	     * be treated as padding: it will not be mutated by {@link
	     * Layout#encode|encode} nor represented as a property in the
	     * decoded Object. */
	    this.property = property;
	  }

	  /** Function to create an Object into which decoded properties will
	   * be written.
	   *
	   * Used only for layouts that {@link Layout#decode|decode} to Object
	   * instances, which means:
	   * * {@link Structure}
	   * * {@link Union}
	   * * {@link VariantLayout}
	   * * {@link BitStructure}
	   *
	   * If left undefined the JavaScript representation of these layouts
	   * will be Object instances.
	   *
	   * See {@link bindConstructorLayout}.
	   */
	  makeDestinationObject() {
	    return {};
	  }

	  /**
	   * Decode from a Buffer into an JavaScript value.
	   *
	   * @param {Buffer} b - the buffer from which encoded data is read.
	   *
	   * @param {Number} [offset] - the offset at which the encoded data
	   * starts.  If absent a zero offset is inferred.
	   *
	   * @returns {(Number|Array|Object)} - the value of the decoded data.
	   *
	   * @abstract
	   */
	  decode(b, offset) {
	    throw new Error('Layout is abstract');
	  }

	  /**
	   * Encode a JavaScript value into a Buffer.
	   *
	   * @param {(Number|Array|Object)} src - the value to be encoded into
	   * the buffer.  The type accepted depends on the (sub-)type of {@link
	   * Layout}.
	   *
	   * @param {Buffer} b - the buffer into which encoded data will be
	   * written.
	   *
	   * @param {Number} [offset] - the offset at which the encoded data
	   * starts.  If absent a zero offset is inferred.
	   *
	   * @returns {Number} - the number of bytes encoded, including the
	   * space skipped for internal padding, but excluding data such as
	   * {@link Sequence#count|lengths} when stored {@link
	   * ExternalLayout|externally}.  This is the adjustment to `offset`
	   * producing the offset where data for the next layout would be
	   * written.
	   *
	   * @abstract
	   */
	  encode(src, b, offset) {
	    throw new Error('Layout is abstract');
	  }

	  /**
	   * Calculate the span of a specific instance of a layout.
	   *
	   * @param {Buffer} b - the buffer that contains an encoded instance.
	   *
	   * @param {Number} [offset] - the offset at which the encoded instance
	   * starts.  If absent a zero offset is inferred.
	   *
	   * @return {Number} - the number of bytes covered by the layout
	   * instance.  If this method is not overridden in a subclass the
	   * definition-time constant {@link Layout#span|span} will be
	   * returned.
	   *
	   * @throws {RangeError} - if the length of the value cannot be
	   * determined.
	   */
	  getSpan(b, offset) {
	    if (0 > this.span) {
	      throw new RangeError('indeterminate span');
	    }
	    return this.span;
	  }

	  /**
	   * Replicate the layout using a new property.
	   *
	   * This function must be used to get a structurally-equivalent layout
	   * with a different name since all {@link Layout} instances are
	   * immutable.
	   *
	   * **NOTE** This is a shallow copy.  All fields except {@link
	   * Layout#property|property} are strictly equal to the origin layout.
	   *
	   * @param {String} property - the value for {@link
	   * Layout#property|property} in the replica.
	   *
	   * @returns {Layout} - the copy with {@link Layout#property|property}
	   * set to `property`.
	   */
	  replicate(property) {
	    const rv = Object.create(this.constructor.prototype);
	    Object.assign(rv, this);
	    rv.property = property;
	    return rv;
	  }

	  /**
	   * Create an object from layout properties and an array of values.
	   *
	   * **NOTE** This function returns `undefined` if invoked on a layout
	   * that does not return its value as an Object.  Objects are
	   * returned for things that are a {@link Structure}, which includes
	   * {@link VariantLayout|variant layouts} if they are structures, and
	   * excludes {@link Union}s.  If you want this feature for a union
	   * you must use {@link Union.getVariant|getVariant} to select the
	   * desired layout.
	   *
	   * @param {Array} values - an array of values that correspond to the
	   * default order for properties.  As with {@link Layout#decode|decode}
	   * layout elements that have no property name are skipped when
	   * iterating over the array values.  Only the top-level properties are
	   * assigned; arguments are not assigned to properties of contained
	   * layouts.  Any unused values are ignored.
	   *
	   * @return {(Object|undefined)}
	   */
	  fromArray(values) {
	    return undefined;
	  }
	}
	Layout$1.Layout = Layout;

	/* Provide text that carries a name (such as for a function that will
	 * be throwing an error) annotated with the property of a given layout
	 * (such as one for which the value was unacceptable).
	 *
	 * @ignore */
	function nameWithProperty(name, lo) {
	  if (lo.property) {
	    return name + '[' + lo.property + ']';
	  }
	  return name;
	}
	Layout$1.nameWithProperty = nameWithProperty;

	/**
	 * Augment a class so that instances can be encoded/decoded using a
	 * given layout.
	 *
	 * Calling this function couples `Class` with `layout` in several ways:
	 *
	 * * `Class.layout_` becomes a static member property equal to `layout`;
	 * * `layout.boundConstructor_` becomes a static member property equal
	 *    to `Class`;
	 * * The {@link Layout#makeDestinationObject|makeDestinationObject()}
	 *   property of `layout` is set to a function that returns a `new
	 *   Class()`;
	 * * `Class.decode(b, offset)` becomes a static member function that
	 *   delegates to {@link Layout#decode|layout.decode}.  The
	 *   synthesized function may be captured and extended.
	 * * `Class.prototype.encode(b, offset)` provides an instance member
	 *   function that delegates to {@link Layout#encode|layout.encode}
	 *   with `src` set to `this`.  The synthesized function may be
	 *   captured and extended, but when the extension is invoked `this`
	 *   must be explicitly bound to the instance.
	 *
	 * @param {class} Class - a JavaScript class with a nullary
	 * constructor.
	 *
	 * @param {Layout} layout - the {@link Layout} instance used to encode
	 * instances of `Class`.
	 */
	function bindConstructorLayout(Class, layout) {
	  if ('function' !== typeof Class) {
	    throw new TypeError('Class must be constructor');
	  }
	  if (Class.hasOwnProperty('layout_')) {
	    throw new Error('Class is already bound to a layout');
	  }
	  if (!(layout && (layout instanceof Layout))) {
	    throw new TypeError('layout must be a Layout');
	  }
	  if (layout.hasOwnProperty('boundConstructor_')) {
	    throw new Error('layout is already bound to a constructor');
	  }
	  Class.layout_ = layout;
	  layout.boundConstructor_ = Class;
	  layout.makeDestinationObject = (() => new Class());
	  Object.defineProperty(Class.prototype, 'encode', {
	    value: function(b, offset) {
	      return layout.encode(this, b, offset);
	    },
	    writable: true,
	  });
	  Object.defineProperty(Class, 'decode', {
	    value: function(b, offset) {
	      return layout.decode(b, offset);
	    },
	    writable: true,
	  });
	}
	Layout$1.bindConstructorLayout = bindConstructorLayout;

	/**
	 * An object that behaves like a layout but does not consume space
	 * within its containing layout.
	 *
	 * This is primarily used to obtain metadata about a member, such as a
	 * {@link OffsetLayout} that can provide data about a {@link
	 * Layout#getSpan|value-specific span}.
	 *
	 * **NOTE** This is an abstract base class; you can create instances
	 * if it amuses you, but they won't support {@link
	 * ExternalLayout#isCount|isCount} or other {@link Layout} functions.
	 *
	 * @param {Number} span - initializer for {@link Layout#span|span}.
	 * The parameter can range from 1 through 6.
	 *
	 * @param {string} [property] - initializer for {@link
	 * Layout#property|property}.
	 *
	 * @abstract
	 * @augments {Layout}
	 */
	class ExternalLayout extends Layout {
	  /**
	   * Return `true` iff the external layout decodes to an unsigned
	   * integer layout.
	   *
	   * In that case it can be used as the source of {@link
	   * Sequence#count|Sequence counts}, {@link Blob#length|Blob lengths},
	   * or as {@link UnionLayoutDiscriminator#layout|external union
	   * discriminators}.
	   *
	   * @abstract
	   */
	  isCount() {
	    throw new Error('ExternalLayout is abstract');
	  }
	}

	/**
	 * An {@link ExternalLayout} that determines its {@link
	 * Layout#decode|value} based on offset into and length of the buffer
	 * on which it is invoked.
	 *
	 * *Factory*: {@link module:Layout.greedy|greedy}
	 *
	 * @param {Number} [elementSpan] - initializer for {@link
	 * GreedyCount#elementSpan|elementSpan}.
	 *
	 * @param {string} [property] - initializer for {@link
	 * Layout#property|property}.
	 *
	 * @augments {ExternalLayout}
	 */
	class GreedyCount extends ExternalLayout {
	  constructor(elementSpan, property) {
	    if (undefined === elementSpan) {
	      elementSpan = 1;
	    }
	    if ((!Number.isInteger(elementSpan)) || (0 >= elementSpan)) {
	      throw new TypeError('elementSpan must be a (positive) integer');
	    }
	    super(-1, property);

	    /** The layout for individual elements of the sequence.  The value
	     * must be a positive integer.  If not provided, the value will be
	     * 1. */
	    this.elementSpan = elementSpan;
	  }

	  /** @override */
	  isCount() {
	    return true;
	  }

	  /** @override */
	  decode(b, offset) {
	    if (undefined === offset) {
	      offset = 0;
	    }
	    const rem = b.length - offset;
	    return Math.floor(rem / this.elementSpan);
	  }

	  /** @override */
	  encode(src, b, offset) {
	    return 0;
	  }
	}

	/**
	 * An {@link ExternalLayout} that supports accessing a {@link Layout}
	 * at a fixed offset from the start of another Layout.  The offset may
	 * be before, within, or after the base layout.
	 *
	 * *Factory*: {@link module:Layout.offset|offset}
	 *
	 * @param {Layout} layout - initializer for {@link
	 * OffsetLayout#layout|layout}, modulo `property`.
	 *
	 * @param {Number} [offset] - Initializes {@link
	 * OffsetLayout#offset|offset}.  Defaults to zero.
	 *
	 * @param {string} [property] - Optional new property name for a
	 * {@link Layout#replicate| replica} of `layout` to be used as {@link
	 * OffsetLayout#layout|layout}.  If not provided the `layout` is used
	 * unchanged.
	 *
	 * @augments {Layout}
	 */
	class OffsetLayout extends ExternalLayout {
	  constructor(layout, offset, property) {
	    if (!(layout instanceof Layout)) {
	      throw new TypeError('layout must be a Layout');
	    }

	    if (undefined === offset) {
	      offset = 0;
	    } else if (!Number.isInteger(offset)) {
	      throw new TypeError('offset must be integer or undefined');
	    }

	    super(layout.span, property || layout.property);

	    /** The subordinated layout. */
	    this.layout = layout;

	    /** The location of {@link OffsetLayout#layout} relative to the
	     * start of another layout.
	     *
	     * The value may be positive or negative, but an error will thrown
	     * if at the point of use it goes outside the span of the Buffer
	     * being accessed.  */
	    this.offset = offset;
	  }

	  /** @override */
	  isCount() {
	    return ((this.layout instanceof UInt)
	            || (this.layout instanceof UIntBE));
	  }

	  /** @override */
	  decode(b, offset) {
	    if (undefined === offset) {
	      offset = 0;
	    }
	    return this.layout.decode(b, offset + this.offset);
	  }

	  /** @override */
	  encode(src, b, offset) {
	    if (undefined === offset) {
	      offset = 0;
	    }
	    return this.layout.encode(src, b, offset + this.offset);
	  }
	}

	/**
	 * Represent an unsigned integer in little-endian format.
	 *
	 * *Factory*: {@link module:Layout.u8|u8}, {@link
	 *  module:Layout.u16|u16}, {@link module:Layout.u24|u24}, {@link
	 *  module:Layout.u32|u32}, {@link module:Layout.u40|u40}, {@link
	 *  module:Layout.u48|u48}
	 *
	 * @param {Number} span - initializer for {@link Layout#span|span}.
	 * The parameter can range from 1 through 6.
	 *
	 * @param {string} [property] - initializer for {@link
	 * Layout#property|property}.
	 *
	 * @augments {Layout}
	 */
	class UInt extends Layout {
	  constructor(span, property) {
	    super(span, property);
	    if (6 < this.span) {
	      throw new RangeError('span must not exceed 6 bytes');
	    }
	  }

	  /** @override */
	  decode(b, offset) {
	    if (undefined === offset) {
	      offset = 0;
	    }
	    return b.readUIntLE(offset, this.span);
	  }

	  /** @override */
	  encode(src, b, offset) {
	    if (undefined === offset) {
	      offset = 0;
	    }
	    b.writeUIntLE(src, offset, this.span);
	    return this.span;
	  }
	}

	/**
	 * Represent an unsigned integer in big-endian format.
	 *
	 * *Factory*: {@link module:Layout.u8be|u8be}, {@link
	 * module:Layout.u16be|u16be}, {@link module:Layout.u24be|u24be},
	 * {@link module:Layout.u32be|u32be}, {@link
	 * module:Layout.u40be|u40be}, {@link module:Layout.u48be|u48be}
	 *
	 * @param {Number} span - initializer for {@link Layout#span|span}.
	 * The parameter can range from 1 through 6.
	 *
	 * @param {string} [property] - initializer for {@link
	 * Layout#property|property}.
	 *
	 * @augments {Layout}
	 */
	class UIntBE extends Layout {
	  constructor(span, property) {
	    super( span, property);
	    if (6 < this.span) {
	      throw new RangeError('span must not exceed 6 bytes');
	    }
	  }

	  /** @override */
	  decode(b, offset) {
	    if (undefined === offset) {
	      offset = 0;
	    }
	    return b.readUIntBE(offset, this.span);
	  }

	  /** @override */
	  encode(src, b, offset) {
	    if (undefined === offset) {
	      offset = 0;
	    }
	    b.writeUIntBE(src, offset, this.span);
	    return this.span;
	  }
	}

	/**
	 * Represent a signed integer in little-endian format.
	 *
	 * *Factory*: {@link module:Layout.s8|s8}, {@link
	 *  module:Layout.s16|s16}, {@link module:Layout.s24|s24}, {@link
	 *  module:Layout.s32|s32}, {@link module:Layout.s40|s40}, {@link
	 *  module:Layout.s48|s48}
	 *
	 * @param {Number} span - initializer for {@link Layout#span|span}.
	 * The parameter can range from 1 through 6.
	 *
	 * @param {string} [property] - initializer for {@link
	 * Layout#property|property}.
	 *
	 * @augments {Layout}
	 */
	class Int extends Layout {
	  constructor(span, property) {
	    super(span, property);
	    if (6 < this.span) {
	      throw new RangeError('span must not exceed 6 bytes');
	    }
	  }

	  /** @override */
	  decode(b, offset) {
	    if (undefined === offset) {
	      offset = 0;
	    }
	    return b.readIntLE(offset, this.span);
	  }

	  /** @override */
	  encode(src, b, offset) {
	    if (undefined === offset) {
	      offset = 0;
	    }
	    b.writeIntLE(src, offset, this.span);
	    return this.span;
	  }
	}

	/**
	 * Represent a signed integer in big-endian format.
	 *
	 * *Factory*: {@link module:Layout.s8be|s8be}, {@link
	 * module:Layout.s16be|s16be}, {@link module:Layout.s24be|s24be},
	 * {@link module:Layout.s32be|s32be}, {@link
	 * module:Layout.s40be|s40be}, {@link module:Layout.s48be|s48be}
	 *
	 * @param {Number} span - initializer for {@link Layout#span|span}.
	 * The parameter can range from 1 through 6.
	 *
	 * @param {string} [property] - initializer for {@link
	 * Layout#property|property}.
	 *
	 * @augments {Layout}
	 */
	class IntBE extends Layout {
	  constructor(span, property) {
	    super(span, property);
	    if (6 < this.span) {
	      throw new RangeError('span must not exceed 6 bytes');
	    }
	  }

	  /** @override */
	  decode(b, offset) {
	    if (undefined === offset) {
	      offset = 0;
	    }
	    return b.readIntBE(offset, this.span);
	  }

	  /** @override */
	  encode(src, b, offset) {
	    if (undefined === offset) {
	      offset = 0;
	    }
	    b.writeIntBE(src, offset, this.span);
	    return this.span;
	  }
	}

	const V2E32 = Math.pow(2, 32);

	/* True modulus high and low 32-bit words, where low word is always
	 * non-negative. */
	function divmodInt64(src) {
	  const hi32 = Math.floor(src / V2E32);
	  const lo32 = src - (hi32 * V2E32);
	  return {hi32, lo32};
	}
	/* Reconstruct Number from quotient and non-negative remainder */
	function roundedInt64(hi32, lo32) {
	  return hi32 * V2E32 + lo32;
	}

	/**
	 * Represent an unsigned 64-bit integer in little-endian format when
	 * encoded and as a near integral JavaScript Number when decoded.
	 *
	 * *Factory*: {@link module:Layout.nu64|nu64}
	 *
	 * **NOTE** Values with magnitude greater than 2^52 may not decode to
	 * the exact value of the encoded representation.
	 *
	 * @augments {Layout}
	 */
	class NearUInt64 extends Layout {
	  constructor(property) {
	    super(8, property);
	  }

	  /** @override */
	  decode(b, offset) {
	    if (undefined === offset) {
	      offset = 0;
	    }
	    const lo32 = b.readUInt32LE(offset);
	    const hi32 = b.readUInt32LE(offset + 4);
	    return roundedInt64(hi32, lo32);
	  }

	  /** @override */
	  encode(src, b, offset) {
	    if (undefined === offset) {
	      offset = 0;
	    }
	    const split = divmodInt64(src);
	    b.writeUInt32LE(split.lo32, offset);
	    b.writeUInt32LE(split.hi32, offset + 4);
	    return 8;
	  }
	}

	/**
	 * Represent an unsigned 64-bit integer in big-endian format when
	 * encoded and as a near integral JavaScript Number when decoded.
	 *
	 * *Factory*: {@link module:Layout.nu64be|nu64be}
	 *
	 * **NOTE** Values with magnitude greater than 2^52 may not decode to
	 * the exact value of the encoded representation.
	 *
	 * @augments {Layout}
	 */
	class NearUInt64BE extends Layout {
	  constructor(property) {
	    super(8, property);
	  }

	  /** @override */
	  decode(b, offset) {
	    if (undefined === offset) {
	      offset = 0;
	    }
	    const hi32 = b.readUInt32BE(offset);
	    const lo32 = b.readUInt32BE(offset + 4);
	    return roundedInt64(hi32, lo32);
	  }

	  /** @override */
	  encode(src, b, offset) {
	    if (undefined === offset) {
	      offset = 0;
	    }
	    const split = divmodInt64(src);
	    b.writeUInt32BE(split.hi32, offset);
	    b.writeUInt32BE(split.lo32, offset + 4);
	    return 8;
	  }
	}

	/**
	 * Represent a signed 64-bit integer in little-endian format when
	 * encoded and as a near integral JavaScript Number when decoded.
	 *
	 * *Factory*: {@link module:Layout.ns64|ns64}
	 *
	 * **NOTE** Values with magnitude greater than 2^52 may not decode to
	 * the exact value of the encoded representation.
	 *
	 * @augments {Layout}
	 */
	class NearInt64 extends Layout {
	  constructor(property) {
	    super(8, property);
	  }

	  /** @override */
	  decode(b, offset) {
	    if (undefined === offset) {
	      offset = 0;
	    }
	    const lo32 = b.readUInt32LE(offset);
	    const hi32 = b.readInt32LE(offset + 4);
	    return roundedInt64(hi32, lo32);
	  }

	  /** @override */
	  encode(src, b, offset) {
	    if (undefined === offset) {
	      offset = 0;
	    }
	    const split = divmodInt64(src);
	    b.writeUInt32LE(split.lo32, offset);
	    b.writeInt32LE(split.hi32, offset + 4);
	    return 8;
	  }
	}

	/**
	 * Represent a signed 64-bit integer in big-endian format when
	 * encoded and as a near integral JavaScript Number when decoded.
	 *
	 * *Factory*: {@link module:Layout.ns64be|ns64be}
	 *
	 * **NOTE** Values with magnitude greater than 2^52 may not decode to
	 * the exact value of the encoded representation.
	 *
	 * @augments {Layout}
	 */
	class NearInt64BE extends Layout {
	  constructor(property) {
	    super(8, property);
	  }

	  /** @override */
	  decode(b, offset) {
	    if (undefined === offset) {
	      offset = 0;
	    }
	    const hi32 = b.readInt32BE(offset);
	    const lo32 = b.readUInt32BE(offset + 4);
	    return roundedInt64(hi32, lo32);
	  }

	  /** @override */
	  encode(src, b, offset) {
	    if (undefined === offset) {
	      offset = 0;
	    }
	    const split = divmodInt64(src);
	    b.writeInt32BE(split.hi32, offset);
	    b.writeUInt32BE(split.lo32, offset + 4);
	    return 8;
	  }
	}

	/**
	 * Represent a 32-bit floating point number in little-endian format.
	 *
	 * *Factory*: {@link module:Layout.f32|f32}
	 *
	 * @param {string} [property] - initializer for {@link
	 * Layout#property|property}.
	 *
	 * @augments {Layout}
	 */
	class Float extends Layout {
	  constructor(property) {
	    super(4, property);
	  }

	  /** @override */
	  decode(b, offset) {
	    if (undefined === offset) {
	      offset = 0;
	    }
	    return b.readFloatLE(offset);
	  }

	  /** @override */
	  encode(src, b, offset) {
	    if (undefined === offset) {
	      offset = 0;
	    }
	    b.writeFloatLE(src, offset);
	    return 4;
	  }
	}

	/**
	 * Represent a 32-bit floating point number in big-endian format.
	 *
	 * *Factory*: {@link module:Layout.f32be|f32be}
	 *
	 * @param {string} [property] - initializer for {@link
	 * Layout#property|property}.
	 *
	 * @augments {Layout}
	 */
	class FloatBE extends Layout {
	  constructor(property) {
	    super(4, property);
	  }

	  /** @override */
	  decode(b, offset) {
	    if (undefined === offset) {
	      offset = 0;
	    }
	    return b.readFloatBE(offset);
	  }

	  /** @override */
	  encode(src, b, offset) {
	    if (undefined === offset) {
	      offset = 0;
	    }
	    b.writeFloatBE(src, offset);
	    return 4;
	  }
	}

	/**
	 * Represent a 64-bit floating point number in little-endian format.
	 *
	 * *Factory*: {@link module:Layout.f64|f64}
	 *
	 * @param {string} [property] - initializer for {@link
	 * Layout#property|property}.
	 *
	 * @augments {Layout}
	 */
	class Double extends Layout {
	  constructor(property) {
	    super(8, property);
	  }

	  /** @override */
	  decode(b, offset) {
	    if (undefined === offset) {
	      offset = 0;
	    }
	    return b.readDoubleLE(offset);
	  }

	  /** @override */
	  encode(src, b, offset) {
	    if (undefined === offset) {
	      offset = 0;
	    }
	    b.writeDoubleLE(src, offset);
	    return 8;
	  }
	}

	/**
	 * Represent a 64-bit floating point number in big-endian format.
	 *
	 * *Factory*: {@link module:Layout.f64be|f64be}
	 *
	 * @param {string} [property] - initializer for {@link
	 * Layout#property|property}.
	 *
	 * @augments {Layout}
	 */
	class DoubleBE extends Layout {
	  constructor(property) {
	    super(8, property);
	  }

	  /** @override */
	  decode(b, offset) {
	    if (undefined === offset) {
	      offset = 0;
	    }
	    return b.readDoubleBE(offset);
	  }

	  /** @override */
	  encode(src, b, offset) {
	    if (undefined === offset) {
	      offset = 0;
	    }
	    b.writeDoubleBE(src, offset);
	    return 8;
	  }
	}

	/**
	 * Represent a contiguous sequence of a specific layout as an Array.
	 *
	 * *Factory*: {@link module:Layout.seq|seq}
	 *
	 * @param {Layout} elementLayout - initializer for {@link
	 * Sequence#elementLayout|elementLayout}.
	 *
	 * @param {(Number|ExternalLayout)} count - initializer for {@link
	 * Sequence#count|count}.  The parameter must be either a positive
	 * integer or an instance of {@link ExternalLayout}.
	 *
	 * @param {string} [property] - initializer for {@link
	 * Layout#property|property}.
	 *
	 * @augments {Layout}
	 */
	class Sequence extends Layout {
	  constructor(elementLayout, count, property) {
	    if (!(elementLayout instanceof Layout)) {
	      throw new TypeError('elementLayout must be a Layout');
	    }
	    if (!(((count instanceof ExternalLayout) && count.isCount())
	          || (Number.isInteger(count) && (0 <= count)))) {
	      throw new TypeError('count must be non-negative integer '
	                          + 'or an unsigned integer ExternalLayout');
	    }
	    let span = -1;
	    if ((!(count instanceof ExternalLayout))
	        && (0 < elementLayout.span)) {
	      span = count * elementLayout.span;
	    }

	    super(span, property);

	    /** The layout for individual elements of the sequence. */
	    this.elementLayout = elementLayout;

	    /** The number of elements in the sequence.
	     *
	     * This will be either a non-negative integer or an instance of
	     * {@link ExternalLayout} for which {@link
	     * ExternalLayout#isCount|isCount()} is `true`. */
	    this.count = count;
	  }

	  /** @override */
	  getSpan(b, offset) {
	    if (0 <= this.span) {
	      return this.span;
	    }
	    if (undefined === offset) {
	      offset = 0;
	    }
	    let span = 0;
	    let count = this.count;
	    if (count instanceof ExternalLayout) {
	      count = count.decode(b, offset);
	    }
	    if (0 < this.elementLayout.span) {
	      span = count * this.elementLayout.span;
	    } else {
	      let idx = 0;
	      while (idx < count) {
	        span += this.elementLayout.getSpan(b, offset + span);
	        ++idx;
	      }
	    }
	    return span;
	  }

	  /** @override */
	  decode(b, offset) {
	    if (undefined === offset) {
	      offset = 0;
	    }
	    const rv = [];
	    let i = 0;
	    let count = this.count;
	    if (count instanceof ExternalLayout) {
	      count = count.decode(b, offset);
	    }
	    while (i < count) {
	      rv.push(this.elementLayout.decode(b, offset));
	      offset += this.elementLayout.getSpan(b, offset);
	      i += 1;
	    }
	    return rv;
	  }

	  /** Implement {@link Layout#encode|encode} for {@link Sequence}.
	   *
	   * **NOTE** If `src` is shorter than {@link Sequence#count|count} then
	   * the unused space in the buffer is left unchanged.  If `src` is
	   * longer than {@link Sequence#count|count} the unneeded elements are
	   * ignored.
	   *
	   * **NOTE** If {@link Layout#count|count} is an instance of {@link
	   * ExternalLayout} then the length of `src` will be encoded as the
	   * count after `src` is encoded. */
	  encode(src, b, offset) {
	    if (undefined === offset) {
	      offset = 0;
	    }
	    const elo = this.elementLayout;
	    const span = src.reduce((span, v) => {
	      return span + elo.encode(v, b, offset + span);
	    }, 0);
	    if (this.count instanceof ExternalLayout) {
	      this.count.encode(src.length, b, offset);
	    }
	    return span;
	  }
	}

	/**
	 * Represent a contiguous sequence of arbitrary layout elements as an
	 * Object.
	 *
	 * *Factory*: {@link module:Layout.struct|struct}
	 *
	 * **NOTE** The {@link Layout#span|span} of the structure is variable
	 * if any layout in {@link Structure#fields|fields} has a variable
	 * span.  When {@link Layout#encode|encoding} we must have a value for
	 * all variable-length fields, or we wouldn't be able to figure out
	 * how much space to use for storage.  We can only identify the value
	 * for a field when it has a {@link Layout#property|property}.  As
	 * such, although a structure may contain both unnamed fields and
	 * variable-length fields, it cannot contain an unnamed
	 * variable-length field.
	 *
	 * @param {Layout[]} fields - initializer for {@link
	 * Structure#fields|fields}.  An error is raised if this contains a
	 * variable-length field for which a {@link Layout#property|property}
	 * is not defined.
	 *
	 * @param {string} [property] - initializer for {@link
	 * Layout#property|property}.
	 *
	 * @param {Boolean} [decodePrefixes] - initializer for {@link
	 * Structure#decodePrefixes|property}.
	 *
	 * @throws {Error} - if `fields` contains an unnamed variable-length
	 * layout.
	 *
	 * @augments {Layout}
	 */
	class Structure extends Layout {
	  constructor(fields, property, decodePrefixes) {
	    if (!(Array.isArray(fields)
	          && fields.reduce((acc, v) => acc && (v instanceof Layout), true))) {
	      throw new TypeError('fields must be array of Layout instances');
	    }
	    if (('boolean' === typeof property)
	        && (undefined === decodePrefixes)) {
	      decodePrefixes = property;
	      property = undefined;
	    }

	    /* Verify absence of unnamed variable-length fields. */
	    for (const fd of fields) {
	      if ((0 > fd.span)
	          && (undefined === fd.property)) {
	        throw new Error('fields cannot contain unnamed variable-length layout');
	      }
	    }

	    let span = -1;
	    try {
	      span = fields.reduce((span, fd) => span + fd.getSpan(), 0);
	    } catch (e) {
	    }
	    super(span, property);

	    /** The sequence of {@link Layout} values that comprise the
	     * structure.
	     *
	     * The individual elements need not be the same type, and may be
	     * either scalar or aggregate layouts.  If a member layout leaves
	     * its {@link Layout#property|property} undefined the
	     * corresponding region of the buffer associated with the element
	     * will not be mutated.
	     *
	     * @type {Layout[]} */
	    this.fields = fields;

	    /** Control behavior of {@link Layout#decode|decode()} given short
	     * buffers.
	     *
	     * In some situations a structure many be extended with additional
	     * fields over time, with older installations providing only a
	     * prefix of the full structure.  If this property is `true`
	     * decoding will accept those buffers and leave subsequent fields
	     * undefined, as long as the buffer ends at a field boundary.
	     * Defaults to `false`. */
	    this.decodePrefixes = !!decodePrefixes;
	  }

	  /** @override */
	  getSpan(b, offset) {
	    if (0 <= this.span) {
	      return this.span;
	    }
	    if (undefined === offset) {
	      offset = 0;
	    }
	    let span = 0;
	    try {
	      span = this.fields.reduce((span, fd) => {
	        const fsp = fd.getSpan(b, offset);
	        offset += fsp;
	        return span + fsp;
	      }, 0);
	    } catch (e) {
	      throw new RangeError('indeterminate span');
	    }
	    return span;
	  }

	  /** @override */
	  decode(b, offset) {
	    if (undefined === offset) {
	      offset = 0;
	    }
	    const dest = this.makeDestinationObject();
	    for (const fd of this.fields) {
	      if (undefined !== fd.property) {
	        dest[fd.property] = fd.decode(b, offset);
	      }
	      offset += fd.getSpan(b, offset);
	      if (this.decodePrefixes
	          && (b.length === offset)) {
	        break;
	      }
	    }
	    return dest;
	  }

	  /** Implement {@link Layout#encode|encode} for {@link Structure}.
	   *
	   * If `src` is missing a property for a member with a defined {@link
	   * Layout#property|property} the corresponding region of the buffer is
	   * left unmodified. */
	  encode(src, b, offset) {
	    if (undefined === offset) {
	      offset = 0;
	    }
	    const firstOffset = offset;
	    let lastOffset = 0;
	    let lastWrote = 0;
	    for (const fd of this.fields) {
	      let span = fd.span;
	      lastWrote = (0 < span) ? span : 0;
	      if (undefined !== fd.property) {
	        const fv = src[fd.property];
	        if (undefined !== fv) {
	          lastWrote = fd.encode(fv, b, offset);
	          if (0 > span) {
	            /* Read the as-encoded span, which is not necessarily the
	             * same as what we wrote. */
	            span = fd.getSpan(b, offset);
	          }
	        }
	      }
	      lastOffset = offset;
	      offset += span;
	    }
	    /* Use (lastOffset + lastWrote) instead of offset because the last
	     * item may have had a dynamic length and we don't want to include
	     * the padding between it and the end of the space reserved for
	     * it. */
	    return (lastOffset + lastWrote) - firstOffset;
	  }

	  /** @override */
	  fromArray(values) {
	    const dest = this.makeDestinationObject();
	    for (const fd of this.fields) {
	      if ((undefined !== fd.property)
	          && (0 < values.length)) {
	        dest[fd.property] = values.shift();
	      }
	    }
	    return dest;
	  }

	  /**
	   * Get access to the layout of a given property.
	   *
	   * @param {String} property - the structure member of interest.
	   *
	   * @return {Layout} - the layout associated with `property`, or
	   * undefined if there is no such property.
	   */
	  layoutFor(property) {
	    if ('string' !== typeof property) {
	      throw new TypeError('property must be string');
	    }
	    for (const fd of this.fields) {
	      if (fd.property === property) {
	        return fd;
	      }
	    }
	  }

	  /**
	   * Get the offset of a structure member.
	   *
	   * @param {String} property - the structure member of interest.
	   *
	   * @return {Number} - the offset in bytes to the start of `property`
	   * within the structure, or undefined if `property` is not a field
	   * within the structure.  If the property is a member but follows a
	   * variable-length structure member a negative number will be
	   * returned.
	   */
	  offsetOf(property) {
	    if ('string' !== typeof property) {
	      throw new TypeError('property must be string');
	    }
	    let offset = 0;
	    for (const fd of this.fields) {
	      if (fd.property === property) {
	        return offset;
	      }
	      if (0 > fd.span) {
	        offset = -1;
	      } else if (0 <= offset) {
	        offset += fd.span;
	      }
	    }
	  }
	}

	/**
	 * An object that can provide a {@link
	 * Union#discriminator|discriminator} API for {@link Union}.
	 *
	 * **NOTE** This is an abstract base class; you can create instances
	 * if it amuses you, but they won't support the {@link
	 * UnionDiscriminator#encode|encode} or {@link
	 * UnionDiscriminator#decode|decode} functions.
	 *
	 * @param {string} [property] - Default for {@link
	 * UnionDiscriminator#property|property}.
	 *
	 * @abstract
	 */
	class UnionDiscriminator {
	  constructor(property) {
	    /** The {@link Layout#property|property} to be used when the
	     * discriminator is referenced in isolation (generally when {@link
	     * Union#decode|Union decode} cannot delegate to a specific
	     * variant). */
	    this.property = property;
	  }

	  /** Analog to {@link Layout#decode|Layout decode} for union discriminators.
	   *
	   * The implementation of this method need not reference the buffer if
	   * variant information is available through other means. */
	  decode() {
	    throw new Error('UnionDiscriminator is abstract');
	  }

	  /** Analog to {@link Layout#decode|Layout encode} for union discriminators.
	   *
	   * The implementation of this method need not store the value if
	   * variant information is maintained through other means. */
	  encode() {
	    throw new Error('UnionDiscriminator is abstract');
	  }
	}

	/**
	 * An object that can provide a {@link
	 * UnionDiscriminator|discriminator API} for {@link Union} using an
	 * unsigned integral {@link Layout} instance located either inside or
	 * outside the union.
	 *
	 * @param {ExternalLayout} layout - initializes {@link
	 * UnionLayoutDiscriminator#layout|layout}.  Must satisfy {@link
	 * ExternalLayout#isCount|isCount()}.
	 *
	 * @param {string} [property] - Default for {@link
	 * UnionDiscriminator#property|property}, superseding the property
	 * from `layout`, but defaulting to `variant` if neither `property`
	 * nor layout provide a property name.
	 *
	 * @augments {UnionDiscriminator}
	 */
	class UnionLayoutDiscriminator extends UnionDiscriminator {
	  constructor(layout, property) {
	    if (!((layout instanceof ExternalLayout)
	          && layout.isCount())) {
	      throw new TypeError('layout must be an unsigned integer ExternalLayout');
	    }

	    super(property || layout.property || 'variant');

	    /** The {@link ExternalLayout} used to access the discriminator
	     * value. */
	    this.layout = layout;
	  }

	  /** Delegate decoding to {@link UnionLayoutDiscriminator#layout|layout}. */
	  decode(b, offset) {
	    return this.layout.decode(b, offset);
	  }

	  /** Delegate encoding to {@link UnionLayoutDiscriminator#layout|layout}. */
	  encode(src, b, offset) {
	    return this.layout.encode(src, b, offset);
	  }
	}

	/**
	 * Represent any number of span-compatible layouts.
	 *
	 * *Factory*: {@link module:Layout.union|union}
	 *
	 * If the union has a {@link Union#defaultLayout|default layout} that
	 * layout must have a non-negative {@link Layout#span|span}.  The span
	 * of a fixed-span union includes its {@link
	 * Union#discriminator|discriminator} if the variant is a {@link
	 * Union#usesPrefixDiscriminator|prefix of the union}, plus the span
	 * of its {@link Union#defaultLayout|default layout}.
	 *
	 * If the union does not have a default layout then the encoded span
	 * of the union depends on the encoded span of its variant (which may
	 * be fixed or variable).
	 *
	 * {@link VariantLayout#layout|Variant layout}s are added through
	 * {@link Union#addVariant|addVariant}.  If the union has a default
	 * layout, the span of the {@link VariantLayout#layout|layout
	 * contained by the variant} must not exceed the span of the {@link
	 * Union#defaultLayout|default layout} (minus the span of a {@link
	 * Union#usesPrefixDiscriminator|prefix disriminator}, if used).  The
	 * span of the variant will equal the span of the union itself.
	 *
	 * The variant for a buffer can only be identified from the {@link
	 * Union#discriminator|discriminator} {@link
	 * UnionDiscriminator#property|property} (in the case of the {@link
	 * Union#defaultLayout|default layout}), or by using {@link
	 * Union#getVariant|getVariant} and examining the resulting {@link
	 * VariantLayout} instance.
	 *
	 * A variant compatible with a JavaScript object can be identified
	 * using {@link Union#getSourceVariant|getSourceVariant}.
	 *
	 * @param {(UnionDiscriminator|ExternalLayout|Layout)} discr - How to
	 * identify the layout used to interpret the union contents.  The
	 * parameter must be an instance of {@link UnionDiscriminator}, an
	 * {@link ExternalLayout} that satisfies {@link
	 * ExternalLayout#isCount|isCount()}, or {@link UInt} (or {@link
	 * UIntBE}).  When a non-external layout element is passed the layout
	 * appears at the start of the union.  In all cases the (synthesized)
	 * {@link UnionDiscriminator} instance is recorded as {@link
	 * Union#discriminator|discriminator}.
	 *
	 * @param {(Layout|null)} defaultLayout - initializer for {@link
	 * Union#defaultLayout|defaultLayout}.  If absent defaults to `null`.
	 * If `null` there is no default layout: the union has data-dependent
	 * length and attempts to decode or encode unrecognized variants will
	 * throw an exception.  A {@link Layout} instance must have a
	 * non-negative {@link Layout#span|span}, and if it lacks a {@link
	 * Layout#property|property} the {@link
	 * Union#defaultLayout|defaultLayout} will be a {@link
	 * Layout#replicate|replica} with property `content`.
	 *
	 * @param {string} [property] - initializer for {@link
	 * Layout#property|property}.
	 *
	 * @augments {Layout}
	 */
	class Union extends Layout {
	  constructor(discr, defaultLayout, property) {
	    const upv = ((discr instanceof UInt)
	               || (discr instanceof UIntBE));
	    if (upv) {
	      discr = new UnionLayoutDiscriminator(new OffsetLayout(discr));
	    } else if ((discr instanceof ExternalLayout)
	               && discr.isCount()) {
	      discr = new UnionLayoutDiscriminator(discr);
	    } else if (!(discr instanceof UnionDiscriminator)) {
	      throw new TypeError('discr must be a UnionDiscriminator '
	                          + 'or an unsigned integer layout');
	    }
	    if (undefined === defaultLayout) {
	      defaultLayout = null;
	    }
	    if (!((null === defaultLayout)
	          || (defaultLayout instanceof Layout))) {
	      throw new TypeError('defaultLayout must be null or a Layout');
	    }
	    if (null !== defaultLayout) {
	      if (0 > defaultLayout.span) {
	        throw new Error('defaultLayout must have constant span');
	      }
	      if (undefined === defaultLayout.property) {
	        defaultLayout = defaultLayout.replicate('content');
	      }
	    }

	    /* The union span can be estimated only if there's a default
	     * layout.  The union spans its default layout, plus any prefix
	     * variant layout.  By construction both layouts, if present, have
	     * non-negative span. */
	    let span = -1;
	    if (defaultLayout) {
	      span = defaultLayout.span;
	      if ((0 <= span) && upv) {
	        span += discr.layout.span;
	      }
	    }
	    super(span, property);

	    /** The interface for the discriminator value in isolation.
	     *
	     * This a {@link UnionDiscriminator} either passed to the
	     * constructor or synthesized from the `discr` constructor
	     * argument.  {@link
	     * Union#usesPrefixDiscriminator|usesPrefixDiscriminator} will be
	     * `true` iff the `discr` parameter was a non-offset {@link
	     * Layout} instance. */
	    this.discriminator = discr;

	    /** `true` if the {@link Union#discriminator|discriminator} is the
	     * first field in the union.
	     *
	     * If `false` the discriminator is obtained from somewhere
	     * else. */
	    this.usesPrefixDiscriminator = upv;

	    /** The layout for non-discriminator content when the value of the
	     * discriminator is not recognized.
	     *
	     * This is the value passed to the constructor.  It is
	     * structurally equivalent to the second component of {@link
	     * Union#layout|layout} but may have a different property
	     * name. */
	    this.defaultLayout = defaultLayout;

	    /** A registry of allowed variants.
	     *
	     * The keys are unsigned integers which should be compatible with
	     * {@link Union.discriminator|discriminator}.  The property value
	     * is the corresponding {@link VariantLayout} instances assigned
	     * to this union by {@link Union#addVariant|addVariant}.
	     *
	     * **NOTE** The registry remains mutable so that variants can be
	     * {@link Union#addVariant|added} at any time.  Users should not
	     * manipulate the content of this property. */
	    this.registry = {};

	    /* Private variable used when invoking getSourceVariant */
	    let boundGetSourceVariant = this.defaultGetSourceVariant.bind(this);

	    /** Function to infer the variant selected by a source object.
	     *
	     * Defaults to {@link
	     * Union#defaultGetSourceVariant|defaultGetSourceVariant} but may
	     * be overridden using {@link
	     * Union#configGetSourceVariant|configGetSourceVariant}.
	     *
	     * @param {Object} src - as with {@link
	     * Union#defaultGetSourceVariant|defaultGetSourceVariant}.
	     *
	     * @returns {(undefined|VariantLayout)} The default variant
	     * (`undefined`) or first registered variant that uses a property
	     * available in `src`. */
	    this.getSourceVariant = function(src) {
	      return boundGetSourceVariant(src);
	    };

	    /** Function to override the implementation of {@link
	     * Union#getSourceVariant|getSourceVariant}.
	     *
	     * Use this if the desired variant cannot be identified using the
	     * algorithm of {@link
	     * Union#defaultGetSourceVariant|defaultGetSourceVariant}.
	     *
	     * **NOTE** The provided function will be invoked bound to this
	     * Union instance, providing local access to {@link
	     * Union#registry|registry}.
	     *
	     * @param {Function} gsv - a function that follows the API of
	     * {@link Union#defaultGetSourceVariant|defaultGetSourceVariant}. */
	    this.configGetSourceVariant = function(gsv) {
	      boundGetSourceVariant = gsv.bind(this);
	    };
	  }

	  /** @override */
	  getSpan(b, offset) {
	    if (0 <= this.span) {
	      return this.span;
	    }
	    if (undefined === offset) {
	      offset = 0;
	    }
	    /* Default layouts always have non-negative span, so we don't have
	     * one and we have to recognize the variant which will in turn
	     * determine the span. */
	    const vlo = this.getVariant(b, offset);
	    if (!vlo) {
	      throw new Error('unable to determine span for unrecognized variant');
	    }
	    return vlo.getSpan(b, offset);
	  }

	  /**
	   * Method to infer a registered Union variant compatible with `src`.
	   *
	   * The first satisified rule in the following sequence defines the
	   * return value:
	   * * If `src` has properties matching the Union discriminator and
	   *   the default layout, `undefined` is returned regardless of the
	   *   value of the discriminator property (this ensures the default
	   *   layout will be used);
	   * * If `src` has a property matching the Union discriminator, the
	   *   value of the discriminator identifies a registered variant, and
	   *   either (a) the variant has no layout, or (b) `src` has the
	   *   variant's property, then the variant is returned (because the
	   *   source satisfies the constraints of the variant it identifies);
	   * * If `src` does not have a property matching the Union
	   *   discriminator, but does have a property matching a registered
	   *   variant, then the variant is returned (because the source
	   *   matches a variant without an explicit conflict);
	   * * An error is thrown (because we either can't identify a variant,
	   *   or we were explicitly told the variant but can't satisfy it).
	   *
	   * @param {Object} src - an object presumed to be compatible with
	   * the content of the Union.
	   *
	   * @return {(undefined|VariantLayout)} - as described above.
	   *
	   * @throws {Error} - if `src` cannot be associated with a default or
	   * registered variant.
	   */
	  defaultGetSourceVariant(src) {
	    if (src.hasOwnProperty(this.discriminator.property)) {
	      if (this.defaultLayout
	          && src.hasOwnProperty(this.defaultLayout.property)) {
	        return undefined;
	      }
	      const vlo = this.registry[src[this.discriminator.property]];
	      if (vlo
	          && ((!vlo.layout)
	              || src.hasOwnProperty(vlo.property))) {
	        return vlo;
	      }
	    } else {
	      for (const tag in this.registry) {
	        const vlo = this.registry[tag];
	        if (src.hasOwnProperty(vlo.property)) {
	          return vlo;
	        }
	      }
	    }
	    throw new Error('unable to infer src variant');
	  }

	  /** Implement {@link Layout#decode|decode} for {@link Union}.
	   *
	   * If the variant is {@link Union#addVariant|registered} the return
	   * value is an instance of that variant, with no explicit
	   * discriminator.  Otherwise the {@link Union#defaultLayout|default
	   * layout} is used to decode the content. */
	  decode(b, offset) {
	    if (undefined === offset) {
	      offset = 0;
	    }
	    let dest;
	    const dlo = this.discriminator;
	    const discr = dlo.decode(b, offset);
	    let clo = this.registry[discr];
	    if (undefined === clo) {
	      let contentOffset = 0;
	      clo = this.defaultLayout;
	      if (this.usesPrefixDiscriminator) {
	        contentOffset = dlo.layout.span;
	      }
	      dest = this.makeDestinationObject();
	      dest[dlo.property] = discr;
	      dest[clo.property] = this.defaultLayout.decode(b, offset + contentOffset);
	    } else {
	      dest = clo.decode(b, offset);
	    }
	    return dest;
	  }

	  /** Implement {@link Layout#encode|encode} for {@link Union}.
	   *
	   * This API assumes the `src` object is consistent with the union's
	   * {@link Union#defaultLayout|default layout}.  To encode variants
	   * use the appropriate variant-specific {@link VariantLayout#encode}
	   * method. */
	  encode(src, b, offset) {
	    if (undefined === offset) {
	      offset = 0;
	    }
	    const vlo = this.getSourceVariant(src);
	    if (undefined === vlo) {
	      const dlo = this.discriminator;
	      const clo = this.defaultLayout;
	      let contentOffset = 0;
	      if (this.usesPrefixDiscriminator) {
	        contentOffset = dlo.layout.span;
	      }
	      dlo.encode(src[dlo.property], b, offset);
	      return contentOffset + clo.encode(src[clo.property], b,
	                                        offset + contentOffset);
	    }
	    return vlo.encode(src, b, offset);
	  }

	  /** Register a new variant structure within a union.  The newly
	   * created variant is returned.
	   *
	   * @param {Number} variant - initializer for {@link
	   * VariantLayout#variant|variant}.
	   *
	   * @param {Layout} layout - initializer for {@link
	   * VariantLayout#layout|layout}.
	   *
	   * @param {String} property - initializer for {@link
	   * Layout#property|property}.
	   *
	   * @return {VariantLayout} */
	  addVariant(variant, layout, property) {
	    const rv = new VariantLayout(this, variant, layout, property);
	    this.registry[variant] = rv;
	    return rv;
	  }

	  /**
	   * Get the layout associated with a registered variant.
	   *
	   * If `vb` does not produce a registered variant the function returns
	   * `undefined`.
	   *
	   * @param {(Number|Buffer)} vb - either the variant number, or a
	   * buffer from which the discriminator is to be read.
	   *
	   * @param {Number} offset - offset into `vb` for the start of the
	   * union.  Used only when `vb` is an instance of {Buffer}.
	   *
	   * @return {({VariantLayout}|undefined)}
	   */
	  getVariant(vb, offset) {
	    let variant = vb;
	    if (Buffer.isBuffer(vb)) {
	      if (undefined === offset) {
	        offset = 0;
	      }
	      variant = this.discriminator.decode(vb, offset);
	    }
	    return this.registry[variant];
	  }
	}

	/**
	 * Represent a specific variant within a containing union.
	 *
	 * **NOTE** The {@link Layout#span|span} of the variant may include
	 * the span of the {@link Union#discriminator|discriminator} used to
	 * identify it, but values read and written using the variant strictly
	 * conform to the content of {@link VariantLayout#layout|layout}.
	 *
	 * **NOTE** User code should not invoke this constructor directly.  Use
	 * the union {@link Union#addVariant|addVariant} helper method.
	 *
	 * @param {Union} union - initializer for {@link
	 * VariantLayout#union|union}.
	 *
	 * @param {Number} variant - initializer for {@link
	 * VariantLayout#variant|variant}.
	 *
	 * @param {Layout} [layout] - initializer for {@link
	 * VariantLayout#layout|layout}.  If absent the variant carries no
	 * data.
	 *
	 * @param {String} [property] - initializer for {@link
	 * Layout#property|property}.  Unlike many other layouts, variant
	 * layouts normally include a property name so they can be identified
	 * within their containing {@link Union}.  The property identifier may
	 * be absent only if `layout` is is absent.
	 *
	 * @augments {Layout}
	 */
	class VariantLayout extends Layout {
	  constructor(union, variant, layout, property) {
	    if (!(union instanceof Union)) {
	      throw new TypeError('union must be a Union');
	    }
	    if ((!Number.isInteger(variant)) || (0 > variant)) {
	      throw new TypeError('variant must be a (non-negative) integer');
	    }
	    if (('string' === typeof layout)
	        && (undefined === property)) {
	      property = layout;
	      layout = null;
	    }
	    if (layout) {
	      if (!(layout instanceof Layout)) {
	        throw new TypeError('layout must be a Layout');
	      }
	      if ((null !== union.defaultLayout)
	          && (0 <= layout.span)
	          && (layout.span > union.defaultLayout.span)) {
	        throw new Error('variant span exceeds span of containing union');
	      }
	      if ('string' !== typeof property) {
	        throw new TypeError('variant must have a String property');
	      }
	    }
	    let span = union.span;
	    if (0 > union.span) {
	      span = layout ? layout.span : 0;
	      if ((0 <= span) && union.usesPrefixDiscriminator) {
	        span += union.discriminator.layout.span;
	      }
	    }
	    super(span, property);

	    /** The {@link Union} to which this variant belongs. */
	    this.union = union;

	    /** The unsigned integral value identifying this variant within
	     * the {@link Union#discriminator|discriminator} of the containing
	     * union. */
	    this.variant = variant;

	    /** The {@link Layout} to be used when reading/writing the
	     * non-discriminator part of the {@link
	     * VariantLayout#union|union}.  If `null` the variant carries no
	     * data. */
	    this.layout = layout || null;
	  }

	  /** @override */
	  getSpan(b, offset) {
	    if (0 <= this.span) {
	      /* Will be equal to the containing union span if that is not
	       * variable. */
	      return this.span;
	    }
	    if (undefined === offset) {
	      offset = 0;
	    }
	    let contentOffset = 0;
	    if (this.union.usesPrefixDiscriminator) {
	      contentOffset = this.union.discriminator.layout.span;
	    }
	    /* Span is defined solely by the variant (and prefix discriminator) */
	    return contentOffset + this.layout.getSpan(b, offset + contentOffset);
	  }

	  /** @override */
	  decode(b, offset) {
	    const dest = this.makeDestinationObject();
	    if (undefined === offset) {
	      offset = 0;
	    }
	    if (this !== this.union.getVariant(b, offset)) {
	      throw new Error('variant mismatch');
	    }
	    let contentOffset = 0;
	    if (this.union.usesPrefixDiscriminator) {
	      contentOffset = this.union.discriminator.layout.span;
	    }
	    if (this.layout) {
	      dest[this.property] = this.layout.decode(b, offset + contentOffset);
	    } else if (this.property) {
	      dest[this.property] = true;
	    } else if (this.union.usesPrefixDiscriminator) {
	      dest[this.union.discriminator.property] = this.variant;
	    }
	    return dest;
	  }

	  /** @override */
	  encode(src, b, offset) {
	    if (undefined === offset) {
	      offset = 0;
	    }
	    let contentOffset = 0;
	    if (this.union.usesPrefixDiscriminator) {
	      contentOffset = this.union.discriminator.layout.span;
	    }
	    if (this.layout
	        && (!src.hasOwnProperty(this.property))) {
	      throw new TypeError('variant lacks property ' + this.property);
	    }
	    this.union.discriminator.encode(this.variant, b, offset);
	    let span = contentOffset;
	    if (this.layout) {
	      this.layout.encode(src[this.property], b, offset + contentOffset);
	      span += this.layout.getSpan(b, offset + contentOffset);
	      if ((0 <= this.union.span)
	          && (span > this.union.span)) {
	        throw new Error('encoded variant overruns containing union');
	      }
	    }
	    return span;
	  }

	  /** Delegate {@link Layout#fromArray|fromArray} to {@link
	   * VariantLayout#layout|layout}. */
	  fromArray(values) {
	    if (this.layout) {
	      return this.layout.fromArray(values);
	    }
	  }
	}

	/** JavaScript chose to define bitwise operations as operating on
	 * signed 32-bit values in 2's complement form, meaning any integer
	 * with bit 31 set is going to look negative.  For right shifts that's
	 * not a problem, because `>>>` is a logical shift, but for every
	 * other bitwise operator we have to compensate for possible negative
	 * results. */
	function fixBitwiseResult(v) {
	  if (0 > v) {
	    v += 0x100000000;
	  }
	  return v;
	}

	/**
	 * Contain a sequence of bit fields as an unsigned integer.
	 *
	 * *Factory*: {@link module:Layout.bits|bits}
	 *
	 * This is a container element; within it there are {@link BitField}
	 * instances that provide the extracted properties.  The container
	 * simply defines the aggregate representation and its bit ordering.
	 * The representation is an object containing properties with numeric
	 * or {@link Boolean} values.
	 *
	 * {@link BitField}s are added with the {@link
	 * BitStructure#addField|addField} and {@link
	 * BitStructure#addBoolean|addBoolean} methods.

	 * @param {Layout} word - initializer for {@link
	 * BitStructure#word|word}.  The parameter must be an instance of
	 * {@link UInt} (or {@link UIntBE}) that is no more than 4 bytes wide.
	 *
	 * @param {bool} [msb] - `true` if the bit numbering starts at the
	 * most significant bit of the containing word; `false` (default) if
	 * it starts at the least significant bit of the containing word.  If
	 * the parameter at this position is a string and `property` is
	 * `undefined` the value of this argument will instead be used as the
	 * value of `property`.
	 *
	 * @param {string} [property] - initializer for {@link
	 * Layout#property|property}.
	 *
	 * @augments {Layout}
	 */
	class BitStructure extends Layout {
	  constructor(word, msb, property) {
	    if (!((word instanceof UInt)
	          || (word instanceof UIntBE))) {
	      throw new TypeError('word must be a UInt or UIntBE layout');
	    }
	    if (('string' === typeof msb)
	        && (undefined === property)) {
	      property = msb;
	      msb = undefined;
	    }
	    if (4 < word.span) {
	      throw new RangeError('word cannot exceed 32 bits');
	    }
	    super(word.span, property);

	    /** The layout used for the packed value.  {@link BitField}
	     * instances are packed sequentially depending on {@link
	     * BitStructure#msb|msb}. */
	    this.word = word;

	    /** Whether the bit sequences are packed starting at the most
	     * significant bit growing down (`true`), or the least significant
	     * bit growing up (`false`).
	     *
	     * **NOTE** Regardless of this value, the least significant bit of
	     * any {@link BitField} value is the least significant bit of the
	     * corresponding section of the packed value. */
	    this.msb = !!msb;

	    /** The sequence of {@link BitField} layouts that comprise the
	     * packed structure.
	     *
	     * **NOTE** The array remains mutable to allow fields to be {@link
	     * BitStructure#addField|added} after construction.  Users should
	     * not manipulate the content of this property.*/
	    this.fields = [];

	    /* Storage for the value.  Capture a variable instead of using an
	     * instance property because we don't want anything to change the
	     * value without going through the mutator. */
	    let value = 0;
	    this._packedSetValue = function(v) {
	      value = fixBitwiseResult(v);
	      return this;
	    };
	    this._packedGetValue = function() {
	      return value;
	    };
	  }

	  /** @override */
	  decode(b, offset) {
	    const dest = this.makeDestinationObject();
	    if (undefined === offset) {
	      offset = 0;
	    }
	    const value = this.word.decode(b, offset);
	    this._packedSetValue(value);
	    for (const fd of this.fields) {
	      if (undefined !== fd.property) {
	        dest[fd.property] = fd.decode(value);
	      }
	    }
	    return dest;
	  }

	  /** Implement {@link Layout#encode|encode} for {@link BitStructure}.
	   *
	   * If `src` is missing a property for a member with a defined {@link
	   * Layout#property|property} the corresponding region of the packed
	   * value is left unmodified.  Unused bits are also left unmodified. */
	  encode(src, b, offset) {
	    if (undefined === offset) {
	      offset = 0;
	    }
	    const value = this.word.decode(b, offset);
	    this._packedSetValue(value);
	    for (const fd of this.fields) {
	      if (undefined !== fd.property) {
	        const fv = src[fd.property];
	        if (undefined !== fv) {
	          fd.encode(fv);
	        }
	      }
	    }
	    return this.word.encode(this._packedGetValue(), b, offset);
	  }

	  /** Register a new bitfield with a containing bit structure.  The
	   * resulting bitfield is returned.
	   *
	   * @param {Number} bits - initializer for {@link BitField#bits|bits}.
	   *
	   * @param {string} property - initializer for {@link
	   * Layout#property|property}.
	   *
	   * @return {BitField} */
	  addField(bits, property) {
	    const bf = new BitField(this, bits, property);
	    this.fields.push(bf);
	    return bf;
	  }

	  /** As with {@link BitStructure#addField|addField} for single-bit
	   * fields with `boolean` value representation.
	   *
	   * @param {string} property - initializer for {@link
	   * Layout#property|property}.
	   *
	   * @return {Boolean} */
	  addBoolean(property) {
	    // This is my Boolean, not the Javascript one.
	    // eslint-disable-next-line no-new-wrappers
	    const bf = new Boolean$1(this, property);
	    this.fields.push(bf);
	    return bf;
	  }

	  /**
	   * Get access to the bit field for a given property.
	   *
	   * @param {String} property - the bit field of interest.
	   *
	   * @return {BitField} - the field associated with `property`, or
	   * undefined if there is no such property.
	   */
	  fieldFor(property) {
	    if ('string' !== typeof property) {
	      throw new TypeError('property must be string');
	    }
	    for (const fd of this.fields) {
	      if (fd.property === property) {
	        return fd;
	      }
	    }
	  }
	}

	/**
	 * Represent a sequence of bits within a {@link BitStructure}.
	 *
	 * All bit field values are represented as unsigned integers.
	 *
	 * **NOTE** User code should not invoke this constructor directly.
	 * Use the container {@link BitStructure#addField|addField} helper
	 * method.
	 *
	 * **NOTE** BitField instances are not instances of {@link Layout}
	 * since {@link Layout#span|span} measures 8-bit units.
	 *
	 * @param {BitStructure} container - initializer for {@link
	 * BitField#container|container}.
	 *
	 * @param {Number} bits - initializer for {@link BitField#bits|bits}.
	 *
	 * @param {string} [property] - initializer for {@link
	 * Layout#property|property}.
	 */
	class BitField {
	  constructor(container, bits, property) {
	    if (!(container instanceof BitStructure)) {
	      throw new TypeError('container must be a BitStructure');
	    }
	    if ((!Number.isInteger(bits)) || (0 >= bits)) {
	      throw new TypeError('bits must be positive integer');
	    }
	    const totalBits = 8 * container.span;
	    const usedBits = container.fields.reduce((sum, fd) => sum + fd.bits, 0);
	    if ((bits + usedBits) > totalBits) {
	      throw new Error('bits too long for span remainder ('
	                      + (totalBits - usedBits) + ' of '
	                      + totalBits + ' remain)');
	    }

	    /** The {@link BitStructure} instance to which this bit field
	     * belongs. */
	    this.container = container;

	    /** The span of this value in bits. */
	    this.bits = bits;

	    /** A mask of {@link BitField#bits|bits} bits isolating value bits
	     * that fit within the field.
	     *
	     * That is, it masks a value that has not yet been shifted into
	     * position within its containing packed integer. */
	    this.valueMask = (1 << bits) - 1;
	    if (32 === bits) { // shifted value out of range
	      this.valueMask = 0xFFFFFFFF;
	    }

	    /** The offset of the value within the containing packed unsigned
	     * integer.  The least significant bit of the packed value is at
	     * offset zero, regardless of bit ordering used. */
	    this.start = usedBits;
	    if (this.container.msb) {
	      this.start = totalBits - usedBits - bits;
	    }

	    /** A mask of {@link BitField#bits|bits} isolating the field value
	     * within the containing packed unsigned integer. */
	    this.wordMask = fixBitwiseResult(this.valueMask << this.start);

	    /** The property name used when this bitfield is represented in an
	     * Object.
	     *
	     * Intended to be functionally equivalent to {@link
	     * Layout#property}.
	     *
	     * If left undefined the corresponding span of bits will be
	     * treated as padding: it will not be mutated by {@link
	     * Layout#encode|encode} nor represented as a property in the
	     * decoded Object. */
	    this.property = property;
	  }

	  /** Store a value into the corresponding subsequence of the containing
	   * bit field. */
	  decode() {
	    const word = this.container._packedGetValue();
	    const wordValue = fixBitwiseResult(word & this.wordMask);
	    const value = wordValue >>> this.start;
	    return value;
	  }

	  /** Store a value into the corresponding subsequence of the containing
	   * bit field.
	   *
	   * **NOTE** This is not a specialization of {@link
	   * Layout#encode|Layout.encode} and there is no return value. */
	  encode(value) {
	    if ((!Number.isInteger(value))
	        || (value !== fixBitwiseResult(value & this.valueMask))) {
	      throw new TypeError(nameWithProperty('BitField.encode', this)
	                          + ' value must be integer not exceeding ' + this.valueMask);
	    }
	    const word = this.container._packedGetValue();
	    const wordValue = fixBitwiseResult(value << this.start);
	    this.container._packedSetValue(fixBitwiseResult(word & ~this.wordMask)
	                                   | wordValue);
	  };
	}

	/**
	 * Represent a single bit within a {@link BitStructure} as a
	 * JavaScript boolean.
	 *
	 * **NOTE** User code should not invoke this constructor directly.
	 * Use the container {@link BitStructure#addBoolean|addBoolean} helper
	 * method.
	 *
	 * @param {BitStructure} container - initializer for {@link
	 * BitField#container|container}.
	 *
	 * @param {string} [property] - initializer for {@link
	 * Layout#property|property}.
	 *
	 * @augments {BitField}
	 */
	/* eslint-disable no-extend-native */
	let Boolean$1 = class Boolean extends BitField {
	  constructor(container, property) {
	    super(container, 1, property);
	  }

	  /** Override {@link BitField#decode|decode} for {@link Boolean|Boolean}.
	   *
	   * @returns {boolean} */
	  decode(b, offset) {
	    return !!BitField.prototype.decode.call(this, b, offset);
	  }

	  /** @override */
	  encode(value) {
	    if ('boolean' === typeof value) {
	      // BitField requires integer values
	      value = +value;
	    }
	    return BitField.prototype.encode.call(this, value);
	  }
	};
	/* eslint-enable no-extend-native */

	/**
	 * Contain a fixed-length block of arbitrary data, represented as a
	 * Buffer.
	 *
	 * *Factory*: {@link module:Layout.blob|blob}
	 *
	 * @param {(Number|ExternalLayout)} length - initializes {@link
	 * Blob#length|length}.
	 *
	 * @param {String} [property] - initializer for {@link
	 * Layout#property|property}.
	 *
	 * @augments {Layout}
	 */
	class Blob extends Layout {
	  constructor(length, property) {
	    if (!(((length instanceof ExternalLayout) && length.isCount())
	          || (Number.isInteger(length) && (0 <= length)))) {
	      throw new TypeError('length must be positive integer '
	                          + 'or an unsigned integer ExternalLayout');
	    }

	    let span = -1;
	    if (!(length instanceof ExternalLayout)) {
	      span = length;
	    }
	    super(span, property);

	    /** The number of bytes in the blob.
	     *
	     * This may be a non-negative integer, or an instance of {@link
	     * ExternalLayout} that satisfies {@link
	     * ExternalLayout#isCount|isCount()}. */
	    this.length = length;
	  }

	  /** @override */
	  getSpan(b, offset) {
	    let span = this.span;
	    if (0 > span) {
	      span = this.length.decode(b, offset);
	    }
	    return span;
	  }

	  /** @override */
	  decode(b, offset) {
	    if (undefined === offset) {
	      offset = 0;
	    }
	    let span = this.span;
	    if (0 > span) {
	      span = this.length.decode(b, offset);
	    }
	    return b.slice(offset, offset + span);
	  }

	  /** Implement {@link Layout#encode|encode} for {@link Blob}.
	   *
	   * **NOTE** If {@link Layout#count|count} is an instance of {@link
	   * ExternalLayout} then the length of `src` will be encoded as the
	   * count after `src` is encoded. */
	  encode(src, b, offset) {
	    let span = this.length;
	    if (this.length instanceof ExternalLayout) {
	      span = src.length;
	    }
	    if (!(Buffer.isBuffer(src)
	          && (span === src.length))) {
	      throw new TypeError(nameWithProperty('Blob.encode', this)
	                          + ' requires (length ' + span + ') Buffer as src');
	    }
	    if ((offset + span) > b.length) {
	      throw new RangeError('encoding overruns Buffer');
	    }
	    b.write(src.toString('hex'), offset, span, 'hex');
	    if (this.length instanceof ExternalLayout) {
	      this.length.encode(span, b, offset);
	    }
	    return span;
	  }
	}

	/**
	 * Contain a `NUL`-terminated UTF8 string.
	 *
	 * *Factory*: {@link module:Layout.cstr|cstr}
	 *
	 * **NOTE** Any UTF8 string that incorporates a zero-valued byte will
	 * not be correctly decoded by this layout.
	 *
	 * @param {String} [property] - initializer for {@link
	 * Layout#property|property}.
	 *
	 * @augments {Layout}
	 */
	class CString extends Layout {
	  constructor(property) {
	    super(-1, property);
	  }

	  /** @override */
	  getSpan(b, offset) {
	    if (!Buffer.isBuffer(b)) {
	      throw new TypeError('b must be a Buffer');
	    }
	    if (undefined === offset) {
	      offset = 0;
	    }
	    let idx = offset;
	    while ((idx < b.length) && (0 !== b[idx])) {
	      idx += 1;
	    }
	    return 1 + idx - offset;
	  }

	  /** @override */
	  decode(b, offset, dest) {
	    if (undefined === offset) {
	      offset = 0;
	    }
	    let span = this.getSpan(b, offset);
	    return b.slice(offset, offset + span - 1).toString('utf-8');
	  }

	  /** @override */
	  encode(src, b, offset) {
	    if (undefined === offset) {
	      offset = 0;
	    }
	    /* Must force this to a string, lest it be a number and the
	     * "utf8-encoding" below actually allocate a buffer of length
	     * src */
	    if ('string' !== typeof src) {
	      src = src.toString();
	    }
	    const srcb = new Buffer(src, 'utf8');
	    const span = srcb.length;
	    if ((offset + span) > b.length) {
	      throw new RangeError('encoding overruns Buffer');
	    }
	    srcb.copy(b, offset);
	    b[offset + span] = 0;
	    return span + 1;
	  }
	}

	/**
	 * Contain a UTF8 string with implicit length.
	 *
	 * *Factory*: {@link module:Layout.utf8|utf8}
	 *
	 * **NOTE** Because the length is implicit in the size of the buffer
	 * this layout should be used only in isolation, or in a situation
	 * where the length can be expressed by operating on a slice of the
	 * containing buffer.
	 *
	 * @param {Number} [maxSpan] - the maximum length allowed for encoded
	 * string content.  If not provided there is no bound on the allowed
	 * content.
	 *
	 * @param {String} [property] - initializer for {@link
	 * Layout#property|property}.
	 *
	 * @augments {Layout}
	 */
	class UTF8 extends Layout {
	  constructor(maxSpan, property) {
	    if (('string' === typeof maxSpan)
	        && (undefined === property)) {
	      property = maxSpan;
	      maxSpan = undefined;
	    }
	    if (undefined === maxSpan) {
	      maxSpan = -1;
	    } else if (!Number.isInteger(maxSpan)) {
	      throw new TypeError('maxSpan must be an integer');
	    }

	    super(-1, property);

	    /** The maximum span of the layout in bytes.
	     *
	     * Positive values are generally expected.  Zero is abnormal.
	     * Attempts to encode or decode a value that exceeds this length
	     * will throw a `RangeError`.
	     *
	     * A negative value indicates that there is no bound on the length
	     * of the content. */
	    this.maxSpan = maxSpan;
	  }

	  /** @override */
	  getSpan(b, offset) {
	    if (!Buffer.isBuffer(b)) {
	      throw new TypeError('b must be a Buffer');
	    }
	    if (undefined === offset) {
	      offset = 0;
	    }
	    return b.length - offset;
	  }

	  /** @override */
	  decode(b, offset, dest) {
	    if (undefined === offset) {
	      offset = 0;
	    }
	    let span = this.getSpan(b, offset);
	    if ((0 <= this.maxSpan)
	        && (this.maxSpan < span)) {
	      throw new RangeError('text length exceeds maxSpan');
	    }
	    return b.slice(offset, offset + span).toString('utf-8');
	  }

	  /** @override */
	  encode(src, b, offset) {
	    if (undefined === offset) {
	      offset = 0;
	    }
	    /* Must force this to a string, lest it be a number and the
	     * "utf8-encoding" below actually allocate a buffer of length
	     * src */
	    if ('string' !== typeof src) {
	      src = src.toString();
	    }
	    const srcb = new Buffer(src, 'utf8');
	    const span = srcb.length;
	    if ((0 <= this.maxSpan)
	        && (this.maxSpan < span)) {
	      throw new RangeError('text length exceeds maxSpan');
	    }
	    if ((offset + span) > b.length) {
	      throw new RangeError('encoding overruns Buffer');
	    }
	    srcb.copy(b, offset);
	    return span;
	  }
	}

	/**
	 * Contain a constant value.
	 *
	 * This layout may be used in cases where a JavaScript value can be
	 * inferred without an expression in the binary encoding.  An example
	 * would be a {@link VariantLayout|variant layout} where the content
	 * is implied by the union {@link Union#discriminator|discriminator}.
	 *
	 * @param {Object|Number|String} value - initializer for {@link
	 * Constant#value|value}.  If the value is an object (or array) and
	 * the application intends the object to remain unchanged regardless
	 * of what is done to values decoded by this layout, the value should
	 * be frozen prior passing it to this constructor.
	 *
	 * @param {String} [property] - initializer for {@link
	 * Layout#property|property}.
	 *
	 * @augments {Layout}
	 */
	class Constant extends Layout {
	  constructor(value, property) {
	    super(0, property);

	    /** The value produced by this constant when the layout is {@link
	     * Constant#decode|decoded}.
	     *
	     * Any JavaScript value including `null` and `undefined` is
	     * permitted.
	     *
	     * **WARNING** If `value` passed in the constructor was not
	     * frozen, it is possible for users of decoded values to change
	     * the content of the value. */
	    this.value = value;
	  }

	  /** @override */
	  decode(b, offset, dest) {
	    return this.value;
	  }

	  /** @override */
	  encode(src, b, offset) {
	    /* Constants take no space */
	    return 0;
	  }
	}

	Layout$1.ExternalLayout = ExternalLayout;
	Layout$1.GreedyCount = GreedyCount;
	Layout$1.OffsetLayout = OffsetLayout;
	Layout$1.UInt = UInt;
	Layout$1.UIntBE = UIntBE;
	Layout$1.Int = Int;
	Layout$1.IntBE = IntBE;
	Layout$1.Float = Float;
	Layout$1.FloatBE = FloatBE;
	Layout$1.Double = Double;
	Layout$1.DoubleBE = DoubleBE;
	Layout$1.Sequence = Sequence;
	Layout$1.Structure = Structure;
	Layout$1.UnionDiscriminator = UnionDiscriminator;
	Layout$1.UnionLayoutDiscriminator = UnionLayoutDiscriminator;
	Layout$1.Union = Union;
	Layout$1.VariantLayout = VariantLayout;
	Layout$1.BitStructure = BitStructure;
	Layout$1.BitField = BitField;
	Layout$1.Boolean = Boolean$1;
	Layout$1.Blob = Blob;
	Layout$1.CString = CString;
	Layout$1.UTF8 = UTF8;
	Layout$1.Constant = Constant;

	/** Factory for {@link GreedyCount}. */
	Layout$1.greedy = ((elementSpan, property) => new GreedyCount(elementSpan, property));

	/** Factory for {@link OffsetLayout}. */
	Layout$1.offset = ((layout, offset, property) => new OffsetLayout(layout, offset, property));

	/** Factory for {@link UInt|unsigned int layouts} spanning one
	 * byte. */
	Layout$1.u8 = (property => new UInt(1, property));

	/** Factory for {@link UInt|little-endian unsigned int layouts}
	 * spanning two bytes. */
	Layout$1.u16 = (property => new UInt(2, property));

	/** Factory for {@link UInt|little-endian unsigned int layouts}
	 * spanning three bytes. */
	Layout$1.u24 = (property => new UInt(3, property));

	/** Factory for {@link UInt|little-endian unsigned int layouts}
	 * spanning four bytes. */
	Layout$1.u32 = (property => new UInt(4, property));

	/** Factory for {@link UInt|little-endian unsigned int layouts}
	 * spanning five bytes. */
	Layout$1.u40 = (property => new UInt(5, property));

	/** Factory for {@link UInt|little-endian unsigned int layouts}
	 * spanning six bytes. */
	Layout$1.u48 = (property => new UInt(6, property));

	/** Factory for {@link NearUInt64|little-endian unsigned int
	 * layouts} interpreted as Numbers. */
	Layout$1.nu64 = (property => new NearUInt64(property));

	/** Factory for {@link UInt|big-endian unsigned int layouts}
	 * spanning two bytes. */
	Layout$1.u16be = (property => new UIntBE(2, property));

	/** Factory for {@link UInt|big-endian unsigned int layouts}
	 * spanning three bytes. */
	Layout$1.u24be = (property => new UIntBE(3, property));

	/** Factory for {@link UInt|big-endian unsigned int layouts}
	 * spanning four bytes. */
	Layout$1.u32be = (property => new UIntBE(4, property));

	/** Factory for {@link UInt|big-endian unsigned int layouts}
	 * spanning five bytes. */
	Layout$1.u40be = (property => new UIntBE(5, property));

	/** Factory for {@link UInt|big-endian unsigned int layouts}
	 * spanning six bytes. */
	Layout$1.u48be = (property => new UIntBE(6, property));

	/** Factory for {@link NearUInt64BE|big-endian unsigned int
	 * layouts} interpreted as Numbers. */
	Layout$1.nu64be = (property => new NearUInt64BE(property));

	/** Factory for {@link Int|signed int layouts} spanning one
	 * byte. */
	Layout$1.s8 = (property => new Int(1, property));

	/** Factory for {@link Int|little-endian signed int layouts}
	 * spanning two bytes. */
	Layout$1.s16 = (property => new Int(2, property));

	/** Factory for {@link Int|little-endian signed int layouts}
	 * spanning three bytes. */
	Layout$1.s24 = (property => new Int(3, property));

	/** Factory for {@link Int|little-endian signed int layouts}
	 * spanning four bytes. */
	Layout$1.s32 = (property => new Int(4, property));

	/** Factory for {@link Int|little-endian signed int layouts}
	 * spanning five bytes. */
	Layout$1.s40 = (property => new Int(5, property));

	/** Factory for {@link Int|little-endian signed int layouts}
	 * spanning six bytes. */
	Layout$1.s48 = (property => new Int(6, property));

	/** Factory for {@link NearInt64|little-endian signed int layouts}
	 * interpreted as Numbers. */
	Layout$1.ns64 = (property => new NearInt64(property));

	/** Factory for {@link Int|big-endian signed int layouts}
	 * spanning two bytes. */
	Layout$1.s16be = (property => new IntBE(2, property));

	/** Factory for {@link Int|big-endian signed int layouts}
	 * spanning three bytes. */
	Layout$1.s24be = (property => new IntBE(3, property));

	/** Factory for {@link Int|big-endian signed int layouts}
	 * spanning four bytes. */
	Layout$1.s32be = (property => new IntBE(4, property));

	/** Factory for {@link Int|big-endian signed int layouts}
	 * spanning five bytes. */
	Layout$1.s40be = (property => new IntBE(5, property));

	/** Factory for {@link Int|big-endian signed int layouts}
	 * spanning six bytes. */
	Layout$1.s48be = (property => new IntBE(6, property));

	/** Factory for {@link NearInt64BE|big-endian signed int layouts}
	 * interpreted as Numbers. */
	Layout$1.ns64be = (property => new NearInt64BE(property));

	/** Factory for {@link Float|little-endian 32-bit floating point} values. */
	Layout$1.f32 = (property => new Float(property));

	/** Factory for {@link FloatBE|big-endian 32-bit floating point} values. */
	Layout$1.f32be = (property => new FloatBE(property));

	/** Factory for {@link Double|little-endian 64-bit floating point} values. */
	Layout$1.f64 = (property => new Double(property));

	/** Factory for {@link DoubleBE|big-endian 64-bit floating point} values. */
	Layout$1.f64be = (property => new DoubleBE(property));

	/** Factory for {@link Structure} values. */
	Layout$1.struct = ((fields, property, decodePrefixes) => new Structure(fields, property, decodePrefixes));

	/** Factory for {@link BitStructure} values. */
	Layout$1.bits = ((word, msb, property) => new BitStructure(word, msb, property));

	/** Factory for {@link Sequence} values. */
	Layout$1.seq = ((elementLayout, count, property) => new Sequence(elementLayout, count, property));

	/** Factory for {@link Union} values. */
	Layout$1.union = ((discr, defaultLayout, property) => new Union(discr, defaultLayout, property));

	/** Factory for {@link UnionLayoutDiscriminator} values. */
	Layout$1.unionLayoutDiscriminator = ((layout, property) => new UnionLayoutDiscriminator(layout, property));

	/** Factory for {@link Blob} values. */
	Layout$1.blob = ((length, property) => new Blob(length, property));

	/** Factory for {@link CString} values. */
	Layout$1.cstr = (property => new CString(property));

	/** Factory for {@link UTF8} values. */
	Layout$1.utf8 = ((maxSpan, property) => new UTF8(maxSpan, property));

	/** Factory for {@link Constant} values. */
	Layout$1.const = ((value, property) => new Constant(value, property));

	var bnExports = {};
	var bn = {
	  get exports(){ return bnExports; },
	  set exports(v){ bnExports = v; },
	};

	(function (module) {
		(function (module, exports) {

		  // Utils
		  function assert (val, msg) {
		    if (!val) throw new Error(msg || 'Assertion failed');
		  }

		  // Could use `inherits` module, but don't want to move from single file
		  // architecture yet.
		  function inherits (ctor, superCtor) {
		    ctor.super_ = superCtor;
		    var TempCtor = function () {};
		    TempCtor.prototype = superCtor.prototype;
		    ctor.prototype = new TempCtor();
		    ctor.prototype.constructor = ctor;
		  }

		  // BN

		  function BN (number, base, endian) {
		    if (BN.isBN(number)) {
		      return number;
		    }

		    this.negative = 0;
		    this.words = null;
		    this.length = 0;

		    // Reduction context
		    this.red = null;

		    if (number !== null) {
		      if (base === 'le' || base === 'be') {
		        endian = base;
		        base = 10;
		      }

		      this._init(number || 0, base || 10, endian || 'be');
		    }
		  }
		  if (typeof module === 'object') {
		    module.exports = BN;
		  } else {
		    exports.BN = BN;
		  }

		  BN.BN = BN;
		  BN.wordSize = 26;

		  var Buffer;
		  try {
		    if (typeof window !== 'undefined' && typeof window.Buffer !== 'undefined') {
		      Buffer = window.Buffer;
		    } else {
		      Buffer = require('buffer').Buffer;
		    }
		  } catch (e) {
		  }

		  BN.isBN = function isBN (num) {
		    if (num instanceof BN) {
		      return true;
		    }

		    return num !== null && typeof num === 'object' &&
		      num.constructor.wordSize === BN.wordSize && Array.isArray(num.words);
		  };

		  BN.max = function max (left, right) {
		    if (left.cmp(right) > 0) return left;
		    return right;
		  };

		  BN.min = function min (left, right) {
		    if (left.cmp(right) < 0) return left;
		    return right;
		  };

		  BN.prototype._init = function init (number, base, endian) {
		    if (typeof number === 'number') {
		      return this._initNumber(number, base, endian);
		    }

		    if (typeof number === 'object') {
		      return this._initArray(number, base, endian);
		    }

		    if (base === 'hex') {
		      base = 16;
		    }
		    assert(base === (base | 0) && base >= 2 && base <= 36);

		    number = number.toString().replace(/\s+/g, '');
		    var start = 0;
		    if (number[0] === '-') {
		      start++;
		      this.negative = 1;
		    }

		    if (start < number.length) {
		      if (base === 16) {
		        this._parseHex(number, start, endian);
		      } else {
		        this._parseBase(number, base, start);
		        if (endian === 'le') {
		          this._initArray(this.toArray(), base, endian);
		        }
		      }
		    }
		  };

		  BN.prototype._initNumber = function _initNumber (number, base, endian) {
		    if (number < 0) {
		      this.negative = 1;
		      number = -number;
		    }
		    if (number < 0x4000000) {
		      this.words = [number & 0x3ffffff];
		      this.length = 1;
		    } else if (number < 0x10000000000000) {
		      this.words = [
		        number & 0x3ffffff,
		        (number / 0x4000000) & 0x3ffffff
		      ];
		      this.length = 2;
		    } else {
		      assert(number < 0x20000000000000); // 2 ^ 53 (unsafe)
		      this.words = [
		        number & 0x3ffffff,
		        (number / 0x4000000) & 0x3ffffff,
		        1
		      ];
		      this.length = 3;
		    }

		    if (endian !== 'le') return;

		    // Reverse the bytes
		    this._initArray(this.toArray(), base, endian);
		  };

		  BN.prototype._initArray = function _initArray (number, base, endian) {
		    // Perhaps a Uint8Array
		    assert(typeof number.length === 'number');
		    if (number.length <= 0) {
		      this.words = [0];
		      this.length = 1;
		      return this;
		    }

		    this.length = Math.ceil(number.length / 3);
		    this.words = new Array(this.length);
		    for (var i = 0; i < this.length; i++) {
		      this.words[i] = 0;
		    }

		    var j, w;
		    var off = 0;
		    if (endian === 'be') {
		      for (i = number.length - 1, j = 0; i >= 0; i -= 3) {
		        w = number[i] | (number[i - 1] << 8) | (number[i - 2] << 16);
		        this.words[j] |= (w << off) & 0x3ffffff;
		        this.words[j + 1] = (w >>> (26 - off)) & 0x3ffffff;
		        off += 24;
		        if (off >= 26) {
		          off -= 26;
		          j++;
		        }
		      }
		    } else if (endian === 'le') {
		      for (i = 0, j = 0; i < number.length; i += 3) {
		        w = number[i] | (number[i + 1] << 8) | (number[i + 2] << 16);
		        this.words[j] |= (w << off) & 0x3ffffff;
		        this.words[j + 1] = (w >>> (26 - off)) & 0x3ffffff;
		        off += 24;
		        if (off >= 26) {
		          off -= 26;
		          j++;
		        }
		      }
		    }
		    return this._strip();
		  };

		  function parseHex4Bits (string, index) {
		    var c = string.charCodeAt(index);
		    // '0' - '9'
		    if (c >= 48 && c <= 57) {
		      return c - 48;
		    // 'A' - 'F'
		    } else if (c >= 65 && c <= 70) {
		      return c - 55;
		    // 'a' - 'f'
		    } else if (c >= 97 && c <= 102) {
		      return c - 87;
		    } else {
		      assert(false, 'Invalid character in ' + string);
		    }
		  }

		  function parseHexByte (string, lowerBound, index) {
		    var r = parseHex4Bits(string, index);
		    if (index - 1 >= lowerBound) {
		      r |= parseHex4Bits(string, index - 1) << 4;
		    }
		    return r;
		  }

		  BN.prototype._parseHex = function _parseHex (number, start, endian) {
		    // Create possibly bigger array to ensure that it fits the number
		    this.length = Math.ceil((number.length - start) / 6);
		    this.words = new Array(this.length);
		    for (var i = 0; i < this.length; i++) {
		      this.words[i] = 0;
		    }

		    // 24-bits chunks
		    var off = 0;
		    var j = 0;

		    var w;
		    if (endian === 'be') {
		      for (i = number.length - 1; i >= start; i -= 2) {
		        w = parseHexByte(number, start, i) << off;
		        this.words[j] |= w & 0x3ffffff;
		        if (off >= 18) {
		          off -= 18;
		          j += 1;
		          this.words[j] |= w >>> 26;
		        } else {
		          off += 8;
		        }
		      }
		    } else {
		      var parseLength = number.length - start;
		      for (i = parseLength % 2 === 0 ? start + 1 : start; i < number.length; i += 2) {
		        w = parseHexByte(number, start, i) << off;
		        this.words[j] |= w & 0x3ffffff;
		        if (off >= 18) {
		          off -= 18;
		          j += 1;
		          this.words[j] |= w >>> 26;
		        } else {
		          off += 8;
		        }
		      }
		    }

		    this._strip();
		  };

		  function parseBase (str, start, end, mul) {
		    var r = 0;
		    var b = 0;
		    var len = Math.min(str.length, end);
		    for (var i = start; i < len; i++) {
		      var c = str.charCodeAt(i) - 48;

		      r *= mul;

		      // 'a'
		      if (c >= 49) {
		        b = c - 49 + 0xa;

		      // 'A'
		      } else if (c >= 17) {
		        b = c - 17 + 0xa;

		      // '0' - '9'
		      } else {
		        b = c;
		      }
		      assert(c >= 0 && b < mul, 'Invalid character');
		      r += b;
		    }
		    return r;
		  }

		  BN.prototype._parseBase = function _parseBase (number, base, start) {
		    // Initialize as zero
		    this.words = [0];
		    this.length = 1;

		    // Find length of limb in base
		    for (var limbLen = 0, limbPow = 1; limbPow <= 0x3ffffff; limbPow *= base) {
		      limbLen++;
		    }
		    limbLen--;
		    limbPow = (limbPow / base) | 0;

		    var total = number.length - start;
		    var mod = total % limbLen;
		    var end = Math.min(total, total - mod) + start;

		    var word = 0;
		    for (var i = start; i < end; i += limbLen) {
		      word = parseBase(number, i, i + limbLen, base);

		      this.imuln(limbPow);
		      if (this.words[0] + word < 0x4000000) {
		        this.words[0] += word;
		      } else {
		        this._iaddn(word);
		      }
		    }

		    if (mod !== 0) {
		      var pow = 1;
		      word = parseBase(number, i, number.length, base);

		      for (i = 0; i < mod; i++) {
		        pow *= base;
		      }

		      this.imuln(pow);
		      if (this.words[0] + word < 0x4000000) {
		        this.words[0] += word;
		      } else {
		        this._iaddn(word);
		      }
		    }

		    this._strip();
		  };

		  BN.prototype.copy = function copy (dest) {
		    dest.words = new Array(this.length);
		    for (var i = 0; i < this.length; i++) {
		      dest.words[i] = this.words[i];
		    }
		    dest.length = this.length;
		    dest.negative = this.negative;
		    dest.red = this.red;
		  };

		  function move (dest, src) {
		    dest.words = src.words;
		    dest.length = src.length;
		    dest.negative = src.negative;
		    dest.red = src.red;
		  }

		  BN.prototype._move = function _move (dest) {
		    move(dest, this);
		  };

		  BN.prototype.clone = function clone () {
		    var r = new BN(null);
		    this.copy(r);
		    return r;
		  };

		  BN.prototype._expand = function _expand (size) {
		    while (this.length < size) {
		      this.words[this.length++] = 0;
		    }
		    return this;
		  };

		  // Remove leading `0` from `this`
		  BN.prototype._strip = function strip () {
		    while (this.length > 1 && this.words[this.length - 1] === 0) {
		      this.length--;
		    }
		    return this._normSign();
		  };

		  BN.prototype._normSign = function _normSign () {
		    // -0 = 0
		    if (this.length === 1 && this.words[0] === 0) {
		      this.negative = 0;
		    }
		    return this;
		  };

		  // Check Symbol.for because not everywhere where Symbol defined
		  // See https://developer.mozilla.org/en-US/docs/Web/JavaScript/Reference/Global_Objects/Symbol#Browser_compatibility
		  if (typeof Symbol !== 'undefined' && typeof Symbol.for === 'function') {
		    try {
		      BN.prototype[Symbol.for('nodejs.util.inspect.custom')] = inspect;
		    } catch (e) {
		      BN.prototype.inspect = inspect;
		    }
		  } else {
		    BN.prototype.inspect = inspect;
		  }

		  function inspect () {
		    return (this.red ? '<BN-R: ' : '<BN: ') + this.toString(16) + '>';
		  }

		  /*

		  var zeros = [];
		  var groupSizes = [];
		  var groupBases = [];

		  var s = '';
		  var i = -1;
		  while (++i < BN.wordSize) {
		    zeros[i] = s;
		    s += '0';
		  }
		  groupSizes[0] = 0;
		  groupSizes[1] = 0;
		  groupBases[0] = 0;
		  groupBases[1] = 0;
		  var base = 2 - 1;
		  while (++base < 36 + 1) {
		    var groupSize = 0;
		    var groupBase = 1;
		    while (groupBase < (1 << BN.wordSize) / base) {
		      groupBase *= base;
		      groupSize += 1;
		    }
		    groupSizes[base] = groupSize;
		    groupBases[base] = groupBase;
		  }

		  */

		  var zeros = [
		    '',
		    '0',
		    '00',
		    '000',
		    '0000',
		    '00000',
		    '000000',
		    '0000000',
		    '00000000',
		    '000000000',
		    '0000000000',
		    '00000000000',
		    '000000000000',
		    '0000000000000',
		    '00000000000000',
		    '000000000000000',
		    '0000000000000000',
		    '00000000000000000',
		    '000000000000000000',
		    '0000000000000000000',
		    '00000000000000000000',
		    '000000000000000000000',
		    '0000000000000000000000',
		    '00000000000000000000000',
		    '000000000000000000000000',
		    '0000000000000000000000000'
		  ];

		  var groupSizes = [
		    0, 0,
		    25, 16, 12, 11, 10, 9, 8,
		    8, 7, 7, 7, 7, 6, 6,
		    6, 6, 6, 6, 6, 5, 5,
		    5, 5, 5, 5, 5, 5, 5,
		    5, 5, 5, 5, 5, 5, 5
		  ];

		  var groupBases = [
		    0, 0,
		    33554432, 43046721, 16777216, 48828125, 60466176, 40353607, 16777216,
		    43046721, 10000000, 19487171, 35831808, 62748517, 7529536, 11390625,
		    16777216, 24137569, 34012224, 47045881, 64000000, 4084101, 5153632,
		    6436343, 7962624, 9765625, 11881376, 14348907, 17210368, 20511149,
		    24300000, 28629151, 33554432, 39135393, 45435424, 52521875, 60466176
		  ];

		  BN.prototype.toString = function toString (base, padding) {
		    base = base || 10;
		    padding = padding | 0 || 1;

		    var out;
		    if (base === 16 || base === 'hex') {
		      out = '';
		      var off = 0;
		      var carry = 0;
		      for (var i = 0; i < this.length; i++) {
		        var w = this.words[i];
		        var word = (((w << off) | carry) & 0xffffff).toString(16);
		        carry = (w >>> (24 - off)) & 0xffffff;
		        off += 2;
		        if (off >= 26) {
		          off -= 26;
		          i--;
		        }
		        if (carry !== 0 || i !== this.length - 1) {
		          out = zeros[6 - word.length] + word + out;
		        } else {
		          out = word + out;
		        }
		      }
		      if (carry !== 0) {
		        out = carry.toString(16) + out;
		      }
		      while (out.length % padding !== 0) {
		        out = '0' + out;
		      }
		      if (this.negative !== 0) {
		        out = '-' + out;
		      }
		      return out;
		    }

		    if (base === (base | 0) && base >= 2 && base <= 36) {
		      // var groupSize = Math.floor(BN.wordSize * Math.LN2 / Math.log(base));
		      var groupSize = groupSizes[base];
		      // var groupBase = Math.pow(base, groupSize);
		      var groupBase = groupBases[base];
		      out = '';
		      var c = this.clone();
		      c.negative = 0;
		      while (!c.isZero()) {
		        var r = c.modrn(groupBase).toString(base);
		        c = c.idivn(groupBase);

		        if (!c.isZero()) {
		          out = zeros[groupSize - r.length] + r + out;
		        } else {
		          out = r + out;
		        }
		      }
		      if (this.isZero()) {
		        out = '0' + out;
		      }
		      while (out.length % padding !== 0) {
		        out = '0' + out;
		      }
		      if (this.negative !== 0) {
		        out = '-' + out;
		      }
		      return out;
		    }

		    assert(false, 'Base should be between 2 and 36');
		  };

		  BN.prototype.toNumber = function toNumber () {
		    var ret = this.words[0];
		    if (this.length === 2) {
		      ret += this.words[1] * 0x4000000;
		    } else if (this.length === 3 && this.words[2] === 0x01) {
		      // NOTE: at this stage it is known that the top bit is set
		      ret += 0x10000000000000 + (this.words[1] * 0x4000000);
		    } else if (this.length > 2) {
		      assert(false, 'Number can only safely store up to 53 bits');
		    }
		    return (this.negative !== 0) ? -ret : ret;
		  };

		  BN.prototype.toJSON = function toJSON () {
		    return this.toString(16, 2);
		  };

		  if (Buffer) {
		    BN.prototype.toBuffer = function toBuffer (endian, length) {
		      return this.toArrayLike(Buffer, endian, length);
		    };
		  }

		  BN.prototype.toArray = function toArray (endian, length) {
		    return this.toArrayLike(Array, endian, length);
		  };

		  var allocate = function allocate (ArrayType, size) {
		    if (ArrayType.allocUnsafe) {
		      return ArrayType.allocUnsafe(size);
		    }
		    return new ArrayType(size);
		  };

		  BN.prototype.toArrayLike = function toArrayLike (ArrayType, endian, length) {
		    this._strip();

		    var byteLength = this.byteLength();
		    var reqLength = length || Math.max(1, byteLength);
		    assert(byteLength <= reqLength, 'byte array longer than desired length');
		    assert(reqLength > 0, 'Requested array length <= 0');

		    var res = allocate(ArrayType, reqLength);
		    var postfix = endian === 'le' ? 'LE' : 'BE';
		    this['_toArrayLike' + postfix](res, byteLength);
		    return res;
		  };

		  BN.prototype._toArrayLikeLE = function _toArrayLikeLE (res, byteLength) {
		    var position = 0;
		    var carry = 0;

		    for (var i = 0, shift = 0; i < this.length; i++) {
		      var word = (this.words[i] << shift) | carry;

		      res[position++] = word & 0xff;
		      if (position < res.length) {
		        res[position++] = (word >> 8) & 0xff;
		      }
		      if (position < res.length) {
		        res[position++] = (word >> 16) & 0xff;
		      }

		      if (shift === 6) {
		        if (position < res.length) {
		          res[position++] = (word >> 24) & 0xff;
		        }
		        carry = 0;
		        shift = 0;
		      } else {
		        carry = word >>> 24;
		        shift += 2;
		      }
		    }

		    if (position < res.length) {
		      res[position++] = carry;

		      while (position < res.length) {
		        res[position++] = 0;
		      }
		    }
		  };

		  BN.prototype._toArrayLikeBE = function _toArrayLikeBE (res, byteLength) {
		    var position = res.length - 1;
		    var carry = 0;

		    for (var i = 0, shift = 0; i < this.length; i++) {
		      var word = (this.words[i] << shift) | carry;

		      res[position--] = word & 0xff;
		      if (position >= 0) {
		        res[position--] = (word >> 8) & 0xff;
		      }
		      if (position >= 0) {
		        res[position--] = (word >> 16) & 0xff;
		      }

		      if (shift === 6) {
		        if (position >= 0) {
		          res[position--] = (word >> 24) & 0xff;
		        }
		        carry = 0;
		        shift = 0;
		      } else {
		        carry = word >>> 24;
		        shift += 2;
		      }
		    }

		    if (position >= 0) {
		      res[position--] = carry;

		      while (position >= 0) {
		        res[position--] = 0;
		      }
		    }
		  };

		  if (Math.clz32) {
		    BN.prototype._countBits = function _countBits (w) {
		      return 32 - Math.clz32(w);
		    };
		  } else {
		    BN.prototype._countBits = function _countBits (w) {
		      var t = w;
		      var r = 0;
		      if (t >= 0x1000) {
		        r += 13;
		        t >>>= 13;
		      }
		      if (t >= 0x40) {
		        r += 7;
		        t >>>= 7;
		      }
		      if (t >= 0x8) {
		        r += 4;
		        t >>>= 4;
		      }
		      if (t >= 0x02) {
		        r += 2;
		        t >>>= 2;
		      }
		      return r + t;
		    };
		  }

		  BN.prototype._zeroBits = function _zeroBits (w) {
		    // Short-cut
		    if (w === 0) return 26;

		    var t = w;
		    var r = 0;
		    if ((t & 0x1fff) === 0) {
		      r += 13;
		      t >>>= 13;
		    }
		    if ((t & 0x7f) === 0) {
		      r += 7;
		      t >>>= 7;
		    }
		    if ((t & 0xf) === 0) {
		      r += 4;
		      t >>>= 4;
		    }
		    if ((t & 0x3) === 0) {
		      r += 2;
		      t >>>= 2;
		    }
		    if ((t & 0x1) === 0) {
		      r++;
		    }
		    return r;
		  };

		  // Return number of used bits in a BN
		  BN.prototype.bitLength = function bitLength () {
		    var w = this.words[this.length - 1];
		    var hi = this._countBits(w);
		    return (this.length - 1) * 26 + hi;
		  };

		  function toBitArray (num) {
		    var w = new Array(num.bitLength());

		    for (var bit = 0; bit < w.length; bit++) {
		      var off = (bit / 26) | 0;
		      var wbit = bit % 26;

		      w[bit] = (num.words[off] >>> wbit) & 0x01;
		    }

		    return w;
		  }

		  // Number of trailing zero bits
		  BN.prototype.zeroBits = function zeroBits () {
		    if (this.isZero()) return 0;

		    var r = 0;
		    for (var i = 0; i < this.length; i++) {
		      var b = this._zeroBits(this.words[i]);
		      r += b;
		      if (b !== 26) break;
		    }
		    return r;
		  };

		  BN.prototype.byteLength = function byteLength () {
		    return Math.ceil(this.bitLength() / 8);
		  };

		  BN.prototype.toTwos = function toTwos (width) {
		    if (this.negative !== 0) {
		      return this.abs().inotn(width).iaddn(1);
		    }
		    return this.clone();
		  };

		  BN.prototype.fromTwos = function fromTwos (width) {
		    if (this.testn(width - 1)) {
		      return this.notn(width).iaddn(1).ineg();
		    }
		    return this.clone();
		  };

		  BN.prototype.isNeg = function isNeg () {
		    return this.negative !== 0;
		  };

		  // Return negative clone of `this`
		  BN.prototype.neg = function neg () {
		    return this.clone().ineg();
		  };

		  BN.prototype.ineg = function ineg () {
		    if (!this.isZero()) {
		      this.negative ^= 1;
		    }

		    return this;
		  };

		  // Or `num` with `this` in-place
		  BN.prototype.iuor = function iuor (num) {
		    while (this.length < num.length) {
		      this.words[this.length++] = 0;
		    }

		    for (var i = 0; i < num.length; i++) {
		      this.words[i] = this.words[i] | num.words[i];
		    }

		    return this._strip();
		  };

		  BN.prototype.ior = function ior (num) {
		    assert((this.negative | num.negative) === 0);
		    return this.iuor(num);
		  };

		  // Or `num` with `this`
		  BN.prototype.or = function or (num) {
		    if (this.length > num.length) return this.clone().ior(num);
		    return num.clone().ior(this);
		  };

		  BN.prototype.uor = function uor (num) {
		    if (this.length > num.length) return this.clone().iuor(num);
		    return num.clone().iuor(this);
		  };

		  // And `num` with `this` in-place
		  BN.prototype.iuand = function iuand (num) {
		    // b = min-length(num, this)
		    var b;
		    if (this.length > num.length) {
		      b = num;
		    } else {
		      b = this;
		    }

		    for (var i = 0; i < b.length; i++) {
		      this.words[i] = this.words[i] & num.words[i];
		    }

		    this.length = b.length;

		    return this._strip();
		  };

		  BN.prototype.iand = function iand (num) {
		    assert((this.negative | num.negative) === 0);
		    return this.iuand(num);
		  };

		  // And `num` with `this`
		  BN.prototype.and = function and (num) {
		    if (this.length > num.length) return this.clone().iand(num);
		    return num.clone().iand(this);
		  };

		  BN.prototype.uand = function uand (num) {
		    if (this.length > num.length) return this.clone().iuand(num);
		    return num.clone().iuand(this);
		  };

		  // Xor `num` with `this` in-place
		  BN.prototype.iuxor = function iuxor (num) {
		    // a.length > b.length
		    var a;
		    var b;
		    if (this.length > num.length) {
		      a = this;
		      b = num;
		    } else {
		      a = num;
		      b = this;
		    }

		    for (var i = 0; i < b.length; i++) {
		      this.words[i] = a.words[i] ^ b.words[i];
		    }

		    if (this !== a) {
		      for (; i < a.length; i++) {
		        this.words[i] = a.words[i];
		      }
		    }

		    this.length = a.length;

		    return this._strip();
		  };

		  BN.prototype.ixor = function ixor (num) {
		    assert((this.negative | num.negative) === 0);
		    return this.iuxor(num);
		  };

		  // Xor `num` with `this`
		  BN.prototype.xor = function xor (num) {
		    if (this.length > num.length) return this.clone().ixor(num);
		    return num.clone().ixor(this);
		  };

		  BN.prototype.uxor = function uxor (num) {
		    if (this.length > num.length) return this.clone().iuxor(num);
		    return num.clone().iuxor(this);
		  };

		  // Not ``this`` with ``width`` bitwidth
		  BN.prototype.inotn = function inotn (width) {
		    assert(typeof width === 'number' && width >= 0);

		    var bytesNeeded = Math.ceil(width / 26) | 0;
		    var bitsLeft = width % 26;

		    // Extend the buffer with leading zeroes
		    this._expand(bytesNeeded);

		    if (bitsLeft > 0) {
		      bytesNeeded--;
		    }

		    // Handle complete words
		    for (var i = 0; i < bytesNeeded; i++) {
		      this.words[i] = ~this.words[i] & 0x3ffffff;
		    }

		    // Handle the residue
		    if (bitsLeft > 0) {
		      this.words[i] = ~this.words[i] & (0x3ffffff >> (26 - bitsLeft));
		    }

		    // And remove leading zeroes
		    return this._strip();
		  };

		  BN.prototype.notn = function notn (width) {
		    return this.clone().inotn(width);
		  };

		  // Set `bit` of `this`
		  BN.prototype.setn = function setn (bit, val) {
		    assert(typeof bit === 'number' && bit >= 0);

		    var off = (bit / 26) | 0;
		    var wbit = bit % 26;

		    this._expand(off + 1);

		    if (val) {
		      this.words[off] = this.words[off] | (1 << wbit);
		    } else {
		      this.words[off] = this.words[off] & ~(1 << wbit);
		    }

		    return this._strip();
		  };

		  // Add `num` to `this` in-place
		  BN.prototype.iadd = function iadd (num) {
		    var r;

		    // negative + positive
		    if (this.negative !== 0 && num.negative === 0) {
		      this.negative = 0;
		      r = this.isub(num);
		      this.negative ^= 1;
		      return this._normSign();

		    // positive + negative
		    } else if (this.negative === 0 && num.negative !== 0) {
		      num.negative = 0;
		      r = this.isub(num);
		      num.negative = 1;
		      return r._normSign();
		    }

		    // a.length > b.length
		    var a, b;
		    if (this.length > num.length) {
		      a = this;
		      b = num;
		    } else {
		      a = num;
		      b = this;
		    }

		    var carry = 0;
		    for (var i = 0; i < b.length; i++) {
		      r = (a.words[i] | 0) + (b.words[i] | 0) + carry;
		      this.words[i] = r & 0x3ffffff;
		      carry = r >>> 26;
		    }
		    for (; carry !== 0 && i < a.length; i++) {
		      r = (a.words[i] | 0) + carry;
		      this.words[i] = r & 0x3ffffff;
		      carry = r >>> 26;
		    }

		    this.length = a.length;
		    if (carry !== 0) {
		      this.words[this.length] = carry;
		      this.length++;
		    // Copy the rest of the words
		    } else if (a !== this) {
		      for (; i < a.length; i++) {
		        this.words[i] = a.words[i];
		      }
		    }

		    return this;
		  };

		  // Add `num` to `this`
		  BN.prototype.add = function add (num) {
		    var res;
		    if (num.negative !== 0 && this.negative === 0) {
		      num.negative = 0;
		      res = this.sub(num);
		      num.negative ^= 1;
		      return res;
		    } else if (num.negative === 0 && this.negative !== 0) {
		      this.negative = 0;
		      res = num.sub(this);
		      this.negative = 1;
		      return res;
		    }

		    if (this.length > num.length) return this.clone().iadd(num);

		    return num.clone().iadd(this);
		  };

		  // Subtract `num` from `this` in-place
		  BN.prototype.isub = function isub (num) {
		    // this - (-num) = this + num
		    if (num.negative !== 0) {
		      num.negative = 0;
		      var r = this.iadd(num);
		      num.negative = 1;
		      return r._normSign();

		    // -this - num = -(this + num)
		    } else if (this.negative !== 0) {
		      this.negative = 0;
		      this.iadd(num);
		      this.negative = 1;
		      return this._normSign();
		    }

		    // At this point both numbers are positive
		    var cmp = this.cmp(num);

		    // Optimization - zeroify
		    if (cmp === 0) {
		      this.negative = 0;
		      this.length = 1;
		      this.words[0] = 0;
		      return this;
		    }

		    // a > b
		    var a, b;
		    if (cmp > 0) {
		      a = this;
		      b = num;
		    } else {
		      a = num;
		      b = this;
		    }

		    var carry = 0;
		    for (var i = 0; i < b.length; i++) {
		      r = (a.words[i] | 0) - (b.words[i] | 0) + carry;
		      carry = r >> 26;
		      this.words[i] = r & 0x3ffffff;
		    }
		    for (; carry !== 0 && i < a.length; i++) {
		      r = (a.words[i] | 0) + carry;
		      carry = r >> 26;
		      this.words[i] = r & 0x3ffffff;
		    }

		    // Copy rest of the words
		    if (carry === 0 && i < a.length && a !== this) {
		      for (; i < a.length; i++) {
		        this.words[i] = a.words[i];
		      }
		    }

		    this.length = Math.max(this.length, i);

		    if (a !== this) {
		      this.negative = 1;
		    }

		    return this._strip();
		  };

		  // Subtract `num` from `this`
		  BN.prototype.sub = function sub (num) {
		    return this.clone().isub(num);
		  };

		  function smallMulTo (self, num, out) {
		    out.negative = num.negative ^ self.negative;
		    var len = (self.length + num.length) | 0;
		    out.length = len;
		    len = (len - 1) | 0;

		    // Peel one iteration (compiler can't do it, because of code complexity)
		    var a = self.words[0] | 0;
		    var b = num.words[0] | 0;
		    var r = a * b;

		    var lo = r & 0x3ffffff;
		    var carry = (r / 0x4000000) | 0;
		    out.words[0] = lo;

		    for (var k = 1; k < len; k++) {
		      // Sum all words with the same `i + j = k` and accumulate `ncarry`,
		      // note that ncarry could be >= 0x3ffffff
		      var ncarry = carry >>> 26;
		      var rword = carry & 0x3ffffff;
		      var maxJ = Math.min(k, num.length - 1);
		      for (var j = Math.max(0, k - self.length + 1); j <= maxJ; j++) {
		        var i = (k - j) | 0;
		        a = self.words[i] | 0;
		        b = num.words[j] | 0;
		        r = a * b + rword;
		        ncarry += (r / 0x4000000) | 0;
		        rword = r & 0x3ffffff;
		      }
		      out.words[k] = rword | 0;
		      carry = ncarry | 0;
		    }
		    if (carry !== 0) {
		      out.words[k] = carry | 0;
		    } else {
		      out.length--;
		    }

		    return out._strip();
		  }

		  // TODO(indutny): it may be reasonable to omit it for users who don't need
		  // to work with 256-bit numbers, otherwise it gives 20% improvement for 256-bit
		  // multiplication (like elliptic secp256k1).
		  var comb10MulTo = function comb10MulTo (self, num, out) {
		    var a = self.words;
		    var b = num.words;
		    var o = out.words;
		    var c = 0;
		    var lo;
		    var mid;
		    var hi;
		    var a0 = a[0] | 0;
		    var al0 = a0 & 0x1fff;
		    var ah0 = a0 >>> 13;
		    var a1 = a[1] | 0;
		    var al1 = a1 & 0x1fff;
		    var ah1 = a1 >>> 13;
		    var a2 = a[2] | 0;
		    var al2 = a2 & 0x1fff;
		    var ah2 = a2 >>> 13;
		    var a3 = a[3] | 0;
		    var al3 = a3 & 0x1fff;
		    var ah3 = a3 >>> 13;
		    var a4 = a[4] | 0;
		    var al4 = a4 & 0x1fff;
		    var ah4 = a4 >>> 13;
		    var a5 = a[5] | 0;
		    var al5 = a5 & 0x1fff;
		    var ah5 = a5 >>> 13;
		    var a6 = a[6] | 0;
		    var al6 = a6 & 0x1fff;
		    var ah6 = a6 >>> 13;
		    var a7 = a[7] | 0;
		    var al7 = a7 & 0x1fff;
		    var ah7 = a7 >>> 13;
		    var a8 = a[8] | 0;
		    var al8 = a8 & 0x1fff;
		    var ah8 = a8 >>> 13;
		    var a9 = a[9] | 0;
		    var al9 = a9 & 0x1fff;
		    var ah9 = a9 >>> 13;
		    var b0 = b[0] | 0;
		    var bl0 = b0 & 0x1fff;
		    var bh0 = b0 >>> 13;
		    var b1 = b[1] | 0;
		    var bl1 = b1 & 0x1fff;
		    var bh1 = b1 >>> 13;
		    var b2 = b[2] | 0;
		    var bl2 = b2 & 0x1fff;
		    var bh2 = b2 >>> 13;
		    var b3 = b[3] | 0;
		    var bl3 = b3 & 0x1fff;
		    var bh3 = b3 >>> 13;
		    var b4 = b[4] | 0;
		    var bl4 = b4 & 0x1fff;
		    var bh4 = b4 >>> 13;
		    var b5 = b[5] | 0;
		    var bl5 = b5 & 0x1fff;
		    var bh5 = b5 >>> 13;
		    var b6 = b[6] | 0;
		    var bl6 = b6 & 0x1fff;
		    var bh6 = b6 >>> 13;
		    var b7 = b[7] | 0;
		    var bl7 = b7 & 0x1fff;
		    var bh7 = b7 >>> 13;
		    var b8 = b[8] | 0;
		    var bl8 = b8 & 0x1fff;
		    var bh8 = b8 >>> 13;
		    var b9 = b[9] | 0;
		    var bl9 = b9 & 0x1fff;
		    var bh9 = b9 >>> 13;

		    out.negative = self.negative ^ num.negative;
		    out.length = 19;
		    /* k = 0 */
		    lo = Math.imul(al0, bl0);
		    mid = Math.imul(al0, bh0);
		    mid = (mid + Math.imul(ah0, bl0)) | 0;
		    hi = Math.imul(ah0, bh0);
		    var w0 = (((c + lo) | 0) + ((mid & 0x1fff) << 13)) | 0;
		    c = (((hi + (mid >>> 13)) | 0) + (w0 >>> 26)) | 0;
		    w0 &= 0x3ffffff;
		    /* k = 1 */
		    lo = Math.imul(al1, bl0);
		    mid = Math.imul(al1, bh0);
		    mid = (mid + Math.imul(ah1, bl0)) | 0;
		    hi = Math.imul(ah1, bh0);
		    lo = (lo + Math.imul(al0, bl1)) | 0;
		    mid = (mid + Math.imul(al0, bh1)) | 0;
		    mid = (mid + Math.imul(ah0, bl1)) | 0;
		    hi = (hi + Math.imul(ah0, bh1)) | 0;
		    var w1 = (((c + lo) | 0) + ((mid & 0x1fff) << 13)) | 0;
		    c = (((hi + (mid >>> 13)) | 0) + (w1 >>> 26)) | 0;
		    w1 &= 0x3ffffff;
		    /* k = 2 */
		    lo = Math.imul(al2, bl0);
		    mid = Math.imul(al2, bh0);
		    mid = (mid + Math.imul(ah2, bl0)) | 0;
		    hi = Math.imul(ah2, bh0);
		    lo = (lo + Math.imul(al1, bl1)) | 0;
		    mid = (mid + Math.imul(al1, bh1)) | 0;
		    mid = (mid + Math.imul(ah1, bl1)) | 0;
		    hi = (hi + Math.imul(ah1, bh1)) | 0;
		    lo = (lo + Math.imul(al0, bl2)) | 0;
		    mid = (mid + Math.imul(al0, bh2)) | 0;
		    mid = (mid + Math.imul(ah0, bl2)) | 0;
		    hi = (hi + Math.imul(ah0, bh2)) | 0;
		    var w2 = (((c + lo) | 0) + ((mid & 0x1fff) << 13)) | 0;
		    c = (((hi + (mid >>> 13)) | 0) + (w2 >>> 26)) | 0;
		    w2 &= 0x3ffffff;
		    /* k = 3 */
		    lo = Math.imul(al3, bl0);
		    mid = Math.imul(al3, bh0);
		    mid = (mid + Math.imul(ah3, bl0)) | 0;
		    hi = Math.imul(ah3, bh0);
		    lo = (lo + Math.imul(al2, bl1)) | 0;
		    mid = (mid + Math.imul(al2, bh1)) | 0;
		    mid = (mid + Math.imul(ah2, bl1)) | 0;
		    hi = (hi + Math.imul(ah2, bh1)) | 0;
		    lo = (lo + Math.imul(al1, bl2)) | 0;
		    mid = (mid + Math.imul(al1, bh2)) | 0;
		    mid = (mid + Math.imul(ah1, bl2)) | 0;
		    hi = (hi + Math.imul(ah1, bh2)) | 0;
		    lo = (lo + Math.imul(al0, bl3)) | 0;
		    mid = (mid + Math.imul(al0, bh3)) | 0;
		    mid = (mid + Math.imul(ah0, bl3)) | 0;
		    hi = (hi + Math.imul(ah0, bh3)) | 0;
		    var w3 = (((c + lo) | 0) + ((mid & 0x1fff) << 13)) | 0;
		    c = (((hi + (mid >>> 13)) | 0) + (w3 >>> 26)) | 0;
		    w3 &= 0x3ffffff;
		    /* k = 4 */
		    lo = Math.imul(al4, bl0);
		    mid = Math.imul(al4, bh0);
		    mid = (mid + Math.imul(ah4, bl0)) | 0;
		    hi = Math.imul(ah4, bh0);
		    lo = (lo + Math.imul(al3, bl1)) | 0;
		    mid = (mid + Math.imul(al3, bh1)) | 0;
		    mid = (mid + Math.imul(ah3, bl1)) | 0;
		    hi = (hi + Math.imul(ah3, bh1)) | 0;
		    lo = (lo + Math.imul(al2, bl2)) | 0;
		    mid = (mid + Math.imul(al2, bh2)) | 0;
		    mid = (mid + Math.imul(ah2, bl2)) | 0;
		    hi = (hi + Math.imul(ah2, bh2)) | 0;
		    lo = (lo + Math.imul(al1, bl3)) | 0;
		    mid = (mid + Math.imul(al1, bh3)) | 0;
		    mid = (mid + Math.imul(ah1, bl3)) | 0;
		    hi = (hi + Math.imul(ah1, bh3)) | 0;
		    lo = (lo + Math.imul(al0, bl4)) | 0;
		    mid = (mid + Math.imul(al0, bh4)) | 0;
		    mid = (mid + Math.imul(ah0, bl4)) | 0;
		    hi = (hi + Math.imul(ah0, bh4)) | 0;
		    var w4 = (((c + lo) | 0) + ((mid & 0x1fff) << 13)) | 0;
		    c = (((hi + (mid >>> 13)) | 0) + (w4 >>> 26)) | 0;
		    w4 &= 0x3ffffff;
		    /* k = 5 */
		    lo = Math.imul(al5, bl0);
		    mid = Math.imul(al5, bh0);
		    mid = (mid + Math.imul(ah5, bl0)) | 0;
		    hi = Math.imul(ah5, bh0);
		    lo = (lo + Math.imul(al4, bl1)) | 0;
		    mid = (mid + Math.imul(al4, bh1)) | 0;
		    mid = (mid + Math.imul(ah4, bl1)) | 0;
		    hi = (hi + Math.imul(ah4, bh1)) | 0;
		    lo = (lo + Math.imul(al3, bl2)) | 0;
		    mid = (mid + Math.imul(al3, bh2)) | 0;
		    mid = (mid + Math.imul(ah3, bl2)) | 0;
		    hi = (hi + Math.imul(ah3, bh2)) | 0;
		    lo = (lo + Math.imul(al2, bl3)) | 0;
		    mid = (mid + Math.imul(al2, bh3)) | 0;
		    mid = (mid + Math.imul(ah2, bl3)) | 0;
		    hi = (hi + Math.imul(ah2, bh3)) | 0;
		    lo = (lo + Math.imul(al1, bl4)) | 0;
		    mid = (mid + Math.imul(al1, bh4)) | 0;
		    mid = (mid + Math.imul(ah1, bl4)) | 0;
		    hi = (hi + Math.imul(ah1, bh4)) | 0;
		    lo = (lo + Math.imul(al0, bl5)) | 0;
		    mid = (mid + Math.imul(al0, bh5)) | 0;
		    mid = (mid + Math.imul(ah0, bl5)) | 0;
		    hi = (hi + Math.imul(ah0, bh5)) | 0;
		    var w5 = (((c + lo) | 0) + ((mid & 0x1fff) << 13)) | 0;
		    c = (((hi + (mid >>> 13)) | 0) + (w5 >>> 26)) | 0;
		    w5 &= 0x3ffffff;
		    /* k = 6 */
		    lo = Math.imul(al6, bl0);
		    mid = Math.imul(al6, bh0);
		    mid = (mid + Math.imul(ah6, bl0)) | 0;
		    hi = Math.imul(ah6, bh0);
		    lo = (lo + Math.imul(al5, bl1)) | 0;
		    mid = (mid + Math.imul(al5, bh1)) | 0;
		    mid = (mid + Math.imul(ah5, bl1)) | 0;
		    hi = (hi + Math.imul(ah5, bh1)) | 0;
		    lo = (lo + Math.imul(al4, bl2)) | 0;
		    mid = (mid + Math.imul(al4, bh2)) | 0;
		    mid = (mid + Math.imul(ah4, bl2)) | 0;
		    hi = (hi + Math.imul(ah4, bh2)) | 0;
		    lo = (lo + Math.imul(al3, bl3)) | 0;
		    mid = (mid + Math.imul(al3, bh3)) | 0;
		    mid = (mid + Math.imul(ah3, bl3)) | 0;
		    hi = (hi + Math.imul(ah3, bh3)) | 0;
		    lo = (lo + Math.imul(al2, bl4)) | 0;
		    mid = (mid + Math.imul(al2, bh4)) | 0;
		    mid = (mid + Math.imul(ah2, bl4)) | 0;
		    hi = (hi + Math.imul(ah2, bh4)) | 0;
		    lo = (lo + Math.imul(al1, bl5)) | 0;
		    mid = (mid + Math.imul(al1, bh5)) | 0;
		    mid = (mid + Math.imul(ah1, bl5)) | 0;
		    hi = (hi + Math.imul(ah1, bh5)) | 0;
		    lo = (lo + Math.imul(al0, bl6)) | 0;
		    mid = (mid + Math.imul(al0, bh6)) | 0;
		    mid = (mid + Math.imul(ah0, bl6)) | 0;
		    hi = (hi + Math.imul(ah0, bh6)) | 0;
		    var w6 = (((c + lo) | 0) + ((mid & 0x1fff) << 13)) | 0;
		    c = (((hi + (mid >>> 13)) | 0) + (w6 >>> 26)) | 0;
		    w6 &= 0x3ffffff;
		    /* k = 7 */
		    lo = Math.imul(al7, bl0);
		    mid = Math.imul(al7, bh0);
		    mid = (mid + Math.imul(ah7, bl0)) | 0;
		    hi = Math.imul(ah7, bh0);
		    lo = (lo + Math.imul(al6, bl1)) | 0;
		    mid = (mid + Math.imul(al6, bh1)) | 0;
		    mid = (mid + Math.imul(ah6, bl1)) | 0;
		    hi = (hi + Math.imul(ah6, bh1)) | 0;
		    lo = (lo + Math.imul(al5, bl2)) | 0;
		    mid = (mid + Math.imul(al5, bh2)) | 0;
		    mid = (mid + Math.imul(ah5, bl2)) | 0;
		    hi = (hi + Math.imul(ah5, bh2)) | 0;
		    lo = (lo + Math.imul(al4, bl3)) | 0;
		    mid = (mid + Math.imul(al4, bh3)) | 0;
		    mid = (mid + Math.imul(ah4, bl3)) | 0;
		    hi = (hi + Math.imul(ah4, bh3)) | 0;
		    lo = (lo + Math.imul(al3, bl4)) | 0;
		    mid = (mid + Math.imul(al3, bh4)) | 0;
		    mid = (mid + Math.imul(ah3, bl4)) | 0;
		    hi = (hi + Math.imul(ah3, bh4)) | 0;
		    lo = (lo + Math.imul(al2, bl5)) | 0;
		    mid = (mid + Math.imul(al2, bh5)) | 0;
		    mid = (mid + Math.imul(ah2, bl5)) | 0;
		    hi = (hi + Math.imul(ah2, bh5)) | 0;
		    lo = (lo + Math.imul(al1, bl6)) | 0;
		    mid = (mid + Math.imul(al1, bh6)) | 0;
		    mid = (mid + Math.imul(ah1, bl6)) | 0;
		    hi = (hi + Math.imul(ah1, bh6)) | 0;
		    lo = (lo + Math.imul(al0, bl7)) | 0;
		    mid = (mid + Math.imul(al0, bh7)) | 0;
		    mid = (mid + Math.imul(ah0, bl7)) | 0;
		    hi = (hi + Math.imul(ah0, bh7)) | 0;
		    var w7 = (((c + lo) | 0) + ((mid & 0x1fff) << 13)) | 0;
		    c = (((hi + (mid >>> 13)) | 0) + (w7 >>> 26)) | 0;
		    w7 &= 0x3ffffff;
		    /* k = 8 */
		    lo = Math.imul(al8, bl0);
		    mid = Math.imul(al8, bh0);
		    mid = (mid + Math.imul(ah8, bl0)) | 0;
		    hi = Math.imul(ah8, bh0);
		    lo = (lo + Math.imul(al7, bl1)) | 0;
		    mid = (mid + Math.imul(al7, bh1)) | 0;
		    mid = (mid + Math.imul(ah7, bl1)) | 0;
		    hi = (hi + Math.imul(ah7, bh1)) | 0;
		    lo = (lo + Math.imul(al6, bl2)) | 0;
		    mid = (mid + Math.imul(al6, bh2)) | 0;
		    mid = (mid + Math.imul(ah6, bl2)) | 0;
		    hi = (hi + Math.imul(ah6, bh2)) | 0;
		    lo = (lo + Math.imul(al5, bl3)) | 0;
		    mid = (mid + Math.imul(al5, bh3)) | 0;
		    mid = (mid + Math.imul(ah5, bl3)) | 0;
		    hi = (hi + Math.imul(ah5, bh3)) | 0;
		    lo = (lo + Math.imul(al4, bl4)) | 0;
		    mid = (mid + Math.imul(al4, bh4)) | 0;
		    mid = (mid + Math.imul(ah4, bl4)) | 0;
		    hi = (hi + Math.imul(ah4, bh4)) | 0;
		    lo = (lo + Math.imul(al3, bl5)) | 0;
		    mid = (mid + Math.imul(al3, bh5)) | 0;
		    mid = (mid + Math.imul(ah3, bl5)) | 0;
		    hi = (hi + Math.imul(ah3, bh5)) | 0;
		    lo = (lo + Math.imul(al2, bl6)) | 0;
		    mid = (mid + Math.imul(al2, bh6)) | 0;
		    mid = (mid + Math.imul(ah2, bl6)) | 0;
		    hi = (hi + Math.imul(ah2, bh6)) | 0;
		    lo = (lo + Math.imul(al1, bl7)) | 0;
		    mid = (mid + Math.imul(al1, bh7)) | 0;
		    mid = (mid + Math.imul(ah1, bl7)) | 0;
		    hi = (hi + Math.imul(ah1, bh7)) | 0;
		    lo = (lo + Math.imul(al0, bl8)) | 0;
		    mid = (mid + Math.imul(al0, bh8)) | 0;
		    mid = (mid + Math.imul(ah0, bl8)) | 0;
		    hi = (hi + Math.imul(ah0, bh8)) | 0;
		    var w8 = (((c + lo) | 0) + ((mid & 0x1fff) << 13)) | 0;
		    c = (((hi + (mid >>> 13)) | 0) + (w8 >>> 26)) | 0;
		    w8 &= 0x3ffffff;
		    /* k = 9 */
		    lo = Math.imul(al9, bl0);
		    mid = Math.imul(al9, bh0);
		    mid = (mid + Math.imul(ah9, bl0)) | 0;
		    hi = Math.imul(ah9, bh0);
		    lo = (lo + Math.imul(al8, bl1)) | 0;
		    mid = (mid + Math.imul(al8, bh1)) | 0;
		    mid = (mid + Math.imul(ah8, bl1)) | 0;
		    hi = (hi + Math.imul(ah8, bh1)) | 0;
		    lo = (lo + Math.imul(al7, bl2)) | 0;
		    mid = (mid + Math.imul(al7, bh2)) | 0;
		    mid = (mid + Math.imul(ah7, bl2)) | 0;
		    hi = (hi + Math.imul(ah7, bh2)) | 0;
		    lo = (lo + Math.imul(al6, bl3)) | 0;
		    mid = (mid + Math.imul(al6, bh3)) | 0;
		    mid = (mid + Math.imul(ah6, bl3)) | 0;
		    hi = (hi + Math.imul(ah6, bh3)) | 0;
		    lo = (lo + Math.imul(al5, bl4)) | 0;
		    mid = (mid + Math.imul(al5, bh4)) | 0;
		    mid = (mid + Math.imul(ah5, bl4)) | 0;
		    hi = (hi + Math.imul(ah5, bh4)) | 0;
		    lo = (lo + Math.imul(al4, bl5)) | 0;
		    mid = (mid + Math.imul(al4, bh5)) | 0;
		    mid = (mid + Math.imul(ah4, bl5)) | 0;
		    hi = (hi + Math.imul(ah4, bh5)) | 0;
		    lo = (lo + Math.imul(al3, bl6)) | 0;
		    mid = (mid + Math.imul(al3, bh6)) | 0;
		    mid = (mid + Math.imul(ah3, bl6)) | 0;
		    hi = (hi + Math.imul(ah3, bh6)) | 0;
		    lo = (lo + Math.imul(al2, bl7)) | 0;
		    mid = (mid + Math.imul(al2, bh7)) | 0;
		    mid = (mid + Math.imul(ah2, bl7)) | 0;
		    hi = (hi + Math.imul(ah2, bh7)) | 0;
		    lo = (lo + Math.imul(al1, bl8)) | 0;
		    mid = (mid + Math.imul(al1, bh8)) | 0;
		    mid = (mid + Math.imul(ah1, bl8)) | 0;
		    hi = (hi + Math.imul(ah1, bh8)) | 0;
		    lo = (lo + Math.imul(al0, bl9)) | 0;
		    mid = (mid + Math.imul(al0, bh9)) | 0;
		    mid = (mid + Math.imul(ah0, bl9)) | 0;
		    hi = (hi + Math.imul(ah0, bh9)) | 0;
		    var w9 = (((c + lo) | 0) + ((mid & 0x1fff) << 13)) | 0;
		    c = (((hi + (mid >>> 13)) | 0) + (w9 >>> 26)) | 0;
		    w9 &= 0x3ffffff;
		    /* k = 10 */
		    lo = Math.imul(al9, bl1);
		    mid = Math.imul(al9, bh1);
		    mid = (mid + Math.imul(ah9, bl1)) | 0;
		    hi = Math.imul(ah9, bh1);
		    lo = (lo + Math.imul(al8, bl2)) | 0;
		    mid = (mid + Math.imul(al8, bh2)) | 0;
		    mid = (mid + Math.imul(ah8, bl2)) | 0;
		    hi = (hi + Math.imul(ah8, bh2)) | 0;
		    lo = (lo + Math.imul(al7, bl3)) | 0;
		    mid = (mid + Math.imul(al7, bh3)) | 0;
		    mid = (mid + Math.imul(ah7, bl3)) | 0;
		    hi = (hi + Math.imul(ah7, bh3)) | 0;
		    lo = (lo + Math.imul(al6, bl4)) | 0;
		    mid = (mid + Math.imul(al6, bh4)) | 0;
		    mid = (mid + Math.imul(ah6, bl4)) | 0;
		    hi = (hi + Math.imul(ah6, bh4)) | 0;
		    lo = (lo + Math.imul(al5, bl5)) | 0;
		    mid = (mid + Math.imul(al5, bh5)) | 0;
		    mid = (mid + Math.imul(ah5, bl5)) | 0;
		    hi = (hi + Math.imul(ah5, bh5)) | 0;
		    lo = (lo + Math.imul(al4, bl6)) | 0;
		    mid = (mid + Math.imul(al4, bh6)) | 0;
		    mid = (mid + Math.imul(ah4, bl6)) | 0;
		    hi = (hi + Math.imul(ah4, bh6)) | 0;
		    lo = (lo + Math.imul(al3, bl7)) | 0;
		    mid = (mid + Math.imul(al3, bh7)) | 0;
		    mid = (mid + Math.imul(ah3, bl7)) | 0;
		    hi = (hi + Math.imul(ah3, bh7)) | 0;
		    lo = (lo + Math.imul(al2, bl8)) | 0;
		    mid = (mid + Math.imul(al2, bh8)) | 0;
		    mid = (mid + Math.imul(ah2, bl8)) | 0;
		    hi = (hi + Math.imul(ah2, bh8)) | 0;
		    lo = (lo + Math.imul(al1, bl9)) | 0;
		    mid = (mid + Math.imul(al1, bh9)) | 0;
		    mid = (mid + Math.imul(ah1, bl9)) | 0;
		    hi = (hi + Math.imul(ah1, bh9)) | 0;
		    var w10 = (((c + lo) | 0) + ((mid & 0x1fff) << 13)) | 0;
		    c = (((hi + (mid >>> 13)) | 0) + (w10 >>> 26)) | 0;
		    w10 &= 0x3ffffff;
		    /* k = 11 */
		    lo = Math.imul(al9, bl2);
		    mid = Math.imul(al9, bh2);
		    mid = (mid + Math.imul(ah9, bl2)) | 0;
		    hi = Math.imul(ah9, bh2);
		    lo = (lo + Math.imul(al8, bl3)) | 0;
		    mid = (mid + Math.imul(al8, bh3)) | 0;
		    mid = (mid + Math.imul(ah8, bl3)) | 0;
		    hi = (hi + Math.imul(ah8, bh3)) | 0;
		    lo = (lo + Math.imul(al7, bl4)) | 0;
		    mid = (mid + Math.imul(al7, bh4)) | 0;
		    mid = (mid + Math.imul(ah7, bl4)) | 0;
		    hi = (hi + Math.imul(ah7, bh4)) | 0;
		    lo = (lo + Math.imul(al6, bl5)) | 0;
		    mid = (mid + Math.imul(al6, bh5)) | 0;
		    mid = (mid + Math.imul(ah6, bl5)) | 0;
		    hi = (hi + Math.imul(ah6, bh5)) | 0;
		    lo = (lo + Math.imul(al5, bl6)) | 0;
		    mid = (mid + Math.imul(al5, bh6)) | 0;
		    mid = (mid + Math.imul(ah5, bl6)) | 0;
		    hi = (hi + Math.imul(ah5, bh6)) | 0;
		    lo = (lo + Math.imul(al4, bl7)) | 0;
		    mid = (mid + Math.imul(al4, bh7)) | 0;
		    mid = (mid + Math.imul(ah4, bl7)) | 0;
		    hi = (hi + Math.imul(ah4, bh7)) | 0;
		    lo = (lo + Math.imul(al3, bl8)) | 0;
		    mid = (mid + Math.imul(al3, bh8)) | 0;
		    mid = (mid + Math.imul(ah3, bl8)) | 0;
		    hi = (hi + Math.imul(ah3, bh8)) | 0;
		    lo = (lo + Math.imul(al2, bl9)) | 0;
		    mid = (mid + Math.imul(al2, bh9)) | 0;
		    mid = (mid + Math.imul(ah2, bl9)) | 0;
		    hi = (hi + Math.imul(ah2, bh9)) | 0;
		    var w11 = (((c + lo) | 0) + ((mid & 0x1fff) << 13)) | 0;
		    c = (((hi + (mid >>> 13)) | 0) + (w11 >>> 26)) | 0;
		    w11 &= 0x3ffffff;
		    /* k = 12 */
		    lo = Math.imul(al9, bl3);
		    mid = Math.imul(al9, bh3);
		    mid = (mid + Math.imul(ah9, bl3)) | 0;
		    hi = Math.imul(ah9, bh3);
		    lo = (lo + Math.imul(al8, bl4)) | 0;
		    mid = (mid + Math.imul(al8, bh4)) | 0;
		    mid = (mid + Math.imul(ah8, bl4)) | 0;
		    hi = (hi + Math.imul(ah8, bh4)) | 0;
		    lo = (lo + Math.imul(al7, bl5)) | 0;
		    mid = (mid + Math.imul(al7, bh5)) | 0;
		    mid = (mid + Math.imul(ah7, bl5)) | 0;
		    hi = (hi + Math.imul(ah7, bh5)) | 0;
		    lo = (lo + Math.imul(al6, bl6)) | 0;
		    mid = (mid + Math.imul(al6, bh6)) | 0;
		    mid = (mid + Math.imul(ah6, bl6)) | 0;
		    hi = (hi + Math.imul(ah6, bh6)) | 0;
		    lo = (lo + Math.imul(al5, bl7)) | 0;
		    mid = (mid + Math.imul(al5, bh7)) | 0;
		    mid = (mid + Math.imul(ah5, bl7)) | 0;
		    hi = (hi + Math.imul(ah5, bh7)) | 0;
		    lo = (lo + Math.imul(al4, bl8)) | 0;
		    mid = (mid + Math.imul(al4, bh8)) | 0;
		    mid = (mid + Math.imul(ah4, bl8)) | 0;
		    hi = (hi + Math.imul(ah4, bh8)) | 0;
		    lo = (lo + Math.imul(al3, bl9)) | 0;
		    mid = (mid + Math.imul(al3, bh9)) | 0;
		    mid = (mid + Math.imul(ah3, bl9)) | 0;
		    hi = (hi + Math.imul(ah3, bh9)) | 0;
		    var w12 = (((c + lo) | 0) + ((mid & 0x1fff) << 13)) | 0;
		    c = (((hi + (mid >>> 13)) | 0) + (w12 >>> 26)) | 0;
		    w12 &= 0x3ffffff;
		    /* k = 13 */
		    lo = Math.imul(al9, bl4);
		    mid = Math.imul(al9, bh4);
		    mid = (mid + Math.imul(ah9, bl4)) | 0;
		    hi = Math.imul(ah9, bh4);
		    lo = (lo + Math.imul(al8, bl5)) | 0;
		    mid = (mid + Math.imul(al8, bh5)) | 0;
		    mid = (mid + Math.imul(ah8, bl5)) | 0;
		    hi = (hi + Math.imul(ah8, bh5)) | 0;
		    lo = (lo + Math.imul(al7, bl6)) | 0;
		    mid = (mid + Math.imul(al7, bh6)) | 0;
		    mid = (mid + Math.imul(ah7, bl6)) | 0;
		    hi = (hi + Math.imul(ah7, bh6)) | 0;
		    lo = (lo + Math.imul(al6, bl7)) | 0;
		    mid = (mid + Math.imul(al6, bh7)) | 0;
		    mid = (mid + Math.imul(ah6, bl7)) | 0;
		    hi = (hi + Math.imul(ah6, bh7)) | 0;
		    lo = (lo + Math.imul(al5, bl8)) | 0;
		    mid = (mid + Math.imul(al5, bh8)) | 0;
		    mid = (mid + Math.imul(ah5, bl8)) | 0;
		    hi = (hi + Math.imul(ah5, bh8)) | 0;
		    lo = (lo + Math.imul(al4, bl9)) | 0;
		    mid = (mid + Math.imul(al4, bh9)) | 0;
		    mid = (mid + Math.imul(ah4, bl9)) | 0;
		    hi = (hi + Math.imul(ah4, bh9)) | 0;
		    var w13 = (((c + lo) | 0) + ((mid & 0x1fff) << 13)) | 0;
		    c = (((hi + (mid >>> 13)) | 0) + (w13 >>> 26)) | 0;
		    w13 &= 0x3ffffff;
		    /* k = 14 */
		    lo = Math.imul(al9, bl5);
		    mid = Math.imul(al9, bh5);
		    mid = (mid + Math.imul(ah9, bl5)) | 0;
		    hi = Math.imul(ah9, bh5);
		    lo = (lo + Math.imul(al8, bl6)) | 0;
		    mid = (mid + Math.imul(al8, bh6)) | 0;
		    mid = (mid + Math.imul(ah8, bl6)) | 0;
		    hi = (hi + Math.imul(ah8, bh6)) | 0;
		    lo = (lo + Math.imul(al7, bl7)) | 0;
		    mid = (mid + Math.imul(al7, bh7)) | 0;
		    mid = (mid + Math.imul(ah7, bl7)) | 0;
		    hi = (hi + Math.imul(ah7, bh7)) | 0;
		    lo = (lo + Math.imul(al6, bl8)) | 0;
		    mid = (mid + Math.imul(al6, bh8)) | 0;
		    mid = (mid + Math.imul(ah6, bl8)) | 0;
		    hi = (hi + Math.imul(ah6, bh8)) | 0;
		    lo = (lo + Math.imul(al5, bl9)) | 0;
		    mid = (mid + Math.imul(al5, bh9)) | 0;
		    mid = (mid + Math.imul(ah5, bl9)) | 0;
		    hi = (hi + Math.imul(ah5, bh9)) | 0;
		    var w14 = (((c + lo) | 0) + ((mid & 0x1fff) << 13)) | 0;
		    c = (((hi + (mid >>> 13)) | 0) + (w14 >>> 26)) | 0;
		    w14 &= 0x3ffffff;
		    /* k = 15 */
		    lo = Math.imul(al9, bl6);
		    mid = Math.imul(al9, bh6);
		    mid = (mid + Math.imul(ah9, bl6)) | 0;
		    hi = Math.imul(ah9, bh6);
		    lo = (lo + Math.imul(al8, bl7)) | 0;
		    mid = (mid + Math.imul(al8, bh7)) | 0;
		    mid = (mid + Math.imul(ah8, bl7)) | 0;
		    hi = (hi + Math.imul(ah8, bh7)) | 0;
		    lo = (lo + Math.imul(al7, bl8)) | 0;
		    mid = (mid + Math.imul(al7, bh8)) | 0;
		    mid = (mid + Math.imul(ah7, bl8)) | 0;
		    hi = (hi + Math.imul(ah7, bh8)) | 0;
		    lo = (lo + Math.imul(al6, bl9)) | 0;
		    mid = (mid + Math.imul(al6, bh9)) | 0;
		    mid = (mid + Math.imul(ah6, bl9)) | 0;
		    hi = (hi + Math.imul(ah6, bh9)) | 0;
		    var w15 = (((c + lo) | 0) + ((mid & 0x1fff) << 13)) | 0;
		    c = (((hi + (mid >>> 13)) | 0) + (w15 >>> 26)) | 0;
		    w15 &= 0x3ffffff;
		    /* k = 16 */
		    lo = Math.imul(al9, bl7);
		    mid = Math.imul(al9, bh7);
		    mid = (mid + Math.imul(ah9, bl7)) | 0;
		    hi = Math.imul(ah9, bh7);
		    lo = (lo + Math.imul(al8, bl8)) | 0;
		    mid = (mid + Math.imul(al8, bh8)) | 0;
		    mid = (mid + Math.imul(ah8, bl8)) | 0;
		    hi = (hi + Math.imul(ah8, bh8)) | 0;
		    lo = (lo + Math.imul(al7, bl9)) | 0;
		    mid = (mid + Math.imul(al7, bh9)) | 0;
		    mid = (mid + Math.imul(ah7, bl9)) | 0;
		    hi = (hi + Math.imul(ah7, bh9)) | 0;
		    var w16 = (((c + lo) | 0) + ((mid & 0x1fff) << 13)) | 0;
		    c = (((hi + (mid >>> 13)) | 0) + (w16 >>> 26)) | 0;
		    w16 &= 0x3ffffff;
		    /* k = 17 */
		    lo = Math.imul(al9, bl8);
		    mid = Math.imul(al9, bh8);
		    mid = (mid + Math.imul(ah9, bl8)) | 0;
		    hi = Math.imul(ah9, bh8);
		    lo = (lo + Math.imul(al8, bl9)) | 0;
		    mid = (mid + Math.imul(al8, bh9)) | 0;
		    mid = (mid + Math.imul(ah8, bl9)) | 0;
		    hi = (hi + Math.imul(ah8, bh9)) | 0;
		    var w17 = (((c + lo) | 0) + ((mid & 0x1fff) << 13)) | 0;
		    c = (((hi + (mid >>> 13)) | 0) + (w17 >>> 26)) | 0;
		    w17 &= 0x3ffffff;
		    /* k = 18 */
		    lo = Math.imul(al9, bl9);
		    mid = Math.imul(al9, bh9);
		    mid = (mid + Math.imul(ah9, bl9)) | 0;
		    hi = Math.imul(ah9, bh9);
		    var w18 = (((c + lo) | 0) + ((mid & 0x1fff) << 13)) | 0;
		    c = (((hi + (mid >>> 13)) | 0) + (w18 >>> 26)) | 0;
		    w18 &= 0x3ffffff;
		    o[0] = w0;
		    o[1] = w1;
		    o[2] = w2;
		    o[3] = w3;
		    o[4] = w4;
		    o[5] = w5;
		    o[6] = w6;
		    o[7] = w7;
		    o[8] = w8;
		    o[9] = w9;
		    o[10] = w10;
		    o[11] = w11;
		    o[12] = w12;
		    o[13] = w13;
		    o[14] = w14;
		    o[15] = w15;
		    o[16] = w16;
		    o[17] = w17;
		    o[18] = w18;
		    if (c !== 0) {
		      o[19] = c;
		      out.length++;
		    }
		    return out;
		  };

		  // Polyfill comb
		  if (!Math.imul) {
		    comb10MulTo = smallMulTo;
		  }

		  function bigMulTo (self, num, out) {
		    out.negative = num.negative ^ self.negative;
		    out.length = self.length + num.length;

		    var carry = 0;
		    var hncarry = 0;
		    for (var k = 0; k < out.length - 1; k++) {
		      // Sum all words with the same `i + j = k` and accumulate `ncarry`,
		      // note that ncarry could be >= 0x3ffffff
		      var ncarry = hncarry;
		      hncarry = 0;
		      var rword = carry & 0x3ffffff;
		      var maxJ = Math.min(k, num.length - 1);
		      for (var j = Math.max(0, k - self.length + 1); j <= maxJ; j++) {
		        var i = k - j;
		        var a = self.words[i] | 0;
		        var b = num.words[j] | 0;
		        var r = a * b;

		        var lo = r & 0x3ffffff;
		        ncarry = (ncarry + ((r / 0x4000000) | 0)) | 0;
		        lo = (lo + rword) | 0;
		        rword = lo & 0x3ffffff;
		        ncarry = (ncarry + (lo >>> 26)) | 0;

		        hncarry += ncarry >>> 26;
		        ncarry &= 0x3ffffff;
		      }
		      out.words[k] = rword;
		      carry = ncarry;
		      ncarry = hncarry;
		    }
		    if (carry !== 0) {
		      out.words[k] = carry;
		    } else {
		      out.length--;
		    }

		    return out._strip();
		  }

		  function jumboMulTo (self, num, out) {
		    // Temporary disable, see https://github.com/indutny/bn.js/issues/211
		    // var fftm = new FFTM();
		    // return fftm.mulp(self, num, out);
		    return bigMulTo(self, num, out);
		  }

		  BN.prototype.mulTo = function mulTo (num, out) {
		    var res;
		    var len = this.length + num.length;
		    if (this.length === 10 && num.length === 10) {
		      res = comb10MulTo(this, num, out);
		    } else if (len < 63) {
		      res = smallMulTo(this, num, out);
		    } else if (len < 1024) {
		      res = bigMulTo(this, num, out);
		    } else {
		      res = jumboMulTo(this, num, out);
		    }

		    return res;
		  };

		  // Multiply `this` by `num`
		  BN.prototype.mul = function mul (num) {
		    var out = new BN(null);
		    out.words = new Array(this.length + num.length);
		    return this.mulTo(num, out);
		  };

		  // Multiply employing FFT
		  BN.prototype.mulf = function mulf (num) {
		    var out = new BN(null);
		    out.words = new Array(this.length + num.length);
		    return jumboMulTo(this, num, out);
		  };

		  // In-place Multiplication
		  BN.prototype.imul = function imul (num) {
		    return this.clone().mulTo(num, this);
		  };

		  BN.prototype.imuln = function imuln (num) {
		    var isNegNum = num < 0;
		    if (isNegNum) num = -num;

		    assert(typeof num === 'number');
		    assert(num < 0x4000000);

		    // Carry
		    var carry = 0;
		    for (var i = 0; i < this.length; i++) {
		      var w = (this.words[i] | 0) * num;
		      var lo = (w & 0x3ffffff) + (carry & 0x3ffffff);
		      carry >>= 26;
		      carry += (w / 0x4000000) | 0;
		      // NOTE: lo is 27bit maximum
		      carry += lo >>> 26;
		      this.words[i] = lo & 0x3ffffff;
		    }

		    if (carry !== 0) {
		      this.words[i] = carry;
		      this.length++;
		    }

		    return isNegNum ? this.ineg() : this;
		  };

		  BN.prototype.muln = function muln (num) {
		    return this.clone().imuln(num);
		  };

		  // `this` * `this`
		  BN.prototype.sqr = function sqr () {
		    return this.mul(this);
		  };

		  // `this` * `this` in-place
		  BN.prototype.isqr = function isqr () {
		    return this.imul(this.clone());
		  };

		  // Math.pow(`this`, `num`)
		  BN.prototype.pow = function pow (num) {
		    var w = toBitArray(num);
		    if (w.length === 0) return new BN(1);

		    // Skip leading zeroes
		    var res = this;
		    for (var i = 0; i < w.length; i++, res = res.sqr()) {
		      if (w[i] !== 0) break;
		    }

		    if (++i < w.length) {
		      for (var q = res.sqr(); i < w.length; i++, q = q.sqr()) {
		        if (w[i] === 0) continue;

		        res = res.mul(q);
		      }
		    }

		    return res;
		  };

		  // Shift-left in-place
		  BN.prototype.iushln = function iushln (bits) {
		    assert(typeof bits === 'number' && bits >= 0);
		    var r = bits % 26;
		    var s = (bits - r) / 26;
		    var carryMask = (0x3ffffff >>> (26 - r)) << (26 - r);
		    var i;

		    if (r !== 0) {
		      var carry = 0;

		      for (i = 0; i < this.length; i++) {
		        var newCarry = this.words[i] & carryMask;
		        var c = ((this.words[i] | 0) - newCarry) << r;
		        this.words[i] = c | carry;
		        carry = newCarry >>> (26 - r);
		      }

		      if (carry) {
		        this.words[i] = carry;
		        this.length++;
		      }
		    }

		    if (s !== 0) {
		      for (i = this.length - 1; i >= 0; i--) {
		        this.words[i + s] = this.words[i];
		      }

		      for (i = 0; i < s; i++) {
		        this.words[i] = 0;
		      }

		      this.length += s;
		    }

		    return this._strip();
		  };

		  BN.prototype.ishln = function ishln (bits) {
		    // TODO(indutny): implement me
		    assert(this.negative === 0);
		    return this.iushln(bits);
		  };

		  // Shift-right in-place
		  // NOTE: `hint` is a lowest bit before trailing zeroes
		  // NOTE: if `extended` is present - it will be filled with destroyed bits
		  BN.prototype.iushrn = function iushrn (bits, hint, extended) {
		    assert(typeof bits === 'number' && bits >= 0);
		    var h;
		    if (hint) {
		      h = (hint - (hint % 26)) / 26;
		    } else {
		      h = 0;
		    }

		    var r = bits % 26;
		    var s = Math.min((bits - r) / 26, this.length);
		    var mask = 0x3ffffff ^ ((0x3ffffff >>> r) << r);
		    var maskedWords = extended;

		    h -= s;
		    h = Math.max(0, h);

		    // Extended mode, copy masked part
		    if (maskedWords) {
		      for (var i = 0; i < s; i++) {
		        maskedWords.words[i] = this.words[i];
		      }
		      maskedWords.length = s;
		    }

		    if (s === 0) ; else if (this.length > s) {
		      this.length -= s;
		      for (i = 0; i < this.length; i++) {
		        this.words[i] = this.words[i + s];
		      }
		    } else {
		      this.words[0] = 0;
		      this.length = 1;
		    }

		    var carry = 0;
		    for (i = this.length - 1; i >= 0 && (carry !== 0 || i >= h); i--) {
		      var word = this.words[i] | 0;
		      this.words[i] = (carry << (26 - r)) | (word >>> r);
		      carry = word & mask;
		    }

		    // Push carried bits as a mask
		    if (maskedWords && carry !== 0) {
		      maskedWords.words[maskedWords.length++] = carry;
		    }

		    if (this.length === 0) {
		      this.words[0] = 0;
		      this.length = 1;
		    }

		    return this._strip();
		  };

		  BN.prototype.ishrn = function ishrn (bits, hint, extended) {
		    // TODO(indutny): implement me
		    assert(this.negative === 0);
		    return this.iushrn(bits, hint, extended);
		  };

		  // Shift-left
		  BN.prototype.shln = function shln (bits) {
		    return this.clone().ishln(bits);
		  };

		  BN.prototype.ushln = function ushln (bits) {
		    return this.clone().iushln(bits);
		  };

		  // Shift-right
		  BN.prototype.shrn = function shrn (bits) {
		    return this.clone().ishrn(bits);
		  };

		  BN.prototype.ushrn = function ushrn (bits) {
		    return this.clone().iushrn(bits);
		  };

		  // Test if n bit is set
		  BN.prototype.testn = function testn (bit) {
		    assert(typeof bit === 'number' && bit >= 0);
		    var r = bit % 26;
		    var s = (bit - r) / 26;
		    var q = 1 << r;

		    // Fast case: bit is much higher than all existing words
		    if (this.length <= s) return false;

		    // Check bit and return
		    var w = this.words[s];

		    return !!(w & q);
		  };

		  // Return only lowers bits of number (in-place)
		  BN.prototype.imaskn = function imaskn (bits) {
		    assert(typeof bits === 'number' && bits >= 0);
		    var r = bits % 26;
		    var s = (bits - r) / 26;

		    assert(this.negative === 0, 'imaskn works only with positive numbers');

		    if (this.length <= s) {
		      return this;
		    }

		    if (r !== 0) {
		      s++;
		    }
		    this.length = Math.min(s, this.length);

		    if (r !== 0) {
		      var mask = 0x3ffffff ^ ((0x3ffffff >>> r) << r);
		      this.words[this.length - 1] &= mask;
		    }

		    return this._strip();
		  };

		  // Return only lowers bits of number
		  BN.prototype.maskn = function maskn (bits) {
		    return this.clone().imaskn(bits);
		  };

		  // Add plain number `num` to `this`
		  BN.prototype.iaddn = function iaddn (num) {
		    assert(typeof num === 'number');
		    assert(num < 0x4000000);
		    if (num < 0) return this.isubn(-num);

		    // Possible sign change
		    if (this.negative !== 0) {
		      if (this.length === 1 && (this.words[0] | 0) <= num) {
		        this.words[0] = num - (this.words[0] | 0);
		        this.negative = 0;
		        return this;
		      }

		      this.negative = 0;
		      this.isubn(num);
		      this.negative = 1;
		      return this;
		    }

		    // Add without checks
		    return this._iaddn(num);
		  };

		  BN.prototype._iaddn = function _iaddn (num) {
		    this.words[0] += num;

		    // Carry
		    for (var i = 0; i < this.length && this.words[i] >= 0x4000000; i++) {
		      this.words[i] -= 0x4000000;
		      if (i === this.length - 1) {
		        this.words[i + 1] = 1;
		      } else {
		        this.words[i + 1]++;
		      }
		    }
		    this.length = Math.max(this.length, i + 1);

		    return this;
		  };

		  // Subtract plain number `num` from `this`
		  BN.prototype.isubn = function isubn (num) {
		    assert(typeof num === 'number');
		    assert(num < 0x4000000);
		    if (num < 0) return this.iaddn(-num);

		    if (this.negative !== 0) {
		      this.negative = 0;
		      this.iaddn(num);
		      this.negative = 1;
		      return this;
		    }

		    this.words[0] -= num;

		    if (this.length === 1 && this.words[0] < 0) {
		      this.words[0] = -this.words[0];
		      this.negative = 1;
		    } else {
		      // Carry
		      for (var i = 0; i < this.length && this.words[i] < 0; i++) {
		        this.words[i] += 0x4000000;
		        this.words[i + 1] -= 1;
		      }
		    }

		    return this._strip();
		  };

		  BN.prototype.addn = function addn (num) {
		    return this.clone().iaddn(num);
		  };

		  BN.prototype.subn = function subn (num) {
		    return this.clone().isubn(num);
		  };

		  BN.prototype.iabs = function iabs () {
		    this.negative = 0;

		    return this;
		  };

		  BN.prototype.abs = function abs () {
		    return this.clone().iabs();
		  };

		  BN.prototype._ishlnsubmul = function _ishlnsubmul (num, mul, shift) {
		    var len = num.length + shift;
		    var i;

		    this._expand(len);

		    var w;
		    var carry = 0;
		    for (i = 0; i < num.length; i++) {
		      w = (this.words[i + shift] | 0) + carry;
		      var right = (num.words[i] | 0) * mul;
		      w -= right & 0x3ffffff;
		      carry = (w >> 26) - ((right / 0x4000000) | 0);
		      this.words[i + shift] = w & 0x3ffffff;
		    }
		    for (; i < this.length - shift; i++) {
		      w = (this.words[i + shift] | 0) + carry;
		      carry = w >> 26;
		      this.words[i + shift] = w & 0x3ffffff;
		    }

		    if (carry === 0) return this._strip();

		    // Subtraction overflow
		    assert(carry === -1);
		    carry = 0;
		    for (i = 0; i < this.length; i++) {
		      w = -(this.words[i] | 0) + carry;
		      carry = w >> 26;
		      this.words[i] = w & 0x3ffffff;
		    }
		    this.negative = 1;

		    return this._strip();
		  };

		  BN.prototype._wordDiv = function _wordDiv (num, mode) {
		    var shift = this.length - num.length;

		    var a = this.clone();
		    var b = num;

		    // Normalize
		    var bhi = b.words[b.length - 1] | 0;
		    var bhiBits = this._countBits(bhi);
		    shift = 26 - bhiBits;
		    if (shift !== 0) {
		      b = b.ushln(shift);
		      a.iushln(shift);
		      bhi = b.words[b.length - 1] | 0;
		    }

		    // Initialize quotient
		    var m = a.length - b.length;
		    var q;

		    if (mode !== 'mod') {
		      q = new BN(null);
		      q.length = m + 1;
		      q.words = new Array(q.length);
		      for (var i = 0; i < q.length; i++) {
		        q.words[i] = 0;
		      }
		    }

		    var diff = a.clone()._ishlnsubmul(b, 1, m);
		    if (diff.negative === 0) {
		      a = diff;
		      if (q) {
		        q.words[m] = 1;
		      }
		    }

		    for (var j = m - 1; j >= 0; j--) {
		      var qj = (a.words[b.length + j] | 0) * 0x4000000 +
		        (a.words[b.length + j - 1] | 0);

		      // NOTE: (qj / bhi) is (0x3ffffff * 0x4000000 + 0x3ffffff) / 0x2000000 max
		      // (0x7ffffff)
		      qj = Math.min((qj / bhi) | 0, 0x3ffffff);

		      a._ishlnsubmul(b, qj, j);
		      while (a.negative !== 0) {
		        qj--;
		        a.negative = 0;
		        a._ishlnsubmul(b, 1, j);
		        if (!a.isZero()) {
		          a.negative ^= 1;
		        }
		      }
		      if (q) {
		        q.words[j] = qj;
		      }
		    }
		    if (q) {
		      q._strip();
		    }
		    a._strip();

		    // Denormalize
		    if (mode !== 'div' && shift !== 0) {
		      a.iushrn(shift);
		    }

		    return {
		      div: q || null,
		      mod: a
		    };
		  };

		  // NOTE: 1) `mode` can be set to `mod` to request mod only,
		  //       to `div` to request div only, or be absent to
		  //       request both div & mod
		  //       2) `positive` is true if unsigned mod is requested
		  BN.prototype.divmod = function divmod (num, mode, positive) {
		    assert(!num.isZero());

		    if (this.isZero()) {
		      return {
		        div: new BN(0),
		        mod: new BN(0)
		      };
		    }

		    var div, mod, res;
		    if (this.negative !== 0 && num.negative === 0) {
		      res = this.neg().divmod(num, mode);

		      if (mode !== 'mod') {
		        div = res.div.neg();
		      }

		      if (mode !== 'div') {
		        mod = res.mod.neg();
		        if (positive && mod.negative !== 0) {
		          mod.iadd(num);
		        }
		      }

		      return {
		        div: div,
		        mod: mod
		      };
		    }

		    if (this.negative === 0 && num.negative !== 0) {
		      res = this.divmod(num.neg(), mode);

		      if (mode !== 'mod') {
		        div = res.div.neg();
		      }

		      return {
		        div: div,
		        mod: res.mod
		      };
		    }

		    if ((this.negative & num.negative) !== 0) {
		      res = this.neg().divmod(num.neg(), mode);

		      if (mode !== 'div') {
		        mod = res.mod.neg();
		        if (positive && mod.negative !== 0) {
		          mod.isub(num);
		        }
		      }

		      return {
		        div: res.div,
		        mod: mod
		      };
		    }

		    // Both numbers are positive at this point

		    // Strip both numbers to approximate shift value
		    if (num.length > this.length || this.cmp(num) < 0) {
		      return {
		        div: new BN(0),
		        mod: this
		      };
		    }

		    // Very short reduction
		    if (num.length === 1) {
		      if (mode === 'div') {
		        return {
		          div: this.divn(num.words[0]),
		          mod: null
		        };
		      }

		      if (mode === 'mod') {
		        return {
		          div: null,
		          mod: new BN(this.modrn(num.words[0]))
		        };
		      }

		      return {
		        div: this.divn(num.words[0]),
		        mod: new BN(this.modrn(num.words[0]))
		      };
		    }

		    return this._wordDiv(num, mode);
		  };

		  // Find `this` / `num`
		  BN.prototype.div = function div (num) {
		    return this.divmod(num, 'div', false).div;
		  };

		  // Find `this` % `num`
		  BN.prototype.mod = function mod (num) {
		    return this.divmod(num, 'mod', false).mod;
		  };

		  BN.prototype.umod = function umod (num) {
		    return this.divmod(num, 'mod', true).mod;
		  };

		  // Find Round(`this` / `num`)
		  BN.prototype.divRound = function divRound (num) {
		    var dm = this.divmod(num);

		    // Fast case - exact division
		    if (dm.mod.isZero()) return dm.div;

		    var mod = dm.div.negative !== 0 ? dm.mod.isub(num) : dm.mod;

		    var half = num.ushrn(1);
		    var r2 = num.andln(1);
		    var cmp = mod.cmp(half);

		    // Round down
		    if (cmp < 0 || (r2 === 1 && cmp === 0)) return dm.div;

		    // Round up
		    return dm.div.negative !== 0 ? dm.div.isubn(1) : dm.div.iaddn(1);
		  };

		  BN.prototype.modrn = function modrn (num) {
		    var isNegNum = num < 0;
		    if (isNegNum) num = -num;

		    assert(num <= 0x3ffffff);
		    var p = (1 << 26) % num;

		    var acc = 0;
		    for (var i = this.length - 1; i >= 0; i--) {
		      acc = (p * acc + (this.words[i] | 0)) % num;
		    }

		    return isNegNum ? -acc : acc;
		  };

		  // WARNING: DEPRECATED
		  BN.prototype.modn = function modn (num) {
		    return this.modrn(num);
		  };

		  // In-place division by number
		  BN.prototype.idivn = function idivn (num) {
		    var isNegNum = num < 0;
		    if (isNegNum) num = -num;

		    assert(num <= 0x3ffffff);

		    var carry = 0;
		    for (var i = this.length - 1; i >= 0; i--) {
		      var w = (this.words[i] | 0) + carry * 0x4000000;
		      this.words[i] = (w / num) | 0;
		      carry = w % num;
		    }

		    this._strip();
		    return isNegNum ? this.ineg() : this;
		  };

		  BN.prototype.divn = function divn (num) {
		    return this.clone().idivn(num);
		  };

		  BN.prototype.egcd = function egcd (p) {
		    assert(p.negative === 0);
		    assert(!p.isZero());

		    var x = this;
		    var y = p.clone();

		    if (x.negative !== 0) {
		      x = x.umod(p);
		    } else {
		      x = x.clone();
		    }

		    // A * x + B * y = x
		    var A = new BN(1);
		    var B = new BN(0);

		    // C * x + D * y = y
		    var C = new BN(0);
		    var D = new BN(1);

		    var g = 0;

		    while (x.isEven() && y.isEven()) {
		      x.iushrn(1);
		      y.iushrn(1);
		      ++g;
		    }

		    var yp = y.clone();
		    var xp = x.clone();

		    while (!x.isZero()) {
		      for (var i = 0, im = 1; (x.words[0] & im) === 0 && i < 26; ++i, im <<= 1);
		      if (i > 0) {
		        x.iushrn(i);
		        while (i-- > 0) {
		          if (A.isOdd() || B.isOdd()) {
		            A.iadd(yp);
		            B.isub(xp);
		          }

		          A.iushrn(1);
		          B.iushrn(1);
		        }
		      }

		      for (var j = 0, jm = 1; (y.words[0] & jm) === 0 && j < 26; ++j, jm <<= 1);
		      if (j > 0) {
		        y.iushrn(j);
		        while (j-- > 0) {
		          if (C.isOdd() || D.isOdd()) {
		            C.iadd(yp);
		            D.isub(xp);
		          }

		          C.iushrn(1);
		          D.iushrn(1);
		        }
		      }

		      if (x.cmp(y) >= 0) {
		        x.isub(y);
		        A.isub(C);
		        B.isub(D);
		      } else {
		        y.isub(x);
		        C.isub(A);
		        D.isub(B);
		      }
		    }

		    return {
		      a: C,
		      b: D,
		      gcd: y.iushln(g)
		    };
		  };

		  // This is reduced incarnation of the binary EEA
		  // above, designated to invert members of the
		  // _prime_ fields F(p) at a maximal speed
		  BN.prototype._invmp = function _invmp (p) {
		    assert(p.negative === 0);
		    assert(!p.isZero());

		    var a = this;
		    var b = p.clone();

		    if (a.negative !== 0) {
		      a = a.umod(p);
		    } else {
		      a = a.clone();
		    }

		    var x1 = new BN(1);
		    var x2 = new BN(0);

		    var delta = b.clone();

		    while (a.cmpn(1) > 0 && b.cmpn(1) > 0) {
		      for (var i = 0, im = 1; (a.words[0] & im) === 0 && i < 26; ++i, im <<= 1);
		      if (i > 0) {
		        a.iushrn(i);
		        while (i-- > 0) {
		          if (x1.isOdd()) {
		            x1.iadd(delta);
		          }

		          x1.iushrn(1);
		        }
		      }

		      for (var j = 0, jm = 1; (b.words[0] & jm) === 0 && j < 26; ++j, jm <<= 1);
		      if (j > 0) {
		        b.iushrn(j);
		        while (j-- > 0) {
		          if (x2.isOdd()) {
		            x2.iadd(delta);
		          }

		          x2.iushrn(1);
		        }
		      }

		      if (a.cmp(b) >= 0) {
		        a.isub(b);
		        x1.isub(x2);
		      } else {
		        b.isub(a);
		        x2.isub(x1);
		      }
		    }

		    var res;
		    if (a.cmpn(1) === 0) {
		      res = x1;
		    } else {
		      res = x2;
		    }

		    if (res.cmpn(0) < 0) {
		      res.iadd(p);
		    }

		    return res;
		  };

		  BN.prototype.gcd = function gcd (num) {
		    if (this.isZero()) return num.abs();
		    if (num.isZero()) return this.abs();

		    var a = this.clone();
		    var b = num.clone();
		    a.negative = 0;
		    b.negative = 0;

		    // Remove common factor of two
		    for (var shift = 0; a.isEven() && b.isEven(); shift++) {
		      a.iushrn(1);
		      b.iushrn(1);
		    }

		    do {
		      while (a.isEven()) {
		        a.iushrn(1);
		      }
		      while (b.isEven()) {
		        b.iushrn(1);
		      }

		      var r = a.cmp(b);
		      if (r < 0) {
		        // Swap `a` and `b` to make `a` always bigger than `b`
		        var t = a;
		        a = b;
		        b = t;
		      } else if (r === 0 || b.cmpn(1) === 0) {
		        break;
		      }

		      a.isub(b);
		    } while (true);

		    return b.iushln(shift);
		  };

		  // Invert number in the field F(num)
		  BN.prototype.invm = function invm (num) {
		    return this.egcd(num).a.umod(num);
		  };

		  BN.prototype.isEven = function isEven () {
		    return (this.words[0] & 1) === 0;
		  };

		  BN.prototype.isOdd = function isOdd () {
		    return (this.words[0] & 1) === 1;
		  };

		  // And first word and num
		  BN.prototype.andln = function andln (num) {
		    return this.words[0] & num;
		  };

		  // Increment at the bit position in-line
		  BN.prototype.bincn = function bincn (bit) {
		    assert(typeof bit === 'number');
		    var r = bit % 26;
		    var s = (bit - r) / 26;
		    var q = 1 << r;

		    // Fast case: bit is much higher than all existing words
		    if (this.length <= s) {
		      this._expand(s + 1);
		      this.words[s] |= q;
		      return this;
		    }

		    // Add bit and propagate, if needed
		    var carry = q;
		    for (var i = s; carry !== 0 && i < this.length; i++) {
		      var w = this.words[i] | 0;
		      w += carry;
		      carry = w >>> 26;
		      w &= 0x3ffffff;
		      this.words[i] = w;
		    }
		    if (carry !== 0) {
		      this.words[i] = carry;
		      this.length++;
		    }
		    return this;
		  };

		  BN.prototype.isZero = function isZero () {
		    return this.length === 1 && this.words[0] === 0;
		  };

		  BN.prototype.cmpn = function cmpn (num) {
		    var negative = num < 0;

		    if (this.negative !== 0 && !negative) return -1;
		    if (this.negative === 0 && negative) return 1;

		    this._strip();

		    var res;
		    if (this.length > 1) {
		      res = 1;
		    } else {
		      if (negative) {
		        num = -num;
		      }

		      assert(num <= 0x3ffffff, 'Number is too big');

		      var w = this.words[0] | 0;
		      res = w === num ? 0 : w < num ? -1 : 1;
		    }
		    if (this.negative !== 0) return -res | 0;
		    return res;
		  };

		  // Compare two numbers and return:
		  // 1 - if `this` > `num`
		  // 0 - if `this` == `num`
		  // -1 - if `this` < `num`
		  BN.prototype.cmp = function cmp (num) {
		    if (this.negative !== 0 && num.negative === 0) return -1;
		    if (this.negative === 0 && num.negative !== 0) return 1;

		    var res = this.ucmp(num);
		    if (this.negative !== 0) return -res | 0;
		    return res;
		  };

		  // Unsigned comparison
		  BN.prototype.ucmp = function ucmp (num) {
		    // At this point both numbers have the same sign
		    if (this.length > num.length) return 1;
		    if (this.length < num.length) return -1;

		    var res = 0;
		    for (var i = this.length - 1; i >= 0; i--) {
		      var a = this.words[i] | 0;
		      var b = num.words[i] | 0;

		      if (a === b) continue;
		      if (a < b) {
		        res = -1;
		      } else if (a > b) {
		        res = 1;
		      }
		      break;
		    }
		    return res;
		  };

		  BN.prototype.gtn = function gtn (num) {
		    return this.cmpn(num) === 1;
		  };

		  BN.prototype.gt = function gt (num) {
		    return this.cmp(num) === 1;
		  };

		  BN.prototype.gten = function gten (num) {
		    return this.cmpn(num) >= 0;
		  };

		  BN.prototype.gte = function gte (num) {
		    return this.cmp(num) >= 0;
		  };

		  BN.prototype.ltn = function ltn (num) {
		    return this.cmpn(num) === -1;
		  };

		  BN.prototype.lt = function lt (num) {
		    return this.cmp(num) === -1;
		  };

		  BN.prototype.lten = function lten (num) {
		    return this.cmpn(num) <= 0;
		  };

		  BN.prototype.lte = function lte (num) {
		    return this.cmp(num) <= 0;
		  };

		  BN.prototype.eqn = function eqn (num) {
		    return this.cmpn(num) === 0;
		  };

		  BN.prototype.eq = function eq (num) {
		    return this.cmp(num) === 0;
		  };

		  //
		  // A reduce context, could be using montgomery or something better, depending
		  // on the `m` itself.
		  //
		  BN.red = function red (num) {
		    return new Red(num);
		  };

		  BN.prototype.toRed = function toRed (ctx) {
		    assert(!this.red, 'Already a number in reduction context');
		    assert(this.negative === 0, 'red works only with positives');
		    return ctx.convertTo(this)._forceRed(ctx);
		  };

		  BN.prototype.fromRed = function fromRed () {
		    assert(this.red, 'fromRed works only with numbers in reduction context');
		    return this.red.convertFrom(this);
		  };

		  BN.prototype._forceRed = function _forceRed (ctx) {
		    this.red = ctx;
		    return this;
		  };

		  BN.prototype.forceRed = function forceRed (ctx) {
		    assert(!this.red, 'Already a number in reduction context');
		    return this._forceRed(ctx);
		  };

		  BN.prototype.redAdd = function redAdd (num) {
		    assert(this.red, 'redAdd works only with red numbers');
		    return this.red.add(this, num);
		  };

		  BN.prototype.redIAdd = function redIAdd (num) {
		    assert(this.red, 'redIAdd works only with red numbers');
		    return this.red.iadd(this, num);
		  };

		  BN.prototype.redSub = function redSub (num) {
		    assert(this.red, 'redSub works only with red numbers');
		    return this.red.sub(this, num);
		  };

		  BN.prototype.redISub = function redISub (num) {
		    assert(this.red, 'redISub works only with red numbers');
		    return this.red.isub(this, num);
		  };

		  BN.prototype.redShl = function redShl (num) {
		    assert(this.red, 'redShl works only with red numbers');
		    return this.red.shl(this, num);
		  };

		  BN.prototype.redMul = function redMul (num) {
		    assert(this.red, 'redMul works only with red numbers');
		    this.red._verify2(this, num);
		    return this.red.mul(this, num);
		  };

		  BN.prototype.redIMul = function redIMul (num) {
		    assert(this.red, 'redMul works only with red numbers');
		    this.red._verify2(this, num);
		    return this.red.imul(this, num);
		  };

		  BN.prototype.redSqr = function redSqr () {
		    assert(this.red, 'redSqr works only with red numbers');
		    this.red._verify1(this);
		    return this.red.sqr(this);
		  };

		  BN.prototype.redISqr = function redISqr () {
		    assert(this.red, 'redISqr works only with red numbers');
		    this.red._verify1(this);
		    return this.red.isqr(this);
		  };

		  // Square root over p
		  BN.prototype.redSqrt = function redSqrt () {
		    assert(this.red, 'redSqrt works only with red numbers');
		    this.red._verify1(this);
		    return this.red.sqrt(this);
		  };

		  BN.prototype.redInvm = function redInvm () {
		    assert(this.red, 'redInvm works only with red numbers');
		    this.red._verify1(this);
		    return this.red.invm(this);
		  };

		  // Return negative clone of `this` % `red modulo`
		  BN.prototype.redNeg = function redNeg () {
		    assert(this.red, 'redNeg works only with red numbers');
		    this.red._verify1(this);
		    return this.red.neg(this);
		  };

		  BN.prototype.redPow = function redPow (num) {
		    assert(this.red && !num.red, 'redPow(normalNum)');
		    this.red._verify1(this);
		    return this.red.pow(this, num);
		  };

		  // Prime numbers with efficient reduction
		  var primes = {
		    k256: null,
		    p224: null,
		    p192: null,
		    p25519: null
		  };

		  // Pseudo-Mersenne prime
		  function MPrime (name, p) {
		    // P = 2 ^ N - K
		    this.name = name;
		    this.p = new BN(p, 16);
		    this.n = this.p.bitLength();
		    this.k = new BN(1).iushln(this.n).isub(this.p);

		    this.tmp = this._tmp();
		  }

		  MPrime.prototype._tmp = function _tmp () {
		    var tmp = new BN(null);
		    tmp.words = new Array(Math.ceil(this.n / 13));
		    return tmp;
		  };

		  MPrime.prototype.ireduce = function ireduce (num) {
		    // Assumes that `num` is less than `P^2`
		    // num = HI * (2 ^ N - K) + HI * K + LO = HI * K + LO (mod P)
		    var r = num;
		    var rlen;

		    do {
		      this.split(r, this.tmp);
		      r = this.imulK(r);
		      r = r.iadd(this.tmp);
		      rlen = r.bitLength();
		    } while (rlen > this.n);

		    var cmp = rlen < this.n ? -1 : r.ucmp(this.p);
		    if (cmp === 0) {
		      r.words[0] = 0;
		      r.length = 1;
		    } else if (cmp > 0) {
		      r.isub(this.p);
		    } else {
		      if (r.strip !== undefined) {
		        // r is a BN v4 instance
		        r.strip();
		      } else {
		        // r is a BN v5 instance
		        r._strip();
		      }
		    }

		    return r;
		  };

		  MPrime.prototype.split = function split (input, out) {
		    input.iushrn(this.n, 0, out);
		  };

		  MPrime.prototype.imulK = function imulK (num) {
		    return num.imul(this.k);
		  };

		  function K256 () {
		    MPrime.call(
		      this,
		      'k256',
		      'ffffffff ffffffff ffffffff ffffffff ffffffff ffffffff fffffffe fffffc2f');
		  }
		  inherits(K256, MPrime);

		  K256.prototype.split = function split (input, output) {
		    // 256 = 9 * 26 + 22
		    var mask = 0x3fffff;

		    var outLen = Math.min(input.length, 9);
		    for (var i = 0; i < outLen; i++) {
		      output.words[i] = input.words[i];
		    }
		    output.length = outLen;

		    if (input.length <= 9) {
		      input.words[0] = 0;
		      input.length = 1;
		      return;
		    }

		    // Shift by 9 limbs
		    var prev = input.words[9];
		    output.words[output.length++] = prev & mask;

		    for (i = 10; i < input.length; i++) {
		      var next = input.words[i] | 0;
		      input.words[i - 10] = ((next & mask) << 4) | (prev >>> 22);
		      prev = next;
		    }
		    prev >>>= 22;
		    input.words[i - 10] = prev;
		    if (prev === 0 && input.length > 10) {
		      input.length -= 10;
		    } else {
		      input.length -= 9;
		    }
		  };

		  K256.prototype.imulK = function imulK (num) {
		    // K = 0x1000003d1 = [ 0x40, 0x3d1 ]
		    num.words[num.length] = 0;
		    num.words[num.length + 1] = 0;
		    num.length += 2;

		    // bounded at: 0x40 * 0x3ffffff + 0x3d0 = 0x100000390
		    var lo = 0;
		    for (var i = 0; i < num.length; i++) {
		      var w = num.words[i] | 0;
		      lo += w * 0x3d1;
		      num.words[i] = lo & 0x3ffffff;
		      lo = w * 0x40 + ((lo / 0x4000000) | 0);
		    }

		    // Fast length reduction
		    if (num.words[num.length - 1] === 0) {
		      num.length--;
		      if (num.words[num.length - 1] === 0) {
		        num.length--;
		      }
		    }
		    return num;
		  };

		  function P224 () {
		    MPrime.call(
		      this,
		      'p224',
		      'ffffffff ffffffff ffffffff ffffffff 00000000 00000000 00000001');
		  }
		  inherits(P224, MPrime);

		  function P192 () {
		    MPrime.call(
		      this,
		      'p192',
		      'ffffffff ffffffff ffffffff fffffffe ffffffff ffffffff');
		  }
		  inherits(P192, MPrime);

		  function P25519 () {
		    // 2 ^ 255 - 19
		    MPrime.call(
		      this,
		      '25519',
		      '7fffffffffffffff ffffffffffffffff ffffffffffffffff ffffffffffffffed');
		  }
		  inherits(P25519, MPrime);

		  P25519.prototype.imulK = function imulK (num) {
		    // K = 0x13
		    var carry = 0;
		    for (var i = 0; i < num.length; i++) {
		      var hi = (num.words[i] | 0) * 0x13 + carry;
		      var lo = hi & 0x3ffffff;
		      hi >>>= 26;

		      num.words[i] = lo;
		      carry = hi;
		    }
		    if (carry !== 0) {
		      num.words[num.length++] = carry;
		    }
		    return num;
		  };

		  // Exported mostly for testing purposes, use plain name instead
		  BN._prime = function prime (name) {
		    // Cached version of prime
		    if (primes[name]) return primes[name];

		    var prime;
		    if (name === 'k256') {
		      prime = new K256();
		    } else if (name === 'p224') {
		      prime = new P224();
		    } else if (name === 'p192') {
		      prime = new P192();
		    } else if (name === 'p25519') {
		      prime = new P25519();
		    } else {
		      throw new Error('Unknown prime ' + name);
		    }
		    primes[name] = prime;

		    return prime;
		  };

		  //
		  // Base reduction engine
		  //
		  function Red (m) {
		    if (typeof m === 'string') {
		      var prime = BN._prime(m);
		      this.m = prime.p;
		      this.prime = prime;
		    } else {
		      assert(m.gtn(1), 'modulus must be greater than 1');
		      this.m = m;
		      this.prime = null;
		    }
		  }

		  Red.prototype._verify1 = function _verify1 (a) {
		    assert(a.negative === 0, 'red works only with positives');
		    assert(a.red, 'red works only with red numbers');
		  };

		  Red.prototype._verify2 = function _verify2 (a, b) {
		    assert((a.negative | b.negative) === 0, 'red works only with positives');
		    assert(a.red && a.red === b.red,
		      'red works only with red numbers');
		  };

		  Red.prototype.imod = function imod (a) {
		    if (this.prime) return this.prime.ireduce(a)._forceRed(this);

		    move(a, a.umod(this.m)._forceRed(this));
		    return a;
		  };

		  Red.prototype.neg = function neg (a) {
		    if (a.isZero()) {
		      return a.clone();
		    }

		    return this.m.sub(a)._forceRed(this);
		  };

		  Red.prototype.add = function add (a, b) {
		    this._verify2(a, b);

		    var res = a.add(b);
		    if (res.cmp(this.m) >= 0) {
		      res.isub(this.m);
		    }
		    return res._forceRed(this);
		  };

		  Red.prototype.iadd = function iadd (a, b) {
		    this._verify2(a, b);

		    var res = a.iadd(b);
		    if (res.cmp(this.m) >= 0) {
		      res.isub(this.m);
		    }
		    return res;
		  };

		  Red.prototype.sub = function sub (a, b) {
		    this._verify2(a, b);

		    var res = a.sub(b);
		    if (res.cmpn(0) < 0) {
		      res.iadd(this.m);
		    }
		    return res._forceRed(this);
		  };

		  Red.prototype.isub = function isub (a, b) {
		    this._verify2(a, b);

		    var res = a.isub(b);
		    if (res.cmpn(0) < 0) {
		      res.iadd(this.m);
		    }
		    return res;
		  };

		  Red.prototype.shl = function shl (a, num) {
		    this._verify1(a);
		    return this.imod(a.ushln(num));
		  };

		  Red.prototype.imul = function imul (a, b) {
		    this._verify2(a, b);
		    return this.imod(a.imul(b));
		  };

		  Red.prototype.mul = function mul (a, b) {
		    this._verify2(a, b);
		    return this.imod(a.mul(b));
		  };

		  Red.prototype.isqr = function isqr (a) {
		    return this.imul(a, a.clone());
		  };

		  Red.prototype.sqr = function sqr (a) {
		    return this.mul(a, a);
		  };

		  Red.prototype.sqrt = function sqrt (a) {
		    if (a.isZero()) return a.clone();

		    var mod3 = this.m.andln(3);
		    assert(mod3 % 2 === 1);

		    // Fast case
		    if (mod3 === 3) {
		      var pow = this.m.add(new BN(1)).iushrn(2);
		      return this.pow(a, pow);
		    }

		    // Tonelli-Shanks algorithm (Totally unoptimized and slow)
		    //
		    // Find Q and S, that Q * 2 ^ S = (P - 1)
		    var q = this.m.subn(1);
		    var s = 0;
		    while (!q.isZero() && q.andln(1) === 0) {
		      s++;
		      q.iushrn(1);
		    }
		    assert(!q.isZero());

		    var one = new BN(1).toRed(this);
		    var nOne = one.redNeg();

		    // Find quadratic non-residue
		    // NOTE: Max is such because of generalized Riemann hypothesis.
		    var lpow = this.m.subn(1).iushrn(1);
		    var z = this.m.bitLength();
		    z = new BN(2 * z * z).toRed(this);

		    while (this.pow(z, lpow).cmp(nOne) !== 0) {
		      z.redIAdd(nOne);
		    }

		    var c = this.pow(z, q);
		    var r = this.pow(a, q.addn(1).iushrn(1));
		    var t = this.pow(a, q);
		    var m = s;
		    while (t.cmp(one) !== 0) {
		      var tmp = t;
		      for (var i = 0; tmp.cmp(one) !== 0; i++) {
		        tmp = tmp.redSqr();
		      }
		      assert(i < m);
		      var b = this.pow(c, new BN(1).iushln(m - i - 1));

		      r = r.redMul(b);
		      c = b.redSqr();
		      t = t.redMul(c);
		      m = i;
		    }

		    return r;
		  };

		  Red.prototype.invm = function invm (a) {
		    var inv = a._invmp(this.m);
		    if (inv.negative !== 0) {
		      inv.negative = 0;
		      return this.imod(inv).redNeg();
		    } else {
		      return this.imod(inv);
		    }
		  };

		  Red.prototype.pow = function pow (a, num) {
		    if (num.isZero()) return new BN(1).toRed(this);
		    if (num.cmpn(1) === 0) return a.clone();

		    var windowSize = 4;
		    var wnd = new Array(1 << windowSize);
		    wnd[0] = new BN(1).toRed(this);
		    wnd[1] = a;
		    for (var i = 2; i < wnd.length; i++) {
		      wnd[i] = this.mul(wnd[i - 1], a);
		    }

		    var res = wnd[0];
		    var current = 0;
		    var currentLen = 0;
		    var start = num.bitLength() % 26;
		    if (start === 0) {
		      start = 26;
		    }

		    for (i = num.length - 1; i >= 0; i--) {
		      var word = num.words[i];
		      for (var j = start - 1; j >= 0; j--) {
		        var bit = (word >> j) & 1;
		        if (res !== wnd[0]) {
		          res = this.sqr(res);
		        }

		        if (bit === 0 && current === 0) {
		          currentLen = 0;
		          continue;
		        }

		        current <<= 1;
		        current |= bit;
		        currentLen++;
		        if (currentLen !== windowSize && (i !== 0 || j !== 0)) continue;

		        res = this.mul(res, wnd[current]);
		        currentLen = 0;
		        current = 0;
		      }
		      start = 26;
		    }

		    return res;
		  };

		  Red.prototype.convertTo = function convertTo (num) {
		    var r = num.umod(this.m);

		    return r === num ? r.clone() : r;
		  };

		  Red.prototype.convertFrom = function convertFrom (num) {
		    var res = num.clone();
		    res.red = null;
		    return res;
		  };

		  //
		  // Montgomery method engine
		  //

		  BN.mont = function mont (num) {
		    return new Mont(num);
		  };

		  function Mont (m) {
		    Red.call(this, m);

		    this.shift = this.m.bitLength();
		    if (this.shift % 26 !== 0) {
		      this.shift += 26 - (this.shift % 26);
		    }

		    this.r = new BN(1).iushln(this.shift);
		    this.r2 = this.imod(this.r.sqr());
		    this.rinv = this.r._invmp(this.m);

		    this.minv = this.rinv.mul(this.r).isubn(1).div(this.m);
		    this.minv = this.minv.umod(this.r);
		    this.minv = this.r.sub(this.minv);
		  }
		  inherits(Mont, Red);

		  Mont.prototype.convertTo = function convertTo (num) {
		    return this.imod(num.ushln(this.shift));
		  };

		  Mont.prototype.convertFrom = function convertFrom (num) {
		    var r = this.imod(num.mul(this.rinv));
		    r.red = null;
		    return r;
		  };

		  Mont.prototype.imul = function imul (a, b) {
		    if (a.isZero() || b.isZero()) {
		      a.words[0] = 0;
		      a.length = 1;
		      return a;
		    }

		    var t = a.imul(b);
		    var c = t.maskn(this.shift).mul(this.minv).imaskn(this.shift).mul(this.m);
		    var u = t.isub(c).iushrn(this.shift);
		    var res = u;

		    if (u.cmp(this.m) >= 0) {
		      res = u.isub(this.m);
		    } else if (u.cmpn(0) < 0) {
		      res = u.iadd(this.m);
		    }

		    return res._forceRed(this);
		  };

		  Mont.prototype.mul = function mul (a, b) {
		    if (a.isZero() || b.isZero()) return new BN(0)._forceRed(this);

		    var t = a.mul(b);
		    var c = t.maskn(this.shift).mul(this.minv).imaskn(this.shift).mul(this.m);
		    var u = t.isub(c).iushrn(this.shift);
		    var res = u;
		    if (u.cmp(this.m) >= 0) {
		      res = u.isub(this.m);
		    } else if (u.cmpn(0) < 0) {
		      res = u.iadd(this.m);
		    }

		    return res._forceRed(this);
		  };

		  Mont.prototype.invm = function invm (a) {
		    // (AR)^-1 * R^2 = (A^-1 * R^-1) * R^2 = A^-1 * R
		    var res = this.imod(a._invmp(this.m).mul(this.r2));
		    return res._forceRed(this);
		  };
		})(module, commonjsGlobal);
	} (bn));

	(function (exports) {
		var __importDefault = (commonjsGlobal && commonjsGlobal.__importDefault) || function (mod) {
		    return (mod && mod.__esModule) ? mod : { "default": mod };
		};
		Object.defineProperty(exports, "__esModule", { value: true });
		exports.map = exports.array = exports.rustEnum = exports.str = exports.vecU8 = exports.tagged = exports.vec = exports.bool = exports.option = exports.publicKey = exports.i128 = exports.u128 = exports.i64 = exports.u64 = exports.struct = exports.f64 = exports.f32 = exports.i32 = exports.u32 = exports.i16 = exports.u16 = exports.i8 = exports.u8 = void 0;
		const buffer_layout_1 = Layout$1;
		const web3_js_1 = require$$0$1;
		const bn_js_1 = __importDefault(bnExports);
		var buffer_layout_2 = Layout$1;
		Object.defineProperty(exports, "u8", { enumerable: true, get: function () { return buffer_layout_2.u8; } });
		Object.defineProperty(exports, "i8", { enumerable: true, get: function () { return buffer_layout_2.s8; } });
		Object.defineProperty(exports, "u16", { enumerable: true, get: function () { return buffer_layout_2.u16; } });
		Object.defineProperty(exports, "i16", { enumerable: true, get: function () { return buffer_layout_2.s16; } });
		Object.defineProperty(exports, "u32", { enumerable: true, get: function () { return buffer_layout_2.u32; } });
		Object.defineProperty(exports, "i32", { enumerable: true, get: function () { return buffer_layout_2.s32; } });
		Object.defineProperty(exports, "f32", { enumerable: true, get: function () { return buffer_layout_2.f32; } });
		Object.defineProperty(exports, "f64", { enumerable: true, get: function () { return buffer_layout_2.f64; } });
		Object.defineProperty(exports, "struct", { enumerable: true, get: function () { return buffer_layout_2.struct; } });
		class BNLayout extends buffer_layout_1.Layout {
		    constructor(span, signed, property) {
		        super(span, property);
		        this.blob = buffer_layout_1.blob(span);
		        this.signed = signed;
		    }
		    decode(b, offset = 0) {
		        const num = new bn_js_1.default(this.blob.decode(b, offset), 10, 'le');
		        if (this.signed) {
		            return num.fromTwos(this.span * 8).clone();
		        }
		        return num;
		    }
		    encode(src, b, offset = 0) {
		        if (this.signed) {
		            src = src.toTwos(this.span * 8);
		        }
		        return this.blob.encode(src.toArrayLike(Buffer, 'le', this.span), b, offset);
		    }
		}
		function u64(property) {
		    return new BNLayout(8, false, property);
		}
		exports.u64 = u64;
		function i64(property) {
		    return new BNLayout(8, true, property);
		}
		exports.i64 = i64;
		function u128(property) {
		    return new BNLayout(16, false, property);
		}
		exports.u128 = u128;
		function i128(property) {
		    return new BNLayout(16, true, property);
		}
		exports.i128 = i128;
		class WrappedLayout extends buffer_layout_1.Layout {
		    constructor(layout, decoder, encoder, property) {
		        super(layout.span, property);
		        this.layout = layout;
		        this.decoder = decoder;
		        this.encoder = encoder;
		    }
		    decode(b, offset) {
		        return this.decoder(this.layout.decode(b, offset));
		    }
		    encode(src, b, offset) {
		        return this.layout.encode(this.encoder(src), b, offset);
		    }
		    getSpan(b, offset) {
		        return this.layout.getSpan(b, offset);
		    }
		}
		function publicKey(property) {
		    return new WrappedLayout(buffer_layout_1.blob(32), (b) => new web3_js_1.PublicKey(b), (key) => key.toBuffer(), property);
		}
		exports.publicKey = publicKey;
		class OptionLayout extends buffer_layout_1.Layout {
		    constructor(layout, property) {
		        super(-1, property);
		        this.layout = layout;
		        this.discriminator = buffer_layout_1.u8();
		    }
		    encode(src, b, offset = 0) {
		        if (src === null || src === undefined) {
		            return this.discriminator.encode(0, b, offset);
		        }
		        this.discriminator.encode(1, b, offset);
		        return this.layout.encode(src, b, offset + 1) + 1;
		    }
		    decode(b, offset = 0) {
		        const discriminator = this.discriminator.decode(b, offset);
		        if (discriminator === 0) {
		            return null;
		        }
		        else if (discriminator === 1) {
		            return this.layout.decode(b, offset + 1);
		        }
		        throw new Error('Invalid option ' + this.property);
		    }
		    getSpan(b, offset = 0) {
		        const discriminator = this.discriminator.decode(b, offset);
		        if (discriminator === 0) {
		            return 1;
		        }
		        else if (discriminator === 1) {
		            return this.layout.getSpan(b, offset + 1) + 1;
		        }
		        throw new Error('Invalid option ' + this.property);
		    }
		}
		function option(layout, property) {
		    return new OptionLayout(layout, property);
		}
		exports.option = option;
		function bool(property) {
		    return new WrappedLayout(buffer_layout_1.u8(), decodeBool, encodeBool, property);
		}
		exports.bool = bool;
		function decodeBool(value) {
		    if (value === 0) {
		        return false;
		    }
		    else if (value === 1) {
		        return true;
		    }
		    throw new Error('Invalid bool: ' + value);
		}
		function encodeBool(value) {
		    return value ? 1 : 0;
		}
		function vec(elementLayout, property) {
		    const length = buffer_layout_1.u32('length');
		    const layout = buffer_layout_1.struct([
		        length,
		        buffer_layout_1.seq(elementLayout, buffer_layout_1.offset(length, -length.span), 'values'),
		    ]);
		    return new WrappedLayout(layout, ({ values }) => values, values => ({ values }), property);
		}
		exports.vec = vec;
		function tagged(tag, layout, property) {
		    const wrappedLayout = buffer_layout_1.struct([
		        u64('tag'),
		        layout.replicate('data'),
		    ]);
		    function decodeTag({ tag: receivedTag, data }) {
		        if (!receivedTag.eq(tag)) {
		            throw new Error('Invalid tag, expected: ' +
		                tag.toString('hex') +
		                ', got: ' +
		                receivedTag.toString('hex'));
		        }
		        return data;
		    }
		    return new WrappedLayout(wrappedLayout, decodeTag, data => ({ tag, data }), property);
		}
		exports.tagged = tagged;
		function vecU8(property) {
		    const length = buffer_layout_1.u32('length');
		    const layout = buffer_layout_1.struct([
		        length,
		        buffer_layout_1.blob(buffer_layout_1.offset(length, -length.span), 'data'),
		    ]);
		    return new WrappedLayout(layout, ({ data }) => data, data => ({ data }), property);
		}
		exports.vecU8 = vecU8;
		function str(property) {
		    return new WrappedLayout(vecU8(), data => data.toString('utf-8'), s => Buffer.from(s, 'utf-8'), property);
		}
		exports.str = str;
		function rustEnum(variants, property, discriminant) {
		    const unionLayout = buffer_layout_1.union(discriminant !== null && discriminant !== void 0 ? discriminant : buffer_layout_1.u8(), property);
		    variants.forEach((variant, index) => unionLayout.addVariant(index, variant, variant.property));
		    return unionLayout;
		}
		exports.rustEnum = rustEnum;
		function array(elementLayout, length, property) {
		    const layout = buffer_layout_1.struct([
		        buffer_layout_1.seq(elementLayout, length, 'values'),
		    ]);
		    return new WrappedLayout(layout, ({ values }) => values, values => ({ values }), property);
		}
		exports.array = array;
		class MapEntryLayout extends buffer_layout_1.Layout {
		    constructor(keyLayout, valueLayout, property) {
		        super(keyLayout.span + valueLayout.span, property);
		        this.keyLayout = keyLayout;
		        this.valueLayout = valueLayout;
		    }
		    decode(b, offset) {
		        offset = offset || 0;
		        const key = this.keyLayout.decode(b, offset);
		        const value = this.valueLayout.decode(b, offset + this.keyLayout.getSpan(b, offset));
		        return [key, value];
		    }
		    encode(src, b, offset) {
		        offset = offset || 0;
		        const keyBytes = this.keyLayout.encode(src[0], b, offset);
		        const valueBytes = this.valueLayout.encode(src[1], b, offset + keyBytes);
		        return keyBytes + valueBytes;
		    }
		    getSpan(b, offset) {
		        return (this.keyLayout.getSpan(b, offset) + this.valueLayout.getSpan(b, offset));
		    }
		}
		function map(keyLayout, valueLayout, property) {
		    const length = buffer_layout_1.u32('length');
		    const layout = buffer_layout_1.struct([
		        length,
		        buffer_layout_1.seq(new MapEntryLayout(keyLayout, valueLayout), buffer_layout_1.offset(length, -length.span), 'values'),
		    ]);
		    return new WrappedLayout(layout, ({ values }) => new Map(values), values => ({ values: Array.from(values.entries()) }), property);
		}
		exports.map = map;
		
	} (lib));

	var __createBinding$b = (commonjsGlobal && commonjsGlobal.__createBinding) || (Object.create ? (function(o, m, k, k2) {
	    if (k2 === undefined) k2 = k;
	    var desc = Object.getOwnPropertyDescriptor(m, k);
	    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
	      desc = { enumerable: true, get: function() { return m[k]; } };
	    }
	    Object.defineProperty(o, k2, desc);
	}) : (function(o, m, k, k2) {
	    if (k2 === undefined) k2 = k;
	    o[k2] = m[k];
	}));
	var __setModuleDefault$b = (commonjsGlobal && commonjsGlobal.__setModuleDefault) || (Object.create ? (function(o, v) {
	    Object.defineProperty(o, "default", { enumerable: true, value: v });
	}) : function(o, v) {
	    o["default"] = v;
	});
	var __importStar$b = (commonjsGlobal && commonjsGlobal.__importStar) || function (mod) {
	    if (mod && mod.__esModule) return mod;
	    var result = {};
	    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding$b(result, mod, k);
	    __setModuleDefault$b(result, mod);
	    return result;
	};
	Object.defineProperty(idl$1, "__esModule", { value: true });
	idl$1.encodeIdlAccount = idl$1.decodeIdlAccount = idl$1.seed = idl$1.idlAddress = void 0;
	const buffer_1$4 = require$$0;
	const web3_js_1$9 = require$$0$1;
	const borsh$2 = __importStar$b(lib);
	// Deterministic IDL address as a function of the program id.
	async function idlAddress(programId) {
	    const base = (await web3_js_1$9.PublicKey.findProgramAddress([], programId))[0];
	    return await web3_js_1$9.PublicKey.createWithSeed(base, seed(), programId);
	}
	idl$1.idlAddress = idlAddress;
	// Seed for generating the idlAddress.
	function seed() {
	    return "anchor:idl";
	}
	idl$1.seed = seed;
	const IDL_ACCOUNT_LAYOUT = borsh$2.struct([
	    borsh$2.publicKey("authority"),
	    borsh$2.vecU8("data"),
	]);
	function decodeIdlAccount(data) {
	    return IDL_ACCOUNT_LAYOUT.decode(data);
	}
	idl$1.decodeIdlAccount = decodeIdlAccount;
	function encodeIdlAccount(acc) {
	    const buffer = buffer_1$4.Buffer.alloc(1000); // TODO: use a tighter buffer.
	    const len = IDL_ACCOUNT_LAYOUT.encode(acc, buffer);
	    return buffer.slice(0, len);
	}
	idl$1.encodeIdlAccount = encodeIdlAccount;

	var coder = {};

	var borsh$1 = {};

	var instruction$3 = {};

	var camelcaseExports = {};
	var camelcase = {
	  get exports(){ return camelcaseExports; },
	  set exports(v){ camelcaseExports = v; },
	};

	const preserveCamelCase = string => {
		let isLastCharLower = false;
		let isLastCharUpper = false;
		let isLastLastCharUpper = false;

		for (let i = 0; i < string.length; i++) {
			const character = string[i];

			if (isLastCharLower && /[a-zA-Z]/.test(character) && character.toUpperCase() === character) {
				string = string.slice(0, i) + '-' + string.slice(i);
				isLastCharLower = false;
				isLastLastCharUpper = isLastCharUpper;
				isLastCharUpper = true;
				i++;
			} else if (isLastCharUpper && isLastLastCharUpper && /[a-zA-Z]/.test(character) && character.toLowerCase() === character) {
				string = string.slice(0, i - 1) + '-' + string.slice(i - 1);
				isLastLastCharUpper = isLastCharUpper;
				isLastCharUpper = false;
				isLastCharLower = true;
			} else {
				isLastCharLower = character.toLowerCase() === character && character.toUpperCase() !== character;
				isLastLastCharUpper = isLastCharUpper;
				isLastCharUpper = character.toUpperCase() === character && character.toLowerCase() !== character;
			}
		}

		return string;
	};

	const camelCase = (input, options) => {
		if (!(typeof input === 'string' || Array.isArray(input))) {
			throw new TypeError('Expected the input to be `string | string[]`');
		}

		options = Object.assign({
			pascalCase: false
		}, options);

		const postProcess = x => options.pascalCase ? x.charAt(0).toUpperCase() + x.slice(1) : x;

		if (Array.isArray(input)) {
			input = input.map(x => x.trim())
				.filter(x => x.length)
				.join('-');
		} else {
			input = input.trim();
		}

		if (input.length === 0) {
			return '';
		}

		if (input.length === 1) {
			return options.pascalCase ? input.toUpperCase() : input.toLowerCase();
		}

		const hasUpperCase = input !== input.toLowerCase();

		if (hasUpperCase) {
			input = preserveCamelCase(input);
		}

		input = input
			.replace(/^[_.\- ]+/, '')
			.toLowerCase()
			.replace(/[_.\- ]+(\w|$)/g, (_, p1) => p1.toUpperCase())
			.replace(/\d+(\w|$)/g, m => m.toUpperCase());

		return postProcess(input);
	};

	camelcase.exports = camelCase;
	// TODO: Remove this for the next major release
	camelcaseExports.default = camelCase;

	/******************************************************************************
	Copyright (c) Microsoft Corporation.

	Permission to use, copy, modify, and/or distribute this software for any
	purpose with or without fee is hereby granted.

	THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES WITH
	REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY
	AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY SPECIAL, DIRECT,
	INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM
	LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR
	OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR
	PERFORMANCE OF THIS SOFTWARE.
	***************************************************************************** */

	var __assign = function() {
	    __assign = Object.assign || function __assign(t) {
	        for (var s, i = 1, n = arguments.length; i < n; i++) {
	            s = arguments[i];
	            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p)) t[p] = s[p];
	        }
	        return t;
	    };
	    return __assign.apply(this, arguments);
	};

	/**
	 * Source: ftp://ftp.unicode.org/Public/UCD/latest/ucd/SpecialCasing.txt
	 */
	/**
	 * Lower case as a function.
	 */
	function lowerCase(str) {
	    return str.toLowerCase();
	}

	// Support camel case ("camelCase" -> "camel Case" and "CAMELCase" -> "CAMEL Case").
	var DEFAULT_SPLIT_REGEXP = [/([a-z0-9])([A-Z])/g, /([A-Z])([A-Z][a-z])/g];
	// Remove all non-word characters.
	var DEFAULT_STRIP_REGEXP = /[^A-Z0-9]+/gi;
	/**
	 * Normalize the string into something other libraries can manipulate easier.
	 */
	function noCase(input, options) {
	    if (options === void 0) { options = {}; }
	    var _a = options.splitRegexp, splitRegexp = _a === void 0 ? DEFAULT_SPLIT_REGEXP : _a, _b = options.stripRegexp, stripRegexp = _b === void 0 ? DEFAULT_STRIP_REGEXP : _b, _c = options.transform, transform = _c === void 0 ? lowerCase : _c, _d = options.delimiter, delimiter = _d === void 0 ? " " : _d;
	    var result = replace(replace(input, splitRegexp, "$1\0$2"), stripRegexp, "\0");
	    var start = 0;
	    var end = result.length;
	    // Trim the delimiter from around the output string.
	    while (result.charAt(start) === "\0")
	        start++;
	    while (result.charAt(end - 1) === "\0")
	        end--;
	    // Transform each token independently.
	    return result.slice(start, end).split("\0").map(transform).join(delimiter);
	}
	/**
	 * Replace `re` in the input string with the replacement value.
	 */
	function replace(input, re, value) {
	    if (re instanceof RegExp)
	        return input.replace(re, value);
	    return re.reduce(function (input, re) { return input.replace(re, value); }, input);
	}

	function dotCase(input, options) {
	    if (options === void 0) { options = {}; }
	    return noCase(input, __assign({ delimiter: "." }, options));
	}

	function snakeCase(input, options) {
	    if (options === void 0) { options = {}; }
	    return dotCase(input, __assign({ delimiter: "_" }, options));
	}

	var dist_es2015 = /*#__PURE__*/Object.freeze({
		__proto__: null,
		snakeCase: snakeCase
	});

	var require$$3 = /*@__PURE__*/getAugmentedNamespace(dist_es2015);

	var sha256Exports = {};
	var sha256 = {
	  get exports(){ return sha256Exports; },
	  set exports(v){ sha256Exports = v; },
	};

	/**
	 * [js-sha256]{@link https://github.com/emn178/js-sha256}
	 *
	 * @version 0.9.0
	 * @author Chen, Yi-Cyuan [emn178@gmail.com]
	 * @copyright Chen, Yi-Cyuan 2014-2017
	 * @license MIT
	 */

	(function (module) {
		/*jslint bitwise: true */
		(function () {

		  var ERROR = 'input is invalid type';
		  var WINDOW = typeof window === 'object';
		  var root = WINDOW ? window : {};
		  if (root.JS_SHA256_NO_WINDOW) {
		    WINDOW = false;
		  }
		  var WEB_WORKER = !WINDOW && typeof self === 'object';
		  var NODE_JS = !root.JS_SHA256_NO_NODE_JS && typeof process === 'object' && process.versions && process.versions.node;
		  if (NODE_JS) {
		    root = commonjsGlobal;
		  } else if (WEB_WORKER) {
		    root = self;
		  }
		  var COMMON_JS = !root.JS_SHA256_NO_COMMON_JS && 'object' === 'object' && module.exports;
		  var ARRAY_BUFFER = !root.JS_SHA256_NO_ARRAY_BUFFER && typeof ArrayBuffer !== 'undefined';
		  var HEX_CHARS = '0123456789abcdef'.split('');
		  var EXTRA = [-2147483648, 8388608, 32768, 128];
		  var SHIFT = [24, 16, 8, 0];
		  var K = [
		    0x428a2f98, 0x71374491, 0xb5c0fbcf, 0xe9b5dba5, 0x3956c25b, 0x59f111f1, 0x923f82a4, 0xab1c5ed5,
		    0xd807aa98, 0x12835b01, 0x243185be, 0x550c7dc3, 0x72be5d74, 0x80deb1fe, 0x9bdc06a7, 0xc19bf174,
		    0xe49b69c1, 0xefbe4786, 0x0fc19dc6, 0x240ca1cc, 0x2de92c6f, 0x4a7484aa, 0x5cb0a9dc, 0x76f988da,
		    0x983e5152, 0xa831c66d, 0xb00327c8, 0xbf597fc7, 0xc6e00bf3, 0xd5a79147, 0x06ca6351, 0x14292967,
		    0x27b70a85, 0x2e1b2138, 0x4d2c6dfc, 0x53380d13, 0x650a7354, 0x766a0abb, 0x81c2c92e, 0x92722c85,
		    0xa2bfe8a1, 0xa81a664b, 0xc24b8b70, 0xc76c51a3, 0xd192e819, 0xd6990624, 0xf40e3585, 0x106aa070,
		    0x19a4c116, 0x1e376c08, 0x2748774c, 0x34b0bcb5, 0x391c0cb3, 0x4ed8aa4a, 0x5b9cca4f, 0x682e6ff3,
		    0x748f82ee, 0x78a5636f, 0x84c87814, 0x8cc70208, 0x90befffa, 0xa4506ceb, 0xbef9a3f7, 0xc67178f2
		  ];
		  var OUTPUT_TYPES = ['hex', 'array', 'digest', 'arrayBuffer'];

		  var blocks = [];

		  if (root.JS_SHA256_NO_NODE_JS || !Array.isArray) {
		    Array.isArray = function (obj) {
		      return Object.prototype.toString.call(obj) === '[object Array]';
		    };
		  }

		  if (ARRAY_BUFFER && (root.JS_SHA256_NO_ARRAY_BUFFER_IS_VIEW || !ArrayBuffer.isView)) {
		    ArrayBuffer.isView = function (obj) {
		      return typeof obj === 'object' && obj.buffer && obj.buffer.constructor === ArrayBuffer;
		    };
		  }

		  var createOutputMethod = function (outputType, is224) {
		    return function (message) {
		      return new Sha256(is224, true).update(message)[outputType]();
		    };
		  };

		  var createMethod = function (is224) {
		    var method = createOutputMethod('hex', is224);
		    if (NODE_JS) {
		      method = nodeWrap(method, is224);
		    }
		    method.create = function () {
		      return new Sha256(is224);
		    };
		    method.update = function (message) {
		      return method.create().update(message);
		    };
		    for (var i = 0; i < OUTPUT_TYPES.length; ++i) {
		      var type = OUTPUT_TYPES[i];
		      method[type] = createOutputMethod(type, is224);
		    }
		    return method;
		  };

		  var nodeWrap = function (method, is224) {
		    var crypto = eval("require('crypto')");
		    var Buffer = eval("require('buffer').Buffer");
		    var algorithm = is224 ? 'sha224' : 'sha256';
		    var nodeMethod = function (message) {
		      if (typeof message === 'string') {
		        return crypto.createHash(algorithm).update(message, 'utf8').digest('hex');
		      } else {
		        if (message === null || message === undefined) {
		          throw new Error(ERROR);
		        } else if (message.constructor === ArrayBuffer) {
		          message = new Uint8Array(message);
		        }
		      }
		      if (Array.isArray(message) || ArrayBuffer.isView(message) ||
		        message.constructor === Buffer) {
		        return crypto.createHash(algorithm).update(new Buffer(message)).digest('hex');
		      } else {
		        return method(message);
		      }
		    };
		    return nodeMethod;
		  };

		  var createHmacOutputMethod = function (outputType, is224) {
		    return function (key, message) {
		      return new HmacSha256(key, is224, true).update(message)[outputType]();
		    };
		  };

		  var createHmacMethod = function (is224) {
		    var method = createHmacOutputMethod('hex', is224);
		    method.create = function (key) {
		      return new HmacSha256(key, is224);
		    };
		    method.update = function (key, message) {
		      return method.create(key).update(message);
		    };
		    for (var i = 0; i < OUTPUT_TYPES.length; ++i) {
		      var type = OUTPUT_TYPES[i];
		      method[type] = createHmacOutputMethod(type, is224);
		    }
		    return method;
		  };

		  function Sha256(is224, sharedMemory) {
		    if (sharedMemory) {
		      blocks[0] = blocks[16] = blocks[1] = blocks[2] = blocks[3] =
		        blocks[4] = blocks[5] = blocks[6] = blocks[7] =
		        blocks[8] = blocks[9] = blocks[10] = blocks[11] =
		        blocks[12] = blocks[13] = blocks[14] = blocks[15] = 0;
		      this.blocks = blocks;
		    } else {
		      this.blocks = [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0];
		    }

		    if (is224) {
		      this.h0 = 0xc1059ed8;
		      this.h1 = 0x367cd507;
		      this.h2 = 0x3070dd17;
		      this.h3 = 0xf70e5939;
		      this.h4 = 0xffc00b31;
		      this.h5 = 0x68581511;
		      this.h6 = 0x64f98fa7;
		      this.h7 = 0xbefa4fa4;
		    } else { // 256
		      this.h0 = 0x6a09e667;
		      this.h1 = 0xbb67ae85;
		      this.h2 = 0x3c6ef372;
		      this.h3 = 0xa54ff53a;
		      this.h4 = 0x510e527f;
		      this.h5 = 0x9b05688c;
		      this.h6 = 0x1f83d9ab;
		      this.h7 = 0x5be0cd19;
		    }

		    this.block = this.start = this.bytes = this.hBytes = 0;
		    this.finalized = this.hashed = false;
		    this.first = true;
		    this.is224 = is224;
		  }

		  Sha256.prototype.update = function (message) {
		    if (this.finalized) {
		      return;
		    }
		    var notString, type = typeof message;
		    if (type !== 'string') {
		      if (type === 'object') {
		        if (message === null) {
		          throw new Error(ERROR);
		        } else if (ARRAY_BUFFER && message.constructor === ArrayBuffer) {
		          message = new Uint8Array(message);
		        } else if (!Array.isArray(message)) {
		          if (!ARRAY_BUFFER || !ArrayBuffer.isView(message)) {
		            throw new Error(ERROR);
		          }
		        }
		      } else {
		        throw new Error(ERROR);
		      }
		      notString = true;
		    }
		    var code, index = 0, i, length = message.length, blocks = this.blocks;

		    while (index < length) {
		      if (this.hashed) {
		        this.hashed = false;
		        blocks[0] = this.block;
		        blocks[16] = blocks[1] = blocks[2] = blocks[3] =
		          blocks[4] = blocks[5] = blocks[6] = blocks[7] =
		          blocks[8] = blocks[9] = blocks[10] = blocks[11] =
		          blocks[12] = blocks[13] = blocks[14] = blocks[15] = 0;
		      }

		      if (notString) {
		        for (i = this.start; index < length && i < 64; ++index) {
		          blocks[i >> 2] |= message[index] << SHIFT[i++ & 3];
		        }
		      } else {
		        for (i = this.start; index < length && i < 64; ++index) {
		          code = message.charCodeAt(index);
		          if (code < 0x80) {
		            blocks[i >> 2] |= code << SHIFT[i++ & 3];
		          } else if (code < 0x800) {
		            blocks[i >> 2] |= (0xc0 | (code >> 6)) << SHIFT[i++ & 3];
		            blocks[i >> 2] |= (0x80 | (code & 0x3f)) << SHIFT[i++ & 3];
		          } else if (code < 0xd800 || code >= 0xe000) {
		            blocks[i >> 2] |= (0xe0 | (code >> 12)) << SHIFT[i++ & 3];
		            blocks[i >> 2] |= (0x80 | ((code >> 6) & 0x3f)) << SHIFT[i++ & 3];
		            blocks[i >> 2] |= (0x80 | (code & 0x3f)) << SHIFT[i++ & 3];
		          } else {
		            code = 0x10000 + (((code & 0x3ff) << 10) | (message.charCodeAt(++index) & 0x3ff));
		            blocks[i >> 2] |= (0xf0 | (code >> 18)) << SHIFT[i++ & 3];
		            blocks[i >> 2] |= (0x80 | ((code >> 12) & 0x3f)) << SHIFT[i++ & 3];
		            blocks[i >> 2] |= (0x80 | ((code >> 6) & 0x3f)) << SHIFT[i++ & 3];
		            blocks[i >> 2] |= (0x80 | (code & 0x3f)) << SHIFT[i++ & 3];
		          }
		        }
		      }

		      this.lastByteIndex = i;
		      this.bytes += i - this.start;
		      if (i >= 64) {
		        this.block = blocks[16];
		        this.start = i - 64;
		        this.hash();
		        this.hashed = true;
		      } else {
		        this.start = i;
		      }
		    }
		    if (this.bytes > 4294967295) {
		      this.hBytes += this.bytes / 4294967296 << 0;
		      this.bytes = this.bytes % 4294967296;
		    }
		    return this;
		  };

		  Sha256.prototype.finalize = function () {
		    if (this.finalized) {
		      return;
		    }
		    this.finalized = true;
		    var blocks = this.blocks, i = this.lastByteIndex;
		    blocks[16] = this.block;
		    blocks[i >> 2] |= EXTRA[i & 3];
		    this.block = blocks[16];
		    if (i >= 56) {
		      if (!this.hashed) {
		        this.hash();
		      }
		      blocks[0] = this.block;
		      blocks[16] = blocks[1] = blocks[2] = blocks[3] =
		        blocks[4] = blocks[5] = blocks[6] = blocks[7] =
		        blocks[8] = blocks[9] = blocks[10] = blocks[11] =
		        blocks[12] = blocks[13] = blocks[14] = blocks[15] = 0;
		    }
		    blocks[14] = this.hBytes << 3 | this.bytes >>> 29;
		    blocks[15] = this.bytes << 3;
		    this.hash();
		  };

		  Sha256.prototype.hash = function () {
		    var a = this.h0, b = this.h1, c = this.h2, d = this.h3, e = this.h4, f = this.h5, g = this.h6,
		      h = this.h7, blocks = this.blocks, j, s0, s1, maj, t1, t2, ch, ab, da, cd, bc;

		    for (j = 16; j < 64; ++j) {
		      // rightrotate
		      t1 = blocks[j - 15];
		      s0 = ((t1 >>> 7) | (t1 << 25)) ^ ((t1 >>> 18) | (t1 << 14)) ^ (t1 >>> 3);
		      t1 = blocks[j - 2];
		      s1 = ((t1 >>> 17) | (t1 << 15)) ^ ((t1 >>> 19) | (t1 << 13)) ^ (t1 >>> 10);
		      blocks[j] = blocks[j - 16] + s0 + blocks[j - 7] + s1 << 0;
		    }

		    bc = b & c;
		    for (j = 0; j < 64; j += 4) {
		      if (this.first) {
		        if (this.is224) {
		          ab = 300032;
		          t1 = blocks[0] - 1413257819;
		          h = t1 - 150054599 << 0;
		          d = t1 + 24177077 << 0;
		        } else {
		          ab = 704751109;
		          t1 = blocks[0] - 210244248;
		          h = t1 - 1521486534 << 0;
		          d = t1 + 143694565 << 0;
		        }
		        this.first = false;
		      } else {
		        s0 = ((a >>> 2) | (a << 30)) ^ ((a >>> 13) | (a << 19)) ^ ((a >>> 22) | (a << 10));
		        s1 = ((e >>> 6) | (e << 26)) ^ ((e >>> 11) | (e << 21)) ^ ((e >>> 25) | (e << 7));
		        ab = a & b;
		        maj = ab ^ (a & c) ^ bc;
		        ch = (e & f) ^ (~e & g);
		        t1 = h + s1 + ch + K[j] + blocks[j];
		        t2 = s0 + maj;
		        h = d + t1 << 0;
		        d = t1 + t2 << 0;
		      }
		      s0 = ((d >>> 2) | (d << 30)) ^ ((d >>> 13) | (d << 19)) ^ ((d >>> 22) | (d << 10));
		      s1 = ((h >>> 6) | (h << 26)) ^ ((h >>> 11) | (h << 21)) ^ ((h >>> 25) | (h << 7));
		      da = d & a;
		      maj = da ^ (d & b) ^ ab;
		      ch = (h & e) ^ (~h & f);
		      t1 = g + s1 + ch + K[j + 1] + blocks[j + 1];
		      t2 = s0 + maj;
		      g = c + t1 << 0;
		      c = t1 + t2 << 0;
		      s0 = ((c >>> 2) | (c << 30)) ^ ((c >>> 13) | (c << 19)) ^ ((c >>> 22) | (c << 10));
		      s1 = ((g >>> 6) | (g << 26)) ^ ((g >>> 11) | (g << 21)) ^ ((g >>> 25) | (g << 7));
		      cd = c & d;
		      maj = cd ^ (c & a) ^ da;
		      ch = (g & h) ^ (~g & e);
		      t1 = f + s1 + ch + K[j + 2] + blocks[j + 2];
		      t2 = s0 + maj;
		      f = b + t1 << 0;
		      b = t1 + t2 << 0;
		      s0 = ((b >>> 2) | (b << 30)) ^ ((b >>> 13) | (b << 19)) ^ ((b >>> 22) | (b << 10));
		      s1 = ((f >>> 6) | (f << 26)) ^ ((f >>> 11) | (f << 21)) ^ ((f >>> 25) | (f << 7));
		      bc = b & c;
		      maj = bc ^ (b & d) ^ cd;
		      ch = (f & g) ^ (~f & h);
		      t1 = e + s1 + ch + K[j + 3] + blocks[j + 3];
		      t2 = s0 + maj;
		      e = a + t1 << 0;
		      a = t1 + t2 << 0;
		    }

		    this.h0 = this.h0 + a << 0;
		    this.h1 = this.h1 + b << 0;
		    this.h2 = this.h2 + c << 0;
		    this.h3 = this.h3 + d << 0;
		    this.h4 = this.h4 + e << 0;
		    this.h5 = this.h5 + f << 0;
		    this.h6 = this.h6 + g << 0;
		    this.h7 = this.h7 + h << 0;
		  };

		  Sha256.prototype.hex = function () {
		    this.finalize();

		    var h0 = this.h0, h1 = this.h1, h2 = this.h2, h3 = this.h3, h4 = this.h4, h5 = this.h5,
		      h6 = this.h6, h7 = this.h7;

		    var hex = HEX_CHARS[(h0 >> 28) & 0x0F] + HEX_CHARS[(h0 >> 24) & 0x0F] +
		      HEX_CHARS[(h0 >> 20) & 0x0F] + HEX_CHARS[(h0 >> 16) & 0x0F] +
		      HEX_CHARS[(h0 >> 12) & 0x0F] + HEX_CHARS[(h0 >> 8) & 0x0F] +
		      HEX_CHARS[(h0 >> 4) & 0x0F] + HEX_CHARS[h0 & 0x0F] +
		      HEX_CHARS[(h1 >> 28) & 0x0F] + HEX_CHARS[(h1 >> 24) & 0x0F] +
		      HEX_CHARS[(h1 >> 20) & 0x0F] + HEX_CHARS[(h1 >> 16) & 0x0F] +
		      HEX_CHARS[(h1 >> 12) & 0x0F] + HEX_CHARS[(h1 >> 8) & 0x0F] +
		      HEX_CHARS[(h1 >> 4) & 0x0F] + HEX_CHARS[h1 & 0x0F] +
		      HEX_CHARS[(h2 >> 28) & 0x0F] + HEX_CHARS[(h2 >> 24) & 0x0F] +
		      HEX_CHARS[(h2 >> 20) & 0x0F] + HEX_CHARS[(h2 >> 16) & 0x0F] +
		      HEX_CHARS[(h2 >> 12) & 0x0F] + HEX_CHARS[(h2 >> 8) & 0x0F] +
		      HEX_CHARS[(h2 >> 4) & 0x0F] + HEX_CHARS[h2 & 0x0F] +
		      HEX_CHARS[(h3 >> 28) & 0x0F] + HEX_CHARS[(h3 >> 24) & 0x0F] +
		      HEX_CHARS[(h3 >> 20) & 0x0F] + HEX_CHARS[(h3 >> 16) & 0x0F] +
		      HEX_CHARS[(h3 >> 12) & 0x0F] + HEX_CHARS[(h3 >> 8) & 0x0F] +
		      HEX_CHARS[(h3 >> 4) & 0x0F] + HEX_CHARS[h3 & 0x0F] +
		      HEX_CHARS[(h4 >> 28) & 0x0F] + HEX_CHARS[(h4 >> 24) & 0x0F] +
		      HEX_CHARS[(h4 >> 20) & 0x0F] + HEX_CHARS[(h4 >> 16) & 0x0F] +
		      HEX_CHARS[(h4 >> 12) & 0x0F] + HEX_CHARS[(h4 >> 8) & 0x0F] +
		      HEX_CHARS[(h4 >> 4) & 0x0F] + HEX_CHARS[h4 & 0x0F] +
		      HEX_CHARS[(h5 >> 28) & 0x0F] + HEX_CHARS[(h5 >> 24) & 0x0F] +
		      HEX_CHARS[(h5 >> 20) & 0x0F] + HEX_CHARS[(h5 >> 16) & 0x0F] +
		      HEX_CHARS[(h5 >> 12) & 0x0F] + HEX_CHARS[(h5 >> 8) & 0x0F] +
		      HEX_CHARS[(h5 >> 4) & 0x0F] + HEX_CHARS[h5 & 0x0F] +
		      HEX_CHARS[(h6 >> 28) & 0x0F] + HEX_CHARS[(h6 >> 24) & 0x0F] +
		      HEX_CHARS[(h6 >> 20) & 0x0F] + HEX_CHARS[(h6 >> 16) & 0x0F] +
		      HEX_CHARS[(h6 >> 12) & 0x0F] + HEX_CHARS[(h6 >> 8) & 0x0F] +
		      HEX_CHARS[(h6 >> 4) & 0x0F] + HEX_CHARS[h6 & 0x0F];
		    if (!this.is224) {
		      hex += HEX_CHARS[(h7 >> 28) & 0x0F] + HEX_CHARS[(h7 >> 24) & 0x0F] +
		        HEX_CHARS[(h7 >> 20) & 0x0F] + HEX_CHARS[(h7 >> 16) & 0x0F] +
		        HEX_CHARS[(h7 >> 12) & 0x0F] + HEX_CHARS[(h7 >> 8) & 0x0F] +
		        HEX_CHARS[(h7 >> 4) & 0x0F] + HEX_CHARS[h7 & 0x0F];
		    }
		    return hex;
		  };

		  Sha256.prototype.toString = Sha256.prototype.hex;

		  Sha256.prototype.digest = function () {
		    this.finalize();

		    var h0 = this.h0, h1 = this.h1, h2 = this.h2, h3 = this.h3, h4 = this.h4, h5 = this.h5,
		      h6 = this.h6, h7 = this.h7;

		    var arr = [
		      (h0 >> 24) & 0xFF, (h0 >> 16) & 0xFF, (h0 >> 8) & 0xFF, h0 & 0xFF,
		      (h1 >> 24) & 0xFF, (h1 >> 16) & 0xFF, (h1 >> 8) & 0xFF, h1 & 0xFF,
		      (h2 >> 24) & 0xFF, (h2 >> 16) & 0xFF, (h2 >> 8) & 0xFF, h2 & 0xFF,
		      (h3 >> 24) & 0xFF, (h3 >> 16) & 0xFF, (h3 >> 8) & 0xFF, h3 & 0xFF,
		      (h4 >> 24) & 0xFF, (h4 >> 16) & 0xFF, (h4 >> 8) & 0xFF, h4 & 0xFF,
		      (h5 >> 24) & 0xFF, (h5 >> 16) & 0xFF, (h5 >> 8) & 0xFF, h5 & 0xFF,
		      (h6 >> 24) & 0xFF, (h6 >> 16) & 0xFF, (h6 >> 8) & 0xFF, h6 & 0xFF
		    ];
		    if (!this.is224) {
		      arr.push((h7 >> 24) & 0xFF, (h7 >> 16) & 0xFF, (h7 >> 8) & 0xFF, h7 & 0xFF);
		    }
		    return arr;
		  };

		  Sha256.prototype.array = Sha256.prototype.digest;

		  Sha256.prototype.arrayBuffer = function () {
		    this.finalize();

		    var buffer = new ArrayBuffer(this.is224 ? 28 : 32);
		    var dataView = new DataView(buffer);
		    dataView.setUint32(0, this.h0);
		    dataView.setUint32(4, this.h1);
		    dataView.setUint32(8, this.h2);
		    dataView.setUint32(12, this.h3);
		    dataView.setUint32(16, this.h4);
		    dataView.setUint32(20, this.h5);
		    dataView.setUint32(24, this.h6);
		    if (!this.is224) {
		      dataView.setUint32(28, this.h7);
		    }
		    return buffer;
		  };

		  function HmacSha256(key, is224, sharedMemory) {
		    var i, type = typeof key;
		    if (type === 'string') {
		      var bytes = [], length = key.length, index = 0, code;
		      for (i = 0; i < length; ++i) {
		        code = key.charCodeAt(i);
		        if (code < 0x80) {
		          bytes[index++] = code;
		        } else if (code < 0x800) {
		          bytes[index++] = (0xc0 | (code >> 6));
		          bytes[index++] = (0x80 | (code & 0x3f));
		        } else if (code < 0xd800 || code >= 0xe000) {
		          bytes[index++] = (0xe0 | (code >> 12));
		          bytes[index++] = (0x80 | ((code >> 6) & 0x3f));
		          bytes[index++] = (0x80 | (code & 0x3f));
		        } else {
		          code = 0x10000 + (((code & 0x3ff) << 10) | (key.charCodeAt(++i) & 0x3ff));
		          bytes[index++] = (0xf0 | (code >> 18));
		          bytes[index++] = (0x80 | ((code >> 12) & 0x3f));
		          bytes[index++] = (0x80 | ((code >> 6) & 0x3f));
		          bytes[index++] = (0x80 | (code & 0x3f));
		        }
		      }
		      key = bytes;
		    } else {
		      if (type === 'object') {
		        if (key === null) {
		          throw new Error(ERROR);
		        } else if (ARRAY_BUFFER && key.constructor === ArrayBuffer) {
		          key = new Uint8Array(key);
		        } else if (!Array.isArray(key)) {
		          if (!ARRAY_BUFFER || !ArrayBuffer.isView(key)) {
		            throw new Error(ERROR);
		          }
		        }
		      } else {
		        throw new Error(ERROR);
		      }
		    }

		    if (key.length > 64) {
		      key = (new Sha256(is224, true)).update(key).array();
		    }

		    var oKeyPad = [], iKeyPad = [];
		    for (i = 0; i < 64; ++i) {
		      var b = key[i] || 0;
		      oKeyPad[i] = 0x5c ^ b;
		      iKeyPad[i] = 0x36 ^ b;
		    }

		    Sha256.call(this, is224, sharedMemory);

		    this.update(iKeyPad);
		    this.oKeyPad = oKeyPad;
		    this.inner = true;
		    this.sharedMemory = sharedMemory;
		  }
		  HmacSha256.prototype = new Sha256();

		  HmacSha256.prototype.finalize = function () {
		    Sha256.prototype.finalize.call(this);
		    if (this.inner) {
		      this.inner = false;
		      var innerHash = this.array();
		      Sha256.call(this, this.is224, this.sharedMemory);
		      this.update(this.oKeyPad);
		      this.update(innerHash);
		      Sha256.prototype.finalize.call(this);
		    }
		  };

		  var exports = createMethod();
		  exports.sha256 = exports;
		  exports.sha224 = createMethod(true);
		  exports.sha256.hmac = createHmacMethod();
		  exports.sha224.hmac = createHmacMethod(true);

		  if (COMMON_JS) {
		    module.exports = exports;
		  } else {
		    root.sha256 = exports.sha256;
		    root.sha224 = exports.sha224;
		  }
		})();
	} (sha256));

	var idl = {};

	var error = {};

	var features$2 = {};

	Object.defineProperty(features$2, "__esModule", { value: true });
	features$2.isSet = features$2.set = void 0;
	const _AVAILABLE_FEATURES = new Set(["anchor-deprecated-state", "debug-logs"]);
	const _FEATURES = new Map();
	function set(key) {
	    if (!_AVAILABLE_FEATURES.has(key)) {
	        throw new Error("Invalid feature");
	    }
	    _FEATURES.set(key, true);
	}
	features$2.set = set;
	function isSet(key) {
	    return _FEATURES.get(key) !== undefined;
	}
	features$2.isSet = isSet;

	(function (exports) {
		var __createBinding = (commonjsGlobal && commonjsGlobal.__createBinding) || (Object.create ? (function(o, m, k, k2) {
		    if (k2 === undefined) k2 = k;
		    var desc = Object.getOwnPropertyDescriptor(m, k);
		    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
		      desc = { enumerable: true, get: function() { return m[k]; } };
		    }
		    Object.defineProperty(o, k2, desc);
		}) : (function(o, m, k, k2) {
		    if (k2 === undefined) k2 = k;
		    o[k2] = m[k];
		}));
		var __setModuleDefault = (commonjsGlobal && commonjsGlobal.__setModuleDefault) || (Object.create ? (function(o, v) {
		    Object.defineProperty(o, "default", { enumerable: true, value: v });
		}) : function(o, v) {
		    o["default"] = v;
		});
		var __importStar = (commonjsGlobal && commonjsGlobal.__importStar) || function (mod) {
		    if (mod && mod.__esModule) return mod;
		    var result = {};
		    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
		    __setModuleDefault(result, mod);
		    return result;
		};
		Object.defineProperty(exports, "__esModule", { value: true });
		exports.LangErrorMessage = exports.LangErrorCode = exports.translateError = exports.ProgramError = exports.AnchorError = exports.ProgramErrorStack = exports.IdlError = void 0;
		const web3_js_1 = require$$0$1;
		const features = __importStar(features$2);
		class IdlError extends Error {
		    constructor(message) {
		        super(message);
		        this.name = "IdlError";
		    }
		}
		exports.IdlError = IdlError;
		class ProgramErrorStack {
		    constructor(stack) {
		        this.stack = stack;
		    }
		    static parse(logs) {
		        var _a;
		        const programKeyRegex = /^Program (\w*) invoke/;
		        const successRegex = /^Program \w* success/;
		        const programStack = [];
		        for (let i = 0; i < logs.length; i++) {
		            if (successRegex.exec(logs[i])) {
		                programStack.pop();
		                continue;
		            }
		            const programKey = (_a = programKeyRegex.exec(logs[i])) === null || _a === void 0 ? void 0 : _a[1];
		            if (!programKey) {
		                continue;
		            }
		            programStack.push(new web3_js_1.PublicKey(programKey));
		        }
		        return new ProgramErrorStack(programStack);
		    }
		}
		exports.ProgramErrorStack = ProgramErrorStack;
		class AnchorError extends Error {
		    constructor(errorCode, errorMessage, errorLogs, logs, origin, comparedValues) {
		        super(errorLogs.join("\n").replace("Program log: ", ""));
		        this.errorLogs = errorLogs;
		        this.logs = logs;
		        this.error = { errorCode, errorMessage, comparedValues, origin };
		        this._programErrorStack = ProgramErrorStack.parse(logs);
		    }
		    static parse(logs) {
		        if (!logs) {
		            return null;
		        }
		        const anchorErrorLogIndex = logs.findIndex((log) => log.startsWith("Program log: AnchorError"));
		        if (anchorErrorLogIndex === -1) {
		            return null;
		        }
		        const anchorErrorLog = logs[anchorErrorLogIndex];
		        const errorLogs = [anchorErrorLog];
		        let comparedValues;
		        if (anchorErrorLogIndex + 1 < logs.length) {
		            // This catches the comparedValues where the following is logged
		            // <AnchorError>
		            // Left:
		            // <Pubkey>
		            // Right:
		            // <Pubkey>
		            if (logs[anchorErrorLogIndex + 1] === "Program log: Left:") {
		                const pubkeyRegex = /^Program log: (.*)$/;
		                const leftPubkey = pubkeyRegex.exec(logs[anchorErrorLogIndex + 2])[1];
		                const rightPubkey = pubkeyRegex.exec(logs[anchorErrorLogIndex + 4])[1];
		                comparedValues = [
		                    new web3_js_1.PublicKey(leftPubkey),
		                    new web3_js_1.PublicKey(rightPubkey),
		                ];
		                errorLogs.push(...logs.slice(anchorErrorLogIndex + 1, anchorErrorLogIndex + 5));
		            }
		            // This catches the comparedValues where the following is logged
		            // <AnchorError>
		            // Left: <value>
		            // Right: <value>
		            else if (logs[anchorErrorLogIndex + 1].startsWith("Program log: Left:")) {
		                const valueRegex = /^Program log: (Left|Right): (.*)$/;
		                const leftValue = valueRegex.exec(logs[anchorErrorLogIndex + 1])[2];
		                const rightValue = valueRegex.exec(logs[anchorErrorLogIndex + 2])[2];
		                errorLogs.push(...logs.slice(anchorErrorLogIndex + 1, anchorErrorLogIndex + 3));
		                comparedValues = [leftValue, rightValue];
		            }
		        }
		        const regexNoInfo = /^Program log: AnchorError occurred\. Error Code: (.*)\. Error Number: (\d*)\. Error Message: (.*)\./;
		        const noInfoAnchorErrorLog = regexNoInfo.exec(anchorErrorLog);
		        const regexFileLine = /^Program log: AnchorError thrown in (.*):(\d*)\. Error Code: (.*)\. Error Number: (\d*)\. Error Message: (.*)\./;
		        const fileLineAnchorErrorLog = regexFileLine.exec(anchorErrorLog);
		        const regexAccountName = /^Program log: AnchorError caused by account: (.*)\. Error Code: (.*)\. Error Number: (\d*)\. Error Message: (.*)\./;
		        const accountNameAnchorErrorLog = regexAccountName.exec(anchorErrorLog);
		        if (noInfoAnchorErrorLog) {
		            const [errorCodeString, errorNumber, errorMessage] = noInfoAnchorErrorLog.slice(1, 4);
		            const errorCode = {
		                code: errorCodeString,
		                number: parseInt(errorNumber),
		            };
		            return new AnchorError(errorCode, errorMessage, errorLogs, logs, undefined, comparedValues);
		        }
		        else if (fileLineAnchorErrorLog) {
		            const [file, line, errorCodeString, errorNumber, errorMessage] = fileLineAnchorErrorLog.slice(1, 6);
		            const errorCode = {
		                code: errorCodeString,
		                number: parseInt(errorNumber),
		            };
		            const fileLine = { file, line: parseInt(line) };
		            return new AnchorError(errorCode, errorMessage, errorLogs, logs, fileLine, comparedValues);
		        }
		        else if (accountNameAnchorErrorLog) {
		            const [accountName, errorCodeString, errorNumber, errorMessage] = accountNameAnchorErrorLog.slice(1, 5);
		            const origin = accountName;
		            const errorCode = {
		                code: errorCodeString,
		                number: parseInt(errorNumber),
		            };
		            return new AnchorError(errorCode, errorMessage, errorLogs, logs, origin, comparedValues);
		        }
		        else {
		            return null;
		        }
		    }
		    get program() {
		        return this._programErrorStack.stack[this._programErrorStack.stack.length - 1];
		    }
		    get programErrorStack() {
		        return this._programErrorStack.stack;
		    }
		    toString() {
		        return this.message;
		    }
		}
		exports.AnchorError = AnchorError;
		// An error from a user defined program.
		class ProgramError extends Error {
		    constructor(code, msg, logs) {
		        super();
		        this.code = code;
		        this.msg = msg;
		        this.logs = logs;
		        if (logs) {
		            this._programErrorStack = ProgramErrorStack.parse(logs);
		        }
		    }
		    static parse(err, idlErrors) {
		        const errString = err.toString();
		        // TODO: don't rely on the error string. web3.js should preserve the error
		        //       code information instead of giving us an untyped string.
		        let unparsedErrorCode;
		        if (errString.includes("custom program error:")) {
		            let components = errString.split("custom program error: ");
		            if (components.length !== 2) {
		                return null;
		            }
		            else {
		                unparsedErrorCode = components[1];
		            }
		        }
		        else {
		            const matches = errString.match(/"Custom":([0-9]+)}/g);
		            if (!matches || matches.length > 1) {
		                return null;
		            }
		            unparsedErrorCode = matches[0].match(/([0-9]+)/g)[0];
		        }
		        let errorCode;
		        try {
		            errorCode = parseInt(unparsedErrorCode);
		        }
		        catch (parseErr) {
		            return null;
		        }
		        // Parse user error.
		        let errorMsg = idlErrors.get(errorCode);
		        if (errorMsg !== undefined) {
		            return new ProgramError(errorCode, errorMsg, err.logs);
		        }
		        // Parse framework internal error.
		        errorMsg = exports.LangErrorMessage.get(errorCode);
		        if (errorMsg !== undefined) {
		            return new ProgramError(errorCode, errorMsg, err.logs);
		        }
		        // Unable to parse the error. Just return the untranslated error.
		        return null;
		    }
		    get program() {
		        var _a;
		        return (_a = this._programErrorStack) === null || _a === void 0 ? void 0 : _a.stack[this._programErrorStack.stack.length - 1];
		    }
		    get programErrorStack() {
		        var _a;
		        return (_a = this._programErrorStack) === null || _a === void 0 ? void 0 : _a.stack;
		    }
		    toString() {
		        return this.msg;
		    }
		}
		exports.ProgramError = ProgramError;
		function translateError(err, idlErrors) {
		    if (features.isSet("debug-logs")) {
		        console.log("Translating error:", err);
		    }
		    const anchorError = AnchorError.parse(err.logs);
		    if (anchorError) {
		        return anchorError;
		    }
		    const programError = ProgramError.parse(err, idlErrors);
		    if (programError) {
		        return programError;
		    }
		    if (err.logs) {
		        const handler = {
		            get: function (target, prop) {
		                if (prop === "programErrorStack") {
		                    return target.programErrorStack.stack;
		                }
		                else if (prop === "program") {
		                    return target.programErrorStack.stack[err.programErrorStack.stack.length - 1];
		                }
		                else {
		                    // this is the normal way to return all other props
		                    // without modifying them.
		                    // @ts-expect-error
		                    return Reflect.get(...arguments);
		                }
		            },
		        };
		        err.programErrorStack = ProgramErrorStack.parse(err.logs);
		        return new Proxy(err, handler);
		    }
		    return err;
		}
		exports.translateError = translateError;
		exports.LangErrorCode = {
		    // Instructions.
		    InstructionMissing: 100,
		    InstructionFallbackNotFound: 101,
		    InstructionDidNotDeserialize: 102,
		    InstructionDidNotSerialize: 103,
		    // IDL instructions.
		    IdlInstructionStub: 1000,
		    IdlInstructionInvalidProgram: 1001,
		    // Constraints.
		    ConstraintMut: 2000,
		    ConstraintHasOne: 2001,
		    ConstraintSigner: 2002,
		    ConstraintRaw: 2003,
		    ConstraintOwner: 2004,
		    ConstraintRentExempt: 2005,
		    ConstraintSeeds: 2006,
		    ConstraintExecutable: 2007,
		    ConstraintState: 2008,
		    ConstraintAssociated: 2009,
		    ConstraintAssociatedInit: 2010,
		    ConstraintClose: 2011,
		    ConstraintAddress: 2012,
		    ConstraintZero: 2013,
		    ConstraintTokenMint: 2014,
		    ConstraintTokenOwner: 2015,
		    ConstraintMintMintAuthority: 2016,
		    ConstraintMintFreezeAuthority: 2017,
		    ConstraintMintDecimals: 2018,
		    ConstraintSpace: 2019,
		    // Require.
		    RequireViolated: 2500,
		    RequireEqViolated: 2501,
		    RequireKeysEqViolated: 2502,
		    RequireNeqViolated: 2503,
		    RequireKeysNeqViolated: 2504,
		    RequireGtViolated: 2505,
		    RequireGteViolated: 2506,
		    // Accounts.
		    AccountDiscriminatorAlreadySet: 3000,
		    AccountDiscriminatorNotFound: 3001,
		    AccountDiscriminatorMismatch: 3002,
		    AccountDidNotDeserialize: 3003,
		    AccountDidNotSerialize: 3004,
		    AccountNotEnoughKeys: 3005,
		    AccountNotMutable: 3006,
		    AccountOwnedByWrongProgram: 3007,
		    InvalidProgramId: 3008,
		    InvalidProgramExecutable: 3009,
		    AccountNotSigner: 3010,
		    AccountNotSystemOwned: 3011,
		    AccountNotInitialized: 3012,
		    AccountNotProgramData: 3013,
		    AccountNotAssociatedTokenAccount: 3014,
		    AccountSysvarMismatch: 3015,
		    AccountReallocExceedsLimit: 3016,
		    AccountDuplicateReallocs: 3017,
		    // State.
		    StateInvalidAddress: 4000,
		    // Miscellaneous
		    DeclaredProgramIdMismatch: 4100,
		    // Used for APIs that shouldn't be used anymore.
		    Deprecated: 5000,
		};
		exports.LangErrorMessage = new Map([
		    // Instructions.
		    [
		        exports.LangErrorCode.InstructionMissing,
		        "8 byte instruction identifier not provided",
		    ],
		    [
		        exports.LangErrorCode.InstructionFallbackNotFound,
		        "Fallback functions are not supported",
		    ],
		    [
		        exports.LangErrorCode.InstructionDidNotDeserialize,
		        "The program could not deserialize the given instruction",
		    ],
		    [
		        exports.LangErrorCode.InstructionDidNotSerialize,
		        "The program could not serialize the given instruction",
		    ],
		    // Idl instructions.
		    [
		        exports.LangErrorCode.IdlInstructionStub,
		        "The program was compiled without idl instructions",
		    ],
		    [
		        exports.LangErrorCode.IdlInstructionInvalidProgram,
		        "The transaction was given an invalid program for the IDL instruction",
		    ],
		    // Constraints.
		    [exports.LangErrorCode.ConstraintMut, "A mut constraint was violated"],
		    [exports.LangErrorCode.ConstraintHasOne, "A has_one constraint was violated"],
		    [exports.LangErrorCode.ConstraintSigner, "A signer constraint was violated"],
		    [exports.LangErrorCode.ConstraintRaw, "A raw constraint was violated"],
		    [exports.LangErrorCode.ConstraintOwner, "An owner constraint was violated"],
		    [
		        exports.LangErrorCode.ConstraintRentExempt,
		        "A rent exemption constraint was violated",
		    ],
		    [exports.LangErrorCode.ConstraintSeeds, "A seeds constraint was violated"],
		    [exports.LangErrorCode.ConstraintExecutable, "An executable constraint was violated"],
		    [exports.LangErrorCode.ConstraintState, "A state constraint was violated"],
		    [exports.LangErrorCode.ConstraintAssociated, "An associated constraint was violated"],
		    [
		        exports.LangErrorCode.ConstraintAssociatedInit,
		        "An associated init constraint was violated",
		    ],
		    [exports.LangErrorCode.ConstraintClose, "A close constraint was violated"],
		    [exports.LangErrorCode.ConstraintAddress, "An address constraint was violated"],
		    [exports.LangErrorCode.ConstraintZero, "Expected zero account discriminant"],
		    [exports.LangErrorCode.ConstraintTokenMint, "A token mint constraint was violated"],
		    [exports.LangErrorCode.ConstraintTokenOwner, "A token owner constraint was violated"],
		    [
		        exports.LangErrorCode.ConstraintMintMintAuthority,
		        "A mint mint authority constraint was violated",
		    ],
		    [
		        exports.LangErrorCode.ConstraintMintFreezeAuthority,
		        "A mint freeze authority constraint was violated",
		    ],
		    [
		        exports.LangErrorCode.ConstraintMintDecimals,
		        "A mint decimals constraint was violated",
		    ],
		    [exports.LangErrorCode.ConstraintSpace, "A space constraint was violated"],
		    // Require.
		    [exports.LangErrorCode.RequireViolated, "A require expression was violated"],
		    [exports.LangErrorCode.RequireEqViolated, "A require_eq expression was violated"],
		    [
		        exports.LangErrorCode.RequireKeysEqViolated,
		        "A require_keys_eq expression was violated",
		    ],
		    [exports.LangErrorCode.RequireNeqViolated, "A require_neq expression was violated"],
		    [
		        exports.LangErrorCode.RequireKeysNeqViolated,
		        "A require_keys_neq expression was violated",
		    ],
		    [exports.LangErrorCode.RequireGtViolated, "A require_gt expression was violated"],
		    [exports.LangErrorCode.RequireGteViolated, "A require_gte expression was violated"],
		    // Accounts.
		    [
		        exports.LangErrorCode.AccountDiscriminatorAlreadySet,
		        "The account discriminator was already set on this account",
		    ],
		    [
		        exports.LangErrorCode.AccountDiscriminatorNotFound,
		        "No 8 byte discriminator was found on the account",
		    ],
		    [
		        exports.LangErrorCode.AccountDiscriminatorMismatch,
		        "8 byte discriminator did not match what was expected",
		    ],
		    [exports.LangErrorCode.AccountDidNotDeserialize, "Failed to deserialize the account"],
		    [exports.LangErrorCode.AccountDidNotSerialize, "Failed to serialize the account"],
		    [
		        exports.LangErrorCode.AccountNotEnoughKeys,
		        "Not enough account keys given to the instruction",
		    ],
		    [exports.LangErrorCode.AccountNotMutable, "The given account is not mutable"],
		    [
		        exports.LangErrorCode.AccountOwnedByWrongProgram,
		        "The given account is owned by a different program than expected",
		    ],
		    [exports.LangErrorCode.InvalidProgramId, "Program ID was not as expected"],
		    [exports.LangErrorCode.InvalidProgramExecutable, "Program account is not executable"],
		    [exports.LangErrorCode.AccountNotSigner, "The given account did not sign"],
		    [
		        exports.LangErrorCode.AccountNotSystemOwned,
		        "The given account is not owned by the system program",
		    ],
		    [
		        exports.LangErrorCode.AccountNotInitialized,
		        "The program expected this account to be already initialized",
		    ],
		    [
		        exports.LangErrorCode.AccountNotProgramData,
		        "The given account is not a program data account",
		    ],
		    [
		        exports.LangErrorCode.AccountNotAssociatedTokenAccount,
		        "The given account is not the associated token account",
		    ],
		    [
		        exports.LangErrorCode.AccountSysvarMismatch,
		        "The given public key does not match the required sysvar",
		    ],
		    [
		        exports.LangErrorCode.AccountReallocExceedsLimit,
		        "The account reallocation exceeds the MAX_PERMITTED_DATA_INCREASE limit",
		    ],
		    [
		        exports.LangErrorCode.AccountDuplicateReallocs,
		        "The account was duplicated for more than one reallocation",
		    ],
		    // State.
		    [
		        exports.LangErrorCode.StateInvalidAddress,
		        "The given state account does not have the correct address",
		    ],
		    // Miscellaneous
		    [
		        exports.LangErrorCode.DeclaredProgramIdMismatch,
		        "The declared program id does not match the actual program id",
		    ],
		    // Deprecated
		    [
		        exports.LangErrorCode.Deprecated,
		        "The API being used is deprecated and should no longer be used",
		    ],
		]);
		
	} (error));

	var __createBinding$a = (commonjsGlobal && commonjsGlobal.__createBinding) || (Object.create ? (function(o, m, k, k2) {
	    if (k2 === undefined) k2 = k;
	    var desc = Object.getOwnPropertyDescriptor(m, k);
	    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
	      desc = { enumerable: true, get: function() { return m[k]; } };
	    }
	    Object.defineProperty(o, k2, desc);
	}) : (function(o, m, k, k2) {
	    if (k2 === undefined) k2 = k;
	    o[k2] = m[k];
	}));
	var __setModuleDefault$a = (commonjsGlobal && commonjsGlobal.__setModuleDefault) || (Object.create ? (function(o, v) {
	    Object.defineProperty(o, "default", { enumerable: true, value: v });
	}) : function(o, v) {
	    o["default"] = v;
	});
	var __importStar$a = (commonjsGlobal && commonjsGlobal.__importStar) || function (mod) {
	    if (mod && mod.__esModule) return mod;
	    var result = {};
	    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding$a(result, mod, k);
	    __setModuleDefault$a(result, mod);
	    return result;
	};
	var __importDefault$7 = (commonjsGlobal && commonjsGlobal.__importDefault) || function (mod) {
	    return (mod && mod.__esModule) ? mod : { "default": mod };
	};
	Object.defineProperty(idl, "__esModule", { value: true });
	idl.IdlCoder = void 0;
	const camelcase_1$4 = __importDefault$7(camelcaseExports);
	const borsh = __importStar$a(lib);
	const error_js_1$4 = error;
	class IdlCoder {
	    static fieldLayout(field, types) {
	        const fieldName = field.name !== undefined ? (0, camelcase_1$4.default)(field.name) : undefined;
	        switch (field.type) {
	            case "bool": {
	                return borsh.bool(fieldName);
	            }
	            case "u8": {
	                return borsh.u8(fieldName);
	            }
	            case "i8": {
	                return borsh.i8(fieldName);
	            }
	            case "u16": {
	                return borsh.u16(fieldName);
	            }
	            case "i16": {
	                return borsh.i16(fieldName);
	            }
	            case "u32": {
	                return borsh.u32(fieldName);
	            }
	            case "i32": {
	                return borsh.i32(fieldName);
	            }
	            case "f32": {
	                return borsh.f32(fieldName);
	            }
	            case "u64": {
	                return borsh.u64(fieldName);
	            }
	            case "i64": {
	                return borsh.i64(fieldName);
	            }
	            case "f64": {
	                return borsh.f64(fieldName);
	            }
	            case "u128": {
	                return borsh.u128(fieldName);
	            }
	            case "i128": {
	                return borsh.i128(fieldName);
	            }
	            case "bytes": {
	                return borsh.vecU8(fieldName);
	            }
	            case "string": {
	                return borsh.str(fieldName);
	            }
	            case "publicKey": {
	                return borsh.publicKey(fieldName);
	            }
	            default: {
	                if ("vec" in field.type) {
	                    return borsh.vec(IdlCoder.fieldLayout({
	                        name: undefined,
	                        type: field.type.vec,
	                    }, types), fieldName);
	                }
	                else if ("option" in field.type) {
	                    return borsh.option(IdlCoder.fieldLayout({
	                        name: undefined,
	                        type: field.type.option,
	                    }, types), fieldName);
	                }
	                else if ("defined" in field.type) {
	                    const defined = field.type.defined;
	                    // User defined type.
	                    if (types === undefined) {
	                        throw new error_js_1$4.IdlError("User defined types not provided");
	                    }
	                    const filtered = types.filter((t) => t.name === defined);
	                    if (filtered.length !== 1) {
	                        throw new error_js_1$4.IdlError(`Type not found: ${JSON.stringify(field)}`);
	                    }
	                    return IdlCoder.typeDefLayout(filtered[0], types, fieldName);
	                }
	                else if ("array" in field.type) {
	                    let arrayTy = field.type.array[0];
	                    let arrayLen = field.type.array[1];
	                    let innerLayout = IdlCoder.fieldLayout({
	                        name: undefined,
	                        type: arrayTy,
	                    }, types);
	                    return borsh.array(innerLayout, arrayLen, fieldName);
	                }
	                else {
	                    throw new Error(`Not yet implemented: ${field}`);
	                }
	            }
	        }
	    }
	    static typeDefLayout(typeDef, types = [], name) {
	        if (typeDef.type.kind === "struct") {
	            const fieldLayouts = typeDef.type.fields.map((field) => {
	                const x = IdlCoder.fieldLayout(field, types);
	                return x;
	            });
	            return borsh.struct(fieldLayouts, name);
	        }
	        else if (typeDef.type.kind === "enum") {
	            let variants = typeDef.type.variants.map((variant) => {
	                const name = (0, camelcase_1$4.default)(variant.name);
	                if (variant.fields === undefined) {
	                    return borsh.struct([], name);
	                }
	                const fieldLayouts = variant.fields.map((f) => {
	                    if (!f.hasOwnProperty("name")) {
	                        throw new Error("Tuple enum variants not yet implemented.");
	                    }
	                    // this typescript conversion is ok
	                    // because if f were of type IdlType
	                    // (that does not have a name property)
	                    // the check before would've errored
	                    return IdlCoder.fieldLayout(f, types);
	                });
	                return borsh.struct(fieldLayouts, name);
	            });
	            if (name !== undefined) {
	                // Buffer-layout lib requires the name to be null (on construction)
	                // when used as a field.
	                return borsh.rustEnum(variants).replicate(name);
	            }
	            return borsh.rustEnum(variants, name);
	        }
	        else {
	            throw new Error(`Unknown type kint: ${typeDef}`);
	        }
	    }
	}
	idl.IdlCoder = IdlCoder;

	(function (exports) {
		var __createBinding = (commonjsGlobal && commonjsGlobal.__createBinding) || (Object.create ? (function(o, m, k, k2) {
		    if (k2 === undefined) k2 = k;
		    var desc = Object.getOwnPropertyDescriptor(m, k);
		    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
		      desc = { enumerable: true, get: function() { return m[k]; } };
		    }
		    Object.defineProperty(o, k2, desc);
		}) : (function(o, m, k, k2) {
		    if (k2 === undefined) k2 = k;
		    o[k2] = m[k];
		}));
		var __setModuleDefault = (commonjsGlobal && commonjsGlobal.__setModuleDefault) || (Object.create ? (function(o, v) {
		    Object.defineProperty(o, "default", { enumerable: true, value: v });
		}) : function(o, v) {
		    o["default"] = v;
		});
		var __importStar = (commonjsGlobal && commonjsGlobal.__importStar) || function (mod) {
		    if (mod && mod.__esModule) return mod;
		    var result = {};
		    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
		    __setModuleDefault(result, mod);
		    return result;
		};
		var __importDefault = (commonjsGlobal && commonjsGlobal.__importDefault) || function (mod) {
		    return (mod && mod.__esModule) ? mod : { "default": mod };
		};
		Object.defineProperty(exports, "__esModule", { value: true });
		exports.BorshInstructionCoder = exports.SIGHASH_GLOBAL_NAMESPACE = exports.SIGHASH_STATE_NAMESPACE = void 0;
		const bs58_1 = __importDefault(bs58$1);
		const buffer_1 = require$$0;
		const camelcase_1 = __importDefault(camelcaseExports);
		const snake_case_1 = require$$3;
		const js_sha256_1 = sha256Exports;
		const borsh = __importStar(lib);
		const idl_js_1 = idl;
		/**
		 * Namespace for state method function signatures.
		 */
		exports.SIGHASH_STATE_NAMESPACE = "state";
		/**
		 * Namespace for global instruction function signatures (i.e. functions
		 * that aren't namespaced by the state or any of its trait implementations).
		 */
		exports.SIGHASH_GLOBAL_NAMESPACE = "global";
		/**
		 * Encodes and decodes program instructions.
		 */
		class BorshInstructionCoder {
		    constructor(idl) {
		        this.idl = idl;
		        this.ixLayout = BorshInstructionCoder.parseIxLayout(idl);
		        const sighashLayouts = new Map();
		        idl.instructions.forEach((ix) => {
		            const sh = sighash(exports.SIGHASH_GLOBAL_NAMESPACE, ix.name);
		            sighashLayouts.set(bs58_1.default.encode(sh), {
		                layout: this.ixLayout.get(ix.name),
		                name: ix.name,
		            });
		        });
		        if (idl.state) {
		            idl.state.methods.map((ix) => {
		                const sh = sighash(exports.SIGHASH_STATE_NAMESPACE, ix.name);
		                sighashLayouts.set(bs58_1.default.encode(sh), {
		                    layout: this.ixLayout.get(ix.name),
		                    name: ix.name,
		                });
		            });
		        }
		        this.sighashLayouts = sighashLayouts;
		    }
		    /**
		     * Encodes a program instruction.
		     */
		    encode(ixName, ix) {
		        return this._encode(exports.SIGHASH_GLOBAL_NAMESPACE, ixName, ix);
		    }
		    /**
		     * Encodes a program state instruction.
		     */
		    encodeState(ixName, ix) {
		        return this._encode(exports.SIGHASH_STATE_NAMESPACE, ixName, ix);
		    }
		    _encode(nameSpace, ixName, ix) {
		        const buffer = buffer_1.Buffer.alloc(1000); // TODO: use a tighter buffer.
		        const methodName = (0, camelcase_1.default)(ixName);
		        const layout = this.ixLayout.get(methodName);
		        if (!layout) {
		            throw new Error(`Unknown method: ${methodName}`);
		        }
		        const len = layout.encode(ix, buffer);
		        const data = buffer.slice(0, len);
		        return buffer_1.Buffer.concat([sighash(nameSpace, ixName), data]);
		    }
		    static parseIxLayout(idl) {
		        const stateMethods = idl.state ? idl.state.methods : [];
		        const ixLayouts = stateMethods
		            .map((m) => {
		            let fieldLayouts = m.args.map((arg) => {
		                var _a, _b;
		                return idl_js_1.IdlCoder.fieldLayout(arg, Array.from([...((_a = idl.accounts) !== null && _a !== void 0 ? _a : []), ...((_b = idl.types) !== null && _b !== void 0 ? _b : [])]));
		            });
		            const name = (0, camelcase_1.default)(m.name);
		            return [name, borsh.struct(fieldLayouts, name)];
		        })
		            .concat(idl.instructions.map((ix) => {
		            let fieldLayouts = ix.args.map((arg) => {
		                var _a, _b;
		                return idl_js_1.IdlCoder.fieldLayout(arg, Array.from([...((_a = idl.accounts) !== null && _a !== void 0 ? _a : []), ...((_b = idl.types) !== null && _b !== void 0 ? _b : [])]));
		            });
		            const name = (0, camelcase_1.default)(ix.name);
		            return [name, borsh.struct(fieldLayouts, name)];
		        }));
		        return new Map(ixLayouts);
		    }
		    /**
		     * Decodes a program instruction.
		     */
		    decode(ix, encoding = "hex") {
		        if (typeof ix === "string") {
		            ix = encoding === "hex" ? buffer_1.Buffer.from(ix, "hex") : bs58_1.default.decode(ix);
		        }
		        let sighash = bs58_1.default.encode(ix.slice(0, 8));
		        let data = ix.slice(8);
		        const decoder = this.sighashLayouts.get(sighash);
		        if (!decoder) {
		            return null;
		        }
		        return {
		            data: decoder.layout.decode(data),
		            name: decoder.name,
		        };
		    }
		    /**
		     * Returns a formatted table of all the fields in the given instruction data.
		     */
		    format(ix, accountMetas) {
		        return InstructionFormatter.format(ix, accountMetas, this.idl);
		    }
		}
		exports.BorshInstructionCoder = BorshInstructionCoder;
		class InstructionFormatter {
		    static format(ix, accountMetas, idl) {
		        const idlIx = idl.instructions.filter((i) => ix.name === i.name)[0];
		        if (idlIx === undefined) {
		            console.error("Invalid instruction given");
		            return null;
		        }
		        const args = idlIx.args.map((idlField) => {
		            return {
		                name: idlField.name,
		                type: InstructionFormatter.formatIdlType(idlField.type),
		                data: InstructionFormatter.formatIdlData(idlField, ix.data[idlField.name], idl.types),
		            };
		        });
		        const flatIdlAccounts = InstructionFormatter.flattenIdlAccounts(idlIx.accounts);
		        const accounts = accountMetas.map((meta, idx) => {
		            if (idx < flatIdlAccounts.length) {
		                return {
		                    name: flatIdlAccounts[idx].name,
		                    ...meta,
		                };
		            }
		            // "Remaining accounts" are unnamed in Anchor.
		            else {
		                return {
		                    name: undefined,
		                    ...meta,
		                };
		            }
		        });
		        return {
		            args,
		            accounts,
		        };
		    }
		    static formatIdlType(idlType) {
		        if (typeof idlType === "string") {
		            return idlType;
		        }
		        if ("vec" in idlType) {
		            return `Vec<${this.formatIdlType(idlType.vec)}>`;
		        }
		        if ("option" in idlType) {
		            return `Option<${this.formatIdlType(idlType.option)}>`;
		        }
		        if ("defined" in idlType) {
		            return idlType.defined;
		        }
		        if ("array" in idlType) {
		            return `Array<${idlType.array[0]}; ${idlType.array[1]}>`;
		        }
		        throw new Error(`Unknown IDL type: ${idlType}`);
		    }
		    static formatIdlData(idlField, data, types) {
		        if (typeof idlField.type === "string") {
		            return data.toString();
		        }
		        if (idlField.type.hasOwnProperty("vec")) {
		            return ("[" +
		                data
		                    .map((d) => this.formatIdlData({ name: "", type: idlField.type.vec }, d))
		                    .join(", ") +
		                "]");
		        }
		        if (idlField.type.hasOwnProperty("option")) {
		            return data === null
		                ? "null"
		                : this.formatIdlData({ name: "", type: idlField.type.option }, data, types);
		        }
		        if (idlField.type.hasOwnProperty("defined")) {
		            if (types === undefined) {
		                throw new Error("User defined types not provided");
		            }
		            const filtered = types.filter((t) => t.name === idlField.type.defined);
		            if (filtered.length !== 1) {
		                throw new Error(`Type not found: ${idlField.type.defined}`);
		            }
		            return InstructionFormatter.formatIdlDataDefined(filtered[0], data, types);
		        }
		        return "unknown";
		    }
		    static formatIdlDataDefined(typeDef, data, types) {
		        if (typeDef.type.kind === "struct") {
		            const struct = typeDef.type;
		            const fields = Object.keys(data)
		                .map((k) => {
		                const f = struct.fields.filter((f) => f.name === k)[0];
		                if (f === undefined) {
		                    throw new Error("Unable to find type");
		                }
		                return (k + ": " + InstructionFormatter.formatIdlData(f, data[k], types));
		            })
		                .join(", ");
		            return "{ " + fields + " }";
		        }
		        else {
		            if (typeDef.type.variants.length === 0) {
		                return "{}";
		            }
		            // Struct enum.
		            if (typeDef.type.variants[0].name) {
		                const variants = typeDef.type.variants;
		                const variant = Object.keys(data)[0];
		                const enumType = data[variant];
		                const namedFields = Object.keys(enumType)
		                    .map((f) => {
		                    var _a;
		                    const fieldData = enumType[f];
		                    const idlField = (_a = variants[variant]) === null || _a === void 0 ? void 0 : _a.filter((v) => v.name === f)[0];
		                    if (idlField === undefined) {
		                        throw new Error("Unable to find variant");
		                    }
		                    return (f +
		                        ": " +
		                        InstructionFormatter.formatIdlData(idlField, fieldData, types));
		                })
		                    .join(", ");
		                const variantName = (0, camelcase_1.default)(variant, { pascalCase: true });
		                if (namedFields.length === 0) {
		                    return variantName;
		                }
		                return `${variantName} { ${namedFields} }`;
		            }
		            // Tuple enum.
		            else {
		                // TODO.
		                return "Tuple formatting not yet implemented";
		            }
		        }
		    }
		    static flattenIdlAccounts(accounts, prefix) {
		        return accounts
		            .map((account) => {
		            const accName = sentenceCase(account.name);
		            if (account.hasOwnProperty("accounts")) {
		                const newPrefix = prefix ? `${prefix} > ${accName}` : accName;
		                return InstructionFormatter.flattenIdlAccounts(account.accounts, newPrefix);
		            }
		            else {
		                return {
		                    ...account,
		                    name: prefix ? `${prefix} > ${accName}` : accName,
		                };
		            }
		        })
		            .flat();
		    }
		}
		function sentenceCase(field) {
		    const result = field.replace(/([A-Z])/g, " $1");
		    return result.charAt(0).toUpperCase() + result.slice(1);
		}
		// Not technically sighash, since we don't include the arguments, as Rust
		// doesn't allow function overloading.
		function sighash(nameSpace, ixName) {
		    let name = (0, snake_case_1.snakeCase)(ixName);
		    let preimage = `${nameSpace}:${name}`;
		    return buffer_1.Buffer.from(js_sha256_1.sha256.digest(preimage)).slice(0, 8);
		}
		
	} (instruction$3));

	var accounts$2 = {};

	var common = {};

	Object.defineProperty(common, "__esModule", { value: true });
	common.accountSize = void 0;
	const error_js_1$3 = error;
	function accountSize(idl, idlAccount) {
	    if (idlAccount.type.kind === "enum") {
	        let variantSizes = idlAccount.type.variants.map((variant) => {
	            if (variant.fields === undefined) {
	                return 0;
	            }
	            return variant.fields
	                .map((f) => {
	                if (!(typeof f === "object" && "name" in f)) {
	                    throw new Error("Tuple enum variants not yet implemented.");
	                }
	                return typeSize(idl, f.type);
	            })
	                .reduce((a, b) => a + b);
	        });
	        return Math.max(...variantSizes) + 1;
	    }
	    if (idlAccount.type.fields === undefined) {
	        return 0;
	    }
	    return idlAccount.type.fields
	        .map((f) => typeSize(idl, f.type))
	        .reduce((a, b) => a + b, 0);
	}
	common.accountSize = accountSize;
	// Returns the size of the type in bytes. For variable length types, just return
	// 1. Users should override this value in such cases.
	function typeSize(idl, ty) {
	    var _a, _b;
	    switch (ty) {
	        case "bool":
	            return 1;
	        case "u8":
	            return 1;
	        case "i8":
	            return 1;
	        case "i16":
	            return 2;
	        case "u16":
	            return 2;
	        case "u32":
	            return 4;
	        case "i32":
	            return 4;
	        case "f32":
	            return 4;
	        case "u64":
	            return 8;
	        case "i64":
	            return 8;
	        case "f64":
	            return 8;
	        case "u128":
	            return 16;
	        case "i128":
	            return 16;
	        case "bytes":
	            return 1;
	        case "string":
	            return 1;
	        case "publicKey":
	            return 32;
	        default:
	            if ("vec" in ty) {
	                return 1;
	            }
	            if ("option" in ty) {
	                return 1 + typeSize(idl, ty.option);
	            }
	            if ("coption" in ty) {
	                return 4 + typeSize(idl, ty.coption);
	            }
	            if ("defined" in ty) {
	                const filtered = (_b = (_a = idl.types) === null || _a === void 0 ? void 0 : _a.filter((t) => t.name === ty.defined)) !== null && _b !== void 0 ? _b : [];
	                if (filtered.length !== 1) {
	                    throw new error_js_1$3.IdlError(`Type not found: ${JSON.stringify(ty)}`);
	                }
	                let typeDef = filtered[0];
	                return accountSize(idl, typeDef);
	            }
	            if ("array" in ty) {
	                let arrayTy = ty.array[0];
	                let arraySize = ty.array[1];
	                return typeSize(idl, arrayTy) * arraySize;
	            }
	            throw new Error(`Invalid type ${JSON.stringify(ty)}`);
	    }
	}

	(function (exports) {
		var __importDefault = (commonjsGlobal && commonjsGlobal.__importDefault) || function (mod) {
		    return (mod && mod.__esModule) ? mod : { "default": mod };
		};
		Object.defineProperty(exports, "__esModule", { value: true });
		exports.BorshAccountsCoder = exports.ACCOUNT_DISCRIMINATOR_SIZE = void 0;
		const bs58_1 = __importDefault(bs58$1);
		const buffer_1 = require$$0;
		const camelcase_1 = __importDefault(camelcaseExports);
		const js_sha256_1 = sha256Exports;
		const idl_js_1 = idl;
		const common_js_1 = common;
		/**
		 * Number of bytes of the account discriminator.
		 */
		exports.ACCOUNT_DISCRIMINATOR_SIZE = 8;
		/**
		 * Encodes and decodes account objects.
		 */
		class BorshAccountsCoder {
		    constructor(idl) {
		        if (idl.accounts === undefined) {
		            this.accountLayouts = new Map();
		            return;
		        }
		        const layouts = idl.accounts.map((acc) => {
		            return [acc.name, idl_js_1.IdlCoder.typeDefLayout(acc, idl.types)];
		        });
		        this.accountLayouts = new Map(layouts);
		        this.idl = idl;
		    }
		    async encode(accountName, account) {
		        const buffer = buffer_1.Buffer.alloc(1000); // TODO: use a tighter buffer.
		        const layout = this.accountLayouts.get(accountName);
		        if (!layout) {
		            throw new Error(`Unknown account: ${accountName}`);
		        }
		        const len = layout.encode(account, buffer);
		        let accountData = buffer.slice(0, len);
		        let discriminator = BorshAccountsCoder.accountDiscriminator(accountName);
		        return buffer_1.Buffer.concat([discriminator, accountData]);
		    }
		    decode(accountName, data) {
		        // Assert the account discriminator is correct.
		        const discriminator = BorshAccountsCoder.accountDiscriminator(accountName);
		        if (discriminator.compare(data.slice(0, 8))) {
		            throw new Error("Invalid account discriminator");
		        }
		        return this.decodeUnchecked(accountName, data);
		    }
		    decodeUnchecked(accountName, ix) {
		        // Chop off the discriminator before decoding.
		        const data = ix.slice(exports.ACCOUNT_DISCRIMINATOR_SIZE);
		        const layout = this.accountLayouts.get(accountName);
		        if (!layout) {
		            throw new Error(`Unknown account: ${accountName}`);
		        }
		        return layout.decode(data);
		    }
		    memcmp(accountName, appendData) {
		        const discriminator = BorshAccountsCoder.accountDiscriminator(accountName);
		        return {
		            offset: 0,
		            bytes: bs58_1.default.encode(appendData ? buffer_1.Buffer.concat([discriminator, appendData]) : discriminator),
		        };
		    }
		    size(idlAccount) {
		        var _a;
		        return (exports.ACCOUNT_DISCRIMINATOR_SIZE + ((_a = (0, common_js_1.accountSize)(this.idl, idlAccount)) !== null && _a !== void 0 ? _a : 0));
		    }
		    /**
		     * Calculates and returns a unique 8 byte discriminator prepended to all anchor accounts.
		     *
		     * @param name The name of the account to calculate the discriminator.
		     */
		    static accountDiscriminator(name) {
		        return buffer_1.Buffer.from(js_sha256_1.sha256.digest(`account:${(0, camelcase_1.default)(name, { pascalCase: true })}`)).slice(0, exports.ACCOUNT_DISCRIMINATOR_SIZE);
		    }
		}
		exports.BorshAccountsCoder = BorshAccountsCoder;
		
	} (accounts$2));

	var event$1 = {};

	var __createBinding$9 = (commonjsGlobal && commonjsGlobal.__createBinding) || (Object.create ? (function(o, m, k, k2) {
	    if (k2 === undefined) k2 = k;
	    var desc = Object.getOwnPropertyDescriptor(m, k);
	    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
	      desc = { enumerable: true, get: function() { return m[k]; } };
	    }
	    Object.defineProperty(o, k2, desc);
	}) : (function(o, m, k, k2) {
	    if (k2 === undefined) k2 = k;
	    o[k2] = m[k];
	}));
	var __setModuleDefault$9 = (commonjsGlobal && commonjsGlobal.__setModuleDefault) || (Object.create ? (function(o, v) {
	    Object.defineProperty(o, "default", { enumerable: true, value: v });
	}) : function(o, v) {
	    o["default"] = v;
	});
	var __importStar$9 = (commonjsGlobal && commonjsGlobal.__importStar) || function (mod) {
	    if (mod && mod.__esModule) return mod;
	    var result = {};
	    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding$9(result, mod, k);
	    __setModuleDefault$9(result, mod);
	    return result;
	};
	Object.defineProperty(event$1, "__esModule", { value: true });
	event$1.eventDiscriminator = event$1.BorshEventCoder = void 0;
	const buffer_1$3 = require$$0;
	const base64 = __importStar$9(base64Js);
	const js_sha256_1$2 = sha256Exports;
	const idl_js_1$2 = idl;
	class BorshEventCoder {
	    constructor(idl) {
	        if (idl.events === undefined) {
	            this.layouts = new Map();
	            return;
	        }
	        const layouts = idl.events.map((event) => {
	            let eventTypeDef = {
	                name: event.name,
	                type: {
	                    kind: "struct",
	                    fields: event.fields.map((f) => {
	                        return { name: f.name, type: f.type };
	                    }),
	                },
	            };
	            return [event.name, idl_js_1$2.IdlCoder.typeDefLayout(eventTypeDef, idl.types)];
	        });
	        this.layouts = new Map(layouts);
	        this.discriminators = new Map(idl.events === undefined
	            ? []
	            : idl.events.map((e) => [
	                base64.fromByteArray(eventDiscriminator(e.name)),
	                e.name,
	            ]));
	    }
	    decode(log) {
	        let logArr;
	        // This will throw if log length is not a multiple of 4.
	        try {
	            logArr = buffer_1$3.Buffer.from(base64.toByteArray(log));
	        }
	        catch (e) {
	            return null;
	        }
	        const disc = base64.fromByteArray(logArr.slice(0, 8));
	        // Only deserialize if the discriminator implies a proper event.
	        const eventName = this.discriminators.get(disc);
	        if (eventName === undefined) {
	            return null;
	        }
	        const layout = this.layouts.get(eventName);
	        if (!layout) {
	            throw new Error(`Unknown event: ${eventName}`);
	        }
	        const data = layout.decode(logArr.slice(8));
	        return { data, name: eventName };
	    }
	}
	event$1.BorshEventCoder = BorshEventCoder;
	function eventDiscriminator(name) {
	    return buffer_1$3.Buffer.from(js_sha256_1$2.sha256.digest(`event:${name}`)).slice(0, 8);
	}
	event$1.eventDiscriminator = eventDiscriminator;

	var state$3 = {};

	var __createBinding$8 = (commonjsGlobal && commonjsGlobal.__createBinding) || (Object.create ? (function(o, m, k, k2) {
	    if (k2 === undefined) k2 = k;
	    var desc = Object.getOwnPropertyDescriptor(m, k);
	    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
	      desc = { enumerable: true, get: function() { return m[k]; } };
	    }
	    Object.defineProperty(o, k2, desc);
	}) : (function(o, m, k, k2) {
	    if (k2 === undefined) k2 = k;
	    o[k2] = m[k];
	}));
	var __setModuleDefault$8 = (commonjsGlobal && commonjsGlobal.__setModuleDefault) || (Object.create ? (function(o, v) {
	    Object.defineProperty(o, "default", { enumerable: true, value: v });
	}) : function(o, v) {
	    o["default"] = v;
	});
	var __importStar$8 = (commonjsGlobal && commonjsGlobal.__importStar) || function (mod) {
	    if (mod && mod.__esModule) return mod;
	    var result = {};
	    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding$8(result, mod, k);
	    __setModuleDefault$8(result, mod);
	    return result;
	};
	Object.defineProperty(state$3, "__esModule", { value: true });
	state$3.stateDiscriminator = state$3.BorshStateCoder = void 0;
	const buffer_1$2 = require$$0;
	const js_sha256_1$1 = sha256Exports;
	const idl_js_1$1 = idl;
	const features$1 = __importStar$8(features$2);
	class BorshStateCoder {
	    constructor(idl) {
	        if (idl.state === undefined) {
	            throw new Error("Idl state not defined.");
	        }
	        this.layout = idl_js_1$1.IdlCoder.typeDefLayout(idl.state.struct, idl.types);
	    }
	    async encode(name, account) {
	        const buffer = buffer_1$2.Buffer.alloc(1000); // TODO: use a tighter buffer.
	        const len = this.layout.encode(account, buffer);
	        const disc = await stateDiscriminator(name);
	        const accData = buffer.slice(0, len);
	        return buffer_1$2.Buffer.concat([disc, accData]);
	    }
	    decode(ix) {
	        // Chop off discriminator.
	        const data = ix.slice(8);
	        return this.layout.decode(data);
	    }
	}
	state$3.BorshStateCoder = BorshStateCoder;
	// Calculates unique 8 byte discriminator prepended to all anchor state accounts.
	async function stateDiscriminator(name) {
	    let ns = features$1.isSet("anchor-deprecated-state") ? "account" : "state";
	    return buffer_1$2.Buffer.from(js_sha256_1$1.sha256.digest(`${ns}:${name}`)).slice(0, 8);
	}
	state$3.stateDiscriminator = stateDiscriminator;

	var types$2 = {};

	Object.defineProperty(types$2, "__esModule", { value: true });
	types$2.BorshTypesCoder = void 0;
	const buffer_1$1 = require$$0;
	const idl_js_1 = idl;
	/**
	 * Encodes and decodes user-defined types.
	 */
	class BorshTypesCoder {
	    constructor(idl) {
	        if (idl.types === undefined) {
	            this.typeLayouts = new Map();
	            return;
	        }
	        const layouts = idl.types.map((acc) => {
	            return [acc.name, idl_js_1.IdlCoder.typeDefLayout(acc, idl.types)];
	        });
	        this.typeLayouts = new Map(layouts);
	        this.idl = idl;
	    }
	    encode(typeName, type) {
	        const buffer = buffer_1$1.Buffer.alloc(1000); // TODO: use a tighter buffer.
	        const layout = this.typeLayouts.get(typeName);
	        if (!layout) {
	            throw new Error(`Unknown type: ${typeName}`);
	        }
	        const len = layout.encode(type, buffer);
	        return buffer.slice(0, len);
	    }
	    decode(typeName, typeData) {
	        const layout = this.typeLayouts.get(typeName);
	        if (!layout) {
	            throw new Error(`Unknown type: ${typeName}`);
	        }
	        return layout.decode(typeData);
	    }
	}
	types$2.BorshTypesCoder = BorshTypesCoder;

	(function (exports) {
		Object.defineProperty(exports, "__esModule", { value: true });
		exports.BorshCoder = exports.stateDiscriminator = exports.BorshStateCoder = exports.eventDiscriminator = exports.BorshEventCoder = exports.ACCOUNT_DISCRIMINATOR_SIZE = exports.BorshAccountsCoder = exports.BorshInstructionCoder = void 0;
		const instruction_js_1 = instruction$3;
		const accounts_js_1 = accounts$2;
		const event_js_1 = event$1;
		const state_js_1 = state$3;
		const types_js_1 = types$2;
		var instruction_js_2 = instruction$3;
		Object.defineProperty(exports, "BorshInstructionCoder", { enumerable: true, get: function () { return instruction_js_2.BorshInstructionCoder; } });
		var accounts_js_2 = accounts$2;
		Object.defineProperty(exports, "BorshAccountsCoder", { enumerable: true, get: function () { return accounts_js_2.BorshAccountsCoder; } });
		Object.defineProperty(exports, "ACCOUNT_DISCRIMINATOR_SIZE", { enumerable: true, get: function () { return accounts_js_2.ACCOUNT_DISCRIMINATOR_SIZE; } });
		var event_js_2 = event$1;
		Object.defineProperty(exports, "BorshEventCoder", { enumerable: true, get: function () { return event_js_2.BorshEventCoder; } });
		Object.defineProperty(exports, "eventDiscriminator", { enumerable: true, get: function () { return event_js_2.eventDiscriminator; } });
		var state_js_2 = state$3;
		Object.defineProperty(exports, "BorshStateCoder", { enumerable: true, get: function () { return state_js_2.BorshStateCoder; } });
		Object.defineProperty(exports, "stateDiscriminator", { enumerable: true, get: function () { return state_js_2.stateDiscriminator; } });
		/**
		 * BorshCoder is the default Coder for Anchor programs implementing the
		 * borsh based serialization interface.
		 */
		class BorshCoder {
		    constructor(idl) {
		        this.instruction = new instruction_js_1.BorshInstructionCoder(idl);
		        this.accounts = new accounts_js_1.BorshAccountsCoder(idl);
		        this.events = new event_js_1.BorshEventCoder(idl);
		        if (idl.state) {
		            this.state = new state_js_1.BorshStateCoder(idl);
		        }
		        this.types = new types_js_1.BorshTypesCoder(idl);
		    }
		}
		exports.BorshCoder = BorshCoder;
		
	} (borsh$1));

	var splToken = {};

	var instruction$2 = {};

	var __createBinding$7 = (commonjsGlobal && commonjsGlobal.__createBinding) || (Object.create ? (function(o, m, k, k2) {
	    if (k2 === undefined) k2 = k;
	    var desc = Object.getOwnPropertyDescriptor(m, k);
	    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
	      desc = { enumerable: true, get: function() { return m[k]; } };
	    }
	    Object.defineProperty(o, k2, desc);
	}) : (function(o, m, k, k2) {
	    if (k2 === undefined) k2 = k;
	    o[k2] = m[k];
	}));
	var __setModuleDefault$7 = (commonjsGlobal && commonjsGlobal.__setModuleDefault) || (Object.create ? (function(o, v) {
	    Object.defineProperty(o, "default", { enumerable: true, value: v });
	}) : function(o, v) {
	    o["default"] = v;
	});
	var __importStar$7 = (commonjsGlobal && commonjsGlobal.__importStar) || function (mod) {
	    if (mod && mod.__esModule) return mod;
	    var result = {};
	    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding$7(result, mod, k);
	    __setModuleDefault$7(result, mod);
	    return result;
	};
	var __importDefault$6 = (commonjsGlobal && commonjsGlobal.__importDefault) || function (mod) {
	    return (mod && mod.__esModule) ? mod : { "default": mod };
	};
	Object.defineProperty(instruction$2, "__esModule", { value: true });
	instruction$2.SplTokenInstructionCoder = void 0;
	const BufferLayout$4 = __importStar$7(Layout$1);
	const camelcase_1$3 = __importDefault$6(camelcaseExports);
	const web3_js_1$8 = require$$0$1;
	class SplTokenInstructionCoder {
	    constructor(_) { }
	    encode(ixName, ix) {
	        switch ((0, camelcase_1$3.default)(ixName)) {
	            case "initializeMint": {
	                return encodeInitializeMint(ix);
	            }
	            case "initializeAccount": {
	                return encodeInitializeAccount();
	            }
	            case "initializeMultisig": {
	                return encodeInitializeMultisig(ix);
	            }
	            case "transfer": {
	                return encodeTransfer$1(ix);
	            }
	            case "approve": {
	                return encodeApprove(ix);
	            }
	            case "revoke": {
	                return encodeRevoke();
	            }
	            case "setAuthority": {
	                return encodeSetAuthority(ix);
	            }
	            case "mintTo": {
	                return encodeMintTo(ix);
	            }
	            case "burn": {
	                return encodeBurn(ix);
	            }
	            case "closeAccount": {
	                return encodeCloseAccount();
	            }
	            case "freezeAccount": {
	                return encodeFreezeAccount();
	            }
	            case "thawAccount": {
	                return encodeThawAccount();
	            }
	            case "transferChecked": {
	                return encodeTransferChecked(ix);
	            }
	            case "approvedChecked": {
	                return encodeApproveChecked(ix);
	            }
	            case "mintToChecked": {
	                return encodeMintToChecked(ix);
	            }
	            case "burnChecked": {
	                return encodeBurnChecked(ix);
	            }
	            case "intializeAccount2": {
	                return encodeInitializeAccount2(ix);
	            }
	            case "syncNative": {
	                return encodeSyncNative();
	            }
	            case "initializeAccount3": {
	                return encodeInitializeAccount3(ix);
	            }
	            case "initializeMultisig2": {
	                return encodeInitializeMultisig2(ix);
	            }
	            case "initializeMint2": {
	                return encodeInitializeMint2(ix);
	            }
	            default: {
	                throw new Error(`Invalid instruction: ${ixName}`);
	            }
	        }
	    }
	    encodeState(_ixName, _ix) {
	        throw new Error("SPL token does not have state");
	    }
	}
	instruction$2.SplTokenInstructionCoder = SplTokenInstructionCoder;
	function encodeInitializeMint({ decimals, mintAuthority, freezeAuthority, }) {
	    return encodeData$1({
	        initializeMint: {
	            decimals,
	            mintAuthority: mintAuthority.toBuffer(),
	            freezeAuthorityOption: !!freezeAuthority,
	            freezeAuthority: (freezeAuthority || web3_js_1$8.PublicKey.default).toBuffer(),
	        },
	    });
	}
	function encodeInitializeAccount(_ix) {
	    return encodeData$1({
	        initializeAccount: {},
	    });
	}
	function encodeInitializeMultisig({ m }) {
	    return encodeData$1({
	        initializeMultisig: {
	            m,
	        },
	    });
	}
	function encodeTransfer$1({ amount }) {
	    return encodeData$1({
	        transfer: { amount },
	    });
	}
	function encodeApprove({ amount }) {
	    return encodeData$1({
	        approve: { amount },
	    });
	}
	function encodeRevoke(_ix) {
	    return encodeData$1({
	        revoke: {},
	    });
	}
	function encodeSetAuthority({ authorityType, newAuthority }) {
	    return encodeData$1({
	        setAuthority: { authorityType, newAuthority },
	    });
	}
	function encodeMintTo({ amount }) {
	    return encodeData$1({
	        mintTo: { amount },
	    });
	}
	function encodeBurn({ amount }) {
	    return encodeData$1({
	        burn: { amount },
	    });
	}
	function encodeCloseAccount(_) {
	    return encodeData$1({
	        closeAccount: {},
	    });
	}
	function encodeFreezeAccount(_) {
	    return encodeData$1({
	        freezeAccount: {},
	    });
	}
	function encodeThawAccount(_) {
	    return encodeData$1({
	        thawAccount: {},
	    });
	}
	function encodeTransferChecked({ amount, decimals }) {
	    return encodeData$1({
	        transferChecked: { amount, decimals },
	    });
	}
	function encodeApproveChecked({ amount, decimals }) {
	    return encodeData$1({
	        approveChecked: { amount, decimals },
	    });
	}
	function encodeMintToChecked({ amount, decimals }) {
	    return encodeData$1({
	        mintToChecked: { amount, decimals },
	    });
	}
	function encodeBurnChecked({ amount, decimals }) {
	    return encodeData$1({
	        burnChecked: { amount, decimals },
	    });
	}
	function encodeInitializeAccount2({ authority }) {
	    return encodeData$1({
	        initilaizeAccount2: { authority },
	    });
	}
	function encodeSyncNative(_) {
	    return encodeData$1({
	        syncNative: {},
	    });
	}
	function encodeInitializeAccount3({ authority }) {
	    return encodeData$1({
	        initializeAccount3: { authority },
	    });
	}
	function encodeInitializeMultisig2({ m }) {
	    return encodeData$1({
	        initializeMultisig2: { m },
	    });
	}
	function encodeInitializeMint2({ decimals, mintAuthority, freezeAuthority, }) {
	    return encodeData$1({
	        encodeInitializeMint2: { decimals, mintAuthority, freezeAuthority },
	    });
	}
	const LAYOUT$1 = BufferLayout$4.union(BufferLayout$4.u8("instruction"));
	LAYOUT$1.addVariant(0, BufferLayout$4.struct([
	    BufferLayout$4.u8("decimals"),
	    BufferLayout$4.blob(32, "mintAuthority"),
	    BufferLayout$4.u8("freezeAuthorityOption"),
	    publicKey$3("freezeAuthority"),
	]), "initializeMint");
	LAYOUT$1.addVariant(1, BufferLayout$4.struct([]), "initializeAccount");
	LAYOUT$1.addVariant(2, BufferLayout$4.struct([BufferLayout$4.u8("m")]), "initializeMultisig");
	LAYOUT$1.addVariant(3, BufferLayout$4.struct([BufferLayout$4.nu64("amount")]), "transfer");
	LAYOUT$1.addVariant(4, BufferLayout$4.struct([BufferLayout$4.nu64("amount")]), "approve");
	LAYOUT$1.addVariant(5, BufferLayout$4.struct([]), "revoke");
	LAYOUT$1.addVariant(6, BufferLayout$4.struct([
	    BufferLayout$4.u8("authorityType"),
	    BufferLayout$4.u8("newAuthorityOption"),
	    publicKey$3("newAuthority"),
	]), "setAuthority");
	LAYOUT$1.addVariant(7, BufferLayout$4.struct([BufferLayout$4.nu64("amount")]), "mintTo");
	LAYOUT$1.addVariant(8, BufferLayout$4.struct([BufferLayout$4.nu64("amount")]), "burn");
	LAYOUT$1.addVariant(9, BufferLayout$4.struct([]), "closeAccount");
	LAYOUT$1.addVariant(10, BufferLayout$4.struct([]), "freezeAccount");
	LAYOUT$1.addVariant(11, BufferLayout$4.struct([]), "thawAccount");
	LAYOUT$1.addVariant(12, BufferLayout$4.struct([
	    BufferLayout$4.nu64("amount"),
	    BufferLayout$4.u8("decimals"),
	]), "transferChecked");
	LAYOUT$1.addVariant(13, BufferLayout$4.struct([
	    BufferLayout$4.nu64("amount"),
	    BufferLayout$4.u8("decimals"),
	]), "approvedChecked");
	LAYOUT$1.addVariant(14, BufferLayout$4.struct([
	    BufferLayout$4.nu64("amount"),
	    BufferLayout$4.u8("decimals"),
	]), "mintToChecked");
	LAYOUT$1.addVariant(15, BufferLayout$4.struct([
	    BufferLayout$4.nu64("amount"),
	    BufferLayout$4.u8("decimals"),
	]), "burnedChecked");
	LAYOUT$1.addVariant(16, BufferLayout$4.struct([publicKey$3("authority")]), "InitializeAccount2");
	LAYOUT$1.addVariant(17, BufferLayout$4.struct([]), "syncNative");
	LAYOUT$1.addVariant(18, BufferLayout$4.struct([publicKey$3("authority")]), "initializeAccount3");
	LAYOUT$1.addVariant(19, BufferLayout$4.struct([BufferLayout$4.u8("m")]), "initializeMultisig2");
	LAYOUT$1.addVariant(20, BufferLayout$4.struct([
	    BufferLayout$4.u8("decimals"),
	    publicKey$3("mintAuthority"),
	    BufferLayout$4.u8("freezeAuthorityOption"),
	    publicKey$3("freezeAuthority"),
	]), "initializeMint2");
	function publicKey$3(property) {
	    return BufferLayout$4.blob(32, property);
	}
	function encodeData$1(instruction) {
	    let b = Buffer.alloc(instructionMaxSpan$1);
	    let span = LAYOUT$1.encode(instruction, b);
	    return b.slice(0, span);
	}
	const instructionMaxSpan$1 = Math.max(
	// @ts-ignore
	...Object.values(LAYOUT$1.registry).map((r) => r.span));

	var state$2 = {};

	Object.defineProperty(state$2, "__esModule", { value: true });
	state$2.SplTokenStateCoder = void 0;
	class SplTokenStateCoder {
	    constructor(_idl) { }
	    encode(_name, _account) {
	        throw new Error("SPL token does not have state");
	    }
	    decode(_ix) {
	        throw new Error("SPL token does not have state");
	    }
	}
	state$2.SplTokenStateCoder = SplTokenStateCoder;

	var accounts$1 = {};

	var bufferLayout = {};

	var __createBinding$6 = (commonjsGlobal && commonjsGlobal.__createBinding) || (Object.create ? (function(o, m, k, k2) {
	    if (k2 === undefined) k2 = k;
	    var desc = Object.getOwnPropertyDescriptor(m, k);
	    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
	      desc = { enumerable: true, get: function() { return m[k]; } };
	    }
	    Object.defineProperty(o, k2, desc);
	}) : (function(o, m, k, k2) {
	    if (k2 === undefined) k2 = k;
	    o[k2] = m[k];
	}));
	var __setModuleDefault$6 = (commonjsGlobal && commonjsGlobal.__setModuleDefault) || (Object.create ? (function(o, v) {
	    Object.defineProperty(o, "default", { enumerable: true, value: v });
	}) : function(o, v) {
	    o["default"] = v;
	});
	var __importStar$6 = (commonjsGlobal && commonjsGlobal.__importStar) || function (mod) {
	    if (mod && mod.__esModule) return mod;
	    var result = {};
	    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding$6(result, mod, k);
	    __setModuleDefault$6(result, mod);
	    return result;
	};
	var __importDefault$5 = (commonjsGlobal && commonjsGlobal.__importDefault) || function (mod) {
	    return (mod && mod.__esModule) ? mod : { "default": mod };
	};
	Object.defineProperty(bufferLayout, "__esModule", { value: true });
	bufferLayout.u64 = bufferLayout.COptionLayout = bufferLayout.coption = bufferLayout.publicKey = bufferLayout.bool = bufferLayout.uint64 = void 0;
	const bn_js_1$3 = __importDefault$5(bnExports);
	const BufferLayout$3 = __importStar$6(Layout$1);
	const buffer_layout_1$2 = Layout$1;
	const web3_js_1$7 = require$$0$1;
	function uint64(property) {
	    return new WrappedLayout$1(BufferLayout$3.blob(8), (b) => u64$1.fromBuffer(b), (n) => n.toBuffer(), property);
	}
	bufferLayout.uint64 = uint64;
	function bool(property) {
	    return new WrappedLayout$1(BufferLayout$3.u8(), decodeBool, encodeBool, property);
	}
	bufferLayout.bool = bool;
	function publicKey$2(property) {
	    return new WrappedLayout$1(BufferLayout$3.blob(32), (b) => new web3_js_1$7.PublicKey(b), (key) => key.toBuffer(), property);
	}
	bufferLayout.publicKey = publicKey$2;
	function coption(layout, property) {
	    return new COptionLayout(layout, property);
	}
	bufferLayout.coption = coption;
	let WrappedLayout$1 = class WrappedLayout extends buffer_layout_1$2.Layout {
	    constructor(layout, decoder, encoder, property) {
	        super(layout.span, property);
	        this.layout = layout;
	        this.decoder = decoder;
	        this.encoder = encoder;
	    }
	    decode(b, offset) {
	        return this.decoder(this.layout.decode(b, offset));
	    }
	    encode(src, b, offset) {
	        return this.layout.encode(this.encoder(src), b, offset);
	    }
	    getSpan(b, offset) {
	        return this.layout.getSpan(b, offset);
	    }
	};
	class COptionLayout extends buffer_layout_1$2.Layout {
	    constructor(layout, property) {
	        super(-1, property);
	        this.layout = layout;
	        this.discriminator = BufferLayout$3.u32();
	    }
	    encode(src, b, offset = 0) {
	        if (src === null || src === undefined) {
	            return this.layout.span + this.discriminator.encode(0, b, offset);
	        }
	        this.discriminator.encode(1, b, offset);
	        return this.layout.encode(src, b, offset + 4) + 4;
	    }
	    decode(b, offset = 0) {
	        const discriminator = this.discriminator.decode(b, offset);
	        if (discriminator === 0) {
	            return null;
	        }
	        else if (discriminator === 1) {
	            return this.layout.decode(b, offset + 4);
	        }
	        throw new Error("Invalid coption " + this.layout.property);
	    }
	    getSpan(b, offset = 0) {
	        return this.layout.getSpan(b, offset + 4) + 4;
	    }
	}
	bufferLayout.COptionLayout = COptionLayout;
	function decodeBool(value) {
	    if (value === 0) {
	        return false;
	    }
	    else if (value === 1) {
	        return true;
	    }
	    throw new Error("Invalid bool: " + value);
	}
	function encodeBool(value) {
	    return value ? 1 : 0;
	}
	let u64$1 = class u64 extends bn_js_1$3.default {
	    /**
	     * Convert to Buffer representation
	     */
	    toBuffer() {
	        const a = super.toArray().reverse();
	        const b = Buffer.from(a);
	        if (b.length === 8) {
	            return b;
	        }
	        if (b.length >= 8) {
	            throw new Error("u64 too large");
	        }
	        const zeroPad = Buffer.alloc(8);
	        b.copy(zeroPad);
	        return zeroPad;
	    }
	    /**
	     * Construct a u64 from Buffer representation
	     */
	    static fromBuffer(buffer) {
	        if (buffer.length !== 8) {
	            throw new Error(`Invalid buffer length: ${buffer.length}`);
	        }
	        return new u64([...buffer]
	            .reverse()
	            .map((i) => `00${i.toString(16)}`.slice(-2))
	            .join(""), 16);
	    }
	};
	bufferLayout.u64 = u64$1;

	var __createBinding$5 = (commonjsGlobal && commonjsGlobal.__createBinding) || (Object.create ? (function(o, m, k, k2) {
	    if (k2 === undefined) k2 = k;
	    var desc = Object.getOwnPropertyDescriptor(m, k);
	    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
	      desc = { enumerable: true, get: function() { return m[k]; } };
	    }
	    Object.defineProperty(o, k2, desc);
	}) : (function(o, m, k, k2) {
	    if (k2 === undefined) k2 = k;
	    o[k2] = m[k];
	}));
	var __setModuleDefault$5 = (commonjsGlobal && commonjsGlobal.__setModuleDefault) || (Object.create ? (function(o, v) {
	    Object.defineProperty(o, "default", { enumerable: true, value: v });
	}) : function(o, v) {
	    o["default"] = v;
	});
	var __importStar$5 = (commonjsGlobal && commonjsGlobal.__importStar) || function (mod) {
	    if (mod && mod.__esModule) return mod;
	    var result = {};
	    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding$5(result, mod, k);
	    __setModuleDefault$5(result, mod);
	    return result;
	};
	Object.defineProperty(accounts$1, "__esModule", { value: true });
	accounts$1.SplTokenAccountsCoder = void 0;
	const BufferLayout$2 = __importStar$5(Layout$1);
	const buffer_layout_js_1 = bufferLayout;
	const common_1 = common;
	class SplTokenAccountsCoder {
	    constructor(idl) {
	        this.idl = idl;
	    }
	    async encode(accountName, account) {
	        switch (accountName) {
	            case "token": {
	                const buffer = Buffer.alloc(165);
	                const len = TOKEN_ACCOUNT_LAYOUT.encode(account, buffer);
	                return buffer.slice(0, len);
	            }
	            case "mint": {
	                const buffer = Buffer.alloc(82);
	                const len = MINT_ACCOUNT_LAYOUT.encode(account, buffer);
	                return buffer.slice(0, len);
	            }
	            default: {
	                throw new Error(`Invalid account name: ${accountName}`);
	            }
	        }
	    }
	    decode(accountName, ix) {
	        return this.decodeUnchecked(accountName, ix);
	    }
	    decodeUnchecked(accountName, ix) {
	        switch (accountName) {
	            case "token": {
	                return decodeTokenAccount(ix);
	            }
	            case "mint": {
	                return decodeMintAccount(ix);
	            }
	            default: {
	                throw new Error(`Invalid account name: ${accountName}`);
	            }
	        }
	    }
	    // TODO: this won't use the appendData.
	    memcmp(accountName, _appendData) {
	        switch (accountName) {
	            case "token": {
	                return {
	                    dataSize: 165,
	                };
	            }
	            case "mint": {
	                return {
	                    dataSize: 82,
	                };
	            }
	            default: {
	                throw new Error(`Invalid account name: ${accountName}`);
	            }
	        }
	    }
	    size(idlAccount) {
	        var _a;
	        return (_a = (0, common_1.accountSize)(this.idl, idlAccount)) !== null && _a !== void 0 ? _a : 0;
	    }
	}
	accounts$1.SplTokenAccountsCoder = SplTokenAccountsCoder;
	function decodeMintAccount(ix) {
	    return MINT_ACCOUNT_LAYOUT.decode(ix);
	}
	function decodeTokenAccount(ix) {
	    return TOKEN_ACCOUNT_LAYOUT.decode(ix);
	}
	const MINT_ACCOUNT_LAYOUT = BufferLayout$2.struct([
	    (0, buffer_layout_js_1.coption)((0, buffer_layout_js_1.publicKey)(), "mintAuthority"),
	    (0, buffer_layout_js_1.uint64)("supply"),
	    BufferLayout$2.u8("decimals"),
	    (0, buffer_layout_js_1.bool)("isInitialized"),
	    (0, buffer_layout_js_1.coption)((0, buffer_layout_js_1.publicKey)(), "freezeAuthority"),
	]);
	const TOKEN_ACCOUNT_LAYOUT = BufferLayout$2.struct([
	    (0, buffer_layout_js_1.publicKey)("mint"),
	    (0, buffer_layout_js_1.publicKey)("authority"),
	    (0, buffer_layout_js_1.uint64)("amount"),
	    (0, buffer_layout_js_1.coption)((0, buffer_layout_js_1.publicKey)(), "delegate"),
	    BufferLayout$2.u8("state"),
	    (0, buffer_layout_js_1.coption)((0, buffer_layout_js_1.uint64)(), "isNative"),
	    (0, buffer_layout_js_1.uint64)("delegatedAmount"),
	    (0, buffer_layout_js_1.coption)((0, buffer_layout_js_1.publicKey)(), "closeAuthority"),
	]);

	var events$1 = {};

	Object.defineProperty(events$1, "__esModule", { value: true });
	events$1.SplTokenEventsCoder = void 0;
	class SplTokenEventsCoder {
	    constructor(_idl) { }
	    decode(_log) {
	        throw new Error("SPL token program does not have events");
	    }
	}
	events$1.SplTokenEventsCoder = SplTokenEventsCoder;

	var types$1 = {};

	Object.defineProperty(types$1, "__esModule", { value: true });
	types$1.SplTokenTypesCoder = void 0;
	class SplTokenTypesCoder {
	    constructor(_idl) { }
	    encode(_name, _type) {
	        throw new Error("SPL token does not have user-defined types");
	    }
	    decode(_name, _typeData) {
	        throw new Error("SPL token does not have user-defined types");
	    }
	}
	types$1.SplTokenTypesCoder = SplTokenTypesCoder;

	Object.defineProperty(splToken, "__esModule", { value: true });
	splToken.SplTokenCoder = void 0;
	const instruction_js_1$2 = instruction$2;
	const state_js_1$1 = state$2;
	const accounts_js_1$1 = accounts$1;
	const events_js_1$1 = events$1;
	const types_js_1$1 = types$1;
	/**
	 * Coder for the SPL token program.
	 */
	class SplTokenCoder {
	    constructor(idl) {
	        this.instruction = new instruction_js_1$2.SplTokenInstructionCoder(idl);
	        this.accounts = new accounts_js_1$1.SplTokenAccountsCoder(idl);
	        this.events = new events_js_1$1.SplTokenEventsCoder(idl);
	        this.state = new state_js_1$1.SplTokenStateCoder(idl);
	        this.types = new types_js_1$1.SplTokenTypesCoder(idl);
	    }
	}
	splToken.SplTokenCoder = SplTokenCoder;

	var system = {};

	var instruction$1 = {};

	var __createBinding$4 = (commonjsGlobal && commonjsGlobal.__createBinding) || (Object.create ? (function(o, m, k, k2) {
	    if (k2 === undefined) k2 = k;
	    var desc = Object.getOwnPropertyDescriptor(m, k);
	    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
	      desc = { enumerable: true, get: function() { return m[k]; } };
	    }
	    Object.defineProperty(o, k2, desc);
	}) : (function(o, m, k, k2) {
	    if (k2 === undefined) k2 = k;
	    o[k2] = m[k];
	}));
	var __setModuleDefault$4 = (commonjsGlobal && commonjsGlobal.__setModuleDefault) || (Object.create ? (function(o, v) {
	    Object.defineProperty(o, "default", { enumerable: true, value: v });
	}) : function(o, v) {
	    o["default"] = v;
	});
	var __importStar$4 = (commonjsGlobal && commonjsGlobal.__importStar) || function (mod) {
	    if (mod && mod.__esModule) return mod;
	    var result = {};
	    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding$4(result, mod, k);
	    __setModuleDefault$4(result, mod);
	    return result;
	};
	var __importDefault$4 = (commonjsGlobal && commonjsGlobal.__importDefault) || function (mod) {
	    return (mod && mod.__esModule) ? mod : { "default": mod };
	};
	Object.defineProperty(instruction$1, "__esModule", { value: true });
	instruction$1.SystemInstructionCoder = void 0;
	const bn_js_1$2 = __importDefault$4(bnExports);
	const BufferLayout$1 = __importStar$4(Layout$1);
	const camelcase_1$2 = __importDefault$4(camelcaseExports);
	class SystemInstructionCoder {
	    // eslint-disable-next-line @typescript-eslint/no-empty-function
	    constructor(_) { }
	    encode(ixName, ix) {
	        switch ((0, camelcase_1$2.default)(ixName)) {
	            case "createAccount": {
	                return encodeCreateAccount(ix);
	            }
	            case "assign": {
	                return encodeAssign(ix);
	            }
	            case "transfer": {
	                return encodeTransfer(ix);
	            }
	            case "createAccountWithSeed": {
	                return encodeCreateAccountWithSeed(ix);
	            }
	            case "advanceNonceAccount": {
	                return encodeAdvanceNonceAccount(ix);
	            }
	            case "withdrawNonceAccount": {
	                return encodeWithdrawNonceAccount(ix);
	            }
	            case "initializeNonceAccount": {
	                return encodeInitializeNonceAccount(ix);
	            }
	            case "authorizeNonceAccount": {
	                return encodeAuthorizeNonceAccount(ix);
	            }
	            case "allocate": {
	                return encodeAllocate(ix);
	            }
	            case "allocateWithSeed": {
	                return encodeAllocateWithSeed(ix);
	            }
	            case "assignWithSeed": {
	                return encodeAssignWithSeed(ix);
	            }
	            case "transferWithSeed": {
	                return encodeTransferWithSeed(ix);
	            }
	            default: {
	                throw new Error(`Invalid instruction: ${ixName}`);
	            }
	        }
	    }
	    encodeState(_ixName, _ix) {
	        throw new Error("System does not have state");
	    }
	}
	instruction$1.SystemInstructionCoder = SystemInstructionCoder;
	class RustStringLayout extends BufferLayout$1.Layout {
	    constructor(property) {
	        super(-1, property);
	        this.property = property;
	        this.layout = BufferLayout$1.struct([
	            BufferLayout$1.u32("length"),
	            BufferLayout$1.u32("lengthPadding"),
	            BufferLayout$1.blob(BufferLayout$1.offset(BufferLayout$1.u32(), -8), "chars"),
	        ], this.property);
	    }
	    encode(src, b, offset = 0) {
	        if (src === null || src === undefined) {
	            return this.layout.span;
	        }
	        const data = {
	            chars: Buffer.from(src, "utf8"),
	        };
	        return this.layout.encode(data, b, offset);
	    }
	    decode(b, offset = 0) {
	        const data = this.layout.decode(b, offset);
	        return data["chars"].toString();
	    }
	    getSpan(b, offset = 0) {
	        return (BufferLayout$1.u32().span +
	            BufferLayout$1.u32().span +
	            new bn_js_1$2.default(new Uint8Array(b).slice(offset, offset + 4), 10, "le").toNumber());
	    }
	}
	function rustStringLayout(property) {
	    return new RustStringLayout(property);
	}
	function publicKey$1(property) {
	    return BufferLayout$1.blob(32, property);
	}
	function encodeCreateAccount({ lamports, space, owner }) {
	    return encodeData({
	        createAccount: { lamports, space, owner: owner.toBuffer() },
	    });
	}
	function encodeAssign({ owner }) {
	    return encodeData({
	        assign: { owner: owner.toBuffer() },
	    });
	}
	function encodeTransfer({ lamports }) {
	    return encodeData({
	        transfer: { lamports },
	    });
	}
	function encodeCreateAccountWithSeed({ base, seed, lamports, space, owner, }) {
	    return encodeData({
	        createAccountWithSeed: {
	            base: base.toBuffer(),
	            seed,
	            lamports,
	            space,
	            owner: owner.toBuffer(),
	        },
	    }, LAYOUT.getVariant(3).span + seed.length);
	}
	function encodeInitializeNonceAccount({ authorized }) {
	    return encodeData({
	        initializeNonceAccount: { authorized: authorized.toBuffer() },
	    });
	}
	function encodeAdvanceNonceAccount({ authorized }) {
	    return encodeData({
	        advanceNonceAccount: { authorized: authorized.toBuffer() },
	    });
	}
	function encodeWithdrawNonceAccount({ lamports }) {
	    return encodeData({
	        withdrawNonceAccount: { lamports },
	    });
	}
	function encodeAuthorizeNonceAccount({ authorized }) {
	    return encodeData({
	        authorizeNonceAccount: { authorized: authorized.toBuffer() },
	    });
	}
	function encodeAllocate({ space }) {
	    return encodeData({
	        allocate: { space },
	    });
	}
	function encodeAllocateWithSeed({ base, seed, space, owner }) {
	    return encodeData({
	        allocateWithSeed: {
	            base: base.toBuffer(),
	            seed,
	            space,
	            owner: owner.toBuffer(),
	        },
	    }, LAYOUT.getVariant(9).span + seed.length);
	}
	function encodeAssignWithSeed({ base, seed, owner }) {
	    return encodeData({
	        assignWithSeed: {
	            base: base.toBuffer(),
	            seed,
	            owner: owner.toBuffer(),
	        },
	    }, LAYOUT.getVariant(10).span + seed.length);
	}
	function encodeTransferWithSeed({ lamports, seed, owner }) {
	    return encodeData({
	        transferWithSeed: {
	            lamports,
	            seed,
	            owner: owner.toBuffer(),
	        },
	    }, LAYOUT.getVariant(11).span + seed.length);
	}
	const LAYOUT = BufferLayout$1.union(BufferLayout$1.u32("instruction"));
	LAYOUT.addVariant(0, BufferLayout$1.struct([
	    BufferLayout$1.ns64("lamports"),
	    BufferLayout$1.ns64("space"),
	    publicKey$1("owner"),
	]), "createAccount");
	LAYOUT.addVariant(1, BufferLayout$1.struct([publicKey$1("owner")]), "assign");
	LAYOUT.addVariant(2, BufferLayout$1.struct([BufferLayout$1.ns64("lamports")]), "transfer");
	LAYOUT.addVariant(3, BufferLayout$1.struct([
	    publicKey$1("base"),
	    rustStringLayout("seed"),
	    BufferLayout$1.ns64("lamports"),
	    BufferLayout$1.ns64("space"),
	    publicKey$1("owner"),
	]), "createAccountWithSeed");
	LAYOUT.addVariant(4, BufferLayout$1.struct([publicKey$1("authorized")]), "advanceNonceAccount");
	LAYOUT.addVariant(5, BufferLayout$1.struct([BufferLayout$1.ns64("lamports")]), "withdrawNonceAccount");
	LAYOUT.addVariant(6, BufferLayout$1.struct([publicKey$1("authorized")]), "initializeNonceAccount");
	LAYOUT.addVariant(7, BufferLayout$1.struct([publicKey$1("authorized")]), "authorizeNonceAccount");
	LAYOUT.addVariant(8, BufferLayout$1.struct([BufferLayout$1.ns64("space")]), "allocate");
	LAYOUT.addVariant(9, BufferLayout$1.struct([
	    publicKey$1("base"),
	    rustStringLayout("seed"),
	    BufferLayout$1.ns64("space"),
	    publicKey$1("owner"),
	]), "allocateWithSeed");
	LAYOUT.addVariant(10, BufferLayout$1.struct([
	    publicKey$1("base"),
	    rustStringLayout("seed"),
	    publicKey$1("owner"),
	]), "assignWithSeed");
	LAYOUT.addVariant(11, BufferLayout$1.struct([
	    BufferLayout$1.ns64("lamports"),
	    rustStringLayout("seed"),
	    publicKey$1("owner"),
	]), "transferWithSeed");
	function encodeData(instruction, maxSpan) {
	    const b = Buffer.alloc(maxSpan !== null && maxSpan !== void 0 ? maxSpan : instructionMaxSpan);
	    const span = LAYOUT.encode(instruction, b);
	    if (maxSpan === undefined) {
	        return b.slice(0, span);
	    }
	    return b;
	}
	const instructionMaxSpan = Math.max(...Object.values(LAYOUT.registry).map((r) => r.span));

	var state$1 = {};

	Object.defineProperty(state$1, "__esModule", { value: true });
	state$1.SystemStateCoder = void 0;
	class SystemStateCoder {
	    // eslint-disable-next-line @typescript-eslint/no-empty-function
	    constructor(_idl) { }
	    encode(_name, _account) {
	        throw new Error("System does not have state");
	    }
	    decode(_ix) {
	        throw new Error("System does not have state");
	    }
	}
	state$1.SystemStateCoder = SystemStateCoder;

	var accounts = {};

	var __createBinding$3 = (commonjsGlobal && commonjsGlobal.__createBinding) || (Object.create ? (function(o, m, k, k2) {
	    if (k2 === undefined) k2 = k;
	    var desc = Object.getOwnPropertyDescriptor(m, k);
	    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
	      desc = { enumerable: true, get: function() { return m[k]; } };
	    }
	    Object.defineProperty(o, k2, desc);
	}) : (function(o, m, k, k2) {
	    if (k2 === undefined) k2 = k;
	    o[k2] = m[k];
	}));
	var __setModuleDefault$3 = (commonjsGlobal && commonjsGlobal.__setModuleDefault) || (Object.create ? (function(o, v) {
	    Object.defineProperty(o, "default", { enumerable: true, value: v });
	}) : function(o, v) {
	    o["default"] = v;
	});
	var __importStar$3 = (commonjsGlobal && commonjsGlobal.__importStar) || function (mod) {
	    if (mod && mod.__esModule) return mod;
	    var result = {};
	    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding$3(result, mod, k);
	    __setModuleDefault$3(result, mod);
	    return result;
	};
	Object.defineProperty(accounts, "__esModule", { value: true });
	accounts.SystemAccountsCoder = void 0;
	const BufferLayout = __importStar$3(Layout$1);
	const web3_js_1$6 = require$$0$1;
	const common_js_1$4 = common;
	class SystemAccountsCoder {
	    constructor(idl) {
	        this.idl = idl;
	    }
	    async encode(accountName, account) {
	        switch (accountName) {
	            case "nonce": {
	                const buffer = Buffer.alloc(web3_js_1$6.NONCE_ACCOUNT_LENGTH);
	                const len = NONCE_ACCOUNT_LAYOUT.encode(account, buffer);
	                return buffer.slice(0, len);
	            }
	            default: {
	                throw new Error(`Invalid account name: ${accountName}`);
	            }
	        }
	    }
	    decode(accountName, ix) {
	        return this.decodeUnchecked(accountName, ix);
	    }
	    decodeUnchecked(accountName, ix) {
	        switch (accountName) {
	            case "nonce": {
	                return decodeNonceAccount(ix);
	            }
	            default: {
	                throw new Error(`Invalid account name: ${accountName}`);
	            }
	        }
	    }
	    // TODO: this won't use the appendData.
	    memcmp(accountName, _appendData) {
	        switch (accountName) {
	            case "nonce": {
	                return {
	                    dataSize: web3_js_1$6.NONCE_ACCOUNT_LENGTH,
	                };
	            }
	            default: {
	                throw new Error(`Invalid account name: ${accountName}`);
	            }
	        }
	    }
	    size(idlAccount) {
	        var _a;
	        return (_a = (0, common_js_1$4.accountSize)(this.idl, idlAccount)) !== null && _a !== void 0 ? _a : 0;
	    }
	}
	accounts.SystemAccountsCoder = SystemAccountsCoder;
	function decodeNonceAccount(ix) {
	    return NONCE_ACCOUNT_LAYOUT.decode(ix);
	}
	class WrappedLayout extends BufferLayout.Layout {
	    constructor(layout, decoder, encoder, property) {
	        super(layout.span, property);
	        this.layout = layout;
	        this.decoder = decoder;
	        this.encoder = encoder;
	    }
	    decode(b, offset) {
	        return this.decoder(this.layout.decode(b, offset));
	    }
	    encode(src, b, offset) {
	        return this.layout.encode(this.encoder(src), b, offset);
	    }
	    getSpan(b, offset) {
	        return this.layout.getSpan(b, offset);
	    }
	}
	function publicKey(property) {
	    return new WrappedLayout(BufferLayout.blob(32), (b) => new web3_js_1$6.PublicKey(b), (key) => key.toBuffer(), property);
	}
	const NONCE_ACCOUNT_LAYOUT = BufferLayout.struct([
	    BufferLayout.u32("version"),
	    BufferLayout.u32("state"),
	    publicKey("authorizedPubkey"),
	    publicKey("nonce"),
	    BufferLayout.struct([BufferLayout.nu64("lamportsPerSignature")], "feeCalculator"),
	]);

	var events = {};

	Object.defineProperty(events, "__esModule", { value: true });
	events.SystemEventsCoder = void 0;
	class SystemEventsCoder {
	    constructor(_idl) { }
	    decode(_log) {
	        throw new Error("System program does not have events");
	    }
	}
	events.SystemEventsCoder = SystemEventsCoder;

	var types = {};

	Object.defineProperty(types, "__esModule", { value: true });
	types.SystemTypesCoder = void 0;
	class SystemTypesCoder {
	    constructor(_idl) { }
	    encode(_name, _type) {
	        throw new Error("System does not have user-defined types");
	    }
	    decode(_name, _typeData) {
	        throw new Error("System does not have user-defined types");
	    }
	}
	types.SystemTypesCoder = SystemTypesCoder;

	Object.defineProperty(system, "__esModule", { value: true });
	system.SystemCoder = void 0;
	const instruction_js_1$1 = instruction$1;
	const state_js_1 = state$1;
	const accounts_js_1 = accounts;
	const events_js_1 = events;
	const types_js_1 = types;
	/**
	 * Coder for the System program.
	 */
	class SystemCoder {
	    constructor(idl) {
	        this.instruction = new instruction_js_1$1.SystemInstructionCoder(idl);
	        this.accounts = new accounts_js_1.SystemAccountsCoder(idl);
	        this.events = new events_js_1.SystemEventsCoder(idl);
	        this.state = new state_js_1.SystemStateCoder(idl);
	        this.types = new types_js_1.SystemTypesCoder(idl);
	    }
	}
	system.SystemCoder = SystemCoder;

	(function (exports) {
		var __createBinding = (commonjsGlobal && commonjsGlobal.__createBinding) || (Object.create ? (function(o, m, k, k2) {
		    if (k2 === undefined) k2 = k;
		    var desc = Object.getOwnPropertyDescriptor(m, k);
		    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
		      desc = { enumerable: true, get: function() { return m[k]; } };
		    }
		    Object.defineProperty(o, k2, desc);
		}) : (function(o, m, k, k2) {
		    if (k2 === undefined) k2 = k;
		    o[k2] = m[k];
		}));
		var __exportStar = (commonjsGlobal && commonjsGlobal.__exportStar) || function(m, exports) {
		    for (var p in m) if (p !== "default" && !Object.prototype.hasOwnProperty.call(exports, p)) __createBinding(exports, m, p);
		};
		Object.defineProperty(exports, "__esModule", { value: true });
		__exportStar(borsh$1, exports);
		__exportStar(splToken, exports);
		__exportStar(system, exports);
		
	} (coder));

	var namespace = {};

	var state = {};

	var eventemitter3Exports = {};
	var eventemitter3 = {
	  get exports(){ return eventemitter3Exports; },
	  set exports(v){ eventemitter3Exports = v; },
	};

	(function (module) {

		var has = Object.prototype.hasOwnProperty
		  , prefix = '~';

		/**
		 * Constructor to create a storage for our `EE` objects.
		 * An `Events` instance is a plain object whose properties are event names.
		 *
		 * @constructor
		 * @private
		 */
		function Events() {}

		//
		// We try to not inherit from `Object.prototype`. In some engines creating an
		// instance in this way is faster than calling `Object.create(null)` directly.
		// If `Object.create(null)` is not supported we prefix the event names with a
		// character to make sure that the built-in object properties are not
		// overridden or used as an attack vector.
		//
		if (Object.create) {
		  Events.prototype = Object.create(null);

		  //
		  // This hack is needed because the `__proto__` property is still inherited in
		  // some old browsers like Android 4, iPhone 5.1, Opera 11 and Safari 5.
		  //
		  if (!new Events().__proto__) prefix = false;
		}

		/**
		 * Representation of a single event listener.
		 *
		 * @param {Function} fn The listener function.
		 * @param {*} context The context to invoke the listener with.
		 * @param {Boolean} [once=false] Specify if the listener is a one-time listener.
		 * @constructor
		 * @private
		 */
		function EE(fn, context, once) {
		  this.fn = fn;
		  this.context = context;
		  this.once = once || false;
		}

		/**
		 * Add a listener for a given event.
		 *
		 * @param {EventEmitter} emitter Reference to the `EventEmitter` instance.
		 * @param {(String|Symbol)} event The event name.
		 * @param {Function} fn The listener function.
		 * @param {*} context The context to invoke the listener with.
		 * @param {Boolean} once Specify if the listener is a one-time listener.
		 * @returns {EventEmitter}
		 * @private
		 */
		function addListener(emitter, event, fn, context, once) {
		  if (typeof fn !== 'function') {
		    throw new TypeError('The listener must be a function');
		  }

		  var listener = new EE(fn, context || emitter, once)
		    , evt = prefix ? prefix + event : event;

		  if (!emitter._events[evt]) emitter._events[evt] = listener, emitter._eventsCount++;
		  else if (!emitter._events[evt].fn) emitter._events[evt].push(listener);
		  else emitter._events[evt] = [emitter._events[evt], listener];

		  return emitter;
		}

		/**
		 * Clear event by name.
		 *
		 * @param {EventEmitter} emitter Reference to the `EventEmitter` instance.
		 * @param {(String|Symbol)} evt The Event name.
		 * @private
		 */
		function clearEvent(emitter, evt) {
		  if (--emitter._eventsCount === 0) emitter._events = new Events();
		  else delete emitter._events[evt];
		}

		/**
		 * Minimal `EventEmitter` interface that is molded against the Node.js
		 * `EventEmitter` interface.
		 *
		 * @constructor
		 * @public
		 */
		function EventEmitter() {
		  this._events = new Events();
		  this._eventsCount = 0;
		}

		/**
		 * Return an array listing the events for which the emitter has registered
		 * listeners.
		 *
		 * @returns {Array}
		 * @public
		 */
		EventEmitter.prototype.eventNames = function eventNames() {
		  var names = []
		    , events
		    , name;

		  if (this._eventsCount === 0) return names;

		  for (name in (events = this._events)) {
		    if (has.call(events, name)) names.push(prefix ? name.slice(1) : name);
		  }

		  if (Object.getOwnPropertySymbols) {
		    return names.concat(Object.getOwnPropertySymbols(events));
		  }

		  return names;
		};

		/**
		 * Return the listeners registered for a given event.
		 *
		 * @param {(String|Symbol)} event The event name.
		 * @returns {Array} The registered listeners.
		 * @public
		 */
		EventEmitter.prototype.listeners = function listeners(event) {
		  var evt = prefix ? prefix + event : event
		    , handlers = this._events[evt];

		  if (!handlers) return [];
		  if (handlers.fn) return [handlers.fn];

		  for (var i = 0, l = handlers.length, ee = new Array(l); i < l; i++) {
		    ee[i] = handlers[i].fn;
		  }

		  return ee;
		};

		/**
		 * Return the number of listeners listening to a given event.
		 *
		 * @param {(String|Symbol)} event The event name.
		 * @returns {Number} The number of listeners.
		 * @public
		 */
		EventEmitter.prototype.listenerCount = function listenerCount(event) {
		  var evt = prefix ? prefix + event : event
		    , listeners = this._events[evt];

		  if (!listeners) return 0;
		  if (listeners.fn) return 1;
		  return listeners.length;
		};

		/**
		 * Calls each of the listeners registered for a given event.
		 *
		 * @param {(String|Symbol)} event The event name.
		 * @returns {Boolean} `true` if the event had listeners, else `false`.
		 * @public
		 */
		EventEmitter.prototype.emit = function emit(event, a1, a2, a3, a4, a5) {
		  var evt = prefix ? prefix + event : event;

		  if (!this._events[evt]) return false;

		  var listeners = this._events[evt]
		    , len = arguments.length
		    , args
		    , i;

		  if (listeners.fn) {
		    if (listeners.once) this.removeListener(event, listeners.fn, undefined, true);

		    switch (len) {
		      case 1: return listeners.fn.call(listeners.context), true;
		      case 2: return listeners.fn.call(listeners.context, a1), true;
		      case 3: return listeners.fn.call(listeners.context, a1, a2), true;
		      case 4: return listeners.fn.call(listeners.context, a1, a2, a3), true;
		      case 5: return listeners.fn.call(listeners.context, a1, a2, a3, a4), true;
		      case 6: return listeners.fn.call(listeners.context, a1, a2, a3, a4, a5), true;
		    }

		    for (i = 1, args = new Array(len -1); i < len; i++) {
		      args[i - 1] = arguments[i];
		    }

		    listeners.fn.apply(listeners.context, args);
		  } else {
		    var length = listeners.length
		      , j;

		    for (i = 0; i < length; i++) {
		      if (listeners[i].once) this.removeListener(event, listeners[i].fn, undefined, true);

		      switch (len) {
		        case 1: listeners[i].fn.call(listeners[i].context); break;
		        case 2: listeners[i].fn.call(listeners[i].context, a1); break;
		        case 3: listeners[i].fn.call(listeners[i].context, a1, a2); break;
		        case 4: listeners[i].fn.call(listeners[i].context, a1, a2, a3); break;
		        default:
		          if (!args) for (j = 1, args = new Array(len -1); j < len; j++) {
		            args[j - 1] = arguments[j];
		          }

		          listeners[i].fn.apply(listeners[i].context, args);
		      }
		    }
		  }

		  return true;
		};

		/**
		 * Add a listener for a given event.
		 *
		 * @param {(String|Symbol)} event The event name.
		 * @param {Function} fn The listener function.
		 * @param {*} [context=this] The context to invoke the listener with.
		 * @returns {EventEmitter} `this`.
		 * @public
		 */
		EventEmitter.prototype.on = function on(event, fn, context) {
		  return addListener(this, event, fn, context, false);
		};

		/**
		 * Add a one-time listener for a given event.
		 *
		 * @param {(String|Symbol)} event The event name.
		 * @param {Function} fn The listener function.
		 * @param {*} [context=this] The context to invoke the listener with.
		 * @returns {EventEmitter} `this`.
		 * @public
		 */
		EventEmitter.prototype.once = function once(event, fn, context) {
		  return addListener(this, event, fn, context, true);
		};

		/**
		 * Remove the listeners of a given event.
		 *
		 * @param {(String|Symbol)} event The event name.
		 * @param {Function} fn Only remove the listeners that match this function.
		 * @param {*} context Only remove the listeners that have this context.
		 * @param {Boolean} once Only remove one-time listeners.
		 * @returns {EventEmitter} `this`.
		 * @public
		 */
		EventEmitter.prototype.removeListener = function removeListener(event, fn, context, once) {
		  var evt = prefix ? prefix + event : event;

		  if (!this._events[evt]) return this;
		  if (!fn) {
		    clearEvent(this, evt);
		    return this;
		  }

		  var listeners = this._events[evt];

		  if (listeners.fn) {
		    if (
		      listeners.fn === fn &&
		      (!once || listeners.once) &&
		      (!context || listeners.context === context)
		    ) {
		      clearEvent(this, evt);
		    }
		  } else {
		    for (var i = 0, events = [], length = listeners.length; i < length; i++) {
		      if (
		        listeners[i].fn !== fn ||
		        (once && !listeners[i].once) ||
		        (context && listeners[i].context !== context)
		      ) {
		        events.push(listeners[i]);
		      }
		    }

		    //
		    // Reset the array, or remove it completely if we have no more listeners.
		    //
		    if (events.length) this._events[evt] = events.length === 1 ? events[0] : events;
		    else clearEvent(this, evt);
		  }

		  return this;
		};

		/**
		 * Remove all listeners, or those of the specified event.
		 *
		 * @param {(String|Symbol)} [event] The event name.
		 * @returns {EventEmitter} `this`.
		 * @public
		 */
		EventEmitter.prototype.removeAllListeners = function removeAllListeners(event) {
		  var evt;

		  if (event) {
		    evt = prefix ? prefix + event : event;
		    if (this._events[evt]) clearEvent(this, evt);
		  } else {
		    this._events = new Events();
		    this._eventsCount = 0;
		  }

		  return this;
		};

		//
		// Alias methods names because people roll like that.
		//
		EventEmitter.prototype.off = EventEmitter.prototype.removeListener;
		EventEmitter.prototype.addListener = EventEmitter.prototype.on;

		//
		// Expose the prefix.
		//
		EventEmitter.prefixed = prefix;

		//
		// Allow `EventEmitter` to be imported as module namespace.
		//
		EventEmitter.EventEmitter = EventEmitter;

		//
		// Expose the module.
		//
		{
		  module.exports = EventEmitter;
		}
	} (eventemitter3));

	var pubkey = {};

	var __importDefault$3 = (commonjsGlobal && commonjsGlobal.__importDefault) || function (mod) {
	    return (mod && mod.__esModule) ? mod : { "default": mod };
	};
	Object.defineProperty(pubkey, "__esModule", { value: true });
	pubkey.associated = pubkey.findProgramAddressSync = pubkey.createProgramAddressSync = pubkey.createWithSeedSync = void 0;
	const buffer_1 = require$$0;
	const bn_js_1$1 = __importDefault$3(bnExports);
	const js_sha256_1 = sha256Exports;
	const web3_js_1$5 = require$$0$1;
	const common_js_1$3 = common$1;
	// Sync version of web3.PublicKey.createWithSeed.
	function createWithSeedSync(fromPublicKey, seed, programId) {
	    const buffer = buffer_1.Buffer.concat([
	        fromPublicKey.toBuffer(),
	        buffer_1.Buffer.from(seed),
	        programId.toBuffer(),
	    ]);
	    const hash = js_sha256_1.sha256.digest(buffer);
	    return new web3_js_1$5.PublicKey(buffer_1.Buffer.from(hash));
	}
	pubkey.createWithSeedSync = createWithSeedSync;
	// Sync version of web3.PublicKey.createProgramAddress.
	function createProgramAddressSync(seeds, programId) {
	    const MAX_SEED_LENGTH = 32;
	    let buffer = buffer_1.Buffer.alloc(0);
	    seeds.forEach(function (seed) {
	        if (seed.length > MAX_SEED_LENGTH) {
	            throw new TypeError(`Max seed length exceeded`);
	        }
	        buffer = buffer_1.Buffer.concat([buffer, toBuffer(seed)]);
	    });
	    buffer = buffer_1.Buffer.concat([
	        buffer,
	        programId.toBuffer(),
	        buffer_1.Buffer.from("ProgramDerivedAddress"),
	    ]);
	    let hash = (0, js_sha256_1.sha256)(new Uint8Array(buffer));
	    let publicKeyBytes = new bn_js_1$1.default(hash, 16).toArray(undefined, 32);
	    if (web3_js_1$5.PublicKey.isOnCurve(new Uint8Array(publicKeyBytes))) {
	        throw new Error(`Invalid seeds, address must fall off the curve`);
	    }
	    return new web3_js_1$5.PublicKey(publicKeyBytes);
	}
	pubkey.createProgramAddressSync = createProgramAddressSync;
	// Sync version of web3.PublicKey.findProgramAddress.
	function findProgramAddressSync(seeds, programId) {
	    let nonce = 255;
	    let address;
	    while (nonce != 0) {
	        try {
	            const seedsWithNonce = seeds.concat(buffer_1.Buffer.from([nonce]));
	            address = createProgramAddressSync(seedsWithNonce, programId);
	        }
	        catch (err) {
	            if (err instanceof TypeError) {
	                throw err;
	            }
	            nonce--;
	            continue;
	        }
	        return [address, nonce];
	    }
	    throw new Error(`Unable to find a viable program address nonce`);
	}
	pubkey.findProgramAddressSync = findProgramAddressSync;
	const toBuffer = (arr) => {
	    if (arr instanceof buffer_1.Buffer) {
	        return arr;
	    }
	    else if (arr instanceof Uint8Array) {
	        return buffer_1.Buffer.from(arr.buffer, arr.byteOffset, arr.byteLength);
	    }
	    else {
	        return buffer_1.Buffer.from(arr);
	    }
	};
	async function associated(programId, ...args) {
	    let seeds = [buffer_1.Buffer.from([97, 110, 99, 104, 111, 114])]; // b"anchor".
	    args.forEach((arg) => {
	        seeds.push(arg instanceof buffer_1.Buffer ? arg : (0, common_js_1$3.translateAddress)(arg).toBuffer());
	    });
	    const [assoc] = await web3_js_1$5.PublicKey.findProgramAddress(seeds, (0, common_js_1$3.translateAddress)(programId));
	    return assoc;
	}
	pubkey.associated = associated;

	var instruction = {};

	var context = {};

	Object.defineProperty(context, "__esModule", { value: true });
	context.splitArgsAndCtx = void 0;
	function splitArgsAndCtx(idlIx, args) {
	    var _a, _b;
	    let options = {};
	    const inputLen = idlIx.args ? idlIx.args.length : 0;
	    if (args.length > inputLen) {
	        if (args.length !== inputLen + 1) {
	            throw new Error(`provided too many arguments ${args} to instruction ${idlIx === null || idlIx === void 0 ? void 0 : idlIx.name} expecting: ${(_b = (_a = idlIx.args) === null || _a === void 0 ? void 0 : _a.map((a) => a.name)) !== null && _b !== void 0 ? _b : []}`);
	        }
	        options = args.pop();
	    }
	    return [args, options];
	}
	context.splitArgsAndCtx = splitArgsAndCtx;

	var __createBinding$2 = (commonjsGlobal && commonjsGlobal.__createBinding) || (Object.create ? (function(o, m, k, k2) {
	    if (k2 === undefined) k2 = k;
	    var desc = Object.getOwnPropertyDescriptor(m, k);
	    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
	      desc = { enumerable: true, get: function() { return m[k]; } };
	    }
	    Object.defineProperty(o, k2, desc);
	}) : (function(o, m, k, k2) {
	    if (k2 === undefined) k2 = k;
	    o[k2] = m[k];
	}));
	var __setModuleDefault$2 = (commonjsGlobal && commonjsGlobal.__setModuleDefault) || (Object.create ? (function(o, v) {
	    Object.defineProperty(o, "default", { enumerable: true, value: v });
	}) : function(o, v) {
	    o["default"] = v;
	});
	var __importStar$2 = (commonjsGlobal && commonjsGlobal.__importStar) || function (mod) {
	    if (mod && mod.__esModule) return mod;
	    var result = {};
	    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding$2(result, mod, k);
	    __setModuleDefault$2(result, mod);
	    return result;
	};
	Object.defineProperty(instruction, "__esModule", { value: true });
	const web3_js_1$4 = require$$0$1;
	const error_js_1$2 = error;
	const common_js_1$2 = common$1;
	const context_js_1$3 = context;
	const features = __importStar$2(features$2);
	class InstructionNamespaceFactory {
	    static build(idlIx, encodeFn, programId) {
	        if (idlIx.name === "_inner") {
	            throw new error_js_1$2.IdlError("the _inner name is reserved");
	        }
	        const ix = (...args) => {
	            const [ixArgs, ctx] = (0, context_js_1$3.splitArgsAndCtx)(idlIx, [...args]);
	            (0, common_js_1$2.validateAccounts)(idlIx.accounts, ctx.accounts);
	            validateInstruction(idlIx, ...args);
	            const keys = ix.accounts(ctx.accounts);
	            if (ctx.remainingAccounts !== undefined) {
	                keys.push(...ctx.remainingAccounts);
	            }
	            if (features.isSet("debug-logs")) {
	                console.log("Outgoing account metas:", keys);
	            }
	            return new web3_js_1$4.TransactionInstruction({
	                keys,
	                programId,
	                data: encodeFn(idlIx.name, (0, common_js_1$2.toInstruction)(idlIx, ...ixArgs)),
	            });
	        };
	        // Utility fn for ordering the accounts for this instruction.
	        ix["accounts"] = (accs) => {
	            return InstructionNamespaceFactory.accountsArray(accs, idlIx.accounts, idlIx.name);
	        };
	        return ix;
	    }
	    static accountsArray(ctx, accounts, ixName) {
	        if (!ctx) {
	            return [];
	        }
	        return accounts
	            .map((acc) => {
	            // Nested accounts.
	            const nestedAccounts = "accounts" in acc ? acc.accounts : undefined;
	            if (nestedAccounts !== undefined) {
	                const rpcAccs = ctx[acc.name];
	                return InstructionNamespaceFactory.accountsArray(rpcAccs, acc.accounts, ixName).flat();
	            }
	            else {
	                const account = acc;
	                let pubkey;
	                try {
	                    pubkey = (0, common_js_1$2.translateAddress)(ctx[acc.name]);
	                }
	                catch (err) {
	                    throw new Error(`Wrong input type for account "${acc.name}" in the instruction accounts object${ixName !== undefined ? ' for instruction "' + ixName + '"' : ""}. Expected PublicKey or string.`);
	                }
	                return {
	                    pubkey,
	                    isWritable: account.isMut,
	                    isSigner: account.isSigner,
	                };
	            }
	        })
	            .flat();
	    }
	}
	instruction.default = InstructionNamespaceFactory;
	// Throws error if any argument required for the `ix` is not given.
	function validateInstruction(ix, ...args) {
	    // todo
	}

	var rpc = {};

	Object.defineProperty(rpc, "__esModule", { value: true });
	const context_js_1$2 = context;
	const error_js_1$1 = error;
	class RpcFactory {
	    static build(idlIx, txFn, idlErrors, provider) {
	        const rpc = async (...args) => {
	            var _a;
	            const tx = txFn(...args);
	            const [, ctx] = (0, context_js_1$2.splitArgsAndCtx)(idlIx, [...args]);
	            if (provider.sendAndConfirm === undefined) {
	                throw new Error("This function requires 'Provider.sendAndConfirm' to be implemented.");
	            }
	            try {
	                return await provider.sendAndConfirm(tx, (_a = ctx.signers) !== null && _a !== void 0 ? _a : [], ctx.options);
	            }
	            catch (err) {
	                throw (0, error_js_1$1.translateError)(err, idlErrors);
	            }
	        };
	        return rpc;
	    }
	}
	rpc.default = RpcFactory;

	var transaction = {};

	Object.defineProperty(transaction, "__esModule", { value: true });
	const web3_js_1$3 = require$$0$1;
	const context_js_1$1 = context;
	class TransactionFactory {
	    static build(idlIx, ixFn) {
	        const txFn = (...args) => {
	            var _a, _b, _c;
	            const [, ctx] = (0, context_js_1$1.splitArgsAndCtx)(idlIx, [...args]);
	            const tx = new web3_js_1$3.Transaction();
	            if (ctx.preInstructions && ctx.instructions) {
	                throw new Error("instructions is deprecated, use preInstructions");
	            }
	            (_a = ctx.preInstructions) === null || _a === void 0 ? void 0 : _a.forEach((ix) => tx.add(ix));
	            (_b = ctx.instructions) === null || _b === void 0 ? void 0 : _b.forEach((ix) => tx.add(ix));
	            tx.add(ixFn(...args));
	            (_c = ctx.postInstructions) === null || _c === void 0 ? void 0 : _c.forEach((ix) => tx.add(ix));
	            return tx;
	        };
	        return txFn;
	    }
	}
	transaction.default = TransactionFactory;

	var __importDefault$2 = (commonjsGlobal && commonjsGlobal.__importDefault) || function (mod) {
	    return (mod && mod.__esModule) ? mod : { "default": mod };
	};
	Object.defineProperty(state, "__esModule", { value: true });
	state.StateClient = void 0;
	const eventemitter3_1$1 = __importDefault$2(eventemitter3Exports);
	const camelcase_1$1 = __importDefault$2(camelcaseExports);
	const web3_js_1$2 = require$$0$1;
	const provider_js_1$1 = requireProvider();
	const index_js_1$1 = coder;
	const common_js_1$1 = common$1;
	const pubkey_js_1 = pubkey;
	const instruction_js_1 = __importDefault$2(instruction);
	const rpc_js_1 = __importDefault$2(rpc);
	const transaction_js_1 = __importDefault$2(transaction);
	class StateFactory {
	    static build(idl, coder, programId, provider) {
	        if (idl.state === undefined) {
	            return undefined;
	        }
	        return new StateClient(idl, programId, provider, coder);
	    }
	}
	state.default = StateFactory;
	/**
	 * A client for the program state. Similar to the base [[Program]] client,
	 * one can use this to send transactions and read accounts for the state
	 * abstraction.
	 */
	class StateClient {
	    constructor(idl, programId, 
	    /**
	     * Returns the client's wallet and network provider.
	     */
	    provider = (0, provider_js_1$1.getProvider)(), 
	    /**
	     * Returns the coder.
	     */
	    coder = new index_js_1$1.BorshCoder(idl)) {
	        this.provider = provider;
	        this.coder = coder;
	        this._idl = idl;
	        this._programId = programId;
	        this._address = programStateAddress(programId);
	        this._sub = null;
	        // Build namespaces.
	        const [instruction, transaction, rpc] = (() => {
	            var _a;
	            let instruction = {};
	            let transaction = {};
	            let rpc = {};
	            (_a = idl.state) === null || _a === void 0 ? void 0 : _a.methods.forEach((m) => {
	                // Build instruction method.
	                const ixItem = instruction_js_1.default.build(m, (ixName, ix) => coder.instruction.encodeState(ixName, ix), programId);
	                ixItem["accounts"] = (accounts) => {
	                    const keys = stateInstructionKeys(programId, provider, m, accounts);
	                    return keys.concat(instruction_js_1.default.accountsArray(accounts, m.accounts, m.name));
	                };
	                // Build transaction method.
	                const txItem = transaction_js_1.default.build(m, ixItem);
	                // Build RPC method.
	                const rpcItem = rpc_js_1.default.build(m, txItem, (0, common_js_1$1.parseIdlErrors)(idl), provider);
	                // Attach them all to their respective namespaces.
	                const name = (0, camelcase_1$1.default)(m.name);
	                instruction[name] = ixItem;
	                transaction[name] = txItem;
	                rpc[name] = rpcItem;
	            });
	            return [
	                instruction,
	                transaction,
	                rpc,
	            ];
	        })();
	        this.instruction = instruction;
	        this.transaction = transaction;
	        this.rpc = rpc;
	    }
	    /**
	     * Returns the program ID owning the state.
	     */
	    get programId() {
	        return this._programId;
	    }
	    /**
	     * Returns the deserialized state account.
	     */
	    async fetch() {
	        const addr = this.address();
	        const accountInfo = await this.provider.connection.getAccountInfo(addr);
	        if (accountInfo === null) {
	            throw new Error(`Account does not exist ${addr.toString()}`);
	        }
	        // Assert the account discriminator is correct.
	        const state = this._idl.state;
	        if (!state) {
	            throw new Error("State is not specified in IDL.");
	        }
	        const expectedDiscriminator = await (0, index_js_1$1.stateDiscriminator)(state.struct.name);
	        if (expectedDiscriminator.compare(accountInfo.data.slice(0, 8))) {
	            throw new Error("Invalid account discriminator");
	        }
	        return this.coder.state.decode(accountInfo.data);
	    }
	    /**
	     * Returns the state address.
	     */
	    address() {
	        return this._address;
	    }
	    /**
	     * Returns an `EventEmitter` with a `"change"` event that's fired whenever
	     * the state account cahnges.
	     */
	    subscribe(commitment) {
	        if (this._sub !== null) {
	            return this._sub.ee;
	        }
	        const ee = new eventemitter3_1$1.default();
	        const listener = this.provider.connection.onAccountChange(this.address(), (acc) => {
	            const account = this.coder.state.decode(acc.data);
	            ee.emit("change", account);
	        }, commitment);
	        this._sub = {
	            ee,
	            listener,
	        };
	        return ee;
	    }
	    /**
	     * Unsubscribes to state changes.
	     */
	    unsubscribe() {
	        if (this._sub !== null) {
	            this.provider.connection
	                .removeAccountChangeListener(this._sub.listener)
	                .then(async () => {
	                this._sub = null;
	            })
	                .catch(console.error);
	        }
	    }
	}
	state.StateClient = StateClient;
	// Calculates the deterministic address of the program's "state" account.
	function programStateAddress(programId) {
	    let [registrySigner] = (0, pubkey_js_1.findProgramAddressSync)([], programId);
	    return (0, pubkey_js_1.createWithSeedSync)(registrySigner, "unversioned", programId);
	}
	// Returns the common keys that are prepended to all instructions targeting
	// the "state" of a program.
	function stateInstructionKeys(programId, provider, m, accounts) {
	    if (m.name === "new") {
	        // Ctor `new` method.
	        const [programSigner] = (0, pubkey_js_1.findProgramAddressSync)([], programId);
	        // @ts-expect-error
	        if (provider.wallet === undefined) {
	            throw new Error("This function requires the Provider interface implementor to have a 'wallet' field.");
	        }
	        return [
	            {
	                // @ts-expect-error
	                pubkey: provider.wallet.publicKey,
	                isWritable: false,
	                isSigner: true,
	            },
	            {
	                pubkey: programStateAddress(programId),
	                isWritable: true,
	                isSigner: false,
	            },
	            { pubkey: programSigner, isWritable: false, isSigner: false },
	            {
	                pubkey: web3_js_1$2.SystemProgram.programId,
	                isWritable: false,
	                isSigner: false,
	            },
	            { pubkey: programId, isWritable: false, isSigner: false },
	        ];
	    }
	    else {
	        (0, common_js_1$1.validateAccounts)(m.accounts, accounts);
	        return [
	            {
	                pubkey: programStateAddress(programId),
	                isWritable: true,
	                isSigner: false,
	            },
	        ];
	    }
	}

	var account = {};

	var __createBinding$1 = (commonjsGlobal && commonjsGlobal.__createBinding) || (Object.create ? (function(o, m, k, k2) {
	    if (k2 === undefined) k2 = k;
	    var desc = Object.getOwnPropertyDescriptor(m, k);
	    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
	      desc = { enumerable: true, get: function() { return m[k]; } };
	    }
	    Object.defineProperty(o, k2, desc);
	}) : (function(o, m, k, k2) {
	    if (k2 === undefined) k2 = k;
	    o[k2] = m[k];
	}));
	var __setModuleDefault$1 = (commonjsGlobal && commonjsGlobal.__setModuleDefault) || (Object.create ? (function(o, v) {
	    Object.defineProperty(o, "default", { enumerable: true, value: v });
	}) : function(o, v) {
	    o["default"] = v;
	});
	var __importStar$1 = (commonjsGlobal && commonjsGlobal.__importStar) || function (mod) {
	    if (mod && mod.__esModule) return mod;
	    var result = {};
	    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding$1(result, mod, k);
	    __setModuleDefault$1(result, mod);
	    return result;
	};
	var __importDefault$1 = (commonjsGlobal && commonjsGlobal.__importDefault) || function (mod) {
	    return (mod && mod.__esModule) ? mod : { "default": mod };
	};
	Object.defineProperty(account, "__esModule", { value: true });
	account.AccountClient = void 0;
	const camelcase_1 = __importDefault$1(camelcaseExports);
	const eventemitter3_1 = __importDefault$1(eventemitter3Exports);
	const web3_js_1$1 = require$$0$1;
	const provider_js_1 = requireProvider();
	const index_js_1 = coder;
	const common_js_1 = common$1;
	const pubkeyUtil = __importStar$1(pubkey);
	const rpcUtil = __importStar$1(requireRpc());
	class AccountFactory {
	    static build(idl, coder, programId, provider) {
	        var _a;
	        const accountFns = {};
	        (_a = idl.accounts) === null || _a === void 0 ? void 0 : _a.forEach((idlAccount) => {
	            const name = (0, camelcase_1.default)(idlAccount.name);
	            accountFns[name] = new AccountClient(idl, idlAccount, programId, provider, coder);
	        });
	        return accountFns;
	    }
	}
	account.default = AccountFactory;
	class AccountClient {
	    constructor(idl, idlAccount, programId, provider, coder) {
	        this._idlAccount = idlAccount;
	        this._programId = programId;
	        this._provider = provider !== null && provider !== void 0 ? provider : (0, provider_js_1.getProvider)();
	        this._coder = coder !== null && coder !== void 0 ? coder : new index_js_1.BorshCoder(idl);
	        this._size = this._coder.accounts.size(idlAccount);
	    }
	    /**
	     * Returns the number of bytes in this account.
	     */
	    get size() {
	        return this._size;
	    }
	    /**
	     * Returns the program ID owning all accounts.
	     */
	    get programId() {
	        return this._programId;
	    }
	    /**
	     * Returns the client's wallet and network provider.
	     */
	    get provider() {
	        return this._provider;
	    }
	    /**
	     * Returns the coder.
	     */
	    get coder() {
	        return this._coder;
	    }
	    /**
	     * Returns a deserialized account, returning null if it doesn't exist.
	     *
	     * @param address The address of the account to fetch.
	     */
	    async fetchNullable(address, commitment) {
	        const accountInfo = await this.getAccountInfo(address, commitment);
	        if (accountInfo === null) {
	            return null;
	        }
	        return this._coder.accounts.decode(this._idlAccount.name, accountInfo.data);
	    }
	    /**
	     * Returns a deserialized account.
	     *
	     * @param address The address of the account to fetch.
	     */
	    async fetch(address, commitment) {
	        const data = await this.fetchNullable(address, commitment);
	        if (data === null) {
	            throw new Error(`Account does not exist ${address.toString()}`);
	        }
	        return data;
	    }
	    /**
	     * Returns multiple deserialized accounts.
	     * Accounts not found or with wrong discriminator are returned as null.
	     *
	     * @param addresses The addresses of the accounts to fetch.
	     */
	    async fetchMultiple(addresses, commitment) {
	        const accounts = await rpcUtil.getMultipleAccounts(this._provider.connection, addresses.map((address) => (0, common_js_1.translateAddress)(address)), commitment);
	        // Decode accounts where discriminator is correct, null otherwise
	        return accounts.map((account) => {
	            if (account == null) {
	                return null;
	            }
	            return this._coder.accounts.decode(this._idlAccount.name, account === null || account === void 0 ? void 0 : account.account.data);
	        });
	    }
	    /**
	     * Returns all instances of this account type for the program.
	     *
	     * @param filters User-provided filters to narrow the results from `connection.getProgramAccounts`.
	     *
	     *                When filters are not defined this method returns all
	     *                the account instances.
	     *
	     *                When filters are of type `Buffer`, the filters are appended
	     *                after the discriminator.
	     *
	     *                When filters are of type `GetProgramAccountsFilter[]`,
	     *                filters are appended after the discriminator filter.
	     */
	    async all(filters) {
	        let resp = await this._provider.connection.getProgramAccounts(this._programId, {
	            commitment: this._provider.connection.commitment,
	            filters: [
	                {
	                    memcmp: this.coder.accounts.memcmp(this._idlAccount.name, filters instanceof Buffer ? filters : undefined),
	                },
	                ...(Array.isArray(filters) ? filters : []),
	            ],
	        });
	        return resp.map(({ pubkey, account }) => {
	            return {
	                publicKey: pubkey,
	                account: this._coder.accounts.decode(this._idlAccount.name, account.data),
	            };
	        });
	    }
	    /**
	     * Returns an `EventEmitter` emitting a "change" event whenever the account
	     * changes.
	     */
	    subscribe(address, commitment) {
	        const sub = subscriptions.get(address.toString());
	        if (sub) {
	            return sub.ee;
	        }
	        const ee = new eventemitter3_1.default();
	        address = (0, common_js_1.translateAddress)(address);
	        const listener = this._provider.connection.onAccountChange(address, (acc) => {
	            const account = this._coder.accounts.decode(this._idlAccount.name, acc.data);
	            ee.emit("change", account);
	        }, commitment);
	        subscriptions.set(address.toString(), {
	            ee,
	            listener,
	        });
	        return ee;
	    }
	    /**
	     * Unsubscribes from the account at the given address.
	     */
	    async unsubscribe(address) {
	        let sub = subscriptions.get(address.toString());
	        if (!sub) {
	            console.warn("Address is not subscribed");
	            return;
	        }
	        if (subscriptions) {
	            await this._provider.connection
	                .removeAccountChangeListener(sub.listener)
	                .then(() => {
	                subscriptions.delete(address.toString());
	            })
	                .catch(console.error);
	        }
	    }
	    /**
	     * Returns an instruction for creating this account.
	     */
	    async createInstruction(signer, sizeOverride) {
	        const size = this.size;
	        // @ts-expect-error
	        if (this._provider.wallet === undefined) {
	            throw new Error("This function requires the Provider interface implementor to have a 'wallet' field.");
	        }
	        return web3_js_1$1.SystemProgram.createAccount({
	            // @ts-expect-error
	            fromPubkey: this._provider.wallet.publicKey,
	            newAccountPubkey: signer.publicKey,
	            space: sizeOverride !== null && sizeOverride !== void 0 ? sizeOverride : size,
	            lamports: await this._provider.connection.getMinimumBalanceForRentExemption(sizeOverride !== null && sizeOverride !== void 0 ? sizeOverride : size),
	            programId: this._programId,
	        });
	    }
	    /**
	     * @deprecated since version 14.0.
	     *
	     * Function returning the associated account. Args are keys to associate.
	     * Order matters.
	     */
	    async associated(...args) {
	        const addr = await this.associatedAddress(...args);
	        return await this.fetch(addr);
	    }
	    /**
	     * @deprecated since version 14.0.
	     *
	     * Function returning the associated address. Args are keys to associate.
	     * Order matters.
	     */
	    async associatedAddress(...args) {
	        return await pubkeyUtil.associated(this._programId, ...args);
	    }
	    async getAccountInfo(address, commitment) {
	        return await this._provider.connection.getAccountInfo((0, common_js_1.translateAddress)(address), commitment);
	    }
	}
	account.AccountClient = AccountClient;
	// Tracks all subscriptions.
	const subscriptions = new Map();

	var simulate = {};

	var event = {};

	var __createBinding = (commonjsGlobal && commonjsGlobal.__createBinding) || (Object.create ? (function(o, m, k, k2) {
	    if (k2 === undefined) k2 = k;
	    var desc = Object.getOwnPropertyDescriptor(m, k);
	    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
	      desc = { enumerable: true, get: function() { return m[k]; } };
	    }
	    Object.defineProperty(o, k2, desc);
	}) : (function(o, m, k, k2) {
	    if (k2 === undefined) k2 = k;
	    o[k2] = m[k];
	}));
	var __setModuleDefault = (commonjsGlobal && commonjsGlobal.__setModuleDefault) || (Object.create ? (function(o, v) {
	    Object.defineProperty(o, "default", { enumerable: true, value: v });
	}) : function(o, v) {
	    o["default"] = v;
	});
	var __importStar = (commonjsGlobal && commonjsGlobal.__importStar) || function (mod) {
	    if (mod && mod.__esModule) return mod;
	    var result = {};
	    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
	    __setModuleDefault(result, mod);
	    return result;
	};
	Object.defineProperty(event, "__esModule", { value: true });
	event.EventParser = event.EventManager = void 0;
	const assert = __importStar(require$$0$2);
	const PROGRAM_LOG = "Program log: ";
	const PROGRAM_DATA = "Program data: ";
	const PROGRAM_LOG_START_INDEX = PROGRAM_LOG.length;
	const PROGRAM_DATA_START_INDEX = PROGRAM_DATA.length;
	class EventManager {
	    constructor(programId, provider, coder) {
	        this._programId = programId;
	        this._provider = provider;
	        this._eventParser = new EventParser(programId, coder);
	        this._eventCallbacks = new Map();
	        this._eventListeners = new Map();
	        this._listenerIdCount = 0;
	    }
	    addEventListener(eventName, callback) {
	        var _a;
	        let listener = this._listenerIdCount;
	        this._listenerIdCount += 1;
	        // Store the listener into the event map.
	        if (!(eventName in this._eventCallbacks)) {
	            this._eventListeners.set(eventName, []);
	        }
	        this._eventListeners.set(eventName, ((_a = this._eventListeners.get(eventName)) !== null && _a !== void 0 ? _a : []).concat(listener));
	        // Store the callback into the listener map.
	        this._eventCallbacks.set(listener, [eventName, callback]);
	        // Create the subscription singleton, if needed.
	        if (this._onLogsSubscriptionId !== undefined) {
	            return listener;
	        }
	        this._onLogsSubscriptionId = this._provider.connection.onLogs(this._programId, (logs, ctx) => {
	            if (logs.err) {
	                return;
	            }
	            for (const event of this._eventParser.parseLogs(logs.logs)) {
	                const allListeners = this._eventListeners.get(event.name);
	                if (allListeners) {
	                    allListeners.forEach((listener) => {
	                        const listenerCb = this._eventCallbacks.get(listener);
	                        if (listenerCb) {
	                            const [, callback] = listenerCb;
	                            callback(event.data, ctx.slot, logs.signature);
	                        }
	                    });
	                }
	            }
	        });
	        return listener;
	    }
	    async removeEventListener(listener) {
	        // Get the callback.
	        const callback = this._eventCallbacks.get(listener);
	        if (!callback) {
	            throw new Error(`Event listener ${listener} doesn't exist!`);
	        }
	        const [eventName] = callback;
	        // Get the listeners.
	        let listeners = this._eventListeners.get(eventName);
	        if (!listeners) {
	            throw new Error(`Event listeners don't exist for ${eventName}!`);
	        }
	        // Update both maps.
	        this._eventCallbacks.delete(listener);
	        listeners = listeners.filter((l) => l !== listener);
	        if (listeners.length === 0) {
	            this._eventListeners.delete(eventName);
	        }
	        // Kill the websocket connection if all listeners have been removed.
	        if (this._eventCallbacks.size == 0) {
	            assert.ok(this._eventListeners.size === 0);
	            if (this._onLogsSubscriptionId !== undefined) {
	                await this._provider.connection.removeOnLogsListener(this._onLogsSubscriptionId);
	                this._onLogsSubscriptionId = undefined;
	            }
	        }
	    }
	}
	event.EventManager = EventManager;
	class EventParser {
	    constructor(programId, coder) {
	        this.coder = coder;
	        this.programId = programId;
	    }
	    // Each log given, represents an array of messages emitted by
	    // a single transaction, which can execute many different programs across
	    // CPI boundaries. However, the subscription is only interested in the
	    // events emitted by *this* program. In achieving this, we keep track of the
	    // program execution context by parsing each log and looking for a CPI
	    // `invoke` call. If one exists, we know a new program is executing. So we
	    // push the programId onto a stack and switch the program context. This
	    // allows us to track, for a given log, which program was executing during
	    // its emission, thereby allowing us to know if a given log event was
	    // emitted by *this* program. If it was, then we parse the raw string and
	    // emit the event if the string matches the event being subscribed to.
	    *parseLogs(logs) {
	        const logScanner = new LogScanner(logs);
	        const execution = new ExecutionContext();
	        let log = logScanner.next();
	        while (log !== null) {
	            let [event, newProgram, didPop] = this.handleLog(execution, log);
	            if (event) {
	                yield event;
	            }
	            if (newProgram) {
	                execution.push(newProgram);
	            }
	            if (didPop) {
	                execution.pop();
	            }
	            log = logScanner.next();
	        }
	    }
	    // Main log handler. Returns a three element array of the event, the
	    // next program that was invoked for CPI, and a boolean indicating if
	    // a program has completed execution (and thus should be popped off the
	    // execution stack).
	    handleLog(execution, log) {
	        // Executing program is this program.
	        if (execution.stack.length > 0 &&
	            execution.program() === this.programId.toString()) {
	            return this.handleProgramLog(log);
	        }
	        // Executing program is not this program.
	        else {
	            return [null, ...this.handleSystemLog(log)];
	        }
	    }
	    // Handles logs from *this* program.
	    handleProgramLog(log) {
	        // This is a `msg!` log or a `sol_log_data` log.
	        if (log.startsWith(PROGRAM_LOG) || log.startsWith(PROGRAM_DATA)) {
	            const logStr = log.startsWith(PROGRAM_LOG)
	                ? log.slice(PROGRAM_LOG_START_INDEX)
	                : log.slice(PROGRAM_DATA_START_INDEX);
	            const event = this.coder.events.decode(logStr);
	            return [event, null, false];
	        }
	        // System log.
	        else {
	            return [null, ...this.handleSystemLog(log)];
	        }
	    }
	    // Handles logs when the current program being executing is *not* this.
	    handleSystemLog(log) {
	        // System component.
	        const logStart = log.split(":")[0];
	        // Did the program finish executing?
	        if (logStart.match(/^Program (.*) success/g) !== null) {
	            return [null, true];
	            // Recursive call.
	        }
	        else if (logStart.startsWith(`Program ${this.programId.toString()} invoke`)) {
	            return [this.programId.toString(), false];
	        }
	        // CPI call.
	        else if (logStart.includes("invoke")) {
	            return ["cpi", false]; // Any string will do.
	        }
	        else {
	            return [null, false];
	        }
	    }
	}
	event.EventParser = EventParser;
	// Stack frame execution context, allowing one to track what program is
	// executing for a given log.
	class ExecutionContext {
	    constructor() {
	        this.stack = [];
	    }
	    program() {
	        assert.ok(this.stack.length > 0);
	        return this.stack[this.stack.length - 1];
	    }
	    push(newProgram) {
	        this.stack.push(newProgram);
	    }
	    pop() {
	        assert.ok(this.stack.length > 0);
	        this.stack.pop();
	    }
	}
	class LogScanner {
	    constructor(logs) {
	        this.logs = logs;
	    }
	    next() {
	        if (this.logs.length === 0) {
	            return null;
	        }
	        let l = this.logs[0];
	        this.logs = this.logs.slice(1);
	        return l;
	    }
	}

	Object.defineProperty(simulate, "__esModule", { value: true });
	const context_js_1 = context;
	const event_js_1 = event;
	const error_js_1 = error;
	class SimulateFactory {
	    static build(idlIx, txFn, idlErrors, provider, coder, programId, idl) {
	        const simulate = async (...args) => {
	            var _a;
	            const tx = txFn(...args);
	            const [, ctx] = (0, context_js_1.splitArgsAndCtx)(idlIx, [...args]);
	            let resp = undefined;
	            if (provider.simulate === undefined) {
	                throw new Error("This function requires 'Provider.simulate' to be implemented.");
	            }
	            try {
	                resp = await provider.simulate(tx, ctx.signers, (_a = ctx.options) === null || _a === void 0 ? void 0 : _a.commitment);
	            }
	            catch (err) {
	                throw (0, error_js_1.translateError)(err, idlErrors);
	            }
	            if (resp === undefined) {
	                throw new Error("Unable to simulate transaction");
	            }
	            const logs = resp.logs;
	            if (!logs) {
	                throw new Error("Simulated logs not found");
	            }
	            const events = [];
	            if (idl.events) {
	                let parser = new event_js_1.EventParser(programId, coder);
	                for (const event of parser.parseLogs(logs)) {
	                    events.push(event);
	                }
	            }
	            return { events, raw: logs };
	        };
	        return simulate;
	    }
	}
	simulate.default = SimulateFactory;

	var methods = {};

	var accountsResolver = {};

	var token = {};

	(function (exports) {
		Object.defineProperty(exports, "__esModule", { value: true });
		exports.associatedAddress = exports.ASSOCIATED_PROGRAM_ID = exports.TOKEN_PROGRAM_ID = void 0;
		const web3_js_1 = require$$0$1;
		exports.TOKEN_PROGRAM_ID = new web3_js_1.PublicKey("TokenkegQfeZyiNwAJbNbGKPFXCWuBvf9Ss623VQ5DA");
		exports.ASSOCIATED_PROGRAM_ID = new web3_js_1.PublicKey("ATokenGPvbdGVxr1b2hvZbsiqW5xWH25efTNsLJA8knL");
		async function associatedAddress({ mint, owner, }) {
		    return (await web3_js_1.PublicKey.findProgramAddress([owner.toBuffer(), exports.TOKEN_PROGRAM_ID.toBuffer(), mint.toBuffer()], exports.ASSOCIATED_PROGRAM_ID))[0];
		}
		exports.associatedAddress = associatedAddress;
		
	} (token));

	var hasRequiredAccountsResolver;

	function requireAccountsResolver () {
		if (hasRequiredAccountsResolver) return accountsResolver;
		hasRequiredAccountsResolver = 1;
		var __createBinding = (commonjsGlobal && commonjsGlobal.__createBinding) || (Object.create ? (function(o, m, k, k2) {
		    if (k2 === undefined) k2 = k;
		    var desc = Object.getOwnPropertyDescriptor(m, k);
		    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
		      desc = { enumerable: true, get: function() { return m[k]; } };
		    }
		    Object.defineProperty(o, k2, desc);
		}) : (function(o, m, k, k2) {
		    if (k2 === undefined) k2 = k;
		    o[k2] = m[k];
		}));
		var __setModuleDefault = (commonjsGlobal && commonjsGlobal.__setModuleDefault) || (Object.create ? (function(o, v) {
		    Object.defineProperty(o, "default", { enumerable: true, value: v });
		}) : function(o, v) {
		    o["default"] = v;
		});
		var __importStar = (commonjsGlobal && commonjsGlobal.__importStar) || function (mod) {
		    if (mod && mod.__esModule) return mod;
		    var result = {};
		    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
		    __setModuleDefault(result, mod);
		    return result;
		};
		var __importDefault = (commonjsGlobal && commonjsGlobal.__importDefault) || function (mod) {
		    return (mod && mod.__esModule) ? mod : { "default": mod };
		};
		Object.defineProperty(accountsResolver, "__esModule", { value: true });
		accountsResolver.AccountStore = accountsResolver.AccountsResolver = void 0;
		const camelcase_1 = __importDefault(camelcaseExports);
		const web3_js_1 = require$$0$1;
		const utf8 = __importStar(utf8$1);
		const token_js_1 = token;
		const token_1 = requireToken();
		// Populates a given accounts context with PDAs and common missing accounts.
		class AccountsResolver {
		    constructor(_args, _accounts, _provider, _programId, _idlIx, _accountNamespace) {
		        this._args = _args;
		        this._accounts = _accounts;
		        this._provider = _provider;
		        this._programId = _programId;
		        this._idlIx = _idlIx;
		        this._accountStore = new AccountStore(_provider, _accountNamespace);
		    }
		    // Note: We serially resolve PDAs one by one rather than doing them
		    //       in parallel because there can be dependencies between
		    //       addresses. That is, one PDA can be used as a seed in another.
		    //
		    // TODO: PDAs need to be resolved in topological order. For now, we
		    //       require the developer to simply list the accounts in the
		    //       correct order. But in future work, we should create the
		    //       dependency graph and resolve automatically.
		    //
		    async resolve() {
		        for (let k = 0; k < this._idlIx.accounts.length; k += 1) {
		            // Cast is ok because only a non-nested IdlAccount can have a seeds
		            // cosntraint.
		            const accountDesc = this._idlIx.accounts[k];
		            const accountDescName = (0, camelcase_1.default)(accountDesc.name);
		            // Signers default to the provider.
		            if (accountDesc.isSigner && !this._accounts[accountDescName]) {
		                // @ts-expect-error
		                if (this._provider.wallet === undefined) {
		                    throw new Error("This function requires the Provider interface implementor to have a 'wallet' field.");
		                }
		                // @ts-expect-error
		                this._accounts[accountDescName] = this._provider.wallet.publicKey;
		                continue;
		            }
		            // Common accounts are auto populated with magic names by convention.
		            if (Reflect.has(AccountsResolver.CONST_ACCOUNTS, accountDescName) &&
		                !this._accounts[accountDescName]) {
		                this._accounts[accountDescName] =
		                    AccountsResolver.CONST_ACCOUNTS[accountDescName];
		            }
		        }
		        for (let k = 0; k < this._idlIx.accounts.length; k += 1) {
		            // Cast is ok because only a non-nested IdlAccount can have a seeds
		            // cosntraint.
		            const accountDesc = this._idlIx.accounts[k];
		            const accountDescName = (0, camelcase_1.default)(accountDesc.name);
		            // PDA derived from IDL seeds.
		            if (accountDesc.pda &&
		                accountDesc.pda.seeds.length > 0 &&
		                !this._accounts[accountDescName]) {
		                await this.autoPopulatePda(accountDesc);
		                continue;
		            }
		        }
		    }
		    async autoPopulatePda(accountDesc) {
		        if (!accountDesc.pda || !accountDesc.pda.seeds)
		            throw new Error("Must have seeds");
		        const seeds = await Promise.all(accountDesc.pda.seeds.map((seedDesc) => this.toBuffer(seedDesc)));
		        const programId = await this.parseProgramId(accountDesc);
		        const [pubkey] = await web3_js_1.PublicKey.findProgramAddress(seeds, programId);
		        this._accounts[(0, camelcase_1.default)(accountDesc.name)] = pubkey;
		    }
		    async parseProgramId(accountDesc) {
		        var _a;
		        if (!((_a = accountDesc.pda) === null || _a === void 0 ? void 0 : _a.programId)) {
		            return this._programId;
		        }
		        switch (accountDesc.pda.programId.kind) {
		            case "const":
		                return new web3_js_1.PublicKey(this.toBufferConst(accountDesc.pda.programId.value));
		            case "arg":
		                return this.argValue(accountDesc.pda.programId);
		            case "account":
		                return await this.accountValue(accountDesc.pda.programId);
		            default:
		                throw new Error(`Unexpected program seed kind: ${accountDesc.pda.programId.kind}`);
		        }
		    }
		    async toBuffer(seedDesc) {
		        switch (seedDesc.kind) {
		            case "const":
		                return this.toBufferConst(seedDesc);
		            case "arg":
		                return await this.toBufferArg(seedDesc);
		            case "account":
		                return await this.toBufferAccount(seedDesc);
		            default:
		                throw new Error(`Unexpected seed kind: ${seedDesc.kind}`);
		        }
		    }
		    toBufferConst(seedDesc) {
		        return this.toBufferValue(seedDesc.type, seedDesc.value);
		    }
		    async toBufferArg(seedDesc) {
		        const argValue = this.argValue(seedDesc);
		        return this.toBufferValue(seedDesc.type, argValue);
		    }
		    argValue(seedDesc) {
		        const seedArgName = (0, camelcase_1.default)(seedDesc.path.split(".")[0]);
		        const idlArgPosition = this._idlIx.args.findIndex((argDesc) => argDesc.name === seedArgName);
		        if (idlArgPosition === -1) {
		            throw new Error(`Unable to find argument for seed: ${seedArgName}`);
		        }
		        return this._args[idlArgPosition];
		    }
		    async toBufferAccount(seedDesc) {
		        const accountValue = await this.accountValue(seedDesc);
		        return this.toBufferValue(seedDesc.type, accountValue);
		    }
		    async accountValue(seedDesc) {
		        const pathComponents = seedDesc.path.split(".");
		        const fieldName = pathComponents[0];
		        const fieldPubkey = this._accounts[(0, camelcase_1.default)(fieldName)];
		        // The seed is a pubkey of the account.
		        if (pathComponents.length === 1) {
		            return fieldPubkey;
		        }
		        // The key is account data.
		        //
		        // Fetch and deserialize it.
		        const account = await this._accountStore.fetchAccount(seedDesc.account, fieldPubkey);
		        // Dereference all fields in the path to get the field value
		        // used in the seed.
		        const fieldValue = this.parseAccountValue(account, pathComponents.slice(1));
		        return fieldValue;
		    }
		    parseAccountValue(account, path) {
		        let accountField;
		        while (path.length > 0) {
		            accountField = account[(0, camelcase_1.default)(path[0])];
		            path = path.slice(1);
		        }
		        return accountField;
		    }
		    // Converts the given idl valaue into a Buffer. The values here must be
		    // primitives. E.g. no structs.
		    //
		    // TODO: add more types here as needed.
		    toBufferValue(type, value) {
		        switch (type) {
		            case "u8":
		                return Buffer.from([value]);
		            case "u16":
		                let b = Buffer.alloc(2);
		                b.writeUInt16LE(value);
		                return b;
		            case "u32":
		                let buf = Buffer.alloc(4);
		                buf.writeUInt32LE(value);
		                return buf;
		            case "u64":
		                let bU64 = Buffer.alloc(8);
		                bU64.writeBigUInt64LE(BigInt(value));
		                return bU64;
		            case "string":
		                return Buffer.from(utf8.encode(value));
		            case "publicKey":
		                return value.toBuffer();
		            default:
		                if (type.array) {
		                    return Buffer.from(value);
		                }
		                throw new Error(`Unexpected seed type: ${type}`);
		        }
		    }
		}
		accountsResolver.AccountsResolver = AccountsResolver;
		AccountsResolver.CONST_ACCOUNTS = {
		    associatedTokenProgram: token_js_1.ASSOCIATED_PROGRAM_ID,
		    rent: web3_js_1.SYSVAR_RENT_PUBKEY,
		    systemProgram: web3_js_1.SystemProgram.programId,
		    tokenProgram: token_js_1.TOKEN_PROGRAM_ID,
		};
		// TODO: this should be configureable to avoid unnecessary requests.
		class AccountStore {
		    // todo: don't use the progrma use the account namespace.
		    constructor(_provider, _accounts) {
		        this._provider = _provider;
		        this._accounts = _accounts;
		        this._cache = new Map();
		    }
		    async fetchAccount(name, publicKey) {
		        const address = publicKey.toString();
		        if (!this._cache.has(address)) {
		            if (name === "TokenAccount") {
		                const accountInfo = await this._provider.connection.getAccountInfo(publicKey);
		                if (accountInfo === null) {
		                    throw new Error(`invalid account info for ${address}`);
		                }
		                const data = (0, token_1.coder)().accounts.decode("token", accountInfo.data);
		                this._cache.set(address, data);
		            }
		            else {
		                const account = this._accounts[(0, camelcase_1.default)(name)].fetch(publicKey);
		                this._cache.set(address, account);
		            }
		        }
		        return this._cache.get(address);
		    }
		}
		accountsResolver.AccountStore = AccountStore;
		
		return accountsResolver;
	}

	var hasRequiredMethods;

	function requireMethods () {
		if (hasRequiredMethods) return methods;
		hasRequiredMethods = 1;
		Object.defineProperty(methods, "__esModule", { value: true });
		methods.MethodsBuilder = methods.MethodsBuilderFactory = void 0;
		const accounts_resolver_js_1 = requireAccountsResolver();
		class MethodsBuilderFactory {
		    static build(provider, programId, idlIx, ixFn, txFn, rpcFn, simulateFn, viewFn, accountNamespace) {
		        return (...args) => new MethodsBuilder(args, ixFn, txFn, rpcFn, simulateFn, viewFn, provider, programId, idlIx, accountNamespace);
		    }
		}
		methods.MethodsBuilderFactory = MethodsBuilderFactory;
		class MethodsBuilder {
		    constructor(_args, _ixFn, _txFn, _rpcFn, _simulateFn, _viewFn, _provider, _programId, _idlIx, _accountNamespace) {
		        this._args = _args;
		        this._ixFn = _ixFn;
		        this._txFn = _txFn;
		        this._rpcFn = _rpcFn;
		        this._simulateFn = _simulateFn;
		        this._viewFn = _viewFn;
		        this._accounts = {};
		        this._remainingAccounts = [];
		        this._signers = [];
		        this._preInstructions = [];
		        this._postInstructions = [];
		        this._autoResolveAccounts = true;
		        this._accountsResolver = new accounts_resolver_js_1.AccountsResolver(_args, this._accounts, _provider, _programId, _idlIx, _accountNamespace);
		    }
		    async pubkeys() {
		        if (this._autoResolveAccounts) {
		            await this._accountsResolver.resolve();
		        }
		        return this._accounts;
		    }
		    accounts(accounts) {
		        this._autoResolveAccounts = true;
		        Object.assign(this._accounts, accounts);
		        return this;
		    }
		    accountsStrict(accounts) {
		        this._autoResolveAccounts = false;
		        Object.assign(this._accounts, accounts);
		        return this;
		    }
		    signers(signers) {
		        this._signers = this._signers.concat(signers);
		        return this;
		    }
		    remainingAccounts(accounts) {
		        this._remainingAccounts = this._remainingAccounts.concat(accounts);
		        return this;
		    }
		    preInstructions(ixs) {
		        this._preInstructions = this._preInstructions.concat(ixs);
		        return this;
		    }
		    postInstructions(ixs) {
		        this._postInstructions = this._postInstructions.concat(ixs);
		        return this;
		    }
		    async rpc(options) {
		        if (this._autoResolveAccounts) {
		            await this._accountsResolver.resolve();
		        }
		        // @ts-ignore
		        return this._rpcFn(...this._args, {
		            accounts: this._accounts,
		            signers: this._signers,
		            remainingAccounts: this._remainingAccounts,
		            preInstructions: this._preInstructions,
		            postInstructions: this._postInstructions,
		            options: options,
		        });
		    }
		    async view(options) {
		        if (this._autoResolveAccounts) {
		            await this._accountsResolver.resolve();
		        }
		        if (!this._viewFn) {
		            throw new Error("Method does not support views");
		        }
		        // @ts-ignore
		        return this._viewFn(...this._args, {
		            accounts: this._accounts,
		            signers: this._signers,
		            remainingAccounts: this._remainingAccounts,
		            preInstructions: this._preInstructions,
		            postInstructions: this._postInstructions,
		            options: options,
		        });
		    }
		    async simulate(options) {
		        if (this._autoResolveAccounts) {
		            await this._accountsResolver.resolve();
		        }
		        // @ts-ignore
		        return this._simulateFn(...this._args, {
		            accounts: this._accounts,
		            signers: this._signers,
		            remainingAccounts: this._remainingAccounts,
		            preInstructions: this._preInstructions,
		            postInstructions: this._postInstructions,
		            options: options,
		        });
		    }
		    async instruction() {
		        if (this._autoResolveAccounts) {
		            await this._accountsResolver.resolve();
		        }
		        // @ts-ignore
		        return this._ixFn(...this._args, {
		            accounts: this._accounts,
		            signers: this._signers,
		            remainingAccounts: this._remainingAccounts,
		            preInstructions: this._preInstructions,
		            postInstructions: this._postInstructions,
		        });
		    }
		    async transaction() {
		        if (this._autoResolveAccounts) {
		            await this._accountsResolver.resolve();
		        }
		        // @ts-ignore
		        return this._txFn(...this._args, {
		            accounts: this._accounts,
		            signers: this._signers,
		            remainingAccounts: this._remainingAccounts,
		            preInstructions: this._preInstructions,
		            postInstructions: this._postInstructions,
		        });
		    }
		}
		methods.MethodsBuilder = MethodsBuilder;
		
		return methods;
	}

	var views = {};

	Object.defineProperty(views, "__esModule", { value: true });
	const idl_1 = idl;
	const base64_1 = base64$2;
	class ViewFactory {
	    static build(programId, idlIx, simulateFn, idl) {
	        const isMut = idlIx.accounts.find((a) => a.isMut);
	        const hasReturn = !!idlIx.returns;
	        if (isMut || !hasReturn)
	            return;
	        const view = async (...args) => {
	            var _a, _b;
	            let simulationResult = await simulateFn(...args);
	            const returnPrefix = `Program return: ${programId} `;
	            let returnLog = simulationResult.raw.find((l) => l.startsWith(returnPrefix));
	            if (!returnLog) {
	                throw new Error("View expected return log");
	            }
	            let returnData = (0, base64_1.decode)(returnLog.slice(returnPrefix.length));
	            let returnType = idlIx.returns;
	            if (!returnType) {
	                throw new Error("View expected return type");
	            }
	            const coder = idl_1.IdlCoder.fieldLayout({ type: returnType }, Array.from([...((_a = idl.accounts) !== null && _a !== void 0 ? _a : []), ...((_b = idl.types) !== null && _b !== void 0 ? _b : [])]));
	            return coder.decode(returnData);
	        };
	        return view;
	    }
	}
	views.default = ViewFactory;

	var hasRequiredNamespace;

	function requireNamespace () {
		if (hasRequiredNamespace) return namespace;
		hasRequiredNamespace = 1;
		(function (exports) {
			var __importDefault = (commonjsGlobal && commonjsGlobal.__importDefault) || function (mod) {
			    return (mod && mod.__esModule) ? mod : { "default": mod };
			};
			Object.defineProperty(exports, "__esModule", { value: true });
			exports.MethodsBuilderFactory = exports.AccountClient = exports.StateClient = void 0;
			const camelcase_1 = __importDefault(camelcaseExports);
			const state_js_1 = __importDefault(state);
			const instruction_js_1 = __importDefault(instruction);
			const transaction_js_1 = __importDefault(transaction);
			const rpc_js_1 = __importDefault(rpc);
			const account_js_1 = __importDefault(account);
			const simulate_js_1 = __importDefault(simulate);
			const common_js_1 = common$1;
			const methods_1 = requireMethods();
			const views_1 = __importDefault(views);
			// Re-exports.
			var state_js_2 = state;
			Object.defineProperty(exports, "StateClient", { enumerable: true, get: function () { return state_js_2.StateClient; } });
			var account_js_2 = account;
			Object.defineProperty(exports, "AccountClient", { enumerable: true, get: function () { return account_js_2.AccountClient; } });
			var methods_2 = requireMethods();
			Object.defineProperty(exports, "MethodsBuilderFactory", { enumerable: true, get: function () { return methods_2.MethodsBuilderFactory; } });
			class NamespaceFactory {
			    /**
			     * Generates all namespaces for a given program.
			     */
			    static build(idl, coder, programId, provider) {
			        const rpc = {};
			        const instruction = {};
			        const transaction = {};
			        const simulate = {};
			        const methods = {};
			        const view = {};
			        const idlErrors = (0, common_js_1.parseIdlErrors)(idl);
			        const account = idl.accounts
			            ? account_js_1.default.build(idl, coder, programId, provider)
			            : {};
			        const state = state_js_1.default.build(idl, coder, programId, provider);
			        idl.instructions.forEach((idlIx) => {
			            const ixItem = instruction_js_1.default.build(idlIx, (ixName, ix) => coder.instruction.encode(ixName, ix), programId);
			            const txItem = transaction_js_1.default.build(idlIx, ixItem);
			            const rpcItem = rpc_js_1.default.build(idlIx, txItem, idlErrors, provider);
			            const simulateItem = simulate_js_1.default.build(idlIx, txItem, idlErrors, provider, coder, programId, idl);
			            const viewItem = views_1.default.build(programId, idlIx, simulateItem, idl);
			            const methodItem = methods_1.MethodsBuilderFactory.build(provider, programId, idlIx, ixItem, txItem, rpcItem, simulateItem, viewItem, account);
			            const name = (0, camelcase_1.default)(idlIx.name);
			            instruction[name] = ixItem;
			            transaction[name] = txItem;
			            rpc[name] = rpcItem;
			            simulate[name] = simulateItem;
			            methods[name] = methodItem;
			            if (viewItem) {
			                view[name] = viewItem;
			            }
			        });
			        return [
			            rpc,
			            instruction,
			            transaction,
			            account,
			            simulate,
			            methods,
			            state,
			            view,
			        ];
			    }
			}
			exports.default = NamespaceFactory;
			
	} (namespace));
		return namespace;
	}

	var hasRequiredProgram;

	function requireProgram () {
		if (hasRequiredProgram) return program;
		hasRequiredProgram = 1;
		(function (exports) {
			var __createBinding = (commonjsGlobal && commonjsGlobal.__createBinding) || (Object.create ? (function(o, m, k, k2) {
			    if (k2 === undefined) k2 = k;
			    var desc = Object.getOwnPropertyDescriptor(m, k);
			    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
			      desc = { enumerable: true, get: function() { return m[k]; } };
			    }
			    Object.defineProperty(o, k2, desc);
			}) : (function(o, m, k, k2) {
			    if (k2 === undefined) k2 = k;
			    o[k2] = m[k];
			}));
			var __exportStar = (commonjsGlobal && commonjsGlobal.__exportStar) || function(m, exports) {
			    for (var p in m) if (p !== "default" && !Object.prototype.hasOwnProperty.call(exports, p)) __createBinding(exports, m, p);
			};
			var __importDefault = (commonjsGlobal && commonjsGlobal.__importDefault) || function (mod) {
			    return (mod && mod.__esModule) ? mod : { "default": mod };
			};
			Object.defineProperty(exports, "__esModule", { value: true });
			exports.Program = void 0;
			const pako_1 = pako;
			const provider_js_1 = requireProvider();
			const idl_js_1 = idl$1;
			const index_js_1 = coder;
			const index_js_2 = __importDefault(requireNamespace());
			const index_js_3 = bytes;
			const event_js_1 = event;
			const common_js_1 = common$1;
			__exportStar(common$1, exports);
			__exportStar(context, exports);
			__exportStar(event, exports);
			__exportStar(requireNamespace(), exports);
			/**
			 * ## Program
			 *
			 * Program provides the IDL deserialized client representation of an Anchor
			 * program.
			 *
			 * This API is the one stop shop for all things related to communicating with
			 * on-chain programs. Among other things, one can send transactions, fetch
			 * deserialized accounts, decode instruction data, subscribe to account
			 * changes, and listen to events.
			 *
			 * In addition to field accessors and methods, the object provides a set of
			 * dynamically generated properties, also known as namespaces, that
			 * map one-to-one to program methods and accounts. These namespaces generally
			 *  can be used as follows:
			 *
			 * ## Usage
			 *
			 * ```javascript
			 * program.<namespace>.<program-specific-method>
			 * ```
			 *
			 * API specifics are namespace dependent. The examples used in the documentation
			 * below will refer to the two counter examples found
			 * [here](https://github.com/coral-xyz/anchor#examples).
			 */
			class Program {
			    /**
			     * @param idl       The interface definition.
			     * @param programId The on-chain address of the program.
			     * @param provider  The network and wallet context to use. If not provided
			     *                  then uses [[getProvider]].
			     */
			    constructor(idl, programId, provider, coder) {
			        programId = (0, common_js_1.translateAddress)(programId);
			        if (!provider) {
			            provider = (0, provider_js_1.getProvider)();
			        }
			        // Fields.
			        this._idl = idl;
			        this._provider = provider;
			        this._programId = programId;
			        this._coder = coder !== null && coder !== void 0 ? coder : new index_js_1.BorshCoder(idl);
			        this._events = new event_js_1.EventManager(this._programId, provider, this._coder);
			        // Dynamic namespaces.
			        const [rpc, instruction, transaction, account, simulate, methods, state, views,] = index_js_2.default.build(idl, this._coder, programId, provider);
			        this.rpc = rpc;
			        this.instruction = instruction;
			        this.transaction = transaction;
			        this.account = account;
			        this.simulate = simulate;
			        this.methods = methods;
			        this.state = state;
			        this.views = views;
			    }
			    /**
			     * Address of the program.
			     */
			    get programId() {
			        return this._programId;
			    }
			    /**
			     * IDL defining the program's interface.
			     */
			    get idl() {
			        return this._idl;
			    }
			    /**
			     * Coder for serializing requests.
			     */
			    get coder() {
			        return this._coder;
			    }
			    /**
			     * Wallet and network provider.
			     */
			    get provider() {
			        return this._provider;
			    }
			    /**
			     * Generates a Program client by fetching the IDL from the network.
			     *
			     * In order to use this method, an IDL must have been previously initialized
			     * via the anchor CLI's `anchor idl init` command.
			     *
			     * @param programId The on-chain address of the program.
			     * @param provider  The network and wallet context.
			     */
			    static async at(address, provider) {
			        const programId = (0, common_js_1.translateAddress)(address);
			        const idl = await Program.fetchIdl(programId, provider);
			        if (!idl) {
			            throw new Error(`IDL not found for program: ${address.toString()}`);
			        }
			        return new Program(idl, programId, provider);
			    }
			    /**
			     * Fetches an idl from the blockchain.
			     *
			     * In order to use this method, an IDL must have been previously initialized
			     * via the anchor CLI's `anchor idl init` command.
			     *
			     * @param programId The on-chain address of the program.
			     * @param provider  The network and wallet context.
			     */
			    static async fetchIdl(address, provider) {
			        provider = provider !== null && provider !== void 0 ? provider : (0, provider_js_1.getProvider)();
			        const programId = (0, common_js_1.translateAddress)(address);
			        const idlAddr = await (0, idl_js_1.idlAddress)(programId);
			        const accountInfo = await provider.connection.getAccountInfo(idlAddr);
			        if (!accountInfo) {
			            return null;
			        }
			        // Chop off account discriminator.
			        let idlAccount = (0, idl_js_1.decodeIdlAccount)(accountInfo.data.slice(8));
			        const inflatedIdl = (0, pako_1.inflate)(idlAccount.data);
			        return JSON.parse(index_js_3.utf8.decode(inflatedIdl));
			    }
			    /**
			     * Invokes the given callback every time the given event is emitted.
			     *
			     * @param eventName The PascalCase name of the event, provided by the IDL.
			     * @param callback  The function to invoke whenever the event is emitted from
			     *                  program logs.
			     */
			    addEventListener(eventName, callback) {
			        return this._events.addEventListener(eventName, callback);
			    }
			    /**
			     * Unsubscribes from the given eventName.
			     */
			    async removeEventListener(listener) {
			        return await this._events.removeEventListener(listener);
			    }
			}
			exports.Program = Program;
			
	} (program));
		return program;
	}

	var hasRequiredToken;

	function requireToken () {
		if (hasRequiredToken) return token$1;
		hasRequiredToken = 1;
		(function (exports) {
			Object.defineProperty(exports, "__esModule", { value: true });
			exports.IDL = exports.coder = exports.program = void 0;
			const web3_js_1 = require$$0$1;
			const index_js_1 = requireProgram();
			const index_js_2 = splToken;
			const TOKEN_PROGRAM_ID = new web3_js_1.PublicKey("TokenkegQfeZyiNwAJbNbGKPFXCWuBvf9Ss623VQ5DA");
			function program(provider) {
			    return new index_js_1.Program(exports.IDL, TOKEN_PROGRAM_ID, provider, coder());
			}
			exports.program = program;
			function coder() {
			    return new index_js_2.SplTokenCoder(exports.IDL);
			}
			exports.coder = coder;
			exports.IDL = {
			    version: "0.1.0",
			    name: "spl_token",
			    instructions: [
			        {
			            name: "initializeMint",
			            accounts: [
			                {
			                    name: "mint",
			                    isMut: true,
			                    isSigner: false,
			                },
			                {
			                    name: "rent",
			                    isMut: false,
			                    isSigner: false,
			                },
			            ],
			            args: [
			                {
			                    name: "decimals",
			                    type: "u8",
			                },
			                {
			                    name: "mintAuthority",
			                    type: "publicKey",
			                },
			                {
			                    name: "freezeAuthority",
			                    type: {
			                        coption: "publicKey",
			                    },
			                },
			            ],
			        },
			        {
			            name: "initializeAccount",
			            accounts: [
			                {
			                    name: "account",
			                    isMut: true,
			                    isSigner: false,
			                },
			                {
			                    name: "mint",
			                    isMut: false,
			                    isSigner: false,
			                },
			                {
			                    name: "authority",
			                    isMut: false,
			                    isSigner: false,
			                },
			                {
			                    name: "rent",
			                    isMut: false,
			                    isSigner: false,
			                },
			            ],
			            args: [],
			        },
			        {
			            name: "initializeMultisig",
			            accounts: [
			                {
			                    name: "account",
			                    isMut: true,
			                    isSigner: false,
			                },
			                {
			                    name: "rent",
			                    isMut: false,
			                    isSigner: false,
			                },
			            ],
			            args: [
			                {
			                    name: "m",
			                    type: "u8",
			                },
			            ],
			        },
			        {
			            name: "transfer",
			            accounts: [
			                {
			                    name: "source",
			                    isMut: true,
			                    isSigner: false,
			                },
			                {
			                    name: "destination",
			                    isMut: true,
			                    isSigner: false,
			                },
			                {
			                    name: "authority",
			                    isMut: false,
			                    isSigner: true,
			                },
			            ],
			            args: [
			                {
			                    name: "amount",
			                    type: "u64",
			                },
			            ],
			        },
			        {
			            name: "approve",
			            accounts: [
			                {
			                    name: "source",
			                    isMut: true,
			                    isSigner: false,
			                },
			                {
			                    name: "delegate",
			                    isMut: false,
			                    isSigner: false,
			                },
			                {
			                    name: "authority",
			                    isMut: false,
			                    isSigner: true,
			                },
			            ],
			            args: [
			                {
			                    name: "amount",
			                    type: "u64",
			                },
			            ],
			        },
			        {
			            name: "revoke",
			            accounts: [
			                {
			                    name: "source",
			                    isMut: true,
			                    isSigner: false,
			                },
			                {
			                    name: "authority",
			                    isMut: false,
			                    isSigner: true,
			                },
			            ],
			            args: [],
			        },
			        {
			            name: "setAuthority",
			            accounts: [
			                {
			                    name: "mint",
			                    isMut: true,
			                    isSigner: false,
			                },
			                {
			                    name: "authority",
			                    isMut: false,
			                    isSigner: true,
			                },
			            ],
			            args: [
			                {
			                    name: "authorityType",
			                    type: "u8",
			                },
			                {
			                    name: "newAuthority",
			                    type: {
			                        coption: "publicKey",
			                    },
			                },
			            ],
			        },
			        {
			            name: "mintTo",
			            accounts: [
			                {
			                    name: "mint",
			                    isMut: true,
			                    isSigner: false,
			                },
			                {
			                    name: "to",
			                    isMut: true,
			                    isSigner: false,
			                },
			                {
			                    name: "authority",
			                    isMut: false,
			                    isSigner: true,
			                },
			            ],
			            args: [
			                {
			                    name: "amount",
			                    type: "u64",
			                },
			            ],
			        },
			        {
			            name: "burn",
			            accounts: [
			                {
			                    name: "source",
			                    isMut: true,
			                    isSigner: false,
			                },
			                {
			                    name: "mint",
			                    isMut: true,
			                    isSigner: false,
			                },
			                {
			                    name: "authority",
			                    isMut: false,
			                    isSigner: true,
			                },
			            ],
			            args: [
			                {
			                    name: "amount",
			                    type: "u64",
			                },
			            ],
			        },
			        {
			            name: "closeAccount",
			            accounts: [
			                {
			                    name: "account",
			                    isMut: true,
			                    isSigner: false,
			                },
			                {
			                    name: "destination",
			                    isMut: true,
			                    isSigner: false,
			                },
			                {
			                    name: "authority",
			                    isMut: false,
			                    isSigner: false,
			                },
			            ],
			            args: [],
			        },
			        {
			            name: "freezeAccount",
			            accounts: [
			                {
			                    name: "account",
			                    isMut: true,
			                    isSigner: false,
			                },
			                {
			                    name: "mint",
			                    isMut: false,
			                    isSigner: false,
			                },
			                {
			                    name: "authority",
			                    isMut: false,
			                    isSigner: true,
			                },
			            ],
			            args: [],
			        },
			        {
			            name: "thawAccount",
			            accounts: [
			                {
			                    name: "account",
			                    isMut: true,
			                    isSigner: false,
			                },
			                {
			                    name: "mint",
			                    isMut: false,
			                    isSigner: false,
			                },
			                {
			                    name: "authority",
			                    isMut: false,
			                    isSigner: true,
			                },
			            ],
			            args: [],
			        },
			        {
			            name: "transferChecked",
			            accounts: [
			                {
			                    name: "source",
			                    isMut: true,
			                    isSigner: false,
			                },
			                {
			                    name: "mint",
			                    isMut: false,
			                    isSigner: false,
			                },
			                {
			                    name: "destination",
			                    isMut: true,
			                    isSigner: false,
			                },
			                {
			                    name: "authority",
			                    isMut: false,
			                    isSigner: true,
			                },
			            ],
			            args: [
			                {
			                    name: "amount",
			                    type: "u64",
			                },
			                {
			                    name: "decimals",
			                    type: "u8",
			                },
			            ],
			        },
			        {
			            name: "approveChecked",
			            accounts: [
			                {
			                    name: "source",
			                    isMut: true,
			                    isSigner: false,
			                },
			                {
			                    name: "mint",
			                    isMut: false,
			                    isSigner: false,
			                },
			                {
			                    name: "delegate",
			                    isMut: false,
			                    isSigner: false,
			                },
			                {
			                    name: "authority",
			                    isMut: false,
			                    isSigner: true,
			                },
			            ],
			            args: [
			                {
			                    name: "amount",
			                    type: "u64",
			                },
			                {
			                    name: "decimals",
			                    type: "u8",
			                },
			            ],
			        },
			        {
			            name: "mintToChecked",
			            accounts: [
			                {
			                    name: "mint",
			                    isMut: true,
			                    isSigner: false,
			                },
			                {
			                    name: "to",
			                    isMut: true,
			                    isSigner: false,
			                },
			                {
			                    name: "authority",
			                    isMut: false,
			                    isSigner: true,
			                },
			            ],
			            args: [
			                {
			                    name: "amount",
			                    type: "u64",
			                },
			                {
			                    name: "decimals",
			                    type: "u8",
			                },
			            ],
			        },
			        {
			            name: "burnChecked",
			            accounts: [
			                {
			                    name: "source",
			                    isMut: true,
			                    isSigner: false,
			                },
			                {
			                    name: "mint",
			                    isMut: true,
			                    isSigner: false,
			                },
			                {
			                    name: "authority",
			                    isMut: false,
			                    isSigner: true,
			                },
			            ],
			            args: [
			                {
			                    name: "amount",
			                    type: "u64",
			                },
			                {
			                    name: "decimals",
			                    type: "u8",
			                },
			            ],
			        },
			        {
			            name: "initializeAccount2",
			            accounts: [
			                {
			                    name: "account",
			                    isMut: true,
			                    isSigner: false,
			                },
			                {
			                    name: "mint",
			                    isMut: false,
			                    isSigner: false,
			                },
			                {
			                    name: "rent",
			                    isMut: false,
			                    isSigner: false,
			                },
			            ],
			            args: [
			                {
			                    name: "authority",
			                    type: "publicKey",
			                },
			            ],
			        },
			        {
			            name: "syncNative",
			            accounts: [
			                {
			                    name: "account",
			                    isMut: true,
			                    isSigner: false,
			                },
			            ],
			            args: [],
			        },
			        {
			            name: "initializeAccount3",
			            accounts: [
			                {
			                    name: "account",
			                    isMut: true,
			                    isSigner: false,
			                },
			                {
			                    name: "mint",
			                    isMut: false,
			                    isSigner: false,
			                },
			            ],
			            args: [
			                {
			                    name: "authority",
			                    type: "publicKey",
			                },
			            ],
			        },
			        {
			            name: "initializeMultisig2",
			            accounts: [
			                {
			                    name: "account",
			                    isMut: true,
			                    isSigner: false,
			                },
			            ],
			            args: [
			                {
			                    name: "m",
			                    type: "u8",
			                },
			            ],
			        },
			        {
			            name: "initializeMint2",
			            accounts: [
			                {
			                    name: "mint",
			                    isMut: true,
			                    isSigner: false,
			                },
			            ],
			            args: [
			                {
			                    name: "decimals",
			                    type: "u8",
			                },
			                {
			                    name: "mintAuthority",
			                    type: "publicKey",
			                },
			                {
			                    name: "freezeAuthority",
			                    type: {
			                        coption: "publicKey",
			                    },
			                },
			            ],
			        },
			    ],
			    accounts: [
			        {
			            name: "mint",
			            type: {
			                kind: "struct",
			                fields: [
			                    {
			                        name: "mintAuthority",
			                        type: {
			                            coption: "publicKey",
			                        },
			                    },
			                    {
			                        name: "supply",
			                        type: "u64",
			                    },
			                    {
			                        name: "decimals",
			                        type: "u8",
			                    },
			                    {
			                        name: "isInitialized",
			                        type: "bool",
			                    },
			                    {
			                        name: "freezeAuthority",
			                        type: {
			                            coption: "publicKey",
			                        },
			                    },
			                ],
			            },
			        },
			        {
			            name: "token",
			            type: {
			                kind: "struct",
			                fields: [
			                    {
			                        name: "mint",
			                        type: "publicKey",
			                    },
			                    {
			                        name: "authority",
			                        type: "publicKey",
			                    },
			                    {
			                        name: "amount",
			                        type: "u64",
			                    },
			                    {
			                        name: "delegate",
			                        type: {
			                            coption: "publicKey",
			                        },
			                    },
			                    {
			                        name: "state",
			                        type: "u8",
			                    },
			                    {
			                        name: "isNative",
			                        type: {
			                            coption: "u64",
			                        },
			                    },
			                    {
			                        name: "delegatedAmount",
			                        type: "u64",
			                    },
			                    {
			                        name: "closeAuthority",
			                        type: {
			                            coption: "publicKey",
			                        },
			                    },
			                ],
			            },
			        },
			    ],
			};
			
	} (token$1));
		return token$1;
	}

	var tokenExports = requireToken();

	var lodashExports = {};
	var lodash = {
	  get exports(){ return lodashExports; },
	  set exports(v){ lodashExports = v; },
	};

	/**
	 * @license
	 * Lodash <https://lodash.com/>
	 * Copyright OpenJS Foundation and other contributors <https://openjsf.org/>
	 * Released under MIT license <https://lodash.com/license>
	 * Based on Underscore.js 1.8.3 <http://underscorejs.org/LICENSE>
	 * Copyright Jeremy Ashkenas, DocumentCloud and Investigative Reporters & Editors
	 */

	(function (module, exports) {
	(function() {

		  /** Used as a safe reference for `undefined` in pre-ES5 environments. */
		  var undefined$1;

		  /** Used as the semantic version number. */
		  var VERSION = '4.17.21';

		  /** Used as the size to enable large array optimizations. */
		  var LARGE_ARRAY_SIZE = 200;

		  /** Error message constants. */
		  var CORE_ERROR_TEXT = 'Unsupported core-js use. Try https://npms.io/search?q=ponyfill.',
		      FUNC_ERROR_TEXT = 'Expected a function',
		      INVALID_TEMPL_VAR_ERROR_TEXT = 'Invalid `variable` option passed into `_.template`';

		  /** Used to stand-in for `undefined` hash values. */
		  var HASH_UNDEFINED = '__lodash_hash_undefined__';

		  /** Used as the maximum memoize cache size. */
		  var MAX_MEMOIZE_SIZE = 500;

		  /** Used as the internal argument placeholder. */
		  var PLACEHOLDER = '__lodash_placeholder__';

		  /** Used to compose bitmasks for cloning. */
		  var CLONE_DEEP_FLAG = 1,
		      CLONE_FLAT_FLAG = 2,
		      CLONE_SYMBOLS_FLAG = 4;

		  /** Used to compose bitmasks for value comparisons. */
		  var COMPARE_PARTIAL_FLAG = 1,
		      COMPARE_UNORDERED_FLAG = 2;

		  /** Used to compose bitmasks for function metadata. */
		  var WRAP_BIND_FLAG = 1,
		      WRAP_BIND_KEY_FLAG = 2,
		      WRAP_CURRY_BOUND_FLAG = 4,
		      WRAP_CURRY_FLAG = 8,
		      WRAP_CURRY_RIGHT_FLAG = 16,
		      WRAP_PARTIAL_FLAG = 32,
		      WRAP_PARTIAL_RIGHT_FLAG = 64,
		      WRAP_ARY_FLAG = 128,
		      WRAP_REARG_FLAG = 256,
		      WRAP_FLIP_FLAG = 512;

		  /** Used as default options for `_.truncate`. */
		  var DEFAULT_TRUNC_LENGTH = 30,
		      DEFAULT_TRUNC_OMISSION = '...';

		  /** Used to detect hot functions by number of calls within a span of milliseconds. */
		  var HOT_COUNT = 800,
		      HOT_SPAN = 16;

		  /** Used to indicate the type of lazy iteratees. */
		  var LAZY_FILTER_FLAG = 1,
		      LAZY_MAP_FLAG = 2,
		      LAZY_WHILE_FLAG = 3;

		  /** Used as references for various `Number` constants. */
		  var INFINITY = 1 / 0,
		      MAX_SAFE_INTEGER = 9007199254740991,
		      MAX_INTEGER = 1.7976931348623157e+308,
		      NAN = 0 / 0;

		  /** Used as references for the maximum length and index of an array. */
		  var MAX_ARRAY_LENGTH = 4294967295,
		      MAX_ARRAY_INDEX = MAX_ARRAY_LENGTH - 1,
		      HALF_MAX_ARRAY_LENGTH = MAX_ARRAY_LENGTH >>> 1;

		  /** Used to associate wrap methods with their bit flags. */
		  var wrapFlags = [
		    ['ary', WRAP_ARY_FLAG],
		    ['bind', WRAP_BIND_FLAG],
		    ['bindKey', WRAP_BIND_KEY_FLAG],
		    ['curry', WRAP_CURRY_FLAG],
		    ['curryRight', WRAP_CURRY_RIGHT_FLAG],
		    ['flip', WRAP_FLIP_FLAG],
		    ['partial', WRAP_PARTIAL_FLAG],
		    ['partialRight', WRAP_PARTIAL_RIGHT_FLAG],
		    ['rearg', WRAP_REARG_FLAG]
		  ];

		  /** `Object#toString` result references. */
		  var argsTag = '[object Arguments]',
		      arrayTag = '[object Array]',
		      asyncTag = '[object AsyncFunction]',
		      boolTag = '[object Boolean]',
		      dateTag = '[object Date]',
		      domExcTag = '[object DOMException]',
		      errorTag = '[object Error]',
		      funcTag = '[object Function]',
		      genTag = '[object GeneratorFunction]',
		      mapTag = '[object Map]',
		      numberTag = '[object Number]',
		      nullTag = '[object Null]',
		      objectTag = '[object Object]',
		      promiseTag = '[object Promise]',
		      proxyTag = '[object Proxy]',
		      regexpTag = '[object RegExp]',
		      setTag = '[object Set]',
		      stringTag = '[object String]',
		      symbolTag = '[object Symbol]',
		      undefinedTag = '[object Undefined]',
		      weakMapTag = '[object WeakMap]',
		      weakSetTag = '[object WeakSet]';

		  var arrayBufferTag = '[object ArrayBuffer]',
		      dataViewTag = '[object DataView]',
		      float32Tag = '[object Float32Array]',
		      float64Tag = '[object Float64Array]',
		      int8Tag = '[object Int8Array]',
		      int16Tag = '[object Int16Array]',
		      int32Tag = '[object Int32Array]',
		      uint8Tag = '[object Uint8Array]',
		      uint8ClampedTag = '[object Uint8ClampedArray]',
		      uint16Tag = '[object Uint16Array]',
		      uint32Tag = '[object Uint32Array]';

		  /** Used to match empty string literals in compiled template source. */
		  var reEmptyStringLeading = /\b__p \+= '';/g,
		      reEmptyStringMiddle = /\b(__p \+=) '' \+/g,
		      reEmptyStringTrailing = /(__e\(.*?\)|\b__t\)) \+\n'';/g;

		  /** Used to match HTML entities and HTML characters. */
		  var reEscapedHtml = /&(?:amp|lt|gt|quot|#39);/g,
		      reUnescapedHtml = /[&<>"']/g,
		      reHasEscapedHtml = RegExp(reEscapedHtml.source),
		      reHasUnescapedHtml = RegExp(reUnescapedHtml.source);

		  /** Used to match template delimiters. */
		  var reEscape = /<%-([\s\S]+?)%>/g,
		      reEvaluate = /<%([\s\S]+?)%>/g,
		      reInterpolate = /<%=([\s\S]+?)%>/g;

		  /** Used to match property names within property paths. */
		  var reIsDeepProp = /\.|\[(?:[^[\]]*|(["'])(?:(?!\1)[^\\]|\\.)*?\1)\]/,
		      reIsPlainProp = /^\w*$/,
		      rePropName = /[^.[\]]+|\[(?:(-?\d+(?:\.\d+)?)|(["'])((?:(?!\2)[^\\]|\\.)*?)\2)\]|(?=(?:\.|\[\])(?:\.|\[\]|$))/g;

		  /**
		   * Used to match `RegExp`
		   * [syntax characters](http://ecma-international.org/ecma-262/7.0/#sec-patterns).
		   */
		  var reRegExpChar = /[\\^$.*+?()[\]{}|]/g,
		      reHasRegExpChar = RegExp(reRegExpChar.source);

		  /** Used to match leading whitespace. */
		  var reTrimStart = /^\s+/;

		  /** Used to match a single whitespace character. */
		  var reWhitespace = /\s/;

		  /** Used to match wrap detail comments. */
		  var reWrapComment = /\{(?:\n\/\* \[wrapped with .+\] \*\/)?\n?/,
		      reWrapDetails = /\{\n\/\* \[wrapped with (.+)\] \*/,
		      reSplitDetails = /,? & /;

		  /** Used to match words composed of alphanumeric characters. */
		  var reAsciiWord = /[^\x00-\x2f\x3a-\x40\x5b-\x60\x7b-\x7f]+/g;

		  /**
		   * Used to validate the `validate` option in `_.template` variable.
		   *
		   * Forbids characters which could potentially change the meaning of the function argument definition:
		   * - "()," (modification of function parameters)
		   * - "=" (default value)
		   * - "[]{}" (destructuring of function parameters)
		   * - "/" (beginning of a comment)
		   * - whitespace
		   */
		  var reForbiddenIdentifierChars = /[()=,{}\[\]\/\s]/;

		  /** Used to match backslashes in property paths. */
		  var reEscapeChar = /\\(\\)?/g;

		  /**
		   * Used to match
		   * [ES template delimiters](http://ecma-international.org/ecma-262/7.0/#sec-template-literal-lexical-components).
		   */
		  var reEsTemplate = /\$\{([^\\}]*(?:\\.[^\\}]*)*)\}/g;

		  /** Used to match `RegExp` flags from their coerced string values. */
		  var reFlags = /\w*$/;

		  /** Used to detect bad signed hexadecimal string values. */
		  var reIsBadHex = /^[-+]0x[0-9a-f]+$/i;

		  /** Used to detect binary string values. */
		  var reIsBinary = /^0b[01]+$/i;

		  /** Used to detect host constructors (Safari). */
		  var reIsHostCtor = /^\[object .+?Constructor\]$/;

		  /** Used to detect octal string values. */
		  var reIsOctal = /^0o[0-7]+$/i;

		  /** Used to detect unsigned integer values. */
		  var reIsUint = /^(?:0|[1-9]\d*)$/;

		  /** Used to match Latin Unicode letters (excluding mathematical operators). */
		  var reLatin = /[\xc0-\xd6\xd8-\xf6\xf8-\xff\u0100-\u017f]/g;

		  /** Used to ensure capturing order of template delimiters. */
		  var reNoMatch = /($^)/;

		  /** Used to match unescaped characters in compiled string literals. */
		  var reUnescapedString = /['\n\r\u2028\u2029\\]/g;

		  /** Used to compose unicode character classes. */
		  var rsAstralRange = '\\ud800-\\udfff',
		      rsComboMarksRange = '\\u0300-\\u036f',
		      reComboHalfMarksRange = '\\ufe20-\\ufe2f',
		      rsComboSymbolsRange = '\\u20d0-\\u20ff',
		      rsComboRange = rsComboMarksRange + reComboHalfMarksRange + rsComboSymbolsRange,
		      rsDingbatRange = '\\u2700-\\u27bf',
		      rsLowerRange = 'a-z\\xdf-\\xf6\\xf8-\\xff',
		      rsMathOpRange = '\\xac\\xb1\\xd7\\xf7',
		      rsNonCharRange = '\\x00-\\x2f\\x3a-\\x40\\x5b-\\x60\\x7b-\\xbf',
		      rsPunctuationRange = '\\u2000-\\u206f',
		      rsSpaceRange = ' \\t\\x0b\\f\\xa0\\ufeff\\n\\r\\u2028\\u2029\\u1680\\u180e\\u2000\\u2001\\u2002\\u2003\\u2004\\u2005\\u2006\\u2007\\u2008\\u2009\\u200a\\u202f\\u205f\\u3000',
		      rsUpperRange = 'A-Z\\xc0-\\xd6\\xd8-\\xde',
		      rsVarRange = '\\ufe0e\\ufe0f',
		      rsBreakRange = rsMathOpRange + rsNonCharRange + rsPunctuationRange + rsSpaceRange;

		  /** Used to compose unicode capture groups. */
		  var rsApos = "['\u2019]",
		      rsAstral = '[' + rsAstralRange + ']',
		      rsBreak = '[' + rsBreakRange + ']',
		      rsCombo = '[' + rsComboRange + ']',
		      rsDigits = '\\d+',
		      rsDingbat = '[' + rsDingbatRange + ']',
		      rsLower = '[' + rsLowerRange + ']',
		      rsMisc = '[^' + rsAstralRange + rsBreakRange + rsDigits + rsDingbatRange + rsLowerRange + rsUpperRange + ']',
		      rsFitz = '\\ud83c[\\udffb-\\udfff]',
		      rsModifier = '(?:' + rsCombo + '|' + rsFitz + ')',
		      rsNonAstral = '[^' + rsAstralRange + ']',
		      rsRegional = '(?:\\ud83c[\\udde6-\\uddff]){2}',
		      rsSurrPair = '[\\ud800-\\udbff][\\udc00-\\udfff]',
		      rsUpper = '[' + rsUpperRange + ']',
		      rsZWJ = '\\u200d';

		  /** Used to compose unicode regexes. */
		  var rsMiscLower = '(?:' + rsLower + '|' + rsMisc + ')',
		      rsMiscUpper = '(?:' + rsUpper + '|' + rsMisc + ')',
		      rsOptContrLower = '(?:' + rsApos + '(?:d|ll|m|re|s|t|ve))?',
		      rsOptContrUpper = '(?:' + rsApos + '(?:D|LL|M|RE|S|T|VE))?',
		      reOptMod = rsModifier + '?',
		      rsOptVar = '[' + rsVarRange + ']?',
		      rsOptJoin = '(?:' + rsZWJ + '(?:' + [rsNonAstral, rsRegional, rsSurrPair].join('|') + ')' + rsOptVar + reOptMod + ')*',
		      rsOrdLower = '\\d*(?:1st|2nd|3rd|(?![123])\\dth)(?=\\b|[A-Z_])',
		      rsOrdUpper = '\\d*(?:1ST|2ND|3RD|(?![123])\\dTH)(?=\\b|[a-z_])',
		      rsSeq = rsOptVar + reOptMod + rsOptJoin,
		      rsEmoji = '(?:' + [rsDingbat, rsRegional, rsSurrPair].join('|') + ')' + rsSeq,
		      rsSymbol = '(?:' + [rsNonAstral + rsCombo + '?', rsCombo, rsRegional, rsSurrPair, rsAstral].join('|') + ')';

		  /** Used to match apostrophes. */
		  var reApos = RegExp(rsApos, 'g');

		  /**
		   * Used to match [combining diacritical marks](https://en.wikipedia.org/wiki/Combining_Diacritical_Marks) and
		   * [combining diacritical marks for symbols](https://en.wikipedia.org/wiki/Combining_Diacritical_Marks_for_Symbols).
		   */
		  var reComboMark = RegExp(rsCombo, 'g');

		  /** Used to match [string symbols](https://mathiasbynens.be/notes/javascript-unicode). */
		  var reUnicode = RegExp(rsFitz + '(?=' + rsFitz + ')|' + rsSymbol + rsSeq, 'g');

		  /** Used to match complex or compound words. */
		  var reUnicodeWord = RegExp([
		    rsUpper + '?' + rsLower + '+' + rsOptContrLower + '(?=' + [rsBreak, rsUpper, '$'].join('|') + ')',
		    rsMiscUpper + '+' + rsOptContrUpper + '(?=' + [rsBreak, rsUpper + rsMiscLower, '$'].join('|') + ')',
		    rsUpper + '?' + rsMiscLower + '+' + rsOptContrLower,
		    rsUpper + '+' + rsOptContrUpper,
		    rsOrdUpper,
		    rsOrdLower,
		    rsDigits,
		    rsEmoji
		  ].join('|'), 'g');

		  /** Used to detect strings with [zero-width joiners or code points from the astral planes](http://eev.ee/blog/2015/09/12/dark-corners-of-unicode/). */
		  var reHasUnicode = RegExp('[' + rsZWJ + rsAstralRange  + rsComboRange + rsVarRange + ']');

		  /** Used to detect strings that need a more robust regexp to match words. */
		  var reHasUnicodeWord = /[a-z][A-Z]|[A-Z]{2}[a-z]|[0-9][a-zA-Z]|[a-zA-Z][0-9]|[^a-zA-Z0-9 ]/;

		  /** Used to assign default `context` object properties. */
		  var contextProps = [
		    'Array', 'Buffer', 'DataView', 'Date', 'Error', 'Float32Array', 'Float64Array',
		    'Function', 'Int8Array', 'Int16Array', 'Int32Array', 'Map', 'Math', 'Object',
		    'Promise', 'RegExp', 'Set', 'String', 'Symbol', 'TypeError', 'Uint8Array',
		    'Uint8ClampedArray', 'Uint16Array', 'Uint32Array', 'WeakMap',
		    '_', 'clearTimeout', 'isFinite', 'parseInt', 'setTimeout'
		  ];

		  /** Used to make template sourceURLs easier to identify. */
		  var templateCounter = -1;

		  /** Used to identify `toStringTag` values of typed arrays. */
		  var typedArrayTags = {};
		  typedArrayTags[float32Tag] = typedArrayTags[float64Tag] =
		  typedArrayTags[int8Tag] = typedArrayTags[int16Tag] =
		  typedArrayTags[int32Tag] = typedArrayTags[uint8Tag] =
		  typedArrayTags[uint8ClampedTag] = typedArrayTags[uint16Tag] =
		  typedArrayTags[uint32Tag] = true;
		  typedArrayTags[argsTag] = typedArrayTags[arrayTag] =
		  typedArrayTags[arrayBufferTag] = typedArrayTags[boolTag] =
		  typedArrayTags[dataViewTag] = typedArrayTags[dateTag] =
		  typedArrayTags[errorTag] = typedArrayTags[funcTag] =
		  typedArrayTags[mapTag] = typedArrayTags[numberTag] =
		  typedArrayTags[objectTag] = typedArrayTags[regexpTag] =
		  typedArrayTags[setTag] = typedArrayTags[stringTag] =
		  typedArrayTags[weakMapTag] = false;

		  /** Used to identify `toStringTag` values supported by `_.clone`. */
		  var cloneableTags = {};
		  cloneableTags[argsTag] = cloneableTags[arrayTag] =
		  cloneableTags[arrayBufferTag] = cloneableTags[dataViewTag] =
		  cloneableTags[boolTag] = cloneableTags[dateTag] =
		  cloneableTags[float32Tag] = cloneableTags[float64Tag] =
		  cloneableTags[int8Tag] = cloneableTags[int16Tag] =
		  cloneableTags[int32Tag] = cloneableTags[mapTag] =
		  cloneableTags[numberTag] = cloneableTags[objectTag] =
		  cloneableTags[regexpTag] = cloneableTags[setTag] =
		  cloneableTags[stringTag] = cloneableTags[symbolTag] =
		  cloneableTags[uint8Tag] = cloneableTags[uint8ClampedTag] =
		  cloneableTags[uint16Tag] = cloneableTags[uint32Tag] = true;
		  cloneableTags[errorTag] = cloneableTags[funcTag] =
		  cloneableTags[weakMapTag] = false;

		  /** Used to map Latin Unicode letters to basic Latin letters. */
		  var deburredLetters = {
		    // Latin-1 Supplement block.
		    '\xc0': 'A',  '\xc1': 'A', '\xc2': 'A', '\xc3': 'A', '\xc4': 'A', '\xc5': 'A',
		    '\xe0': 'a',  '\xe1': 'a', '\xe2': 'a', '\xe3': 'a', '\xe4': 'a', '\xe5': 'a',
		    '\xc7': 'C',  '\xe7': 'c',
		    '\xd0': 'D',  '\xf0': 'd',
		    '\xc8': 'E',  '\xc9': 'E', '\xca': 'E', '\xcb': 'E',
		    '\xe8': 'e',  '\xe9': 'e', '\xea': 'e', '\xeb': 'e',
		    '\xcc': 'I',  '\xcd': 'I', '\xce': 'I', '\xcf': 'I',
		    '\xec': 'i',  '\xed': 'i', '\xee': 'i', '\xef': 'i',
		    '\xd1': 'N',  '\xf1': 'n',
		    '\xd2': 'O',  '\xd3': 'O', '\xd4': 'O', '\xd5': 'O', '\xd6': 'O', '\xd8': 'O',
		    '\xf2': 'o',  '\xf3': 'o', '\xf4': 'o', '\xf5': 'o', '\xf6': 'o', '\xf8': 'o',
		    '\xd9': 'U',  '\xda': 'U', '\xdb': 'U', '\xdc': 'U',
		    '\xf9': 'u',  '\xfa': 'u', '\xfb': 'u', '\xfc': 'u',
		    '\xdd': 'Y',  '\xfd': 'y', '\xff': 'y',
		    '\xc6': 'Ae', '\xe6': 'ae',
		    '\xde': 'Th', '\xfe': 'th',
		    '\xdf': 'ss',
		    // Latin Extended-A block.
		    '\u0100': 'A',  '\u0102': 'A', '\u0104': 'A',
		    '\u0101': 'a',  '\u0103': 'a', '\u0105': 'a',
		    '\u0106': 'C',  '\u0108': 'C', '\u010a': 'C', '\u010c': 'C',
		    '\u0107': 'c',  '\u0109': 'c', '\u010b': 'c', '\u010d': 'c',
		    '\u010e': 'D',  '\u0110': 'D', '\u010f': 'd', '\u0111': 'd',
		    '\u0112': 'E',  '\u0114': 'E', '\u0116': 'E', '\u0118': 'E', '\u011a': 'E',
		    '\u0113': 'e',  '\u0115': 'e', '\u0117': 'e', '\u0119': 'e', '\u011b': 'e',
		    '\u011c': 'G',  '\u011e': 'G', '\u0120': 'G', '\u0122': 'G',
		    '\u011d': 'g',  '\u011f': 'g', '\u0121': 'g', '\u0123': 'g',
		    '\u0124': 'H',  '\u0126': 'H', '\u0125': 'h', '\u0127': 'h',
		    '\u0128': 'I',  '\u012a': 'I', '\u012c': 'I', '\u012e': 'I', '\u0130': 'I',
		    '\u0129': 'i',  '\u012b': 'i', '\u012d': 'i', '\u012f': 'i', '\u0131': 'i',
		    '\u0134': 'J',  '\u0135': 'j',
		    '\u0136': 'K',  '\u0137': 'k', '\u0138': 'k',
		    '\u0139': 'L',  '\u013b': 'L', '\u013d': 'L', '\u013f': 'L', '\u0141': 'L',
		    '\u013a': 'l',  '\u013c': 'l', '\u013e': 'l', '\u0140': 'l', '\u0142': 'l',
		    '\u0143': 'N',  '\u0145': 'N', '\u0147': 'N', '\u014a': 'N',
		    '\u0144': 'n',  '\u0146': 'n', '\u0148': 'n', '\u014b': 'n',
		    '\u014c': 'O',  '\u014e': 'O', '\u0150': 'O',
		    '\u014d': 'o',  '\u014f': 'o', '\u0151': 'o',
		    '\u0154': 'R',  '\u0156': 'R', '\u0158': 'R',
		    '\u0155': 'r',  '\u0157': 'r', '\u0159': 'r',
		    '\u015a': 'S',  '\u015c': 'S', '\u015e': 'S', '\u0160': 'S',
		    '\u015b': 's',  '\u015d': 's', '\u015f': 's', '\u0161': 's',
		    '\u0162': 'T',  '\u0164': 'T', '\u0166': 'T',
		    '\u0163': 't',  '\u0165': 't', '\u0167': 't',
		    '\u0168': 'U',  '\u016a': 'U', '\u016c': 'U', '\u016e': 'U', '\u0170': 'U', '\u0172': 'U',
		    '\u0169': 'u',  '\u016b': 'u', '\u016d': 'u', '\u016f': 'u', '\u0171': 'u', '\u0173': 'u',
		    '\u0174': 'W',  '\u0175': 'w',
		    '\u0176': 'Y',  '\u0177': 'y', '\u0178': 'Y',
		    '\u0179': 'Z',  '\u017b': 'Z', '\u017d': 'Z',
		    '\u017a': 'z',  '\u017c': 'z', '\u017e': 'z',
		    '\u0132': 'IJ', '\u0133': 'ij',
		    '\u0152': 'Oe', '\u0153': 'oe',
		    '\u0149': "'n", '\u017f': 's'
		  };

		  /** Used to map characters to HTML entities. */
		  var htmlEscapes = {
		    '&': '&amp;',
		    '<': '&lt;',
		    '>': '&gt;',
		    '"': '&quot;',
		    "'": '&#39;'
		  };

		  /** Used to map HTML entities to characters. */
		  var htmlUnescapes = {
		    '&amp;': '&',
		    '&lt;': '<',
		    '&gt;': '>',
		    '&quot;': '"',
		    '&#39;': "'"
		  };

		  /** Used to escape characters for inclusion in compiled string literals. */
		  var stringEscapes = {
		    '\\': '\\',
		    "'": "'",
		    '\n': 'n',
		    '\r': 'r',
		    '\u2028': 'u2028',
		    '\u2029': 'u2029'
		  };

		  /** Built-in method references without a dependency on `root`. */
		  var freeParseFloat = parseFloat,
		      freeParseInt = parseInt;

		  /** Detect free variable `global` from Node.js. */
		  var freeGlobal = typeof commonjsGlobal == 'object' && commonjsGlobal && commonjsGlobal.Object === Object && commonjsGlobal;

		  /** Detect free variable `self`. */
		  var freeSelf = typeof self == 'object' && self && self.Object === Object && self;

		  /** Used as a reference to the global object. */
		  var root = freeGlobal || freeSelf || Function('return this')();

		  /** Detect free variable `exports`. */
		  var freeExports = exports && !exports.nodeType && exports;

		  /** Detect free variable `module`. */
		  var freeModule = freeExports && 'object' == 'object' && module && !module.nodeType && module;

		  /** Detect the popular CommonJS extension `module.exports`. */
		  var moduleExports = freeModule && freeModule.exports === freeExports;

		  /** Detect free variable `process` from Node.js. */
		  var freeProcess = moduleExports && freeGlobal.process;

		  /** Used to access faster Node.js helpers. */
		  var nodeUtil = (function() {
		    try {
		      // Use `util.types` for Node.js 10+.
		      var types = freeModule && freeModule.require && freeModule.require('util').types;

		      if (types) {
		        return types;
		      }

		      // Legacy `process.binding('util')` for Node.js < 10.
		      return freeProcess && freeProcess.binding && freeProcess.binding('util');
		    } catch (e) {}
		  }());

		  /* Node.js helper references. */
		  var nodeIsArrayBuffer = nodeUtil && nodeUtil.isArrayBuffer,
		      nodeIsDate = nodeUtil && nodeUtil.isDate,
		      nodeIsMap = nodeUtil && nodeUtil.isMap,
		      nodeIsRegExp = nodeUtil && nodeUtil.isRegExp,
		      nodeIsSet = nodeUtil && nodeUtil.isSet,
		      nodeIsTypedArray = nodeUtil && nodeUtil.isTypedArray;

		  /*--------------------------------------------------------------------------*/

		  /**
		   * A faster alternative to `Function#apply`, this function invokes `func`
		   * with the `this` binding of `thisArg` and the arguments of `args`.
		   *
		   * @private
		   * @param {Function} func The function to invoke.
		   * @param {*} thisArg The `this` binding of `func`.
		   * @param {Array} args The arguments to invoke `func` with.
		   * @returns {*} Returns the result of `func`.
		   */
		  function apply(func, thisArg, args) {
		    switch (args.length) {
		      case 0: return func.call(thisArg);
		      case 1: return func.call(thisArg, args[0]);
		      case 2: return func.call(thisArg, args[0], args[1]);
		      case 3: return func.call(thisArg, args[0], args[1], args[2]);
		    }
		    return func.apply(thisArg, args);
		  }

		  /**
		   * A specialized version of `baseAggregator` for arrays.
		   *
		   * @private
		   * @param {Array} [array] The array to iterate over.
		   * @param {Function} setter The function to set `accumulator` values.
		   * @param {Function} iteratee The iteratee to transform keys.
		   * @param {Object} accumulator The initial aggregated object.
		   * @returns {Function} Returns `accumulator`.
		   */
		  function arrayAggregator(array, setter, iteratee, accumulator) {
		    var index = -1,
		        length = array == null ? 0 : array.length;

		    while (++index < length) {
		      var value = array[index];
		      setter(accumulator, value, iteratee(value), array);
		    }
		    return accumulator;
		  }

		  /**
		   * A specialized version of `_.forEach` for arrays without support for
		   * iteratee shorthands.
		   *
		   * @private
		   * @param {Array} [array] The array to iterate over.
		   * @param {Function} iteratee The function invoked per iteration.
		   * @returns {Array} Returns `array`.
		   */
		  function arrayEach(array, iteratee) {
		    var index = -1,
		        length = array == null ? 0 : array.length;

		    while (++index < length) {
		      if (iteratee(array[index], index, array) === false) {
		        break;
		      }
		    }
		    return array;
		  }

		  /**
		   * A specialized version of `_.forEachRight` for arrays without support for
		   * iteratee shorthands.
		   *
		   * @private
		   * @param {Array} [array] The array to iterate over.
		   * @param {Function} iteratee The function invoked per iteration.
		   * @returns {Array} Returns `array`.
		   */
		  function arrayEachRight(array, iteratee) {
		    var length = array == null ? 0 : array.length;

		    while (length--) {
		      if (iteratee(array[length], length, array) === false) {
		        break;
		      }
		    }
		    return array;
		  }

		  /**
		   * A specialized version of `_.every` for arrays without support for
		   * iteratee shorthands.
		   *
		   * @private
		   * @param {Array} [array] The array to iterate over.
		   * @param {Function} predicate The function invoked per iteration.
		   * @returns {boolean} Returns `true` if all elements pass the predicate check,
		   *  else `false`.
		   */
		  function arrayEvery(array, predicate) {
		    var index = -1,
		        length = array == null ? 0 : array.length;

		    while (++index < length) {
		      if (!predicate(array[index], index, array)) {
		        return false;
		      }
		    }
		    return true;
		  }

		  /**
		   * A specialized version of `_.filter` for arrays without support for
		   * iteratee shorthands.
		   *
		   * @private
		   * @param {Array} [array] The array to iterate over.
		   * @param {Function} predicate The function invoked per iteration.
		   * @returns {Array} Returns the new filtered array.
		   */
		  function arrayFilter(array, predicate) {
		    var index = -1,
		        length = array == null ? 0 : array.length,
		        resIndex = 0,
		        result = [];

		    while (++index < length) {
		      var value = array[index];
		      if (predicate(value, index, array)) {
		        result[resIndex++] = value;
		      }
		    }
		    return result;
		  }

		  /**
		   * A specialized version of `_.includes` for arrays without support for
		   * specifying an index to search from.
		   *
		   * @private
		   * @param {Array} [array] The array to inspect.
		   * @param {*} target The value to search for.
		   * @returns {boolean} Returns `true` if `target` is found, else `false`.
		   */
		  function arrayIncludes(array, value) {
		    var length = array == null ? 0 : array.length;
		    return !!length && baseIndexOf(array, value, 0) > -1;
		  }

		  /**
		   * This function is like `arrayIncludes` except that it accepts a comparator.
		   *
		   * @private
		   * @param {Array} [array] The array to inspect.
		   * @param {*} target The value to search for.
		   * @param {Function} comparator The comparator invoked per element.
		   * @returns {boolean} Returns `true` if `target` is found, else `false`.
		   */
		  function arrayIncludesWith(array, value, comparator) {
		    var index = -1,
		        length = array == null ? 0 : array.length;

		    while (++index < length) {
		      if (comparator(value, array[index])) {
		        return true;
		      }
		    }
		    return false;
		  }

		  /**
		   * A specialized version of `_.map` for arrays without support for iteratee
		   * shorthands.
		   *
		   * @private
		   * @param {Array} [array] The array to iterate over.
		   * @param {Function} iteratee The function invoked per iteration.
		   * @returns {Array} Returns the new mapped array.
		   */
		  function arrayMap(array, iteratee) {
		    var index = -1,
		        length = array == null ? 0 : array.length,
		        result = Array(length);

		    while (++index < length) {
		      result[index] = iteratee(array[index], index, array);
		    }
		    return result;
		  }

		  /**
		   * Appends the elements of `values` to `array`.
		   *
		   * @private
		   * @param {Array} array The array to modify.
		   * @param {Array} values The values to append.
		   * @returns {Array} Returns `array`.
		   */
		  function arrayPush(array, values) {
		    var index = -1,
		        length = values.length,
		        offset = array.length;

		    while (++index < length) {
		      array[offset + index] = values[index];
		    }
		    return array;
		  }

		  /**
		   * A specialized version of `_.reduce` for arrays without support for
		   * iteratee shorthands.
		   *
		   * @private
		   * @param {Array} [array] The array to iterate over.
		   * @param {Function} iteratee The function invoked per iteration.
		   * @param {*} [accumulator] The initial value.
		   * @param {boolean} [initAccum] Specify using the first element of `array` as
		   *  the initial value.
		   * @returns {*} Returns the accumulated value.
		   */
		  function arrayReduce(array, iteratee, accumulator, initAccum) {
		    var index = -1,
		        length = array == null ? 0 : array.length;

		    if (initAccum && length) {
		      accumulator = array[++index];
		    }
		    while (++index < length) {
		      accumulator = iteratee(accumulator, array[index], index, array);
		    }
		    return accumulator;
		  }

		  /**
		   * A specialized version of `_.reduceRight` for arrays without support for
		   * iteratee shorthands.
		   *
		   * @private
		   * @param {Array} [array] The array to iterate over.
		   * @param {Function} iteratee The function invoked per iteration.
		   * @param {*} [accumulator] The initial value.
		   * @param {boolean} [initAccum] Specify using the last element of `array` as
		   *  the initial value.
		   * @returns {*} Returns the accumulated value.
		   */
		  function arrayReduceRight(array, iteratee, accumulator, initAccum) {
		    var length = array == null ? 0 : array.length;
		    if (initAccum && length) {
		      accumulator = array[--length];
		    }
		    while (length--) {
		      accumulator = iteratee(accumulator, array[length], length, array);
		    }
		    return accumulator;
		  }

		  /**
		   * A specialized version of `_.some` for arrays without support for iteratee
		   * shorthands.
		   *
		   * @private
		   * @param {Array} [array] The array to iterate over.
		   * @param {Function} predicate The function invoked per iteration.
		   * @returns {boolean} Returns `true` if any element passes the predicate check,
		   *  else `false`.
		   */
		  function arraySome(array, predicate) {
		    var index = -1,
		        length = array == null ? 0 : array.length;

		    while (++index < length) {
		      if (predicate(array[index], index, array)) {
		        return true;
		      }
		    }
		    return false;
		  }

		  /**
		   * Gets the size of an ASCII `string`.
		   *
		   * @private
		   * @param {string} string The string inspect.
		   * @returns {number} Returns the string size.
		   */
		  var asciiSize = baseProperty('length');

		  /**
		   * Converts an ASCII `string` to an array.
		   *
		   * @private
		   * @param {string} string The string to convert.
		   * @returns {Array} Returns the converted array.
		   */
		  function asciiToArray(string) {
		    return string.split('');
		  }

		  /**
		   * Splits an ASCII `string` into an array of its words.
		   *
		   * @private
		   * @param {string} The string to inspect.
		   * @returns {Array} Returns the words of `string`.
		   */
		  function asciiWords(string) {
		    return string.match(reAsciiWord) || [];
		  }

		  /**
		   * The base implementation of methods like `_.findKey` and `_.findLastKey`,
		   * without support for iteratee shorthands, which iterates over `collection`
		   * using `eachFunc`.
		   *
		   * @private
		   * @param {Array|Object} collection The collection to inspect.
		   * @param {Function} predicate The function invoked per iteration.
		   * @param {Function} eachFunc The function to iterate over `collection`.
		   * @returns {*} Returns the found element or its key, else `undefined`.
		   */
		  function baseFindKey(collection, predicate, eachFunc) {
		    var result;
		    eachFunc(collection, function(value, key, collection) {
		      if (predicate(value, key, collection)) {
		        result = key;
		        return false;
		      }
		    });
		    return result;
		  }

		  /**
		   * The base implementation of `_.findIndex` and `_.findLastIndex` without
		   * support for iteratee shorthands.
		   *
		   * @private
		   * @param {Array} array The array to inspect.
		   * @param {Function} predicate The function invoked per iteration.
		   * @param {number} fromIndex The index to search from.
		   * @param {boolean} [fromRight] Specify iterating from right to left.
		   * @returns {number} Returns the index of the matched value, else `-1`.
		   */
		  function baseFindIndex(array, predicate, fromIndex, fromRight) {
		    var length = array.length,
		        index = fromIndex + (fromRight ? 1 : -1);

		    while ((fromRight ? index-- : ++index < length)) {
		      if (predicate(array[index], index, array)) {
		        return index;
		      }
		    }
		    return -1;
		  }

		  /**
		   * The base implementation of `_.indexOf` without `fromIndex` bounds checks.
		   *
		   * @private
		   * @param {Array} array The array to inspect.
		   * @param {*} value The value to search for.
		   * @param {number} fromIndex The index to search from.
		   * @returns {number} Returns the index of the matched value, else `-1`.
		   */
		  function baseIndexOf(array, value, fromIndex) {
		    return value === value
		      ? strictIndexOf(array, value, fromIndex)
		      : baseFindIndex(array, baseIsNaN, fromIndex);
		  }

		  /**
		   * This function is like `baseIndexOf` except that it accepts a comparator.
		   *
		   * @private
		   * @param {Array} array The array to inspect.
		   * @param {*} value The value to search for.
		   * @param {number} fromIndex The index to search from.
		   * @param {Function} comparator The comparator invoked per element.
		   * @returns {number} Returns the index of the matched value, else `-1`.
		   */
		  function baseIndexOfWith(array, value, fromIndex, comparator) {
		    var index = fromIndex - 1,
		        length = array.length;

		    while (++index < length) {
		      if (comparator(array[index], value)) {
		        return index;
		      }
		    }
		    return -1;
		  }

		  /**
		   * The base implementation of `_.isNaN` without support for number objects.
		   *
		   * @private
		   * @param {*} value The value to check.
		   * @returns {boolean} Returns `true` if `value` is `NaN`, else `false`.
		   */
		  function baseIsNaN(value) {
		    return value !== value;
		  }

		  /**
		   * The base implementation of `_.mean` and `_.meanBy` without support for
		   * iteratee shorthands.
		   *
		   * @private
		   * @param {Array} array The array to iterate over.
		   * @param {Function} iteratee The function invoked per iteration.
		   * @returns {number} Returns the mean.
		   */
		  function baseMean(array, iteratee) {
		    var length = array == null ? 0 : array.length;
		    return length ? (baseSum(array, iteratee) / length) : NAN;
		  }

		  /**
		   * The base implementation of `_.property` without support for deep paths.
		   *
		   * @private
		   * @param {string} key The key of the property to get.
		   * @returns {Function} Returns the new accessor function.
		   */
		  function baseProperty(key) {
		    return function(object) {
		      return object == null ? undefined$1 : object[key];
		    };
		  }

		  /**
		   * The base implementation of `_.propertyOf` without support for deep paths.
		   *
		   * @private
		   * @param {Object} object The object to query.
		   * @returns {Function} Returns the new accessor function.
		   */
		  function basePropertyOf(object) {
		    return function(key) {
		      return object == null ? undefined$1 : object[key];
		    };
		  }

		  /**
		   * The base implementation of `_.reduce` and `_.reduceRight`, without support
		   * for iteratee shorthands, which iterates over `collection` using `eachFunc`.
		   *
		   * @private
		   * @param {Array|Object} collection The collection to iterate over.
		   * @param {Function} iteratee The function invoked per iteration.
		   * @param {*} accumulator The initial value.
		   * @param {boolean} initAccum Specify using the first or last element of
		   *  `collection` as the initial value.
		   * @param {Function} eachFunc The function to iterate over `collection`.
		   * @returns {*} Returns the accumulated value.
		   */
		  function baseReduce(collection, iteratee, accumulator, initAccum, eachFunc) {
		    eachFunc(collection, function(value, index, collection) {
		      accumulator = initAccum
		        ? (initAccum = false, value)
		        : iteratee(accumulator, value, index, collection);
		    });
		    return accumulator;
		  }

		  /**
		   * The base implementation of `_.sortBy` which uses `comparer` to define the
		   * sort order of `array` and replaces criteria objects with their corresponding
		   * values.
		   *
		   * @private
		   * @param {Array} array The array to sort.
		   * @param {Function} comparer The function to define sort order.
		   * @returns {Array} Returns `array`.
		   */
		  function baseSortBy(array, comparer) {
		    var length = array.length;

		    array.sort(comparer);
		    while (length--) {
		      array[length] = array[length].value;
		    }
		    return array;
		  }

		  /**
		   * The base implementation of `_.sum` and `_.sumBy` without support for
		   * iteratee shorthands.
		   *
		   * @private
		   * @param {Array} array The array to iterate over.
		   * @param {Function} iteratee The function invoked per iteration.
		   * @returns {number} Returns the sum.
		   */
		  function baseSum(array, iteratee) {
		    var result,
		        index = -1,
		        length = array.length;

		    while (++index < length) {
		      var current = iteratee(array[index]);
		      if (current !== undefined$1) {
		        result = result === undefined$1 ? current : (result + current);
		      }
		    }
		    return result;
		  }

		  /**
		   * The base implementation of `_.times` without support for iteratee shorthands
		   * or max array length checks.
		   *
		   * @private
		   * @param {number} n The number of times to invoke `iteratee`.
		   * @param {Function} iteratee The function invoked per iteration.
		   * @returns {Array} Returns the array of results.
		   */
		  function baseTimes(n, iteratee) {
		    var index = -1,
		        result = Array(n);

		    while (++index < n) {
		      result[index] = iteratee(index);
		    }
		    return result;
		  }

		  /**
		   * The base implementation of `_.toPairs` and `_.toPairsIn` which creates an array
		   * of key-value pairs for `object` corresponding to the property names of `props`.
		   *
		   * @private
		   * @param {Object} object The object to query.
		   * @param {Array} props The property names to get values for.
		   * @returns {Object} Returns the key-value pairs.
		   */
		  function baseToPairs(object, props) {
		    return arrayMap(props, function(key) {
		      return [key, object[key]];
		    });
		  }

		  /**
		   * The base implementation of `_.trim`.
		   *
		   * @private
		   * @param {string} string The string to trim.
		   * @returns {string} Returns the trimmed string.
		   */
		  function baseTrim(string) {
		    return string
		      ? string.slice(0, trimmedEndIndex(string) + 1).replace(reTrimStart, '')
		      : string;
		  }

		  /**
		   * The base implementation of `_.unary` without support for storing metadata.
		   *
		   * @private
		   * @param {Function} func The function to cap arguments for.
		   * @returns {Function} Returns the new capped function.
		   */
		  function baseUnary(func) {
		    return function(value) {
		      return func(value);
		    };
		  }

		  /**
		   * The base implementation of `_.values` and `_.valuesIn` which creates an
		   * array of `object` property values corresponding to the property names
		   * of `props`.
		   *
		   * @private
		   * @param {Object} object The object to query.
		   * @param {Array} props The property names to get values for.
		   * @returns {Object} Returns the array of property values.
		   */
		  function baseValues(object, props) {
		    return arrayMap(props, function(key) {
		      return object[key];
		    });
		  }

		  /**
		   * Checks if a `cache` value for `key` exists.
		   *
		   * @private
		   * @param {Object} cache The cache to query.
		   * @param {string} key The key of the entry to check.
		   * @returns {boolean} Returns `true` if an entry for `key` exists, else `false`.
		   */
		  function cacheHas(cache, key) {
		    return cache.has(key);
		  }

		  /**
		   * Used by `_.trim` and `_.trimStart` to get the index of the first string symbol
		   * that is not found in the character symbols.
		   *
		   * @private
		   * @param {Array} strSymbols The string symbols to inspect.
		   * @param {Array} chrSymbols The character symbols to find.
		   * @returns {number} Returns the index of the first unmatched string symbol.
		   */
		  function charsStartIndex(strSymbols, chrSymbols) {
		    var index = -1,
		        length = strSymbols.length;

		    while (++index < length && baseIndexOf(chrSymbols, strSymbols[index], 0) > -1) {}
		    return index;
		  }

		  /**
		   * Used by `_.trim` and `_.trimEnd` to get the index of the last string symbol
		   * that is not found in the character symbols.
		   *
		   * @private
		   * @param {Array} strSymbols The string symbols to inspect.
		   * @param {Array} chrSymbols The character symbols to find.
		   * @returns {number} Returns the index of the last unmatched string symbol.
		   */
		  function charsEndIndex(strSymbols, chrSymbols) {
		    var index = strSymbols.length;

		    while (index-- && baseIndexOf(chrSymbols, strSymbols[index], 0) > -1) {}
		    return index;
		  }

		  /**
		   * Gets the number of `placeholder` occurrences in `array`.
		   *
		   * @private
		   * @param {Array} array The array to inspect.
		   * @param {*} placeholder The placeholder to search for.
		   * @returns {number} Returns the placeholder count.
		   */
		  function countHolders(array, placeholder) {
		    var length = array.length,
		        result = 0;

		    while (length--) {
		      if (array[length] === placeholder) {
		        ++result;
		      }
		    }
		    return result;
		  }

		  /**
		   * Used by `_.deburr` to convert Latin-1 Supplement and Latin Extended-A
		   * letters to basic Latin letters.
		   *
		   * @private
		   * @param {string} letter The matched letter to deburr.
		   * @returns {string} Returns the deburred letter.
		   */
		  var deburrLetter = basePropertyOf(deburredLetters);

		  /**
		   * Used by `_.escape` to convert characters to HTML entities.
		   *
		   * @private
		   * @param {string} chr The matched character to escape.
		   * @returns {string} Returns the escaped character.
		   */
		  var escapeHtmlChar = basePropertyOf(htmlEscapes);

		  /**
		   * Used by `_.template` to escape characters for inclusion in compiled string literals.
		   *
		   * @private
		   * @param {string} chr The matched character to escape.
		   * @returns {string} Returns the escaped character.
		   */
		  function escapeStringChar(chr) {
		    return '\\' + stringEscapes[chr];
		  }

		  /**
		   * Gets the value at `key` of `object`.
		   *
		   * @private
		   * @param {Object} [object] The object to query.
		   * @param {string} key The key of the property to get.
		   * @returns {*} Returns the property value.
		   */
		  function getValue(object, key) {
		    return object == null ? undefined$1 : object[key];
		  }

		  /**
		   * Checks if `string` contains Unicode symbols.
		   *
		   * @private
		   * @param {string} string The string to inspect.
		   * @returns {boolean} Returns `true` if a symbol is found, else `false`.
		   */
		  function hasUnicode(string) {
		    return reHasUnicode.test(string);
		  }

		  /**
		   * Checks if `string` contains a word composed of Unicode symbols.
		   *
		   * @private
		   * @param {string} string The string to inspect.
		   * @returns {boolean} Returns `true` if a word is found, else `false`.
		   */
		  function hasUnicodeWord(string) {
		    return reHasUnicodeWord.test(string);
		  }

		  /**
		   * Converts `iterator` to an array.
		   *
		   * @private
		   * @param {Object} iterator The iterator to convert.
		   * @returns {Array} Returns the converted array.
		   */
		  function iteratorToArray(iterator) {
		    var data,
		        result = [];

		    while (!(data = iterator.next()).done) {
		      result.push(data.value);
		    }
		    return result;
		  }

		  /**
		   * Converts `map` to its key-value pairs.
		   *
		   * @private
		   * @param {Object} map The map to convert.
		   * @returns {Array} Returns the key-value pairs.
		   */
		  function mapToArray(map) {
		    var index = -1,
		        result = Array(map.size);

		    map.forEach(function(value, key) {
		      result[++index] = [key, value];
		    });
		    return result;
		  }

		  /**
		   * Creates a unary function that invokes `func` with its argument transformed.
		   *
		   * @private
		   * @param {Function} func The function to wrap.
		   * @param {Function} transform The argument transform.
		   * @returns {Function} Returns the new function.
		   */
		  function overArg(func, transform) {
		    return function(arg) {
		      return func(transform(arg));
		    };
		  }

		  /**
		   * Replaces all `placeholder` elements in `array` with an internal placeholder
		   * and returns an array of their indexes.
		   *
		   * @private
		   * @param {Array} array The array to modify.
		   * @param {*} placeholder The placeholder to replace.
		   * @returns {Array} Returns the new array of placeholder indexes.
		   */
		  function replaceHolders(array, placeholder) {
		    var index = -1,
		        length = array.length,
		        resIndex = 0,
		        result = [];

		    while (++index < length) {
		      var value = array[index];
		      if (value === placeholder || value === PLACEHOLDER) {
		        array[index] = PLACEHOLDER;
		        result[resIndex++] = index;
		      }
		    }
		    return result;
		  }

		  /**
		   * Converts `set` to an array of its values.
		   *
		   * @private
		   * @param {Object} set The set to convert.
		   * @returns {Array} Returns the values.
		   */
		  function setToArray(set) {
		    var index = -1,
		        result = Array(set.size);

		    set.forEach(function(value) {
		      result[++index] = value;
		    });
		    return result;
		  }

		  /**
		   * Converts `set` to its value-value pairs.
		   *
		   * @private
		   * @param {Object} set The set to convert.
		   * @returns {Array} Returns the value-value pairs.
		   */
		  function setToPairs(set) {
		    var index = -1,
		        result = Array(set.size);

		    set.forEach(function(value) {
		      result[++index] = [value, value];
		    });
		    return result;
		  }

		  /**
		   * A specialized version of `_.indexOf` which performs strict equality
		   * comparisons of values, i.e. `===`.
		   *
		   * @private
		   * @param {Array} array The array to inspect.
		   * @param {*} value The value to search for.
		   * @param {number} fromIndex The index to search from.
		   * @returns {number} Returns the index of the matched value, else `-1`.
		   */
		  function strictIndexOf(array, value, fromIndex) {
		    var index = fromIndex - 1,
		        length = array.length;

		    while (++index < length) {
		      if (array[index] === value) {
		        return index;
		      }
		    }
		    return -1;
		  }

		  /**
		   * A specialized version of `_.lastIndexOf` which performs strict equality
		   * comparisons of values, i.e. `===`.
		   *
		   * @private
		   * @param {Array} array The array to inspect.
		   * @param {*} value The value to search for.
		   * @param {number} fromIndex The index to search from.
		   * @returns {number} Returns the index of the matched value, else `-1`.
		   */
		  function strictLastIndexOf(array, value, fromIndex) {
		    var index = fromIndex + 1;
		    while (index--) {
		      if (array[index] === value) {
		        return index;
		      }
		    }
		    return index;
		  }

		  /**
		   * Gets the number of symbols in `string`.
		   *
		   * @private
		   * @param {string} string The string to inspect.
		   * @returns {number} Returns the string size.
		   */
		  function stringSize(string) {
		    return hasUnicode(string)
		      ? unicodeSize(string)
		      : asciiSize(string);
		  }

		  /**
		   * Converts `string` to an array.
		   *
		   * @private
		   * @param {string} string The string to convert.
		   * @returns {Array} Returns the converted array.
		   */
		  function stringToArray(string) {
		    return hasUnicode(string)
		      ? unicodeToArray(string)
		      : asciiToArray(string);
		  }

		  /**
		   * Used by `_.trim` and `_.trimEnd` to get the index of the last non-whitespace
		   * character of `string`.
		   *
		   * @private
		   * @param {string} string The string to inspect.
		   * @returns {number} Returns the index of the last non-whitespace character.
		   */
		  function trimmedEndIndex(string) {
		    var index = string.length;

		    while (index-- && reWhitespace.test(string.charAt(index))) {}
		    return index;
		  }

		  /**
		   * Used by `_.unescape` to convert HTML entities to characters.
		   *
		   * @private
		   * @param {string} chr The matched character to unescape.
		   * @returns {string} Returns the unescaped character.
		   */
		  var unescapeHtmlChar = basePropertyOf(htmlUnescapes);

		  /**
		   * Gets the size of a Unicode `string`.
		   *
		   * @private
		   * @param {string} string The string inspect.
		   * @returns {number} Returns the string size.
		   */
		  function unicodeSize(string) {
		    var result = reUnicode.lastIndex = 0;
		    while (reUnicode.test(string)) {
		      ++result;
		    }
		    return result;
		  }

		  /**
		   * Converts a Unicode `string` to an array.
		   *
		   * @private
		   * @param {string} string The string to convert.
		   * @returns {Array} Returns the converted array.
		   */
		  function unicodeToArray(string) {
		    return string.match(reUnicode) || [];
		  }

		  /**
		   * Splits a Unicode `string` into an array of its words.
		   *
		   * @private
		   * @param {string} The string to inspect.
		   * @returns {Array} Returns the words of `string`.
		   */
		  function unicodeWords(string) {
		    return string.match(reUnicodeWord) || [];
		  }

		  /*--------------------------------------------------------------------------*/

		  /**
		   * Create a new pristine `lodash` function using the `context` object.
		   *
		   * @static
		   * @memberOf _
		   * @since 1.1.0
		   * @category Util
		   * @param {Object} [context=root] The context object.
		   * @returns {Function} Returns a new `lodash` function.
		   * @example
		   *
		   * _.mixin({ 'foo': _.constant('foo') });
		   *
		   * var lodash = _.runInContext();
		   * lodash.mixin({ 'bar': lodash.constant('bar') });
		   *
		   * _.isFunction(_.foo);
		   * // => true
		   * _.isFunction(_.bar);
		   * // => false
		   *
		   * lodash.isFunction(lodash.foo);
		   * // => false
		   * lodash.isFunction(lodash.bar);
		   * // => true
		   *
		   * // Create a suped-up `defer` in Node.js.
		   * var defer = _.runInContext({ 'setTimeout': setImmediate }).defer;
		   */
		  var runInContext = (function runInContext(context) {
		    context = context == null ? root : _.defaults(root.Object(), context, _.pick(root, contextProps));

		    /** Built-in constructor references. */
		    var Array = context.Array,
		        Date = context.Date,
		        Error = context.Error,
		        Function = context.Function,
		        Math = context.Math,
		        Object = context.Object,
		        RegExp = context.RegExp,
		        String = context.String,
		        TypeError = context.TypeError;

		    /** Used for built-in method references. */
		    var arrayProto = Array.prototype,
		        funcProto = Function.prototype,
		        objectProto = Object.prototype;

		    /** Used to detect overreaching core-js shims. */
		    var coreJsData = context['__core-js_shared__'];

		    /** Used to resolve the decompiled source of functions. */
		    var funcToString = funcProto.toString;

		    /** Used to check objects for own properties. */
		    var hasOwnProperty = objectProto.hasOwnProperty;

		    /** Used to generate unique IDs. */
		    var idCounter = 0;

		    /** Used to detect methods masquerading as native. */
		    var maskSrcKey = (function() {
		      var uid = /[^.]+$/.exec(coreJsData && coreJsData.keys && coreJsData.keys.IE_PROTO || '');
		      return uid ? ('Symbol(src)_1.' + uid) : '';
		    }());

		    /**
		     * Used to resolve the
		     * [`toStringTag`](http://ecma-international.org/ecma-262/7.0/#sec-object.prototype.tostring)
		     * of values.
		     */
		    var nativeObjectToString = objectProto.toString;

		    /** Used to infer the `Object` constructor. */
		    var objectCtorString = funcToString.call(Object);

		    /** Used to restore the original `_` reference in `_.noConflict`. */
		    var oldDash = root._;

		    /** Used to detect if a method is native. */
		    var reIsNative = RegExp('^' +
		      funcToString.call(hasOwnProperty).replace(reRegExpChar, '\\$&')
		      .replace(/hasOwnProperty|(function).*?(?=\\\()| for .+?(?=\\\])/g, '$1.*?') + '$'
		    );

		    /** Built-in value references. */
		    var Buffer = moduleExports ? context.Buffer : undefined$1,
		        Symbol = context.Symbol,
		        Uint8Array = context.Uint8Array,
		        allocUnsafe = Buffer ? Buffer.allocUnsafe : undefined$1,
		        getPrototype = overArg(Object.getPrototypeOf, Object),
		        objectCreate = Object.create,
		        propertyIsEnumerable = objectProto.propertyIsEnumerable,
		        splice = arrayProto.splice,
		        spreadableSymbol = Symbol ? Symbol.isConcatSpreadable : undefined$1,
		        symIterator = Symbol ? Symbol.iterator : undefined$1,
		        symToStringTag = Symbol ? Symbol.toStringTag : undefined$1;

		    var defineProperty = (function() {
		      try {
		        var func = getNative(Object, 'defineProperty');
		        func({}, '', {});
		        return func;
		      } catch (e) {}
		    }());

		    /** Mocked built-ins. */
		    var ctxClearTimeout = context.clearTimeout !== root.clearTimeout && context.clearTimeout,
		        ctxNow = Date && Date.now !== root.Date.now && Date.now,
		        ctxSetTimeout = context.setTimeout !== root.setTimeout && context.setTimeout;

		    /* Built-in method references for those with the same name as other `lodash` methods. */
		    var nativeCeil = Math.ceil,
		        nativeFloor = Math.floor,
		        nativeGetSymbols = Object.getOwnPropertySymbols,
		        nativeIsBuffer = Buffer ? Buffer.isBuffer : undefined$1,
		        nativeIsFinite = context.isFinite,
		        nativeJoin = arrayProto.join,
		        nativeKeys = overArg(Object.keys, Object),
		        nativeMax = Math.max,
		        nativeMin = Math.min,
		        nativeNow = Date.now,
		        nativeParseInt = context.parseInt,
		        nativeRandom = Math.random,
		        nativeReverse = arrayProto.reverse;

		    /* Built-in method references that are verified to be native. */
		    var DataView = getNative(context, 'DataView'),
		        Map = getNative(context, 'Map'),
		        Promise = getNative(context, 'Promise'),
		        Set = getNative(context, 'Set'),
		        WeakMap = getNative(context, 'WeakMap'),
		        nativeCreate = getNative(Object, 'create');

		    /** Used to store function metadata. */
		    var metaMap = WeakMap && new WeakMap;

		    /** Used to lookup unminified function names. */
		    var realNames = {};

		    /** Used to detect maps, sets, and weakmaps. */
		    var dataViewCtorString = toSource(DataView),
		        mapCtorString = toSource(Map),
		        promiseCtorString = toSource(Promise),
		        setCtorString = toSource(Set),
		        weakMapCtorString = toSource(WeakMap);

		    /** Used to convert symbols to primitives and strings. */
		    var symbolProto = Symbol ? Symbol.prototype : undefined$1,
		        symbolValueOf = symbolProto ? symbolProto.valueOf : undefined$1,
		        symbolToString = symbolProto ? symbolProto.toString : undefined$1;

		    /*------------------------------------------------------------------------*/

		    /**
		     * Creates a `lodash` object which wraps `value` to enable implicit method
		     * chain sequences. Methods that operate on and return arrays, collections,
		     * and functions can be chained together. Methods that retrieve a single value
		     * or may return a primitive value will automatically end the chain sequence
		     * and return the unwrapped value. Otherwise, the value must be unwrapped
		     * with `_#value`.
		     *
		     * Explicit chain sequences, which must be unwrapped with `_#value`, may be
		     * enabled using `_.chain`.
		     *
		     * The execution of chained methods is lazy, that is, it's deferred until
		     * `_#value` is implicitly or explicitly called.
		     *
		     * Lazy evaluation allows several methods to support shortcut fusion.
		     * Shortcut fusion is an optimization to merge iteratee calls; this avoids
		     * the creation of intermediate arrays and can greatly reduce the number of
		     * iteratee executions. Sections of a chain sequence qualify for shortcut
		     * fusion if the section is applied to an array and iteratees accept only
		     * one argument. The heuristic for whether a section qualifies for shortcut
		     * fusion is subject to change.
		     *
		     * Chaining is supported in custom builds as long as the `_#value` method is
		     * directly or indirectly included in the build.
		     *
		     * In addition to lodash methods, wrappers have `Array` and `String` methods.
		     *
		     * The wrapper `Array` methods are:
		     * `concat`, `join`, `pop`, `push`, `shift`, `sort`, `splice`, and `unshift`
		     *
		     * The wrapper `String` methods are:
		     * `replace` and `split`
		     *
		     * The wrapper methods that support shortcut fusion are:
		     * `at`, `compact`, `drop`, `dropRight`, `dropWhile`, `filter`, `find`,
		     * `findLast`, `head`, `initial`, `last`, `map`, `reject`, `reverse`, `slice`,
		     * `tail`, `take`, `takeRight`, `takeRightWhile`, `takeWhile`, and `toArray`
		     *
		     * The chainable wrapper methods are:
		     * `after`, `ary`, `assign`, `assignIn`, `assignInWith`, `assignWith`, `at`,
		     * `before`, `bind`, `bindAll`, `bindKey`, `castArray`, `chain`, `chunk`,
		     * `commit`, `compact`, `concat`, `conforms`, `constant`, `countBy`, `create`,
		     * `curry`, `debounce`, `defaults`, `defaultsDeep`, `defer`, `delay`,
		     * `difference`, `differenceBy`, `differenceWith`, `drop`, `dropRight`,
		     * `dropRightWhile`, `dropWhile`, `extend`, `extendWith`, `fill`, `filter`,
		     * `flatMap`, `flatMapDeep`, `flatMapDepth`, `flatten`, `flattenDeep`,
		     * `flattenDepth`, `flip`, `flow`, `flowRight`, `fromPairs`, `functions`,
		     * `functionsIn`, `groupBy`, `initial`, `intersection`, `intersectionBy`,
		     * `intersectionWith`, `invert`, `invertBy`, `invokeMap`, `iteratee`, `keyBy`,
		     * `keys`, `keysIn`, `map`, `mapKeys`, `mapValues`, `matches`, `matchesProperty`,
		     * `memoize`, `merge`, `mergeWith`, `method`, `methodOf`, `mixin`, `negate`,
		     * `nthArg`, `omit`, `omitBy`, `once`, `orderBy`, `over`, `overArgs`,
		     * `overEvery`, `overSome`, `partial`, `partialRight`, `partition`, `pick`,
		     * `pickBy`, `plant`, `property`, `propertyOf`, `pull`, `pullAll`, `pullAllBy`,
		     * `pullAllWith`, `pullAt`, `push`, `range`, `rangeRight`, `rearg`, `reject`,
		     * `remove`, `rest`, `reverse`, `sampleSize`, `set`, `setWith`, `shuffle`,
		     * `slice`, `sort`, `sortBy`, `splice`, `spread`, `tail`, `take`, `takeRight`,
		     * `takeRightWhile`, `takeWhile`, `tap`, `throttle`, `thru`, `toArray`,
		     * `toPairs`, `toPairsIn`, `toPath`, `toPlainObject`, `transform`, `unary`,
		     * `union`, `unionBy`, `unionWith`, `uniq`, `uniqBy`, `uniqWith`, `unset`,
		     * `unshift`, `unzip`, `unzipWith`, `update`, `updateWith`, `values`,
		     * `valuesIn`, `without`, `wrap`, `xor`, `xorBy`, `xorWith`, `zip`,
		     * `zipObject`, `zipObjectDeep`, and `zipWith`
		     *
		     * The wrapper methods that are **not** chainable by default are:
		     * `add`, `attempt`, `camelCase`, `capitalize`, `ceil`, `clamp`, `clone`,
		     * `cloneDeep`, `cloneDeepWith`, `cloneWith`, `conformsTo`, `deburr`,
		     * `defaultTo`, `divide`, `each`, `eachRight`, `endsWith`, `eq`, `escape`,
		     * `escapeRegExp`, `every`, `find`, `findIndex`, `findKey`, `findLast`,
		     * `findLastIndex`, `findLastKey`, `first`, `floor`, `forEach`, `forEachRight`,
		     * `forIn`, `forInRight`, `forOwn`, `forOwnRight`, `get`, `gt`, `gte`, `has`,
		     * `hasIn`, `head`, `identity`, `includes`, `indexOf`, `inRange`, `invoke`,
		     * `isArguments`, `isArray`, `isArrayBuffer`, `isArrayLike`, `isArrayLikeObject`,
		     * `isBoolean`, `isBuffer`, `isDate`, `isElement`, `isEmpty`, `isEqual`,
		     * `isEqualWith`, `isError`, `isFinite`, `isFunction`, `isInteger`, `isLength`,
		     * `isMap`, `isMatch`, `isMatchWith`, `isNaN`, `isNative`, `isNil`, `isNull`,
		     * `isNumber`, `isObject`, `isObjectLike`, `isPlainObject`, `isRegExp`,
		     * `isSafeInteger`, `isSet`, `isString`, `isUndefined`, `isTypedArray`,
		     * `isWeakMap`, `isWeakSet`, `join`, `kebabCase`, `last`, `lastIndexOf`,
		     * `lowerCase`, `lowerFirst`, `lt`, `lte`, `max`, `maxBy`, `mean`, `meanBy`,
		     * `min`, `minBy`, `multiply`, `noConflict`, `noop`, `now`, `nth`, `pad`,
		     * `padEnd`, `padStart`, `parseInt`, `pop`, `random`, `reduce`, `reduceRight`,
		     * `repeat`, `result`, `round`, `runInContext`, `sample`, `shift`, `size`,
		     * `snakeCase`, `some`, `sortedIndex`, `sortedIndexBy`, `sortedLastIndex`,
		     * `sortedLastIndexBy`, `startCase`, `startsWith`, `stubArray`, `stubFalse`,
		     * `stubObject`, `stubString`, `stubTrue`, `subtract`, `sum`, `sumBy`,
		     * `template`, `times`, `toFinite`, `toInteger`, `toJSON`, `toLength`,
		     * `toLower`, `toNumber`, `toSafeInteger`, `toString`, `toUpper`, `trim`,
		     * `trimEnd`, `trimStart`, `truncate`, `unescape`, `uniqueId`, `upperCase`,
		     * `upperFirst`, `value`, and `words`
		     *
		     * @name _
		     * @constructor
		     * @category Seq
		     * @param {*} value The value to wrap in a `lodash` instance.
		     * @returns {Object} Returns the new `lodash` wrapper instance.
		     * @example
		     *
		     * function square(n) {
		     *   return n * n;
		     * }
		     *
		     * var wrapped = _([1, 2, 3]);
		     *
		     * // Returns an unwrapped value.
		     * wrapped.reduce(_.add);
		     * // => 6
		     *
		     * // Returns a wrapped value.
		     * var squares = wrapped.map(square);
		     *
		     * _.isArray(squares);
		     * // => false
		     *
		     * _.isArray(squares.value());
		     * // => true
		     */
		    function lodash(value) {
		      if (isObjectLike(value) && !isArray(value) && !(value instanceof LazyWrapper)) {
		        if (value instanceof LodashWrapper) {
		          return value;
		        }
		        if (hasOwnProperty.call(value, '__wrapped__')) {
		          return wrapperClone(value);
		        }
		      }
		      return new LodashWrapper(value);
		    }

		    /**
		     * The base implementation of `_.create` without support for assigning
		     * properties to the created object.
		     *
		     * @private
		     * @param {Object} proto The object to inherit from.
		     * @returns {Object} Returns the new object.
		     */
		    var baseCreate = (function() {
		      function object() {}
		      return function(proto) {
		        if (!isObject(proto)) {
		          return {};
		        }
		        if (objectCreate) {
		          return objectCreate(proto);
		        }
		        object.prototype = proto;
		        var result = new object;
		        object.prototype = undefined$1;
		        return result;
		      };
		    }());

		    /**
		     * The function whose prototype chain sequence wrappers inherit from.
		     *
		     * @private
		     */
		    function baseLodash() {
		      // No operation performed.
		    }

		    /**
		     * The base constructor for creating `lodash` wrapper objects.
		     *
		     * @private
		     * @param {*} value The value to wrap.
		     * @param {boolean} [chainAll] Enable explicit method chain sequences.
		     */
		    function LodashWrapper(value, chainAll) {
		      this.__wrapped__ = value;
		      this.__actions__ = [];
		      this.__chain__ = !!chainAll;
		      this.__index__ = 0;
		      this.__values__ = undefined$1;
		    }

		    /**
		     * By default, the template delimiters used by lodash are like those in
		     * embedded Ruby (ERB) as well as ES2015 template strings. Change the
		     * following template settings to use alternative delimiters.
		     *
		     * @static
		     * @memberOf _
		     * @type {Object}
		     */
		    lodash.templateSettings = {

		      /**
		       * Used to detect `data` property values to be HTML-escaped.
		       *
		       * @memberOf _.templateSettings
		       * @type {RegExp}
		       */
		      'escape': reEscape,

		      /**
		       * Used to detect code to be evaluated.
		       *
		       * @memberOf _.templateSettings
		       * @type {RegExp}
		       */
		      'evaluate': reEvaluate,

		      /**
		       * Used to detect `data` property values to inject.
		       *
		       * @memberOf _.templateSettings
		       * @type {RegExp}
		       */
		      'interpolate': reInterpolate,

		      /**
		       * Used to reference the data object in the template text.
		       *
		       * @memberOf _.templateSettings
		       * @type {string}
		       */
		      'variable': '',

		      /**
		       * Used to import variables into the compiled template.
		       *
		       * @memberOf _.templateSettings
		       * @type {Object}
		       */
		      'imports': {

		        /**
		         * A reference to the `lodash` function.
		         *
		         * @memberOf _.templateSettings.imports
		         * @type {Function}
		         */
		        '_': lodash
		      }
		    };

		    // Ensure wrappers are instances of `baseLodash`.
		    lodash.prototype = baseLodash.prototype;
		    lodash.prototype.constructor = lodash;

		    LodashWrapper.prototype = baseCreate(baseLodash.prototype);
		    LodashWrapper.prototype.constructor = LodashWrapper;

		    /*------------------------------------------------------------------------*/

		    /**
		     * Creates a lazy wrapper object which wraps `value` to enable lazy evaluation.
		     *
		     * @private
		     * @constructor
		     * @param {*} value The value to wrap.
		     */
		    function LazyWrapper(value) {
		      this.__wrapped__ = value;
		      this.__actions__ = [];
		      this.__dir__ = 1;
		      this.__filtered__ = false;
		      this.__iteratees__ = [];
		      this.__takeCount__ = MAX_ARRAY_LENGTH;
		      this.__views__ = [];
		    }

		    /**
		     * Creates a clone of the lazy wrapper object.
		     *
		     * @private
		     * @name clone
		     * @memberOf LazyWrapper
		     * @returns {Object} Returns the cloned `LazyWrapper` object.
		     */
		    function lazyClone() {
		      var result = new LazyWrapper(this.__wrapped__);
		      result.__actions__ = copyArray(this.__actions__);
		      result.__dir__ = this.__dir__;
		      result.__filtered__ = this.__filtered__;
		      result.__iteratees__ = copyArray(this.__iteratees__);
		      result.__takeCount__ = this.__takeCount__;
		      result.__views__ = copyArray(this.__views__);
		      return result;
		    }

		    /**
		     * Reverses the direction of lazy iteration.
		     *
		     * @private
		     * @name reverse
		     * @memberOf LazyWrapper
		     * @returns {Object} Returns the new reversed `LazyWrapper` object.
		     */
		    function lazyReverse() {
		      if (this.__filtered__) {
		        var result = new LazyWrapper(this);
		        result.__dir__ = -1;
		        result.__filtered__ = true;
		      } else {
		        result = this.clone();
		        result.__dir__ *= -1;
		      }
		      return result;
		    }

		    /**
		     * Extracts the unwrapped value from its lazy wrapper.
		     *
		     * @private
		     * @name value
		     * @memberOf LazyWrapper
		     * @returns {*} Returns the unwrapped value.
		     */
		    function lazyValue() {
		      var array = this.__wrapped__.value(),
		          dir = this.__dir__,
		          isArr = isArray(array),
		          isRight = dir < 0,
		          arrLength = isArr ? array.length : 0,
		          view = getView(0, arrLength, this.__views__),
		          start = view.start,
		          end = view.end,
		          length = end - start,
		          index = isRight ? end : (start - 1),
		          iteratees = this.__iteratees__,
		          iterLength = iteratees.length,
		          resIndex = 0,
		          takeCount = nativeMin(length, this.__takeCount__);

		      if (!isArr || (!isRight && arrLength == length && takeCount == length)) {
		        return baseWrapperValue(array, this.__actions__);
		      }
		      var result = [];

		      outer:
		      while (length-- && resIndex < takeCount) {
		        index += dir;

		        var iterIndex = -1,
		            value = array[index];

		        while (++iterIndex < iterLength) {
		          var data = iteratees[iterIndex],
		              iteratee = data.iteratee,
		              type = data.type,
		              computed = iteratee(value);

		          if (type == LAZY_MAP_FLAG) {
		            value = computed;
		          } else if (!computed) {
		            if (type == LAZY_FILTER_FLAG) {
		              continue outer;
		            } else {
		              break outer;
		            }
		          }
		        }
		        result[resIndex++] = value;
		      }
		      return result;
		    }

		    // Ensure `LazyWrapper` is an instance of `baseLodash`.
		    LazyWrapper.prototype = baseCreate(baseLodash.prototype);
		    LazyWrapper.prototype.constructor = LazyWrapper;

		    /*------------------------------------------------------------------------*/

		    /**
		     * Creates a hash object.
		     *
		     * @private
		     * @constructor
		     * @param {Array} [entries] The key-value pairs to cache.
		     */
		    function Hash(entries) {
		      var index = -1,
		          length = entries == null ? 0 : entries.length;

		      this.clear();
		      while (++index < length) {
		        var entry = entries[index];
		        this.set(entry[0], entry[1]);
		      }
		    }

		    /**
		     * Removes all key-value entries from the hash.
		     *
		     * @private
		     * @name clear
		     * @memberOf Hash
		     */
		    function hashClear() {
		      this.__data__ = nativeCreate ? nativeCreate(null) : {};
		      this.size = 0;
		    }

		    /**
		     * Removes `key` and its value from the hash.
		     *
		     * @private
		     * @name delete
		     * @memberOf Hash
		     * @param {Object} hash The hash to modify.
		     * @param {string} key The key of the value to remove.
		     * @returns {boolean} Returns `true` if the entry was removed, else `false`.
		     */
		    function hashDelete(key) {
		      var result = this.has(key) && delete this.__data__[key];
		      this.size -= result ? 1 : 0;
		      return result;
		    }

		    /**
		     * Gets the hash value for `key`.
		     *
		     * @private
		     * @name get
		     * @memberOf Hash
		     * @param {string} key The key of the value to get.
		     * @returns {*} Returns the entry value.
		     */
		    function hashGet(key) {
		      var data = this.__data__;
		      if (nativeCreate) {
		        var result = data[key];
		        return result === HASH_UNDEFINED ? undefined$1 : result;
		      }
		      return hasOwnProperty.call(data, key) ? data[key] : undefined$1;
		    }

		    /**
		     * Checks if a hash value for `key` exists.
		     *
		     * @private
		     * @name has
		     * @memberOf Hash
		     * @param {string} key The key of the entry to check.
		     * @returns {boolean} Returns `true` if an entry for `key` exists, else `false`.
		     */
		    function hashHas(key) {
		      var data = this.__data__;
		      return nativeCreate ? (data[key] !== undefined$1) : hasOwnProperty.call(data, key);
		    }

		    /**
		     * Sets the hash `key` to `value`.
		     *
		     * @private
		     * @name set
		     * @memberOf Hash
		     * @param {string} key The key of the value to set.
		     * @param {*} value The value to set.
		     * @returns {Object} Returns the hash instance.
		     */
		    function hashSet(key, value) {
		      var data = this.__data__;
		      this.size += this.has(key) ? 0 : 1;
		      data[key] = (nativeCreate && value === undefined$1) ? HASH_UNDEFINED : value;
		      return this;
		    }

		    // Add methods to `Hash`.
		    Hash.prototype.clear = hashClear;
		    Hash.prototype['delete'] = hashDelete;
		    Hash.prototype.get = hashGet;
		    Hash.prototype.has = hashHas;
		    Hash.prototype.set = hashSet;

		    /*------------------------------------------------------------------------*/

		    /**
		     * Creates an list cache object.
		     *
		     * @private
		     * @constructor
		     * @param {Array} [entries] The key-value pairs to cache.
		     */
		    function ListCache(entries) {
		      var index = -1,
		          length = entries == null ? 0 : entries.length;

		      this.clear();
		      while (++index < length) {
		        var entry = entries[index];
		        this.set(entry[0], entry[1]);
		      }
		    }

		    /**
		     * Removes all key-value entries from the list cache.
		     *
		     * @private
		     * @name clear
		     * @memberOf ListCache
		     */
		    function listCacheClear() {
		      this.__data__ = [];
		      this.size = 0;
		    }

		    /**
		     * Removes `key` and its value from the list cache.
		     *
		     * @private
		     * @name delete
		     * @memberOf ListCache
		     * @param {string} key The key of the value to remove.
		     * @returns {boolean} Returns `true` if the entry was removed, else `false`.
		     */
		    function listCacheDelete(key) {
		      var data = this.__data__,
		          index = assocIndexOf(data, key);

		      if (index < 0) {
		        return false;
		      }
		      var lastIndex = data.length - 1;
		      if (index == lastIndex) {
		        data.pop();
		      } else {
		        splice.call(data, index, 1);
		      }
		      --this.size;
		      return true;
		    }

		    /**
		     * Gets the list cache value for `key`.
		     *
		     * @private
		     * @name get
		     * @memberOf ListCache
		     * @param {string} key The key of the value to get.
		     * @returns {*} Returns the entry value.
		     */
		    function listCacheGet(key) {
		      var data = this.__data__,
		          index = assocIndexOf(data, key);

		      return index < 0 ? undefined$1 : data[index][1];
		    }

		    /**
		     * Checks if a list cache value for `key` exists.
		     *
		     * @private
		     * @name has
		     * @memberOf ListCache
		     * @param {string} key The key of the entry to check.
		     * @returns {boolean} Returns `true` if an entry for `key` exists, else `false`.
		     */
		    function listCacheHas(key) {
		      return assocIndexOf(this.__data__, key) > -1;
		    }

		    /**
		     * Sets the list cache `key` to `value`.
		     *
		     * @private
		     * @name set
		     * @memberOf ListCache
		     * @param {string} key The key of the value to set.
		     * @param {*} value The value to set.
		     * @returns {Object} Returns the list cache instance.
		     */
		    function listCacheSet(key, value) {
		      var data = this.__data__,
		          index = assocIndexOf(data, key);

		      if (index < 0) {
		        ++this.size;
		        data.push([key, value]);
		      } else {
		        data[index][1] = value;
		      }
		      return this;
		    }

		    // Add methods to `ListCache`.
		    ListCache.prototype.clear = listCacheClear;
		    ListCache.prototype['delete'] = listCacheDelete;
		    ListCache.prototype.get = listCacheGet;
		    ListCache.prototype.has = listCacheHas;
		    ListCache.prototype.set = listCacheSet;

		    /*------------------------------------------------------------------------*/

		    /**
		     * Creates a map cache object to store key-value pairs.
		     *
		     * @private
		     * @constructor
		     * @param {Array} [entries] The key-value pairs to cache.
		     */
		    function MapCache(entries) {
		      var index = -1,
		          length = entries == null ? 0 : entries.length;

		      this.clear();
		      while (++index < length) {
		        var entry = entries[index];
		        this.set(entry[0], entry[1]);
		      }
		    }

		    /**
		     * Removes all key-value entries from the map.
		     *
		     * @private
		     * @name clear
		     * @memberOf MapCache
		     */
		    function mapCacheClear() {
		      this.size = 0;
		      this.__data__ = {
		        'hash': new Hash,
		        'map': new (Map || ListCache),
		        'string': new Hash
		      };
		    }

		    /**
		     * Removes `key` and its value from the map.
		     *
		     * @private
		     * @name delete
		     * @memberOf MapCache
		     * @param {string} key The key of the value to remove.
		     * @returns {boolean} Returns `true` if the entry was removed, else `false`.
		     */
		    function mapCacheDelete(key) {
		      var result = getMapData(this, key)['delete'](key);
		      this.size -= result ? 1 : 0;
		      return result;
		    }

		    /**
		     * Gets the map value for `key`.
		     *
		     * @private
		     * @name get
		     * @memberOf MapCache
		     * @param {string} key The key of the value to get.
		     * @returns {*} Returns the entry value.
		     */
		    function mapCacheGet(key) {
		      return getMapData(this, key).get(key);
		    }

		    /**
		     * Checks if a map value for `key` exists.
		     *
		     * @private
		     * @name has
		     * @memberOf MapCache
		     * @param {string} key The key of the entry to check.
		     * @returns {boolean} Returns `true` if an entry for `key` exists, else `false`.
		     */
		    function mapCacheHas(key) {
		      return getMapData(this, key).has(key);
		    }

		    /**
		     * Sets the map `key` to `value`.
		     *
		     * @private
		     * @name set
		     * @memberOf MapCache
		     * @param {string} key The key of the value to set.
		     * @param {*} value The value to set.
		     * @returns {Object} Returns the map cache instance.
		     */
		    function mapCacheSet(key, value) {
		      var data = getMapData(this, key),
		          size = data.size;

		      data.set(key, value);
		      this.size += data.size == size ? 0 : 1;
		      return this;
		    }

		    // Add methods to `MapCache`.
		    MapCache.prototype.clear = mapCacheClear;
		    MapCache.prototype['delete'] = mapCacheDelete;
		    MapCache.prototype.get = mapCacheGet;
		    MapCache.prototype.has = mapCacheHas;
		    MapCache.prototype.set = mapCacheSet;

		    /*------------------------------------------------------------------------*/

		    /**
		     *
		     * Creates an array cache object to store unique values.
		     *
		     * @private
		     * @constructor
		     * @param {Array} [values] The values to cache.
		     */
		    function SetCache(values) {
		      var index = -1,
		          length = values == null ? 0 : values.length;

		      this.__data__ = new MapCache;
		      while (++index < length) {
		        this.add(values[index]);
		      }
		    }

		    /**
		     * Adds `value` to the array cache.
		     *
		     * @private
		     * @name add
		     * @memberOf SetCache
		     * @alias push
		     * @param {*} value The value to cache.
		     * @returns {Object} Returns the cache instance.
		     */
		    function setCacheAdd(value) {
		      this.__data__.set(value, HASH_UNDEFINED);
		      return this;
		    }

		    /**
		     * Checks if `value` is in the array cache.
		     *
		     * @private
		     * @name has
		     * @memberOf SetCache
		     * @param {*} value The value to search for.
		     * @returns {number} Returns `true` if `value` is found, else `false`.
		     */
		    function setCacheHas(value) {
		      return this.__data__.has(value);
		    }

		    // Add methods to `SetCache`.
		    SetCache.prototype.add = SetCache.prototype.push = setCacheAdd;
		    SetCache.prototype.has = setCacheHas;

		    /*------------------------------------------------------------------------*/

		    /**
		     * Creates a stack cache object to store key-value pairs.
		     *
		     * @private
		     * @constructor
		     * @param {Array} [entries] The key-value pairs to cache.
		     */
		    function Stack(entries) {
		      var data = this.__data__ = new ListCache(entries);
		      this.size = data.size;
		    }

		    /**
		     * Removes all key-value entries from the stack.
		     *
		     * @private
		     * @name clear
		     * @memberOf Stack
		     */
		    function stackClear() {
		      this.__data__ = new ListCache;
		      this.size = 0;
		    }

		    /**
		     * Removes `key` and its value from the stack.
		     *
		     * @private
		     * @name delete
		     * @memberOf Stack
		     * @param {string} key The key of the value to remove.
		     * @returns {boolean} Returns `true` if the entry was removed, else `false`.
		     */
		    function stackDelete(key) {
		      var data = this.__data__,
		          result = data['delete'](key);

		      this.size = data.size;
		      return result;
		    }

		    /**
		     * Gets the stack value for `key`.
		     *
		     * @private
		     * @name get
		     * @memberOf Stack
		     * @param {string} key The key of the value to get.
		     * @returns {*} Returns the entry value.
		     */
		    function stackGet(key) {
		      return this.__data__.get(key);
		    }

		    /**
		     * Checks if a stack value for `key` exists.
		     *
		     * @private
		     * @name has
		     * @memberOf Stack
		     * @param {string} key The key of the entry to check.
		     * @returns {boolean} Returns `true` if an entry for `key` exists, else `false`.
		     */
		    function stackHas(key) {
		      return this.__data__.has(key);
		    }

		    /**
		     * Sets the stack `key` to `value`.
		     *
		     * @private
		     * @name set
		     * @memberOf Stack
		     * @param {string} key The key of the value to set.
		     * @param {*} value The value to set.
		     * @returns {Object} Returns the stack cache instance.
		     */
		    function stackSet(key, value) {
		      var data = this.__data__;
		      if (data instanceof ListCache) {
		        var pairs = data.__data__;
		        if (!Map || (pairs.length < LARGE_ARRAY_SIZE - 1)) {
		          pairs.push([key, value]);
		          this.size = ++data.size;
		          return this;
		        }
		        data = this.__data__ = new MapCache(pairs);
		      }
		      data.set(key, value);
		      this.size = data.size;
		      return this;
		    }

		    // Add methods to `Stack`.
		    Stack.prototype.clear = stackClear;
		    Stack.prototype['delete'] = stackDelete;
		    Stack.prototype.get = stackGet;
		    Stack.prototype.has = stackHas;
		    Stack.prototype.set = stackSet;

		    /*------------------------------------------------------------------------*/

		    /**
		     * Creates an array of the enumerable property names of the array-like `value`.
		     *
		     * @private
		     * @param {*} value The value to query.
		     * @param {boolean} inherited Specify returning inherited property names.
		     * @returns {Array} Returns the array of property names.
		     */
		    function arrayLikeKeys(value, inherited) {
		      var isArr = isArray(value),
		          isArg = !isArr && isArguments(value),
		          isBuff = !isArr && !isArg && isBuffer(value),
		          isType = !isArr && !isArg && !isBuff && isTypedArray(value),
		          skipIndexes = isArr || isArg || isBuff || isType,
		          result = skipIndexes ? baseTimes(value.length, String) : [],
		          length = result.length;

		      for (var key in value) {
		        if ((inherited || hasOwnProperty.call(value, key)) &&
		            !(skipIndexes && (
		               // Safari 9 has enumerable `arguments.length` in strict mode.
		               key == 'length' ||
		               // Node.js 0.10 has enumerable non-index properties on buffers.
		               (isBuff && (key == 'offset' || key == 'parent')) ||
		               // PhantomJS 2 has enumerable non-index properties on typed arrays.
		               (isType && (key == 'buffer' || key == 'byteLength' || key == 'byteOffset')) ||
		               // Skip index properties.
		               isIndex(key, length)
		            ))) {
		          result.push(key);
		        }
		      }
		      return result;
		    }

		    /**
		     * A specialized version of `_.sample` for arrays.
		     *
		     * @private
		     * @param {Array} array The array to sample.
		     * @returns {*} Returns the random element.
		     */
		    function arraySample(array) {
		      var length = array.length;
		      return length ? array[baseRandom(0, length - 1)] : undefined$1;
		    }

		    /**
		     * A specialized version of `_.sampleSize` for arrays.
		     *
		     * @private
		     * @param {Array} array The array to sample.
		     * @param {number} n The number of elements to sample.
		     * @returns {Array} Returns the random elements.
		     */
		    function arraySampleSize(array, n) {
		      return shuffleSelf(copyArray(array), baseClamp(n, 0, array.length));
		    }

		    /**
		     * A specialized version of `_.shuffle` for arrays.
		     *
		     * @private
		     * @param {Array} array The array to shuffle.
		     * @returns {Array} Returns the new shuffled array.
		     */
		    function arrayShuffle(array) {
		      return shuffleSelf(copyArray(array));
		    }

		    /**
		     * This function is like `assignValue` except that it doesn't assign
		     * `undefined` values.
		     *
		     * @private
		     * @param {Object} object The object to modify.
		     * @param {string} key The key of the property to assign.
		     * @param {*} value The value to assign.
		     */
		    function assignMergeValue(object, key, value) {
		      if ((value !== undefined$1 && !eq(object[key], value)) ||
		          (value === undefined$1 && !(key in object))) {
		        baseAssignValue(object, key, value);
		      }
		    }

		    /**
		     * Assigns `value` to `key` of `object` if the existing value is not equivalent
		     * using [`SameValueZero`](http://ecma-international.org/ecma-262/7.0/#sec-samevaluezero)
		     * for equality comparisons.
		     *
		     * @private
		     * @param {Object} object The object to modify.
		     * @param {string} key The key of the property to assign.
		     * @param {*} value The value to assign.
		     */
		    function assignValue(object, key, value) {
		      var objValue = object[key];
		      if (!(hasOwnProperty.call(object, key) && eq(objValue, value)) ||
		          (value === undefined$1 && !(key in object))) {
		        baseAssignValue(object, key, value);
		      }
		    }

		    /**
		     * Gets the index at which the `key` is found in `array` of key-value pairs.
		     *
		     * @private
		     * @param {Array} array The array to inspect.
		     * @param {*} key The key to search for.
		     * @returns {number} Returns the index of the matched value, else `-1`.
		     */
		    function assocIndexOf(array, key) {
		      var length = array.length;
		      while (length--) {
		        if (eq(array[length][0], key)) {
		          return length;
		        }
		      }
		      return -1;
		    }

		    /**
		     * Aggregates elements of `collection` on `accumulator` with keys transformed
		     * by `iteratee` and values set by `setter`.
		     *
		     * @private
		     * @param {Array|Object} collection The collection to iterate over.
		     * @param {Function} setter The function to set `accumulator` values.
		     * @param {Function} iteratee The iteratee to transform keys.
		     * @param {Object} accumulator The initial aggregated object.
		     * @returns {Function} Returns `accumulator`.
		     */
		    function baseAggregator(collection, setter, iteratee, accumulator) {
		      baseEach(collection, function(value, key, collection) {
		        setter(accumulator, value, iteratee(value), collection);
		      });
		      return accumulator;
		    }

		    /**
		     * The base implementation of `_.assign` without support for multiple sources
		     * or `customizer` functions.
		     *
		     * @private
		     * @param {Object} object The destination object.
		     * @param {Object} source The source object.
		     * @returns {Object} Returns `object`.
		     */
		    function baseAssign(object, source) {
		      return object && copyObject(source, keys(source), object);
		    }

		    /**
		     * The base implementation of `_.assignIn` without support for multiple sources
		     * or `customizer` functions.
		     *
		     * @private
		     * @param {Object} object The destination object.
		     * @param {Object} source The source object.
		     * @returns {Object} Returns `object`.
		     */
		    function baseAssignIn(object, source) {
		      return object && copyObject(source, keysIn(source), object);
		    }

		    /**
		     * The base implementation of `assignValue` and `assignMergeValue` without
		     * value checks.
		     *
		     * @private
		     * @param {Object} object The object to modify.
		     * @param {string} key The key of the property to assign.
		     * @param {*} value The value to assign.
		     */
		    function baseAssignValue(object, key, value) {
		      if (key == '__proto__' && defineProperty) {
		        defineProperty(object, key, {
		          'configurable': true,
		          'enumerable': true,
		          'value': value,
		          'writable': true
		        });
		      } else {
		        object[key] = value;
		      }
		    }

		    /**
		     * The base implementation of `_.at` without support for individual paths.
		     *
		     * @private
		     * @param {Object} object The object to iterate over.
		     * @param {string[]} paths The property paths to pick.
		     * @returns {Array} Returns the picked elements.
		     */
		    function baseAt(object, paths) {
		      var index = -1,
		          length = paths.length,
		          result = Array(length),
		          skip = object == null;

		      while (++index < length) {
		        result[index] = skip ? undefined$1 : get(object, paths[index]);
		      }
		      return result;
		    }

		    /**
		     * The base implementation of `_.clamp` which doesn't coerce arguments.
		     *
		     * @private
		     * @param {number} number The number to clamp.
		     * @param {number} [lower] The lower bound.
		     * @param {number} upper The upper bound.
		     * @returns {number} Returns the clamped number.
		     */
		    function baseClamp(number, lower, upper) {
		      if (number === number) {
		        if (upper !== undefined$1) {
		          number = number <= upper ? number : upper;
		        }
		        if (lower !== undefined$1) {
		          number = number >= lower ? number : lower;
		        }
		      }
		      return number;
		    }

		    /**
		     * The base implementation of `_.clone` and `_.cloneDeep` which tracks
		     * traversed objects.
		     *
		     * @private
		     * @param {*} value The value to clone.
		     * @param {boolean} bitmask The bitmask flags.
		     *  1 - Deep clone
		     *  2 - Flatten inherited properties
		     *  4 - Clone symbols
		     * @param {Function} [customizer] The function to customize cloning.
		     * @param {string} [key] The key of `value`.
		     * @param {Object} [object] The parent object of `value`.
		     * @param {Object} [stack] Tracks traversed objects and their clone counterparts.
		     * @returns {*} Returns the cloned value.
		     */
		    function baseClone(value, bitmask, customizer, key, object, stack) {
		      var result,
		          isDeep = bitmask & CLONE_DEEP_FLAG,
		          isFlat = bitmask & CLONE_FLAT_FLAG,
		          isFull = bitmask & CLONE_SYMBOLS_FLAG;

		      if (customizer) {
		        result = object ? customizer(value, key, object, stack) : customizer(value);
		      }
		      if (result !== undefined$1) {
		        return result;
		      }
		      if (!isObject(value)) {
		        return value;
		      }
		      var isArr = isArray(value);
		      if (isArr) {
		        result = initCloneArray(value);
		        if (!isDeep) {
		          return copyArray(value, result);
		        }
		      } else {
		        var tag = getTag(value),
		            isFunc = tag == funcTag || tag == genTag;

		        if (isBuffer(value)) {
		          return cloneBuffer(value, isDeep);
		        }
		        if (tag == objectTag || tag == argsTag || (isFunc && !object)) {
		          result = (isFlat || isFunc) ? {} : initCloneObject(value);
		          if (!isDeep) {
		            return isFlat
		              ? copySymbolsIn(value, baseAssignIn(result, value))
		              : copySymbols(value, baseAssign(result, value));
		          }
		        } else {
		          if (!cloneableTags[tag]) {
		            return object ? value : {};
		          }
		          result = initCloneByTag(value, tag, isDeep);
		        }
		      }
		      // Check for circular references and return its corresponding clone.
		      stack || (stack = new Stack);
		      var stacked = stack.get(value);
		      if (stacked) {
		        return stacked;
		      }
		      stack.set(value, result);

		      if (isSet(value)) {
		        value.forEach(function(subValue) {
		          result.add(baseClone(subValue, bitmask, customizer, subValue, value, stack));
		        });
		      } else if (isMap(value)) {
		        value.forEach(function(subValue, key) {
		          result.set(key, baseClone(subValue, bitmask, customizer, key, value, stack));
		        });
		      }

		      var keysFunc = isFull
		        ? (isFlat ? getAllKeysIn : getAllKeys)
		        : (isFlat ? keysIn : keys);

		      var props = isArr ? undefined$1 : keysFunc(value);
		      arrayEach(props || value, function(subValue, key) {
		        if (props) {
		          key = subValue;
		          subValue = value[key];
		        }
		        // Recursively populate clone (susceptible to call stack limits).
		        assignValue(result, key, baseClone(subValue, bitmask, customizer, key, value, stack));
		      });
		      return result;
		    }

		    /**
		     * The base implementation of `_.conforms` which doesn't clone `source`.
		     *
		     * @private
		     * @param {Object} source The object of property predicates to conform to.
		     * @returns {Function} Returns the new spec function.
		     */
		    function baseConforms(source) {
		      var props = keys(source);
		      return function(object) {
		        return baseConformsTo(object, source, props);
		      };
		    }

		    /**
		     * The base implementation of `_.conformsTo` which accepts `props` to check.
		     *
		     * @private
		     * @param {Object} object The object to inspect.
		     * @param {Object} source The object of property predicates to conform to.
		     * @returns {boolean} Returns `true` if `object` conforms, else `false`.
		     */
		    function baseConformsTo(object, source, props) {
		      var length = props.length;
		      if (object == null) {
		        return !length;
		      }
		      object = Object(object);
		      while (length--) {
		        var key = props[length],
		            predicate = source[key],
		            value = object[key];

		        if ((value === undefined$1 && !(key in object)) || !predicate(value)) {
		          return false;
		        }
		      }
		      return true;
		    }

		    /**
		     * The base implementation of `_.delay` and `_.defer` which accepts `args`
		     * to provide to `func`.
		     *
		     * @private
		     * @param {Function} func The function to delay.
		     * @param {number} wait The number of milliseconds to delay invocation.
		     * @param {Array} args The arguments to provide to `func`.
		     * @returns {number|Object} Returns the timer id or timeout object.
		     */
		    function baseDelay(func, wait, args) {
		      if (typeof func != 'function') {
		        throw new TypeError(FUNC_ERROR_TEXT);
		      }
		      return setTimeout(function() { func.apply(undefined$1, args); }, wait);
		    }

		    /**
		     * The base implementation of methods like `_.difference` without support
		     * for excluding multiple arrays or iteratee shorthands.
		     *
		     * @private
		     * @param {Array} array The array to inspect.
		     * @param {Array} values The values to exclude.
		     * @param {Function} [iteratee] The iteratee invoked per element.
		     * @param {Function} [comparator] The comparator invoked per element.
		     * @returns {Array} Returns the new array of filtered values.
		     */
		    function baseDifference(array, values, iteratee, comparator) {
		      var index = -1,
		          includes = arrayIncludes,
		          isCommon = true,
		          length = array.length,
		          result = [],
		          valuesLength = values.length;

		      if (!length) {
		        return result;
		      }
		      if (iteratee) {
		        values = arrayMap(values, baseUnary(iteratee));
		      }
		      if (comparator) {
		        includes = arrayIncludesWith;
		        isCommon = false;
		      }
		      else if (values.length >= LARGE_ARRAY_SIZE) {
		        includes = cacheHas;
		        isCommon = false;
		        values = new SetCache(values);
		      }
		      outer:
		      while (++index < length) {
		        var value = array[index],
		            computed = iteratee == null ? value : iteratee(value);

		        value = (comparator || value !== 0) ? value : 0;
		        if (isCommon && computed === computed) {
		          var valuesIndex = valuesLength;
		          while (valuesIndex--) {
		            if (values[valuesIndex] === computed) {
		              continue outer;
		            }
		          }
		          result.push(value);
		        }
		        else if (!includes(values, computed, comparator)) {
		          result.push(value);
		        }
		      }
		      return result;
		    }

		    /**
		     * The base implementation of `_.forEach` without support for iteratee shorthands.
		     *
		     * @private
		     * @param {Array|Object} collection The collection to iterate over.
		     * @param {Function} iteratee The function invoked per iteration.
		     * @returns {Array|Object} Returns `collection`.
		     */
		    var baseEach = createBaseEach(baseForOwn);

		    /**
		     * The base implementation of `_.forEachRight` without support for iteratee shorthands.
		     *
		     * @private
		     * @param {Array|Object} collection The collection to iterate over.
		     * @param {Function} iteratee The function invoked per iteration.
		     * @returns {Array|Object} Returns `collection`.
		     */
		    var baseEachRight = createBaseEach(baseForOwnRight, true);

		    /**
		     * The base implementation of `_.every` without support for iteratee shorthands.
		     *
		     * @private
		     * @param {Array|Object} collection The collection to iterate over.
		     * @param {Function} predicate The function invoked per iteration.
		     * @returns {boolean} Returns `true` if all elements pass the predicate check,
		     *  else `false`
		     */
		    function baseEvery(collection, predicate) {
		      var result = true;
		      baseEach(collection, function(value, index, collection) {
		        result = !!predicate(value, index, collection);
		        return result;
		      });
		      return result;
		    }

		    /**
		     * The base implementation of methods like `_.max` and `_.min` which accepts a
		     * `comparator` to determine the extremum value.
		     *
		     * @private
		     * @param {Array} array The array to iterate over.
		     * @param {Function} iteratee The iteratee invoked per iteration.
		     * @param {Function} comparator The comparator used to compare values.
		     * @returns {*} Returns the extremum value.
		     */
		    function baseExtremum(array, iteratee, comparator) {
		      var index = -1,
		          length = array.length;

		      while (++index < length) {
		        var value = array[index],
		            current = iteratee(value);

		        if (current != null && (computed === undefined$1
		              ? (current === current && !isSymbol(current))
		              : comparator(current, computed)
		            )) {
		          var computed = current,
		              result = value;
		        }
		      }
		      return result;
		    }

		    /**
		     * The base implementation of `_.fill` without an iteratee call guard.
		     *
		     * @private
		     * @param {Array} array The array to fill.
		     * @param {*} value The value to fill `array` with.
		     * @param {number} [start=0] The start position.
		     * @param {number} [end=array.length] The end position.
		     * @returns {Array} Returns `array`.
		     */
		    function baseFill(array, value, start, end) {
		      var length = array.length;

		      start = toInteger(start);
		      if (start < 0) {
		        start = -start > length ? 0 : (length + start);
		      }
		      end = (end === undefined$1 || end > length) ? length : toInteger(end);
		      if (end < 0) {
		        end += length;
		      }
		      end = start > end ? 0 : toLength(end);
		      while (start < end) {
		        array[start++] = value;
		      }
		      return array;
		    }

		    /**
		     * The base implementation of `_.filter` without support for iteratee shorthands.
		     *
		     * @private
		     * @param {Array|Object} collection The collection to iterate over.
		     * @param {Function} predicate The function invoked per iteration.
		     * @returns {Array} Returns the new filtered array.
		     */
		    function baseFilter(collection, predicate) {
		      var result = [];
		      baseEach(collection, function(value, index, collection) {
		        if (predicate(value, index, collection)) {
		          result.push(value);
		        }
		      });
		      return result;
		    }

		    /**
		     * The base implementation of `_.flatten` with support for restricting flattening.
		     *
		     * @private
		     * @param {Array} array The array to flatten.
		     * @param {number} depth The maximum recursion depth.
		     * @param {boolean} [predicate=isFlattenable] The function invoked per iteration.
		     * @param {boolean} [isStrict] Restrict to values that pass `predicate` checks.
		     * @param {Array} [result=[]] The initial result value.
		     * @returns {Array} Returns the new flattened array.
		     */
		    function baseFlatten(array, depth, predicate, isStrict, result) {
		      var index = -1,
		          length = array.length;

		      predicate || (predicate = isFlattenable);
		      result || (result = []);

		      while (++index < length) {
		        var value = array[index];
		        if (depth > 0 && predicate(value)) {
		          if (depth > 1) {
		            // Recursively flatten arrays (susceptible to call stack limits).
		            baseFlatten(value, depth - 1, predicate, isStrict, result);
		          } else {
		            arrayPush(result, value);
		          }
		        } else if (!isStrict) {
		          result[result.length] = value;
		        }
		      }
		      return result;
		    }

		    /**
		     * The base implementation of `baseForOwn` which iterates over `object`
		     * properties returned by `keysFunc` and invokes `iteratee` for each property.
		     * Iteratee functions may exit iteration early by explicitly returning `false`.
		     *
		     * @private
		     * @param {Object} object The object to iterate over.
		     * @param {Function} iteratee The function invoked per iteration.
		     * @param {Function} keysFunc The function to get the keys of `object`.
		     * @returns {Object} Returns `object`.
		     */
		    var baseFor = createBaseFor();

		    /**
		     * This function is like `baseFor` except that it iterates over properties
		     * in the opposite order.
		     *
		     * @private
		     * @param {Object} object The object to iterate over.
		     * @param {Function} iteratee The function invoked per iteration.
		     * @param {Function} keysFunc The function to get the keys of `object`.
		     * @returns {Object} Returns `object`.
		     */
		    var baseForRight = createBaseFor(true);

		    /**
		     * The base implementation of `_.forOwn` without support for iteratee shorthands.
		     *
		     * @private
		     * @param {Object} object The object to iterate over.
		     * @param {Function} iteratee The function invoked per iteration.
		     * @returns {Object} Returns `object`.
		     */
		    function baseForOwn(object, iteratee) {
		      return object && baseFor(object, iteratee, keys);
		    }

		    /**
		     * The base implementation of `_.forOwnRight` without support for iteratee shorthands.
		     *
		     * @private
		     * @param {Object} object The object to iterate over.
		     * @param {Function} iteratee The function invoked per iteration.
		     * @returns {Object} Returns `object`.
		     */
		    function baseForOwnRight(object, iteratee) {
		      return object && baseForRight(object, iteratee, keys);
		    }

		    /**
		     * The base implementation of `_.functions` which creates an array of
		     * `object` function property names filtered from `props`.
		     *
		     * @private
		     * @param {Object} object The object to inspect.
		     * @param {Array} props The property names to filter.
		     * @returns {Array} Returns the function names.
		     */
		    function baseFunctions(object, props) {
		      return arrayFilter(props, function(key) {
		        return isFunction(object[key]);
		      });
		    }

		    /**
		     * The base implementation of `_.get` without support for default values.
		     *
		     * @private
		     * @param {Object} object The object to query.
		     * @param {Array|string} path The path of the property to get.
		     * @returns {*} Returns the resolved value.
		     */
		    function baseGet(object, path) {
		      path = castPath(path, object);

		      var index = 0,
		          length = path.length;

		      while (object != null && index < length) {
		        object = object[toKey(path[index++])];
		      }
		      return (index && index == length) ? object : undefined$1;
		    }

		    /**
		     * The base implementation of `getAllKeys` and `getAllKeysIn` which uses
		     * `keysFunc` and `symbolsFunc` to get the enumerable property names and
		     * symbols of `object`.
		     *
		     * @private
		     * @param {Object} object The object to query.
		     * @param {Function} keysFunc The function to get the keys of `object`.
		     * @param {Function} symbolsFunc The function to get the symbols of `object`.
		     * @returns {Array} Returns the array of property names and symbols.
		     */
		    function baseGetAllKeys(object, keysFunc, symbolsFunc) {
		      var result = keysFunc(object);
		      return isArray(object) ? result : arrayPush(result, symbolsFunc(object));
		    }

		    /**
		     * The base implementation of `getTag` without fallbacks for buggy environments.
		     *
		     * @private
		     * @param {*} value The value to query.
		     * @returns {string} Returns the `toStringTag`.
		     */
		    function baseGetTag(value) {
		      if (value == null) {
		        return value === undefined$1 ? undefinedTag : nullTag;
		      }
		      return (symToStringTag && symToStringTag in Object(value))
		        ? getRawTag(value)
		        : objectToString(value);
		    }

		    /**
		     * The base implementation of `_.gt` which doesn't coerce arguments.
		     *
		     * @private
		     * @param {*} value The value to compare.
		     * @param {*} other The other value to compare.
		     * @returns {boolean} Returns `true` if `value` is greater than `other`,
		     *  else `false`.
		     */
		    function baseGt(value, other) {
		      return value > other;
		    }

		    /**
		     * The base implementation of `_.has` without support for deep paths.
		     *
		     * @private
		     * @param {Object} [object] The object to query.
		     * @param {Array|string} key The key to check.
		     * @returns {boolean} Returns `true` if `key` exists, else `false`.
		     */
		    function baseHas(object, key) {
		      return object != null && hasOwnProperty.call(object, key);
		    }

		    /**
		     * The base implementation of `_.hasIn` without support for deep paths.
		     *
		     * @private
		     * @param {Object} [object] The object to query.
		     * @param {Array|string} key The key to check.
		     * @returns {boolean} Returns `true` if `key` exists, else `false`.
		     */
		    function baseHasIn(object, key) {
		      return object != null && key in Object(object);
		    }

		    /**
		     * The base implementation of `_.inRange` which doesn't coerce arguments.
		     *
		     * @private
		     * @param {number} number The number to check.
		     * @param {number} start The start of the range.
		     * @param {number} end The end of the range.
		     * @returns {boolean} Returns `true` if `number` is in the range, else `false`.
		     */
		    function baseInRange(number, start, end) {
		      return number >= nativeMin(start, end) && number < nativeMax(start, end);
		    }

		    /**
		     * The base implementation of methods like `_.intersection`, without support
		     * for iteratee shorthands, that accepts an array of arrays to inspect.
		     *
		     * @private
		     * @param {Array} arrays The arrays to inspect.
		     * @param {Function} [iteratee] The iteratee invoked per element.
		     * @param {Function} [comparator] The comparator invoked per element.
		     * @returns {Array} Returns the new array of shared values.
		     */
		    function baseIntersection(arrays, iteratee, comparator) {
		      var includes = comparator ? arrayIncludesWith : arrayIncludes,
		          length = arrays[0].length,
		          othLength = arrays.length,
		          othIndex = othLength,
		          caches = Array(othLength),
		          maxLength = Infinity,
		          result = [];

		      while (othIndex--) {
		        var array = arrays[othIndex];
		        if (othIndex && iteratee) {
		          array = arrayMap(array, baseUnary(iteratee));
		        }
		        maxLength = nativeMin(array.length, maxLength);
		        caches[othIndex] = !comparator && (iteratee || (length >= 120 && array.length >= 120))
		          ? new SetCache(othIndex && array)
		          : undefined$1;
		      }
		      array = arrays[0];

		      var index = -1,
		          seen = caches[0];

		      outer:
		      while (++index < length && result.length < maxLength) {
		        var value = array[index],
		            computed = iteratee ? iteratee(value) : value;

		        value = (comparator || value !== 0) ? value : 0;
		        if (!(seen
		              ? cacheHas(seen, computed)
		              : includes(result, computed, comparator)
		            )) {
		          othIndex = othLength;
		          while (--othIndex) {
		            var cache = caches[othIndex];
		            if (!(cache
		                  ? cacheHas(cache, computed)
		                  : includes(arrays[othIndex], computed, comparator))
		                ) {
		              continue outer;
		            }
		          }
		          if (seen) {
		            seen.push(computed);
		          }
		          result.push(value);
		        }
		      }
		      return result;
		    }

		    /**
		     * The base implementation of `_.invert` and `_.invertBy` which inverts
		     * `object` with values transformed by `iteratee` and set by `setter`.
		     *
		     * @private
		     * @param {Object} object The object to iterate over.
		     * @param {Function} setter The function to set `accumulator` values.
		     * @param {Function} iteratee The iteratee to transform values.
		     * @param {Object} accumulator The initial inverted object.
		     * @returns {Function} Returns `accumulator`.
		     */
		    function baseInverter(object, setter, iteratee, accumulator) {
		      baseForOwn(object, function(value, key, object) {
		        setter(accumulator, iteratee(value), key, object);
		      });
		      return accumulator;
		    }

		    /**
		     * The base implementation of `_.invoke` without support for individual
		     * method arguments.
		     *
		     * @private
		     * @param {Object} object The object to query.
		     * @param {Array|string} path The path of the method to invoke.
		     * @param {Array} args The arguments to invoke the method with.
		     * @returns {*} Returns the result of the invoked method.
		     */
		    function baseInvoke(object, path, args) {
		      path = castPath(path, object);
		      object = parent(object, path);
		      var func = object == null ? object : object[toKey(last(path))];
		      return func == null ? undefined$1 : apply(func, object, args);
		    }

		    /**
		     * The base implementation of `_.isArguments`.
		     *
		     * @private
		     * @param {*} value The value to check.
		     * @returns {boolean} Returns `true` if `value` is an `arguments` object,
		     */
		    function baseIsArguments(value) {
		      return isObjectLike(value) && baseGetTag(value) == argsTag;
		    }

		    /**
		     * The base implementation of `_.isArrayBuffer` without Node.js optimizations.
		     *
		     * @private
		     * @param {*} value The value to check.
		     * @returns {boolean} Returns `true` if `value` is an array buffer, else `false`.
		     */
		    function baseIsArrayBuffer(value) {
		      return isObjectLike(value) && baseGetTag(value) == arrayBufferTag;
		    }

		    /**
		     * The base implementation of `_.isDate` without Node.js optimizations.
		     *
		     * @private
		     * @param {*} value The value to check.
		     * @returns {boolean} Returns `true` if `value` is a date object, else `false`.
		     */
		    function baseIsDate(value) {
		      return isObjectLike(value) && baseGetTag(value) == dateTag;
		    }

		    /**
		     * The base implementation of `_.isEqual` which supports partial comparisons
		     * and tracks traversed objects.
		     *
		     * @private
		     * @param {*} value The value to compare.
		     * @param {*} other The other value to compare.
		     * @param {boolean} bitmask The bitmask flags.
		     *  1 - Unordered comparison
		     *  2 - Partial comparison
		     * @param {Function} [customizer] The function to customize comparisons.
		     * @param {Object} [stack] Tracks traversed `value` and `other` objects.
		     * @returns {boolean} Returns `true` if the values are equivalent, else `false`.
		     */
		    function baseIsEqual(value, other, bitmask, customizer, stack) {
		      if (value === other) {
		        return true;
		      }
		      if (value == null || other == null || (!isObjectLike(value) && !isObjectLike(other))) {
		        return value !== value && other !== other;
		      }
		      return baseIsEqualDeep(value, other, bitmask, customizer, baseIsEqual, stack);
		    }

		    /**
		     * A specialized version of `baseIsEqual` for arrays and objects which performs
		     * deep comparisons and tracks traversed objects enabling objects with circular
		     * references to be compared.
		     *
		     * @private
		     * @param {Object} object The object to compare.
		     * @param {Object} other The other object to compare.
		     * @param {number} bitmask The bitmask flags. See `baseIsEqual` for more details.
		     * @param {Function} customizer The function to customize comparisons.
		     * @param {Function} equalFunc The function to determine equivalents of values.
		     * @param {Object} [stack] Tracks traversed `object` and `other` objects.
		     * @returns {boolean} Returns `true` if the objects are equivalent, else `false`.
		     */
		    function baseIsEqualDeep(object, other, bitmask, customizer, equalFunc, stack) {
		      var objIsArr = isArray(object),
		          othIsArr = isArray(other),
		          objTag = objIsArr ? arrayTag : getTag(object),
		          othTag = othIsArr ? arrayTag : getTag(other);

		      objTag = objTag == argsTag ? objectTag : objTag;
		      othTag = othTag == argsTag ? objectTag : othTag;

		      var objIsObj = objTag == objectTag,
		          othIsObj = othTag == objectTag,
		          isSameTag = objTag == othTag;

		      if (isSameTag && isBuffer(object)) {
		        if (!isBuffer(other)) {
		          return false;
		        }
		        objIsArr = true;
		        objIsObj = false;
		      }
		      if (isSameTag && !objIsObj) {
		        stack || (stack = new Stack);
		        return (objIsArr || isTypedArray(object))
		          ? equalArrays(object, other, bitmask, customizer, equalFunc, stack)
		          : equalByTag(object, other, objTag, bitmask, customizer, equalFunc, stack);
		      }
		      if (!(bitmask & COMPARE_PARTIAL_FLAG)) {
		        var objIsWrapped = objIsObj && hasOwnProperty.call(object, '__wrapped__'),
		            othIsWrapped = othIsObj && hasOwnProperty.call(other, '__wrapped__');

		        if (objIsWrapped || othIsWrapped) {
		          var objUnwrapped = objIsWrapped ? object.value() : object,
		              othUnwrapped = othIsWrapped ? other.value() : other;

		          stack || (stack = new Stack);
		          return equalFunc(objUnwrapped, othUnwrapped, bitmask, customizer, stack);
		        }
		      }
		      if (!isSameTag) {
		        return false;
		      }
		      stack || (stack = new Stack);
		      return equalObjects(object, other, bitmask, customizer, equalFunc, stack);
		    }

		    /**
		     * The base implementation of `_.isMap` without Node.js optimizations.
		     *
		     * @private
		     * @param {*} value The value to check.
		     * @returns {boolean} Returns `true` if `value` is a map, else `false`.
		     */
		    function baseIsMap(value) {
		      return isObjectLike(value) && getTag(value) == mapTag;
		    }

		    /**
		     * The base implementation of `_.isMatch` without support for iteratee shorthands.
		     *
		     * @private
		     * @param {Object} object The object to inspect.
		     * @param {Object} source The object of property values to match.
		     * @param {Array} matchData The property names, values, and compare flags to match.
		     * @param {Function} [customizer] The function to customize comparisons.
		     * @returns {boolean} Returns `true` if `object` is a match, else `false`.
		     */
		    function baseIsMatch(object, source, matchData, customizer) {
		      var index = matchData.length,
		          length = index,
		          noCustomizer = !customizer;

		      if (object == null) {
		        return !length;
		      }
		      object = Object(object);
		      while (index--) {
		        var data = matchData[index];
		        if ((noCustomizer && data[2])
		              ? data[1] !== object[data[0]]
		              : !(data[0] in object)
		            ) {
		          return false;
		        }
		      }
		      while (++index < length) {
		        data = matchData[index];
		        var key = data[0],
		            objValue = object[key],
		            srcValue = data[1];

		        if (noCustomizer && data[2]) {
		          if (objValue === undefined$1 && !(key in object)) {
		            return false;
		          }
		        } else {
		          var stack = new Stack;
		          if (customizer) {
		            var result = customizer(objValue, srcValue, key, object, source, stack);
		          }
		          if (!(result === undefined$1
		                ? baseIsEqual(srcValue, objValue, COMPARE_PARTIAL_FLAG | COMPARE_UNORDERED_FLAG, customizer, stack)
		                : result
		              )) {
		            return false;
		          }
		        }
		      }
		      return true;
		    }

		    /**
		     * The base implementation of `_.isNative` without bad shim checks.
		     *
		     * @private
		     * @param {*} value The value to check.
		     * @returns {boolean} Returns `true` if `value` is a native function,
		     *  else `false`.
		     */
		    function baseIsNative(value) {
		      if (!isObject(value) || isMasked(value)) {
		        return false;
		      }
		      var pattern = isFunction(value) ? reIsNative : reIsHostCtor;
		      return pattern.test(toSource(value));
		    }

		    /**
		     * The base implementation of `_.isRegExp` without Node.js optimizations.
		     *
		     * @private
		     * @param {*} value The value to check.
		     * @returns {boolean} Returns `true` if `value` is a regexp, else `false`.
		     */
		    function baseIsRegExp(value) {
		      return isObjectLike(value) && baseGetTag(value) == regexpTag;
		    }

		    /**
		     * The base implementation of `_.isSet` without Node.js optimizations.
		     *
		     * @private
		     * @param {*} value The value to check.
		     * @returns {boolean} Returns `true` if `value` is a set, else `false`.
		     */
		    function baseIsSet(value) {
		      return isObjectLike(value) && getTag(value) == setTag;
		    }

		    /**
		     * The base implementation of `_.isTypedArray` without Node.js optimizations.
		     *
		     * @private
		     * @param {*} value The value to check.
		     * @returns {boolean} Returns `true` if `value` is a typed array, else `false`.
		     */
		    function baseIsTypedArray(value) {
		      return isObjectLike(value) &&
		        isLength(value.length) && !!typedArrayTags[baseGetTag(value)];
		    }

		    /**
		     * The base implementation of `_.iteratee`.
		     *
		     * @private
		     * @param {*} [value=_.identity] The value to convert to an iteratee.
		     * @returns {Function} Returns the iteratee.
		     */
		    function baseIteratee(value) {
		      // Don't store the `typeof` result in a variable to avoid a JIT bug in Safari 9.
		      // See https://bugs.webkit.org/show_bug.cgi?id=156034 for more details.
		      if (typeof value == 'function') {
		        return value;
		      }
		      if (value == null) {
		        return identity;
		      }
		      if (typeof value == 'object') {
		        return isArray(value)
		          ? baseMatchesProperty(value[0], value[1])
		          : baseMatches(value);
		      }
		      return property(value);
		    }

		    /**
		     * The base implementation of `_.keys` which doesn't treat sparse arrays as dense.
		     *
		     * @private
		     * @param {Object} object The object to query.
		     * @returns {Array} Returns the array of property names.
		     */
		    function baseKeys(object) {
		      if (!isPrototype(object)) {
		        return nativeKeys(object);
		      }
		      var result = [];
		      for (var key in Object(object)) {
		        if (hasOwnProperty.call(object, key) && key != 'constructor') {
		          result.push(key);
		        }
		      }
		      return result;
		    }

		    /**
		     * The base implementation of `_.keysIn` which doesn't treat sparse arrays as dense.
		     *
		     * @private
		     * @param {Object} object The object to query.
		     * @returns {Array} Returns the array of property names.
		     */
		    function baseKeysIn(object) {
		      if (!isObject(object)) {
		        return nativeKeysIn(object);
		      }
		      var isProto = isPrototype(object),
		          result = [];

		      for (var key in object) {
		        if (!(key == 'constructor' && (isProto || !hasOwnProperty.call(object, key)))) {
		          result.push(key);
		        }
		      }
		      return result;
		    }

		    /**
		     * The base implementation of `_.lt` which doesn't coerce arguments.
		     *
		     * @private
		     * @param {*} value The value to compare.
		     * @param {*} other The other value to compare.
		     * @returns {boolean} Returns `true` if `value` is less than `other`,
		     *  else `false`.
		     */
		    function baseLt(value, other) {
		      return value < other;
		    }

		    /**
		     * The base implementation of `_.map` without support for iteratee shorthands.
		     *
		     * @private
		     * @param {Array|Object} collection The collection to iterate over.
		     * @param {Function} iteratee The function invoked per iteration.
		     * @returns {Array} Returns the new mapped array.
		     */
		    function baseMap(collection, iteratee) {
		      var index = -1,
		          result = isArrayLike(collection) ? Array(collection.length) : [];

		      baseEach(collection, function(value, key, collection) {
		        result[++index] = iteratee(value, key, collection);
		      });
		      return result;
		    }

		    /**
		     * The base implementation of `_.matches` which doesn't clone `source`.
		     *
		     * @private
		     * @param {Object} source The object of property values to match.
		     * @returns {Function} Returns the new spec function.
		     */
		    function baseMatches(source) {
		      var matchData = getMatchData(source);
		      if (matchData.length == 1 && matchData[0][2]) {
		        return matchesStrictComparable(matchData[0][0], matchData[0][1]);
		      }
		      return function(object) {
		        return object === source || baseIsMatch(object, source, matchData);
		      };
		    }

		    /**
		     * The base implementation of `_.matchesProperty` which doesn't clone `srcValue`.
		     *
		     * @private
		     * @param {string} path The path of the property to get.
		     * @param {*} srcValue The value to match.
		     * @returns {Function} Returns the new spec function.
		     */
		    function baseMatchesProperty(path, srcValue) {
		      if (isKey(path) && isStrictComparable(srcValue)) {
		        return matchesStrictComparable(toKey(path), srcValue);
		      }
		      return function(object) {
		        var objValue = get(object, path);
		        return (objValue === undefined$1 && objValue === srcValue)
		          ? hasIn(object, path)
		          : baseIsEqual(srcValue, objValue, COMPARE_PARTIAL_FLAG | COMPARE_UNORDERED_FLAG);
		      };
		    }

		    /**
		     * The base implementation of `_.merge` without support for multiple sources.
		     *
		     * @private
		     * @param {Object} object The destination object.
		     * @param {Object} source The source object.
		     * @param {number} srcIndex The index of `source`.
		     * @param {Function} [customizer] The function to customize merged values.
		     * @param {Object} [stack] Tracks traversed source values and their merged
		     *  counterparts.
		     */
		    function baseMerge(object, source, srcIndex, customizer, stack) {
		      if (object === source) {
		        return;
		      }
		      baseFor(source, function(srcValue, key) {
		        stack || (stack = new Stack);
		        if (isObject(srcValue)) {
		          baseMergeDeep(object, source, key, srcIndex, baseMerge, customizer, stack);
		        }
		        else {
		          var newValue = customizer
		            ? customizer(safeGet(object, key), srcValue, (key + ''), object, source, stack)
		            : undefined$1;

		          if (newValue === undefined$1) {
		            newValue = srcValue;
		          }
		          assignMergeValue(object, key, newValue);
		        }
		      }, keysIn);
		    }

		    /**
		     * A specialized version of `baseMerge` for arrays and objects which performs
		     * deep merges and tracks traversed objects enabling objects with circular
		     * references to be merged.
		     *
		     * @private
		     * @param {Object} object The destination object.
		     * @param {Object} source The source object.
		     * @param {string} key The key of the value to merge.
		     * @param {number} srcIndex The index of `source`.
		     * @param {Function} mergeFunc The function to merge values.
		     * @param {Function} [customizer] The function to customize assigned values.
		     * @param {Object} [stack] Tracks traversed source values and their merged
		     *  counterparts.
		     */
		    function baseMergeDeep(object, source, key, srcIndex, mergeFunc, customizer, stack) {
		      var objValue = safeGet(object, key),
		          srcValue = safeGet(source, key),
		          stacked = stack.get(srcValue);

		      if (stacked) {
		        assignMergeValue(object, key, stacked);
		        return;
		      }
		      var newValue = customizer
		        ? customizer(objValue, srcValue, (key + ''), object, source, stack)
		        : undefined$1;

		      var isCommon = newValue === undefined$1;

		      if (isCommon) {
		        var isArr = isArray(srcValue),
		            isBuff = !isArr && isBuffer(srcValue),
		            isTyped = !isArr && !isBuff && isTypedArray(srcValue);

		        newValue = srcValue;
		        if (isArr || isBuff || isTyped) {
		          if (isArray(objValue)) {
		            newValue = objValue;
		          }
		          else if (isArrayLikeObject(objValue)) {
		            newValue = copyArray(objValue);
		          }
		          else if (isBuff) {
		            isCommon = false;
		            newValue = cloneBuffer(srcValue, true);
		          }
		          else if (isTyped) {
		            isCommon = false;
		            newValue = cloneTypedArray(srcValue, true);
		          }
		          else {
		            newValue = [];
		          }
		        }
		        else if (isPlainObject(srcValue) || isArguments(srcValue)) {
		          newValue = objValue;
		          if (isArguments(objValue)) {
		            newValue = toPlainObject(objValue);
		          }
		          else if (!isObject(objValue) || isFunction(objValue)) {
		            newValue = initCloneObject(srcValue);
		          }
		        }
		        else {
		          isCommon = false;
		        }
		      }
		      if (isCommon) {
		        // Recursively merge objects and arrays (susceptible to call stack limits).
		        stack.set(srcValue, newValue);
		        mergeFunc(newValue, srcValue, srcIndex, customizer, stack);
		        stack['delete'](srcValue);
		      }
		      assignMergeValue(object, key, newValue);
		    }

		    /**
		     * The base implementation of `_.nth` which doesn't coerce arguments.
		     *
		     * @private
		     * @param {Array} array The array to query.
		     * @param {number} n The index of the element to return.
		     * @returns {*} Returns the nth element of `array`.
		     */
		    function baseNth(array, n) {
		      var length = array.length;
		      if (!length) {
		        return;
		      }
		      n += n < 0 ? length : 0;
		      return isIndex(n, length) ? array[n] : undefined$1;
		    }

		    /**
		     * The base implementation of `_.orderBy` without param guards.
		     *
		     * @private
		     * @param {Array|Object} collection The collection to iterate over.
		     * @param {Function[]|Object[]|string[]} iteratees The iteratees to sort by.
		     * @param {string[]} orders The sort orders of `iteratees`.
		     * @returns {Array} Returns the new sorted array.
		     */
		    function baseOrderBy(collection, iteratees, orders) {
		      if (iteratees.length) {
		        iteratees = arrayMap(iteratees, function(iteratee) {
		          if (isArray(iteratee)) {
		            return function(value) {
		              return baseGet(value, iteratee.length === 1 ? iteratee[0] : iteratee);
		            }
		          }
		          return iteratee;
		        });
		      } else {
		        iteratees = [identity];
		      }

		      var index = -1;
		      iteratees = arrayMap(iteratees, baseUnary(getIteratee()));

		      var result = baseMap(collection, function(value, key, collection) {
		        var criteria = arrayMap(iteratees, function(iteratee) {
		          return iteratee(value);
		        });
		        return { 'criteria': criteria, 'index': ++index, 'value': value };
		      });

		      return baseSortBy(result, function(object, other) {
		        return compareMultiple(object, other, orders);
		      });
		    }

		    /**
		     * The base implementation of `_.pick` without support for individual
		     * property identifiers.
		     *
		     * @private
		     * @param {Object} object The source object.
		     * @param {string[]} paths The property paths to pick.
		     * @returns {Object} Returns the new object.
		     */
		    function basePick(object, paths) {
		      return basePickBy(object, paths, function(value, path) {
		        return hasIn(object, path);
		      });
		    }

		    /**
		     * The base implementation of  `_.pickBy` without support for iteratee shorthands.
		     *
		     * @private
		     * @param {Object} object The source object.
		     * @param {string[]} paths The property paths to pick.
		     * @param {Function} predicate The function invoked per property.
		     * @returns {Object} Returns the new object.
		     */
		    function basePickBy(object, paths, predicate) {
		      var index = -1,
		          length = paths.length,
		          result = {};

		      while (++index < length) {
		        var path = paths[index],
		            value = baseGet(object, path);

		        if (predicate(value, path)) {
		          baseSet(result, castPath(path, object), value);
		        }
		      }
		      return result;
		    }

		    /**
		     * A specialized version of `baseProperty` which supports deep paths.
		     *
		     * @private
		     * @param {Array|string} path The path of the property to get.
		     * @returns {Function} Returns the new accessor function.
		     */
		    function basePropertyDeep(path) {
		      return function(object) {
		        return baseGet(object, path);
		      };
		    }

		    /**
		     * The base implementation of `_.pullAllBy` without support for iteratee
		     * shorthands.
		     *
		     * @private
		     * @param {Array} array The array to modify.
		     * @param {Array} values The values to remove.
		     * @param {Function} [iteratee] The iteratee invoked per element.
		     * @param {Function} [comparator] The comparator invoked per element.
		     * @returns {Array} Returns `array`.
		     */
		    function basePullAll(array, values, iteratee, comparator) {
		      var indexOf = comparator ? baseIndexOfWith : baseIndexOf,
		          index = -1,
		          length = values.length,
		          seen = array;

		      if (array === values) {
		        values = copyArray(values);
		      }
		      if (iteratee) {
		        seen = arrayMap(array, baseUnary(iteratee));
		      }
		      while (++index < length) {
		        var fromIndex = 0,
		            value = values[index],
		            computed = iteratee ? iteratee(value) : value;

		        while ((fromIndex = indexOf(seen, computed, fromIndex, comparator)) > -1) {
		          if (seen !== array) {
		            splice.call(seen, fromIndex, 1);
		          }
		          splice.call(array, fromIndex, 1);
		        }
		      }
		      return array;
		    }

		    /**
		     * The base implementation of `_.pullAt` without support for individual
		     * indexes or capturing the removed elements.
		     *
		     * @private
		     * @param {Array} array The array to modify.
		     * @param {number[]} indexes The indexes of elements to remove.
		     * @returns {Array} Returns `array`.
		     */
		    function basePullAt(array, indexes) {
		      var length = array ? indexes.length : 0,
		          lastIndex = length - 1;

		      while (length--) {
		        var index = indexes[length];
		        if (length == lastIndex || index !== previous) {
		          var previous = index;
		          if (isIndex(index)) {
		            splice.call(array, index, 1);
		          } else {
		            baseUnset(array, index);
		          }
		        }
		      }
		      return array;
		    }

		    /**
		     * The base implementation of `_.random` without support for returning
		     * floating-point numbers.
		     *
		     * @private
		     * @param {number} lower The lower bound.
		     * @param {number} upper The upper bound.
		     * @returns {number} Returns the random number.
		     */
		    function baseRandom(lower, upper) {
		      return lower + nativeFloor(nativeRandom() * (upper - lower + 1));
		    }

		    /**
		     * The base implementation of `_.range` and `_.rangeRight` which doesn't
		     * coerce arguments.
		     *
		     * @private
		     * @param {number} start The start of the range.
		     * @param {number} end The end of the range.
		     * @param {number} step The value to increment or decrement by.
		     * @param {boolean} [fromRight] Specify iterating from right to left.
		     * @returns {Array} Returns the range of numbers.
		     */
		    function baseRange(start, end, step, fromRight) {
		      var index = -1,
		          length = nativeMax(nativeCeil((end - start) / (step || 1)), 0),
		          result = Array(length);

		      while (length--) {
		        result[fromRight ? length : ++index] = start;
		        start += step;
		      }
		      return result;
		    }

		    /**
		     * The base implementation of `_.repeat` which doesn't coerce arguments.
		     *
		     * @private
		     * @param {string} string The string to repeat.
		     * @param {number} n The number of times to repeat the string.
		     * @returns {string} Returns the repeated string.
		     */
		    function baseRepeat(string, n) {
		      var result = '';
		      if (!string || n < 1 || n > MAX_SAFE_INTEGER) {
		        return result;
		      }
		      // Leverage the exponentiation by squaring algorithm for a faster repeat.
		      // See https://en.wikipedia.org/wiki/Exponentiation_by_squaring for more details.
		      do {
		        if (n % 2) {
		          result += string;
		        }
		        n = nativeFloor(n / 2);
		        if (n) {
		          string += string;
		        }
		      } while (n);

		      return result;
		    }

		    /**
		     * The base implementation of `_.rest` which doesn't validate or coerce arguments.
		     *
		     * @private
		     * @param {Function} func The function to apply a rest parameter to.
		     * @param {number} [start=func.length-1] The start position of the rest parameter.
		     * @returns {Function} Returns the new function.
		     */
		    function baseRest(func, start) {
		      return setToString(overRest(func, start, identity), func + '');
		    }

		    /**
		     * The base implementation of `_.sample`.
		     *
		     * @private
		     * @param {Array|Object} collection The collection to sample.
		     * @returns {*} Returns the random element.
		     */
		    function baseSample(collection) {
		      return arraySample(values(collection));
		    }

		    /**
		     * The base implementation of `_.sampleSize` without param guards.
		     *
		     * @private
		     * @param {Array|Object} collection The collection to sample.
		     * @param {number} n The number of elements to sample.
		     * @returns {Array} Returns the random elements.
		     */
		    function baseSampleSize(collection, n) {
		      var array = values(collection);
		      return shuffleSelf(array, baseClamp(n, 0, array.length));
		    }

		    /**
		     * The base implementation of `_.set`.
		     *
		     * @private
		     * @param {Object} object The object to modify.
		     * @param {Array|string} path The path of the property to set.
		     * @param {*} value The value to set.
		     * @param {Function} [customizer] The function to customize path creation.
		     * @returns {Object} Returns `object`.
		     */
		    function baseSet(object, path, value, customizer) {
		      if (!isObject(object)) {
		        return object;
		      }
		      path = castPath(path, object);

		      var index = -1,
		          length = path.length,
		          lastIndex = length - 1,
		          nested = object;

		      while (nested != null && ++index < length) {
		        var key = toKey(path[index]),
		            newValue = value;

		        if (key === '__proto__' || key === 'constructor' || key === 'prototype') {
		          return object;
		        }

		        if (index != lastIndex) {
		          var objValue = nested[key];
		          newValue = customizer ? customizer(objValue, key, nested) : undefined$1;
		          if (newValue === undefined$1) {
		            newValue = isObject(objValue)
		              ? objValue
		              : (isIndex(path[index + 1]) ? [] : {});
		          }
		        }
		        assignValue(nested, key, newValue);
		        nested = nested[key];
		      }
		      return object;
		    }

		    /**
		     * The base implementation of `setData` without support for hot loop shorting.
		     *
		     * @private
		     * @param {Function} func The function to associate metadata with.
		     * @param {*} data The metadata.
		     * @returns {Function} Returns `func`.
		     */
		    var baseSetData = !metaMap ? identity : function(func, data) {
		      metaMap.set(func, data);
		      return func;
		    };

		    /**
		     * The base implementation of `setToString` without support for hot loop shorting.
		     *
		     * @private
		     * @param {Function} func The function to modify.
		     * @param {Function} string The `toString` result.
		     * @returns {Function} Returns `func`.
		     */
		    var baseSetToString = !defineProperty ? identity : function(func, string) {
		      return defineProperty(func, 'toString', {
		        'configurable': true,
		        'enumerable': false,
		        'value': constant(string),
		        'writable': true
		      });
		    };

		    /**
		     * The base implementation of `_.shuffle`.
		     *
		     * @private
		     * @param {Array|Object} collection The collection to shuffle.
		     * @returns {Array} Returns the new shuffled array.
		     */
		    function baseShuffle(collection) {
		      return shuffleSelf(values(collection));
		    }

		    /**
		     * The base implementation of `_.slice` without an iteratee call guard.
		     *
		     * @private
		     * @param {Array} array The array to slice.
		     * @param {number} [start=0] The start position.
		     * @param {number} [end=array.length] The end position.
		     * @returns {Array} Returns the slice of `array`.
		     */
		    function baseSlice(array, start, end) {
		      var index = -1,
		          length = array.length;

		      if (start < 0) {
		        start = -start > length ? 0 : (length + start);
		      }
		      end = end > length ? length : end;
		      if (end < 0) {
		        end += length;
		      }
		      length = start > end ? 0 : ((end - start) >>> 0);
		      start >>>= 0;

		      var result = Array(length);
		      while (++index < length) {
		        result[index] = array[index + start];
		      }
		      return result;
		    }

		    /**
		     * The base implementation of `_.some` without support for iteratee shorthands.
		     *
		     * @private
		     * @param {Array|Object} collection The collection to iterate over.
		     * @param {Function} predicate The function invoked per iteration.
		     * @returns {boolean} Returns `true` if any element passes the predicate check,
		     *  else `false`.
		     */
		    function baseSome(collection, predicate) {
		      var result;

		      baseEach(collection, function(value, index, collection) {
		        result = predicate(value, index, collection);
		        return !result;
		      });
		      return !!result;
		    }

		    /**
		     * The base implementation of `_.sortedIndex` and `_.sortedLastIndex` which
		     * performs a binary search of `array` to determine the index at which `value`
		     * should be inserted into `array` in order to maintain its sort order.
		     *
		     * @private
		     * @param {Array} array The sorted array to inspect.
		     * @param {*} value The value to evaluate.
		     * @param {boolean} [retHighest] Specify returning the highest qualified index.
		     * @returns {number} Returns the index at which `value` should be inserted
		     *  into `array`.
		     */
		    function baseSortedIndex(array, value, retHighest) {
		      var low = 0,
		          high = array == null ? low : array.length;

		      if (typeof value == 'number' && value === value && high <= HALF_MAX_ARRAY_LENGTH) {
		        while (low < high) {
		          var mid = (low + high) >>> 1,
		              computed = array[mid];

		          if (computed !== null && !isSymbol(computed) &&
		              (retHighest ? (computed <= value) : (computed < value))) {
		            low = mid + 1;
		          } else {
		            high = mid;
		          }
		        }
		        return high;
		      }
		      return baseSortedIndexBy(array, value, identity, retHighest);
		    }

		    /**
		     * The base implementation of `_.sortedIndexBy` and `_.sortedLastIndexBy`
		     * which invokes `iteratee` for `value` and each element of `array` to compute
		     * their sort ranking. The iteratee is invoked with one argument; (value).
		     *
		     * @private
		     * @param {Array} array The sorted array to inspect.
		     * @param {*} value The value to evaluate.
		     * @param {Function} iteratee The iteratee invoked per element.
		     * @param {boolean} [retHighest] Specify returning the highest qualified index.
		     * @returns {number} Returns the index at which `value` should be inserted
		     *  into `array`.
		     */
		    function baseSortedIndexBy(array, value, iteratee, retHighest) {
		      var low = 0,
		          high = array == null ? 0 : array.length;
		      if (high === 0) {
		        return 0;
		      }

		      value = iteratee(value);
		      var valIsNaN = value !== value,
		          valIsNull = value === null,
		          valIsSymbol = isSymbol(value),
		          valIsUndefined = value === undefined$1;

		      while (low < high) {
		        var mid = nativeFloor((low + high) / 2),
		            computed = iteratee(array[mid]),
		            othIsDefined = computed !== undefined$1,
		            othIsNull = computed === null,
		            othIsReflexive = computed === computed,
		            othIsSymbol = isSymbol(computed);

		        if (valIsNaN) {
		          var setLow = retHighest || othIsReflexive;
		        } else if (valIsUndefined) {
		          setLow = othIsReflexive && (retHighest || othIsDefined);
		        } else if (valIsNull) {
		          setLow = othIsReflexive && othIsDefined && (retHighest || !othIsNull);
		        } else if (valIsSymbol) {
		          setLow = othIsReflexive && othIsDefined && !othIsNull && (retHighest || !othIsSymbol);
		        } else if (othIsNull || othIsSymbol) {
		          setLow = false;
		        } else {
		          setLow = retHighest ? (computed <= value) : (computed < value);
		        }
		        if (setLow) {
		          low = mid + 1;
		        } else {
		          high = mid;
		        }
		      }
		      return nativeMin(high, MAX_ARRAY_INDEX);
		    }

		    /**
		     * The base implementation of `_.sortedUniq` and `_.sortedUniqBy` without
		     * support for iteratee shorthands.
		     *
		     * @private
		     * @param {Array} array The array to inspect.
		     * @param {Function} [iteratee] The iteratee invoked per element.
		     * @returns {Array} Returns the new duplicate free array.
		     */
		    function baseSortedUniq(array, iteratee) {
		      var index = -1,
		          length = array.length,
		          resIndex = 0,
		          result = [];

		      while (++index < length) {
		        var value = array[index],
		            computed = iteratee ? iteratee(value) : value;

		        if (!index || !eq(computed, seen)) {
		          var seen = computed;
		          result[resIndex++] = value === 0 ? 0 : value;
		        }
		      }
		      return result;
		    }

		    /**
		     * The base implementation of `_.toNumber` which doesn't ensure correct
		     * conversions of binary, hexadecimal, or octal string values.
		     *
		     * @private
		     * @param {*} value The value to process.
		     * @returns {number} Returns the number.
		     */
		    function baseToNumber(value) {
		      if (typeof value == 'number') {
		        return value;
		      }
		      if (isSymbol(value)) {
		        return NAN;
		      }
		      return +value;
		    }

		    /**
		     * The base implementation of `_.toString` which doesn't convert nullish
		     * values to empty strings.
		     *
		     * @private
		     * @param {*} value The value to process.
		     * @returns {string} Returns the string.
		     */
		    function baseToString(value) {
		      // Exit early for strings to avoid a performance hit in some environments.
		      if (typeof value == 'string') {
		        return value;
		      }
		      if (isArray(value)) {
		        // Recursively convert values (susceptible to call stack limits).
		        return arrayMap(value, baseToString) + '';
		      }
		      if (isSymbol(value)) {
		        return symbolToString ? symbolToString.call(value) : '';
		      }
		      var result = (value + '');
		      return (result == '0' && (1 / value) == -INFINITY) ? '-0' : result;
		    }

		    /**
		     * The base implementation of `_.uniqBy` without support for iteratee shorthands.
		     *
		     * @private
		     * @param {Array} array The array to inspect.
		     * @param {Function} [iteratee] The iteratee invoked per element.
		     * @param {Function} [comparator] The comparator invoked per element.
		     * @returns {Array} Returns the new duplicate free array.
		     */
		    function baseUniq(array, iteratee, comparator) {
		      var index = -1,
		          includes = arrayIncludes,
		          length = array.length,
		          isCommon = true,
		          result = [],
		          seen = result;

		      if (comparator) {
		        isCommon = false;
		        includes = arrayIncludesWith;
		      }
		      else if (length >= LARGE_ARRAY_SIZE) {
		        var set = iteratee ? null : createSet(array);
		        if (set) {
		          return setToArray(set);
		        }
		        isCommon = false;
		        includes = cacheHas;
		        seen = new SetCache;
		      }
		      else {
		        seen = iteratee ? [] : result;
		      }
		      outer:
		      while (++index < length) {
		        var value = array[index],
		            computed = iteratee ? iteratee(value) : value;

		        value = (comparator || value !== 0) ? value : 0;
		        if (isCommon && computed === computed) {
		          var seenIndex = seen.length;
		          while (seenIndex--) {
		            if (seen[seenIndex] === computed) {
		              continue outer;
		            }
		          }
		          if (iteratee) {
		            seen.push(computed);
		          }
		          result.push(value);
		        }
		        else if (!includes(seen, computed, comparator)) {
		          if (seen !== result) {
		            seen.push(computed);
		          }
		          result.push(value);
		        }
		      }
		      return result;
		    }

		    /**
		     * The base implementation of `_.unset`.
		     *
		     * @private
		     * @param {Object} object The object to modify.
		     * @param {Array|string} path The property path to unset.
		     * @returns {boolean} Returns `true` if the property is deleted, else `false`.
		     */
		    function baseUnset(object, path) {
		      path = castPath(path, object);
		      object = parent(object, path);
		      return object == null || delete object[toKey(last(path))];
		    }

		    /**
		     * The base implementation of `_.update`.
		     *
		     * @private
		     * @param {Object} object The object to modify.
		     * @param {Array|string} path The path of the property to update.
		     * @param {Function} updater The function to produce the updated value.
		     * @param {Function} [customizer] The function to customize path creation.
		     * @returns {Object} Returns `object`.
		     */
		    function baseUpdate(object, path, updater, customizer) {
		      return baseSet(object, path, updater(baseGet(object, path)), customizer);
		    }

		    /**
		     * The base implementation of methods like `_.dropWhile` and `_.takeWhile`
		     * without support for iteratee shorthands.
		     *
		     * @private
		     * @param {Array} array The array to query.
		     * @param {Function} predicate The function invoked per iteration.
		     * @param {boolean} [isDrop] Specify dropping elements instead of taking them.
		     * @param {boolean} [fromRight] Specify iterating from right to left.
		     * @returns {Array} Returns the slice of `array`.
		     */
		    function baseWhile(array, predicate, isDrop, fromRight) {
		      var length = array.length,
		          index = fromRight ? length : -1;

		      while ((fromRight ? index-- : ++index < length) &&
		        predicate(array[index], index, array)) {}

		      return isDrop
		        ? baseSlice(array, (fromRight ? 0 : index), (fromRight ? index + 1 : length))
		        : baseSlice(array, (fromRight ? index + 1 : 0), (fromRight ? length : index));
		    }

		    /**
		     * The base implementation of `wrapperValue` which returns the result of
		     * performing a sequence of actions on the unwrapped `value`, where each
		     * successive action is supplied the return value of the previous.
		     *
		     * @private
		     * @param {*} value The unwrapped value.
		     * @param {Array} actions Actions to perform to resolve the unwrapped value.
		     * @returns {*} Returns the resolved value.
		     */
		    function baseWrapperValue(value, actions) {
		      var result = value;
		      if (result instanceof LazyWrapper) {
		        result = result.value();
		      }
		      return arrayReduce(actions, function(result, action) {
		        return action.func.apply(action.thisArg, arrayPush([result], action.args));
		      }, result);
		    }

		    /**
		     * The base implementation of methods like `_.xor`, without support for
		     * iteratee shorthands, that accepts an array of arrays to inspect.
		     *
		     * @private
		     * @param {Array} arrays The arrays to inspect.
		     * @param {Function} [iteratee] The iteratee invoked per element.
		     * @param {Function} [comparator] The comparator invoked per element.
		     * @returns {Array} Returns the new array of values.
		     */
		    function baseXor(arrays, iteratee, comparator) {
		      var length = arrays.length;
		      if (length < 2) {
		        return length ? baseUniq(arrays[0]) : [];
		      }
		      var index = -1,
		          result = Array(length);

		      while (++index < length) {
		        var array = arrays[index],
		            othIndex = -1;

		        while (++othIndex < length) {
		          if (othIndex != index) {
		            result[index] = baseDifference(result[index] || array, arrays[othIndex], iteratee, comparator);
		          }
		        }
		      }
		      return baseUniq(baseFlatten(result, 1), iteratee, comparator);
		    }

		    /**
		     * This base implementation of `_.zipObject` which assigns values using `assignFunc`.
		     *
		     * @private
		     * @param {Array} props The property identifiers.
		     * @param {Array} values The property values.
		     * @param {Function} assignFunc The function to assign values.
		     * @returns {Object} Returns the new object.
		     */
		    function baseZipObject(props, values, assignFunc) {
		      var index = -1,
		          length = props.length,
		          valsLength = values.length,
		          result = {};

		      while (++index < length) {
		        var value = index < valsLength ? values[index] : undefined$1;
		        assignFunc(result, props[index], value);
		      }
		      return result;
		    }

		    /**
		     * Casts `value` to an empty array if it's not an array like object.
		     *
		     * @private
		     * @param {*} value The value to inspect.
		     * @returns {Array|Object} Returns the cast array-like object.
		     */
		    function castArrayLikeObject(value) {
		      return isArrayLikeObject(value) ? value : [];
		    }

		    /**
		     * Casts `value` to `identity` if it's not a function.
		     *
		     * @private
		     * @param {*} value The value to inspect.
		     * @returns {Function} Returns cast function.
		     */
		    function castFunction(value) {
		      return typeof value == 'function' ? value : identity;
		    }

		    /**
		     * Casts `value` to a path array if it's not one.
		     *
		     * @private
		     * @param {*} value The value to inspect.
		     * @param {Object} [object] The object to query keys on.
		     * @returns {Array} Returns the cast property path array.
		     */
		    function castPath(value, object) {
		      if (isArray(value)) {
		        return value;
		      }
		      return isKey(value, object) ? [value] : stringToPath(toString(value));
		    }

		    /**
		     * A `baseRest` alias which can be replaced with `identity` by module
		     * replacement plugins.
		     *
		     * @private
		     * @type {Function}
		     * @param {Function} func The function to apply a rest parameter to.
		     * @returns {Function} Returns the new function.
		     */
		    var castRest = baseRest;

		    /**
		     * Casts `array` to a slice if it's needed.
		     *
		     * @private
		     * @param {Array} array The array to inspect.
		     * @param {number} start The start position.
		     * @param {number} [end=array.length] The end position.
		     * @returns {Array} Returns the cast slice.
		     */
		    function castSlice(array, start, end) {
		      var length = array.length;
		      end = end === undefined$1 ? length : end;
		      return (!start && end >= length) ? array : baseSlice(array, start, end);
		    }

		    /**
		     * A simple wrapper around the global [`clearTimeout`](https://mdn.io/clearTimeout).
		     *
		     * @private
		     * @param {number|Object} id The timer id or timeout object of the timer to clear.
		     */
		    var clearTimeout = ctxClearTimeout || function(id) {
		      return root.clearTimeout(id);
		    };

		    /**
		     * Creates a clone of  `buffer`.
		     *
		     * @private
		     * @param {Buffer} buffer The buffer to clone.
		     * @param {boolean} [isDeep] Specify a deep clone.
		     * @returns {Buffer} Returns the cloned buffer.
		     */
		    function cloneBuffer(buffer, isDeep) {
		      if (isDeep) {
		        return buffer.slice();
		      }
		      var length = buffer.length,
		          result = allocUnsafe ? allocUnsafe(length) : new buffer.constructor(length);

		      buffer.copy(result);
		      return result;
		    }

		    /**
		     * Creates a clone of `arrayBuffer`.
		     *
		     * @private
		     * @param {ArrayBuffer} arrayBuffer The array buffer to clone.
		     * @returns {ArrayBuffer} Returns the cloned array buffer.
		     */
		    function cloneArrayBuffer(arrayBuffer) {
		      var result = new arrayBuffer.constructor(arrayBuffer.byteLength);
		      new Uint8Array(result).set(new Uint8Array(arrayBuffer));
		      return result;
		    }

		    /**
		     * Creates a clone of `dataView`.
		     *
		     * @private
		     * @param {Object} dataView The data view to clone.
		     * @param {boolean} [isDeep] Specify a deep clone.
		     * @returns {Object} Returns the cloned data view.
		     */
		    function cloneDataView(dataView, isDeep) {
		      var buffer = isDeep ? cloneArrayBuffer(dataView.buffer) : dataView.buffer;
		      return new dataView.constructor(buffer, dataView.byteOffset, dataView.byteLength);
		    }

		    /**
		     * Creates a clone of `regexp`.
		     *
		     * @private
		     * @param {Object} regexp The regexp to clone.
		     * @returns {Object} Returns the cloned regexp.
		     */
		    function cloneRegExp(regexp) {
		      var result = new regexp.constructor(regexp.source, reFlags.exec(regexp));
		      result.lastIndex = regexp.lastIndex;
		      return result;
		    }

		    /**
		     * Creates a clone of the `symbol` object.
		     *
		     * @private
		     * @param {Object} symbol The symbol object to clone.
		     * @returns {Object} Returns the cloned symbol object.
		     */
		    function cloneSymbol(symbol) {
		      return symbolValueOf ? Object(symbolValueOf.call(symbol)) : {};
		    }

		    /**
		     * Creates a clone of `typedArray`.
		     *
		     * @private
		     * @param {Object} typedArray The typed array to clone.
		     * @param {boolean} [isDeep] Specify a deep clone.
		     * @returns {Object} Returns the cloned typed array.
		     */
		    function cloneTypedArray(typedArray, isDeep) {
		      var buffer = isDeep ? cloneArrayBuffer(typedArray.buffer) : typedArray.buffer;
		      return new typedArray.constructor(buffer, typedArray.byteOffset, typedArray.length);
		    }

		    /**
		     * Compares values to sort them in ascending order.
		     *
		     * @private
		     * @param {*} value The value to compare.
		     * @param {*} other The other value to compare.
		     * @returns {number} Returns the sort order indicator for `value`.
		     */
		    function compareAscending(value, other) {
		      if (value !== other) {
		        var valIsDefined = value !== undefined$1,
		            valIsNull = value === null,
		            valIsReflexive = value === value,
		            valIsSymbol = isSymbol(value);

		        var othIsDefined = other !== undefined$1,
		            othIsNull = other === null,
		            othIsReflexive = other === other,
		            othIsSymbol = isSymbol(other);

		        if ((!othIsNull && !othIsSymbol && !valIsSymbol && value > other) ||
		            (valIsSymbol && othIsDefined && othIsReflexive && !othIsNull && !othIsSymbol) ||
		            (valIsNull && othIsDefined && othIsReflexive) ||
		            (!valIsDefined && othIsReflexive) ||
		            !valIsReflexive) {
		          return 1;
		        }
		        if ((!valIsNull && !valIsSymbol && !othIsSymbol && value < other) ||
		            (othIsSymbol && valIsDefined && valIsReflexive && !valIsNull && !valIsSymbol) ||
		            (othIsNull && valIsDefined && valIsReflexive) ||
		            (!othIsDefined && valIsReflexive) ||
		            !othIsReflexive) {
		          return -1;
		        }
		      }
		      return 0;
		    }

		    /**
		     * Used by `_.orderBy` to compare multiple properties of a value to another
		     * and stable sort them.
		     *
		     * If `orders` is unspecified, all values are sorted in ascending order. Otherwise,
		     * specify an order of "desc" for descending or "asc" for ascending sort order
		     * of corresponding values.
		     *
		     * @private
		     * @param {Object} object The object to compare.
		     * @param {Object} other The other object to compare.
		     * @param {boolean[]|string[]} orders The order to sort by for each property.
		     * @returns {number} Returns the sort order indicator for `object`.
		     */
		    function compareMultiple(object, other, orders) {
		      var index = -1,
		          objCriteria = object.criteria,
		          othCriteria = other.criteria,
		          length = objCriteria.length,
		          ordersLength = orders.length;

		      while (++index < length) {
		        var result = compareAscending(objCriteria[index], othCriteria[index]);
		        if (result) {
		          if (index >= ordersLength) {
		            return result;
		          }
		          var order = orders[index];
		          return result * (order == 'desc' ? -1 : 1);
		        }
		      }
		      // Fixes an `Array#sort` bug in the JS engine embedded in Adobe applications
		      // that causes it, under certain circumstances, to provide the same value for
		      // `object` and `other`. See https://github.com/jashkenas/underscore/pull/1247
		      // for more details.
		      //
		      // This also ensures a stable sort in V8 and other engines.
		      // See https://bugs.chromium.org/p/v8/issues/detail?id=90 for more details.
		      return object.index - other.index;
		    }

		    /**
		     * Creates an array that is the composition of partially applied arguments,
		     * placeholders, and provided arguments into a single array of arguments.
		     *
		     * @private
		     * @param {Array} args The provided arguments.
		     * @param {Array} partials The arguments to prepend to those provided.
		     * @param {Array} holders The `partials` placeholder indexes.
		     * @params {boolean} [isCurried] Specify composing for a curried function.
		     * @returns {Array} Returns the new array of composed arguments.
		     */
		    function composeArgs(args, partials, holders, isCurried) {
		      var argsIndex = -1,
		          argsLength = args.length,
		          holdersLength = holders.length,
		          leftIndex = -1,
		          leftLength = partials.length,
		          rangeLength = nativeMax(argsLength - holdersLength, 0),
		          result = Array(leftLength + rangeLength),
		          isUncurried = !isCurried;

		      while (++leftIndex < leftLength) {
		        result[leftIndex] = partials[leftIndex];
		      }
		      while (++argsIndex < holdersLength) {
		        if (isUncurried || argsIndex < argsLength) {
		          result[holders[argsIndex]] = args[argsIndex];
		        }
		      }
		      while (rangeLength--) {
		        result[leftIndex++] = args[argsIndex++];
		      }
		      return result;
		    }

		    /**
		     * This function is like `composeArgs` except that the arguments composition
		     * is tailored for `_.partialRight`.
		     *
		     * @private
		     * @param {Array} args The provided arguments.
		     * @param {Array} partials The arguments to append to those provided.
		     * @param {Array} holders The `partials` placeholder indexes.
		     * @params {boolean} [isCurried] Specify composing for a curried function.
		     * @returns {Array} Returns the new array of composed arguments.
		     */
		    function composeArgsRight(args, partials, holders, isCurried) {
		      var argsIndex = -1,
		          argsLength = args.length,
		          holdersIndex = -1,
		          holdersLength = holders.length,
		          rightIndex = -1,
		          rightLength = partials.length,
		          rangeLength = nativeMax(argsLength - holdersLength, 0),
		          result = Array(rangeLength + rightLength),
		          isUncurried = !isCurried;

		      while (++argsIndex < rangeLength) {
		        result[argsIndex] = args[argsIndex];
		      }
		      var offset = argsIndex;
		      while (++rightIndex < rightLength) {
		        result[offset + rightIndex] = partials[rightIndex];
		      }
		      while (++holdersIndex < holdersLength) {
		        if (isUncurried || argsIndex < argsLength) {
		          result[offset + holders[holdersIndex]] = args[argsIndex++];
		        }
		      }
		      return result;
		    }

		    /**
		     * Copies the values of `source` to `array`.
		     *
		     * @private
		     * @param {Array} source The array to copy values from.
		     * @param {Array} [array=[]] The array to copy values to.
		     * @returns {Array} Returns `array`.
		     */
		    function copyArray(source, array) {
		      var index = -1,
		          length = source.length;

		      array || (array = Array(length));
		      while (++index < length) {
		        array[index] = source[index];
		      }
		      return array;
		    }

		    /**
		     * Copies properties of `source` to `object`.
		     *
		     * @private
		     * @param {Object} source The object to copy properties from.
		     * @param {Array} props The property identifiers to copy.
		     * @param {Object} [object={}] The object to copy properties to.
		     * @param {Function} [customizer] The function to customize copied values.
		     * @returns {Object} Returns `object`.
		     */
		    function copyObject(source, props, object, customizer) {
		      var isNew = !object;
		      object || (object = {});

		      var index = -1,
		          length = props.length;

		      while (++index < length) {
		        var key = props[index];

		        var newValue = customizer
		          ? customizer(object[key], source[key], key, object, source)
		          : undefined$1;

		        if (newValue === undefined$1) {
		          newValue = source[key];
		        }
		        if (isNew) {
		          baseAssignValue(object, key, newValue);
		        } else {
		          assignValue(object, key, newValue);
		        }
		      }
		      return object;
		    }

		    /**
		     * Copies own symbols of `source` to `object`.
		     *
		     * @private
		     * @param {Object} source The object to copy symbols from.
		     * @param {Object} [object={}] The object to copy symbols to.
		     * @returns {Object} Returns `object`.
		     */
		    function copySymbols(source, object) {
		      return copyObject(source, getSymbols(source), object);
		    }

		    /**
		     * Copies own and inherited symbols of `source` to `object`.
		     *
		     * @private
		     * @param {Object} source The object to copy symbols from.
		     * @param {Object} [object={}] The object to copy symbols to.
		     * @returns {Object} Returns `object`.
		     */
		    function copySymbolsIn(source, object) {
		      return copyObject(source, getSymbolsIn(source), object);
		    }

		    /**
		     * Creates a function like `_.groupBy`.
		     *
		     * @private
		     * @param {Function} setter The function to set accumulator values.
		     * @param {Function} [initializer] The accumulator object initializer.
		     * @returns {Function} Returns the new aggregator function.
		     */
		    function createAggregator(setter, initializer) {
		      return function(collection, iteratee) {
		        var func = isArray(collection) ? arrayAggregator : baseAggregator,
		            accumulator = initializer ? initializer() : {};

		        return func(collection, setter, getIteratee(iteratee, 2), accumulator);
		      };
		    }

		    /**
		     * Creates a function like `_.assign`.
		     *
		     * @private
		     * @param {Function} assigner The function to assign values.
		     * @returns {Function} Returns the new assigner function.
		     */
		    function createAssigner(assigner) {
		      return baseRest(function(object, sources) {
		        var index = -1,
		            length = sources.length,
		            customizer = length > 1 ? sources[length - 1] : undefined$1,
		            guard = length > 2 ? sources[2] : undefined$1;

		        customizer = (assigner.length > 3 && typeof customizer == 'function')
		          ? (length--, customizer)
		          : undefined$1;

		        if (guard && isIterateeCall(sources[0], sources[1], guard)) {
		          customizer = length < 3 ? undefined$1 : customizer;
		          length = 1;
		        }
		        object = Object(object);
		        while (++index < length) {
		          var source = sources[index];
		          if (source) {
		            assigner(object, source, index, customizer);
		          }
		        }
		        return object;
		      });
		    }

		    /**
		     * Creates a `baseEach` or `baseEachRight` function.
		     *
		     * @private
		     * @param {Function} eachFunc The function to iterate over a collection.
		     * @param {boolean} [fromRight] Specify iterating from right to left.
		     * @returns {Function} Returns the new base function.
		     */
		    function createBaseEach(eachFunc, fromRight) {
		      return function(collection, iteratee) {
		        if (collection == null) {
		          return collection;
		        }
		        if (!isArrayLike(collection)) {
		          return eachFunc(collection, iteratee);
		        }
		        var length = collection.length,
		            index = fromRight ? length : -1,
		            iterable = Object(collection);

		        while ((fromRight ? index-- : ++index < length)) {
		          if (iteratee(iterable[index], index, iterable) === false) {
		            break;
		          }
		        }
		        return collection;
		      };
		    }

		    /**
		     * Creates a base function for methods like `_.forIn` and `_.forOwn`.
		     *
		     * @private
		     * @param {boolean} [fromRight] Specify iterating from right to left.
		     * @returns {Function} Returns the new base function.
		     */
		    function createBaseFor(fromRight) {
		      return function(object, iteratee, keysFunc) {
		        var index = -1,
		            iterable = Object(object),
		            props = keysFunc(object),
		            length = props.length;

		        while (length--) {
		          var key = props[fromRight ? length : ++index];
		          if (iteratee(iterable[key], key, iterable) === false) {
		            break;
		          }
		        }
		        return object;
		      };
		    }

		    /**
		     * Creates a function that wraps `func` to invoke it with the optional `this`
		     * binding of `thisArg`.
		     *
		     * @private
		     * @param {Function} func The function to wrap.
		     * @param {number} bitmask The bitmask flags. See `createWrap` for more details.
		     * @param {*} [thisArg] The `this` binding of `func`.
		     * @returns {Function} Returns the new wrapped function.
		     */
		    function createBind(func, bitmask, thisArg) {
		      var isBind = bitmask & WRAP_BIND_FLAG,
		          Ctor = createCtor(func);

		      function wrapper() {
		        var fn = (this && this !== root && this instanceof wrapper) ? Ctor : func;
		        return fn.apply(isBind ? thisArg : this, arguments);
		      }
		      return wrapper;
		    }

		    /**
		     * Creates a function like `_.lowerFirst`.
		     *
		     * @private
		     * @param {string} methodName The name of the `String` case method to use.
		     * @returns {Function} Returns the new case function.
		     */
		    function createCaseFirst(methodName) {
		      return function(string) {
		        string = toString(string);

		        var strSymbols = hasUnicode(string)
		          ? stringToArray(string)
		          : undefined$1;

		        var chr = strSymbols
		          ? strSymbols[0]
		          : string.charAt(0);

		        var trailing = strSymbols
		          ? castSlice(strSymbols, 1).join('')
		          : string.slice(1);

		        return chr[methodName]() + trailing;
		      };
		    }

		    /**
		     * Creates a function like `_.camelCase`.
		     *
		     * @private
		     * @param {Function} callback The function to combine each word.
		     * @returns {Function} Returns the new compounder function.
		     */
		    function createCompounder(callback) {
		      return function(string) {
		        return arrayReduce(words(deburr(string).replace(reApos, '')), callback, '');
		      };
		    }

		    /**
		     * Creates a function that produces an instance of `Ctor` regardless of
		     * whether it was invoked as part of a `new` expression or by `call` or `apply`.
		     *
		     * @private
		     * @param {Function} Ctor The constructor to wrap.
		     * @returns {Function} Returns the new wrapped function.
		     */
		    function createCtor(Ctor) {
		      return function() {
		        // Use a `switch` statement to work with class constructors. See
		        // http://ecma-international.org/ecma-262/7.0/#sec-ecmascript-function-objects-call-thisargument-argumentslist
		        // for more details.
		        var args = arguments;
		        switch (args.length) {
		          case 0: return new Ctor;
		          case 1: return new Ctor(args[0]);
		          case 2: return new Ctor(args[0], args[1]);
		          case 3: return new Ctor(args[0], args[1], args[2]);
		          case 4: return new Ctor(args[0], args[1], args[2], args[3]);
		          case 5: return new Ctor(args[0], args[1], args[2], args[3], args[4]);
		          case 6: return new Ctor(args[0], args[1], args[2], args[3], args[4], args[5]);
		          case 7: return new Ctor(args[0], args[1], args[2], args[3], args[4], args[5], args[6]);
		        }
		        var thisBinding = baseCreate(Ctor.prototype),
		            result = Ctor.apply(thisBinding, args);

		        // Mimic the constructor's `return` behavior.
		        // See https://es5.github.io/#x13.2.2 for more details.
		        return isObject(result) ? result : thisBinding;
		      };
		    }

		    /**
		     * Creates a function that wraps `func` to enable currying.
		     *
		     * @private
		     * @param {Function} func The function to wrap.
		     * @param {number} bitmask The bitmask flags. See `createWrap` for more details.
		     * @param {number} arity The arity of `func`.
		     * @returns {Function} Returns the new wrapped function.
		     */
		    function createCurry(func, bitmask, arity) {
		      var Ctor = createCtor(func);

		      function wrapper() {
		        var length = arguments.length,
		            args = Array(length),
		            index = length,
		            placeholder = getHolder(wrapper);

		        while (index--) {
		          args[index] = arguments[index];
		        }
		        var holders = (length < 3 && args[0] !== placeholder && args[length - 1] !== placeholder)
		          ? []
		          : replaceHolders(args, placeholder);

		        length -= holders.length;
		        if (length < arity) {
		          return createRecurry(
		            func, bitmask, createHybrid, wrapper.placeholder, undefined$1,
		            args, holders, undefined$1, undefined$1, arity - length);
		        }
		        var fn = (this && this !== root && this instanceof wrapper) ? Ctor : func;
		        return apply(fn, this, args);
		      }
		      return wrapper;
		    }

		    /**
		     * Creates a `_.find` or `_.findLast` function.
		     *
		     * @private
		     * @param {Function} findIndexFunc The function to find the collection index.
		     * @returns {Function} Returns the new find function.
		     */
		    function createFind(findIndexFunc) {
		      return function(collection, predicate, fromIndex) {
		        var iterable = Object(collection);
		        if (!isArrayLike(collection)) {
		          var iteratee = getIteratee(predicate, 3);
		          collection = keys(collection);
		          predicate = function(key) { return iteratee(iterable[key], key, iterable); };
		        }
		        var index = findIndexFunc(collection, predicate, fromIndex);
		        return index > -1 ? iterable[iteratee ? collection[index] : index] : undefined$1;
		      };
		    }

		    /**
		     * Creates a `_.flow` or `_.flowRight` function.
		     *
		     * @private
		     * @param {boolean} [fromRight] Specify iterating from right to left.
		     * @returns {Function} Returns the new flow function.
		     */
		    function createFlow(fromRight) {
		      return flatRest(function(funcs) {
		        var length = funcs.length,
		            index = length,
		            prereq = LodashWrapper.prototype.thru;

		        if (fromRight) {
		          funcs.reverse();
		        }
		        while (index--) {
		          var func = funcs[index];
		          if (typeof func != 'function') {
		            throw new TypeError(FUNC_ERROR_TEXT);
		          }
		          if (prereq && !wrapper && getFuncName(func) == 'wrapper') {
		            var wrapper = new LodashWrapper([], true);
		          }
		        }
		        index = wrapper ? index : length;
		        while (++index < length) {
		          func = funcs[index];

		          var funcName = getFuncName(func),
		              data = funcName == 'wrapper' ? getData(func) : undefined$1;

		          if (data && isLaziable(data[0]) &&
		                data[1] == (WRAP_ARY_FLAG | WRAP_CURRY_FLAG | WRAP_PARTIAL_FLAG | WRAP_REARG_FLAG) &&
		                !data[4].length && data[9] == 1
		              ) {
		            wrapper = wrapper[getFuncName(data[0])].apply(wrapper, data[3]);
		          } else {
		            wrapper = (func.length == 1 && isLaziable(func))
		              ? wrapper[funcName]()
		              : wrapper.thru(func);
		          }
		        }
		        return function() {
		          var args = arguments,
		              value = args[0];

		          if (wrapper && args.length == 1 && isArray(value)) {
		            return wrapper.plant(value).value();
		          }
		          var index = 0,
		              result = length ? funcs[index].apply(this, args) : value;

		          while (++index < length) {
		            result = funcs[index].call(this, result);
		          }
		          return result;
		        };
		      });
		    }

		    /**
		     * Creates a function that wraps `func` to invoke it with optional `this`
		     * binding of `thisArg`, partial application, and currying.
		     *
		     * @private
		     * @param {Function|string} func The function or method name to wrap.
		     * @param {number} bitmask The bitmask flags. See `createWrap` for more details.
		     * @param {*} [thisArg] The `this` binding of `func`.
		     * @param {Array} [partials] The arguments to prepend to those provided to
		     *  the new function.
		     * @param {Array} [holders] The `partials` placeholder indexes.
		     * @param {Array} [partialsRight] The arguments to append to those provided
		     *  to the new function.
		     * @param {Array} [holdersRight] The `partialsRight` placeholder indexes.
		     * @param {Array} [argPos] The argument positions of the new function.
		     * @param {number} [ary] The arity cap of `func`.
		     * @param {number} [arity] The arity of `func`.
		     * @returns {Function} Returns the new wrapped function.
		     */
		    function createHybrid(func, bitmask, thisArg, partials, holders, partialsRight, holdersRight, argPos, ary, arity) {
		      var isAry = bitmask & WRAP_ARY_FLAG,
		          isBind = bitmask & WRAP_BIND_FLAG,
		          isBindKey = bitmask & WRAP_BIND_KEY_FLAG,
		          isCurried = bitmask & (WRAP_CURRY_FLAG | WRAP_CURRY_RIGHT_FLAG),
		          isFlip = bitmask & WRAP_FLIP_FLAG,
		          Ctor = isBindKey ? undefined$1 : createCtor(func);

		      function wrapper() {
		        var length = arguments.length,
		            args = Array(length),
		            index = length;

		        while (index--) {
		          args[index] = arguments[index];
		        }
		        if (isCurried) {
		          var placeholder = getHolder(wrapper),
		              holdersCount = countHolders(args, placeholder);
		        }
		        if (partials) {
		          args = composeArgs(args, partials, holders, isCurried);
		        }
		        if (partialsRight) {
		          args = composeArgsRight(args, partialsRight, holdersRight, isCurried);
		        }
		        length -= holdersCount;
		        if (isCurried && length < arity) {
		          var newHolders = replaceHolders(args, placeholder);
		          return createRecurry(
		            func, bitmask, createHybrid, wrapper.placeholder, thisArg,
		            args, newHolders, argPos, ary, arity - length
		          );
		        }
		        var thisBinding = isBind ? thisArg : this,
		            fn = isBindKey ? thisBinding[func] : func;

		        length = args.length;
		        if (argPos) {
		          args = reorder(args, argPos);
		        } else if (isFlip && length > 1) {
		          args.reverse();
		        }
		        if (isAry && ary < length) {
		          args.length = ary;
		        }
		        if (this && this !== root && this instanceof wrapper) {
		          fn = Ctor || createCtor(fn);
		        }
		        return fn.apply(thisBinding, args);
		      }
		      return wrapper;
		    }

		    /**
		     * Creates a function like `_.invertBy`.
		     *
		     * @private
		     * @param {Function} setter The function to set accumulator values.
		     * @param {Function} toIteratee The function to resolve iteratees.
		     * @returns {Function} Returns the new inverter function.
		     */
		    function createInverter(setter, toIteratee) {
		      return function(object, iteratee) {
		        return baseInverter(object, setter, toIteratee(iteratee), {});
		      };
		    }

		    /**
		     * Creates a function that performs a mathematical operation on two values.
		     *
		     * @private
		     * @param {Function} operator The function to perform the operation.
		     * @param {number} [defaultValue] The value used for `undefined` arguments.
		     * @returns {Function} Returns the new mathematical operation function.
		     */
		    function createMathOperation(operator, defaultValue) {
		      return function(value, other) {
		        var result;
		        if (value === undefined$1 && other === undefined$1) {
		          return defaultValue;
		        }
		        if (value !== undefined$1) {
		          result = value;
		        }
		        if (other !== undefined$1) {
		          if (result === undefined$1) {
		            return other;
		          }
		          if (typeof value == 'string' || typeof other == 'string') {
		            value = baseToString(value);
		            other = baseToString(other);
		          } else {
		            value = baseToNumber(value);
		            other = baseToNumber(other);
		          }
		          result = operator(value, other);
		        }
		        return result;
		      };
		    }

		    /**
		     * Creates a function like `_.over`.
		     *
		     * @private
		     * @param {Function} arrayFunc The function to iterate over iteratees.
		     * @returns {Function} Returns the new over function.
		     */
		    function createOver(arrayFunc) {
		      return flatRest(function(iteratees) {
		        iteratees = arrayMap(iteratees, baseUnary(getIteratee()));
		        return baseRest(function(args) {
		          var thisArg = this;
		          return arrayFunc(iteratees, function(iteratee) {
		            return apply(iteratee, thisArg, args);
		          });
		        });
		      });
		    }

		    /**
		     * Creates the padding for `string` based on `length`. The `chars` string
		     * is truncated if the number of characters exceeds `length`.
		     *
		     * @private
		     * @param {number} length The padding length.
		     * @param {string} [chars=' '] The string used as padding.
		     * @returns {string} Returns the padding for `string`.
		     */
		    function createPadding(length, chars) {
		      chars = chars === undefined$1 ? ' ' : baseToString(chars);

		      var charsLength = chars.length;
		      if (charsLength < 2) {
		        return charsLength ? baseRepeat(chars, length) : chars;
		      }
		      var result = baseRepeat(chars, nativeCeil(length / stringSize(chars)));
		      return hasUnicode(chars)
		        ? castSlice(stringToArray(result), 0, length).join('')
		        : result.slice(0, length);
		    }

		    /**
		     * Creates a function that wraps `func` to invoke it with the `this` binding
		     * of `thisArg` and `partials` prepended to the arguments it receives.
		     *
		     * @private
		     * @param {Function} func The function to wrap.
		     * @param {number} bitmask The bitmask flags. See `createWrap` for more details.
		     * @param {*} thisArg The `this` binding of `func`.
		     * @param {Array} partials The arguments to prepend to those provided to
		     *  the new function.
		     * @returns {Function} Returns the new wrapped function.
		     */
		    function createPartial(func, bitmask, thisArg, partials) {
		      var isBind = bitmask & WRAP_BIND_FLAG,
		          Ctor = createCtor(func);

		      function wrapper() {
		        var argsIndex = -1,
		            argsLength = arguments.length,
		            leftIndex = -1,
		            leftLength = partials.length,
		            args = Array(leftLength + argsLength),
		            fn = (this && this !== root && this instanceof wrapper) ? Ctor : func;

		        while (++leftIndex < leftLength) {
		          args[leftIndex] = partials[leftIndex];
		        }
		        while (argsLength--) {
		          args[leftIndex++] = arguments[++argsIndex];
		        }
		        return apply(fn, isBind ? thisArg : this, args);
		      }
		      return wrapper;
		    }

		    /**
		     * Creates a `_.range` or `_.rangeRight` function.
		     *
		     * @private
		     * @param {boolean} [fromRight] Specify iterating from right to left.
		     * @returns {Function} Returns the new range function.
		     */
		    function createRange(fromRight) {
		      return function(start, end, step) {
		        if (step && typeof step != 'number' && isIterateeCall(start, end, step)) {
		          end = step = undefined$1;
		        }
		        // Ensure the sign of `-0` is preserved.
		        start = toFinite(start);
		        if (end === undefined$1) {
		          end = start;
		          start = 0;
		        } else {
		          end = toFinite(end);
		        }
		        step = step === undefined$1 ? (start < end ? 1 : -1) : toFinite(step);
		        return baseRange(start, end, step, fromRight);
		      };
		    }

		    /**
		     * Creates a function that performs a relational operation on two values.
		     *
		     * @private
		     * @param {Function} operator The function to perform the operation.
		     * @returns {Function} Returns the new relational operation function.
		     */
		    function createRelationalOperation(operator) {
		      return function(value, other) {
		        if (!(typeof value == 'string' && typeof other == 'string')) {
		          value = toNumber(value);
		          other = toNumber(other);
		        }
		        return operator(value, other);
		      };
		    }

		    /**
		     * Creates a function that wraps `func` to continue currying.
		     *
		     * @private
		     * @param {Function} func The function to wrap.
		     * @param {number} bitmask The bitmask flags. See `createWrap` for more details.
		     * @param {Function} wrapFunc The function to create the `func` wrapper.
		     * @param {*} placeholder The placeholder value.
		     * @param {*} [thisArg] The `this` binding of `func`.
		     * @param {Array} [partials] The arguments to prepend to those provided to
		     *  the new function.
		     * @param {Array} [holders] The `partials` placeholder indexes.
		     * @param {Array} [argPos] The argument positions of the new function.
		     * @param {number} [ary] The arity cap of `func`.
		     * @param {number} [arity] The arity of `func`.
		     * @returns {Function} Returns the new wrapped function.
		     */
		    function createRecurry(func, bitmask, wrapFunc, placeholder, thisArg, partials, holders, argPos, ary, arity) {
		      var isCurry = bitmask & WRAP_CURRY_FLAG,
		          newHolders = isCurry ? holders : undefined$1,
		          newHoldersRight = isCurry ? undefined$1 : holders,
		          newPartials = isCurry ? partials : undefined$1,
		          newPartialsRight = isCurry ? undefined$1 : partials;

		      bitmask |= (isCurry ? WRAP_PARTIAL_FLAG : WRAP_PARTIAL_RIGHT_FLAG);
		      bitmask &= ~(isCurry ? WRAP_PARTIAL_RIGHT_FLAG : WRAP_PARTIAL_FLAG);

		      if (!(bitmask & WRAP_CURRY_BOUND_FLAG)) {
		        bitmask &= ~(WRAP_BIND_FLAG | WRAP_BIND_KEY_FLAG);
		      }
		      var newData = [
		        func, bitmask, thisArg, newPartials, newHolders, newPartialsRight,
		        newHoldersRight, argPos, ary, arity
		      ];

		      var result = wrapFunc.apply(undefined$1, newData);
		      if (isLaziable(func)) {
		        setData(result, newData);
		      }
		      result.placeholder = placeholder;
		      return setWrapToString(result, func, bitmask);
		    }

		    /**
		     * Creates a function like `_.round`.
		     *
		     * @private
		     * @param {string} methodName The name of the `Math` method to use when rounding.
		     * @returns {Function} Returns the new round function.
		     */
		    function createRound(methodName) {
		      var func = Math[methodName];
		      return function(number, precision) {
		        number = toNumber(number);
		        precision = precision == null ? 0 : nativeMin(toInteger(precision), 292);
		        if (precision && nativeIsFinite(number)) {
		          // Shift with exponential notation to avoid floating-point issues.
		          // See [MDN](https://mdn.io/round#Examples) for more details.
		          var pair = (toString(number) + 'e').split('e'),
		              value = func(pair[0] + 'e' + (+pair[1] + precision));

		          pair = (toString(value) + 'e').split('e');
		          return +(pair[0] + 'e' + (+pair[1] - precision));
		        }
		        return func(number);
		      };
		    }

		    /**
		     * Creates a set object of `values`.
		     *
		     * @private
		     * @param {Array} values The values to add to the set.
		     * @returns {Object} Returns the new set.
		     */
		    var createSet = !(Set && (1 / setToArray(new Set([,-0]))[1]) == INFINITY) ? noop : function(values) {
		      return new Set(values);
		    };

		    /**
		     * Creates a `_.toPairs` or `_.toPairsIn` function.
		     *
		     * @private
		     * @param {Function} keysFunc The function to get the keys of a given object.
		     * @returns {Function} Returns the new pairs function.
		     */
		    function createToPairs(keysFunc) {
		      return function(object) {
		        var tag = getTag(object);
		        if (tag == mapTag) {
		          return mapToArray(object);
		        }
		        if (tag == setTag) {
		          return setToPairs(object);
		        }
		        return baseToPairs(object, keysFunc(object));
		      };
		    }

		    /**
		     * Creates a function that either curries or invokes `func` with optional
		     * `this` binding and partially applied arguments.
		     *
		     * @private
		     * @param {Function|string} func The function or method name to wrap.
		     * @param {number} bitmask The bitmask flags.
		     *    1 - `_.bind`
		     *    2 - `_.bindKey`
		     *    4 - `_.curry` or `_.curryRight` of a bound function
		     *    8 - `_.curry`
		     *   16 - `_.curryRight`
		     *   32 - `_.partial`
		     *   64 - `_.partialRight`
		     *  128 - `_.rearg`
		     *  256 - `_.ary`
		     *  512 - `_.flip`
		     * @param {*} [thisArg] The `this` binding of `func`.
		     * @param {Array} [partials] The arguments to be partially applied.
		     * @param {Array} [holders] The `partials` placeholder indexes.
		     * @param {Array} [argPos] The argument positions of the new function.
		     * @param {number} [ary] The arity cap of `func`.
		     * @param {number} [arity] The arity of `func`.
		     * @returns {Function} Returns the new wrapped function.
		     */
		    function createWrap(func, bitmask, thisArg, partials, holders, argPos, ary, arity) {
		      var isBindKey = bitmask & WRAP_BIND_KEY_FLAG;
		      if (!isBindKey && typeof func != 'function') {
		        throw new TypeError(FUNC_ERROR_TEXT);
		      }
		      var length = partials ? partials.length : 0;
		      if (!length) {
		        bitmask &= ~(WRAP_PARTIAL_FLAG | WRAP_PARTIAL_RIGHT_FLAG);
		        partials = holders = undefined$1;
		      }
		      ary = ary === undefined$1 ? ary : nativeMax(toInteger(ary), 0);
		      arity = arity === undefined$1 ? arity : toInteger(arity);
		      length -= holders ? holders.length : 0;

		      if (bitmask & WRAP_PARTIAL_RIGHT_FLAG) {
		        var partialsRight = partials,
		            holdersRight = holders;

		        partials = holders = undefined$1;
		      }
		      var data = isBindKey ? undefined$1 : getData(func);

		      var newData = [
		        func, bitmask, thisArg, partials, holders, partialsRight, holdersRight,
		        argPos, ary, arity
		      ];

		      if (data) {
		        mergeData(newData, data);
		      }
		      func = newData[0];
		      bitmask = newData[1];
		      thisArg = newData[2];
		      partials = newData[3];
		      holders = newData[4];
		      arity = newData[9] = newData[9] === undefined$1
		        ? (isBindKey ? 0 : func.length)
		        : nativeMax(newData[9] - length, 0);

		      if (!arity && bitmask & (WRAP_CURRY_FLAG | WRAP_CURRY_RIGHT_FLAG)) {
		        bitmask &= ~(WRAP_CURRY_FLAG | WRAP_CURRY_RIGHT_FLAG);
		      }
		      if (!bitmask || bitmask == WRAP_BIND_FLAG) {
		        var result = createBind(func, bitmask, thisArg);
		      } else if (bitmask == WRAP_CURRY_FLAG || bitmask == WRAP_CURRY_RIGHT_FLAG) {
		        result = createCurry(func, bitmask, arity);
		      } else if ((bitmask == WRAP_PARTIAL_FLAG || bitmask == (WRAP_BIND_FLAG | WRAP_PARTIAL_FLAG)) && !holders.length) {
		        result = createPartial(func, bitmask, thisArg, partials);
		      } else {
		        result = createHybrid.apply(undefined$1, newData);
		      }
		      var setter = data ? baseSetData : setData;
		      return setWrapToString(setter(result, newData), func, bitmask);
		    }

		    /**
		     * Used by `_.defaults` to customize its `_.assignIn` use to assign properties
		     * of source objects to the destination object for all destination properties
		     * that resolve to `undefined`.
		     *
		     * @private
		     * @param {*} objValue The destination value.
		     * @param {*} srcValue The source value.
		     * @param {string} key The key of the property to assign.
		     * @param {Object} object The parent object of `objValue`.
		     * @returns {*} Returns the value to assign.
		     */
		    function customDefaultsAssignIn(objValue, srcValue, key, object) {
		      if (objValue === undefined$1 ||
		          (eq(objValue, objectProto[key]) && !hasOwnProperty.call(object, key))) {
		        return srcValue;
		      }
		      return objValue;
		    }

		    /**
		     * Used by `_.defaultsDeep` to customize its `_.merge` use to merge source
		     * objects into destination objects that are passed thru.
		     *
		     * @private
		     * @param {*} objValue The destination value.
		     * @param {*} srcValue The source value.
		     * @param {string} key The key of the property to merge.
		     * @param {Object} object The parent object of `objValue`.
		     * @param {Object} source The parent object of `srcValue`.
		     * @param {Object} [stack] Tracks traversed source values and their merged
		     *  counterparts.
		     * @returns {*} Returns the value to assign.
		     */
		    function customDefaultsMerge(objValue, srcValue, key, object, source, stack) {
		      if (isObject(objValue) && isObject(srcValue)) {
		        // Recursively merge objects and arrays (susceptible to call stack limits).
		        stack.set(srcValue, objValue);
		        baseMerge(objValue, srcValue, undefined$1, customDefaultsMerge, stack);
		        stack['delete'](srcValue);
		      }
		      return objValue;
		    }

		    /**
		     * Used by `_.omit` to customize its `_.cloneDeep` use to only clone plain
		     * objects.
		     *
		     * @private
		     * @param {*} value The value to inspect.
		     * @param {string} key The key of the property to inspect.
		     * @returns {*} Returns the uncloned value or `undefined` to defer cloning to `_.cloneDeep`.
		     */
		    function customOmitClone(value) {
		      return isPlainObject(value) ? undefined$1 : value;
		    }

		    /**
		     * A specialized version of `baseIsEqualDeep` for arrays with support for
		     * partial deep comparisons.
		     *
		     * @private
		     * @param {Array} array The array to compare.
		     * @param {Array} other The other array to compare.
		     * @param {number} bitmask The bitmask flags. See `baseIsEqual` for more details.
		     * @param {Function} customizer The function to customize comparisons.
		     * @param {Function} equalFunc The function to determine equivalents of values.
		     * @param {Object} stack Tracks traversed `array` and `other` objects.
		     * @returns {boolean} Returns `true` if the arrays are equivalent, else `false`.
		     */
		    function equalArrays(array, other, bitmask, customizer, equalFunc, stack) {
		      var isPartial = bitmask & COMPARE_PARTIAL_FLAG,
		          arrLength = array.length,
		          othLength = other.length;

		      if (arrLength != othLength && !(isPartial && othLength > arrLength)) {
		        return false;
		      }
		      // Check that cyclic values are equal.
		      var arrStacked = stack.get(array);
		      var othStacked = stack.get(other);
		      if (arrStacked && othStacked) {
		        return arrStacked == other && othStacked == array;
		      }
		      var index = -1,
		          result = true,
		          seen = (bitmask & COMPARE_UNORDERED_FLAG) ? new SetCache : undefined$1;

		      stack.set(array, other);
		      stack.set(other, array);

		      // Ignore non-index properties.
		      while (++index < arrLength) {
		        var arrValue = array[index],
		            othValue = other[index];

		        if (customizer) {
		          var compared = isPartial
		            ? customizer(othValue, arrValue, index, other, array, stack)
		            : customizer(arrValue, othValue, index, array, other, stack);
		        }
		        if (compared !== undefined$1) {
		          if (compared) {
		            continue;
		          }
		          result = false;
		          break;
		        }
		        // Recursively compare arrays (susceptible to call stack limits).
		        if (seen) {
		          if (!arraySome(other, function(othValue, othIndex) {
		                if (!cacheHas(seen, othIndex) &&
		                    (arrValue === othValue || equalFunc(arrValue, othValue, bitmask, customizer, stack))) {
		                  return seen.push(othIndex);
		                }
		              })) {
		            result = false;
		            break;
		          }
		        } else if (!(
		              arrValue === othValue ||
		                equalFunc(arrValue, othValue, bitmask, customizer, stack)
		            )) {
		          result = false;
		          break;
		        }
		      }
		      stack['delete'](array);
		      stack['delete'](other);
		      return result;
		    }

		    /**
		     * A specialized version of `baseIsEqualDeep` for comparing objects of
		     * the same `toStringTag`.
		     *
		     * **Note:** This function only supports comparing values with tags of
		     * `Boolean`, `Date`, `Error`, `Number`, `RegExp`, or `String`.
		     *
		     * @private
		     * @param {Object} object The object to compare.
		     * @param {Object} other The other object to compare.
		     * @param {string} tag The `toStringTag` of the objects to compare.
		     * @param {number} bitmask The bitmask flags. See `baseIsEqual` for more details.
		     * @param {Function} customizer The function to customize comparisons.
		     * @param {Function} equalFunc The function to determine equivalents of values.
		     * @param {Object} stack Tracks traversed `object` and `other` objects.
		     * @returns {boolean} Returns `true` if the objects are equivalent, else `false`.
		     */
		    function equalByTag(object, other, tag, bitmask, customizer, equalFunc, stack) {
		      switch (tag) {
		        case dataViewTag:
		          if ((object.byteLength != other.byteLength) ||
		              (object.byteOffset != other.byteOffset)) {
		            return false;
		          }
		          object = object.buffer;
		          other = other.buffer;

		        case arrayBufferTag:
		          if ((object.byteLength != other.byteLength) ||
		              !equalFunc(new Uint8Array(object), new Uint8Array(other))) {
		            return false;
		          }
		          return true;

		        case boolTag:
		        case dateTag:
		        case numberTag:
		          // Coerce booleans to `1` or `0` and dates to milliseconds.
		          // Invalid dates are coerced to `NaN`.
		          return eq(+object, +other);

		        case errorTag:
		          return object.name == other.name && object.message == other.message;

		        case regexpTag:
		        case stringTag:
		          // Coerce regexes to strings and treat strings, primitives and objects,
		          // as equal. See http://www.ecma-international.org/ecma-262/7.0/#sec-regexp.prototype.tostring
		          // for more details.
		          return object == (other + '');

		        case mapTag:
		          var convert = mapToArray;

		        case setTag:
		          var isPartial = bitmask & COMPARE_PARTIAL_FLAG;
		          convert || (convert = setToArray);

		          if (object.size != other.size && !isPartial) {
		            return false;
		          }
		          // Assume cyclic values are equal.
		          var stacked = stack.get(object);
		          if (stacked) {
		            return stacked == other;
		          }
		          bitmask |= COMPARE_UNORDERED_FLAG;

		          // Recursively compare objects (susceptible to call stack limits).
		          stack.set(object, other);
		          var result = equalArrays(convert(object), convert(other), bitmask, customizer, equalFunc, stack);
		          stack['delete'](object);
		          return result;

		        case symbolTag:
		          if (symbolValueOf) {
		            return symbolValueOf.call(object) == symbolValueOf.call(other);
		          }
		      }
		      return false;
		    }

		    /**
		     * A specialized version of `baseIsEqualDeep` for objects with support for
		     * partial deep comparisons.
		     *
		     * @private
		     * @param {Object} object The object to compare.
		     * @param {Object} other The other object to compare.
		     * @param {number} bitmask The bitmask flags. See `baseIsEqual` for more details.
		     * @param {Function} customizer The function to customize comparisons.
		     * @param {Function} equalFunc The function to determine equivalents of values.
		     * @param {Object} stack Tracks traversed `object` and `other` objects.
		     * @returns {boolean} Returns `true` if the objects are equivalent, else `false`.
		     */
		    function equalObjects(object, other, bitmask, customizer, equalFunc, stack) {
		      var isPartial = bitmask & COMPARE_PARTIAL_FLAG,
		          objProps = getAllKeys(object),
		          objLength = objProps.length,
		          othProps = getAllKeys(other),
		          othLength = othProps.length;

		      if (objLength != othLength && !isPartial) {
		        return false;
		      }
		      var index = objLength;
		      while (index--) {
		        var key = objProps[index];
		        if (!(isPartial ? key in other : hasOwnProperty.call(other, key))) {
		          return false;
		        }
		      }
		      // Check that cyclic values are equal.
		      var objStacked = stack.get(object);
		      var othStacked = stack.get(other);
		      if (objStacked && othStacked) {
		        return objStacked == other && othStacked == object;
		      }
		      var result = true;
		      stack.set(object, other);
		      stack.set(other, object);

		      var skipCtor = isPartial;
		      while (++index < objLength) {
		        key = objProps[index];
		        var objValue = object[key],
		            othValue = other[key];

		        if (customizer) {
		          var compared = isPartial
		            ? customizer(othValue, objValue, key, other, object, stack)
		            : customizer(objValue, othValue, key, object, other, stack);
		        }
		        // Recursively compare objects (susceptible to call stack limits).
		        if (!(compared === undefined$1
		              ? (objValue === othValue || equalFunc(objValue, othValue, bitmask, customizer, stack))
		              : compared
		            )) {
		          result = false;
		          break;
		        }
		        skipCtor || (skipCtor = key == 'constructor');
		      }
		      if (result && !skipCtor) {
		        var objCtor = object.constructor,
		            othCtor = other.constructor;

		        // Non `Object` object instances with different constructors are not equal.
		        if (objCtor != othCtor &&
		            ('constructor' in object && 'constructor' in other) &&
		            !(typeof objCtor == 'function' && objCtor instanceof objCtor &&
		              typeof othCtor == 'function' && othCtor instanceof othCtor)) {
		          result = false;
		        }
		      }
		      stack['delete'](object);
		      stack['delete'](other);
		      return result;
		    }

		    /**
		     * A specialized version of `baseRest` which flattens the rest array.
		     *
		     * @private
		     * @param {Function} func The function to apply a rest parameter to.
		     * @returns {Function} Returns the new function.
		     */
		    function flatRest(func) {
		      return setToString(overRest(func, undefined$1, flatten), func + '');
		    }

		    /**
		     * Creates an array of own enumerable property names and symbols of `object`.
		     *
		     * @private
		     * @param {Object} object The object to query.
		     * @returns {Array} Returns the array of property names and symbols.
		     */
		    function getAllKeys(object) {
		      return baseGetAllKeys(object, keys, getSymbols);
		    }

		    /**
		     * Creates an array of own and inherited enumerable property names and
		     * symbols of `object`.
		     *
		     * @private
		     * @param {Object} object The object to query.
		     * @returns {Array} Returns the array of property names and symbols.
		     */
		    function getAllKeysIn(object) {
		      return baseGetAllKeys(object, keysIn, getSymbolsIn);
		    }

		    /**
		     * Gets metadata for `func`.
		     *
		     * @private
		     * @param {Function} func The function to query.
		     * @returns {*} Returns the metadata for `func`.
		     */
		    var getData = !metaMap ? noop : function(func) {
		      return metaMap.get(func);
		    };

		    /**
		     * Gets the name of `func`.
		     *
		     * @private
		     * @param {Function} func The function to query.
		     * @returns {string} Returns the function name.
		     */
		    function getFuncName(func) {
		      var result = (func.name + ''),
		          array = realNames[result],
		          length = hasOwnProperty.call(realNames, result) ? array.length : 0;

		      while (length--) {
		        var data = array[length],
		            otherFunc = data.func;
		        if (otherFunc == null || otherFunc == func) {
		          return data.name;
		        }
		      }
		      return result;
		    }

		    /**
		     * Gets the argument placeholder value for `func`.
		     *
		     * @private
		     * @param {Function} func The function to inspect.
		     * @returns {*} Returns the placeholder value.
		     */
		    function getHolder(func) {
		      var object = hasOwnProperty.call(lodash, 'placeholder') ? lodash : func;
		      return object.placeholder;
		    }

		    /**
		     * Gets the appropriate "iteratee" function. If `_.iteratee` is customized,
		     * this function returns the custom method, otherwise it returns `baseIteratee`.
		     * If arguments are provided, the chosen function is invoked with them and
		     * its result is returned.
		     *
		     * @private
		     * @param {*} [value] The value to convert to an iteratee.
		     * @param {number} [arity] The arity of the created iteratee.
		     * @returns {Function} Returns the chosen function or its result.
		     */
		    function getIteratee() {
		      var result = lodash.iteratee || iteratee;
		      result = result === iteratee ? baseIteratee : result;
		      return arguments.length ? result(arguments[0], arguments[1]) : result;
		    }

		    /**
		     * Gets the data for `map`.
		     *
		     * @private
		     * @param {Object} map The map to query.
		     * @param {string} key The reference key.
		     * @returns {*} Returns the map data.
		     */
		    function getMapData(map, key) {
		      var data = map.__data__;
		      return isKeyable(key)
		        ? data[typeof key == 'string' ? 'string' : 'hash']
		        : data.map;
		    }

		    /**
		     * Gets the property names, values, and compare flags of `object`.
		     *
		     * @private
		     * @param {Object} object The object to query.
		     * @returns {Array} Returns the match data of `object`.
		     */
		    function getMatchData(object) {
		      var result = keys(object),
		          length = result.length;

		      while (length--) {
		        var key = result[length],
		            value = object[key];

		        result[length] = [key, value, isStrictComparable(value)];
		      }
		      return result;
		    }

		    /**
		     * Gets the native function at `key` of `object`.
		     *
		     * @private
		     * @param {Object} object The object to query.
		     * @param {string} key The key of the method to get.
		     * @returns {*} Returns the function if it's native, else `undefined`.
		     */
		    function getNative(object, key) {
		      var value = getValue(object, key);
		      return baseIsNative(value) ? value : undefined$1;
		    }

		    /**
		     * A specialized version of `baseGetTag` which ignores `Symbol.toStringTag` values.
		     *
		     * @private
		     * @param {*} value The value to query.
		     * @returns {string} Returns the raw `toStringTag`.
		     */
		    function getRawTag(value) {
		      var isOwn = hasOwnProperty.call(value, symToStringTag),
		          tag = value[symToStringTag];

		      try {
		        value[symToStringTag] = undefined$1;
		        var unmasked = true;
		      } catch (e) {}

		      var result = nativeObjectToString.call(value);
		      if (unmasked) {
		        if (isOwn) {
		          value[symToStringTag] = tag;
		        } else {
		          delete value[symToStringTag];
		        }
		      }
		      return result;
		    }

		    /**
		     * Creates an array of the own enumerable symbols of `object`.
		     *
		     * @private
		     * @param {Object} object The object to query.
		     * @returns {Array} Returns the array of symbols.
		     */
		    var getSymbols = !nativeGetSymbols ? stubArray : function(object) {
		      if (object == null) {
		        return [];
		      }
		      object = Object(object);
		      return arrayFilter(nativeGetSymbols(object), function(symbol) {
		        return propertyIsEnumerable.call(object, symbol);
		      });
		    };

		    /**
		     * Creates an array of the own and inherited enumerable symbols of `object`.
		     *
		     * @private
		     * @param {Object} object The object to query.
		     * @returns {Array} Returns the array of symbols.
		     */
		    var getSymbolsIn = !nativeGetSymbols ? stubArray : function(object) {
		      var result = [];
		      while (object) {
		        arrayPush(result, getSymbols(object));
		        object = getPrototype(object);
		      }
		      return result;
		    };

		    /**
		     * Gets the `toStringTag` of `value`.
		     *
		     * @private
		     * @param {*} value The value to query.
		     * @returns {string} Returns the `toStringTag`.
		     */
		    var getTag = baseGetTag;

		    // Fallback for data views, maps, sets, and weak maps in IE 11 and promises in Node.js < 6.
		    if ((DataView && getTag(new DataView(new ArrayBuffer(1))) != dataViewTag) ||
		        (Map && getTag(new Map) != mapTag) ||
		        (Promise && getTag(Promise.resolve()) != promiseTag) ||
		        (Set && getTag(new Set) != setTag) ||
		        (WeakMap && getTag(new WeakMap) != weakMapTag)) {
		      getTag = function(value) {
		        var result = baseGetTag(value),
		            Ctor = result == objectTag ? value.constructor : undefined$1,
		            ctorString = Ctor ? toSource(Ctor) : '';

		        if (ctorString) {
		          switch (ctorString) {
		            case dataViewCtorString: return dataViewTag;
		            case mapCtorString: return mapTag;
		            case promiseCtorString: return promiseTag;
		            case setCtorString: return setTag;
		            case weakMapCtorString: return weakMapTag;
		          }
		        }
		        return result;
		      };
		    }

		    /**
		     * Gets the view, applying any `transforms` to the `start` and `end` positions.
		     *
		     * @private
		     * @param {number} start The start of the view.
		     * @param {number} end The end of the view.
		     * @param {Array} transforms The transformations to apply to the view.
		     * @returns {Object} Returns an object containing the `start` and `end`
		     *  positions of the view.
		     */
		    function getView(start, end, transforms) {
		      var index = -1,
		          length = transforms.length;

		      while (++index < length) {
		        var data = transforms[index],
		            size = data.size;

		        switch (data.type) {
		          case 'drop':      start += size; break;
		          case 'dropRight': end -= size; break;
		          case 'take':      end = nativeMin(end, start + size); break;
		          case 'takeRight': start = nativeMax(start, end - size); break;
		        }
		      }
		      return { 'start': start, 'end': end };
		    }

		    /**
		     * Extracts wrapper details from the `source` body comment.
		     *
		     * @private
		     * @param {string} source The source to inspect.
		     * @returns {Array} Returns the wrapper details.
		     */
		    function getWrapDetails(source) {
		      var match = source.match(reWrapDetails);
		      return match ? match[1].split(reSplitDetails) : [];
		    }

		    /**
		     * Checks if `path` exists on `object`.
		     *
		     * @private
		     * @param {Object} object The object to query.
		     * @param {Array|string} path The path to check.
		     * @param {Function} hasFunc The function to check properties.
		     * @returns {boolean} Returns `true` if `path` exists, else `false`.
		     */
		    function hasPath(object, path, hasFunc) {
		      path = castPath(path, object);

		      var index = -1,
		          length = path.length,
		          result = false;

		      while (++index < length) {
		        var key = toKey(path[index]);
		        if (!(result = object != null && hasFunc(object, key))) {
		          break;
		        }
		        object = object[key];
		      }
		      if (result || ++index != length) {
		        return result;
		      }
		      length = object == null ? 0 : object.length;
		      return !!length && isLength(length) && isIndex(key, length) &&
		        (isArray(object) || isArguments(object));
		    }

		    /**
		     * Initializes an array clone.
		     *
		     * @private
		     * @param {Array} array The array to clone.
		     * @returns {Array} Returns the initialized clone.
		     */
		    function initCloneArray(array) {
		      var length = array.length,
		          result = new array.constructor(length);

		      // Add properties assigned by `RegExp#exec`.
		      if (length && typeof array[0] == 'string' && hasOwnProperty.call(array, 'index')) {
		        result.index = array.index;
		        result.input = array.input;
		      }
		      return result;
		    }

		    /**
		     * Initializes an object clone.
		     *
		     * @private
		     * @param {Object} object The object to clone.
		     * @returns {Object} Returns the initialized clone.
		     */
		    function initCloneObject(object) {
		      return (typeof object.constructor == 'function' && !isPrototype(object))
		        ? baseCreate(getPrototype(object))
		        : {};
		    }

		    /**
		     * Initializes an object clone based on its `toStringTag`.
		     *
		     * **Note:** This function only supports cloning values with tags of
		     * `Boolean`, `Date`, `Error`, `Map`, `Number`, `RegExp`, `Set`, or `String`.
		     *
		     * @private
		     * @param {Object} object The object to clone.
		     * @param {string} tag The `toStringTag` of the object to clone.
		     * @param {boolean} [isDeep] Specify a deep clone.
		     * @returns {Object} Returns the initialized clone.
		     */
		    function initCloneByTag(object, tag, isDeep) {
		      var Ctor = object.constructor;
		      switch (tag) {
		        case arrayBufferTag:
		          return cloneArrayBuffer(object);

		        case boolTag:
		        case dateTag:
		          return new Ctor(+object);

		        case dataViewTag:
		          return cloneDataView(object, isDeep);

		        case float32Tag: case float64Tag:
		        case int8Tag: case int16Tag: case int32Tag:
		        case uint8Tag: case uint8ClampedTag: case uint16Tag: case uint32Tag:
		          return cloneTypedArray(object, isDeep);

		        case mapTag:
		          return new Ctor;

		        case numberTag:
		        case stringTag:
		          return new Ctor(object);

		        case regexpTag:
		          return cloneRegExp(object);

		        case setTag:
		          return new Ctor;

		        case symbolTag:
		          return cloneSymbol(object);
		      }
		    }

		    /**
		     * Inserts wrapper `details` in a comment at the top of the `source` body.
		     *
		     * @private
		     * @param {string} source The source to modify.
		     * @returns {Array} details The details to insert.
		     * @returns {string} Returns the modified source.
		     */
		    function insertWrapDetails(source, details) {
		      var length = details.length;
		      if (!length) {
		        return source;
		      }
		      var lastIndex = length - 1;
		      details[lastIndex] = (length > 1 ? '& ' : '') + details[lastIndex];
		      details = details.join(length > 2 ? ', ' : ' ');
		      return source.replace(reWrapComment, '{\n/* [wrapped with ' + details + '] */\n');
		    }

		    /**
		     * Checks if `value` is a flattenable `arguments` object or array.
		     *
		     * @private
		     * @param {*} value The value to check.
		     * @returns {boolean} Returns `true` if `value` is flattenable, else `false`.
		     */
		    function isFlattenable(value) {
		      return isArray(value) || isArguments(value) ||
		        !!(spreadableSymbol && value && value[spreadableSymbol]);
		    }

		    /**
		     * Checks if `value` is a valid array-like index.
		     *
		     * @private
		     * @param {*} value The value to check.
		     * @param {number} [length=MAX_SAFE_INTEGER] The upper bounds of a valid index.
		     * @returns {boolean} Returns `true` if `value` is a valid index, else `false`.
		     */
		    function isIndex(value, length) {
		      var type = typeof value;
		      length = length == null ? MAX_SAFE_INTEGER : length;

		      return !!length &&
		        (type == 'number' ||
		          (type != 'symbol' && reIsUint.test(value))) &&
		            (value > -1 && value % 1 == 0 && value < length);
		    }

		    /**
		     * Checks if the given arguments are from an iteratee call.
		     *
		     * @private
		     * @param {*} value The potential iteratee value argument.
		     * @param {*} index The potential iteratee index or key argument.
		     * @param {*} object The potential iteratee object argument.
		     * @returns {boolean} Returns `true` if the arguments are from an iteratee call,
		     *  else `false`.
		     */
		    function isIterateeCall(value, index, object) {
		      if (!isObject(object)) {
		        return false;
		      }
		      var type = typeof index;
		      if (type == 'number'
		            ? (isArrayLike(object) && isIndex(index, object.length))
		            : (type == 'string' && index in object)
		          ) {
		        return eq(object[index], value);
		      }
		      return false;
		    }

		    /**
		     * Checks if `value` is a property name and not a property path.
		     *
		     * @private
		     * @param {*} value The value to check.
		     * @param {Object} [object] The object to query keys on.
		     * @returns {boolean} Returns `true` if `value` is a property name, else `false`.
		     */
		    function isKey(value, object) {
		      if (isArray(value)) {
		        return false;
		      }
		      var type = typeof value;
		      if (type == 'number' || type == 'symbol' || type == 'boolean' ||
		          value == null || isSymbol(value)) {
		        return true;
		      }
		      return reIsPlainProp.test(value) || !reIsDeepProp.test(value) ||
		        (object != null && value in Object(object));
		    }

		    /**
		     * Checks if `value` is suitable for use as unique object key.
		     *
		     * @private
		     * @param {*} value The value to check.
		     * @returns {boolean} Returns `true` if `value` is suitable, else `false`.
		     */
		    function isKeyable(value) {
		      var type = typeof value;
		      return (type == 'string' || type == 'number' || type == 'symbol' || type == 'boolean')
		        ? (value !== '__proto__')
		        : (value === null);
		    }

		    /**
		     * Checks if `func` has a lazy counterpart.
		     *
		     * @private
		     * @param {Function} func The function to check.
		     * @returns {boolean} Returns `true` if `func` has a lazy counterpart,
		     *  else `false`.
		     */
		    function isLaziable(func) {
		      var funcName = getFuncName(func),
		          other = lodash[funcName];

		      if (typeof other != 'function' || !(funcName in LazyWrapper.prototype)) {
		        return false;
		      }
		      if (func === other) {
		        return true;
		      }
		      var data = getData(other);
		      return !!data && func === data[0];
		    }

		    /**
		     * Checks if `func` has its source masked.
		     *
		     * @private
		     * @param {Function} func The function to check.
		     * @returns {boolean} Returns `true` if `func` is masked, else `false`.
		     */
		    function isMasked(func) {
		      return !!maskSrcKey && (maskSrcKey in func);
		    }

		    /**
		     * Checks if `func` is capable of being masked.
		     *
		     * @private
		     * @param {*} value The value to check.
		     * @returns {boolean} Returns `true` if `func` is maskable, else `false`.
		     */
		    var isMaskable = coreJsData ? isFunction : stubFalse;

		    /**
		     * Checks if `value` is likely a prototype object.
		     *
		     * @private
		     * @param {*} value The value to check.
		     * @returns {boolean} Returns `true` if `value` is a prototype, else `false`.
		     */
		    function isPrototype(value) {
		      var Ctor = value && value.constructor,
		          proto = (typeof Ctor == 'function' && Ctor.prototype) || objectProto;

		      return value === proto;
		    }

		    /**
		     * Checks if `value` is suitable for strict equality comparisons, i.e. `===`.
		     *
		     * @private
		     * @param {*} value The value to check.
		     * @returns {boolean} Returns `true` if `value` if suitable for strict
		     *  equality comparisons, else `false`.
		     */
		    function isStrictComparable(value) {
		      return value === value && !isObject(value);
		    }

		    /**
		     * A specialized version of `matchesProperty` for source values suitable
		     * for strict equality comparisons, i.e. `===`.
		     *
		     * @private
		     * @param {string} key The key of the property to get.
		     * @param {*} srcValue The value to match.
		     * @returns {Function} Returns the new spec function.
		     */
		    function matchesStrictComparable(key, srcValue) {
		      return function(object) {
		        if (object == null) {
		          return false;
		        }
		        return object[key] === srcValue &&
		          (srcValue !== undefined$1 || (key in Object(object)));
		      };
		    }

		    /**
		     * A specialized version of `_.memoize` which clears the memoized function's
		     * cache when it exceeds `MAX_MEMOIZE_SIZE`.
		     *
		     * @private
		     * @param {Function} func The function to have its output memoized.
		     * @returns {Function} Returns the new memoized function.
		     */
		    function memoizeCapped(func) {
		      var result = memoize(func, function(key) {
		        if (cache.size === MAX_MEMOIZE_SIZE) {
		          cache.clear();
		        }
		        return key;
		      });

		      var cache = result.cache;
		      return result;
		    }

		    /**
		     * Merges the function metadata of `source` into `data`.
		     *
		     * Merging metadata reduces the number of wrappers used to invoke a function.
		     * This is possible because methods like `_.bind`, `_.curry`, and `_.partial`
		     * may be applied regardless of execution order. Methods like `_.ary` and
		     * `_.rearg` modify function arguments, making the order in which they are
		     * executed important, preventing the merging of metadata. However, we make
		     * an exception for a safe combined case where curried functions have `_.ary`
		     * and or `_.rearg` applied.
		     *
		     * @private
		     * @param {Array} data The destination metadata.
		     * @param {Array} source The source metadata.
		     * @returns {Array} Returns `data`.
		     */
		    function mergeData(data, source) {
		      var bitmask = data[1],
		          srcBitmask = source[1],
		          newBitmask = bitmask | srcBitmask,
		          isCommon = newBitmask < (WRAP_BIND_FLAG | WRAP_BIND_KEY_FLAG | WRAP_ARY_FLAG);

		      var isCombo =
		        ((srcBitmask == WRAP_ARY_FLAG) && (bitmask == WRAP_CURRY_FLAG)) ||
		        ((srcBitmask == WRAP_ARY_FLAG) && (bitmask == WRAP_REARG_FLAG) && (data[7].length <= source[8])) ||
		        ((srcBitmask == (WRAP_ARY_FLAG | WRAP_REARG_FLAG)) && (source[7].length <= source[8]) && (bitmask == WRAP_CURRY_FLAG));

		      // Exit early if metadata can't be merged.
		      if (!(isCommon || isCombo)) {
		        return data;
		      }
		      // Use source `thisArg` if available.
		      if (srcBitmask & WRAP_BIND_FLAG) {
		        data[2] = source[2];
		        // Set when currying a bound function.
		        newBitmask |= bitmask & WRAP_BIND_FLAG ? 0 : WRAP_CURRY_BOUND_FLAG;
		      }
		      // Compose partial arguments.
		      var value = source[3];
		      if (value) {
		        var partials = data[3];
		        data[3] = partials ? composeArgs(partials, value, source[4]) : value;
		        data[4] = partials ? replaceHolders(data[3], PLACEHOLDER) : source[4];
		      }
		      // Compose partial right arguments.
		      value = source[5];
		      if (value) {
		        partials = data[5];
		        data[5] = partials ? composeArgsRight(partials, value, source[6]) : value;
		        data[6] = partials ? replaceHolders(data[5], PLACEHOLDER) : source[6];
		      }
		      // Use source `argPos` if available.
		      value = source[7];
		      if (value) {
		        data[7] = value;
		      }
		      // Use source `ary` if it's smaller.
		      if (srcBitmask & WRAP_ARY_FLAG) {
		        data[8] = data[8] == null ? source[8] : nativeMin(data[8], source[8]);
		      }
		      // Use source `arity` if one is not provided.
		      if (data[9] == null) {
		        data[9] = source[9];
		      }
		      // Use source `func` and merge bitmasks.
		      data[0] = source[0];
		      data[1] = newBitmask;

		      return data;
		    }

		    /**
		     * This function is like
		     * [`Object.keys`](http://ecma-international.org/ecma-262/7.0/#sec-object.keys)
		     * except that it includes inherited enumerable properties.
		     *
		     * @private
		     * @param {Object} object The object to query.
		     * @returns {Array} Returns the array of property names.
		     */
		    function nativeKeysIn(object) {
		      var result = [];
		      if (object != null) {
		        for (var key in Object(object)) {
		          result.push(key);
		        }
		      }
		      return result;
		    }

		    /**
		     * Converts `value` to a string using `Object.prototype.toString`.
		     *
		     * @private
		     * @param {*} value The value to convert.
		     * @returns {string} Returns the converted string.
		     */
		    function objectToString(value) {
		      return nativeObjectToString.call(value);
		    }

		    /**
		     * A specialized version of `baseRest` which transforms the rest array.
		     *
		     * @private
		     * @param {Function} func The function to apply a rest parameter to.
		     * @param {number} [start=func.length-1] The start position of the rest parameter.
		     * @param {Function} transform The rest array transform.
		     * @returns {Function} Returns the new function.
		     */
		    function overRest(func, start, transform) {
		      start = nativeMax(start === undefined$1 ? (func.length - 1) : start, 0);
		      return function() {
		        var args = arguments,
		            index = -1,
		            length = nativeMax(args.length - start, 0),
		            array = Array(length);

		        while (++index < length) {
		          array[index] = args[start + index];
		        }
		        index = -1;
		        var otherArgs = Array(start + 1);
		        while (++index < start) {
		          otherArgs[index] = args[index];
		        }
		        otherArgs[start] = transform(array);
		        return apply(func, this, otherArgs);
		      };
		    }

		    /**
		     * Gets the parent value at `path` of `object`.
		     *
		     * @private
		     * @param {Object} object The object to query.
		     * @param {Array} path The path to get the parent value of.
		     * @returns {*} Returns the parent value.
		     */
		    function parent(object, path) {
		      return path.length < 2 ? object : baseGet(object, baseSlice(path, 0, -1));
		    }

		    /**
		     * Reorder `array` according to the specified indexes where the element at
		     * the first index is assigned as the first element, the element at
		     * the second index is assigned as the second element, and so on.
		     *
		     * @private
		     * @param {Array} array The array to reorder.
		     * @param {Array} indexes The arranged array indexes.
		     * @returns {Array} Returns `array`.
		     */
		    function reorder(array, indexes) {
		      var arrLength = array.length,
		          length = nativeMin(indexes.length, arrLength),
		          oldArray = copyArray(array);

		      while (length--) {
		        var index = indexes[length];
		        array[length] = isIndex(index, arrLength) ? oldArray[index] : undefined$1;
		      }
		      return array;
		    }

		    /**
		     * Gets the value at `key`, unless `key` is "__proto__" or "constructor".
		     *
		     * @private
		     * @param {Object} object The object to query.
		     * @param {string} key The key of the property to get.
		     * @returns {*} Returns the property value.
		     */
		    function safeGet(object, key) {
		      if (key === 'constructor' && typeof object[key] === 'function') {
		        return;
		      }

		      if (key == '__proto__') {
		        return;
		      }

		      return object[key];
		    }

		    /**
		     * Sets metadata for `func`.
		     *
		     * **Note:** If this function becomes hot, i.e. is invoked a lot in a short
		     * period of time, it will trip its breaker and transition to an identity
		     * function to avoid garbage collection pauses in V8. See
		     * [V8 issue 2070](https://bugs.chromium.org/p/v8/issues/detail?id=2070)
		     * for more details.
		     *
		     * @private
		     * @param {Function} func The function to associate metadata with.
		     * @param {*} data The metadata.
		     * @returns {Function} Returns `func`.
		     */
		    var setData = shortOut(baseSetData);

		    /**
		     * A simple wrapper around the global [`setTimeout`](https://mdn.io/setTimeout).
		     *
		     * @private
		     * @param {Function} func The function to delay.
		     * @param {number} wait The number of milliseconds to delay invocation.
		     * @returns {number|Object} Returns the timer id or timeout object.
		     */
		    var setTimeout = ctxSetTimeout || function(func, wait) {
		      return root.setTimeout(func, wait);
		    };

		    /**
		     * Sets the `toString` method of `func` to return `string`.
		     *
		     * @private
		     * @param {Function} func The function to modify.
		     * @param {Function} string The `toString` result.
		     * @returns {Function} Returns `func`.
		     */
		    var setToString = shortOut(baseSetToString);

		    /**
		     * Sets the `toString` method of `wrapper` to mimic the source of `reference`
		     * with wrapper details in a comment at the top of the source body.
		     *
		     * @private
		     * @param {Function} wrapper The function to modify.
		     * @param {Function} reference The reference function.
		     * @param {number} bitmask The bitmask flags. See `createWrap` for more details.
		     * @returns {Function} Returns `wrapper`.
		     */
		    function setWrapToString(wrapper, reference, bitmask) {
		      var source = (reference + '');
		      return setToString(wrapper, insertWrapDetails(source, updateWrapDetails(getWrapDetails(source), bitmask)));
		    }

		    /**
		     * Creates a function that'll short out and invoke `identity` instead
		     * of `func` when it's called `HOT_COUNT` or more times in `HOT_SPAN`
		     * milliseconds.
		     *
		     * @private
		     * @param {Function} func The function to restrict.
		     * @returns {Function} Returns the new shortable function.
		     */
		    function shortOut(func) {
		      var count = 0,
		          lastCalled = 0;

		      return function() {
		        var stamp = nativeNow(),
		            remaining = HOT_SPAN - (stamp - lastCalled);

		        lastCalled = stamp;
		        if (remaining > 0) {
		          if (++count >= HOT_COUNT) {
		            return arguments[0];
		          }
		        } else {
		          count = 0;
		        }
		        return func.apply(undefined$1, arguments);
		      };
		    }

		    /**
		     * A specialized version of `_.shuffle` which mutates and sets the size of `array`.
		     *
		     * @private
		     * @param {Array} array The array to shuffle.
		     * @param {number} [size=array.length] The size of `array`.
		     * @returns {Array} Returns `array`.
		     */
		    function shuffleSelf(array, size) {
		      var index = -1,
		          length = array.length,
		          lastIndex = length - 1;

		      size = size === undefined$1 ? length : size;
		      while (++index < size) {
		        var rand = baseRandom(index, lastIndex),
		            value = array[rand];

		        array[rand] = array[index];
		        array[index] = value;
		      }
		      array.length = size;
		      return array;
		    }

		    /**
		     * Converts `string` to a property path array.
		     *
		     * @private
		     * @param {string} string The string to convert.
		     * @returns {Array} Returns the property path array.
		     */
		    var stringToPath = memoizeCapped(function(string) {
		      var result = [];
		      if (string.charCodeAt(0) === 46 /* . */) {
		        result.push('');
		      }
		      string.replace(rePropName, function(match, number, quote, subString) {
		        result.push(quote ? subString.replace(reEscapeChar, '$1') : (number || match));
		      });
		      return result;
		    });

		    /**
		     * Converts `value` to a string key if it's not a string or symbol.
		     *
		     * @private
		     * @param {*} value The value to inspect.
		     * @returns {string|symbol} Returns the key.
		     */
		    function toKey(value) {
		      if (typeof value == 'string' || isSymbol(value)) {
		        return value;
		      }
		      var result = (value + '');
		      return (result == '0' && (1 / value) == -INFINITY) ? '-0' : result;
		    }

		    /**
		     * Converts `func` to its source code.
		     *
		     * @private
		     * @param {Function} func The function to convert.
		     * @returns {string} Returns the source code.
		     */
		    function toSource(func) {
		      if (func != null) {
		        try {
		          return funcToString.call(func);
		        } catch (e) {}
		        try {
		          return (func + '');
		        } catch (e) {}
		      }
		      return '';
		    }

		    /**
		     * Updates wrapper `details` based on `bitmask` flags.
		     *
		     * @private
		     * @returns {Array} details The details to modify.
		     * @param {number} bitmask The bitmask flags. See `createWrap` for more details.
		     * @returns {Array} Returns `details`.
		     */
		    function updateWrapDetails(details, bitmask) {
		      arrayEach(wrapFlags, function(pair) {
		        var value = '_.' + pair[0];
		        if ((bitmask & pair[1]) && !arrayIncludes(details, value)) {
		          details.push(value);
		        }
		      });
		      return details.sort();
		    }

		    /**
		     * Creates a clone of `wrapper`.
		     *
		     * @private
		     * @param {Object} wrapper The wrapper to clone.
		     * @returns {Object} Returns the cloned wrapper.
		     */
		    function wrapperClone(wrapper) {
		      if (wrapper instanceof LazyWrapper) {
		        return wrapper.clone();
		      }
		      var result = new LodashWrapper(wrapper.__wrapped__, wrapper.__chain__);
		      result.__actions__ = copyArray(wrapper.__actions__);
		      result.__index__  = wrapper.__index__;
		      result.__values__ = wrapper.__values__;
		      return result;
		    }

		    /*------------------------------------------------------------------------*/

		    /**
		     * Creates an array of elements split into groups the length of `size`.
		     * If `array` can't be split evenly, the final chunk will be the remaining
		     * elements.
		     *
		     * @static
		     * @memberOf _
		     * @since 3.0.0
		     * @category Array
		     * @param {Array} array The array to process.
		     * @param {number} [size=1] The length of each chunk
		     * @param- {Object} [guard] Enables use as an iteratee for methods like `_.map`.
		     * @returns {Array} Returns the new array of chunks.
		     * @example
		     *
		     * _.chunk(['a', 'b', 'c', 'd'], 2);
		     * // => [['a', 'b'], ['c', 'd']]
		     *
		     * _.chunk(['a', 'b', 'c', 'd'], 3);
		     * // => [['a', 'b', 'c'], ['d']]
		     */
		    function chunk(array, size, guard) {
		      if ((guard ? isIterateeCall(array, size, guard) : size === undefined$1)) {
		        size = 1;
		      } else {
		        size = nativeMax(toInteger(size), 0);
		      }
		      var length = array == null ? 0 : array.length;
		      if (!length || size < 1) {
		        return [];
		      }
		      var index = 0,
		          resIndex = 0,
		          result = Array(nativeCeil(length / size));

		      while (index < length) {
		        result[resIndex++] = baseSlice(array, index, (index += size));
		      }
		      return result;
		    }

		    /**
		     * Creates an array with all falsey values removed. The values `false`, `null`,
		     * `0`, `""`, `undefined`, and `NaN` are falsey.
		     *
		     * @static
		     * @memberOf _
		     * @since 0.1.0
		     * @category Array
		     * @param {Array} array The array to compact.
		     * @returns {Array} Returns the new array of filtered values.
		     * @example
		     *
		     * _.compact([0, 1, false, 2, '', 3]);
		     * // => [1, 2, 3]
		     */
		    function compact(array) {
		      var index = -1,
		          length = array == null ? 0 : array.length,
		          resIndex = 0,
		          result = [];

		      while (++index < length) {
		        var value = array[index];
		        if (value) {
		          result[resIndex++] = value;
		        }
		      }
		      return result;
		    }

		    /**
		     * Creates a new array concatenating `array` with any additional arrays
		     * and/or values.
		     *
		     * @static
		     * @memberOf _
		     * @since 4.0.0
		     * @category Array
		     * @param {Array} array The array to concatenate.
		     * @param {...*} [values] The values to concatenate.
		     * @returns {Array} Returns the new concatenated array.
		     * @example
		     *
		     * var array = [1];
		     * var other = _.concat(array, 2, [3], [[4]]);
		     *
		     * console.log(other);
		     * // => [1, 2, 3, [4]]
		     *
		     * console.log(array);
		     * // => [1]
		     */
		    function concat() {
		      var length = arguments.length;
		      if (!length) {
		        return [];
		      }
		      var args = Array(length - 1),
		          array = arguments[0],
		          index = length;

		      while (index--) {
		        args[index - 1] = arguments[index];
		      }
		      return arrayPush(isArray(array) ? copyArray(array) : [array], baseFlatten(args, 1));
		    }

		    /**
		     * Creates an array of `array` values not included in the other given arrays
		     * using [`SameValueZero`](http://ecma-international.org/ecma-262/7.0/#sec-samevaluezero)
		     * for equality comparisons. The order and references of result values are
		     * determined by the first array.
		     *
		     * **Note:** Unlike `_.pullAll`, this method returns a new array.
		     *
		     * @static
		     * @memberOf _
		     * @since 0.1.0
		     * @category Array
		     * @param {Array} array The array to inspect.
		     * @param {...Array} [values] The values to exclude.
		     * @returns {Array} Returns the new array of filtered values.
		     * @see _.without, _.xor
		     * @example
		     *
		     * _.difference([2, 1], [2, 3]);
		     * // => [1]
		     */
		    var difference = baseRest(function(array, values) {
		      return isArrayLikeObject(array)
		        ? baseDifference(array, baseFlatten(values, 1, isArrayLikeObject, true))
		        : [];
		    });

		    /**
		     * This method is like `_.difference` except that it accepts `iteratee` which
		     * is invoked for each element of `array` and `values` to generate the criterion
		     * by which they're compared. The order and references of result values are
		     * determined by the first array. The iteratee is invoked with one argument:
		     * (value).
		     *
		     * **Note:** Unlike `_.pullAllBy`, this method returns a new array.
		     *
		     * @static
		     * @memberOf _
		     * @since 4.0.0
		     * @category Array
		     * @param {Array} array The array to inspect.
		     * @param {...Array} [values] The values to exclude.
		     * @param {Function} [iteratee=_.identity] The iteratee invoked per element.
		     * @returns {Array} Returns the new array of filtered values.
		     * @example
		     *
		     * _.differenceBy([2.1, 1.2], [2.3, 3.4], Math.floor);
		     * // => [1.2]
		     *
		     * // The `_.property` iteratee shorthand.
		     * _.differenceBy([{ 'x': 2 }, { 'x': 1 }], [{ 'x': 1 }], 'x');
		     * // => [{ 'x': 2 }]
		     */
		    var differenceBy = baseRest(function(array, values) {
		      var iteratee = last(values);
		      if (isArrayLikeObject(iteratee)) {
		        iteratee = undefined$1;
		      }
		      return isArrayLikeObject(array)
		        ? baseDifference(array, baseFlatten(values, 1, isArrayLikeObject, true), getIteratee(iteratee, 2))
		        : [];
		    });

		    /**
		     * This method is like `_.difference` except that it accepts `comparator`
		     * which is invoked to compare elements of `array` to `values`. The order and
		     * references of result values are determined by the first array. The comparator
		     * is invoked with two arguments: (arrVal, othVal).
		     *
		     * **Note:** Unlike `_.pullAllWith`, this method returns a new array.
		     *
		     * @static
		     * @memberOf _
		     * @since 4.0.0
		     * @category Array
		     * @param {Array} array The array to inspect.
		     * @param {...Array} [values] The values to exclude.
		     * @param {Function} [comparator] The comparator invoked per element.
		     * @returns {Array} Returns the new array of filtered values.
		     * @example
		     *
		     * var objects = [{ 'x': 1, 'y': 2 }, { 'x': 2, 'y': 1 }];
		     *
		     * _.differenceWith(objects, [{ 'x': 1, 'y': 2 }], _.isEqual);
		     * // => [{ 'x': 2, 'y': 1 }]
		     */
		    var differenceWith = baseRest(function(array, values) {
		      var comparator = last(values);
		      if (isArrayLikeObject(comparator)) {
		        comparator = undefined$1;
		      }
		      return isArrayLikeObject(array)
		        ? baseDifference(array, baseFlatten(values, 1, isArrayLikeObject, true), undefined$1, comparator)
		        : [];
		    });

		    /**
		     * Creates a slice of `array` with `n` elements dropped from the beginning.
		     *
		     * @static
		     * @memberOf _
		     * @since 0.5.0
		     * @category Array
		     * @param {Array} array The array to query.
		     * @param {number} [n=1] The number of elements to drop.
		     * @param- {Object} [guard] Enables use as an iteratee for methods like `_.map`.
		     * @returns {Array} Returns the slice of `array`.
		     * @example
		     *
		     * _.drop([1, 2, 3]);
		     * // => [2, 3]
		     *
		     * _.drop([1, 2, 3], 2);
		     * // => [3]
		     *
		     * _.drop([1, 2, 3], 5);
		     * // => []
		     *
		     * _.drop([1, 2, 3], 0);
		     * // => [1, 2, 3]
		     */
		    function drop(array, n, guard) {
		      var length = array == null ? 0 : array.length;
		      if (!length) {
		        return [];
		      }
		      n = (guard || n === undefined$1) ? 1 : toInteger(n);
		      return baseSlice(array, n < 0 ? 0 : n, length);
		    }

		    /**
		     * Creates a slice of `array` with `n` elements dropped from the end.
		     *
		     * @static
		     * @memberOf _
		     * @since 3.0.0
		     * @category Array
		     * @param {Array} array The array to query.
		     * @param {number} [n=1] The number of elements to drop.
		     * @param- {Object} [guard] Enables use as an iteratee for methods like `_.map`.
		     * @returns {Array} Returns the slice of `array`.
		     * @example
		     *
		     * _.dropRight([1, 2, 3]);
		     * // => [1, 2]
		     *
		     * _.dropRight([1, 2, 3], 2);
		     * // => [1]
		     *
		     * _.dropRight([1, 2, 3], 5);
		     * // => []
		     *
		     * _.dropRight([1, 2, 3], 0);
		     * // => [1, 2, 3]
		     */
		    function dropRight(array, n, guard) {
		      var length = array == null ? 0 : array.length;
		      if (!length) {
		        return [];
		      }
		      n = (guard || n === undefined$1) ? 1 : toInteger(n);
		      n = length - n;
		      return baseSlice(array, 0, n < 0 ? 0 : n);
		    }

		    /**
		     * Creates a slice of `array` excluding elements dropped from the end.
		     * Elements are dropped until `predicate` returns falsey. The predicate is
		     * invoked with three arguments: (value, index, array).
		     *
		     * @static
		     * @memberOf _
		     * @since 3.0.0
		     * @category Array
		     * @param {Array} array The array to query.
		     * @param {Function} [predicate=_.identity] The function invoked per iteration.
		     * @returns {Array} Returns the slice of `array`.
		     * @example
		     *
		     * var users = [
		     *   { 'user': 'barney',  'active': true },
		     *   { 'user': 'fred',    'active': false },
		     *   { 'user': 'pebbles', 'active': false }
		     * ];
		     *
		     * _.dropRightWhile(users, function(o) { return !o.active; });
		     * // => objects for ['barney']
		     *
		     * // The `_.matches` iteratee shorthand.
		     * _.dropRightWhile(users, { 'user': 'pebbles', 'active': false });
		     * // => objects for ['barney', 'fred']
		     *
		     * // The `_.matchesProperty` iteratee shorthand.
		     * _.dropRightWhile(users, ['active', false]);
		     * // => objects for ['barney']
		     *
		     * // The `_.property` iteratee shorthand.
		     * _.dropRightWhile(users, 'active');
		     * // => objects for ['barney', 'fred', 'pebbles']
		     */
		    function dropRightWhile(array, predicate) {
		      return (array && array.length)
		        ? baseWhile(array, getIteratee(predicate, 3), true, true)
		        : [];
		    }

		    /**
		     * Creates a slice of `array` excluding elements dropped from the beginning.
		     * Elements are dropped until `predicate` returns falsey. The predicate is
		     * invoked with three arguments: (value, index, array).
		     *
		     * @static
		     * @memberOf _
		     * @since 3.0.0
		     * @category Array
		     * @param {Array} array The array to query.
		     * @param {Function} [predicate=_.identity] The function invoked per iteration.
		     * @returns {Array} Returns the slice of `array`.
		     * @example
		     *
		     * var users = [
		     *   { 'user': 'barney',  'active': false },
		     *   { 'user': 'fred',    'active': false },
		     *   { 'user': 'pebbles', 'active': true }
		     * ];
		     *
		     * _.dropWhile(users, function(o) { return !o.active; });
		     * // => objects for ['pebbles']
		     *
		     * // The `_.matches` iteratee shorthand.
		     * _.dropWhile(users, { 'user': 'barney', 'active': false });
		     * // => objects for ['fred', 'pebbles']
		     *
		     * // The `_.matchesProperty` iteratee shorthand.
		     * _.dropWhile(users, ['active', false]);
		     * // => objects for ['pebbles']
		     *
		     * // The `_.property` iteratee shorthand.
		     * _.dropWhile(users, 'active');
		     * // => objects for ['barney', 'fred', 'pebbles']
		     */
		    function dropWhile(array, predicate) {
		      return (array && array.length)
		        ? baseWhile(array, getIteratee(predicate, 3), true)
		        : [];
		    }

		    /**
		     * Fills elements of `array` with `value` from `start` up to, but not
		     * including, `end`.
		     *
		     * **Note:** This method mutates `array`.
		     *
		     * @static
		     * @memberOf _
		     * @since 3.2.0
		     * @category Array
		     * @param {Array} array The array to fill.
		     * @param {*} value The value to fill `array` with.
		     * @param {number} [start=0] The start position.
		     * @param {number} [end=array.length] The end position.
		     * @returns {Array} Returns `array`.
		     * @example
		     *
		     * var array = [1, 2, 3];
		     *
		     * _.fill(array, 'a');
		     * console.log(array);
		     * // => ['a', 'a', 'a']
		     *
		     * _.fill(Array(3), 2);
		     * // => [2, 2, 2]
		     *
		     * _.fill([4, 6, 8, 10], '*', 1, 3);
		     * // => [4, '*', '*', 10]
		     */
		    function fill(array, value, start, end) {
		      var length = array == null ? 0 : array.length;
		      if (!length) {
		        return [];
		      }
		      if (start && typeof start != 'number' && isIterateeCall(array, value, start)) {
		        start = 0;
		        end = length;
		      }
		      return baseFill(array, value, start, end);
		    }

		    /**
		     * This method is like `_.find` except that it returns the index of the first
		     * element `predicate` returns truthy for instead of the element itself.
		     *
		     * @static
		     * @memberOf _
		     * @since 1.1.0
		     * @category Array
		     * @param {Array} array The array to inspect.
		     * @param {Function} [predicate=_.identity] The function invoked per iteration.
		     * @param {number} [fromIndex=0] The index to search from.
		     * @returns {number} Returns the index of the found element, else `-1`.
		     * @example
		     *
		     * var users = [
		     *   { 'user': 'barney',  'active': false },
		     *   { 'user': 'fred',    'active': false },
		     *   { 'user': 'pebbles', 'active': true }
		     * ];
		     *
		     * _.findIndex(users, function(o) { return o.user == 'barney'; });
		     * // => 0
		     *
		     * // The `_.matches` iteratee shorthand.
		     * _.findIndex(users, { 'user': 'fred', 'active': false });
		     * // => 1
		     *
		     * // The `_.matchesProperty` iteratee shorthand.
		     * _.findIndex(users, ['active', false]);
		     * // => 0
		     *
		     * // The `_.property` iteratee shorthand.
		     * _.findIndex(users, 'active');
		     * // => 2
		     */
		    function findIndex(array, predicate, fromIndex) {
		      var length = array == null ? 0 : array.length;
		      if (!length) {
		        return -1;
		      }
		      var index = fromIndex == null ? 0 : toInteger(fromIndex);
		      if (index < 0) {
		        index = nativeMax(length + index, 0);
		      }
		      return baseFindIndex(array, getIteratee(predicate, 3), index);
		    }

		    /**
		     * This method is like `_.findIndex` except that it iterates over elements
		     * of `collection` from right to left.
		     *
		     * @static
		     * @memberOf _
		     * @since 2.0.0
		     * @category Array
		     * @param {Array} array The array to inspect.
		     * @param {Function} [predicate=_.identity] The function invoked per iteration.
		     * @param {number} [fromIndex=array.length-1] The index to search from.
		     * @returns {number} Returns the index of the found element, else `-1`.
		     * @example
		     *
		     * var users = [
		     *   { 'user': 'barney',  'active': true },
		     *   { 'user': 'fred',    'active': false },
		     *   { 'user': 'pebbles', 'active': false }
		     * ];
		     *
		     * _.findLastIndex(users, function(o) { return o.user == 'pebbles'; });
		     * // => 2
		     *
		     * // The `_.matches` iteratee shorthand.
		     * _.findLastIndex(users, { 'user': 'barney', 'active': true });
		     * // => 0
		     *
		     * // The `_.matchesProperty` iteratee shorthand.
		     * _.findLastIndex(users, ['active', false]);
		     * // => 2
		     *
		     * // The `_.property` iteratee shorthand.
		     * _.findLastIndex(users, 'active');
		     * // => 0
		     */
		    function findLastIndex(array, predicate, fromIndex) {
		      var length = array == null ? 0 : array.length;
		      if (!length) {
		        return -1;
		      }
		      var index = length - 1;
		      if (fromIndex !== undefined$1) {
		        index = toInteger(fromIndex);
		        index = fromIndex < 0
		          ? nativeMax(length + index, 0)
		          : nativeMin(index, length - 1);
		      }
		      return baseFindIndex(array, getIteratee(predicate, 3), index, true);
		    }

		    /**
		     * Flattens `array` a single level deep.
		     *
		     * @static
		     * @memberOf _
		     * @since 0.1.0
		     * @category Array
		     * @param {Array} array The array to flatten.
		     * @returns {Array} Returns the new flattened array.
		     * @example
		     *
		     * _.flatten([1, [2, [3, [4]], 5]]);
		     * // => [1, 2, [3, [4]], 5]
		     */
		    function flatten(array) {
		      var length = array == null ? 0 : array.length;
		      return length ? baseFlatten(array, 1) : [];
		    }

		    /**
		     * Recursively flattens `array`.
		     *
		     * @static
		     * @memberOf _
		     * @since 3.0.0
		     * @category Array
		     * @param {Array} array The array to flatten.
		     * @returns {Array} Returns the new flattened array.
		     * @example
		     *
		     * _.flattenDeep([1, [2, [3, [4]], 5]]);
		     * // => [1, 2, 3, 4, 5]
		     */
		    function flattenDeep(array) {
		      var length = array == null ? 0 : array.length;
		      return length ? baseFlatten(array, INFINITY) : [];
		    }

		    /**
		     * Recursively flatten `array` up to `depth` times.
		     *
		     * @static
		     * @memberOf _
		     * @since 4.4.0
		     * @category Array
		     * @param {Array} array The array to flatten.
		     * @param {number} [depth=1] The maximum recursion depth.
		     * @returns {Array} Returns the new flattened array.
		     * @example
		     *
		     * var array = [1, [2, [3, [4]], 5]];
		     *
		     * _.flattenDepth(array, 1);
		     * // => [1, 2, [3, [4]], 5]
		     *
		     * _.flattenDepth(array, 2);
		     * // => [1, 2, 3, [4], 5]
		     */
		    function flattenDepth(array, depth) {
		      var length = array == null ? 0 : array.length;
		      if (!length) {
		        return [];
		      }
		      depth = depth === undefined$1 ? 1 : toInteger(depth);
		      return baseFlatten(array, depth);
		    }

		    /**
		     * The inverse of `_.toPairs`; this method returns an object composed
		     * from key-value `pairs`.
		     *
		     * @static
		     * @memberOf _
		     * @since 4.0.0
		     * @category Array
		     * @param {Array} pairs The key-value pairs.
		     * @returns {Object} Returns the new object.
		     * @example
		     *
		     * _.fromPairs([['a', 1], ['b', 2]]);
		     * // => { 'a': 1, 'b': 2 }
		     */
		    function fromPairs(pairs) {
		      var index = -1,
		          length = pairs == null ? 0 : pairs.length,
		          result = {};

		      while (++index < length) {
		        var pair = pairs[index];
		        result[pair[0]] = pair[1];
		      }
		      return result;
		    }

		    /**
		     * Gets the first element of `array`.
		     *
		     * @static
		     * @memberOf _
		     * @since 0.1.0
		     * @alias first
		     * @category Array
		     * @param {Array} array The array to query.
		     * @returns {*} Returns the first element of `array`.
		     * @example
		     *
		     * _.head([1, 2, 3]);
		     * // => 1
		     *
		     * _.head([]);
		     * // => undefined
		     */
		    function head(array) {
		      return (array && array.length) ? array[0] : undefined$1;
		    }

		    /**
		     * Gets the index at which the first occurrence of `value` is found in `array`
		     * using [`SameValueZero`](http://ecma-international.org/ecma-262/7.0/#sec-samevaluezero)
		     * for equality comparisons. If `fromIndex` is negative, it's used as the
		     * offset from the end of `array`.
		     *
		     * @static
		     * @memberOf _
		     * @since 0.1.0
		     * @category Array
		     * @param {Array} array The array to inspect.
		     * @param {*} value The value to search for.
		     * @param {number} [fromIndex=0] The index to search from.
		     * @returns {number} Returns the index of the matched value, else `-1`.
		     * @example
		     *
		     * _.indexOf([1, 2, 1, 2], 2);
		     * // => 1
		     *
		     * // Search from the `fromIndex`.
		     * _.indexOf([1, 2, 1, 2], 2, 2);
		     * // => 3
		     */
		    function indexOf(array, value, fromIndex) {
		      var length = array == null ? 0 : array.length;
		      if (!length) {
		        return -1;
		      }
		      var index = fromIndex == null ? 0 : toInteger(fromIndex);
		      if (index < 0) {
		        index = nativeMax(length + index, 0);
		      }
		      return baseIndexOf(array, value, index);
		    }

		    /**
		     * Gets all but the last element of `array`.
		     *
		     * @static
		     * @memberOf _
		     * @since 0.1.0
		     * @category Array
		     * @param {Array} array The array to query.
		     * @returns {Array} Returns the slice of `array`.
		     * @example
		     *
		     * _.initial([1, 2, 3]);
		     * // => [1, 2]
		     */
		    function initial(array) {
		      var length = array == null ? 0 : array.length;
		      return length ? baseSlice(array, 0, -1) : [];
		    }

		    /**
		     * Creates an array of unique values that are included in all given arrays
		     * using [`SameValueZero`](http://ecma-international.org/ecma-262/7.0/#sec-samevaluezero)
		     * for equality comparisons. The order and references of result values are
		     * determined by the first array.
		     *
		     * @static
		     * @memberOf _
		     * @since 0.1.0
		     * @category Array
		     * @param {...Array} [arrays] The arrays to inspect.
		     * @returns {Array} Returns the new array of intersecting values.
		     * @example
		     *
		     * _.intersection([2, 1], [2, 3]);
		     * // => [2]
		     */
		    var intersection = baseRest(function(arrays) {
		      var mapped = arrayMap(arrays, castArrayLikeObject);
		      return (mapped.length && mapped[0] === arrays[0])
		        ? baseIntersection(mapped)
		        : [];
		    });

		    /**
		     * This method is like `_.intersection` except that it accepts `iteratee`
		     * which is invoked for each element of each `arrays` to generate the criterion
		     * by which they're compared. The order and references of result values are
		     * determined by the first array. The iteratee is invoked with one argument:
		     * (value).
		     *
		     * @static
		     * @memberOf _
		     * @since 4.0.0
		     * @category Array
		     * @param {...Array} [arrays] The arrays to inspect.
		     * @param {Function} [iteratee=_.identity] The iteratee invoked per element.
		     * @returns {Array} Returns the new array of intersecting values.
		     * @example
		     *
		     * _.intersectionBy([2.1, 1.2], [2.3, 3.4], Math.floor);
		     * // => [2.1]
		     *
		     * // The `_.property` iteratee shorthand.
		     * _.intersectionBy([{ 'x': 1 }], [{ 'x': 2 }, { 'x': 1 }], 'x');
		     * // => [{ 'x': 1 }]
		     */
		    var intersectionBy = baseRest(function(arrays) {
		      var iteratee = last(arrays),
		          mapped = arrayMap(arrays, castArrayLikeObject);

		      if (iteratee === last(mapped)) {
		        iteratee = undefined$1;
		      } else {
		        mapped.pop();
		      }
		      return (mapped.length && mapped[0] === arrays[0])
		        ? baseIntersection(mapped, getIteratee(iteratee, 2))
		        : [];
		    });

		    /**
		     * This method is like `_.intersection` except that it accepts `comparator`
		     * which is invoked to compare elements of `arrays`. The order and references
		     * of result values are determined by the first array. The comparator is
		     * invoked with two arguments: (arrVal, othVal).
		     *
		     * @static
		     * @memberOf _
		     * @since 4.0.0
		     * @category Array
		     * @param {...Array} [arrays] The arrays to inspect.
		     * @param {Function} [comparator] The comparator invoked per element.
		     * @returns {Array} Returns the new array of intersecting values.
		     * @example
		     *
		     * var objects = [{ 'x': 1, 'y': 2 }, { 'x': 2, 'y': 1 }];
		     * var others = [{ 'x': 1, 'y': 1 }, { 'x': 1, 'y': 2 }];
		     *
		     * _.intersectionWith(objects, others, _.isEqual);
		     * // => [{ 'x': 1, 'y': 2 }]
		     */
		    var intersectionWith = baseRest(function(arrays) {
		      var comparator = last(arrays),
		          mapped = arrayMap(arrays, castArrayLikeObject);

		      comparator = typeof comparator == 'function' ? comparator : undefined$1;
		      if (comparator) {
		        mapped.pop();
		      }
		      return (mapped.length && mapped[0] === arrays[0])
		        ? baseIntersection(mapped, undefined$1, comparator)
		        : [];
		    });

		    /**
		     * Converts all elements in `array` into a string separated by `separator`.
		     *
		     * @static
		     * @memberOf _
		     * @since 4.0.0
		     * @category Array
		     * @param {Array} array The array to convert.
		     * @param {string} [separator=','] The element separator.
		     * @returns {string} Returns the joined string.
		     * @example
		     *
		     * _.join(['a', 'b', 'c'], '~');
		     * // => 'a~b~c'
		     */
		    function join(array, separator) {
		      return array == null ? '' : nativeJoin.call(array, separator);
		    }

		    /**
		     * Gets the last element of `array`.
		     *
		     * @static
		     * @memberOf _
		     * @since 0.1.0
		     * @category Array
		     * @param {Array} array The array to query.
		     * @returns {*} Returns the last element of `array`.
		     * @example
		     *
		     * _.last([1, 2, 3]);
		     * // => 3
		     */
		    function last(array) {
		      var length = array == null ? 0 : array.length;
		      return length ? array[length - 1] : undefined$1;
		    }

		    /**
		     * This method is like `_.indexOf` except that it iterates over elements of
		     * `array` from right to left.
		     *
		     * @static
		     * @memberOf _
		     * @since 0.1.0
		     * @category Array
		     * @param {Array} array The array to inspect.
		     * @param {*} value The value to search for.
		     * @param {number} [fromIndex=array.length-1] The index to search from.
		     * @returns {number} Returns the index of the matched value, else `-1`.
		     * @example
		     *
		     * _.lastIndexOf([1, 2, 1, 2], 2);
		     * // => 3
		     *
		     * // Search from the `fromIndex`.
		     * _.lastIndexOf([1, 2, 1, 2], 2, 2);
		     * // => 1
		     */
		    function lastIndexOf(array, value, fromIndex) {
		      var length = array == null ? 0 : array.length;
		      if (!length) {
		        return -1;
		      }
		      var index = length;
		      if (fromIndex !== undefined$1) {
		        index = toInteger(fromIndex);
		        index = index < 0 ? nativeMax(length + index, 0) : nativeMin(index, length - 1);
		      }
		      return value === value
		        ? strictLastIndexOf(array, value, index)
		        : baseFindIndex(array, baseIsNaN, index, true);
		    }

		    /**
		     * Gets the element at index `n` of `array`. If `n` is negative, the nth
		     * element from the end is returned.
		     *
		     * @static
		     * @memberOf _
		     * @since 4.11.0
		     * @category Array
		     * @param {Array} array The array to query.
		     * @param {number} [n=0] The index of the element to return.
		     * @returns {*} Returns the nth element of `array`.
		     * @example
		     *
		     * var array = ['a', 'b', 'c', 'd'];
		     *
		     * _.nth(array, 1);
		     * // => 'b'
		     *
		     * _.nth(array, -2);
		     * // => 'c';
		     */
		    function nth(array, n) {
		      return (array && array.length) ? baseNth(array, toInteger(n)) : undefined$1;
		    }

		    /**
		     * Removes all given values from `array` using
		     * [`SameValueZero`](http://ecma-international.org/ecma-262/7.0/#sec-samevaluezero)
		     * for equality comparisons.
		     *
		     * **Note:** Unlike `_.without`, this method mutates `array`. Use `_.remove`
		     * to remove elements from an array by predicate.
		     *
		     * @static
		     * @memberOf _
		     * @since 2.0.0
		     * @category Array
		     * @param {Array} array The array to modify.
		     * @param {...*} [values] The values to remove.
		     * @returns {Array} Returns `array`.
		     * @example
		     *
		     * var array = ['a', 'b', 'c', 'a', 'b', 'c'];
		     *
		     * _.pull(array, 'a', 'c');
		     * console.log(array);
		     * // => ['b', 'b']
		     */
		    var pull = baseRest(pullAll);

		    /**
		     * This method is like `_.pull` except that it accepts an array of values to remove.
		     *
		     * **Note:** Unlike `_.difference`, this method mutates `array`.
		     *
		     * @static
		     * @memberOf _
		     * @since 4.0.0
		     * @category Array
		     * @param {Array} array The array to modify.
		     * @param {Array} values The values to remove.
		     * @returns {Array} Returns `array`.
		     * @example
		     *
		     * var array = ['a', 'b', 'c', 'a', 'b', 'c'];
		     *
		     * _.pullAll(array, ['a', 'c']);
		     * console.log(array);
		     * // => ['b', 'b']
		     */
		    function pullAll(array, values) {
		      return (array && array.length && values && values.length)
		        ? basePullAll(array, values)
		        : array;
		    }

		    /**
		     * This method is like `_.pullAll` except that it accepts `iteratee` which is
		     * invoked for each element of `array` and `values` to generate the criterion
		     * by which they're compared. The iteratee is invoked with one argument: (value).
		     *
		     * **Note:** Unlike `_.differenceBy`, this method mutates `array`.
		     *
		     * @static
		     * @memberOf _
		     * @since 4.0.0
		     * @category Array
		     * @param {Array} array The array to modify.
		     * @param {Array} values The values to remove.
		     * @param {Function} [iteratee=_.identity] The iteratee invoked per element.
		     * @returns {Array} Returns `array`.
		     * @example
		     *
		     * var array = [{ 'x': 1 }, { 'x': 2 }, { 'x': 3 }, { 'x': 1 }];
		     *
		     * _.pullAllBy(array, [{ 'x': 1 }, { 'x': 3 }], 'x');
		     * console.log(array);
		     * // => [{ 'x': 2 }]
		     */
		    function pullAllBy(array, values, iteratee) {
		      return (array && array.length && values && values.length)
		        ? basePullAll(array, values, getIteratee(iteratee, 2))
		        : array;
		    }

		    /**
		     * This method is like `_.pullAll` except that it accepts `comparator` which
		     * is invoked to compare elements of `array` to `values`. The comparator is
		     * invoked with two arguments: (arrVal, othVal).
		     *
		     * **Note:** Unlike `_.differenceWith`, this method mutates `array`.
		     *
		     * @static
		     * @memberOf _
		     * @since 4.6.0
		     * @category Array
		     * @param {Array} array The array to modify.
		     * @param {Array} values The values to remove.
		     * @param {Function} [comparator] The comparator invoked per element.
		     * @returns {Array} Returns `array`.
		     * @example
		     *
		     * var array = [{ 'x': 1, 'y': 2 }, { 'x': 3, 'y': 4 }, { 'x': 5, 'y': 6 }];
		     *
		     * _.pullAllWith(array, [{ 'x': 3, 'y': 4 }], _.isEqual);
		     * console.log(array);
		     * // => [{ 'x': 1, 'y': 2 }, { 'x': 5, 'y': 6 }]
		     */
		    function pullAllWith(array, values, comparator) {
		      return (array && array.length && values && values.length)
		        ? basePullAll(array, values, undefined$1, comparator)
		        : array;
		    }

		    /**
		     * Removes elements from `array` corresponding to `indexes` and returns an
		     * array of removed elements.
		     *
		     * **Note:** Unlike `_.at`, this method mutates `array`.
		     *
		     * @static
		     * @memberOf _
		     * @since 3.0.0
		     * @category Array
		     * @param {Array} array The array to modify.
		     * @param {...(number|number[])} [indexes] The indexes of elements to remove.
		     * @returns {Array} Returns the new array of removed elements.
		     * @example
		     *
		     * var array = ['a', 'b', 'c', 'd'];
		     * var pulled = _.pullAt(array, [1, 3]);
		     *
		     * console.log(array);
		     * // => ['a', 'c']
		     *
		     * console.log(pulled);
		     * // => ['b', 'd']
		     */
		    var pullAt = flatRest(function(array, indexes) {
		      var length = array == null ? 0 : array.length,
		          result = baseAt(array, indexes);

		      basePullAt(array, arrayMap(indexes, function(index) {
		        return isIndex(index, length) ? +index : index;
		      }).sort(compareAscending));

		      return result;
		    });

		    /**
		     * Removes all elements from `array` that `predicate` returns truthy for
		     * and returns an array of the removed elements. The predicate is invoked
		     * with three arguments: (value, index, array).
		     *
		     * **Note:** Unlike `_.filter`, this method mutates `array`. Use `_.pull`
		     * to pull elements from an array by value.
		     *
		     * @static
		     * @memberOf _
		     * @since 2.0.0
		     * @category Array
		     * @param {Array} array The array to modify.
		     * @param {Function} [predicate=_.identity] The function invoked per iteration.
		     * @returns {Array} Returns the new array of removed elements.
		     * @example
		     *
		     * var array = [1, 2, 3, 4];
		     * var evens = _.remove(array, function(n) {
		     *   return n % 2 == 0;
		     * });
		     *
		     * console.log(array);
		     * // => [1, 3]
		     *
		     * console.log(evens);
		     * // => [2, 4]
		     */
		    function remove(array, predicate) {
		      var result = [];
		      if (!(array && array.length)) {
		        return result;
		      }
		      var index = -1,
		          indexes = [],
		          length = array.length;

		      predicate = getIteratee(predicate, 3);
		      while (++index < length) {
		        var value = array[index];
		        if (predicate(value, index, array)) {
		          result.push(value);
		          indexes.push(index);
		        }
		      }
		      basePullAt(array, indexes);
		      return result;
		    }

		    /**
		     * Reverses `array` so that the first element becomes the last, the second
		     * element becomes the second to last, and so on.
		     *
		     * **Note:** This method mutates `array` and is based on
		     * [`Array#reverse`](https://mdn.io/Array/reverse).
		     *
		     * @static
		     * @memberOf _
		     * @since 4.0.0
		     * @category Array
		     * @param {Array} array The array to modify.
		     * @returns {Array} Returns `array`.
		     * @example
		     *
		     * var array = [1, 2, 3];
		     *
		     * _.reverse(array);
		     * // => [3, 2, 1]
		     *
		     * console.log(array);
		     * // => [3, 2, 1]
		     */
		    function reverse(array) {
		      return array == null ? array : nativeReverse.call(array);
		    }

		    /**
		     * Creates a slice of `array` from `start` up to, but not including, `end`.
		     *
		     * **Note:** This method is used instead of
		     * [`Array#slice`](https://mdn.io/Array/slice) to ensure dense arrays are
		     * returned.
		     *
		     * @static
		     * @memberOf _
		     * @since 3.0.0
		     * @category Array
		     * @param {Array} array The array to slice.
		     * @param {number} [start=0] The start position.
		     * @param {number} [end=array.length] The end position.
		     * @returns {Array} Returns the slice of `array`.
		     */
		    function slice(array, start, end) {
		      var length = array == null ? 0 : array.length;
		      if (!length) {
		        return [];
		      }
		      if (end && typeof end != 'number' && isIterateeCall(array, start, end)) {
		        start = 0;
		        end = length;
		      }
		      else {
		        start = start == null ? 0 : toInteger(start);
		        end = end === undefined$1 ? length : toInteger(end);
		      }
		      return baseSlice(array, start, end);
		    }

		    /**
		     * Uses a binary search to determine the lowest index at which `value`
		     * should be inserted into `array` in order to maintain its sort order.
		     *
		     * @static
		     * @memberOf _
		     * @since 0.1.0
		     * @category Array
		     * @param {Array} array The sorted array to inspect.
		     * @param {*} value The value to evaluate.
		     * @returns {number} Returns the index at which `value` should be inserted
		     *  into `array`.
		     * @example
		     *
		     * _.sortedIndex([30, 50], 40);
		     * // => 1
		     */
		    function sortedIndex(array, value) {
		      return baseSortedIndex(array, value);
		    }

		    /**
		     * This method is like `_.sortedIndex` except that it accepts `iteratee`
		     * which is invoked for `value` and each element of `array` to compute their
		     * sort ranking. The iteratee is invoked with one argument: (value).
		     *
		     * @static
		     * @memberOf _
		     * @since 4.0.0
		     * @category Array
		     * @param {Array} array The sorted array to inspect.
		     * @param {*} value The value to evaluate.
		     * @param {Function} [iteratee=_.identity] The iteratee invoked per element.
		     * @returns {number} Returns the index at which `value` should be inserted
		     *  into `array`.
		     * @example
		     *
		     * var objects = [{ 'x': 4 }, { 'x': 5 }];
		     *
		     * _.sortedIndexBy(objects, { 'x': 4 }, function(o) { return o.x; });
		     * // => 0
		     *
		     * // The `_.property` iteratee shorthand.
		     * _.sortedIndexBy(objects, { 'x': 4 }, 'x');
		     * // => 0
		     */
		    function sortedIndexBy(array, value, iteratee) {
		      return baseSortedIndexBy(array, value, getIteratee(iteratee, 2));
		    }

		    /**
		     * This method is like `_.indexOf` except that it performs a binary
		     * search on a sorted `array`.
		     *
		     * @static
		     * @memberOf _
		     * @since 4.0.0
		     * @category Array
		     * @param {Array} array The array to inspect.
		     * @param {*} value The value to search for.
		     * @returns {number} Returns the index of the matched value, else `-1`.
		     * @example
		     *
		     * _.sortedIndexOf([4, 5, 5, 5, 6], 5);
		     * // => 1
		     */
		    function sortedIndexOf(array, value) {
		      var length = array == null ? 0 : array.length;
		      if (length) {
		        var index = baseSortedIndex(array, value);
		        if (index < length && eq(array[index], value)) {
		          return index;
		        }
		      }
		      return -1;
		    }

		    /**
		     * This method is like `_.sortedIndex` except that it returns the highest
		     * index at which `value` should be inserted into `array` in order to
		     * maintain its sort order.
		     *
		     * @static
		     * @memberOf _
		     * @since 3.0.0
		     * @category Array
		     * @param {Array} array The sorted array to inspect.
		     * @param {*} value The value to evaluate.
		     * @returns {number} Returns the index at which `value` should be inserted
		     *  into `array`.
		     * @example
		     *
		     * _.sortedLastIndex([4, 5, 5, 5, 6], 5);
		     * // => 4
		     */
		    function sortedLastIndex(array, value) {
		      return baseSortedIndex(array, value, true);
		    }

		    /**
		     * This method is like `_.sortedLastIndex` except that it accepts `iteratee`
		     * which is invoked for `value` and each element of `array` to compute their
		     * sort ranking. The iteratee is invoked with one argument: (value).
		     *
		     * @static
		     * @memberOf _
		     * @since 4.0.0
		     * @category Array
		     * @param {Array} array The sorted array to inspect.
		     * @param {*} value The value to evaluate.
		     * @param {Function} [iteratee=_.identity] The iteratee invoked per element.
		     * @returns {number} Returns the index at which `value` should be inserted
		     *  into `array`.
		     * @example
		     *
		     * var objects = [{ 'x': 4 }, { 'x': 5 }];
		     *
		     * _.sortedLastIndexBy(objects, { 'x': 4 }, function(o) { return o.x; });
		     * // => 1
		     *
		     * // The `_.property` iteratee shorthand.
		     * _.sortedLastIndexBy(objects, { 'x': 4 }, 'x');
		     * // => 1
		     */
		    function sortedLastIndexBy(array, value, iteratee) {
		      return baseSortedIndexBy(array, value, getIteratee(iteratee, 2), true);
		    }

		    /**
		     * This method is like `_.lastIndexOf` except that it performs a binary
		     * search on a sorted `array`.
		     *
		     * @static
		     * @memberOf _
		     * @since 4.0.0
		     * @category Array
		     * @param {Array} array The array to inspect.
		     * @param {*} value The value to search for.
		     * @returns {number} Returns the index of the matched value, else `-1`.
		     * @example
		     *
		     * _.sortedLastIndexOf([4, 5, 5, 5, 6], 5);
		     * // => 3
		     */
		    function sortedLastIndexOf(array, value) {
		      var length = array == null ? 0 : array.length;
		      if (length) {
		        var index = baseSortedIndex(array, value, true) - 1;
		        if (eq(array[index], value)) {
		          return index;
		        }
		      }
		      return -1;
		    }

		    /**
		     * This method is like `_.uniq` except that it's designed and optimized
		     * for sorted arrays.
		     *
		     * @static
		     * @memberOf _
		     * @since 4.0.0
		     * @category Array
		     * @param {Array} array The array to inspect.
		     * @returns {Array} Returns the new duplicate free array.
		     * @example
		     *
		     * _.sortedUniq([1, 1, 2]);
		     * // => [1, 2]
		     */
		    function sortedUniq(array) {
		      return (array && array.length)
		        ? baseSortedUniq(array)
		        : [];
		    }

		    /**
		     * This method is like `_.uniqBy` except that it's designed and optimized
		     * for sorted arrays.
		     *
		     * @static
		     * @memberOf _
		     * @since 4.0.0
		     * @category Array
		     * @param {Array} array The array to inspect.
		     * @param {Function} [iteratee] The iteratee invoked per element.
		     * @returns {Array} Returns the new duplicate free array.
		     * @example
		     *
		     * _.sortedUniqBy([1.1, 1.2, 2.3, 2.4], Math.floor);
		     * // => [1.1, 2.3]
		     */
		    function sortedUniqBy(array, iteratee) {
		      return (array && array.length)
		        ? baseSortedUniq(array, getIteratee(iteratee, 2))
		        : [];
		    }

		    /**
		     * Gets all but the first element of `array`.
		     *
		     * @static
		     * @memberOf _
		     * @since 4.0.0
		     * @category Array
		     * @param {Array} array The array to query.
		     * @returns {Array} Returns the slice of `array`.
		     * @example
		     *
		     * _.tail([1, 2, 3]);
		     * // => [2, 3]
		     */
		    function tail(array) {
		      var length = array == null ? 0 : array.length;
		      return length ? baseSlice(array, 1, length) : [];
		    }

		    /**
		     * Creates a slice of `array` with `n` elements taken from the beginning.
		     *
		     * @static
		     * @memberOf _
		     * @since 0.1.0
		     * @category Array
		     * @param {Array} array The array to query.
		     * @param {number} [n=1] The number of elements to take.
		     * @param- {Object} [guard] Enables use as an iteratee for methods like `_.map`.
		     * @returns {Array} Returns the slice of `array`.
		     * @example
		     *
		     * _.take([1, 2, 3]);
		     * // => [1]
		     *
		     * _.take([1, 2, 3], 2);
		     * // => [1, 2]
		     *
		     * _.take([1, 2, 3], 5);
		     * // => [1, 2, 3]
		     *
		     * _.take([1, 2, 3], 0);
		     * // => []
		     */
		    function take(array, n, guard) {
		      if (!(array && array.length)) {
		        return [];
		      }
		      n = (guard || n === undefined$1) ? 1 : toInteger(n);
		      return baseSlice(array, 0, n < 0 ? 0 : n);
		    }

		    /**
		     * Creates a slice of `array` with `n` elements taken from the end.
		     *
		     * @static
		     * @memberOf _
		     * @since 3.0.0
		     * @category Array
		     * @param {Array} array The array to query.
		     * @param {number} [n=1] The number of elements to take.
		     * @param- {Object} [guard] Enables use as an iteratee for methods like `_.map`.
		     * @returns {Array} Returns the slice of `array`.
		     * @example
		     *
		     * _.takeRight([1, 2, 3]);
		     * // => [3]
		     *
		     * _.takeRight([1, 2, 3], 2);
		     * // => [2, 3]
		     *
		     * _.takeRight([1, 2, 3], 5);
		     * // => [1, 2, 3]
		     *
		     * _.takeRight([1, 2, 3], 0);
		     * // => []
		     */
		    function takeRight(array, n, guard) {
		      var length = array == null ? 0 : array.length;
		      if (!length) {
		        return [];
		      }
		      n = (guard || n === undefined$1) ? 1 : toInteger(n);
		      n = length - n;
		      return baseSlice(array, n < 0 ? 0 : n, length);
		    }

		    /**
		     * Creates a slice of `array` with elements taken from the end. Elements are
		     * taken until `predicate` returns falsey. The predicate is invoked with
		     * three arguments: (value, index, array).
		     *
		     * @static
		     * @memberOf _
		     * @since 3.0.0
		     * @category Array
		     * @param {Array} array The array to query.
		     * @param {Function} [predicate=_.identity] The function invoked per iteration.
		     * @returns {Array} Returns the slice of `array`.
		     * @example
		     *
		     * var users = [
		     *   { 'user': 'barney',  'active': true },
		     *   { 'user': 'fred',    'active': false },
		     *   { 'user': 'pebbles', 'active': false }
		     * ];
		     *
		     * _.takeRightWhile(users, function(o) { return !o.active; });
		     * // => objects for ['fred', 'pebbles']
		     *
		     * // The `_.matches` iteratee shorthand.
		     * _.takeRightWhile(users, { 'user': 'pebbles', 'active': false });
		     * // => objects for ['pebbles']
		     *
		     * // The `_.matchesProperty` iteratee shorthand.
		     * _.takeRightWhile(users, ['active', false]);
		     * // => objects for ['fred', 'pebbles']
		     *
		     * // The `_.property` iteratee shorthand.
		     * _.takeRightWhile(users, 'active');
		     * // => []
		     */
		    function takeRightWhile(array, predicate) {
		      return (array && array.length)
		        ? baseWhile(array, getIteratee(predicate, 3), false, true)
		        : [];
		    }

		    /**
		     * Creates a slice of `array` with elements taken from the beginning. Elements
		     * are taken until `predicate` returns falsey. The predicate is invoked with
		     * three arguments: (value, index, array).
		     *
		     * @static
		     * @memberOf _
		     * @since 3.0.0
		     * @category Array
		     * @param {Array} array The array to query.
		     * @param {Function} [predicate=_.identity] The function invoked per iteration.
		     * @returns {Array} Returns the slice of `array`.
		     * @example
		     *
		     * var users = [
		     *   { 'user': 'barney',  'active': false },
		     *   { 'user': 'fred',    'active': false },
		     *   { 'user': 'pebbles', 'active': true }
		     * ];
		     *
		     * _.takeWhile(users, function(o) { return !o.active; });
		     * // => objects for ['barney', 'fred']
		     *
		     * // The `_.matches` iteratee shorthand.
		     * _.takeWhile(users, { 'user': 'barney', 'active': false });
		     * // => objects for ['barney']
		     *
		     * // The `_.matchesProperty` iteratee shorthand.
		     * _.takeWhile(users, ['active', false]);
		     * // => objects for ['barney', 'fred']
		     *
		     * // The `_.property` iteratee shorthand.
		     * _.takeWhile(users, 'active');
		     * // => []
		     */
		    function takeWhile(array, predicate) {
		      return (array && array.length)
		        ? baseWhile(array, getIteratee(predicate, 3))
		        : [];
		    }

		    /**
		     * Creates an array of unique values, in order, from all given arrays using
		     * [`SameValueZero`](http://ecma-international.org/ecma-262/7.0/#sec-samevaluezero)
		     * for equality comparisons.
		     *
		     * @static
		     * @memberOf _
		     * @since 0.1.0
		     * @category Array
		     * @param {...Array} [arrays] The arrays to inspect.
		     * @returns {Array} Returns the new array of combined values.
		     * @example
		     *
		     * _.union([2], [1, 2]);
		     * // => [2, 1]
		     */
		    var union = baseRest(function(arrays) {
		      return baseUniq(baseFlatten(arrays, 1, isArrayLikeObject, true));
		    });

		    /**
		     * This method is like `_.union` except that it accepts `iteratee` which is
		     * invoked for each element of each `arrays` to generate the criterion by
		     * which uniqueness is computed. Result values are chosen from the first
		     * array in which the value occurs. The iteratee is invoked with one argument:
		     * (value).
		     *
		     * @static
		     * @memberOf _
		     * @since 4.0.0
		     * @category Array
		     * @param {...Array} [arrays] The arrays to inspect.
		     * @param {Function} [iteratee=_.identity] The iteratee invoked per element.
		     * @returns {Array} Returns the new array of combined values.
		     * @example
		     *
		     * _.unionBy([2.1], [1.2, 2.3], Math.floor);
		     * // => [2.1, 1.2]
		     *
		     * // The `_.property` iteratee shorthand.
		     * _.unionBy([{ 'x': 1 }], [{ 'x': 2 }, { 'x': 1 }], 'x');
		     * // => [{ 'x': 1 }, { 'x': 2 }]
		     */
		    var unionBy = baseRest(function(arrays) {
		      var iteratee = last(arrays);
		      if (isArrayLikeObject(iteratee)) {
		        iteratee = undefined$1;
		      }
		      return baseUniq(baseFlatten(arrays, 1, isArrayLikeObject, true), getIteratee(iteratee, 2));
		    });

		    /**
		     * This method is like `_.union` except that it accepts `comparator` which
		     * is invoked to compare elements of `arrays`. Result values are chosen from
		     * the first array in which the value occurs. The comparator is invoked
		     * with two arguments: (arrVal, othVal).
		     *
		     * @static
		     * @memberOf _
		     * @since 4.0.0
		     * @category Array
		     * @param {...Array} [arrays] The arrays to inspect.
		     * @param {Function} [comparator] The comparator invoked per element.
		     * @returns {Array} Returns the new array of combined values.
		     * @example
		     *
		     * var objects = [{ 'x': 1, 'y': 2 }, { 'x': 2, 'y': 1 }];
		     * var others = [{ 'x': 1, 'y': 1 }, { 'x': 1, 'y': 2 }];
		     *
		     * _.unionWith(objects, others, _.isEqual);
		     * // => [{ 'x': 1, 'y': 2 }, { 'x': 2, 'y': 1 }, { 'x': 1, 'y': 1 }]
		     */
		    var unionWith = baseRest(function(arrays) {
		      var comparator = last(arrays);
		      comparator = typeof comparator == 'function' ? comparator : undefined$1;
		      return baseUniq(baseFlatten(arrays, 1, isArrayLikeObject, true), undefined$1, comparator);
		    });

		    /**
		     * Creates a duplicate-free version of an array, using
		     * [`SameValueZero`](http://ecma-international.org/ecma-262/7.0/#sec-samevaluezero)
		     * for equality comparisons, in which only the first occurrence of each element
		     * is kept. The order of result values is determined by the order they occur
		     * in the array.
		     *
		     * @static
		     * @memberOf _
		     * @since 0.1.0
		     * @category Array
		     * @param {Array} array The array to inspect.
		     * @returns {Array} Returns the new duplicate free array.
		     * @example
		     *
		     * _.uniq([2, 1, 2]);
		     * // => [2, 1]
		     */
		    function uniq(array) {
		      return (array && array.length) ? baseUniq(array) : [];
		    }

		    /**
		     * This method is like `_.uniq` except that it accepts `iteratee` which is
		     * invoked for each element in `array` to generate the criterion by which
		     * uniqueness is computed. The order of result values is determined by the
		     * order they occur in the array. The iteratee is invoked with one argument:
		     * (value).
		     *
		     * @static
		     * @memberOf _
		     * @since 4.0.0
		     * @category Array
		     * @param {Array} array The array to inspect.
		     * @param {Function} [iteratee=_.identity] The iteratee invoked per element.
		     * @returns {Array} Returns the new duplicate free array.
		     * @example
		     *
		     * _.uniqBy([2.1, 1.2, 2.3], Math.floor);
		     * // => [2.1, 1.2]
		     *
		     * // The `_.property` iteratee shorthand.
		     * _.uniqBy([{ 'x': 1 }, { 'x': 2 }, { 'x': 1 }], 'x');
		     * // => [{ 'x': 1 }, { 'x': 2 }]
		     */
		    function uniqBy(array, iteratee) {
		      return (array && array.length) ? baseUniq(array, getIteratee(iteratee, 2)) : [];
		    }

		    /**
		     * This method is like `_.uniq` except that it accepts `comparator` which
		     * is invoked to compare elements of `array`. The order of result values is
		     * determined by the order they occur in the array.The comparator is invoked
		     * with two arguments: (arrVal, othVal).
		     *
		     * @static
		     * @memberOf _
		     * @since 4.0.0
		     * @category Array
		     * @param {Array} array The array to inspect.
		     * @param {Function} [comparator] The comparator invoked per element.
		     * @returns {Array} Returns the new duplicate free array.
		     * @example
		     *
		     * var objects = [{ 'x': 1, 'y': 2 }, { 'x': 2, 'y': 1 }, { 'x': 1, 'y': 2 }];
		     *
		     * _.uniqWith(objects, _.isEqual);
		     * // => [{ 'x': 1, 'y': 2 }, { 'x': 2, 'y': 1 }]
		     */
		    function uniqWith(array, comparator) {
		      comparator = typeof comparator == 'function' ? comparator : undefined$1;
		      return (array && array.length) ? baseUniq(array, undefined$1, comparator) : [];
		    }

		    /**
		     * This method is like `_.zip` except that it accepts an array of grouped
		     * elements and creates an array regrouping the elements to their pre-zip
		     * configuration.
		     *
		     * @static
		     * @memberOf _
		     * @since 1.2.0
		     * @category Array
		     * @param {Array} array The array of grouped elements to process.
		     * @returns {Array} Returns the new array of regrouped elements.
		     * @example
		     *
		     * var zipped = _.zip(['a', 'b'], [1, 2], [true, false]);
		     * // => [['a', 1, true], ['b', 2, false]]
		     *
		     * _.unzip(zipped);
		     * // => [['a', 'b'], [1, 2], [true, false]]
		     */
		    function unzip(array) {
		      if (!(array && array.length)) {
		        return [];
		      }
		      var length = 0;
		      array = arrayFilter(array, function(group) {
		        if (isArrayLikeObject(group)) {
		          length = nativeMax(group.length, length);
		          return true;
		        }
		      });
		      return baseTimes(length, function(index) {
		        return arrayMap(array, baseProperty(index));
		      });
		    }

		    /**
		     * This method is like `_.unzip` except that it accepts `iteratee` to specify
		     * how regrouped values should be combined. The iteratee is invoked with the
		     * elements of each group: (...group).
		     *
		     * @static
		     * @memberOf _
		     * @since 3.8.0
		     * @category Array
		     * @param {Array} array The array of grouped elements to process.
		     * @param {Function} [iteratee=_.identity] The function to combine
		     *  regrouped values.
		     * @returns {Array} Returns the new array of regrouped elements.
		     * @example
		     *
		     * var zipped = _.zip([1, 2], [10, 20], [100, 200]);
		     * // => [[1, 10, 100], [2, 20, 200]]
		     *
		     * _.unzipWith(zipped, _.add);
		     * // => [3, 30, 300]
		     */
		    function unzipWith(array, iteratee) {
		      if (!(array && array.length)) {
		        return [];
		      }
		      var result = unzip(array);
		      if (iteratee == null) {
		        return result;
		      }
		      return arrayMap(result, function(group) {
		        return apply(iteratee, undefined$1, group);
		      });
		    }

		    /**
		     * Creates an array excluding all given values using
		     * [`SameValueZero`](http://ecma-international.org/ecma-262/7.0/#sec-samevaluezero)
		     * for equality comparisons.
		     *
		     * **Note:** Unlike `_.pull`, this method returns a new array.
		     *
		     * @static
		     * @memberOf _
		     * @since 0.1.0
		     * @category Array
		     * @param {Array} array The array to inspect.
		     * @param {...*} [values] The values to exclude.
		     * @returns {Array} Returns the new array of filtered values.
		     * @see _.difference, _.xor
		     * @example
		     *
		     * _.without([2, 1, 2, 3], 1, 2);
		     * // => [3]
		     */
		    var without = baseRest(function(array, values) {
		      return isArrayLikeObject(array)
		        ? baseDifference(array, values)
		        : [];
		    });

		    /**
		     * Creates an array of unique values that is the
		     * [symmetric difference](https://en.wikipedia.org/wiki/Symmetric_difference)
		     * of the given arrays. The order of result values is determined by the order
		     * they occur in the arrays.
		     *
		     * @static
		     * @memberOf _
		     * @since 2.4.0
		     * @category Array
		     * @param {...Array} [arrays] The arrays to inspect.
		     * @returns {Array} Returns the new array of filtered values.
		     * @see _.difference, _.without
		     * @example
		     *
		     * _.xor([2, 1], [2, 3]);
		     * // => [1, 3]
		     */
		    var xor = baseRest(function(arrays) {
		      return baseXor(arrayFilter(arrays, isArrayLikeObject));
		    });

		    /**
		     * This method is like `_.xor` except that it accepts `iteratee` which is
		     * invoked for each element of each `arrays` to generate the criterion by
		     * which by which they're compared. The order of result values is determined
		     * by the order they occur in the arrays. The iteratee is invoked with one
		     * argument: (value).
		     *
		     * @static
		     * @memberOf _
		     * @since 4.0.0
		     * @category Array
		     * @param {...Array} [arrays] The arrays to inspect.
		     * @param {Function} [iteratee=_.identity] The iteratee invoked per element.
		     * @returns {Array} Returns the new array of filtered values.
		     * @example
		     *
		     * _.xorBy([2.1, 1.2], [2.3, 3.4], Math.floor);
		     * // => [1.2, 3.4]
		     *
		     * // The `_.property` iteratee shorthand.
		     * _.xorBy([{ 'x': 1 }], [{ 'x': 2 }, { 'x': 1 }], 'x');
		     * // => [{ 'x': 2 }]
		     */
		    var xorBy = baseRest(function(arrays) {
		      var iteratee = last(arrays);
		      if (isArrayLikeObject(iteratee)) {
		        iteratee = undefined$1;
		      }
		      return baseXor(arrayFilter(arrays, isArrayLikeObject), getIteratee(iteratee, 2));
		    });

		    /**
		     * This method is like `_.xor` except that it accepts `comparator` which is
		     * invoked to compare elements of `arrays`. The order of result values is
		     * determined by the order they occur in the arrays. The comparator is invoked
		     * with two arguments: (arrVal, othVal).
		     *
		     * @static
		     * @memberOf _
		     * @since 4.0.0
		     * @category Array
		     * @param {...Array} [arrays] The arrays to inspect.
		     * @param {Function} [comparator] The comparator invoked per element.
		     * @returns {Array} Returns the new array of filtered values.
		     * @example
		     *
		     * var objects = [{ 'x': 1, 'y': 2 }, { 'x': 2, 'y': 1 }];
		     * var others = [{ 'x': 1, 'y': 1 }, { 'x': 1, 'y': 2 }];
		     *
		     * _.xorWith(objects, others, _.isEqual);
		     * // => [{ 'x': 2, 'y': 1 }, { 'x': 1, 'y': 1 }]
		     */
		    var xorWith = baseRest(function(arrays) {
		      var comparator = last(arrays);
		      comparator = typeof comparator == 'function' ? comparator : undefined$1;
		      return baseXor(arrayFilter(arrays, isArrayLikeObject), undefined$1, comparator);
		    });

		    /**
		     * Creates an array of grouped elements, the first of which contains the
		     * first elements of the given arrays, the second of which contains the
		     * second elements of the given arrays, and so on.
		     *
		     * @static
		     * @memberOf _
		     * @since 0.1.0
		     * @category Array
		     * @param {...Array} [arrays] The arrays to process.
		     * @returns {Array} Returns the new array of grouped elements.
		     * @example
		     *
		     * _.zip(['a', 'b'], [1, 2], [true, false]);
		     * // => [['a', 1, true], ['b', 2, false]]
		     */
		    var zip = baseRest(unzip);

		    /**
		     * This method is like `_.fromPairs` except that it accepts two arrays,
		     * one of property identifiers and one of corresponding values.
		     *
		     * @static
		     * @memberOf _
		     * @since 0.4.0
		     * @category Array
		     * @param {Array} [props=[]] The property identifiers.
		     * @param {Array} [values=[]] The property values.
		     * @returns {Object} Returns the new object.
		     * @example
		     *
		     * _.zipObject(['a', 'b'], [1, 2]);
		     * // => { 'a': 1, 'b': 2 }
		     */
		    function zipObject(props, values) {
		      return baseZipObject(props || [], values || [], assignValue);
		    }

		    /**
		     * This method is like `_.zipObject` except that it supports property paths.
		     *
		     * @static
		     * @memberOf _
		     * @since 4.1.0
		     * @category Array
		     * @param {Array} [props=[]] The property identifiers.
		     * @param {Array} [values=[]] The property values.
		     * @returns {Object} Returns the new object.
		     * @example
		     *
		     * _.zipObjectDeep(['a.b[0].c', 'a.b[1].d'], [1, 2]);
		     * // => { 'a': { 'b': [{ 'c': 1 }, { 'd': 2 }] } }
		     */
		    function zipObjectDeep(props, values) {
		      return baseZipObject(props || [], values || [], baseSet);
		    }

		    /**
		     * This method is like `_.zip` except that it accepts `iteratee` to specify
		     * how grouped values should be combined. The iteratee is invoked with the
		     * elements of each group: (...group).
		     *
		     * @static
		     * @memberOf _
		     * @since 3.8.0
		     * @category Array
		     * @param {...Array} [arrays] The arrays to process.
		     * @param {Function} [iteratee=_.identity] The function to combine
		     *  grouped values.
		     * @returns {Array} Returns the new array of grouped elements.
		     * @example
		     *
		     * _.zipWith([1, 2], [10, 20], [100, 200], function(a, b, c) {
		     *   return a + b + c;
		     * });
		     * // => [111, 222]
		     */
		    var zipWith = baseRest(function(arrays) {
		      var length = arrays.length,
		          iteratee = length > 1 ? arrays[length - 1] : undefined$1;

		      iteratee = typeof iteratee == 'function' ? (arrays.pop(), iteratee) : undefined$1;
		      return unzipWith(arrays, iteratee);
		    });

		    /*------------------------------------------------------------------------*/

		    /**
		     * Creates a `lodash` wrapper instance that wraps `value` with explicit method
		     * chain sequences enabled. The result of such sequences must be unwrapped
		     * with `_#value`.
		     *
		     * @static
		     * @memberOf _
		     * @since 1.3.0
		     * @category Seq
		     * @param {*} value The value to wrap.
		     * @returns {Object} Returns the new `lodash` wrapper instance.
		     * @example
		     *
		     * var users = [
		     *   { 'user': 'barney',  'age': 36 },
		     *   { 'user': 'fred',    'age': 40 },
		     *   { 'user': 'pebbles', 'age': 1 }
		     * ];
		     *
		     * var youngest = _
		     *   .chain(users)
		     *   .sortBy('age')
		     *   .map(function(o) {
		     *     return o.user + ' is ' + o.age;
		     *   })
		     *   .head()
		     *   .value();
		     * // => 'pebbles is 1'
		     */
		    function chain(value) {
		      var result = lodash(value);
		      result.__chain__ = true;
		      return result;
		    }

		    /**
		     * This method invokes `interceptor` and returns `value`. The interceptor
		     * is invoked with one argument; (value). The purpose of this method is to
		     * "tap into" a method chain sequence in order to modify intermediate results.
		     *
		     * @static
		     * @memberOf _
		     * @since 0.1.0
		     * @category Seq
		     * @param {*} value The value to provide to `interceptor`.
		     * @param {Function} interceptor The function to invoke.
		     * @returns {*} Returns `value`.
		     * @example
		     *
		     * _([1, 2, 3])
		     *  .tap(function(array) {
		     *    // Mutate input array.
		     *    array.pop();
		     *  })
		     *  .reverse()
		     *  .value();
		     * // => [2, 1]
		     */
		    function tap(value, interceptor) {
		      interceptor(value);
		      return value;
		    }

		    /**
		     * This method is like `_.tap` except that it returns the result of `interceptor`.
		     * The purpose of this method is to "pass thru" values replacing intermediate
		     * results in a method chain sequence.
		     *
		     * @static
		     * @memberOf _
		     * @since 3.0.0
		     * @category Seq
		     * @param {*} value The value to provide to `interceptor`.
		     * @param {Function} interceptor The function to invoke.
		     * @returns {*} Returns the result of `interceptor`.
		     * @example
		     *
		     * _('  abc  ')
		     *  .chain()
		     *  .trim()
		     *  .thru(function(value) {
		     *    return [value];
		     *  })
		     *  .value();
		     * // => ['abc']
		     */
		    function thru(value, interceptor) {
		      return interceptor(value);
		    }

		    /**
		     * This method is the wrapper version of `_.at`.
		     *
		     * @name at
		     * @memberOf _
		     * @since 1.0.0
		     * @category Seq
		     * @param {...(string|string[])} [paths] The property paths to pick.
		     * @returns {Object} Returns the new `lodash` wrapper instance.
		     * @example
		     *
		     * var object = { 'a': [{ 'b': { 'c': 3 } }, 4] };
		     *
		     * _(object).at(['a[0].b.c', 'a[1]']).value();
		     * // => [3, 4]
		     */
		    var wrapperAt = flatRest(function(paths) {
		      var length = paths.length,
		          start = length ? paths[0] : 0,
		          value = this.__wrapped__,
		          interceptor = function(object) { return baseAt(object, paths); };

		      if (length > 1 || this.__actions__.length ||
		          !(value instanceof LazyWrapper) || !isIndex(start)) {
		        return this.thru(interceptor);
		      }
		      value = value.slice(start, +start + (length ? 1 : 0));
		      value.__actions__.push({
		        'func': thru,
		        'args': [interceptor],
		        'thisArg': undefined$1
		      });
		      return new LodashWrapper(value, this.__chain__).thru(function(array) {
		        if (length && !array.length) {
		          array.push(undefined$1);
		        }
		        return array;
		      });
		    });

		    /**
		     * Creates a `lodash` wrapper instance with explicit method chain sequences enabled.
		     *
		     * @name chain
		     * @memberOf _
		     * @since 0.1.0
		     * @category Seq
		     * @returns {Object} Returns the new `lodash` wrapper instance.
		     * @example
		     *
		     * var users = [
		     *   { 'user': 'barney', 'age': 36 },
		     *   { 'user': 'fred',   'age': 40 }
		     * ];
		     *
		     * // A sequence without explicit chaining.
		     * _(users).head();
		     * // => { 'user': 'barney', 'age': 36 }
		     *
		     * // A sequence with explicit chaining.
		     * _(users)
		     *   .chain()
		     *   .head()
		     *   .pick('user')
		     *   .value();
		     * // => { 'user': 'barney' }
		     */
		    function wrapperChain() {
		      return chain(this);
		    }

		    /**
		     * Executes the chain sequence and returns the wrapped result.
		     *
		     * @name commit
		     * @memberOf _
		     * @since 3.2.0
		     * @category Seq
		     * @returns {Object} Returns the new `lodash` wrapper instance.
		     * @example
		     *
		     * var array = [1, 2];
		     * var wrapped = _(array).push(3);
		     *
		     * console.log(array);
		     * // => [1, 2]
		     *
		     * wrapped = wrapped.commit();
		     * console.log(array);
		     * // => [1, 2, 3]
		     *
		     * wrapped.last();
		     * // => 3
		     *
		     * console.log(array);
		     * // => [1, 2, 3]
		     */
		    function wrapperCommit() {
		      return new LodashWrapper(this.value(), this.__chain__);
		    }

		    /**
		     * Gets the next value on a wrapped object following the
		     * [iterator protocol](https://mdn.io/iteration_protocols#iterator).
		     *
		     * @name next
		     * @memberOf _
		     * @since 4.0.0
		     * @category Seq
		     * @returns {Object} Returns the next iterator value.
		     * @example
		     *
		     * var wrapped = _([1, 2]);
		     *
		     * wrapped.next();
		     * // => { 'done': false, 'value': 1 }
		     *
		     * wrapped.next();
		     * // => { 'done': false, 'value': 2 }
		     *
		     * wrapped.next();
		     * // => { 'done': true, 'value': undefined }
		     */
		    function wrapperNext() {
		      if (this.__values__ === undefined$1) {
		        this.__values__ = toArray(this.value());
		      }
		      var done = this.__index__ >= this.__values__.length,
		          value = done ? undefined$1 : this.__values__[this.__index__++];

		      return { 'done': done, 'value': value };
		    }

		    /**
		     * Enables the wrapper to be iterable.
		     *
		     * @name Symbol.iterator
		     * @memberOf _
		     * @since 4.0.0
		     * @category Seq
		     * @returns {Object} Returns the wrapper object.
		     * @example
		     *
		     * var wrapped = _([1, 2]);
		     *
		     * wrapped[Symbol.iterator]() === wrapped;
		     * // => true
		     *
		     * Array.from(wrapped);
		     * // => [1, 2]
		     */
		    function wrapperToIterator() {
		      return this;
		    }

		    /**
		     * Creates a clone of the chain sequence planting `value` as the wrapped value.
		     *
		     * @name plant
		     * @memberOf _
		     * @since 3.2.0
		     * @category Seq
		     * @param {*} value The value to plant.
		     * @returns {Object} Returns the new `lodash` wrapper instance.
		     * @example
		     *
		     * function square(n) {
		     *   return n * n;
		     * }
		     *
		     * var wrapped = _([1, 2]).map(square);
		     * var other = wrapped.plant([3, 4]);
		     *
		     * other.value();
		     * // => [9, 16]
		     *
		     * wrapped.value();
		     * // => [1, 4]
		     */
		    function wrapperPlant(value) {
		      var result,
		          parent = this;

		      while (parent instanceof baseLodash) {
		        var clone = wrapperClone(parent);
		        clone.__index__ = 0;
		        clone.__values__ = undefined$1;
		        if (result) {
		          previous.__wrapped__ = clone;
		        } else {
		          result = clone;
		        }
		        var previous = clone;
		        parent = parent.__wrapped__;
		      }
		      previous.__wrapped__ = value;
		      return result;
		    }

		    /**
		     * This method is the wrapper version of `_.reverse`.
		     *
		     * **Note:** This method mutates the wrapped array.
		     *
		     * @name reverse
		     * @memberOf _
		     * @since 0.1.0
		     * @category Seq
		     * @returns {Object} Returns the new `lodash` wrapper instance.
		     * @example
		     *
		     * var array = [1, 2, 3];
		     *
		     * _(array).reverse().value()
		     * // => [3, 2, 1]
		     *
		     * console.log(array);
		     * // => [3, 2, 1]
		     */
		    function wrapperReverse() {
		      var value = this.__wrapped__;
		      if (value instanceof LazyWrapper) {
		        var wrapped = value;
		        if (this.__actions__.length) {
		          wrapped = new LazyWrapper(this);
		        }
		        wrapped = wrapped.reverse();
		        wrapped.__actions__.push({
		          'func': thru,
		          'args': [reverse],
		          'thisArg': undefined$1
		        });
		        return new LodashWrapper(wrapped, this.__chain__);
		      }
		      return this.thru(reverse);
		    }

		    /**
		     * Executes the chain sequence to resolve the unwrapped value.
		     *
		     * @name value
		     * @memberOf _
		     * @since 0.1.0
		     * @alias toJSON, valueOf
		     * @category Seq
		     * @returns {*} Returns the resolved unwrapped value.
		     * @example
		     *
		     * _([1, 2, 3]).value();
		     * // => [1, 2, 3]
		     */
		    function wrapperValue() {
		      return baseWrapperValue(this.__wrapped__, this.__actions__);
		    }

		    /*------------------------------------------------------------------------*/

		    /**
		     * Creates an object composed of keys generated from the results of running
		     * each element of `collection` thru `iteratee`. The corresponding value of
		     * each key is the number of times the key was returned by `iteratee`. The
		     * iteratee is invoked with one argument: (value).
		     *
		     * @static
		     * @memberOf _
		     * @since 0.5.0
		     * @category Collection
		     * @param {Array|Object} collection The collection to iterate over.
		     * @param {Function} [iteratee=_.identity] The iteratee to transform keys.
		     * @returns {Object} Returns the composed aggregate object.
		     * @example
		     *
		     * _.countBy([6.1, 4.2, 6.3], Math.floor);
		     * // => { '4': 1, '6': 2 }
		     *
		     * // The `_.property` iteratee shorthand.
		     * _.countBy(['one', 'two', 'three'], 'length');
		     * // => { '3': 2, '5': 1 }
		     */
		    var countBy = createAggregator(function(result, value, key) {
		      if (hasOwnProperty.call(result, key)) {
		        ++result[key];
		      } else {
		        baseAssignValue(result, key, 1);
		      }
		    });

		    /**
		     * Checks if `predicate` returns truthy for **all** elements of `collection`.
		     * Iteration is stopped once `predicate` returns falsey. The predicate is
		     * invoked with three arguments: (value, index|key, collection).
		     *
		     * **Note:** This method returns `true` for
		     * [empty collections](https://en.wikipedia.org/wiki/Empty_set) because
		     * [everything is true](https://en.wikipedia.org/wiki/Vacuous_truth) of
		     * elements of empty collections.
		     *
		     * @static
		     * @memberOf _
		     * @since 0.1.0
		     * @category Collection
		     * @param {Array|Object} collection The collection to iterate over.
		     * @param {Function} [predicate=_.identity] The function invoked per iteration.
		     * @param- {Object} [guard] Enables use as an iteratee for methods like `_.map`.
		     * @returns {boolean} Returns `true` if all elements pass the predicate check,
		     *  else `false`.
		     * @example
		     *
		     * _.every([true, 1, null, 'yes'], Boolean);
		     * // => false
		     *
		     * var users = [
		     *   { 'user': 'barney', 'age': 36, 'active': false },
		     *   { 'user': 'fred',   'age': 40, 'active': false }
		     * ];
		     *
		     * // The `_.matches` iteratee shorthand.
		     * _.every(users, { 'user': 'barney', 'active': false });
		     * // => false
		     *
		     * // The `_.matchesProperty` iteratee shorthand.
		     * _.every(users, ['active', false]);
		     * // => true
		     *
		     * // The `_.property` iteratee shorthand.
		     * _.every(users, 'active');
		     * // => false
		     */
		    function every(collection, predicate, guard) {
		      var func = isArray(collection) ? arrayEvery : baseEvery;
		      if (guard && isIterateeCall(collection, predicate, guard)) {
		        predicate = undefined$1;
		      }
		      return func(collection, getIteratee(predicate, 3));
		    }

		    /**
		     * Iterates over elements of `collection`, returning an array of all elements
		     * `predicate` returns truthy for. The predicate is invoked with three
		     * arguments: (value, index|key, collection).
		     *
		     * **Note:** Unlike `_.remove`, this method returns a new array.
		     *
		     * @static
		     * @memberOf _
		     * @since 0.1.0
		     * @category Collection
		     * @param {Array|Object} collection The collection to iterate over.
		     * @param {Function} [predicate=_.identity] The function invoked per iteration.
		     * @returns {Array} Returns the new filtered array.
		     * @see _.reject
		     * @example
		     *
		     * var users = [
		     *   { 'user': 'barney', 'age': 36, 'active': true },
		     *   { 'user': 'fred',   'age': 40, 'active': false }
		     * ];
		     *
		     * _.filter(users, function(o) { return !o.active; });
		     * // => objects for ['fred']
		     *
		     * // The `_.matches` iteratee shorthand.
		     * _.filter(users, { 'age': 36, 'active': true });
		     * // => objects for ['barney']
		     *
		     * // The `_.matchesProperty` iteratee shorthand.
		     * _.filter(users, ['active', false]);
		     * // => objects for ['fred']
		     *
		     * // The `_.property` iteratee shorthand.
		     * _.filter(users, 'active');
		     * // => objects for ['barney']
		     *
		     * // Combining several predicates using `_.overEvery` or `_.overSome`.
		     * _.filter(users, _.overSome([{ 'age': 36 }, ['age', 40]]));
		     * // => objects for ['fred', 'barney']
		     */
		    function filter(collection, predicate) {
		      var func = isArray(collection) ? arrayFilter : baseFilter;
		      return func(collection, getIteratee(predicate, 3));
		    }

		    /**
		     * Iterates over elements of `collection`, returning the first element
		     * `predicate` returns truthy for. The predicate is invoked with three
		     * arguments: (value, index|key, collection).
		     *
		     * @static
		     * @memberOf _
		     * @since 0.1.0
		     * @category Collection
		     * @param {Array|Object} collection The collection to inspect.
		     * @param {Function} [predicate=_.identity] The function invoked per iteration.
		     * @param {number} [fromIndex=0] The index to search from.
		     * @returns {*} Returns the matched element, else `undefined`.
		     * @example
		     *
		     * var users = [
		     *   { 'user': 'barney',  'age': 36, 'active': true },
		     *   { 'user': 'fred',    'age': 40, 'active': false },
		     *   { 'user': 'pebbles', 'age': 1,  'active': true }
		     * ];
		     *
		     * _.find(users, function(o) { return o.age < 40; });
		     * // => object for 'barney'
		     *
		     * // The `_.matches` iteratee shorthand.
		     * _.find(users, { 'age': 1, 'active': true });
		     * // => object for 'pebbles'
		     *
		     * // The `_.matchesProperty` iteratee shorthand.
		     * _.find(users, ['active', false]);
		     * // => object for 'fred'
		     *
		     * // The `_.property` iteratee shorthand.
		     * _.find(users, 'active');
		     * // => object for 'barney'
		     */
		    var find = createFind(findIndex);

		    /**
		     * This method is like `_.find` except that it iterates over elements of
		     * `collection` from right to left.
		     *
		     * @static
		     * @memberOf _
		     * @since 2.0.0
		     * @category Collection
		     * @param {Array|Object} collection The collection to inspect.
		     * @param {Function} [predicate=_.identity] The function invoked per iteration.
		     * @param {number} [fromIndex=collection.length-1] The index to search from.
		     * @returns {*} Returns the matched element, else `undefined`.
		     * @example
		     *
		     * _.findLast([1, 2, 3, 4], function(n) {
		     *   return n % 2 == 1;
		     * });
		     * // => 3
		     */
		    var findLast = createFind(findLastIndex);

		    /**
		     * Creates a flattened array of values by running each element in `collection`
		     * thru `iteratee` and flattening the mapped results. The iteratee is invoked
		     * with three arguments: (value, index|key, collection).
		     *
		     * @static
		     * @memberOf _
		     * @since 4.0.0
		     * @category Collection
		     * @param {Array|Object} collection The collection to iterate over.
		     * @param {Function} [iteratee=_.identity] The function invoked per iteration.
		     * @returns {Array} Returns the new flattened array.
		     * @example
		     *
		     * function duplicate(n) {
		     *   return [n, n];
		     * }
		     *
		     * _.flatMap([1, 2], duplicate);
		     * // => [1, 1, 2, 2]
		     */
		    function flatMap(collection, iteratee) {
		      return baseFlatten(map(collection, iteratee), 1);
		    }

		    /**
		     * This method is like `_.flatMap` except that it recursively flattens the
		     * mapped results.
		     *
		     * @static
		     * @memberOf _
		     * @since 4.7.0
		     * @category Collection
		     * @param {Array|Object} collection The collection to iterate over.
		     * @param {Function} [iteratee=_.identity] The function invoked per iteration.
		     * @returns {Array} Returns the new flattened array.
		     * @example
		     *
		     * function duplicate(n) {
		     *   return [[[n, n]]];
		     * }
		     *
		     * _.flatMapDeep([1, 2], duplicate);
		     * // => [1, 1, 2, 2]
		     */
		    function flatMapDeep(collection, iteratee) {
		      return baseFlatten(map(collection, iteratee), INFINITY);
		    }

		    /**
		     * This method is like `_.flatMap` except that it recursively flattens the
		     * mapped results up to `depth` times.
		     *
		     * @static
		     * @memberOf _
		     * @since 4.7.0
		     * @category Collection
		     * @param {Array|Object} collection The collection to iterate over.
		     * @param {Function} [iteratee=_.identity] The function invoked per iteration.
		     * @param {number} [depth=1] The maximum recursion depth.
		     * @returns {Array} Returns the new flattened array.
		     * @example
		     *
		     * function duplicate(n) {
		     *   return [[[n, n]]];
		     * }
		     *
		     * _.flatMapDepth([1, 2], duplicate, 2);
		     * // => [[1, 1], [2, 2]]
		     */
		    function flatMapDepth(collection, iteratee, depth) {
		      depth = depth === undefined$1 ? 1 : toInteger(depth);
		      return baseFlatten(map(collection, iteratee), depth);
		    }

		    /**
		     * Iterates over elements of `collection` and invokes `iteratee` for each element.
		     * The iteratee is invoked with three arguments: (value, index|key, collection).
		     * Iteratee functions may exit iteration early by explicitly returning `false`.
		     *
		     * **Note:** As with other "Collections" methods, objects with a "length"
		     * property are iterated like arrays. To avoid this behavior use `_.forIn`
		     * or `_.forOwn` for object iteration.
		     *
		     * @static
		     * @memberOf _
		     * @since 0.1.0
		     * @alias each
		     * @category Collection
		     * @param {Array|Object} collection The collection to iterate over.
		     * @param {Function} [iteratee=_.identity] The function invoked per iteration.
		     * @returns {Array|Object} Returns `collection`.
		     * @see _.forEachRight
		     * @example
		     *
		     * _.forEach([1, 2], function(value) {
		     *   console.log(value);
		     * });
		     * // => Logs `1` then `2`.
		     *
		     * _.forEach({ 'a': 1, 'b': 2 }, function(value, key) {
		     *   console.log(key);
		     * });
		     * // => Logs 'a' then 'b' (iteration order is not guaranteed).
		     */
		    function forEach(collection, iteratee) {
		      var func = isArray(collection) ? arrayEach : baseEach;
		      return func(collection, getIteratee(iteratee, 3));
		    }

		    /**
		     * This method is like `_.forEach` except that it iterates over elements of
		     * `collection` from right to left.
		     *
		     * @static
		     * @memberOf _
		     * @since 2.0.0
		     * @alias eachRight
		     * @category Collection
		     * @param {Array|Object} collection The collection to iterate over.
		     * @param {Function} [iteratee=_.identity] The function invoked per iteration.
		     * @returns {Array|Object} Returns `collection`.
		     * @see _.forEach
		     * @example
		     *
		     * _.forEachRight([1, 2], function(value) {
		     *   console.log(value);
		     * });
		     * // => Logs `2` then `1`.
		     */
		    function forEachRight(collection, iteratee) {
		      var func = isArray(collection) ? arrayEachRight : baseEachRight;
		      return func(collection, getIteratee(iteratee, 3));
		    }

		    /**
		     * Creates an object composed of keys generated from the results of running
		     * each element of `collection` thru `iteratee`. The order of grouped values
		     * is determined by the order they occur in `collection`. The corresponding
		     * value of each key is an array of elements responsible for generating the
		     * key. The iteratee is invoked with one argument: (value).
		     *
		     * @static
		     * @memberOf _
		     * @since 0.1.0
		     * @category Collection
		     * @param {Array|Object} collection The collection to iterate over.
		     * @param {Function} [iteratee=_.identity] The iteratee to transform keys.
		     * @returns {Object} Returns the composed aggregate object.
		     * @example
		     *
		     * _.groupBy([6.1, 4.2, 6.3], Math.floor);
		     * // => { '4': [4.2], '6': [6.1, 6.3] }
		     *
		     * // The `_.property` iteratee shorthand.
		     * _.groupBy(['one', 'two', 'three'], 'length');
		     * // => { '3': ['one', 'two'], '5': ['three'] }
		     */
		    var groupBy = createAggregator(function(result, value, key) {
		      if (hasOwnProperty.call(result, key)) {
		        result[key].push(value);
		      } else {
		        baseAssignValue(result, key, [value]);
		      }
		    });

		    /**
		     * Checks if `value` is in `collection`. If `collection` is a string, it's
		     * checked for a substring of `value`, otherwise
		     * [`SameValueZero`](http://ecma-international.org/ecma-262/7.0/#sec-samevaluezero)
		     * is used for equality comparisons. If `fromIndex` is negative, it's used as
		     * the offset from the end of `collection`.
		     *
		     * @static
		     * @memberOf _
		     * @since 0.1.0
		     * @category Collection
		     * @param {Array|Object|string} collection The collection to inspect.
		     * @param {*} value The value to search for.
		     * @param {number} [fromIndex=0] The index to search from.
		     * @param- {Object} [guard] Enables use as an iteratee for methods like `_.reduce`.
		     * @returns {boolean} Returns `true` if `value` is found, else `false`.
		     * @example
		     *
		     * _.includes([1, 2, 3], 1);
		     * // => true
		     *
		     * _.includes([1, 2, 3], 1, 2);
		     * // => false
		     *
		     * _.includes({ 'a': 1, 'b': 2 }, 1);
		     * // => true
		     *
		     * _.includes('abcd', 'bc');
		     * // => true
		     */
		    function includes(collection, value, fromIndex, guard) {
		      collection = isArrayLike(collection) ? collection : values(collection);
		      fromIndex = (fromIndex && !guard) ? toInteger(fromIndex) : 0;

		      var length = collection.length;
		      if (fromIndex < 0) {
		        fromIndex = nativeMax(length + fromIndex, 0);
		      }
		      return isString(collection)
		        ? (fromIndex <= length && collection.indexOf(value, fromIndex) > -1)
		        : (!!length && baseIndexOf(collection, value, fromIndex) > -1);
		    }

		    /**
		     * Invokes the method at `path` of each element in `collection`, returning
		     * an array of the results of each invoked method. Any additional arguments
		     * are provided to each invoked method. If `path` is a function, it's invoked
		     * for, and `this` bound to, each element in `collection`.
		     *
		     * @static
		     * @memberOf _
		     * @since 4.0.0
		     * @category Collection
		     * @param {Array|Object} collection The collection to iterate over.
		     * @param {Array|Function|string} path The path of the method to invoke or
		     *  the function invoked per iteration.
		     * @param {...*} [args] The arguments to invoke each method with.
		     * @returns {Array} Returns the array of results.
		     * @example
		     *
		     * _.invokeMap([[5, 1, 7], [3, 2, 1]], 'sort');
		     * // => [[1, 5, 7], [1, 2, 3]]
		     *
		     * _.invokeMap([123, 456], String.prototype.split, '');
		     * // => [['1', '2', '3'], ['4', '5', '6']]
		     */
		    var invokeMap = baseRest(function(collection, path, args) {
		      var index = -1,
		          isFunc = typeof path == 'function',
		          result = isArrayLike(collection) ? Array(collection.length) : [];

		      baseEach(collection, function(value) {
		        result[++index] = isFunc ? apply(path, value, args) : baseInvoke(value, path, args);
		      });
		      return result;
		    });

		    /**
		     * Creates an object composed of keys generated from the results of running
		     * each element of `collection` thru `iteratee`. The corresponding value of
		     * each key is the last element responsible for generating the key. The
		     * iteratee is invoked with one argument: (value).
		     *
		     * @static
		     * @memberOf _
		     * @since 4.0.0
		     * @category Collection
		     * @param {Array|Object} collection The collection to iterate over.
		     * @param {Function} [iteratee=_.identity] The iteratee to transform keys.
		     * @returns {Object} Returns the composed aggregate object.
		     * @example
		     *
		     * var array = [
		     *   { 'dir': 'left', 'code': 97 },
		     *   { 'dir': 'right', 'code': 100 }
		     * ];
		     *
		     * _.keyBy(array, function(o) {
		     *   return String.fromCharCode(o.code);
		     * });
		     * // => { 'a': { 'dir': 'left', 'code': 97 }, 'd': { 'dir': 'right', 'code': 100 } }
		     *
		     * _.keyBy(array, 'dir');
		     * // => { 'left': { 'dir': 'left', 'code': 97 }, 'right': { 'dir': 'right', 'code': 100 } }
		     */
		    var keyBy = createAggregator(function(result, value, key) {
		      baseAssignValue(result, key, value);
		    });

		    /**
		     * Creates an array of values by running each element in `collection` thru
		     * `iteratee`. The iteratee is invoked with three arguments:
		     * (value, index|key, collection).
		     *
		     * Many lodash methods are guarded to work as iteratees for methods like
		     * `_.every`, `_.filter`, `_.map`, `_.mapValues`, `_.reject`, and `_.some`.
		     *
		     * The guarded methods are:
		     * `ary`, `chunk`, `curry`, `curryRight`, `drop`, `dropRight`, `every`,
		     * `fill`, `invert`, `parseInt`, `random`, `range`, `rangeRight`, `repeat`,
		     * `sampleSize`, `slice`, `some`, `sortBy`, `split`, `take`, `takeRight`,
		     * `template`, `trim`, `trimEnd`, `trimStart`, and `words`
		     *
		     * @static
		     * @memberOf _
		     * @since 0.1.0
		     * @category Collection
		     * @param {Array|Object} collection The collection to iterate over.
		     * @param {Function} [iteratee=_.identity] The function invoked per iteration.
		     * @returns {Array} Returns the new mapped array.
		     * @example
		     *
		     * function square(n) {
		     *   return n * n;
		     * }
		     *
		     * _.map([4, 8], square);
		     * // => [16, 64]
		     *
		     * _.map({ 'a': 4, 'b': 8 }, square);
		     * // => [16, 64] (iteration order is not guaranteed)
		     *
		     * var users = [
		     *   { 'user': 'barney' },
		     *   { 'user': 'fred' }
		     * ];
		     *
		     * // The `_.property` iteratee shorthand.
		     * _.map(users, 'user');
		     * // => ['barney', 'fred']
		     */
		    function map(collection, iteratee) {
		      var func = isArray(collection) ? arrayMap : baseMap;
		      return func(collection, getIteratee(iteratee, 3));
		    }

		    /**
		     * This method is like `_.sortBy` except that it allows specifying the sort
		     * orders of the iteratees to sort by. If `orders` is unspecified, all values
		     * are sorted in ascending order. Otherwise, specify an order of "desc" for
		     * descending or "asc" for ascending sort order of corresponding values.
		     *
		     * @static
		     * @memberOf _
		     * @since 4.0.0
		     * @category Collection
		     * @param {Array|Object} collection The collection to iterate over.
		     * @param {Array[]|Function[]|Object[]|string[]} [iteratees=[_.identity]]
		     *  The iteratees to sort by.
		     * @param {string[]} [orders] The sort orders of `iteratees`.
		     * @param- {Object} [guard] Enables use as an iteratee for methods like `_.reduce`.
		     * @returns {Array} Returns the new sorted array.
		     * @example
		     *
		     * var users = [
		     *   { 'user': 'fred',   'age': 48 },
		     *   { 'user': 'barney', 'age': 34 },
		     *   { 'user': 'fred',   'age': 40 },
		     *   { 'user': 'barney', 'age': 36 }
		     * ];
		     *
		     * // Sort by `user` in ascending order and by `age` in descending order.
		     * _.orderBy(users, ['user', 'age'], ['asc', 'desc']);
		     * // => objects for [['barney', 36], ['barney', 34], ['fred', 48], ['fred', 40]]
		     */
		    function orderBy(collection, iteratees, orders, guard) {
		      if (collection == null) {
		        return [];
		      }
		      if (!isArray(iteratees)) {
		        iteratees = iteratees == null ? [] : [iteratees];
		      }
		      orders = guard ? undefined$1 : orders;
		      if (!isArray(orders)) {
		        orders = orders == null ? [] : [orders];
		      }
		      return baseOrderBy(collection, iteratees, orders);
		    }

		    /**
		     * Creates an array of elements split into two groups, the first of which
		     * contains elements `predicate` returns truthy for, the second of which
		     * contains elements `predicate` returns falsey for. The predicate is
		     * invoked with one argument: (value).
		     *
		     * @static
		     * @memberOf _
		     * @since 3.0.0
		     * @category Collection
		     * @param {Array|Object} collection The collection to iterate over.
		     * @param {Function} [predicate=_.identity] The function invoked per iteration.
		     * @returns {Array} Returns the array of grouped elements.
		     * @example
		     *
		     * var users = [
		     *   { 'user': 'barney',  'age': 36, 'active': false },
		     *   { 'user': 'fred',    'age': 40, 'active': true },
		     *   { 'user': 'pebbles', 'age': 1,  'active': false }
		     * ];
		     *
		     * _.partition(users, function(o) { return o.active; });
		     * // => objects for [['fred'], ['barney', 'pebbles']]
		     *
		     * // The `_.matches` iteratee shorthand.
		     * _.partition(users, { 'age': 1, 'active': false });
		     * // => objects for [['pebbles'], ['barney', 'fred']]
		     *
		     * // The `_.matchesProperty` iteratee shorthand.
		     * _.partition(users, ['active', false]);
		     * // => objects for [['barney', 'pebbles'], ['fred']]
		     *
		     * // The `_.property` iteratee shorthand.
		     * _.partition(users, 'active');
		     * // => objects for [['fred'], ['barney', 'pebbles']]
		     */
		    var partition = createAggregator(function(result, value, key) {
		      result[key ? 0 : 1].push(value);
		    }, function() { return [[], []]; });

		    /**
		     * Reduces `collection` to a value which is the accumulated result of running
		     * each element in `collection` thru `iteratee`, where each successive
		     * invocation is supplied the return value of the previous. If `accumulator`
		     * is not given, the first element of `collection` is used as the initial
		     * value. The iteratee is invoked with four arguments:
		     * (accumulator, value, index|key, collection).
		     *
		     * Many lodash methods are guarded to work as iteratees for methods like
		     * `_.reduce`, `_.reduceRight`, and `_.transform`.
		     *
		     * The guarded methods are:
		     * `assign`, `defaults`, `defaultsDeep`, `includes`, `merge`, `orderBy`,
		     * and `sortBy`
		     *
		     * @static
		     * @memberOf _
		     * @since 0.1.0
		     * @category Collection
		     * @param {Array|Object} collection The collection to iterate over.
		     * @param {Function} [iteratee=_.identity] The function invoked per iteration.
		     * @param {*} [accumulator] The initial value.
		     * @returns {*} Returns the accumulated value.
		     * @see _.reduceRight
		     * @example
		     *
		     * _.reduce([1, 2], function(sum, n) {
		     *   return sum + n;
		     * }, 0);
		     * // => 3
		     *
		     * _.reduce({ 'a': 1, 'b': 2, 'c': 1 }, function(result, value, key) {
		     *   (result[value] || (result[value] = [])).push(key);
		     *   return result;
		     * }, {});
		     * // => { '1': ['a', 'c'], '2': ['b'] } (iteration order is not guaranteed)
		     */
		    function reduce(collection, iteratee, accumulator) {
		      var func = isArray(collection) ? arrayReduce : baseReduce,
		          initAccum = arguments.length < 3;

		      return func(collection, getIteratee(iteratee, 4), accumulator, initAccum, baseEach);
		    }

		    /**
		     * This method is like `_.reduce` except that it iterates over elements of
		     * `collection` from right to left.
		     *
		     * @static
		     * @memberOf _
		     * @since 0.1.0
		     * @category Collection
		     * @param {Array|Object} collection The collection to iterate over.
		     * @param {Function} [iteratee=_.identity] The function invoked per iteration.
		     * @param {*} [accumulator] The initial value.
		     * @returns {*} Returns the accumulated value.
		     * @see _.reduce
		     * @example
		     *
		     * var array = [[0, 1], [2, 3], [4, 5]];
		     *
		     * _.reduceRight(array, function(flattened, other) {
		     *   return flattened.concat(other);
		     * }, []);
		     * // => [4, 5, 2, 3, 0, 1]
		     */
		    function reduceRight(collection, iteratee, accumulator) {
		      var func = isArray(collection) ? arrayReduceRight : baseReduce,
		          initAccum = arguments.length < 3;

		      return func(collection, getIteratee(iteratee, 4), accumulator, initAccum, baseEachRight);
		    }

		    /**
		     * The opposite of `_.filter`; this method returns the elements of `collection`
		     * that `predicate` does **not** return truthy for.
		     *
		     * @static
		     * @memberOf _
		     * @since 0.1.0
		     * @category Collection
		     * @param {Array|Object} collection The collection to iterate over.
		     * @param {Function} [predicate=_.identity] The function invoked per iteration.
		     * @returns {Array} Returns the new filtered array.
		     * @see _.filter
		     * @example
		     *
		     * var users = [
		     *   { 'user': 'barney', 'age': 36, 'active': false },
		     *   { 'user': 'fred',   'age': 40, 'active': true }
		     * ];
		     *
		     * _.reject(users, function(o) { return !o.active; });
		     * // => objects for ['fred']
		     *
		     * // The `_.matches` iteratee shorthand.
		     * _.reject(users, { 'age': 40, 'active': true });
		     * // => objects for ['barney']
		     *
		     * // The `_.matchesProperty` iteratee shorthand.
		     * _.reject(users, ['active', false]);
		     * // => objects for ['fred']
		     *
		     * // The `_.property` iteratee shorthand.
		     * _.reject(users, 'active');
		     * // => objects for ['barney']
		     */
		    function reject(collection, predicate) {
		      var func = isArray(collection) ? arrayFilter : baseFilter;
		      return func(collection, negate(getIteratee(predicate, 3)));
		    }

		    /**
		     * Gets a random element from `collection`.
		     *
		     * @static
		     * @memberOf _
		     * @since 2.0.0
		     * @category Collection
		     * @param {Array|Object} collection The collection to sample.
		     * @returns {*} Returns the random element.
		     * @example
		     *
		     * _.sample([1, 2, 3, 4]);
		     * // => 2
		     */
		    function sample(collection) {
		      var func = isArray(collection) ? arraySample : baseSample;
		      return func(collection);
		    }

		    /**
		     * Gets `n` random elements at unique keys from `collection` up to the
		     * size of `collection`.
		     *
		     * @static
		     * @memberOf _
		     * @since 4.0.0
		     * @category Collection
		     * @param {Array|Object} collection The collection to sample.
		     * @param {number} [n=1] The number of elements to sample.
		     * @param- {Object} [guard] Enables use as an iteratee for methods like `_.map`.
		     * @returns {Array} Returns the random elements.
		     * @example
		     *
		     * _.sampleSize([1, 2, 3], 2);
		     * // => [3, 1]
		     *
		     * _.sampleSize([1, 2, 3], 4);
		     * // => [2, 3, 1]
		     */
		    function sampleSize(collection, n, guard) {
		      if ((guard ? isIterateeCall(collection, n, guard) : n === undefined$1)) {
		        n = 1;
		      } else {
		        n = toInteger(n);
		      }
		      var func = isArray(collection) ? arraySampleSize : baseSampleSize;
		      return func(collection, n);
		    }

		    /**
		     * Creates an array of shuffled values, using a version of the
		     * [Fisher-Yates shuffle](https://en.wikipedia.org/wiki/Fisher-Yates_shuffle).
		     *
		     * @static
		     * @memberOf _
		     * @since 0.1.0
		     * @category Collection
		     * @param {Array|Object} collection The collection to shuffle.
		     * @returns {Array} Returns the new shuffled array.
		     * @example
		     *
		     * _.shuffle([1, 2, 3, 4]);
		     * // => [4, 1, 3, 2]
		     */
		    function shuffle(collection) {
		      var func = isArray(collection) ? arrayShuffle : baseShuffle;
		      return func(collection);
		    }

		    /**
		     * Gets the size of `collection` by returning its length for array-like
		     * values or the number of own enumerable string keyed properties for objects.
		     *
		     * @static
		     * @memberOf _
		     * @since 0.1.0
		     * @category Collection
		     * @param {Array|Object|string} collection The collection to inspect.
		     * @returns {number} Returns the collection size.
		     * @example
		     *
		     * _.size([1, 2, 3]);
		     * // => 3
		     *
		     * _.size({ 'a': 1, 'b': 2 });
		     * // => 2
		     *
		     * _.size('pebbles');
		     * // => 7
		     */
		    function size(collection) {
		      if (collection == null) {
		        return 0;
		      }
		      if (isArrayLike(collection)) {
		        return isString(collection) ? stringSize(collection) : collection.length;
		      }
		      var tag = getTag(collection);
		      if (tag == mapTag || tag == setTag) {
		        return collection.size;
		      }
		      return baseKeys(collection).length;
		    }

		    /**
		     * Checks if `predicate` returns truthy for **any** element of `collection`.
		     * Iteration is stopped once `predicate` returns truthy. The predicate is
		     * invoked with three arguments: (value, index|key, collection).
		     *
		     * @static
		     * @memberOf _
		     * @since 0.1.0
		     * @category Collection
		     * @param {Array|Object} collection The collection to iterate over.
		     * @param {Function} [predicate=_.identity] The function invoked per iteration.
		     * @param- {Object} [guard] Enables use as an iteratee for methods like `_.map`.
		     * @returns {boolean} Returns `true` if any element passes the predicate check,
		     *  else `false`.
		     * @example
		     *
		     * _.some([null, 0, 'yes', false], Boolean);
		     * // => true
		     *
		     * var users = [
		     *   { 'user': 'barney', 'active': true },
		     *   { 'user': 'fred',   'active': false }
		     * ];
		     *
		     * // The `_.matches` iteratee shorthand.
		     * _.some(users, { 'user': 'barney', 'active': false });
		     * // => false
		     *
		     * // The `_.matchesProperty` iteratee shorthand.
		     * _.some(users, ['active', false]);
		     * // => true
		     *
		     * // The `_.property` iteratee shorthand.
		     * _.some(users, 'active');
		     * // => true
		     */
		    function some(collection, predicate, guard) {
		      var func = isArray(collection) ? arraySome : baseSome;
		      if (guard && isIterateeCall(collection, predicate, guard)) {
		        predicate = undefined$1;
		      }
		      return func(collection, getIteratee(predicate, 3));
		    }

		    /**
		     * Creates an array of elements, sorted in ascending order by the results of
		     * running each element in a collection thru each iteratee. This method
		     * performs a stable sort, that is, it preserves the original sort order of
		     * equal elements. The iteratees are invoked with one argument: (value).
		     *
		     * @static
		     * @memberOf _
		     * @since 0.1.0
		     * @category Collection
		     * @param {Array|Object} collection The collection to iterate over.
		     * @param {...(Function|Function[])} [iteratees=[_.identity]]
		     *  The iteratees to sort by.
		     * @returns {Array} Returns the new sorted array.
		     * @example
		     *
		     * var users = [
		     *   { 'user': 'fred',   'age': 48 },
		     *   { 'user': 'barney', 'age': 36 },
		     *   { 'user': 'fred',   'age': 30 },
		     *   { 'user': 'barney', 'age': 34 }
		     * ];
		     *
		     * _.sortBy(users, [function(o) { return o.user; }]);
		     * // => objects for [['barney', 36], ['barney', 34], ['fred', 48], ['fred', 30]]
		     *
		     * _.sortBy(users, ['user', 'age']);
		     * // => objects for [['barney', 34], ['barney', 36], ['fred', 30], ['fred', 48]]
		     */
		    var sortBy = baseRest(function(collection, iteratees) {
		      if (collection == null) {
		        return [];
		      }
		      var length = iteratees.length;
		      if (length > 1 && isIterateeCall(collection, iteratees[0], iteratees[1])) {
		        iteratees = [];
		      } else if (length > 2 && isIterateeCall(iteratees[0], iteratees[1], iteratees[2])) {
		        iteratees = [iteratees[0]];
		      }
		      return baseOrderBy(collection, baseFlatten(iteratees, 1), []);
		    });

		    /*------------------------------------------------------------------------*/

		    /**
		     * Gets the timestamp of the number of milliseconds that have elapsed since
		     * the Unix epoch (1 January 1970 00:00:00 UTC).
		     *
		     * @static
		     * @memberOf _
		     * @since 2.4.0
		     * @category Date
		     * @returns {number} Returns the timestamp.
		     * @example
		     *
		     * _.defer(function(stamp) {
		     *   console.log(_.now() - stamp);
		     * }, _.now());
		     * // => Logs the number of milliseconds it took for the deferred invocation.
		     */
		    var now = ctxNow || function() {
		      return root.Date.now();
		    };

		    /*------------------------------------------------------------------------*/

		    /**
		     * The opposite of `_.before`; this method creates a function that invokes
		     * `func` once it's called `n` or more times.
		     *
		     * @static
		     * @memberOf _
		     * @since 0.1.0
		     * @category Function
		     * @param {number} n The number of calls before `func` is invoked.
		     * @param {Function} func The function to restrict.
		     * @returns {Function} Returns the new restricted function.
		     * @example
		     *
		     * var saves = ['profile', 'settings'];
		     *
		     * var done = _.after(saves.length, function() {
		     *   console.log('done saving!');
		     * });
		     *
		     * _.forEach(saves, function(type) {
		     *   asyncSave({ 'type': type, 'complete': done });
		     * });
		     * // => Logs 'done saving!' after the two async saves have completed.
		     */
		    function after(n, func) {
		      if (typeof func != 'function') {
		        throw new TypeError(FUNC_ERROR_TEXT);
		      }
		      n = toInteger(n);
		      return function() {
		        if (--n < 1) {
		          return func.apply(this, arguments);
		        }
		      };
		    }

		    /**
		     * Creates a function that invokes `func`, with up to `n` arguments,
		     * ignoring any additional arguments.
		     *
		     * @static
		     * @memberOf _
		     * @since 3.0.0
		     * @category Function
		     * @param {Function} func The function to cap arguments for.
		     * @param {number} [n=func.length] The arity cap.
		     * @param- {Object} [guard] Enables use as an iteratee for methods like `_.map`.
		     * @returns {Function} Returns the new capped function.
		     * @example
		     *
		     * _.map(['6', '8', '10'], _.ary(parseInt, 1));
		     * // => [6, 8, 10]
		     */
		    function ary(func, n, guard) {
		      n = guard ? undefined$1 : n;
		      n = (func && n == null) ? func.length : n;
		      return createWrap(func, WRAP_ARY_FLAG, undefined$1, undefined$1, undefined$1, undefined$1, n);
		    }

		    /**
		     * Creates a function that invokes `func`, with the `this` binding and arguments
		     * of the created function, while it's called less than `n` times. Subsequent
		     * calls to the created function return the result of the last `func` invocation.
		     *
		     * @static
		     * @memberOf _
		     * @since 3.0.0
		     * @category Function
		     * @param {number} n The number of calls at which `func` is no longer invoked.
		     * @param {Function} func The function to restrict.
		     * @returns {Function} Returns the new restricted function.
		     * @example
		     *
		     * jQuery(element).on('click', _.before(5, addContactToList));
		     * // => Allows adding up to 4 contacts to the list.
		     */
		    function before(n, func) {
		      var result;
		      if (typeof func != 'function') {
		        throw new TypeError(FUNC_ERROR_TEXT);
		      }
		      n = toInteger(n);
		      return function() {
		        if (--n > 0) {
		          result = func.apply(this, arguments);
		        }
		        if (n <= 1) {
		          func = undefined$1;
		        }
		        return result;
		      };
		    }

		    /**
		     * Creates a function that invokes `func` with the `this` binding of `thisArg`
		     * and `partials` prepended to the arguments it receives.
		     *
		     * The `_.bind.placeholder` value, which defaults to `_` in monolithic builds,
		     * may be used as a placeholder for partially applied arguments.
		     *
		     * **Note:** Unlike native `Function#bind`, this method doesn't set the "length"
		     * property of bound functions.
		     *
		     * @static
		     * @memberOf _
		     * @since 0.1.0
		     * @category Function
		     * @param {Function} func The function to bind.
		     * @param {*} thisArg The `this` binding of `func`.
		     * @param {...*} [partials] The arguments to be partially applied.
		     * @returns {Function} Returns the new bound function.
		     * @example
		     *
		     * function greet(greeting, punctuation) {
		     *   return greeting + ' ' + this.user + punctuation;
		     * }
		     *
		     * var object = { 'user': 'fred' };
		     *
		     * var bound = _.bind(greet, object, 'hi');
		     * bound('!');
		     * // => 'hi fred!'
		     *
		     * // Bound with placeholders.
		     * var bound = _.bind(greet, object, _, '!');
		     * bound('hi');
		     * // => 'hi fred!'
		     */
		    var bind = baseRest(function(func, thisArg, partials) {
		      var bitmask = WRAP_BIND_FLAG;
		      if (partials.length) {
		        var holders = replaceHolders(partials, getHolder(bind));
		        bitmask |= WRAP_PARTIAL_FLAG;
		      }
		      return createWrap(func, bitmask, thisArg, partials, holders);
		    });

		    /**
		     * Creates a function that invokes the method at `object[key]` with `partials`
		     * prepended to the arguments it receives.
		     *
		     * This method differs from `_.bind` by allowing bound functions to reference
		     * methods that may be redefined or don't yet exist. See
		     * [Peter Michaux's article](http://peter.michaux.ca/articles/lazy-function-definition-pattern)
		     * for more details.
		     *
		     * The `_.bindKey.placeholder` value, which defaults to `_` in monolithic
		     * builds, may be used as a placeholder for partially applied arguments.
		     *
		     * @static
		     * @memberOf _
		     * @since 0.10.0
		     * @category Function
		     * @param {Object} object The object to invoke the method on.
		     * @param {string} key The key of the method.
		     * @param {...*} [partials] The arguments to be partially applied.
		     * @returns {Function} Returns the new bound function.
		     * @example
		     *
		     * var object = {
		     *   'user': 'fred',
		     *   'greet': function(greeting, punctuation) {
		     *     return greeting + ' ' + this.user + punctuation;
		     *   }
		     * };
		     *
		     * var bound = _.bindKey(object, 'greet', 'hi');
		     * bound('!');
		     * // => 'hi fred!'
		     *
		     * object.greet = function(greeting, punctuation) {
		     *   return greeting + 'ya ' + this.user + punctuation;
		     * };
		     *
		     * bound('!');
		     * // => 'hiya fred!'
		     *
		     * // Bound with placeholders.
		     * var bound = _.bindKey(object, 'greet', _, '!');
		     * bound('hi');
		     * // => 'hiya fred!'
		     */
		    var bindKey = baseRest(function(object, key, partials) {
		      var bitmask = WRAP_BIND_FLAG | WRAP_BIND_KEY_FLAG;
		      if (partials.length) {
		        var holders = replaceHolders(partials, getHolder(bindKey));
		        bitmask |= WRAP_PARTIAL_FLAG;
		      }
		      return createWrap(key, bitmask, object, partials, holders);
		    });

		    /**
		     * Creates a function that accepts arguments of `func` and either invokes
		     * `func` returning its result, if at least `arity` number of arguments have
		     * been provided, or returns a function that accepts the remaining `func`
		     * arguments, and so on. The arity of `func` may be specified if `func.length`
		     * is not sufficient.
		     *
		     * The `_.curry.placeholder` value, which defaults to `_` in monolithic builds,
		     * may be used as a placeholder for provided arguments.
		     *
		     * **Note:** This method doesn't set the "length" property of curried functions.
		     *
		     * @static
		     * @memberOf _
		     * @since 2.0.0
		     * @category Function
		     * @param {Function} func The function to curry.
		     * @param {number} [arity=func.length] The arity of `func`.
		     * @param- {Object} [guard] Enables use as an iteratee for methods like `_.map`.
		     * @returns {Function} Returns the new curried function.
		     * @example
		     *
		     * var abc = function(a, b, c) {
		     *   return [a, b, c];
		     * };
		     *
		     * var curried = _.curry(abc);
		     *
		     * curried(1)(2)(3);
		     * // => [1, 2, 3]
		     *
		     * curried(1, 2)(3);
		     * // => [1, 2, 3]
		     *
		     * curried(1, 2, 3);
		     * // => [1, 2, 3]
		     *
		     * // Curried with placeholders.
		     * curried(1)(_, 3)(2);
		     * // => [1, 2, 3]
		     */
		    function curry(func, arity, guard) {
		      arity = guard ? undefined$1 : arity;
		      var result = createWrap(func, WRAP_CURRY_FLAG, undefined$1, undefined$1, undefined$1, undefined$1, undefined$1, arity);
		      result.placeholder = curry.placeholder;
		      return result;
		    }

		    /**
		     * This method is like `_.curry` except that arguments are applied to `func`
		     * in the manner of `_.partialRight` instead of `_.partial`.
		     *
		     * The `_.curryRight.placeholder` value, which defaults to `_` in monolithic
		     * builds, may be used as a placeholder for provided arguments.
		     *
		     * **Note:** This method doesn't set the "length" property of curried functions.
		     *
		     * @static
		     * @memberOf _
		     * @since 3.0.0
		     * @category Function
		     * @param {Function} func The function to curry.
		     * @param {number} [arity=func.length] The arity of `func`.
		     * @param- {Object} [guard] Enables use as an iteratee for methods like `_.map`.
		     * @returns {Function} Returns the new curried function.
		     * @example
		     *
		     * var abc = function(a, b, c) {
		     *   return [a, b, c];
		     * };
		     *
		     * var curried = _.curryRight(abc);
		     *
		     * curried(3)(2)(1);
		     * // => [1, 2, 3]
		     *
		     * curried(2, 3)(1);
		     * // => [1, 2, 3]
		     *
		     * curried(1, 2, 3);
		     * // => [1, 2, 3]
		     *
		     * // Curried with placeholders.
		     * curried(3)(1, _)(2);
		     * // => [1, 2, 3]
		     */
		    function curryRight(func, arity, guard) {
		      arity = guard ? undefined$1 : arity;
		      var result = createWrap(func, WRAP_CURRY_RIGHT_FLAG, undefined$1, undefined$1, undefined$1, undefined$1, undefined$1, arity);
		      result.placeholder = curryRight.placeholder;
		      return result;
		    }

		    /**
		     * Creates a debounced function that delays invoking `func` until after `wait`
		     * milliseconds have elapsed since the last time the debounced function was
		     * invoked. The debounced function comes with a `cancel` method to cancel
		     * delayed `func` invocations and a `flush` method to immediately invoke them.
		     * Provide `options` to indicate whether `func` should be invoked on the
		     * leading and/or trailing edge of the `wait` timeout. The `func` is invoked
		     * with the last arguments provided to the debounced function. Subsequent
		     * calls to the debounced function return the result of the last `func`
		     * invocation.
		     *
		     * **Note:** If `leading` and `trailing` options are `true`, `func` is
		     * invoked on the trailing edge of the timeout only if the debounced function
		     * is invoked more than once during the `wait` timeout.
		     *
		     * If `wait` is `0` and `leading` is `false`, `func` invocation is deferred
		     * until to the next tick, similar to `setTimeout` with a timeout of `0`.
		     *
		     * See [David Corbacho's article](https://css-tricks.com/debouncing-throttling-explained-examples/)
		     * for details over the differences between `_.debounce` and `_.throttle`.
		     *
		     * @static
		     * @memberOf _
		     * @since 0.1.0
		     * @category Function
		     * @param {Function} func The function to debounce.
		     * @param {number} [wait=0] The number of milliseconds to delay.
		     * @param {Object} [options={}] The options object.
		     * @param {boolean} [options.leading=false]
		     *  Specify invoking on the leading edge of the timeout.
		     * @param {number} [options.maxWait]
		     *  The maximum time `func` is allowed to be delayed before it's invoked.
		     * @param {boolean} [options.trailing=true]
		     *  Specify invoking on the trailing edge of the timeout.
		     * @returns {Function} Returns the new debounced function.
		     * @example
		     *
		     * // Avoid costly calculations while the window size is in flux.
		     * jQuery(window).on('resize', _.debounce(calculateLayout, 150));
		     *
		     * // Invoke `sendMail` when clicked, debouncing subsequent calls.
		     * jQuery(element).on('click', _.debounce(sendMail, 300, {
		     *   'leading': true,
		     *   'trailing': false
		     * }));
		     *
		     * // Ensure `batchLog` is invoked once after 1 second of debounced calls.
		     * var debounced = _.debounce(batchLog, 250, { 'maxWait': 1000 });
		     * var source = new EventSource('/stream');
		     * jQuery(source).on('message', debounced);
		     *
		     * // Cancel the trailing debounced invocation.
		     * jQuery(window).on('popstate', debounced.cancel);
		     */
		    function debounce(func, wait, options) {
		      var lastArgs,
		          lastThis,
		          maxWait,
		          result,
		          timerId,
		          lastCallTime,
		          lastInvokeTime = 0,
		          leading = false,
		          maxing = false,
		          trailing = true;

		      if (typeof func != 'function') {
		        throw new TypeError(FUNC_ERROR_TEXT);
		      }
		      wait = toNumber(wait) || 0;
		      if (isObject(options)) {
		        leading = !!options.leading;
		        maxing = 'maxWait' in options;
		        maxWait = maxing ? nativeMax(toNumber(options.maxWait) || 0, wait) : maxWait;
		        trailing = 'trailing' in options ? !!options.trailing : trailing;
		      }

		      function invokeFunc(time) {
		        var args = lastArgs,
		            thisArg = lastThis;

		        lastArgs = lastThis = undefined$1;
		        lastInvokeTime = time;
		        result = func.apply(thisArg, args);
		        return result;
		      }

		      function leadingEdge(time) {
		        // Reset any `maxWait` timer.
		        lastInvokeTime = time;
		        // Start the timer for the trailing edge.
		        timerId = setTimeout(timerExpired, wait);
		        // Invoke the leading edge.
		        return leading ? invokeFunc(time) : result;
		      }

		      function remainingWait(time) {
		        var timeSinceLastCall = time - lastCallTime,
		            timeSinceLastInvoke = time - lastInvokeTime,
		            timeWaiting = wait - timeSinceLastCall;

		        return maxing
		          ? nativeMin(timeWaiting, maxWait - timeSinceLastInvoke)
		          : timeWaiting;
		      }

		      function shouldInvoke(time) {
		        var timeSinceLastCall = time - lastCallTime,
		            timeSinceLastInvoke = time - lastInvokeTime;

		        // Either this is the first call, activity has stopped and we're at the
		        // trailing edge, the system time has gone backwards and we're treating
		        // it as the trailing edge, or we've hit the `maxWait` limit.
		        return (lastCallTime === undefined$1 || (timeSinceLastCall >= wait) ||
		          (timeSinceLastCall < 0) || (maxing && timeSinceLastInvoke >= maxWait));
		      }

		      function timerExpired() {
		        var time = now();
		        if (shouldInvoke(time)) {
		          return trailingEdge(time);
		        }
		        // Restart the timer.
		        timerId = setTimeout(timerExpired, remainingWait(time));
		      }

		      function trailingEdge(time) {
		        timerId = undefined$1;

		        // Only invoke if we have `lastArgs` which means `func` has been
		        // debounced at least once.
		        if (trailing && lastArgs) {
		          return invokeFunc(time);
		        }
		        lastArgs = lastThis = undefined$1;
		        return result;
		      }

		      function cancel() {
		        if (timerId !== undefined$1) {
		          clearTimeout(timerId);
		        }
		        lastInvokeTime = 0;
		        lastArgs = lastCallTime = lastThis = timerId = undefined$1;
		      }

		      function flush() {
		        return timerId === undefined$1 ? result : trailingEdge(now());
		      }

		      function debounced() {
		        var time = now(),
		            isInvoking = shouldInvoke(time);

		        lastArgs = arguments;
		        lastThis = this;
		        lastCallTime = time;

		        if (isInvoking) {
		          if (timerId === undefined$1) {
		            return leadingEdge(lastCallTime);
		          }
		          if (maxing) {
		            // Handle invocations in a tight loop.
		            clearTimeout(timerId);
		            timerId = setTimeout(timerExpired, wait);
		            return invokeFunc(lastCallTime);
		          }
		        }
		        if (timerId === undefined$1) {
		          timerId = setTimeout(timerExpired, wait);
		        }
		        return result;
		      }
		      debounced.cancel = cancel;
		      debounced.flush = flush;
		      return debounced;
		    }

		    /**
		     * Defers invoking the `func` until the current call stack has cleared. Any
		     * additional arguments are provided to `func` when it's invoked.
		     *
		     * @static
		     * @memberOf _
		     * @since 0.1.0
		     * @category Function
		     * @param {Function} func The function to defer.
		     * @param {...*} [args] The arguments to invoke `func` with.
		     * @returns {number} Returns the timer id.
		     * @example
		     *
		     * _.defer(function(text) {
		     *   console.log(text);
		     * }, 'deferred');
		     * // => Logs 'deferred' after one millisecond.
		     */
		    var defer = baseRest(function(func, args) {
		      return baseDelay(func, 1, args);
		    });

		    /**
		     * Invokes `func` after `wait` milliseconds. Any additional arguments are
		     * provided to `func` when it's invoked.
		     *
		     * @static
		     * @memberOf _
		     * @since 0.1.0
		     * @category Function
		     * @param {Function} func The function to delay.
		     * @param {number} wait The number of milliseconds to delay invocation.
		     * @param {...*} [args] The arguments to invoke `func` with.
		     * @returns {number} Returns the timer id.
		     * @example
		     *
		     * _.delay(function(text) {
		     *   console.log(text);
		     * }, 1000, 'later');
		     * // => Logs 'later' after one second.
		     */
		    var delay = baseRest(function(func, wait, args) {
		      return baseDelay(func, toNumber(wait) || 0, args);
		    });

		    /**
		     * Creates a function that invokes `func` with arguments reversed.
		     *
		     * @static
		     * @memberOf _
		     * @since 4.0.0
		     * @category Function
		     * @param {Function} func The function to flip arguments for.
		     * @returns {Function} Returns the new flipped function.
		     * @example
		     *
		     * var flipped = _.flip(function() {
		     *   return _.toArray(arguments);
		     * });
		     *
		     * flipped('a', 'b', 'c', 'd');
		     * // => ['d', 'c', 'b', 'a']
		     */
		    function flip(func) {
		      return createWrap(func, WRAP_FLIP_FLAG);
		    }

		    /**
		     * Creates a function that memoizes the result of `func`. If `resolver` is
		     * provided, it determines the cache key for storing the result based on the
		     * arguments provided to the memoized function. By default, the first argument
		     * provided to the memoized function is used as the map cache key. The `func`
		     * is invoked with the `this` binding of the memoized function.
		     *
		     * **Note:** The cache is exposed as the `cache` property on the memoized
		     * function. Its creation may be customized by replacing the `_.memoize.Cache`
		     * constructor with one whose instances implement the
		     * [`Map`](http://ecma-international.org/ecma-262/7.0/#sec-properties-of-the-map-prototype-object)
		     * method interface of `clear`, `delete`, `get`, `has`, and `set`.
		     *
		     * @static
		     * @memberOf _
		     * @since 0.1.0
		     * @category Function
		     * @param {Function} func The function to have its output memoized.
		     * @param {Function} [resolver] The function to resolve the cache key.
		     * @returns {Function} Returns the new memoized function.
		     * @example
		     *
		     * var object = { 'a': 1, 'b': 2 };
		     * var other = { 'c': 3, 'd': 4 };
		     *
		     * var values = _.memoize(_.values);
		     * values(object);
		     * // => [1, 2]
		     *
		     * values(other);
		     * // => [3, 4]
		     *
		     * object.a = 2;
		     * values(object);
		     * // => [1, 2]
		     *
		     * // Modify the result cache.
		     * values.cache.set(object, ['a', 'b']);
		     * values(object);
		     * // => ['a', 'b']
		     *
		     * // Replace `_.memoize.Cache`.
		     * _.memoize.Cache = WeakMap;
		     */
		    function memoize(func, resolver) {
		      if (typeof func != 'function' || (resolver != null && typeof resolver != 'function')) {
		        throw new TypeError(FUNC_ERROR_TEXT);
		      }
		      var memoized = function() {
		        var args = arguments,
		            key = resolver ? resolver.apply(this, args) : args[0],
		            cache = memoized.cache;

		        if (cache.has(key)) {
		          return cache.get(key);
		        }
		        var result = func.apply(this, args);
		        memoized.cache = cache.set(key, result) || cache;
		        return result;
		      };
		      memoized.cache = new (memoize.Cache || MapCache);
		      return memoized;
		    }

		    // Expose `MapCache`.
		    memoize.Cache = MapCache;

		    /**
		     * Creates a function that negates the result of the predicate `func`. The
		     * `func` predicate is invoked with the `this` binding and arguments of the
		     * created function.
		     *
		     * @static
		     * @memberOf _
		     * @since 3.0.0
		     * @category Function
		     * @param {Function} predicate The predicate to negate.
		     * @returns {Function} Returns the new negated function.
		     * @example
		     *
		     * function isEven(n) {
		     *   return n % 2 == 0;
		     * }
		     *
		     * _.filter([1, 2, 3, 4, 5, 6], _.negate(isEven));
		     * // => [1, 3, 5]
		     */
		    function negate(predicate) {
		      if (typeof predicate != 'function') {
		        throw new TypeError(FUNC_ERROR_TEXT);
		      }
		      return function() {
		        var args = arguments;
		        switch (args.length) {
		          case 0: return !predicate.call(this);
		          case 1: return !predicate.call(this, args[0]);
		          case 2: return !predicate.call(this, args[0], args[1]);
		          case 3: return !predicate.call(this, args[0], args[1], args[2]);
		        }
		        return !predicate.apply(this, args);
		      };
		    }

		    /**
		     * Creates a function that is restricted to invoking `func` once. Repeat calls
		     * to the function return the value of the first invocation. The `func` is
		     * invoked with the `this` binding and arguments of the created function.
		     *
		     * @static
		     * @memberOf _
		     * @since 0.1.0
		     * @category Function
		     * @param {Function} func The function to restrict.
		     * @returns {Function} Returns the new restricted function.
		     * @example
		     *
		     * var initialize = _.once(createApplication);
		     * initialize();
		     * initialize();
		     * // => `createApplication` is invoked once
		     */
		    function once(func) {
		      return before(2, func);
		    }

		    /**
		     * Creates a function that invokes `func` with its arguments transformed.
		     *
		     * @static
		     * @since 4.0.0
		     * @memberOf _
		     * @category Function
		     * @param {Function} func The function to wrap.
		     * @param {...(Function|Function[])} [transforms=[_.identity]]
		     *  The argument transforms.
		     * @returns {Function} Returns the new function.
		     * @example
		     *
		     * function doubled(n) {
		     *   return n * 2;
		     * }
		     *
		     * function square(n) {
		     *   return n * n;
		     * }
		     *
		     * var func = _.overArgs(function(x, y) {
		     *   return [x, y];
		     * }, [square, doubled]);
		     *
		     * func(9, 3);
		     * // => [81, 6]
		     *
		     * func(10, 5);
		     * // => [100, 10]
		     */
		    var overArgs = castRest(function(func, transforms) {
		      transforms = (transforms.length == 1 && isArray(transforms[0]))
		        ? arrayMap(transforms[0], baseUnary(getIteratee()))
		        : arrayMap(baseFlatten(transforms, 1), baseUnary(getIteratee()));

		      var funcsLength = transforms.length;
		      return baseRest(function(args) {
		        var index = -1,
		            length = nativeMin(args.length, funcsLength);

		        while (++index < length) {
		          args[index] = transforms[index].call(this, args[index]);
		        }
		        return apply(func, this, args);
		      });
		    });

		    /**
		     * Creates a function that invokes `func` with `partials` prepended to the
		     * arguments it receives. This method is like `_.bind` except it does **not**
		     * alter the `this` binding.
		     *
		     * The `_.partial.placeholder` value, which defaults to `_` in monolithic
		     * builds, may be used as a placeholder for partially applied arguments.
		     *
		     * **Note:** This method doesn't set the "length" property of partially
		     * applied functions.
		     *
		     * @static
		     * @memberOf _
		     * @since 0.2.0
		     * @category Function
		     * @param {Function} func The function to partially apply arguments to.
		     * @param {...*} [partials] The arguments to be partially applied.
		     * @returns {Function} Returns the new partially applied function.
		     * @example
		     *
		     * function greet(greeting, name) {
		     *   return greeting + ' ' + name;
		     * }
		     *
		     * var sayHelloTo = _.partial(greet, 'hello');
		     * sayHelloTo('fred');
		     * // => 'hello fred'
		     *
		     * // Partially applied with placeholders.
		     * var greetFred = _.partial(greet, _, 'fred');
		     * greetFred('hi');
		     * // => 'hi fred'
		     */
		    var partial = baseRest(function(func, partials) {
		      var holders = replaceHolders(partials, getHolder(partial));
		      return createWrap(func, WRAP_PARTIAL_FLAG, undefined$1, partials, holders);
		    });

		    /**
		     * This method is like `_.partial` except that partially applied arguments
		     * are appended to the arguments it receives.
		     *
		     * The `_.partialRight.placeholder` value, which defaults to `_` in monolithic
		     * builds, may be used as a placeholder for partially applied arguments.
		     *
		     * **Note:** This method doesn't set the "length" property of partially
		     * applied functions.
		     *
		     * @static
		     * @memberOf _
		     * @since 1.0.0
		     * @category Function
		     * @param {Function} func The function to partially apply arguments to.
		     * @param {...*} [partials] The arguments to be partially applied.
		     * @returns {Function} Returns the new partially applied function.
		     * @example
		     *
		     * function greet(greeting, name) {
		     *   return greeting + ' ' + name;
		     * }
		     *
		     * var greetFred = _.partialRight(greet, 'fred');
		     * greetFred('hi');
		     * // => 'hi fred'
		     *
		     * // Partially applied with placeholders.
		     * var sayHelloTo = _.partialRight(greet, 'hello', _);
		     * sayHelloTo('fred');
		     * // => 'hello fred'
		     */
		    var partialRight = baseRest(function(func, partials) {
		      var holders = replaceHolders(partials, getHolder(partialRight));
		      return createWrap(func, WRAP_PARTIAL_RIGHT_FLAG, undefined$1, partials, holders);
		    });

		    /**
		     * Creates a function that invokes `func` with arguments arranged according
		     * to the specified `indexes` where the argument value at the first index is
		     * provided as the first argument, the argument value at the second index is
		     * provided as the second argument, and so on.
		     *
		     * @static
		     * @memberOf _
		     * @since 3.0.0
		     * @category Function
		     * @param {Function} func The function to rearrange arguments for.
		     * @param {...(number|number[])} indexes The arranged argument indexes.
		     * @returns {Function} Returns the new function.
		     * @example
		     *
		     * var rearged = _.rearg(function(a, b, c) {
		     *   return [a, b, c];
		     * }, [2, 0, 1]);
		     *
		     * rearged('b', 'c', 'a')
		     * // => ['a', 'b', 'c']
		     */
		    var rearg = flatRest(function(func, indexes) {
		      return createWrap(func, WRAP_REARG_FLAG, undefined$1, undefined$1, undefined$1, indexes);
		    });

		    /**
		     * Creates a function that invokes `func` with the `this` binding of the
		     * created function and arguments from `start` and beyond provided as
		     * an array.
		     *
		     * **Note:** This method is based on the
		     * [rest parameter](https://mdn.io/rest_parameters).
		     *
		     * @static
		     * @memberOf _
		     * @since 4.0.0
		     * @category Function
		     * @param {Function} func The function to apply a rest parameter to.
		     * @param {number} [start=func.length-1] The start position of the rest parameter.
		     * @returns {Function} Returns the new function.
		     * @example
		     *
		     * var say = _.rest(function(what, names) {
		     *   return what + ' ' + _.initial(names).join(', ') +
		     *     (_.size(names) > 1 ? ', & ' : '') + _.last(names);
		     * });
		     *
		     * say('hello', 'fred', 'barney', 'pebbles');
		     * // => 'hello fred, barney, & pebbles'
		     */
		    function rest(func, start) {
		      if (typeof func != 'function') {
		        throw new TypeError(FUNC_ERROR_TEXT);
		      }
		      start = start === undefined$1 ? start : toInteger(start);
		      return baseRest(func, start);
		    }

		    /**
		     * Creates a function that invokes `func` with the `this` binding of the
		     * create function and an array of arguments much like
		     * [`Function#apply`](http://www.ecma-international.org/ecma-262/7.0/#sec-function.prototype.apply).
		     *
		     * **Note:** This method is based on the
		     * [spread operator](https://mdn.io/spread_operator).
		     *
		     * @static
		     * @memberOf _
		     * @since 3.2.0
		     * @category Function
		     * @param {Function} func The function to spread arguments over.
		     * @param {number} [start=0] The start position of the spread.
		     * @returns {Function} Returns the new function.
		     * @example
		     *
		     * var say = _.spread(function(who, what) {
		     *   return who + ' says ' + what;
		     * });
		     *
		     * say(['fred', 'hello']);
		     * // => 'fred says hello'
		     *
		     * var numbers = Promise.all([
		     *   Promise.resolve(40),
		     *   Promise.resolve(36)
		     * ]);
		     *
		     * numbers.then(_.spread(function(x, y) {
		     *   return x + y;
		     * }));
		     * // => a Promise of 76
		     */
		    function spread(func, start) {
		      if (typeof func != 'function') {
		        throw new TypeError(FUNC_ERROR_TEXT);
		      }
		      start = start == null ? 0 : nativeMax(toInteger(start), 0);
		      return baseRest(function(args) {
		        var array = args[start],
		            otherArgs = castSlice(args, 0, start);

		        if (array) {
		          arrayPush(otherArgs, array);
		        }
		        return apply(func, this, otherArgs);
		      });
		    }

		    /**
		     * Creates a throttled function that only invokes `func` at most once per
		     * every `wait` milliseconds. The throttled function comes with a `cancel`
		     * method to cancel delayed `func` invocations and a `flush` method to
		     * immediately invoke them. Provide `options` to indicate whether `func`
		     * should be invoked on the leading and/or trailing edge of the `wait`
		     * timeout. The `func` is invoked with the last arguments provided to the
		     * throttled function. Subsequent calls to the throttled function return the
		     * result of the last `func` invocation.
		     *
		     * **Note:** If `leading` and `trailing` options are `true`, `func` is
		     * invoked on the trailing edge of the timeout only if the throttled function
		     * is invoked more than once during the `wait` timeout.
		     *
		     * If `wait` is `0` and `leading` is `false`, `func` invocation is deferred
		     * until to the next tick, similar to `setTimeout` with a timeout of `0`.
		     *
		     * See [David Corbacho's article](https://css-tricks.com/debouncing-throttling-explained-examples/)
		     * for details over the differences between `_.throttle` and `_.debounce`.
		     *
		     * @static
		     * @memberOf _
		     * @since 0.1.0
		     * @category Function
		     * @param {Function} func The function to throttle.
		     * @param {number} [wait=0] The number of milliseconds to throttle invocations to.
		     * @param {Object} [options={}] The options object.
		     * @param {boolean} [options.leading=true]
		     *  Specify invoking on the leading edge of the timeout.
		     * @param {boolean} [options.trailing=true]
		     *  Specify invoking on the trailing edge of the timeout.
		     * @returns {Function} Returns the new throttled function.
		     * @example
		     *
		     * // Avoid excessively updating the position while scrolling.
		     * jQuery(window).on('scroll', _.throttle(updatePosition, 100));
		     *
		     * // Invoke `renewToken` when the click event is fired, but not more than once every 5 minutes.
		     * var throttled = _.throttle(renewToken, 300000, { 'trailing': false });
		     * jQuery(element).on('click', throttled);
		     *
		     * // Cancel the trailing throttled invocation.
		     * jQuery(window).on('popstate', throttled.cancel);
		     */
		    function throttle(func, wait, options) {
		      var leading = true,
		          trailing = true;

		      if (typeof func != 'function') {
		        throw new TypeError(FUNC_ERROR_TEXT);
		      }
		      if (isObject(options)) {
		        leading = 'leading' in options ? !!options.leading : leading;
		        trailing = 'trailing' in options ? !!options.trailing : trailing;
		      }
		      return debounce(func, wait, {
		        'leading': leading,
		        'maxWait': wait,
		        'trailing': trailing
		      });
		    }

		    /**
		     * Creates a function that accepts up to one argument, ignoring any
		     * additional arguments.
		     *
		     * @static
		     * @memberOf _
		     * @since 4.0.0
		     * @category Function
		     * @param {Function} func The function to cap arguments for.
		     * @returns {Function} Returns the new capped function.
		     * @example
		     *
		     * _.map(['6', '8', '10'], _.unary(parseInt));
		     * // => [6, 8, 10]
		     */
		    function unary(func) {
		      return ary(func, 1);
		    }

		    /**
		     * Creates a function that provides `value` to `wrapper` as its first
		     * argument. Any additional arguments provided to the function are appended
		     * to those provided to the `wrapper`. The wrapper is invoked with the `this`
		     * binding of the created function.
		     *
		     * @static
		     * @memberOf _
		     * @since 0.1.0
		     * @category Function
		     * @param {*} value The value to wrap.
		     * @param {Function} [wrapper=identity] The wrapper function.
		     * @returns {Function} Returns the new function.
		     * @example
		     *
		     * var p = _.wrap(_.escape, function(func, text) {
		     *   return '<p>' + func(text) + '</p>';
		     * });
		     *
		     * p('fred, barney, & pebbles');
		     * // => '<p>fred, barney, &amp; pebbles</p>'
		     */
		    function wrap(value, wrapper) {
		      return partial(castFunction(wrapper), value);
		    }

		    /*------------------------------------------------------------------------*/

		    /**
		     * Casts `value` as an array if it's not one.
		     *
		     * @static
		     * @memberOf _
		     * @since 4.4.0
		     * @category Lang
		     * @param {*} value The value to inspect.
		     * @returns {Array} Returns the cast array.
		     * @example
		     *
		     * _.castArray(1);
		     * // => [1]
		     *
		     * _.castArray({ 'a': 1 });
		     * // => [{ 'a': 1 }]
		     *
		     * _.castArray('abc');
		     * // => ['abc']
		     *
		     * _.castArray(null);
		     * // => [null]
		     *
		     * _.castArray(undefined);
		     * // => [undefined]
		     *
		     * _.castArray();
		     * // => []
		     *
		     * var array = [1, 2, 3];
		     * console.log(_.castArray(array) === array);
		     * // => true
		     */
		    function castArray() {
		      if (!arguments.length) {
		        return [];
		      }
		      var value = arguments[0];
		      return isArray(value) ? value : [value];
		    }

		    /**
		     * Creates a shallow clone of `value`.
		     *
		     * **Note:** This method is loosely based on the
		     * [structured clone algorithm](https://mdn.io/Structured_clone_algorithm)
		     * and supports cloning arrays, array buffers, booleans, date objects, maps,
		     * numbers, `Object` objects, regexes, sets, strings, symbols, and typed
		     * arrays. The own enumerable properties of `arguments` objects are cloned
		     * as plain objects. An empty object is returned for uncloneable values such
		     * as error objects, functions, DOM nodes, and WeakMaps.
		     *
		     * @static
		     * @memberOf _
		     * @since 0.1.0
		     * @category Lang
		     * @param {*} value The value to clone.
		     * @returns {*} Returns the cloned value.
		     * @see _.cloneDeep
		     * @example
		     *
		     * var objects = [{ 'a': 1 }, { 'b': 2 }];
		     *
		     * var shallow = _.clone(objects);
		     * console.log(shallow[0] === objects[0]);
		     * // => true
		     */
		    function clone(value) {
		      return baseClone(value, CLONE_SYMBOLS_FLAG);
		    }

		    /**
		     * This method is like `_.clone` except that it accepts `customizer` which
		     * is invoked to produce the cloned value. If `customizer` returns `undefined`,
		     * cloning is handled by the method instead. The `customizer` is invoked with
		     * up to four arguments; (value [, index|key, object, stack]).
		     *
		     * @static
		     * @memberOf _
		     * @since 4.0.0
		     * @category Lang
		     * @param {*} value The value to clone.
		     * @param {Function} [customizer] The function to customize cloning.
		     * @returns {*} Returns the cloned value.
		     * @see _.cloneDeepWith
		     * @example
		     *
		     * function customizer(value) {
		     *   if (_.isElement(value)) {
		     *     return value.cloneNode(false);
		     *   }
		     * }
		     *
		     * var el = _.cloneWith(document.body, customizer);
		     *
		     * console.log(el === document.body);
		     * // => false
		     * console.log(el.nodeName);
		     * // => 'BODY'
		     * console.log(el.childNodes.length);
		     * // => 0
		     */
		    function cloneWith(value, customizer) {
		      customizer = typeof customizer == 'function' ? customizer : undefined$1;
		      return baseClone(value, CLONE_SYMBOLS_FLAG, customizer);
		    }

		    /**
		     * This method is like `_.clone` except that it recursively clones `value`.
		     *
		     * @static
		     * @memberOf _
		     * @since 1.0.0
		     * @category Lang
		     * @param {*} value The value to recursively clone.
		     * @returns {*} Returns the deep cloned value.
		     * @see _.clone
		     * @example
		     *
		     * var objects = [{ 'a': 1 }, { 'b': 2 }];
		     *
		     * var deep = _.cloneDeep(objects);
		     * console.log(deep[0] === objects[0]);
		     * // => false
		     */
		    function cloneDeep(value) {
		      return baseClone(value, CLONE_DEEP_FLAG | CLONE_SYMBOLS_FLAG);
		    }

		    /**
		     * This method is like `_.cloneWith` except that it recursively clones `value`.
		     *
		     * @static
		     * @memberOf _
		     * @since 4.0.0
		     * @category Lang
		     * @param {*} value The value to recursively clone.
		     * @param {Function} [customizer] The function to customize cloning.
		     * @returns {*} Returns the deep cloned value.
		     * @see _.cloneWith
		     * @example
		     *
		     * function customizer(value) {
		     *   if (_.isElement(value)) {
		     *     return value.cloneNode(true);
		     *   }
		     * }
		     *
		     * var el = _.cloneDeepWith(document.body, customizer);
		     *
		     * console.log(el === document.body);
		     * // => false
		     * console.log(el.nodeName);
		     * // => 'BODY'
		     * console.log(el.childNodes.length);
		     * // => 20
		     */
		    function cloneDeepWith(value, customizer) {
		      customizer = typeof customizer == 'function' ? customizer : undefined$1;
		      return baseClone(value, CLONE_DEEP_FLAG | CLONE_SYMBOLS_FLAG, customizer);
		    }

		    /**
		     * Checks if `object` conforms to `source` by invoking the predicate
		     * properties of `source` with the corresponding property values of `object`.
		     *
		     * **Note:** This method is equivalent to `_.conforms` when `source` is
		     * partially applied.
		     *
		     * @static
		     * @memberOf _
		     * @since 4.14.0
		     * @category Lang
		     * @param {Object} object The object to inspect.
		     * @param {Object} source The object of property predicates to conform to.
		     * @returns {boolean} Returns `true` if `object` conforms, else `false`.
		     * @example
		     *
		     * var object = { 'a': 1, 'b': 2 };
		     *
		     * _.conformsTo(object, { 'b': function(n) { return n > 1; } });
		     * // => true
		     *
		     * _.conformsTo(object, { 'b': function(n) { return n > 2; } });
		     * // => false
		     */
		    function conformsTo(object, source) {
		      return source == null || baseConformsTo(object, source, keys(source));
		    }

		    /**
		     * Performs a
		     * [`SameValueZero`](http://ecma-international.org/ecma-262/7.0/#sec-samevaluezero)
		     * comparison between two values to determine if they are equivalent.
		     *
		     * @static
		     * @memberOf _
		     * @since 4.0.0
		     * @category Lang
		     * @param {*} value The value to compare.
		     * @param {*} other The other value to compare.
		     * @returns {boolean} Returns `true` if the values are equivalent, else `false`.
		     * @example
		     *
		     * var object = { 'a': 1 };
		     * var other = { 'a': 1 };
		     *
		     * _.eq(object, object);
		     * // => true
		     *
		     * _.eq(object, other);
		     * // => false
		     *
		     * _.eq('a', 'a');
		     * // => true
		     *
		     * _.eq('a', Object('a'));
		     * // => false
		     *
		     * _.eq(NaN, NaN);
		     * // => true
		     */
		    function eq(value, other) {
		      return value === other || (value !== value && other !== other);
		    }

		    /**
		     * Checks if `value` is greater than `other`.
		     *
		     * @static
		     * @memberOf _
		     * @since 3.9.0
		     * @category Lang
		     * @param {*} value The value to compare.
		     * @param {*} other The other value to compare.
		     * @returns {boolean} Returns `true` if `value` is greater than `other`,
		     *  else `false`.
		     * @see _.lt
		     * @example
		     *
		     * _.gt(3, 1);
		     * // => true
		     *
		     * _.gt(3, 3);
		     * // => false
		     *
		     * _.gt(1, 3);
		     * // => false
		     */
		    var gt = createRelationalOperation(baseGt);

		    /**
		     * Checks if `value` is greater than or equal to `other`.
		     *
		     * @static
		     * @memberOf _
		     * @since 3.9.0
		     * @category Lang
		     * @param {*} value The value to compare.
		     * @param {*} other The other value to compare.
		     * @returns {boolean} Returns `true` if `value` is greater than or equal to
		     *  `other`, else `false`.
		     * @see _.lte
		     * @example
		     *
		     * _.gte(3, 1);
		     * // => true
		     *
		     * _.gte(3, 3);
		     * // => true
		     *
		     * _.gte(1, 3);
		     * // => false
		     */
		    var gte = createRelationalOperation(function(value, other) {
		      return value >= other;
		    });

		    /**
		     * Checks if `value` is likely an `arguments` object.
		     *
		     * @static
		     * @memberOf _
		     * @since 0.1.0
		     * @category Lang
		     * @param {*} value The value to check.
		     * @returns {boolean} Returns `true` if `value` is an `arguments` object,
		     *  else `false`.
		     * @example
		     *
		     * _.isArguments(function() { return arguments; }());
		     * // => true
		     *
		     * _.isArguments([1, 2, 3]);
		     * // => false
		     */
		    var isArguments = baseIsArguments(function() { return arguments; }()) ? baseIsArguments : function(value) {
		      return isObjectLike(value) && hasOwnProperty.call(value, 'callee') &&
		        !propertyIsEnumerable.call(value, 'callee');
		    };

		    /**
		     * Checks if `value` is classified as an `Array` object.
		     *
		     * @static
		     * @memberOf _
		     * @since 0.1.0
		     * @category Lang
		     * @param {*} value The value to check.
		     * @returns {boolean} Returns `true` if `value` is an array, else `false`.
		     * @example
		     *
		     * _.isArray([1, 2, 3]);
		     * // => true
		     *
		     * _.isArray(document.body.children);
		     * // => false
		     *
		     * _.isArray('abc');
		     * // => false
		     *
		     * _.isArray(_.noop);
		     * // => false
		     */
		    var isArray = Array.isArray;

		    /**
		     * Checks if `value` is classified as an `ArrayBuffer` object.
		     *
		     * @static
		     * @memberOf _
		     * @since 4.3.0
		     * @category Lang
		     * @param {*} value The value to check.
		     * @returns {boolean} Returns `true` if `value` is an array buffer, else `false`.
		     * @example
		     *
		     * _.isArrayBuffer(new ArrayBuffer(2));
		     * // => true
		     *
		     * _.isArrayBuffer(new Array(2));
		     * // => false
		     */
		    var isArrayBuffer = nodeIsArrayBuffer ? baseUnary(nodeIsArrayBuffer) : baseIsArrayBuffer;

		    /**
		     * Checks if `value` is array-like. A value is considered array-like if it's
		     * not a function and has a `value.length` that's an integer greater than or
		     * equal to `0` and less than or equal to `Number.MAX_SAFE_INTEGER`.
		     *
		     * @static
		     * @memberOf _
		     * @since 4.0.0
		     * @category Lang
		     * @param {*} value The value to check.
		     * @returns {boolean} Returns `true` if `value` is array-like, else `false`.
		     * @example
		     *
		     * _.isArrayLike([1, 2, 3]);
		     * // => true
		     *
		     * _.isArrayLike(document.body.children);
		     * // => true
		     *
		     * _.isArrayLike('abc');
		     * // => true
		     *
		     * _.isArrayLike(_.noop);
		     * // => false
		     */
		    function isArrayLike(value) {
		      return value != null && isLength(value.length) && !isFunction(value);
		    }

		    /**
		     * This method is like `_.isArrayLike` except that it also checks if `value`
		     * is an object.
		     *
		     * @static
		     * @memberOf _
		     * @since 4.0.0
		     * @category Lang
		     * @param {*} value The value to check.
		     * @returns {boolean} Returns `true` if `value` is an array-like object,
		     *  else `false`.
		     * @example
		     *
		     * _.isArrayLikeObject([1, 2, 3]);
		     * // => true
		     *
		     * _.isArrayLikeObject(document.body.children);
		     * // => true
		     *
		     * _.isArrayLikeObject('abc');
		     * // => false
		     *
		     * _.isArrayLikeObject(_.noop);
		     * // => false
		     */
		    function isArrayLikeObject(value) {
		      return isObjectLike(value) && isArrayLike(value);
		    }

		    /**
		     * Checks if `value` is classified as a boolean primitive or object.
		     *
		     * @static
		     * @memberOf _
		     * @since 0.1.0
		     * @category Lang
		     * @param {*} value The value to check.
		     * @returns {boolean} Returns `true` if `value` is a boolean, else `false`.
		     * @example
		     *
		     * _.isBoolean(false);
		     * // => true
		     *
		     * _.isBoolean(null);
		     * // => false
		     */
		    function isBoolean(value) {
		      return value === true || value === false ||
		        (isObjectLike(value) && baseGetTag(value) == boolTag);
		    }

		    /**
		     * Checks if `value` is a buffer.
		     *
		     * @static
		     * @memberOf _
		     * @since 4.3.0
		     * @category Lang
		     * @param {*} value The value to check.
		     * @returns {boolean} Returns `true` if `value` is a buffer, else `false`.
		     * @example
		     *
		     * _.isBuffer(new Buffer(2));
		     * // => true
		     *
		     * _.isBuffer(new Uint8Array(2));
		     * // => false
		     */
		    var isBuffer = nativeIsBuffer || stubFalse;

		    /**
		     * Checks if `value` is classified as a `Date` object.
		     *
		     * @static
		     * @memberOf _
		     * @since 0.1.0
		     * @category Lang
		     * @param {*} value The value to check.
		     * @returns {boolean} Returns `true` if `value` is a date object, else `false`.
		     * @example
		     *
		     * _.isDate(new Date);
		     * // => true
		     *
		     * _.isDate('Mon April 23 2012');
		     * // => false
		     */
		    var isDate = nodeIsDate ? baseUnary(nodeIsDate) : baseIsDate;

		    /**
		     * Checks if `value` is likely a DOM element.
		     *
		     * @static
		     * @memberOf _
		     * @since 0.1.0
		     * @category Lang
		     * @param {*} value The value to check.
		     * @returns {boolean} Returns `true` if `value` is a DOM element, else `false`.
		     * @example
		     *
		     * _.isElement(document.body);
		     * // => true
		     *
		     * _.isElement('<body>');
		     * // => false
		     */
		    function isElement(value) {
		      return isObjectLike(value) && value.nodeType === 1 && !isPlainObject(value);
		    }

		    /**
		     * Checks if `value` is an empty object, collection, map, or set.
		     *
		     * Objects are considered empty if they have no own enumerable string keyed
		     * properties.
		     *
		     * Array-like values such as `arguments` objects, arrays, buffers, strings, or
		     * jQuery-like collections are considered empty if they have a `length` of `0`.
		     * Similarly, maps and sets are considered empty if they have a `size` of `0`.
		     *
		     * @static
		     * @memberOf _
		     * @since 0.1.0
		     * @category Lang
		     * @param {*} value The value to check.
		     * @returns {boolean} Returns `true` if `value` is empty, else `false`.
		     * @example
		     *
		     * _.isEmpty(null);
		     * // => true
		     *
		     * _.isEmpty(true);
		     * // => true
		     *
		     * _.isEmpty(1);
		     * // => true
		     *
		     * _.isEmpty([1, 2, 3]);
		     * // => false
		     *
		     * _.isEmpty({ 'a': 1 });
		     * // => false
		     */
		    function isEmpty(value) {
		      if (value == null) {
		        return true;
		      }
		      if (isArrayLike(value) &&
		          (isArray(value) || typeof value == 'string' || typeof value.splice == 'function' ||
		            isBuffer(value) || isTypedArray(value) || isArguments(value))) {
		        return !value.length;
		      }
		      var tag = getTag(value);
		      if (tag == mapTag || tag == setTag) {
		        return !value.size;
		      }
		      if (isPrototype(value)) {
		        return !baseKeys(value).length;
		      }
		      for (var key in value) {
		        if (hasOwnProperty.call(value, key)) {
		          return false;
		        }
		      }
		      return true;
		    }

		    /**
		     * Performs a deep comparison between two values to determine if they are
		     * equivalent.
		     *
		     * **Note:** This method supports comparing arrays, array buffers, booleans,
		     * date objects, error objects, maps, numbers, `Object` objects, regexes,
		     * sets, strings, symbols, and typed arrays. `Object` objects are compared
		     * by their own, not inherited, enumerable properties. Functions and DOM
		     * nodes are compared by strict equality, i.e. `===`.
		     *
		     * @static
		     * @memberOf _
		     * @since 0.1.0
		     * @category Lang
		     * @param {*} value The value to compare.
		     * @param {*} other The other value to compare.
		     * @returns {boolean} Returns `true` if the values are equivalent, else `false`.
		     * @example
		     *
		     * var object = { 'a': 1 };
		     * var other = { 'a': 1 };
		     *
		     * _.isEqual(object, other);
		     * // => true
		     *
		     * object === other;
		     * // => false
		     */
		    function isEqual(value, other) {
		      return baseIsEqual(value, other);
		    }

		    /**
		     * This method is like `_.isEqual` except that it accepts `customizer` which
		     * is invoked to compare values. If `customizer` returns `undefined`, comparisons
		     * are handled by the method instead. The `customizer` is invoked with up to
		     * six arguments: (objValue, othValue [, index|key, object, other, stack]).
		     *
		     * @static
		     * @memberOf _
		     * @since 4.0.0
		     * @category Lang
		     * @param {*} value The value to compare.
		     * @param {*} other The other value to compare.
		     * @param {Function} [customizer] The function to customize comparisons.
		     * @returns {boolean} Returns `true` if the values are equivalent, else `false`.
		     * @example
		     *
		     * function isGreeting(value) {
		     *   return /^h(?:i|ello)$/.test(value);
		     * }
		     *
		     * function customizer(objValue, othValue) {
		     *   if (isGreeting(objValue) && isGreeting(othValue)) {
		     *     return true;
		     *   }
		     * }
		     *
		     * var array = ['hello', 'goodbye'];
		     * var other = ['hi', 'goodbye'];
		     *
		     * _.isEqualWith(array, other, customizer);
		     * // => true
		     */
		    function isEqualWith(value, other, customizer) {
		      customizer = typeof customizer == 'function' ? customizer : undefined$1;
		      var result = customizer ? customizer(value, other) : undefined$1;
		      return result === undefined$1 ? baseIsEqual(value, other, undefined$1, customizer) : !!result;
		    }

		    /**
		     * Checks if `value` is an `Error`, `EvalError`, `RangeError`, `ReferenceError`,
		     * `SyntaxError`, `TypeError`, or `URIError` object.
		     *
		     * @static
		     * @memberOf _
		     * @since 3.0.0
		     * @category Lang
		     * @param {*} value The value to check.
		     * @returns {boolean} Returns `true` if `value` is an error object, else `false`.
		     * @example
		     *
		     * _.isError(new Error);
		     * // => true
		     *
		     * _.isError(Error);
		     * // => false
		     */
		    function isError(value) {
		      if (!isObjectLike(value)) {
		        return false;
		      }
		      var tag = baseGetTag(value);
		      return tag == errorTag || tag == domExcTag ||
		        (typeof value.message == 'string' && typeof value.name == 'string' && !isPlainObject(value));
		    }

		    /**
		     * Checks if `value` is a finite primitive number.
		     *
		     * **Note:** This method is based on
		     * [`Number.isFinite`](https://mdn.io/Number/isFinite).
		     *
		     * @static
		     * @memberOf _
		     * @since 0.1.0
		     * @category Lang
		     * @param {*} value The value to check.
		     * @returns {boolean} Returns `true` if `value` is a finite number, else `false`.
		     * @example
		     *
		     * _.isFinite(3);
		     * // => true
		     *
		     * _.isFinite(Number.MIN_VALUE);
		     * // => true
		     *
		     * _.isFinite(Infinity);
		     * // => false
		     *
		     * _.isFinite('3');
		     * // => false
		     */
		    function isFinite(value) {
		      return typeof value == 'number' && nativeIsFinite(value);
		    }

		    /**
		     * Checks if `value` is classified as a `Function` object.
		     *
		     * @static
		     * @memberOf _
		     * @since 0.1.0
		     * @category Lang
		     * @param {*} value The value to check.
		     * @returns {boolean} Returns `true` if `value` is a function, else `false`.
		     * @example
		     *
		     * _.isFunction(_);
		     * // => true
		     *
		     * _.isFunction(/abc/);
		     * // => false
		     */
		    function isFunction(value) {
		      if (!isObject(value)) {
		        return false;
		      }
		      // The use of `Object#toString` avoids issues with the `typeof` operator
		      // in Safari 9 which returns 'object' for typed arrays and other constructors.
		      var tag = baseGetTag(value);
		      return tag == funcTag || tag == genTag || tag == asyncTag || tag == proxyTag;
		    }

		    /**
		     * Checks if `value` is an integer.
		     *
		     * **Note:** This method is based on
		     * [`Number.isInteger`](https://mdn.io/Number/isInteger).
		     *
		     * @static
		     * @memberOf _
		     * @since 4.0.0
		     * @category Lang
		     * @param {*} value The value to check.
		     * @returns {boolean} Returns `true` if `value` is an integer, else `false`.
		     * @example
		     *
		     * _.isInteger(3);
		     * // => true
		     *
		     * _.isInteger(Number.MIN_VALUE);
		     * // => false
		     *
		     * _.isInteger(Infinity);
		     * // => false
		     *
		     * _.isInteger('3');
		     * // => false
		     */
		    function isInteger(value) {
		      return typeof value == 'number' && value == toInteger(value);
		    }

		    /**
		     * Checks if `value` is a valid array-like length.
		     *
		     * **Note:** This method is loosely based on
		     * [`ToLength`](http://ecma-international.org/ecma-262/7.0/#sec-tolength).
		     *
		     * @static
		     * @memberOf _
		     * @since 4.0.0
		     * @category Lang
		     * @param {*} value The value to check.
		     * @returns {boolean} Returns `true` if `value` is a valid length, else `false`.
		     * @example
		     *
		     * _.isLength(3);
		     * // => true
		     *
		     * _.isLength(Number.MIN_VALUE);
		     * // => false
		     *
		     * _.isLength(Infinity);
		     * // => false
		     *
		     * _.isLength('3');
		     * // => false
		     */
		    function isLength(value) {
		      return typeof value == 'number' &&
		        value > -1 && value % 1 == 0 && value <= MAX_SAFE_INTEGER;
		    }

		    /**
		     * Checks if `value` is the
		     * [language type](http://www.ecma-international.org/ecma-262/7.0/#sec-ecmascript-language-types)
		     * of `Object`. (e.g. arrays, functions, objects, regexes, `new Number(0)`, and `new String('')`)
		     *
		     * @static
		     * @memberOf _
		     * @since 0.1.0
		     * @category Lang
		     * @param {*} value The value to check.
		     * @returns {boolean} Returns `true` if `value` is an object, else `false`.
		     * @example
		     *
		     * _.isObject({});
		     * // => true
		     *
		     * _.isObject([1, 2, 3]);
		     * // => true
		     *
		     * _.isObject(_.noop);
		     * // => true
		     *
		     * _.isObject(null);
		     * // => false
		     */
		    function isObject(value) {
		      var type = typeof value;
		      return value != null && (type == 'object' || type == 'function');
		    }

		    /**
		     * Checks if `value` is object-like. A value is object-like if it's not `null`
		     * and has a `typeof` result of "object".
		     *
		     * @static
		     * @memberOf _
		     * @since 4.0.0
		     * @category Lang
		     * @param {*} value The value to check.
		     * @returns {boolean} Returns `true` if `value` is object-like, else `false`.
		     * @example
		     *
		     * _.isObjectLike({});
		     * // => true
		     *
		     * _.isObjectLike([1, 2, 3]);
		     * // => true
		     *
		     * _.isObjectLike(_.noop);
		     * // => false
		     *
		     * _.isObjectLike(null);
		     * // => false
		     */
		    function isObjectLike(value) {
		      return value != null && typeof value == 'object';
		    }

		    /**
		     * Checks if `value` is classified as a `Map` object.
		     *
		     * @static
		     * @memberOf _
		     * @since 4.3.0
		     * @category Lang
		     * @param {*} value The value to check.
		     * @returns {boolean} Returns `true` if `value` is a map, else `false`.
		     * @example
		     *
		     * _.isMap(new Map);
		     * // => true
		     *
		     * _.isMap(new WeakMap);
		     * // => false
		     */
		    var isMap = nodeIsMap ? baseUnary(nodeIsMap) : baseIsMap;

		    /**
		     * Performs a partial deep comparison between `object` and `source` to
		     * determine if `object` contains equivalent property values.
		     *
		     * **Note:** This method is equivalent to `_.matches` when `source` is
		     * partially applied.
		     *
		     * Partial comparisons will match empty array and empty object `source`
		     * values against any array or object value, respectively. See `_.isEqual`
		     * for a list of supported value comparisons.
		     *
		     * @static
		     * @memberOf _
		     * @since 3.0.0
		     * @category Lang
		     * @param {Object} object The object to inspect.
		     * @param {Object} source The object of property values to match.
		     * @returns {boolean} Returns `true` if `object` is a match, else `false`.
		     * @example
		     *
		     * var object = { 'a': 1, 'b': 2 };
		     *
		     * _.isMatch(object, { 'b': 2 });
		     * // => true
		     *
		     * _.isMatch(object, { 'b': 1 });
		     * // => false
		     */
		    function isMatch(object, source) {
		      return object === source || baseIsMatch(object, source, getMatchData(source));
		    }

		    /**
		     * This method is like `_.isMatch` except that it accepts `customizer` which
		     * is invoked to compare values. If `customizer` returns `undefined`, comparisons
		     * are handled by the method instead. The `customizer` is invoked with five
		     * arguments: (objValue, srcValue, index|key, object, source).
		     *
		     * @static
		     * @memberOf _
		     * @since 4.0.0
		     * @category Lang
		     * @param {Object} object The object to inspect.
		     * @param {Object} source The object of property values to match.
		     * @param {Function} [customizer] The function to customize comparisons.
		     * @returns {boolean} Returns `true` if `object` is a match, else `false`.
		     * @example
		     *
		     * function isGreeting(value) {
		     *   return /^h(?:i|ello)$/.test(value);
		     * }
		     *
		     * function customizer(objValue, srcValue) {
		     *   if (isGreeting(objValue) && isGreeting(srcValue)) {
		     *     return true;
		     *   }
		     * }
		     *
		     * var object = { 'greeting': 'hello' };
		     * var source = { 'greeting': 'hi' };
		     *
		     * _.isMatchWith(object, source, customizer);
		     * // => true
		     */
		    function isMatchWith(object, source, customizer) {
		      customizer = typeof customizer == 'function' ? customizer : undefined$1;
		      return baseIsMatch(object, source, getMatchData(source), customizer);
		    }

		    /**
		     * Checks if `value` is `NaN`.
		     *
		     * **Note:** This method is based on
		     * [`Number.isNaN`](https://mdn.io/Number/isNaN) and is not the same as
		     * global [`isNaN`](https://mdn.io/isNaN) which returns `true` for
		     * `undefined` and other non-number values.
		     *
		     * @static
		     * @memberOf _
		     * @since 0.1.0
		     * @category Lang
		     * @param {*} value The value to check.
		     * @returns {boolean} Returns `true` if `value` is `NaN`, else `false`.
		     * @example
		     *
		     * _.isNaN(NaN);
		     * // => true
		     *
		     * _.isNaN(new Number(NaN));
		     * // => true
		     *
		     * isNaN(undefined);
		     * // => true
		     *
		     * _.isNaN(undefined);
		     * // => false
		     */
		    function isNaN(value) {
		      // An `NaN` primitive is the only value that is not equal to itself.
		      // Perform the `toStringTag` check first to avoid errors with some
		      // ActiveX objects in IE.
		      return isNumber(value) && value != +value;
		    }

		    /**
		     * Checks if `value` is a pristine native function.
		     *
		     * **Note:** This method can't reliably detect native functions in the presence
		     * of the core-js package because core-js circumvents this kind of detection.
		     * Despite multiple requests, the core-js maintainer has made it clear: any
		     * attempt to fix the detection will be obstructed. As a result, we're left
		     * with little choice but to throw an error. Unfortunately, this also affects
		     * packages, like [babel-polyfill](https://www.npmjs.com/package/babel-polyfill),
		     * which rely on core-js.
		     *
		     * @static
		     * @memberOf _
		     * @since 3.0.0
		     * @category Lang
		     * @param {*} value The value to check.
		     * @returns {boolean} Returns `true` if `value` is a native function,
		     *  else `false`.
		     * @example
		     *
		     * _.isNative(Array.prototype.push);
		     * // => true
		     *
		     * _.isNative(_);
		     * // => false
		     */
		    function isNative(value) {
		      if (isMaskable(value)) {
		        throw new Error(CORE_ERROR_TEXT);
		      }
		      return baseIsNative(value);
		    }

		    /**
		     * Checks if `value` is `null`.
		     *
		     * @static
		     * @memberOf _
		     * @since 0.1.0
		     * @category Lang
		     * @param {*} value The value to check.
		     * @returns {boolean} Returns `true` if `value` is `null`, else `false`.
		     * @example
		     *
		     * _.isNull(null);
		     * // => true
		     *
		     * _.isNull(void 0);
		     * // => false
		     */
		    function isNull(value) {
		      return value === null;
		    }

		    /**
		     * Checks if `value` is `null` or `undefined`.
		     *
		     * @static
		     * @memberOf _
		     * @since 4.0.0
		     * @category Lang
		     * @param {*} value The value to check.
		     * @returns {boolean} Returns `true` if `value` is nullish, else `false`.
		     * @example
		     *
		     * _.isNil(null);
		     * // => true
		     *
		     * _.isNil(void 0);
		     * // => true
		     *
		     * _.isNil(NaN);
		     * // => false
		     */
		    function isNil(value) {
		      return value == null;
		    }

		    /**
		     * Checks if `value` is classified as a `Number` primitive or object.
		     *
		     * **Note:** To exclude `Infinity`, `-Infinity`, and `NaN`, which are
		     * classified as numbers, use the `_.isFinite` method.
		     *
		     * @static
		     * @memberOf _
		     * @since 0.1.0
		     * @category Lang
		     * @param {*} value The value to check.
		     * @returns {boolean} Returns `true` if `value` is a number, else `false`.
		     * @example
		     *
		     * _.isNumber(3);
		     * // => true
		     *
		     * _.isNumber(Number.MIN_VALUE);
		     * // => true
		     *
		     * _.isNumber(Infinity);
		     * // => true
		     *
		     * _.isNumber('3');
		     * // => false
		     */
		    function isNumber(value) {
		      return typeof value == 'number' ||
		        (isObjectLike(value) && baseGetTag(value) == numberTag);
		    }

		    /**
		     * Checks if `value` is a plain object, that is, an object created by the
		     * `Object` constructor or one with a `[[Prototype]]` of `null`.
		     *
		     * @static
		     * @memberOf _
		     * @since 0.8.0
		     * @category Lang
		     * @param {*} value The value to check.
		     * @returns {boolean} Returns `true` if `value` is a plain object, else `false`.
		     * @example
		     *
		     * function Foo() {
		     *   this.a = 1;
		     * }
		     *
		     * _.isPlainObject(new Foo);
		     * // => false
		     *
		     * _.isPlainObject([1, 2, 3]);
		     * // => false
		     *
		     * _.isPlainObject({ 'x': 0, 'y': 0 });
		     * // => true
		     *
		     * _.isPlainObject(Object.create(null));
		     * // => true
		     */
		    function isPlainObject(value) {
		      if (!isObjectLike(value) || baseGetTag(value) != objectTag) {
		        return false;
		      }
		      var proto = getPrototype(value);
		      if (proto === null) {
		        return true;
		      }
		      var Ctor = hasOwnProperty.call(proto, 'constructor') && proto.constructor;
		      return typeof Ctor == 'function' && Ctor instanceof Ctor &&
		        funcToString.call(Ctor) == objectCtorString;
		    }

		    /**
		     * Checks if `value` is classified as a `RegExp` object.
		     *
		     * @static
		     * @memberOf _
		     * @since 0.1.0
		     * @category Lang
		     * @param {*} value The value to check.
		     * @returns {boolean} Returns `true` if `value` is a regexp, else `false`.
		     * @example
		     *
		     * _.isRegExp(/abc/);
		     * // => true
		     *
		     * _.isRegExp('/abc/');
		     * // => false
		     */
		    var isRegExp = nodeIsRegExp ? baseUnary(nodeIsRegExp) : baseIsRegExp;

		    /**
		     * Checks if `value` is a safe integer. An integer is safe if it's an IEEE-754
		     * double precision number which isn't the result of a rounded unsafe integer.
		     *
		     * **Note:** This method is based on
		     * [`Number.isSafeInteger`](https://mdn.io/Number/isSafeInteger).
		     *
		     * @static
		     * @memberOf _
		     * @since 4.0.0
		     * @category Lang
		     * @param {*} value The value to check.
		     * @returns {boolean} Returns `true` if `value` is a safe integer, else `false`.
		     * @example
		     *
		     * _.isSafeInteger(3);
		     * // => true
		     *
		     * _.isSafeInteger(Number.MIN_VALUE);
		     * // => false
		     *
		     * _.isSafeInteger(Infinity);
		     * // => false
		     *
		     * _.isSafeInteger('3');
		     * // => false
		     */
		    function isSafeInteger(value) {
		      return isInteger(value) && value >= -MAX_SAFE_INTEGER && value <= MAX_SAFE_INTEGER;
		    }

		    /**
		     * Checks if `value` is classified as a `Set` object.
		     *
		     * @static
		     * @memberOf _
		     * @since 4.3.0
		     * @category Lang
		     * @param {*} value The value to check.
		     * @returns {boolean} Returns `true` if `value` is a set, else `false`.
		     * @example
		     *
		     * _.isSet(new Set);
		     * // => true
		     *
		     * _.isSet(new WeakSet);
		     * // => false
		     */
		    var isSet = nodeIsSet ? baseUnary(nodeIsSet) : baseIsSet;

		    /**
		     * Checks if `value` is classified as a `String` primitive or object.
		     *
		     * @static
		     * @since 0.1.0
		     * @memberOf _
		     * @category Lang
		     * @param {*} value The value to check.
		     * @returns {boolean} Returns `true` if `value` is a string, else `false`.
		     * @example
		     *
		     * _.isString('abc');
		     * // => true
		     *
		     * _.isString(1);
		     * // => false
		     */
		    function isString(value) {
		      return typeof value == 'string' ||
		        (!isArray(value) && isObjectLike(value) && baseGetTag(value) == stringTag);
		    }

		    /**
		     * Checks if `value` is classified as a `Symbol` primitive or object.
		     *
		     * @static
		     * @memberOf _
		     * @since 4.0.0
		     * @category Lang
		     * @param {*} value The value to check.
		     * @returns {boolean} Returns `true` if `value` is a symbol, else `false`.
		     * @example
		     *
		     * _.isSymbol(Symbol.iterator);
		     * // => true
		     *
		     * _.isSymbol('abc');
		     * // => false
		     */
		    function isSymbol(value) {
		      return typeof value == 'symbol' ||
		        (isObjectLike(value) && baseGetTag(value) == symbolTag);
		    }

		    /**
		     * Checks if `value` is classified as a typed array.
		     *
		     * @static
		     * @memberOf _
		     * @since 3.0.0
		     * @category Lang
		     * @param {*} value The value to check.
		     * @returns {boolean} Returns `true` if `value` is a typed array, else `false`.
		     * @example
		     *
		     * _.isTypedArray(new Uint8Array);
		     * // => true
		     *
		     * _.isTypedArray([]);
		     * // => false
		     */
		    var isTypedArray = nodeIsTypedArray ? baseUnary(nodeIsTypedArray) : baseIsTypedArray;

		    /**
		     * Checks if `value` is `undefined`.
		     *
		     * @static
		     * @since 0.1.0
		     * @memberOf _
		     * @category Lang
		     * @param {*} value The value to check.
		     * @returns {boolean} Returns `true` if `value` is `undefined`, else `false`.
		     * @example
		     *
		     * _.isUndefined(void 0);
		     * // => true
		     *
		     * _.isUndefined(null);
		     * // => false
		     */
		    function isUndefined(value) {
		      return value === undefined$1;
		    }

		    /**
		     * Checks if `value` is classified as a `WeakMap` object.
		     *
		     * @static
		     * @memberOf _
		     * @since 4.3.0
		     * @category Lang
		     * @param {*} value The value to check.
		     * @returns {boolean} Returns `true` if `value` is a weak map, else `false`.
		     * @example
		     *
		     * _.isWeakMap(new WeakMap);
		     * // => true
		     *
		     * _.isWeakMap(new Map);
		     * // => false
		     */
		    function isWeakMap(value) {
		      return isObjectLike(value) && getTag(value) == weakMapTag;
		    }

		    /**
		     * Checks if `value` is classified as a `WeakSet` object.
		     *
		     * @static
		     * @memberOf _
		     * @since 4.3.0
		     * @category Lang
		     * @param {*} value The value to check.
		     * @returns {boolean} Returns `true` if `value` is a weak set, else `false`.
		     * @example
		     *
		     * _.isWeakSet(new WeakSet);
		     * // => true
		     *
		     * _.isWeakSet(new Set);
		     * // => false
		     */
		    function isWeakSet(value) {
		      return isObjectLike(value) && baseGetTag(value) == weakSetTag;
		    }

		    /**
		     * Checks if `value` is less than `other`.
		     *
		     * @static
		     * @memberOf _
		     * @since 3.9.0
		     * @category Lang
		     * @param {*} value The value to compare.
		     * @param {*} other The other value to compare.
		     * @returns {boolean} Returns `true` if `value` is less than `other`,
		     *  else `false`.
		     * @see _.gt
		     * @example
		     *
		     * _.lt(1, 3);
		     * // => true
		     *
		     * _.lt(3, 3);
		     * // => false
		     *
		     * _.lt(3, 1);
		     * // => false
		     */
		    var lt = createRelationalOperation(baseLt);

		    /**
		     * Checks if `value` is less than or equal to `other`.
		     *
		     * @static
		     * @memberOf _
		     * @since 3.9.0
		     * @category Lang
		     * @param {*} value The value to compare.
		     * @param {*} other The other value to compare.
		     * @returns {boolean} Returns `true` if `value` is less than or equal to
		     *  `other`, else `false`.
		     * @see _.gte
		     * @example
		     *
		     * _.lte(1, 3);
		     * // => true
		     *
		     * _.lte(3, 3);
		     * // => true
		     *
		     * _.lte(3, 1);
		     * // => false
		     */
		    var lte = createRelationalOperation(function(value, other) {
		      return value <= other;
		    });

		    /**
		     * Converts `value` to an array.
		     *
		     * @static
		     * @since 0.1.0
		     * @memberOf _
		     * @category Lang
		     * @param {*} value The value to convert.
		     * @returns {Array} Returns the converted array.
		     * @example
		     *
		     * _.toArray({ 'a': 1, 'b': 2 });
		     * // => [1, 2]
		     *
		     * _.toArray('abc');
		     * // => ['a', 'b', 'c']
		     *
		     * _.toArray(1);
		     * // => []
		     *
		     * _.toArray(null);
		     * // => []
		     */
		    function toArray(value) {
		      if (!value) {
		        return [];
		      }
		      if (isArrayLike(value)) {
		        return isString(value) ? stringToArray(value) : copyArray(value);
		      }
		      if (symIterator && value[symIterator]) {
		        return iteratorToArray(value[symIterator]());
		      }
		      var tag = getTag(value),
		          func = tag == mapTag ? mapToArray : (tag == setTag ? setToArray : values);

		      return func(value);
		    }

		    /**
		     * Converts `value` to a finite number.
		     *
		     * @static
		     * @memberOf _
		     * @since 4.12.0
		     * @category Lang
		     * @param {*} value The value to convert.
		     * @returns {number} Returns the converted number.
		     * @example
		     *
		     * _.toFinite(3.2);
		     * // => 3.2
		     *
		     * _.toFinite(Number.MIN_VALUE);
		     * // => 5e-324
		     *
		     * _.toFinite(Infinity);
		     * // => 1.7976931348623157e+308
		     *
		     * _.toFinite('3.2');
		     * // => 3.2
		     */
		    function toFinite(value) {
		      if (!value) {
		        return value === 0 ? value : 0;
		      }
		      value = toNumber(value);
		      if (value === INFINITY || value === -INFINITY) {
		        var sign = (value < 0 ? -1 : 1);
		        return sign * MAX_INTEGER;
		      }
		      return value === value ? value : 0;
		    }

		    /**
		     * Converts `value` to an integer.
		     *
		     * **Note:** This method is loosely based on
		     * [`ToInteger`](http://www.ecma-international.org/ecma-262/7.0/#sec-tointeger).
		     *
		     * @static
		     * @memberOf _
		     * @since 4.0.0
		     * @category Lang
		     * @param {*} value The value to convert.
		     * @returns {number} Returns the converted integer.
		     * @example
		     *
		     * _.toInteger(3.2);
		     * // => 3
		     *
		     * _.toInteger(Number.MIN_VALUE);
		     * // => 0
		     *
		     * _.toInteger(Infinity);
		     * // => 1.7976931348623157e+308
		     *
		     * _.toInteger('3.2');
		     * // => 3
		     */
		    function toInteger(value) {
		      var result = toFinite(value),
		          remainder = result % 1;

		      return result === result ? (remainder ? result - remainder : result) : 0;
		    }

		    /**
		     * Converts `value` to an integer suitable for use as the length of an
		     * array-like object.
		     *
		     * **Note:** This method is based on
		     * [`ToLength`](http://ecma-international.org/ecma-262/7.0/#sec-tolength).
		     *
		     * @static
		     * @memberOf _
		     * @since 4.0.0
		     * @category Lang
		     * @param {*} value The value to convert.
		     * @returns {number} Returns the converted integer.
		     * @example
		     *
		     * _.toLength(3.2);
		     * // => 3
		     *
		     * _.toLength(Number.MIN_VALUE);
		     * // => 0
		     *
		     * _.toLength(Infinity);
		     * // => 4294967295
		     *
		     * _.toLength('3.2');
		     * // => 3
		     */
		    function toLength(value) {
		      return value ? baseClamp(toInteger(value), 0, MAX_ARRAY_LENGTH) : 0;
		    }

		    /**
		     * Converts `value` to a number.
		     *
		     * @static
		     * @memberOf _
		     * @since 4.0.0
		     * @category Lang
		     * @param {*} value The value to process.
		     * @returns {number} Returns the number.
		     * @example
		     *
		     * _.toNumber(3.2);
		     * // => 3.2
		     *
		     * _.toNumber(Number.MIN_VALUE);
		     * // => 5e-324
		     *
		     * _.toNumber(Infinity);
		     * // => Infinity
		     *
		     * _.toNumber('3.2');
		     * // => 3.2
		     */
		    function toNumber(value) {
		      if (typeof value == 'number') {
		        return value;
		      }
		      if (isSymbol(value)) {
		        return NAN;
		      }
		      if (isObject(value)) {
		        var other = typeof value.valueOf == 'function' ? value.valueOf() : value;
		        value = isObject(other) ? (other + '') : other;
		      }
		      if (typeof value != 'string') {
		        return value === 0 ? value : +value;
		      }
		      value = baseTrim(value);
		      var isBinary = reIsBinary.test(value);
		      return (isBinary || reIsOctal.test(value))
		        ? freeParseInt(value.slice(2), isBinary ? 2 : 8)
		        : (reIsBadHex.test(value) ? NAN : +value);
		    }

		    /**
		     * Converts `value` to a plain object flattening inherited enumerable string
		     * keyed properties of `value` to own properties of the plain object.
		     *
		     * @static
		     * @memberOf _
		     * @since 3.0.0
		     * @category Lang
		     * @param {*} value The value to convert.
		     * @returns {Object} Returns the converted plain object.
		     * @example
		     *
		     * function Foo() {
		     *   this.b = 2;
		     * }
		     *
		     * Foo.prototype.c = 3;
		     *
		     * _.assign({ 'a': 1 }, new Foo);
		     * // => { 'a': 1, 'b': 2 }
		     *
		     * _.assign({ 'a': 1 }, _.toPlainObject(new Foo));
		     * // => { 'a': 1, 'b': 2, 'c': 3 }
		     */
		    function toPlainObject(value) {
		      return copyObject(value, keysIn(value));
		    }

		    /**
		     * Converts `value` to a safe integer. A safe integer can be compared and
		     * represented correctly.
		     *
		     * @static
		     * @memberOf _
		     * @since 4.0.0
		     * @category Lang
		     * @param {*} value The value to convert.
		     * @returns {number} Returns the converted integer.
		     * @example
		     *
		     * _.toSafeInteger(3.2);
		     * // => 3
		     *
		     * _.toSafeInteger(Number.MIN_VALUE);
		     * // => 0
		     *
		     * _.toSafeInteger(Infinity);
		     * // => 9007199254740991
		     *
		     * _.toSafeInteger('3.2');
		     * // => 3
		     */
		    function toSafeInteger(value) {
		      return value
		        ? baseClamp(toInteger(value), -MAX_SAFE_INTEGER, MAX_SAFE_INTEGER)
		        : (value === 0 ? value : 0);
		    }

		    /**
		     * Converts `value` to a string. An empty string is returned for `null`
		     * and `undefined` values. The sign of `-0` is preserved.
		     *
		     * @static
		     * @memberOf _
		     * @since 4.0.0
		     * @category Lang
		     * @param {*} value The value to convert.
		     * @returns {string} Returns the converted string.
		     * @example
		     *
		     * _.toString(null);
		     * // => ''
		     *
		     * _.toString(-0);
		     * // => '-0'
		     *
		     * _.toString([1, 2, 3]);
		     * // => '1,2,3'
		     */
		    function toString(value) {
		      return value == null ? '' : baseToString(value);
		    }

		    /*------------------------------------------------------------------------*/

		    /**
		     * Assigns own enumerable string keyed properties of source objects to the
		     * destination object. Source objects are applied from left to right.
		     * Subsequent sources overwrite property assignments of previous sources.
		     *
		     * **Note:** This method mutates `object` and is loosely based on
		     * [`Object.assign`](https://mdn.io/Object/assign).
		     *
		     * @static
		     * @memberOf _
		     * @since 0.10.0
		     * @category Object
		     * @param {Object} object The destination object.
		     * @param {...Object} [sources] The source objects.
		     * @returns {Object} Returns `object`.
		     * @see _.assignIn
		     * @example
		     *
		     * function Foo() {
		     *   this.a = 1;
		     * }
		     *
		     * function Bar() {
		     *   this.c = 3;
		     * }
		     *
		     * Foo.prototype.b = 2;
		     * Bar.prototype.d = 4;
		     *
		     * _.assign({ 'a': 0 }, new Foo, new Bar);
		     * // => { 'a': 1, 'c': 3 }
		     */
		    var assign = createAssigner(function(object, source) {
		      if (isPrototype(source) || isArrayLike(source)) {
		        copyObject(source, keys(source), object);
		        return;
		      }
		      for (var key in source) {
		        if (hasOwnProperty.call(source, key)) {
		          assignValue(object, key, source[key]);
		        }
		      }
		    });

		    /**
		     * This method is like `_.assign` except that it iterates over own and
		     * inherited source properties.
		     *
		     * **Note:** This method mutates `object`.
		     *
		     * @static
		     * @memberOf _
		     * @since 4.0.0
		     * @alias extend
		     * @category Object
		     * @param {Object} object The destination object.
		     * @param {...Object} [sources] The source objects.
		     * @returns {Object} Returns `object`.
		     * @see _.assign
		     * @example
		     *
		     * function Foo() {
		     *   this.a = 1;
		     * }
		     *
		     * function Bar() {
		     *   this.c = 3;
		     * }
		     *
		     * Foo.prototype.b = 2;
		     * Bar.prototype.d = 4;
		     *
		     * _.assignIn({ 'a': 0 }, new Foo, new Bar);
		     * // => { 'a': 1, 'b': 2, 'c': 3, 'd': 4 }
		     */
		    var assignIn = createAssigner(function(object, source) {
		      copyObject(source, keysIn(source), object);
		    });

		    /**
		     * This method is like `_.assignIn` except that it accepts `customizer`
		     * which is invoked to produce the assigned values. If `customizer` returns
		     * `undefined`, assignment is handled by the method instead. The `customizer`
		     * is invoked with five arguments: (objValue, srcValue, key, object, source).
		     *
		     * **Note:** This method mutates `object`.
		     *
		     * @static
		     * @memberOf _
		     * @since 4.0.0
		     * @alias extendWith
		     * @category Object
		     * @param {Object} object The destination object.
		     * @param {...Object} sources The source objects.
		     * @param {Function} [customizer] The function to customize assigned values.
		     * @returns {Object} Returns `object`.
		     * @see _.assignWith
		     * @example
		     *
		     * function customizer(objValue, srcValue) {
		     *   return _.isUndefined(objValue) ? srcValue : objValue;
		     * }
		     *
		     * var defaults = _.partialRight(_.assignInWith, customizer);
		     *
		     * defaults({ 'a': 1 }, { 'b': 2 }, { 'a': 3 });
		     * // => { 'a': 1, 'b': 2 }
		     */
		    var assignInWith = createAssigner(function(object, source, srcIndex, customizer) {
		      copyObject(source, keysIn(source), object, customizer);
		    });

		    /**
		     * This method is like `_.assign` except that it accepts `customizer`
		     * which is invoked to produce the assigned values. If `customizer` returns
		     * `undefined`, assignment is handled by the method instead. The `customizer`
		     * is invoked with five arguments: (objValue, srcValue, key, object, source).
		     *
		     * **Note:** This method mutates `object`.
		     *
		     * @static
		     * @memberOf _
		     * @since 4.0.0
		     * @category Object
		     * @param {Object} object The destination object.
		     * @param {...Object} sources The source objects.
		     * @param {Function} [customizer] The function to customize assigned values.
		     * @returns {Object} Returns `object`.
		     * @see _.assignInWith
		     * @example
		     *
		     * function customizer(objValue, srcValue) {
		     *   return _.isUndefined(objValue) ? srcValue : objValue;
		     * }
		     *
		     * var defaults = _.partialRight(_.assignWith, customizer);
		     *
		     * defaults({ 'a': 1 }, { 'b': 2 }, { 'a': 3 });
		     * // => { 'a': 1, 'b': 2 }
		     */
		    var assignWith = createAssigner(function(object, source, srcIndex, customizer) {
		      copyObject(source, keys(source), object, customizer);
		    });

		    /**
		     * Creates an array of values corresponding to `paths` of `object`.
		     *
		     * @static
		     * @memberOf _
		     * @since 1.0.0
		     * @category Object
		     * @param {Object} object The object to iterate over.
		     * @param {...(string|string[])} [paths] The property paths to pick.
		     * @returns {Array} Returns the picked values.
		     * @example
		     *
		     * var object = { 'a': [{ 'b': { 'c': 3 } }, 4] };
		     *
		     * _.at(object, ['a[0].b.c', 'a[1]']);
		     * // => [3, 4]
		     */
		    var at = flatRest(baseAt);

		    /**
		     * Creates an object that inherits from the `prototype` object. If a
		     * `properties` object is given, its own enumerable string keyed properties
		     * are assigned to the created object.
		     *
		     * @static
		     * @memberOf _
		     * @since 2.3.0
		     * @category Object
		     * @param {Object} prototype The object to inherit from.
		     * @param {Object} [properties] The properties to assign to the object.
		     * @returns {Object} Returns the new object.
		     * @example
		     *
		     * function Shape() {
		     *   this.x = 0;
		     *   this.y = 0;
		     * }
		     *
		     * function Circle() {
		     *   Shape.call(this);
		     * }
		     *
		     * Circle.prototype = _.create(Shape.prototype, {
		     *   'constructor': Circle
		     * });
		     *
		     * var circle = new Circle;
		     * circle instanceof Circle;
		     * // => true
		     *
		     * circle instanceof Shape;
		     * // => true
		     */
		    function create(prototype, properties) {
		      var result = baseCreate(prototype);
		      return properties == null ? result : baseAssign(result, properties);
		    }

		    /**
		     * Assigns own and inherited enumerable string keyed properties of source
		     * objects to the destination object for all destination properties that
		     * resolve to `undefined`. Source objects are applied from left to right.
		     * Once a property is set, additional values of the same property are ignored.
		     *
		     * **Note:** This method mutates `object`.
		     *
		     * @static
		     * @since 0.1.0
		     * @memberOf _
		     * @category Object
		     * @param {Object} object The destination object.
		     * @param {...Object} [sources] The source objects.
		     * @returns {Object} Returns `object`.
		     * @see _.defaultsDeep
		     * @example
		     *
		     * _.defaults({ 'a': 1 }, { 'b': 2 }, { 'a': 3 });
		     * // => { 'a': 1, 'b': 2 }
		     */
		    var defaults = baseRest(function(object, sources) {
		      object = Object(object);

		      var index = -1;
		      var length = sources.length;
		      var guard = length > 2 ? sources[2] : undefined$1;

		      if (guard && isIterateeCall(sources[0], sources[1], guard)) {
		        length = 1;
		      }

		      while (++index < length) {
		        var source = sources[index];
		        var props = keysIn(source);
		        var propsIndex = -1;
		        var propsLength = props.length;

		        while (++propsIndex < propsLength) {
		          var key = props[propsIndex];
		          var value = object[key];

		          if (value === undefined$1 ||
		              (eq(value, objectProto[key]) && !hasOwnProperty.call(object, key))) {
		            object[key] = source[key];
		          }
		        }
		      }

		      return object;
		    });

		    /**
		     * This method is like `_.defaults` except that it recursively assigns
		     * default properties.
		     *
		     * **Note:** This method mutates `object`.
		     *
		     * @static
		     * @memberOf _
		     * @since 3.10.0
		     * @category Object
		     * @param {Object} object The destination object.
		     * @param {...Object} [sources] The source objects.
		     * @returns {Object} Returns `object`.
		     * @see _.defaults
		     * @example
		     *
		     * _.defaultsDeep({ 'a': { 'b': 2 } }, { 'a': { 'b': 1, 'c': 3 } });
		     * // => { 'a': { 'b': 2, 'c': 3 } }
		     */
		    var defaultsDeep = baseRest(function(args) {
		      args.push(undefined$1, customDefaultsMerge);
		      return apply(mergeWith, undefined$1, args);
		    });

		    /**
		     * This method is like `_.find` except that it returns the key of the first
		     * element `predicate` returns truthy for instead of the element itself.
		     *
		     * @static
		     * @memberOf _
		     * @since 1.1.0
		     * @category Object
		     * @param {Object} object The object to inspect.
		     * @param {Function} [predicate=_.identity] The function invoked per iteration.
		     * @returns {string|undefined} Returns the key of the matched element,
		     *  else `undefined`.
		     * @example
		     *
		     * var users = {
		     *   'barney':  { 'age': 36, 'active': true },
		     *   'fred':    { 'age': 40, 'active': false },
		     *   'pebbles': { 'age': 1,  'active': true }
		     * };
		     *
		     * _.findKey(users, function(o) { return o.age < 40; });
		     * // => 'barney' (iteration order is not guaranteed)
		     *
		     * // The `_.matches` iteratee shorthand.
		     * _.findKey(users, { 'age': 1, 'active': true });
		     * // => 'pebbles'
		     *
		     * // The `_.matchesProperty` iteratee shorthand.
		     * _.findKey(users, ['active', false]);
		     * // => 'fred'
		     *
		     * // The `_.property` iteratee shorthand.
		     * _.findKey(users, 'active');
		     * // => 'barney'
		     */
		    function findKey(object, predicate) {
		      return baseFindKey(object, getIteratee(predicate, 3), baseForOwn);
		    }

		    /**
		     * This method is like `_.findKey` except that it iterates over elements of
		     * a collection in the opposite order.
		     *
		     * @static
		     * @memberOf _
		     * @since 2.0.0
		     * @category Object
		     * @param {Object} object The object to inspect.
		     * @param {Function} [predicate=_.identity] The function invoked per iteration.
		     * @returns {string|undefined} Returns the key of the matched element,
		     *  else `undefined`.
		     * @example
		     *
		     * var users = {
		     *   'barney':  { 'age': 36, 'active': true },
		     *   'fred':    { 'age': 40, 'active': false },
		     *   'pebbles': { 'age': 1,  'active': true }
		     * };
		     *
		     * _.findLastKey(users, function(o) { return o.age < 40; });
		     * // => returns 'pebbles' assuming `_.findKey` returns 'barney'
		     *
		     * // The `_.matches` iteratee shorthand.
		     * _.findLastKey(users, { 'age': 36, 'active': true });
		     * // => 'barney'
		     *
		     * // The `_.matchesProperty` iteratee shorthand.
		     * _.findLastKey(users, ['active', false]);
		     * // => 'fred'
		     *
		     * // The `_.property` iteratee shorthand.
		     * _.findLastKey(users, 'active');
		     * // => 'pebbles'
		     */
		    function findLastKey(object, predicate) {
		      return baseFindKey(object, getIteratee(predicate, 3), baseForOwnRight);
		    }

		    /**
		     * Iterates over own and inherited enumerable string keyed properties of an
		     * object and invokes `iteratee` for each property. The iteratee is invoked
		     * with three arguments: (value, key, object). Iteratee functions may exit
		     * iteration early by explicitly returning `false`.
		     *
		     * @static
		     * @memberOf _
		     * @since 0.3.0
		     * @category Object
		     * @param {Object} object The object to iterate over.
		     * @param {Function} [iteratee=_.identity] The function invoked per iteration.
		     * @returns {Object} Returns `object`.
		     * @see _.forInRight
		     * @example
		     *
		     * function Foo() {
		     *   this.a = 1;
		     *   this.b = 2;
		     * }
		     *
		     * Foo.prototype.c = 3;
		     *
		     * _.forIn(new Foo, function(value, key) {
		     *   console.log(key);
		     * });
		     * // => Logs 'a', 'b', then 'c' (iteration order is not guaranteed).
		     */
		    function forIn(object, iteratee) {
		      return object == null
		        ? object
		        : baseFor(object, getIteratee(iteratee, 3), keysIn);
		    }

		    /**
		     * This method is like `_.forIn` except that it iterates over properties of
		     * `object` in the opposite order.
		     *
		     * @static
		     * @memberOf _
		     * @since 2.0.0
		     * @category Object
		     * @param {Object} object The object to iterate over.
		     * @param {Function} [iteratee=_.identity] The function invoked per iteration.
		     * @returns {Object} Returns `object`.
		     * @see _.forIn
		     * @example
		     *
		     * function Foo() {
		     *   this.a = 1;
		     *   this.b = 2;
		     * }
		     *
		     * Foo.prototype.c = 3;
		     *
		     * _.forInRight(new Foo, function(value, key) {
		     *   console.log(key);
		     * });
		     * // => Logs 'c', 'b', then 'a' assuming `_.forIn` logs 'a', 'b', then 'c'.
		     */
		    function forInRight(object, iteratee) {
		      return object == null
		        ? object
		        : baseForRight(object, getIteratee(iteratee, 3), keysIn);
		    }

		    /**
		     * Iterates over own enumerable string keyed properties of an object and
		     * invokes `iteratee` for each property. The iteratee is invoked with three
		     * arguments: (value, key, object). Iteratee functions may exit iteration
		     * early by explicitly returning `false`.
		     *
		     * @static
		     * @memberOf _
		     * @since 0.3.0
		     * @category Object
		     * @param {Object} object The object to iterate over.
		     * @param {Function} [iteratee=_.identity] The function invoked per iteration.
		     * @returns {Object} Returns `object`.
		     * @see _.forOwnRight
		     * @example
		     *
		     * function Foo() {
		     *   this.a = 1;
		     *   this.b = 2;
		     * }
		     *
		     * Foo.prototype.c = 3;
		     *
		     * _.forOwn(new Foo, function(value, key) {
		     *   console.log(key);
		     * });
		     * // => Logs 'a' then 'b' (iteration order is not guaranteed).
		     */
		    function forOwn(object, iteratee) {
		      return object && baseForOwn(object, getIteratee(iteratee, 3));
		    }

		    /**
		     * This method is like `_.forOwn` except that it iterates over properties of
		     * `object` in the opposite order.
		     *
		     * @static
		     * @memberOf _
		     * @since 2.0.0
		     * @category Object
		     * @param {Object} object The object to iterate over.
		     * @param {Function} [iteratee=_.identity] The function invoked per iteration.
		     * @returns {Object} Returns `object`.
		     * @see _.forOwn
		     * @example
		     *
		     * function Foo() {
		     *   this.a = 1;
		     *   this.b = 2;
		     * }
		     *
		     * Foo.prototype.c = 3;
		     *
		     * _.forOwnRight(new Foo, function(value, key) {
		     *   console.log(key);
		     * });
		     * // => Logs 'b' then 'a' assuming `_.forOwn` logs 'a' then 'b'.
		     */
		    function forOwnRight(object, iteratee) {
		      return object && baseForOwnRight(object, getIteratee(iteratee, 3));
		    }

		    /**
		     * Creates an array of function property names from own enumerable properties
		     * of `object`.
		     *
		     * @static
		     * @since 0.1.0
		     * @memberOf _
		     * @category Object
		     * @param {Object} object The object to inspect.
		     * @returns {Array} Returns the function names.
		     * @see _.functionsIn
		     * @example
		     *
		     * function Foo() {
		     *   this.a = _.constant('a');
		     *   this.b = _.constant('b');
		     * }
		     *
		     * Foo.prototype.c = _.constant('c');
		     *
		     * _.functions(new Foo);
		     * // => ['a', 'b']
		     */
		    function functions(object) {
		      return object == null ? [] : baseFunctions(object, keys(object));
		    }

		    /**
		     * Creates an array of function property names from own and inherited
		     * enumerable properties of `object`.
		     *
		     * @static
		     * @memberOf _
		     * @since 4.0.0
		     * @category Object
		     * @param {Object} object The object to inspect.
		     * @returns {Array} Returns the function names.
		     * @see _.functions
		     * @example
		     *
		     * function Foo() {
		     *   this.a = _.constant('a');
		     *   this.b = _.constant('b');
		     * }
		     *
		     * Foo.prototype.c = _.constant('c');
		     *
		     * _.functionsIn(new Foo);
		     * // => ['a', 'b', 'c']
		     */
		    function functionsIn(object) {
		      return object == null ? [] : baseFunctions(object, keysIn(object));
		    }

		    /**
		     * Gets the value at `path` of `object`. If the resolved value is
		     * `undefined`, the `defaultValue` is returned in its place.
		     *
		     * @static
		     * @memberOf _
		     * @since 3.7.0
		     * @category Object
		     * @param {Object} object The object to query.
		     * @param {Array|string} path The path of the property to get.
		     * @param {*} [defaultValue] The value returned for `undefined` resolved values.
		     * @returns {*} Returns the resolved value.
		     * @example
		     *
		     * var object = { 'a': [{ 'b': { 'c': 3 } }] };
		     *
		     * _.get(object, 'a[0].b.c');
		     * // => 3
		     *
		     * _.get(object, ['a', '0', 'b', 'c']);
		     * // => 3
		     *
		     * _.get(object, 'a.b.c', 'default');
		     * // => 'default'
		     */
		    function get(object, path, defaultValue) {
		      var result = object == null ? undefined$1 : baseGet(object, path);
		      return result === undefined$1 ? defaultValue : result;
		    }

		    /**
		     * Checks if `path` is a direct property of `object`.
		     *
		     * @static
		     * @since 0.1.0
		     * @memberOf _
		     * @category Object
		     * @param {Object} object The object to query.
		     * @param {Array|string} path The path to check.
		     * @returns {boolean} Returns `true` if `path` exists, else `false`.
		     * @example
		     *
		     * var object = { 'a': { 'b': 2 } };
		     * var other = _.create({ 'a': _.create({ 'b': 2 }) });
		     *
		     * _.has(object, 'a');
		     * // => true
		     *
		     * _.has(object, 'a.b');
		     * // => true
		     *
		     * _.has(object, ['a', 'b']);
		     * // => true
		     *
		     * _.has(other, 'a');
		     * // => false
		     */
		    function has(object, path) {
		      return object != null && hasPath(object, path, baseHas);
		    }

		    /**
		     * Checks if `path` is a direct or inherited property of `object`.
		     *
		     * @static
		     * @memberOf _
		     * @since 4.0.0
		     * @category Object
		     * @param {Object} object The object to query.
		     * @param {Array|string} path The path to check.
		     * @returns {boolean} Returns `true` if `path` exists, else `false`.
		     * @example
		     *
		     * var object = _.create({ 'a': _.create({ 'b': 2 }) });
		     *
		     * _.hasIn(object, 'a');
		     * // => true
		     *
		     * _.hasIn(object, 'a.b');
		     * // => true
		     *
		     * _.hasIn(object, ['a', 'b']);
		     * // => true
		     *
		     * _.hasIn(object, 'b');
		     * // => false
		     */
		    function hasIn(object, path) {
		      return object != null && hasPath(object, path, baseHasIn);
		    }

		    /**
		     * Creates an object composed of the inverted keys and values of `object`.
		     * If `object` contains duplicate values, subsequent values overwrite
		     * property assignments of previous values.
		     *
		     * @static
		     * @memberOf _
		     * @since 0.7.0
		     * @category Object
		     * @param {Object} object The object to invert.
		     * @returns {Object} Returns the new inverted object.
		     * @example
		     *
		     * var object = { 'a': 1, 'b': 2, 'c': 1 };
		     *
		     * _.invert(object);
		     * // => { '1': 'c', '2': 'b' }
		     */
		    var invert = createInverter(function(result, value, key) {
		      if (value != null &&
		          typeof value.toString != 'function') {
		        value = nativeObjectToString.call(value);
		      }

		      result[value] = key;
		    }, constant(identity));

		    /**
		     * This method is like `_.invert` except that the inverted object is generated
		     * from the results of running each element of `object` thru `iteratee`. The
		     * corresponding inverted value of each inverted key is an array of keys
		     * responsible for generating the inverted value. The iteratee is invoked
		     * with one argument: (value).
		     *
		     * @static
		     * @memberOf _
		     * @since 4.1.0
		     * @category Object
		     * @param {Object} object The object to invert.
		     * @param {Function} [iteratee=_.identity] The iteratee invoked per element.
		     * @returns {Object} Returns the new inverted object.
		     * @example
		     *
		     * var object = { 'a': 1, 'b': 2, 'c': 1 };
		     *
		     * _.invertBy(object);
		     * // => { '1': ['a', 'c'], '2': ['b'] }
		     *
		     * _.invertBy(object, function(value) {
		     *   return 'group' + value;
		     * });
		     * // => { 'group1': ['a', 'c'], 'group2': ['b'] }
		     */
		    var invertBy = createInverter(function(result, value, key) {
		      if (value != null &&
		          typeof value.toString != 'function') {
		        value = nativeObjectToString.call(value);
		      }

		      if (hasOwnProperty.call(result, value)) {
		        result[value].push(key);
		      } else {
		        result[value] = [key];
		      }
		    }, getIteratee);

		    /**
		     * Invokes the method at `path` of `object`.
		     *
		     * @static
		     * @memberOf _
		     * @since 4.0.0
		     * @category Object
		     * @param {Object} object The object to query.
		     * @param {Array|string} path The path of the method to invoke.
		     * @param {...*} [args] The arguments to invoke the method with.
		     * @returns {*} Returns the result of the invoked method.
		     * @example
		     *
		     * var object = { 'a': [{ 'b': { 'c': [1, 2, 3, 4] } }] };
		     *
		     * _.invoke(object, 'a[0].b.c.slice', 1, 3);
		     * // => [2, 3]
		     */
		    var invoke = baseRest(baseInvoke);

		    /**
		     * Creates an array of the own enumerable property names of `object`.
		     *
		     * **Note:** Non-object values are coerced to objects. See the
		     * [ES spec](http://ecma-international.org/ecma-262/7.0/#sec-object.keys)
		     * for more details.
		     *
		     * @static
		     * @since 0.1.0
		     * @memberOf _
		     * @category Object
		     * @param {Object} object The object to query.
		     * @returns {Array} Returns the array of property names.
		     * @example
		     *
		     * function Foo() {
		     *   this.a = 1;
		     *   this.b = 2;
		     * }
		     *
		     * Foo.prototype.c = 3;
		     *
		     * _.keys(new Foo);
		     * // => ['a', 'b'] (iteration order is not guaranteed)
		     *
		     * _.keys('hi');
		     * // => ['0', '1']
		     */
		    function keys(object) {
		      return isArrayLike(object) ? arrayLikeKeys(object) : baseKeys(object);
		    }

		    /**
		     * Creates an array of the own and inherited enumerable property names of `object`.
		     *
		     * **Note:** Non-object values are coerced to objects.
		     *
		     * @static
		     * @memberOf _
		     * @since 3.0.0
		     * @category Object
		     * @param {Object} object The object to query.
		     * @returns {Array} Returns the array of property names.
		     * @example
		     *
		     * function Foo() {
		     *   this.a = 1;
		     *   this.b = 2;
		     * }
		     *
		     * Foo.prototype.c = 3;
		     *
		     * _.keysIn(new Foo);
		     * // => ['a', 'b', 'c'] (iteration order is not guaranteed)
		     */
		    function keysIn(object) {
		      return isArrayLike(object) ? arrayLikeKeys(object, true) : baseKeysIn(object);
		    }

		    /**
		     * The opposite of `_.mapValues`; this method creates an object with the
		     * same values as `object` and keys generated by running each own enumerable
		     * string keyed property of `object` thru `iteratee`. The iteratee is invoked
		     * with three arguments: (value, key, object).
		     *
		     * @static
		     * @memberOf _
		     * @since 3.8.0
		     * @category Object
		     * @param {Object} object The object to iterate over.
		     * @param {Function} [iteratee=_.identity] The function invoked per iteration.
		     * @returns {Object} Returns the new mapped object.
		     * @see _.mapValues
		     * @example
		     *
		     * _.mapKeys({ 'a': 1, 'b': 2 }, function(value, key) {
		     *   return key + value;
		     * });
		     * // => { 'a1': 1, 'b2': 2 }
		     */
		    function mapKeys(object, iteratee) {
		      var result = {};
		      iteratee = getIteratee(iteratee, 3);

		      baseForOwn(object, function(value, key, object) {
		        baseAssignValue(result, iteratee(value, key, object), value);
		      });
		      return result;
		    }

		    /**
		     * Creates an object with the same keys as `object` and values generated
		     * by running each own enumerable string keyed property of `object` thru
		     * `iteratee`. The iteratee is invoked with three arguments:
		     * (value, key, object).
		     *
		     * @static
		     * @memberOf _
		     * @since 2.4.0
		     * @category Object
		     * @param {Object} object The object to iterate over.
		     * @param {Function} [iteratee=_.identity] The function invoked per iteration.
		     * @returns {Object} Returns the new mapped object.
		     * @see _.mapKeys
		     * @example
		     *
		     * var users = {
		     *   'fred':    { 'user': 'fred',    'age': 40 },
		     *   'pebbles': { 'user': 'pebbles', 'age': 1 }
		     * };
		     *
		     * _.mapValues(users, function(o) { return o.age; });
		     * // => { 'fred': 40, 'pebbles': 1 } (iteration order is not guaranteed)
		     *
		     * // The `_.property` iteratee shorthand.
		     * _.mapValues(users, 'age');
		     * // => { 'fred': 40, 'pebbles': 1 } (iteration order is not guaranteed)
		     */
		    function mapValues(object, iteratee) {
		      var result = {};
		      iteratee = getIteratee(iteratee, 3);

		      baseForOwn(object, function(value, key, object) {
		        baseAssignValue(result, key, iteratee(value, key, object));
		      });
		      return result;
		    }

		    /**
		     * This method is like `_.assign` except that it recursively merges own and
		     * inherited enumerable string keyed properties of source objects into the
		     * destination object. Source properties that resolve to `undefined` are
		     * skipped if a destination value exists. Array and plain object properties
		     * are merged recursively. Other objects and value types are overridden by
		     * assignment. Source objects are applied from left to right. Subsequent
		     * sources overwrite property assignments of previous sources.
		     *
		     * **Note:** This method mutates `object`.
		     *
		     * @static
		     * @memberOf _
		     * @since 0.5.0
		     * @category Object
		     * @param {Object} object The destination object.
		     * @param {...Object} [sources] The source objects.
		     * @returns {Object} Returns `object`.
		     * @example
		     *
		     * var object = {
		     *   'a': [{ 'b': 2 }, { 'd': 4 }]
		     * };
		     *
		     * var other = {
		     *   'a': [{ 'c': 3 }, { 'e': 5 }]
		     * };
		     *
		     * _.merge(object, other);
		     * // => { 'a': [{ 'b': 2, 'c': 3 }, { 'd': 4, 'e': 5 }] }
		     */
		    var merge = createAssigner(function(object, source, srcIndex) {
		      baseMerge(object, source, srcIndex);
		    });

		    /**
		     * This method is like `_.merge` except that it accepts `customizer` which
		     * is invoked to produce the merged values of the destination and source
		     * properties. If `customizer` returns `undefined`, merging is handled by the
		     * method instead. The `customizer` is invoked with six arguments:
		     * (objValue, srcValue, key, object, source, stack).
		     *
		     * **Note:** This method mutates `object`.
		     *
		     * @static
		     * @memberOf _
		     * @since 4.0.0
		     * @category Object
		     * @param {Object} object The destination object.
		     * @param {...Object} sources The source objects.
		     * @param {Function} customizer The function to customize assigned values.
		     * @returns {Object} Returns `object`.
		     * @example
		     *
		     * function customizer(objValue, srcValue) {
		     *   if (_.isArray(objValue)) {
		     *     return objValue.concat(srcValue);
		     *   }
		     * }
		     *
		     * var object = { 'a': [1], 'b': [2] };
		     * var other = { 'a': [3], 'b': [4] };
		     *
		     * _.mergeWith(object, other, customizer);
		     * // => { 'a': [1, 3], 'b': [2, 4] }
		     */
		    var mergeWith = createAssigner(function(object, source, srcIndex, customizer) {
		      baseMerge(object, source, srcIndex, customizer);
		    });

		    /**
		     * The opposite of `_.pick`; this method creates an object composed of the
		     * own and inherited enumerable property paths of `object` that are not omitted.
		     *
		     * **Note:** This method is considerably slower than `_.pick`.
		     *
		     * @static
		     * @since 0.1.0
		     * @memberOf _
		     * @category Object
		     * @param {Object} object The source object.
		     * @param {...(string|string[])} [paths] The property paths to omit.
		     * @returns {Object} Returns the new object.
		     * @example
		     *
		     * var object = { 'a': 1, 'b': '2', 'c': 3 };
		     *
		     * _.omit(object, ['a', 'c']);
		     * // => { 'b': '2' }
		     */
		    var omit = flatRest(function(object, paths) {
		      var result = {};
		      if (object == null) {
		        return result;
		      }
		      var isDeep = false;
		      paths = arrayMap(paths, function(path) {
		        path = castPath(path, object);
		        isDeep || (isDeep = path.length > 1);
		        return path;
		      });
		      copyObject(object, getAllKeysIn(object), result);
		      if (isDeep) {
		        result = baseClone(result, CLONE_DEEP_FLAG | CLONE_FLAT_FLAG | CLONE_SYMBOLS_FLAG, customOmitClone);
		      }
		      var length = paths.length;
		      while (length--) {
		        baseUnset(result, paths[length]);
		      }
		      return result;
		    });

		    /**
		     * The opposite of `_.pickBy`; this method creates an object composed of
		     * the own and inherited enumerable string keyed properties of `object` that
		     * `predicate` doesn't return truthy for. The predicate is invoked with two
		     * arguments: (value, key).
		     *
		     * @static
		     * @memberOf _
		     * @since 4.0.0
		     * @category Object
		     * @param {Object} object The source object.
		     * @param {Function} [predicate=_.identity] The function invoked per property.
		     * @returns {Object} Returns the new object.
		     * @example
		     *
		     * var object = { 'a': 1, 'b': '2', 'c': 3 };
		     *
		     * _.omitBy(object, _.isNumber);
		     * // => { 'b': '2' }
		     */
		    function omitBy(object, predicate) {
		      return pickBy(object, negate(getIteratee(predicate)));
		    }

		    /**
		     * Creates an object composed of the picked `object` properties.
		     *
		     * @static
		     * @since 0.1.0
		     * @memberOf _
		     * @category Object
		     * @param {Object} object The source object.
		     * @param {...(string|string[])} [paths] The property paths to pick.
		     * @returns {Object} Returns the new object.
		     * @example
		     *
		     * var object = { 'a': 1, 'b': '2', 'c': 3 };
		     *
		     * _.pick(object, ['a', 'c']);
		     * // => { 'a': 1, 'c': 3 }
		     */
		    var pick = flatRest(function(object, paths) {
		      return object == null ? {} : basePick(object, paths);
		    });

		    /**
		     * Creates an object composed of the `object` properties `predicate` returns
		     * truthy for. The predicate is invoked with two arguments: (value, key).
		     *
		     * @static
		     * @memberOf _
		     * @since 4.0.0
		     * @category Object
		     * @param {Object} object The source object.
		     * @param {Function} [predicate=_.identity] The function invoked per property.
		     * @returns {Object} Returns the new object.
		     * @example
		     *
		     * var object = { 'a': 1, 'b': '2', 'c': 3 };
		     *
		     * _.pickBy(object, _.isNumber);
		     * // => { 'a': 1, 'c': 3 }
		     */
		    function pickBy(object, predicate) {
		      if (object == null) {
		        return {};
		      }
		      var props = arrayMap(getAllKeysIn(object), function(prop) {
		        return [prop];
		      });
		      predicate = getIteratee(predicate);
		      return basePickBy(object, props, function(value, path) {
		        return predicate(value, path[0]);
		      });
		    }

		    /**
		     * This method is like `_.get` except that if the resolved value is a
		     * function it's invoked with the `this` binding of its parent object and
		     * its result is returned.
		     *
		     * @static
		     * @since 0.1.0
		     * @memberOf _
		     * @category Object
		     * @param {Object} object The object to query.
		     * @param {Array|string} path The path of the property to resolve.
		     * @param {*} [defaultValue] The value returned for `undefined` resolved values.
		     * @returns {*} Returns the resolved value.
		     * @example
		     *
		     * var object = { 'a': [{ 'b': { 'c1': 3, 'c2': _.constant(4) } }] };
		     *
		     * _.result(object, 'a[0].b.c1');
		     * // => 3
		     *
		     * _.result(object, 'a[0].b.c2');
		     * // => 4
		     *
		     * _.result(object, 'a[0].b.c3', 'default');
		     * // => 'default'
		     *
		     * _.result(object, 'a[0].b.c3', _.constant('default'));
		     * // => 'default'
		     */
		    function result(object, path, defaultValue) {
		      path = castPath(path, object);

		      var index = -1,
		          length = path.length;

		      // Ensure the loop is entered when path is empty.
		      if (!length) {
		        length = 1;
		        object = undefined$1;
		      }
		      while (++index < length) {
		        var value = object == null ? undefined$1 : object[toKey(path[index])];
		        if (value === undefined$1) {
		          index = length;
		          value = defaultValue;
		        }
		        object = isFunction(value) ? value.call(object) : value;
		      }
		      return object;
		    }

		    /**
		     * Sets the value at `path` of `object`. If a portion of `path` doesn't exist,
		     * it's created. Arrays are created for missing index properties while objects
		     * are created for all other missing properties. Use `_.setWith` to customize
		     * `path` creation.
		     *
		     * **Note:** This method mutates `object`.
		     *
		     * @static
		     * @memberOf _
		     * @since 3.7.0
		     * @category Object
		     * @param {Object} object The object to modify.
		     * @param {Array|string} path The path of the property to set.
		     * @param {*} value The value to set.
		     * @returns {Object} Returns `object`.
		     * @example
		     *
		     * var object = { 'a': [{ 'b': { 'c': 3 } }] };
		     *
		     * _.set(object, 'a[0].b.c', 4);
		     * console.log(object.a[0].b.c);
		     * // => 4
		     *
		     * _.set(object, ['x', '0', 'y', 'z'], 5);
		     * console.log(object.x[0].y.z);
		     * // => 5
		     */
		    function set(object, path, value) {
		      return object == null ? object : baseSet(object, path, value);
		    }

		    /**
		     * This method is like `_.set` except that it accepts `customizer` which is
		     * invoked to produce the objects of `path`.  If `customizer` returns `undefined`
		     * path creation is handled by the method instead. The `customizer` is invoked
		     * with three arguments: (nsValue, key, nsObject).
		     *
		     * **Note:** This method mutates `object`.
		     *
		     * @static
		     * @memberOf _
		     * @since 4.0.0
		     * @category Object
		     * @param {Object} object The object to modify.
		     * @param {Array|string} path The path of the property to set.
		     * @param {*} value The value to set.
		     * @param {Function} [customizer] The function to customize assigned values.
		     * @returns {Object} Returns `object`.
		     * @example
		     *
		     * var object = {};
		     *
		     * _.setWith(object, '[0][1]', 'a', Object);
		     * // => { '0': { '1': 'a' } }
		     */
		    function setWith(object, path, value, customizer) {
		      customizer = typeof customizer == 'function' ? customizer : undefined$1;
		      return object == null ? object : baseSet(object, path, value, customizer);
		    }

		    /**
		     * Creates an array of own enumerable string keyed-value pairs for `object`
		     * which can be consumed by `_.fromPairs`. If `object` is a map or set, its
		     * entries are returned.
		     *
		     * @static
		     * @memberOf _
		     * @since 4.0.0
		     * @alias entries
		     * @category Object
		     * @param {Object} object The object to query.
		     * @returns {Array} Returns the key-value pairs.
		     * @example
		     *
		     * function Foo() {
		     *   this.a = 1;
		     *   this.b = 2;
		     * }
		     *
		     * Foo.prototype.c = 3;
		     *
		     * _.toPairs(new Foo);
		     * // => [['a', 1], ['b', 2]] (iteration order is not guaranteed)
		     */
		    var toPairs = createToPairs(keys);

		    /**
		     * Creates an array of own and inherited enumerable string keyed-value pairs
		     * for `object` which can be consumed by `_.fromPairs`. If `object` is a map
		     * or set, its entries are returned.
		     *
		     * @static
		     * @memberOf _
		     * @since 4.0.0
		     * @alias entriesIn
		     * @category Object
		     * @param {Object} object The object to query.
		     * @returns {Array} Returns the key-value pairs.
		     * @example
		     *
		     * function Foo() {
		     *   this.a = 1;
		     *   this.b = 2;
		     * }
		     *
		     * Foo.prototype.c = 3;
		     *
		     * _.toPairsIn(new Foo);
		     * // => [['a', 1], ['b', 2], ['c', 3]] (iteration order is not guaranteed)
		     */
		    var toPairsIn = createToPairs(keysIn);

		    /**
		     * An alternative to `_.reduce`; this method transforms `object` to a new
		     * `accumulator` object which is the result of running each of its own
		     * enumerable string keyed properties thru `iteratee`, with each invocation
		     * potentially mutating the `accumulator` object. If `accumulator` is not
		     * provided, a new object with the same `[[Prototype]]` will be used. The
		     * iteratee is invoked with four arguments: (accumulator, value, key, object).
		     * Iteratee functions may exit iteration early by explicitly returning `false`.
		     *
		     * @static
		     * @memberOf _
		     * @since 1.3.0
		     * @category Object
		     * @param {Object} object The object to iterate over.
		     * @param {Function} [iteratee=_.identity] The function invoked per iteration.
		     * @param {*} [accumulator] The custom accumulator value.
		     * @returns {*} Returns the accumulated value.
		     * @example
		     *
		     * _.transform([2, 3, 4], function(result, n) {
		     *   result.push(n *= n);
		     *   return n % 2 == 0;
		     * }, []);
		     * // => [4, 9]
		     *
		     * _.transform({ 'a': 1, 'b': 2, 'c': 1 }, function(result, value, key) {
		     *   (result[value] || (result[value] = [])).push(key);
		     * }, {});
		     * // => { '1': ['a', 'c'], '2': ['b'] }
		     */
		    function transform(object, iteratee, accumulator) {
		      var isArr = isArray(object),
		          isArrLike = isArr || isBuffer(object) || isTypedArray(object);

		      iteratee = getIteratee(iteratee, 4);
		      if (accumulator == null) {
		        var Ctor = object && object.constructor;
		        if (isArrLike) {
		          accumulator = isArr ? new Ctor : [];
		        }
		        else if (isObject(object)) {
		          accumulator = isFunction(Ctor) ? baseCreate(getPrototype(object)) : {};
		        }
		        else {
		          accumulator = {};
		        }
		      }
		      (isArrLike ? arrayEach : baseForOwn)(object, function(value, index, object) {
		        return iteratee(accumulator, value, index, object);
		      });
		      return accumulator;
		    }

		    /**
		     * Removes the property at `path` of `object`.
		     *
		     * **Note:** This method mutates `object`.
		     *
		     * @static
		     * @memberOf _
		     * @since 4.0.0
		     * @category Object
		     * @param {Object} object The object to modify.
		     * @param {Array|string} path The path of the property to unset.
		     * @returns {boolean} Returns `true` if the property is deleted, else `false`.
		     * @example
		     *
		     * var object = { 'a': [{ 'b': { 'c': 7 } }] };
		     * _.unset(object, 'a[0].b.c');
		     * // => true
		     *
		     * console.log(object);
		     * // => { 'a': [{ 'b': {} }] };
		     *
		     * _.unset(object, ['a', '0', 'b', 'c']);
		     * // => true
		     *
		     * console.log(object);
		     * // => { 'a': [{ 'b': {} }] };
		     */
		    function unset(object, path) {
		      return object == null ? true : baseUnset(object, path);
		    }

		    /**
		     * This method is like `_.set` except that accepts `updater` to produce the
		     * value to set. Use `_.updateWith` to customize `path` creation. The `updater`
		     * is invoked with one argument: (value).
		     *
		     * **Note:** This method mutates `object`.
		     *
		     * @static
		     * @memberOf _
		     * @since 4.6.0
		     * @category Object
		     * @param {Object} object The object to modify.
		     * @param {Array|string} path The path of the property to set.
		     * @param {Function} updater The function to produce the updated value.
		     * @returns {Object} Returns `object`.
		     * @example
		     *
		     * var object = { 'a': [{ 'b': { 'c': 3 } }] };
		     *
		     * _.update(object, 'a[0].b.c', function(n) { return n * n; });
		     * console.log(object.a[0].b.c);
		     * // => 9
		     *
		     * _.update(object, 'x[0].y.z', function(n) { return n ? n + 1 : 0; });
		     * console.log(object.x[0].y.z);
		     * // => 0
		     */
		    function update(object, path, updater) {
		      return object == null ? object : baseUpdate(object, path, castFunction(updater));
		    }

		    /**
		     * This method is like `_.update` except that it accepts `customizer` which is
		     * invoked to produce the objects of `path`.  If `customizer` returns `undefined`
		     * path creation is handled by the method instead. The `customizer` is invoked
		     * with three arguments: (nsValue, key, nsObject).
		     *
		     * **Note:** This method mutates `object`.
		     *
		     * @static
		     * @memberOf _
		     * @since 4.6.0
		     * @category Object
		     * @param {Object} object The object to modify.
		     * @param {Array|string} path The path of the property to set.
		     * @param {Function} updater The function to produce the updated value.
		     * @param {Function} [customizer] The function to customize assigned values.
		     * @returns {Object} Returns `object`.
		     * @example
		     *
		     * var object = {};
		     *
		     * _.updateWith(object, '[0][1]', _.constant('a'), Object);
		     * // => { '0': { '1': 'a' } }
		     */
		    function updateWith(object, path, updater, customizer) {
		      customizer = typeof customizer == 'function' ? customizer : undefined$1;
		      return object == null ? object : baseUpdate(object, path, castFunction(updater), customizer);
		    }

		    /**
		     * Creates an array of the own enumerable string keyed property values of `object`.
		     *
		     * **Note:** Non-object values are coerced to objects.
		     *
		     * @static
		     * @since 0.1.0
		     * @memberOf _
		     * @category Object
		     * @param {Object} object The object to query.
		     * @returns {Array} Returns the array of property values.
		     * @example
		     *
		     * function Foo() {
		     *   this.a = 1;
		     *   this.b = 2;
		     * }
		     *
		     * Foo.prototype.c = 3;
		     *
		     * _.values(new Foo);
		     * // => [1, 2] (iteration order is not guaranteed)
		     *
		     * _.values('hi');
		     * // => ['h', 'i']
		     */
		    function values(object) {
		      return object == null ? [] : baseValues(object, keys(object));
		    }

		    /**
		     * Creates an array of the own and inherited enumerable string keyed property
		     * values of `object`.
		     *
		     * **Note:** Non-object values are coerced to objects.
		     *
		     * @static
		     * @memberOf _
		     * @since 3.0.0
		     * @category Object
		     * @param {Object} object The object to query.
		     * @returns {Array} Returns the array of property values.
		     * @example
		     *
		     * function Foo() {
		     *   this.a = 1;
		     *   this.b = 2;
		     * }
		     *
		     * Foo.prototype.c = 3;
		     *
		     * _.valuesIn(new Foo);
		     * // => [1, 2, 3] (iteration order is not guaranteed)
		     */
		    function valuesIn(object) {
		      return object == null ? [] : baseValues(object, keysIn(object));
		    }

		    /*------------------------------------------------------------------------*/

		    /**
		     * Clamps `number` within the inclusive `lower` and `upper` bounds.
		     *
		     * @static
		     * @memberOf _
		     * @since 4.0.0
		     * @category Number
		     * @param {number} number The number to clamp.
		     * @param {number} [lower] The lower bound.
		     * @param {number} upper The upper bound.
		     * @returns {number} Returns the clamped number.
		     * @example
		     *
		     * _.clamp(-10, -5, 5);
		     * // => -5
		     *
		     * _.clamp(10, -5, 5);
		     * // => 5
		     */
		    function clamp(number, lower, upper) {
		      if (upper === undefined$1) {
		        upper = lower;
		        lower = undefined$1;
		      }
		      if (upper !== undefined$1) {
		        upper = toNumber(upper);
		        upper = upper === upper ? upper : 0;
		      }
		      if (lower !== undefined$1) {
		        lower = toNumber(lower);
		        lower = lower === lower ? lower : 0;
		      }
		      return baseClamp(toNumber(number), lower, upper);
		    }

		    /**
		     * Checks if `n` is between `start` and up to, but not including, `end`. If
		     * `end` is not specified, it's set to `start` with `start` then set to `0`.
		     * If `start` is greater than `end` the params are swapped to support
		     * negative ranges.
		     *
		     * @static
		     * @memberOf _
		     * @since 3.3.0
		     * @category Number
		     * @param {number} number The number to check.
		     * @param {number} [start=0] The start of the range.
		     * @param {number} end The end of the range.
		     * @returns {boolean} Returns `true` if `number` is in the range, else `false`.
		     * @see _.range, _.rangeRight
		     * @example
		     *
		     * _.inRange(3, 2, 4);
		     * // => true
		     *
		     * _.inRange(4, 8);
		     * // => true
		     *
		     * _.inRange(4, 2);
		     * // => false
		     *
		     * _.inRange(2, 2);
		     * // => false
		     *
		     * _.inRange(1.2, 2);
		     * // => true
		     *
		     * _.inRange(5.2, 4);
		     * // => false
		     *
		     * _.inRange(-3, -2, -6);
		     * // => true
		     */
		    function inRange(number, start, end) {
		      start = toFinite(start);
		      if (end === undefined$1) {
		        end = start;
		        start = 0;
		      } else {
		        end = toFinite(end);
		      }
		      number = toNumber(number);
		      return baseInRange(number, start, end);
		    }

		    /**
		     * Produces a random number between the inclusive `lower` and `upper` bounds.
		     * If only one argument is provided a number between `0` and the given number
		     * is returned. If `floating` is `true`, or either `lower` or `upper` are
		     * floats, a floating-point number is returned instead of an integer.
		     *
		     * **Note:** JavaScript follows the IEEE-754 standard for resolving
		     * floating-point values which can produce unexpected results.
		     *
		     * @static
		     * @memberOf _
		     * @since 0.7.0
		     * @category Number
		     * @param {number} [lower=0] The lower bound.
		     * @param {number} [upper=1] The upper bound.
		     * @param {boolean} [floating] Specify returning a floating-point number.
		     * @returns {number} Returns the random number.
		     * @example
		     *
		     * _.random(0, 5);
		     * // => an integer between 0 and 5
		     *
		     * _.random(5);
		     * // => also an integer between 0 and 5
		     *
		     * _.random(5, true);
		     * // => a floating-point number between 0 and 5
		     *
		     * _.random(1.2, 5.2);
		     * // => a floating-point number between 1.2 and 5.2
		     */
		    function random(lower, upper, floating) {
		      if (floating && typeof floating != 'boolean' && isIterateeCall(lower, upper, floating)) {
		        upper = floating = undefined$1;
		      }
		      if (floating === undefined$1) {
		        if (typeof upper == 'boolean') {
		          floating = upper;
		          upper = undefined$1;
		        }
		        else if (typeof lower == 'boolean') {
		          floating = lower;
		          lower = undefined$1;
		        }
		      }
		      if (lower === undefined$1 && upper === undefined$1) {
		        lower = 0;
		        upper = 1;
		      }
		      else {
		        lower = toFinite(lower);
		        if (upper === undefined$1) {
		          upper = lower;
		          lower = 0;
		        } else {
		          upper = toFinite(upper);
		        }
		      }
		      if (lower > upper) {
		        var temp = lower;
		        lower = upper;
		        upper = temp;
		      }
		      if (floating || lower % 1 || upper % 1) {
		        var rand = nativeRandom();
		        return nativeMin(lower + (rand * (upper - lower + freeParseFloat('1e-' + ((rand + '').length - 1)))), upper);
		      }
		      return baseRandom(lower, upper);
		    }

		    /*------------------------------------------------------------------------*/

		    /**
		     * Converts `string` to [camel case](https://en.wikipedia.org/wiki/CamelCase).
		     *
		     * @static
		     * @memberOf _
		     * @since 3.0.0
		     * @category String
		     * @param {string} [string=''] The string to convert.
		     * @returns {string} Returns the camel cased string.
		     * @example
		     *
		     * _.camelCase('Foo Bar');
		     * // => 'fooBar'
		     *
		     * _.camelCase('--foo-bar--');
		     * // => 'fooBar'
		     *
		     * _.camelCase('__FOO_BAR__');
		     * // => 'fooBar'
		     */
		    var camelCase = createCompounder(function(result, word, index) {
		      word = word.toLowerCase();
		      return result + (index ? capitalize(word) : word);
		    });

		    /**
		     * Converts the first character of `string` to upper case and the remaining
		     * to lower case.
		     *
		     * @static
		     * @memberOf _
		     * @since 3.0.0
		     * @category String
		     * @param {string} [string=''] The string to capitalize.
		     * @returns {string} Returns the capitalized string.
		     * @example
		     *
		     * _.capitalize('FRED');
		     * // => 'Fred'
		     */
		    function capitalize(string) {
		      return upperFirst(toString(string).toLowerCase());
		    }

		    /**
		     * Deburrs `string` by converting
		     * [Latin-1 Supplement](https://en.wikipedia.org/wiki/Latin-1_Supplement_(Unicode_block)#Character_table)
		     * and [Latin Extended-A](https://en.wikipedia.org/wiki/Latin_Extended-A)
		     * letters to basic Latin letters and removing
		     * [combining diacritical marks](https://en.wikipedia.org/wiki/Combining_Diacritical_Marks).
		     *
		     * @static
		     * @memberOf _
		     * @since 3.0.0
		     * @category String
		     * @param {string} [string=''] The string to deburr.
		     * @returns {string} Returns the deburred string.
		     * @example
		     *
		     * _.deburr('déjà vu');
		     * // => 'deja vu'
		     */
		    function deburr(string) {
		      string = toString(string);
		      return string && string.replace(reLatin, deburrLetter).replace(reComboMark, '');
		    }

		    /**
		     * Checks if `string` ends with the given target string.
		     *
		     * @static
		     * @memberOf _
		     * @since 3.0.0
		     * @category String
		     * @param {string} [string=''] The string to inspect.
		     * @param {string} [target] The string to search for.
		     * @param {number} [position=string.length] The position to search up to.
		     * @returns {boolean} Returns `true` if `string` ends with `target`,
		     *  else `false`.
		     * @example
		     *
		     * _.endsWith('abc', 'c');
		     * // => true
		     *
		     * _.endsWith('abc', 'b');
		     * // => false
		     *
		     * _.endsWith('abc', 'b', 2);
		     * // => true
		     */
		    function endsWith(string, target, position) {
		      string = toString(string);
		      target = baseToString(target);

		      var length = string.length;
		      position = position === undefined$1
		        ? length
		        : baseClamp(toInteger(position), 0, length);

		      var end = position;
		      position -= target.length;
		      return position >= 0 && string.slice(position, end) == target;
		    }

		    /**
		     * Converts the characters "&", "<", ">", '"', and "'" in `string` to their
		     * corresponding HTML entities.
		     *
		     * **Note:** No other characters are escaped. To escape additional
		     * characters use a third-party library like [_he_](https://mths.be/he).
		     *
		     * Though the ">" character is escaped for symmetry, characters like
		     * ">" and "/" don't need escaping in HTML and have no special meaning
		     * unless they're part of a tag or unquoted attribute value. See
		     * [Mathias Bynens's article](https://mathiasbynens.be/notes/ambiguous-ampersands)
		     * (under "semi-related fun fact") for more details.
		     *
		     * When working with HTML you should always
		     * [quote attribute values](http://wonko.com/post/html-escaping) to reduce
		     * XSS vectors.
		     *
		     * @static
		     * @since 0.1.0
		     * @memberOf _
		     * @category String
		     * @param {string} [string=''] The string to escape.
		     * @returns {string} Returns the escaped string.
		     * @example
		     *
		     * _.escape('fred, barney, & pebbles');
		     * // => 'fred, barney, &amp; pebbles'
		     */
		    function escape(string) {
		      string = toString(string);
		      return (string && reHasUnescapedHtml.test(string))
		        ? string.replace(reUnescapedHtml, escapeHtmlChar)
		        : string;
		    }

		    /**
		     * Escapes the `RegExp` special characters "^", "$", "\", ".", "*", "+",
		     * "?", "(", ")", "[", "]", "{", "}", and "|" in `string`.
		     *
		     * @static
		     * @memberOf _
		     * @since 3.0.0
		     * @category String
		     * @param {string} [string=''] The string to escape.
		     * @returns {string} Returns the escaped string.
		     * @example
		     *
		     * _.escapeRegExp('[lodash](https://lodash.com/)');
		     * // => '\[lodash\]\(https://lodash\.com/\)'
		     */
		    function escapeRegExp(string) {
		      string = toString(string);
		      return (string && reHasRegExpChar.test(string))
		        ? string.replace(reRegExpChar, '\\$&')
		        : string;
		    }

		    /**
		     * Converts `string` to
		     * [kebab case](https://en.wikipedia.org/wiki/Letter_case#Special_case_styles).
		     *
		     * @static
		     * @memberOf _
		     * @since 3.0.0
		     * @category String
		     * @param {string} [string=''] The string to convert.
		     * @returns {string} Returns the kebab cased string.
		     * @example
		     *
		     * _.kebabCase('Foo Bar');
		     * // => 'foo-bar'
		     *
		     * _.kebabCase('fooBar');
		     * // => 'foo-bar'
		     *
		     * _.kebabCase('__FOO_BAR__');
		     * // => 'foo-bar'
		     */
		    var kebabCase = createCompounder(function(result, word, index) {
		      return result + (index ? '-' : '') + word.toLowerCase();
		    });

		    /**
		     * Converts `string`, as space separated words, to lower case.
		     *
		     * @static
		     * @memberOf _
		     * @since 4.0.0
		     * @category String
		     * @param {string} [string=''] The string to convert.
		     * @returns {string} Returns the lower cased string.
		     * @example
		     *
		     * _.lowerCase('--Foo-Bar--');
		     * // => 'foo bar'
		     *
		     * _.lowerCase('fooBar');
		     * // => 'foo bar'
		     *
		     * _.lowerCase('__FOO_BAR__');
		     * // => 'foo bar'
		     */
		    var lowerCase = createCompounder(function(result, word, index) {
		      return result + (index ? ' ' : '') + word.toLowerCase();
		    });

		    /**
		     * Converts the first character of `string` to lower case.
		     *
		     * @static
		     * @memberOf _
		     * @since 4.0.0
		     * @category String
		     * @param {string} [string=''] The string to convert.
		     * @returns {string} Returns the converted string.
		     * @example
		     *
		     * _.lowerFirst('Fred');
		     * // => 'fred'
		     *
		     * _.lowerFirst('FRED');
		     * // => 'fRED'
		     */
		    var lowerFirst = createCaseFirst('toLowerCase');

		    /**
		     * Pads `string` on the left and right sides if it's shorter than `length`.
		     * Padding characters are truncated if they can't be evenly divided by `length`.
		     *
		     * @static
		     * @memberOf _
		     * @since 3.0.0
		     * @category String
		     * @param {string} [string=''] The string to pad.
		     * @param {number} [length=0] The padding length.
		     * @param {string} [chars=' '] The string used as padding.
		     * @returns {string} Returns the padded string.
		     * @example
		     *
		     * _.pad('abc', 8);
		     * // => '  abc   '
		     *
		     * _.pad('abc', 8, '_-');
		     * // => '_-abc_-_'
		     *
		     * _.pad('abc', 3);
		     * // => 'abc'
		     */
		    function pad(string, length, chars) {
		      string = toString(string);
		      length = toInteger(length);

		      var strLength = length ? stringSize(string) : 0;
		      if (!length || strLength >= length) {
		        return string;
		      }
		      var mid = (length - strLength) / 2;
		      return (
		        createPadding(nativeFloor(mid), chars) +
		        string +
		        createPadding(nativeCeil(mid), chars)
		      );
		    }

		    /**
		     * Pads `string` on the right side if it's shorter than `length`. Padding
		     * characters are truncated if they exceed `length`.
		     *
		     * @static
		     * @memberOf _
		     * @since 4.0.0
		     * @category String
		     * @param {string} [string=''] The string to pad.
		     * @param {number} [length=0] The padding length.
		     * @param {string} [chars=' '] The string used as padding.
		     * @returns {string} Returns the padded string.
		     * @example
		     *
		     * _.padEnd('abc', 6);
		     * // => 'abc   '
		     *
		     * _.padEnd('abc', 6, '_-');
		     * // => 'abc_-_'
		     *
		     * _.padEnd('abc', 3);
		     * // => 'abc'
		     */
		    function padEnd(string, length, chars) {
		      string = toString(string);
		      length = toInteger(length);

		      var strLength = length ? stringSize(string) : 0;
		      return (length && strLength < length)
		        ? (string + createPadding(length - strLength, chars))
		        : string;
		    }

		    /**
		     * Pads `string` on the left side if it's shorter than `length`. Padding
		     * characters are truncated if they exceed `length`.
		     *
		     * @static
		     * @memberOf _
		     * @since 4.0.0
		     * @category String
		     * @param {string} [string=''] The string to pad.
		     * @param {number} [length=0] The padding length.
		     * @param {string} [chars=' '] The string used as padding.
		     * @returns {string} Returns the padded string.
		     * @example
		     *
		     * _.padStart('abc', 6);
		     * // => '   abc'
		     *
		     * _.padStart('abc', 6, '_-');
		     * // => '_-_abc'
		     *
		     * _.padStart('abc', 3);
		     * // => 'abc'
		     */
		    function padStart(string, length, chars) {
		      string = toString(string);
		      length = toInteger(length);

		      var strLength = length ? stringSize(string) : 0;
		      return (length && strLength < length)
		        ? (createPadding(length - strLength, chars) + string)
		        : string;
		    }

		    /**
		     * Converts `string` to an integer of the specified radix. If `radix` is
		     * `undefined` or `0`, a `radix` of `10` is used unless `value` is a
		     * hexadecimal, in which case a `radix` of `16` is used.
		     *
		     * **Note:** This method aligns with the
		     * [ES5 implementation](https://es5.github.io/#x15.1.2.2) of `parseInt`.
		     *
		     * @static
		     * @memberOf _
		     * @since 1.1.0
		     * @category String
		     * @param {string} string The string to convert.
		     * @param {number} [radix=10] The radix to interpret `value` by.
		     * @param- {Object} [guard] Enables use as an iteratee for methods like `_.map`.
		     * @returns {number} Returns the converted integer.
		     * @example
		     *
		     * _.parseInt('08');
		     * // => 8
		     *
		     * _.map(['6', '08', '10'], _.parseInt);
		     * // => [6, 8, 10]
		     */
		    function parseInt(string, radix, guard) {
		      if (guard || radix == null) {
		        radix = 0;
		      } else if (radix) {
		        radix = +radix;
		      }
		      return nativeParseInt(toString(string).replace(reTrimStart, ''), radix || 0);
		    }

		    /**
		     * Repeats the given string `n` times.
		     *
		     * @static
		     * @memberOf _
		     * @since 3.0.0
		     * @category String
		     * @param {string} [string=''] The string to repeat.
		     * @param {number} [n=1] The number of times to repeat the string.
		     * @param- {Object} [guard] Enables use as an iteratee for methods like `_.map`.
		     * @returns {string} Returns the repeated string.
		     * @example
		     *
		     * _.repeat('*', 3);
		     * // => '***'
		     *
		     * _.repeat('abc', 2);
		     * // => 'abcabc'
		     *
		     * _.repeat('abc', 0);
		     * // => ''
		     */
		    function repeat(string, n, guard) {
		      if ((guard ? isIterateeCall(string, n, guard) : n === undefined$1)) {
		        n = 1;
		      } else {
		        n = toInteger(n);
		      }
		      return baseRepeat(toString(string), n);
		    }

		    /**
		     * Replaces matches for `pattern` in `string` with `replacement`.
		     *
		     * **Note:** This method is based on
		     * [`String#replace`](https://mdn.io/String/replace).
		     *
		     * @static
		     * @memberOf _
		     * @since 4.0.0
		     * @category String
		     * @param {string} [string=''] The string to modify.
		     * @param {RegExp|string} pattern The pattern to replace.
		     * @param {Function|string} replacement The match replacement.
		     * @returns {string} Returns the modified string.
		     * @example
		     *
		     * _.replace('Hi Fred', 'Fred', 'Barney');
		     * // => 'Hi Barney'
		     */
		    function replace() {
		      var args = arguments,
		          string = toString(args[0]);

		      return args.length < 3 ? string : string.replace(args[1], args[2]);
		    }

		    /**
		     * Converts `string` to
		     * [snake case](https://en.wikipedia.org/wiki/Snake_case).
		     *
		     * @static
		     * @memberOf _
		     * @since 3.0.0
		     * @category String
		     * @param {string} [string=''] The string to convert.
		     * @returns {string} Returns the snake cased string.
		     * @example
		     *
		     * _.snakeCase('Foo Bar');
		     * // => 'foo_bar'
		     *
		     * _.snakeCase('fooBar');
		     * // => 'foo_bar'
		     *
		     * _.snakeCase('--FOO-BAR--');
		     * // => 'foo_bar'
		     */
		    var snakeCase = createCompounder(function(result, word, index) {
		      return result + (index ? '_' : '') + word.toLowerCase();
		    });

		    /**
		     * Splits `string` by `separator`.
		     *
		     * **Note:** This method is based on
		     * [`String#split`](https://mdn.io/String/split).
		     *
		     * @static
		     * @memberOf _
		     * @since 4.0.0
		     * @category String
		     * @param {string} [string=''] The string to split.
		     * @param {RegExp|string} separator The separator pattern to split by.
		     * @param {number} [limit] The length to truncate results to.
		     * @returns {Array} Returns the string segments.
		     * @example
		     *
		     * _.split('a-b-c', '-', 2);
		     * // => ['a', 'b']
		     */
		    function split(string, separator, limit) {
		      if (limit && typeof limit != 'number' && isIterateeCall(string, separator, limit)) {
		        separator = limit = undefined$1;
		      }
		      limit = limit === undefined$1 ? MAX_ARRAY_LENGTH : limit >>> 0;
		      if (!limit) {
		        return [];
		      }
		      string = toString(string);
		      if (string && (
		            typeof separator == 'string' ||
		            (separator != null && !isRegExp(separator))
		          )) {
		        separator = baseToString(separator);
		        if (!separator && hasUnicode(string)) {
		          return castSlice(stringToArray(string), 0, limit);
		        }
		      }
		      return string.split(separator, limit);
		    }

		    /**
		     * Converts `string` to
		     * [start case](https://en.wikipedia.org/wiki/Letter_case#Stylistic_or_specialised_usage).
		     *
		     * @static
		     * @memberOf _
		     * @since 3.1.0
		     * @category String
		     * @param {string} [string=''] The string to convert.
		     * @returns {string} Returns the start cased string.
		     * @example
		     *
		     * _.startCase('--foo-bar--');
		     * // => 'Foo Bar'
		     *
		     * _.startCase('fooBar');
		     * // => 'Foo Bar'
		     *
		     * _.startCase('__FOO_BAR__');
		     * // => 'FOO BAR'
		     */
		    var startCase = createCompounder(function(result, word, index) {
		      return result + (index ? ' ' : '') + upperFirst(word);
		    });

		    /**
		     * Checks if `string` starts with the given target string.
		     *
		     * @static
		     * @memberOf _
		     * @since 3.0.0
		     * @category String
		     * @param {string} [string=''] The string to inspect.
		     * @param {string} [target] The string to search for.
		     * @param {number} [position=0] The position to search from.
		     * @returns {boolean} Returns `true` if `string` starts with `target`,
		     *  else `false`.
		     * @example
		     *
		     * _.startsWith('abc', 'a');
		     * // => true
		     *
		     * _.startsWith('abc', 'b');
		     * // => false
		     *
		     * _.startsWith('abc', 'b', 1);
		     * // => true
		     */
		    function startsWith(string, target, position) {
		      string = toString(string);
		      position = position == null
		        ? 0
		        : baseClamp(toInteger(position), 0, string.length);

		      target = baseToString(target);
		      return string.slice(position, position + target.length) == target;
		    }

		    /**
		     * Creates a compiled template function that can interpolate data properties
		     * in "interpolate" delimiters, HTML-escape interpolated data properties in
		     * "escape" delimiters, and execute JavaScript in "evaluate" delimiters. Data
		     * properties may be accessed as free variables in the template. If a setting
		     * object is given, it takes precedence over `_.templateSettings` values.
		     *
		     * **Note:** In the development build `_.template` utilizes
		     * [sourceURLs](http://www.html5rocks.com/en/tutorials/developertools/sourcemaps/#toc-sourceurl)
		     * for easier debugging.
		     *
		     * For more information on precompiling templates see
		     * [lodash's custom builds documentation](https://lodash.com/custom-builds).
		     *
		     * For more information on Chrome extension sandboxes see
		     * [Chrome's extensions documentation](https://developer.chrome.com/extensions/sandboxingEval).
		     *
		     * @static
		     * @since 0.1.0
		     * @memberOf _
		     * @category String
		     * @param {string} [string=''] The template string.
		     * @param {Object} [options={}] The options object.
		     * @param {RegExp} [options.escape=_.templateSettings.escape]
		     *  The HTML "escape" delimiter.
		     * @param {RegExp} [options.evaluate=_.templateSettings.evaluate]
		     *  The "evaluate" delimiter.
		     * @param {Object} [options.imports=_.templateSettings.imports]
		     *  An object to import into the template as free variables.
		     * @param {RegExp} [options.interpolate=_.templateSettings.interpolate]
		     *  The "interpolate" delimiter.
		     * @param {string} [options.sourceURL='lodash.templateSources[n]']
		     *  The sourceURL of the compiled template.
		     * @param {string} [options.variable='obj']
		     *  The data object variable name.
		     * @param- {Object} [guard] Enables use as an iteratee for methods like `_.map`.
		     * @returns {Function} Returns the compiled template function.
		     * @example
		     *
		     * // Use the "interpolate" delimiter to create a compiled template.
		     * var compiled = _.template('hello <%= user %>!');
		     * compiled({ 'user': 'fred' });
		     * // => 'hello fred!'
		     *
		     * // Use the HTML "escape" delimiter to escape data property values.
		     * var compiled = _.template('<b><%- value %></b>');
		     * compiled({ 'value': '<script>' });
		     * // => '<b>&lt;script&gt;</b>'
		     *
		     * // Use the "evaluate" delimiter to execute JavaScript and generate HTML.
		     * var compiled = _.template('<% _.forEach(users, function(user) { %><li><%- user %></li><% }); %>');
		     * compiled({ 'users': ['fred', 'barney'] });
		     * // => '<li>fred</li><li>barney</li>'
		     *
		     * // Use the internal `print` function in "evaluate" delimiters.
		     * var compiled = _.template('<% print("hello " + user); %>!');
		     * compiled({ 'user': 'barney' });
		     * // => 'hello barney!'
		     *
		     * // Use the ES template literal delimiter as an "interpolate" delimiter.
		     * // Disable support by replacing the "interpolate" delimiter.
		     * var compiled = _.template('hello ${ user }!');
		     * compiled({ 'user': 'pebbles' });
		     * // => 'hello pebbles!'
		     *
		     * // Use backslashes to treat delimiters as plain text.
		     * var compiled = _.template('<%= "\\<%- value %\\>" %>');
		     * compiled({ 'value': 'ignored' });
		     * // => '<%- value %>'
		     *
		     * // Use the `imports` option to import `jQuery` as `jq`.
		     * var text = '<% jq.each(users, function(user) { %><li><%- user %></li><% }); %>';
		     * var compiled = _.template(text, { 'imports': { 'jq': jQuery } });
		     * compiled({ 'users': ['fred', 'barney'] });
		     * // => '<li>fred</li><li>barney</li>'
		     *
		     * // Use the `sourceURL` option to specify a custom sourceURL for the template.
		     * var compiled = _.template('hello <%= user %>!', { 'sourceURL': '/basic/greeting.jst' });
		     * compiled(data);
		     * // => Find the source of "greeting.jst" under the Sources tab or Resources panel of the web inspector.
		     *
		     * // Use the `variable` option to ensure a with-statement isn't used in the compiled template.
		     * var compiled = _.template('hi <%= data.user %>!', { 'variable': 'data' });
		     * compiled.source;
		     * // => function(data) {
		     * //   var __t, __p = '';
		     * //   __p += 'hi ' + ((__t = ( data.user )) == null ? '' : __t) + '!';
		     * //   return __p;
		     * // }
		     *
		     * // Use custom template delimiters.
		     * _.templateSettings.interpolate = /{{([\s\S]+?)}}/g;
		     * var compiled = _.template('hello {{ user }}!');
		     * compiled({ 'user': 'mustache' });
		     * // => 'hello mustache!'
		     *
		     * // Use the `source` property to inline compiled templates for meaningful
		     * // line numbers in error messages and stack traces.
		     * fs.writeFileSync(path.join(process.cwd(), 'jst.js'), '\
		     *   var JST = {\
		     *     "main": ' + _.template(mainText).source + '\
		     *   };\
		     * ');
		     */
		    function template(string, options, guard) {
		      // Based on John Resig's `tmpl` implementation
		      // (http://ejohn.org/blog/javascript-micro-templating/)
		      // and Laura Doktorova's doT.js (https://github.com/olado/doT).
		      var settings = lodash.templateSettings;

		      if (guard && isIterateeCall(string, options, guard)) {
		        options = undefined$1;
		      }
		      string = toString(string);
		      options = assignInWith({}, options, settings, customDefaultsAssignIn);

		      var imports = assignInWith({}, options.imports, settings.imports, customDefaultsAssignIn),
		          importsKeys = keys(imports),
		          importsValues = baseValues(imports, importsKeys);

		      var isEscaping,
		          isEvaluating,
		          index = 0,
		          interpolate = options.interpolate || reNoMatch,
		          source = "__p += '";

		      // Compile the regexp to match each delimiter.
		      var reDelimiters = RegExp(
		        (options.escape || reNoMatch).source + '|' +
		        interpolate.source + '|' +
		        (interpolate === reInterpolate ? reEsTemplate : reNoMatch).source + '|' +
		        (options.evaluate || reNoMatch).source + '|$'
		      , 'g');

		      // Use a sourceURL for easier debugging.
		      // The sourceURL gets injected into the source that's eval-ed, so be careful
		      // to normalize all kinds of whitespace, so e.g. newlines (and unicode versions of it) can't sneak in
		      // and escape the comment, thus injecting code that gets evaled.
		      var sourceURL = '//# sourceURL=' +
		        (hasOwnProperty.call(options, 'sourceURL')
		          ? (options.sourceURL + '').replace(/\s/g, ' ')
		          : ('lodash.templateSources[' + (++templateCounter) + ']')
		        ) + '\n';

		      string.replace(reDelimiters, function(match, escapeValue, interpolateValue, esTemplateValue, evaluateValue, offset) {
		        interpolateValue || (interpolateValue = esTemplateValue);

		        // Escape characters that can't be included in string literals.
		        source += string.slice(index, offset).replace(reUnescapedString, escapeStringChar);

		        // Replace delimiters with snippets.
		        if (escapeValue) {
		          isEscaping = true;
		          source += "' +\n__e(" + escapeValue + ") +\n'";
		        }
		        if (evaluateValue) {
		          isEvaluating = true;
		          source += "';\n" + evaluateValue + ";\n__p += '";
		        }
		        if (interpolateValue) {
		          source += "' +\n((__t = (" + interpolateValue + ")) == null ? '' : __t) +\n'";
		        }
		        index = offset + match.length;

		        // The JS engine embedded in Adobe products needs `match` returned in
		        // order to produce the correct `offset` value.
		        return match;
		      });

		      source += "';\n";

		      // If `variable` is not specified wrap a with-statement around the generated
		      // code to add the data object to the top of the scope chain.
		      var variable = hasOwnProperty.call(options, 'variable') && options.variable;
		      if (!variable) {
		        source = 'with (obj) {\n' + source + '\n}\n';
		      }
		      // Throw an error if a forbidden character was found in `variable`, to prevent
		      // potential command injection attacks.
		      else if (reForbiddenIdentifierChars.test(variable)) {
		        throw new Error(INVALID_TEMPL_VAR_ERROR_TEXT);
		      }

		      // Cleanup code by stripping empty strings.
		      source = (isEvaluating ? source.replace(reEmptyStringLeading, '') : source)
		        .replace(reEmptyStringMiddle, '$1')
		        .replace(reEmptyStringTrailing, '$1;');

		      // Frame code as the function body.
		      source = 'function(' + (variable || 'obj') + ') {\n' +
		        (variable
		          ? ''
		          : 'obj || (obj = {});\n'
		        ) +
		        "var __t, __p = ''" +
		        (isEscaping
		           ? ', __e = _.escape'
		           : ''
		        ) +
		        (isEvaluating
		          ? ', __j = Array.prototype.join;\n' +
		            "function print() { __p += __j.call(arguments, '') }\n"
		          : ';\n'
		        ) +
		        source +
		        'return __p\n}';

		      var result = attempt(function() {
		        return Function(importsKeys, sourceURL + 'return ' + source)
		          .apply(undefined$1, importsValues);
		      });

		      // Provide the compiled function's source by its `toString` method or
		      // the `source` property as a convenience for inlining compiled templates.
		      result.source = source;
		      if (isError(result)) {
		        throw result;
		      }
		      return result;
		    }

		    /**
		     * Converts `string`, as a whole, to lower case just like
		     * [String#toLowerCase](https://mdn.io/toLowerCase).
		     *
		     * @static
		     * @memberOf _
		     * @since 4.0.0
		     * @category String
		     * @param {string} [string=''] The string to convert.
		     * @returns {string} Returns the lower cased string.
		     * @example
		     *
		     * _.toLower('--Foo-Bar--');
		     * // => '--foo-bar--'
		     *
		     * _.toLower('fooBar');
		     * // => 'foobar'
		     *
		     * _.toLower('__FOO_BAR__');
		     * // => '__foo_bar__'
		     */
		    function toLower(value) {
		      return toString(value).toLowerCase();
		    }

		    /**
		     * Converts `string`, as a whole, to upper case just like
		     * [String#toUpperCase](https://mdn.io/toUpperCase).
		     *
		     * @static
		     * @memberOf _
		     * @since 4.0.0
		     * @category String
		     * @param {string} [string=''] The string to convert.
		     * @returns {string} Returns the upper cased string.
		     * @example
		     *
		     * _.toUpper('--foo-bar--');
		     * // => '--FOO-BAR--'
		     *
		     * _.toUpper('fooBar');
		     * // => 'FOOBAR'
		     *
		     * _.toUpper('__foo_bar__');
		     * // => '__FOO_BAR__'
		     */
		    function toUpper(value) {
		      return toString(value).toUpperCase();
		    }

		    /**
		     * Removes leading and trailing whitespace or specified characters from `string`.
		     *
		     * @static
		     * @memberOf _
		     * @since 3.0.0
		     * @category String
		     * @param {string} [string=''] The string to trim.
		     * @param {string} [chars=whitespace] The characters to trim.
		     * @param- {Object} [guard] Enables use as an iteratee for methods like `_.map`.
		     * @returns {string} Returns the trimmed string.
		     * @example
		     *
		     * _.trim('  abc  ');
		     * // => 'abc'
		     *
		     * _.trim('-_-abc-_-', '_-');
		     * // => 'abc'
		     *
		     * _.map(['  foo  ', '  bar  '], _.trim);
		     * // => ['foo', 'bar']
		     */
		    function trim(string, chars, guard) {
		      string = toString(string);
		      if (string && (guard || chars === undefined$1)) {
		        return baseTrim(string);
		      }
		      if (!string || !(chars = baseToString(chars))) {
		        return string;
		      }
		      var strSymbols = stringToArray(string),
		          chrSymbols = stringToArray(chars),
		          start = charsStartIndex(strSymbols, chrSymbols),
		          end = charsEndIndex(strSymbols, chrSymbols) + 1;

		      return castSlice(strSymbols, start, end).join('');
		    }

		    /**
		     * Removes trailing whitespace or specified characters from `string`.
		     *
		     * @static
		     * @memberOf _
		     * @since 4.0.0
		     * @category String
		     * @param {string} [string=''] The string to trim.
		     * @param {string} [chars=whitespace] The characters to trim.
		     * @param- {Object} [guard] Enables use as an iteratee for methods like `_.map`.
		     * @returns {string} Returns the trimmed string.
		     * @example
		     *
		     * _.trimEnd('  abc  ');
		     * // => '  abc'
		     *
		     * _.trimEnd('-_-abc-_-', '_-');
		     * // => '-_-abc'
		     */
		    function trimEnd(string, chars, guard) {
		      string = toString(string);
		      if (string && (guard || chars === undefined$1)) {
		        return string.slice(0, trimmedEndIndex(string) + 1);
		      }
		      if (!string || !(chars = baseToString(chars))) {
		        return string;
		      }
		      var strSymbols = stringToArray(string),
		          end = charsEndIndex(strSymbols, stringToArray(chars)) + 1;

		      return castSlice(strSymbols, 0, end).join('');
		    }

		    /**
		     * Removes leading whitespace or specified characters from `string`.
		     *
		     * @static
		     * @memberOf _
		     * @since 4.0.0
		     * @category String
		     * @param {string} [string=''] The string to trim.
		     * @param {string} [chars=whitespace] The characters to trim.
		     * @param- {Object} [guard] Enables use as an iteratee for methods like `_.map`.
		     * @returns {string} Returns the trimmed string.
		     * @example
		     *
		     * _.trimStart('  abc  ');
		     * // => 'abc  '
		     *
		     * _.trimStart('-_-abc-_-', '_-');
		     * // => 'abc-_-'
		     */
		    function trimStart(string, chars, guard) {
		      string = toString(string);
		      if (string && (guard || chars === undefined$1)) {
		        return string.replace(reTrimStart, '');
		      }
		      if (!string || !(chars = baseToString(chars))) {
		        return string;
		      }
		      var strSymbols = stringToArray(string),
		          start = charsStartIndex(strSymbols, stringToArray(chars));

		      return castSlice(strSymbols, start).join('');
		    }

		    /**
		     * Truncates `string` if it's longer than the given maximum string length.
		     * The last characters of the truncated string are replaced with the omission
		     * string which defaults to "...".
		     *
		     * @static
		     * @memberOf _
		     * @since 4.0.0
		     * @category String
		     * @param {string} [string=''] The string to truncate.
		     * @param {Object} [options={}] The options object.
		     * @param {number} [options.length=30] The maximum string length.
		     * @param {string} [options.omission='...'] The string to indicate text is omitted.
		     * @param {RegExp|string} [options.separator] The separator pattern to truncate to.
		     * @returns {string} Returns the truncated string.
		     * @example
		     *
		     * _.truncate('hi-diddly-ho there, neighborino');
		     * // => 'hi-diddly-ho there, neighbo...'
		     *
		     * _.truncate('hi-diddly-ho there, neighborino', {
		     *   'length': 24,
		     *   'separator': ' '
		     * });
		     * // => 'hi-diddly-ho there,...'
		     *
		     * _.truncate('hi-diddly-ho there, neighborino', {
		     *   'length': 24,
		     *   'separator': /,? +/
		     * });
		     * // => 'hi-diddly-ho there...'
		     *
		     * _.truncate('hi-diddly-ho there, neighborino', {
		     *   'omission': ' [...]'
		     * });
		     * // => 'hi-diddly-ho there, neig [...]'
		     */
		    function truncate(string, options) {
		      var length = DEFAULT_TRUNC_LENGTH,
		          omission = DEFAULT_TRUNC_OMISSION;

		      if (isObject(options)) {
		        var separator = 'separator' in options ? options.separator : separator;
		        length = 'length' in options ? toInteger(options.length) : length;
		        omission = 'omission' in options ? baseToString(options.omission) : omission;
		      }
		      string = toString(string);

		      var strLength = string.length;
		      if (hasUnicode(string)) {
		        var strSymbols = stringToArray(string);
		        strLength = strSymbols.length;
		      }
		      if (length >= strLength) {
		        return string;
		      }
		      var end = length - stringSize(omission);
		      if (end < 1) {
		        return omission;
		      }
		      var result = strSymbols
		        ? castSlice(strSymbols, 0, end).join('')
		        : string.slice(0, end);

		      if (separator === undefined$1) {
		        return result + omission;
		      }
		      if (strSymbols) {
		        end += (result.length - end);
		      }
		      if (isRegExp(separator)) {
		        if (string.slice(end).search(separator)) {
		          var match,
		              substring = result;

		          if (!separator.global) {
		            separator = RegExp(separator.source, toString(reFlags.exec(separator)) + 'g');
		          }
		          separator.lastIndex = 0;
		          while ((match = separator.exec(substring))) {
		            var newEnd = match.index;
		          }
		          result = result.slice(0, newEnd === undefined$1 ? end : newEnd);
		        }
		      } else if (string.indexOf(baseToString(separator), end) != end) {
		        var index = result.lastIndexOf(separator);
		        if (index > -1) {
		          result = result.slice(0, index);
		        }
		      }
		      return result + omission;
		    }

		    /**
		     * The inverse of `_.escape`; this method converts the HTML entities
		     * `&amp;`, `&lt;`, `&gt;`, `&quot;`, and `&#39;` in `string` to
		     * their corresponding characters.
		     *
		     * **Note:** No other HTML entities are unescaped. To unescape additional
		     * HTML entities use a third-party library like [_he_](https://mths.be/he).
		     *
		     * @static
		     * @memberOf _
		     * @since 0.6.0
		     * @category String
		     * @param {string} [string=''] The string to unescape.
		     * @returns {string} Returns the unescaped string.
		     * @example
		     *
		     * _.unescape('fred, barney, &amp; pebbles');
		     * // => 'fred, barney, & pebbles'
		     */
		    function unescape(string) {
		      string = toString(string);
		      return (string && reHasEscapedHtml.test(string))
		        ? string.replace(reEscapedHtml, unescapeHtmlChar)
		        : string;
		    }

		    /**
		     * Converts `string`, as space separated words, to upper case.
		     *
		     * @static
		     * @memberOf _
		     * @since 4.0.0
		     * @category String
		     * @param {string} [string=''] The string to convert.
		     * @returns {string} Returns the upper cased string.
		     * @example
		     *
		     * _.upperCase('--foo-bar');
		     * // => 'FOO BAR'
		     *
		     * _.upperCase('fooBar');
		     * // => 'FOO BAR'
		     *
		     * _.upperCase('__foo_bar__');
		     * // => 'FOO BAR'
		     */
		    var upperCase = createCompounder(function(result, word, index) {
		      return result + (index ? ' ' : '') + word.toUpperCase();
		    });

		    /**
		     * Converts the first character of `string` to upper case.
		     *
		     * @static
		     * @memberOf _
		     * @since 4.0.0
		     * @category String
		     * @param {string} [string=''] The string to convert.
		     * @returns {string} Returns the converted string.
		     * @example
		     *
		     * _.upperFirst('fred');
		     * // => 'Fred'
		     *
		     * _.upperFirst('FRED');
		     * // => 'FRED'
		     */
		    var upperFirst = createCaseFirst('toUpperCase');

		    /**
		     * Splits `string` into an array of its words.
		     *
		     * @static
		     * @memberOf _
		     * @since 3.0.0
		     * @category String
		     * @param {string} [string=''] The string to inspect.
		     * @param {RegExp|string} [pattern] The pattern to match words.
		     * @param- {Object} [guard] Enables use as an iteratee for methods like `_.map`.
		     * @returns {Array} Returns the words of `string`.
		     * @example
		     *
		     * _.words('fred, barney, & pebbles');
		     * // => ['fred', 'barney', 'pebbles']
		     *
		     * _.words('fred, barney, & pebbles', /[^, ]+/g);
		     * // => ['fred', 'barney', '&', 'pebbles']
		     */
		    function words(string, pattern, guard) {
		      string = toString(string);
		      pattern = guard ? undefined$1 : pattern;

		      if (pattern === undefined$1) {
		        return hasUnicodeWord(string) ? unicodeWords(string) : asciiWords(string);
		      }
		      return string.match(pattern) || [];
		    }

		    /*------------------------------------------------------------------------*/

		    /**
		     * Attempts to invoke `func`, returning either the result or the caught error
		     * object. Any additional arguments are provided to `func` when it's invoked.
		     *
		     * @static
		     * @memberOf _
		     * @since 3.0.0
		     * @category Util
		     * @param {Function} func The function to attempt.
		     * @param {...*} [args] The arguments to invoke `func` with.
		     * @returns {*} Returns the `func` result or error object.
		     * @example
		     *
		     * // Avoid throwing errors for invalid selectors.
		     * var elements = _.attempt(function(selector) {
		     *   return document.querySelectorAll(selector);
		     * }, '>_>');
		     *
		     * if (_.isError(elements)) {
		     *   elements = [];
		     * }
		     */
		    var attempt = baseRest(function(func, args) {
		      try {
		        return apply(func, undefined$1, args);
		      } catch (e) {
		        return isError(e) ? e : new Error(e);
		      }
		    });

		    /**
		     * Binds methods of an object to the object itself, overwriting the existing
		     * method.
		     *
		     * **Note:** This method doesn't set the "length" property of bound functions.
		     *
		     * @static
		     * @since 0.1.0
		     * @memberOf _
		     * @category Util
		     * @param {Object} object The object to bind and assign the bound methods to.
		     * @param {...(string|string[])} methodNames The object method names to bind.
		     * @returns {Object} Returns `object`.
		     * @example
		     *
		     * var view = {
		     *   'label': 'docs',
		     *   'click': function() {
		     *     console.log('clicked ' + this.label);
		     *   }
		     * };
		     *
		     * _.bindAll(view, ['click']);
		     * jQuery(element).on('click', view.click);
		     * // => Logs 'clicked docs' when clicked.
		     */
		    var bindAll = flatRest(function(object, methodNames) {
		      arrayEach(methodNames, function(key) {
		        key = toKey(key);
		        baseAssignValue(object, key, bind(object[key], object));
		      });
		      return object;
		    });

		    /**
		     * Creates a function that iterates over `pairs` and invokes the corresponding
		     * function of the first predicate to return truthy. The predicate-function
		     * pairs are invoked with the `this` binding and arguments of the created
		     * function.
		     *
		     * @static
		     * @memberOf _
		     * @since 4.0.0
		     * @category Util
		     * @param {Array} pairs The predicate-function pairs.
		     * @returns {Function} Returns the new composite function.
		     * @example
		     *
		     * var func = _.cond([
		     *   [_.matches({ 'a': 1 }),           _.constant('matches A')],
		     *   [_.conforms({ 'b': _.isNumber }), _.constant('matches B')],
		     *   [_.stubTrue,                      _.constant('no match')]
		     * ]);
		     *
		     * func({ 'a': 1, 'b': 2 });
		     * // => 'matches A'
		     *
		     * func({ 'a': 0, 'b': 1 });
		     * // => 'matches B'
		     *
		     * func({ 'a': '1', 'b': '2' });
		     * // => 'no match'
		     */
		    function cond(pairs) {
		      var length = pairs == null ? 0 : pairs.length,
		          toIteratee = getIteratee();

		      pairs = !length ? [] : arrayMap(pairs, function(pair) {
		        if (typeof pair[1] != 'function') {
		          throw new TypeError(FUNC_ERROR_TEXT);
		        }
		        return [toIteratee(pair[0]), pair[1]];
		      });

		      return baseRest(function(args) {
		        var index = -1;
		        while (++index < length) {
		          var pair = pairs[index];
		          if (apply(pair[0], this, args)) {
		            return apply(pair[1], this, args);
		          }
		        }
		      });
		    }

		    /**
		     * Creates a function that invokes the predicate properties of `source` with
		     * the corresponding property values of a given object, returning `true` if
		     * all predicates return truthy, else `false`.
		     *
		     * **Note:** The created function is equivalent to `_.conformsTo` with
		     * `source` partially applied.
		     *
		     * @static
		     * @memberOf _
		     * @since 4.0.0
		     * @category Util
		     * @param {Object} source The object of property predicates to conform to.
		     * @returns {Function} Returns the new spec function.
		     * @example
		     *
		     * var objects = [
		     *   { 'a': 2, 'b': 1 },
		     *   { 'a': 1, 'b': 2 }
		     * ];
		     *
		     * _.filter(objects, _.conforms({ 'b': function(n) { return n > 1; } }));
		     * // => [{ 'a': 1, 'b': 2 }]
		     */
		    function conforms(source) {
		      return baseConforms(baseClone(source, CLONE_DEEP_FLAG));
		    }

		    /**
		     * Creates a function that returns `value`.
		     *
		     * @static
		     * @memberOf _
		     * @since 2.4.0
		     * @category Util
		     * @param {*} value The value to return from the new function.
		     * @returns {Function} Returns the new constant function.
		     * @example
		     *
		     * var objects = _.times(2, _.constant({ 'a': 1 }));
		     *
		     * console.log(objects);
		     * // => [{ 'a': 1 }, { 'a': 1 }]
		     *
		     * console.log(objects[0] === objects[1]);
		     * // => true
		     */
		    function constant(value) {
		      return function() {
		        return value;
		      };
		    }

		    /**
		     * Checks `value` to determine whether a default value should be returned in
		     * its place. The `defaultValue` is returned if `value` is `NaN`, `null`,
		     * or `undefined`.
		     *
		     * @static
		     * @memberOf _
		     * @since 4.14.0
		     * @category Util
		     * @param {*} value The value to check.
		     * @param {*} defaultValue The default value.
		     * @returns {*} Returns the resolved value.
		     * @example
		     *
		     * _.defaultTo(1, 10);
		     * // => 1
		     *
		     * _.defaultTo(undefined, 10);
		     * // => 10
		     */
		    function defaultTo(value, defaultValue) {
		      return (value == null || value !== value) ? defaultValue : value;
		    }

		    /**
		     * Creates a function that returns the result of invoking the given functions
		     * with the `this` binding of the created function, where each successive
		     * invocation is supplied the return value of the previous.
		     *
		     * @static
		     * @memberOf _
		     * @since 3.0.0
		     * @category Util
		     * @param {...(Function|Function[])} [funcs] The functions to invoke.
		     * @returns {Function} Returns the new composite function.
		     * @see _.flowRight
		     * @example
		     *
		     * function square(n) {
		     *   return n * n;
		     * }
		     *
		     * var addSquare = _.flow([_.add, square]);
		     * addSquare(1, 2);
		     * // => 9
		     */
		    var flow = createFlow();

		    /**
		     * This method is like `_.flow` except that it creates a function that
		     * invokes the given functions from right to left.
		     *
		     * @static
		     * @since 3.0.0
		     * @memberOf _
		     * @category Util
		     * @param {...(Function|Function[])} [funcs] The functions to invoke.
		     * @returns {Function} Returns the new composite function.
		     * @see _.flow
		     * @example
		     *
		     * function square(n) {
		     *   return n * n;
		     * }
		     *
		     * var addSquare = _.flowRight([square, _.add]);
		     * addSquare(1, 2);
		     * // => 9
		     */
		    var flowRight = createFlow(true);

		    /**
		     * This method returns the first argument it receives.
		     *
		     * @static
		     * @since 0.1.0
		     * @memberOf _
		     * @category Util
		     * @param {*} value Any value.
		     * @returns {*} Returns `value`.
		     * @example
		     *
		     * var object = { 'a': 1 };
		     *
		     * console.log(_.identity(object) === object);
		     * // => true
		     */
		    function identity(value) {
		      return value;
		    }

		    /**
		     * Creates a function that invokes `func` with the arguments of the created
		     * function. If `func` is a property name, the created function returns the
		     * property value for a given element. If `func` is an array or object, the
		     * created function returns `true` for elements that contain the equivalent
		     * source properties, otherwise it returns `false`.
		     *
		     * @static
		     * @since 4.0.0
		     * @memberOf _
		     * @category Util
		     * @param {*} [func=_.identity] The value to convert to a callback.
		     * @returns {Function} Returns the callback.
		     * @example
		     *
		     * var users = [
		     *   { 'user': 'barney', 'age': 36, 'active': true },
		     *   { 'user': 'fred',   'age': 40, 'active': false }
		     * ];
		     *
		     * // The `_.matches` iteratee shorthand.
		     * _.filter(users, _.iteratee({ 'user': 'barney', 'active': true }));
		     * // => [{ 'user': 'barney', 'age': 36, 'active': true }]
		     *
		     * // The `_.matchesProperty` iteratee shorthand.
		     * _.filter(users, _.iteratee(['user', 'fred']));
		     * // => [{ 'user': 'fred', 'age': 40 }]
		     *
		     * // The `_.property` iteratee shorthand.
		     * _.map(users, _.iteratee('user'));
		     * // => ['barney', 'fred']
		     *
		     * // Create custom iteratee shorthands.
		     * _.iteratee = _.wrap(_.iteratee, function(iteratee, func) {
		     *   return !_.isRegExp(func) ? iteratee(func) : function(string) {
		     *     return func.test(string);
		     *   };
		     * });
		     *
		     * _.filter(['abc', 'def'], /ef/);
		     * // => ['def']
		     */
		    function iteratee(func) {
		      return baseIteratee(typeof func == 'function' ? func : baseClone(func, CLONE_DEEP_FLAG));
		    }

		    /**
		     * Creates a function that performs a partial deep comparison between a given
		     * object and `source`, returning `true` if the given object has equivalent
		     * property values, else `false`.
		     *
		     * **Note:** The created function is equivalent to `_.isMatch` with `source`
		     * partially applied.
		     *
		     * Partial comparisons will match empty array and empty object `source`
		     * values against any array or object value, respectively. See `_.isEqual`
		     * for a list of supported value comparisons.
		     *
		     * **Note:** Multiple values can be checked by combining several matchers
		     * using `_.overSome`
		     *
		     * @static
		     * @memberOf _
		     * @since 3.0.0
		     * @category Util
		     * @param {Object} source The object of property values to match.
		     * @returns {Function} Returns the new spec function.
		     * @example
		     *
		     * var objects = [
		     *   { 'a': 1, 'b': 2, 'c': 3 },
		     *   { 'a': 4, 'b': 5, 'c': 6 }
		     * ];
		     *
		     * _.filter(objects, _.matches({ 'a': 4, 'c': 6 }));
		     * // => [{ 'a': 4, 'b': 5, 'c': 6 }]
		     *
		     * // Checking for several possible values
		     * _.filter(objects, _.overSome([_.matches({ 'a': 1 }), _.matches({ 'a': 4 })]));
		     * // => [{ 'a': 1, 'b': 2, 'c': 3 }, { 'a': 4, 'b': 5, 'c': 6 }]
		     */
		    function matches(source) {
		      return baseMatches(baseClone(source, CLONE_DEEP_FLAG));
		    }

		    /**
		     * Creates a function that performs a partial deep comparison between the
		     * value at `path` of a given object to `srcValue`, returning `true` if the
		     * object value is equivalent, else `false`.
		     *
		     * **Note:** Partial comparisons will match empty array and empty object
		     * `srcValue` values against any array or object value, respectively. See
		     * `_.isEqual` for a list of supported value comparisons.
		     *
		     * **Note:** Multiple values can be checked by combining several matchers
		     * using `_.overSome`
		     *
		     * @static
		     * @memberOf _
		     * @since 3.2.0
		     * @category Util
		     * @param {Array|string} path The path of the property to get.
		     * @param {*} srcValue The value to match.
		     * @returns {Function} Returns the new spec function.
		     * @example
		     *
		     * var objects = [
		     *   { 'a': 1, 'b': 2, 'c': 3 },
		     *   { 'a': 4, 'b': 5, 'c': 6 }
		     * ];
		     *
		     * _.find(objects, _.matchesProperty('a', 4));
		     * // => { 'a': 4, 'b': 5, 'c': 6 }
		     *
		     * // Checking for several possible values
		     * _.filter(objects, _.overSome([_.matchesProperty('a', 1), _.matchesProperty('a', 4)]));
		     * // => [{ 'a': 1, 'b': 2, 'c': 3 }, { 'a': 4, 'b': 5, 'c': 6 }]
		     */
		    function matchesProperty(path, srcValue) {
		      return baseMatchesProperty(path, baseClone(srcValue, CLONE_DEEP_FLAG));
		    }

		    /**
		     * Creates a function that invokes the method at `path` of a given object.
		     * Any additional arguments are provided to the invoked method.
		     *
		     * @static
		     * @memberOf _
		     * @since 3.7.0
		     * @category Util
		     * @param {Array|string} path The path of the method to invoke.
		     * @param {...*} [args] The arguments to invoke the method with.
		     * @returns {Function} Returns the new invoker function.
		     * @example
		     *
		     * var objects = [
		     *   { 'a': { 'b': _.constant(2) } },
		     *   { 'a': { 'b': _.constant(1) } }
		     * ];
		     *
		     * _.map(objects, _.method('a.b'));
		     * // => [2, 1]
		     *
		     * _.map(objects, _.method(['a', 'b']));
		     * // => [2, 1]
		     */
		    var method = baseRest(function(path, args) {
		      return function(object) {
		        return baseInvoke(object, path, args);
		      };
		    });

		    /**
		     * The opposite of `_.method`; this method creates a function that invokes
		     * the method at a given path of `object`. Any additional arguments are
		     * provided to the invoked method.
		     *
		     * @static
		     * @memberOf _
		     * @since 3.7.0
		     * @category Util
		     * @param {Object} object The object to query.
		     * @param {...*} [args] The arguments to invoke the method with.
		     * @returns {Function} Returns the new invoker function.
		     * @example
		     *
		     * var array = _.times(3, _.constant),
		     *     object = { 'a': array, 'b': array, 'c': array };
		     *
		     * _.map(['a[2]', 'c[0]'], _.methodOf(object));
		     * // => [2, 0]
		     *
		     * _.map([['a', '2'], ['c', '0']], _.methodOf(object));
		     * // => [2, 0]
		     */
		    var methodOf = baseRest(function(object, args) {
		      return function(path) {
		        return baseInvoke(object, path, args);
		      };
		    });

		    /**
		     * Adds all own enumerable string keyed function properties of a source
		     * object to the destination object. If `object` is a function, then methods
		     * are added to its prototype as well.
		     *
		     * **Note:** Use `_.runInContext` to create a pristine `lodash` function to
		     * avoid conflicts caused by modifying the original.
		     *
		     * @static
		     * @since 0.1.0
		     * @memberOf _
		     * @category Util
		     * @param {Function|Object} [object=lodash] The destination object.
		     * @param {Object} source The object of functions to add.
		     * @param {Object} [options={}] The options object.
		     * @param {boolean} [options.chain=true] Specify whether mixins are chainable.
		     * @returns {Function|Object} Returns `object`.
		     * @example
		     *
		     * function vowels(string) {
		     *   return _.filter(string, function(v) {
		     *     return /[aeiou]/i.test(v);
		     *   });
		     * }
		     *
		     * _.mixin({ 'vowels': vowels });
		     * _.vowels('fred');
		     * // => ['e']
		     *
		     * _('fred').vowels().value();
		     * // => ['e']
		     *
		     * _.mixin({ 'vowels': vowels }, { 'chain': false });
		     * _('fred').vowels();
		     * // => ['e']
		     */
		    function mixin(object, source, options) {
		      var props = keys(source),
		          methodNames = baseFunctions(source, props);

		      if (options == null &&
		          !(isObject(source) && (methodNames.length || !props.length))) {
		        options = source;
		        source = object;
		        object = this;
		        methodNames = baseFunctions(source, keys(source));
		      }
		      var chain = !(isObject(options) && 'chain' in options) || !!options.chain,
		          isFunc = isFunction(object);

		      arrayEach(methodNames, function(methodName) {
		        var func = source[methodName];
		        object[methodName] = func;
		        if (isFunc) {
		          object.prototype[methodName] = function() {
		            var chainAll = this.__chain__;
		            if (chain || chainAll) {
		              var result = object(this.__wrapped__),
		                  actions = result.__actions__ = copyArray(this.__actions__);

		              actions.push({ 'func': func, 'args': arguments, 'thisArg': object });
		              result.__chain__ = chainAll;
		              return result;
		            }
		            return func.apply(object, arrayPush([this.value()], arguments));
		          };
		        }
		      });

		      return object;
		    }

		    /**
		     * Reverts the `_` variable to its previous value and returns a reference to
		     * the `lodash` function.
		     *
		     * @static
		     * @since 0.1.0
		     * @memberOf _
		     * @category Util
		     * @returns {Function} Returns the `lodash` function.
		     * @example
		     *
		     * var lodash = _.noConflict();
		     */
		    function noConflict() {
		      if (root._ === this) {
		        root._ = oldDash;
		      }
		      return this;
		    }

		    /**
		     * This method returns `undefined`.
		     *
		     * @static
		     * @memberOf _
		     * @since 2.3.0
		     * @category Util
		     * @example
		     *
		     * _.times(2, _.noop);
		     * // => [undefined, undefined]
		     */
		    function noop() {
		      // No operation performed.
		    }

		    /**
		     * Creates a function that gets the argument at index `n`. If `n` is negative,
		     * the nth argument from the end is returned.
		     *
		     * @static
		     * @memberOf _
		     * @since 4.0.0
		     * @category Util
		     * @param {number} [n=0] The index of the argument to return.
		     * @returns {Function} Returns the new pass-thru function.
		     * @example
		     *
		     * var func = _.nthArg(1);
		     * func('a', 'b', 'c', 'd');
		     * // => 'b'
		     *
		     * var func = _.nthArg(-2);
		     * func('a', 'b', 'c', 'd');
		     * // => 'c'
		     */
		    function nthArg(n) {
		      n = toInteger(n);
		      return baseRest(function(args) {
		        return baseNth(args, n);
		      });
		    }

		    /**
		     * Creates a function that invokes `iteratees` with the arguments it receives
		     * and returns their results.
		     *
		     * @static
		     * @memberOf _
		     * @since 4.0.0
		     * @category Util
		     * @param {...(Function|Function[])} [iteratees=[_.identity]]
		     *  The iteratees to invoke.
		     * @returns {Function} Returns the new function.
		     * @example
		     *
		     * var func = _.over([Math.max, Math.min]);
		     *
		     * func(1, 2, 3, 4);
		     * // => [4, 1]
		     */
		    var over = createOver(arrayMap);

		    /**
		     * Creates a function that checks if **all** of the `predicates` return
		     * truthy when invoked with the arguments it receives.
		     *
		     * Following shorthands are possible for providing predicates.
		     * Pass an `Object` and it will be used as an parameter for `_.matches` to create the predicate.
		     * Pass an `Array` of parameters for `_.matchesProperty` and the predicate will be created using them.
		     *
		     * @static
		     * @memberOf _
		     * @since 4.0.0
		     * @category Util
		     * @param {...(Function|Function[])} [predicates=[_.identity]]
		     *  The predicates to check.
		     * @returns {Function} Returns the new function.
		     * @example
		     *
		     * var func = _.overEvery([Boolean, isFinite]);
		     *
		     * func('1');
		     * // => true
		     *
		     * func(null);
		     * // => false
		     *
		     * func(NaN);
		     * // => false
		     */
		    var overEvery = createOver(arrayEvery);

		    /**
		     * Creates a function that checks if **any** of the `predicates` return
		     * truthy when invoked with the arguments it receives.
		     *
		     * Following shorthands are possible for providing predicates.
		     * Pass an `Object` and it will be used as an parameter for `_.matches` to create the predicate.
		     * Pass an `Array` of parameters for `_.matchesProperty` and the predicate will be created using them.
		     *
		     * @static
		     * @memberOf _
		     * @since 4.0.0
		     * @category Util
		     * @param {...(Function|Function[])} [predicates=[_.identity]]
		     *  The predicates to check.
		     * @returns {Function} Returns the new function.
		     * @example
		     *
		     * var func = _.overSome([Boolean, isFinite]);
		     *
		     * func('1');
		     * // => true
		     *
		     * func(null);
		     * // => true
		     *
		     * func(NaN);
		     * // => false
		     *
		     * var matchesFunc = _.overSome([{ 'a': 1 }, { 'a': 2 }])
		     * var matchesPropertyFunc = _.overSome([['a', 1], ['a', 2]])
		     */
		    var overSome = createOver(arraySome);

		    /**
		     * Creates a function that returns the value at `path` of a given object.
		     *
		     * @static
		     * @memberOf _
		     * @since 2.4.0
		     * @category Util
		     * @param {Array|string} path The path of the property to get.
		     * @returns {Function} Returns the new accessor function.
		     * @example
		     *
		     * var objects = [
		     *   { 'a': { 'b': 2 } },
		     *   { 'a': { 'b': 1 } }
		     * ];
		     *
		     * _.map(objects, _.property('a.b'));
		     * // => [2, 1]
		     *
		     * _.map(_.sortBy(objects, _.property(['a', 'b'])), 'a.b');
		     * // => [1, 2]
		     */
		    function property(path) {
		      return isKey(path) ? baseProperty(toKey(path)) : basePropertyDeep(path);
		    }

		    /**
		     * The opposite of `_.property`; this method creates a function that returns
		     * the value at a given path of `object`.
		     *
		     * @static
		     * @memberOf _
		     * @since 3.0.0
		     * @category Util
		     * @param {Object} object The object to query.
		     * @returns {Function} Returns the new accessor function.
		     * @example
		     *
		     * var array = [0, 1, 2],
		     *     object = { 'a': array, 'b': array, 'c': array };
		     *
		     * _.map(['a[2]', 'c[0]'], _.propertyOf(object));
		     * // => [2, 0]
		     *
		     * _.map([['a', '2'], ['c', '0']], _.propertyOf(object));
		     * // => [2, 0]
		     */
		    function propertyOf(object) {
		      return function(path) {
		        return object == null ? undefined$1 : baseGet(object, path);
		      };
		    }

		    /**
		     * Creates an array of numbers (positive and/or negative) progressing from
		     * `start` up to, but not including, `end`. A step of `-1` is used if a negative
		     * `start` is specified without an `end` or `step`. If `end` is not specified,
		     * it's set to `start` with `start` then set to `0`.
		     *
		     * **Note:** JavaScript follows the IEEE-754 standard for resolving
		     * floating-point values which can produce unexpected results.
		     *
		     * @static
		     * @since 0.1.0
		     * @memberOf _
		     * @category Util
		     * @param {number} [start=0] The start of the range.
		     * @param {number} end The end of the range.
		     * @param {number} [step=1] The value to increment or decrement by.
		     * @returns {Array} Returns the range of numbers.
		     * @see _.inRange, _.rangeRight
		     * @example
		     *
		     * _.range(4);
		     * // => [0, 1, 2, 3]
		     *
		     * _.range(-4);
		     * // => [0, -1, -2, -3]
		     *
		     * _.range(1, 5);
		     * // => [1, 2, 3, 4]
		     *
		     * _.range(0, 20, 5);
		     * // => [0, 5, 10, 15]
		     *
		     * _.range(0, -4, -1);
		     * // => [0, -1, -2, -3]
		     *
		     * _.range(1, 4, 0);
		     * // => [1, 1, 1]
		     *
		     * _.range(0);
		     * // => []
		     */
		    var range = createRange();

		    /**
		     * This method is like `_.range` except that it populates values in
		     * descending order.
		     *
		     * @static
		     * @memberOf _
		     * @since 4.0.0
		     * @category Util
		     * @param {number} [start=0] The start of the range.
		     * @param {number} end The end of the range.
		     * @param {number} [step=1] The value to increment or decrement by.
		     * @returns {Array} Returns the range of numbers.
		     * @see _.inRange, _.range
		     * @example
		     *
		     * _.rangeRight(4);
		     * // => [3, 2, 1, 0]
		     *
		     * _.rangeRight(-4);
		     * // => [-3, -2, -1, 0]
		     *
		     * _.rangeRight(1, 5);
		     * // => [4, 3, 2, 1]
		     *
		     * _.rangeRight(0, 20, 5);
		     * // => [15, 10, 5, 0]
		     *
		     * _.rangeRight(0, -4, -1);
		     * // => [-3, -2, -1, 0]
		     *
		     * _.rangeRight(1, 4, 0);
		     * // => [1, 1, 1]
		     *
		     * _.rangeRight(0);
		     * // => []
		     */
		    var rangeRight = createRange(true);

		    /**
		     * This method returns a new empty array.
		     *
		     * @static
		     * @memberOf _
		     * @since 4.13.0
		     * @category Util
		     * @returns {Array} Returns the new empty array.
		     * @example
		     *
		     * var arrays = _.times(2, _.stubArray);
		     *
		     * console.log(arrays);
		     * // => [[], []]
		     *
		     * console.log(arrays[0] === arrays[1]);
		     * // => false
		     */
		    function stubArray() {
		      return [];
		    }

		    /**
		     * This method returns `false`.
		     *
		     * @static
		     * @memberOf _
		     * @since 4.13.0
		     * @category Util
		     * @returns {boolean} Returns `false`.
		     * @example
		     *
		     * _.times(2, _.stubFalse);
		     * // => [false, false]
		     */
		    function stubFalse() {
		      return false;
		    }

		    /**
		     * This method returns a new empty object.
		     *
		     * @static
		     * @memberOf _
		     * @since 4.13.0
		     * @category Util
		     * @returns {Object} Returns the new empty object.
		     * @example
		     *
		     * var objects = _.times(2, _.stubObject);
		     *
		     * console.log(objects);
		     * // => [{}, {}]
		     *
		     * console.log(objects[0] === objects[1]);
		     * // => false
		     */
		    function stubObject() {
		      return {};
		    }

		    /**
		     * This method returns an empty string.
		     *
		     * @static
		     * @memberOf _
		     * @since 4.13.0
		     * @category Util
		     * @returns {string} Returns the empty string.
		     * @example
		     *
		     * _.times(2, _.stubString);
		     * // => ['', '']
		     */
		    function stubString() {
		      return '';
		    }

		    /**
		     * This method returns `true`.
		     *
		     * @static
		     * @memberOf _
		     * @since 4.13.0
		     * @category Util
		     * @returns {boolean} Returns `true`.
		     * @example
		     *
		     * _.times(2, _.stubTrue);
		     * // => [true, true]
		     */
		    function stubTrue() {
		      return true;
		    }

		    /**
		     * Invokes the iteratee `n` times, returning an array of the results of
		     * each invocation. The iteratee is invoked with one argument; (index).
		     *
		     * @static
		     * @since 0.1.0
		     * @memberOf _
		     * @category Util
		     * @param {number} n The number of times to invoke `iteratee`.
		     * @param {Function} [iteratee=_.identity] The function invoked per iteration.
		     * @returns {Array} Returns the array of results.
		     * @example
		     *
		     * _.times(3, String);
		     * // => ['0', '1', '2']
		     *
		     *  _.times(4, _.constant(0));
		     * // => [0, 0, 0, 0]
		     */
		    function times(n, iteratee) {
		      n = toInteger(n);
		      if (n < 1 || n > MAX_SAFE_INTEGER) {
		        return [];
		      }
		      var index = MAX_ARRAY_LENGTH,
		          length = nativeMin(n, MAX_ARRAY_LENGTH);

		      iteratee = getIteratee(iteratee);
		      n -= MAX_ARRAY_LENGTH;

		      var result = baseTimes(length, iteratee);
		      while (++index < n) {
		        iteratee(index);
		      }
		      return result;
		    }

		    /**
		     * Converts `value` to a property path array.
		     *
		     * @static
		     * @memberOf _
		     * @since 4.0.0
		     * @category Util
		     * @param {*} value The value to convert.
		     * @returns {Array} Returns the new property path array.
		     * @example
		     *
		     * _.toPath('a.b.c');
		     * // => ['a', 'b', 'c']
		     *
		     * _.toPath('a[0].b.c');
		     * // => ['a', '0', 'b', 'c']
		     */
		    function toPath(value) {
		      if (isArray(value)) {
		        return arrayMap(value, toKey);
		      }
		      return isSymbol(value) ? [value] : copyArray(stringToPath(toString(value)));
		    }

		    /**
		     * Generates a unique ID. If `prefix` is given, the ID is appended to it.
		     *
		     * @static
		     * @since 0.1.0
		     * @memberOf _
		     * @category Util
		     * @param {string} [prefix=''] The value to prefix the ID with.
		     * @returns {string} Returns the unique ID.
		     * @example
		     *
		     * _.uniqueId('contact_');
		     * // => 'contact_104'
		     *
		     * _.uniqueId();
		     * // => '105'
		     */
		    function uniqueId(prefix) {
		      var id = ++idCounter;
		      return toString(prefix) + id;
		    }

		    /*------------------------------------------------------------------------*/

		    /**
		     * Adds two numbers.
		     *
		     * @static
		     * @memberOf _
		     * @since 3.4.0
		     * @category Math
		     * @param {number} augend The first number in an addition.
		     * @param {number} addend The second number in an addition.
		     * @returns {number} Returns the total.
		     * @example
		     *
		     * _.add(6, 4);
		     * // => 10
		     */
		    var add = createMathOperation(function(augend, addend) {
		      return augend + addend;
		    }, 0);

		    /**
		     * Computes `number` rounded up to `precision`.
		     *
		     * @static
		     * @memberOf _
		     * @since 3.10.0
		     * @category Math
		     * @param {number} number The number to round up.
		     * @param {number} [precision=0] The precision to round up to.
		     * @returns {number} Returns the rounded up number.
		     * @example
		     *
		     * _.ceil(4.006);
		     * // => 5
		     *
		     * _.ceil(6.004, 2);
		     * // => 6.01
		     *
		     * _.ceil(6040, -2);
		     * // => 6100
		     */
		    var ceil = createRound('ceil');

		    /**
		     * Divide two numbers.
		     *
		     * @static
		     * @memberOf _
		     * @since 4.7.0
		     * @category Math
		     * @param {number} dividend The first number in a division.
		     * @param {number} divisor The second number in a division.
		     * @returns {number} Returns the quotient.
		     * @example
		     *
		     * _.divide(6, 4);
		     * // => 1.5
		     */
		    var divide = createMathOperation(function(dividend, divisor) {
		      return dividend / divisor;
		    }, 1);

		    /**
		     * Computes `number` rounded down to `precision`.
		     *
		     * @static
		     * @memberOf _
		     * @since 3.10.0
		     * @category Math
		     * @param {number} number The number to round down.
		     * @param {number} [precision=0] The precision to round down to.
		     * @returns {number} Returns the rounded down number.
		     * @example
		     *
		     * _.floor(4.006);
		     * // => 4
		     *
		     * _.floor(0.046, 2);
		     * // => 0.04
		     *
		     * _.floor(4060, -2);
		     * // => 4000
		     */
		    var floor = createRound('floor');

		    /**
		     * Computes the maximum value of `array`. If `array` is empty or falsey,
		     * `undefined` is returned.
		     *
		     * @static
		     * @since 0.1.0
		     * @memberOf _
		     * @category Math
		     * @param {Array} array The array to iterate over.
		     * @returns {*} Returns the maximum value.
		     * @example
		     *
		     * _.max([4, 2, 8, 6]);
		     * // => 8
		     *
		     * _.max([]);
		     * // => undefined
		     */
		    function max(array) {
		      return (array && array.length)
		        ? baseExtremum(array, identity, baseGt)
		        : undefined$1;
		    }

		    /**
		     * This method is like `_.max` except that it accepts `iteratee` which is
		     * invoked for each element in `array` to generate the criterion by which
		     * the value is ranked. The iteratee is invoked with one argument: (value).
		     *
		     * @static
		     * @memberOf _
		     * @since 4.0.0
		     * @category Math
		     * @param {Array} array The array to iterate over.
		     * @param {Function} [iteratee=_.identity] The iteratee invoked per element.
		     * @returns {*} Returns the maximum value.
		     * @example
		     *
		     * var objects = [{ 'n': 1 }, { 'n': 2 }];
		     *
		     * _.maxBy(objects, function(o) { return o.n; });
		     * // => { 'n': 2 }
		     *
		     * // The `_.property` iteratee shorthand.
		     * _.maxBy(objects, 'n');
		     * // => { 'n': 2 }
		     */
		    function maxBy(array, iteratee) {
		      return (array && array.length)
		        ? baseExtremum(array, getIteratee(iteratee, 2), baseGt)
		        : undefined$1;
		    }

		    /**
		     * Computes the mean of the values in `array`.
		     *
		     * @static
		     * @memberOf _
		     * @since 4.0.0
		     * @category Math
		     * @param {Array} array The array to iterate over.
		     * @returns {number} Returns the mean.
		     * @example
		     *
		     * _.mean([4, 2, 8, 6]);
		     * // => 5
		     */
		    function mean(array) {
		      return baseMean(array, identity);
		    }

		    /**
		     * This method is like `_.mean` except that it accepts `iteratee` which is
		     * invoked for each element in `array` to generate the value to be averaged.
		     * The iteratee is invoked with one argument: (value).
		     *
		     * @static
		     * @memberOf _
		     * @since 4.7.0
		     * @category Math
		     * @param {Array} array The array to iterate over.
		     * @param {Function} [iteratee=_.identity] The iteratee invoked per element.
		     * @returns {number} Returns the mean.
		     * @example
		     *
		     * var objects = [{ 'n': 4 }, { 'n': 2 }, { 'n': 8 }, { 'n': 6 }];
		     *
		     * _.meanBy(objects, function(o) { return o.n; });
		     * // => 5
		     *
		     * // The `_.property` iteratee shorthand.
		     * _.meanBy(objects, 'n');
		     * // => 5
		     */
		    function meanBy(array, iteratee) {
		      return baseMean(array, getIteratee(iteratee, 2));
		    }

		    /**
		     * Computes the minimum value of `array`. If `array` is empty or falsey,
		     * `undefined` is returned.
		     *
		     * @static
		     * @since 0.1.0
		     * @memberOf _
		     * @category Math
		     * @param {Array} array The array to iterate over.
		     * @returns {*} Returns the minimum value.
		     * @example
		     *
		     * _.min([4, 2, 8, 6]);
		     * // => 2
		     *
		     * _.min([]);
		     * // => undefined
		     */
		    function min(array) {
		      return (array && array.length)
		        ? baseExtremum(array, identity, baseLt)
		        : undefined$1;
		    }

		    /**
		     * This method is like `_.min` except that it accepts `iteratee` which is
		     * invoked for each element in `array` to generate the criterion by which
		     * the value is ranked. The iteratee is invoked with one argument: (value).
		     *
		     * @static
		     * @memberOf _
		     * @since 4.0.0
		     * @category Math
		     * @param {Array} array The array to iterate over.
		     * @param {Function} [iteratee=_.identity] The iteratee invoked per element.
		     * @returns {*} Returns the minimum value.
		     * @example
		     *
		     * var objects = [{ 'n': 1 }, { 'n': 2 }];
		     *
		     * _.minBy(objects, function(o) { return o.n; });
		     * // => { 'n': 1 }
		     *
		     * // The `_.property` iteratee shorthand.
		     * _.minBy(objects, 'n');
		     * // => { 'n': 1 }
		     */
		    function minBy(array, iteratee) {
		      return (array && array.length)
		        ? baseExtremum(array, getIteratee(iteratee, 2), baseLt)
		        : undefined$1;
		    }

		    /**
		     * Multiply two numbers.
		     *
		     * @static
		     * @memberOf _
		     * @since 4.7.0
		     * @category Math
		     * @param {number} multiplier The first number in a multiplication.
		     * @param {number} multiplicand The second number in a multiplication.
		     * @returns {number} Returns the product.
		     * @example
		     *
		     * _.multiply(6, 4);
		     * // => 24
		     */
		    var multiply = createMathOperation(function(multiplier, multiplicand) {
		      return multiplier * multiplicand;
		    }, 1);

		    /**
		     * Computes `number` rounded to `precision`.
		     *
		     * @static
		     * @memberOf _
		     * @since 3.10.0
		     * @category Math
		     * @param {number} number The number to round.
		     * @param {number} [precision=0] The precision to round to.
		     * @returns {number} Returns the rounded number.
		     * @example
		     *
		     * _.round(4.006);
		     * // => 4
		     *
		     * _.round(4.006, 2);
		     * // => 4.01
		     *
		     * _.round(4060, -2);
		     * // => 4100
		     */
		    var round = createRound('round');

		    /**
		     * Subtract two numbers.
		     *
		     * @static
		     * @memberOf _
		     * @since 4.0.0
		     * @category Math
		     * @param {number} minuend The first number in a subtraction.
		     * @param {number} subtrahend The second number in a subtraction.
		     * @returns {number} Returns the difference.
		     * @example
		     *
		     * _.subtract(6, 4);
		     * // => 2
		     */
		    var subtract = createMathOperation(function(minuend, subtrahend) {
		      return minuend - subtrahend;
		    }, 0);

		    /**
		     * Computes the sum of the values in `array`.
		     *
		     * @static
		     * @memberOf _
		     * @since 3.4.0
		     * @category Math
		     * @param {Array} array The array to iterate over.
		     * @returns {number} Returns the sum.
		     * @example
		     *
		     * _.sum([4, 2, 8, 6]);
		     * // => 20
		     */
		    function sum(array) {
		      return (array && array.length)
		        ? baseSum(array, identity)
		        : 0;
		    }

		    /**
		     * This method is like `_.sum` except that it accepts `iteratee` which is
		     * invoked for each element in `array` to generate the value to be summed.
		     * The iteratee is invoked with one argument: (value).
		     *
		     * @static
		     * @memberOf _
		     * @since 4.0.0
		     * @category Math
		     * @param {Array} array The array to iterate over.
		     * @param {Function} [iteratee=_.identity] The iteratee invoked per element.
		     * @returns {number} Returns the sum.
		     * @example
		     *
		     * var objects = [{ 'n': 4 }, { 'n': 2 }, { 'n': 8 }, { 'n': 6 }];
		     *
		     * _.sumBy(objects, function(o) { return o.n; });
		     * // => 20
		     *
		     * // The `_.property` iteratee shorthand.
		     * _.sumBy(objects, 'n');
		     * // => 20
		     */
		    function sumBy(array, iteratee) {
		      return (array && array.length)
		        ? baseSum(array, getIteratee(iteratee, 2))
		        : 0;
		    }

		    /*------------------------------------------------------------------------*/

		    // Add methods that return wrapped values in chain sequences.
		    lodash.after = after;
		    lodash.ary = ary;
		    lodash.assign = assign;
		    lodash.assignIn = assignIn;
		    lodash.assignInWith = assignInWith;
		    lodash.assignWith = assignWith;
		    lodash.at = at;
		    lodash.before = before;
		    lodash.bind = bind;
		    lodash.bindAll = bindAll;
		    lodash.bindKey = bindKey;
		    lodash.castArray = castArray;
		    lodash.chain = chain;
		    lodash.chunk = chunk;
		    lodash.compact = compact;
		    lodash.concat = concat;
		    lodash.cond = cond;
		    lodash.conforms = conforms;
		    lodash.constant = constant;
		    lodash.countBy = countBy;
		    lodash.create = create;
		    lodash.curry = curry;
		    lodash.curryRight = curryRight;
		    lodash.debounce = debounce;
		    lodash.defaults = defaults;
		    lodash.defaultsDeep = defaultsDeep;
		    lodash.defer = defer;
		    lodash.delay = delay;
		    lodash.difference = difference;
		    lodash.differenceBy = differenceBy;
		    lodash.differenceWith = differenceWith;
		    lodash.drop = drop;
		    lodash.dropRight = dropRight;
		    lodash.dropRightWhile = dropRightWhile;
		    lodash.dropWhile = dropWhile;
		    lodash.fill = fill;
		    lodash.filter = filter;
		    lodash.flatMap = flatMap;
		    lodash.flatMapDeep = flatMapDeep;
		    lodash.flatMapDepth = flatMapDepth;
		    lodash.flatten = flatten;
		    lodash.flattenDeep = flattenDeep;
		    lodash.flattenDepth = flattenDepth;
		    lodash.flip = flip;
		    lodash.flow = flow;
		    lodash.flowRight = flowRight;
		    lodash.fromPairs = fromPairs;
		    lodash.functions = functions;
		    lodash.functionsIn = functionsIn;
		    lodash.groupBy = groupBy;
		    lodash.initial = initial;
		    lodash.intersection = intersection;
		    lodash.intersectionBy = intersectionBy;
		    lodash.intersectionWith = intersectionWith;
		    lodash.invert = invert;
		    lodash.invertBy = invertBy;
		    lodash.invokeMap = invokeMap;
		    lodash.iteratee = iteratee;
		    lodash.keyBy = keyBy;
		    lodash.keys = keys;
		    lodash.keysIn = keysIn;
		    lodash.map = map;
		    lodash.mapKeys = mapKeys;
		    lodash.mapValues = mapValues;
		    lodash.matches = matches;
		    lodash.matchesProperty = matchesProperty;
		    lodash.memoize = memoize;
		    lodash.merge = merge;
		    lodash.mergeWith = mergeWith;
		    lodash.method = method;
		    lodash.methodOf = methodOf;
		    lodash.mixin = mixin;
		    lodash.negate = negate;
		    lodash.nthArg = nthArg;
		    lodash.omit = omit;
		    lodash.omitBy = omitBy;
		    lodash.once = once;
		    lodash.orderBy = orderBy;
		    lodash.over = over;
		    lodash.overArgs = overArgs;
		    lodash.overEvery = overEvery;
		    lodash.overSome = overSome;
		    lodash.partial = partial;
		    lodash.partialRight = partialRight;
		    lodash.partition = partition;
		    lodash.pick = pick;
		    lodash.pickBy = pickBy;
		    lodash.property = property;
		    lodash.propertyOf = propertyOf;
		    lodash.pull = pull;
		    lodash.pullAll = pullAll;
		    lodash.pullAllBy = pullAllBy;
		    lodash.pullAllWith = pullAllWith;
		    lodash.pullAt = pullAt;
		    lodash.range = range;
		    lodash.rangeRight = rangeRight;
		    lodash.rearg = rearg;
		    lodash.reject = reject;
		    lodash.remove = remove;
		    lodash.rest = rest;
		    lodash.reverse = reverse;
		    lodash.sampleSize = sampleSize;
		    lodash.set = set;
		    lodash.setWith = setWith;
		    lodash.shuffle = shuffle;
		    lodash.slice = slice;
		    lodash.sortBy = sortBy;
		    lodash.sortedUniq = sortedUniq;
		    lodash.sortedUniqBy = sortedUniqBy;
		    lodash.split = split;
		    lodash.spread = spread;
		    lodash.tail = tail;
		    lodash.take = take;
		    lodash.takeRight = takeRight;
		    lodash.takeRightWhile = takeRightWhile;
		    lodash.takeWhile = takeWhile;
		    lodash.tap = tap;
		    lodash.throttle = throttle;
		    lodash.thru = thru;
		    lodash.toArray = toArray;
		    lodash.toPairs = toPairs;
		    lodash.toPairsIn = toPairsIn;
		    lodash.toPath = toPath;
		    lodash.toPlainObject = toPlainObject;
		    lodash.transform = transform;
		    lodash.unary = unary;
		    lodash.union = union;
		    lodash.unionBy = unionBy;
		    lodash.unionWith = unionWith;
		    lodash.uniq = uniq;
		    lodash.uniqBy = uniqBy;
		    lodash.uniqWith = uniqWith;
		    lodash.unset = unset;
		    lodash.unzip = unzip;
		    lodash.unzipWith = unzipWith;
		    lodash.update = update;
		    lodash.updateWith = updateWith;
		    lodash.values = values;
		    lodash.valuesIn = valuesIn;
		    lodash.without = without;
		    lodash.words = words;
		    lodash.wrap = wrap;
		    lodash.xor = xor;
		    lodash.xorBy = xorBy;
		    lodash.xorWith = xorWith;
		    lodash.zip = zip;
		    lodash.zipObject = zipObject;
		    lodash.zipObjectDeep = zipObjectDeep;
		    lodash.zipWith = zipWith;

		    // Add aliases.
		    lodash.entries = toPairs;
		    lodash.entriesIn = toPairsIn;
		    lodash.extend = assignIn;
		    lodash.extendWith = assignInWith;

		    // Add methods to `lodash.prototype`.
		    mixin(lodash, lodash);

		    /*------------------------------------------------------------------------*/

		    // Add methods that return unwrapped values in chain sequences.
		    lodash.add = add;
		    lodash.attempt = attempt;
		    lodash.camelCase = camelCase;
		    lodash.capitalize = capitalize;
		    lodash.ceil = ceil;
		    lodash.clamp = clamp;
		    lodash.clone = clone;
		    lodash.cloneDeep = cloneDeep;
		    lodash.cloneDeepWith = cloneDeepWith;
		    lodash.cloneWith = cloneWith;
		    lodash.conformsTo = conformsTo;
		    lodash.deburr = deburr;
		    lodash.defaultTo = defaultTo;
		    lodash.divide = divide;
		    lodash.endsWith = endsWith;
		    lodash.eq = eq;
		    lodash.escape = escape;
		    lodash.escapeRegExp = escapeRegExp;
		    lodash.every = every;
		    lodash.find = find;
		    lodash.findIndex = findIndex;
		    lodash.findKey = findKey;
		    lodash.findLast = findLast;
		    lodash.findLastIndex = findLastIndex;
		    lodash.findLastKey = findLastKey;
		    lodash.floor = floor;
		    lodash.forEach = forEach;
		    lodash.forEachRight = forEachRight;
		    lodash.forIn = forIn;
		    lodash.forInRight = forInRight;
		    lodash.forOwn = forOwn;
		    lodash.forOwnRight = forOwnRight;
		    lodash.get = get;
		    lodash.gt = gt;
		    lodash.gte = gte;
		    lodash.has = has;
		    lodash.hasIn = hasIn;
		    lodash.head = head;
		    lodash.identity = identity;
		    lodash.includes = includes;
		    lodash.indexOf = indexOf;
		    lodash.inRange = inRange;
		    lodash.invoke = invoke;
		    lodash.isArguments = isArguments;
		    lodash.isArray = isArray;
		    lodash.isArrayBuffer = isArrayBuffer;
		    lodash.isArrayLike = isArrayLike;
		    lodash.isArrayLikeObject = isArrayLikeObject;
		    lodash.isBoolean = isBoolean;
		    lodash.isBuffer = isBuffer;
		    lodash.isDate = isDate;
		    lodash.isElement = isElement;
		    lodash.isEmpty = isEmpty;
		    lodash.isEqual = isEqual;
		    lodash.isEqualWith = isEqualWith;
		    lodash.isError = isError;
		    lodash.isFinite = isFinite;
		    lodash.isFunction = isFunction;
		    lodash.isInteger = isInteger;
		    lodash.isLength = isLength;
		    lodash.isMap = isMap;
		    lodash.isMatch = isMatch;
		    lodash.isMatchWith = isMatchWith;
		    lodash.isNaN = isNaN;
		    lodash.isNative = isNative;
		    lodash.isNil = isNil;
		    lodash.isNull = isNull;
		    lodash.isNumber = isNumber;
		    lodash.isObject = isObject;
		    lodash.isObjectLike = isObjectLike;
		    lodash.isPlainObject = isPlainObject;
		    lodash.isRegExp = isRegExp;
		    lodash.isSafeInteger = isSafeInteger;
		    lodash.isSet = isSet;
		    lodash.isString = isString;
		    lodash.isSymbol = isSymbol;
		    lodash.isTypedArray = isTypedArray;
		    lodash.isUndefined = isUndefined;
		    lodash.isWeakMap = isWeakMap;
		    lodash.isWeakSet = isWeakSet;
		    lodash.join = join;
		    lodash.kebabCase = kebabCase;
		    lodash.last = last;
		    lodash.lastIndexOf = lastIndexOf;
		    lodash.lowerCase = lowerCase;
		    lodash.lowerFirst = lowerFirst;
		    lodash.lt = lt;
		    lodash.lte = lte;
		    lodash.max = max;
		    lodash.maxBy = maxBy;
		    lodash.mean = mean;
		    lodash.meanBy = meanBy;
		    lodash.min = min;
		    lodash.minBy = minBy;
		    lodash.stubArray = stubArray;
		    lodash.stubFalse = stubFalse;
		    lodash.stubObject = stubObject;
		    lodash.stubString = stubString;
		    lodash.stubTrue = stubTrue;
		    lodash.multiply = multiply;
		    lodash.nth = nth;
		    lodash.noConflict = noConflict;
		    lodash.noop = noop;
		    lodash.now = now;
		    lodash.pad = pad;
		    lodash.padEnd = padEnd;
		    lodash.padStart = padStart;
		    lodash.parseInt = parseInt;
		    lodash.random = random;
		    lodash.reduce = reduce;
		    lodash.reduceRight = reduceRight;
		    lodash.repeat = repeat;
		    lodash.replace = replace;
		    lodash.result = result;
		    lodash.round = round;
		    lodash.runInContext = runInContext;
		    lodash.sample = sample;
		    lodash.size = size;
		    lodash.snakeCase = snakeCase;
		    lodash.some = some;
		    lodash.sortedIndex = sortedIndex;
		    lodash.sortedIndexBy = sortedIndexBy;
		    lodash.sortedIndexOf = sortedIndexOf;
		    lodash.sortedLastIndex = sortedLastIndex;
		    lodash.sortedLastIndexBy = sortedLastIndexBy;
		    lodash.sortedLastIndexOf = sortedLastIndexOf;
		    lodash.startCase = startCase;
		    lodash.startsWith = startsWith;
		    lodash.subtract = subtract;
		    lodash.sum = sum;
		    lodash.sumBy = sumBy;
		    lodash.template = template;
		    lodash.times = times;
		    lodash.toFinite = toFinite;
		    lodash.toInteger = toInteger;
		    lodash.toLength = toLength;
		    lodash.toLower = toLower;
		    lodash.toNumber = toNumber;
		    lodash.toSafeInteger = toSafeInteger;
		    lodash.toString = toString;
		    lodash.toUpper = toUpper;
		    lodash.trim = trim;
		    lodash.trimEnd = trimEnd;
		    lodash.trimStart = trimStart;
		    lodash.truncate = truncate;
		    lodash.unescape = unescape;
		    lodash.uniqueId = uniqueId;
		    lodash.upperCase = upperCase;
		    lodash.upperFirst = upperFirst;

		    // Add aliases.
		    lodash.each = forEach;
		    lodash.eachRight = forEachRight;
		    lodash.first = head;

		    mixin(lodash, (function() {
		      var source = {};
		      baseForOwn(lodash, function(func, methodName) {
		        if (!hasOwnProperty.call(lodash.prototype, methodName)) {
		          source[methodName] = func;
		        }
		      });
		      return source;
		    }()), { 'chain': false });

		    /*------------------------------------------------------------------------*/

		    /**
		     * The semantic version number.
		     *
		     * @static
		     * @memberOf _
		     * @type {string}
		     */
		    lodash.VERSION = VERSION;

		    // Assign default placeholders.
		    arrayEach(['bind', 'bindKey', 'curry', 'curryRight', 'partial', 'partialRight'], function(methodName) {
		      lodash[methodName].placeholder = lodash;
		    });

		    // Add `LazyWrapper` methods for `_.drop` and `_.take` variants.
		    arrayEach(['drop', 'take'], function(methodName, index) {
		      LazyWrapper.prototype[methodName] = function(n) {
		        n = n === undefined$1 ? 1 : nativeMax(toInteger(n), 0);

		        var result = (this.__filtered__ && !index)
		          ? new LazyWrapper(this)
		          : this.clone();

		        if (result.__filtered__) {
		          result.__takeCount__ = nativeMin(n, result.__takeCount__);
		        } else {
		          result.__views__.push({
		            'size': nativeMin(n, MAX_ARRAY_LENGTH),
		            'type': methodName + (result.__dir__ < 0 ? 'Right' : '')
		          });
		        }
		        return result;
		      };

		      LazyWrapper.prototype[methodName + 'Right'] = function(n) {
		        return this.reverse()[methodName](n).reverse();
		      };
		    });

		    // Add `LazyWrapper` methods that accept an `iteratee` value.
		    arrayEach(['filter', 'map', 'takeWhile'], function(methodName, index) {
		      var type = index + 1,
		          isFilter = type == LAZY_FILTER_FLAG || type == LAZY_WHILE_FLAG;

		      LazyWrapper.prototype[methodName] = function(iteratee) {
		        var result = this.clone();
		        result.__iteratees__.push({
		          'iteratee': getIteratee(iteratee, 3),
		          'type': type
		        });
		        result.__filtered__ = result.__filtered__ || isFilter;
		        return result;
		      };
		    });

		    // Add `LazyWrapper` methods for `_.head` and `_.last`.
		    arrayEach(['head', 'last'], function(methodName, index) {
		      var takeName = 'take' + (index ? 'Right' : '');

		      LazyWrapper.prototype[methodName] = function() {
		        return this[takeName](1).value()[0];
		      };
		    });

		    // Add `LazyWrapper` methods for `_.initial` and `_.tail`.
		    arrayEach(['initial', 'tail'], function(methodName, index) {
		      var dropName = 'drop' + (index ? '' : 'Right');

		      LazyWrapper.prototype[methodName] = function() {
		        return this.__filtered__ ? new LazyWrapper(this) : this[dropName](1);
		      };
		    });

		    LazyWrapper.prototype.compact = function() {
		      return this.filter(identity);
		    };

		    LazyWrapper.prototype.find = function(predicate) {
		      return this.filter(predicate).head();
		    };

		    LazyWrapper.prototype.findLast = function(predicate) {
		      return this.reverse().find(predicate);
		    };

		    LazyWrapper.prototype.invokeMap = baseRest(function(path, args) {
		      if (typeof path == 'function') {
		        return new LazyWrapper(this);
		      }
		      return this.map(function(value) {
		        return baseInvoke(value, path, args);
		      });
		    });

		    LazyWrapper.prototype.reject = function(predicate) {
		      return this.filter(negate(getIteratee(predicate)));
		    };

		    LazyWrapper.prototype.slice = function(start, end) {
		      start = toInteger(start);

		      var result = this;
		      if (result.__filtered__ && (start > 0 || end < 0)) {
		        return new LazyWrapper(result);
		      }
		      if (start < 0) {
		        result = result.takeRight(-start);
		      } else if (start) {
		        result = result.drop(start);
		      }
		      if (end !== undefined$1) {
		        end = toInteger(end);
		        result = end < 0 ? result.dropRight(-end) : result.take(end - start);
		      }
		      return result;
		    };

		    LazyWrapper.prototype.takeRightWhile = function(predicate) {
		      return this.reverse().takeWhile(predicate).reverse();
		    };

		    LazyWrapper.prototype.toArray = function() {
		      return this.take(MAX_ARRAY_LENGTH);
		    };

		    // Add `LazyWrapper` methods to `lodash.prototype`.
		    baseForOwn(LazyWrapper.prototype, function(func, methodName) {
		      var checkIteratee = /^(?:filter|find|map|reject)|While$/.test(methodName),
		          isTaker = /^(?:head|last)$/.test(methodName),
		          lodashFunc = lodash[isTaker ? ('take' + (methodName == 'last' ? 'Right' : '')) : methodName],
		          retUnwrapped = isTaker || /^find/.test(methodName);

		      if (!lodashFunc) {
		        return;
		      }
		      lodash.prototype[methodName] = function() {
		        var value = this.__wrapped__,
		            args = isTaker ? [1] : arguments,
		            isLazy = value instanceof LazyWrapper,
		            iteratee = args[0],
		            useLazy = isLazy || isArray(value);

		        var interceptor = function(value) {
		          var result = lodashFunc.apply(lodash, arrayPush([value], args));
		          return (isTaker && chainAll) ? result[0] : result;
		        };

		        if (useLazy && checkIteratee && typeof iteratee == 'function' && iteratee.length != 1) {
		          // Avoid lazy use if the iteratee has a "length" value other than `1`.
		          isLazy = useLazy = false;
		        }
		        var chainAll = this.__chain__,
		            isHybrid = !!this.__actions__.length,
		            isUnwrapped = retUnwrapped && !chainAll,
		            onlyLazy = isLazy && !isHybrid;

		        if (!retUnwrapped && useLazy) {
		          value = onlyLazy ? value : new LazyWrapper(this);
		          var result = func.apply(value, args);
		          result.__actions__.push({ 'func': thru, 'args': [interceptor], 'thisArg': undefined$1 });
		          return new LodashWrapper(result, chainAll);
		        }
		        if (isUnwrapped && onlyLazy) {
		          return func.apply(this, args);
		        }
		        result = this.thru(interceptor);
		        return isUnwrapped ? (isTaker ? result.value()[0] : result.value()) : result;
		      };
		    });

		    // Add `Array` methods to `lodash.prototype`.
		    arrayEach(['pop', 'push', 'shift', 'sort', 'splice', 'unshift'], function(methodName) {
		      var func = arrayProto[methodName],
		          chainName = /^(?:push|sort|unshift)$/.test(methodName) ? 'tap' : 'thru',
		          retUnwrapped = /^(?:pop|shift)$/.test(methodName);

		      lodash.prototype[methodName] = function() {
		        var args = arguments;
		        if (retUnwrapped && !this.__chain__) {
		          var value = this.value();
		          return func.apply(isArray(value) ? value : [], args);
		        }
		        return this[chainName](function(value) {
		          return func.apply(isArray(value) ? value : [], args);
		        });
		      };
		    });

		    // Map minified method names to their real names.
		    baseForOwn(LazyWrapper.prototype, function(func, methodName) {
		      var lodashFunc = lodash[methodName];
		      if (lodashFunc) {
		        var key = lodashFunc.name + '';
		        if (!hasOwnProperty.call(realNames, key)) {
		          realNames[key] = [];
		        }
		        realNames[key].push({ 'name': methodName, 'func': lodashFunc });
		      }
		    });

		    realNames[createHybrid(undefined$1, WRAP_BIND_KEY_FLAG).name] = [{
		      'name': 'wrapper',
		      'func': undefined$1
		    }];

		    // Add methods to `LazyWrapper`.
		    LazyWrapper.prototype.clone = lazyClone;
		    LazyWrapper.prototype.reverse = lazyReverse;
		    LazyWrapper.prototype.value = lazyValue;

		    // Add chain sequence methods to the `lodash` wrapper.
		    lodash.prototype.at = wrapperAt;
		    lodash.prototype.chain = wrapperChain;
		    lodash.prototype.commit = wrapperCommit;
		    lodash.prototype.next = wrapperNext;
		    lodash.prototype.plant = wrapperPlant;
		    lodash.prototype.reverse = wrapperReverse;
		    lodash.prototype.toJSON = lodash.prototype.valueOf = lodash.prototype.value = wrapperValue;

		    // Add lazy aliases.
		    lodash.prototype.first = lodash.prototype.head;

		    if (symIterator) {
		      lodash.prototype[symIterator] = wrapperToIterator;
		    }
		    return lodash;
		  });

		  /*--------------------------------------------------------------------------*/

		  // Export lodash.
		  var _ = runInContext();

		  // Some AMD build optimizers, like r.js, check for condition patterns like:
		  if (freeModule) {
		    // Export for Node.js.
		    (freeModule.exports = _)._ = _;
		    // Export for CommonJS support.
		    freeExports._ = _;
		  }
		  else {
		    // Export to the global object.
		    root._ = _;
		  }
		}.call(commonjsGlobal));
	} (lodash, lodashExports));

	const RUST_U64_MAX = () => {
	    return new anchor.BN('18446744073709551615');
	};
	const RUST_I64_MAX = () => {
	    return new anchor.BN('9223372036854775807');
	};
	const RUST_I64_MIN = () => {
	    return new anchor.BN('-9223372036854775807');
	};
	const OPENBOOK_PROGRAM_ID = {
	    devnet: new require$$0$1.PublicKey('EoTcMgcDRTJVZDMZWBoU6rhYHZfkNTVEAfz3uUJRcYGj'),
	    'mainnet-beta': new require$$0$1.PublicKey('srmqPvymJeFKQ4zGQed1GFppgkRHL9kaELCbyksJtPX'),
	};
	const MANGO_V4_ID = {
	    testnet: new require$$0$1.PublicKey('4MangoMjqJ2firMokCjjGgoK8d4MXcrgL7XJaL3w6fVg'),
	    devnet: new require$$0$1.PublicKey('4MangoMjqJ2firMokCjjGgoK8d4MXcrgL7XJaL3w6fVg'),
	    'mainnet-beta': new require$$0$1.PublicKey('4MangoMjqJ2firMokCjjGgoK8d4MXcrgL7XJaL3w6fVg'),
	};

	class I80F48Dto {
	    val;
	    constructor(val) {
	        this.val = val;
	    }
	}
	// TODO - this whole class is inefficient; consider optimizing
	class I80F48 {
	    /**
	    This is represented by a 128 bit signed integer underneath
	    The first 80 bits are treated as an integer and last 48 bits are treated as fractional part after binary point
	    It's possible to think of an I80F48 as an i128 divided by 2 ^ 40
	  
	    Read up on how fixed point math works: https://inst.eecs.berkeley.edu/~cs61c/sp06/handout/fixedpt.html
	    Read up on how 2s complement works: https://en.wikipedia.org/wiki/Two%27s_complement
	     */
	    static MAX_SIZE = 128;
	    static FRACTIONS = 48;
	    static MULTIPLIER_BIG = new Big(2).pow(I80F48.FRACTIONS);
	    static MULTIPLIER_BN = new bnExports(2).pow(new bnExports(I80F48.FRACTIONS));
	    static MULTIPLIER_NUMBER = Math.pow(2, I80F48.FRACTIONS);
	    static MAX_BN = new bnExports(2)
	        .pow(new bnExports(I80F48.MAX_SIZE))
	        .div(new bnExports(2))
	        .sub(new bnExports(1));
	    static MIN_BN = new bnExports(2)
	        .pow(new bnExports(I80F48.MAX_SIZE))
	        .div(new bnExports(2))
	        .neg();
	    data; // This is i128 => array of 16 bytes
	    static from(dto) {
	        return new I80F48(dto.val);
	    }
	    constructor(data) {
	        if (data.lt(I80F48.MIN_BN) || data.gt(I80F48.MAX_BN)) {
	            throw new Error('Number out of range');
	        }
	        this.data = data;
	    }
	    static fromNumber(x) {
	        const int_part = Math.trunc(x);
	        const v = new bnExports(int_part.toFixed(0)).iushln(48);
	        v.iadd(new bnExports((x - int_part) * I80F48.MULTIPLIER_NUMBER));
	        return new I80F48(v);
	    }
	    static fromNumberOrUndef(x) {
	        return x === undefined ? undefined : I80F48.fromNumber(x);
	    }
	    static fromOptionalString(x) {
	        return x ? I80F48.fromString(x) : undefined;
	    }
	    static fromString(x) {
	        const initialValue = new Big(x).times(I80F48.MULTIPLIER_BIG);
	        const fixedPointValue = new bnExports(initialValue.round().toFixed());
	        return new I80F48(fixedPointValue);
	    }
	    static fromI64(x) {
	        return new I80F48(x.ushln(48));
	    }
	    static fromU64(x) {
	        return new I80F48(x.ushln(48));
	    }
	    toTwos() {
	        return this.data.toTwos(I80F48.MAX_SIZE);
	    }
	    toString() {
	        return this.toBig().toFixed();
	    }
	    /**
	     * The number will be rounded first for UI sensibilities, then toFixed
	     */
	    toFixed(decimals) {
	        return this.toBig().round(14).toFixed(decimals);
	    }
	    toLocaleString(locales, options) {
	        return this.toNumber().toLocaleString(locales, options);
	    }
	    toBig() {
	        return new Big(this.data.toString()).div(I80F48.MULTIPLIER_BIG);
	    }
	    static fromBig(x) {
	        return new I80F48(new bnExports(x.mul(I80F48.MULTIPLIER_BIG).round().toFixed()));
	    }
	    toNumber() {
	        return this.toBig().toNumber();
	    }
	    static fromArray(src) {
	        if (src.length !== 16) {
	            throw new Error('Uint8Array must be of length 16');
	        }
	        return new I80F48(new bnExports(src, 'le').fromTwos(I80F48.MAX_SIZE));
	    }
	    toArray() {
	        return new Uint8Array(this.data.toTwos(I80F48.MAX_SIZE).toArray('le', 16));
	    }
	    toArrayLike(ArrayType, endian, length) {
	        return this.data
	            .toTwos(I80F48.MAX_SIZE)
	            .toArrayLike(ArrayType, endian, length);
	    }
	    getData() {
	        return this.data;
	    }
	    getBinaryLayout() {
	        return this.data
	            .toTwos(I80F48.MAX_SIZE)
	            .toString(2, I80F48.MAX_SIZE)
	            .replace(/-/g, '');
	    }
	    add(x) {
	        return new I80F48(this.data.add(x.getData()));
	    }
	    sub(x) {
	        return new I80F48(this.data.sub(x.getData()));
	    }
	    iadd(x) {
	        this.data.iadd(x.getData());
	        return this;
	    }
	    isub(x) {
	        this.data.isub(x.getData());
	        return this;
	    }
	    floor() {
	        // Low IQ method
	        return I80F48.fromBig(this.toBig().round(undefined, 0));
	        // return new I80F48(this.data.shrn(I80F48.FRACTIONS).shln(I80F48.FRACTIONS));
	    }
	    ceil() {
	        // Low IQ method, 3 -> round up
	        return I80F48.fromBig(this.toBig().round(undefined, 3));
	        // const frac = this.data.maskn(I80F48.FRACTIONS);
	        // if (frac.eq(ZERO_BN)) {
	        //   return this;
	        // } else {
	        //   return this.floor().add(ONE_I80F48);
	        // }
	    }
	    frac() {
	        // TODO verify this works for negative numbers
	        return new I80F48(this.data.maskn(I80F48.FRACTIONS));
	    }
	    /**
	     * Multiply the two and shift
	     */
	    mul(x) {
	        return new I80F48(this.data.mul(x.data).iushrn(I80F48.FRACTIONS));
	    }
	    imul(x) {
	        this.data.imul(x.getData()).iushrn(I80F48.FRACTIONS);
	        return this;
	    }
	    div(x) {
	        return new I80F48(this.data.ushln(I80F48.FRACTIONS).div(x.data));
	    }
	    idiv(x) {
	        this.data = this.data.iushln(I80F48.FRACTIONS).div(x.data);
	        return this;
	    }
	    gt(x) {
	        return this.data.gt(x.getData());
	    }
	    lt(x) {
	        return this.data.lt(x.getData());
	    }
	    gte(x) {
	        return this.data.gte(x.getData());
	    }
	    lte(x) {
	        return this.data.lte(x.getData());
	    }
	    eq(x) {
	        // TODO make sure this works when they're diff signs or 0
	        return this.data.eq(x.getData());
	    }
	    cmp(x) {
	        // TODO make sure this works when they're diff signs or 0
	        return this.data.cmp(x.getData());
	    }
	    neg() {
	        return this.mul(_NEG_ONE_I80F48);
	    }
	    isPos() {
	        return this.gt(_ZERO_I80F48);
	    }
	    isNeg() {
	        return this.data.isNeg();
	    }
	    isZero() {
	        return this.eq(_ZERO_I80F48);
	    }
	    min(x) {
	        return this.lte(x) ? this : x;
	    }
	    max(x) {
	        return this.gte(x) ? this : x;
	    }
	    abs() {
	        if (this.isNeg()) {
	            return this.neg();
	        }
	        else {
	            return this;
	        }
	    }
	}
	/** @internal */
	const _ZERO_I80F48 = I80F48.fromNumber(0);
	/** @internal */
	const _NEG_ONE_I80F48 = I80F48.fromNumber(-1);
	function ONE_I80F48() {
	    return I80F48.fromNumber(1);
	}
	function ZERO_I80F48() {
	    return I80F48.fromNumber(0);
	}
	function HUNDRED_I80F48() {
	    return I80F48.fromNumber(100);
	}
	function MAX_I80F48() {
	    return new I80F48(I80F48.MAX_BN);
	}

	///
	/// numeric helpers
	///
	const U64_MAX_BN = new bnExports('18446744073709551615');
	const I64_MAX_BN = new bnExports('9223372036854775807').toTwos(64);
	function toNativeI80F48ForQuote(uiAmount) {
	    return I80F48.fromNumber(uiAmount * Math.pow(10, 6));
	}
	function toNativeI80F48(uiAmount, decimals) {
	    return I80F48.fromNumber(uiAmount * Math.pow(10, decimals));
	}
	function toNative(uiAmount, decimals) {
	    return new bnExports((uiAmount * Math.pow(10, decimals)).toFixed(0));
	}
	function toUiDecimals(nativeAmount, decimals) {
	    // TODO: remove BN and upgrade to bigint https://github.com/solana-labs/solana/issues/27440
	    if (nativeAmount instanceof bnExports) {
	        nativeAmount = I80F48.fromU64(nativeAmount);
	    }
	    if (nativeAmount instanceof I80F48) {
	        return nativeAmount
	            .div(I80F48.fromNumber(Math.pow(10, decimals)))
	            .toNumber();
	    }
	    return nativeAmount / Math.pow(10, decimals);
	}
	const QUOTE_DECIMALS = 6;
	function toUiDecimalsForQuote(nativeAmount) {
	    return toUiDecimals(nativeAmount, QUOTE_DECIMALS);
	}
	function toUiI80F48(nativeAmount, decimals) {
	    return nativeAmount.div(I80F48.fromNumber(Math.pow(10, decimals)));
	}
	///
	/// web3js extensions
	///
	/**
	 * Get the address of the associated token account for a given mint and owner
	 *
	 * @param mint                     Token mint account
	 * @param owner                    Owner of the new account
	 * @param allowOwnerOffCurve       Allow the owner account to be a PDA (Program Derived Address)
	 * @param programId                SPL Token program account
	 * @param associatedTokenProgramId SPL Associated Token program account
	 *
	 * @return Address of the associated token account
	 */
	async function getAssociatedTokenAddress(mint, owner, allowOwnerOffCurve = false, programId = splToken$1.TOKEN_PROGRAM_ID, associatedTokenProgramId = splToken$1.ASSOCIATED_TOKEN_PROGRAM_ID) {
	    if (!allowOwnerOffCurve && !require$$0$1.PublicKey.isOnCurve(owner.toBuffer()))
	        throw new Error('TokenOwnerOffCurve!');
	    const [address] = await require$$0$1.PublicKey.findProgramAddress([owner.toBuffer(), programId.toBuffer(), mint.toBuffer()], associatedTokenProgramId);
	    return address;
	}
	async function createAssociatedTokenAccountIdempotentInstruction(payer, owner, mint) {
	    const account = await getAssociatedTokenAddress(mint, owner);
	    return new require$$0$1.TransactionInstruction({
	        keys: [
	            { pubkey: payer, isSigner: true, isWritable: true },
	            { pubkey: account, isSigner: false, isWritable: true },
	            { pubkey: owner, isSigner: false, isWritable: false },
	            { pubkey: mint, isSigner: false, isWritable: false },
	            {
	                pubkey: require$$0$1.SystemProgram.programId,
	                isSigner: false,
	                isWritable: false,
	            },
	            { pubkey: splToken$1.TOKEN_PROGRAM_ID, isSigner: false, isWritable: false },
	        ],
	        programId: splToken$1.ASSOCIATED_TOKEN_PROGRAM_ID,
	        data: Buffer.from([0x1]),
	    });
	}
	async function buildVersionedTx(provider, ix, additionalSigners = [], alts = []) {
	    const message = require$$0$1.MessageV0.compile({
	        payerKey: provider.wallet.publicKey,
	        instructions: ix,
	        recentBlockhash: (await provider.connection.getLatestBlockhash()).blockhash,
	        addressLookupTableAccounts: alts,
	    });
	    const vTx = new require$$0$1.VersionedTransaction(message);
	    vTx.sign([
	        provider.wallet.payer,
	        ...additionalSigners,
	    ]);
	    return vTx;
	}

	class Bank {
	    publicKey;
	    group;
	    mint;
	    vault;
	    oracle;
	    stablePriceModel;
	    indexLastUpdated;
	    bankRateLastUpdated;
	    tokenIndex;
	    mintDecimals;
	    bankNum;
	    minVaultToDepositsRatio;
	    netBorrowLimitWindowSizeTs;
	    lastNetBorrowsWindowStartTs;
	    netBorrowLimitPerWindowQuote;
	    netBorrowsInWindow;
	    borrowWeightScaleStartQuote;
	    depositWeightScaleStartQuote;
	    reduceOnly;
	    name;
	    oracleConfig;
	    depositIndex;
	    borrowIndex;
	    indexedDeposits;
	    indexedBorrows;
	    avgUtilization;
	    adjustmentFactor;
	    maxRate;
	    rate0;
	    rate1;
	    util0;
	    util1;
	    _price;
	    _uiPrice;
	    _oracleLastUpdatedSlot;
	    collectedFeesNative;
	    loanFeeRate;
	    loanOriginationFeeRate;
	    initAssetWeight;
	    maintAssetWeight;
	    initLiabWeight;
	    maintLiabWeight;
	    liquidationFee;
	    dust;
	    static from(publicKey, obj) {
	        return new Bank(publicKey, obj.group, obj.name, obj.mint, obj.vault, obj.oracle, obj.oracleConfig, obj.stablePriceModel, obj.depositIndex, obj.borrowIndex, obj.indexedDeposits, obj.indexedBorrows, obj.indexLastUpdated, obj.bankRateLastUpdated, obj.avgUtilization, obj.adjustmentFactor, obj.util0, obj.rate0, obj.util1, obj.rate1, obj.maxRate, obj.collectedFeesNative, obj.loanOriginationFeeRate, obj.loanFeeRate, obj.maintAssetWeight, obj.initAssetWeight, obj.maintLiabWeight, obj.initLiabWeight, obj.liquidationFee, obj.dust, obj.flashLoanTokenAccountInitial, obj.flashLoanApprovedAmount, obj.tokenIndex, obj.mintDecimals, obj.bankNum, obj.minVaultToDepositsRatio, obj.netBorrowLimitWindowSizeTs, obj.lastNetBorrowsWindowStartTs, obj.netBorrowLimitPerWindowQuote, obj.netBorrowsInWindow, obj.borrowWeightScaleStartQuote, obj.depositWeightScaleStartQuote, obj.reduceOnly == 1);
	    }
	    constructor(publicKey, group, name, mint, vault, oracle, oracleConfig, stablePriceModel, depositIndex, borrowIndex, indexedDeposits, indexedBorrows, indexLastUpdated, bankRateLastUpdated, avgUtilization, adjustmentFactor, util0, rate0, util1, rate1, maxRate, collectedFeesNative, loanOriginationFeeRate, loanFeeRate, maintAssetWeight, initAssetWeight, maintLiabWeight, initLiabWeight, liquidationFee, dust, flashLoanTokenAccountInitial, flashLoanApprovedAmount, tokenIndex, mintDecimals, bankNum, minVaultToDepositsRatio, netBorrowLimitWindowSizeTs, lastNetBorrowsWindowStartTs, netBorrowLimitPerWindowQuote, netBorrowsInWindow, borrowWeightScaleStartQuote, depositWeightScaleStartQuote, reduceOnly) {
	        this.publicKey = publicKey;
	        this.group = group;
	        this.mint = mint;
	        this.vault = vault;
	        this.oracle = oracle;
	        this.stablePriceModel = stablePriceModel;
	        this.indexLastUpdated = indexLastUpdated;
	        this.bankRateLastUpdated = bankRateLastUpdated;
	        this.tokenIndex = tokenIndex;
	        this.mintDecimals = mintDecimals;
	        this.bankNum = bankNum;
	        this.minVaultToDepositsRatio = minVaultToDepositsRatio;
	        this.netBorrowLimitWindowSizeTs = netBorrowLimitWindowSizeTs;
	        this.lastNetBorrowsWindowStartTs = lastNetBorrowsWindowStartTs;
	        this.netBorrowLimitPerWindowQuote = netBorrowLimitPerWindowQuote;
	        this.netBorrowsInWindow = netBorrowsInWindow;
	        this.borrowWeightScaleStartQuote = borrowWeightScaleStartQuote;
	        this.depositWeightScaleStartQuote = depositWeightScaleStartQuote;
	        this.reduceOnly = reduceOnly;
	        this.name = utf8.decode(new Uint8Array(name)).split('\x00')[0];
	        this.oracleConfig = {
	            confFilter: I80F48.from(oracleConfig.confFilter),
	            maxStalenessSlots: oracleConfig.maxStalenessSlots,
	        };
	        this.depositIndex = I80F48.from(depositIndex);
	        this.borrowIndex = I80F48.from(borrowIndex);
	        this.indexedDeposits = I80F48.from(indexedDeposits);
	        this.indexedBorrows = I80F48.from(indexedBorrows);
	        this.avgUtilization = I80F48.from(avgUtilization);
	        this.adjustmentFactor = I80F48.from(adjustmentFactor);
	        this.maxRate = I80F48.from(maxRate);
	        this.util0 = I80F48.from(util0);
	        this.rate0 = I80F48.from(rate0);
	        this.util1 = I80F48.from(util1);
	        this.rate1 = I80F48.from(rate1);
	        this.collectedFeesNative = I80F48.from(collectedFeesNative);
	        this.loanFeeRate = I80F48.from(loanFeeRate);
	        this.loanOriginationFeeRate = I80F48.from(loanOriginationFeeRate);
	        this.maintAssetWeight = I80F48.from(maintAssetWeight);
	        this.initAssetWeight = I80F48.from(initAssetWeight);
	        this.maintLiabWeight = I80F48.from(maintLiabWeight);
	        this.initLiabWeight = I80F48.from(initLiabWeight);
	        this.liquidationFee = I80F48.from(liquidationFee);
	        this.dust = I80F48.from(dust);
	        this._price = undefined;
	        this._uiPrice = undefined;
	        this._oracleLastUpdatedSlot = undefined;
	    }
	    toString() {
	        return ('Bank ' +
	            '\n public key - ' +
	            this.publicKey.toBase58() +
	            '\n token index - ' +
	            this.tokenIndex +
	            '\n token name - ' +
	            this.name +
	            '\n vault - ' +
	            this.vault.toBase58() +
	            '\n mintDecimals - ' +
	            this.mintDecimals +
	            '\n oracle - ' +
	            this.oracle.toBase58() +
	            '\n price - ' +
	            this._price?.toString() +
	            '\n uiPrice - ' +
	            this._uiPrice +
	            '\n deposit index - ' +
	            this.depositIndex.toString() +
	            '\n borrow index - ' +
	            this.borrowIndex.toString() +
	            '\n indexedDeposits - ' +
	            this.indexedDeposits.toString() +
	            '\n indexedBorrows - ' +
	            this.indexedBorrows.toString() +
	            '\n indexLastUpdated - ' +
	            new Date(this.indexLastUpdated.toNumber() * 1000) +
	            '\n bankRateLastUpdated - ' +
	            new Date(this.bankRateLastUpdated.toNumber() * 1000) +
	            '\n avgUtilization - ' +
	            this.avgUtilization.toString() +
	            '\n adjustmentFactor - ' +
	            this.adjustmentFactor.toString() +
	            '\n maxRate - ' +
	            this.maxRate.toString() +
	            '\n util0 - ' +
	            this.util0.toString() +
	            '\n rate0 - ' +
	            this.rate0.toString() +
	            '\n util1 - ' +
	            this.util1.toString() +
	            '\n rate1 - ' +
	            this.rate1.toString() +
	            '\n loanFeeRate - ' +
	            this.loanFeeRate.toString() +
	            '\n loanOriginationFeeRate - ' +
	            this.loanOriginationFeeRate.toString() +
	            '\n maintAssetWeight - ' +
	            this.maintAssetWeight.toString() +
	            '\n initAssetWeight - ' +
	            this.initAssetWeight.toString() +
	            '\n maintLiabWeight - ' +
	            this.maintLiabWeight.toString() +
	            '\n initLiabWeight - ' +
	            this.initLiabWeight.toString() +
	            '\n liquidationFee - ' +
	            this.liquidationFee.toString() +
	            '\n uiDeposits() - ' +
	            this.uiDeposits() +
	            '\n uiBorrows() - ' +
	            this.uiBorrows() +
	            '\n getDepositRate() - ' +
	            this.getDepositRate().toString() +
	            '\n getBorrowRate() - ' +
	            this.getBorrowRate().toString());
	    }
	    scaledInitAssetWeight(price) {
	        const depositsQuote = this.nativeDeposits().mul(price);
	        if (this.depositWeightScaleStartQuote >= Number.MAX_SAFE_INTEGER ||
	            depositsQuote.lte(I80F48.fromNumber(this.depositWeightScaleStartQuote))) {
	            return this.initAssetWeight;
	        }
	        return this.initAssetWeight.mul(I80F48.fromNumber(this.depositWeightScaleStartQuote).div(depositsQuote));
	    }
	    scaledInitLiabWeight(price) {
	        const borrowsQuote = this.nativeBorrows().mul(price);
	        if (this.borrowWeightScaleStartQuote >= Number.MAX_SAFE_INTEGER ||
	            borrowsQuote.lte(I80F48.fromNumber(this.borrowWeightScaleStartQuote))) {
	            return this.initLiabWeight;
	        }
	        return this.initLiabWeight.mul(borrowsQuote.div(I80F48.fromNumber(this.borrowWeightScaleStartQuote)));
	    }
	    get price() {
	        if (!this._price) {
	            throw new Error(`Undefined price for bank ${this.publicKey} with tokenIndex ${this.tokenIndex}!`);
	        }
	        return this._price;
	    }
	    get uiPrice() {
	        if (!this._uiPrice) {
	            throw new Error(`Undefined uiPrice for bank ${this.publicKey} with tokenIndex ${this.tokenIndex}!`);
	        }
	        return this._uiPrice;
	    }
	    get oracleLastUpdatedSlot() {
	        if (!this._oracleLastUpdatedSlot) {
	            throw new Error(`Undefined oracleLastUpdatedSlot for bank ${this.publicKey} with tokenIndex ${this.tokenIndex}!`);
	        }
	        return this._oracleLastUpdatedSlot;
	    }
	    nativeDeposits() {
	        return this.indexedDeposits.mul(this.depositIndex);
	    }
	    nativeBorrows() {
	        return this.indexedBorrows.mul(this.borrowIndex);
	    }
	    uiDeposits() {
	        return toUiDecimals(this.indexedDeposits.mul(this.depositIndex), this.mintDecimals);
	    }
	    uiBorrows() {
	        return toUiDecimals(this.indexedBorrows.mul(this.borrowIndex), this.mintDecimals);
	    }
	    /**
	     *
	     * @returns borrow rate, 0 is 0% where 1 is 100%
	     */
	    getBorrowRate() {
	        const totalBorrows = this.nativeBorrows();
	        const totalDeposits = this.nativeDeposits();
	        if (totalDeposits.isZero() && totalBorrows.isZero()) {
	            return ZERO_I80F48();
	        }
	        if (totalDeposits.lte(totalBorrows)) {
	            return this.maxRate;
	        }
	        const utilization = totalBorrows.div(totalDeposits);
	        if (utilization.gt(this.util1)) {
	            const extraUtil = utilization.sub(this.util1);
	            const slope = this.maxRate
	                .sub(this.rate1)
	                .div(I80F48.fromNumber(1).sub(this.util1));
	            return this.rate1.add(slope.mul(extraUtil));
	        }
	        else if (utilization.gt(this.util0)) {
	            const extraUtil = utilization.sub(this.util0);
	            const slope = this.maxRate
	                .sub(this.rate0)
	                .div(I80F48.fromNumber(1).sub(this.util0));
	            return this.rate0.add(slope.mul(extraUtil));
	        }
	        else {
	            const slope = this.rate0.div(this.util0);
	            return slope.mul(utilization);
	        }
	    }
	    /**
	     *
	     * @returns borrow rate percentage
	     */
	    getBorrowRateUi() {
	        return this.getBorrowRate().toNumber() * 100;
	    }
	    /**
	     *
	     * @returns deposit rate, 0 is 0% where 1 is 100%
	     */
	    getDepositRate() {
	        const borrowRate = this.getBorrowRate();
	        const totalBorrows = this.nativeBorrows();
	        const totalDeposits = this.nativeDeposits();
	        if (totalDeposits.isZero() && totalBorrows.isZero()) {
	            return ZERO_I80F48();
	        }
	        else if (totalDeposits.isZero()) {
	            return this.maxRate;
	        }
	        const utilization = totalBorrows.div(totalDeposits);
	        return utilization.mul(borrowRate);
	    }
	    /**
	     *
	     * @returns deposit rate percentage
	     */
	    getDepositRateUi() {
	        return this.getDepositRate().toNumber() * 100;
	    }
	}
	class MintInfo {
	    publicKey;
	    group;
	    tokenIndex;
	    mint;
	    banks;
	    vaults;
	    oracle;
	    registrationTime;
	    groupInsuranceFund;
	    static from(publicKey, obj) {
	        return new MintInfo(publicKey, obj.group, obj.tokenIndex, obj.mint, obj.banks, obj.vaults, obj.oracle, obj.registrationTime, obj.groupInsuranceFund);
	    }
	    constructor(publicKey, group, tokenIndex, mint, banks, vaults, oracle, registrationTime, groupInsuranceFund) {
	        this.publicKey = publicKey;
	        this.group = group;
	        this.tokenIndex = tokenIndex;
	        this.mint = mint;
	        this.banks = banks;
	        this.vaults = vaults;
	        this.oracle = oracle;
	        this.registrationTime = registrationTime;
	        this.groupInsuranceFund = groupInsuranceFund;
	    }
	    firstBank() {
	        return this.banks[0];
	    }
	    firstVault() {
	        return this.vaults[0];
	    }
	    toString() {
	        const res = 'mint ' +
	            this.mint.toBase58() +
	            '\n oracle ' +
	            this.oracle.toBase58() +
	            '\n banks ' +
	            this.banks
	                .filter((pk) => pk.toBase58() !== require$$0$1.PublicKey.default.toBase58())
	                .toString() +
	            '\n vaults ' +
	            this.vaults
	                .filter((pk) => pk.toBase58() !== require$$0$1.PublicKey.default.toBase58())
	                .toString();
	        return res;
	    }
	}

	const SBV1_DEVNET_PID = new require$$0$1.PublicKey('7azgmy1pFXHikv36q1zZASvFq5vFa39TT9NweVugKKTU');
	const SBV1_MAINNET_PID = new require$$0$1.PublicKey('DtmE9D2CSB4L5D6A15mraeEjrGMm6auWVzgaD8hK2tZM');
	let sbv2DevnetProgram;
	let sbv2MainnetProgram;
	class StubOracle {
	    publicKey;
	    group;
	    mint;
	    price;
	    lastUpdated;
	    static from(publicKey, obj) {
	        return new StubOracle(publicKey, obj.group, obj.mint, obj.price, obj.lastUpdated);
	    }
	    constructor(publicKey, group, mint, price, lastUpdated) {
	        this.publicKey = publicKey;
	        this.group = group;
	        this.mint = mint;
	        this.price = I80F48.from(price);
	        this.lastUpdated = lastUpdated;
	    }
	}
	// https://gist.github.com/microwavedcola1/b741a11e6ee273a859f3ef00b35ac1f0
	function parseSwitchboardOracleV1(accountInfo) {
	    const price = accountInfo.data.readDoubleLE(1 + 32 + 4 + 4);
	    const lastUpdatedSlot = parseInt(accountInfo.data.readBigUInt64LE(1 + 32 + 4 + 4 + 8).toString());
	    return { price, lastUpdatedSlot };
	}
	function parseSwitchboardOracleV2(program, accountInfo) {
	    const price = program.decodeLatestAggregatorValue(accountInfo).toNumber();
	    const lastUpdatedSlot = program
	        .decodeAggregator(accountInfo)
	        .latestConfirmedRound.roundOpenSlot.toNumber();
	    if (!price || !lastUpdatedSlot)
	        throw new Error('Unable to parse Switchboard Oracle V2');
	    return { price, lastUpdatedSlot };
	}
	/**
	 *
	 * @param accountInfo
	 * @returns ui price
	 */
	async function parseSwitchboardOracle(accountInfo, connection) {
	    if (accountInfo.owner.equals(SwitchboardProgram.devnetPid)) {
	        if (!sbv2DevnetProgram) {
	            sbv2DevnetProgram = await SwitchboardProgram.loadDevnet(connection);
	        }
	        return parseSwitchboardOracleV2(sbv2DevnetProgram, accountInfo);
	    }
	    if (accountInfo.owner.equals(SwitchboardProgram.mainnetPid)) {
	        if (!sbv2MainnetProgram) {
	            sbv2MainnetProgram = await SwitchboardProgram.loadMainnet(connection);
	        }
	        return parseSwitchboardOracleV2(sbv2MainnetProgram, accountInfo);
	    }
	    if (accountInfo.owner.equals(SBV1_DEVNET_PID) ||
	        accountInfo.owner.equals(SBV1_MAINNET_PID)) {
	        return parseSwitchboardOracleV1(accountInfo);
	    }
	    throw new Error(`Should not be reached!`);
	}
	function isSwitchboardOracle(accountInfo) {
	    if (accountInfo.owner.equals(SBV1_DEVNET_PID) ||
	        accountInfo.owner.equals(SBV1_MAINNET_PID) ||
	        accountInfo.owner.equals(SwitchboardProgram.devnetPid) ||
	        accountInfo.owner.equals(SwitchboardProgram.mainnetPid)) {
	        return true;
	    }
	    return false;
	}
	function isPythOracle(accountInfo) {
	    return accountInfo.data.readUInt32LE(0) === client.Magic;
	}

	class PerpMarket {
	    publicKey;
	    group;
	    settleTokenIndex;
	    perpMarketIndex;
	    groupInsuranceFund;
	    baseDecimals;
	    bids;
	    asks;
	    eventQueue;
	    oracle;
	    stablePriceModel;
	    quoteLotSize;
	    baseLotSize;
	    openInterest;
	    seqNum;
	    registrationTime;
	    impactQuantity;
	    fundingLastUpdated;
	    feePenalty;
	    settleFeeFlat;
	    settleFeeAmountThreshold;
	    settleFeeFractionLowHealth;
	    settlePnlLimitFactor;
	    settlePnlLimitWindowSizeTs;
	    reduceOnly;
	    name;
	    oracleConfig;
	    maintBaseAssetWeight;
	    initBaseAssetWeight;
	    maintBaseLiabWeight;
	    initBaseLiabWeight;
	    baseLiquidationFee;
	    makerFee;
	    takerFee;
	    minFunding;
	    maxFunding;
	    longFunding;
	    shortFunding;
	    feesAccrued;
	    feesSettled;
	    maintOverallAssetWeight;
	    initOverallAssetWeight;
	    _price;
	    _uiPrice;
	    _oracleLastUpdatedSlot;
	    priceLotsToUiConverter;
	    baseLotsToUiConverter;
	    quoteLotsToUiConverter;
	    _bids;
	    _asks;
	    static from(publicKey, obj) {
	        return new PerpMarket(publicKey, obj.group, obj.settleTokenIndex, obj.perpMarketIndex, obj.groupInsuranceFund == 1, obj.baseDecimals, obj.name, obj.bids, obj.asks, obj.eventQueue, obj.oracle, obj.oracleConfig, obj.stablePriceModel, obj.quoteLotSize, obj.baseLotSize, obj.maintBaseAssetWeight, obj.initBaseAssetWeight, obj.maintBaseLiabWeight, obj.initBaseLiabWeight, obj.openInterest, obj.seqNum, obj.registrationTime, obj.minFunding, obj.maxFunding, obj.impactQuantity, obj.longFunding, obj.shortFunding, obj.fundingLastUpdated, obj.baseLiquidationFee, obj.makerFee, obj.takerFee, obj.feesAccrued, obj.feesSettled, obj.feePenalty, obj.settleFeeFlat, obj.settleFeeAmountThreshold, obj.settleFeeFractionLowHealth, obj.settlePnlLimitFactor, obj.settlePnlLimitWindowSizeTs, obj.reduceOnly == 1, obj.maintOverallAssetWeight, obj.initOverallAssetWeight, obj.positivePnlLiquidationFee);
	    }
	    constructor(publicKey, group, settleTokenIndex, perpMarketIndex, // TODO rename to marketIndex?
	    groupInsuranceFund, baseDecimals, name, bids, asks, eventQueue, oracle, oracleConfig, stablePriceModel, quoteLotSize, baseLotSize, maintBaseAssetWeight, initBaseAssetWeight, maintBaseLiabWeight, initBaseLiabWeight, openInterest, seqNum, registrationTime, minFunding, maxFunding, impactQuantity, longFunding, shortFunding, fundingLastUpdated, baseLiquidationFee, makerFee, takerFee, feesAccrued, feesSettled, feePenalty, settleFeeFlat, settleFeeAmountThreshold, settleFeeFractionLowHealth, settlePnlLimitFactor, settlePnlLimitWindowSizeTs, reduceOnly, maintOverallAssetWeight, initOverallAssetWeight, positivePnlLiquidationFee) {
	        this.publicKey = publicKey;
	        this.group = group;
	        this.settleTokenIndex = settleTokenIndex;
	        this.perpMarketIndex = perpMarketIndex;
	        this.groupInsuranceFund = groupInsuranceFund;
	        this.baseDecimals = baseDecimals;
	        this.bids = bids;
	        this.asks = asks;
	        this.eventQueue = eventQueue;
	        this.oracle = oracle;
	        this.stablePriceModel = stablePriceModel;
	        this.quoteLotSize = quoteLotSize;
	        this.baseLotSize = baseLotSize;
	        this.openInterest = openInterest;
	        this.seqNum = seqNum;
	        this.registrationTime = registrationTime;
	        this.impactQuantity = impactQuantity;
	        this.fundingLastUpdated = fundingLastUpdated;
	        this.feePenalty = feePenalty;
	        this.settleFeeFlat = settleFeeFlat;
	        this.settleFeeAmountThreshold = settleFeeAmountThreshold;
	        this.settleFeeFractionLowHealth = settleFeeFractionLowHealth;
	        this.settlePnlLimitFactor = settlePnlLimitFactor;
	        this.settlePnlLimitWindowSizeTs = settlePnlLimitWindowSizeTs;
	        this.reduceOnly = reduceOnly;
	        this.name = utf8.decode(new Uint8Array(name)).split('\x00')[0];
	        this.oracleConfig = {
	            confFilter: I80F48.from(oracleConfig.confFilter),
	            maxStalenessSlots: oracleConfig.maxStalenessSlots,
	        };
	        this.maintBaseAssetWeight = I80F48.from(maintBaseAssetWeight);
	        this.initBaseAssetWeight = I80F48.from(initBaseAssetWeight);
	        this.maintBaseLiabWeight = I80F48.from(maintBaseLiabWeight);
	        this.initBaseLiabWeight = I80F48.from(initBaseLiabWeight);
	        this.baseLiquidationFee = I80F48.from(baseLiquidationFee);
	        this.makerFee = I80F48.from(makerFee);
	        this.takerFee = I80F48.from(takerFee);
	        this.minFunding = I80F48.from(minFunding);
	        this.maxFunding = I80F48.from(maxFunding);
	        this.longFunding = I80F48.from(longFunding);
	        this.shortFunding = I80F48.from(shortFunding);
	        this.feesAccrued = I80F48.from(feesAccrued);
	        this.feesSettled = I80F48.from(feesSettled);
	        this.maintOverallAssetWeight = I80F48.from(maintOverallAssetWeight);
	        this.initOverallAssetWeight = I80F48.from(initOverallAssetWeight);
	        this.priceLotsToUiConverter = new Big(10)
	            .pow(baseDecimals - QUOTE_DECIMALS)
	            .mul(new Big(this.quoteLotSize.toString()))
	            .div(new Big(this.baseLotSize.toString()))
	            .toNumber();
	        this.baseLotsToUiConverter = new Big(this.baseLotSize.toString())
	            .div(new Big(10).pow(baseDecimals))
	            .toNumber();
	        this.quoteLotsToUiConverter = new Big(this.quoteLotSize.toString())
	            .div(new Big(10).pow(QUOTE_DECIMALS))
	            .toNumber();
	    }
	    get price() {
	        if (!this._price) {
	            throw new Error(`Undefined price for perpMarket ${this.publicKey} with marketIndex ${this.perpMarketIndex}!`);
	        }
	        return this._price;
	    }
	    get uiPrice() {
	        if (!this._uiPrice) {
	            throw new Error(`Undefined price for perpMarket ${this.publicKey} with marketIndex ${this.perpMarketIndex}!`);
	        }
	        return this._uiPrice;
	    }
	    get oracleLastUpdatedSlot() {
	        if (!this._oracleLastUpdatedSlot) {
	            throw new Error(`Undefined oracleLastUpdatedSlot for perpMarket ${this.publicKey} with marketIndex ${this.perpMarketIndex}!`);
	        }
	        return this._oracleLastUpdatedSlot;
	    }
	    get minOrderSize() {
	        return this.baseLotsToUiConverter;
	    }
	    get tickSize() {
	        return this.priceLotsToUiConverter;
	    }
	    insidePriceLimit(side, orderPrice) {
	        return ((side === PerpOrderSide.bid &&
	            orderPrice <= this.maintBaseLiabWeight.toNumber() * this.uiPrice) ||
	            (side === PerpOrderSide.ask &&
	                orderPrice >= this.maintBaseAssetWeight.toNumber() * this.uiPrice));
	    }
	    async loadAsks(client, forceReload = false) {
	        if (forceReload || !this._asks) {
	            const asks = await client.program.account.bookSide.fetch(this.asks);
	            this._asks = BookSide.from(client, this, BookSideType.asks, asks);
	        }
	        return this._asks;
	    }
	    async loadBids(client, forceReload = false) {
	        if (forceReload || !this._bids) {
	            const bids = await client.program.account.bookSide.fetch(this.bids);
	            this._bids = BookSide.from(client, this, BookSideType.bids, bids);
	        }
	        return this._bids;
	    }
	    async loadEventQueue(client) {
	        const eventQueue = await client.program.account.eventQueue.fetch(this.eventQueue);
	        return new PerpEventQueue(client, eventQueue.header, eventQueue.buf);
	    }
	    async loadFills(client, lastSeqNum = new anchor.BN(0)) {
	        const eventQueue = await this.loadEventQueue(client);
	        return eventQueue
	            .eventsSince(lastSeqNum)
	            .filter((event) => event.eventType == PerpEventQueue.FILL_EVENT_TYPE)
	            .map(this.parseFillEvent.bind(this));
	    }
	    parseFillEvent(event) {
	        const quantity = this.baseLotsToUi(event.quantity);
	        const price = this.priceLotsToUi(event.price);
	        return {
	            ...event,
	            quantity,
	            size: quantity,
	            price,
	        };
	    }
	    async logOb(client) {
	        let res = ``;
	        res += `  ${this.name} OrderBook`;
	        let orders = await this?.loadAsks(client);
	        for (const order of orders.items()) {
	            res += `\n ${order.uiPrice.toFixed(5).padStart(10)}, ${order.uiSize
                .toString()
                .padStart(10)} ${order.isOraclePegged && order.oraclePeggedProperties
                ? order.oraclePeggedProperties.pegLimit.toNumber() + ' (PegLimit)'
                : ''}`;
	        }
	        res += `\n  asks ↑ --------- ↓ bids`;
	        orders = await this?.loadBids(client);
	        for (const order of orders.items()) {
	            res += `\n  ${order.uiPrice.toFixed(5).padStart(10)}, ${order.uiSize
                .toString()
                .padStart(10)} ${order.isOraclePegged && order.oraclePeggedProperties
                ? order.oraclePeggedProperties.pegLimit.toNumber() + ' (PegLimit)'
                : ''}`;
	        }
	        return res;
	    }
	    /**
	     *
	     * @param bids
	     * @param asks
	     * @returns returns funding rate per hour
	     */
	    getCurrentFundingRate(bids, asks) {
	        const MIN_FUNDING = this.minFunding.toNumber();
	        const MAX_FUNDING = this.maxFunding.toNumber();
	        const bid = bids.getImpactPriceUi(new anchor.BN(this.impactQuantity));
	        const ask = asks.getImpactPriceUi(new anchor.BN(this.impactQuantity));
	        const indexPrice = this._uiPrice;
	        let funding;
	        if (bid !== undefined && ask !== undefined) {
	            const bookPrice = (bid + ask) / 2;
	            funding = Math.min(Math.max(bookPrice / indexPrice - 1, MIN_FUNDING), MAX_FUNDING);
	        }
	        else if (bid !== undefined) {
	            funding = MAX_FUNDING;
	        }
	        else if (ask !== undefined) {
	            funding = MIN_FUNDING;
	        }
	        else {
	            funding = 0;
	        }
	        return funding / 24 / Math.pow(10, QUOTE_DECIMALS);
	    }
	    uiPriceToLots(price) {
	        return toNative(price, QUOTE_DECIMALS)
	            .mul(this.baseLotSize)
	            .div(this.quoteLotSize.mul(new anchor.BN(Math.pow(10, this.baseDecimals))));
	    }
	    uiBaseToLots(quantity) {
	        return toNative(quantity, this.baseDecimals).div(this.baseLotSize);
	    }
	    uiQuoteToLots(uiQuote) {
	        return toNative(uiQuote, QUOTE_DECIMALS).div(this.quoteLotSize);
	    }
	    priceLotsToUi(price) {
	        return parseFloat(price.toString()) * this.priceLotsToUiConverter;
	    }
	    priceNativeToUi(price) {
	        return toUiDecimals(price, QUOTE_DECIMALS - this.baseDecimals);
	    }
	    baseLotsToUi(quantity) {
	        return parseFloat(quantity.toString()) * this.baseLotsToUiConverter;
	    }
	    quoteLotsToUi(quantity) {
	        return parseFloat(quantity.toString()) * this.quoteLotsToUiConverter;
	    }
	    /**
	     * Returns a list of (upto count) accounts, and the pnl that is settle'able on this perp market,
	     * the list is sorted ascending for 'negative' direction and descending for 'positive' direction.
	     *
	     * NOTE: keep in sync with perp_pnl.rs:fetch_top
	     *
	     * TODO: replace with a more performant offchain service call
	     * @param client
	     * @param group
	     * @param direction
	     * @returns
	     */
	    async getSettlePnlCandidates(client, group, direction, count = 2) {
	        let accountsWithSettleablePnl = (await client.getAllMangoAccounts(group, true))
	            .filter((acc) => acc.perpPositionExistsForMarket(this))
	            .map((acc) => {
	            const pp = acc
	                .perpActive()
	                .find((pp) => pp.marketIndex === this.perpMarketIndex);
	            return {
	                account: acc,
	                settleablePnl: pp.getSettleablePnl(group, this, acc),
	            };
	        });
	        accountsWithSettleablePnl = accountsWithSettleablePnl
	            .filter((acc) => 
	        // need perp positions with -ve pnl to settle +ve pnl and vice versa
	        (direction === 'negative' && acc.settleablePnl.lt(ZERO_I80F48())) ||
	            (direction === 'positive' && acc.settleablePnl.gt(ZERO_I80F48())))
	            .sort((a, b) => direction === 'negative'
	            ? // most negative
	                a.settleablePnl.cmp(b.settleablePnl)
	            : // most positive
	                b.settleablePnl.cmp(a.settleablePnl));
	        if (direction === 'negative') {
	            let stable = 0;
	            for (let i = 0; i < accountsWithSettleablePnl.length; i++) {
	                const acc = accountsWithSettleablePnl[i];
	                const nextPnl = i + 1 < accountsWithSettleablePnl.length
	                    ? accountsWithSettleablePnl[i + 1].settleablePnl
	                    : ZERO_I80F48();
	                const perpSettleHealth = acc.account.getPerpSettleHealth(group);
	                acc.settleablePnl =
	                    // need positive settle health to settle against +ve pnl
	                    perpSettleHealth.gt(ZERO_I80F48())
	                        ? // can only settle min
	                            acc.settleablePnl.max(perpSettleHealth.neg())
	                        : ZERO_I80F48();
	                // If the ordering was unchanged `count` times we know we have the top `count` accounts
	                if (acc.settleablePnl.lte(nextPnl)) {
	                    stable += 1;
	                    if (stable >= count) {
	                        break;
	                    }
	                }
	            }
	        }
	        accountsWithSettleablePnl.sort((a, b) => direction === 'negative'
	            ? // most negative
	                a.settleablePnl.cmp(b.settleablePnl)
	            : // most positive
	                b.settleablePnl.cmp(a.settleablePnl));
	        return accountsWithSettleablePnl.slice(0, count);
	    }
	    toString() {
	        return ('PerpMarket ' +
	            '\n perpMarketIndex -' +
	            this.perpMarketIndex +
	            '\n maintAssetWeight -' +
	            this.maintBaseAssetWeight.toString() +
	            '\n initAssetWeight -' +
	            this.initBaseAssetWeight.toString() +
	            '\n maintLiabWeight -' +
	            this.maintBaseLiabWeight.toString() +
	            '\n initLiabWeight -' +
	            this.initBaseLiabWeight.toString() +
	            '\n baseLiquidationFee -' +
	            this.baseLiquidationFee.toString() +
	            '\n makerFee -' +
	            this.makerFee.toString() +
	            '\n takerFee -' +
	            this.takerFee.toString());
	    }
	}
	class BookSide {
	    client;
	    perpMarket;
	    type;
	    rootFixed;
	    rootOraclePegged;
	    orderTreeNodes;
	    static INNER_NODE_TAG = 1;
	    static LEAF_NODE_TAG = 2;
	    now;
	    static from(client, perpMarket, bookSideType, obj) {
	        return new BookSide(client, perpMarket, bookSideType, obj.roots[0], obj.roots[1], obj.nodes);
	    }
	    constructor(client, perpMarket, type, rootFixed, rootOraclePegged, orderTreeNodes, maxBookDelay) {
	        this.client = client;
	        this.perpMarket = perpMarket;
	        this.type = type;
	        this.rootFixed = rootFixed;
	        this.rootOraclePegged = rootOraclePegged;
	        this.orderTreeNodes = orderTreeNodes;
	        // Determine the maxTimestamp found on the book to use for tif
	        // If maxBookDelay is not provided, use 3600 as a very large number
	        maxBookDelay = maxBookDelay === undefined ? 3600 : maxBookDelay;
	        let maxTimestamp = new anchor.BN(new Date().getTime() / 1000 - maxBookDelay);
	        for (const node of this.orderTreeNodes.nodes) {
	            if (node.tag !== BookSide.LEAF_NODE_TAG) {
	                continue;
	            }
	            const leafNode = BookSide.toLeafNode(client, node.data);
	            if (leafNode.timestamp.gt(maxTimestamp)) {
	                maxTimestamp = leafNode.timestamp;
	            }
	        }
	        this.now = maxTimestamp;
	    }
	    static getPriceFromKey(key) {
	        return key.ushrn(64);
	    }
	    /**
	     * iterates over all orders
	     */
	    *items() {
	        function isBetter(type, a, b) {
	            return a.priceLots.eq(b.priceLots)
	                ? a.seqNum.lt(b.seqNum) // if prices are equal prefer perp orders in the order they are placed
	                : type === BookSideType.bids // else compare the actual prices
	                    ? a.priceLots.gt(b.priceLots)
	                    : b.priceLots.gt(a.priceLots);
	        }
	        const fGen = this.fixedItems();
	        const oPegGen = this.oraclePeggedItems();
	        let fOrderRes = fGen.next();
	        let oPegOrderRes = oPegGen.next();
	        while (true) {
	            if (fOrderRes.value && oPegOrderRes.value) {
	                if (isBetter(this.type, fOrderRes.value, oPegOrderRes.value)) {
	                    yield fOrderRes.value;
	                    fOrderRes = fGen.next();
	                }
	                else {
	                    yield oPegOrderRes.value;
	                    oPegOrderRes = oPegGen.next();
	                }
	            }
	            else if (fOrderRes.value && !oPegOrderRes.value) {
	                yield fOrderRes.value;
	                fOrderRes = fGen.next();
	            }
	            else if (!fOrderRes.value && oPegOrderRes.value) {
	                yield oPegOrderRes.value;
	                oPegOrderRes = oPegGen.next();
	            }
	            else if (!fOrderRes.value && !oPegOrderRes.value) {
	                break;
	            }
	        }
	    }
	    /**
	     * iterates over all orders,
	     * skips oracle pegged orders which are invalid due to oracle price crossing the peg limit,
	     * skips tif orders which are invalid due to tif having elapsed,
	     */
	    *itemsValid() {
	        const itemsGen = this.items();
	        let itemsRes = itemsGen.next();
	        while (true) {
	            if (itemsRes.value) {
	                const val = itemsRes.value;
	                if (!val.isExpired &&
	                    (!val.isOraclePegged ||
	                        (val.isOraclePegged && !val.oraclePeggedProperties.isInvalid))) {
	                    yield val;
	                }
	                itemsRes = itemsGen.next();
	            }
	            else {
	                break;
	            }
	        }
	    }
	    *fixedItems() {
	        if (this.rootFixed.leafCount === 0) {
	            return;
	        }
	        const now = this.now;
	        const stack = [this.rootFixed.maybeNode];
	        const [left, right] = this.type === BookSideType.bids ? [1, 0] : [0, 1];
	        while (stack.length > 0) {
	            const index = stack.pop();
	            const node = this.orderTreeNodes.nodes[index];
	            if (node.tag === BookSide.INNER_NODE_TAG) {
	                const innerNode = BookSide.toInnerNode(this.client, node.data);
	                stack.push(innerNode.children[right], innerNode.children[left]);
	            }
	            else if (node.tag === BookSide.LEAF_NODE_TAG) {
	                const leafNode = BookSide.toLeafNode(this.client, node.data);
	                const expiryTimestamp = leafNode.timeInForce
	                    ? leafNode.timestamp.add(new anchor.BN(leafNode.timeInForce))
	                    : U64_MAX_BN;
	                yield PerpOrder.from(this.perpMarket, leafNode, this.type, now.lt(expiryTimestamp));
	            }
	        }
	    }
	    *oraclePeggedItems() {
	        if (this.rootOraclePegged.leafCount === 0) {
	            return;
	        }
	        const now = this.now;
	        const stack = [this.rootOraclePegged.maybeNode];
	        const [left, right] = this.type === BookSideType.bids ? [1, 0] : [0, 1];
	        while (stack.length > 0) {
	            const index = stack.pop();
	            const node = this.orderTreeNodes.nodes[index];
	            if (node.tag === BookSide.INNER_NODE_TAG) {
	                const innerNode = BookSide.toInnerNode(this.client, node.data);
	                stack.push(innerNode.children[right], innerNode.children[left]);
	            }
	            else if (node.tag === BookSide.LEAF_NODE_TAG) {
	                const leafNode = BookSide.toLeafNode(this.client, node.data);
	                const expiryTimestamp = leafNode.timeInForce
	                    ? leafNode.timestamp.add(new anchor.BN(leafNode.timeInForce))
	                    : U64_MAX_BN;
	                yield PerpOrder.from(this.perpMarket, leafNode, this.type, now.lt(expiryTimestamp), true);
	            }
	        }
	    }
	    best() {
	        return this.items().next().value;
	    }
	    getImpactPriceUi(baseLots) {
	        const s = new anchor.BN(0);
	        for (const order of this.items()) {
	            s.iadd(order.sizeLots);
	            if (s.gte(baseLots)) {
	                return order.uiPrice;
	            }
	        }
	        return undefined;
	    }
	    getL2(depth) {
	        const levels = [];
	        for (const { priceLots, sizeLots } of this.items()) {
	            if (levels.length > 0 && levels[levels.length - 1][0].eq(priceLots)) {
	                levels[levels.length - 1][1].iadd(sizeLots);
	            }
	            else if (levels.length === depth) {
	                break;
	            }
	            else {
	                levels.push([priceLots, sizeLots]);
	            }
	        }
	        return levels.map(([priceLots, sizeLots]) => [
	            this.perpMarket.priceLotsToUi(priceLots),
	            this.perpMarket.baseLotsToUi(sizeLots),
	            priceLots,
	            sizeLots,
	        ]);
	    }
	    getL2Ui(depth) {
	        const levels = [];
	        for (const { uiPrice: price, uiSize: size } of this.items()) {
	            if (levels.length > 0 && levels[levels.length - 1][0] === price) {
	                levels[levels.length - 1][1] += size;
	            }
	            else if (levels.length === depth) {
	                break;
	            }
	            else {
	                levels.push([price, size]);
	            }
	        }
	        return levels;
	    }
	    static toInnerNode(client, data) {
	        return client.program._coder.types.typeLayouts
	            .get('InnerNode')
	            .decode(Buffer.from([BookSide.INNER_NODE_TAG].concat(data)));
	    }
	    static toLeafNode(client, data) {
	        return LeafNode.from(client.program._coder.types.typeLayouts
	            .get('LeafNode')
	            .decode(Buffer.from([BookSide.LEAF_NODE_TAG].concat(data))));
	    }
	}
	class BookSideType {
	    static bids = { bids: {} };
	    static asks = { asks: {} };
	}
	class LeafNode {
	    ownerSlot;
	    orderType;
	    timeInForce;
	    key;
	    owner;
	    quantity;
	    timestamp;
	    pegLimit;
	    static from(obj) {
	        return new LeafNode(obj.ownerSlot, obj.orderType, obj.timeInForce, obj.key, obj.owner, obj.quantity, obj.timestamp, obj.pegLimit);
	    }
	    constructor(ownerSlot, orderType, timeInForce, key, owner, quantity, timestamp, pegLimit) {
	        this.ownerSlot = ownerSlot;
	        this.orderType = orderType;
	        this.timeInForce = timeInForce;
	        this.key = key;
	        this.owner = owner;
	        this.quantity = quantity;
	        this.timestamp = timestamp;
	        this.pegLimit = pegLimit;
	    }
	}
	class InnerNode {
	    children;
	    static from(obj) {
	        return new InnerNode(obj.children);
	    }
	    constructor(children) {
	        this.children = children;
	    }
	}
	class PerpOrderSide {
	    static bid = { bid: {} };
	    static ask = { ask: {} };
	}
	class PerpOrderType {
	    static limit = { limit: {} };
	    static immediateOrCancel = { immediateOrCancel: {} };
	    static postOnly = { postOnly: {} };
	    static market = { market: {} };
	    static postOnlySlide = { postOnlySlide: {} };
	}
	class PerpOrder {
	    seqNum;
	    orderId;
	    owner;
	    openOrdersSlot;
	    feeTier;
	    uiPrice;
	    priceLots;
	    uiSize;
	    sizeLots;
	    side;
	    timestamp;
	    expiryTimestamp;
	    perpMarketIndex;
	    isExpired;
	    isOraclePegged;
	    oraclePeggedProperties;
	    static from(perpMarket, leafNode, type, isExpired = false, isOraclePegged = false) {
	        const side = type == BookSideType.bids ? PerpOrderSide.bid : PerpOrderSide.ask;
	        let priceLots;
	        let oraclePeggedProperties;
	        if (isOraclePegged) {
	            const priceData = leafNode.key.ushrn(64);
	            const priceOffset = priceData.sub(new anchor.BN(1).ushln(63));
	            priceLots = perpMarket.uiPriceToLots(perpMarket.uiPrice).add(priceOffset);
	            const isInvalid = type === BookSideType.bids
	                ? priceLots.gt(leafNode.pegLimit)
	                : leafNode.pegLimit.gt(priceLots);
	            oraclePeggedProperties = {
	                isInvalid,
	                priceOffset,
	                uiPriceOffset: perpMarket.priceLotsToUi(priceOffset),
	                pegLimit: leafNode.pegLimit,
	                uiPegLimit: perpMarket.priceLotsToUi(leafNode.pegLimit),
	            };
	        }
	        else {
	            priceLots = BookSide.getPriceFromKey(leafNode.key);
	        }
	        const expiryTimestamp = leafNode.timeInForce
	            ? leafNode.timestamp.add(new anchor.BN(leafNode.timeInForce))
	            : U64_MAX_BN;
	        return new PerpOrder(type === BookSideType.bids
	            ? RUST_U64_MAX().sub(leafNode.key.maskn(64))
	            : leafNode.key.maskn(64), leafNode.key, leafNode.owner, leafNode.ownerSlot, 0, perpMarket.priceLotsToUi(priceLots), priceLots, perpMarket.baseLotsToUi(leafNode.quantity), leafNode.quantity, side, leafNode.timestamp, expiryTimestamp, perpMarket.perpMarketIndex, isExpired, isOraclePegged, oraclePeggedProperties);
	    }
	    constructor(seqNum, orderId, owner, openOrdersSlot, feeTier, uiPrice, priceLots, uiSize, sizeLots, side, timestamp, expiryTimestamp, perpMarketIndex, isExpired = false, isOraclePegged = false, oraclePeggedProperties) {
	        this.seqNum = seqNum;
	        this.orderId = orderId;
	        this.owner = owner;
	        this.openOrdersSlot = openOrdersSlot;
	        this.feeTier = feeTier;
	        this.uiPrice = uiPrice;
	        this.priceLots = priceLots;
	        this.uiSize = uiSize;
	        this.sizeLots = sizeLots;
	        this.side = side;
	        this.timestamp = timestamp;
	        this.expiryTimestamp = expiryTimestamp;
	        this.perpMarketIndex = perpMarketIndex;
	        this.isExpired = isExpired;
	        this.isOraclePegged = isOraclePegged;
	        this.oraclePeggedProperties = oraclePeggedProperties;
	    }
	    get price() {
	        return this.uiPrice;
	    }
	    get size() {
	        return this.uiSize;
	    }
	}
	class PerpEventQueue {
	    static FILL_EVENT_TYPE = 0;
	    static OUT_EVENT_TYPE = 1;
	    static LIQUIDATE_EVENT_TYPE = 2;
	    head;
	    count;
	    seqNum;
	    rawEvents;
	    constructor(client, header, buf) {
	        this.head = header.head;
	        this.count = header.count;
	        this.seqNum = header.seqNum;
	        this.rawEvents = buf.map((event) => {
	            if (event.eventType === PerpEventQueue.FILL_EVENT_TYPE) {
	                return client.program._coder.types.typeLayouts
	                    .get('FillEvent')
	                    .decode(Buffer.from([PerpEventQueue.FILL_EVENT_TYPE].concat(event.padding)));
	            }
	            else if (event.eventType === PerpEventQueue.OUT_EVENT_TYPE) {
	                return client.program._coder.types.typeLayouts
	                    .get('OutEvent')
	                    .decode(Buffer.from([PerpEventQueue.OUT_EVENT_TYPE].concat(event.padding)));
	            }
	            else if (event.eventType === PerpEventQueue.LIQUIDATE_EVENT_TYPE) {
	                return client.program._coder.types.typeLayouts
	                    .get('LiquidateEvent')
	                    .decode(Buffer.from([PerpEventQueue.LIQUIDATE_EVENT_TYPE].concat(event.padding)));
	            }
	            throw new Error(`Unknown event with eventType ${event.eventType}!`);
	        });
	    }
	    getUnconsumedEvents() {
	        const events = [];
	        const head = this.head;
	        for (let i = 0; i < this.count; i++) {
	            events.push(this.rawEvents[(head + i) % this.rawEvents.length]);
	        }
	        return events;
	    }
	    eventsSince(lastSeqNum) {
	        return this.rawEvents
	            .filter((e) => e.seqNum.gt(lastSeqNum === undefined ? new anchor.BN(0) : lastSeqNum))
	            .sort((a, b) => a.seqNum.cmp(b.seqNum));
	    }
	}

	class Serum3Market {
	    publicKey;
	    group;
	    baseTokenIndex;
	    quoteTokenIndex;
	    serumProgram;
	    serumMarketExternal;
	    marketIndex;
	    registrationTime;
	    reduceOnly;
	    name;
	    static from(publicKey, obj) {
	        return new Serum3Market(publicKey, obj.group, obj.baseTokenIndex, obj.quoteTokenIndex, obj.name, obj.serumProgram, obj.serumMarketExternal, obj.marketIndex, obj.registrationTime, obj.reduceOnly == 1);
	    }
	    constructor(publicKey, group, baseTokenIndex, quoteTokenIndex, name, serumProgram, serumMarketExternal, marketIndex, registrationTime, reduceOnly) {
	        this.publicKey = publicKey;
	        this.group = group;
	        this.baseTokenIndex = baseTokenIndex;
	        this.quoteTokenIndex = quoteTokenIndex;
	        this.serumProgram = serumProgram;
	        this.serumMarketExternal = serumMarketExternal;
	        this.marketIndex = marketIndex;
	        this.registrationTime = registrationTime;
	        this.reduceOnly = reduceOnly;
	        this.name = utf8.decode(new Uint8Array(name)).split('\x00')[0];
	    }
	    async findOoPda(programId, mangoAccount) {
	        const [openOrderPublicKey] = await require$$0$1.PublicKey.findProgramAddress([
	            Buffer.from('Serum3OO'),
	            mangoAccount.toBuffer(),
	            this.publicKey.toBuffer(),
	        ], programId);
	        return openOrderPublicKey;
	    }
	    getFeeRates(taker = true) {
	        // See https://github.com/openbook-dex/program/blob/master/dex/src/fees.rs#L81
	        const ratesBps = this.name === 'USDT/USDC'
	            ? { maker: -0.5, taker: 1 }
	            : { maker: -2, taker: 4 };
	        return taker ? ratesBps.maker * 0.0001 : ratesBps.taker * 0.0001;
	    }
	    /**
	     *
	     * @param group
	     * @returns maximum leverage one can bid on this market, this is only for display purposes,
	     *  also see getMaxQuoteForSerum3BidUi and getMaxBaseForSerum3AskUi
	     */
	    maxBidLeverage(group) {
	        const baseBank = group.getFirstBankByTokenIndex(this.baseTokenIndex);
	        const quoteBank = group.getFirstBankByTokenIndex(this.quoteTokenIndex);
	        if (quoteBank.initLiabWeight.sub(baseBank.initAssetWeight).lte(ZERO_I80F48())) {
	            return MAX_I80F48().toNumber();
	        }
	        return ONE_I80F48()
	            .div(quoteBank.initLiabWeight.sub(baseBank.initAssetWeight))
	            .toNumber();
	    }
	    /**
	     *
	     * @param group
	     * @returns maximum leverage one can ask on this market, this is only for display purposes,
	     *  also see getMaxQuoteForSerum3BidUi and getMaxBaseForSerum3AskUi
	     */
	    maxAskLeverage(group) {
	        const baseBank = group.getFirstBankByTokenIndex(this.baseTokenIndex);
	        const quoteBank = group.getFirstBankByTokenIndex(this.quoteTokenIndex);
	        if (baseBank.initLiabWeight.sub(quoteBank.initAssetWeight).lte(ZERO_I80F48())) {
	            return MAX_I80F48().toNumber();
	        }
	        return ONE_I80F48()
	            .div(baseBank.initLiabWeight.sub(quoteBank.initAssetWeight))
	            .toNumber();
	    }
	    async loadBids(client, group) {
	        const serum3MarketExternal = group.getSerum3ExternalMarket(this.serumMarketExternal);
	        return await serum3MarketExternal.loadBids(client.program.provider.connection);
	    }
	    async loadAsks(client, group) {
	        const serum3MarketExternal = group.getSerum3ExternalMarket(this.serumMarketExternal);
	        return await serum3MarketExternal.loadAsks(client.program.provider.connection);
	    }
	    async logOb(client, group) {
	        let res = ``;
	        res += `  ${this.name} OrderBook`;
	        let orders = await this?.loadAsks(client, group);
	        for (const order of orders.items(true)) {
	            res += `\n  ${order.price.toString().padStart(10)}, ${order.size
                .toString()
                .padStart(10)}`;
	        }
	        res += `\n  --------------------------`;
	        orders = await this?.loadBids(client, group);
	        for (const order of orders.items(true)) {
	            res += `\n  ${order.price.toString().padStart(10)}, ${order.size
                .toString()
                .padStart(10)}`;
	        }
	        return res;
	    }
	}
	class Serum3SelfTradeBehavior {
	    static decrementTake = { decrementTake: {} };
	    static cancelProvide = { cancelProvide: {} };
	    static abortTransaction = { abortTransaction: {} };
	}
	class Serum3OrderType {
	    static limit = { limit: {} };
	    static immediateOrCancel = { immediateOrCancel: {} };
	    static postOnly = { postOnly: {} };
	}
	class Serum3Side {
	    static bid = { bid: {} };
	    static ask = { ask: {} };
	}
	async function generateSerum3MarketExternalVaultSignerAddress(cluster, serum3Market, serum3MarketExternal) {
	    return await require$$0$1.PublicKey.createProgramAddress([
	        serum3Market.serumMarketExternal.toBuffer(),
	        serum3MarketExternal.decoded.vaultSignerNonce.toArrayLike(Buffer, 'le', 8),
	    ], OPENBOOK_PROGRAM_ID[cluster]);
	}

	class Group {
	    publicKey;
	    creator;
	    groupNum;
	    admin;
	    fastListingAdmin;
	    securityAdmin;
	    insuranceMint;
	    insuranceVault;
	    testing;
	    version;
	    ixGate;
	    addressLookupTables;
	    addressLookupTablesList;
	    banksMapByName;
	    banksMapByMint;
	    banksMapByTokenIndex;
	    serum3MarketsMapByExternal;
	    serum3MarketsMapByMarketIndex;
	    serum3ExternalMarketsMap;
	    perpMarketsMapByOracle;
	    perpMarketsMapByMarketIndex;
	    perpMarketsMapByName;
	    mintInfosMapByTokenIndex;
	    mintInfosMapByMint;
	    vaultAmountsMap;
	    static from(publicKey, obj) {
	        return new Group(publicKey, obj.creator, obj.groupNum, obj.admin, obj.fastListingAdmin, obj.securityAdmin, obj.insuranceMint, obj.insuranceVault, obj.testing, obj.version, obj.ixGate, obj.addressLookupTables, [], // addressLookupTablesList
	        new Map(), // banksMapByName
	        new Map(), // banksMapByMint
	        new Map(), // banksMapByTokenIndex
	        new Map(), // serum3MarketsMapByExternal
	        new Map(), // serum3MarketsMapByMarketIndex
	        new Map(), // serum3MarketExternalsMap
	        new Map(), // perpMarketsMapByOracle
	        new Map(), // perpMarketsMapByMarketIndex
	        new Map(), // perpMarketsMapByName
	        new Map(), // mintInfosMapByTokenIndex
	        new Map(), // mintInfosMapByMint
	        new Map());
	    }
	    constructor(publicKey, creator, groupNum, admin, fastListingAdmin, securityAdmin, insuranceMint, insuranceVault, testing, version, ixGate, addressLookupTables, addressLookupTablesList, banksMapByName, banksMapByMint, banksMapByTokenIndex, serum3MarketsMapByExternal, serum3MarketsMapByMarketIndex, serum3ExternalMarketsMap, perpMarketsMapByOracle, perpMarketsMapByMarketIndex, perpMarketsMapByName, mintInfosMapByTokenIndex, mintInfosMapByMint, vaultAmountsMap) {
	        this.publicKey = publicKey;
	        this.creator = creator;
	        this.groupNum = groupNum;
	        this.admin = admin;
	        this.fastListingAdmin = fastListingAdmin;
	        this.securityAdmin = securityAdmin;
	        this.insuranceMint = insuranceMint;
	        this.insuranceVault = insuranceVault;
	        this.testing = testing;
	        this.version = version;
	        this.ixGate = ixGate;
	        this.addressLookupTables = addressLookupTables;
	        this.addressLookupTablesList = addressLookupTablesList;
	        this.banksMapByName = banksMapByName;
	        this.banksMapByMint = banksMapByMint;
	        this.banksMapByTokenIndex = banksMapByTokenIndex;
	        this.serum3MarketsMapByExternal = serum3MarketsMapByExternal;
	        this.serum3MarketsMapByMarketIndex = serum3MarketsMapByMarketIndex;
	        this.serum3ExternalMarketsMap = serum3ExternalMarketsMap;
	        this.perpMarketsMapByOracle = perpMarketsMapByOracle;
	        this.perpMarketsMapByMarketIndex = perpMarketsMapByMarketIndex;
	        this.perpMarketsMapByName = perpMarketsMapByName;
	        this.mintInfosMapByTokenIndex = mintInfosMapByTokenIndex;
	        this.mintInfosMapByMint = mintInfosMapByMint;
	        this.vaultAmountsMap = vaultAmountsMap;
	    }
	    async reloadAll(client) {
	        const ids = await client.getIds(this.publicKey);
	        // console.time('group.reload');
	        await Promise.all([
	            this.reloadAlts(client),
	            this.reloadBanks(client, ids).then(() => Promise.all([
	                this.reloadBankOraclePrices(client),
	                this.reloadVaults(client),
	                this.reloadPerpMarkets(client, ids).then(() => this.reloadPerpMarketOraclePrices(client)),
	            ])),
	            this.reloadMintInfos(client, ids),
	            this.reloadSerum3Markets(client, ids).then(() => this.reloadSerum3ExternalMarkets(client)),
	        ]);
	        // console.timeEnd('group.reload');
	    }
	    async reloadAlts(client) {
	        const alts = await Promise.all(this.addressLookupTables
	            .filter((alt) => !alt.equals(require$$0$1.PublicKey.default))
	            .map((alt) => client.program.provider.connection.getAddressLookupTable(alt)));
	        this.addressLookupTablesList = alts.map((res, i) => {
	            if (!res || !res.value) {
	                throw new Error(`Undefined ALT ${this.addressLookupTables[i]}!`);
	            }
	            return res.value;
	        });
	    }
	    async reloadBanks(client, ids) {
	        let banks;
	        if (ids && ids.getBanks().length) {
	            banks = (await client.program.account.bank.fetchMultiple(ids.getBanks())).map((account, index) => Bank.from(ids.getBanks()[index], account));
	        }
	        else {
	            banks = await client.getBanksForGroup(this);
	        }
	        const oldbanksMapByTokenIndex = lodashExports.cloneDeep(this.banksMapByTokenIndex);
	        this.banksMapByName = new Map();
	        this.banksMapByMint = new Map();
	        this.banksMapByTokenIndex = new Map();
	        for (const bank of banks) {
	            // ensure that freshly fetched banks have valid price until we fetch oracles again
	            const oldBanks = oldbanksMapByTokenIndex.get(bank.tokenIndex);
	            if (oldBanks && oldBanks.length > 0) {
	                lodashExports.merge(bank, oldBanks[0]);
	            }
	            const mintId = bank.mint.toString();
	            if (this.banksMapByMint.has(mintId)) {
	                this.banksMapByMint.get(mintId)?.push(bank);
	                this.banksMapByName.get(bank.name)?.push(bank);
	                this.banksMapByTokenIndex.get(bank.tokenIndex)?.push(bank);
	            }
	            else {
	                this.banksMapByMint.set(mintId, [bank]);
	                this.banksMapByName.set(bank.name, [bank]);
	                this.banksMapByTokenIndex.set(bank.tokenIndex, [bank]);
	            }
	        }
	    }
	    async reloadMintInfos(client, ids) {
	        let mintInfos;
	        if (ids && ids.getMintInfos().length) {
	            mintInfos = (await client.program.account.mintInfo.fetchMultiple(ids.getMintInfos())).map((account, index) => MintInfo.from(ids.getMintInfos()[index], account));
	        }
	        else {
	            mintInfos = await client.getMintInfosForGroup(this);
	        }
	        this.mintInfosMapByTokenIndex = new Map(mintInfos.map((mintInfo) => {
	            return [mintInfo.tokenIndex, mintInfo];
	        }));
	        this.mintInfosMapByMint = new Map(mintInfos.map((mintInfo) => {
	            return [mintInfo.mint.toString(), mintInfo];
	        }));
	    }
	    async reloadSerum3Markets(client, ids) {
	        let serum3Markets;
	        if (ids && ids.getSerum3Markets().length) {
	            serum3Markets = (await client.program.account.serum3Market.fetchMultiple(ids.getSerum3Markets())).map((account, index) => Serum3Market.from(ids.getSerum3Markets()[index], account));
	        }
	        else {
	            serum3Markets = await client.serum3GetMarkets(this);
	        }
	        this.serum3MarketsMapByExternal = new Map(serum3Markets.map((serum3Market) => [
	            serum3Market.serumMarketExternal.toBase58(),
	            serum3Market,
	        ]));
	        this.serum3MarketsMapByMarketIndex = new Map(serum3Markets.map((serum3Market) => [
	            serum3Market.marketIndex,
	            serum3Market,
	        ]));
	    }
	    async reloadSerum3ExternalMarkets(client) {
	        const externalMarkets = await Promise.all(Array.from(this.serum3MarketsMapByExternal.values()).map((serum3Market) => serum.Market.load(client.program.provider.connection, serum3Market.serumMarketExternal, { commitment: client.program.provider.connection.commitment }, OPENBOOK_PROGRAM_ID[client.cluster])));
	        this.serum3ExternalMarketsMap = new Map(Array.from(this.serum3MarketsMapByExternal.values()).map((serum3Market, index) => [
	            serum3Market.serumMarketExternal.toBase58(),
	            externalMarkets[index],
	        ]));
	    }
	    async reloadPerpMarkets(client, ids) {
	        let perpMarkets;
	        if (ids && ids.getPerpMarkets().length) {
	            perpMarkets = (await client.program.account.perpMarket.fetchMultiple(ids.getPerpMarkets())).map((account, index) => PerpMarket.from(ids.getPerpMarkets()[index], account));
	        }
	        else {
	            perpMarkets = await client.perpGetMarkets(this);
	        }
	        // ensure that freshly fetched perp markets have valid price until we fetch oracles again
	        const oldPerpMarketByMarketIndex = lodashExports.cloneDeep(this.perpMarketsMapByMarketIndex);
	        for (const perpMarket of perpMarkets) {
	            const oldPerpMarket = oldPerpMarketByMarketIndex.get(perpMarket.perpMarketIndex);
	            if (oldPerpMarket) {
	                lodashExports.merge(perpMarket, oldPerpMarket);
	            }
	        }
	        this.perpMarketsMapByName = new Map(perpMarkets.map((perpMarket) => [perpMarket.name, perpMarket]));
	        this.perpMarketsMapByOracle = new Map(perpMarkets.map((perpMarket) => [
	            perpMarket.oracle.toBase58(),
	            perpMarket,
	        ]));
	        this.perpMarketsMapByMarketIndex = new Map(perpMarkets.map((perpMarket) => [perpMarket.perpMarketIndex, perpMarket]));
	    }
	    async reloadBankOraclePrices(client) {
	        const banks = Array.from(this.banksMapByMint, ([, value]) => value);
	        const oracles = banks.map((b) => b[0].oracle);
	        const ais = await client.program.provider.connection.getMultipleAccountsInfo(oracles);
	        const coder = new anchor.BorshAccountsCoder(client.program.idl);
	        for (const [index, ai] of ais.entries()) {
	            for (const bank of banks[index]) {
	                if (bank.name === 'USDC') {
	                    bank._price = ONE_I80F48();
	                    bank._uiPrice = 1;
	                }
	                else {
	                    if (!ai)
	                        throw new Error(`Undefined accountInfo object in reloadBankOraclePrices for ${bank.oracle}!`);
	                    const { price, uiPrice, lastUpdatedSlot } = await this.decodePriceFromOracleAi(coder, bank.oracle, ai, this.getMintDecimals(bank.mint), client);
	                    bank._price = price;
	                    bank._uiPrice = uiPrice;
	                    bank._oracleLastUpdatedSlot = lastUpdatedSlot;
	                }
	            }
	        }
	    }
	    async reloadPerpMarketOraclePrices(client) {
	        const perpMarkets = Array.from(this.perpMarketsMapByName.values());
	        const oracles = perpMarkets.map((b) => b.oracle);
	        const ais = await client.program.provider.connection.getMultipleAccountsInfo(oracles);
	        const coder = new anchor.BorshAccountsCoder(client.program.idl);
	        await Promise.all(Array.from(ais.entries()).map(async ([i, ai]) => {
	            const perpMarket = perpMarkets[i];
	            if (!ai)
	                throw new Error(`Undefined ai object in reloadPerpMarketOraclePrices for ${perpMarket.oracle}!`);
	            const { price, uiPrice, lastUpdatedSlot } = await this.decodePriceFromOracleAi(coder, perpMarket.oracle, ai, perpMarket.baseDecimals, client);
	            perpMarket._price = price;
	            perpMarket._uiPrice = uiPrice;
	            perpMarket._oracleLastUpdatedSlot = lastUpdatedSlot;
	        }));
	    }
	    async decodePriceFromOracleAi(coder, oracle, ai, baseDecimals, client$1) {
	        let price, uiPrice, lastUpdatedSlot;
	        if (!anchor.BorshAccountsCoder.accountDiscriminator('stubOracle').compare(ai.data.slice(0, 8))) {
	            const stubOracle = coder.decode('stubOracle', ai.data);
	            price = new I80F48(stubOracle.price.val);
	            uiPrice = this.toUiPrice(price, baseDecimals);
	            lastUpdatedSlot = stubOracle.lastUpdated.val;
	        }
	        else if (isPythOracle(ai)) {
	            const priceData = client.parsePriceData(ai.data);
	            uiPrice = priceData.previousPrice;
	            price = this.toNativePrice(uiPrice, baseDecimals);
	            lastUpdatedSlot = parseInt(priceData.lastSlot.toString());
	        }
	        else if (isSwitchboardOracle(ai)) {
	            const priceData = await parseSwitchboardOracle(ai, client$1.program.provider.connection);
	            uiPrice = priceData.price;
	            price = this.toNativePrice(uiPrice, baseDecimals);
	            lastUpdatedSlot = priceData.lastUpdatedSlot;
	        }
	        else {
	            throw new Error(`Unknown oracle provider (parsing not implemented) for oracle ${oracle}, with owner ${ai.owner}!`);
	        }
	        return { price, uiPrice, lastUpdatedSlot };
	    }
	    async reloadVaults(client) {
	        const vaultPks = Array.from(this.banksMapByMint.values())
	            .flat()
	            .map((bank) => bank.vault);
	        const vaultAccounts = await client.program.provider.connection.getMultipleAccountsInfo(vaultPks);
	        this.vaultAmountsMap = new Map(vaultAccounts.map((vaultAi, i) => {
	            if (!vaultAi) {
	                throw new Error(`Undefined vaultAi for ${vaultPks[i]}`);
	            }
	            const vaultAmount = tokenExports.coder().accounts.decode('token', vaultAi.data).amount;
	            return [vaultPks[i].toBase58(), vaultAmount];
	        }));
	    }
	    getMintDecimals(mintPk) {
	        const bank = this.getFirstBankByMint(mintPk);
	        return bank.mintDecimals;
	    }
	    getMintDecimalsByTokenIndex(tokenIndex) {
	        const bank = this.getFirstBankByTokenIndex(tokenIndex);
	        return bank.mintDecimals;
	    }
	    getInsuranceMintDecimals() {
	        return this.getMintDecimals(this.insuranceMint);
	    }
	    getFirstBankByMint(mintPk) {
	        const banks = this.banksMapByMint.get(mintPk.toString());
	        if (!banks)
	            throw new Error(`No bank found for mint ${mintPk}!`);
	        return banks[0];
	    }
	    getFirstBankByTokenIndex(tokenIndex) {
	        const banks = this.banksMapByTokenIndex.get(tokenIndex);
	        if (!banks)
	            throw new Error(`No bank found for tokenIndex ${tokenIndex}!`);
	        return banks[0];
	    }
	    /**
	     *
	     * @param mintPk
	     * @returns sum of ui balances of vaults for all banks for a token
	     */
	    getTokenVaultBalanceByMintUi(mintPk) {
	        const banks = this.banksMapByMint.get(mintPk.toBase58());
	        if (!banks) {
	            throw new Error(`No bank found for mint ${mintPk}!`);
	        }
	        const totalAmount = new bnExports(0);
	        for (const bank of banks) {
	            const amount = this.vaultAmountsMap.get(bank.vault.toBase58());
	            if (!amount) {
	                throw new Error(`Vault balance not found for bank ${bank.name} ${bank.bankNum}!`);
	            }
	            totalAmount.iadd(amount);
	        }
	        return toUiDecimals(totalAmount, this.getMintDecimals(mintPk));
	    }
	    getSerum3MarketByMarketIndex(marketIndex) {
	        const serum3Market = this.serum3MarketsMapByMarketIndex.get(marketIndex);
	        if (!serum3Market) {
	            throw new Error(`No serum3Market found for marketIndex ${marketIndex}!`);
	        }
	        return serum3Market;
	    }
	    getSerum3MarketByName(name) {
	        const serum3Market = Array.from(this.serum3MarketsMapByExternal.values()).find((serum3Market) => serum3Market.name === name);
	        if (!serum3Market) {
	            throw new Error(`No serum3Market found by name ${name}!`);
	        }
	        return serum3Market;
	    }
	    getSerum3MarketByExternalMarket(externalMarketPk) {
	        const serum3Market = Array.from(this.serum3MarketsMapByExternal.values()).find((serum3Market) => serum3Market.serumMarketExternal.equals(externalMarketPk));
	        if (!serum3Market) {
	            throw new Error(`No serum3Market found for external serum3 market ${externalMarketPk.toString()}!`);
	        }
	        return serum3Market;
	    }
	    getSerum3ExternalMarket(externalMarketPk) {
	        const market = this.serum3ExternalMarketsMap.get(externalMarketPk.toBase58());
	        if (!market) {
	            throw new Error(`No external market found for pk ${externalMarketPk.toString()}!`);
	        }
	        return market;
	    }
	    async loadSerum3BidsForMarket(client, externalMarketPk) {
	        const serum3Market = this.getSerum3MarketByExternalMarket(externalMarketPk);
	        return await serum3Market.loadBids(client, this);
	    }
	    async loadSerum3AsksForMarket(client, externalMarketPk) {
	        const serum3Market = this.getSerum3MarketByExternalMarket(externalMarketPk);
	        return await serum3Market.loadAsks(client, this);
	    }
	    findPerpMarket(marketIndex) {
	        const perpMarket = Array.from(this.perpMarketsMapByName.values()).find((perpMarket) => perpMarket.perpMarketIndex === marketIndex);
	        if (!perpMarket) {
	            throw new Error(`No perpMarket found for perpMarketIndex ${marketIndex}!`);
	        }
	        return perpMarket;
	    }
	    getPerpMarketByOracle(oracle) {
	        const perpMarket = this.perpMarketsMapByOracle.get(oracle.toBase58());
	        if (!perpMarket) {
	            throw new Error(`No PerpMarket found for oracle ${oracle}!`);
	        }
	        return perpMarket;
	    }
	    getPerpMarketByMarketIndex(marketIndex) {
	        const perpMarket = this.perpMarketsMapByMarketIndex.get(marketIndex);
	        if (!perpMarket) {
	            throw new Error(`No PerpMarket found with marketIndex ${marketIndex}!`);
	        }
	        return perpMarket;
	    }
	    getPerpMarketByName(perpMarketName) {
	        const perpMarket = Array.from(this.perpMarketsMapByMarketIndex.values()).find((perpMarket) => perpMarket.name === perpMarketName);
	        if (!perpMarket) {
	            throw new Error(`No PerpMarket found by name ${perpMarketName}!`);
	        }
	        return perpMarket;
	    }
	    async loadPerpBidsForMarket(client, perpMarketIndex) {
	        const perpMarket = this.getPerpMarketByMarketIndex(perpMarketIndex);
	        return await perpMarket.loadBids(client);
	    }
	    async loadPerpAsksForMarket(client, group, perpMarketIndex) {
	        const perpMarket = this.getPerpMarketByMarketIndex(perpMarketIndex);
	        return await perpMarket.loadAsks(client);
	    }
	    consoleLogBanks() {
	        for (const mintBanks of this.banksMapByMint.values()) {
	            for (const bank of mintBanks) {
	                console.log(bank.toString());
	            }
	        }
	    }
	    toUiPrice(price, baseDecimals) {
	        return toUiDecimals(price, this.getInsuranceMintDecimals() - baseDecimals);
	    }
	    toNativePrice(uiPrice, baseDecimals) {
	        return toNativeI80F48(uiPrice, 
	        // note: our oracles are quoted in USD and our insurance mint is USD
	        // please update when these assumptions change
	        this.getInsuranceMintDecimals() - baseDecimals);
	    }
	    toNativeDecimals(uiAmount, mintPk) {
	        const decimals = this.getMintDecimals(mintPk);
	        return toNative(uiAmount, decimals);
	    }
	    toString() {
	        let res = 'Group\n';
	        res = res + ' pk: ' + this.publicKey.toString();
	        res =
	            res +
	                '\n mintInfos:' +
	                Array.from(this.mintInfosMapByTokenIndex.entries())
	                    .map((mintInfoTuple) => '  \n' + mintInfoTuple[0] + ') ' + mintInfoTuple[1].toString())
	                    .join(', ');
	        const banks = [];
	        for (const tokenBanks of this.banksMapByMint.values()) {
	            for (const bank of tokenBanks) {
	                banks.push(bank);
	            }
	        }
	        res =
	            res +
	                '\n banks:' +
	                Array.from(banks)
	                    .map((bank) => '  \n' + bank.name + ') ' + bank.toString())
	                    .join(', ');
	        return res;
	    }
	}

	var tokenInstructions = {};

	var layout = {};

	// @ts-nocheck
	var __importDefault = (commonjsGlobal && commonjsGlobal.__importDefault) || function (mod) {
	    return (mod && mod.__esModule) ? mod : { "default": mod };
	};
	Object.defineProperty(layout, "__esModule", { value: true });
	layout.setLayoutEncoder = layout.setLayoutDecoder = layout.accountFlagsLayout = layout.selfTradeBehaviorLayout = layout.orderTypeLayout = layout.sideLayout = layout.VersionedLayout = layout.WideBits = layout.u128 = layout.i64 = layout.u64 = layout.publicKeyLayout = layout.zeros = void 0;
	const buffer_layout_1$1 = Layout$1;
	const web3_js_1 = require$$0$1;
	const bn_js_1 = __importDefault(bnExports);
	class Zeros extends buffer_layout_1$1.Blob {
	    decode(b, offset) {
	        const slice = super.decode(b, offset);
	        if (!slice.every((v) => v === 0)) {
	            throw new Error('nonzero padding bytes');
	        }
	        return slice;
	    }
	}
	function zeros(length) {
	    return new Zeros(length);
	}
	layout.zeros = zeros;
	class PublicKeyLayout extends buffer_layout_1$1.Blob {
	    constructor(property) {
	        super(32, property);
	    }
	    decode(b, offset) {
	        return new web3_js_1.PublicKey(super.decode(b, offset));
	    }
	    encode(src, b, offset) {
	        return super.encode(src.toBuffer(), b, offset);
	    }
	}
	function publicKeyLayout(property) {
	    return new PublicKeyLayout(property);
	}
	layout.publicKeyLayout = publicKeyLayout;
	class BNLayout extends buffer_layout_1$1.Blob {
	    decode(b, offset) {
	        return new bn_js_1.default(super.decode(b, offset), 10, 'le');
	    }
	    encode(src, b, offset) {
	        return super.encode(src.toArrayLike(Buffer, 'le', this.span), b, offset);
	    }
	}
	function u64(property) {
	    return new BNLayout(8, property);
	}
	layout.u64 = u64;
	function i64(property) {
	    return new BNLayout(8, property);
	}
	layout.i64 = i64;
	function u128(property) {
	    return new BNLayout(16, property);
	}
	layout.u128 = u128;
	class WideBits extends buffer_layout_1$1.Layout {
	    constructor(property) {
	        super(8, property);
	        this._lower = buffer_layout_1$1.bits(buffer_layout_1$1.u32(), false);
	        this._upper = buffer_layout_1$1.bits(buffer_layout_1$1.u32(), false);
	    }
	    addBoolean(property) {
	        if (this._lower.fields.length < 32) {
	            this._lower.addBoolean(property);
	        }
	        else {
	            this._upper.addBoolean(property);
	        }
	    }
	    decode(b, offset = 0) {
	        const lowerDecoded = this._lower.decode(b, offset);
	        const upperDecoded = this._upper.decode(b, offset + this._lower.span);
	        return { ...lowerDecoded, ...upperDecoded };
	    }
	    encode(src, b, offset = 0) {
	        return (this._lower.encode(src, b, offset) +
	            this._upper.encode(src, b, offset + this._lower.span));
	    }
	}
	layout.WideBits = WideBits;
	class VersionedLayout extends buffer_layout_1$1.Layout {
	    constructor(version, inner, property) {
	        super(inner.span > 0 ? inner.span + 1 : inner.span, property);
	        this.version = version;
	        this.inner = inner;
	    }
	    decode(b, offset = 0) {
	        // if (b.readUInt8(offset) !== this._version) {
	        //   throw new Error('invalid version');
	        // }
	        return this.inner.decode(b, offset + 1);
	    }
	    encode(src, b, offset = 0) {
	        b.writeUInt8(this.version, offset);
	        return 1 + this.inner.encode(src, b, offset + 1);
	    }
	    getSpan(b, offset = 0) {
	        return 1 + this.inner.getSpan(b, offset + 1);
	    }
	}
	layout.VersionedLayout = VersionedLayout;
	class EnumLayout extends buffer_layout_1$1.UInt {
	    constructor(values, span, property) {
	        super(span, property);
	        this.values = values;
	    }
	    encode(src, b, offset) {
	        if (this.values[src] !== undefined) {
	            return super.encode(this.values[src], b, offset);
	        }
	        throw new Error('Invalid ' + this.property);
	    }
	    decode(b, offset) {
	        const decodedValue = super.decode(b, offset);
	        const entry = Object.entries(this.values).find(([, value]) => value === decodedValue);
	        if (entry) {
	            return entry[0];
	        }
	        throw new Error('Invalid ' + this.property);
	    }
	}
	function sideLayout(property) {
	    return new EnumLayout({ buy: 0, sell: 1 }, 4, property);
	}
	layout.sideLayout = sideLayout;
	function orderTypeLayout(property) {
	    return new EnumLayout({ limit: 0, ioc: 1, postOnly: 2 }, 4, property);
	}
	layout.orderTypeLayout = orderTypeLayout;
	function selfTradeBehaviorLayout(property) {
	    return new EnumLayout({ decrementTake: 0, cancelProvide: 1, abortTransaction: 2 }, 4, property);
	}
	layout.selfTradeBehaviorLayout = selfTradeBehaviorLayout;
	const ACCOUNT_FLAGS_LAYOUT = new WideBits();
	ACCOUNT_FLAGS_LAYOUT.addBoolean('initialized');
	ACCOUNT_FLAGS_LAYOUT.addBoolean('market');
	ACCOUNT_FLAGS_LAYOUT.addBoolean('openOrders');
	ACCOUNT_FLAGS_LAYOUT.addBoolean('requestQueue');
	ACCOUNT_FLAGS_LAYOUT.addBoolean('eventQueue');
	ACCOUNT_FLAGS_LAYOUT.addBoolean('bids');
	ACCOUNT_FLAGS_LAYOUT.addBoolean('asks');
	function accountFlagsLayout(property = 'accountFlags') {
	    return ACCOUNT_FLAGS_LAYOUT.replicate(property);
	}
	layout.accountFlagsLayout = accountFlagsLayout;
	function setLayoutDecoder(layout, decoder) {
	    const originalDecode = layout.decode;
	    layout.decode = function decode(b, offset = 0) {
	        return decoder(originalDecode.call(this, b, offset));
	    };
	}
	layout.setLayoutDecoder = setLayoutDecoder;
	function setLayoutEncoder(layout, encoder) {
	    const originalEncode = layout.encode;
	    layout.encode = function encode(src, b, offset) {
	        return originalEncode.call(this, encoder(src), b, offset);
	    };
	    return layout;
	}
	layout.setLayoutEncoder = setLayoutEncoder;

	(function (exports) {
		var __createBinding = (commonjsGlobal && commonjsGlobal.__createBinding) || (Object.create ? (function(o, m, k, k2) {
		    if (k2 === undefined) k2 = k;
		    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
		}) : (function(o, m, k, k2) {
		    if (k2 === undefined) k2 = k;
		    o[k2] = m[k];
		}));
		var __setModuleDefault = (commonjsGlobal && commonjsGlobal.__setModuleDefault) || (Object.create ? (function(o, v) {
		    Object.defineProperty(o, "default", { enumerable: true, value: v });
		}) : function(o, v) {
		    o["default"] = v;
		});
		var __importStar = (commonjsGlobal && commonjsGlobal.__importStar) || function (mod) {
		    if (mod && mod.__esModule) return mod;
		    var result = {};
		    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
		    __setModuleDefault(result, mod);
		    return result;
		};
		Object.defineProperty(exports, "__esModule", { value: true });
		exports.closeAccount = exports.mintTo = exports.setAuthority = exports.revoke = exports.approve = exports.transfer = exports.initializeAccount = exports.initializeMint = exports.decodeTokenInstructionData = exports.SRM_DECIMALS = exports.SRM_MINT = exports.MSRM_DECIMALS = exports.MSRM_MINT = exports.WRAPPED_SOL_MINT = exports.TOKEN_PROGRAM_ID = exports.CLOSE_ACCOUNT_OWNER_INDEX = exports.CLOSE_ACCOUNT_DESTINATION_INDEX = exports.CLOSE_ACCOUNT_SOURCE_INDEX = exports.TRANSFER_OWNER_INDEX = exports.TRANSFER_DESTINATION_INDEX = exports.TRANSFER_SOURCE_INDEX = exports.INITIALIZE_ACCOUNT_OWNER_INDEX = exports.INITIALIZE_ACCOUNT_MINT_INDEX = exports.INITIALIZE_ACCOUNT_ACCOUNT_INDEX = void 0;
		const BufferLayout = __importStar(Layout$1);
		const web3_js_1 = require$$0$1;
		const layout_1 = layout;
		// NOTE: Update these if the position of arguments for the initializeAccount instruction changes
		exports.INITIALIZE_ACCOUNT_ACCOUNT_INDEX = 0;
		exports.INITIALIZE_ACCOUNT_MINT_INDEX = 1;
		exports.INITIALIZE_ACCOUNT_OWNER_INDEX = 2;
		// NOTE: Update these if the position of arguments for the transfer instruction changes
		exports.TRANSFER_SOURCE_INDEX = 0;
		exports.TRANSFER_DESTINATION_INDEX = 1;
		exports.TRANSFER_OWNER_INDEX = 2;
		// NOTE: Update these if the position of arguments for the closeAccount instruction changes
		exports.CLOSE_ACCOUNT_SOURCE_INDEX = 0;
		exports.CLOSE_ACCOUNT_DESTINATION_INDEX = 1;
		exports.CLOSE_ACCOUNT_OWNER_INDEX = 2;
		exports.TOKEN_PROGRAM_ID = new web3_js_1.PublicKey('TokenkegQfeZyiNwAJbNbGKPFXCWuBvf9Ss623VQ5DA');
		exports.WRAPPED_SOL_MINT = new web3_js_1.PublicKey('So11111111111111111111111111111111111111112');
		exports.MSRM_MINT = new web3_js_1.PublicKey('MSRMcoVyrFxnSgo5uXwone5SKcGhT1KEJMFEkMEWf9L');
		exports.MSRM_DECIMALS = 0;
		exports.SRM_MINT = new web3_js_1.PublicKey('SRMuApVNdxXokk5GT7XD5cUUgXMBCoAz2LHeuAoKWRt');
		exports.SRM_DECIMALS = 6;
		const LAYOUT = BufferLayout.union(BufferLayout.u8('instruction'));
		LAYOUT.addVariant(0, BufferLayout.struct([
		    BufferLayout.u8('decimals'),
		    layout_1.publicKeyLayout('mintAuthority'),
		    BufferLayout.u8('freezeAuthorityOption'),
		    layout_1.publicKeyLayout('freezeAuthority'),
		]), 'initializeMint');
		LAYOUT.addVariant(1, BufferLayout.struct([]), 'initializeAccount');
		LAYOUT.addVariant(3, BufferLayout.struct([BufferLayout.nu64('amount')]), 'transfer');
		LAYOUT.addVariant(4, BufferLayout.struct([BufferLayout.nu64('amount')]), 'approve');
		LAYOUT.addVariant(5, BufferLayout.struct([]), 'revoke');
		LAYOUT.addVariant(6, BufferLayout.struct([
		    BufferLayout.u8('authorityType'),
		    BufferLayout.u8('newAuthorityOption'),
		    layout_1.publicKeyLayout('newAuthority'),
		]), 'setAuthority');
		LAYOUT.addVariant(7, BufferLayout.struct([BufferLayout.nu64('amount')]), 'mintTo');
		LAYOUT.addVariant(8, BufferLayout.struct([BufferLayout.nu64('amount')]), 'burn');
		LAYOUT.addVariant(9, BufferLayout.struct([]), 'closeAccount');
		const instructionMaxSpan = Math.max(...Object.values(LAYOUT.registry).map((r) => r.span));
		function encodeTokenInstructionData(instruction) {
		    const b = Buffer.alloc(instructionMaxSpan);
		    const span = LAYOUT.encode(instruction, b);
		    return b.slice(0, span);
		}
		function decodeTokenInstructionData(instruction) {
		    return LAYOUT.decode(instruction);
		}
		exports.decodeTokenInstructionData = decodeTokenInstructionData;
		function initializeMint({ mint, decimals, mintAuthority, freezeAuthority = null, }) {
		    const keys = [
		        { pubkey: mint, isSigner: false, isWritable: true },
		        { pubkey: web3_js_1.SYSVAR_RENT_PUBKEY, isSigner: false, isWritable: false },
		    ];
		    return new web3_js_1.TransactionInstruction({
		        keys,
		        data: encodeTokenInstructionData({
		            initializeMint: {
		                decimals,
		                mintAuthority,
		                freezeAuthorityOption: !!freezeAuthority,
		                freezeAuthority: freezeAuthority || new web3_js_1.PublicKey(0),
		            },
		        }),
		        programId: exports.TOKEN_PROGRAM_ID,
		    });
		}
		exports.initializeMint = initializeMint;
		function initializeAccount({ account, mint, owner }) {
		    const keys = [
		        { pubkey: account, isSigner: false, isWritable: true },
		        { pubkey: mint, isSigner: false, isWritable: false },
		        { pubkey: owner, isSigner: false, isWritable: false },
		        { pubkey: web3_js_1.SYSVAR_RENT_PUBKEY, isSigner: false, isWritable: false },
		    ];
		    return new web3_js_1.TransactionInstruction({
		        keys,
		        data: encodeTokenInstructionData({
		            initializeAccount: {},
		        }),
		        programId: exports.TOKEN_PROGRAM_ID,
		    });
		}
		exports.initializeAccount = initializeAccount;
		function transfer({ source, destination, amount, owner }) {
		    const keys = [
		        { pubkey: source, isSigner: false, isWritable: true },
		        { pubkey: destination, isSigner: false, isWritable: true },
		        { pubkey: owner, isSigner: true, isWritable: false },
		    ];
		    return new web3_js_1.TransactionInstruction({
		        keys,
		        data: encodeTokenInstructionData({
		            transfer: { amount },
		        }),
		        programId: exports.TOKEN_PROGRAM_ID,
		    });
		}
		exports.transfer = transfer;
		function approve({ source, delegate, amount, owner }) {
		    const keys = [
		        { pubkey: source, isSigner: false, isWritable: true },
		        { pubkey: delegate, isSigner: false, isWritable: false },
		        { pubkey: owner, isSigner: true, isWritable: false },
		    ];
		    return new web3_js_1.TransactionInstruction({
		        keys,
		        data: encodeTokenInstructionData({
		            approve: { amount },
		        }),
		        programId: exports.TOKEN_PROGRAM_ID,
		    });
		}
		exports.approve = approve;
		function revoke({ source, owner }) {
		    const keys = [
		        { pubkey: source, isSigner: false, isWritable: true },
		        { pubkey: owner, isSigner: true, isWritable: false },
		    ];
		    return new web3_js_1.TransactionInstruction({
		        keys,
		        data: encodeTokenInstructionData({
		            revoke: {},
		        }),
		        programId: exports.TOKEN_PROGRAM_ID,
		    });
		}
		exports.revoke = revoke;
		function setAuthority({ target, currentAuthority, newAuthority, authorityType, }) {
		    const keys = [
		        { pubkey: target, isSigner: false, isWritable: true },
		        { pubkey: currentAuthority, isSigner: true, isWritable: false },
		    ];
		    return new web3_js_1.TransactionInstruction({
		        keys,
		        data: encodeTokenInstructionData({
		            setAuthority: {
		                authorityType,
		                newAuthorityOption: !!newAuthority,
		                newAuthority,
		            },
		        }),
		        programId: exports.TOKEN_PROGRAM_ID,
		    });
		}
		exports.setAuthority = setAuthority;
		function mintTo({ mint, destination, amount, mintAuthority }) {
		    const keys = [
		        { pubkey: mint, isSigner: false, isWritable: true },
		        { pubkey: destination, isSigner: false, isWritable: true },
		        { pubkey: mintAuthority, isSigner: true, isWritable: false },
		    ];
		    return new web3_js_1.TransactionInstruction({
		        keys,
		        data: encodeTokenInstructionData({
		            mintTo: { amount },
		        }),
		        programId: exports.TOKEN_PROGRAM_ID,
		    });
		}
		exports.mintTo = mintTo;
		function closeAccount({ source, destination, owner }) {
		    const keys = [
		        { pubkey: source, isSigner: false, isWritable: true },
		        { pubkey: destination, isSigner: false, isWritable: true },
		        { pubkey: owner, isSigner: true, isWritable: false },
		    ];
		    return new web3_js_1.TransactionInstruction({
		        keys,
		        data: encodeTokenInstructionData({
		            closeAccount: {},
		        }),
		        programId: exports.TOKEN_PROGRAM_ID,
		    });
		}
		exports.closeAccount = closeAccount;
		
	} (tokenInstructions));

	var market = {};

	var slab = {};

	(function (exports) {
		var __importDefault = (commonjsGlobal && commonjsGlobal.__importDefault) || function (mod) {
		    return (mod && mod.__esModule) ? mod : { "default": mod };
		};
		Object.defineProperty(exports, "__esModule", { value: true });
		exports.Slab = exports.SLAB_LAYOUT = void 0;
		const bn_js_1 = __importDefault(bnExports);
		const buffer_layout_1 = Layout$1;
		const layout_1 = layout;
		const SLAB_HEADER_LAYOUT = buffer_layout_1.struct([
		    // Number of modified slab nodes
		    buffer_layout_1.u32('bumpIndex'),
		    layout_1.zeros(4),
		    // Linked list of unused nodes
		    buffer_layout_1.u32('freeListLen'),
		    layout_1.zeros(4),
		    buffer_layout_1.u32('freeListHead'),
		    buffer_layout_1.u32('root'),
		    buffer_layout_1.u32('leafCount'),
		    layout_1.zeros(4),
		], 'header');
		const SLAB_NODE_LAYOUT = buffer_layout_1.union(buffer_layout_1.u32('tag'), buffer_layout_1.blob(68), 'node');
		SLAB_NODE_LAYOUT.addVariant(0, buffer_layout_1.struct([]), 'uninitialized');
		SLAB_NODE_LAYOUT.addVariant(1, buffer_layout_1.struct([
		    // Only the first prefixLen high-order bits of key are meaningful
		    buffer_layout_1.u32('prefixLen'),
		    layout_1.u128('key'),
		    buffer_layout_1.seq(buffer_layout_1.u32(), 2, 'children'),
		]), 'innerNode');
		SLAB_NODE_LAYOUT.addVariant(2, buffer_layout_1.struct([
		    buffer_layout_1.u8('ownerSlot'),
		    buffer_layout_1.u8('feeTier'),
		    buffer_layout_1.blob(2),
		    layout_1.u128('key'),
		    layout_1.publicKeyLayout('owner'),
		    layout_1.u64('quantity'),
		    layout_1.u64('clientOrderId'),
		]), 'leafNode');
		SLAB_NODE_LAYOUT.addVariant(3, buffer_layout_1.struct([buffer_layout_1.u32('next')]), 'freeNode');
		SLAB_NODE_LAYOUT.addVariant(4, buffer_layout_1.struct([]), 'lastFreeNode');
		exports.SLAB_LAYOUT = buffer_layout_1.struct([
		    SLAB_HEADER_LAYOUT,
		    buffer_layout_1.seq(SLAB_NODE_LAYOUT, buffer_layout_1.offset(SLAB_HEADER_LAYOUT.layoutFor('bumpIndex'), SLAB_HEADER_LAYOUT.offsetOf('bumpIndex') - SLAB_HEADER_LAYOUT.span), 'nodes'),
		]);
		class Slab {
		    constructor(header, nodes) {
		        this.header = header;
		        this.nodes = nodes;
		    }
		    static decode(buffer) {
		        return exports.SLAB_LAYOUT.decode(buffer);
		    }
		    get(searchKey) {
		        if (this.header.leafCount === 0) {
		            return null;
		        }
		        if (!(searchKey instanceof bn_js_1.default)) {
		            searchKey = new bn_js_1.default(searchKey);
		        }
		        let index = this.header.root;
		        while (true) {
		            const { leafNode, innerNode } = this.nodes[index];
		            if (leafNode) {
		                if (leafNode.key.eq(searchKey)) {
		                    return leafNode;
		                }
		                return null;
		            }
		            else if (innerNode) {
		                if (!innerNode.key
		                    .xor(searchKey)
		                    .iushrn(128 - innerNode.prefixLen)
		                    .isZero()) {
		                    return null;
		                }
		                index =
		                    innerNode.children[searchKey.testn(128 - innerNode.prefixLen - 1) ? 1 : 0];
		            }
		            else {
		                throw new Error('Invalid slab');
		            }
		        }
		    }
		    [Symbol.iterator]() {
		        return this.items(false);
		    }
		    *items(descending = false) {
		        if (this.header.leafCount === 0) {
		            return;
		        }
		        const stack = [this.header.root];
		        while (stack.length > 0) {
		            const index = stack.pop();
		            const { leafNode, innerNode } = this.nodes[index];
		            if (leafNode) {
		                yield leafNode;
		            }
		            else if (innerNode) {
		                if (descending) {
		                    stack.push(innerNode.children[0], innerNode.children[1]);
		                }
		                else {
		                    stack.push(innerNode.children[1], innerNode.children[0]);
		                }
		            }
		        }
		    }
		}
		exports.Slab = Slab;
		layout_1.setLayoutDecoder(exports.SLAB_LAYOUT, ({ header, nodes }) => new Slab(header, nodes));
		
	} (slab));

	var instructions = {};

	(function (exports) {
		var __importDefault = (commonjsGlobal && commonjsGlobal.__importDefault) || function (mod) {
		    return (mod && mod.__esModule) ? mod : { "default": mod };
		};
		Object.defineProperty(exports, "__esModule", { value: true });
		exports.DexInstructions = exports.decodeInstructionV2 = exports.decodeInstruction = exports.encodeInstructionV2 = exports.encodeInstruction = exports.INSTRUCTION_LAYOUT_V2 = exports.INSTRUCTION_LAYOUT = exports.NEW_ORDER_V3_OWNER_INDEX = exports.NEW_ORDER_V3_OPEN_ORDERS_INDEX = exports.NEW_ORDER_OWNER_INDEX = exports.NEW_ORDER_OPEN_ORDERS_INDEX = exports.SETTLE_FUNDS_QUOTE_WALLET_INDEX = exports.SETTLE_FUNDS_BASE_WALLET_INDEX = void 0;
		const buffer_layout_1 = Layout$1;
		const layout_1 = layout;
		const web3_js_1 = require$$0$1;
		const token_instructions_1 = tokenInstructions;
		const bn_js_1 = __importDefault(bnExports);
		// NOTE: Update these if the position of arguments for the settleFunds instruction changes
		exports.SETTLE_FUNDS_BASE_WALLET_INDEX = 5;
		exports.SETTLE_FUNDS_QUOTE_WALLET_INDEX = 6;
		// NOTE: Update these if the position of arguments for the newOrder instruction changes
		exports.NEW_ORDER_OPEN_ORDERS_INDEX = 1;
		exports.NEW_ORDER_OWNER_INDEX = 4;
		// NOTE: Update these if the position of arguments for the newOrder instruction changes
		exports.NEW_ORDER_V3_OPEN_ORDERS_INDEX = 1;
		exports.NEW_ORDER_V3_OWNER_INDEX = 7;
		exports.INSTRUCTION_LAYOUT = new layout_1.VersionedLayout(0, buffer_layout_1.union(buffer_layout_1.u32('instruction')));
		exports.INSTRUCTION_LAYOUT.inner.addVariant(0, buffer_layout_1.struct([
		    layout_1.u64('baseLotSize'),
		    layout_1.u64('quoteLotSize'),
		    buffer_layout_1.u16('feeRateBps'),
		    layout_1.u64('vaultSignerNonce'),
		    layout_1.u64('quoteDustThreshold'),
		]), 'initializeMarket');
		exports.INSTRUCTION_LAYOUT.inner.addVariant(1, buffer_layout_1.struct([
		    layout_1.sideLayout('side'),
		    layout_1.u64('limitPrice'),
		    layout_1.u64('maxQuantity'),
		    layout_1.orderTypeLayout('orderType'),
		    layout_1.u64('clientId'),
		]), 'newOrder');
		exports.INSTRUCTION_LAYOUT.inner.addVariant(2, buffer_layout_1.struct([buffer_layout_1.u16('limit')]), 'matchOrders');
		exports.INSTRUCTION_LAYOUT.inner.addVariant(3, buffer_layout_1.struct([buffer_layout_1.u16('limit')]), 'consumeEvents');
		exports.INSTRUCTION_LAYOUT.inner.addVariant(4, buffer_layout_1.struct([
		    layout_1.sideLayout('side'),
		    layout_1.u128('orderId'),
		    layout_1.publicKeyLayout('openOrders'),
		    buffer_layout_1.u8('openOrdersSlot'),
		]), 'cancelOrder');
		exports.INSTRUCTION_LAYOUT.inner.addVariant(5, buffer_layout_1.struct([]), 'settleFunds');
		exports.INSTRUCTION_LAYOUT.inner.addVariant(6, buffer_layout_1.struct([layout_1.u64('clientId')]), 'cancelOrderByClientId');
		exports.INSTRUCTION_LAYOUT.inner.addVariant(10, buffer_layout_1.struct([
		    layout_1.sideLayout('side'),
		    layout_1.u64('limitPrice'),
		    layout_1.u64('maxBaseQuantity'),
		    layout_1.u64('maxQuoteQuantity'),
		    layout_1.selfTradeBehaviorLayout('selfTradeBehavior'),
		    layout_1.orderTypeLayout('orderType'),
		    layout_1.u64('clientId'),
		    buffer_layout_1.u16('limit'),
		]), 'newOrderV3');
		exports.INSTRUCTION_LAYOUT.inner.addVariant(11, buffer_layout_1.struct([layout_1.sideLayout('side'), layout_1.u128('orderId')]), 'cancelOrderV2');
		exports.INSTRUCTION_LAYOUT.inner.addVariant(12, buffer_layout_1.struct([layout_1.u64('clientId')]), 'cancelOrderByClientIdV2');
		exports.INSTRUCTION_LAYOUT.inner.addVariant(14, buffer_layout_1.struct([]), 'closeOpenOrders');
		exports.INSTRUCTION_LAYOUT.inner.addVariant(15, buffer_layout_1.struct([]), 'initOpenOrders');
		exports.INSTRUCTION_LAYOUT.inner.addVariant(16, buffer_layout_1.struct([buffer_layout_1.u16('limit')]), 'prune');
		exports.INSTRUCTION_LAYOUT.inner.addVariant(17, buffer_layout_1.struct([buffer_layout_1.u16('limit')]), 'consumeEventsPermissioned');
		exports.INSTRUCTION_LAYOUT.inner.addVariant(18, buffer_layout_1.struct([buffer_layout_1.seq(layout_1.u64(), 8, 'clientIds')]), 'cancelOrdersByClientIds');
		const orderStruct = () => buffer_layout_1.struct([
		    layout_1.sideLayout('side'),
		    layout_1.u64('limitPrice'),
		    layout_1.u64('maxBaseQuantity'),
		    layout_1.u64('maxQuoteQuantity'),
		    layout_1.selfTradeBehaviorLayout('selfTradeBehavior'),
		    layout_1.orderTypeLayout('orderType'),
		    layout_1.u64('clientId'),
		    buffer_layout_1.u16('limit'),
		    layout_1.i64('maxTs'),
		]);
		exports.INSTRUCTION_LAYOUT.inner.addVariant(19, orderStruct(), 'replaceOrderByClientId');
		exports.INSTRUCTION_LAYOUT.inner.addVariant(20, buffer_layout_1.struct([layout_1.u64('orderAmount'), buffer_layout_1.seq(orderStruct(), 8, 'orders')]), 'replaceOrdersByClientIds');
		exports.INSTRUCTION_LAYOUT_V2 = new layout_1.VersionedLayout(0, buffer_layout_1.union(buffer_layout_1.u32('instruction')));
		exports.INSTRUCTION_LAYOUT_V2.inner.addVariant(10, orderStruct(), 'newOrderV3');
		function encodeInstruction(instruction, maxLength = 100) {
		    const b = Buffer.alloc(maxLength);
		    return b.slice(0, exports.INSTRUCTION_LAYOUT.encode(instruction, b));
		}
		exports.encodeInstruction = encodeInstruction;
		function encodeInstructionV2(instruction) {
		    const b = Buffer.alloc(100);
		    return b.slice(0, exports.INSTRUCTION_LAYOUT_V2.encode(instruction, b));
		}
		exports.encodeInstructionV2 = encodeInstructionV2;
		function decodeInstruction(message) {
		    return exports.INSTRUCTION_LAYOUT.decode(message);
		}
		exports.decodeInstruction = decodeInstruction;
		function decodeInstructionV2(message) {
		    return exports.INSTRUCTION_LAYOUT_V2.decode(message);
		}
		exports.decodeInstructionV2 = decodeInstructionV2;
		class DexInstructions {
		    static initializeMarket({ market, requestQueue, eventQueue, bids, asks, baseVault, quoteVault, baseMint, quoteMint, baseLotSize, quoteLotSize, feeRateBps, vaultSignerNonce, quoteDustThreshold, programId, authority = undefined, pruneAuthority = undefined, crankAuthority = undefined, }) {
		        new web3_js_1.PublicKey('SysvarRent111111111111111111111111111111111');
		        return new web3_js_1.TransactionInstruction({
		            keys: [
		                { pubkey: market, isSigner: false, isWritable: true },
		                { pubkey: requestQueue, isSigner: false, isWritable: true },
		                { pubkey: eventQueue, isSigner: false, isWritable: true },
		                { pubkey: bids, isSigner: false, isWritable: true },
		                { pubkey: asks, isSigner: false, isWritable: true },
		                { pubkey: baseVault, isSigner: false, isWritable: true },
		                { pubkey: quoteVault, isSigner: false, isWritable: true },
		                { pubkey: baseMint, isSigner: false, isWritable: false },
		                { pubkey: quoteMint, isSigner: false, isWritable: false },
		                // Use a dummy address if using the new dex upgrade to save tx space.
		                {
		                    pubkey: authority ? quoteMint : web3_js_1.SYSVAR_RENT_PUBKEY,
		                    isSigner: false,
		                    isWritable: false,
		                },
		            ]
		                .concat(authority
		                ? { pubkey: authority, isSigner: false, isWritable: false }
		                : [])
		                .concat(authority && pruneAuthority
		                ? { pubkey: pruneAuthority, isSigner: false, isWritable: false }
		                : [])
		                .concat(authority && pruneAuthority && crankAuthority
		                ? { pubkey: crankAuthority, isSigner: false, isWritable: false }
		                : []),
		            programId,
		            data: encodeInstruction({
		                initializeMarket: {
		                    baseLotSize,
		                    quoteLotSize,
		                    feeRateBps,
		                    vaultSignerNonce,
		                    quoteDustThreshold,
		                },
		            }),
		        });
		    }
		    static newOrder({ market, openOrders, payer, owner, requestQueue, baseVault, quoteVault, side, limitPrice, maxQuantity, orderType, clientId, programId, feeDiscountPubkey = null, }) {
		        const keys = [
		            { pubkey: market, isSigner: false, isWritable: true },
		            { pubkey: openOrders, isSigner: false, isWritable: true },
		            { pubkey: requestQueue, isSigner: false, isWritable: true },
		            { pubkey: payer, isSigner: false, isWritable: true },
		            { pubkey: owner, isSigner: true, isWritable: false },
		            { pubkey: baseVault, isSigner: false, isWritable: true },
		            { pubkey: quoteVault, isSigner: false, isWritable: true },
		            { pubkey: token_instructions_1.TOKEN_PROGRAM_ID, isSigner: false, isWritable: false },
		            { pubkey: web3_js_1.SYSVAR_RENT_PUBKEY, isSigner: false, isWritable: false },
		        ];
		        if (feeDiscountPubkey) {
		            keys.push({
		                pubkey: feeDiscountPubkey,
		                isSigner: false,
		                isWritable: false,
		            });
		        }
		        return new web3_js_1.TransactionInstruction({
		            keys,
		            programId,
		            data: encodeInstruction({
		                newOrder: clientId
		                    ? { side, limitPrice, maxQuantity, orderType, clientId }
		                    : { side, limitPrice, maxQuantity, orderType },
		            }),
		        });
		    }
		    static newOrderV3({ market, openOrders, payer, owner, requestQueue, eventQueue, bids, asks, baseVault, quoteVault, side, limitPrice, maxBaseQuantity, maxQuoteQuantity, orderType, clientId, programId, selfTradeBehavior, feeDiscountPubkey = null, maxTs = null, replaceIfExists = false, }) {
		        const keys = [
		            { pubkey: market, isSigner: false, isWritable: true },
		            { pubkey: openOrders, isSigner: false, isWritable: true },
		            { pubkey: requestQueue, isSigner: false, isWritable: true },
		            { pubkey: eventQueue, isSigner: false, isWritable: true },
		            { pubkey: bids, isSigner: false, isWritable: true },
		            { pubkey: asks, isSigner: false, isWritable: true },
		            { pubkey: payer, isSigner: false, isWritable: true },
		            { pubkey: owner, isSigner: true, isWritable: false },
		            { pubkey: baseVault, isSigner: false, isWritable: true },
		            { pubkey: quoteVault, isSigner: false, isWritable: true },
		            { pubkey: token_instructions_1.TOKEN_PROGRAM_ID, isSigner: false, isWritable: false },
		            { pubkey: web3_js_1.SYSVAR_RENT_PUBKEY, isSigner: false, isWritable: false },
		        ];
		        if (feeDiscountPubkey) {
		            keys.push({
		                pubkey: feeDiscountPubkey,
		                isSigner: false,
		                isWritable: false,
		            });
		        }
		        let instructionName, encoder;
		        if (replaceIfExists) {
		            instructionName = 'replaceOrderByClientId';
		            encoder = encodeInstruction;
		        }
		        else {
		            instructionName = 'newOrderV3';
		            encoder = maxTs ? encodeInstructionV2 : encodeInstruction;
		        }
		        return new web3_js_1.TransactionInstruction({
		            keys,
		            programId,
		            data: encoder({
		                [instructionName]: {
		                    side,
		                    limitPrice,
		                    maxBaseQuantity,
		                    maxQuoteQuantity,
		                    selfTradeBehavior,
		                    orderType,
		                    clientId,
		                    limit: 65535,
		                    maxTs: new bn_js_1.default(maxTs !== null && maxTs !== void 0 ? maxTs : '9223372036854775807'),
		                },
		            }),
		        });
		    }
		    static replaceOrdersByClientIds({ market, openOrders, payer, owner, requestQueue, eventQueue, bids, asks, baseVault, quoteVault, feeDiscountPubkey = null, programId, orders }) {
		        const keys = [
		            { pubkey: market, isSigner: false, isWritable: true },
		            { pubkey: openOrders, isSigner: false, isWritable: true },
		            { pubkey: requestQueue, isSigner: false, isWritable: true },
		            { pubkey: eventQueue, isSigner: false, isWritable: true },
		            { pubkey: bids, isSigner: false, isWritable: true },
		            { pubkey: asks, isSigner: false, isWritable: true },
		            { pubkey: payer, isSigner: false, isWritable: true },
		            { pubkey: owner, isSigner: true, isWritable: false },
		            { pubkey: baseVault, isSigner: false, isWritable: true },
		            { pubkey: quoteVault, isSigner: false, isWritable: true },
		            { pubkey: token_instructions_1.TOKEN_PROGRAM_ID, isSigner: false, isWritable: false },
		            { pubkey: web3_js_1.SYSVAR_RENT_PUBKEY, isSigner: false, isWritable: false },
		        ];
		        if (feeDiscountPubkey) {
		            keys.push({
		                pubkey: feeDiscountPubkey,
		                isSigner: false,
		                isWritable: false,
		            });
		        }
		        return new web3_js_1.TransactionInstruction({
		            keys,
		            programId,
		            data: encodeInstruction({
		                replaceOrdersByClientIds: {
		                    orderAmount: new bn_js_1.default(orders.length),
		                    orders: orders.map(order => {
		                        var _a;
		                        return ({
		                            ...order,
		                            maxTs: new bn_js_1.default((_a = order.maxTs) !== null && _a !== void 0 ? _a : '9223372036854775807'),
		                            limit: 65535,
		                        });
		                    })
		                }
		            }, 15 + orders.length * 60).slice(0, 13 + orders.length * 54)
		        });
		    }
		    static matchOrders({ market, requestQueue, eventQueue, bids, asks, baseVault, quoteVault, limit, programId, }) {
		        return new web3_js_1.TransactionInstruction({
		            keys: [
		                { pubkey: market, isSigner: false, isWritable: true },
		                { pubkey: requestQueue, isSigner: false, isWritable: true },
		                { pubkey: eventQueue, isSigner: false, isWritable: true },
		                { pubkey: bids, isSigner: false, isWritable: true },
		                { pubkey: asks, isSigner: false, isWritable: true },
		                { pubkey: baseVault, isSigner: false, isWritable: true },
		                { pubkey: quoteVault, isSigner: false, isWritable: true },
		            ],
		            programId,
		            data: encodeInstruction({ matchOrders: { limit } }),
		        });
		    }
		    static consumeEvents({ market, eventQueue, coinFee, pcFee, openOrdersAccounts, limit, programId, }) {
		        return new web3_js_1.TransactionInstruction({
		            keys: [
		                ...openOrdersAccounts.map((account) => ({
		                    pubkey: account,
		                    isSigner: false,
		                    isWritable: true,
		                })),
		                { pubkey: market, isSigner: false, isWritable: true },
		                { pubkey: eventQueue, isSigner: false, isWritable: true },
		                { pubkey: coinFee, isSigner: false, isWriteable: true },
		                { pubkey: pcFee, isSigner: false, isWritable: true },
		            ],
		            programId,
		            data: encodeInstruction({ consumeEvents: { limit } }),
		        });
		    }
		    static consumeEventsPermissioned({ market, eventQueue, crankAuthority, openOrdersAccounts, limit, programId, }) {
		        return new web3_js_1.TransactionInstruction({
		            keys: [
		                ...openOrdersAccounts.map((account) => ({
		                    pubkey: account,
		                    isSigner: false,
		                    isWritable: true,
		                })),
		                { pubkey: market, isSigner: false, isWritable: true },
		                { pubkey: eventQueue, isSigner: false, isWritable: true },
		                { pubkey: crankAuthority, isSigner: true, isWritable: false },
		            ],
		            programId,
		            data: encodeInstruction({ consumeEventsPermissioned: { limit } }),
		        });
		    }
		    static cancelOrder({ market, openOrders, owner, requestQueue, side, orderId, openOrdersSlot, programId, }) {
		        return new web3_js_1.TransactionInstruction({
		            keys: [
		                { pubkey: market, isSigner: false, isWritable: false },
		                { pubkey: openOrders, isSigner: false, isWritable: true },
		                { pubkey: requestQueue, isSigner: false, isWritable: true },
		                { pubkey: owner, isSigner: true, isWritable: false },
		            ],
		            programId,
		            data: encodeInstruction({
		                cancelOrder: { side, orderId, openOrders, openOrdersSlot },
		            }),
		        });
		    }
		    static cancelOrderV2(order) {
		        const { market, bids, asks, eventQueue, openOrders, owner, side, orderId, programId, } = order;
		        return new web3_js_1.TransactionInstruction({
		            keys: [
		                { pubkey: market, isSigner: false, isWritable: false },
		                { pubkey: bids, isSigner: false, isWritable: true },
		                { pubkey: asks, isSigner: false, isWritable: true },
		                { pubkey: openOrders, isSigner: false, isWritable: true },
		                { pubkey: owner, isSigner: true, isWritable: false },
		                { pubkey: eventQueue, isSigner: false, isWritable: true },
		            ],
		            programId,
		            data: encodeInstruction({
		                cancelOrderV2: { side, orderId },
		            }),
		        });
		    }
		    static cancelOrderByClientId({ market, openOrders, owner, requestQueue, clientId, programId, }) {
		        return new web3_js_1.TransactionInstruction({
		            keys: [
		                { pubkey: market, isSigner: false, isWritable: false },
		                { pubkey: openOrders, isSigner: false, isWritable: true },
		                { pubkey: requestQueue, isSigner: false, isWritable: true },
		                { pubkey: owner, isSigner: true, isWritable: false },
		            ],
		            programId,
		            data: encodeInstruction({
		                cancelOrderByClientId: { clientId },
		            }),
		        });
		    }
		    static cancelOrderByClientIdV2({ market, openOrders, owner, bids, asks, eventQueue, clientId, programId, }) {
		        return new web3_js_1.TransactionInstruction({
		            keys: [
		                { pubkey: market, isSigner: false, isWritable: false },
		                { pubkey: bids, isSigner: false, isWritable: true },
		                { pubkey: asks, isSigner: false, isWritable: true },
		                { pubkey: openOrders, isSigner: false, isWritable: true },
		                { pubkey: owner, isSigner: true, isWritable: false },
		                { pubkey: eventQueue, isSigner: false, isWritable: true },
		            ],
		            programId,
		            data: encodeInstruction({
		                cancelOrderByClientIdV2: { clientId },
		            }),
		        });
		    }
		    static cancelOrdersByClientIds({ market, openOrders, owner, bids, asks, eventQueue, clientIds, programId, }) {
		        if (clientIds.length > 8) {
		            throw new Error("Number of client ids cannot exceed 8!");
		        }
		        while (clientIds.length < 8) {
		            clientIds.push(new bn_js_1.default(0));
		        }
		        return new web3_js_1.TransactionInstruction({
		            keys: [
		                { pubkey: market, isSigner: false, isWritable: false },
		                { pubkey: bids, isSigner: false, isWritable: true },
		                { pubkey: asks, isSigner: false, isWritable: true },
		                { pubkey: openOrders, isSigner: false, isWritable: true },
		                { pubkey: owner, isSigner: true, isWritable: false },
		                { pubkey: eventQueue, isSigner: false, isWritable: true },
		            ],
		            programId,
		            data: encodeInstruction({
		                cancelOrdersByClientIds: { clientIds },
		            }),
		        });
		    }
		    static settleFunds({ market, openOrders, owner, baseVault, quoteVault, baseWallet, quoteWallet, vaultSigner, programId, referrerQuoteWallet = null, }) {
		        const keys = [
		            { pubkey: market, isSigner: false, isWritable: true },
		            { pubkey: openOrders, isSigner: false, isWritable: true },
		            { pubkey: owner, isSigner: true, isWritable: false },
		            { pubkey: baseVault, isSigner: false, isWritable: true },
		            { pubkey: quoteVault, isSigner: false, isWritable: true },
		            { pubkey: baseWallet, isSigner: false, isWritable: true },
		            { pubkey: quoteWallet, isSigner: false, isWritable: true },
		            { pubkey: vaultSigner, isSigner: false, isWritable: false },
		            { pubkey: token_instructions_1.TOKEN_PROGRAM_ID, isSigner: false, isWritable: false },
		        ];
		        if (referrerQuoteWallet) {
		            keys.push({
		                pubkey: referrerQuoteWallet,
		                isSigner: false,
		                isWritable: true,
		            });
		        }
		        return new web3_js_1.TransactionInstruction({
		            keys,
		            programId,
		            data: encodeInstruction({
		                settleFunds: {},
		            }),
		        });
		    }
		    static closeOpenOrders({ market, openOrders, owner, solWallet, programId }) {
		        const keys = [
		            { pubkey: openOrders, isSigner: false, isWritable: true },
		            { pubkey: owner, isSigner: true, isWritable: false },
		            { pubkey: solWallet, isSigner: false, isWritable: true },
		            { pubkey: market, isSigner: false, isWritable: false },
		        ];
		        return new web3_js_1.TransactionInstruction({
		            keys,
		            programId,
		            data: encodeInstruction({
		                closeOpenOrders: {},
		            }),
		        });
		    }
		    static initOpenOrders({ market, openOrders, owner, programId, marketAuthority, }) {
		        const keys = [
		            { pubkey: openOrders, isSigner: false, isWritable: true },
		            { pubkey: owner, isSigner: true, isWritable: false },
		            { pubkey: market, isSigner: false, isWritable: false },
		            { pubkey: web3_js_1.SYSVAR_RENT_PUBKEY, isSigner: false, isWritable: false },
		        ].concat(marketAuthority
		            ? { pubkey: marketAuthority, isSigner: false, isWritable: false }
		            : []);
		        return new web3_js_1.TransactionInstruction({
		            keys,
		            programId,
		            data: encodeInstruction({
		                initOpenOrders: {},
		            }),
		        });
		    }
		    static prune({ market, bids, asks, eventQueue, pruneAuthority, openOrders, openOrdersOwner, programId, limit, }) {
		        const keys = [
		            { pubkey: market, isSigner: false, isWritable: true },
		            { pubkey: bids, isSigner: false, isWritable: true },
		            { pubkey: asks, isSigner: false, isWritable: true },
		            // Keep signer false so that one can use a PDA.
		            { pubkey: pruneAuthority, isSigner: false, isWritable: false },
		            { pubkey: openOrders, isSigner: false, isWritable: true },
		            { pubkey: openOrdersOwner, isSigner: false, isWritable: false },
		            { pubkey: eventQueue, isSigner: false, isWritable: true },
		        ];
		        return new web3_js_1.TransactionInstruction({
		            keys,
		            programId,
		            data: encodeInstruction({
		                prune: { limit },
		            }),
		        });
		    }
		}
		exports.DexInstructions = DexInstructions;
		
	} (instructions));

	var queue = {};

	Object.defineProperty(queue, "__esModule", { value: true });
	queue.EVENT_QUEUE_LAYOUT = queue.REQUEST_QUEUE_LAYOUT = queue.decodeEventQueue = queue.decodeRequestQueue = queue.decodeEventsSince = void 0;
	const buffer_layout_1 = Layout$1;
	const layout_1 = layout;
	const REQUEST_QUEUE_HEADER = buffer_layout_1.struct([
	    buffer_layout_1.blob(5),
	    layout_1.accountFlagsLayout('accountFlags'),
	    buffer_layout_1.u32('head'),
	    layout_1.zeros(4),
	    buffer_layout_1.u32('count'),
	    layout_1.zeros(4),
	    buffer_layout_1.u32('nextSeqNum'),
	    layout_1.zeros(4),
	]);
	const REQUEST_FLAGS = buffer_layout_1.bits(buffer_layout_1.u8(), false, 'requestFlags');
	REQUEST_FLAGS.addBoolean('newOrder');
	REQUEST_FLAGS.addBoolean('cancelOrder');
	REQUEST_FLAGS.addBoolean('bid');
	REQUEST_FLAGS.addBoolean('postOnly');
	REQUEST_FLAGS.addBoolean('ioc');
	const REQUEST = buffer_layout_1.struct([
	    REQUEST_FLAGS,
	    buffer_layout_1.u8('openOrdersSlot'),
	    buffer_layout_1.u8('feeTier'),
	    buffer_layout_1.blob(5),
	    layout_1.u64('maxBaseSizeOrCancelId'),
	    layout_1.u64('nativeQuoteQuantityLocked'),
	    layout_1.u128('orderId'),
	    layout_1.publicKeyLayout('openOrders'),
	    layout_1.u64('clientOrderId'),
	]);
	const EVENT_QUEUE_HEADER = buffer_layout_1.struct([
	    buffer_layout_1.blob(5),
	    layout_1.accountFlagsLayout('accountFlags'),
	    buffer_layout_1.u32('head'),
	    layout_1.zeros(4),
	    buffer_layout_1.u32('count'),
	    layout_1.zeros(4),
	    buffer_layout_1.u32('seqNum'),
	    layout_1.zeros(4),
	]);
	const EVENT_FLAGS = buffer_layout_1.bits(buffer_layout_1.u8(), false, 'eventFlags');
	EVENT_FLAGS.addBoolean('fill');
	EVENT_FLAGS.addBoolean('out');
	EVENT_FLAGS.addBoolean('bid');
	EVENT_FLAGS.addBoolean('maker');
	const EVENT = buffer_layout_1.struct([
	    EVENT_FLAGS,
	    buffer_layout_1.u8('openOrdersSlot'),
	    buffer_layout_1.u8('feeTier'),
	    buffer_layout_1.blob(5),
	    layout_1.u64('nativeQuantityReleased'),
	    layout_1.u64('nativeQuantityPaid'),
	    layout_1.u64('nativeFeeOrRebate'),
	    layout_1.u128('orderId'),
	    layout_1.publicKeyLayout('openOrders'),
	    layout_1.u64('clientOrderId'),
	]);
	function decodeQueueItem(headerLayout, nodeLayout, buffer, nodeIndex) {
	    return nodeLayout.decode(buffer, headerLayout.span + nodeIndex * nodeLayout.span);
	}
	function decodeQueue(headerLayout, nodeLayout, buffer, history) {
	    const header = headerLayout.decode(buffer);
	    const allocLen = Math.floor((buffer.length - headerLayout.span) / nodeLayout.span);
	    const nodes = [];
	    if (history) {
	        for (let i = 0; i < Math.min(history, allocLen); ++i) {
	            const nodeIndex = (header.head + header.count + allocLen - 1 - i) % allocLen;
	            nodes.push(decodeQueueItem(headerLayout, nodeLayout, buffer, nodeIndex));
	        }
	    }
	    else {
	        for (let i = 0; i < header.count; ++i) {
	            const nodeIndex = (header.head + i) % allocLen;
	            nodes.push(decodeQueueItem(headerLayout, nodeLayout, buffer, nodeIndex));
	        }
	    }
	    return { header, nodes };
	}
	function decodeEventsSince(buffer, lastSeqNum) {
	    const header = EVENT_QUEUE_HEADER.decode(buffer);
	    const allocLen = Math.floor((buffer.length - EVENT_QUEUE_HEADER.span) / EVENT.span);
	    // calculate number of missed events
	    // account for u32 & ringbuffer overflows
	    const modulo32Uint = 0x100000000;
	    let missedEvents = (header.seqNum - lastSeqNum + modulo32Uint) % modulo32Uint;
	    if (missedEvents > allocLen) {
	        missedEvents = allocLen - 1;
	    }
	    const startSeq = (header.seqNum - missedEvents + modulo32Uint) % modulo32Uint;
	    // define boundary indexes in ring buffer [start;end)
	    const endIndex = (header.head + header.count) % allocLen;
	    const startIndex = (endIndex - missedEvents + allocLen) % allocLen;
	    const results = [];
	    for (let i = 0; i < missedEvents; ++i) {
	        const nodeIndex = (startIndex + i) % allocLen;
	        const event = decodeQueueItem(EVENT_QUEUE_HEADER, EVENT, buffer, nodeIndex);
	        event.seqNum = (startSeq + i) % modulo32Uint;
	        results.push(event);
	    }
	    return results;
	}
	queue.decodeEventsSince = decodeEventsSince;
	function decodeRequestQueue(buffer, history) {
	    const { header, nodes } = decodeQueue(REQUEST_QUEUE_HEADER, REQUEST, buffer, history);
	    if (!header.accountFlags.initialized || !header.accountFlags.requestQueue) {
	        throw new Error('Invalid requests queue');
	    }
	    return nodes;
	}
	queue.decodeRequestQueue = decodeRequestQueue;
	function decodeEventQueue(buffer, history) {
	    const { header, nodes } = decodeQueue(EVENT_QUEUE_HEADER, EVENT, buffer, history);
	    if (!header.accountFlags.initialized || !header.accountFlags.eventQueue) {
	        throw new Error('Invalid events queue');
	    }
	    return nodes;
	}
	queue.decodeEventQueue = decodeEventQueue;
	queue.REQUEST_QUEUE_LAYOUT = {
	    HEADER: REQUEST_QUEUE_HEADER,
	    NODE: REQUEST,
	};
	queue.EVENT_QUEUE_LAYOUT = {
	    HEADER: EVENT_QUEUE_HEADER,
	    NODE: EVENT,
	};

	var fees = {};

	var tokens_and_markets = {};

	var require$$1 = [
		{
			address: "B37pZmwrwXHjpgvd9hHDAx1yeDsNevTnbbrN9W12BoGK",
			deprecated: true,
			name: "soALEPH/soUSDC",
			programId: "4ckmDgGdxQoPDLUkDT3vHgSAkzA3QRdNq5ywwY4sUSJn"
		},
		{
			address: "CAgAeMD7quTdnr6RPa7JySQpjf3irAmefYNdTb6anemq",
			deprecated: true,
			name: "BTC/soUSDC",
			programId: "4ckmDgGdxQoPDLUkDT3vHgSAkzA3QRdNq5ywwY4sUSJn"
		},
		{
			address: "ASKiV944nKg1W9vsf7hf3fTsjawK6DwLwrnB2LH9n61c",
			deprecated: true,
			name: "soETH/soUSDC",
			programId: "4ckmDgGdxQoPDLUkDT3vHgSAkzA3QRdNq5ywwY4sUSJn"
		},
		{
			address: "Cdp72gDcYMCLLk3aDkPxjeiirKoFqK38ECm8Ywvk94Wi",
			deprecated: true,
			name: "SOL/soUSDC",
			programId: "BJ3jrUzddfuSrZHXSCxMUUQsjKEyLmuuyZebkcaFp2fg"
		},
		{
			address: "68J6nkWToik6oM9rTatKSR5ibVSykAtzftBUEAvpRsys",
			deprecated: true,
			name: "SRM/soUSDC",
			programId: "4ckmDgGdxQoPDLUkDT3vHgSAkzA3QRdNq5ywwY4sUSJn"
		},
		{
			address: "8Jzed8Fafu1RU1CQDWdiETSrqAJy1ukZ5JL6Pma3p3a2",
			deprecated: true,
			name: "SRM/SOL",
			programId: "EUqojwWA2rd19FZrzeBncJsm38Jm1hEhE3zsmX3bRc2o"
		},
		{
			address: "9wDmxsfwaDb2ysmZpBLzxKzoWrF1zHzBN7PV5EmJe19R",
			deprecated: true,
			name: "soSUSHI/soUSDC",
			programId: "4ckmDgGdxQoPDLUkDT3vHgSAkzA3QRdNq5ywwY4sUSJn"
		},
		{
			address: "GbQSffne1NcJbS4jsewZEpRGYVR4RNnuVUN8Ht6vAGb6",
			deprecated: true,
			name: "soSXP/soUSDC",
			programId: "4ckmDgGdxQoPDLUkDT3vHgSAkzA3QRdNq5ywwY4sUSJn"
		},
		{
			address: "7kgkDyW7dmyMeP8KFXzbcUZz1R2WHsovDZ7n3ihZuNDS",
			deprecated: true,
			name: "MSRM/soUSDC",
			programId: "4ckmDgGdxQoPDLUkDT3vHgSAkzA3QRdNq5ywwY4sUSJn"
		},
		{
			address: "FZqrBXz7ADGsmDf1TM9YgysPUfvtG8rJiNUrqDpHc9Au",
			deprecated: true,
			name: "soFTT/soUSDC",
			programId: "4ckmDgGdxQoPDLUkDT3vHgSAkzA3QRdNq5ywwY4sUSJn"
		},
		{
			address: "FJg9FUtbN3fg3YFbMCFiZKjGh5Bn4gtzxZmtxFzmz9kT",
			deprecated: true,
			name: "soYFI/soUSDC",
			programId: "4ckmDgGdxQoPDLUkDT3vHgSAkzA3QRdNq5ywwY4sUSJn"
		},
		{
			address: "7GZ59DMgJ7D6dfoJTpszPayTRyua9jwcaGJXaRMMF1my",
			deprecated: true,
			name: "soLINK/soUSDC",
			programId: "4ckmDgGdxQoPDLUkDT3vHgSAkzA3QRdNq5ywwY4sUSJn"
		},
		{
			address: "uPNcBgFhrLW3FtvyYYbBUi53BBEQf9e4NPgwxaLu5Hn",
			deprecated: true,
			name: "soHGET/soUSDC",
			programId: "4ckmDgGdxQoPDLUkDT3vHgSAkzA3QRdNq5ywwY4sUSJn"
		},
		{
			address: "3puWJFZyCso14EdxhywjD7xqyTarpsULx483mzvqxQRW",
			deprecated: true,
			name: "soCREAM/soUSDC",
			programId: "4ckmDgGdxQoPDLUkDT3vHgSAkzA3QRdNq5ywwY4sUSJn"
		},
		{
			address: "8Ae7Uhigx8k4fKdJG7irdPCVDZLvWsJfeTH2t5fr3TVD",
			deprecated: true,
			name: "soUBXT/soUSDC",
			programId: "4ckmDgGdxQoPDLUkDT3vHgSAkzA3QRdNq5ywwY4sUSJn"
		},
		{
			address: "Hze5AUX4Qp1cTujiJ4CsAMRGn4g6ZpgXsmptFn3xxhWg",
			deprecated: true,
			name: "soHNT/soUSDC",
			programId: "4ckmDgGdxQoPDLUkDT3vHgSAkzA3QRdNq5ywwY4sUSJn"
		},
		{
			address: "FJq4HX3bUSgF3yQZ8ADALtJYfAyr9fz36SNG18hc3dgF",
			deprecated: true,
			name: "soFRONT/soUSDC",
			programId: "4ckmDgGdxQoPDLUkDT3vHgSAkzA3QRdNq5ywwY4sUSJn"
		},
		{
			address: "BZMuoQ2i2noNUXMdrRDivc7MwjGspNJTCfZkdHMwK18T",
			deprecated: true,
			name: "soALEPH/soUSDC",
			programId: "EUqojwWA2rd19FZrzeBncJsm38Jm1hEhE3zsmX3bRc2o"
		},
		{
			address: "5LgJphS6D5zXwUVPU7eCryDBkyta3AidrJ5vjNU6BcGW",
			deprecated: true,
			name: "BTC/soUSDC",
			programId: "EUqojwWA2rd19FZrzeBncJsm38Jm1hEhE3zsmX3bRc2o"
		},
		{
			address: "DmEDKZPXXkWgaYiKgWws2ZXWWKCh41eryDPRVD4zKnD9",
			deprecated: true,
			name: "soETH/soUSDC",
			programId: "EUqojwWA2rd19FZrzeBncJsm38Jm1hEhE3zsmX3bRc2o"
		},
		{
			address: "EBFTQNg2QjyxV7WDDenoLbfLLXLcbSz6w1YrdTCGPWT5",
			deprecated: true,
			name: "SOL/soUSDC",
			programId: "EUqojwWA2rd19FZrzeBncJsm38Jm1hEhE3zsmX3bRc2o"
		},
		{
			address: "8YmQZRXGizZXYPCDmxgjwB8X8XN4PZG7MMwNg76iAmPZ",
			deprecated: true,
			name: "SRM/soUSDC",
			programId: "EUqojwWA2rd19FZrzeBncJsm38Jm1hEhE3zsmX3bRc2o"
		},
		{
			address: "9vFuX2BizwinWjkZLQTmThDcNMFEcY3wVXYuqnRQtcD",
			deprecated: true,
			name: "soSUSHI/soUSDC",
			programId: "EUqojwWA2rd19FZrzeBncJsm38Jm1hEhE3zsmX3bRc2o"
		},
		{
			address: "C5NReXAeQhfjiDCGPFj1UUmDxDqF8v2CUVKoYuQqb4eW",
			deprecated: true,
			name: "soSXP/soUSDC",
			programId: "EUqojwWA2rd19FZrzeBncJsm38Jm1hEhE3zsmX3bRc2o"
		},
		{
			address: "58H7ZRmiyWtsrz2sQGz1qQCMW6n7447xhNNehUSQGPj5",
			deprecated: true,
			name: "MSRM/soUSDC",
			programId: "EUqojwWA2rd19FZrzeBncJsm38Jm1hEhE3zsmX3bRc2o"
		},
		{
			address: "ES8skmkEeyH1BYFThd2FtyaFKhkqtwH7XWp8mXptv3vg",
			deprecated: true,
			name: "soFTT/soUSDC",
			programId: "EUqojwWA2rd19FZrzeBncJsm38Jm1hEhE3zsmX3bRc2o"
		},
		{
			address: "Gw78CYLLFbgmmn4rps9KoPAnNtBQ2S1foL2Mn6Z5ZHYB",
			deprecated: true,
			name: "soYFI/soUSDC",
			programId: "EUqojwWA2rd19FZrzeBncJsm38Jm1hEhE3zsmX3bRc2o"
		},
		{
			address: "WjfsTPyrvUUrhGJ9hVQFubMnKDcnQS8VxSXU7L2gLcA",
			deprecated: true,
			name: "soLINK/soUSDC",
			programId: "EUqojwWA2rd19FZrzeBncJsm38Jm1hEhE3zsmX3bRc2o"
		},
		{
			address: "2ZmB255T4FVUugpeXTFxD6Yz5GE47yTByYvqSTDUbk3G",
			deprecated: true,
			name: "soHGET/soUSDC",
			programId: "EUqojwWA2rd19FZrzeBncJsm38Jm1hEhE3zsmX3bRc2o"
		},
		{
			address: "FGJtCDXoHLHjagP5Ht6xcUFt2rW3z8MJPe87rFKP2ZW6",
			deprecated: true,
			name: "soCREAM/soUSDC",
			programId: "EUqojwWA2rd19FZrzeBncJsm38Jm1hEhE3zsmX3bRc2o"
		},
		{
			address: "7K6MPog6LskZmyaYwqtLvRUuedoiE68nirbQ9tK3LasE",
			deprecated: true,
			name: "soUBXT/soUSDC",
			programId: "EUqojwWA2rd19FZrzeBncJsm38Jm1hEhE3zsmX3bRc2o"
		},
		{
			address: "9RyozJe3bkAFfH3jmoiKHjkWCoLTxn7aBQSi6YfaV6ab",
			deprecated: true,
			name: "soHNT/soUSDC",
			programId: "EUqojwWA2rd19FZrzeBncJsm38Jm1hEhE3zsmX3bRc2o"
		},
		{
			address: "AGtBbGuJZiv3Ko3dfT4v6g4kCqnNc9DXfoGLe5HpjmWx",
			deprecated: true,
			name: "soFRONT/soUSDC",
			programId: "EUqojwWA2rd19FZrzeBncJsm38Jm1hEhE3zsmX3bRc2o"
		},
		{
			address: "AA1HSrsMcRNzjaQfRMTNarHR9B7e4U79LJ2319UtiqPF",
			deprecated: true,
			name: "soAKRO/soUSDC",
			programId: "EUqojwWA2rd19FZrzeBncJsm38Jm1hEhE3zsmX3bRc2o"
		},
		{
			address: "AUAobJdffexcoJBMeyLorpShu3ZtG9VvPEPjoeTN4u5Z",
			deprecated: true,
			name: "soHXRO/soUSDC",
			programId: "EUqojwWA2rd19FZrzeBncJsm38Jm1hEhE3zsmX3bRc2o"
		},
		{
			address: "GpdYLFbKHeSeDGqsnQ4jnP7D1294iBpQcsN1VPwhoaFS",
			deprecated: true,
			name: "soUNI/soUSDC",
			programId: "EUqojwWA2rd19FZrzeBncJsm38Jm1hEhE3zsmX3bRc2o"
		},
		{
			address: "sxS9EdTx1UPe4j2c6Au9f1GKZXrFj5pTgNKgjGGtGdY",
			deprecated: true,
			name: "soKEEP/soUSDC",
			programId: "EUqojwWA2rd19FZrzeBncJsm38Jm1hEhE3zsmX3bRc2o"
		},
		{
			address: "CfnnU38ACScF6pcurxSB3FLXeZmfFYunVKExeUyosu5P",
			deprecated: true,
			name: "soMATH/soUSDC",
			programId: "EUqojwWA2rd19FZrzeBncJsm38Jm1hEhE3zsmX3bRc2o"
		},
		{
			address: "7NR5GDouQYkkfppVkNhpa4HfJ2LwqUQymE3b4CYQiYHa",
			deprecated: true,
			name: "soALEPH/USDC",
			programId: "EUqojwWA2rd19FZrzeBncJsm38Jm1hEhE3zsmX3bRc2o"
		},
		{
			address: "CVfYa8RGXnuDBeGmniCcdkBwoLqVxh92xB1JqgRQx3F",
			deprecated: true,
			name: "BTC/USDC",
			programId: "EUqojwWA2rd19FZrzeBncJsm38Jm1hEhE3zsmX3bRc2o"
		},
		{
			address: "H5uzEytiByuXt964KampmuNCurNDwkVVypkym75J2DQW",
			deprecated: true,
			name: "soETH/USDC",
			programId: "EUqojwWA2rd19FZrzeBncJsm38Jm1hEhE3zsmX3bRc2o"
		},
		{
			address: "7xMDbYTCqQEcK2aM9LbetGtNFJpzKdfXzLL5juaLh4GJ",
			deprecated: true,
			name: "SOL/USDC",
			programId: "EUqojwWA2rd19FZrzeBncJsm38Jm1hEhE3zsmX3bRc2o"
		},
		{
			address: "CDdR97S8y96v3To93aKvi3nCnjUrbuVSuumw8FLvbVeg",
			deprecated: true,
			name: "SRM/USDC",
			programId: "EUqojwWA2rd19FZrzeBncJsm38Jm1hEhE3zsmX3bRc2o"
		},
		{
			address: "7LVJtqSrF6RudMaz5rKGTmR3F3V5TKoDcN6bnk68biYZ",
			deprecated: true,
			name: "soSUSHI/USDC",
			programId: "EUqojwWA2rd19FZrzeBncJsm38Jm1hEhE3zsmX3bRc2o"
		},
		{
			address: "13vjJ8pxDMmzen26bQ5UrouX8dkXYPW1p3VLVDjxXrKR",
			deprecated: true,
			name: "soSXP/USDC",
			programId: "EUqojwWA2rd19FZrzeBncJsm38Jm1hEhE3zsmX3bRc2o"
		},
		{
			address: "AwvPwwSprfDZ86beBJDNH5vocFvuw4ZbVQ6upJDbSCXZ",
			deprecated: true,
			name: "MSRM/USDC",
			programId: "EUqojwWA2rd19FZrzeBncJsm38Jm1hEhE3zsmX3bRc2o"
		},
		{
			address: "FfDb3QZUdMW2R2aqJQgzeieys4ETb3rPrFFfPSemzq7R",
			deprecated: true,
			name: "soFTT/USDC",
			programId: "EUqojwWA2rd19FZrzeBncJsm38Jm1hEhE3zsmX3bRc2o"
		},
		{
			address: "4QL5AQvXdMSCVZmnKXiuMMU83Kq3LCwVfU8CyznqZELG",
			deprecated: true,
			name: "soYFI/USDC",
			programId: "EUqojwWA2rd19FZrzeBncJsm38Jm1hEhE3zsmX3bRc2o"
		},
		{
			address: "7JCG9TsCx3AErSV3pvhxiW4AbkKRcJ6ZAveRmJwrgQ16",
			deprecated: true,
			name: "soLINK/USDC",
			programId: "EUqojwWA2rd19FZrzeBncJsm38Jm1hEhE3zsmX3bRc2o"
		},
		{
			address: "3otQFkeQ7GNUKT3i2p3aGTQKS2SAw6NLYPE5qxh3PoqZ",
			deprecated: true,
			name: "soHGET/USDC",
			programId: "EUqojwWA2rd19FZrzeBncJsm38Jm1hEhE3zsmX3bRc2o"
		},
		{
			address: "2M8EBxFbLANnCoHydypL1jupnRHG782RofnvkatuKyLL",
			deprecated: true,
			name: "soCREAM/USDC",
			programId: "EUqojwWA2rd19FZrzeBncJsm38Jm1hEhE3zsmX3bRc2o"
		},
		{
			address: "3UqXdFtNBZsFrFtRGAWGvy9R8H6GJR2hAyGRdYT9BgG3",
			deprecated: true,
			name: "soUBXT/USDC",
			programId: "EUqojwWA2rd19FZrzeBncJsm38Jm1hEhE3zsmX3bRc2o"
		},
		{
			address: "9jiasgdYGGh34fAbBQSwkKe1dYSapXbjy2sLsYpetqFp",
			deprecated: true,
			name: "soHNT/USDC",
			programId: "EUqojwWA2rd19FZrzeBncJsm38Jm1hEhE3zsmX3bRc2o"
		},
		{
			address: "7oKqJhnz9b8af8Mw47dieTiuxeaHnRYYGBiqCrRpzTRD",
			deprecated: true,
			name: "soFRONT/USDC",
			programId: "EUqojwWA2rd19FZrzeBncJsm38Jm1hEhE3zsmX3bRc2o"
		},
		{
			address: "F1rxD8Ns5w4WzVcTRdaJ96LG7YKaA5a25BBmM32yFP4b",
			deprecated: true,
			name: "soAKRO/USDC",
			programId: "EUqojwWA2rd19FZrzeBncJsm38Jm1hEhE3zsmX3bRc2o"
		},
		{
			address: "6ToedDwjRCvrcKX7fnHSTA9uABQe1dcLK6YgS5B9M3wo",
			deprecated: true,
			name: "soHXRO/USDC",
			programId: "EUqojwWA2rd19FZrzeBncJsm38Jm1hEhE3zsmX3bRc2o"
		},
		{
			address: "FURvCsDUiuUaxZ13pZqQbbfktFGWmQVTHz7tL992LQVZ",
			deprecated: true,
			name: "soUNI/USDC",
			programId: "EUqojwWA2rd19FZrzeBncJsm38Jm1hEhE3zsmX3bRc2o"
		},
		{
			address: "EcfDRMrEJ3yW4SgrRyyxTPoKqAZDNSBV8EerigT7BNSS",
			deprecated: true,
			name: "soKEEP/USDC",
			programId: "EUqojwWA2rd19FZrzeBncJsm38Jm1hEhE3zsmX3bRc2o"
		},
		{
			address: "2bPsJ6bZ9KDLfJ8QgSN1Eb4mRsbAiaGyHN6cJkoVLpwd",
			deprecated: true,
			name: "soMATH/USDC",
			programId: "EUqojwWA2rd19FZrzeBncJsm38Jm1hEhE3zsmX3bRc2o"
		},
		{
			address: "B1GypajMh7S8zJVp6M1xMfu6zGsMgvYrt3cSn9wG7Dd6",
			deprecated: true,
			name: "soTOMO/USDC",
			programId: "EUqojwWA2rd19FZrzeBncJsm38Jm1hEhE3zsmX3bRc2o"
		},
		{
			address: "rPTGvVrNFYzBeTEcYnHiaWGNnkSXsWNNjUgk771LkwJ",
			deprecated: true,
			name: "soLUA/USDC",
			programId: "EUqojwWA2rd19FZrzeBncJsm38Jm1hEhE3zsmX3bRc2o"
		},
		{
			address: "FrDavxi4QawYnQY259PVfYUjUvuyPNfqSXbLBqMnbfWJ",
			deprecated: true,
			name: "FIDA/USDC",
			programId: "EUqojwWA2rd19FZrzeBncJsm38Jm1hEhE3zsmX3bRc2o"
		},
		{
			address: "CVn1nJ5Utuseyy2qqwrpYoJz9Y7jjYonVL4UYvcCepDH",
			deprecated: true,
			name: "KIN/USDC",
			programId: "EUqojwWA2rd19FZrzeBncJsm38Jm1hEhE3zsmX3bRc2o"
		},
		{
			address: "BqjGW7ousAizgs8VrHo5SR1LxTksAQPtb8cKZZiNvX5D",
			deprecated: true,
			name: "MAPS/USDC",
			programId: "EUqojwWA2rd19FZrzeBncJsm38Jm1hEhE3zsmX3bRc2o"
		},
		{
			address: "GcoKtAmTy5QyuijXSmJKBtFdt99e6Buza18Js7j9AJ6e",
			deprecated: false,
			name: "soALEPH/USDC",
			programId: "9xQeWvG816bUx9EPjHmaT23yvVM2ZWbrrpZb9PusVFin"
		},
		{
			address: "A8YFbxQYFVqKZaoYJLLUVcQiWP7G2MeEgW5wsAQgMvFw",
			deprecated: false,
			name: "BTC/USDC",
			programId: "9xQeWvG816bUx9EPjHmaT23yvVM2ZWbrrpZb9PusVFin"
		},
		{
			address: "4tSvZvnbyzHXLMTiFonMyxZoHmFqau1XArcRCVHLZ5gX",
			deprecated: false,
			name: "soETH/USDC",
			programId: "9xQeWvG816bUx9EPjHmaT23yvVM2ZWbrrpZb9PusVFin"
		},
		{
			address: "ByRys5tuUWDgL73G8JBAEfkdFf8JWBzPBDHsBVQ5vbQA",
			deprecated: false,
			name: "SRM/USDC",
			programId: "9xQeWvG816bUx9EPjHmaT23yvVM2ZWbrrpZb9PusVFin"
		},
		{
			address: "A1Q9iJDVVS8Wsswr9ajeZugmj64bQVCYLZQLra2TMBMo",
			deprecated: false,
			name: "soSUSHI/USDC",
			programId: "9xQeWvG816bUx9EPjHmaT23yvVM2ZWbrrpZb9PusVFin"
		},
		{
			address: "4LUro5jaPaTurXK737QAxgJywdhABnFAMQkXX4ZyqqaZ",
			deprecated: false,
			name: "soSXP/USDC",
			programId: "9xQeWvG816bUx9EPjHmaT23yvVM2ZWbrrpZb9PusVFin"
		},
		{
			address: "4VKLSYdvrQ5ngQrt1d2VS8o4ewvb2MMUZLiejbnGPV33",
			deprecated: false,
			name: "MSRM/USDC",
			programId: "9xQeWvG816bUx9EPjHmaT23yvVM2ZWbrrpZb9PusVFin"
		},
		{
			address: "2Pbh1CvRVku1TgewMfycemghf6sU9EyuFDcNXqvRmSxc",
			deprecated: false,
			name: "soFTT/USDC",
			programId: "9xQeWvG816bUx9EPjHmaT23yvVM2ZWbrrpZb9PusVFin"
		},
		{
			address: "7qcCo8jqepnjjvB5swP4Afsr3keVBs6gNpBTNubd1Kr2",
			deprecated: false,
			name: "soYFI/USDC",
			programId: "9xQeWvG816bUx9EPjHmaT23yvVM2ZWbrrpZb9PusVFin"
		},
		{
			address: "3hwH1txjJVS8qv588tWrjHfRxdqNjBykM1kMcit484up",
			deprecated: false,
			name: "soLINK/USDC",
			programId: "9xQeWvG816bUx9EPjHmaT23yvVM2ZWbrrpZb9PusVFin"
		},
		{
			address: "88vztw7RTN6yJQchVvxrs6oXUDryvpv9iJaFa1EEmg87",
			deprecated: false,
			name: "soHGET/USDC",
			programId: "9xQeWvG816bUx9EPjHmaT23yvVM2ZWbrrpZb9PusVFin"
		},
		{
			address: "7nZP6feE94eAz9jmfakNJWPwEKaeezuKKC5D1vrnqyo2",
			deprecated: false,
			name: "soCREAM/USDC",
			programId: "9xQeWvG816bUx9EPjHmaT23yvVM2ZWbrrpZb9PusVFin"
		},
		{
			address: "2wr3Ab29KNwGhtzr5HaPCyfU1qGJzTUAN4amCLZWaD1H",
			deprecated: false,
			name: "soUBXT/USDC",
			programId: "9xQeWvG816bUx9EPjHmaT23yvVM2ZWbrrpZb9PusVFin"
		},
		{
			address: "CnUV42ZykoKUnMDdyefv5kP6nDSJf7jFd7WXAecC6LYr",
			deprecated: false,
			name: "soHNT/USDC",
			programId: "9xQeWvG816bUx9EPjHmaT23yvVM2ZWbrrpZb9PusVFin"
		},
		{
			address: "9Zx1CvxSVdroKMMWf2z8RwrnrLiQZ9VkQ7Ex3syQqdSH",
			deprecated: false,
			name: "soFRONT/USDC",
			programId: "9xQeWvG816bUx9EPjHmaT23yvVM2ZWbrrpZb9PusVFin"
		},
		{
			address: "5CZXTTgVZKSzgSA3AFMN5a2f3hmwmmJ6hU8BHTEJ3PX8",
			deprecated: false,
			name: "soAKRO/USDC",
			programId: "9xQeWvG816bUx9EPjHmaT23yvVM2ZWbrrpZb9PusVFin"
		},
		{
			address: "6Pn1cSiRos3qhBf54uBP9ZQg8x3JTardm1dL3n4p29tA",
			deprecated: false,
			name: "soHXRO/USDC",
			programId: "9xQeWvG816bUx9EPjHmaT23yvVM2ZWbrrpZb9PusVFin"
		},
		{
			address: "6JYHjaQBx6AtKSSsizDMwozAEDEZ5KBsSUzH7kRjGJon",
			deprecated: false,
			name: "soUNI/USDC",
			programId: "9xQeWvG816bUx9EPjHmaT23yvVM2ZWbrrpZb9PusVFin"
		},
		{
			address: "J7cPYBrXVy8Qeki2crZkZavcojf2sMRyQU7nx438Mf8t",
			deprecated: false,
			name: "soMATH/USDC",
			programId: "9xQeWvG816bUx9EPjHmaT23yvVM2ZWbrrpZb9PusVFin"
		},
		{
			address: "8BdpjpSD5n3nk8DQLqPUyTZvVqFu6kcff5bzUX5dqDpy",
			deprecated: false,
			name: "soTOMO/USDC",
			programId: "9xQeWvG816bUx9EPjHmaT23yvVM2ZWbrrpZb9PusVFin"
		},
		{
			address: "4xyWjQ74Eifq17vbue5Ut9xfFNfuVB116tZLEpiZuAn8",
			deprecated: false,
			name: "soLUA/USDC",
			programId: "9xQeWvG816bUx9EPjHmaT23yvVM2ZWbrrpZb9PusVFin"
		},
		{
			address: "jyei9Fpj2GtHLDDGgcuhDacxYLLiSyxU4TY7KxB2xai",
			deprecated: false,
			name: "SRM/SOL",
			programId: "9xQeWvG816bUx9EPjHmaT23yvVM2ZWbrrpZb9PusVFin"
		},
		{
			address: "9wFFyRfZBsuAha4YcuxcXLKwMxJR43S7fPfQLusDBzvT",
			deprecated: false,
			name: "SOL/USDC",
			programId: "9xQeWvG816bUx9EPjHmaT23yvVM2ZWbrrpZb9PusVFin"
		},
		{
			address: "E14BKBhDWD4EuTkWj1ooZezesGxMW8LPCps4W5PuzZJo",
			deprecated: false,
			name: "FIDA/USDC",
			programId: "9xQeWvG816bUx9EPjHmaT23yvVM2ZWbrrpZb9PusVFin"
		},
		{
			address: "Bn6NPyr6UzrFAwC4WmvPvDr2Vm8XSUnFykM2aQroedgn",
			deprecated: false,
			name: "KIN/USDC",
			programId: "9xQeWvG816bUx9EPjHmaT23yvVM2ZWbrrpZb9PusVFin"
		},
		{
			address: "3A8XQRWXC7BjLpgLDDBhQJLT5yPCzS16cGYRKHkKxvYo",
			deprecated: false,
			name: "MAPS/USDC",
			programId: "9xQeWvG816bUx9EPjHmaT23yvVM2ZWbrrpZb9PusVFin"
		},
		{
			address: "3rgacody9SvM88QR83GHaNdEEx4Fe2V2ed5GJp2oeKDr",
			deprecated: false,
			name: "soKEEP/USDC",
			programId: "9xQeWvG816bUx9EPjHmaT23yvVM2ZWbrrpZb9PusVFin"
		},
		{
			address: "EmCzMQfXMgNHcnRoFwAdPe1i2SuiSzMj1mx6wu3KN2uA",
			deprecated: true,
			name: "soALEPH/soUSDT",
			programId: "4ckmDgGdxQoPDLUkDT3vHgSAkzA3QRdNq5ywwY4sUSJn"
		},
		{
			address: "8AcVjMG2LTbpkjNoyq8RwysokqZunkjy3d5JDzxC6BJa",
			deprecated: true,
			name: "BTC/soUSDT",
			programId: "4ckmDgGdxQoPDLUkDT3vHgSAkzA3QRdNq5ywwY4sUSJn"
		},
		{
			address: "HfCZdJ1wfsWKfYP2qyWdXTT5PWAGWFctzFjLH48U1Hsd",
			deprecated: true,
			name: "soETH/soUSDT",
			programId: "4ckmDgGdxQoPDLUkDT3vHgSAkzA3QRdNq5ywwY4sUSJn"
		},
		{
			address: "8mDuvJJSgoodovMRYArtVVYBbixWYdGzR47GPrRT65YJ",
			deprecated: true,
			name: "SOL/soUSDT",
			programId: "BJ3jrUzddfuSrZHXSCxMUUQsjKEyLmuuyZebkcaFp2fg"
		},
		{
			address: "HARFLhSq8nECZk4DVFKvzqXMNMA9a3hjvridGMFizeLa",
			deprecated: true,
			name: "SRM/soUSDT",
			programId: "4ckmDgGdxQoPDLUkDT3vHgSAkzA3QRdNq5ywwY4sUSJn"
		},
		{
			address: "DzFjazak6EKHnaB2w6qSsArnj28CV1TKd2Smcj9fqtHW",
			deprecated: true,
			name: "soSUSHI/soUSDT",
			programId: "4ckmDgGdxQoPDLUkDT3vHgSAkzA3QRdNq5ywwY4sUSJn"
		},
		{
			address: "GuvWMATdEV6DExWnXncPYEzn4ePWYkvGdC8pu8gsn7m7",
			deprecated: true,
			name: "soSXP/soUSDT",
			programId: "4ckmDgGdxQoPDLUkDT3vHgSAkzA3QRdNq5ywwY4sUSJn"
		},
		{
			address: "H4snTKK9adiU15gP22ErfZYtro3aqR9BTMXiH3AwiUTQ",
			deprecated: true,
			name: "MSRM/soUSDT",
			programId: "4ckmDgGdxQoPDLUkDT3vHgSAkzA3QRdNq5ywwY4sUSJn"
		},
		{
			address: "DHDdghmkBhEpReno3tbzBPtsxCt6P3KrMzZvxavTktJt",
			deprecated: true,
			name: "soFTT/soUSDT",
			programId: "4ckmDgGdxQoPDLUkDT3vHgSAkzA3QRdNq5ywwY4sUSJn"
		},
		{
			address: "5zu5bTZZvqESAAgFsr12CUMxdQvMrvU9CgvC1GW8vJdf",
			deprecated: true,
			name: "soYFI/soUSDT",
			programId: "4ckmDgGdxQoPDLUkDT3vHgSAkzA3QRdNq5ywwY4sUSJn"
		},
		{
			address: "F5xschQBMpu1gD2q1babYEAVJHR1buj1YazLiXyQNqSW",
			deprecated: true,
			name: "soLINK/soUSDT",
			programId: "4ckmDgGdxQoPDLUkDT3vHgSAkzA3QRdNq5ywwY4sUSJn"
		},
		{
			address: "BAbc9baz4hV1hnYjWSJ6cZDRjfvziWbYGQu9UFkcdUmx",
			deprecated: true,
			name: "soHGET/soUSDT",
			programId: "4ckmDgGdxQoPDLUkDT3vHgSAkzA3QRdNq5ywwY4sUSJn"
		},
		{
			address: "EBxJWA2nLV57ZntbjizxH527ZjPNLT5cpUHMnY5k3oq",
			deprecated: true,
			name: "soCREAM/soUSDT",
			programId: "4ckmDgGdxQoPDLUkDT3vHgSAkzA3QRdNq5ywwY4sUSJn"
		},
		{
			address: "46VdEkj4MJwZinwVb3Y7DUDpVXLNb9YW7P2waKU3vCqr",
			deprecated: true,
			name: "soUBXT/soUSDT",
			programId: "4ckmDgGdxQoPDLUkDT3vHgSAkzA3QRdNq5ywwY4sUSJn"
		},
		{
			address: "Hc22rHKrhbrZBaQMmhJvPTkp1yDr31PDusU8wKoqFSZV",
			deprecated: true,
			name: "soHNT/soUSDT",
			programId: "4ckmDgGdxQoPDLUkDT3vHgSAkzA3QRdNq5ywwY4sUSJn"
		},
		{
			address: "HFoca5HKwiTPpw9iUY5iXWqzkXdu88dS7YrpSvt2uhyF",
			deprecated: true,
			name: "soFRONT/soUSDT",
			programId: "4ckmDgGdxQoPDLUkDT3vHgSAkzA3QRdNq5ywwY4sUSJn"
		},
		{
			address: "5xnYnWca2bFwC6cPufpdsCbDJhMjYCC59YgwoZHEfiee",
			deprecated: true,
			name: "soALEPH/soUSDT",
			programId: "EUqojwWA2rd19FZrzeBncJsm38Jm1hEhE3zsmX3bRc2o"
		},
		{
			address: "EXnGBBSamqzd3uxEdRLUiYzjJkTwQyorAaFXdfteuGXe",
			deprecated: true,
			name: "BTC/soUSDT",
			programId: "EUqojwWA2rd19FZrzeBncJsm38Jm1hEhE3zsmX3bRc2o"
		},
		{
			address: "5abZGhrELnUnfM9ZUnvK6XJPoBU5eShZwfFPkdhAC7o",
			deprecated: true,
			name: "soETH/soUSDT",
			programId: "EUqojwWA2rd19FZrzeBncJsm38Jm1hEhE3zsmX3bRc2o"
		},
		{
			address: "7xLk17EQQ5KLDLDe44wCmupJKJjTGd8hs3eSVVhCx932",
			deprecated: true,
			name: "SOL/soUSDT",
			programId: "EUqojwWA2rd19FZrzeBncJsm38Jm1hEhE3zsmX3bRc2o"
		},
		{
			address: "H3APNWA8bZW2gLMSq5sRL41JSMmEJ648AqoEdDgLcdvB",
			deprecated: true,
			name: "SRM/soUSDT",
			programId: "EUqojwWA2rd19FZrzeBncJsm38Jm1hEhE3zsmX3bRc2o"
		},
		{
			address: "4uZTPc72sCDcVRfKKii67dTPm2Xe4ri3TYnGcUQrtnU9",
			deprecated: true,
			name: "soSUSHI/soUSDT",
			programId: "EUqojwWA2rd19FZrzeBncJsm38Jm1hEhE3zsmX3bRc2o"
		},
		{
			address: "33GHmwG9woY95JuWNi74Aa8uKvysSXxif9P1EwwkrCRz",
			deprecated: true,
			name: "soSXP/soUSDT",
			programId: "EUqojwWA2rd19FZrzeBncJsm38Jm1hEhE3zsmX3bRc2o"
		},
		{
			address: "FUaF58sDrgbqakHTR8RUwRLauSofRTjqyCsqThFPh6YM",
			deprecated: true,
			name: "MSRM/soUSDT",
			programId: "EUqojwWA2rd19FZrzeBncJsm38Jm1hEhE3zsmX3bRc2o"
		},
		{
			address: "5NqjQVXLuLSDnsnQMfWp3rF9gbWDusWG4B1Xwtk3rZ5S",
			deprecated: true,
			name: "soFTT/soUSDT",
			programId: "EUqojwWA2rd19FZrzeBncJsm38Jm1hEhE3zsmX3bRc2o"
		},
		{
			address: "97NiXHUNkpYd1eb2HthSDGhaPfepuqMAV3QsZhAgb1wm",
			deprecated: true,
			name: "soYFI/soUSDT",
			programId: "EUqojwWA2rd19FZrzeBncJsm38Jm1hEhE3zsmX3bRc2o"
		},
		{
			address: "hBswhpNyz4m5nt4KwtCA7jYXvh7VmyZ4TuuPmpaKQb1",
			deprecated: true,
			name: "soLINK/soUSDT",
			programId: "EUqojwWA2rd19FZrzeBncJsm38Jm1hEhE3zsmX3bRc2o"
		},
		{
			address: "GaeUpY7CT8rjoeVGjY1t3mJJDd1bdXxYWtrGSpsVFors",
			deprecated: true,
			name: "soHGET/soUSDT",
			programId: "EUqojwWA2rd19FZrzeBncJsm38Jm1hEhE3zsmX3bRc2o"
		},
		{
			address: "7qq9BABQvTWKZuJ5fX2PeTKX6XVtduEs9zW9WS21fSzN",
			deprecated: true,
			name: "soCREAM/soUSDT",
			programId: "EUqojwWA2rd19FZrzeBncJsm38Jm1hEhE3zsmX3bRc2o"
		},
		{
			address: "DCHvVahuLTNWBGUtEzF5GrTdx5FRpxqEJiS6Ru1hrDfD",
			deprecated: true,
			name: "soUBXT/soUSDT",
			programId: "EUqojwWA2rd19FZrzeBncJsm38Jm1hEhE3zsmX3bRc2o"
		},
		{
			address: "DWjJ8VHdGYBxDQYdrRBVDWkHswrgjuBFEv5pBhiRoPBz",
			deprecated: true,
			name: "soHNT/soUSDT",
			programId: "EUqojwWA2rd19FZrzeBncJsm38Jm1hEhE3zsmX3bRc2o"
		},
		{
			address: "56eqxJYzPigm4FkigiBdsfebjMgAbKNh24E7oiKLBtye",
			deprecated: true,
			name: "soFRONT/soUSDT",
			programId: "EUqojwWA2rd19FZrzeBncJsm38Jm1hEhE3zsmX3bRc2o"
		},
		{
			address: "FQbCNSVH3RgosCPB4CJRstkLh5hXkvuXzAjQzT11oMYo",
			deprecated: true,
			name: "soAKRO/soUSDT",
			programId: "EUqojwWA2rd19FZrzeBncJsm38Jm1hEhE3zsmX3bRc2o"
		},
		{
			address: "Fs5xtGUmJTYo8Ao75M3R3m3mVX53KMUhzfXCmyRLnp2P",
			deprecated: true,
			name: "soHXRO/soUSDT",
			programId: "EUqojwWA2rd19FZrzeBncJsm38Jm1hEhE3zsmX3bRc2o"
		},
		{
			address: "ChKV7mxecPqFPGYJjhzowPHDiLKFWXXVujUiE3EWxFcg",
			deprecated: true,
			name: "soUNI/soUSDT",
			programId: "EUqojwWA2rd19FZrzeBncJsm38Jm1hEhE3zsmX3bRc2o"
		},
		{
			address: "6N3oU7ALvn2RPwdpYVzPBgQJ8njT29inBbS2tSrwx8fh",
			deprecated: true,
			name: "soKEEP/soUSDT",
			programId: "EUqojwWA2rd19FZrzeBncJsm38Jm1hEhE3zsmX3bRc2o"
		},
		{
			address: "5P6dJbyKySFXMYNWiEcNQu8xPRYsehYzCeVpae9Ueqrg",
			deprecated: true,
			name: "soMATH/soUSDT",
			programId: "EUqojwWA2rd19FZrzeBncJsm38Jm1hEhE3zsmX3bRc2o"
		},
		{
			address: "H7c8FcQPJ2E5tJmpWBPSi7xCAbk8immdtUxKFRUyE4Ro",
			deprecated: true,
			name: "soTOMO/soUSDT",
			programId: "EUqojwWA2rd19FZrzeBncJsm38Jm1hEhE3zsmX3bRc2o"
		},
		{
			address: "7PSeX1AEtBY9KvgegF5rUh452VemMh7oDzFtJgH7sxMG",
			deprecated: true,
			name: "soLUA/soUSDT",
			programId: "EUqojwWA2rd19FZrzeBncJsm38Jm1hEhE3zsmX3bRc2o"
		},
		{
			address: "AF2oQQaLtcrTnQyVs3EPTdyw57TPaK6njKYDq2Qw7LqP",
			deprecated: true,
			name: "soSWAG/soUSDT",
			programId: "EUqojwWA2rd19FZrzeBncJsm38Jm1hEhE3zsmX3bRc2o"
		},
		{
			address: "9TE15E5h61zJ5VmQAAHkGrAuQdFTth33aBbKdcrppZBp",
			deprecated: true,
			name: "FIDA/soUSDT",
			programId: "EUqojwWA2rd19FZrzeBncJsm38Jm1hEhE3zsmX3bRc2o"
		},
		{
			address: "8HEaA1vSA5mGQoHcvRPNibnuZvnUpSjJJru9HJNH3SqM",
			deprecated: true,
			name: "KIN/soUSDT",
			programId: "EUqojwWA2rd19FZrzeBncJsm38Jm1hEhE3zsmX3bRc2o"
		},
		{
			address: "8EuuEwULFM7n7zthPjC7kA64LPRzYkpAyuLFiLuVg7D4",
			deprecated: true,
			name: "soUSDT/USDC",
			programId: "EUqojwWA2rd19FZrzeBncJsm38Jm1hEhE3zsmX3bRc2o"
		},
		{
			address: "8grUs4WZoTs4KJ8LfRNUBs6SNkMTp5BnVRzJgQ2ranDT",
			deprecated: true,
			name: "MAPS/soUSDT",
			programId: "EUqojwWA2rd19FZrzeBncJsm38Jm1hEhE3zsmX3bRc2o"
		},
		{
			address: "FoCuWt4KboucUg2PwmQ3dbkvLqYPLnAo1Rsm8p7QPyf",
			deprecated: true,
			name: "soALEPH/soUSDT",
			programId: "9xQeWvG816bUx9EPjHmaT23yvVM2ZWbrrpZb9PusVFin"
		},
		{
			address: "5r8FfnbNYcQbS1m4CYmoHYGjBtu6bxfo6UJHNRfzPiYH",
			deprecated: true,
			name: "BTC/soUSDT",
			programId: "9xQeWvG816bUx9EPjHmaT23yvVM2ZWbrrpZb9PusVFin"
		},
		{
			address: "71CtEComq2XdhGNbXBuYPmosAjMCPSedcgbNi5jDaGbR",
			deprecated: true,
			name: "soETH/soUSDT",
			programId: "9xQeWvG816bUx9EPjHmaT23yvVM2ZWbrrpZb9PusVFin"
		},
		{
			address: "EZyQ9zyqQsw3QcsLksoWyd1UFVjHZkzRx8N4ZMnZQrS2",
			deprecated: true,
			name: "SRM/soUSDT",
			programId: "9xQeWvG816bUx9EPjHmaT23yvVM2ZWbrrpZb9PusVFin"
		},
		{
			address: "6ERBjj692XHLWwWSRAUpiKenXshcwmPqhMy7RMapeoKa",
			deprecated: true,
			name: "soSUSHI/soUSDT",
			programId: "9xQeWvG816bUx9EPjHmaT23yvVM2ZWbrrpZb9PusVFin"
		},
		{
			address: "CQ3kAGxPmpBbak2RSHWyMeRhyLYbH6oVZHJxgjzDLpLW",
			deprecated: true,
			name: "soSXP/soUSDT",
			programId: "9xQeWvG816bUx9EPjHmaT23yvVM2ZWbrrpZb9PusVFin"
		},
		{
			address: "2Hqn46jhwaQMQ3zEnHtxrWxQZom6qwLXAgdsFJM1Srwh",
			deprecated: true,
			name: "MSRM/soUSDT",
			programId: "9xQeWvG816bUx9EPjHmaT23yvVM2ZWbrrpZb9PusVFin"
		},
		{
			address: "G5jqZNo2UVCTnJxgEhKCYvqFRs3MxsnH8Bervq3rfLoL",
			deprecated: true,
			name: "soFTT/soUSDT",
			programId: "9xQeWvG816bUx9EPjHmaT23yvVM2ZWbrrpZb9PusVFin"
		},
		{
			address: "CbwtTHEpfTnCyLw4GoTbKk7WyrXkuATLfLadY2odBSsY",
			deprecated: true,
			name: "soYFI/soUSDT",
			programId: "9xQeWvG816bUx9EPjHmaT23yvVM2ZWbrrpZb9PusVFin"
		},
		{
			address: "5GjhBAYx8pYeCeUQt7rt93KQZnoQFuDq9Jx4iqq97Mip",
			deprecated: true,
			name: "soLINK/soUSDT",
			programId: "9xQeWvG816bUx9EPjHmaT23yvVM2ZWbrrpZb9PusVFin"
		},
		{
			address: "9jMPV9E23pTirMjC7vz5suRNkd25311G3Httg7jTib8R",
			deprecated: true,
			name: "soCREAM/soUSDT",
			programId: "9xQeWvG816bUx9EPjHmaT23yvVM2ZWbrrpZb9PusVFin"
		},
		{
			address: "DsSz9KWT97T4RewRTqTNDpNFQyxMPcuYNAJw2xHAzSiZ",
			deprecated: true,
			name: "soUBXT/soUSDT",
			programId: "9xQeWvG816bUx9EPjHmaT23yvVM2ZWbrrpZb9PusVFin"
		},
		{
			address: "3k1sURztjxhjYczjyioQ7y2UkMB6K5Ksi3SWvLeLx6Ex",
			deprecated: true,
			name: "soHNT/soUSDT",
			programId: "9xQeWvG816bUx9EPjHmaT23yvVM2ZWbrrpZb9PusVFin"
		},
		{
			address: "B791G8UCahfmABVcR2wPAMK6LJnuqxSAqiG6wX3mmVVM",
			deprecated: true,
			name: "soFRONT/soUSDT",
			programId: "9xQeWvG816bUx9EPjHmaT23yvVM2ZWbrrpZb9PusVFin"
		},
		{
			address: "95f7fxfUh8WqUTrdjorHRXm6rTfkWqr23ioGMmKMjedP",
			deprecated: true,
			name: "soAKRO/soUSDT",
			programId: "9xQeWvG816bUx9EPjHmaT23yvVM2ZWbrrpZb9PusVFin"
		},
		{
			address: "H4RxtmQ4P3TYPt78G3DuHgaGzyFct6MfaeYneLB5PyeG",
			deprecated: true,
			name: "soHXRO/soUSDT",
			programId: "9xQeWvG816bUx9EPjHmaT23yvVM2ZWbrrpZb9PusVFin"
		},
		{
			address: "7myaZEGZf9m72T1Mqm8GTx5MnmSFS5NCXSwRP18W4EA3",
			deprecated: true,
			name: "soUNI/soUSDT",
			programId: "9xQeWvG816bUx9EPjHmaT23yvVM2ZWbrrpZb9PusVFin"
		},
		{
			address: "7cRKzNoqjF9VtzvdnP129VYP3izivk9iY3jMJBMzREVT",
			deprecated: true,
			name: "soHGET/soUSDT",
			programId: "9xQeWvG816bUx9EPjHmaT23yvVM2ZWbrrpZb9PusVFin"
		},
		{
			address: "GV9fYzdwipoaagXFxe5tzDMPcmSVQati5CUvBPsEZThH",
			deprecated: true,
			name: "soMATH/soUSDT",
			programId: "9xQeWvG816bUx9EPjHmaT23yvVM2ZWbrrpZb9PusVFin"
		},
		{
			address: "AaMLXcwYYi5fA41JNCB2ukAmQyKHitYx5NnpsiWWev6R",
			deprecated: true,
			name: "soTOMO/soUSDT",
			programId: "9xQeWvG816bUx9EPjHmaT23yvVM2ZWbrrpZb9PusVFin"
		},
		{
			address: "5ZeNLrduGi3WkH9CPwv2Zpbkh38MH8v63aSi2aBUW23g",
			deprecated: true,
			name: "soLUA/soUSDT",
			programId: "9xQeWvG816bUx9EPjHmaT23yvVM2ZWbrrpZb9PusVFin"
		},
		{
			address: "Ec1aq54XKH9o5fe169cU2sCcxxTP54eeQCe77SpizKuc",
			deprecated: true,
			name: "soUSDT/USDC",
			programId: "9xQeWvG816bUx9EPjHmaT23yvVM2ZWbrrpZb9PusVFin"
		},
		{
			address: "G3uhFg2rBFunHUXtCera13vyQ5KCS8Hx3d4HohLoZbT5",
			deprecated: true,
			name: "SOL/soUSDT",
			programId: "9xQeWvG816bUx9EPjHmaT23yvVM2ZWbrrpZb9PusVFin"
		},
		{
			address: "2NMTG7tFZidRpQk9Sf4dgQyJb9HxKCyXjQdiuXww3sKm",
			deprecated: true,
			name: "soSWAG/soUSDT",
			programId: "9xQeWvG816bUx9EPjHmaT23yvVM2ZWbrrpZb9PusVFin"
		},
		{
			address: "7QpJAiwGmqY1SiucjfPXvgeWwCobyV6hZSgzMysZX6Ww",
			deprecated: true,
			name: "FIDA/soUSDT",
			programId: "9xQeWvG816bUx9EPjHmaT23yvVM2ZWbrrpZb9PusVFin"
		},
		{
			address: "CmLhvXARncLncE1949XBfQWeJh6Zvw3FE5A3Z5ecPYQH",
			deprecated: true,
			name: "KIN/soUSDT",
			programId: "9xQeWvG816bUx9EPjHmaT23yvVM2ZWbrrpZb9PusVFin"
		},
		{
			address: "FhP3X2ptdi7L1RtWK9Vfow5dyzD92gfXiA57e8eqxvka",
			deprecated: true,
			name: "MAPS/soUSDT",
			programId: "9xQeWvG816bUx9EPjHmaT23yvVM2ZWbrrpZb9PusVFin"
		},
		{
			address: "DE7xJE2EkaV81wLabDMuhBzUwFhhwfURLdz1aXBBQZQ1",
			deprecated: true,
			name: "soKEEP/soUSDT",
			programId: "9xQeWvG816bUx9EPjHmaT23yvVM2ZWbrrpZb9PusVFin"
		},
		{
			address: "5nLJ22h1DUfeCfwbFxPYK8zbfbri7nA9bXoDcR8AcJjs",
			deprecated: false,
			name: "MSRM/USDT",
			programId: "9xQeWvG816bUx9EPjHmaT23yvVM2ZWbrrpZb9PusVFin"
		},
		{
			address: "7dLVkUfBVfCGkFhSXDCq1ukM9usathSgS716t643iFGF",
			deprecated: false,
			name: "soETH/USDT",
			programId: "9xQeWvG816bUx9EPjHmaT23yvVM2ZWbrrpZb9PusVFin"
		},
		{
			address: "8afKwzHR3wJE7W7Y5hvQkngXh6iTepSZuutRMMy96MjR",
			deprecated: false,
			name: "soSXP/USDT",
			programId: "9xQeWvG816bUx9EPjHmaT23yvVM2ZWbrrpZb9PusVFin"
		},
		{
			address: "cgani53cMZgYfRMgSrNekJTMaLmccRfspsfTbXWRg7u",
			deprecated: false,
			name: "soCEL/USDT",
			programId: "9xQeWvG816bUx9EPjHmaT23yvVM2ZWbrrpZb9PusVFin"
		},
		{
			address: "Gyp1UGRgbrb6z8t7fpssxEKQgEmcJ4pVnWW3ds2p6ZPY",
			deprecated: false,
			name: "soALEPH/USDT",
			programId: "9xQeWvG816bUx9EPjHmaT23yvVM2ZWbrrpZb9PusVFin"
		},
		{
			address: "4ztJEvQyryoYagj2uieep3dyPwG2pyEwb2dKXTwmXe82",
			deprecated: false,
			name: "soCREAM/USDT",
			programId: "9xQeWvG816bUx9EPjHmaT23yvVM2ZWbrrpZb9PusVFin"
		},
		{
			address: "HEGnaVL5i48ubPBqWAhodnZo8VsSLzEM3Gfc451DnFj9",
			deprecated: false,
			name: "soKEEP/USDT",
			programId: "9xQeWvG816bUx9EPjHmaT23yvVM2ZWbrrpZb9PusVFin"
		},
		{
			address: "8FpuMGLtMZ7Wt9ZvyTGuTVwTwwzLYfS5NZWcHxbP1Wuh",
			deprecated: false,
			name: "soHNT/USDT",
			programId: "9xQeWvG816bUx9EPjHmaT23yvVM2ZWbrrpZb9PusVFin"
		},
		{
			address: "5GAPymgnnWieGcRrcghZdA3aanefqa4cZx1ZSE8UTyMV",
			deprecated: false,
			name: "soMAPS/USDT",
			programId: "9xQeWvG816bUx9EPjHmaT23yvVM2ZWbrrpZb9PusVFin"
		},
		{
			address: "AADohBGxvf7bvixs2HKC3dG2RuU3xpZDwaTzYFJThM8U",
			deprecated: false,
			name: "TRYB/USDT",
			programId: "9xQeWvG816bUx9EPjHmaT23yvVM2ZWbrrpZb9PusVFin"
		},
		{
			address: "EbV7pPpEvheLizuYX3gUCvWM8iySbSRAhu2mQ5Vz2Mxf",
			deprecated: false,
			name: "FIDA/USDT",
			programId: "9xQeWvG816bUx9EPjHmaT23yvVM2ZWbrrpZb9PusVFin"
		},
		{
			address: "FcPet5fz9NLdbXwVM6kw2WTHzRAD7mT78UjwTpawd7hJ",
			deprecated: false,
			name: "soRSR/USDT",
			programId: "9xQeWvG816bUx9EPjHmaT23yvVM2ZWbrrpZb9PusVFin"
		},
		{
			address: "AtNnsY1AyRERWJ8xCskfz38YdvruWVJQUVXgScC1iPb",
			deprecated: false,
			name: "SRM/USDT",
			programId: "9xQeWvG816bUx9EPjHmaT23yvVM2ZWbrrpZb9PusVFin"
		},
		{
			address: "teE55QrL4a4QSfydR9dnHF97jgCfptpuigbb53Lo95g",
			deprecated: false,
			name: "RAY/USDT",
			programId: "9xQeWvG816bUx9EPjHmaT23yvVM2ZWbrrpZb9PusVFin"
		},
		{
			address: "C1EuT9VokAKLiW7i2ASnZUvxDoKuKkCpDDeNxAptuNe4",
			deprecated: false,
			name: "BTC/USDT",
			programId: "9xQeWvG816bUx9EPjHmaT23yvVM2ZWbrrpZb9PusVFin"
		},
		{
			address: "Hr3wzG8mZXNHV7TuL6YqtgfVUesCqMxGYCEyP3otywZE",
			deprecated: false,
			name: "soFTT/USDT",
			programId: "9xQeWvG816bUx9EPjHmaT23yvVM2ZWbrrpZb9PusVFin"
		},
		{
			address: "HLvRdctRB48F9yLnu9E24LUTRt89D48Z35yi1HcxayDf",
			deprecated: false,
			name: "soAKRO/USDT",
			programId: "9xQeWvG816bUx9EPjHmaT23yvVM2ZWbrrpZb9PusVFin"
		},
		{
			address: "2SSnWNrc83otLpfRo792P6P3PESZpdr8cu2r8zCE6bMD",
			deprecated: false,
			name: "soUNI/USDT",
			programId: "9xQeWvG816bUx9EPjHmaT23yvVM2ZWbrrpZb9PusVFin"
		},
		{
			address: "F1T7b6pnR8Pge3qmfNUfW6ZipRDiGpMww6TKTrRU4NiL",
			deprecated: false,
			name: "soUBXT/USDT",
			programId: "9xQeWvG816bUx9EPjHmaT23yvVM2ZWbrrpZb9PusVFin"
		},
		{
			address: "HWHvQhFmJB3NUcu1aihKmrKegfVxBEHzwVX6yZCKEsi1",
			deprecated: false,
			name: "SOL/USDT",
			programId: "9xQeWvG816bUx9EPjHmaT23yvVM2ZWbrrpZb9PusVFin"
		},
		{
			address: "35tV8UsHH8FnSAi3YFRrgCu4K9tb883wKnAXpnihot5r",
			deprecated: false,
			name: "soLUA/USDT",
			programId: "9xQeWvG816bUx9EPjHmaT23yvVM2ZWbrrpZb9PusVFin"
		},
		{
			address: "6DgQRTpJTnAYBSShngAVZZDq7j9ogRN1GfSQ3cq9tubW",
			deprecated: false,
			name: "soSUSHI/USDT",
			programId: "9xQeWvG816bUx9EPjHmaT23yvVM2ZWbrrpZb9PusVFin"
		},
		{
			address: "2WghiBkDL2yRhHdvm8CpprrkmfguuQGJTCDfPSudKBAZ",
			deprecated: false,
			name: "soMATH/USDT",
			programId: "9xQeWvG816bUx9EPjHmaT23yvVM2ZWbrrpZb9PusVFin"
		},
		{
			address: "ErQXxiNfJgd4fqQ58PuEw5xY35TZG84tHT6FXf5s4UxY",
			deprecated: false,
			name: "soHGET/USDT",
			programId: "9xQeWvG816bUx9EPjHmaT23yvVM2ZWbrrpZb9PusVFin"
		},
		{
			address: "CGC4UgWwqA9PET6Tfx6o6dLv94EK2coVkPtxgNHuBtxj",
			deprecated: false,
			name: "soFRONT/USDT",
			programId: "9xQeWvG816bUx9EPjHmaT23yvVM2ZWbrrpZb9PusVFin"
		},
		{
			address: "GnKPri4thaGipzTbp8hhSGSrHgG4F8MFiZVrbRn16iG2",
			deprecated: false,
			name: "soTOMO/USDT",
			programId: "9xQeWvG816bUx9EPjHmaT23yvVM2ZWbrrpZb9PusVFin"
		},
		{
			address: "6bxuB5N3bt3qW8UnPNLgMMzDq5sEH8pFmYJYGgzvE11V",
			deprecated: false,
			name: "soAAVE/USDT",
			programId: "9xQeWvG816bUx9EPjHmaT23yvVM2ZWbrrpZb9PusVFin"
		},
		{
			address: "7cknqHAuGpfVXPtFoJpFvUjJ8wkmyEfbFusmwMfNy3FE",
			deprecated: false,
			name: "MAPS/USDT",
			programId: "9xQeWvG816bUx9EPjHmaT23yvVM2ZWbrrpZb9PusVFin"
		},
		{
			address: "4absuMsgemvdjfkgdLQq1zKEjw3dHBoCWkzKoctndyqd",
			deprecated: false,
			name: "soHXRO/USDT",
			programId: "9xQeWvG816bUx9EPjHmaT23yvVM2ZWbrrpZb9PusVFin"
		},
		{
			address: "4nCFQr8sahhhL4XJ7kngGFBmpkmyf3xLzemuMhn6mWTm",
			deprecated: false,
			name: "KIN/USDT",
			programId: "9xQeWvG816bUx9EPjHmaT23yvVM2ZWbrrpZb9PusVFin"
		},
		{
			address: "3Xg9Q4VtZhD4bVYJbTfgGWFV5zjE3U7ztSHa938zizte",
			deprecated: false,
			name: "soYFI/USDT",
			programId: "9xQeWvG816bUx9EPjHmaT23yvVM2ZWbrrpZb9PusVFin"
		},
		{
			address: "3yEZ9ZpXSQapmKjLAGKZEzUNA1rcupJtsDp5mPBWmGZR",
			deprecated: false,
			name: "soLINK/USDT",
			programId: "9xQeWvG816bUx9EPjHmaT23yvVM2ZWbrrpZb9PusVFin"
		},
		{
			address: "J2XSt77XWim5HwtUM8RUwQvmRXNZsbMKpp5GTKpHafvf",
			deprecated: false,
			name: "soSWAG/USDT",
			programId: "9xQeWvG816bUx9EPjHmaT23yvVM2ZWbrrpZb9PusVFin"
		},
		{
			address: "77quYg4MGneUdjgXCunt9GgM1usmrxKY31twEy3WHwcS",
			deprecated: false,
			name: "USDT/USDC",
			programId: "9xQeWvG816bUx9EPjHmaT23yvVM2ZWbrrpZb9PusVFin"
		},
		{
			address: "GKLev6UHeX1KSDCyo2bzyG6wqhByEzDBkmYTxEdmYJgB",
			deprecated: false,
			name: "OXY/USDT",
			programId: "9xQeWvG816bUx9EPjHmaT23yvVM2ZWbrrpZb9PusVFin"
		},
		{
			address: "HdBhZrnrxpje39ggXnTb6WuTWVvj5YKcSHwYGQCRsVj",
			deprecated: false,
			name: "OXY/soUSDT",
			programId: "9xQeWvG816bUx9EPjHmaT23yvVM2ZWbrrpZb9PusVFin"
		},
		{
			name: "OXY/USDC",
			address: "GZ3WBFsqntmERPwumFEYgrX2B7J7G11MzNZAy7Hje27X",
			deprecated: false,
			programId: "9xQeWvG816bUx9EPjHmaT23yvVM2ZWbrrpZb9PusVFin"
		},
		{
			name: "xCOPE/USDC",
			address: "7MpMwArporUHEGW7quUpkPZp5L5cHPs9eKUfKCdaPHq2",
			deprecated: false,
			programId: "9xQeWvG816bUx9EPjHmaT23yvVM2ZWbrrpZb9PusVFin"
		},
		{
			name: "COPE/USDC",
			address: "6fc7v3PmjZG9Lk2XTot6BywGyYLkBQuzuFKd4FpCsPxk",
			deprecated: false,
			programId: "9xQeWvG816bUx9EPjHmaT23yvVM2ZWbrrpZb9PusVFin"
		},
		{
			name: "MER/USDC",
			address: "HhvDWug3ftYNx5148ZmrQxzvEmohN2pKVNiRT4TVoekF",
			deprecated: true,
			programId: "9xQeWvG816bUx9EPjHmaT23yvVM2ZWbrrpZb9PusVFin"
		},
		{
			name: "MER/USDT",
			address: "6HwcY27nbeb933UkEcxqJejtjWLfNQFWkGCjAVNes6g7",
			deprecated: false,
			programId: "9xQeWvG816bUx9EPjHmaT23yvVM2ZWbrrpZb9PusVFin"
		},
		{
			name: "MER/USDC",
			address: "G4LcexdCzzJUKZfqyVDQFzpkjhB1JoCNL8Kooxi9nJz5",
			deprecated: false,
			programId: "9xQeWvG816bUx9EPjHmaT23yvVM2ZWbrrpZb9PusVFin"
		},
		{
			name: "SNY/USDC",
			address: "DPfj2jYwPaezkCmUNm5SSYfkrkz8WFqwGLcxDDUsN3gA",
			deprecated: false,
			programId: "9xQeWvG816bUx9EPjHmaT23yvVM2ZWbrrpZb9PusVFin"
		},
		{
			name: "SLRS/USDC",
			address: "2Gx3UfV831BAh8uQv1FKSPKS9yajfeeD8GJ4ZNb2o2YP",
			deprecated: false,
			programId: "9xQeWvG816bUx9EPjHmaT23yvVM2ZWbrrpZb9PusVFin"
		},
		{
			name: "ETHV/USDT",
			programId: "9xQeWvG816bUx9EPjHmaT23yvVM2ZWbrrpZb9PusVFin",
			deprecated: false,
			address: "HrgkuJryyKRserkoz7LBFYkASzhXHWp9XA6fRYCA6PHb"
		},
		{
			name: "IETHV/USDT",
			programId: "9xQeWvG816bUx9EPjHmaT23yvVM2ZWbrrpZb9PusVFin",
			deprecated: false,
			address: "5aoLj1bySDhhWjo7cLfT3pF2gqNGd63uEJ9HMSfASESL"
		},
		{
			name: "SBR/USDC",
			programId: "9xQeWvG816bUx9EPjHmaT23yvVM2ZWbrrpZb9PusVFin",
			deprecated: false,
			address: "HXBi8YBwbh4TXF6PjVw81m8Z3Cc4WBofvauj5SBFdgUs"
		},
		{
			name: "renBTC/USDC",
			programId: "9xQeWvG816bUx9EPjHmaT23yvVM2ZWbrrpZb9PusVFin",
			deprecated: false,
			address: "74Ciu5yRzhe8TFTHvQuEVbFZJrbnCMRoohBK33NNiPtv"
		},
		{
			name: "renDOGE/USDC",
			programId: "9xQeWvG816bUx9EPjHmaT23yvVM2ZWbrrpZb9PusVFin",
			deprecated: false,
			address: "5FpKCWYXgHWZ9CdDMHjwxAfqxJLdw2PRXuAmtECkzADk"
		},
		{
			name: "DXL/USDC",
			programId: "9xQeWvG816bUx9EPjHmaT23yvVM2ZWbrrpZb9PusVFin",
			deprecated: false,
			address: "DYfigimKWc5VhavR4moPBibx9sMcWYVSjVdWvPztBPTa"
		},
		{
			name: "MNGO/USDC",
			programId: "9xQeWvG816bUx9EPjHmaT23yvVM2ZWbrrpZb9PusVFin",
			deprecated: false,
			address: "3d4rzwpy9iGdCZvgxcu7B1YocYffVLsQXPXkBZKt2zLc"
		},
		{
			name: "CYS/USDC",
			programId: "9xQeWvG816bUx9EPjHmaT23yvVM2ZWbrrpZb9PusVFin",
			deprecated: false,
			address: "6V6y6QFi17QZC9qNRpVp7SaPiHpCTp2skbRQkUyZZXPW"
		},
		{
			name: "POLIS/USDC",
			programId: "9xQeWvG816bUx9EPjHmaT23yvVM2ZWbrrpZb9PusVFin",
			deprecated: false,
			address: "HxFLKUAmAMLz1jtT3hbvCMELwH5H9tpM2QugP8sKyfhW"
		},
		{
			name: "ATLAS/USDC",
			programId: "9xQeWvG816bUx9EPjHmaT23yvVM2ZWbrrpZb9PusVFin",
			deprecated: false,
			address: "Di66GTLsV64JgCCYGVcY21RZ173BHkjJVgPyezNN7P1K"
		},
		{
			name: "LIKE/USDC",
			programId: "9xQeWvG816bUx9EPjHmaT23yvVM2ZWbrrpZb9PusVFin",
			deprecated: false,
			address: "3WptgZZu34aiDrLMUiPntTYZGNZ72yT1yxHYxSdbTArX"
		},
		{
			name: "MSOL/USDC",
			programId: "9xQeWvG816bUx9EPjHmaT23yvVM2ZWbrrpZb9PusVFin",
			deprecated: false,
			address: "6oGsL2puUgySccKzn9XA9afqF217LfxP5ocq4B3LWsjy"
		},
		{
			name: "MSOL/SOL",
			programId: "9xQeWvG816bUx9EPjHmaT23yvVM2ZWbrrpZb9PusVFin",
			deprecated: false,
			address: "5cLrMai1DsLRYc1Nio9qMTicsWtvzjzZfJPXyAoF4t1Z"
		},
		{
			name: "AAVE/USDC",
			programId: "9xQeWvG816bUx9EPjHmaT23yvVM2ZWbrrpZb9PusVFin",
			deprecated: false,
			address: "8WZrmdpLckptiVKd2fPHPjewRVYQGQkjxi9vzRYG1sfs"
		},
		{
			name: "AAVE/USDT",
			programId: "9xQeWvG816bUx9EPjHmaT23yvVM2ZWbrrpZb9PusVFin",
			deprecated: false,
			address: "LghsMERQWQFK3zWMTrUkoyAJARQw2wSmcYZjexeN3zy"
		},
		{
			name: "AKRO/USDC",
			programId: "9xQeWvG816bUx9EPjHmaT23yvVM2ZWbrrpZb9PusVFin",
			deprecated: false,
			address: "G3h8NZgJozk9crme2me6sKDJuSQ12mNCtvC9NbSWqGuk"
		},
		{
			name: "AKRO/USDT",
			programId: "9xQeWvG816bUx9EPjHmaT23yvVM2ZWbrrpZb9PusVFin",
			deprecated: false,
			address: "DvbiPxKzuXZPcmUcYDqBz1tvUrXYPsNrRAjSeuwHtmEA"
		},
		{
			name: "ALEPH/USDC",
			programId: "9xQeWvG816bUx9EPjHmaT23yvVM2ZWbrrpZb9PusVFin",
			deprecated: false,
			address: "Fw4mvuE7KZmTjQPxP2sRpHwPDfRMWnKBupFZGyW9CAQH"
		},
		{
			name: "ALEPH/USDT",
			programId: "9xQeWvG816bUx9EPjHmaT23yvVM2ZWbrrpZb9PusVFin",
			deprecated: false,
			address: "GZeHR8uCTVoHVDZFRVXTgm386DK1EKehy9yMS3BFChcL"
		},
		{
			name: "CEL/USDC",
			programId: "9xQeWvG816bUx9EPjHmaT23yvVM2ZWbrrpZb9PusVFin",
			deprecated: false,
			address: "79ESpYSb2hM14KTRXPZUwDkxUGC5irE2esd1vxdXfnZz"
		},
		{
			name: "CEL/USDT",
			programId: "9xQeWvG816bUx9EPjHmaT23yvVM2ZWbrrpZb9PusVFin",
			deprecated: false,
			address: "J9ww1yufRNDDbUbDXmew2mW2ozkx7cme7dMvKjMQVHrL"
		},
		{
			name: "CREAM/USDC",
			programId: "9xQeWvG816bUx9EPjHmaT23yvVM2ZWbrrpZb9PusVFin",
			deprecated: false,
			address: "4pdQ2D4gehMhGu4z9jeQbEPUFbTxB5qcPr3zCynjJGyp"
		},
		{
			name: "CREAM/USDT",
			programId: "9xQeWvG816bUx9EPjHmaT23yvVM2ZWbrrpZb9PusVFin",
			deprecated: false,
			address: "6fspxMfBmYFTGFBDN5MU33A55i2MkGr7eSjBLPCAU6y9"
		},
		{
			name: "ETH/USDC",
			programId: "9xQeWvG816bUx9EPjHmaT23yvVM2ZWbrrpZb9PusVFin",
			deprecated: false,
			address: "8Gmi2HhZmwQPVdCwzS7CM66MGstMXPcTVHA7jF19cLZz"
		},
		{
			name: "ETH/USDT",
			programId: "9xQeWvG816bUx9EPjHmaT23yvVM2ZWbrrpZb9PusVFin",
			deprecated: false,
			address: "ch7kmPrtoQUSEPBggcNAvLGiMQkJagVwd3gDYfd8m7Q"
		},
		{
			name: "FRONT/USDC",
			programId: "9xQeWvG816bUx9EPjHmaT23yvVM2ZWbrrpZb9PusVFin",
			deprecated: false,
			address: "B95oZN5HCLGmFAhbzReWBA9cuSGPFQAXeuhm2FfpdrML"
		},
		{
			name: "FRONT/USDT",
			programId: "9xQeWvG816bUx9EPjHmaT23yvVM2ZWbrrpZb9PusVFin",
			deprecated: false,
			address: "DZTYyy1L5Pr6DmTtYY5bEuU9g3LQ4XGvuYiN3zS25yG7"
		},
		{
			name: "FTT/USDC",
			programId: "9xQeWvG816bUx9EPjHmaT23yvVM2ZWbrrpZb9PusVFin",
			deprecated: false,
			address: "2wteg25ch227n4Rh1CN4WNrDZXBpRBpWJ48mEC2K7f4r"
		},
		{
			name: "FTT/USDT",
			programId: "9xQeWvG816bUx9EPjHmaT23yvVM2ZWbrrpZb9PusVFin",
			deprecated: false,
			address: "BoHojHESAv4McZx9gXd1bWTZMq25JYyGz4qL1m5C3nvk"
		},
		{
			name: "HGET/USDC",
			programId: "9xQeWvG816bUx9EPjHmaT23yvVM2ZWbrrpZb9PusVFin",
			deprecated: false,
			address: "27e1mB6UoPohbc3MmwMXu5QM7b2E3k5Mbhwv6JguwyXg"
		},
		{
			name: "HGET/USDT",
			programId: "9xQeWvG816bUx9EPjHmaT23yvVM2ZWbrrpZb9PusVFin",
			deprecated: false,
			address: "BdRzTEKb7Qdu4tWts5zXjwcpQErZxEzvShKZ5QcthMag"
		},
		{
			name: "HXRO/USDC",
			programId: "9xQeWvG816bUx9EPjHmaT23yvVM2ZWbrrpZb9PusVFin",
			deprecated: false,
			address: "CBb5zXwNRB73WVjs2m21P5prcEZa6SWmej74Vzxh8dRm"
		},
		{
			name: "HXRO/USDT",
			programId: "9xQeWvG816bUx9EPjHmaT23yvVM2ZWbrrpZb9PusVFin",
			deprecated: false,
			address: "3BScwNxtMrEcQ5VTHyXHYQR98dTaxfyXGaLkuSjBY1dW"
		},
		{
			name: "LINK/USDC",
			programId: "9xQeWvG816bUx9EPjHmaT23yvVM2ZWbrrpZb9PusVFin",
			deprecated: false,
			address: "FJMjxMCiDKn16TLhXUdEbVDH5wC6k9EHYJTcrH6NcbDE"
		},
		{
			name: "LINK/USDT",
			programId: "9xQeWvG816bUx9EPjHmaT23yvVM2ZWbrrpZb9PusVFin",
			deprecated: false,
			address: "Gr2KmhK7Upr4uW56B1QQrJuhhgmot6zAHJeZALTMStiX"
		},
		{
			name: "LUA/USDC",
			programId: "9xQeWvG816bUx9EPjHmaT23yvVM2ZWbrrpZb9PusVFin",
			deprecated: false,
			address: "J9imTcEeahZqKuaoQaPcCeSGCMWL8qSACpK4B7bC8NN4"
		},
		{
			name: "LUA/USDT",
			programId: "9xQeWvG816bUx9EPjHmaT23yvVM2ZWbrrpZb9PusVFin",
			deprecated: false,
			address: "BMJ3CvQZ57cNnuc3Lz5Pb6cW6Sr9kZGz3qz2bJQTE24A"
		},
		{
			name: "MATH/USDC",
			programId: "9xQeWvG816bUx9EPjHmaT23yvVM2ZWbrrpZb9PusVFin",
			deprecated: false,
			address: "G8L1YLrktaG1t8YBMJs3CwV96nExvJJCSpw3DARPDjE2"
		},
		{
			name: "MATH/USDT",
			programId: "9xQeWvG816bUx9EPjHmaT23yvVM2ZWbrrpZb9PusVFin",
			deprecated: false,
			address: "CkvNfATB7nky8zPLuwS9bgcFbVRkQdkd5zuKEovyo9rs"
		},
		{
			name: "RAY/USDC",
			programId: "9xQeWvG816bUx9EPjHmaT23yvVM2ZWbrrpZb9PusVFin",
			deprecated: false,
			address: "2xiv8A5xrJ7RnGdxXB42uFEkYHJjszEhaJyKKt4WaLep"
		},
		{
			name: "RSR/USDC",
			programId: "9xQeWvG816bUx9EPjHmaT23yvVM2ZWbrrpZb9PusVFin",
			deprecated: false,
			address: "GqgkxEswUwHBntmzb5GpUhKrVpJhzreSruZycuJwdNwB"
		},
		{
			name: "RSR/USDT",
			programId: "9xQeWvG816bUx9EPjHmaT23yvVM2ZWbrrpZb9PusVFin",
			deprecated: false,
			address: "2j2or38X2FUbpkK4gkgvjDtqN3ibkKw3v5yn7o2gHqPc"
		},
		{
			name: "SUSHI/USDC",
			programId: "9xQeWvG816bUx9EPjHmaT23yvVM2ZWbrrpZb9PusVFin",
			deprecated: false,
			address: "3uWVMWu7cwMnYMAAdtsZNwaaqeeeZHARGZwcExnQiFay"
		},
		{
			name: "SUSHI/USDT",
			programId: "9xQeWvG816bUx9EPjHmaT23yvVM2ZWbrrpZb9PusVFin",
			deprecated: false,
			address: "T3aC6qcPAJtX1gqkckfSxBPdPWziz5fLYRt5Dz3Nafq"
		},
		{
			name: "SWAG/USDC",
			programId: "9xQeWvG816bUx9EPjHmaT23yvVM2ZWbrrpZb9PusVFin",
			deprecated: false,
			address: "wSkeLMv3ktJyLm51bvQWxY2saGKqGxbnUFimPxbgEvQ"
		},
		{
			name: "SWAG/USDT",
			programId: "9xQeWvG816bUx9EPjHmaT23yvVM2ZWbrrpZb9PusVFin",
			deprecated: false,
			address: "6URQ4zFWvPm1fhJCKKWorrh8X3mmTFiDDyXEUmSf8Rb2"
		},
		{
			name: "SXP/USDC",
			programId: "9xQeWvG816bUx9EPjHmaT23yvVM2ZWbrrpZb9PusVFin",
			deprecated: false,
			address: "G5F84rfqmWqzZv5GBpSn8mMwW8zJ2B4Y1GpGupiwjHNM"
		},
		{
			name: "SXP/USDT",
			programId: "9xQeWvG816bUx9EPjHmaT23yvVM2ZWbrrpZb9PusVFin",
			deprecated: false,
			address: "2FQbPW1ticJz2SMMbEXxbKWJKmw1wLc6ggSP2HyzdMen"
		},
		{
			name: "UBXT/USDC",
			programId: "9xQeWvG816bUx9EPjHmaT23yvVM2ZWbrrpZb9PusVFin",
			deprecated: false,
			address: "Hh4p7tJpqkGW6xsHM2LiPPMpJg43fwn5TbmVmfrURdLY"
		},
		{
			name: "UBXT/USDT",
			programId: "9xQeWvG816bUx9EPjHmaT23yvVM2ZWbrrpZb9PusVFin",
			deprecated: false,
			address: "5xhjc3ZtAwnBK3qsaro28VChL7WrxY9N4SG6UZpYxpGc"
		},
		{
			name: "UNI/USDC",
			programId: "9xQeWvG816bUx9EPjHmaT23yvVM2ZWbrrpZb9PusVFin",
			deprecated: false,
			address: "B7b5rjQuqQCuGqmUBWmcCTqaL3Z1462mo4NArqty6QFR"
		},
		{
			name: "UNI/USDT",
			programId: "9xQeWvG816bUx9EPjHmaT23yvVM2ZWbrrpZb9PusVFin",
			deprecated: false,
			address: "FrKM6kJtAjXknHPEpkrQtJSXZwUxV5dq26wDpc4YjQST"
		},
		{
			name: "YFI/USDC",
			programId: "9xQeWvG816bUx9EPjHmaT23yvVM2ZWbrrpZb9PusVFin",
			deprecated: false,
			address: "BiJXGFc1c4gyPpv9HLRJoKbZewWQrTCHGuxYKjYMQJpC"
		},
		{
			name: "YFI/USDT",
			programId: "9xQeWvG816bUx9EPjHmaT23yvVM2ZWbrrpZb9PusVFin",
			deprecated: false,
			address: "9sue9TZAeUhNtNAPPGb9dke7rkJeXktGD3u8ZC37GWnQ"
		},
		{
			name: "AVAX/USDC",
			programId: "9xQeWvG816bUx9EPjHmaT23yvVM2ZWbrrpZb9PusVFin",
			deprecated: false,
			address: "E8JQstcwjuqN5kdMyUJLNuaectymnhffkvfg1j286UCr"
		},
		{
			name: "AXSet/USDC",
			programId: "9xQeWvG816bUx9EPjHmaT23yvVM2ZWbrrpZb9PusVFin",
			deprecated: false,
			address: "HZCheduA4nsSuQpVww1TiyKZpXSAitqaXxjBD2ymg22X"
		},
		{
			name: "BNB/USDC",
			programId: "9xQeWvG816bUx9EPjHmaT23yvVM2ZWbrrpZb9PusVFin",
			deprecated: false,
			address: "4UPUurKveNEJgBqJzqHPyi8DhedvpYsMXi7d43CjAg2f"
		},
		{
			name: "BNB/USDT",
			programId: "9xQeWvG816bUx9EPjHmaT23yvVM2ZWbrrpZb9PusVFin",
			deprecated: false,
			address: "FjbKNZME5yVSC1R3HJM99kB3yir3q3frS5MteMFD72sV"
		},
		{
			name: "GALA/USDC",
			programId: "9xQeWvG816bUx9EPjHmaT23yvVM2ZWbrrpZb9PusVFin",
			deprecated: false,
			address: "F7WJsoxTWQRmAwAyFe9APmuVv4HqmhchFtdbR9dvAUDm"
		},
		{
			name: "MATICpo/USDC",
			programId: "9xQeWvG816bUx9EPjHmaT23yvVM2ZWbrrpZb9PusVFin",
			deprecated: false,
			address: "5WRoQxE59966N2XfD2wYy1uhuyKeoVJ9NBMH6r6RNYEF"
		},
		{
			name: "ROSE/USDC",
			programId: "9xQeWvG816bUx9EPjHmaT23yvVM2ZWbrrpZb9PusVFin",
			deprecated: false,
			address: "EybAYkmRKCyD4w8AErTG1bqmnvT85LFuPQPMCc8J3yD"
		},
		{
			name: "SAND/USDC",
			programId: "9xQeWvG816bUx9EPjHmaT23yvVM2ZWbrrpZb9PusVFin",
			deprecated: false,
			address: "3FE2g3cadTJjN3C7gNRavwnv7Yh9Midq7h9KgTVUE7tR"
		},
		{
			name: "LUNA/USDC",
			programId: "9xQeWvG816bUx9EPjHmaT23yvVM2ZWbrrpZb9PusVFin",
			deprecated: false,
			address: "HBTu8hNaoT3VyiSSzJYa8jwt9sDGKtJviSwFa11iXdmE"
		},
		{
			name: "SHIB/USDC",
			programId: "9xQeWvG816bUx9EPjHmaT23yvVM2ZWbrrpZb9PusVFin",
			deprecated: false,
			address: "Er7Jp4PADPVHifykFwbVoHdkL1RtZSsx9zGJrPJTrCgW"
		},
		{
			name: "UST/USDC",
			programId: "9xQeWvG816bUx9EPjHmaT23yvVM2ZWbrrpZb9PusVFin",
			deprecated: false,
			address: "8WmckvEoVGZvtN8knjdzFGbWJ3Sr4BcWdyzSYuCrD4YK"
		},
		{
			name: "FAB/USDC",
			programId: "9xQeWvG816bUx9EPjHmaT23yvVM2ZWbrrpZb9PusVFin",
			deprecated: false,
			address: "Cud48DK2qoxsWNzQeTL5D8sAiHsGwG8Ev1VMNcYLayxt"
		},
		{
			name: "JET/USDC",
			programId: "9xQeWvG816bUx9EPjHmaT23yvVM2ZWbrrpZb9PusVFin",
			deprecated: false,
			address: "6pQMoHDC2o8eeFxyTKtfnsr8d48hKFWsRpLHAqVHH2ZP"
		},
		{
			name: "scnSOL/USDC",
			programId: "9xQeWvG816bUx9EPjHmaT23yvVM2ZWbrrpZb9PusVFin",
			deprecated: false,
			address: "D52sefGCWho2nd5UGxWd7wCftAzeNEMNYZkdEPGEdQTb"
		},
		{
			name: "stSOL/USDC",
			programId: "9xQeWvG816bUx9EPjHmaT23yvVM2ZWbrrpZb9PusVFin",
			deprecated: false,
			address: "5F7LGsP1LPtaRV7vVKgxwNYX4Vf22xvuzyXjyar7jJqp"
		}
	];

	var require$$2 = [
		{
			address: "9n4nbM75f5Ui33ZbPYXn59EwSgE8CGsHtAeTH5YFeJ9E",
			name: "BTC"
		},
		{
			address: "2FPyTwcZLUg1MDrwsyoP4D6s1tM7hAkHYRjkNb5w6Pxk",
			name: "ETH"
		},
		{
			address: "AGFEad2et2ZJif9jaGpdMixQqvW5i81aBdvKe7PHNfz3",
			name: "FTT"
		},
		{
			address: "3JSf5tPeuscJGtaCp5giEiDhv51gQ4v3zWg8DGgyLfAB",
			name: "YFI"
		},
		{
			address: "CWE8jPTUYhdCTZYWPTe1o5DFqfdjzWKc9WKz6rSjQUdG",
			name: "LINK"
		},
		{
			address: "Ga2AXHpfAF6mv2ekZwcsJFqu7wB4NV331qNH7fW9Nst8",
			name: "XRP"
		},
		{
			address: "Es9vMFrzaCERmJfrF4H2FYD4KCoNkY11McCe8BenwNYB",
			name: "USDT"
		},
		{
			address: "BQcdHdAQW1hczDbBi9hiegXAR7A98Q9jx3X3iBBBDiq4",
			name: "WUSDT"
		},
		{
			address: "BXXkv6z8ykpG1yuvUDPgh732wzVHB69RnB9YgSYh3itW",
			name: "WUSDC"
		},
		{
			address: "EPjFWdd5AufqSSqeM2qN1xzybapC8G4wEGGkZwyTDt1v",
			name: "USDC"
		},
		{
			address: "MSRMcoVyrFxnSgo5uXwone5SKcGhT1KEJMFEkMEWf9L",
			name: "MSRM"
		},
		{
			address: "SRMuApVNdxXokk5GT7XD5cUUgXMBCoAz2LHeuAoKWRt",
			name: "SRM"
		},
		{
			address: "AR1Mtgh7zAtxuxGd2XPovXPVjcSdY3i4rQYisNadjfKy",
			name: "SUSHI"
		},
		{
			address: "SF3oTvfWzEP3DTwGSvUXRrGTvr75pdZNnBLAH9bzMuX",
			name: "SXP"
		},
		{
			address: "CsZ5LZkDS7h9TDKjrbL7VAwQZ9nsRu8vJLhRYfmGaN8K",
			name: "ALEPH"
		},
		{
			address: "BtZQfWqDGbk9Wf2rXEiWyQBdBY1etnUUn6zEphvVS7yN",
			name: "HGET"
		},
		{
			address: "5Fu5UUgbjpUvdBveb3a1JTNirL8rXtiYeSMWvKjtUNQv",
			name: "CREAM"
		},
		{
			address: "873KLxCbz7s9Kc4ZzgYRtNmhfkQrhfyWGZJBmyCbC3ei",
			name: "UBXT"
		},
		{
			address: "HqB7uswoVg4suaQiDP3wjxob1G5WdZ144zhdStwMCq7e",
			name: "HNT"
		},
		{
			address: "9S4t2NEAiJVMvPdRYKVrfJpBafPBLtvbvyS3DecojQHw",
			name: "FRONT"
		},
		{
			address: "6WNVCuxCGJzNjmMZoKyhZJwvJ5tYpsLyAtagzYASqBoF",
			name: "AKRO"
		},
		{
			address: "DJafV9qemGp7mLMEn5wrfqaFwxsbLgUsGVS16zKRk9kc",
			name: "HXRO"
		},
		{
			address: "DEhAasscXF4kEGxFgJ3bq4PpVGp5wyUxMRvn6TzGVHaw",
			name: "UNI"
		},
		{
			address: "GUohe4DJUA5FKPWo3joiPgsB7yzer7LpDmt1Vhzy3Zht",
			name: "KEEP"
		},
		{
			address: "GeDS162t9yGJuLEHPWXXGrb1zwkzinCgRwnT8vHYjKza",
			name: "MATH"
		},
		{
			address: "So11111111111111111111111111111111111111112",
			name: "SOL"
		},
		{
			address: "GXMvfY2jpQctDqZ9RoU3oWPhufKiCcFEfchvYumtX7jd",
			name: "TOMO"
		},
		{
			address: "EqWCKXfs3x47uVosDpTRgFniThL9Y8iCztJaapxbEaVX",
			name: "LUA"
		},
		{
			address: "9F9fNTT6qwjsu4X4yWYKZpsbw5qT7o6yR2i57JF2jagy",
			name: "SWAG"
		},
		{
			address: "EchesyfXePKdLtoiZSL8pBe8Myagyy8ZRqsACNCFGnvp",
			name: "FIDA"
		},
		{
			address: "kinXdEcpDQeHPEuQnqmUgtYykqKGVFq6CeVX5iAHJq6",
			name: "KIN"
		},
		{
			address: "MAPS41MDahZ9QdKXhVa4dWB9RuyfV4XqhyAZ8XcYepb",
			name: "MAPS"
		},
		{
			address: "z3dn17yLaGMKffVogeFHQ9zWVcXgqgf3PQnDsNs2g6M",
			name: "OXY"
		},
		{
			address: "4k3Dyjzvzp8eMZWUXbBCjEvwSkkk59S5iCNLY3QrkX6R",
			name: "RAY"
		},
		{
			address: "3K6rftdAaQYMPunrtNRHgnK2UAtjm2JwyT2oCiTDouYE",
			name: "xCOPE"
		},
		{
			address: "dK83wTVypEpa1pqiBbHY3MNuUnT3ADUZM4wk9VZXZEc",
			name: "AAVE"
		},
		{
			address: "DgHK9mfhMtUwwv54GChRrU54T2Em5cuszq2uMuen1ZVE",
			name: "CEL"
		},
		{
			address: "7ncCLJpP3MNww17LW8bRvx8odQQnubNtfNZBL5BgAEHW",
			name: "RSR"
		},
		{
			address: "6ry4WBDvAwAnrYJVv6MCog4J8zx6S3cPgSqnTsDZ73AR",
			name: "TRYB"
		},
		{
			address: "8HGyAAB1yoM1ttS7pXjHMa3dukTFGQggnFFH3hJZgzQh",
			name: "COPE"
		},
		{
			address: "MERt85fc5boKw3BW1eYdxonEuJNvXbiMbs6hvheau5K",
			name: "MER"
		},
		{
			address: "4dmKkXNHdgYsXqBHCuMikNQWwVomZURhYvkkX5c4pQ7y",
			name: "SNY"
		},
		{
			address: "SLRSSpSLUTP7okbCUBYStWCo1vUgyt775faPqz8HUMr",
			name: "SLRS"
		},
		{
			address: "CDJWUqTcYTVAKXAVXoQZFes5JUFc7owSeq7eMQcDSbo5",
			name: "renBTC"
		},
		{
			address: "ArUkYE2XDKzqy77PRRGjo4wREWwqk6RXTfM9NeqzPvjU",
			name: "renDOGE"
		},
		{
			address: "GsNzxJfFn6zQdJGeYsupJWzUAm57Ba7335mfhWvFiE9Z",
			name: "DXL"
		}
	];

	(function (exports) {
		var __importDefault = (commonjsGlobal && commonjsGlobal.__importDefault) || function (mod) {
		    return (mod && mod.__esModule) ? mod : { "default": mod };
		};
		Object.defineProperty(exports, "__esModule", { value: true });
		exports.MARKETS = exports.TOKEN_MINTS = exports.getLayoutVersion = exports.PROGRAM_LAYOUT_VERSIONS = void 0;
		const web3_js_1 = require$$0$1;
		const markets_json_1 = __importDefault(require$$1);
		const token_mints_json_1 = __importDefault(require$$2);
		exports.PROGRAM_LAYOUT_VERSIONS = {
		    '4ckmDgGdxQoPDLUkDT3vHgSAkzA3QRdNq5ywwY4sUSJn': 1,
		    BJ3jrUzddfuSrZHXSCxMUUQsjKEyLmuuyZebkcaFp2fg: 1,
		    EUqojwWA2rd19FZrzeBncJsm38Jm1hEhE3zsmX3bRc2o: 2,
		    '9xQeWvG816bUx9EPjHmaT23yvVM2ZWbrrpZb9PusVFin': 3,
		};
		function getLayoutVersion(programId) {
		    return exports.PROGRAM_LAYOUT_VERSIONS[programId.toString()] || 3;
		}
		exports.getLayoutVersion = getLayoutVersion;
		exports.TOKEN_MINTS = token_mints_json_1.default.map((mint) => {
		    return {
		        address: new web3_js_1.PublicKey(mint.address),
		        name: mint.name,
		    };
		});
		exports.MARKETS = markets_json_1.default.map((market) => {
		    return {
		        address: new web3_js_1.PublicKey(market.address),
		        name: market.name,
		        programId: new web3_js_1.PublicKey(market.programId),
		        deprecated: market.deprecated,
		    };
		});
		
	} (tokens_and_markets));

	Object.defineProperty(fees, "__esModule", { value: true });
	fees.getFeeTier = fees.getFeeRates = fees.supportsSrmFeeDiscounts = void 0;
	const tokens_and_markets_1 = tokens_and_markets;
	function supportsSrmFeeDiscounts(programId) {
	    return tokens_and_markets_1.getLayoutVersion(programId) > 1;
	}
	fees.supportsSrmFeeDiscounts = supportsSrmFeeDiscounts;
	function getFeeRates(feeTier) {
	    if (feeTier === 1) {
	        // SRM2
	        return { taker: 0.002, maker: -0.0003 };
	    }
	    else if (feeTier === 2) {
	        // SRM3
	        return { taker: 0.0018, maker: -0.0003 };
	    }
	    else if (feeTier === 3) {
	        // SRM4
	        return { taker: 0.0016, maker: -0.0003 };
	    }
	    else if (feeTier === 4) {
	        // SRM5
	        return { taker: 0.0014, maker: -0.0003 };
	    }
	    else if (feeTier === 5) {
	        // SRM6
	        return { taker: 0.0012, maker: -0.0003 };
	    }
	    else if (feeTier === 6) {
	        // MSRM
	        return { taker: 0.001, maker: -0.0005 };
	    }
	    // Base
	    return { taker: 0.0022, maker: -0.0003 };
	}
	fees.getFeeRates = getFeeRates;
	function getFeeTier(msrmBalance, srmBalance) {
	    if (msrmBalance >= 1) {
	        return 6;
	    }
	    else if (srmBalance >= 1000000) {
	        return 5;
	    }
	    else if (srmBalance >= 100000) {
	        return 4;
	    }
	    else if (srmBalance >= 10000) {
	        return 3;
	    }
	    else if (srmBalance >= 1000) {
	        return 2;
	    }
	    else if (srmBalance >= 100) {
	        return 1;
	    }
	    else {
	        return 0;
	    }
	}
	fees.getFeeTier = getFeeTier;

	(function (exports) {
		var __importDefault = (commonjsGlobal && commonjsGlobal.__importDefault) || function (mod) {
		    return (mod && mod.__esModule) ? mod : { "default": mod };
		};
		Object.defineProperty(exports, "__esModule", { value: true });
		exports.getMintDecimals = exports.Orderbook = exports.ORDERBOOK_LAYOUT = exports.OpenOrders = exports._OPEN_ORDERS_LAYOUT_V2 = exports._OPEN_ORDERS_LAYOUT_V1 = exports.Market = exports.MARKET_STATE_LAYOUT_V3 = exports.MARKET_STATE_LAYOUT_V2 = exports._MARKET_STAT_LAYOUT_V1 = void 0;
		const buffer_layout_1 = Layout$1;
		const layout_1 = layout;
		const slab_1 = slab;
		const instructions_1 = instructions;
		const bn_js_1 = __importDefault(bnExports);
		const web3_js_1 = require$$0$1;
		const queue_1 = queue;
		const buffer_1 = require$$0;
		const fees_1 = fees;
		const token_instructions_1 = tokenInstructions;
		const tokens_and_markets_1 = tokens_and_markets;
		exports._MARKET_STAT_LAYOUT_V1 = buffer_layout_1.struct([
		    buffer_layout_1.blob(5),
		    layout_1.accountFlagsLayout('accountFlags'),
		    layout_1.publicKeyLayout('ownAddress'),
		    layout_1.u64('vaultSignerNonce'),
		    layout_1.publicKeyLayout('baseMint'),
		    layout_1.publicKeyLayout('quoteMint'),
		    layout_1.publicKeyLayout('baseVault'),
		    layout_1.u64('baseDepositsTotal'),
		    layout_1.u64('baseFeesAccrued'),
		    layout_1.publicKeyLayout('quoteVault'),
		    layout_1.u64('quoteDepositsTotal'),
		    layout_1.u64('quoteFeesAccrued'),
		    layout_1.u64('quoteDustThreshold'),
		    layout_1.publicKeyLayout('requestQueue'),
		    layout_1.publicKeyLayout('eventQueue'),
		    layout_1.publicKeyLayout('bids'),
		    layout_1.publicKeyLayout('asks'),
		    layout_1.u64('baseLotSize'),
		    layout_1.u64('quoteLotSize'),
		    layout_1.u64('feeRateBps'),
		    buffer_layout_1.blob(7),
		]);
		exports.MARKET_STATE_LAYOUT_V2 = buffer_layout_1.struct([
		    buffer_layout_1.blob(5),
		    layout_1.accountFlagsLayout('accountFlags'),
		    layout_1.publicKeyLayout('ownAddress'),
		    layout_1.u64('vaultSignerNonce'),
		    layout_1.publicKeyLayout('baseMint'),
		    layout_1.publicKeyLayout('quoteMint'),
		    layout_1.publicKeyLayout('baseVault'),
		    layout_1.u64('baseDepositsTotal'),
		    layout_1.u64('baseFeesAccrued'),
		    layout_1.publicKeyLayout('quoteVault'),
		    layout_1.u64('quoteDepositsTotal'),
		    layout_1.u64('quoteFeesAccrued'),
		    layout_1.u64('quoteDustThreshold'),
		    layout_1.publicKeyLayout('requestQueue'),
		    layout_1.publicKeyLayout('eventQueue'),
		    layout_1.publicKeyLayout('bids'),
		    layout_1.publicKeyLayout('asks'),
		    layout_1.u64('baseLotSize'),
		    layout_1.u64('quoteLotSize'),
		    layout_1.u64('feeRateBps'),
		    layout_1.u64('referrerRebatesAccrued'),
		    buffer_layout_1.blob(7),
		]);
		exports.MARKET_STATE_LAYOUT_V3 = buffer_layout_1.struct([
		    buffer_layout_1.blob(5),
		    layout_1.accountFlagsLayout('accountFlags'),
		    layout_1.publicKeyLayout('ownAddress'),
		    layout_1.u64('vaultSignerNonce'),
		    layout_1.publicKeyLayout('baseMint'),
		    layout_1.publicKeyLayout('quoteMint'),
		    layout_1.publicKeyLayout('baseVault'),
		    layout_1.u64('baseDepositsTotal'),
		    layout_1.u64('baseFeesAccrued'),
		    layout_1.publicKeyLayout('quoteVault'),
		    layout_1.u64('quoteDepositsTotal'),
		    layout_1.u64('quoteFeesAccrued'),
		    layout_1.u64('quoteDustThreshold'),
		    layout_1.publicKeyLayout('requestQueue'),
		    layout_1.publicKeyLayout('eventQueue'),
		    layout_1.publicKeyLayout('bids'),
		    layout_1.publicKeyLayout('asks'),
		    layout_1.u64('baseLotSize'),
		    layout_1.u64('quoteLotSize'),
		    layout_1.u64('feeRateBps'),
		    layout_1.u64('referrerRebatesAccrued'),
		    layout_1.publicKeyLayout('authority'),
		    layout_1.publicKeyLayout('pruneAuthority'),
		    layout_1.publicKeyLayout('consumeEventsAuthority'),
		    buffer_layout_1.blob(992),
		    buffer_layout_1.blob(7),
		]);
		class Market {
		    constructor(decoded, baseMintDecimals, quoteMintDecimals, options = {}, programId, layoutOverride) {
		        const { skipPreflight = false, commitment = 'recent' } = options;
		        if (!decoded.accountFlags.initialized || !decoded.accountFlags.market) {
		            throw new Error('Invalid market state');
		        }
		        this._decoded = decoded;
		        this._baseSplTokenDecimals = baseMintDecimals;
		        this._quoteSplTokenDecimals = quoteMintDecimals;
		        this._skipPreflight = skipPreflight;
		        this._commitment = commitment;
		        this._programId = programId;
		        this._openOrdersAccountsCache = {};
		        this._feeDiscountKeysCache = {};
		        this._layoutOverride = layoutOverride;
		    }
		    static getLayout(programId) {
		        if (tokens_and_markets_1.getLayoutVersion(programId) === 1) {
		            return exports._MARKET_STAT_LAYOUT_V1;
		        }
		        return exports.MARKET_STATE_LAYOUT_V2;
		    }
		    static async findAccountsByMints(connection, baseMintAddress, quoteMintAddress, programId) {
		        const filters = [
		            {
		                memcmp: {
		                    offset: this.getLayout(programId).offsetOf('baseMint'),
		                    bytes: baseMintAddress.toBase58(),
		                },
		            },
		            {
		                memcmp: {
		                    offset: Market.getLayout(programId).offsetOf('quoteMint'),
		                    bytes: quoteMintAddress.toBase58(),
		                },
		            },
		        ];
		        return getFilteredProgramAccounts(connection, programId, filters);
		    }
		    static async load(connection, address, options = {}, programId, layoutOverride) {
		        const { owner, data } = throwIfNull(await connection.getAccountInfo(address), 'Market not found');
		        if (!owner.equals(programId)) {
		            throw new Error('Address not owned by program: ' + owner.toBase58());
		        }
		        const decoded = (layoutOverride !== null && layoutOverride !== void 0 ? layoutOverride : this.getLayout(programId)).decode(data);
		        if (!decoded.accountFlags.initialized ||
		            !decoded.accountFlags.market ||
		            !decoded.ownAddress.equals(address)) {
		            throw new Error('Invalid market');
		        }
		        const [baseMintDecimals, quoteMintDecimals] = await Promise.all([
		            getMintDecimals(connection, decoded.baseMint),
		            getMintDecimals(connection, decoded.quoteMint),
		        ]);
		        return new Market(decoded, baseMintDecimals, quoteMintDecimals, options, programId, layoutOverride);
		    }
		    get programId() {
		        return this._programId;
		    }
		    get address() {
		        return this._decoded.ownAddress;
		    }
		    get publicKey() {
		        return this.address;
		    }
		    get baseMintAddress() {
		        return this._decoded.baseMint;
		    }
		    get quoteMintAddress() {
		        return this._decoded.quoteMint;
		    }
		    get bidsAddress() {
		        return this._decoded.bids;
		    }
		    get asksAddress() {
		        return this._decoded.asks;
		    }
		    get decoded() {
		        return this._decoded;
		    }
		    async loadBids(connection) {
		        const { data } = throwIfNull(await connection.getAccountInfo(this._decoded.bids));
		        return Orderbook.decode(this, data);
		    }
		    async loadAsks(connection) {
		        const { data } = throwIfNull(await connection.getAccountInfo(this._decoded.asks));
		        return Orderbook.decode(this, data);
		    }
		    async loadOrdersForOwner(connection, ownerAddress, cacheDurationMs = 0) {
		        const [bids, asks, openOrdersAccounts] = await Promise.all([
		            this.loadBids(connection),
		            this.loadAsks(connection),
		            this.findOpenOrdersAccountsForOwner(connection, ownerAddress, cacheDurationMs),
		        ]);
		        return this.filterForOpenOrders(bids, asks, openOrdersAccounts);
		    }
		    filterForOpenOrders(bids, asks, openOrdersAccounts) {
		        return [...bids, ...asks].filter((order) => openOrdersAccounts.some((openOrders) => order.openOrdersAddress.equals(openOrders.address)));
		    }
		    async findBaseTokenAccountsForOwner(connection, ownerAddress, includeUnwrappedSol = false) {
		        if (this.baseMintAddress.equals(token_instructions_1.WRAPPED_SOL_MINT) && includeUnwrappedSol) {
		            const [wrapped, unwrapped] = await Promise.all([
		                this.findBaseTokenAccountsForOwner(connection, ownerAddress, false),
		                connection.getAccountInfo(ownerAddress),
		            ]);
		            if (unwrapped !== null) {
		                return [{ pubkey: ownerAddress, account: unwrapped }, ...wrapped];
		            }
		            return wrapped;
		        }
		        return await this.getTokenAccountsByOwnerForMint(connection, ownerAddress, this.baseMintAddress);
		    }
		    async getTokenAccountsByOwnerForMint(connection, ownerAddress, mintAddress) {
		        return (await connection.getTokenAccountsByOwner(ownerAddress, {
		            mint: mintAddress,
		        })).value;
		    }
		    async findQuoteTokenAccountsForOwner(connection, ownerAddress, includeUnwrappedSol = false) {
		        if (this.quoteMintAddress.equals(token_instructions_1.WRAPPED_SOL_MINT) && includeUnwrappedSol) {
		            const [wrapped, unwrapped] = await Promise.all([
		                this.findQuoteTokenAccountsForOwner(connection, ownerAddress, false),
		                connection.getAccountInfo(ownerAddress),
		            ]);
		            if (unwrapped !== null) {
		                return [{ pubkey: ownerAddress, account: unwrapped }, ...wrapped];
		            }
		            return wrapped;
		        }
		        return await this.getTokenAccountsByOwnerForMint(connection, ownerAddress, this.quoteMintAddress);
		    }
		    async findOpenOrdersAccountsForOwner(connection, ownerAddress, cacheDurationMs = 0) {
		        const strOwner = ownerAddress.toBase58();
		        const now = new Date().getTime();
		        if (strOwner in this._openOrdersAccountsCache &&
		            now - this._openOrdersAccountsCache[strOwner].ts < cacheDurationMs) {
		            return this._openOrdersAccountsCache[strOwner].accounts;
		        }
		        const openOrdersAccountsForOwner = await OpenOrders.findForMarketAndOwner(connection, this.address, ownerAddress, this._programId);
		        this._openOrdersAccountsCache[strOwner] = {
		            accounts: openOrdersAccountsForOwner,
		            ts: now,
		        };
		        return openOrdersAccountsForOwner;
		    }
		    async replaceOrders(connection, accounts, orders, cacheDurationMs = 0) {
		        var _a;
		        if (!accounts.openOrdersAccount && !accounts.openOrdersAddressKey) {
		            const ownerAddress = (_a = accounts.owner.publicKey) !== null && _a !== void 0 ? _a : accounts.owner;
		            const openOrdersAccounts = await this.findOpenOrdersAccountsForOwner(connection, ownerAddress, cacheDurationMs);
		            accounts.openOrdersAddressKey = openOrdersAccounts[0].address;
		        }
		        const transaction = new web3_js_1.Transaction();
		        transaction.add(this.makeReplaceOrdersByClientIdsInstruction(accounts, orders));
		        return await this._sendTransaction(connection, transaction, [
		            accounts.owner,
		        ]);
		    }
		    async placeOrder(connection, { owner, payer, side, price, size, orderType = 'limit', clientId, openOrdersAddressKey, openOrdersAccount, feeDiscountPubkey, maxTs, replaceIfExists = false, }) {
		        const { transaction, signers } = await this.makePlaceOrderTransaction(connection, {
		            owner,
		            payer,
		            side,
		            price,
		            size,
		            orderType,
		            clientId,
		            openOrdersAddressKey,
		            openOrdersAccount,
		            feeDiscountPubkey,
		            maxTs,
		            replaceIfExists,
		        });
		        return await this._sendTransaction(connection, transaction, [
		            owner,
		            ...signers,
		        ]);
		    }
		    getSplTokenBalanceFromAccountInfo(accountInfo, decimals) {
		        return divideBnToNumber(new bn_js_1.default(accountInfo.data.slice(64, 72), 10, 'le'), new bn_js_1.default(10).pow(new bn_js_1.default(decimals)));
		    }
		    get supportsSrmFeeDiscounts() {
		        return fees_1.supportsSrmFeeDiscounts(this._programId);
		    }
		    get supportsReferralFees() {
		        return tokens_and_markets_1.getLayoutVersion(this._programId) > 1;
		    }
		    get usesRequestQueue() {
		        return tokens_and_markets_1.getLayoutVersion(this._programId) <= 2;
		    }
		    async findFeeDiscountKeys(connection, ownerAddress, cacheDurationMs = 0) {
		        let sortedAccounts = [];
		        const now = new Date().getTime();
		        const strOwner = ownerAddress.toBase58();
		        if (strOwner in this._feeDiscountKeysCache &&
		            now - this._feeDiscountKeysCache[strOwner].ts < cacheDurationMs) {
		            return this._feeDiscountKeysCache[strOwner].accounts;
		        }
		        if (this.supportsSrmFeeDiscounts) {
		            // Fee discounts based on (M)SRM holdings supported in newer versions
		            const msrmAccounts = (await this.getTokenAccountsByOwnerForMint(connection, ownerAddress, token_instructions_1.MSRM_MINT)).map(({ pubkey, account }) => {
		                const balance = this.getSplTokenBalanceFromAccountInfo(account, token_instructions_1.MSRM_DECIMALS);
		                return {
		                    pubkey,
		                    mint: token_instructions_1.MSRM_MINT,
		                    balance,
		                    feeTier: fees_1.getFeeTier(balance, 0),
		                };
		            });
		            const srmAccounts = (await this.getTokenAccountsByOwnerForMint(connection, ownerAddress, token_instructions_1.SRM_MINT)).map(({ pubkey, account }) => {
		                const balance = this.getSplTokenBalanceFromAccountInfo(account, token_instructions_1.SRM_DECIMALS);
		                return {
		                    pubkey,
		                    mint: token_instructions_1.SRM_MINT,
		                    balance,
		                    feeTier: fees_1.getFeeTier(0, balance),
		                };
		            });
		            sortedAccounts = msrmAccounts.concat(srmAccounts).sort((a, b) => {
		                if (a.feeTier > b.feeTier) {
		                    return -1;
		                }
		                else if (a.feeTier < b.feeTier) {
		                    return 1;
		                }
		                else {
		                    if (a.balance > b.balance) {
		                        return -1;
		                    }
		                    else if (a.balance < b.balance) {
		                        return 1;
		                    }
		                    else {
		                        return 0;
		                    }
		                }
		            });
		        }
		        this._feeDiscountKeysCache[strOwner] = {
		            accounts: sortedAccounts,
		            ts: now,
		        };
		        return sortedAccounts;
		    }
		    async findBestFeeDiscountKey(connection, ownerAddress, cacheDurationMs = 30000) {
		        const accounts = await this.findFeeDiscountKeys(connection, ownerAddress, cacheDurationMs);
		        if (accounts.length > 0) {
		            return {
		                pubkey: accounts[0].pubkey,
		                feeTier: accounts[0].feeTier,
		            };
		        }
		        return {
		            pubkey: null,
		            feeTier: 0,
		        };
		    }
		    async makePlaceOrderTransaction(connection, { owner, payer, side, price, size, orderType = 'limit', clientId, openOrdersAddressKey, openOrdersAccount, feeDiscountPubkey = undefined, selfTradeBehavior = 'decrementTake', maxTs, replaceIfExists = false, }, cacheDurationMs = 0, feeDiscountPubkeyCacheDurationMs = 0) {
		        var _a, _b;
		        // @ts-ignore
		        const ownerAddress = (_a = owner.publicKey) !== null && _a !== void 0 ? _a : owner;
		        const openOrdersAccounts = await this.findOpenOrdersAccountsForOwner(connection, ownerAddress, cacheDurationMs);
		        const transaction = new web3_js_1.Transaction();
		        const signers = [];
		        // Fetch an SRM fee discount key if the market supports discounts and it is not supplied
		        let useFeeDiscountPubkey;
		        if (feeDiscountPubkey) {
		            useFeeDiscountPubkey = feeDiscountPubkey;
		        }
		        else if (feeDiscountPubkey === undefined &&
		            this.supportsSrmFeeDiscounts) {
		            useFeeDiscountPubkey = (await this.findBestFeeDiscountKey(connection, ownerAddress, feeDiscountPubkeyCacheDurationMs)).pubkey;
		        }
		        else {
		            useFeeDiscountPubkey = null;
		        }
		        let openOrdersAddress;
		        if (openOrdersAccounts.length === 0) {
		            let account;
		            if (openOrdersAccount) {
		                account = openOrdersAccount;
		            }
		            else {
		                account = new web3_js_1.Account();
		            }
		            transaction.add(await OpenOrders.makeCreateAccountTransaction(connection, this.address, ownerAddress, account.publicKey, this._programId));
		            openOrdersAddress = account.publicKey;
		            signers.push(account);
		            // refresh the cache of open order accounts on next fetch
		            this._openOrdersAccountsCache[ownerAddress.toBase58()].ts = 0;
		        }
		        else if (openOrdersAccount) {
		            openOrdersAddress = openOrdersAccount.publicKey;
		        }
		        else if (openOrdersAddressKey) {
		            openOrdersAddress = openOrdersAddressKey;
		        }
		        else {
		            openOrdersAddress = openOrdersAccounts[0].address;
		        }
		        let wrappedSolAccount = null;
		        if (payer.equals(ownerAddress)) {
		            if ((side === 'buy' && this.quoteMintAddress.equals(token_instructions_1.WRAPPED_SOL_MINT)) ||
		                (side === 'sell' && this.baseMintAddress.equals(token_instructions_1.WRAPPED_SOL_MINT))) {
		                wrappedSolAccount = new web3_js_1.Account();
		                let lamports;
		                if (side === 'buy') {
		                    lamports = Math.round(price * size * 1.01 * web3_js_1.LAMPORTS_PER_SOL);
		                    if (openOrdersAccounts.length > 0) {
		                        lamports -= openOrdersAccounts[0].quoteTokenFree.toNumber();
		                    }
		                }
		                else {
		                    lamports = Math.round(size * web3_js_1.LAMPORTS_PER_SOL);
		                    if (openOrdersAccounts.length > 0) {
		                        lamports -= openOrdersAccounts[0].baseTokenFree.toNumber();
		                    }
		                }
		                lamports = Math.max(lamports, 0) + 1e7;
		                transaction.add(web3_js_1.SystemProgram.createAccount({
		                    fromPubkey: ownerAddress,
		                    newAccountPubkey: wrappedSolAccount.publicKey,
		                    lamports,
		                    space: 165,
		                    programId: token_instructions_1.TOKEN_PROGRAM_ID,
		                }));
		                transaction.add(token_instructions_1.initializeAccount({
		                    account: wrappedSolAccount.publicKey,
		                    mint: token_instructions_1.WRAPPED_SOL_MINT,
		                    owner: ownerAddress,
		                }));
		                signers.push(wrappedSolAccount);
		            }
		            else {
		                throw new Error('Invalid payer account');
		            }
		        }
		        const placeOrderInstruction = this.makePlaceOrderInstruction(connection, {
		            owner,
		            payer: (_b = wrappedSolAccount === null || wrappedSolAccount === void 0 ? void 0 : wrappedSolAccount.publicKey) !== null && _b !== void 0 ? _b : payer,
		            side,
		            price,
		            size,
		            orderType,
		            clientId,
		            openOrdersAddressKey: openOrdersAddress,
		            feeDiscountPubkey: useFeeDiscountPubkey,
		            selfTradeBehavior,
		            maxTs,
		            replaceIfExists,
		        });
		        transaction.add(placeOrderInstruction);
		        if (wrappedSolAccount) {
		            transaction.add(token_instructions_1.closeAccount({
		                source: wrappedSolAccount.publicKey,
		                destination: ownerAddress,
		                owner: ownerAddress,
		            }));
		        }
		        return { transaction, signers, payer: owner };
		    }
		    makePlaceOrderInstruction(connection, params) {
		        var _a;
		        const { owner, payer, side, price, size, orderType = 'limit', clientId, openOrdersAddressKey, openOrdersAccount, feeDiscountPubkey = null, } = params;
		        // @ts-ignore
		        const ownerAddress = (_a = owner.publicKey) !== null && _a !== void 0 ? _a : owner;
		        if (this.baseSizeNumberToLots(size).lte(new bn_js_1.default(0))) {
		            throw new Error('size too small');
		        }
		        if (this.priceNumberToLots(price).lte(new bn_js_1.default(0))) {
		            throw new Error('invalid price');
		        }
		        if (this.usesRequestQueue) {
		            return instructions_1.DexInstructions.newOrder({
		                market: this.address,
		                requestQueue: this._decoded.requestQueue,
		                baseVault: this._decoded.baseVault,
		                quoteVault: this._decoded.quoteVault,
		                openOrders: openOrdersAccount
		                    ? openOrdersAccount.publicKey
		                    : openOrdersAddressKey,
		                owner: ownerAddress,
		                payer,
		                side,
		                limitPrice: this.priceNumberToLots(price),
		                maxQuantity: this.baseSizeNumberToLots(size),
		                orderType,
		                clientId,
		                programId: this._programId,
		                // @ts-ignore
		                feeDiscountPubkey: this.supportsSrmFeeDiscounts
		                    ? feeDiscountPubkey
		                    : null,
		            });
		        }
		        else {
		            return this.makeNewOrderV3Instruction(params);
		        }
		    }
		    makeNewOrderV3Instruction(params) {
		        var _a;
		        const { owner, payer, side, price, size, orderType = 'limit', clientId, openOrdersAddressKey, openOrdersAccount, feeDiscountPubkey = null, selfTradeBehavior = 'decrementTake', programId, maxTs, replaceIfExists, } = params;
		        // @ts-ignore
		        const ownerAddress = (_a = owner.publicKey) !== null && _a !== void 0 ? _a : owner;
		        return instructions_1.DexInstructions.newOrderV3({
		            market: this.address,
		            bids: this._decoded.bids,
		            asks: this._decoded.asks,
		            requestQueue: this._decoded.requestQueue,
		            eventQueue: this._decoded.eventQueue,
		            baseVault: this._decoded.baseVault,
		            quoteVault: this._decoded.quoteVault,
		            openOrders: openOrdersAccount
		                ? openOrdersAccount.publicKey
		                : openOrdersAddressKey,
		            owner: ownerAddress,
		            payer,
		            side,
		            limitPrice: this.priceNumberToLots(price),
		            maxBaseQuantity: this.baseSizeNumberToLots(size),
		            maxQuoteQuantity: new bn_js_1.default(this._decoded.quoteLotSize.toNumber()).mul(this.baseSizeNumberToLots(size).mul(this.priceNumberToLots(price))),
		            orderType,
		            clientId,
		            programId: programId !== null && programId !== void 0 ? programId : this._programId,
		            selfTradeBehavior,
		            // @ts-ignore
		            feeDiscountPubkey: this.supportsSrmFeeDiscounts
		                ? feeDiscountPubkey
		                : null,
		            // @ts-ignore
		            maxTs,
		            replaceIfExists,
		        });
		    }
		    makeReplaceOrdersByClientIdsInstruction(accounts, orders) {
		        var _a, _b;
		        // @ts-ignore
		        const ownerAddress = (_a = accounts.owner.publicKey) !== null && _a !== void 0 ? _a : accounts.owner;
		        return instructions_1.DexInstructions.replaceOrdersByClientIds({
		            market: this.address,
		            bids: this._decoded.bids,
		            asks: this._decoded.asks,
		            requestQueue: this._decoded.requestQueue,
		            eventQueue: this._decoded.eventQueue,
		            baseVault: this._decoded.baseVault,
		            quoteVault: this._decoded.quoteVault,
		            openOrders: accounts.openOrdersAccount
		                ? accounts.openOrdersAccount.publicKey
		                : accounts.openOrdersAddressKey,
		            owner: ownerAddress,
		            payer: accounts.payer,
		            programId: (_b = accounts.programId) !== null && _b !== void 0 ? _b : this._programId,
		            // @ts-ignore
		            feeDiscountPubkey: this.supportsSrmFeeDiscounts
		                ? accounts.feeDiscountPubkey
		                : null,
		            orders: orders.map(order => {
		                var _a;
		                return ({
		                    side: order.side,
		                    limitPrice: this.priceNumberToLots(order.price),
		                    maxBaseQuantity: this.baseSizeNumberToLots(order.size),
		                    maxQuoteQuantity: new bn_js_1.default(this._decoded.quoteLotSize.toNumber()).mul(this.baseSizeNumberToLots(order.size).mul(this.priceNumberToLots(order.price))),
		                    orderType: order.orderType,
		                    clientId: order.clientId,
		                    programId: (_a = accounts.programId) !== null && _a !== void 0 ? _a : this._programId,
		                    selfTradeBehavior: order.selfTradeBehavior,
		                    // @ts-ignore
		                    maxTs: order.maxTs,
		                });
		            })
		        });
		    }
		    async _sendTransaction(connection, transaction, signers) {
		        const signature = await connection.sendTransaction(transaction, signers, {
		            skipPreflight: this._skipPreflight,
		        });
		        const { value } = await connection.confirmTransaction(signature, this._commitment);
		        if (value === null || value === void 0 ? void 0 : value.err) {
		            throw new Error(JSON.stringify(value.err));
		        }
		        return signature;
		    }
		    async cancelOrderByClientId(connection, owner, openOrders, clientId) {
		        const transaction = await this.makeCancelOrderByClientIdTransaction(connection, owner.publicKey, openOrders, clientId);
		        return await this._sendTransaction(connection, transaction, [owner]);
		    }
		    async cancelOrdersByClientIds(connection, owner, openOrders, clientIds) {
		        const transaction = await this.makeCancelOrdersByClientIdsTransaction(connection, owner.publicKey, openOrders, clientIds);
		        return await this._sendTransaction(connection, transaction, [owner]);
		    }
		    async makeCancelOrderByClientIdTransaction(connection, owner, openOrders, clientId) {
		        const transaction = new web3_js_1.Transaction();
		        if (this.usesRequestQueue) {
		            transaction.add(instructions_1.DexInstructions.cancelOrderByClientId({
		                market: this.address,
		                owner,
		                openOrders,
		                requestQueue: this._decoded.requestQueue,
		                clientId,
		                programId: this._programId,
		            }));
		        }
		        else {
		            transaction.add(instructions_1.DexInstructions.cancelOrderByClientIdV2({
		                market: this.address,
		                openOrders,
		                owner,
		                bids: this._decoded.bids,
		                asks: this._decoded.asks,
		                eventQueue: this._decoded.eventQueue,
		                clientId,
		                programId: this._programId,
		            }));
		        }
		        return transaction;
		    }
		    async makeCancelOrdersByClientIdsTransaction(connection, owner, openOrders, clientIds) {
		        const transaction = new web3_js_1.Transaction();
		        transaction.add(instructions_1.DexInstructions.cancelOrdersByClientIds({
		            market: this.address,
		            openOrders,
		            owner,
		            bids: this._decoded.bids,
		            asks: this._decoded.asks,
		            eventQueue: this._decoded.eventQueue,
		            clientIds,
		            programId: this._programId,
		        }));
		        return transaction;
		    }
		    async cancelOrder(connection, owner, order) {
		        const transaction = await this.makeCancelOrderTransaction(connection, owner.publicKey, order);
		        return await this._sendTransaction(connection, transaction, [owner]);
		    }
		    async makeCancelOrderTransaction(connection, owner, order) {
		        const transaction = new web3_js_1.Transaction();
		        transaction.add(this.makeCancelOrderInstruction(connection, owner, order));
		        return transaction;
		    }
		    makeCancelOrderInstruction(connection, owner, order) {
		        if (this.usesRequestQueue) {
		            return instructions_1.DexInstructions.cancelOrder({
		                market: this.address,
		                owner,
		                openOrders: order.openOrdersAddress,
		                requestQueue: this._decoded.requestQueue,
		                side: order.side,
		                orderId: order.orderId,
		                openOrdersSlot: order.openOrdersSlot,
		                programId: this._programId,
		            });
		        }
		        else {
		            return instructions_1.DexInstructions.cancelOrderV2({
		                market: this.address,
		                owner,
		                openOrders: order.openOrdersAddress,
		                bids: this._decoded.bids,
		                asks: this._decoded.asks,
		                eventQueue: this._decoded.eventQueue,
		                side: order.side,
		                orderId: order.orderId,
		                openOrdersSlot: order.openOrdersSlot,
		                programId: this._programId,
		            });
		        }
		    }
		    makeConsumeEventsInstruction(openOrdersAccounts, limit) {
		        return instructions_1.DexInstructions.consumeEvents({
		            market: this.address,
		            eventQueue: this._decoded.eventQueue,
		            coinFee: this._decoded.eventQueue,
		            pcFee: this._decoded.eventQueue,
		            openOrdersAccounts,
		            limit,
		            programId: this._programId,
		        });
		    }
		    makeConsumeEventsPermissionedInstruction(openOrdersAccounts, limit) {
		        return instructions_1.DexInstructions.consumeEventsPermissioned({
		            market: this.address,
		            eventQueue: this._decoded.eventQueue,
		            crankAuthority: this._decoded.consumeEventsAuthority,
		            openOrdersAccounts,
		            limit,
		            programId: this._programId,
		        });
		    }
		    async settleFunds(connection, owner, openOrders, baseWallet, quoteWallet, referrerQuoteWallet = null) {
		        if (!openOrders.owner.equals(owner.publicKey)) {
		            throw new Error('Invalid open orders account');
		        }
		        if (referrerQuoteWallet && !this.supportsReferralFees) {
		            throw new Error('This program ID does not support referrerQuoteWallet');
		        }
		        const { transaction, signers } = await this.makeSettleFundsTransaction(connection, openOrders, baseWallet, quoteWallet, referrerQuoteWallet);
		        return await this._sendTransaction(connection, transaction, [
		            owner,
		            ...signers,
		        ]);
		    }
		    async makeSettleFundsTransaction(connection, openOrders, baseWallet, quoteWallet, referrerQuoteWallet = null) {
		        // @ts-ignore
		        const vaultSigner = await web3_js_1.PublicKey.createProgramAddress([
		            this.address.toBuffer(),
		            this._decoded.vaultSignerNonce.toArrayLike(buffer_1.Buffer, 'le', 8),
		        ], this._programId);
		        const transaction = new web3_js_1.Transaction();
		        const signers = [];
		        let wrappedSolAccount = null;
		        if ((this.baseMintAddress.equals(token_instructions_1.WRAPPED_SOL_MINT) &&
		            baseWallet.equals(openOrders.owner)) ||
		            (this.quoteMintAddress.equals(token_instructions_1.WRAPPED_SOL_MINT) &&
		                quoteWallet.equals(openOrders.owner))) {
		            wrappedSolAccount = new web3_js_1.Account();
		            transaction.add(web3_js_1.SystemProgram.createAccount({
		                fromPubkey: openOrders.owner,
		                newAccountPubkey: wrappedSolAccount.publicKey,
		                lamports: await connection.getMinimumBalanceForRentExemption(165),
		                space: 165,
		                programId: token_instructions_1.TOKEN_PROGRAM_ID,
		            }));
		            transaction.add(token_instructions_1.initializeAccount({
		                account: wrappedSolAccount.publicKey,
		                mint: token_instructions_1.WRAPPED_SOL_MINT,
		                owner: openOrders.owner,
		            }));
		            signers.push(wrappedSolAccount);
		        }
		        transaction.add(instructions_1.DexInstructions.settleFunds({
		            market: this.address,
		            openOrders: openOrders.address,
		            owner: openOrders.owner,
		            baseVault: this._decoded.baseVault,
		            quoteVault: this._decoded.quoteVault,
		            baseWallet: baseWallet.equals(openOrders.owner) && wrappedSolAccount
		                ? wrappedSolAccount.publicKey
		                : baseWallet,
		            quoteWallet: quoteWallet.equals(openOrders.owner) && wrappedSolAccount
		                ? wrappedSolAccount.publicKey
		                : quoteWallet,
		            vaultSigner,
		            programId: this._programId,
		            referrerQuoteWallet,
		        }));
		        if (wrappedSolAccount) {
		            transaction.add(token_instructions_1.closeAccount({
		                source: wrappedSolAccount.publicKey,
		                destination: openOrders.owner,
		                owner: openOrders.owner,
		            }));
		        }
		        return { transaction, signers, payer: openOrders.owner };
		    }
		    async matchOrders(connection, feePayer, limit) {
		        const tx = this.makeMatchOrdersTransaction(limit);
		        return await this._sendTransaction(connection, tx, [feePayer]);
		    }
		    makeMatchOrdersTransaction(limit) {
		        const tx = new web3_js_1.Transaction();
		        tx.add(instructions_1.DexInstructions.matchOrders({
		            market: this.address,
		            requestQueue: this._decoded.requestQueue,
		            eventQueue: this._decoded.eventQueue,
		            bids: this._decoded.bids,
		            asks: this._decoded.asks,
		            baseVault: this._decoded.baseVault,
		            quoteVault: this._decoded.quoteVault,
		            limit,
		            programId: this._programId,
		        }));
		        return tx;
		    }
		    async loadRequestQueue(connection) {
		        const { data } = throwIfNull(await connection.getAccountInfo(this._decoded.requestQueue));
		        return queue_1.decodeRequestQueue(data);
		    }
		    async loadEventQueue(connection) {
		        const { data } = throwIfNull(await connection.getAccountInfo(this._decoded.eventQueue));
		        return queue_1.decodeEventQueue(data);
		    }
		    async loadFills(connection, limit = 100) {
		        // TODO: once there's a separate source of fills use that instead
		        const { data } = throwIfNull(await connection.getAccountInfo(this._decoded.eventQueue));
		        const events = queue_1.decodeEventQueue(data, limit);
		        return events
		            .filter((event) => event.eventFlags.fill && event.nativeQuantityPaid.gtn(0))
		            .map(this.parseFillEvent.bind(this));
		    }
		    parseFillEvent(event) {
		        let size, price, side, priceBeforeFees;
		        if (event.eventFlags.bid) {
		            side = 'buy';
		            priceBeforeFees = event.eventFlags.maker
		                ? event.nativeQuantityPaid.add(event.nativeFeeOrRebate)
		                : event.nativeQuantityPaid.sub(event.nativeFeeOrRebate);
		            price = divideBnToNumber(priceBeforeFees.mul(this._baseSplTokenMultiplier), this._quoteSplTokenMultiplier.mul(event.nativeQuantityReleased));
		            size = divideBnToNumber(event.nativeQuantityReleased, this._baseSplTokenMultiplier);
		        }
		        else {
		            side = 'sell';
		            priceBeforeFees = event.eventFlags.maker
		                ? event.nativeQuantityReleased.sub(event.nativeFeeOrRebate)
		                : event.nativeQuantityReleased.add(event.nativeFeeOrRebate);
		            price = divideBnToNumber(priceBeforeFees.mul(this._baseSplTokenMultiplier), this._quoteSplTokenMultiplier.mul(event.nativeQuantityPaid));
		            size = divideBnToNumber(event.nativeQuantityPaid, this._baseSplTokenMultiplier);
		        }
		        return {
		            ...event,
		            side,
		            price,
		            feeCost: this.quoteSplSizeToNumber(event.nativeFeeOrRebate) *
		                (event.eventFlags.maker ? -1 : 1),
		            size,
		        };
		    }
		    get _baseSplTokenMultiplier() {
		        return new bn_js_1.default(10).pow(new bn_js_1.default(this._baseSplTokenDecimals));
		    }
		    get _quoteSplTokenMultiplier() {
		        return new bn_js_1.default(10).pow(new bn_js_1.default(this._quoteSplTokenDecimals));
		    }
		    priceLotsToNumber(price) {
		        return divideBnToNumber(price.mul(this._decoded.quoteLotSize).mul(this._baseSplTokenMultiplier), this._decoded.baseLotSize.mul(this._quoteSplTokenMultiplier));
		    }
		    priceNumberToLots(price) {
		        return new bn_js_1.default(Math.round((price *
		            Math.pow(10, this._quoteSplTokenDecimals) *
		            this._decoded.baseLotSize.toNumber()) /
		            (Math.pow(10, this._baseSplTokenDecimals) *
		                this._decoded.quoteLotSize.toNumber())));
		    }
		    baseSplSizeToNumber(size) {
		        return divideBnToNumber(size, this._baseSplTokenMultiplier);
		    }
		    quoteSplSizeToNumber(size) {
		        return divideBnToNumber(size, this._quoteSplTokenMultiplier);
		    }
		    baseSizeLotsToNumber(size) {
		        return divideBnToNumber(size.mul(this._decoded.baseLotSize), this._baseSplTokenMultiplier);
		    }
		    baseSizeNumberToLots(size) {
		        const native = new bn_js_1.default(Math.round(size * Math.pow(10, this._baseSplTokenDecimals)));
		        // rounds down to the nearest lot size
		        return native.div(this._decoded.baseLotSize);
		    }
		    quoteSizeLotsToNumber(size) {
		        return divideBnToNumber(size.mul(this._decoded.quoteLotSize), this._quoteSplTokenMultiplier);
		    }
		    quoteSizeNumberToLots(size) {
		        const native = new bn_js_1.default(Math.round(size * Math.pow(10, this._quoteSplTokenDecimals)));
		        // rounds down to the nearest lot size
		        return native.div(this._decoded.quoteLotSize);
		    }
		    get minOrderSize() {
		        return this.baseSizeLotsToNumber(new bn_js_1.default(1));
		    }
		    get tickSize() {
		        return this.priceLotsToNumber(new bn_js_1.default(1));
		    }
		}
		exports.Market = Market;
		exports._OPEN_ORDERS_LAYOUT_V1 = buffer_layout_1.struct([
		    buffer_layout_1.blob(5),
		    layout_1.accountFlagsLayout('accountFlags'),
		    layout_1.publicKeyLayout('market'),
		    layout_1.publicKeyLayout('owner'),
		    // These are in spl-token (i.e. not lot) units
		    layout_1.u64('baseTokenFree'),
		    layout_1.u64('baseTokenTotal'),
		    layout_1.u64('quoteTokenFree'),
		    layout_1.u64('quoteTokenTotal'),
		    layout_1.u128('freeSlotBits'),
		    layout_1.u128('isBidBits'),
		    buffer_layout_1.seq(layout_1.u128(), 128, 'orders'),
		    buffer_layout_1.seq(layout_1.u64(), 128, 'clientIds'),
		    buffer_layout_1.blob(7),
		]);
		exports._OPEN_ORDERS_LAYOUT_V2 = buffer_layout_1.struct([
		    buffer_layout_1.blob(5),
		    layout_1.accountFlagsLayout('accountFlags'),
		    layout_1.publicKeyLayout('market'),
		    layout_1.publicKeyLayout('owner'),
		    // These are in spl-token (i.e. not lot) units
		    layout_1.u64('baseTokenFree'),
		    layout_1.u64('baseTokenTotal'),
		    layout_1.u64('quoteTokenFree'),
		    layout_1.u64('quoteTokenTotal'),
		    layout_1.u128('freeSlotBits'),
		    layout_1.u128('isBidBits'),
		    buffer_layout_1.seq(layout_1.u128(), 128, 'orders'),
		    buffer_layout_1.seq(layout_1.u64(), 128, 'clientIds'),
		    layout_1.u64('referrerRebatesAccrued'),
		    buffer_layout_1.blob(7),
		]);
		class OpenOrders {
		    constructor(address, decoded, programId) {
		        this.address = address;
		        this._programId = programId;
		        Object.assign(this, decoded);
		    }
		    static getLayout(programId) {
		        if (tokens_and_markets_1.getLayoutVersion(programId) === 1) {
		            return exports._OPEN_ORDERS_LAYOUT_V1;
		        }
		        return exports._OPEN_ORDERS_LAYOUT_V2;
		    }
		    static async findForOwner(connection, ownerAddress, programId) {
		        const filters = [
		            {
		                memcmp: {
		                    offset: this.getLayout(programId).offsetOf('owner'),
		                    bytes: ownerAddress.toBase58(),
		                },
		            },
		            {
		                dataSize: this.getLayout(programId).span,
		            },
		        ];
		        const accounts = await getFilteredProgramAccounts(connection, programId, filters);
		        return accounts.map(({ publicKey, accountInfo }) => OpenOrders.fromAccountInfo(publicKey, accountInfo, programId));
		    }
		    static async findForMarketAndOwner(connection, marketAddress, ownerAddress, programId) {
		        const filters = [
		            {
		                memcmp: {
		                    offset: this.getLayout(programId).offsetOf('market'),
		                    bytes: marketAddress.toBase58(),
		                },
		            },
		            {
		                memcmp: {
		                    offset: this.getLayout(programId).offsetOf('owner'),
		                    bytes: ownerAddress.toBase58(),
		                },
		            },
		            {
		                dataSize: this.getLayout(programId).span,
		            },
		        ];
		        const accounts = await getFilteredProgramAccounts(connection, programId, filters);
		        return accounts.map(({ publicKey, accountInfo }) => OpenOrders.fromAccountInfo(publicKey, accountInfo, programId));
		    }
		    static async load(connection, address, programId) {
		        const accountInfo = await connection.getAccountInfo(address);
		        if (accountInfo === null) {
		            throw new Error('Open orders account not found');
		        }
		        return OpenOrders.fromAccountInfo(address, accountInfo, programId);
		    }
		    static fromAccountInfo(address, accountInfo, programId) {
		        const { owner, data } = accountInfo;
		        if (!owner.equals(programId)) {
		            throw new Error('Address not owned by program');
		        }
		        const decoded = this.getLayout(programId).decode(data);
		        if (!decoded.accountFlags.initialized || !decoded.accountFlags.openOrders) {
		            throw new Error('Invalid open orders account');
		        }
		        return new OpenOrders(address, decoded, programId);
		    }
		    static async makeCreateAccountTransaction(connection, marketAddress, ownerAddress, newAccountAddress, programId) {
		        return web3_js_1.SystemProgram.createAccount({
		            fromPubkey: ownerAddress,
		            newAccountPubkey: newAccountAddress,
		            lamports: await connection.getMinimumBalanceForRentExemption(this.getLayout(programId).span),
		            space: this.getLayout(programId).span,
		            programId,
		        });
		    }
		    get publicKey() {
		        return this.address;
		    }
		}
		exports.OpenOrders = OpenOrders;
		exports.ORDERBOOK_LAYOUT = buffer_layout_1.struct([
		    buffer_layout_1.blob(5),
		    layout_1.accountFlagsLayout('accountFlags'),
		    slab_1.SLAB_LAYOUT.replicate('slab'),
		    buffer_layout_1.blob(7),
		]);
		class Orderbook {
		    constructor(market, accountFlags, slab) {
		        if (!accountFlags.initialized || !(accountFlags.bids ^ accountFlags.asks)) {
		            throw new Error('Invalid orderbook');
		        }
		        this.market = market;
		        this.isBids = accountFlags.bids;
		        this.slab = slab;
		    }
		    static get LAYOUT() {
		        return exports.ORDERBOOK_LAYOUT;
		    }
		    static decode(market, buffer) {
		        const { accountFlags, slab } = exports.ORDERBOOK_LAYOUT.decode(buffer);
		        return new Orderbook(market, accountFlags, slab);
		    }
		    getL2(depth) {
		        const descending = this.isBids;
		        const levels = []; // (price, size)
		        for (const { key, quantity } of this.slab.items(descending)) {
		            const price = getPriceFromKey(key);
		            if (levels.length > 0 && levels[levels.length - 1][0].eq(price)) {
		                levels[levels.length - 1][1] = levels[levels.length - 1][1].add(quantity);
		            }
		            else if (levels.length === depth) {
		                break;
		            }
		            else {
		                levels.push([price, quantity]);
		            }
		        }
		        return levels.map(([priceLots, sizeLots]) => [
		            this.market.priceLotsToNumber(priceLots),
		            this.market.baseSizeLotsToNumber(sizeLots),
		            priceLots,
		            sizeLots,
		        ]);
		    }
		    [Symbol.iterator]() {
		        return this.items(false);
		    }
		    *items(descending = false) {
		        for (const { key, ownerSlot, owner, quantity, feeTier, clientOrderId, } of this.slab.items(descending)) {
		            const price = getPriceFromKey(key);
		            yield {
		                orderId: key,
		                clientId: clientOrderId,
		                openOrdersAddress: owner,
		                openOrdersSlot: ownerSlot,
		                feeTier,
		                price: this.market.priceLotsToNumber(price),
		                priceLots: price,
		                size: this.market.baseSizeLotsToNumber(quantity),
		                sizeLots: quantity,
		                side: (this.isBids ? 'buy' : 'sell'),
		            };
		        }
		    }
		}
		exports.Orderbook = Orderbook;
		function getPriceFromKey(key) {
		    return key.ushrn(64);
		}
		function divideBnToNumber(numerator, denominator) {
		    const quotient = numerator.div(denominator).toNumber();
		    const rem = numerator.umod(denominator);
		    const gcd = rem.gcd(denominator);
		    return quotient + rem.div(gcd).toNumber() / denominator.div(gcd).toNumber();
		}
		const MINT_LAYOUT = buffer_layout_1.struct([buffer_layout_1.blob(44), buffer_layout_1.u8('decimals'), buffer_layout_1.blob(37)]);
		async function getMintDecimals(connection, mint) {
		    if (mint.equals(token_instructions_1.WRAPPED_SOL_MINT)) {
		        return 9;
		    }
		    const { data } = throwIfNull(await connection.getAccountInfo(mint), 'mint not found');
		    const { decimals } = MINT_LAYOUT.decode(data);
		    return decimals;
		}
		exports.getMintDecimals = getMintDecimals;
		async function getFilteredProgramAccounts(connection, programId, filters) {
		    // @ts-ignore
		    const resp = await connection._rpcRequest('getProgramAccounts', [
		        programId.toBase58(),
		        {
		            commitment: connection.commitment,
		            filters,
		            encoding: 'base64',
		        },
		    ]);
		    if (resp.error) {
		        throw new Error(resp.error.message);
		    }
		    return resp.result.map(({ pubkey, account: { data, executable, owner, lamports } }) => ({
		        publicKey: new web3_js_1.PublicKey(pubkey),
		        accountInfo: {
		            data: buffer_1.Buffer.from(data[0], 'base64'),
		            executable,
		            owner: new web3_js_1.PublicKey(owner),
		            lamports,
		        },
		    }));
		}
		function throwIfNull(value, message = 'account not found') {
		    if (value === null) {
		        throw new Error(message);
		    }
		    return value;
		}
		
	} (market));

	//               ░░░░
	//
	//                                           ██
	//                                         ██░░██
	// ░░          ░░                        ██░░░░░░██                            ░░░░
	//                                     ██░░░░░░░░░░██
	//                                     ██░░░░░░░░░░██
	//                                   ██░░░░░░░░░░░░░░██
	//                                 ██░░░░░░██████░░░░░░██
	//                                 ██░░░░░░██████░░░░░░██
	//                               ██░░░░░░░░██████░░░░░░░░██
	//                               ██░░░░░░░░██████░░░░░░░░██
	//                             ██░░░░░░░░░░██████░░░░░░░░░░██
	//                           ██░░░░░░░░░░░░██████░░░░░░░░░░░░██
	//                           ██░░░░░░░░░░░░██████░░░░░░░░░░░░██
	//                         ██░░░░░░░░░░░░░░██████░░░░░░░░░░░░░░██
	//                         ██░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░██
	//                       ██░░░░░░░░░░░░░░░░██████░░░░░░░░░░░░░░░░██
	//                       ██░░░░░░░░░░░░░░░░██████░░░░░░░░░░░░░░░░██
	//                     ██░░░░░░░░░░░░░░░░░░██████░░░░░░░░░░░░░░░░░░██
	//       ░░            ██░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░██
	//                       ██████████████████████████████████████████
	// warning: this code is copy pasta from rust, keep in sync with health.rs
	class HealthCache {
	    tokenInfos;
	    serum3Infos;
	    perpInfos;
	    constructor(tokenInfos, serum3Infos, perpInfos) {
	        this.tokenInfos = tokenInfos;
	        this.serum3Infos = serum3Infos;
	        this.perpInfos = perpInfos;
	    }
	    static fromMangoAccount(group, mangoAccount) {
	        // token contribution from token accounts
	        const tokenInfos = mangoAccount.tokensActive().map((tokenPosition) => {
	            const bank = group.getFirstBankByTokenIndex(tokenPosition.tokenIndex);
	            return TokenInfo.fromBank(bank, tokenPosition.balance(bank));
	        });
	        // Fill the TokenInfo balance with free funds in serum3 oo accounts, and fill
	        // the serum3MaxReserved with their reserved funds. Also build Serum3Infos.
	        const serum3Infos = mangoAccount.serum3Active().map((serum3) => {
	            const oo = mangoAccount.getSerum3OoAccount(serum3.marketIndex);
	            // find the TokenInfos for the market's base and quote tokens
	            const baseIndex = tokenInfos.findIndex((tokenInfo) => tokenInfo.tokenIndex === serum3.baseTokenIndex);
	            const baseInfo = tokenInfos[baseIndex];
	            if (!baseInfo) {
	                throw new Error(`BaseInfo not found for market with marketIndex ${serum3.marketIndex}!`);
	            }
	            const quoteIndex = tokenInfos.findIndex((tokenInfo) => tokenInfo.tokenIndex === serum3.quoteTokenIndex);
	            const quoteInfo = tokenInfos[quoteIndex];
	            if (!quoteInfo) {
	                throw new Error(`QuoteInfo not found for market with marketIndex ${serum3.marketIndex}!`);
	            }
	            return Serum3Info.fromOoModifyingTokenInfos(baseIndex, baseInfo, quoteIndex, quoteInfo, serum3.marketIndex, oo);
	        });
	        // health contribution from perp accounts
	        const perpInfos = mangoAccount.perpActive().map((perpPosition) => {
	            const perpMarket = group.getPerpMarketByMarketIndex(perpPosition.marketIndex);
	            return PerpInfo.fromPerpPosition(perpMarket, perpPosition);
	        });
	        return new HealthCache(tokenInfos, serum3Infos, perpInfos);
	    }
	    static fromDto(dto) {
	        return new HealthCache(dto.tokenInfos.map((dto) => TokenInfo.fromDto(dto)), dto.serum3Infos.map((dto) => Serum3Info.fromDto(dto)), dto.perpInfos.map((dto) => PerpInfo.fromDto(dto)));
	    }
	    computeSerum3Reservations(healthType) {
	        // For each token, compute the sum of serum-reserved amounts over all markets.
	        const tokenMaxReserved = new Array(this.tokenInfos.length)
	            .fill(null)
	            .map((ignored) => ZERO_I80F48());
	        // For each serum market, compute what happened if reserved_base was converted to quote
	        // or reserved_quote was converted to base.
	        const serum3Reserved = [];
	        for (const info of this.serum3Infos) {
	            const quote = this.tokenInfos[info.quoteIndex];
	            const base = this.tokenInfos[info.baseIndex];
	            const reservedBase = info.reservedBase;
	            const reservedQuote = info.reservedQuote;
	            const quoteAsset = quote.prices.asset(healthType);
	            const baseLiab = base.prices.liab(healthType);
	            const allReservedAsBase = reservedBase.add(reservedQuote.mul(quoteAsset).div(baseLiab));
	            const baseAsset = base.prices.asset(healthType);
	            const quoteLiab = quote.prices.liab(healthType);
	            const allReservedAsQuote = reservedQuote.add(reservedBase.mul(baseAsset).div(quoteLiab));
	            const baseMaxReserved = tokenMaxReserved[info.baseIndex];
	            baseMaxReserved.iadd(allReservedAsBase);
	            const quoteMaxReserved = tokenMaxReserved[info.quoteIndex];
	            quoteMaxReserved.iadd(allReservedAsQuote);
	            serum3Reserved.push(new Serum3Reserved(allReservedAsBase, allReservedAsQuote));
	        }
	        return {
	            tokenMaxReserved: tokenMaxReserved,
	            serum3Reserved: serum3Reserved,
	        };
	    }
	    health(healthType) {
	        const health = ZERO_I80F48();
	        for (const tokenInfo of this.tokenInfos) {
	            const contrib = tokenInfo.healthContribution(healthType);
	            // console.log(` - ti ${contrib}`);
	            health.iadd(contrib);
	        }
	        const res = this.computeSerum3Reservations(healthType);
	        for (const [index, serum3Info] of this.serum3Infos.entries()) {
	            const contrib = serum3Info.healthContribution(healthType, this.tokenInfos, res.tokenMaxReserved, res.serum3Reserved[index]);
	            // console.log(` - si ${contrib}`);
	            health.iadd(contrib);
	        }
	        for (const perpInfo of this.perpInfos) {
	            const contrib = perpInfo.healthContribution(healthType);
	            // console.log(` - pi ${contrib}`);
	            health.iadd(contrib);
	        }
	        return health;
	    }
	    // Note: only considers positive perp pnl contributions, see program code for more reasoning
	    perpSettleHealth() {
	        const health = ZERO_I80F48();
	        for (const tokenInfo of this.tokenInfos) {
	            const contrib = tokenInfo.healthContribution(HealthType.maint);
	            // console.log(` - ti ${contrib}`);
	            health.iadd(contrib);
	        }
	        const res = this.computeSerum3Reservations(HealthType.maint);
	        for (const [index, serum3Info] of this.serum3Infos.entries()) {
	            const contrib = serum3Info.healthContribution(HealthType.maint, this.tokenInfos, res.tokenMaxReserved, res.serum3Reserved[index]);
	            // console.log(` - si ${contrib}`);
	            health.iadd(contrib);
	        }
	        for (const perpInfo of this.perpInfos) {
	            const positiveContrib = perpInfo
	                .healthContribution(HealthType.maint)
	                .max(ZERO_I80F48());
	            // console.log(` - pi ${positiveContrib}`);
	            health.iadd(positiveContrib);
	        }
	        return health;
	    }
	    // An undefined HealthType will use an asset and liab weight of 1
	    assets(healthType) {
	        const assets = ZERO_I80F48();
	        for (const tokenInfo of this.tokenInfos) {
	            const contrib = tokenInfo.healthContribution(healthType);
	            if (contrib.isPos()) {
	                assets.iadd(contrib);
	            }
	        }
	        const res = this.computeSerum3Reservations(HealthType.maint);
	        for (const [index, serum3Info] of this.serum3Infos.entries()) {
	            const contrib = serum3Info.healthContribution(healthType, this.tokenInfos, res.tokenMaxReserved, res.serum3Reserved[index]);
	            if (contrib.isPos()) {
	                assets.iadd(contrib);
	            }
	        }
	        for (const perpInfo of this.perpInfos) {
	            const contrib = perpInfo.healthContribution(healthType);
	            if (contrib.isPos()) {
	                assets.iadd(contrib);
	            }
	        }
	        return assets;
	    }
	    // An undefined HealthType will use an asset and liab weight of 1
	    liabs(healthType) {
	        const liabs = ZERO_I80F48();
	        for (const tokenInfo of this.tokenInfos) {
	            const contrib = tokenInfo.healthContribution(healthType);
	            if (contrib.isNeg()) {
	                liabs.isub(contrib);
	            }
	        }
	        const res = this.computeSerum3Reservations(HealthType.maint);
	        for (const [index, serum3Info] of this.serum3Infos.entries()) {
	            const contrib = serum3Info.healthContribution(healthType, this.tokenInfos, res.tokenMaxReserved, res.serum3Reserved[index]);
	            if (contrib.isNeg()) {
	                liabs.isub(contrib);
	            }
	        }
	        for (const perpInfo of this.perpInfos) {
	            const contrib = perpInfo.healthContribution(healthType);
	            if (contrib.isNeg()) {
	                liabs.isub(contrib);
	            }
	        }
	        return liabs;
	    }
	    healthRatio(healthType) {
	        const assets = ZERO_I80F48();
	        const liabs = ZERO_I80F48();
	        for (const tokenInfo of this.tokenInfos) {
	            const contrib = tokenInfo.healthContribution(healthType);
	            // console.log(` - ti contrib ${contrib.toLocaleString()}`);
	            if (contrib.isPos()) {
	                assets.iadd(contrib);
	            }
	            else {
	                liabs.isub(contrib);
	            }
	        }
	        const res = this.computeSerum3Reservations(HealthType.maint);
	        for (const [index, serum3Info] of this.serum3Infos.entries()) {
	            const contrib = serum3Info.healthContribution(healthType, this.tokenInfos, res.tokenMaxReserved, res.serum3Reserved[index]);
	            // console.log(` - si contrib ${contrib.toLocaleString()}`);
	            if (contrib.isPos()) {
	                assets.iadd(contrib);
	            }
	            else {
	                liabs.isub(contrib);
	            }
	        }
	        for (const perpInfo of this.perpInfos) {
	            const contrib = perpInfo.healthContribution(healthType);
	            // console.log(` - pi contrib ${contrib.toLocaleString()}`);
	            if (contrib.isPos()) {
	                assets.iadd(contrib);
	            }
	            else {
	                liabs.isub(contrib);
	            }
	        }
	        // console.log(
	        //   ` - assets ${assets.toLocaleString()}, liabs ${liabs.toLocaleString()}`,
	        // );
	        if (liabs.gt(I80F48.fromNumber(0.001))) {
	            return HUNDRED_I80F48().mul(assets.sub(liabs).div(liabs));
	        }
	        else {
	            return MAX_I80F48();
	        }
	    }
	    findTokenInfoIndex(tokenIndex) {
	        return this.tokenInfos.findIndex((tokenInfo) => tokenInfo.tokenIndex === tokenIndex);
	    }
	    getOrCreateTokenInfoIndex(bank) {
	        const index = this.findTokenInfoIndex(bank.tokenIndex);
	        if (index == -1) {
	            this.tokenInfos.push(TokenInfo.fromBank(bank));
	        }
	        return this.findTokenInfoIndex(bank.tokenIndex);
	    }
	    simHealthRatioWithTokenPositionChanges(group, nativeTokenChanges, healthType = HealthType.init) {
	        const adjustedCache = lodashExports.cloneDeep(this);
	        // HealthCache.logHealthCache('beforeChange', adjustedCache);
	        for (const change of nativeTokenChanges) {
	            const bank = group.getFirstBankByMint(change.mintPk);
	            const changeIndex = adjustedCache.getOrCreateTokenInfoIndex(bank);
	            // TODO: this will no longer work as easily because of the health weight changes
	            adjustedCache.tokenInfos[changeIndex].balanceNative.iadd(change.nativeTokenAmount);
	        }
	        // HealthCache.logHealthCache('afterChange', adjustedCache);
	        return adjustedCache.healthRatio(healthType);
	    }
	    findSerum3InfoIndex(marketIndex) {
	        return this.serum3Infos.findIndex((serum3Info) => serum3Info.marketIndex === marketIndex);
	    }
	    getOrCreateSerum3InfoIndex(baseBank, quoteBank, serum3Market) {
	        const index = this.findSerum3InfoIndex(serum3Market.marketIndex);
	        const baseEntryIndex = this.getOrCreateTokenInfoIndex(baseBank);
	        const quoteEntryIndex = this.getOrCreateTokenInfoIndex(quoteBank);
	        if (index == -1) {
	            this.serum3Infos.push(Serum3Info.emptyFromSerum3Market(serum3Market, baseEntryIndex, quoteEntryIndex));
	        }
	        return this.findSerum3InfoIndex(serum3Market.marketIndex);
	    }
	    adjustSerum3Reserved(baseBank, quoteBank, serum3Market, reservedBaseChange, freeBaseChange, reservedQuoteChange, freeQuoteChange) {
	        const baseEntryIndex = this.getOrCreateTokenInfoIndex(baseBank);
	        const quoteEntryIndex = this.getOrCreateTokenInfoIndex(quoteBank);
	        const baseEntry = this.tokenInfos[baseEntryIndex];
	        const quoteEntry = this.tokenInfos[quoteEntryIndex];
	        // Apply it to the tokens
	        baseEntry.balanceNative.iadd(freeBaseChange);
	        quoteEntry.balanceNative.iadd(freeQuoteChange);
	        // Apply it to the serum3 info
	        const index = this.getOrCreateSerum3InfoIndex(baseBank, quoteBank, serum3Market);
	        const serum3Info = this.serum3Infos[index];
	        serum3Info.reservedBase.iadd(reservedBaseChange);
	        serum3Info.reservedQuote.iadd(reservedQuoteChange);
	    }
	    simHealthRatioWithSerum3BidChanges(baseBank, quoteBank, bidNativeQuoteAmount, serum3Market, healthType = HealthType.init) {
	        const adjustedCache = lodashExports.cloneDeep(this);
	        const quoteIndex = adjustedCache.getOrCreateTokenInfoIndex(quoteBank);
	        // Move token balance to reserved funds in open orders,
	        // essentially simulating a place order
	        // Reduce token balance for quote
	        adjustedCache.tokenInfos[quoteIndex].balanceNative.isub(bidNativeQuoteAmount);
	        // Increase reserved in Serum3Info for quote
	        adjustedCache.adjustSerum3Reserved(baseBank, quoteBank, serum3Market, ZERO_I80F48(), ZERO_I80F48(), bidNativeQuoteAmount, ZERO_I80F48());
	        return adjustedCache.healthRatio(healthType);
	    }
	    simHealthRatioWithSerum3AskChanges(baseBank, quoteBank, askNativeBaseAmount, serum3Market, healthType = HealthType.init) {
	        const adjustedCache = lodashExports.cloneDeep(this);
	        const baseIndex = adjustedCache.getOrCreateTokenInfoIndex(baseBank);
	        // Move token balance to reserved funds in open orders,
	        // essentially simulating a place order
	        // Reduce token balance for base
	        adjustedCache.tokenInfos[baseIndex].balanceNative.isub(askNativeBaseAmount);
	        // Increase reserved in Serum3Info for base
	        adjustedCache.adjustSerum3Reserved(baseBank, quoteBank, serum3Market, askNativeBaseAmount, ZERO_I80F48(), ZERO_I80F48(), ZERO_I80F48());
	        return adjustedCache.healthRatio(healthType);
	    }
	    findPerpInfoIndex(perpMarketIndex) {
	        return this.perpInfos.findIndex((perpInfo) => perpInfo.perpMarketIndex === perpMarketIndex);
	    }
	    getOrCreatePerpInfoIndex(perpMarket) {
	        const index = this.findPerpInfoIndex(perpMarket.perpMarketIndex);
	        if (index == -1) {
	            this.perpInfos.push(PerpInfo.emptyFromPerpMarket(perpMarket));
	        }
	        return this.findPerpInfoIndex(perpMarket.perpMarketIndex);
	    }
	    adjustPerpInfo(perpInfoIndex, price, side, newOrderBaseLots) {
	        if (side == PerpOrderSide.bid) {
	            this.perpInfos[perpInfoIndex].baseLots.iadd(newOrderBaseLots);
	            this.perpInfos[perpInfoIndex].quote.isub(I80F48.fromI64(newOrderBaseLots)
	                .mul(I80F48.fromI64(this.perpInfos[perpInfoIndex].baseLotSize))
	                .mul(price));
	        }
	        else {
	            this.perpInfos[perpInfoIndex].baseLots.isub(newOrderBaseLots);
	            this.perpInfos[perpInfoIndex].quote.iadd(I80F48.fromI64(newOrderBaseLots)
	                .mul(I80F48.fromI64(this.perpInfos[perpInfoIndex].baseLotSize))
	                .mul(price));
	        }
	    }
	    simHealthRatioWithPerpOrderChanges(perpMarket, existingPerpPosition, side, baseLots, price, healthType = HealthType.init) {
	        const clonedHealthCache = lodashExports.cloneDeep(this);
	        const perpInfoIndex = clonedHealthCache.getOrCreatePerpInfoIndex(perpMarket);
	        clonedHealthCache.adjustPerpInfo(perpInfoIndex, price, side, baseLots);
	        return clonedHealthCache.healthRatio(healthType);
	    }
	    logHealthCache(debug) {
	        if (debug)
	            console.log(debug);
	        for (const token of this.tokenInfos) {
	            console.log(` ${token.toString()}`);
	        }
	        const res = this.computeSerum3Reservations(HealthType.maint);
	        for (const [index, serum3Info] of this.serum3Infos.entries()) {
	            console.log(` ${serum3Info.toString(this.tokenInfos, res.tokenMaxReserved, res.serum3Reserved[index])}`);
	        }
	        console.log(` assets ${this.assets(HealthType.init)}, liabs ${this.liabs(HealthType.init)}, `);
	        console.log(` health(HealthType.init) ${this.health(HealthType.init)}`);
	        console.log(` healthRatio(HealthType.init) ${this.healthRatio(HealthType.init)}`);
	    }
	    static scanRightUntilLessThan(start, target, fun) {
	        const maxIterations = 20;
	        let current = start;
	        // console.log(`scanRightUntilLessThan, start ${start.toLocaleString()}`);
	        for (const key of Array(maxIterations).fill(0).keys()) {
	            const value = fun(current);
	            if (value.lt(target)) {
	                return current;
	            }
	            // console.log(
	            //   ` - current ${current.toLocaleString()}, value ${value.toLocaleString()}, target ${target.toLocaleString()}`,
	            // );
	            current = current.max(ONE_I80F48()).mul(I80F48.fromNumber(2));
	        }
	        throw new Error('Could not find amount that led to health ratio <=0');
	    }
	    /// This is not a generic function. It assumes there is a unique maximum between left and right.
	    static findMaximum(left, right, minStep, fun) {
	        const half = I80F48.fromNumber(0.5);
	        let mid = half.mul(left.add(right));
	        let leftValue = fun(left);
	        let rightValue = fun(right);
	        let midValue = fun(mid);
	        while (right.sub(left).gt(minStep)) {
	            if (leftValue.gte(midValue)) {
	                // max must be between left and mid
	                right = mid;
	                rightValue = midValue;
	                mid = half.mul(left.add(mid));
	                midValue = fun(mid);
	            }
	            else if (midValue.lte(rightValue)) {
	                // max must be between mid and right
	                left = mid;
	                leftValue = midValue;
	                mid = half.mul(mid.add(right));
	                midValue = fun(mid);
	            }
	            else {
	                // mid is larger than both left and right, max could be on either side
	                const leftmid = half.mul(left.add(mid));
	                const leftMidValue = fun(leftmid);
	                if (leftMidValue.gte(midValue)) {
	                    // max between left and mid
	                    right = mid;
	                    rightValue = midValue;
	                    mid = leftmid;
	                    midValue = leftMidValue;
	                    continue;
	                }
	                const rightmid = half.mul(mid.add(right));
	                const rightMidValue = fun(rightmid);
	                if (rightMidValue.gte(midValue)) {
	                    // max between mid and right
	                    left = mid;
	                    leftValue = midValue;
	                    mid = rightmid;
	                    midValue = rightMidValue;
	                    continue;
	                }
	                // max between leftmid and rightmid
	                left = leftmid;
	                leftValue = leftMidValue;
	                right = rightmid;
	                rightValue = rightMidValue;
	            }
	        }
	        if (leftValue.gte(midValue)) {
	            return [left, leftValue];
	        }
	        else if (midValue.gte(rightValue)) {
	            return [mid, midValue];
	        }
	        else {
	            return [right, rightValue];
	        }
	    }
	    static binaryApproximationSearch(left, leftValue, right, targetValue, minStep, fun) {
	        const maxIterations = 50;
	        const targetError = I80F48.fromNumber(0.1);
	        const rightValue = fun(right);
	        // console.log(
	        //   ` - binaryApproximationSearch left ${left.toLocaleString()}, leftValue ${leftValue.toLocaleString()}, right ${right.toLocaleString()}, rightValue ${rightValue.toLocaleString()}, targetValue ${targetValue.toLocaleString()}`,
	        // );
	        if ((leftValue.sub(targetValue).isPos() &&
	            rightValue.sub(targetValue).isPos()) ||
	            (leftValue.sub(targetValue).isNeg() &&
	                rightValue.sub(targetValue).isNeg())) {
	            throw new Error(`Internal error: left ${leftValue.toNumber()}  and right ${rightValue.toNumber()} don't contain the target value ${targetValue.toNumber()}!`);
	        }
	        let newAmount, newAmountValue;
	        // eslint-disable-next-line @typescript-eslint/no-unused-vars
	        for (const key of Array(maxIterations).fill(0).keys()) {
	            if (right.sub(left).abs().lt(minStep)) {
	                return left;
	            }
	            newAmount = left.add(right).mul(I80F48.fromNumber(0.5));
	            newAmountValue = fun(newAmount);
	            // console.log(
	            //   `   - left ${left.toLocaleString()}, right ${right.toLocaleString()}, newAmount ${newAmount.toLocaleString()}, newAmountValue ${newAmountValue.toLocaleString()}, targetValue ${targetValue.toLocaleString()}`,
	            // );
	            const error = newAmountValue.sub(targetValue);
	            if (error.isPos() && error.lt(targetError)) {
	                return newAmount;
	            }
	            if (newAmountValue.gt(targetValue) != rightValue.gt(targetValue)) {
	                left = newAmount;
	            }
	            else {
	                right = newAmount;
	            }
	        }
	        console.error(`Unable to get targetValue within ${maxIterations} iterations, newAmount ${newAmount}, newAmountValue ${newAmountValue}, target ${targetValue}`);
	        return newAmount;
	    }
	    getMaxSwapSource(sourceBank, targetBank, price) {
	        const health = this.health(HealthType.init);
	        if (health.isNeg()) {
	            return this.getMaxSwapSourceForHealth(sourceBank, targetBank, price, toNativeI80F48ForQuote(1));
	        }
	        return this.getMaxSwapSourceForHealthRatio(sourceBank, targetBank, price, I80F48.fromNumber(2));
	    }
	    getMaxSwapSourceForHealthRatio(sourceBank, targetBank, price, minRatio) {
	        return this.getMaxSwapSourceForHealthFn(sourceBank, targetBank, price, minRatio, function (hc) {
	            return hc.healthRatio(HealthType.init);
	        });
	    }
	    getMaxSwapSourceForHealth(sourceBank, targetBank, price, minHealth) {
	        return this.getMaxSwapSourceForHealthFn(sourceBank, targetBank, price, minHealth, function (hc) {
	            return hc.health(HealthType.init);
	        });
	    }
	    getMaxSwapSourceForHealthFn(sourceBank, targetBank, price, minFnValue, targetFn) {
	        if (sourceBank.initLiabWeight
	            .sub(targetBank.initAssetWeight)
	            .abs()
	            .lte(ZERO_I80F48())) {
	            return ZERO_I80F48();
	        }
	        // The health and health_ratio are nonlinear based on swap amount.
	        // For large swap amounts the slope is guaranteed to be negative, but small amounts
	        // can have positive slope (e.g. using source deposits to pay back target borrows).
	        //
	        // That means:
	        // - even if the initial value is < minRatio it can be useful to swap to *increase* health
	        // - even if initial value is < 0, swapping can increase health (maybe above 0)
	        // - be careful about finding the minFnValue: the function isn't convex
	        this.healthRatio(HealthType.init);
	        // eslint-disable-next-line @typescript-eslint/no-unused-vars
	        const healthCacheClone = lodashExports.cloneDeep(this);
	        const sourceIndex = healthCacheClone.getOrCreateTokenInfoIndex(sourceBank);
	        const targetIndex = healthCacheClone.getOrCreateTokenInfoIndex(targetBank);
	        const source = healthCacheClone.tokenInfos[sourceIndex];
	        const target = healthCacheClone.tokenInfos[targetIndex];
	        const res = healthCacheClone.computeSerum3Reservations(HealthType.init);
	        const sourceReserved = res.tokenMaxReserved[sourceIndex];
	        const targetReserved = res.tokenMaxReserved[targetIndex];
	        // If the price is sufficiently good, then health will just increase from swapping:
	        // once we've swapped enough, swapping x reduces health by x * source_liab_weight and
	        // increases it by x * target_asset_weight * price_factor.
	        const finalHealthSlope = source.initLiabWeight
	            .neg()
	            .mul(source.prices.liab(HealthType.init))
	            .add(target.initAssetWeight
	            .mul(target.prices.asset(HealthType.init))
	            .mul(price));
	        if (finalHealthSlope.gte(ZERO_I80F48())) {
	            return MAX_I80F48();
	        }
	        // There are two key slope changes: Assume source.balance > 0 and target.balance < 0. Then
	        // initially health ratio goes up. When one of balances flips sign, the health ratio slope
	        // may be positive or negative for a bit, until both balances have flipped and the slope is
	        // negative.
	        // The maximum will be at one of these points (ignoring serum3 effects).
	        function cacheAfterSwap(amount) {
	            const adjustedCache = lodashExports.cloneDeep(healthCacheClone);
	            // adjustedCache.logHealthCache('beforeSwap', adjustedCache);
	            // TODO: make a copy of the bank, apply amount, recompute weights,
	            // and set the new weights on the tokenInfos
	            adjustedCache.tokenInfos[sourceIndex].balanceNative.isub(amount);
	            adjustedCache.tokenInfos[targetIndex].balanceNative.iadd(amount.mul(price));
	            // adjustedCache.logHealthCache('afterSwap', adjustedCache);
	            return adjustedCache;
	        }
	        function fnValueAfterSwap(amount) {
	            return targetFn(cacheAfterSwap(amount));
	        }
	        // The function we're looking at has a unique maximum.
	        //
	        // If we discount serum3 reservations, there are two key slope changes:
	        // Assume source.balance > 0 and target.balance < 0.
	        // When these values flip sign, the health slope decreases, but could still be positive.
	        //
	        // The first thing we do is to find this maximum.
	        // The largest amount that the maximum could be at
	        const rightmost = source.balanceNative
	            .abs()
	            .add(sourceReserved)
	            .max(target.balanceNative.abs().add(targetReserved).div(price));
	        const [amountForMaxValue, maxValue] = HealthCache.findMaximum(ZERO_I80F48(), rightmost, I80F48.fromNumber(0.1), fnValueAfterSwap);
	        if (maxValue.lte(minFnValue)) {
	            // We cannot reach min_ratio, just return the max
	            return amountForMaxValue;
	        }
	        let amount;
	        // Now max_value is bigger than minFnValue, the target amount must be >amountForMaxValue.
	        // Search to the right of amountForMaxValue: but how far?
	        // Use a simple estimation for the amount that would lead to zero health:
	        //           health
	        //              - source_liab_weight * source_liab_price * a
	        //              + target_asset_weight * target_asset_price * price * a = 0.
	        // where a is the source token native amount.
	        // Note that this is just an estimate. Swapping can increase the amount that serum3
	        // reserved contributions offset, moving the actual zero point further to the right.
	        const healthAtMaxValue = cacheAfterSwap(amountForMaxValue).health(HealthType.init);
	        if (healthAtMaxValue.lte(ZERO_I80F48())) {
	            return ZERO_I80F48();
	        }
	        const zeroHealthEstimate = amountForMaxValue.sub(healthAtMaxValue.div(finalHealthSlope));
	        const rightBound = HealthCache.scanRightUntilLessThan(zeroHealthEstimate, minFnValue, fnValueAfterSwap);
	        if (rightBound.eq(zeroHealthEstimate)) {
	            amount = HealthCache.binaryApproximationSearch(amountForMaxValue, maxValue, rightBound, minFnValue, I80F48.fromNumber(0.1), fnValueAfterSwap);
	        }
	        else {
	            // Must be between 0 and point0_amount
	            amount = HealthCache.binaryApproximationSearch(zeroHealthEstimate, fnValueAfterSwap(zeroHealthEstimate), rightBound, minFnValue, I80F48.fromNumber(0.1), fnValueAfterSwap);
	        }
	        return amount;
	    }
	    getMaxSerum3OrderForHealthRatio(baseBank, quoteBank, serum3Market, side, minRatio) {
	        const healthCacheClone = lodashExports.cloneDeep(this);
	        const baseIndex = healthCacheClone.getOrCreateTokenInfoIndex(baseBank);
	        const quoteIndex = healthCacheClone.getOrCreateTokenInfoIndex(quoteBank);
	        const base = healthCacheClone.tokenInfos[baseIndex];
	        const quote = healthCacheClone.tokenInfos[quoteIndex];
	        // Binary search between current health (0 sized new order) and
	        // an amount to trade which will bring health to 0.
	        // Current health and amount i.e. 0
	        const initialAmount = ZERO_I80F48();
	        const initialHealth = this.health(HealthType.init);
	        const initialRatio = this.healthRatio(HealthType.init);
	        if (initialRatio.lte(ZERO_I80F48())) {
	            return ZERO_I80F48();
	        }
	        // console.log(`getMaxSerum3OrderForHealthRatio`);
	        // Amount which would bring health to 0
	        // where M = max(A_deposits, B_borrows)
	        // amount = M + (init_health + M * (B_init_liab - A_init_asset)) / (A_init_liab - B_init_asset);
	        // A is what we would be essentially swapping for B
	        // So when its an ask, then base->quote,
	        // and when its a bid, then quote->bid
	        let zeroAmount;
	        if (side == Serum3Side.ask) {
	            const quoteBorrows = quote.balanceNative.lt(ZERO_I80F48())
	                ? quote.balanceNative.abs().mul(quote.prices.liab(HealthType.init))
	                : ZERO_I80F48();
	            const max = base.balanceNative
	                .mul(base.prices.asset(HealthType.init))
	                .max(quoteBorrows);
	            zeroAmount = max.add(initialHealth
	                .add(max.mul(quote.initLiabWeight.sub(base.initAssetWeight)))
	                .div(base
	                .liabWeight(HealthType.init)
	                .sub(quote.assetWeight(HealthType.init))));
	            // console.log(` - quoteBorrows ${quoteBorrows.toLocaleString()}`);
	            // console.log(` - max ${max.toLocaleString()}`);
	        }
	        else {
	            const baseBorrows = base.balanceNative.lt(ZERO_I80F48())
	                ? base.balanceNative.abs().mul(base.prices.liab(HealthType.init))
	                : ZERO_I80F48();
	            const max = quote.balanceNative
	                .mul(quote.prices.asset(HealthType.init))
	                .max(baseBorrows);
	            zeroAmount = max.add(initialHealth
	                .add(max.mul(base.initLiabWeight.sub(quote.initAssetWeight)))
	                .div(quote
	                .liabWeight(HealthType.init)
	                .sub(base.assetWeight(HealthType.init))));
	            // console.log(` - baseBorrows ${baseBorrows.toLocaleString()}`);
	            // console.log(` - max ${max.toLocaleString()}`);
	        }
	        const cache = cacheAfterPlacingOrder(zeroAmount);
	        // eslint-disable-next-line @typescript-eslint/no-unused-vars
	        cache.health(HealthType.init);
	        cache.healthRatio(HealthType.init);
	        // console.log(` - zeroAmount ${zeroAmount.toLocaleString()}`);
	        // console.log(` - zeroAmountHealth ${zeroAmountHealth.toLocaleString()}`);
	        // console.log(` - zeroAmountRatio ${zeroAmountRatio.toLocaleString()}`);
	        function cacheAfterPlacingOrder(amount) {
	            const adjustedCache = lodashExports.cloneDeep(healthCacheClone);
	            // adjustedCache.logHealthCache(` before placing order ${amount}`);
	            // TODO: there should also be some issue with oracle vs stable price here;
	            // probably better to pass in not the quote amount but the base or quote native amount
	            side === Serum3Side.ask
	                ? adjustedCache.tokenInfos[baseIndex].balanceNative.isub(amount.div(base.prices.oracle))
	                : adjustedCache.tokenInfos[quoteIndex].balanceNative.isub(amount.div(quote.prices.oracle));
	            adjustedCache.adjustSerum3Reserved(baseBank, quoteBank, serum3Market, side === Serum3Side.ask
	                ? amount.div(base.prices.oracle)
	                : ZERO_I80F48(), ZERO_I80F48(), side === Serum3Side.bid
	                ? amount.div(quote.prices.oracle)
	                : ZERO_I80F48(), ZERO_I80F48());
	            // adjustedCache.logHealthCache(' after placing order');
	            return adjustedCache;
	        }
	        function healthRatioAfterPlacingOrder(amount) {
	            return cacheAfterPlacingOrder(amount).healthRatio(HealthType.init);
	        }
	        const amount = HealthCache.binaryApproximationSearch(initialAmount, initialRatio, zeroAmount, minRatio, ONE_I80F48(), healthRatioAfterPlacingOrder);
	        return amount;
	    }
	    getMaxPerpForHealthRatio(perpMarket, price, side, minRatio) {
	        const healthCacheClone = lodashExports.cloneDeep(this);
	        const initialRatio = this.healthRatio(HealthType.init);
	        if (initialRatio.lt(ZERO_I80F48())) {
	            return ZERO_I80F48();
	        }
	        const direction = side == PerpOrderSide.bid ? 1 : -1;
	        const perpInfoIndex = healthCacheClone.getOrCreatePerpInfoIndex(perpMarket);
	        const perpInfo = healthCacheClone.perpInfos[perpInfoIndex];
	        const prices = perpInfo.prices;
	        const baseLotSize = I80F48.fromI64(perpMarket.baseLotSize);
	        // If the price is sufficiently good then health will just increase from trading
	        const finalHealthSlope = direction == 1
	            ? perpInfo.initBaseAssetWeight
	                .mul(prices.asset(HealthType.init))
	                .sub(price)
	            : price.sub(perpInfo.initBaseLiabWeight.mul(prices.liab(HealthType.init)));
	        if (finalHealthSlope.gte(ZERO_I80F48())) {
	            return MAX_I80F48();
	        }
	        function cacheAfterTrade(baseLots) {
	            const adjustedCache = lodashExports.cloneDeep(healthCacheClone);
	            // adjustedCache.logHealthCache(' -- before trade');
	            adjustedCache.adjustPerpInfo(perpInfoIndex, price, side, baseLots);
	            // adjustedCache.logHealthCache(' -- after trade');
	            return adjustedCache;
	        }
	        function healthRatioAfterTrade(baseLots) {
	            return cacheAfterTrade(new anchor.BN(baseLots.toNumber())).healthRatio(HealthType.init);
	        }
	        function healthRatioAfterTradeTrunc(baseLots) {
	            return healthRatioAfterTrade(baseLots.floor());
	        }
	        const initialBaseLots = I80F48.fromU64(perpInfo.baseLots);
	        // There are two cases:
	        // 1. We are increasing abs(baseLots)
	        // 2. We are bringing the base position to 0, and then going to case 1.
	        const hasCase2 = (initialBaseLots.gt(ZERO_I80F48()) && direction == -1) ||
	            (initialBaseLots.lt(ZERO_I80F48()) && direction == 1);
	        let case1Start, case1StartRatio;
	        if (hasCase2) {
	            case1Start = initialBaseLots.abs();
	            case1StartRatio = healthRatioAfterTrade(case1Start);
	        }
	        else {
	            case1Start = ZERO_I80F48();
	            case1StartRatio = initialRatio;
	        }
	        // If we start out below minRatio and can't go above, pick the best case
	        let baseLots;
	        if (initialRatio.lte(minRatio) && case1StartRatio.lt(minRatio)) {
	            if (case1StartRatio.gte(initialRatio)) {
	                baseLots = case1Start;
	            }
	            else {
	                baseLots = ZERO_I80F48();
	            }
	        }
	        else if (case1StartRatio.gte(minRatio)) {
	            // Must reach minRatio to the right of case1Start
	            // Need to figure out how many lots to trade to reach zero health (zero_health_amount).
	            // We do this by looking at the starting health and the health slope per
	            // traded base lot (finalHealthSlope).
	            const startCache = cacheAfterTrade(new anchor.BN(case1Start.toNumber()));
	            const startHealth = startCache.health(HealthType.init);
	            if (startHealth.lte(ZERO_I80F48())) {
	                return ZERO_I80F48();
	            }
	            // The perp market's contribution to the health above may be capped. But we need to trade
	            // enough to fully reduce any positive-pnl buffer. Thus get the uncapped health:
	            const perpInfo = startCache.perpInfos[perpInfoIndex];
	            const startHealthUncapped = startHealth
	                .sub(perpInfo.healthContribution(HealthType.init))
	                .add(perpInfo.unweightedHealthContribution(HealthType.init));
	            const zeroHealthAmount = case1Start
	                .sub(startHealthUncapped.div(finalHealthSlope).div(baseLotSize))
	                .add(ONE_I80F48());
	            healthRatioAfterTradeTrunc(zeroHealthAmount);
	            baseLots = HealthCache.binaryApproximationSearch(case1Start, case1StartRatio, zeroHealthAmount, minRatio, ONE_I80F48(), healthRatioAfterTradeTrunc);
	        }
	        else {
	            // Between 0 and case1Start
	            baseLots = HealthCache.binaryApproximationSearch(ZERO_I80F48(), initialRatio, case1Start, minRatio, ONE_I80F48(), healthRatioAfterTradeTrunc);
	        }
	        return baseLots.floor();
	    }
	}
	class Prices {
	    oracle;
	    stable;
	    constructor(oracle, stable) {
	        this.oracle = oracle;
	        this.stable = stable;
	    }
	    liab(healthType) {
	        if (healthType === HealthType.maint ||
	            healthType === HealthType.liquidationEnd ||
	            healthType === undefined) {
	            return this.oracle;
	        }
	        return this.oracle.max(this.stable);
	    }
	    asset(healthType) {
	        if (healthType === HealthType.maint ||
	            healthType === HealthType.liquidationEnd ||
	            healthType === undefined) {
	            return this.oracle;
	        }
	        return this.oracle.min(this.stable);
	    }
	}
	class TokenInfo {
	    tokenIndex;
	    maintAssetWeight;
	    initAssetWeight;
	    initScaledAssetWeight;
	    maintLiabWeight;
	    initLiabWeight;
	    initScaledLiabWeight;
	    prices;
	    balanceNative;
	    constructor(tokenIndex, maintAssetWeight, initAssetWeight, initScaledAssetWeight, maintLiabWeight, initLiabWeight, initScaledLiabWeight, prices, balanceNative) {
	        this.tokenIndex = tokenIndex;
	        this.maintAssetWeight = maintAssetWeight;
	        this.initAssetWeight = initAssetWeight;
	        this.initScaledAssetWeight = initScaledAssetWeight;
	        this.maintLiabWeight = maintLiabWeight;
	        this.initLiabWeight = initLiabWeight;
	        this.initScaledLiabWeight = initScaledLiabWeight;
	        this.prices = prices;
	        this.balanceNative = balanceNative;
	    }
	    static fromDto(dto) {
	        return new TokenInfo(dto.tokenIndex, I80F48.from(dto.maintAssetWeight), I80F48.from(dto.initAssetWeight), I80F48.from(dto.initScaledAssetWeight), I80F48.from(dto.maintLiabWeight), I80F48.from(dto.initLiabWeight), I80F48.from(dto.initScaledLiabWeight), new Prices(I80F48.from(dto.prices.oracle), I80F48.from(dto.prices.stable)), I80F48.from(dto.balanceNative));
	    }
	    static fromBank(bank, nativeBalance) {
	        const p = new Prices(bank.price, I80F48.fromNumber(bank.stablePriceModel.stablePrice));
	        // Use the liab price for computing weight scaling, because it's pessimistic and
	        // causes the most unfavorable scaling.
	        const liabPrice = p.liab(HealthType.init);
	        return new TokenInfo(bank.tokenIndex, bank.maintAssetWeight, bank.initAssetWeight, bank.scaledInitAssetWeight(liabPrice), bank.maintLiabWeight, bank.initLiabWeight, bank.scaledInitLiabWeight(liabPrice), p, nativeBalance ? nativeBalance : ZERO_I80F48());
	    }
	    assetWeight(healthType) {
	        if (healthType == HealthType.init) {
	            return this.initScaledAssetWeight;
	        }
	        else if (healthType == HealthType.liquidationEnd) {
	            return this.initAssetWeight;
	        }
	        // healthType == HealthType.maint
	        return this.maintAssetWeight;
	    }
	    liabWeight(healthType) {
	        if (healthType == HealthType.init) {
	            return this.initScaledLiabWeight;
	        }
	        else if (healthType == HealthType.liquidationEnd) {
	            return this.initLiabWeight;
	        }
	        // healthType == HealthType.maint
	        return this.maintLiabWeight;
	    }
	    healthContribution(healthType) {
	        let weight, price;
	        if (healthType === undefined) {
	            return this.balanceNative.mul(this.prices.oracle);
	        }
	        if (this.balanceNative.isNeg()) {
	            weight = this.liabWeight(healthType);
	            price = this.prices.liab(healthType);
	        }
	        else {
	            weight = this.assetWeight(healthType);
	            price = this.prices.asset(healthType);
	        }
	        return this.balanceNative.mul(weight).mul(price);
	    }
	    toString() {
	        return `  tokenIndex: ${this.tokenIndex}, balanceNative: ${this.balanceNative}, initHealth ${this.healthContribution(HealthType.init)}`;
	    }
	}
	class Serum3Reserved {
	    allReservedAsBase;
	    allReservedAsQuote;
	    constructor(allReservedAsBase, allReservedAsQuote) {
	        this.allReservedAsBase = allReservedAsBase;
	        this.allReservedAsQuote = allReservedAsQuote;
	    }
	}
	class Serum3Info {
	    reservedBase;
	    reservedQuote;
	    baseIndex;
	    quoteIndex;
	    marketIndex;
	    constructor(reservedBase, reservedQuote, baseIndex, quoteIndex, marketIndex) {
	        this.reservedBase = reservedBase;
	        this.reservedQuote = reservedQuote;
	        this.baseIndex = baseIndex;
	        this.quoteIndex = quoteIndex;
	        this.marketIndex = marketIndex;
	    }
	    static fromDto(dto) {
	        return new Serum3Info(I80F48.from(dto.reservedBase), I80F48.from(dto.reservedQuote), dto.baseIndex, dto.quoteIndex, dto.marketIndex);
	    }
	    static emptyFromSerum3Market(serum3Market, baseEntryIndex, quoteEntryIndex) {
	        return new Serum3Info(ZERO_I80F48(), ZERO_I80F48(), baseEntryIndex, quoteEntryIndex, serum3Market.marketIndex);
	    }
	    static fromOoModifyingTokenInfos(baseIndex, baseInfo, quoteIndex, quoteInfo, marketIndex, oo) {
	        // add the amounts that are freely settleable immediately to token balances
	        const baseFree = I80F48.fromI64(oo.baseTokenFree);
	        // NOTE: referrerRebatesAccrued is not declared on oo class, but the layout
	        // is aware of it
	        const quoteFree = I80F48.fromI64(oo.quoteTokenFree.add(oo.referrerRebatesAccrued));
	        baseInfo.balanceNative.iadd(baseFree);
	        quoteInfo.balanceNative.iadd(quoteFree);
	        // track the reserved amounts
	        const reservedBase = I80F48.fromI64(oo.baseTokenTotal.sub(oo.baseTokenFree));
	        const reservedQuote = I80F48.fromI64(oo.quoteTokenTotal.sub(oo.quoteTokenFree));
	        return new Serum3Info(reservedBase, reservedQuote, baseIndex, quoteIndex, marketIndex);
	    }
	    // An undefined HealthType will use an asset and liab weight of 1
	    healthContribution(healthType, tokenInfos, tokenMaxReserved, marketReserved) {
	        if (marketReserved.allReservedAsBase.isZero() ||
	            marketReserved.allReservedAsQuote.isZero()) {
	            return ZERO_I80F48();
	        }
	        const baseInfo = tokenInfos[this.baseIndex];
	        const quoteInfo = tokenInfos[this.quoteIndex];
	        const baseMaxReserved = tokenMaxReserved[this.baseIndex];
	        const quoteMaxReserved = tokenMaxReserved[this.quoteIndex];
	        // How much the health would increase if the reserved balance were applied to the passed
	        // token info?
	        const computeHealthEffect = function (tokenInfo, tokenMaxReserved, marketReserved) {
	            // This balance includes all possible reserved funds from markets that relate to the
	            // token, including this market itself: `tokenMaxReserved` is already included in `maxBalance`.
	            const maxBalance = tokenInfo.balanceNative.add(tokenMaxReserved);
	            // Assuming `reserved` was added to `max_balance` last (because that gives the smallest
	            // health effects): how much did health change because of it?
	            let assetPart, liabPart;
	            if (maxBalance.gte(marketReserved)) {
	                assetPart = marketReserved;
	                liabPart = ZERO_I80F48();
	            }
	            else if (maxBalance.isNeg()) {
	                assetPart = ZERO_I80F48();
	                liabPart = marketReserved;
	            }
	            else {
	                assetPart = maxBalance;
	                liabPart = marketReserved.sub(maxBalance);
	            }
	            if (healthType === undefined) {
	                return assetPart
	                    .mul(tokenInfo.prices.oracle)
	                    .add(liabPart.mul(tokenInfo.prices.oracle));
	            }
	            const assetWeight = tokenInfo.assetWeight(healthType);
	            const liabWeight = tokenInfo.liabWeight(healthType);
	            const assetPrice = tokenInfo.prices.asset(healthType);
	            const liabPrice = tokenInfo.prices.liab(healthType);
	            return assetWeight
	                .mul(assetPart)
	                .mul(assetPrice)
	                .add(liabWeight.mul(liabPart).mul(liabPrice));
	        };
	        const healthBase = computeHealthEffect(baseInfo, baseMaxReserved, marketReserved.allReservedAsBase);
	        const healthQuote = computeHealthEffect(quoteInfo, quoteMaxReserved, marketReserved.allReservedAsQuote);
	        // console.log(` - healthBase ${healthBase.toLocaleString()}`);
	        // console.log(` - healthQuote ${healthQuote.toLocaleString()}`);
	        return healthBase.min(healthQuote);
	    }
	    toString(tokenInfos, tokenMaxReserved, marketReserved) {
	        return `  marketIndex: ${this.marketIndex}, baseIndex: ${this.baseIndex}, quoteIndex: ${this.quoteIndex}, reservedBase: ${this.reservedBase}, reservedQuote: ${this.reservedQuote}, initHealth ${this.healthContribution(HealthType.init, tokenInfos, tokenMaxReserved, marketReserved)}`;
	    }
	}
	class PerpInfo {
	    perpMarketIndex;
	    maintBaseAssetWeight;
	    initBaseAssetWeight;
	    maintBaseLiabWeight;
	    initBaseLiabWeight;
	    maintOverallAssetWeight;
	    initOverallAssetWeight;
	    baseLotSize;
	    baseLots;
	    bidsBaseLots;
	    asksBaseLots;
	    quote;
	    prices;
	    hasOpenOrders;
	    constructor(perpMarketIndex, maintBaseAssetWeight, initBaseAssetWeight, maintBaseLiabWeight, initBaseLiabWeight, maintOverallAssetWeight, initOverallAssetWeight, baseLotSize, baseLots, bidsBaseLots, asksBaseLots, quote, prices, hasOpenOrders) {
	        this.perpMarketIndex = perpMarketIndex;
	        this.maintBaseAssetWeight = maintBaseAssetWeight;
	        this.initBaseAssetWeight = initBaseAssetWeight;
	        this.maintBaseLiabWeight = maintBaseLiabWeight;
	        this.initBaseLiabWeight = initBaseLiabWeight;
	        this.maintOverallAssetWeight = maintOverallAssetWeight;
	        this.initOverallAssetWeight = initOverallAssetWeight;
	        this.baseLotSize = baseLotSize;
	        this.baseLots = baseLots;
	        this.bidsBaseLots = bidsBaseLots;
	        this.asksBaseLots = asksBaseLots;
	        this.quote = quote;
	        this.prices = prices;
	        this.hasOpenOrders = hasOpenOrders;
	    }
	    static fromDto(dto) {
	        return new PerpInfo(dto.perpMarketIndex, I80F48.from(dto.maintBaseAssetWeight), I80F48.from(dto.initBaseAssetWeight), I80F48.from(dto.maintBaseLiabWeight), I80F48.from(dto.initBaseLiabWeight), I80F48.from(dto.maintOverallAssetWeight), I80F48.from(dto.initOverallAssetWeight), dto.baseLotSize, dto.baseLots, dto.bidsBaseLots, dto.asksBaseLots, I80F48.from(dto.quote), new Prices(I80F48.from(dto.prices.oracle), I80F48.from(dto.prices.stable)), dto.hasOpenOrders);
	    }
	    static fromPerpPosition(perpMarket, perpPosition) {
	        const baseLots = perpPosition.basePositionLots.add(perpPosition.takerBaseLots);
	        const unsettledFunding = perpPosition.getUnsettledFunding(perpMarket);
	        const takerQuote = I80F48.fromI64(new anchor.BN(perpPosition.takerQuoteLots).mul(perpMarket.quoteLotSize));
	        const quoteCurrent = perpPosition.quotePositionNative
	            .sub(unsettledFunding)
	            .add(takerQuote);
	        return new PerpInfo(perpMarket.perpMarketIndex, perpMarket.maintBaseAssetWeight, perpMarket.initBaseAssetWeight, perpMarket.maintBaseLiabWeight, perpMarket.initBaseLiabWeight, perpMarket.maintOverallAssetWeight, perpMarket.initOverallAssetWeight, perpMarket.baseLotSize, baseLots, perpPosition.bidsBaseLots, perpPosition.asksBaseLots, quoteCurrent, new Prices(perpMarket.price, I80F48.fromNumber(perpMarket.stablePriceModel.stablePrice)), perpPosition.hasOpenOrders());
	    }
	    healthContribution(healthType) {
	        const contrib = this.unweightedHealthContribution(healthType);
	        if (contrib.gt(ZERO_I80F48())) {
	            const assetWeight = healthType == HealthType.init || healthType == HealthType.liquidationEnd
	                ? this.initOverallAssetWeight
	                : this.maintOverallAssetWeight;
	            return assetWeight.mul(contrib);
	        }
	        return contrib;
	    }
	    unweightedHealthContribution(healthType) {
	        function orderExecutionCase(pi, ordersBaseLots, orderPrice) {
	            const netBaseNative = I80F48.fromU64(pi.baseLots.add(ordersBaseLots).mul(pi.baseLotSize));
	            let weight, basePrice;
	            if (healthType == HealthType.init ||
	                healthType == HealthType.liquidationEnd) {
	                if (netBaseNative.isNeg()) {
	                    weight = pi.initBaseLiabWeight;
	                }
	                else {
	                    weight = pi.initBaseAssetWeight;
	                }
	            }
	            // healthType == HealthType.maint
	            else {
	                if (netBaseNative.isNeg()) {
	                    weight = pi.maintBaseLiabWeight;
	                }
	                else {
	                    weight = pi.maintBaseAssetWeight;
	                }
	            }
	            if (netBaseNative.isNeg()) {
	                basePrice = pi.prices.liab(healthType);
	            }
	            else {
	                basePrice = pi.prices.asset(healthType);
	            }
	            // Total value of the order-execution adjusted base position
	            const baseHealth = netBaseNative.mul(weight).mul(basePrice);
	            const ordersBaseNative = I80F48.fromU64(ordersBaseLots.mul(pi.baseLotSize));
	            // The quote change from executing the bids/asks
	            const orderQuote = ordersBaseNative.neg().mul(orderPrice);
	            return baseHealth.add(orderQuote);
	        }
	        // What is worse: Executing all bids at oracle_price.liab, or executing all asks at oracle_price.asset?
	        const bidsCase = orderExecutionCase(this, this.bidsBaseLots, this.prices.liab(healthType));
	        const asksCase = orderExecutionCase(this, this.asksBaseLots.neg(), this.prices.asset(healthType));
	        const worstCase = bidsCase.min(asksCase);
	        return this.quote.add(worstCase);
	    }
	    static emptyFromPerpMarket(perpMarket) {
	        return new PerpInfo(perpMarket.perpMarketIndex, perpMarket.maintBaseAssetWeight, perpMarket.initBaseAssetWeight, perpMarket.maintBaseLiabWeight, perpMarket.initBaseLiabWeight, perpMarket.maintOverallAssetWeight, perpMarket.initOverallAssetWeight, perpMarket.baseLotSize, new anchor.BN(0), new anchor.BN(0), new anchor.BN(0), ZERO_I80F48(), new Prices(perpMarket.price, I80F48.fromNumber(perpMarket.stablePriceModel.stablePrice)), false);
	    }
	    toString() {
	        return `  perpMarketIndex: ${this.perpMarketIndex}, base: ${this.baseLots}, quote: ${this.quote}, oraclePrice: ${this.prices.oracle}, uncapped health contribution ${this.unweightedHealthContribution(HealthType.init)}`;
	    }
	}

	class MangoAccount {
	    publicKey;
	    group;
	    owner;
	    delegate;
	    accountNum;
	    beingLiquidated;
	    inHealthRegion;
	    netDeposits;
	    perpSpotTransfers;
	    healthRegionBeginInitHealth;
	    frozenUntil;
	    headerVersion;
	    serum3OosMapByMarketIndex;
	    name;
	    tokens;
	    serum3;
	    perps;
	    perpOpenOrders;
	    static from(publicKey, obj) {
	        return new MangoAccount(publicKey, obj.group, obj.owner, obj.name, obj.delegate, obj.accountNum, obj.beingLiquidated == 1, obj.inHealthRegion == 1, obj.netDeposits, obj.perpSpotTransfers, obj.healthRegionBeginInitHealth, obj.frozenUntil, obj.headerVersion, obj.tokens, obj.serum3, obj.perps, obj.perpOpenOrders, new Map());
	    }
	    constructor(publicKey, group, owner, name, delegate, accountNum, beingLiquidated, inHealthRegion, netDeposits, perpSpotTransfers, healthRegionBeginInitHealth, frozenUntil, headerVersion, tokens, serum3, perps, perpOpenOrders, serum3OosMapByMarketIndex) {
	        this.publicKey = publicKey;
	        this.group = group;
	        this.owner = owner;
	        this.delegate = delegate;
	        this.accountNum = accountNum;
	        this.beingLiquidated = beingLiquidated;
	        this.inHealthRegion = inHealthRegion;
	        this.netDeposits = netDeposits;
	        this.perpSpotTransfers = perpSpotTransfers;
	        this.healthRegionBeginInitHealth = healthRegionBeginInitHealth;
	        this.frozenUntil = frozenUntil;
	        this.headerVersion = headerVersion;
	        this.serum3OosMapByMarketIndex = serum3OosMapByMarketIndex;
	        this.name = utf8.decode(new Uint8Array(name)).split('\x00')[0];
	        this.tokens = tokens.map((dto) => TokenPosition.from(dto));
	        this.serum3 = serum3.map((dto) => Serum3Orders.from(dto));
	        this.perps = perps.map((dto) => PerpPosition.from(dto));
	        this.perpOpenOrders = perpOpenOrders.map((dto) => PerpOo.from(dto));
	    }
	    async reload(client) {
	        const mangoAccount = await client.getMangoAccount(this);
	        await mangoAccount.reloadSerum3OpenOrders(client);
	        Object.assign(this, mangoAccount);
	        return mangoAccount;
	    }
	    async reloadWithSlot(client) {
	        const resp = await client.getMangoAccountWithSlot(this.publicKey);
	        await resp?.value.reloadSerum3OpenOrders(client);
	        Object.assign(this, resp?.value);
	        return { value: resp.value, slot: resp.slot };
	    }
	    async reloadSerum3OpenOrders(client) {
	        const serum3Active = this.serum3Active();
	        const ais = await client.program.provider.connection.getMultipleAccountsInfo(serum3Active.map((serum3) => serum3.openOrders));
	        this.serum3OosMapByMarketIndex = new Map(Array.from(ais.map((ai, i) => {
	            if (!ai) {
	                throw new Error(`Undefined AI for open orders ${serum3Active[i].openOrders} and market ${serum3Active[i].marketIndex}!`);
	            }
	            const oo = market.OpenOrders.fromAccountInfo(serum3Active[i].openOrders, ai, OPENBOOK_PROGRAM_ID[client.cluster]);
	            return [serum3Active[i].marketIndex, oo];
	        })));
	        return this;
	    }
	    isDelegate(client) {
	        return this.delegate.equals(client.program.provider.wallet.publicKey);
	    }
	    isOperational() {
	        return this.frozenUntil.lt(new anchor.BN(Date.now() / 1000));
	    }
	    tokensActive() {
	        return this.tokens.filter((token) => token.isActive());
	    }
	    serum3Active() {
	        return this.serum3.filter((serum3) => serum3.isActive());
	    }
	    perpPositionExistsForMarket(perpMarket) {
	        return this.perps.some((pp) => pp.isActive() && pp.marketIndex == perpMarket.perpMarketIndex);
	    }
	    perpOrderExistsForMarket(perpMarket) {
	        return this.perpOpenOrders.some((poo) => poo.isActive() && poo.orderMarket == perpMarket.perpMarketIndex);
	    }
	    perpActive() {
	        return this.perps.filter((perp) => perp.isActive());
	    }
	    perpOrdersActive() {
	        return this.perpOpenOrders.filter((oo) => oo.orderMarket !== PerpOo.OrderMarketUnset);
	    }
	    getToken(tokenIndex) {
	        return this.tokens.find((ta) => ta.tokenIndex == tokenIndex);
	    }
	    getSerum3Account(marketIndex) {
	        return this.serum3.find((sa) => sa.marketIndex == marketIndex);
	    }
	    getPerpPosition(perpMarketIndex) {
	        return this.perps.find((pp) => pp.marketIndex == perpMarketIndex);
	    }
	    getPerpPositionUi(group, perpMarketIndex, useEventQueue) {
	        const pp = this.perps.find((pp) => pp.marketIndex == perpMarketIndex);
	        if (!pp) {
	            throw new Error(`No position found for PerpMarket ${perpMarketIndex}!`);
	        }
	        const perpMarket = group.getPerpMarketByMarketIndex(perpMarketIndex);
	        return pp.getBasePositionUi(perpMarket, useEventQueue);
	    }
	    getSerum3OoAccount(marketIndex) {
	        const oo = this.serum3OosMapByMarketIndex.get(marketIndex);
	        if (!oo) {
	            throw new Error(`Open orders account not loaded for market with marketIndex ${marketIndex}!`);
	        }
	        return oo;
	    }
	    // How to navigate
	    // * if a function is returning a I80F48, then usually the return value is in native quote or native token, unless specified
	    // * if a function is returning a number, then usually the return value is in ui tokens, unless specified
	    // * functions try to be explicit by having native or ui in the name to better reflect the value
	    // * some values might appear unexpected large or small, usually the doc contains a "note"
	    /**
	     *
	     * @param bank
	     * @returns native balance for a token, is signed
	     */
	    getTokenBalance(bank) {
	        const tp = this.getToken(bank.tokenIndex);
	        return tp ? tp.balance(bank) : ZERO_I80F48();
	    }
	    /**
	     *
	     * @param bank
	     * @returns native deposits for a token, 0 if position has borrows
	     */
	    getTokenDeposits(bank) {
	        const tp = this.getToken(bank.tokenIndex);
	        return tp ? tp.deposits(bank) : ZERO_I80F48();
	    }
	    /**
	     *
	     * @param bank
	     * @returns native borrows for a token, 0 if position has deposits
	     */
	    getTokenBorrows(bank) {
	        const tp = this.getToken(bank.tokenIndex);
	        return tp ? tp.borrows(bank) : ZERO_I80F48();
	    }
	    /**
	     *
	     * @param bank
	     * @returns UI balance for a token, is signed
	     */
	    getTokenBalanceUi(bank) {
	        const tp = this.getToken(bank.tokenIndex);
	        return tp ? tp.balanceUi(bank) : 0;
	    }
	    /**
	     *
	     * @param bank
	     * @returns UI deposits for a token, 0 or more
	     */
	    getTokenDepositsUi(bank) {
	        const ta = this.getToken(bank.tokenIndex);
	        return ta ? ta.depositsUi(bank) : 0;
	    }
	    /**
	     *
	     * @param bank
	     * @returns UI borrows for a token, 0 or less
	     */
	    getTokenBorrowsUi(bank) {
	        const ta = this.getToken(bank.tokenIndex);
	        return ta ? ta.borrowsUi(bank) : 0;
	    }
	    /**
	     * Health, see health.rs or https://docs.mango.markets/mango-markets/health-overview
	     * @param healthType
	     * @returns raw health number, in native quote
	     */
	    getHealth(group, healthType) {
	        const hc = HealthCache.fromMangoAccount(group, this);
	        return hc.health(healthType);
	    }
	    getPerpSettleHealth(group) {
	        const hc = HealthCache.fromMangoAccount(group, this);
	        return hc.perpSettleHealth();
	    }
	    /**
	     * Health ratio, which is computed so `100 * (assets-liabs)/liabs`
	     * Note: health ratio is technically ∞ if liabs are 0
	     * @param healthType
	     * @returns health ratio, in percentage form
	     */
	    getHealthRatio(group, healthType) {
	        const hc = HealthCache.fromMangoAccount(group, this);
	        return hc.healthRatio(healthType);
	    }
	    /**
	     * Health ratio
	     * @param healthType
	     * @returns health ratio, in percentage form, capped to 100
	     */
	    getHealthRatioUi(group, healthType) {
	        const ratio = this.getHealthRatio(group, healthType).toNumber();
	        return ratio > 100 ? 100 : Math.trunc(ratio);
	    }
	    /**
	     * Sum of all the assets i.e. token deposits, borrows, total assets in spot open orders, and perps positions.
	     * @returns equity, in native quote
	     */
	    getEquity(group) {
	        const tokensMap = new Map();
	        for (const tp of this.tokensActive()) {
	            const bank = group.getFirstBankByTokenIndex(tp.tokenIndex);
	            tokensMap.set(tp.tokenIndex, tp.balance(bank).mul(bank.price));
	        }
	        for (const sp of this.serum3Active()) {
	            const oo = this.getSerum3OoAccount(sp.marketIndex);
	            const baseBank = group.getFirstBankByTokenIndex(sp.baseTokenIndex);
	            tokensMap
	                .get(baseBank.tokenIndex)
	                .iadd(I80F48.fromI64(oo.baseTokenTotal).mul(baseBank.price));
	            const quoteBank = group.getFirstBankByTokenIndex(sp.quoteTokenIndex);
	            // NOTE: referrerRebatesAccrued is not declared on oo class, but the layout
	            // is aware of it
	            tokensMap
	                .get(baseBank.tokenIndex)
	                .iadd(I80F48.fromI64(oo.quoteTokenTotal.add(oo.referrerRebatesAccrued)).mul(quoteBank.price));
	        }
	        const tokenEquity = Array.from(tokensMap.values()).reduce((a, b) => a.add(b), ZERO_I80F48());
	        const perpEquity = this.perpActive().reduce((a, b) => a.add(b.getEquity(group.getPerpMarketByMarketIndex(b.marketIndex))), ZERO_I80F48());
	        return tokenEquity.add(perpEquity);
	    }
	    /**
	     * The amount of native quote you could withdraw against your existing assets.
	     * @returns collateral value, in native quote
	     */
	    getCollateralValue(group) {
	        return this.getHealth(group, HealthType.init);
	    }
	    /**
	     * Sum of all positive assets.
	     * @returns assets, in native quote
	     */
	    getAssetsValue(group, healthType) {
	        const hc = HealthCache.fromMangoAccount(group, this);
	        return hc.assets(healthType);
	    }
	    /**
	     * Sum of all negative assets.
	     * @returns liabs, in native quote
	     */
	    getLiabsValue(group, healthType) {
	        const hc = HealthCache.fromMangoAccount(group, this);
	        return hc.liabs(healthType);
	    }
	    /**
	     * @returns Overall PNL, in native quote
	     * PNL is defined here as spot value + serum3 open orders value + perp value - net deposits value (evaluated at native quote price at the time of the deposit/withdraw)
	     * spot value + serum3 open orders value + perp value is returned by getEquity (open orders values are added to spot token values implicitly)
	     */
	    getPnl(group) {
	        return this.getEquity(group)?.add(I80F48.fromI64(this.netDeposits).mul(I80F48.fromNumber(-1)));
	    }
	    /**
	     * @returns token cumulative interest, in native token units. Sum of deposit and borrow interest.
	     * Caveat: This will only return cumulative interest since the tokenPosition was last opened.
	     * If the tokenPosition was closed and reopened multiple times it is necessary to add this result to
	     * cumulative interest at each of the prior tokenPosition closings (from mango API) to get the all time
	     * cumulative interest.
	     */
	    getCumulativeInterest(bank) {
	        const token = this.getToken(bank.tokenIndex);
	        if (token === undefined) {
	            // tokenPosition does not exist on mangoAccount so no cumulative interest
	            return 0;
	        }
	        else {
	            if (token.indexedPosition.isPos()) {
	                const interest = bank.depositIndex
	                    .sub(token.previousIndex)
	                    .mul(token.indexedPosition)
	                    .toNumber();
	                return (interest +
	                    token.cumulativeDepositInterest +
	                    token.cumulativeBorrowInterest);
	            }
	            else {
	                const interest = bank.borrowIndex
	                    .sub(token.previousIndex)
	                    .mul(token.indexedPosition)
	                    .toNumber();
	                return (interest +
	                    token.cumulativeDepositInterest +
	                    token.cumulativeBorrowInterest);
	            }
	        }
	    }
	    /**
	     * The amount of given native token you can withdraw including borrows, considering all existing assets as collateral.
	     * @returns amount of given native token you can borrow, considering all existing assets as collateral, in native token
	     *
	     * TODO: take into account net_borrow_limit and min_vault_to_deposits_ratio
	     */
	    getMaxWithdrawWithBorrowForToken(group, mintPk) {
	        const tokenBank = group.getFirstBankByMint(mintPk);
	        const initHealth = this.getHealth(group, HealthType.init);
	        // Case 1:
	        // Cannot withdraw if init health is below 0
	        if (initHealth.lte(ZERO_I80F48())) {
	            return ZERO_I80F48();
	        }
	        // Deposits need special treatment since they would neither count towards liabilities
	        // nor would be charged loanOriginationFeeRate when withdrawn
	        const tp = this.getToken(tokenBank.tokenIndex);
	        const existingTokenDeposits = tp ? tp.deposits(tokenBank) : ZERO_I80F48();
	        let existingPositionHealthContrib = ZERO_I80F48();
	        if (existingTokenDeposits.gt(ZERO_I80F48())) {
	            existingPositionHealthContrib = existingTokenDeposits
	                .mul(tokenBank.price)
	                .imul(tokenBank.initAssetWeight);
	        }
	        // Case 2: token deposits have higher contribution than initHealth,
	        // can withdraw without borrowing until initHealth reaches 0
	        if (existingPositionHealthContrib.gt(initHealth)) {
	            const withdrawAbleExistingPositionHealthContrib = initHealth;
	            return withdrawAbleExistingPositionHealthContrib
	                .div(tokenBank.initAssetWeight)
	                .div(tokenBank.price);
	        }
	        // Case 3: withdraw = withdraw existing deposits + borrows until initHealth reaches 0
	        const initHealthWithoutExistingPosition = initHealth.sub(existingPositionHealthContrib);
	        let maxBorrowNative = initHealthWithoutExistingPosition
	            .div(tokenBank.initLiabWeight)
	            .div(tokenBank.price);
	        // Cap maxBorrow to maintain minVaultToDepositsRatio on the bank
	        const vaultAmount = group.vaultAmountsMap.get(tokenBank.vault.toBase58());
	        if (!vaultAmount) {
	            throw new Error(`No vault amount found for ${tokenBank.name} vault ${tokenBank.vault}!`);
	        }
	        const vaultAmountAfterWithdrawingDeposits = I80F48.fromU64(vaultAmount).sub(existingTokenDeposits);
	        const expectedVaultMinAmount = tokenBank
	            .nativeDeposits()
	            .mul(I80F48.fromNumber(tokenBank.minVaultToDepositsRatio));
	        if (vaultAmountAfterWithdrawingDeposits.gt(expectedVaultMinAmount)) {
	            maxBorrowNative = maxBorrowNative.min(vaultAmountAfterWithdrawingDeposits.sub(expectedVaultMinAmount));
	        }
	        const maxBorrowNativeWithoutFees = maxBorrowNative.div(ONE_I80F48().add(tokenBank.loanOriginationFeeRate));
	        return maxBorrowNativeWithoutFees.add(existingTokenDeposits);
	    }
	    getMaxWithdrawWithBorrowForTokenUi(group, mintPk) {
	        const maxWithdrawWithBorrow = this.getMaxWithdrawWithBorrowForToken(group, mintPk);
	        return toUiDecimals(maxWithdrawWithBorrow, group.getMintDecimals(mintPk));
	    }
	    /**
	     * The max amount of given source ui token you can swap to a target token.
	     * @returns max amount of given source ui token you can swap to a target token, in ui token
	     */
	    getMaxSourceUiForTokenSwap(group, sourceMintPk, targetMintPk, slippageAndFeesFactor = 1) {
	        if (sourceMintPk.equals(targetMintPk)) {
	            return 0;
	        }
	        const sourceBank = group.getFirstBankByMint(sourceMintPk);
	        const targetBank = group.getFirstBankByMint(targetMintPk);
	        const hc = HealthCache.fromMangoAccount(group, this);
	        let maxSource = hc.getMaxSwapSource(sourceBank, targetBank, I80F48.fromNumber(slippageAndFeesFactor *
	            ((sourceBank.uiPrice / targetBank.uiPrice) *
	                Math.pow(10, targetBank.mintDecimals - sourceBank.mintDecimals))));
	        const sourceBalance = this.getTokenBalance(sourceBank);
	        if (maxSource.gt(sourceBalance)) {
	            const sourceBorrow = maxSource.sub(sourceBalance);
	            maxSource = sourceBalance.add(sourceBorrow.div(ONE_I80F48().add(sourceBank.loanOriginationFeeRate)));
	        }
	        return toUiDecimals(maxSource, group.getMintDecimals(sourceMintPk));
	    }
	    /**
	     * Simulates new health ratio after applying tokenChanges to the token positions.
	     * Note: token changes are expected in ui amounts
	     *
	     * e.g. useful to simulate health after a potential swap.
	     * Note: health ratio is technically ∞ if liabs are 0
	     * @returns health ratio, in percentage form
	     */
	    simHealthRatioWithTokenPositionUiChanges(group, uiTokenChanges, healthType = HealthType.init) {
	        const nativeTokenChanges = uiTokenChanges.map((tokenChange) => {
	            return {
	                nativeTokenAmount: toNativeI80F48(tokenChange.uiTokenAmount, group.getMintDecimals(tokenChange.mintPk)),
	                mintPk: tokenChange.mintPk,
	            };
	        });
	        const hc = HealthCache.fromMangoAccount(group, this);
	        return hc
	            .simHealthRatioWithTokenPositionChanges(group, nativeTokenChanges, healthType)
	            .toNumber();
	    }
	    async loadSerum3OpenOrdersAccounts(client) {
	        const response = await client.program.provider.connection.getMultipleAccountsInfo(this.serum3Active().map((s) => s.openOrders));
	        const accounts = response.filter((a) => Boolean(a));
	        return accounts.map((acc, index) => {
	            return market.OpenOrders.fromAccountInfo(this.serum3[index].openOrders, acc, OPENBOOK_PROGRAM_ID[client.cluster]);
	        });
	    }
	    async loadSerum3OpenOrdersForMarket(client, group, externalMarketPk) {
	        const serum3Market = group.getSerum3MarketByExternalMarket(externalMarketPk);
	        const serum3OO = this.serum3Active().find((s) => s.marketIndex === serum3Market.marketIndex);
	        if (!serum3OO) {
	            throw new Error(`No open orders account found for ${externalMarketPk}`);
	        }
	        const serum3MarketExternal = group.serum3ExternalMarketsMap.get(externalMarketPk.toBase58());
	        const [bidsInfo, asksInfo] = await client.program.provider.connection.getMultipleAccountsInfo([
	            serum3MarketExternal.bidsAddress,
	            serum3MarketExternal.asksAddress,
	        ]);
	        if (!bidsInfo) {
	            throw new Error(`Undefined bidsInfo for serum3Market with externalMarket ${externalMarketPk.toString()}`);
	        }
	        if (!asksInfo) {
	            throw new Error(`Undefined asksInfo for serum3Market with externalMarket ${externalMarketPk.toString()}`);
	        }
	        const bids = market.Orderbook.decode(serum3MarketExternal, bidsInfo.data);
	        const asks = market.Orderbook.decode(serum3MarketExternal, asksInfo.data);
	        return [...bids, ...asks].filter((o) => o.openOrdersAddress.equals(serum3OO.openOrders));
	    }
	    /**
	     * TODO REWORK, know to break in binary search, also make work for limit orders
	     *
	     * @param group
	     * @param externalMarketPk
	     * @returns maximum ui quote which can be traded at oracle price for base token given current health
	     */
	    getMaxQuoteForSerum3BidUi(group, externalMarketPk) {
	        const serum3Market = group.getSerum3MarketByExternalMarket(externalMarketPk);
	        const baseBank = group.getFirstBankByTokenIndex(serum3Market.baseTokenIndex);
	        const quoteBank = group.getFirstBankByTokenIndex(serum3Market.quoteTokenIndex);
	        const hc = HealthCache.fromMangoAccount(group, this);
	        const nativeAmount = hc.getMaxSerum3OrderForHealthRatio(baseBank, quoteBank, serum3Market, Serum3Side.bid, I80F48.fromNumber(2));
	        let quoteAmount = nativeAmount.div(quoteBank.price);
	        // If its a bid then the reserved fund and potential loan is in base
	        // also keep some buffer for fees, use taker fees for worst case simulation.
	        const quoteBalance = this.getTokenBalance(quoteBank);
	        if (quoteAmount.gt(quoteBalance)) {
	            const quoteBorrow = quoteAmount.sub(quoteBalance);
	            quoteAmount = quoteBalance.add(quoteBorrow.div(ONE_I80F48().add(quoteBank.loanOriginationFeeRate)));
	        }
	        quoteAmount = quoteAmount.div(ONE_I80F48().add(I80F48.fromNumber(serum3Market.getFeeRates(true))));
	        return toUiDecimals(nativeAmount, quoteBank.mintDecimals);
	    }
	    /**
	     * TODO REWORK, know to break in binary search, also make work for limit orders
	     * @param group
	     * @param externalMarketPk
	     * @returns maximum ui base which can be traded at oracle price for quote token given current health
	     */
	    getMaxBaseForSerum3AskUi(group, externalMarketPk) {
	        const serum3Market = group.getSerum3MarketByExternalMarket(externalMarketPk);
	        const baseBank = group.getFirstBankByTokenIndex(serum3Market.baseTokenIndex);
	        const quoteBank = group.getFirstBankByTokenIndex(serum3Market.quoteTokenIndex);
	        const hc = HealthCache.fromMangoAccount(group, this);
	        const nativeAmount = hc.getMaxSerum3OrderForHealthRatio(baseBank, quoteBank, serum3Market, Serum3Side.ask, I80F48.fromNumber(2));
	        let baseAmount = nativeAmount.div(baseBank.price);
	        // If its a ask then the reserved fund and potential loan is in base
	        // also keep some buffer for fees, use taker fees for worst case simulation.
	        const baseBalance = this.getTokenBalance(baseBank);
	        if (baseAmount.gt(baseBalance)) {
	            const baseBorrow = baseAmount.sub(baseBalance);
	            baseAmount = baseBalance.add(baseBorrow.div(ONE_I80F48().add(baseBank.loanOriginationFeeRate)));
	        }
	        baseAmount = baseAmount.div(ONE_I80F48().add(I80F48.fromNumber(serum3Market.getFeeRates(true))));
	        return toUiDecimals(baseAmount, baseBank.mintDecimals);
	    }
	    /**
	     *
	     * @param group
	     * @param uiQuoteAmount
	     * @param externalMarketPk
	     * @param healthType
	     * @returns health ratio after a bid with uiQuoteAmount is placed
	     */
	    simHealthRatioWithSerum3BidUiChanges(group, uiQuoteAmount, externalMarketPk, healthType = HealthType.init) {
	        const serum3Market = group.getSerum3MarketByExternalMarket(externalMarketPk);
	        const baseBank = group.getFirstBankByTokenIndex(serum3Market.baseTokenIndex);
	        const quoteBank = group.getFirstBankByTokenIndex(serum3Market.quoteTokenIndex);
	        const hc = HealthCache.fromMangoAccount(group, this);
	        return hc
	            .simHealthRatioWithSerum3BidChanges(baseBank, quoteBank, toNativeI80F48(uiQuoteAmount, group.getFirstBankByTokenIndex(serum3Market.quoteTokenIndex)
	            .mintDecimals), serum3Market, healthType)
	            .toNumber();
	    }
	    /**
	     *
	     * @param group
	     * @param uiBaseAmount
	     * @param externalMarketPk
	     * @param healthType
	     * @returns health ratio after an ask with uiBaseAmount is placed
	     */
	    simHealthRatioWithSerum3AskUiChanges(group, uiBaseAmount, externalMarketPk, healthType = HealthType.init) {
	        const serum3Market = group.getSerum3MarketByExternalMarket(externalMarketPk);
	        const baseBank = group.getFirstBankByTokenIndex(serum3Market.baseTokenIndex);
	        const quoteBank = group.getFirstBankByTokenIndex(serum3Market.quoteTokenIndex);
	        const hc = HealthCache.fromMangoAccount(group, this);
	        return hc
	            .simHealthRatioWithSerum3AskChanges(baseBank, quoteBank, toNativeI80F48(uiBaseAmount, group.getFirstBankByTokenIndex(serum3Market.baseTokenIndex)
	            .mintDecimals), serum3Market, healthType)
	            .toNumber();
	    }
	    // TODO: don't send a settle instruction if there's nothing to settle
	    async serum3SettleFundsForAllMarkets(client, group) {
	        // Future: collect ixs, batch them, and send them in fewer txs
	        return await Promise.all(this.serum3Active().map((s) => {
	            const serum3Market = group.getSerum3MarketByMarketIndex(s.marketIndex);
	            return client.serum3SettleFunds(group, this, serum3Market.serumMarketExternal);
	        }));
	    }
	    // TODO: cancel until all are cancelled
	    async serum3CancelAllOrdersForAllMarkets(client, group) {
	        // Future: collect ixs, batch them, and send them in in fewer txs
	        return await Promise.all(this.serum3Active().map((s) => {
	            const serum3Market = group.getSerum3MarketByMarketIndex(s.marketIndex);
	            return client.serum3CancelAllOrders(group, this, serum3Market.serumMarketExternal);
	        }));
	    }
	    /**
	     * TODO: also think about limit orders
	     *
	     * The max ui quote you can place a market/ioc bid on the market,
	     * price is the ui price at which you think the order would materialiase.
	     * @param group
	     * @param perpMarketName
	     * @returns maximum ui quote which can be traded at oracle price for quote token given current health
	     */
	    getMaxQuoteForPerpBidUi(group, perpMarketIndex) {
	        const perpMarket = group.getPerpMarketByMarketIndex(perpMarketIndex);
	        const hc = HealthCache.fromMangoAccount(group, this);
	        const baseLots = hc.getMaxPerpForHealthRatio(perpMarket, I80F48.fromNumber(perpMarket.uiPrice), PerpOrderSide.bid, I80F48.fromNumber(2));
	        const nativeBase = baseLots.mul(I80F48.fromI64(perpMarket.baseLotSize));
	        const nativeQuote = nativeBase.mul(perpMarket.price);
	        return toUiDecimalsForQuote(nativeQuote);
	    }
	    /**
	     * TODO: also think about limit orders
	     *
	     * The max ui base you can place a market/ioc ask on the market,
	     * price is the ui price at which you think the order would materialiase.
	     * @param group
	     * @param perpMarketName
	     * @param uiPrice ui price at which ask would be placed at
	     * @returns max ui base ask
	     */
	    getMaxBaseForPerpAskUi(group, perpMarketIndex) {
	        const perpMarket = group.getPerpMarketByMarketIndex(perpMarketIndex);
	        const hc = HealthCache.fromMangoAccount(group, this);
	        const baseLots = hc.getMaxPerpForHealthRatio(perpMarket, I80F48.fromNumber(perpMarket.uiPrice), PerpOrderSide.ask, I80F48.fromNumber(2));
	        return perpMarket.baseLotsToUi(new anchor.BN(baseLots.toString()));
	    }
	    simHealthRatioWithPerpBidUiChanges(group, perpMarketIndex, size) {
	        const perpMarket = group.getPerpMarketByMarketIndex(perpMarketIndex);
	        const pp = this.getPerpPosition(perpMarket.perpMarketIndex);
	        const hc = HealthCache.fromMangoAccount(group, this);
	        return hc
	            .simHealthRatioWithPerpOrderChanges(perpMarket, pp
	            ? pp
	            : PerpPosition.emptyFromPerpMarketIndex(perpMarket.perpMarketIndex), PerpOrderSide.bid, perpMarket.uiBaseToLots(size), I80F48.fromNumber(perpMarket.uiPrice), HealthType.init)
	            .toNumber();
	    }
	    simHealthRatioWithPerpAskUiChanges(group, perpMarketIndex, size) {
	        const perpMarket = group.getPerpMarketByMarketIndex(perpMarketIndex);
	        const pp = this.getPerpPosition(perpMarket.perpMarketIndex);
	        const hc = HealthCache.fromMangoAccount(group, this);
	        return hc
	            .simHealthRatioWithPerpOrderChanges(perpMarket, pp
	            ? pp
	            : PerpPosition.emptyFromPerpMarketIndex(perpMarket.perpMarketIndex), PerpOrderSide.ask, perpMarket.uiBaseToLots(size), I80F48.fromNumber(perpMarket.uiPrice), HealthType.init)
	            .toNumber();
	    }
	    async loadPerpOpenOrdersForMarket(client, group, perpMarketIndex) {
	        const perpMarket = group.getPerpMarketByMarketIndex(perpMarketIndex);
	        const [bids, asks] = await Promise.all([
	            perpMarket.loadBids(client),
	            perpMarket.loadAsks(client),
	        ]);
	        return [...Array.from(bids.items()), ...Array.from(asks.items())].filter((order) => order.owner.equals(this.publicKey));
	    }
	    toString(group, onlyTokens = false) {
	        let res = 'MangoAccount';
	        res = res + '\n pk: ' + this.publicKey.toString();
	        res = res + '\n name: ' + this.name;
	        res = res + '\n accountNum: ' + this.accountNum;
	        res = res + '\n owner: ' + this.owner;
	        res = res + '\n delegate: ' + this.delegate;
	        res =
	            res +
	                `\n max token slots ${this.tokens.length}, max serum3 slots ${this.serum3.length}, max perp slots ${this.perps.length}, max perp oo slots ${this.perpOpenOrders.length}`;
	        res =
	            this.tokensActive().length > 0
	                ? res +
	                    '\n tokens:' +
	                    JSON.stringify(this.tokens
	                        .filter((token, i) => token.isActive())
	                        .map((token, i) => token.toString(group, i)), null, 4)
	                : res + '';
	        if (onlyTokens) {
	            return res;
	        }
	        res =
	            this.serum3Active().length > 0
	                ? res + '\n serum:' + JSON.stringify(this.serum3Active(), null, 4)
	                : res + '';
	        res =
	            this.perpActive().length > 0
	                ? res +
	                    '\n perps:' +
	                    JSON.stringify(this.perpActive().map((p) => p.toString(group?.getPerpMarketByMarketIndex(p.marketIndex))), null, 4)
	                : res + '';
	        res =
	            this.perpOrdersActive().length > 0
	                ? res +
	                    '\n perps oo:' +
	                    JSON.stringify(this.perpOrdersActive(), null, 4)
	                : res + '';
	        return res;
	    }
	}
	class TokenPosition {
	    indexedPosition;
	    tokenIndex;
	    inUseCount;
	    previousIndex;
	    cumulativeDepositInterest;
	    cumulativeBorrowInterest;
	    static TokenIndexUnset = 65535;
	    static from(dto) {
	        return new TokenPosition(I80F48.from(dto.indexedPosition), dto.tokenIndex, dto.inUseCount, I80F48.from(dto.previousIndex), dto.cumulativeDepositInterest, dto.cumulativeBorrowInterest);
	    }
	    constructor(indexedPosition, tokenIndex, inUseCount, previousIndex, cumulativeDepositInterest, cumulativeBorrowInterest) {
	        this.indexedPosition = indexedPosition;
	        this.tokenIndex = tokenIndex;
	        this.inUseCount = inUseCount;
	        this.previousIndex = previousIndex;
	        this.cumulativeDepositInterest = cumulativeDepositInterest;
	        this.cumulativeBorrowInterest = cumulativeBorrowInterest;
	    }
	    isActive() {
	        return this.tokenIndex !== TokenPosition.TokenIndexUnset;
	    }
	    /**
	     *
	     * @param bank
	     * @returns native balance
	     */
	    balance(bank) {
	        if (this.indexedPosition.isPos()) {
	            return bank.depositIndex.mul(this.indexedPosition);
	        }
	        else {
	            return bank.borrowIndex.mul(this.indexedPosition);
	        }
	    }
	    /**
	     *
	     * @param bank
	     * @returns native deposits, 0 if position has borrows
	     */
	    deposits(bank) {
	        if (this.indexedPosition && this.indexedPosition.lt(ZERO_I80F48())) {
	            return ZERO_I80F48();
	        }
	        return this.balance(bank);
	    }
	    /**
	     *
	     * @param bank
	     * @returns native borrows, 0 if position has deposits
	     */
	    borrows(bank) {
	        if (this.indexedPosition && this.indexedPosition.gt(ZERO_I80F48())) {
	            return ZERO_I80F48();
	        }
	        return this.balance(bank).abs();
	    }
	    /**
	     * @param bank
	     * @returns UI balance, is signed
	     */
	    balanceUi(bank) {
	        return toUiDecimals(this.balance(bank), bank.mintDecimals);
	    }
	    /**
	     * @param bank
	     * @returns UI deposits, 0 if position has borrows
	     */
	    depositsUi(bank) {
	        return toUiDecimals(this.deposits(bank), bank.mintDecimals);
	    }
	    /**
	     * @param bank
	     * @returns UI borrows, 0 if position has deposits
	     */
	    borrowsUi(bank) {
	        return toUiDecimals(this.borrows(bank), bank.mintDecimals);
	    }
	    toString(group, index) {
	        let extra = '';
	        if (group) {
	            const bank = group.getFirstBankByTokenIndex(this.tokenIndex);
	            if (bank) {
	                const native = this.balance(bank);
	                extra += ', native: ' + native.toNumber();
	                extra += ', ui: ' + this.balanceUi(bank);
	                extra += ', tokenName: ' + bank.name;
	            }
	        }
	        return ((index !== undefined ? 'index: ' + index : '') +
	            ', tokenIndex: ' +
	            this.tokenIndex +
	            ', inUseCount: ' +
	            this.inUseCount +
	            ', indexedValue: ' +
	            this.indexedPosition.toNumber() +
	            extra);
	    }
	}
	class TokenPositionDto {
	    indexedPosition;
	    tokenIndex;
	    inUseCount;
	    reserved;
	    previousIndex;
	    cumulativeDepositInterest;
	    cumulativeBorrowInterest;
	    constructor(indexedPosition, tokenIndex, inUseCount, reserved, previousIndex, cumulativeDepositInterest, cumulativeBorrowInterest) {
	        this.indexedPosition = indexedPosition;
	        this.tokenIndex = tokenIndex;
	        this.inUseCount = inUseCount;
	        this.reserved = reserved;
	        this.previousIndex = previousIndex;
	        this.cumulativeDepositInterest = cumulativeDepositInterest;
	        this.cumulativeBorrowInterest = cumulativeBorrowInterest;
	    }
	}
	class Serum3Orders {
	    openOrders;
	    marketIndex;
	    baseTokenIndex;
	    quoteTokenIndex;
	    static Serum3MarketIndexUnset = 65535;
	    static from(dto) {
	        return new Serum3Orders(dto.openOrders, dto.marketIndex, dto.baseTokenIndex, dto.quoteTokenIndex);
	    }
	    constructor(openOrders, marketIndex, baseTokenIndex, quoteTokenIndex) {
	        this.openOrders = openOrders;
	        this.marketIndex = marketIndex;
	        this.baseTokenIndex = baseTokenIndex;
	        this.quoteTokenIndex = quoteTokenIndex;
	    }
	    isActive() {
	        return this.marketIndex !== Serum3Orders.Serum3MarketIndexUnset;
	    }
	}
	class Serum3PositionDto {
	    openOrders;
	    marketIndex;
	    baseBorrowsWithoutFee;
	    quoteBorrowsWithoutFee;
	    baseTokenIndex;
	    quoteTokenIndex;
	    reserved;
	    constructor(openOrders, marketIndex, baseBorrowsWithoutFee, quoteBorrowsWithoutFee, baseTokenIndex, quoteTokenIndex, reserved) {
	        this.openOrders = openOrders;
	        this.marketIndex = marketIndex;
	        this.baseBorrowsWithoutFee = baseBorrowsWithoutFee;
	        this.quoteBorrowsWithoutFee = quoteBorrowsWithoutFee;
	        this.baseTokenIndex = baseTokenIndex;
	        this.quoteTokenIndex = quoteTokenIndex;
	        this.reserved = reserved;
	    }
	}
	class PerpPosition {
	    marketIndex;
	    settlePnlLimitWindow;
	    settlePnlLimitSettledInCurrentWindowNative;
	    basePositionLots;
	    quotePositionNative;
	    quoteRunningNative;
	    longSettledFunding;
	    shortSettledFunding;
	    bidsBaseLots;
	    asksBaseLots;
	    takerBaseLots;
	    takerQuoteLots;
	    cumulativeLongFunding;
	    cumulativeShortFunding;
	    makerVolume;
	    takerVolume;
	    perpSpotTransfers;
	    avgEntryPricePerBaseLot;
	    realizedTradePnlNative;
	    realizedOtherPnlNative;
	    settlePnlLimitRealizedTrade;
	    realizedPnlForPositionNative;
	    static PerpMarketIndexUnset = 65535;
	    static from(dto) {
	        return new PerpPosition(dto.marketIndex, dto.settlePnlLimitWindow, dto.settlePnlLimitSettledInCurrentWindowNative, dto.basePositionLots, I80F48.from(dto.quotePositionNative), dto.quoteRunningNative, I80F48.from(dto.longSettledFunding), I80F48.from(dto.shortSettledFunding), dto.bidsBaseLots, dto.asksBaseLots, dto.takerBaseLots, dto.takerQuoteLots, dto.cumulativeLongFunding, dto.cumulativeShortFunding, dto.makerVolume, dto.takerVolume, dto.perpSpotTransfers, dto.avgEntryPricePerBaseLot, I80F48.from(dto.realizedTradePnlNative), I80F48.from(dto.realizedOtherPnlNative), dto.settlePnlLimitRealizedTrade, I80F48.from(dto.realizedPnlForPositionNative));
	    }
	    static emptyFromPerpMarketIndex(perpMarketIndex) {
	        return new PerpPosition(perpMarketIndex, 0, new anchor.BN(0), new anchor.BN(0), ZERO_I80F48(), new anchor.BN(0), ZERO_I80F48(), ZERO_I80F48(), new anchor.BN(0), new anchor.BN(0), new anchor.BN(0), new anchor.BN(0), 0, 0, new anchor.BN(0), new anchor.BN(0), new anchor.BN(0), 0, ZERO_I80F48(), ZERO_I80F48(), new anchor.BN(0), ZERO_I80F48());
	    }
	    constructor(marketIndex, settlePnlLimitWindow, settlePnlLimitSettledInCurrentWindowNative, basePositionLots, quotePositionNative, quoteRunningNative, longSettledFunding, shortSettledFunding, bidsBaseLots, asksBaseLots, takerBaseLots, takerQuoteLots, cumulativeLongFunding, cumulativeShortFunding, makerVolume, takerVolume, perpSpotTransfers, avgEntryPricePerBaseLot, realizedTradePnlNative, realizedOtherPnlNative, settlePnlLimitRealizedTrade, realizedPnlForPositionNative) {
	        this.marketIndex = marketIndex;
	        this.settlePnlLimitWindow = settlePnlLimitWindow;
	        this.settlePnlLimitSettledInCurrentWindowNative = settlePnlLimitSettledInCurrentWindowNative;
	        this.basePositionLots = basePositionLots;
	        this.quotePositionNative = quotePositionNative;
	        this.quoteRunningNative = quoteRunningNative;
	        this.longSettledFunding = longSettledFunding;
	        this.shortSettledFunding = shortSettledFunding;
	        this.bidsBaseLots = bidsBaseLots;
	        this.asksBaseLots = asksBaseLots;
	        this.takerBaseLots = takerBaseLots;
	        this.takerQuoteLots = takerQuoteLots;
	        this.cumulativeLongFunding = cumulativeLongFunding;
	        this.cumulativeShortFunding = cumulativeShortFunding;
	        this.makerVolume = makerVolume;
	        this.takerVolume = takerVolume;
	        this.perpSpotTransfers = perpSpotTransfers;
	        this.avgEntryPricePerBaseLot = avgEntryPricePerBaseLot;
	        this.realizedTradePnlNative = realizedTradePnlNative;
	        this.realizedOtherPnlNative = realizedOtherPnlNative;
	        this.settlePnlLimitRealizedTrade = settlePnlLimitRealizedTrade;
	        this.realizedPnlForPositionNative = realizedPnlForPositionNative;
	    }
	    isActive() {
	        return this.marketIndex !== PerpPosition.PerpMarketIndexUnset;
	    }
	    getBasePositionNative(perpMarket) {
	        return I80F48.fromI64(this.basePositionLots.mul(perpMarket.baseLotSize));
	    }
	    getBasePositionUi(perpMarket, useEventQueue) {
	        if (perpMarket.perpMarketIndex !== this.marketIndex) {
	            throw new Error("PerpPosition doesn't belong to the given market!");
	        }
	        return perpMarket.baseLotsToUi(useEventQueue
	            ? this.basePositionLots.add(this.takerBaseLots)
	            : this.basePositionLots);
	    }
	    getUnsettledFunding(perpMarket) {
	        if (perpMarket.perpMarketIndex !== this.marketIndex) {
	            throw new Error("PerpPosition doesn't belong to the given market!");
	        }
	        if (this.basePositionLots.gt(new anchor.BN(0))) {
	            return perpMarket.longFunding
	                .sub(this.longSettledFunding)
	                .mul(I80F48.fromI64(this.basePositionLots));
	        }
	        else if (this.basePositionLots.lt(new anchor.BN(0))) {
	            return perpMarket.shortFunding
	                .sub(this.shortSettledFunding)
	                .mul(I80F48.fromI64(this.basePositionLots));
	        }
	        return ZERO_I80F48();
	    }
	    getEquityUi(perpMarket) {
	        if (perpMarket.perpMarketIndex !== this.marketIndex) {
	            throw new Error("PerpPosition doesn't belong to the given market!");
	        }
	        return toUiDecimalsForQuote(this.getEquity(perpMarket));
	    }
	    getEquity(perpMarket) {
	        if (perpMarket.perpMarketIndex !== this.marketIndex) {
	            throw new Error("PerpPosition doesn't belong to the given market!");
	        }
	        const lotsToQuote = I80F48.fromI64(perpMarket.baseLotSize).mul(perpMarket.price);
	        const baseLots = I80F48.fromI64(this.basePositionLots.add(this.takerBaseLots));
	        const unsettledFunding = this.getUnsettledFunding(perpMarket);
	        const takerQuote = I80F48.fromI64(new anchor.BN(this.takerQuoteLots).mul(perpMarket.quoteLotSize));
	        const quoteCurrent = this.quotePositionNative
	            .sub(unsettledFunding)
	            .add(takerQuote);
	        return baseLots.mul(lotsToQuote).add(quoteCurrent);
	    }
	    hasOpenOrders() {
	        const zero = new anchor.BN(0);
	        return (!this.asksBaseLots.eq(zero) ||
	            !this.bidsBaseLots.eq(zero) ||
	            !this.takerBaseLots.eq(zero) ||
	            !this.takerQuoteLots.eq(zero));
	    }
	    getAverageEntryPrice(perpMarket) {
	        return I80F48.fromNumber(this.avgEntryPricePerBaseLot).div(I80F48.fromI64(perpMarket.baseLotSize));
	    }
	    getAverageEntryPriceUi(perpMarket) {
	        return perpMarket.priceNativeToUi(this.getAverageEntryPrice(perpMarket).toNumber());
	    }
	    getBreakEvenPriceUi(perpMarket) {
	        if (perpMarket.perpMarketIndex !== this.marketIndex) {
	            throw new Error("PerpPosition doesn't belong to the given market!");
	        }
	        if (this.basePositionLots.eq(new anchor.BN(0))) {
	            return 0;
	        }
	        return perpMarket.priceNativeToUi(-this.quoteRunningNative.toNumber() /
	            this.basePositionLots.mul(perpMarket.baseLotSize).toNumber());
	    }
	    cumulativePnlOverPositionLifetimeUi(perpMarket) {
	        if (perpMarket.perpMarketIndex !== this.marketIndex) {
	            throw new Error("PerpPosition doesn't belong to the given market!");
	        }
	        const priceChange = perpMarket.price.sub(this.getAverageEntryPrice(perpMarket));
	        return toUiDecimalsForQuote(this.realizedPnlForPositionNative.add(this.getBasePositionNative(perpMarket).mul(priceChange)));
	    }
	    getUnsettledPnl(perpMarket) {
	        if (perpMarket.perpMarketIndex !== this.marketIndex) {
	            throw new Error("PerpPosition doesn't belong to the given market!");
	        }
	        return this.quotePositionNative.add(this.getBasePositionNative(perpMarket).mul(perpMarket.price));
	    }
	    getUnsettledPnlUi(perpMarket) {
	        return toUiDecimalsForQuote(this.getUnsettledPnl(perpMarket));
	    }
	    updateSettleLimit(perpMarket) {
	        if (perpMarket.perpMarketIndex !== this.marketIndex) {
	            throw new Error("PerpPosition doesn't belong to the given market!");
	        }
	        const windowSize = perpMarket.settlePnlLimitWindowSizeTs;
	        const windowStart = new anchor.BN(this.settlePnlLimitWindow).mul(windowSize);
	        const windowEnd = windowStart.add(windowSize);
	        const nowTs = new anchor.BN(Date.now() / 1000);
	        const newWindow = nowTs.gte(windowEnd) || nowTs.lt(windowStart);
	        if (newWindow) {
	            this.settlePnlLimitWindow = nowTs.div(windowSize).toNumber();
	            this.settlePnlLimitSettledInCurrentWindowNative = new anchor.BN(0);
	        }
	    }
	    availableSettleLimit(perpMarket) {
	        if (perpMarket.perpMarketIndex !== this.marketIndex) {
	            throw new Error("PerpPosition doesn't belong to the given market!");
	        }
	        if (perpMarket.settlePnlLimitFactor < 0) {
	            return [RUST_I64_MIN(), RUST_I64_MAX()];
	        }
	        const baseNative = I80F48.fromI64(this.basePositionLots.mul(perpMarket.baseLotSize));
	        const positionValue = I80F48.fromNumber(perpMarket.stablePriceModel.stablePrice)
	            .mul(baseNative)
	            .toNumber();
	        const unrealized = new anchor.BN(perpMarket.settlePnlLimitFactor * positionValue);
	        const used = new anchor.BN(this.settlePnlLimitSettledInCurrentWindowNative.toNumber());
	        let minPnl = unrealized.neg().sub(used);
	        let maxPnl = unrealized.sub(used);
	        const realizedTrade = this.settlePnlLimitRealizedTrade;
	        if (realizedTrade.gte(new anchor.BN(0))) {
	            maxPnl = maxPnl.add(realizedTrade);
	        }
	        else {
	            minPnl = minPnl.add(realizedTrade);
	        }
	        const realizedOther = new anchor.BN(this.realizedOtherPnlNative.toNumber());
	        if (realizedOther.gte(new anchor.BN(0))) {
	            maxPnl = maxPnl.add(realizedOther);
	        }
	        else {
	            minPnl = minPnl.add(realizedOther);
	        }
	        return [anchor.BN.min(minPnl, new anchor.BN(0)), anchor.BN.max(maxPnl, new anchor.BN(0))];
	    }
	    applyPnlSettleLimit(pnl, perpMarket) {
	        if (perpMarket.perpMarketIndex !== this.marketIndex) {
	            throw new Error("PerpPosition doesn't belong to the given market!");
	        }
	        if (perpMarket.settlePnlLimitFactor < 0) {
	            return pnl;
	        }
	        const [minPnl, maxPnl] = this.availableSettleLimit(perpMarket);
	        if (pnl.lt(ZERO_I80F48())) {
	            return pnl.max(I80F48.fromI64(minPnl));
	        }
	        else {
	            return pnl.min(I80F48.fromI64(maxPnl));
	        }
	    }
	    getSettleablePnl(group, perpMarket, account) {
	        if (perpMarket.perpMarketIndex !== this.marketIndex) {
	            throw new Error("PerpPosition doesn't belong to the given market!");
	        }
	        this.updateSettleLimit(perpMarket);
	        const perpSettleHealth = account.getPerpSettleHealth(group);
	        const limitedUnsettled = this.applyPnlSettleLimit(this.getUnsettledPnl(perpMarket), perpMarket);
	        if (limitedUnsettled.lt(ZERO_I80F48())) {
	            return limitedUnsettled.max(perpSettleHealth.max(ZERO_I80F48()).neg());
	        }
	        return limitedUnsettled;
	    }
	    getSettleablePnlUi(group, perpMarket, account) {
	        return toUiDecimalsForQuote(this.getSettleablePnl(group, perpMarket, account));
	    }
	    canSettlePnl(group, perpMarket, account) {
	        return !this.getSettleablePnl(group, perpMarket, account).eq(ZERO_I80F48());
	    }
	    toString(perpMarket) {
	        return perpMarket
	            ? 'market - ' +
	                perpMarket.name +
	                ', basePositionLots - ' +
	                perpMarket.baseLotsToUi(this.basePositionLots) +
	                ', quotePositive - ' +
	                toUiDecimalsForQuote(this.quotePositionNative.toNumber()) +
	                ', bidsBaseLots - ' +
	                perpMarket.baseLotsToUi(this.bidsBaseLots) +
	                ', asksBaseLots - ' +
	                perpMarket.baseLotsToUi(this.asksBaseLots) +
	                ', takerBaseLots - ' +
	                perpMarket.baseLotsToUi(this.takerBaseLots) +
	                ', takerQuoteLots - ' +
	                perpMarket.quoteLotsToUi(this.takerQuoteLots) +
	                ', unsettled pnl - ' +
	                this.getUnsettledPnlUi(perpMarket).toString()
	            : '';
	    }
	}
	class PerpPositionDto {
	    marketIndex;
	    settlePnlLimitWindow;
	    settlePnlLimitSettledInCurrentWindowNative;
	    basePositionLots;
	    quotePositionNative;
	    quoteRunningNative;
	    longSettledFunding;
	    shortSettledFunding;
	    bidsBaseLots;
	    asksBaseLots;
	    takerBaseLots;
	    takerQuoteLots;
	    cumulativeLongFunding;
	    cumulativeShortFunding;
	    makerVolume;
	    takerVolume;
	    perpSpotTransfers;
	    avgEntryPricePerBaseLot;
	    realizedTradePnlNative;
	    realizedOtherPnlNative;
	    settlePnlLimitRealizedTrade;
	    realizedPnlForPositionNative;
	    constructor(marketIndex, settlePnlLimitWindow, settlePnlLimitSettledInCurrentWindowNative, basePositionLots, quotePositionNative, quoteRunningNative, longSettledFunding, shortSettledFunding, bidsBaseLots, asksBaseLots, takerBaseLots, takerQuoteLots, cumulativeLongFunding, cumulativeShortFunding, makerVolume, takerVolume, perpSpotTransfers, avgEntryPricePerBaseLot, realizedTradePnlNative, realizedOtherPnlNative, settlePnlLimitRealizedTrade, realizedPnlForPositionNative) {
	        this.marketIndex = marketIndex;
	        this.settlePnlLimitWindow = settlePnlLimitWindow;
	        this.settlePnlLimitSettledInCurrentWindowNative = settlePnlLimitSettledInCurrentWindowNative;
	        this.basePositionLots = basePositionLots;
	        this.quotePositionNative = quotePositionNative;
	        this.quoteRunningNative = quoteRunningNative;
	        this.longSettledFunding = longSettledFunding;
	        this.shortSettledFunding = shortSettledFunding;
	        this.bidsBaseLots = bidsBaseLots;
	        this.asksBaseLots = asksBaseLots;
	        this.takerBaseLots = takerBaseLots;
	        this.takerQuoteLots = takerQuoteLots;
	        this.cumulativeLongFunding = cumulativeLongFunding;
	        this.cumulativeShortFunding = cumulativeShortFunding;
	        this.makerVolume = makerVolume;
	        this.takerVolume = takerVolume;
	        this.perpSpotTransfers = perpSpotTransfers;
	        this.avgEntryPricePerBaseLot = avgEntryPricePerBaseLot;
	        this.realizedTradePnlNative = realizedTradePnlNative;
	        this.realizedOtherPnlNative = realizedOtherPnlNative;
	        this.settlePnlLimitRealizedTrade = settlePnlLimitRealizedTrade;
	        this.realizedPnlForPositionNative = realizedPnlForPositionNative;
	    }
	}
	class PerpOo {
	    sideAndTree;
	    orderMarket;
	    clientId;
	    id;
	    static OrderMarketUnset = 65535;
	    static from(dto) {
	        return new PerpOo(dto.sideAndTree, dto.market, dto.clientId, dto.id);
	    }
	    constructor(sideAndTree, orderMarket, clientId, id) {
	        this.sideAndTree = sideAndTree;
	        this.orderMarket = orderMarket;
	        this.clientId = clientId;
	        this.id = id;
	    }
	    isActive() {
	        return this.orderMarket !== PerpOo.OrderMarketUnset;
	    }
	}
	class PerpOoDto {
	    sideAndTree;
	    market;
	    clientId;
	    id;
	    constructor(sideAndTree, market, clientId, id) {
	        this.sideAndTree = sideAndTree;
	        this.market = market;
	        this.clientId = clientId;
	        this.id = id;
	    }
	}
	class HealthType {
	    static maint = { maint: {} };
	    static init = { init: {} };
	    static liquidationEnd = { liquidationEnd: {} };
	}

	const NullTokenEditParams = {
	    oracle: null,
	    oracleConfig: null,
	    groupInsuranceFund: null,
	    interestRateParams: null,
	    loanFeeRate: null,
	    loanOriginationFeeRate: null,
	    maintAssetWeight: null,
	    initAssetWeight: null,
	    maintLiabWeight: null,
	    initLiabWeight: null,
	    liquidationFee: null,
	    stablePriceDelayIntervalSeconds: null,
	    stablePriceDelayGrowthLimit: null,
	    stablePriceGrowthLimit: null,
	    minVaultToDepositsRatio: null,
	    netBorrowLimitPerWindowQuote: null,
	    netBorrowLimitWindowSizeTs: null,
	    borrowWeightScaleStartQuote: null,
	    depositWeightScaleStartQuote: null,
	    resetStablePrice: null,
	    resetNetBorrowLimit: null,
	    reduceOnly: null,
	};
	const NullPerpEditParams = {
	    oracle: null,
	    oracleConfig: null,
	    baseDecimals: null,
	    maintBaseAssetWeight: null,
	    initBaseAssetWeight: null,
	    maintBaseLiabWeight: null,
	    initBaseLiabWeight: null,
	    maintOverallAssetWeight: null,
	    initOverallAssetWeight: null,
	    baseLiquidationFee: null,
	    makerFee: null,
	    takerFee: null,
	    feePenalty: null,
	    minFunding: null,
	    maxFunding: null,
	    impactQuantity: null,
	    groupInsuranceFund: null,
	    settleFeeFlat: null,
	    settleFeeAmountThreshold: null,
	    settleFeeFractionLowHealth: null,
	    stablePriceDelayIntervalSeconds: null,
	    stablePriceDelayGrowthLimit: null,
	    stablePriceGrowthLimit: null,
	    settlePnlLimitFactor: null,
	    settlePnlLimitWindowSize: null,
	    reduceOnly: null,
	    resetStablePrice: null,
	    positivePnlLiquidationFee: null,
	};
	// Default with all ixs enabled, use with buildIxGate
	const TrueIxGateParams = {
	    AccountClose: true,
	    AccountCreate: true,
	    AccountEdit: true,
	    AccountExpand: true,
	    AccountToggleFreeze: true,
	    AltExtend: true,
	    AltSet: true,
	    FlashLoan: true,
	    GroupClose: true,
	    GroupCreate: true,
	    GroupToggleHalt: true,
	    HealthRegion: true,
	    PerpCancelAllOrders: true,
	    PerpCancelAllOrdersBySide: true,
	    PerpCancelOrder: true,
	    PerpCancelOrderByClientOrderId: true,
	    PerpCloseMarket: true,
	    PerpConsumeEvents: true,
	    PerpCreateMarket: true,
	    PerpDeactivatePosition: true,
	    PerpEditMarket: true,
	    PerpLiqBaseOrPositivePnl: true,
	    PerpLiqForceCancelOrders: true,
	    PerpLiqNegativePnlOrBankruptcy: true,
	    PerpPlaceOrder: true,
	    PerpSettleFees: true,
	    PerpSettlePnl: true,
	    PerpUpdateFunding: true,
	    Serum3CancelAllOrders: true,
	    Serum3CancelOrder: true,
	    Serum3CloseOpenOrders: true,
	    Serum3CreateOpenOrders: true,
	    Serum3DeregisterMarket: true,
	    Serum3EditMarket: true,
	    Serum3LiqForceCancelOrders: true,
	    Serum3PlaceOrder: true,
	    Serum3RegisterMarket: true,
	    Serum3SettleFunds: true,
	    StubOracleClose: true,
	    StubOracleCreate: true,
	    StubOracleSet: true,
	    TokenAddBank: true,
	    TokenDeposit: true,
	    TokenDeregister: true,
	    TokenEdit: true,
	    TokenLiqBankruptcy: true,
	    TokenLiqWithToken: true,
	    TokenRegister: true,
	    TokenRegisterTrustless: true,
	    TokenUpdateIndexAndRate: true,
	    TokenWithdraw: true,
	};
	// build ix gate e.g. buildIxGate(Builder(TrueIxGateParams).TokenDeposit(false).build()).toNumber(),
	function buildIxGate(p) {
	    const ixGate = new anchor.BN(0);
	    function toggleIx(ixGate, p, propName, index) {
	        if (p[propName] === undefined) {
	            throw new Error(`Unknown property ${propName}`);
	        }
	        ixGate.ior(p[propName] ? new anchor.BN(0) : new anchor.BN(1).ushln(index));
	    }
	    toggleIx(ixGate, p, 'AccountClose', 0);
	    toggleIx(ixGate, p, 'AccountCreate', 1);
	    toggleIx(ixGate, p, 'AccountEdit', 2);
	    toggleIx(ixGate, p, 'AccountExpand', 3);
	    toggleIx(ixGate, p, 'AccountToggleFreeze', 4);
	    toggleIx(ixGate, p, 'AltExtend', 5);
	    toggleIx(ixGate, p, 'AltSet', 6);
	    toggleIx(ixGate, p, 'FlashLoan', 7);
	    toggleIx(ixGate, p, 'GroupClose', 8);
	    toggleIx(ixGate, p, 'GroupCreate', 9);
	    toggleIx(ixGate, p, 'HealthRegion', 10);
	    toggleIx(ixGate, p, 'PerpCancelAllOrders', 11);
	    toggleIx(ixGate, p, 'PerpCancelAllOrdersBySide', 12);
	    toggleIx(ixGate, p, 'PerpCancelOrder', 13);
	    toggleIx(ixGate, p, 'PerpCancelOrderByClientOrderId', 14);
	    toggleIx(ixGate, p, 'PerpCloseMarket', 15);
	    toggleIx(ixGate, p, 'PerpConsumeEvents', 16);
	    toggleIx(ixGate, p, 'PerpCreateMarket', 17);
	    toggleIx(ixGate, p, 'PerpDeactivatePosition', 18);
	    toggleIx(ixGate, p, 'PerpLiqBaseOrPositivePnl', 19);
	    toggleIx(ixGate, p, 'PerpLiqForceCancelOrders', 20);
	    toggleIx(ixGate, p, 'PerpLiqNegativePnlOrBankruptcy', 21);
	    toggleIx(ixGate, p, 'PerpPlaceOrder', 22);
	    toggleIx(ixGate, p, 'PerpSettleFees', 23);
	    toggleIx(ixGate, p, 'PerpSettlePnl', 24);
	    toggleIx(ixGate, p, 'PerpUpdateFunding', 25);
	    toggleIx(ixGate, p, 'Serum3CancelAllOrders', 26);
	    toggleIx(ixGate, p, 'Serum3CancelOrder', 27);
	    toggleIx(ixGate, p, 'Serum3CloseOpenOrders', 28);
	    toggleIx(ixGate, p, 'Serum3CreateOpenOrders', 29);
	    toggleIx(ixGate, p, 'Serum3DeregisterMarket', 30);
	    toggleIx(ixGate, p, 'Serum3EditMarket', 31);
	    toggleIx(ixGate, p, 'Serum3LiqForceCancelOrders', 32);
	    toggleIx(ixGate, p, 'Serum3PlaceOrder', 33);
	    toggleIx(ixGate, p, 'Serum3RegisterMarket', 34);
	    toggleIx(ixGate, p, 'Serum3SettleFunds', 35);
	    toggleIx(ixGate, p, 'StubOracleClose', 36);
	    toggleIx(ixGate, p, 'StubOracleCreate', 37);
	    toggleIx(ixGate, p, 'StubOracleSet', 38);
	    toggleIx(ixGate, p, 'TokenAddBank', 39);
	    toggleIx(ixGate, p, 'TokenDeposit', 40);
	    toggleIx(ixGate, p, 'TokenDeregister', 41);
	    toggleIx(ixGate, p, 'TokenLiqBankruptcy', 42);
	    toggleIx(ixGate, p, 'TokenLiqWithToken', 43);
	    toggleIx(ixGate, p, 'TokenRegister', 44);
	    toggleIx(ixGate, p, 'TokenRegisterTrustless', 45);
	    toggleIx(ixGate, p, 'TokenUpdateIndexAndRate', 46);
	    toggleIx(ixGate, p, 'TokenWithdraw', 47);
	    return ixGate;
	}

	var groups = [
		{
			cluster: "mainnet-beta",
			name: "mainnet-beta.clarkeni",
			publicKey: "DLdcpC6AsAJ9xeKMR3WhHrN5sM5o7GVVXQhQ5vwisTtz",
			serum3ProgramId: "9xQeWvG816bUx9EPjHmaT23yvVM2ZWbrrpZb9PusVFin",
			mangoProgramId: "4MangoMjqJ2firMokCjjGgoK8d4MXcrgL7XJaL3w6fVg",
			banks: [
				{
					name: "SOL",
					publicKey: "8Z8ypSDDbC2UWqapP4AqDGbTbxYgh5AKtv1682UYc74o",
					mint: "So11111111111111111111111111111111111111112",
					tokenIndex: 5,
					bankNum: 0,
					active: true
				},
				{
					name: "USDT",
					publicKey: "Bid15jgtr5Ppftj7BZdEJbiWFN3R1U3i2PUELA2ZDU1N",
					mint: "Es9vMFrzaCERmJfrF4H2FYD4KCoNkY11McCe8BenwNYB",
					tokenIndex: 1,
					bankNum: 0,
					active: true
				},
				{
					name: "USDC",
					publicKey: "MZSA6xDJFieoMbydmjWv7FkPCcipmtDC2bxE1qYGvaY",
					mint: "EPjFWdd5AufqSSqeM2qN1xzybapC8G4wEGGkZwyTDt1v",
					tokenIndex: 0,
					bankNum: 0,
					active: true
				},
				{
					name: "BTC",
					publicKey: "JfS9mG5Sonm6eyhQis2DdFSkfFmtoP8kW5UAaXcEWa4",
					mint: "9n4nbM75f5Ui33ZbPYXn59EwSgE8CGsHtAeTH5YFeJ9E",
					tokenIndex: 2,
					bankNum: 0,
					active: true
				},
				{
					name: "soETH",
					publicKey: "549bGbirHQSQ5mnFQNT5zBUs8XMFyK9hNAWRWcpCJzBn",
					mint: "2FPyTwcZLUg1MDrwsyoP4D6s1tM7hAkHYRjkNb5w6Pxk",
					tokenIndex: 4,
					bankNum: 0,
					active: true
				},
				{
					name: "ETH",
					publicKey: "2emCTQgGDubaZEdstGXbf9cL4sTgCiSBvWjwk925F4Bd",
					mint: "7vfCXTUXx5WJV5JADk17DUJ4ksgau7utNKj4b963voxs",
					tokenIndex: 3,
					bankNum: 0,
					active: true
				},
				{
					name: "MSOL",
					publicKey: "2uL6J4aUqpDerWoXejAZQ585SVYLjhBhgQvpBEHeLybb",
					mint: "mSoLzYCxHdYgdzU16g5QSh3i5K3z3KZK7ytfqcJm7So",
					tokenIndex: 6,
					bankNum: 0,
					active: true
				}
			],
			stubOracles: [
				{
					name: "EPjFWdd5AufqSSqeM2qN1xzybapC8G4wEGGkZwyTDt1v",
					publicKey: "F1JkVYh6ouopvmgWgaR9p4DyBTeGweHPumE4PzrvK5ti"
				}
			],
			mintInfos: [
				{
					name: "SOL",
					publicKey: "TvWkqqRPT7gRtbAecnYuSgAA11gcQPKJ9eggqt6bM8Q",
					mint: "So11111111111111111111111111111111111111112",
					tokenIndex: 5
				},
				{
					name: "USDT",
					publicKey: "9HGCxDaCfV7L8megn7aSXbQ39DR4BdT2qmvLxVNYgh69",
					mint: "Es9vMFrzaCERmJfrF4H2FYD4KCoNkY11McCe8BenwNYB",
					tokenIndex: 1
				},
				{
					name: "USDC",
					publicKey: "9mbfSj6EWVYShL5ozA7hYFghdjKXtx4GXwUygogqK8ZR",
					mint: "EPjFWdd5AufqSSqeM2qN1xzybapC8G4wEGGkZwyTDt1v",
					tokenIndex: 0
				},
				{
					name: "BTC",
					publicKey: "2rzUjP3ZHR6ZepqwLQ561HzEe2n5Sh1M67AqmzydzzcD",
					mint: "9n4nbM75f5Ui33ZbPYXn59EwSgE8CGsHtAeTH5YFeJ9E",
					tokenIndex: 2
				},
				{
					name: "soETH",
					publicKey: "BYuxStPHhVfNXXdL1sCAfiYmCzFcpoTtbaBhYqYGaE4D",
					mint: "2FPyTwcZLUg1MDrwsyoP4D6s1tM7hAkHYRjkNb5w6Pxk",
					tokenIndex: 4
				},
				{
					name: "ETH",
					publicKey: "8J9NCLCAwHWk5pzYTSmCZPvmkTJik8M4yXtrgeFHqPha",
					mint: "7vfCXTUXx5WJV5JADk17DUJ4ksgau7utNKj4b963voxs",
					tokenIndex: 3
				},
				{
					name: "MSOL",
					publicKey: "DRnvY2SVHuj8YiyyxVHPJu8ZtaXzsgcqxz3Tzf8az3Zx",
					mint: "mSoLzYCxHdYgdzU16g5QSh3i5K3z3KZK7ytfqcJm7So",
					tokenIndex: 6
				}
			],
			serum3Markets: [
			],
			perpMarkets: [
			]
		}
	];
	var ids = {
		groups: groups
	};

	class Id {
	    cluster;
	    name;
	    publicKey;
	    serum3ProgramId;
	    mangoProgramId;
	    banks;
	    stubOracles;
	    mintInfos;
	    serum3Markets;
	    perpMarkets;
	    constructor(cluster, name, publicKey, serum3ProgramId, mangoProgramId, banks, stubOracles, mintInfos, serum3Markets, perpMarkets) {
	        this.cluster = cluster;
	        this.name = name;
	        this.publicKey = publicKey;
	        this.serum3ProgramId = serum3ProgramId;
	        this.mangoProgramId = mangoProgramId;
	        this.banks = banks;
	        this.stubOracles = stubOracles;
	        this.mintInfos = mintInfos;
	        this.serum3Markets = serum3Markets;
	        this.perpMarkets = perpMarkets;
	    }
	    getBanks() {
	        return Array.from(this.banks
	            .filter((perpMarket) => perpMarket.active)
	            .map((bank) => new require$$0$1.PublicKey(bank.publicKey)));
	    }
	    getStubOracles() {
	        return Array.from(this.stubOracles.map((stubOracle) => new require$$0$1.PublicKey(stubOracle.publicKey)));
	    }
	    getMintInfos() {
	        return Array.from(this.mintInfos.map((mintInfo) => new require$$0$1.PublicKey(mintInfo.publicKey)));
	    }
	    getSerum3Markets() {
	        return Array.from(this.serum3Markets
	            .filter((perpMarket) => perpMarket.active)
	            .map((serum3Market) => new require$$0$1.PublicKey(serum3Market.publicKey)));
	    }
	    getPerpMarkets() {
	        return Array.from(this.perpMarkets
	            .filter((perpMarket) => perpMarket.active)
	            .map((perpMarket) => new require$$0$1.PublicKey(perpMarket.publicKey)));
	    }
	    static fromIdsByName(name) {
	        const groupConfig = ids.groups.find((id) => id['name'] === name);
	        if (!groupConfig)
	            throw new Error(`No group config ${name} found in Ids!`);
	        return new Id(groupConfig.cluster, groupConfig.name, groupConfig.publicKey, groupConfig.serum3ProgramId, groupConfig.mangoProgramId, groupConfig['banks'], groupConfig['stubOracles'], groupConfig['mintInfos'], groupConfig['serum3Markets'], groupConfig['perpMarkets']);
	    }
	    static fromIdsByPk(groupPk) {
	        const groupConfig = ids.groups.find((id) => id['publicKey'] === groupPk.toString());
	        if (!groupConfig)
	            throw new Error(`No group config ${groupPk.toString()} found in Ids!`);
	        return new Id(groupConfig.cluster, groupConfig.name, groupConfig.publicKey, groupConfig.serum3ProgramId, groupConfig.mangoProgramId, groupConfig['banks'], groupConfig['stubOracles'], groupConfig['mintInfos'], groupConfig['serum3Markets'], groupConfig['perpMarkets']);
	    }
	    static async fromApi(groupPk) {
	        const groupMetadataApiUrl = 'https://mango-transaction-log.herokuapp.com/v4/group-metadata';
	        const response = await fetch(groupMetadataApiUrl);
	        const jsonData = await response.json();
	        const groupConfig = jsonData.groups.find((group) => group.publicKey === groupPk.toString());
	        return new Id(groupConfig.cluster, groupConfig.name, groupConfig.publicKey, groupConfig.serum3ProgramId, groupConfig.mangoProgramId, groupConfig.tokens.flatMap((t) => t.banks.map((b) => ({
	            name: t.symbol,
	            mint: t.mint,
	            tokenIndex: t.tokenIndex,
	            bankNum: b.bankNum,
	            publicKey: b.publicKey,
	        }))), groupConfig.stubOracles.map((s) => ({
	            mint: s.mint,
	            publicKey: s.publicKey,
	        })), groupConfig.tokens.map((t) => ({
	            name: t.symbol,
	            mint: t.mint,
	            tokenIndex: t.tokenIndex,
	            publicKey: t.mintInfo,
	        })), groupConfig.serum3Markets.map((s) => ({
	            name: s.name,
	            publicKey: s.publicKey,
	            marketExternal: s.marketExternal,
	        })), groupConfig.perpMarkets.map((p) => ({
	            name: p.name,
	            publicKey: p.publicKey,
	        })));
	    }
	}

	const IDL = {
	    "version": "0.6.0",
	    "name": "mango_v4",
	    "instructions": [
	        {
	            "name": "groupCreate",
	            "accounts": [
	                {
	                    "name": "group",
	                    "isMut": true,
	                    "isSigner": false,
	                    "pda": {
	                        "seeds": [
	                            {
	                                "kind": "const",
	                                "type": "string",
	                                "value": "Group"
	                            },
	                            {
	                                "kind": "account",
	                                "type": "publicKey",
	                                "path": "creator"
	                            },
	                            {
	                                "kind": "arg",
	                                "type": "u32",
	                                "path": "group_num"
	                            }
	                        ]
	                    }
	                },
	                {
	                    "name": "creator",
	                    "isMut": false,
	                    "isSigner": true
	                },
	                {
	                    "name": "insuranceMint",
	                    "isMut": false,
	                    "isSigner": false
	                },
	                {
	                    "name": "insuranceVault",
	                    "isMut": true,
	                    "isSigner": false,
	                    "pda": {
	                        "seeds": [
	                            {
	                                "kind": "const",
	                                "type": "string",
	                                "value": "InsuranceVault"
	                            },
	                            {
	                                "kind": "account",
	                                "type": "publicKey",
	                                "path": "group"
	                            }
	                        ]
	                    }
	                },
	                {
	                    "name": "payer",
	                    "isMut": true,
	                    "isSigner": true
	                },
	                {
	                    "name": "tokenProgram",
	                    "isMut": false,
	                    "isSigner": false
	                },
	                {
	                    "name": "systemProgram",
	                    "isMut": false,
	                    "isSigner": false
	                },
	                {
	                    "name": "rent",
	                    "isMut": false,
	                    "isSigner": false
	                }
	            ],
	            "args": [
	                {
	                    "name": "groupNum",
	                    "type": "u32"
	                },
	                {
	                    "name": "testing",
	                    "type": "u8"
	                },
	                {
	                    "name": "version",
	                    "type": "u8"
	                }
	            ]
	        },
	        {
	            "name": "groupEdit",
	            "accounts": [
	                {
	                    "name": "group",
	                    "isMut": true,
	                    "isSigner": false
	                },
	                {
	                    "name": "admin",
	                    "isMut": false,
	                    "isSigner": true
	                }
	            ],
	            "args": [
	                {
	                    "name": "adminOpt",
	                    "type": {
	                        "option": "publicKey"
	                    }
	                },
	                {
	                    "name": "fastListingAdminOpt",
	                    "type": {
	                        "option": "publicKey"
	                    }
	                },
	                {
	                    "name": "securityAdminOpt",
	                    "type": {
	                        "option": "publicKey"
	                    }
	                },
	                {
	                    "name": "testingOpt",
	                    "type": {
	                        "option": "u8"
	                    }
	                },
	                {
	                    "name": "versionOpt",
	                    "type": {
	                        "option": "u8"
	                    }
	                },
	                {
	                    "name": "depositLimitQuoteOpt",
	                    "type": {
	                        "option": "u64"
	                    }
	                }
	            ]
	        },
	        {
	            "name": "ixGateSet",
	            "accounts": [
	                {
	                    "name": "group",
	                    "isMut": true,
	                    "isSigner": false
	                },
	                {
	                    "name": "admin",
	                    "isMut": false,
	                    "isSigner": true
	                }
	            ],
	            "args": [
	                {
	                    "name": "ixGate",
	                    "type": "u128"
	                }
	            ]
	        },
	        {
	            "name": "groupClose",
	            "accounts": [
	                {
	                    "name": "group",
	                    "isMut": true,
	                    "isSigner": false
	                },
	                {
	                    "name": "admin",
	                    "isMut": false,
	                    "isSigner": true
	                },
	                {
	                    "name": "insuranceVault",
	                    "isMut": true,
	                    "isSigner": false
	                },
	                {
	                    "name": "solDestination",
	                    "isMut": true,
	                    "isSigner": false
	                },
	                {
	                    "name": "tokenProgram",
	                    "isMut": false,
	                    "isSigner": false
	                }
	            ],
	            "args": []
	        },
	        {
	            "name": "tokenRegister",
	            "accounts": [
	                {
	                    "name": "group",
	                    "isMut": false,
	                    "isSigner": false
	                },
	                {
	                    "name": "admin",
	                    "isMut": false,
	                    "isSigner": true
	                },
	                {
	                    "name": "mint",
	                    "isMut": false,
	                    "isSigner": false
	                },
	                {
	                    "name": "bank",
	                    "isMut": true,
	                    "isSigner": false,
	                    "pda": {
	                        "seeds": [
	                            {
	                                "kind": "const",
	                                "type": "string",
	                                "value": "Bank"
	                            },
	                            {
	                                "kind": "account",
	                                "type": "publicKey",
	                                "path": "group"
	                            },
	                            {
	                                "kind": "arg",
	                                "type": "u16",
	                                "path": "token_index"
	                            },
	                            {
	                                "kind": "const",
	                                "type": "u32",
	                                "value": 0
	                            }
	                        ]
	                    }
	                },
	                {
	                    "name": "vault",
	                    "isMut": true,
	                    "isSigner": false,
	                    "pda": {
	                        "seeds": [
	                            {
	                                "kind": "const",
	                                "type": "string",
	                                "value": "Vault"
	                            },
	                            {
	                                "kind": "account",
	                                "type": "publicKey",
	                                "path": "group"
	                            },
	                            {
	                                "kind": "arg",
	                                "type": "u16",
	                                "path": "token_index"
	                            },
	                            {
	                                "kind": "const",
	                                "type": "u32",
	                                "value": 0
	                            }
	                        ]
	                    }
	                },
	                {
	                    "name": "mintInfo",
	                    "isMut": true,
	                    "isSigner": false,
	                    "pda": {
	                        "seeds": [
	                            {
	                                "kind": "const",
	                                "type": "string",
	                                "value": "MintInfo"
	                            },
	                            {
	                                "kind": "account",
	                                "type": "publicKey",
	                                "path": "group"
	                            },
	                            {
	                                "kind": "account",
	                                "type": "publicKey",
	                                "account": "Mint",
	                                "path": "mint"
	                            }
	                        ]
	                    }
	                },
	                {
	                    "name": "oracle",
	                    "isMut": false,
	                    "isSigner": false
	                },
	                {
	                    "name": "payer",
	                    "isMut": true,
	                    "isSigner": true
	                },
	                {
	                    "name": "tokenProgram",
	                    "isMut": false,
	                    "isSigner": false
	                },
	                {
	                    "name": "systemProgram",
	                    "isMut": false,
	                    "isSigner": false
	                },
	                {
	                    "name": "rent",
	                    "isMut": false,
	                    "isSigner": false
	                }
	            ],
	            "args": [
	                {
	                    "name": "tokenIndex",
	                    "type": "u16"
	                },
	                {
	                    "name": "name",
	                    "type": "string"
	                },
	                {
	                    "name": "oracleConfig",
	                    "type": {
	                        "defined": "OracleConfigParams"
	                    }
	                },
	                {
	                    "name": "interestRateParams",
	                    "type": {
	                        "defined": "InterestRateParams"
	                    }
	                },
	                {
	                    "name": "loanFeeRate",
	                    "type": "f32"
	                },
	                {
	                    "name": "loanOriginationFeeRate",
	                    "type": "f32"
	                },
	                {
	                    "name": "maintAssetWeight",
	                    "type": "f32"
	                },
	                {
	                    "name": "initAssetWeight",
	                    "type": "f32"
	                },
	                {
	                    "name": "maintLiabWeight",
	                    "type": "f32"
	                },
	                {
	                    "name": "initLiabWeight",
	                    "type": "f32"
	                },
	                {
	                    "name": "liquidationFee",
	                    "type": "f32"
	                },
	                {
	                    "name": "minVaultToDepositsRatio",
	                    "type": "f64"
	                },
	                {
	                    "name": "netBorrowLimitWindowSizeTs",
	                    "type": "u64"
	                },
	                {
	                    "name": "netBorrowLimitPerWindowQuote",
	                    "type": "i64"
	                }
	            ]
	        },
	        {
	            "name": "tokenRegisterTrustless",
	            "accounts": [
	                {
	                    "name": "group",
	                    "isMut": false,
	                    "isSigner": false
	                },
	                {
	                    "name": "fastListingAdmin",
	                    "isMut": false,
	                    "isSigner": true
	                },
	                {
	                    "name": "mint",
	                    "isMut": false,
	                    "isSigner": false
	                },
	                {
	                    "name": "bank",
	                    "isMut": true,
	                    "isSigner": false,
	                    "pda": {
	                        "seeds": [
	                            {
	                                "kind": "const",
	                                "type": "string",
	                                "value": "Bank"
	                            },
	                            {
	                                "kind": "account",
	                                "type": "publicKey",
	                                "path": "group"
	                            },
	                            {
	                                "kind": "arg",
	                                "type": "u16",
	                                "path": "token_index"
	                            },
	                            {
	                                "kind": "const",
	                                "type": "u32",
	                                "value": 0
	                            }
	                        ]
	                    }
	                },
	                {
	                    "name": "vault",
	                    "isMut": true,
	                    "isSigner": false,
	                    "pda": {
	                        "seeds": [
	                            {
	                                "kind": "const",
	                                "type": "string",
	                                "value": "Vault"
	                            },
	                            {
	                                "kind": "account",
	                                "type": "publicKey",
	                                "path": "group"
	                            },
	                            {
	                                "kind": "arg",
	                                "type": "u16",
	                                "path": "token_index"
	                            },
	                            {
	                                "kind": "const",
	                                "type": "u32",
	                                "value": 0
	                            }
	                        ]
	                    }
	                },
	                {
	                    "name": "mintInfo",
	                    "isMut": true,
	                    "isSigner": false,
	                    "pda": {
	                        "seeds": [
	                            {
	                                "kind": "const",
	                                "type": "string",
	                                "value": "MintInfo"
	                            },
	                            {
	                                "kind": "account",
	                                "type": "publicKey",
	                                "path": "group"
	                            },
	                            {
	                                "kind": "account",
	                                "type": "publicKey",
	                                "account": "Mint",
	                                "path": "mint"
	                            }
	                        ]
	                    }
	                },
	                {
	                    "name": "oracle",
	                    "isMut": false,
	                    "isSigner": false
	                },
	                {
	                    "name": "payer",
	                    "isMut": true,
	                    "isSigner": true
	                },
	                {
	                    "name": "tokenProgram",
	                    "isMut": false,
	                    "isSigner": false
	                },
	                {
	                    "name": "systemProgram",
	                    "isMut": false,
	                    "isSigner": false
	                },
	                {
	                    "name": "rent",
	                    "isMut": false,
	                    "isSigner": false
	                }
	            ],
	            "args": [
	                {
	                    "name": "tokenIndex",
	                    "type": "u16"
	                },
	                {
	                    "name": "name",
	                    "type": "string"
	                }
	            ]
	        },
	        {
	            "name": "tokenEdit",
	            "accounts": [
	                {
	                    "name": "group",
	                    "isMut": false,
	                    "isSigner": false
	                },
	                {
	                    "name": "admin",
	                    "isMut": false,
	                    "isSigner": true
	                },
	                {
	                    "name": "mintInfo",
	                    "isMut": true,
	                    "isSigner": false
	                },
	                {
	                    "name": "oracle",
	                    "isMut": false,
	                    "isSigner": false,
	                    "docs": [
	                        "The oracle account is optional and only used when reset_stable_price is set.",
	                        ""
	                    ]
	                }
	            ],
	            "args": [
	                {
	                    "name": "oracleOpt",
	                    "type": {
	                        "option": "publicKey"
	                    }
	                },
	                {
	                    "name": "oracleConfigOpt",
	                    "type": {
	                        "option": {
	                            "defined": "OracleConfigParams"
	                        }
	                    }
	                },
	                {
	                    "name": "groupInsuranceFundOpt",
	                    "type": {
	                        "option": "bool"
	                    }
	                },
	                {
	                    "name": "interestRateParamsOpt",
	                    "type": {
	                        "option": {
	                            "defined": "InterestRateParams"
	                        }
	                    }
	                },
	                {
	                    "name": "loanFeeRateOpt",
	                    "type": {
	                        "option": "f32"
	                    }
	                },
	                {
	                    "name": "loanOriginationFeeRateOpt",
	                    "type": {
	                        "option": "f32"
	                    }
	                },
	                {
	                    "name": "maintAssetWeightOpt",
	                    "type": {
	                        "option": "f32"
	                    }
	                },
	                {
	                    "name": "initAssetWeightOpt",
	                    "type": {
	                        "option": "f32"
	                    }
	                },
	                {
	                    "name": "maintLiabWeightOpt",
	                    "type": {
	                        "option": "f32"
	                    }
	                },
	                {
	                    "name": "initLiabWeightOpt",
	                    "type": {
	                        "option": "f32"
	                    }
	                },
	                {
	                    "name": "liquidationFeeOpt",
	                    "type": {
	                        "option": "f32"
	                    }
	                },
	                {
	                    "name": "stablePriceDelayIntervalSecondsOpt",
	                    "type": {
	                        "option": "u32"
	                    }
	                },
	                {
	                    "name": "stablePriceDelayGrowthLimitOpt",
	                    "type": {
	                        "option": "f32"
	                    }
	                },
	                {
	                    "name": "stablePriceGrowthLimitOpt",
	                    "type": {
	                        "option": "f32"
	                    }
	                },
	                {
	                    "name": "minVaultToDepositsRatioOpt",
	                    "type": {
	                        "option": "f64"
	                    }
	                },
	                {
	                    "name": "netBorrowLimitPerWindowQuoteOpt",
	                    "type": {
	                        "option": "i64"
	                    }
	                },
	                {
	                    "name": "netBorrowLimitWindowSizeTsOpt",
	                    "type": {
	                        "option": "u64"
	                    }
	                },
	                {
	                    "name": "borrowWeightScaleStartQuoteOpt",
	                    "type": {
	                        "option": "f64"
	                    }
	                },
	                {
	                    "name": "depositWeightScaleStartQuoteOpt",
	                    "type": {
	                        "option": "f64"
	                    }
	                },
	                {
	                    "name": "resetStablePrice",
	                    "type": "bool"
	                },
	                {
	                    "name": "resetNetBorrowLimit",
	                    "type": "bool"
	                },
	                {
	                    "name": "reduceOnlyOpt",
	                    "type": {
	                        "option": "bool"
	                    }
	                }
	            ]
	        },
	        {
	            "name": "tokenAddBank",
	            "accounts": [
	                {
	                    "name": "group",
	                    "isMut": false,
	                    "isSigner": false
	                },
	                {
	                    "name": "admin",
	                    "isMut": false,
	                    "isSigner": true
	                },
	                {
	                    "name": "mint",
	                    "isMut": false,
	                    "isSigner": false
	                },
	                {
	                    "name": "existingBank",
	                    "isMut": false,
	                    "isSigner": false
	                },
	                {
	                    "name": "bank",
	                    "isMut": true,
	                    "isSigner": false,
	                    "pda": {
	                        "seeds": [
	                            {
	                                "kind": "const",
	                                "type": "string",
	                                "value": "Bank"
	                            },
	                            {
	                                "kind": "account",
	                                "type": "publicKey",
	                                "path": "group"
	                            },
	                            {
	                                "kind": "arg",
	                                "type": "u16",
	                                "path": "token_index"
	                            },
	                            {
	                                "kind": "arg",
	                                "type": "u32",
	                                "path": "bank_num"
	                            }
	                        ]
	                    }
	                },
	                {
	                    "name": "vault",
	                    "isMut": true,
	                    "isSigner": false,
	                    "pda": {
	                        "seeds": [
	                            {
	                                "kind": "const",
	                                "type": "string",
	                                "value": "Vault"
	                            },
	                            {
	                                "kind": "account",
	                                "type": "publicKey",
	                                "path": "group"
	                            },
	                            {
	                                "kind": "arg",
	                                "type": "u16",
	                                "path": "token_index"
	                            },
	                            {
	                                "kind": "arg",
	                                "type": "u32",
	                                "path": "bank_num"
	                            }
	                        ]
	                    }
	                },
	                {
	                    "name": "mintInfo",
	                    "isMut": true,
	                    "isSigner": false
	                },
	                {
	                    "name": "payer",
	                    "isMut": true,
	                    "isSigner": true
	                },
	                {
	                    "name": "tokenProgram",
	                    "isMut": false,
	                    "isSigner": false
	                },
	                {
	                    "name": "systemProgram",
	                    "isMut": false,
	                    "isSigner": false
	                },
	                {
	                    "name": "rent",
	                    "isMut": false,
	                    "isSigner": false
	                }
	            ],
	            "args": [
	                {
	                    "name": "tokenIndex",
	                    "type": "u16"
	                },
	                {
	                    "name": "bankNum",
	                    "type": "u32"
	                }
	            ]
	        },
	        {
	            "name": "tokenDeregister",
	            "accounts": [
	                {
	                    "name": "group",
	                    "isMut": false,
	                    "isSigner": false
	                },
	                {
	                    "name": "admin",
	                    "isMut": false,
	                    "isSigner": true
	                },
	                {
	                    "name": "mintInfo",
	                    "isMut": true,
	                    "isSigner": false
	                },
	                {
	                    "name": "dustVault",
	                    "isMut": true,
	                    "isSigner": false
	                },
	                {
	                    "name": "solDestination",
	                    "isMut": true,
	                    "isSigner": false
	                },
	                {
	                    "name": "tokenProgram",
	                    "isMut": false,
	                    "isSigner": false
	                }
	            ],
	            "args": []
	        },
	        {
	            "name": "tokenUpdateIndexAndRate",
	            "accounts": [
	                {
	                    "name": "group",
	                    "isMut": false,
	                    "isSigner": false
	                },
	                {
	                    "name": "mintInfo",
	                    "isMut": false,
	                    "isSigner": false
	                },
	                {
	                    "name": "oracle",
	                    "isMut": false,
	                    "isSigner": false
	                },
	                {
	                    "name": "instructions",
	                    "isMut": false,
	                    "isSigner": false
	                }
	            ],
	            "args": []
	        },
	        {
	            "name": "accountCreate",
	            "accounts": [
	                {
	                    "name": "group",
	                    "isMut": false,
	                    "isSigner": false
	                },
	                {
	                    "name": "account",
	                    "isMut": true,
	                    "isSigner": false,
	                    "pda": {
	                        "seeds": [
	                            {
	                                "kind": "const",
	                                "type": "string",
	                                "value": "MangoAccount"
	                            },
	                            {
	                                "kind": "account",
	                                "type": "publicKey",
	                                "path": "group"
	                            },
	                            {
	                                "kind": "account",
	                                "type": "publicKey",
	                                "path": "owner"
	                            },
	                            {
	                                "kind": "arg",
	                                "type": "u32",
	                                "path": "account_num"
	                            }
	                        ]
	                    }
	                },
	                {
	                    "name": "owner",
	                    "isMut": false,
	                    "isSigner": true
	                },
	                {
	                    "name": "payer",
	                    "isMut": true,
	                    "isSigner": true
	                },
	                {
	                    "name": "systemProgram",
	                    "isMut": false,
	                    "isSigner": false
	                }
	            ],
	            "args": [
	                {
	                    "name": "accountNum",
	                    "type": "u32"
	                },
	                {
	                    "name": "tokenCount",
	                    "type": "u8"
	                },
	                {
	                    "name": "serum3Count",
	                    "type": "u8"
	                },
	                {
	                    "name": "perpCount",
	                    "type": "u8"
	                },
	                {
	                    "name": "perpOoCount",
	                    "type": "u8"
	                },
	                {
	                    "name": "name",
	                    "type": "string"
	                }
	            ]
	        },
	        {
	            "name": "accountExpand",
	            "accounts": [
	                {
	                    "name": "group",
	                    "isMut": false,
	                    "isSigner": false
	                },
	                {
	                    "name": "account",
	                    "isMut": true,
	                    "isSigner": false
	                },
	                {
	                    "name": "owner",
	                    "isMut": false,
	                    "isSigner": true
	                },
	                {
	                    "name": "payer",
	                    "isMut": true,
	                    "isSigner": true
	                },
	                {
	                    "name": "systemProgram",
	                    "isMut": false,
	                    "isSigner": false
	                }
	            ],
	            "args": [
	                {
	                    "name": "tokenCount",
	                    "type": "u8"
	                },
	                {
	                    "name": "serum3Count",
	                    "type": "u8"
	                },
	                {
	                    "name": "perpCount",
	                    "type": "u8"
	                },
	                {
	                    "name": "perpOoCount",
	                    "type": "u8"
	                }
	            ]
	        },
	        {
	            "name": "accountEdit",
	            "accounts": [
	                {
	                    "name": "group",
	                    "isMut": false,
	                    "isSigner": false
	                },
	                {
	                    "name": "account",
	                    "isMut": true,
	                    "isSigner": false
	                },
	                {
	                    "name": "owner",
	                    "isMut": false,
	                    "isSigner": true
	                }
	            ],
	            "args": [
	                {
	                    "name": "nameOpt",
	                    "type": {
	                        "option": "string"
	                    }
	                },
	                {
	                    "name": "delegateOpt",
	                    "type": {
	                        "option": "publicKey"
	                    }
	                }
	            ]
	        },
	        {
	            "name": "accountToggleFreeze",
	            "accounts": [
	                {
	                    "name": "group",
	                    "isMut": false,
	                    "isSigner": false
	                },
	                {
	                    "name": "account",
	                    "isMut": true,
	                    "isSigner": false
	                },
	                {
	                    "name": "admin",
	                    "isMut": false,
	                    "isSigner": true
	                }
	            ],
	            "args": [
	                {
	                    "name": "freeze",
	                    "type": "bool"
	                }
	            ]
	        },
	        {
	            "name": "accountClose",
	            "accounts": [
	                {
	                    "name": "group",
	                    "isMut": false,
	                    "isSigner": false
	                },
	                {
	                    "name": "account",
	                    "isMut": true,
	                    "isSigner": false
	                },
	                {
	                    "name": "owner",
	                    "isMut": false,
	                    "isSigner": true
	                },
	                {
	                    "name": "solDestination",
	                    "isMut": true,
	                    "isSigner": false
	                },
	                {
	                    "name": "tokenProgram",
	                    "isMut": false,
	                    "isSigner": false
	                }
	            ],
	            "args": [
	                {
	                    "name": "forceClose",
	                    "type": "bool"
	                }
	            ]
	        },
	        {
	            "name": "stubOracleCreate",
	            "accounts": [
	                {
	                    "name": "group",
	                    "isMut": false,
	                    "isSigner": false
	                },
	                {
	                    "name": "oracle",
	                    "isMut": true,
	                    "isSigner": false,
	                    "pda": {
	                        "seeds": [
	                            {
	                                "kind": "const",
	                                "type": "string",
	                                "value": "StubOracle"
	                            },
	                            {
	                                "kind": "account",
	                                "type": "publicKey",
	                                "path": "group"
	                            },
	                            {
	                                "kind": "account",
	                                "type": "publicKey",
	                                "account": "Mint",
	                                "path": "mint"
	                            }
	                        ]
	                    }
	                },
	                {
	                    "name": "admin",
	                    "isMut": false,
	                    "isSigner": true
	                },
	                {
	                    "name": "mint",
	                    "isMut": false,
	                    "isSigner": false
	                },
	                {
	                    "name": "payer",
	                    "isMut": true,
	                    "isSigner": true
	                },
	                {
	                    "name": "systemProgram",
	                    "isMut": false,
	                    "isSigner": false
	                }
	            ],
	            "args": [
	                {
	                    "name": "price",
	                    "type": {
	                        "defined": "I80F48"
	                    }
	                }
	            ]
	        },
	        {
	            "name": "stubOracleClose",
	            "accounts": [
	                {
	                    "name": "group",
	                    "isMut": false,
	                    "isSigner": false
	                },
	                {
	                    "name": "admin",
	                    "isMut": false,
	                    "isSigner": true
	                },
	                {
	                    "name": "oracle",
	                    "isMut": true,
	                    "isSigner": false
	                },
	                {
	                    "name": "solDestination",
	                    "isMut": true,
	                    "isSigner": false
	                },
	                {
	                    "name": "tokenProgram",
	                    "isMut": false,
	                    "isSigner": false
	                }
	            ],
	            "args": []
	        },
	        {
	            "name": "stubOracleSet",
	            "accounts": [
	                {
	                    "name": "group",
	                    "isMut": false,
	                    "isSigner": false
	                },
	                {
	                    "name": "admin",
	                    "isMut": false,
	                    "isSigner": true
	                },
	                {
	                    "name": "oracle",
	                    "isMut": true,
	                    "isSigner": false
	                }
	            ],
	            "args": [
	                {
	                    "name": "price",
	                    "type": {
	                        "defined": "I80F48"
	                    }
	                }
	            ]
	        },
	        {
	            "name": "tokenDeposit",
	            "accounts": [
	                {
	                    "name": "group",
	                    "isMut": false,
	                    "isSigner": false
	                },
	                {
	                    "name": "account",
	                    "isMut": true,
	                    "isSigner": false
	                },
	                {
	                    "name": "owner",
	                    "isMut": false,
	                    "isSigner": true
	                },
	                {
	                    "name": "bank",
	                    "isMut": true,
	                    "isSigner": false
	                },
	                {
	                    "name": "vault",
	                    "isMut": true,
	                    "isSigner": false
	                },
	                {
	                    "name": "oracle",
	                    "isMut": false,
	                    "isSigner": false
	                },
	                {
	                    "name": "tokenAccount",
	                    "isMut": true,
	                    "isSigner": false
	                },
	                {
	                    "name": "tokenAuthority",
	                    "isMut": false,
	                    "isSigner": true
	                },
	                {
	                    "name": "tokenProgram",
	                    "isMut": false,
	                    "isSigner": false
	                }
	            ],
	            "args": [
	                {
	                    "name": "amount",
	                    "type": "u64"
	                },
	                {
	                    "name": "reduceOnly",
	                    "type": "bool"
	                }
	            ]
	        },
	        {
	            "name": "tokenDepositIntoExisting",
	            "accounts": [
	                {
	                    "name": "group",
	                    "isMut": false,
	                    "isSigner": false
	                },
	                {
	                    "name": "account",
	                    "isMut": true,
	                    "isSigner": false
	                },
	                {
	                    "name": "bank",
	                    "isMut": true,
	                    "isSigner": false
	                },
	                {
	                    "name": "vault",
	                    "isMut": true,
	                    "isSigner": false
	                },
	                {
	                    "name": "oracle",
	                    "isMut": false,
	                    "isSigner": false
	                },
	                {
	                    "name": "tokenAccount",
	                    "isMut": true,
	                    "isSigner": false
	                },
	                {
	                    "name": "tokenAuthority",
	                    "isMut": false,
	                    "isSigner": true
	                },
	                {
	                    "name": "tokenProgram",
	                    "isMut": false,
	                    "isSigner": false
	                }
	            ],
	            "args": [
	                {
	                    "name": "amount",
	                    "type": "u64"
	                },
	                {
	                    "name": "reduceOnly",
	                    "type": "bool"
	                }
	            ]
	        },
	        {
	            "name": "tokenWithdraw",
	            "accounts": [
	                {
	                    "name": "group",
	                    "isMut": false,
	                    "isSigner": false
	                },
	                {
	                    "name": "account",
	                    "isMut": true,
	                    "isSigner": false
	                },
	                {
	                    "name": "owner",
	                    "isMut": false,
	                    "isSigner": true
	                },
	                {
	                    "name": "bank",
	                    "isMut": true,
	                    "isSigner": false
	                },
	                {
	                    "name": "vault",
	                    "isMut": true,
	                    "isSigner": false
	                },
	                {
	                    "name": "oracle",
	                    "isMut": false,
	                    "isSigner": false
	                },
	                {
	                    "name": "tokenAccount",
	                    "isMut": true,
	                    "isSigner": false
	                },
	                {
	                    "name": "tokenProgram",
	                    "isMut": false,
	                    "isSigner": false
	                }
	            ],
	            "args": [
	                {
	                    "name": "amount",
	                    "type": "u64"
	                },
	                {
	                    "name": "allowBorrow",
	                    "type": "bool"
	                }
	            ]
	        },
	        {
	            "name": "flashLoanBegin",
	            "accounts": [
	                {
	                    "name": "account",
	                    "isMut": false,
	                    "isSigner": false
	                },
	                {
	                    "name": "owner",
	                    "isMut": false,
	                    "isSigner": true
	                },
	                {
	                    "name": "tokenProgram",
	                    "isMut": false,
	                    "isSigner": false
	                },
	                {
	                    "name": "instructions",
	                    "isMut": false,
	                    "isSigner": false,
	                    "docs": [
	                        "Instructions Sysvar for instruction introspection"
	                    ]
	                }
	            ],
	            "args": [
	                {
	                    "name": "loanAmounts",
	                    "type": {
	                        "vec": "u64"
	                    }
	                }
	            ]
	        },
	        {
	            "name": "flashLoanEnd",
	            "accounts": [
	                {
	                    "name": "account",
	                    "isMut": true,
	                    "isSigner": false
	                },
	                {
	                    "name": "owner",
	                    "isMut": false,
	                    "isSigner": true
	                },
	                {
	                    "name": "tokenProgram",
	                    "isMut": false,
	                    "isSigner": false
	                }
	            ],
	            "args": [
	                {
	                    "name": "flashLoanType",
	                    "type": {
	                        "defined": "FlashLoanType"
	                    }
	                }
	            ]
	        },
	        {
	            "name": "healthRegionBegin",
	            "accounts": [
	                {
	                    "name": "instructions",
	                    "isMut": false,
	                    "isSigner": false,
	                    "docs": [
	                        "Instructions Sysvar for instruction introspection"
	                    ]
	                },
	                {
	                    "name": "group",
	                    "isMut": false,
	                    "isSigner": false
	                },
	                {
	                    "name": "account",
	                    "isMut": true,
	                    "isSigner": false
	                }
	            ],
	            "args": []
	        },
	        {
	            "name": "healthRegionEnd",
	            "accounts": [
	                {
	                    "name": "account",
	                    "isMut": true,
	                    "isSigner": false
	                }
	            ],
	            "args": []
	        },
	        {
	            "name": "serum3RegisterMarket",
	            "docs": [
	                "",
	                "Serum",
	                ""
	            ],
	            "accounts": [
	                {
	                    "name": "group",
	                    "isMut": true,
	                    "isSigner": false
	                },
	                {
	                    "name": "admin",
	                    "isMut": false,
	                    "isSigner": true
	                },
	                {
	                    "name": "serumProgram",
	                    "isMut": false,
	                    "isSigner": false
	                },
	                {
	                    "name": "serumMarketExternal",
	                    "isMut": false,
	                    "isSigner": false
	                },
	                {
	                    "name": "serumMarket",
	                    "isMut": true,
	                    "isSigner": false,
	                    "pda": {
	                        "seeds": [
	                            {
	                                "kind": "const",
	                                "type": "string",
	                                "value": "Serum3Market"
	                            },
	                            {
	                                "kind": "account",
	                                "type": "publicKey",
	                                "path": "group"
	                            },
	                            {
	                                "kind": "account",
	                                "type": "publicKey",
	                                "path": "serum_market_external"
	                            }
	                        ]
	                    }
	                },
	                {
	                    "name": "indexReservation",
	                    "isMut": true,
	                    "isSigner": false,
	                    "pda": {
	                        "seeds": [
	                            {
	                                "kind": "const",
	                                "type": "string",
	                                "value": "Serum3Index"
	                            },
	                            {
	                                "kind": "account",
	                                "type": "publicKey",
	                                "path": "group"
	                            },
	                            {
	                                "kind": "arg",
	                                "type": "u16",
	                                "path": "market_index"
	                            }
	                        ]
	                    }
	                },
	                {
	                    "name": "quoteBank",
	                    "isMut": false,
	                    "isSigner": false
	                },
	                {
	                    "name": "baseBank",
	                    "isMut": false,
	                    "isSigner": false
	                },
	                {
	                    "name": "payer",
	                    "isMut": true,
	                    "isSigner": true
	                },
	                {
	                    "name": "systemProgram",
	                    "isMut": false,
	                    "isSigner": false
	                }
	            ],
	            "args": [
	                {
	                    "name": "marketIndex",
	                    "type": "u16"
	                },
	                {
	                    "name": "name",
	                    "type": "string"
	                }
	            ]
	        },
	        {
	            "name": "serum3EditMarket",
	            "accounts": [
	                {
	                    "name": "group",
	                    "isMut": false,
	                    "isSigner": false
	                },
	                {
	                    "name": "admin",
	                    "isMut": false,
	                    "isSigner": true
	                },
	                {
	                    "name": "market",
	                    "isMut": true,
	                    "isSigner": false
	                }
	            ],
	            "args": [
	                {
	                    "name": "reduceOnlyOpt",
	                    "type": {
	                        "option": "bool"
	                    }
	                }
	            ]
	        },
	        {
	            "name": "serum3DeregisterMarket",
	            "accounts": [
	                {
	                    "name": "group",
	                    "isMut": true,
	                    "isSigner": false
	                },
	                {
	                    "name": "admin",
	                    "isMut": false,
	                    "isSigner": true
	                },
	                {
	                    "name": "serumMarket",
	                    "isMut": true,
	                    "isSigner": false
	                },
	                {
	                    "name": "indexReservation",
	                    "isMut": true,
	                    "isSigner": false
	                },
	                {
	                    "name": "solDestination",
	                    "isMut": true,
	                    "isSigner": false
	                },
	                {
	                    "name": "tokenProgram",
	                    "isMut": false,
	                    "isSigner": false
	                }
	            ],
	            "args": []
	        },
	        {
	            "name": "serum3CreateOpenOrders",
	            "accounts": [
	                {
	                    "name": "group",
	                    "isMut": false,
	                    "isSigner": false
	                },
	                {
	                    "name": "account",
	                    "isMut": true,
	                    "isSigner": false
	                },
	                {
	                    "name": "owner",
	                    "isMut": false,
	                    "isSigner": true
	                },
	                {
	                    "name": "serumMarket",
	                    "isMut": false,
	                    "isSigner": false
	                },
	                {
	                    "name": "serumProgram",
	                    "isMut": false,
	                    "isSigner": false
	                },
	                {
	                    "name": "serumMarketExternal",
	                    "isMut": false,
	                    "isSigner": false
	                },
	                {
	                    "name": "openOrders",
	                    "isMut": true,
	                    "isSigner": false,
	                    "pda": {
	                        "seeds": [
	                            {
	                                "kind": "const",
	                                "type": "string",
	                                "value": "Serum3OO"
	                            },
	                            {
	                                "kind": "account",
	                                "type": "publicKey",
	                                "path": "account"
	                            },
	                            {
	                                "kind": "account",
	                                "type": "publicKey",
	                                "path": "serum_market"
	                            }
	                        ]
	                    }
	                },
	                {
	                    "name": "payer",
	                    "isMut": true,
	                    "isSigner": true
	                },
	                {
	                    "name": "systemProgram",
	                    "isMut": false,
	                    "isSigner": false
	                },
	                {
	                    "name": "rent",
	                    "isMut": false,
	                    "isSigner": false
	                }
	            ],
	            "args": []
	        },
	        {
	            "name": "serum3CloseOpenOrders",
	            "accounts": [
	                {
	                    "name": "group",
	                    "isMut": false,
	                    "isSigner": false
	                },
	                {
	                    "name": "account",
	                    "isMut": true,
	                    "isSigner": false
	                },
	                {
	                    "name": "owner",
	                    "isMut": false,
	                    "isSigner": true
	                },
	                {
	                    "name": "serumMarket",
	                    "isMut": false,
	                    "isSigner": false
	                },
	                {
	                    "name": "serumProgram",
	                    "isMut": false,
	                    "isSigner": false
	                },
	                {
	                    "name": "serumMarketExternal",
	                    "isMut": false,
	                    "isSigner": false
	                },
	                {
	                    "name": "openOrders",
	                    "isMut": true,
	                    "isSigner": false
	                },
	                {
	                    "name": "solDestination",
	                    "isMut": true,
	                    "isSigner": false
	                }
	            ],
	            "args": []
	        },
	        {
	            "name": "serum3PlaceOrder",
	            "accounts": [
	                {
	                    "name": "group",
	                    "isMut": false,
	                    "isSigner": false
	                },
	                {
	                    "name": "account",
	                    "isMut": true,
	                    "isSigner": false
	                },
	                {
	                    "name": "owner",
	                    "isMut": false,
	                    "isSigner": true
	                },
	                {
	                    "name": "openOrders",
	                    "isMut": true,
	                    "isSigner": false
	                },
	                {
	                    "name": "serumMarket",
	                    "isMut": false,
	                    "isSigner": false
	                },
	                {
	                    "name": "serumProgram",
	                    "isMut": false,
	                    "isSigner": false
	                },
	                {
	                    "name": "serumMarketExternal",
	                    "isMut": true,
	                    "isSigner": false
	                },
	                {
	                    "name": "marketBids",
	                    "isMut": true,
	                    "isSigner": false
	                },
	                {
	                    "name": "marketAsks",
	                    "isMut": true,
	                    "isSigner": false
	                },
	                {
	                    "name": "marketEventQueue",
	                    "isMut": true,
	                    "isSigner": false
	                },
	                {
	                    "name": "marketRequestQueue",
	                    "isMut": true,
	                    "isSigner": false
	                },
	                {
	                    "name": "marketBaseVault",
	                    "isMut": true,
	                    "isSigner": false
	                },
	                {
	                    "name": "marketQuoteVault",
	                    "isMut": true,
	                    "isSigner": false
	                },
	                {
	                    "name": "marketVaultSigner",
	                    "isMut": false,
	                    "isSigner": false,
	                    "docs": [
	                        "needed for the automatic settle_funds call"
	                    ]
	                },
	                {
	                    "name": "payerBank",
	                    "isMut": true,
	                    "isSigner": false,
	                    "docs": [
	                        "The bank that pays for the order, if necessary"
	                    ]
	                },
	                {
	                    "name": "payerVault",
	                    "isMut": true,
	                    "isSigner": false,
	                    "docs": [
	                        "The bank vault that pays for the order, if necessary"
	                    ]
	                },
	                {
	                    "name": "payerOracle",
	                    "isMut": false,
	                    "isSigner": false
	                },
	                {
	                    "name": "tokenProgram",
	                    "isMut": false,
	                    "isSigner": false
	                }
	            ],
	            "args": [
	                {
	                    "name": "side",
	                    "type": {
	                        "defined": "Serum3Side"
	                    }
	                },
	                {
	                    "name": "limitPrice",
	                    "type": "u64"
	                },
	                {
	                    "name": "maxBaseQty",
	                    "type": "u64"
	                },
	                {
	                    "name": "maxNativeQuoteQtyIncludingFees",
	                    "type": "u64"
	                },
	                {
	                    "name": "selfTradeBehavior",
	                    "type": {
	                        "defined": "Serum3SelfTradeBehavior"
	                    }
	                },
	                {
	                    "name": "orderType",
	                    "type": {
	                        "defined": "Serum3OrderType"
	                    }
	                },
	                {
	                    "name": "clientOrderId",
	                    "type": "u64"
	                },
	                {
	                    "name": "limit",
	                    "type": "u16"
	                }
	            ]
	        },
	        {
	            "name": "serum3CancelOrder",
	            "accounts": [
	                {
	                    "name": "group",
	                    "isMut": false,
	                    "isSigner": false
	                },
	                {
	                    "name": "account",
	                    "isMut": true,
	                    "isSigner": false
	                },
	                {
	                    "name": "owner",
	                    "isMut": false,
	                    "isSigner": true
	                },
	                {
	                    "name": "openOrders",
	                    "isMut": true,
	                    "isSigner": false
	                },
	                {
	                    "name": "serumMarket",
	                    "isMut": false,
	                    "isSigner": false
	                },
	                {
	                    "name": "serumProgram",
	                    "isMut": false,
	                    "isSigner": false
	                },
	                {
	                    "name": "serumMarketExternal",
	                    "isMut": true,
	                    "isSigner": false
	                },
	                {
	                    "name": "marketBids",
	                    "isMut": true,
	                    "isSigner": false
	                },
	                {
	                    "name": "marketAsks",
	                    "isMut": true,
	                    "isSigner": false
	                },
	                {
	                    "name": "marketEventQueue",
	                    "isMut": true,
	                    "isSigner": false
	                }
	            ],
	            "args": [
	                {
	                    "name": "side",
	                    "type": {
	                        "defined": "Serum3Side"
	                    }
	                },
	                {
	                    "name": "orderId",
	                    "type": "u128"
	                }
	            ]
	        },
	        {
	            "name": "serum3CancelAllOrders",
	            "accounts": [
	                {
	                    "name": "group",
	                    "isMut": false,
	                    "isSigner": false
	                },
	                {
	                    "name": "account",
	                    "isMut": false,
	                    "isSigner": false
	                },
	                {
	                    "name": "owner",
	                    "isMut": false,
	                    "isSigner": true
	                },
	                {
	                    "name": "openOrders",
	                    "isMut": true,
	                    "isSigner": false
	                },
	                {
	                    "name": "serumMarket",
	                    "isMut": false,
	                    "isSigner": false
	                },
	                {
	                    "name": "serumProgram",
	                    "isMut": false,
	                    "isSigner": false
	                },
	                {
	                    "name": "serumMarketExternal",
	                    "isMut": true,
	                    "isSigner": false
	                },
	                {
	                    "name": "marketBids",
	                    "isMut": true,
	                    "isSigner": false
	                },
	                {
	                    "name": "marketAsks",
	                    "isMut": true,
	                    "isSigner": false
	                },
	                {
	                    "name": "marketEventQueue",
	                    "isMut": true,
	                    "isSigner": false
	                }
	            ],
	            "args": [
	                {
	                    "name": "limit",
	                    "type": "u8"
	                }
	            ]
	        },
	        {
	            "name": "serum3SettleFunds",
	            "accounts": [
	                {
	                    "name": "group",
	                    "isMut": false,
	                    "isSigner": false
	                },
	                {
	                    "name": "account",
	                    "isMut": true,
	                    "isSigner": false
	                },
	                {
	                    "name": "owner",
	                    "isMut": false,
	                    "isSigner": true
	                },
	                {
	                    "name": "openOrders",
	                    "isMut": true,
	                    "isSigner": false
	                },
	                {
	                    "name": "serumMarket",
	                    "isMut": false,
	                    "isSigner": false
	                },
	                {
	                    "name": "serumProgram",
	                    "isMut": false,
	                    "isSigner": false
	                },
	                {
	                    "name": "serumMarketExternal",
	                    "isMut": true,
	                    "isSigner": false
	                },
	                {
	                    "name": "marketBaseVault",
	                    "isMut": true,
	                    "isSigner": false
	                },
	                {
	                    "name": "marketQuoteVault",
	                    "isMut": true,
	                    "isSigner": false
	                },
	                {
	                    "name": "marketVaultSigner",
	                    "isMut": false,
	                    "isSigner": false,
	                    "docs": [
	                        "needed for the automatic settle_funds call"
	                    ]
	                },
	                {
	                    "name": "quoteBank",
	                    "isMut": true,
	                    "isSigner": false
	                },
	                {
	                    "name": "quoteVault",
	                    "isMut": true,
	                    "isSigner": false
	                },
	                {
	                    "name": "baseBank",
	                    "isMut": true,
	                    "isSigner": false
	                },
	                {
	                    "name": "baseVault",
	                    "isMut": true,
	                    "isSigner": false
	                },
	                {
	                    "name": "tokenProgram",
	                    "isMut": false,
	                    "isSigner": false
	                }
	            ],
	            "args": []
	        },
	        {
	            "name": "serum3LiqForceCancelOrders",
	            "accounts": [
	                {
	                    "name": "group",
	                    "isMut": false,
	                    "isSigner": false
	                },
	                {
	                    "name": "account",
	                    "isMut": true,
	                    "isSigner": false
	                },
	                {
	                    "name": "openOrders",
	                    "isMut": true,
	                    "isSigner": false
	                },
	                {
	                    "name": "serumMarket",
	                    "isMut": false,
	                    "isSigner": false
	                },
	                {
	                    "name": "serumProgram",
	                    "isMut": false,
	                    "isSigner": false
	                },
	                {
	                    "name": "serumMarketExternal",
	                    "isMut": true,
	                    "isSigner": false
	                },
	                {
	                    "name": "marketBids",
	                    "isMut": true,
	                    "isSigner": false
	                },
	                {
	                    "name": "marketAsks",
	                    "isMut": true,
	                    "isSigner": false
	                },
	                {
	                    "name": "marketEventQueue",
	                    "isMut": true,
	                    "isSigner": false
	                },
	                {
	                    "name": "marketBaseVault",
	                    "isMut": true,
	                    "isSigner": false
	                },
	                {
	                    "name": "marketQuoteVault",
	                    "isMut": true,
	                    "isSigner": false
	                },
	                {
	                    "name": "marketVaultSigner",
	                    "isMut": false,
	                    "isSigner": false
	                },
	                {
	                    "name": "quoteBank",
	                    "isMut": true,
	                    "isSigner": false
	                },
	                {
	                    "name": "quoteVault",
	                    "isMut": true,
	                    "isSigner": false
	                },
	                {
	                    "name": "baseBank",
	                    "isMut": true,
	                    "isSigner": false
	                },
	                {
	                    "name": "baseVault",
	                    "isMut": true,
	                    "isSigner": false
	                },
	                {
	                    "name": "tokenProgram",
	                    "isMut": false,
	                    "isSigner": false
	                }
	            ],
	            "args": [
	                {
	                    "name": "limit",
	                    "type": "u8"
	                }
	            ]
	        },
	        {
	            "name": "liqTokenWithToken",
	            "accounts": [
	                {
	                    "name": "group",
	                    "isMut": false,
	                    "isSigner": false
	                },
	                {
	                    "name": "liqor",
	                    "isMut": true,
	                    "isSigner": false
	                },
	                {
	                    "name": "liqorOwner",
	                    "isMut": false,
	                    "isSigner": true
	                },
	                {
	                    "name": "liqee",
	                    "isMut": true,
	                    "isSigner": false
	                }
	            ],
	            "args": [
	                {
	                    "name": "assetTokenIndex",
	                    "type": "u16"
	                },
	                {
	                    "name": "liabTokenIndex",
	                    "type": "u16"
	                },
	                {
	                    "name": "maxLiabTransfer",
	                    "type": {
	                        "defined": "I80F48"
	                    }
	                }
	            ]
	        },
	        {
	            "name": "liqTokenBankruptcy",
	            "accounts": [
	                {
	                    "name": "group",
	                    "isMut": false,
	                    "isSigner": false
	                },
	                {
	                    "name": "liqor",
	                    "isMut": true,
	                    "isSigner": false
	                },
	                {
	                    "name": "liqorOwner",
	                    "isMut": false,
	                    "isSigner": true
	                },
	                {
	                    "name": "liqee",
	                    "isMut": true,
	                    "isSigner": false
	                },
	                {
	                    "name": "liabMintInfo",
	                    "isMut": false,
	                    "isSigner": false
	                },
	                {
	                    "name": "quoteVault",
	                    "isMut": true,
	                    "isSigner": false
	                },
	                {
	                    "name": "insuranceVault",
	                    "isMut": true,
	                    "isSigner": false
	                },
	                {
	                    "name": "tokenProgram",
	                    "isMut": false,
	                    "isSigner": false
	                }
	            ],
	            "args": [
	                {
	                    "name": "maxLiabTransfer",
	                    "type": {
	                        "defined": "I80F48"
	                    }
	                }
	            ]
	        },
	        {
	            "name": "tokenLiqWithToken",
	            "accounts": [
	                {
	                    "name": "group",
	                    "isMut": false,
	                    "isSigner": false
	                },
	                {
	                    "name": "liqor",
	                    "isMut": true,
	                    "isSigner": false
	                },
	                {
	                    "name": "liqorOwner",
	                    "isMut": false,
	                    "isSigner": true
	                },
	                {
	                    "name": "liqee",
	                    "isMut": true,
	                    "isSigner": false
	                }
	            ],
	            "args": [
	                {
	                    "name": "assetTokenIndex",
	                    "type": "u16"
	                },
	                {
	                    "name": "liabTokenIndex",
	                    "type": "u16"
	                },
	                {
	                    "name": "maxLiabTransfer",
	                    "type": {
	                        "defined": "I80F48"
	                    }
	                }
	            ]
	        },
	        {
	            "name": "tokenLiqBankruptcy",
	            "accounts": [
	                {
	                    "name": "group",
	                    "isMut": false,
	                    "isSigner": false
	                },
	                {
	                    "name": "liqor",
	                    "isMut": true,
	                    "isSigner": false
	                },
	                {
	                    "name": "liqorOwner",
	                    "isMut": false,
	                    "isSigner": true
	                },
	                {
	                    "name": "liqee",
	                    "isMut": true,
	                    "isSigner": false
	                },
	                {
	                    "name": "liabMintInfo",
	                    "isMut": false,
	                    "isSigner": false
	                },
	                {
	                    "name": "quoteVault",
	                    "isMut": true,
	                    "isSigner": false
	                },
	                {
	                    "name": "insuranceVault",
	                    "isMut": true,
	                    "isSigner": false
	                },
	                {
	                    "name": "tokenProgram",
	                    "isMut": false,
	                    "isSigner": false
	                }
	            ],
	            "args": [
	                {
	                    "name": "maxLiabTransfer",
	                    "type": {
	                        "defined": "I80F48"
	                    }
	                }
	            ]
	        },
	        {
	            "name": "perpCreateMarket",
	            "docs": [
	                "",
	                "Perps",
	                ""
	            ],
	            "accounts": [
	                {
	                    "name": "group",
	                    "isMut": false,
	                    "isSigner": false
	                },
	                {
	                    "name": "admin",
	                    "isMut": false,
	                    "isSigner": true
	                },
	                {
	                    "name": "oracle",
	                    "isMut": false,
	                    "isSigner": false
	                },
	                {
	                    "name": "perpMarket",
	                    "isMut": true,
	                    "isSigner": false,
	                    "pda": {
	                        "seeds": [
	                            {
	                                "kind": "const",
	                                "type": "string",
	                                "value": "PerpMarket"
	                            },
	                            {
	                                "kind": "account",
	                                "type": "publicKey",
	                                "path": "group"
	                            },
	                            {
	                                "kind": "arg",
	                                "type": "u16",
	                                "path": "perp_market_index"
	                            }
	                        ]
	                    }
	                },
	                {
	                    "name": "bids",
	                    "isMut": true,
	                    "isSigner": false,
	                    "docs": [
	                        "Accounts are initialised by client,",
	                        "anchor discriminator is set first when ix exits,"
	                    ]
	                },
	                {
	                    "name": "asks",
	                    "isMut": true,
	                    "isSigner": false
	                },
	                {
	                    "name": "eventQueue",
	                    "isMut": true,
	                    "isSigner": false
	                },
	                {
	                    "name": "payer",
	                    "isMut": true,
	                    "isSigner": true
	                },
	                {
	                    "name": "systemProgram",
	                    "isMut": false,
	                    "isSigner": false
	                }
	            ],
	            "args": [
	                {
	                    "name": "perpMarketIndex",
	                    "type": "u16"
	                },
	                {
	                    "name": "name",
	                    "type": "string"
	                },
	                {
	                    "name": "oracleConfig",
	                    "type": {
	                        "defined": "OracleConfigParams"
	                    }
	                },
	                {
	                    "name": "baseDecimals",
	                    "type": "u8"
	                },
	                {
	                    "name": "quoteLotSize",
	                    "type": "i64"
	                },
	                {
	                    "name": "baseLotSize",
	                    "type": "i64"
	                },
	                {
	                    "name": "maintBaseAssetWeight",
	                    "type": "f32"
	                },
	                {
	                    "name": "initBaseAssetWeight",
	                    "type": "f32"
	                },
	                {
	                    "name": "maintBaseLiabWeight",
	                    "type": "f32"
	                },
	                {
	                    "name": "initBaseLiabWeight",
	                    "type": "f32"
	                },
	                {
	                    "name": "maintOverallAssetWeight",
	                    "type": "f32"
	                },
	                {
	                    "name": "initOverallAssetWeight",
	                    "type": "f32"
	                },
	                {
	                    "name": "baseLiquidationFee",
	                    "type": "f32"
	                },
	                {
	                    "name": "makerFee",
	                    "type": "f32"
	                },
	                {
	                    "name": "takerFee",
	                    "type": "f32"
	                },
	                {
	                    "name": "minFunding",
	                    "type": "f32"
	                },
	                {
	                    "name": "maxFunding",
	                    "type": "f32"
	                },
	                {
	                    "name": "impactQuantity",
	                    "type": "i64"
	                },
	                {
	                    "name": "groupInsuranceFund",
	                    "type": "bool"
	                },
	                {
	                    "name": "feePenalty",
	                    "type": "f32"
	                },
	                {
	                    "name": "settleFeeFlat",
	                    "type": "f32"
	                },
	                {
	                    "name": "settleFeeAmountThreshold",
	                    "type": "f32"
	                },
	                {
	                    "name": "settleFeeFractionLowHealth",
	                    "type": "f32"
	                },
	                {
	                    "name": "settleTokenIndex",
	                    "type": "u16"
	                },
	                {
	                    "name": "settlePnlLimitFactor",
	                    "type": "f32"
	                },
	                {
	                    "name": "settlePnlLimitWindowSizeTs",
	                    "type": "u64"
	                },
	                {
	                    "name": "positivePnlLiquidationFee",
	                    "type": "f32"
	                }
	            ]
	        },
	        {
	            "name": "perpEditMarket",
	            "accounts": [
	                {
	                    "name": "group",
	                    "isMut": false,
	                    "isSigner": false
	                },
	                {
	                    "name": "admin",
	                    "isMut": false,
	                    "isSigner": true
	                },
	                {
	                    "name": "perpMarket",
	                    "isMut": true,
	                    "isSigner": false
	                },
	                {
	                    "name": "oracle",
	                    "isMut": false,
	                    "isSigner": false,
	                    "docs": [
	                        "The oracle account is optional and only used when reset_stable_price is set.",
	                        ""
	                    ]
	                }
	            ],
	            "args": [
	                {
	                    "name": "oracleOpt",
	                    "type": {
	                        "option": "publicKey"
	                    }
	                },
	                {
	                    "name": "oracleConfigOpt",
	                    "type": {
	                        "option": {
	                            "defined": "OracleConfigParams"
	                        }
	                    }
	                },
	                {
	                    "name": "baseDecimalsOpt",
	                    "type": {
	                        "option": "u8"
	                    }
	                },
	                {
	                    "name": "maintBaseAssetWeightOpt",
	                    "type": {
	                        "option": "f32"
	                    }
	                },
	                {
	                    "name": "initBaseAssetWeightOpt",
	                    "type": {
	                        "option": "f32"
	                    }
	                },
	                {
	                    "name": "maintBaseLiabWeightOpt",
	                    "type": {
	                        "option": "f32"
	                    }
	                },
	                {
	                    "name": "initBaseLiabWeightOpt",
	                    "type": {
	                        "option": "f32"
	                    }
	                },
	                {
	                    "name": "maintOverallAssetWeightOpt",
	                    "type": {
	                        "option": "f32"
	                    }
	                },
	                {
	                    "name": "initOverallAssetWeightOpt",
	                    "type": {
	                        "option": "f32"
	                    }
	                },
	                {
	                    "name": "baseLiquidationFeeOpt",
	                    "type": {
	                        "option": "f32"
	                    }
	                },
	                {
	                    "name": "makerFeeOpt",
	                    "type": {
	                        "option": "f32"
	                    }
	                },
	                {
	                    "name": "takerFeeOpt",
	                    "type": {
	                        "option": "f32"
	                    }
	                },
	                {
	                    "name": "minFundingOpt",
	                    "type": {
	                        "option": "f32"
	                    }
	                },
	                {
	                    "name": "maxFundingOpt",
	                    "type": {
	                        "option": "f32"
	                    }
	                },
	                {
	                    "name": "impactQuantityOpt",
	                    "type": {
	                        "option": "i64"
	                    }
	                },
	                {
	                    "name": "groupInsuranceFundOpt",
	                    "type": {
	                        "option": "bool"
	                    }
	                },
	                {
	                    "name": "feePenaltyOpt",
	                    "type": {
	                        "option": "f32"
	                    }
	                },
	                {
	                    "name": "settleFeeFlatOpt",
	                    "type": {
	                        "option": "f32"
	                    }
	                },
	                {
	                    "name": "settleFeeAmountThresholdOpt",
	                    "type": {
	                        "option": "f32"
	                    }
	                },
	                {
	                    "name": "settleFeeFractionLowHealthOpt",
	                    "type": {
	                        "option": "f32"
	                    }
	                },
	                {
	                    "name": "stablePriceDelayIntervalSecondsOpt",
	                    "type": {
	                        "option": "u32"
	                    }
	                },
	                {
	                    "name": "stablePriceDelayGrowthLimitOpt",
	                    "type": {
	                        "option": "f32"
	                    }
	                },
	                {
	                    "name": "stablePriceGrowthLimitOpt",
	                    "type": {
	                        "option": "f32"
	                    }
	                },
	                {
	                    "name": "settlePnlLimitFactorOpt",
	                    "type": {
	                        "option": "f32"
	                    }
	                },
	                {
	                    "name": "settlePnlLimitWindowSizeTsOpt",
	                    "type": {
	                        "option": "u64"
	                    }
	                },
	                {
	                    "name": "reduceOnlyOpt",
	                    "type": {
	                        "option": "bool"
	                    }
	                },
	                {
	                    "name": "resetStablePrice",
	                    "type": "bool"
	                },
	                {
	                    "name": "positivePnlLiquidationFeeOpt",
	                    "type": {
	                        "option": "f32"
	                    }
	                }
	            ]
	        },
	        {
	            "name": "perpCloseMarket",
	            "accounts": [
	                {
	                    "name": "group",
	                    "isMut": false,
	                    "isSigner": false
	                },
	                {
	                    "name": "admin",
	                    "isMut": false,
	                    "isSigner": true
	                },
	                {
	                    "name": "perpMarket",
	                    "isMut": true,
	                    "isSigner": false
	                },
	                {
	                    "name": "bids",
	                    "isMut": true,
	                    "isSigner": false
	                },
	                {
	                    "name": "asks",
	                    "isMut": true,
	                    "isSigner": false
	                },
	                {
	                    "name": "eventQueue",
	                    "isMut": true,
	                    "isSigner": false
	                },
	                {
	                    "name": "solDestination",
	                    "isMut": true,
	                    "isSigner": false
	                },
	                {
	                    "name": "tokenProgram",
	                    "isMut": false,
	                    "isSigner": false
	                }
	            ],
	            "args": []
	        },
	        {
	            "name": "perpDeactivatePosition",
	            "accounts": [
	                {
	                    "name": "group",
	                    "isMut": false,
	                    "isSigner": false
	                },
	                {
	                    "name": "account",
	                    "isMut": true,
	                    "isSigner": false
	                },
	                {
	                    "name": "owner",
	                    "isMut": false,
	                    "isSigner": true
	                },
	                {
	                    "name": "perpMarket",
	                    "isMut": false,
	                    "isSigner": false
	                }
	            ],
	            "args": []
	        },
	        {
	            "name": "perpPlaceOrder",
	            "accounts": [
	                {
	                    "name": "group",
	                    "isMut": false,
	                    "isSigner": false
	                },
	                {
	                    "name": "account",
	                    "isMut": true,
	                    "isSigner": false
	                },
	                {
	                    "name": "owner",
	                    "isMut": false,
	                    "isSigner": true
	                },
	                {
	                    "name": "perpMarket",
	                    "isMut": true,
	                    "isSigner": false
	                },
	                {
	                    "name": "bids",
	                    "isMut": true,
	                    "isSigner": false
	                },
	                {
	                    "name": "asks",
	                    "isMut": true,
	                    "isSigner": false
	                },
	                {
	                    "name": "eventQueue",
	                    "isMut": true,
	                    "isSigner": false
	                },
	                {
	                    "name": "oracle",
	                    "isMut": false,
	                    "isSigner": false
	                }
	            ],
	            "args": [
	                {
	                    "name": "side",
	                    "type": {
	                        "defined": "Side"
	                    }
	                },
	                {
	                    "name": "priceLots",
	                    "type": "i64"
	                },
	                {
	                    "name": "maxBaseLots",
	                    "type": "i64"
	                },
	                {
	                    "name": "maxQuoteLots",
	                    "type": "i64"
	                },
	                {
	                    "name": "clientOrderId",
	                    "type": "u64"
	                },
	                {
	                    "name": "orderType",
	                    "type": {
	                        "defined": "PlaceOrderType"
	                    }
	                },
	                {
	                    "name": "reduceOnly",
	                    "type": "bool"
	                },
	                {
	                    "name": "expiryTimestamp",
	                    "type": "u64"
	                },
	                {
	                    "name": "limit",
	                    "type": "u8"
	                }
	            ],
	            "returns": {
	                "option": "u128"
	            }
	        },
	        {
	            "name": "perpPlaceOrderPegged",
	            "accounts": [
	                {
	                    "name": "group",
	                    "isMut": false,
	                    "isSigner": false
	                },
	                {
	                    "name": "account",
	                    "isMut": true,
	                    "isSigner": false
	                },
	                {
	                    "name": "owner",
	                    "isMut": false,
	                    "isSigner": true
	                },
	                {
	                    "name": "perpMarket",
	                    "isMut": true,
	                    "isSigner": false
	                },
	                {
	                    "name": "bids",
	                    "isMut": true,
	                    "isSigner": false
	                },
	                {
	                    "name": "asks",
	                    "isMut": true,
	                    "isSigner": false
	                },
	                {
	                    "name": "eventQueue",
	                    "isMut": true,
	                    "isSigner": false
	                },
	                {
	                    "name": "oracle",
	                    "isMut": false,
	                    "isSigner": false
	                }
	            ],
	            "args": [
	                {
	                    "name": "side",
	                    "type": {
	                        "defined": "Side"
	                    }
	                },
	                {
	                    "name": "priceOffsetLots",
	                    "type": "i64"
	                },
	                {
	                    "name": "pegLimit",
	                    "type": "i64"
	                },
	                {
	                    "name": "maxBaseLots",
	                    "type": "i64"
	                },
	                {
	                    "name": "maxQuoteLots",
	                    "type": "i64"
	                },
	                {
	                    "name": "clientOrderId",
	                    "type": "u64"
	                },
	                {
	                    "name": "orderType",
	                    "type": {
	                        "defined": "PlaceOrderType"
	                    }
	                },
	                {
	                    "name": "reduceOnly",
	                    "type": "bool"
	                },
	                {
	                    "name": "expiryTimestamp",
	                    "type": "u64"
	                },
	                {
	                    "name": "limit",
	                    "type": "u8"
	                },
	                {
	                    "name": "maxOracleStalenessSlots",
	                    "type": "i32"
	                }
	            ],
	            "returns": {
	                "option": "u128"
	            }
	        },
	        {
	            "name": "perpCancelOrder",
	            "accounts": [
	                {
	                    "name": "group",
	                    "isMut": false,
	                    "isSigner": false
	                },
	                {
	                    "name": "account",
	                    "isMut": true,
	                    "isSigner": false
	                },
	                {
	                    "name": "owner",
	                    "isMut": false,
	                    "isSigner": true
	                },
	                {
	                    "name": "perpMarket",
	                    "isMut": true,
	                    "isSigner": false
	                },
	                {
	                    "name": "bids",
	                    "isMut": true,
	                    "isSigner": false
	                },
	                {
	                    "name": "asks",
	                    "isMut": true,
	                    "isSigner": false
	                }
	            ],
	            "args": [
	                {
	                    "name": "orderId",
	                    "type": "u128"
	                }
	            ]
	        },
	        {
	            "name": "perpCancelOrderByClientOrderId",
	            "accounts": [
	                {
	                    "name": "group",
	                    "isMut": false,
	                    "isSigner": false
	                },
	                {
	                    "name": "account",
	                    "isMut": true,
	                    "isSigner": false
	                },
	                {
	                    "name": "owner",
	                    "isMut": false,
	                    "isSigner": true
	                },
	                {
	                    "name": "perpMarket",
	                    "isMut": true,
	                    "isSigner": false
	                },
	                {
	                    "name": "bids",
	                    "isMut": true,
	                    "isSigner": false
	                },
	                {
	                    "name": "asks",
	                    "isMut": true,
	                    "isSigner": false
	                }
	            ],
	            "args": [
	                {
	                    "name": "clientOrderId",
	                    "type": "u64"
	                }
	            ]
	        },
	        {
	            "name": "perpCancelAllOrders",
	            "accounts": [
	                {
	                    "name": "group",
	                    "isMut": false,
	                    "isSigner": false
	                },
	                {
	                    "name": "account",
	                    "isMut": true,
	                    "isSigner": false
	                },
	                {
	                    "name": "owner",
	                    "isMut": false,
	                    "isSigner": true
	                },
	                {
	                    "name": "perpMarket",
	                    "isMut": true,
	                    "isSigner": false
	                },
	                {
	                    "name": "bids",
	                    "isMut": true,
	                    "isSigner": false
	                },
	                {
	                    "name": "asks",
	                    "isMut": true,
	                    "isSigner": false
	                }
	            ],
	            "args": [
	                {
	                    "name": "limit",
	                    "type": "u8"
	                }
	            ]
	        },
	        {
	            "name": "perpCancelAllOrdersBySide",
	            "accounts": [
	                {
	                    "name": "group",
	                    "isMut": false,
	                    "isSigner": false
	                },
	                {
	                    "name": "account",
	                    "isMut": true,
	                    "isSigner": false
	                },
	                {
	                    "name": "owner",
	                    "isMut": false,
	                    "isSigner": true
	                },
	                {
	                    "name": "perpMarket",
	                    "isMut": true,
	                    "isSigner": false
	                },
	                {
	                    "name": "bids",
	                    "isMut": true,
	                    "isSigner": false
	                },
	                {
	                    "name": "asks",
	                    "isMut": true,
	                    "isSigner": false
	                }
	            ],
	            "args": [
	                {
	                    "name": "sideOption",
	                    "type": {
	                        "option": {
	                            "defined": "Side"
	                        }
	                    }
	                },
	                {
	                    "name": "limit",
	                    "type": "u8"
	                }
	            ]
	        },
	        {
	            "name": "perpConsumeEvents",
	            "accounts": [
	                {
	                    "name": "group",
	                    "isMut": false,
	                    "isSigner": false
	                },
	                {
	                    "name": "perpMarket",
	                    "isMut": true,
	                    "isSigner": false
	                },
	                {
	                    "name": "eventQueue",
	                    "isMut": true,
	                    "isSigner": false
	                }
	            ],
	            "args": [
	                {
	                    "name": "limit",
	                    "type": "u64"
	                }
	            ]
	        },
	        {
	            "name": "perpUpdateFunding",
	            "accounts": [
	                {
	                    "name": "group",
	                    "isMut": false,
	                    "isSigner": false
	                },
	                {
	                    "name": "perpMarket",
	                    "isMut": true,
	                    "isSigner": false
	                },
	                {
	                    "name": "bids",
	                    "isMut": true,
	                    "isSigner": false
	                },
	                {
	                    "name": "asks",
	                    "isMut": true,
	                    "isSigner": false
	                },
	                {
	                    "name": "oracle",
	                    "isMut": false,
	                    "isSigner": false
	                }
	            ],
	            "args": []
	        },
	        {
	            "name": "perpSettlePnl",
	            "accounts": [
	                {
	                    "name": "group",
	                    "isMut": false,
	                    "isSigner": false
	                },
	                {
	                    "name": "settler",
	                    "isMut": true,
	                    "isSigner": false
	                },
	                {
	                    "name": "settlerOwner",
	                    "isMut": false,
	                    "isSigner": true
	                },
	                {
	                    "name": "perpMarket",
	                    "isMut": false,
	                    "isSigner": false
	                },
	                {
	                    "name": "accountA",
	                    "isMut": true,
	                    "isSigner": false
	                },
	                {
	                    "name": "accountB",
	                    "isMut": true,
	                    "isSigner": false
	                },
	                {
	                    "name": "oracle",
	                    "isMut": false,
	                    "isSigner": false
	                },
	                {
	                    "name": "settleBank",
	                    "isMut": true,
	                    "isSigner": false
	                },
	                {
	                    "name": "settleOracle",
	                    "isMut": false,
	                    "isSigner": false
	                }
	            ],
	            "args": []
	        },
	        {
	            "name": "perpSettleFees",
	            "accounts": [
	                {
	                    "name": "group",
	                    "isMut": false,
	                    "isSigner": false
	                },
	                {
	                    "name": "perpMarket",
	                    "isMut": true,
	                    "isSigner": false
	                },
	                {
	                    "name": "account",
	                    "isMut": true,
	                    "isSigner": false
	                },
	                {
	                    "name": "oracle",
	                    "isMut": false,
	                    "isSigner": false
	                },
	                {
	                    "name": "settleBank",
	                    "isMut": true,
	                    "isSigner": false
	                },
	                {
	                    "name": "settleOracle",
	                    "isMut": false,
	                    "isSigner": false
	                }
	            ],
	            "args": [
	                {
	                    "name": "maxSettleAmount",
	                    "type": "u64"
	                }
	            ]
	        },
	        {
	            "name": "perpLiqBaseOrPositivePnl",
	            "accounts": [
	                {
	                    "name": "group",
	                    "isMut": false,
	                    "isSigner": false
	                },
	                {
	                    "name": "perpMarket",
	                    "isMut": true,
	                    "isSigner": false
	                },
	                {
	                    "name": "oracle",
	                    "isMut": false,
	                    "isSigner": false
	                },
	                {
	                    "name": "liqor",
	                    "isMut": true,
	                    "isSigner": false
	                },
	                {
	                    "name": "liqorOwner",
	                    "isMut": false,
	                    "isSigner": true
	                },
	                {
	                    "name": "liqee",
	                    "isMut": true,
	                    "isSigner": false
	                },
	                {
	                    "name": "settleBank",
	                    "isMut": true,
	                    "isSigner": false
	                },
	                {
	                    "name": "settleVault",
	                    "isMut": true,
	                    "isSigner": false
	                },
	                {
	                    "name": "settleOracle",
	                    "isMut": false,
	                    "isSigner": false
	                }
	            ],
	            "args": [
	                {
	                    "name": "maxBaseTransfer",
	                    "type": "i64"
	                },
	                {
	                    "name": "maxPnlTransfer",
	                    "type": "u64"
	                }
	            ]
	        },
	        {
	            "name": "perpLiqForceCancelOrders",
	            "accounts": [
	                {
	                    "name": "group",
	                    "isMut": false,
	                    "isSigner": false
	                },
	                {
	                    "name": "account",
	                    "isMut": true,
	                    "isSigner": false
	                },
	                {
	                    "name": "perpMarket",
	                    "isMut": true,
	                    "isSigner": false
	                },
	                {
	                    "name": "bids",
	                    "isMut": true,
	                    "isSigner": false
	                },
	                {
	                    "name": "asks",
	                    "isMut": true,
	                    "isSigner": false
	                }
	            ],
	            "args": [
	                {
	                    "name": "limit",
	                    "type": "u8"
	                }
	            ]
	        },
	        {
	            "name": "perpLiqNegativePnlOrBankruptcy",
	            "accounts": [
	                {
	                    "name": "group",
	                    "isMut": false,
	                    "isSigner": false
	                },
	                {
	                    "name": "liqor",
	                    "isMut": true,
	                    "isSigner": false
	                },
	                {
	                    "name": "liqorOwner",
	                    "isMut": false,
	                    "isSigner": true
	                },
	                {
	                    "name": "liqee",
	                    "isMut": true,
	                    "isSigner": false
	                },
	                {
	                    "name": "perpMarket",
	                    "isMut": true,
	                    "isSigner": false
	                },
	                {
	                    "name": "oracle",
	                    "isMut": false,
	                    "isSigner": false
	                },
	                {
	                    "name": "settleBank",
	                    "isMut": true,
	                    "isSigner": false
	                },
	                {
	                    "name": "settleVault",
	                    "isMut": true,
	                    "isSigner": false
	                },
	                {
	                    "name": "settleOracle",
	                    "isMut": false,
	                    "isSigner": false
	                },
	                {
	                    "name": "insuranceVault",
	                    "isMut": true,
	                    "isSigner": false
	                },
	                {
	                    "name": "tokenProgram",
	                    "isMut": false,
	                    "isSigner": false
	                }
	            ],
	            "args": [
	                {
	                    "name": "maxLiabTransfer",
	                    "type": "u64"
	                }
	            ]
	        },
	        {
	            "name": "altSet",
	            "accounts": [
	                {
	                    "name": "group",
	                    "isMut": true,
	                    "isSigner": false
	                },
	                {
	                    "name": "admin",
	                    "isMut": false,
	                    "isSigner": true
	                },
	                {
	                    "name": "addressLookupTable",
	                    "isMut": true,
	                    "isSigner": false
	                }
	            ],
	            "args": [
	                {
	                    "name": "index",
	                    "type": "u8"
	                }
	            ]
	        },
	        {
	            "name": "altExtend",
	            "accounts": [
	                {
	                    "name": "group",
	                    "isMut": false,
	                    "isSigner": false
	                },
	                {
	                    "name": "admin",
	                    "isMut": false,
	                    "isSigner": true
	                },
	                {
	                    "name": "payer",
	                    "isMut": false,
	                    "isSigner": true
	                },
	                {
	                    "name": "addressLookupTable",
	                    "isMut": true,
	                    "isSigner": false
	                }
	            ],
	            "args": [
	                {
	                    "name": "index",
	                    "type": "u8"
	                },
	                {
	                    "name": "newAddresses",
	                    "type": {
	                        "vec": "publicKey"
	                    }
	                }
	            ]
	        },
	        {
	            "name": "computeAccountData",
	            "accounts": [
	                {
	                    "name": "group",
	                    "isMut": false,
	                    "isSigner": false
	                },
	                {
	                    "name": "account",
	                    "isMut": false,
	                    "isSigner": false
	                }
	            ],
	            "args": []
	        },
	        {
	            "name": "benchmark",
	            "docs": [
	                "",
	                "benchmark",
	                ""
	            ],
	            "accounts": [],
	            "args": []
	        }
	    ],
	    "accounts": [
	        {
	            "name": "bank",
	            "type": {
	                "kind": "struct",
	                "fields": [
	                    {
	                        "name": "group",
	                        "type": "publicKey"
	                    },
	                    {
	                        "name": "name",
	                        "type": {
	                            "array": [
	                                "u8",
	                                16
	                            ]
	                        }
	                    },
	                    {
	                        "name": "mint",
	                        "type": "publicKey"
	                    },
	                    {
	                        "name": "vault",
	                        "type": "publicKey"
	                    },
	                    {
	                        "name": "oracle",
	                        "type": "publicKey"
	                    },
	                    {
	                        "name": "oracleConfig",
	                        "type": {
	                            "defined": "OracleConfig"
	                        }
	                    },
	                    {
	                        "name": "stablePriceModel",
	                        "type": {
	                            "defined": "StablePriceModel"
	                        }
	                    },
	                    {
	                        "name": "depositIndex",
	                        "docs": [
	                            "the index used to scale the value of an IndexedPosition",
	                            "TODO: should always be >= 0, add checks?"
	                        ],
	                        "type": {
	                            "defined": "I80F48"
	                        }
	                    },
	                    {
	                        "name": "borrowIndex",
	                        "type": {
	                            "defined": "I80F48"
	                        }
	                    },
	                    {
	                        "name": "indexedDeposits",
	                        "docs": [
	                            "deposits/borrows for this bank",
	                            "",
	                            "Note that these may become negative. It's perfectly fine for users to borrow one one bank",
	                            "(increasing indexed_borrows there) and paying back on another (possibly decreasing indexed_borrows",
	                            "below zero).",
	                            "",
	                            "The vault amount is not deducable from these values.",
	                            "",
	                            "These become meaningful when summed over all banks (like in update_index_and_rate)."
	                        ],
	                        "type": {
	                            "defined": "I80F48"
	                        }
	                    },
	                    {
	                        "name": "indexedBorrows",
	                        "type": {
	                            "defined": "I80F48"
	                        }
	                    },
	                    {
	                        "name": "indexLastUpdated",
	                        "type": "u64"
	                    },
	                    {
	                        "name": "bankRateLastUpdated",
	                        "type": "u64"
	                    },
	                    {
	                        "name": "avgUtilization",
	                        "type": {
	                            "defined": "I80F48"
	                        }
	                    },
	                    {
	                        "name": "adjustmentFactor",
	                        "type": {
	                            "defined": "I80F48"
	                        }
	                    },
	                    {
	                        "name": "util0",
	                        "type": {
	                            "defined": "I80F48"
	                        }
	                    },
	                    {
	                        "name": "rate0",
	                        "type": {
	                            "defined": "I80F48"
	                        }
	                    },
	                    {
	                        "name": "util1",
	                        "type": {
	                            "defined": "I80F48"
	                        }
	                    },
	                    {
	                        "name": "rate1",
	                        "type": {
	                            "defined": "I80F48"
	                        }
	                    },
	                    {
	                        "name": "maxRate",
	                        "type": {
	                            "defined": "I80F48"
	                        }
	                    },
	                    {
	                        "name": "collectedFeesNative",
	                        "type": {
	                            "defined": "I80F48"
	                        }
	                    },
	                    {
	                        "name": "loanOriginationFeeRate",
	                        "type": {
	                            "defined": "I80F48"
	                        }
	                    },
	                    {
	                        "name": "loanFeeRate",
	                        "type": {
	                            "defined": "I80F48"
	                        }
	                    },
	                    {
	                        "name": "maintAssetWeight",
	                        "type": {
	                            "defined": "I80F48"
	                        }
	                    },
	                    {
	                        "name": "initAssetWeight",
	                        "type": {
	                            "defined": "I80F48"
	                        }
	                    },
	                    {
	                        "name": "maintLiabWeight",
	                        "type": {
	                            "defined": "I80F48"
	                        }
	                    },
	                    {
	                        "name": "initLiabWeight",
	                        "type": {
	                            "defined": "I80F48"
	                        }
	                    },
	                    {
	                        "name": "liquidationFee",
	                        "type": {
	                            "defined": "I80F48"
	                        }
	                    },
	                    {
	                        "name": "dust",
	                        "type": {
	                            "defined": "I80F48"
	                        }
	                    },
	                    {
	                        "name": "flashLoanTokenAccountInitial",
	                        "type": "u64"
	                    },
	                    {
	                        "name": "flashLoanApprovedAmount",
	                        "type": "u64"
	                    },
	                    {
	                        "name": "tokenIndex",
	                        "type": "u16"
	                    },
	                    {
	                        "name": "bump",
	                        "type": "u8"
	                    },
	                    {
	                        "name": "mintDecimals",
	                        "type": "u8"
	                    },
	                    {
	                        "name": "bankNum",
	                        "type": "u32"
	                    },
	                    {
	                        "name": "minVaultToDepositsRatio",
	                        "docs": [
	                            "Min fraction of deposits that must remain in the vault when borrowing."
	                        ],
	                        "type": "f64"
	                    },
	                    {
	                        "name": "netBorrowLimitWindowSizeTs",
	                        "docs": [
	                            "Size in seconds of a net borrows window"
	                        ],
	                        "type": "u64"
	                    },
	                    {
	                        "name": "lastNetBorrowsWindowStartTs",
	                        "docs": [
	                            "Timestamp at which the last net borrows window started"
	                        ],
	                        "type": "u64"
	                    },
	                    {
	                        "name": "netBorrowLimitPerWindowQuote",
	                        "docs": [
	                            "Net borrow limit per window in quote native; set to -1 to disable."
	                        ],
	                        "type": "i64"
	                    },
	                    {
	                        "name": "netBorrowsInWindow",
	                        "docs": [
	                            "Sum of all deposits and borrows in the last window, in native units."
	                        ],
	                        "type": "i64"
	                    },
	                    {
	                        "name": "borrowWeightScaleStartQuote",
	                        "docs": [
	                            "Soft borrow limit in native quote",
	                            "",
	                            "Once the borrows on the bank exceed this quote value, init_liab_weight is scaled up.",
	                            "Set to f64::MAX to disable.",
	                            "",
	                            "See scaled_init_liab_weight()."
	                        ],
	                        "type": "f64"
	                    },
	                    {
	                        "name": "depositWeightScaleStartQuote",
	                        "docs": [
	                            "Limit for collateral of deposits in native quote",
	                            "",
	                            "Once the deposits in the bank exceed this quote value, init_asset_weight is scaled",
	                            "down to keep the total collateral value constant.",
	                            "Set to f64::MAX to disable.",
	                            "",
	                            "See scaled_init_asset_weight()."
	                        ],
	                        "type": "f64"
	                    },
	                    {
	                        "name": "reduceOnly",
	                        "type": "u8"
	                    },
	                    {
	                        "name": "reserved",
	                        "type": {
	                            "array": [
	                                "u8",
	                                2119
	                            ]
	                        }
	                    }
	                ]
	            }
	        },
	        {
	            "name": "group",
	            "type": {
	                "kind": "struct",
	                "fields": [
	                    {
	                        "name": "creator",
	                        "type": "publicKey"
	                    },
	                    {
	                        "name": "groupNum",
	                        "type": "u32"
	                    },
	                    {
	                        "name": "admin",
	                        "type": "publicKey"
	                    },
	                    {
	                        "name": "fastListingAdmin",
	                        "type": "publicKey"
	                    },
	                    {
	                        "name": "padding",
	                        "type": {
	                            "array": [
	                                "u8",
	                                4
	                            ]
	                        }
	                    },
	                    {
	                        "name": "insuranceVault",
	                        "type": "publicKey"
	                    },
	                    {
	                        "name": "insuranceMint",
	                        "type": "publicKey"
	                    },
	                    {
	                        "name": "bump",
	                        "type": "u8"
	                    },
	                    {
	                        "name": "testing",
	                        "type": "u8"
	                    },
	                    {
	                        "name": "version",
	                        "type": "u8"
	                    },
	                    {
	                        "name": "padding2",
	                        "type": {
	                            "array": [
	                                "u8",
	                                5
	                            ]
	                        }
	                    },
	                    {
	                        "name": "addressLookupTables",
	                        "type": {
	                            "array": [
	                                "publicKey",
	                                20
	                            ]
	                        }
	                    },
	                    {
	                        "name": "securityAdmin",
	                        "type": "publicKey"
	                    },
	                    {
	                        "name": "depositLimitQuote",
	                        "type": "u64"
	                    },
	                    {
	                        "name": "ixGate",
	                        "type": "u128"
	                    },
	                    {
	                        "name": "reserved",
	                        "type": {
	                            "array": [
	                                "u8",
	                                1864
	                            ]
	                        }
	                    }
	                ]
	            }
	        },
	        {
	            "name": "mangoAccount",
	            "type": {
	                "kind": "struct",
	                "fields": [
	                    {
	                        "name": "group",
	                        "type": "publicKey"
	                    },
	                    {
	                        "name": "owner",
	                        "type": "publicKey"
	                    },
	                    {
	                        "name": "name",
	                        "type": {
	                            "array": [
	                                "u8",
	                                32
	                            ]
	                        }
	                    },
	                    {
	                        "name": "delegate",
	                        "type": "publicKey"
	                    },
	                    {
	                        "name": "accountNum",
	                        "type": "u32"
	                    },
	                    {
	                        "name": "beingLiquidated",
	                        "docs": [
	                            "Tracks that this account should be liquidated until init_health >= 0.",
	                            "",
	                            "Normally accounts can not be liquidated while maint_health >= 0. But when an account",
	                            "reaches maint_health < 0, liquidators will call a liquidation instruction and thereby",
	                            "set this flag. Now the account may be liquidated until init_health >= 0.",
	                            "",
	                            "Many actions should be disabled while the account is being liquidated, even if",
	                            "its maint health has recovered to positive. Creating new open orders would, for example,",
	                            "confuse liquidators."
	                        ],
	                        "type": "u8"
	                    },
	                    {
	                        "name": "inHealthRegion",
	                        "docs": [
	                            "The account is currently inside a health region marked by HealthRegionBegin...HealthRegionEnd.",
	                            "",
	                            "Must never be set after a transaction ends."
	                        ],
	                        "type": "u8"
	                    },
	                    {
	                        "name": "bump",
	                        "type": "u8"
	                    },
	                    {
	                        "name": "padding",
	                        "type": {
	                            "array": [
	                                "u8",
	                                1
	                            ]
	                        }
	                    },
	                    {
	                        "name": "netDeposits",
	                        "type": "i64"
	                    },
	                    {
	                        "name": "perpSpotTransfers",
	                        "type": "i64"
	                    },
	                    {
	                        "name": "healthRegionBeginInitHealth",
	                        "docs": [
	                            "Init health as calculated during HealthReginBegin, rounded up."
	                        ],
	                        "type": "i64"
	                    },
	                    {
	                        "name": "frozenUntil",
	                        "type": "u64"
	                    },
	                    {
	                        "name": "reserved",
	                        "type": {
	                            "array": [
	                                "u8",
	                                232
	                            ]
	                        }
	                    },
	                    {
	                        "name": "headerVersion",
	                        "type": "u8"
	                    },
	                    {
	                        "name": "padding3",
	                        "type": {
	                            "array": [
	                                "u8",
	                                7
	                            ]
	                        }
	                    },
	                    {
	                        "name": "padding4",
	                        "type": "u32"
	                    },
	                    {
	                        "name": "tokens",
	                        "type": {
	                            "vec": {
	                                "defined": "TokenPosition"
	                            }
	                        }
	                    },
	                    {
	                        "name": "padding5",
	                        "type": "u32"
	                    },
	                    {
	                        "name": "serum3",
	                        "type": {
	                            "vec": {
	                                "defined": "Serum3Orders"
	                            }
	                        }
	                    },
	                    {
	                        "name": "padding6",
	                        "type": "u32"
	                    },
	                    {
	                        "name": "perps",
	                        "type": {
	                            "vec": {
	                                "defined": "PerpPosition"
	                            }
	                        }
	                    },
	                    {
	                        "name": "padding7",
	                        "type": "u32"
	                    },
	                    {
	                        "name": "perpOpenOrders",
	                        "type": {
	                            "vec": {
	                                "defined": "PerpOpenOrder"
	                            }
	                        }
	                    }
	                ]
	            }
	        },
	        {
	            "name": "mintInfo",
	            "type": {
	                "kind": "struct",
	                "fields": [
	                    {
	                        "name": "group",
	                        "type": "publicKey"
	                    },
	                    {
	                        "name": "tokenIndex",
	                        "type": "u16"
	                    },
	                    {
	                        "name": "groupInsuranceFund",
	                        "type": "u8"
	                    },
	                    {
	                        "name": "padding1",
	                        "type": {
	                            "array": [
	                                "u8",
	                                5
	                            ]
	                        }
	                    },
	                    {
	                        "name": "mint",
	                        "type": "publicKey"
	                    },
	                    {
	                        "name": "banks",
	                        "type": {
	                            "array": [
	                                "publicKey",
	                                6
	                            ]
	                        }
	                    },
	                    {
	                        "name": "vaults",
	                        "type": {
	                            "array": [
	                                "publicKey",
	                                6
	                            ]
	                        }
	                    },
	                    {
	                        "name": "oracle",
	                        "type": "publicKey"
	                    },
	                    {
	                        "name": "registrationTime",
	                        "type": "u64"
	                    },
	                    {
	                        "name": "reserved",
	                        "type": {
	                            "array": [
	                                "u8",
	                                2560
	                            ]
	                        }
	                    }
	                ]
	            }
	        },
	        {
	            "name": "stubOracle",
	            "type": {
	                "kind": "struct",
	                "fields": [
	                    {
	                        "name": "group",
	                        "type": "publicKey"
	                    },
	                    {
	                        "name": "mint",
	                        "type": "publicKey"
	                    },
	                    {
	                        "name": "price",
	                        "type": {
	                            "defined": "I80F48"
	                        }
	                    },
	                    {
	                        "name": "lastUpdated",
	                        "type": "i64"
	                    },
	                    {
	                        "name": "reserved",
	                        "type": {
	                            "array": [
	                                "u8",
	                                128
	                            ]
	                        }
	                    }
	                ]
	            }
	        },
	        {
	            "name": "bookSide",
	            "type": {
	                "kind": "struct",
	                "fields": [
	                    {
	                        "name": "roots",
	                        "type": {
	                            "array": [
	                                {
	                                    "defined": "OrderTreeRoot"
	                                },
	                                2
	                            ]
	                        }
	                    },
	                    {
	                        "name": "reservedRoots",
	                        "type": {
	                            "array": [
	                                {
	                                    "defined": "OrderTreeRoot"
	                                },
	                                4
	                            ]
	                        }
	                    },
	                    {
	                        "name": "reserved",
	                        "type": {
	                            "array": [
	                                "u8",
	                                256
	                            ]
	                        }
	                    },
	                    {
	                        "name": "nodes",
	                        "type": {
	                            "defined": "OrderTreeNodes"
	                        }
	                    }
	                ]
	            }
	        },
	        {
	            "name": "eventQueue",
	            "type": {
	                "kind": "struct",
	                "fields": [
	                    {
	                        "name": "header",
	                        "type": {
	                            "defined": "EventQueueHeader"
	                        }
	                    },
	                    {
	                        "name": "buf",
	                        "type": {
	                            "array": [
	                                {
	                                    "defined": "AnyEvent"
	                                },
	                                488
	                            ]
	                        }
	                    },
	                    {
	                        "name": "reserved",
	                        "type": {
	                            "array": [
	                                "u8",
	                                64
	                            ]
	                        }
	                    }
	                ]
	            }
	        },
	        {
	            "name": "perpMarket",
	            "type": {
	                "kind": "struct",
	                "fields": [
	                    {
	                        "name": "group",
	                        "type": "publicKey"
	                    },
	                    {
	                        "name": "settleTokenIndex",
	                        "docs": [
	                            "Token index that settlements happen in.",
	                            "",
	                            "Currently required to be 0, USDC. In the future settlement",
	                            "may be allowed to happen in other tokens."
	                        ],
	                        "type": "u16"
	                    },
	                    {
	                        "name": "perpMarketIndex",
	                        "docs": [
	                            "Index of this perp market. Other data, like the MangoAccount's PerpPosition",
	                            "reference this market via this index. Unique for this group's perp markets."
	                        ],
	                        "type": "u16"
	                    },
	                    {
	                        "name": "blocked1",
	                        "docs": [
	                            "Field used to contain the trusted_market flag and is now unused."
	                        ],
	                        "type": "u8"
	                    },
	                    {
	                        "name": "groupInsuranceFund",
	                        "docs": [
	                            "Is this market covered by the group insurance fund?"
	                        ],
	                        "type": "u8"
	                    },
	                    {
	                        "name": "bump",
	                        "docs": [
	                            "PDA bump"
	                        ],
	                        "type": "u8"
	                    },
	                    {
	                        "name": "baseDecimals",
	                        "docs": [
	                            "Number of decimals used for the base token.",
	                            "",
	                            "Used to convert the oracle's price into a native/native price."
	                        ],
	                        "type": "u8"
	                    },
	                    {
	                        "name": "name",
	                        "docs": [
	                            "Name. Trailing zero bytes are ignored."
	                        ],
	                        "type": {
	                            "array": [
	                                "u8",
	                                16
	                            ]
	                        }
	                    },
	                    {
	                        "name": "bids",
	                        "docs": [
	                            "Address of the BookSide account for bids"
	                        ],
	                        "type": "publicKey"
	                    },
	                    {
	                        "name": "asks",
	                        "docs": [
	                            "Address of the BookSide account for asks"
	                        ],
	                        "type": "publicKey"
	                    },
	                    {
	                        "name": "eventQueue",
	                        "docs": [
	                            "Address of the EventQueue account"
	                        ],
	                        "type": "publicKey"
	                    },
	                    {
	                        "name": "oracle",
	                        "docs": [
	                            "Oracle account address"
	                        ],
	                        "type": "publicKey"
	                    },
	                    {
	                        "name": "oracleConfig",
	                        "docs": [
	                            "Oracle configuration"
	                        ],
	                        "type": {
	                            "defined": "OracleConfig"
	                        }
	                    },
	                    {
	                        "name": "stablePriceModel",
	                        "docs": [
	                            "Maintains a stable price based on the oracle price that is less volatile."
	                        ],
	                        "type": {
	                            "defined": "StablePriceModel"
	                        }
	                    },
	                    {
	                        "name": "quoteLotSize",
	                        "docs": [
	                            "Number of quote native in a quote lot. Must be a power of 10.",
	                            "",
	                            "Primarily useful for increasing the tick size on the market: A lot price",
	                            "of 1 becomes a native price of quote_lot_size/base_lot_size becomes a",
	                            "ui price of quote_lot_size*base_decimals/base_lot_size/quote_decimals."
	                        ],
	                        "type": "i64"
	                    },
	                    {
	                        "name": "baseLotSize",
	                        "docs": [
	                            "Number of base native in a base lot. Must be a power of 10.",
	                            "",
	                            "Example: If base decimals for the underlying asset is 6, base lot size",
	                            "is 100 and and base position lots is 10_000 then base position native is",
	                            "1_000_000 and base position ui is 1."
	                        ],
	                        "type": "i64"
	                    },
	                    {
	                        "name": "maintBaseAssetWeight",
	                        "docs": [
	                            "These weights apply to the base position. The quote position has",
	                            "no explicit weight (but may be covered by the overall pnl asset weight)."
	                        ],
	                        "type": {
	                            "defined": "I80F48"
	                        }
	                    },
	                    {
	                        "name": "initBaseAssetWeight",
	                        "type": {
	                            "defined": "I80F48"
	                        }
	                    },
	                    {
	                        "name": "maintBaseLiabWeight",
	                        "type": {
	                            "defined": "I80F48"
	                        }
	                    },
	                    {
	                        "name": "initBaseLiabWeight",
	                        "type": {
	                            "defined": "I80F48"
	                        }
	                    },
	                    {
	                        "name": "openInterest",
	                        "docs": [
	                            "Number of base lot pairs currently active in the market. Always >= 0."
	                        ],
	                        "type": "i64"
	                    },
	                    {
	                        "name": "seqNum",
	                        "docs": [
	                            "Total number of orders seen"
	                        ],
	                        "type": "u64"
	                    },
	                    {
	                        "name": "registrationTime",
	                        "docs": [
	                            "Timestamp in seconds that the market was registered at."
	                        ],
	                        "type": "u64"
	                    },
	                    {
	                        "name": "minFunding",
	                        "docs": [
	                            "Minimal funding rate per day, must be <= 0."
	                        ],
	                        "type": {
	                            "defined": "I80F48"
	                        }
	                    },
	                    {
	                        "name": "maxFunding",
	                        "docs": [
	                            "Maximal funding rate per day, must be >= 0."
	                        ],
	                        "type": {
	                            "defined": "I80F48"
	                        }
	                    },
	                    {
	                        "name": "impactQuantity",
	                        "docs": [
	                            "For funding, get the impact price this many base lots deep into the book."
	                        ],
	                        "type": "i64"
	                    },
	                    {
	                        "name": "longFunding",
	                        "docs": [
	                            "Current long funding value. Increasing it means that every long base lot",
	                            "needs to pay that amount in funding.",
	                            "",
	                            "PerpPosition uses and tracks it settle funding. Updated by the perp",
	                            "keeper instruction."
	                        ],
	                        "type": {
	                            "defined": "I80F48"
	                        }
	                    },
	                    {
	                        "name": "shortFunding",
	                        "docs": [
	                            "See long_funding."
	                        ],
	                        "type": {
	                            "defined": "I80F48"
	                        }
	                    },
	                    {
	                        "name": "fundingLastUpdated",
	                        "docs": [
	                            "timestamp that funding was last updated in"
	                        ],
	                        "type": "u64"
	                    },
	                    {
	                        "name": "baseLiquidationFee",
	                        "docs": [
	                            "Fees",
	                            "Fee for base position liquidation"
	                        ],
	                        "type": {
	                            "defined": "I80F48"
	                        }
	                    },
	                    {
	                        "name": "makerFee",
	                        "docs": [
	                            "Fee when matching maker orders. May be negative."
	                        ],
	                        "type": {
	                            "defined": "I80F48"
	                        }
	                    },
	                    {
	                        "name": "takerFee",
	                        "docs": [
	                            "Fee for taker orders, may not be negative."
	                        ],
	                        "type": {
	                            "defined": "I80F48"
	                        }
	                    },
	                    {
	                        "name": "feesAccrued",
	                        "docs": [
	                            "Fees accrued in native quote currency"
	                        ],
	                        "type": {
	                            "defined": "I80F48"
	                        }
	                    },
	                    {
	                        "name": "feesSettled",
	                        "docs": [
	                            "Fees settled in native quote currency"
	                        ],
	                        "type": {
	                            "defined": "I80F48"
	                        }
	                    },
	                    {
	                        "name": "feePenalty",
	                        "docs": [
	                            "Fee (in quote native) to charge for ioc orders"
	                        ],
	                        "type": "f32"
	                    },
	                    {
	                        "name": "settleFeeFlat",
	                        "docs": [
	                            "In native units of settlement token, given to each settle call above the",
	                            "settle_fee_amount_threshold."
	                        ],
	                        "type": "f32"
	                    },
	                    {
	                        "name": "settleFeeAmountThreshold",
	                        "docs": [
	                            "Pnl settlement amount needed to be eligible for fees."
	                        ],
	                        "type": "f32"
	                    },
	                    {
	                        "name": "settleFeeFractionLowHealth",
	                        "docs": [
	                            "Fraction of pnl to pay out as fee if +pnl account has low health."
	                        ],
	                        "type": "f32"
	                    },
	                    {
	                        "name": "settlePnlLimitFactor",
	                        "docs": [
	                            "Controls the strictness of the settle limit.",
	                            "Set to a negative value to disable the limit.",
	                            "",
	                            "This factor applies to the settle limit in two ways",
	                            "- for the unrealized pnl settle limit, the factor is multiplied with the stable perp base value",
	                            "(i.e. limit_factor * base_native * stable_price)",
	                            "- when increasing the realized pnl settle limit (stored per PerpPosition), the factor is",
	                            "multiplied with the stable value of the perp pnl being realized",
	                            "(i.e. limit_factor * reduced_native * stable_price)",
	                            "",
	                            "See also PerpPosition::settle_pnl_limit_realized_trade"
	                        ],
	                        "type": "f32"
	                    },
	                    {
	                        "name": "padding3",
	                        "type": {
	                            "array": [
	                                "u8",
	                                4
	                            ]
	                        }
	                    },
	                    {
	                        "name": "settlePnlLimitWindowSizeTs",
	                        "docs": [
	                            "Window size in seconds for the perp settlement limit"
	                        ],
	                        "type": "u64"
	                    },
	                    {
	                        "name": "reduceOnly",
	                        "docs": [
	                            "If true, users may no longer increase their market exposure. Only actions",
	                            "that reduce their position are still allowed."
	                        ],
	                        "type": "u8"
	                    },
	                    {
	                        "name": "padding4",
	                        "type": {
	                            "array": [
	                                "u8",
	                                7
	                            ]
	                        }
	                    },
	                    {
	                        "name": "maintOverallAssetWeight",
	                        "docs": [
	                            "Weights for full perp market health, if positive"
	                        ],
	                        "type": {
	                            "defined": "I80F48"
	                        }
	                    },
	                    {
	                        "name": "initOverallAssetWeight",
	                        "type": {
	                            "defined": "I80F48"
	                        }
	                    },
	                    {
	                        "name": "positivePnlLiquidationFee",
	                        "type": {
	                            "defined": "I80F48"
	                        }
	                    },
	                    {
	                        "name": "reserved",
	                        "type": {
	                            "array": [
	                                "u8",
	                                1888
	                            ]
	                        }
	                    }
	                ]
	            }
	        },
	        {
	            "name": "serum3Market",
	            "type": {
	                "kind": "struct",
	                "fields": [
	                    {
	                        "name": "group",
	                        "type": "publicKey"
	                    },
	                    {
	                        "name": "baseTokenIndex",
	                        "type": "u16"
	                    },
	                    {
	                        "name": "quoteTokenIndex",
	                        "type": "u16"
	                    },
	                    {
	                        "name": "reduceOnly",
	                        "type": "u8"
	                    },
	                    {
	                        "name": "padding1",
	                        "type": {
	                            "array": [
	                                "u8",
	                                3
	                            ]
	                        }
	                    },
	                    {
	                        "name": "name",
	                        "type": {
	                            "array": [
	                                "u8",
	                                16
	                            ]
	                        }
	                    },
	                    {
	                        "name": "serumProgram",
	                        "type": "publicKey"
	                    },
	                    {
	                        "name": "serumMarketExternal",
	                        "type": "publicKey"
	                    },
	                    {
	                        "name": "marketIndex",
	                        "type": "u16"
	                    },
	                    {
	                        "name": "bump",
	                        "type": "u8"
	                    },
	                    {
	                        "name": "padding2",
	                        "type": {
	                            "array": [
	                                "u8",
	                                5
	                            ]
	                        }
	                    },
	                    {
	                        "name": "registrationTime",
	                        "type": "u64"
	                    },
	                    {
	                        "name": "reserved",
	                        "type": {
	                            "array": [
	                                "u8",
	                                128
	                            ]
	                        }
	                    }
	                ]
	            }
	        },
	        {
	            "name": "serum3MarketIndexReservation",
	            "type": {
	                "kind": "struct",
	                "fields": [
	                    {
	                        "name": "group",
	                        "type": "publicKey"
	                    },
	                    {
	                        "name": "marketIndex",
	                        "type": "u16"
	                    },
	                    {
	                        "name": "reserved",
	                        "type": {
	                            "array": [
	                                "u8",
	                                38
	                            ]
	                        }
	                    }
	                ]
	            }
	        }
	    ],
	    "types": [
	        {
	            "name": "InterestRateParams",
	            "type": {
	                "kind": "struct",
	                "fields": [
	                    {
	                        "name": "util0",
	                        "type": "f32"
	                    },
	                    {
	                        "name": "rate0",
	                        "type": "f32"
	                    },
	                    {
	                        "name": "util1",
	                        "type": "f32"
	                    },
	                    {
	                        "name": "rate1",
	                        "type": "f32"
	                    },
	                    {
	                        "name": "maxRate",
	                        "type": "f32"
	                    },
	                    {
	                        "name": "adjustmentFactor",
	                        "type": "f32"
	                    }
	                ]
	            }
	        },
	        {
	            "name": "Equity",
	            "type": {
	                "kind": "struct",
	                "fields": [
	                    {
	                        "name": "tokens",
	                        "type": {
	                            "vec": {
	                                "defined": "TokenEquity"
	                            }
	                        }
	                    },
	                    {
	                        "name": "perps",
	                        "type": {
	                            "vec": {
	                                "defined": "PerpEquity"
	                            }
	                        }
	                    }
	                ]
	            }
	        },
	        {
	            "name": "TokenEquity",
	            "type": {
	                "kind": "struct",
	                "fields": [
	                    {
	                        "name": "tokenIndex",
	                        "type": "u16"
	                    },
	                    {
	                        "name": "value",
	                        "type": {
	                            "defined": "I80F48"
	                        }
	                    }
	                ]
	            }
	        },
	        {
	            "name": "PerpEquity",
	            "type": {
	                "kind": "struct",
	                "fields": [
	                    {
	                        "name": "perpMarketIndex",
	                        "type": "u16"
	                    },
	                    {
	                        "name": "value",
	                        "type": {
	                            "defined": "I80F48"
	                        }
	                    }
	                ]
	            }
	        },
	        {
	            "name": "Prices",
	            "docs": [
	                "Information about prices for a bank or perp market."
	            ],
	            "type": {
	                "kind": "struct",
	                "fields": [
	                    {
	                        "name": "oracle",
	                        "docs": [
	                            "The current oracle price"
	                        ],
	                        "type": {
	                            "defined": "I80F48"
	                        }
	                    },
	                    {
	                        "name": "stable",
	                        "docs": [
	                            "A \"stable\" price, provided by StablePriceModel"
	                        ],
	                        "type": {
	                            "defined": "I80F48"
	                        }
	                    }
	                ]
	            }
	        },
	        {
	            "name": "TokenInfo",
	            "type": {
	                "kind": "struct",
	                "fields": [
	                    {
	                        "name": "tokenIndex",
	                        "type": "u16"
	                    },
	                    {
	                        "name": "maintAssetWeight",
	                        "type": {
	                            "defined": "I80F48"
	                        }
	                    },
	                    {
	                        "name": "initAssetWeight",
	                        "type": {
	                            "defined": "I80F48"
	                        }
	                    },
	                    {
	                        "name": "initScaledAssetWeight",
	                        "type": {
	                            "defined": "I80F48"
	                        }
	                    },
	                    {
	                        "name": "maintLiabWeight",
	                        "type": {
	                            "defined": "I80F48"
	                        }
	                    },
	                    {
	                        "name": "initLiabWeight",
	                        "type": {
	                            "defined": "I80F48"
	                        }
	                    },
	                    {
	                        "name": "initScaledLiabWeight",
	                        "type": {
	                            "defined": "I80F48"
	                        }
	                    },
	                    {
	                        "name": "prices",
	                        "type": {
	                            "defined": "Prices"
	                        }
	                    },
	                    {
	                        "name": "balanceNative",
	                        "type": {
	                            "defined": "I80F48"
	                        }
	                    }
	                ]
	            }
	        },
	        {
	            "name": "Serum3Info",
	            "type": {
	                "kind": "struct",
	                "fields": [
	                    {
	                        "name": "reservedBase",
	                        "type": {
	                            "defined": "I80F48"
	                        }
	                    },
	                    {
	                        "name": "reservedQuote",
	                        "type": {
	                            "defined": "I80F48"
	                        }
	                    },
	                    {
	                        "name": "baseIndex",
	                        "type": "u64"
	                    },
	                    {
	                        "name": "quoteIndex",
	                        "type": "u64"
	                    },
	                    {
	                        "name": "marketIndex",
	                        "type": "u16"
	                    },
	                    {
	                        "name": "hasZeroFunds",
	                        "docs": [
	                            "The open orders account has no free or reserved funds"
	                        ],
	                        "type": "bool"
	                    }
	                ]
	            }
	        },
	        {
	            "name": "PerpInfo",
	            "type": {
	                "kind": "struct",
	                "fields": [
	                    {
	                        "name": "perpMarketIndex",
	                        "type": "u16"
	                    },
	                    {
	                        "name": "maintBaseAssetWeight",
	                        "type": {
	                            "defined": "I80F48"
	                        }
	                    },
	                    {
	                        "name": "initBaseAssetWeight",
	                        "type": {
	                            "defined": "I80F48"
	                        }
	                    },
	                    {
	                        "name": "maintBaseLiabWeight",
	                        "type": {
	                            "defined": "I80F48"
	                        }
	                    },
	                    {
	                        "name": "initBaseLiabWeight",
	                        "type": {
	                            "defined": "I80F48"
	                        }
	                    },
	                    {
	                        "name": "maintOverallAssetWeight",
	                        "type": {
	                            "defined": "I80F48"
	                        }
	                    },
	                    {
	                        "name": "initOverallAssetWeight",
	                        "type": {
	                            "defined": "I80F48"
	                        }
	                    },
	                    {
	                        "name": "baseLotSize",
	                        "type": "i64"
	                    },
	                    {
	                        "name": "baseLots",
	                        "type": "i64"
	                    },
	                    {
	                        "name": "bidsBaseLots",
	                        "type": "i64"
	                    },
	                    {
	                        "name": "asksBaseLots",
	                        "type": "i64"
	                    },
	                    {
	                        "name": "quote",
	                        "type": {
	                            "defined": "I80F48"
	                        }
	                    },
	                    {
	                        "name": "prices",
	                        "type": {
	                            "defined": "Prices"
	                        }
	                    },
	                    {
	                        "name": "hasOpenOrders",
	                        "type": "bool"
	                    },
	                    {
	                        "name": "hasOpenFills",
	                        "type": "bool"
	                    }
	                ]
	            }
	        },
	        {
	            "name": "HealthCache",
	            "type": {
	                "kind": "struct",
	                "fields": [
	                    {
	                        "name": "tokenInfos",
	                        "type": {
	                            "vec": {
	                                "defined": "TokenInfo"
	                            }
	                        }
	                    },
	                    {
	                        "name": "serum3Infos",
	                        "type": {
	                            "vec": {
	                                "defined": "Serum3Info"
	                            }
	                        }
	                    },
	                    {
	                        "name": "perpInfos",
	                        "type": {
	                            "vec": {
	                                "defined": "PerpInfo"
	                            }
	                        }
	                    },
	                    {
	                        "name": "beingLiquidated",
	                        "type": "bool"
	                    }
	                ]
	            }
	        },
	        {
	            "name": "FlashLoanTokenDetail",
	            "type": {
	                "kind": "struct",
	                "fields": [
	                    {
	                        "name": "tokenIndex",
	                        "type": "u16"
	                    },
	                    {
	                        "name": "changeAmount",
	                        "type": "i128"
	                    },
	                    {
	                        "name": "loan",
	                        "type": "i128"
	                    },
	                    {
	                        "name": "loanOriginationFee",
	                        "type": "i128"
	                    },
	                    {
	                        "name": "depositIndex",
	                        "type": "i128"
	                    },
	                    {
	                        "name": "borrowIndex",
	                        "type": "i128"
	                    },
	                    {
	                        "name": "price",
	                        "type": "i128"
	                    }
	                ]
	            }
	        },
	        {
	            "name": "TokenPosition",
	            "type": {
	                "kind": "struct",
	                "fields": [
	                    {
	                        "name": "indexedPosition",
	                        "docs": [
	                            "The deposit_index (if positive) or borrow_index (if negative) scaled position"
	                        ],
	                        "type": {
	                            "defined": "I80F48"
	                        }
	                    },
	                    {
	                        "name": "tokenIndex",
	                        "docs": [
	                            "index into Group.tokens"
	                        ],
	                        "type": "u16"
	                    },
	                    {
	                        "name": "inUseCount",
	                        "docs": [
	                            "incremented when a market requires this position to stay alive"
	                        ],
	                        "type": "u8"
	                    },
	                    {
	                        "name": "padding",
	                        "type": {
	                            "array": [
	                                "u8",
	                                5
	                            ]
	                        }
	                    },
	                    {
	                        "name": "previousIndex",
	                        "type": {
	                            "defined": "I80F48"
	                        }
	                    },
	                    {
	                        "name": "cumulativeDepositInterest",
	                        "type": "f64"
	                    },
	                    {
	                        "name": "cumulativeBorrowInterest",
	                        "type": "f64"
	                    },
	                    {
	                        "name": "reserved",
	                        "type": {
	                            "array": [
	                                "u8",
	                                128
	                            ]
	                        }
	                    }
	                ]
	            }
	        },
	        {
	            "name": "Serum3Orders",
	            "type": {
	                "kind": "struct",
	                "fields": [
	                    {
	                        "name": "openOrders",
	                        "type": "publicKey"
	                    },
	                    {
	                        "name": "baseBorrowsWithoutFee",
	                        "docs": [
	                            "Tracks the amount of borrows that have flowed into the serum open orders account.",
	                            "These borrows did not have the loan origination fee applied, and that may happen",
	                            "later (in serum3_settle_funds) if we can guarantee that the funds were used.",
	                            "In particular a place-on-book, cancel, settle should not cost fees."
	                        ],
	                        "type": "u64"
	                    },
	                    {
	                        "name": "quoteBorrowsWithoutFee",
	                        "type": "u64"
	                    },
	                    {
	                        "name": "marketIndex",
	                        "type": "u16"
	                    },
	                    {
	                        "name": "baseTokenIndex",
	                        "docs": [
	                            "Store the base/quote token index, so health computations don't need",
	                            "to get passed the static SerumMarket to find which tokens a market",
	                            "uses and look up the correct oracles."
	                        ],
	                        "type": "u16"
	                    },
	                    {
	                        "name": "quoteTokenIndex",
	                        "type": "u16"
	                    },
	                    {
	                        "name": "padding",
	                        "type": {
	                            "array": [
	                                "u8",
	                                2
	                            ]
	                        }
	                    },
	                    {
	                        "name": "reserved",
	                        "type": {
	                            "array": [
	                                "u8",
	                                64
	                            ]
	                        }
	                    }
	                ]
	            }
	        },
	        {
	            "name": "PerpPosition",
	            "type": {
	                "kind": "struct",
	                "fields": [
	                    {
	                        "name": "marketIndex",
	                        "type": "u16"
	                    },
	                    {
	                        "name": "padding",
	                        "type": {
	                            "array": [
	                                "u8",
	                                2
	                            ]
	                        }
	                    },
	                    {
	                        "name": "settlePnlLimitWindow",
	                        "docs": [
	                            "Index of the current settle pnl limit window"
	                        ],
	                        "type": "u32"
	                    },
	                    {
	                        "name": "settlePnlLimitSettledInCurrentWindowNative",
	                        "docs": [
	                            "Amount of realized trade pnl and unrealized pnl that was already settled this window.",
	                            "",
	                            "Will be negative when negative pnl was settled.",
	                            "",
	                            "Note that this will be adjusted for bookkeeping reasons when the realized_trade settle",
	                            "limitchanges and is not useable for actually tracking how much pnl was settled",
	                            "on balance."
	                        ],
	                        "type": "i64"
	                    },
	                    {
	                        "name": "basePositionLots",
	                        "docs": [
	                            "Active position size, measured in base lots"
	                        ],
	                        "type": "i64"
	                    },
	                    {
	                        "name": "quotePositionNative",
	                        "docs": [
	                            "Active position in quote (conversation rate is that of the time the order was settled)",
	                            "measured in native quote"
	                        ],
	                        "type": {
	                            "defined": "I80F48"
	                        }
	                    },
	                    {
	                        "name": "quoteRunningNative",
	                        "docs": [
	                            "Tracks what the position is to calculate average entry & break even price"
	                        ],
	                        "type": "i64"
	                    },
	                    {
	                        "name": "longSettledFunding",
	                        "docs": [
	                            "Already settled long funding"
	                        ],
	                        "type": {
	                            "defined": "I80F48"
	                        }
	                    },
	                    {
	                        "name": "shortSettledFunding",
	                        "docs": [
	                            "Already settled short funding"
	                        ],
	                        "type": {
	                            "defined": "I80F48"
	                        }
	                    },
	                    {
	                        "name": "bidsBaseLots",
	                        "docs": [
	                            "Base lots in open bids"
	                        ],
	                        "type": "i64"
	                    },
	                    {
	                        "name": "asksBaseLots",
	                        "docs": [
	                            "Base lots in open asks"
	                        ],
	                        "type": "i64"
	                    },
	                    {
	                        "name": "takerBaseLots",
	                        "docs": [
	                            "Amount of base lots on the EventQueue waiting to be processed"
	                        ],
	                        "type": "i64"
	                    },
	                    {
	                        "name": "takerQuoteLots",
	                        "docs": [
	                            "Amount of quote lots on the EventQueue waiting to be processed"
	                        ],
	                        "type": "i64"
	                    },
	                    {
	                        "name": "cumulativeLongFunding",
	                        "type": "f64"
	                    },
	                    {
	                        "name": "cumulativeShortFunding",
	                        "type": "f64"
	                    },
	                    {
	                        "name": "makerVolume",
	                        "type": "u64"
	                    },
	                    {
	                        "name": "takerVolume",
	                        "type": "u64"
	                    },
	                    {
	                        "name": "perpSpotTransfers",
	                        "type": "i64"
	                    },
	                    {
	                        "name": "avgEntryPricePerBaseLot",
	                        "docs": [
	                            "The native average entry price for the base lots of the current position.",
	                            "Reset to 0 when the base position reaches or crosses 0."
	                        ],
	                        "type": "f64"
	                    },
	                    {
	                        "name": "realizedTradePnlNative",
	                        "docs": [
	                            "Amount of pnl that was realized by bringing the base position closer to 0.",
	                            "",
	                            "The settlement of this type of pnl is limited by settle_pnl_limit_realized_trade.",
	                            "Settling pnl reduces this value once other_pnl below is exhausted."
	                        ],
	                        "type": {
	                            "defined": "I80F48"
	                        }
	                    },
	                    {
	                        "name": "realizedOtherPnlNative",
	                        "docs": [
	                            "Amount of pnl realized from fees, funding and liquidation.",
	                            "",
	                            "This type of realized pnl is always settleable.",
	                            "Settling pnl reduces this value first."
	                        ],
	                        "type": {
	                            "defined": "I80F48"
	                        }
	                    },
	                    {
	                        "name": "settlePnlLimitRealizedTrade",
	                        "docs": [
	                            "Settle limit contribution from realized pnl.",
	                            "",
	                            "Every time pnl is realized, this is increased by a fraction of the stable",
	                            "value of the realization. It magnitude decreases when realized pnl drops below its value."
	                        ],
	                        "type": "i64"
	                    },
	                    {
	                        "name": "realizedPnlForPositionNative",
	                        "docs": [
	                            "Trade pnl, fees, funding that were added over the current position's lifetime.",
	                            "",
	                            "Reset when the position changes sign or goes to zero.",
	                            "Not decreased by settling.",
	                            "",
	                            "This is tracked for display purposes: this value plus the difference between entry",
	                            "price and current price of the base position is the overall pnl."
	                        ],
	                        "type": {
	                            "defined": "I80F48"
	                        }
	                    },
	                    {
	                        "name": "reserved",
	                        "type": {
	                            "array": [
	                                "u8",
	                                88
	                            ]
	                        }
	                    }
	                ]
	            }
	        },
	        {
	            "name": "PerpOpenOrder",
	            "type": {
	                "kind": "struct",
	                "fields": [
	                    {
	                        "name": "sideAndTree",
	                        "type": "u8"
	                    },
	                    {
	                        "name": "padding1",
	                        "type": {
	                            "array": [
	                                "u8",
	                                1
	                            ]
	                        }
	                    },
	                    {
	                        "name": "market",
	                        "type": "u16"
	                    },
	                    {
	                        "name": "padding2",
	                        "type": {
	                            "array": [
	                                "u8",
	                                4
	                            ]
	                        }
	                    },
	                    {
	                        "name": "clientId",
	                        "type": "u64"
	                    },
	                    {
	                        "name": "id",
	                        "type": "u128"
	                    },
	                    {
	                        "name": "reserved",
	                        "type": {
	                            "array": [
	                                "u8",
	                                64
	                            ]
	                        }
	                    }
	                ]
	            }
	        },
	        {
	            "name": "MangoAccountFixed",
	            "type": {
	                "kind": "struct",
	                "fields": [
	                    {
	                        "name": "group",
	                        "type": "publicKey"
	                    },
	                    {
	                        "name": "owner",
	                        "type": "publicKey"
	                    },
	                    {
	                        "name": "name",
	                        "type": {
	                            "array": [
	                                "u8",
	                                32
	                            ]
	                        }
	                    },
	                    {
	                        "name": "delegate",
	                        "type": "publicKey"
	                    },
	                    {
	                        "name": "accountNum",
	                        "type": "u32"
	                    },
	                    {
	                        "name": "beingLiquidated",
	                        "type": "u8"
	                    },
	                    {
	                        "name": "inHealthRegion",
	                        "type": "u8"
	                    },
	                    {
	                        "name": "bump",
	                        "type": "u8"
	                    },
	                    {
	                        "name": "padding",
	                        "type": {
	                            "array": [
	                                "u8",
	                                1
	                            ]
	                        }
	                    },
	                    {
	                        "name": "netDeposits",
	                        "type": "i64"
	                    },
	                    {
	                        "name": "perpSpotTransfers",
	                        "type": "i64"
	                    },
	                    {
	                        "name": "healthRegionBeginInitHealth",
	                        "type": "i64"
	                    },
	                    {
	                        "name": "frozenUntil",
	                        "type": "u64"
	                    },
	                    {
	                        "name": "reserved",
	                        "type": {
	                            "array": [
	                                "u8",
	                                232
	                            ]
	                        }
	                    }
	                ]
	            }
	        },
	        {
	            "name": "OracleConfig",
	            "type": {
	                "kind": "struct",
	                "fields": [
	                    {
	                        "name": "confFilter",
	                        "type": {
	                            "defined": "I80F48"
	                        }
	                    },
	                    {
	                        "name": "maxStalenessSlots",
	                        "type": "i64"
	                    },
	                    {
	                        "name": "reserved",
	                        "type": {
	                            "array": [
	                                "u8",
	                                72
	                            ]
	                        }
	                    }
	                ]
	            }
	        },
	        {
	            "name": "OracleConfigParams",
	            "type": {
	                "kind": "struct",
	                "fields": [
	                    {
	                        "name": "confFilter",
	                        "type": "f32"
	                    },
	                    {
	                        "name": "maxStalenessSlots",
	                        "type": {
	                            "option": "u32"
	                        }
	                    }
	                ]
	            }
	        },
	        {
	            "name": "InnerNode",
	            "docs": [
	                "InnerNodes and LeafNodes compose the binary tree of orders.",
	                "",
	                "Each InnerNode has exactly two children, which are either InnerNodes themselves,",
	                "or LeafNodes. The children share the top `prefix_len` bits of `key`. The left",
	                "child has a 0 in the next bit, and the right a 1."
	            ],
	            "type": {
	                "kind": "struct",
	                "fields": [
	                    {
	                        "name": "tag",
	                        "type": "u8"
	                    },
	                    {
	                        "name": "padding",
	                        "type": {
	                            "array": [
	                                "u8",
	                                3
	                            ]
	                        }
	                    },
	                    {
	                        "name": "prefixLen",
	                        "docs": [
	                            "number of highest `key` bits that all children share",
	                            "e.g. if it's 2, the two highest bits of `key` will be the same on all children"
	                        ],
	                        "type": "u32"
	                    },
	                    {
	                        "name": "key",
	                        "docs": [
	                            "only the top `prefix_len` bits of `key` are relevant"
	                        ],
	                        "type": "u128"
	                    },
	                    {
	                        "name": "children",
	                        "docs": [
	                            "indexes into `BookSide::nodes`"
	                        ],
	                        "type": {
	                            "array": [
	                                "u32",
	                                2
	                            ]
	                        }
	                    },
	                    {
	                        "name": "childEarliestExpiry",
	                        "docs": [
	                            "The earliest expiry timestamp for the left and right subtrees.",
	                            "",
	                            "Needed to be able to find and remove expired orders without having to",
	                            "iterate through the whole bookside."
	                        ],
	                        "type": {
	                            "array": [
	                                "u64",
	                                2
	                            ]
	                        }
	                    },
	                    {
	                        "name": "reserved",
	                        "type": {
	                            "array": [
	                                "u8",
	                                72
	                            ]
	                        }
	                    }
	                ]
	            }
	        },
	        {
	            "name": "LeafNode",
	            "docs": [
	                "LeafNodes represent an order in the binary tree"
	            ],
	            "type": {
	                "kind": "struct",
	                "fields": [
	                    {
	                        "name": "tag",
	                        "docs": [
	                            "NodeTag"
	                        ],
	                        "type": "u8"
	                    },
	                    {
	                        "name": "ownerSlot",
	                        "docs": [
	                            "Index into the owning MangoAccount's PerpOpenOrders"
	                        ],
	                        "type": "u8"
	                    },
	                    {
	                        "name": "orderType",
	                        "docs": [
	                            "PostOrderType, this was added for TradingView move order"
	                        ],
	                        "type": "u8"
	                    },
	                    {
	                        "name": "padding",
	                        "type": {
	                            "array": [
	                                "u8",
	                                1
	                            ]
	                        }
	                    },
	                    {
	                        "name": "timeInForce",
	                        "docs": [
	                            "Time in seconds after `timestamp` at which the order expires.",
	                            "A value of 0 means no expiry."
	                        ],
	                        "type": "u16"
	                    },
	                    {
	                        "name": "padding2",
	                        "type": {
	                            "array": [
	                                "u8",
	                                2
	                            ]
	                        }
	                    },
	                    {
	                        "name": "key",
	                        "docs": [
	                            "The binary tree key, see new_node_key()"
	                        ],
	                        "type": "u128"
	                    },
	                    {
	                        "name": "owner",
	                        "docs": [
	                            "Address of the owning MangoAccount"
	                        ],
	                        "type": "publicKey"
	                    },
	                    {
	                        "name": "quantity",
	                        "docs": [
	                            "Number of base lots to buy or sell, always >=1"
	                        ],
	                        "type": "i64"
	                    },
	                    {
	                        "name": "timestamp",
	                        "docs": [
	                            "The time the order was placed"
	                        ],
	                        "type": "u64"
	                    },
	                    {
	                        "name": "pegLimit",
	                        "docs": [
	                            "If the effective price of an oracle pegged order exceeds this limit,",
	                            "it will be considered invalid and may be removed.",
	                            "",
	                            "Only applicable in the oracle_pegged OrderTree"
	                        ],
	                        "type": "i64"
	                    },
	                    {
	                        "name": "clientOrderId",
	                        "docs": [
	                            "User defined id for this order, used in FillEvents"
	                        ],
	                        "type": "u64"
	                    },
	                    {
	                        "name": "reserved",
	                        "type": {
	                            "array": [
	                                "u8",
	                                32
	                            ]
	                        }
	                    }
	                ]
	            }
	        },
	        {
	            "name": "AnyNode",
	            "type": {
	                "kind": "struct",
	                "fields": [
	                    {
	                        "name": "tag",
	                        "type": "u8"
	                    },
	                    {
	                        "name": "data",
	                        "type": {
	                            "array": [
	                                "u8",
	                                119
	                            ]
	                        }
	                    }
	                ]
	            }
	        },
	        {
	            "name": "OrderTreeRoot",
	            "type": {
	                "kind": "struct",
	                "fields": [
	                    {
	                        "name": "maybeNode",
	                        "type": "u32"
	                    },
	                    {
	                        "name": "leafCount",
	                        "type": "u32"
	                    }
	                ]
	            }
	        },
	        {
	            "name": "OrderTreeNodes",
	            "docs": [
	                "A binary tree on AnyNode::key()",
	                "",
	                "The key encodes the price in the top 64 bits."
	            ],
	            "type": {
	                "kind": "struct",
	                "fields": [
	                    {
	                        "name": "orderTreeType",
	                        "type": "u8"
	                    },
	                    {
	                        "name": "padding",
	                        "type": {
	                            "array": [
	                                "u8",
	                                3
	                            ]
	                        }
	                    },
	                    {
	                        "name": "bumpIndex",
	                        "type": "u32"
	                    },
	                    {
	                        "name": "freeListLen",
	                        "type": "u32"
	                    },
	                    {
	                        "name": "freeListHead",
	                        "type": "u32"
	                    },
	                    {
	                        "name": "reserved",
	                        "type": {
	                            "array": [
	                                "u8",
	                                512
	                            ]
	                        }
	                    },
	                    {
	                        "name": "nodes",
	                        "type": {
	                            "array": [
	                                {
	                                    "defined": "AnyNode"
	                                },
	                                1024
	                            ]
	                        }
	                    }
	                ]
	            }
	        },
	        {
	            "name": "EventQueueHeader",
	            "type": {
	                "kind": "struct",
	                "fields": [
	                    {
	                        "name": "head",
	                        "type": "u32"
	                    },
	                    {
	                        "name": "count",
	                        "type": "u32"
	                    },
	                    {
	                        "name": "seqNum",
	                        "type": "u64"
	                    }
	                ]
	            }
	        },
	        {
	            "name": "AnyEvent",
	            "type": {
	                "kind": "struct",
	                "fields": [
	                    {
	                        "name": "eventType",
	                        "type": "u8"
	                    },
	                    {
	                        "name": "padding",
	                        "type": {
	                            "array": [
	                                "u8",
	                                207
	                            ]
	                        }
	                    }
	                ]
	            }
	        },
	        {
	            "name": "FillEvent",
	            "type": {
	                "kind": "struct",
	                "fields": [
	                    {
	                        "name": "eventType",
	                        "type": "u8"
	                    },
	                    {
	                        "name": "takerSide",
	                        "type": "u8"
	                    },
	                    {
	                        "name": "makerOut",
	                        "type": "u8"
	                    },
	                    {
	                        "name": "makerSlot",
	                        "type": "u8"
	                    },
	                    {
	                        "name": "padding",
	                        "type": {
	                            "array": [
	                                "u8",
	                                4
	                            ]
	                        }
	                    },
	                    {
	                        "name": "timestamp",
	                        "type": "u64"
	                    },
	                    {
	                        "name": "seqNum",
	                        "type": "u64"
	                    },
	                    {
	                        "name": "maker",
	                        "type": "publicKey"
	                    },
	                    {
	                        "name": "padding2",
	                        "type": {
	                            "array": [
	                                "u8",
	                                32
	                            ]
	                        }
	                    },
	                    {
	                        "name": "makerTimestamp",
	                        "type": "u64"
	                    },
	                    {
	                        "name": "taker",
	                        "type": "publicKey"
	                    },
	                    {
	                        "name": "padding3",
	                        "type": {
	                            "array": [
	                                "u8",
	                                16
	                            ]
	                        }
	                    },
	                    {
	                        "name": "takerClientOrderId",
	                        "type": "u64"
	                    },
	                    {
	                        "name": "padding4",
	                        "type": {
	                            "array": [
	                                "u8",
	                                16
	                            ]
	                        }
	                    },
	                    {
	                        "name": "price",
	                        "type": "i64"
	                    },
	                    {
	                        "name": "quantity",
	                        "type": "i64"
	                    },
	                    {
	                        "name": "makerClientOrderId",
	                        "type": "u64"
	                    },
	                    {
	                        "name": "makerFee",
	                        "type": "f32"
	                    },
	                    {
	                        "name": "takerFee",
	                        "type": "f32"
	                    },
	                    {
	                        "name": "reserved",
	                        "type": {
	                            "array": [
	                                "u8",
	                                8
	                            ]
	                        }
	                    }
	                ]
	            }
	        },
	        {
	            "name": "OutEvent",
	            "type": {
	                "kind": "struct",
	                "fields": [
	                    {
	                        "name": "eventType",
	                        "type": "u8"
	                    },
	                    {
	                        "name": "side",
	                        "type": "u8"
	                    },
	                    {
	                        "name": "ownerSlot",
	                        "type": "u8"
	                    },
	                    {
	                        "name": "padding0",
	                        "type": {
	                            "array": [
	                                "u8",
	                                5
	                            ]
	                        }
	                    },
	                    {
	                        "name": "timestamp",
	                        "type": "u64"
	                    },
	                    {
	                        "name": "seqNum",
	                        "type": "u64"
	                    },
	                    {
	                        "name": "owner",
	                        "type": "publicKey"
	                    },
	                    {
	                        "name": "quantity",
	                        "type": "i64"
	                    },
	                    {
	                        "name": "padding1",
	                        "type": {
	                            "array": [
	                                "u8",
	                                144
	                            ]
	                        }
	                    }
	                ]
	            }
	        },
	        {
	            "name": "StablePriceModel",
	            "docs": [
	                "Maintains a \"stable_price\" based on the oracle price.",
	                "",
	                "The stable price follows the oracle price, but its relative rate of",
	                "change is limited (to `stable_growth_limit`) and futher reduced if",
	                "the oracle price is far from the `delay_price`.",
	                "",
	                "Conceptually the `delay_price` is itself a time delayed",
	                "(`24 * delay_interval_seconds`, assume 24h) and relative rate of change limited",
	                "function of the oracle price. It is implemented as averaging the oracle",
	                "price over every `delay_interval_seconds` (assume 1h) and then applying the",
	                "`delay_growth_limit` between intervals."
	            ],
	            "type": {
	                "kind": "struct",
	                "fields": [
	                    {
	                        "name": "stablePrice",
	                        "docs": [
	                            "Current stable price to use in health"
	                        ],
	                        "type": "f64"
	                    },
	                    {
	                        "name": "lastUpdateTimestamp",
	                        "type": "u64"
	                    },
	                    {
	                        "name": "delayPrices",
	                        "docs": [
	                            "Stored delay_price for each delay_interval.",
	                            "If we want the delay_price to be 24h delayed, we would store one for each hour.",
	                            "This is used in a cyclical way: We use the maximally-delayed value at delay_interval_index",
	                            "and once enough time passes to move to the next delay interval, that gets overwritten and",
	                            "we use the next one."
	                        ],
	                        "type": {
	                            "array": [
	                                "f64",
	                                24
	                            ]
	                        }
	                    },
	                    {
	                        "name": "delayAccumulatorPrice",
	                        "docs": [
	                            "The delay price is based on an average over each delay_interval. The contributions",
	                            "to the average are summed up here."
	                        ],
	                        "type": "f64"
	                    },
	                    {
	                        "name": "delayAccumulatorTime",
	                        "docs": [
	                            "Accumulating the total time for the above average."
	                        ],
	                        "type": "u32"
	                    },
	                    {
	                        "name": "delayIntervalSeconds",
	                        "docs": [
	                            "Length of a delay_interval"
	                        ],
	                        "type": "u32"
	                    },
	                    {
	                        "name": "delayGrowthLimit",
	                        "docs": [
	                            "Maximal relative difference between two delay_price in consecutive intervals."
	                        ],
	                        "type": "f32"
	                    },
	                    {
	                        "name": "stableGrowthLimit",
	                        "docs": [
	                            "Maximal per-second relative difference of the stable price.",
	                            "It gets further reduced if stable and delay price disagree."
	                        ],
	                        "type": "f32"
	                    },
	                    {
	                        "name": "lastDelayIntervalIndex",
	                        "docs": [
	                            "The delay_interval_index that update() was last called on."
	                        ],
	                        "type": "u8"
	                    },
	                    {
	                        "name": "padding",
	                        "type": {
	                            "array": [
	                                "u8",
	                                7
	                            ]
	                        }
	                    },
	                    {
	                        "name": "reserved",
	                        "type": {
	                            "array": [
	                                "u8",
	                                48
	                            ]
	                        }
	                    }
	                ]
	            }
	        },
	        {
	            "name": "TokenIndex",
	            "docs": [
	                "Nothing in Rust shall use these types. They only exist so that the Anchor IDL",
	                "knows about them and typescript can deserialize it."
	            ],
	            "type": {
	                "kind": "struct",
	                "fields": [
	                    {
	                        "name": "val",
	                        "type": "u16"
	                    }
	                ]
	            }
	        },
	        {
	            "name": "Serum3MarketIndex",
	            "type": {
	                "kind": "struct",
	                "fields": [
	                    {
	                        "name": "val",
	                        "type": "u16"
	                    }
	                ]
	            }
	        },
	        {
	            "name": "PerpMarketIndex",
	            "type": {
	                "kind": "struct",
	                "fields": [
	                    {
	                        "name": "val",
	                        "type": "u16"
	                    }
	                ]
	            }
	        },
	        {
	            "name": "I80F48",
	            "type": {
	                "kind": "struct",
	                "fields": [
	                    {
	                        "name": "val",
	                        "type": "i128"
	                    }
	                ]
	            }
	        },
	        {
	            "name": "FlashLoanType",
	            "type": {
	                "kind": "enum",
	                "variants": [
	                    {
	                        "name": "Unknown"
	                    },
	                    {
	                        "name": "Swap"
	                    }
	                ]
	            }
	        },
	        {
	            "name": "Serum3SelfTradeBehavior",
	            "docs": [
	                "Copy paste a bunch of enums so that we could AnchorSerialize & AnchorDeserialize them"
	            ],
	            "type": {
	                "kind": "enum",
	                "variants": [
	                    {
	                        "name": "DecrementTake"
	                    },
	                    {
	                        "name": "CancelProvide"
	                    },
	                    {
	                        "name": "AbortTransaction"
	                    }
	                ]
	            }
	        },
	        {
	            "name": "Serum3OrderType",
	            "type": {
	                "kind": "enum",
	                "variants": [
	                    {
	                        "name": "Limit"
	                    },
	                    {
	                        "name": "ImmediateOrCancel"
	                    },
	                    {
	                        "name": "PostOnly"
	                    }
	                ]
	            }
	        },
	        {
	            "name": "Serum3Side",
	            "type": {
	                "kind": "enum",
	                "variants": [
	                    {
	                        "name": "Bid"
	                    },
	                    {
	                        "name": "Ask"
	                    }
	                ]
	            }
	        },
	        {
	            "name": "HealthType",
	            "docs": [
	                "There are three types of health:",
	                "- initial health (\"init\"): users can only open new positions if it's >= 0",
	                "- maintenance health (\"maint\"): users get liquidated if it's < 0",
	                "- liquidation end health: once liquidation started (see being_liquidated), it",
	                "only stops once this is >= 0",
	                "",
	                "The ordering is",
	                "init health <= liquidation end health <= maint health",
	                "",
	                "The different health types are realized by using different weights and prices:",
	                "- init health: init weights with scaling, stable-price adjusted prices",
	                "- liq end health: init weights without scaling, oracle prices",
	                "- maint health: maint weights, oracle prices",
	                ""
	            ],
	            "type": {
	                "kind": "enum",
	                "variants": [
	                    {
	                        "name": "Init"
	                    },
	                    {
	                        "name": "Maint"
	                    },
	                    {
	                        "name": "LiquidationEnd"
	                    }
	                ]
	            }
	        },
	        {
	            "name": "LoanOriginationFeeInstruction",
	            "type": {
	                "kind": "enum",
	                "variants": [
	                    {
	                        "name": "Unknown"
	                    },
	                    {
	                        "name": "LiqTokenBankruptcy"
	                    },
	                    {
	                        "name": "LiqTokenWithToken"
	                    },
	                    {
	                        "name": "Serum3LiqForceCancelOrders"
	                    },
	                    {
	                        "name": "Serum3PlaceOrder"
	                    },
	                    {
	                        "name": "Serum3SettleFunds"
	                    },
	                    {
	                        "name": "TokenWithdraw"
	                    }
	                ]
	            }
	        },
	        {
	            "name": "IxGate",
	            "docs": [
	                "Enum for lookup into ix gate",
	                "note:",
	                "total ix files 56,",
	                "ix files included 48,",
	                "ix files not included 8,",
	                "- Benchmark,",
	                "- ComputeAccountData,",
	                "- GroupCreate",
	                "- GroupEdit",
	                "- IxGateSet,",
	                "- PerpZeroOut,",
	                "- PerpEditMarket,",
	                "- TokenEdit,"
	            ],
	            "type": {
	                "kind": "enum",
	                "variants": [
	                    {
	                        "name": "AccountClose"
	                    },
	                    {
	                        "name": "AccountCreate"
	                    },
	                    {
	                        "name": "AccountEdit"
	                    },
	                    {
	                        "name": "AccountExpand"
	                    },
	                    {
	                        "name": "AccountToggleFreeze"
	                    },
	                    {
	                        "name": "AltExtend"
	                    },
	                    {
	                        "name": "AltSet"
	                    },
	                    {
	                        "name": "FlashLoan"
	                    },
	                    {
	                        "name": "GroupClose"
	                    },
	                    {
	                        "name": "GroupCreate"
	                    },
	                    {
	                        "name": "HealthRegion"
	                    },
	                    {
	                        "name": "PerpCancelAllOrders"
	                    },
	                    {
	                        "name": "PerpCancelAllOrdersBySide"
	                    },
	                    {
	                        "name": "PerpCancelOrder"
	                    },
	                    {
	                        "name": "PerpCancelOrderByClientOrderId"
	                    },
	                    {
	                        "name": "PerpCloseMarket"
	                    },
	                    {
	                        "name": "PerpConsumeEvents"
	                    },
	                    {
	                        "name": "PerpCreateMarket"
	                    },
	                    {
	                        "name": "PerpDeactivatePosition"
	                    },
	                    {
	                        "name": "PerpLiqBaseOrPositivePnl"
	                    },
	                    {
	                        "name": "PerpLiqForceCancelOrders"
	                    },
	                    {
	                        "name": "PerpLiqNegativePnlOrBankruptcy"
	                    },
	                    {
	                        "name": "PerpPlaceOrder"
	                    },
	                    {
	                        "name": "PerpSettleFees"
	                    },
	                    {
	                        "name": "PerpSettlePnl"
	                    },
	                    {
	                        "name": "PerpUpdateFunding"
	                    },
	                    {
	                        "name": "Serum3CancelAllOrders"
	                    },
	                    {
	                        "name": "Serum3CancelOrder"
	                    },
	                    {
	                        "name": "Serum3CloseOpenOrders"
	                    },
	                    {
	                        "name": "Serum3CreateOpenOrders"
	                    },
	                    {
	                        "name": "Serum3DeregisterMarket"
	                    },
	                    {
	                        "name": "Serum3EditMarket"
	                    },
	                    {
	                        "name": "Serum3LiqForceCancelOrders"
	                    },
	                    {
	                        "name": "Serum3PlaceOrder"
	                    },
	                    {
	                        "name": "Serum3RegisterMarket"
	                    },
	                    {
	                        "name": "Serum3SettleFunds"
	                    },
	                    {
	                        "name": "StubOracleClose"
	                    },
	                    {
	                        "name": "StubOracleCreate"
	                    },
	                    {
	                        "name": "StubOracleSet"
	                    },
	                    {
	                        "name": "TokenAddBank"
	                    },
	                    {
	                        "name": "TokenDeposit"
	                    },
	                    {
	                        "name": "TokenDeregister"
	                    },
	                    {
	                        "name": "TokenLiqBankruptcy"
	                    },
	                    {
	                        "name": "TokenLiqWithToken"
	                    },
	                    {
	                        "name": "TokenRegister"
	                    },
	                    {
	                        "name": "TokenRegisterTrustless"
	                    },
	                    {
	                        "name": "TokenUpdateIndexAndRate"
	                    },
	                    {
	                        "name": "TokenWithdraw"
	                    }
	                ]
	            }
	        },
	        {
	            "name": "OracleType",
	            "type": {
	                "kind": "enum",
	                "variants": [
	                    {
	                        "name": "Pyth"
	                    },
	                    {
	                        "name": "Stub"
	                    },
	                    {
	                        "name": "SwitchboardV1"
	                    },
	                    {
	                        "name": "SwitchboardV2"
	                    }
	                ]
	            }
	        },
	        {
	            "name": "OrderState",
	            "type": {
	                "kind": "enum",
	                "variants": [
	                    {
	                        "name": "Valid"
	                    },
	                    {
	                        "name": "Invalid"
	                    },
	                    {
	                        "name": "Skipped"
	                    }
	                ]
	            }
	        },
	        {
	            "name": "BookSideOrderTree",
	            "type": {
	                "kind": "enum",
	                "variants": [
	                    {
	                        "name": "Fixed"
	                    },
	                    {
	                        "name": "OraclePegged"
	                    }
	                ]
	            }
	        },
	        {
	            "name": "NodeTag",
	            "type": {
	                "kind": "enum",
	                "variants": [
	                    {
	                        "name": "Uninitialized"
	                    },
	                    {
	                        "name": "InnerNode"
	                    },
	                    {
	                        "name": "LeafNode"
	                    },
	                    {
	                        "name": "FreeNode"
	                    },
	                    {
	                        "name": "LastFreeNode"
	                    }
	                ]
	            }
	        },
	        {
	            "name": "PlaceOrderType",
	            "type": {
	                "kind": "enum",
	                "variants": [
	                    {
	                        "name": "Limit"
	                    },
	                    {
	                        "name": "ImmediateOrCancel"
	                    },
	                    {
	                        "name": "PostOnly"
	                    },
	                    {
	                        "name": "Market"
	                    },
	                    {
	                        "name": "PostOnlySlide"
	                    }
	                ]
	            }
	        },
	        {
	            "name": "PostOrderType",
	            "type": {
	                "kind": "enum",
	                "variants": [
	                    {
	                        "name": "Limit"
	                    },
	                    {
	                        "name": "PostOnly"
	                    },
	                    {
	                        "name": "PostOnlySlide"
	                    }
	                ]
	            }
	        },
	        {
	            "name": "Side",
	            "type": {
	                "kind": "enum",
	                "variants": [
	                    {
	                        "name": "Bid"
	                    },
	                    {
	                        "name": "Ask"
	                    }
	                ]
	            }
	        },
	        {
	            "name": "SideAndOrderTree",
	            "docs": [
	                "SideAndOrderTree is a storage optimization, so we don't need two bytes for the data"
	            ],
	            "type": {
	                "kind": "enum",
	                "variants": [
	                    {
	                        "name": "BidFixed"
	                    },
	                    {
	                        "name": "AskFixed"
	                    },
	                    {
	                        "name": "BidOraclePegged"
	                    },
	                    {
	                        "name": "AskOraclePegged"
	                    }
	                ]
	            }
	        },
	        {
	            "name": "OrderParams",
	            "type": {
	                "kind": "enum",
	                "variants": [
	                    {
	                        "name": "Market"
	                    },
	                    {
	                        "name": "ImmediateOrCancel",
	                        "fields": [
	                            {
	                                "name": "price_lots",
	                                "type": "i64"
	                            }
	                        ]
	                    },
	                    {
	                        "name": "Fixed",
	                        "fields": [
	                            {
	                                "name": "price_lots",
	                                "type": "i64"
	                            },
	                            {
	                                "name": "order_type",
	                                "type": {
	                                    "defined": "PostOrderType"
	                                }
	                            }
	                        ]
	                    },
	                    {
	                        "name": "OraclePegged",
	                        "fields": [
	                            {
	                                "name": "price_offset_lots",
	                                "type": "i64"
	                            },
	                            {
	                                "name": "order_type",
	                                "type": {
	                                    "defined": "PostOrderType"
	                                }
	                            },
	                            {
	                                "name": "peg_limit",
	                                "type": "i64"
	                            },
	                            {
	                                "name": "max_oracle_staleness_slots",
	                                "type": "i32"
	                            }
	                        ]
	                    }
	                ]
	            }
	        },
	        {
	            "name": "OrderTreeType",
	            "type": {
	                "kind": "enum",
	                "variants": [
	                    {
	                        "name": "Bids"
	                    },
	                    {
	                        "name": "Asks"
	                    }
	                ]
	            }
	        },
	        {
	            "name": "EventType",
	            "type": {
	                "kind": "enum",
	                "variants": [
	                    {
	                        "name": "Fill"
	                    },
	                    {
	                        "name": "Out"
	                    },
	                    {
	                        "name": "Liquidate"
	                    }
	                ]
	            }
	        }
	    ],
	    "events": [
	        {
	            "name": "MangoAccountData",
	            "fields": [
	                {
	                    "name": "healthCache",
	                    "type": {
	                        "defined": "HealthCache"
	                    },
	                    "index": false
	                },
	                {
	                    "name": "initHealth",
	                    "type": {
	                        "defined": "I80F48"
	                    },
	                    "index": false
	                },
	                {
	                    "name": "maintHealth",
	                    "type": {
	                        "defined": "I80F48"
	                    },
	                    "index": false
	                },
	                {
	                    "name": "equity",
	                    "type": {
	                        "defined": "Equity"
	                    },
	                    "index": false
	                }
	            ]
	        },
	        {
	            "name": "PerpBalanceLog",
	            "fields": [
	                {
	                    "name": "mangoGroup",
	                    "type": "publicKey",
	                    "index": false
	                },
	                {
	                    "name": "mangoAccount",
	                    "type": "publicKey",
	                    "index": false
	                },
	                {
	                    "name": "marketIndex",
	                    "type": "u16",
	                    "index": false
	                },
	                {
	                    "name": "basePosition",
	                    "type": "i64",
	                    "index": false
	                },
	                {
	                    "name": "quotePosition",
	                    "type": "i128",
	                    "index": false
	                },
	                {
	                    "name": "longSettledFunding",
	                    "type": "i128",
	                    "index": false
	                },
	                {
	                    "name": "shortSettledFunding",
	                    "type": "i128",
	                    "index": false
	                },
	                {
	                    "name": "longFunding",
	                    "type": "i128",
	                    "index": false
	                },
	                {
	                    "name": "shortFunding",
	                    "type": "i128",
	                    "index": false
	                }
	            ]
	        },
	        {
	            "name": "TokenBalanceLog",
	            "fields": [
	                {
	                    "name": "mangoGroup",
	                    "type": "publicKey",
	                    "index": false
	                },
	                {
	                    "name": "mangoAccount",
	                    "type": "publicKey",
	                    "index": false
	                },
	                {
	                    "name": "tokenIndex",
	                    "type": "u16",
	                    "index": false
	                },
	                {
	                    "name": "indexedPosition",
	                    "type": "i128",
	                    "index": false
	                },
	                {
	                    "name": "depositIndex",
	                    "type": "i128",
	                    "index": false
	                },
	                {
	                    "name": "borrowIndex",
	                    "type": "i128",
	                    "index": false
	                }
	            ]
	        },
	        {
	            "name": "FlashLoanLog",
	            "fields": [
	                {
	                    "name": "mangoGroup",
	                    "type": "publicKey",
	                    "index": false
	                },
	                {
	                    "name": "mangoAccount",
	                    "type": "publicKey",
	                    "index": false
	                },
	                {
	                    "name": "tokenLoanDetails",
	                    "type": {
	                        "vec": {
	                            "defined": "FlashLoanTokenDetail"
	                        }
	                    },
	                    "index": false
	                },
	                {
	                    "name": "flashLoanType",
	                    "type": {
	                        "defined": "FlashLoanType"
	                    },
	                    "index": false
	                }
	            ]
	        },
	        {
	            "name": "WithdrawLog",
	            "fields": [
	                {
	                    "name": "mangoGroup",
	                    "type": "publicKey",
	                    "index": false
	                },
	                {
	                    "name": "mangoAccount",
	                    "type": "publicKey",
	                    "index": false
	                },
	                {
	                    "name": "signer",
	                    "type": "publicKey",
	                    "index": false
	                },
	                {
	                    "name": "tokenIndex",
	                    "type": "u16",
	                    "index": false
	                },
	                {
	                    "name": "quantity",
	                    "type": "u64",
	                    "index": false
	                },
	                {
	                    "name": "price",
	                    "type": "i128",
	                    "index": false
	                }
	            ]
	        },
	        {
	            "name": "DepositLog",
	            "fields": [
	                {
	                    "name": "mangoGroup",
	                    "type": "publicKey",
	                    "index": false
	                },
	                {
	                    "name": "mangoAccount",
	                    "type": "publicKey",
	                    "index": false
	                },
	                {
	                    "name": "signer",
	                    "type": "publicKey",
	                    "index": false
	                },
	                {
	                    "name": "tokenIndex",
	                    "type": "u16",
	                    "index": false
	                },
	                {
	                    "name": "quantity",
	                    "type": "u64",
	                    "index": false
	                },
	                {
	                    "name": "price",
	                    "type": "i128",
	                    "index": false
	                }
	            ]
	        },
	        {
	            "name": "FillLog",
	            "fields": [
	                {
	                    "name": "mangoGroup",
	                    "type": "publicKey",
	                    "index": false
	                },
	                {
	                    "name": "marketIndex",
	                    "type": "u16",
	                    "index": false
	                },
	                {
	                    "name": "takerSide",
	                    "type": "u8",
	                    "index": false
	                },
	                {
	                    "name": "makerSlot",
	                    "type": "u8",
	                    "index": false
	                },
	                {
	                    "name": "makerOut",
	                    "type": "bool",
	                    "index": false
	                },
	                {
	                    "name": "timestamp",
	                    "type": "u64",
	                    "index": false
	                },
	                {
	                    "name": "seqNum",
	                    "type": "u64",
	                    "index": false
	                },
	                {
	                    "name": "maker",
	                    "type": "publicKey",
	                    "index": false
	                },
	                {
	                    "name": "makerOrderId",
	                    "type": "u128",
	                    "index": false
	                },
	                {
	                    "name": "makerFee",
	                    "type": "i128",
	                    "index": false
	                },
	                {
	                    "name": "makerTimestamp",
	                    "type": "u64",
	                    "index": false
	                },
	                {
	                    "name": "taker",
	                    "type": "publicKey",
	                    "index": false
	                },
	                {
	                    "name": "takerOrderId",
	                    "type": "u128",
	                    "index": false
	                },
	                {
	                    "name": "takerClientOrderId",
	                    "type": "u64",
	                    "index": false
	                },
	                {
	                    "name": "takerFee",
	                    "type": "i128",
	                    "index": false
	                },
	                {
	                    "name": "price",
	                    "type": "i64",
	                    "index": false
	                },
	                {
	                    "name": "quantity",
	                    "type": "i64",
	                    "index": false
	                }
	            ]
	        },
	        {
	            "name": "FillLogV2",
	            "fields": [
	                {
	                    "name": "mangoGroup",
	                    "type": "publicKey",
	                    "index": false
	                },
	                {
	                    "name": "marketIndex",
	                    "type": "u16",
	                    "index": false
	                },
	                {
	                    "name": "takerSide",
	                    "type": "u8",
	                    "index": false
	                },
	                {
	                    "name": "makerSlot",
	                    "type": "u8",
	                    "index": false
	                },
	                {
	                    "name": "makerOut",
	                    "type": "bool",
	                    "index": false
	                },
	                {
	                    "name": "timestamp",
	                    "type": "u64",
	                    "index": false
	                },
	                {
	                    "name": "seqNum",
	                    "type": "u64",
	                    "index": false
	                },
	                {
	                    "name": "maker",
	                    "type": "publicKey",
	                    "index": false
	                },
	                {
	                    "name": "makerClientOrderId",
	                    "type": "u64",
	                    "index": false
	                },
	                {
	                    "name": "makerFee",
	                    "type": "f32",
	                    "index": false
	                },
	                {
	                    "name": "makerTimestamp",
	                    "type": "u64",
	                    "index": false
	                },
	                {
	                    "name": "taker",
	                    "type": "publicKey",
	                    "index": false
	                },
	                {
	                    "name": "takerClientOrderId",
	                    "type": "u64",
	                    "index": false
	                },
	                {
	                    "name": "takerFee",
	                    "type": "f32",
	                    "index": false
	                },
	                {
	                    "name": "price",
	                    "type": "i64",
	                    "index": false
	                },
	                {
	                    "name": "quantity",
	                    "type": "i64",
	                    "index": false
	                }
	            ]
	        },
	        {
	            "name": "PerpUpdateFundingLog",
	            "fields": [
	                {
	                    "name": "mangoGroup",
	                    "type": "publicKey",
	                    "index": false
	                },
	                {
	                    "name": "marketIndex",
	                    "type": "u16",
	                    "index": false
	                },
	                {
	                    "name": "longFunding",
	                    "type": "i128",
	                    "index": false
	                },
	                {
	                    "name": "shortFunding",
	                    "type": "i128",
	                    "index": false
	                },
	                {
	                    "name": "price",
	                    "type": "i128",
	                    "index": false
	                },
	                {
	                    "name": "stablePrice",
	                    "type": "i128",
	                    "index": false
	                },
	                {
	                    "name": "feesAccrued",
	                    "type": "i128",
	                    "index": false
	                },
	                {
	                    "name": "openInterest",
	                    "type": "i64",
	                    "index": false
	                },
	                {
	                    "name": "instantaneousFundingRate",
	                    "type": "i128",
	                    "index": false
	                }
	            ]
	        },
	        {
	            "name": "UpdateIndexLog",
	            "fields": [
	                {
	                    "name": "mangoGroup",
	                    "type": "publicKey",
	                    "index": false
	                },
	                {
	                    "name": "tokenIndex",
	                    "type": "u16",
	                    "index": false
	                },
	                {
	                    "name": "depositIndex",
	                    "type": "i128",
	                    "index": false
	                },
	                {
	                    "name": "borrowIndex",
	                    "type": "i128",
	                    "index": false
	                },
	                {
	                    "name": "avgUtilization",
	                    "type": "i128",
	                    "index": false
	                },
	                {
	                    "name": "price",
	                    "type": "i128",
	                    "index": false
	                },
	                {
	                    "name": "stablePrice",
	                    "type": "i128",
	                    "index": false
	                },
	                {
	                    "name": "collectedFees",
	                    "type": "i128",
	                    "index": false
	                },
	                {
	                    "name": "loanFeeRate",
	                    "type": "i128",
	                    "index": false
	                },
	                {
	                    "name": "totalBorrows",
	                    "type": "i128",
	                    "index": false
	                },
	                {
	                    "name": "totalDeposits",
	                    "type": "i128",
	                    "index": false
	                },
	                {
	                    "name": "borrowRate",
	                    "type": "i128",
	                    "index": false
	                },
	                {
	                    "name": "depositRate",
	                    "type": "i128",
	                    "index": false
	                }
	            ]
	        },
	        {
	            "name": "UpdateRateLog",
	            "fields": [
	                {
	                    "name": "mangoGroup",
	                    "type": "publicKey",
	                    "index": false
	                },
	                {
	                    "name": "tokenIndex",
	                    "type": "u16",
	                    "index": false
	                },
	                {
	                    "name": "rate0",
	                    "type": "i128",
	                    "index": false
	                },
	                {
	                    "name": "rate1",
	                    "type": "i128",
	                    "index": false
	                },
	                {
	                    "name": "maxRate",
	                    "type": "i128",
	                    "index": false
	                }
	            ]
	        },
	        {
	            "name": "TokenLiqWithTokenLog",
	            "fields": [
	                {
	                    "name": "mangoGroup",
	                    "type": "publicKey",
	                    "index": false
	                },
	                {
	                    "name": "liqee",
	                    "type": "publicKey",
	                    "index": false
	                },
	                {
	                    "name": "liqor",
	                    "type": "publicKey",
	                    "index": false
	                },
	                {
	                    "name": "assetTokenIndex",
	                    "type": "u16",
	                    "index": false
	                },
	                {
	                    "name": "liabTokenIndex",
	                    "type": "u16",
	                    "index": false
	                },
	                {
	                    "name": "assetTransfer",
	                    "type": "i128",
	                    "index": false
	                },
	                {
	                    "name": "liabTransfer",
	                    "type": "i128",
	                    "index": false
	                },
	                {
	                    "name": "assetPrice",
	                    "type": "i128",
	                    "index": false
	                },
	                {
	                    "name": "liabPrice",
	                    "type": "i128",
	                    "index": false
	                },
	                {
	                    "name": "bankruptcy",
	                    "type": "bool",
	                    "index": false
	                }
	            ]
	        },
	        {
	            "name": "Serum3OpenOrdersBalanceLog",
	            "fields": [
	                {
	                    "name": "mangoGroup",
	                    "type": "publicKey",
	                    "index": false
	                },
	                {
	                    "name": "mangoAccount",
	                    "type": "publicKey",
	                    "index": false
	                },
	                {
	                    "name": "baseTokenIndex",
	                    "type": "u16",
	                    "index": false
	                },
	                {
	                    "name": "quoteTokenIndex",
	                    "type": "u16",
	                    "index": false
	                },
	                {
	                    "name": "baseTotal",
	                    "type": "u64",
	                    "index": false
	                },
	                {
	                    "name": "baseFree",
	                    "type": "u64",
	                    "index": false
	                },
	                {
	                    "name": "quoteTotal",
	                    "type": "u64",
	                    "index": false
	                },
	                {
	                    "name": "quoteFree",
	                    "type": "u64",
	                    "index": false
	                },
	                {
	                    "name": "referrerRebatesAccrued",
	                    "type": "u64",
	                    "index": false
	                }
	            ]
	        },
	        {
	            "name": "Serum3OpenOrdersBalanceLogV2",
	            "fields": [
	                {
	                    "name": "mangoGroup",
	                    "type": "publicKey",
	                    "index": false
	                },
	                {
	                    "name": "mangoAccount",
	                    "type": "publicKey",
	                    "index": false
	                },
	                {
	                    "name": "marketIndex",
	                    "type": "u16",
	                    "index": false
	                },
	                {
	                    "name": "baseTokenIndex",
	                    "type": "u16",
	                    "index": false
	                },
	                {
	                    "name": "quoteTokenIndex",
	                    "type": "u16",
	                    "index": false
	                },
	                {
	                    "name": "baseTotal",
	                    "type": "u64",
	                    "index": false
	                },
	                {
	                    "name": "baseFree",
	                    "type": "u64",
	                    "index": false
	                },
	                {
	                    "name": "quoteTotal",
	                    "type": "u64",
	                    "index": false
	                },
	                {
	                    "name": "quoteFree",
	                    "type": "u64",
	                    "index": false
	                },
	                {
	                    "name": "referrerRebatesAccrued",
	                    "type": "u64",
	                    "index": false
	                }
	            ]
	        },
	        {
	            "name": "WithdrawLoanOriginationFeeLog",
	            "fields": [
	                {
	                    "name": "mangoGroup",
	                    "type": "publicKey",
	                    "index": false
	                },
	                {
	                    "name": "mangoAccount",
	                    "type": "publicKey",
	                    "index": false
	                },
	                {
	                    "name": "tokenIndex",
	                    "type": "u16",
	                    "index": false
	                },
	                {
	                    "name": "loanOriginationFee",
	                    "type": "i128",
	                    "index": false
	                },
	                {
	                    "name": "instruction",
	                    "type": {
	                        "defined": "LoanOriginationFeeInstruction"
	                    },
	                    "index": false
	                }
	            ]
	        },
	        {
	            "name": "TokenLiqBankruptcyLog",
	            "fields": [
	                {
	                    "name": "mangoGroup",
	                    "type": "publicKey",
	                    "index": false
	                },
	                {
	                    "name": "liqee",
	                    "type": "publicKey",
	                    "index": false
	                },
	                {
	                    "name": "liqor",
	                    "type": "publicKey",
	                    "index": false
	                },
	                {
	                    "name": "liabTokenIndex",
	                    "type": "u16",
	                    "index": false
	                },
	                {
	                    "name": "initialLiabNative",
	                    "type": "i128",
	                    "index": false
	                },
	                {
	                    "name": "liabPrice",
	                    "type": "i128",
	                    "index": false
	                },
	                {
	                    "name": "insuranceTokenIndex",
	                    "type": "u16",
	                    "index": false
	                },
	                {
	                    "name": "insuranceTransfer",
	                    "type": "i128",
	                    "index": false
	                },
	                {
	                    "name": "socializedLoss",
	                    "type": "i128",
	                    "index": false
	                },
	                {
	                    "name": "startingLiabDepositIndex",
	                    "type": "i128",
	                    "index": false
	                },
	                {
	                    "name": "endingLiabDepositIndex",
	                    "type": "i128",
	                    "index": false
	                }
	            ]
	        },
	        {
	            "name": "DeactivateTokenPositionLog",
	            "fields": [
	                {
	                    "name": "mangoGroup",
	                    "type": "publicKey",
	                    "index": false
	                },
	                {
	                    "name": "mangoAccount",
	                    "type": "publicKey",
	                    "index": false
	                },
	                {
	                    "name": "tokenIndex",
	                    "type": "u16",
	                    "index": false
	                },
	                {
	                    "name": "cumulativeDepositInterest",
	                    "type": "f64",
	                    "index": false
	                },
	                {
	                    "name": "cumulativeBorrowInterest",
	                    "type": "f64",
	                    "index": false
	                }
	            ]
	        },
	        {
	            "name": "DeactivatePerpPositionLog",
	            "fields": [
	                {
	                    "name": "mangoGroup",
	                    "type": "publicKey",
	                    "index": false
	                },
	                {
	                    "name": "mangoAccount",
	                    "type": "publicKey",
	                    "index": false
	                },
	                {
	                    "name": "marketIndex",
	                    "type": "u16",
	                    "index": false
	                },
	                {
	                    "name": "cumulativeLongFunding",
	                    "type": "f64",
	                    "index": false
	                },
	                {
	                    "name": "cumulativeShortFunding",
	                    "type": "f64",
	                    "index": false
	                },
	                {
	                    "name": "makerVolume",
	                    "type": "u64",
	                    "index": false
	                },
	                {
	                    "name": "takerVolume",
	                    "type": "u64",
	                    "index": false
	                },
	                {
	                    "name": "perpSpotTransfers",
	                    "type": "i64",
	                    "index": false
	                }
	            ]
	        },
	        {
	            "name": "TokenMetaDataLog",
	            "fields": [
	                {
	                    "name": "mangoGroup",
	                    "type": "publicKey",
	                    "index": false
	                },
	                {
	                    "name": "mint",
	                    "type": "publicKey",
	                    "index": false
	                },
	                {
	                    "name": "tokenIndex",
	                    "type": "u16",
	                    "index": false
	                },
	                {
	                    "name": "mintDecimals",
	                    "type": "u8",
	                    "index": false
	                },
	                {
	                    "name": "oracle",
	                    "type": "publicKey",
	                    "index": false
	                },
	                {
	                    "name": "mintInfo",
	                    "type": "publicKey",
	                    "index": false
	                }
	            ]
	        },
	        {
	            "name": "PerpMarketMetaDataLog",
	            "fields": [
	                {
	                    "name": "mangoGroup",
	                    "type": "publicKey",
	                    "index": false
	                },
	                {
	                    "name": "perpMarket",
	                    "type": "publicKey",
	                    "index": false
	                },
	                {
	                    "name": "perpMarketIndex",
	                    "type": "u16",
	                    "index": false
	                },
	                {
	                    "name": "baseDecimals",
	                    "type": "u8",
	                    "index": false
	                },
	                {
	                    "name": "baseLotSize",
	                    "type": "i64",
	                    "index": false
	                },
	                {
	                    "name": "quoteLotSize",
	                    "type": "i64",
	                    "index": false
	                },
	                {
	                    "name": "oracle",
	                    "type": "publicKey",
	                    "index": false
	                }
	            ]
	        },
	        {
	            "name": "Serum3RegisterMarketLog",
	            "fields": [
	                {
	                    "name": "mangoGroup",
	                    "type": "publicKey",
	                    "index": false
	                },
	                {
	                    "name": "serumMarket",
	                    "type": "publicKey",
	                    "index": false
	                },
	                {
	                    "name": "marketIndex",
	                    "type": "u16",
	                    "index": false
	                },
	                {
	                    "name": "baseTokenIndex",
	                    "type": "u16",
	                    "index": false
	                },
	                {
	                    "name": "quoteTokenIndex",
	                    "type": "u16",
	                    "index": false
	                },
	                {
	                    "name": "serumProgram",
	                    "type": "publicKey",
	                    "index": false
	                },
	                {
	                    "name": "serumProgramExternal",
	                    "type": "publicKey",
	                    "index": false
	                }
	            ]
	        },
	        {
	            "name": "PerpLiqBaseOrPositivePnlLog",
	            "fields": [
	                {
	                    "name": "mangoGroup",
	                    "type": "publicKey",
	                    "index": false
	                },
	                {
	                    "name": "perpMarketIndex",
	                    "type": "u16",
	                    "index": false
	                },
	                {
	                    "name": "liqor",
	                    "type": "publicKey",
	                    "index": false
	                },
	                {
	                    "name": "liqee",
	                    "type": "publicKey",
	                    "index": false
	                },
	                {
	                    "name": "baseTransfer",
	                    "type": "i64",
	                    "index": false
	                },
	                {
	                    "name": "quoteTransfer",
	                    "type": "i128",
	                    "index": false
	                },
	                {
	                    "name": "pnlTransfer",
	                    "type": "i128",
	                    "index": false
	                },
	                {
	                    "name": "pnlSettleLimitTransfer",
	                    "type": "i128",
	                    "index": false
	                },
	                {
	                    "name": "price",
	                    "type": "i128",
	                    "index": false
	                }
	            ]
	        },
	        {
	            "name": "PerpLiqBankruptcyLog",
	            "fields": [
	                {
	                    "name": "mangoGroup",
	                    "type": "publicKey",
	                    "index": false
	                },
	                {
	                    "name": "liqee",
	                    "type": "publicKey",
	                    "index": false
	                },
	                {
	                    "name": "liqor",
	                    "type": "publicKey",
	                    "index": false
	                },
	                {
	                    "name": "perpMarketIndex",
	                    "type": "u16",
	                    "index": false
	                },
	                {
	                    "name": "insuranceTransfer",
	                    "type": "i128",
	                    "index": false
	                },
	                {
	                    "name": "socializedLoss",
	                    "type": "i128",
	                    "index": false
	                },
	                {
	                    "name": "startingLongFunding",
	                    "type": "i128",
	                    "index": false
	                },
	                {
	                    "name": "startingShortFunding",
	                    "type": "i128",
	                    "index": false
	                },
	                {
	                    "name": "endingLongFunding",
	                    "type": "i128",
	                    "index": false
	                },
	                {
	                    "name": "endingShortFunding",
	                    "type": "i128",
	                    "index": false
	                }
	            ]
	        },
	        {
	            "name": "PerpLiqNegativePnlOrBankruptcyLog",
	            "fields": [
	                {
	                    "name": "mangoGroup",
	                    "type": "publicKey",
	                    "index": false
	                },
	                {
	                    "name": "liqee",
	                    "type": "publicKey",
	                    "index": false
	                },
	                {
	                    "name": "liqor",
	                    "type": "publicKey",
	                    "index": false
	                },
	                {
	                    "name": "perpMarketIndex",
	                    "type": "u16",
	                    "index": false
	                },
	                {
	                    "name": "settlement",
	                    "type": "i128",
	                    "index": false
	                }
	            ]
	        },
	        {
	            "name": "PerpSettlePnlLog",
	            "fields": [
	                {
	                    "name": "mangoGroup",
	                    "type": "publicKey",
	                    "index": false
	                },
	                {
	                    "name": "mangoAccountA",
	                    "type": "publicKey",
	                    "index": false
	                },
	                {
	                    "name": "mangoAccountB",
	                    "type": "publicKey",
	                    "index": false
	                },
	                {
	                    "name": "perpMarketIndex",
	                    "type": "u16",
	                    "index": false
	                },
	                {
	                    "name": "settlement",
	                    "type": "i128",
	                    "index": false
	                },
	                {
	                    "name": "settler",
	                    "type": "publicKey",
	                    "index": false
	                },
	                {
	                    "name": "fee",
	                    "type": "i128",
	                    "index": false
	                }
	            ]
	        },
	        {
	            "name": "PerpSettleFeesLog",
	            "fields": [
	                {
	                    "name": "mangoGroup",
	                    "type": "publicKey",
	                    "index": false
	                },
	                {
	                    "name": "mangoAccount",
	                    "type": "publicKey",
	                    "index": false
	                },
	                {
	                    "name": "perpMarketIndex",
	                    "type": "u16",
	                    "index": false
	                },
	                {
	                    "name": "settlement",
	                    "type": "i128",
	                    "index": false
	                }
	            ]
	        }
	    ],
	    "errors": [
	        {
	            "code": 6000,
	            "name": "SomeError",
	            "msg": ""
	        },
	        {
	            "code": 6001,
	            "name": "NotImplementedError",
	            "msg": ""
	        },
	        {
	            "code": 6002,
	            "name": "MathError",
	            "msg": "checked math error"
	        },
	        {
	            "code": 6003,
	            "name": "UnexpectedOracle",
	            "msg": ""
	        },
	        {
	            "code": 6004,
	            "name": "UnknownOracleType",
	            "msg": "oracle type cannot be determined"
	        },
	        {
	            "code": 6005,
	            "name": "InvalidFlashLoanTargetCpiProgram",
	            "msg": ""
	        },
	        {
	            "code": 6006,
	            "name": "HealthMustBePositive",
	            "msg": "health must be positive"
	        },
	        {
	            "code": 6007,
	            "name": "HealthMustBePositiveOrIncrease",
	            "msg": "health must be positive or increase"
	        },
	        {
	            "code": 6008,
	            "name": "HealthMustBeNegative",
	            "msg": "health must be negative"
	        },
	        {
	            "code": 6009,
	            "name": "IsBankrupt",
	            "msg": "the account is bankrupt"
	        },
	        {
	            "code": 6010,
	            "name": "IsNotBankrupt",
	            "msg": "the account is not bankrupt"
	        },
	        {
	            "code": 6011,
	            "name": "NoFreeTokenPositionIndex",
	            "msg": "no free token position index"
	        },
	        {
	            "code": 6012,
	            "name": "NoFreeSerum3OpenOrdersIndex",
	            "msg": "no free serum3 open orders index"
	        },
	        {
	            "code": 6013,
	            "name": "NoFreePerpPositionIndex",
	            "msg": "no free perp position index"
	        },
	        {
	            "code": 6014,
	            "name": "Serum3OpenOrdersExistAlready",
	            "msg": "serum3 open orders exist already"
	        },
	        {
	            "code": 6015,
	            "name": "InsufficentBankVaultFunds",
	            "msg": "bank vault has insufficent funds"
	        },
	        {
	            "code": 6016,
	            "name": "BeingLiquidated",
	            "msg": "account is currently being liquidated"
	        },
	        {
	            "code": 6017,
	            "name": "InvalidBank",
	            "msg": "invalid bank"
	        },
	        {
	            "code": 6018,
	            "name": "ProfitabilityMismatch",
	            "msg": "account profitability is mismatched"
	        },
	        {
	            "code": 6019,
	            "name": "CannotSettleWithSelf",
	            "msg": "cannot settle with self"
	        },
	        {
	            "code": 6020,
	            "name": "PerpPositionDoesNotExist",
	            "msg": "perp position does not exist"
	        },
	        {
	            "code": 6021,
	            "name": "MaxSettleAmountMustBeGreaterThanZero",
	            "msg": "max settle amount must be greater than zero"
	        },
	        {
	            "code": 6022,
	            "name": "HasOpenPerpOrders",
	            "msg": "the perp position has open orders or unprocessed fill events"
	        },
	        {
	            "code": 6023,
	            "name": "OracleConfidence",
	            "msg": "an oracle does not reach the confidence threshold"
	        },
	        {
	            "code": 6024,
	            "name": "OracleStale",
	            "msg": "an oracle is stale"
	        },
	        {
	            "code": 6025,
	            "name": "SettlementAmountMustBePositive",
	            "msg": "settlement amount must always be positive"
	        },
	        {
	            "code": 6026,
	            "name": "BankBorrowLimitReached",
	            "msg": "bank utilization has reached limit"
	        },
	        {
	            "code": 6027,
	            "name": "BankNetBorrowsLimitReached",
	            "msg": "bank net borrows has reached limit - this is an intermittent error - the limit will reset regularly"
	        },
	        {
	            "code": 6028,
	            "name": "TokenPositionDoesNotExist",
	            "msg": "token position does not exist"
	        },
	        {
	            "code": 6029,
	            "name": "DepositsIntoLiquidatingMustRecover",
	            "msg": "token deposits into accounts that are being liquidated must bring their health above the init threshold"
	        },
	        {
	            "code": 6030,
	            "name": "TokenInReduceOnlyMode",
	            "msg": "token is in reduce only mode"
	        },
	        {
	            "code": 6031,
	            "name": "MarketInReduceOnlyMode",
	            "msg": "market is in reduce only mode"
	        },
	        {
	            "code": 6032,
	            "name": "GroupIsHalted",
	            "msg": "group is halted"
	        },
	        {
	            "code": 6033,
	            "name": "PerpHasBaseLots",
	            "msg": "the perp position has non-zero base lots"
	        },
	        {
	            "code": 6034,
	            "name": "HasOpenOrUnsettledSerum3Orders",
	            "msg": "there are open or unsettled serum3 orders"
	        },
	        {
	            "code": 6035,
	            "name": "HasLiquidatableTokenPosition",
	            "msg": "has liquidatable token position"
	        },
	        {
	            "code": 6036,
	            "name": "HasLiquidatablePerpBasePosition",
	            "msg": "has liquidatable perp base position"
	        },
	        {
	            "code": 6037,
	            "name": "HasLiquidatablePositivePerpPnl",
	            "msg": "has liquidatable positive perp pnl"
	        },
	        {
	            "code": 6038,
	            "name": "AccountIsFrozen",
	            "msg": "account is frozen"
	        },
	        {
	            "code": 6039,
	            "name": "InitAssetWeightCantBeNegative",
	            "msg": "Init Asset Weight can't be negative"
	        },
	        {
	            "code": 6040,
	            "name": "HasOpenPerpTakerFills",
	            "msg": "has open perp taker fills"
	        },
	        {
	            "code": 6041,
	            "name": "DepositLimit",
	            "msg": "deposit crosses the current group deposit limit"
	        },
	        {
	            "code": 6042,
	            "name": "IxIsDisabled",
	            "msg": "instruction is disabled"
	        },
	        {
	            "code": 6043,
	            "name": "NoLiquidatablePerpBasePosition",
	            "msg": "no liquidatable perp base position"
	        },
	        {
	            "code": 6044,
	            "name": "PerpOrderIdNotFound",
	            "msg": "perp order id not found on the orderbook"
	        }
	    ]
	};

	async function sendTransaction(provider, ixs, alts, opts = {}) {
	    const connection = provider.connection;
	    const latestBlockhash = await connection.getLatestBlockhash(opts.preflightCommitment ??
	        provider.opts.preflightCommitment ??
	        'finalized');
	    const payer = provider.wallet;
	    if (opts.prioritizationFee) {
	        ixs = [createComputeBudgetIx(opts.prioritizationFee), ...ixs];
	    }
	    const message = require$$0$1.MessageV0.compile({
	        payerKey: provider.wallet.publicKey,
	        instructions: ixs,
	        recentBlockhash: latestBlockhash.blockhash,
	        addressLookupTableAccounts: alts,
	    });
	    let vtx = new require$$0$1.VersionedTransaction(message);
	    if (opts?.additionalSigners?.length) {
	        vtx.sign([...opts?.additionalSigners]);
	    }
	    if (typeof payer.signTransaction === 'function' &&
	        !(payer instanceof _default)) {
	        vtx = (await payer.signTransaction(vtx));
	    }
	    else {
	        // Maybe this path is only correct for NodeWallet?
	        vtx.sign([payer.payer]);
	    }
	    const signature = await connection.sendRawTransaction(vtx.serialize(), {
	        skipPreflight: true, // mergedOpts.skipPreflight,
	    });
	    // const signature = await connection.sendTransactionss(
	    //   vtx as any as VersionedTransaction,
	    //   {
	    //     skipPreflight: true,
	    //   },
	    // );
	    if (opts.postSendTxCallback) {
	        try {
	            opts.postSendTxCallback({ txid: signature });
	        }
	        catch (e) {
	            console.warn(`postSendTxCallback error ${e}`);
	        }
	    }
	    const txConfirmationCommitment = opts.txConfirmationCommitment ?? 'processed';
	    let status;
	    if (latestBlockhash.blockhash != null &&
	        latestBlockhash.lastValidBlockHeight != null) {
	        status = (await connection.confirmTransaction({
	            signature: signature,
	            blockhash: latestBlockhash.blockhash,
	            lastValidBlockHeight: latestBlockhash.lastValidBlockHeight,
	        }, txConfirmationCommitment)).value;
	    }
	    else {
	        status = (await connection.confirmTransaction(signature, txConfirmationCommitment)).value;
	    }
	    if (status.err) {
	        console.warn('Tx status: ', status);
	        throw new MangoError({
	            txid: signature,
	            message: `${JSON.stringify(status)}`,
	        });
	    }
	    return signature;
	}
	const createComputeBudgetIx = (microLamports) => {
	    const computeBudgetIx = require$$0$1.ComputeBudgetProgram.setComputeUnitPrice({
	        microLamports,
	    });
	    return computeBudgetIx;
	};
	class MangoError extends Error {
	    message;
	    txid;
	    constructor({ txid, message }) {
	        super();
	        this.message = message;
	        this.txid = txid;
	    }
	}

	var AccountRetriever;
	(function (AccountRetriever) {
	    AccountRetriever[AccountRetriever["Scanning"] = 0] = "Scanning";
	    AccountRetriever[AccountRetriever["Fixed"] = 1] = "Fixed";
	})(AccountRetriever || (AccountRetriever = {}));
	class MangoClient {
	    program;
	    programId;
	    cluster;
	    opts;
	    idsSource;
	    postSendTxCallback;
	    prioritizationFee;
	    txConfirmationCommitment;
	    constructor(program, programId, cluster, opts = {}) {
	        this.program = program;
	        this.programId = programId;
	        this.cluster = cluster;
	        this.opts = opts;
	        this.idsSource = opts?.idsSource || 'get-program-accounts';
	        this.prioritizationFee = opts?.prioritizationFee || 0;
	        this.postSendTxCallback = opts?.postSendTxCallback;
	        this.txConfirmationCommitment =
	            opts?.txConfirmationCommitment ??
	                program.provider.opts.commitment ??
	                'processed';
	        // TODO: evil side effect, but limited backtraces are a nightmare
	        Error.stackTraceLimit = 1000;
	    }
	    /// Transactions
	    async sendAndConfirmTransaction(ixs, opts = {}) {
	        return await sendTransaction(this.program.provider, ixs, opts.alts ?? [], {
	            postSendTxCallback: this.postSendTxCallback,
	            prioritizationFee: this.prioritizationFee,
	            txConfirmationCommitment: this.txConfirmationCommitment,
	            ...opts,
	        });
	    }
	    async sendAndConfirmTransactionForGroup(group, ixs, opts = {}) {
	        return await this.sendAndConfirmTransaction(ixs, {
	            alts: group.addressLookupTablesList,
	            ...opts,
	        });
	    }
	    // Group
	    async groupCreate(groupNum, testing, version, insuranceMintPk) {
	        const adminPk = this.program.provider.wallet.publicKey;
	        const ix = await this.program.methods
	            .groupCreate(groupNum, testing ? 1 : 0, version)
	            .accounts({
	            creator: adminPk,
	            payer: adminPk,
	            insuranceMint: insuranceMintPk,
	        })
	            .instruction();
	        return await this.sendAndConfirmTransaction([ix]);
	    }
	    async groupEdit(group, admin, fastListingAdmin, securityAdmin, testing, version, depositLimitQuote) {
	        const ix = await this.program.methods
	            .groupEdit(admin ?? null, fastListingAdmin ?? null, securityAdmin ?? null, testing ?? null, version ?? null, depositLimitQuote !== undefined ? depositLimitQuote : null)
	            .accounts({
	            group: group.publicKey,
	            admin: this.program.provider.wallet.publicKey,
	        })
	            .instruction();
	        return await this.sendAndConfirmTransactionForGroup(group, [ix]);
	    }
	    async ixGateSet(group, ixGateParams) {
	        const ix = await this.program.methods
	            .ixGateSet(buildIxGate(ixGateParams))
	            .accounts({
	            group: group.publicKey,
	            admin: this.program.provider.wallet.publicKey,
	        })
	            .instruction();
	        return await this.sendAndConfirmTransactionForGroup(group, [ix]);
	    }
	    async groupClose(group) {
	        const adminPk = this.program.provider.wallet.publicKey;
	        const ix = await this.program.methods
	            .groupClose()
	            .accounts({
	            group: group.publicKey,
	            insuranceVault: group.insuranceVault,
	            admin: adminPk,
	            solDestination: this.program.provider.wallet
	                .publicKey,
	        })
	            .instruction();
	        return await this.sendAndConfirmTransactionForGroup(group, [ix]);
	    }
	    async getGroup(groupPk) {
	        const groupAccount = await this.program.account.group.fetch(groupPk);
	        const group = Group.from(groupPk, groupAccount);
	        await group.reloadAll(this);
	        return group;
	    }
	    async getGroupsForCreator(creatorPk) {
	        const filters = [
	            {
	                memcmp: {
	                    bytes: creatorPk.toBase58(),
	                    offset: 8,
	                },
	            },
	        ];
	        const groups = (await this.program.account.group.all(filters)).map((tuple) => Group.from(tuple.publicKey, tuple.account));
	        groups.forEach((group) => group.reloadAll(this));
	        return groups;
	    }
	    async getGroupForCreator(creatorPk, groupNum) {
	        const bbuf = Buffer.alloc(4);
	        bbuf.writeUInt32LE(groupNum);
	        const filters = [
	            {
	                memcmp: {
	                    bytes: creatorPk.toBase58(),
	                    offset: 8,
	                },
	            },
	            {
	                memcmp: {
	                    bytes: bs58$1.encode(bbuf),
	                    offset: 40,
	                },
	            },
	        ];
	        const groups = (await this.program.account.group.all(filters)).map((tuple) => Group.from(tuple.publicKey, tuple.account));
	        await groups[0].reloadAll(this);
	        return groups[0];
	    }
	    async getIds(groupPk) {
	        switch (this.idsSource) {
	            case 'api':
	                return await Id.fromApi(groupPk);
	            case 'get-program-accounts':
	                return undefined;
	            case 'static':
	                return Id.fromIdsByPk(groupPk);
	        }
	    }
	    // Tokens/Banks
	    async tokenRegister(group, mintPk, oraclePk, oracleConfig, tokenIndex, name, interestRateParams, loanFeeRate, loanOriginationFeeRate, maintAssetWeight, initAssetWeight, maintLiabWeight, initLiabWeight, liquidationFee, minVaultToDepositsRatio, netBorrowLimitWindowSizeTs, netBorrowLimitPerWindowQuote) {
	        const ix = await this.program.methods
	            .tokenRegister(tokenIndex, name, oracleConfig, interestRateParams, loanFeeRate, loanOriginationFeeRate, maintAssetWeight, initAssetWeight, maintLiabWeight, initLiabWeight, liquidationFee, minVaultToDepositsRatio, new anchor.BN(netBorrowLimitWindowSizeTs), new anchor.BN(netBorrowLimitPerWindowQuote))
	            .accounts({
	            group: group.publicKey,
	            admin: this.program.provider.wallet.publicKey,
	            mint: mintPk,
	            oracle: oraclePk,
	            payer: this.program.provider.wallet.publicKey,
	            rent: require$$0$1.SYSVAR_RENT_PUBKEY,
	        })
	            .instruction();
	        return await this.sendAndConfirmTransactionForGroup(group, [ix]);
	    }
	    async tokenRegisterTrustless(group, mintPk, oraclePk, tokenIndex, name) {
	        const ix = await this.program.methods
	            .tokenRegisterTrustless(tokenIndex, name)
	            .accounts({
	            group: group.publicKey,
	            fastListingAdmin: this.program.provider.wallet
	                .publicKey,
	            mint: mintPk,
	            oracle: oraclePk,
	            payer: this.program.provider.wallet.publicKey,
	            rent: require$$0$1.SYSVAR_RENT_PUBKEY,
	        })
	            .instruction();
	        return await this.sendAndConfirmTransactionForGroup(group, [ix]);
	    }
	    async tokenEdit(group, mintPk, params) {
	        const bank = group.getFirstBankByMint(mintPk);
	        const mintInfo = group.mintInfosMapByTokenIndex.get(bank.tokenIndex);
	        const ix = await this.program.methods
	            .tokenEdit(params.oracle, params.oracleConfig, params.groupInsuranceFund, params.interestRateParams, params.loanFeeRate, params.loanOriginationFeeRate, params.maintAssetWeight, params.initAssetWeight, params.maintLiabWeight, params.initLiabWeight, params.liquidationFee, params.stablePriceDelayIntervalSeconds, params.stablePriceDelayGrowthLimit, params.stablePriceGrowthLimit, params.minVaultToDepositsRatio, params.netBorrowLimitPerWindowQuote !== null
	            ? new anchor.BN(params.netBorrowLimitPerWindowQuote)
	            : null, params.netBorrowLimitWindowSizeTs !== null
	            ? new anchor.BN(params.netBorrowLimitWindowSizeTs)
	            : null, params.borrowWeightScaleStartQuote, params.depositWeightScaleStartQuote, params.resetStablePrice ?? false, params.resetNetBorrowLimit ?? false, params.reduceOnly)
	            .accounts({
	            group: group.publicKey,
	            oracle: params.oracle ?? bank.oracle,
	            admin: this.program.provider.wallet.publicKey,
	            mintInfo: mintInfo.publicKey,
	        })
	            .remainingAccounts([
	            {
	                pubkey: bank.publicKey,
	                isWritable: true,
	                isSigner: false,
	            },
	        ])
	            .instruction();
	        return await this.sendAndConfirmTransactionForGroup(group, [ix]);
	    }
	    async tokenDeregister(group, mintPk) {
	        const bank = group.getFirstBankByMint(mintPk);
	        const adminPk = this.program.provider.wallet.publicKey;
	        const dustVaultPk = await getAssociatedTokenAddress(bank.mint, adminPk);
	        const ai = await this.program.provider.connection.getAccountInfo(dustVaultPk);
	        const preInstructions = [];
	        if (!ai) {
	            preInstructions.push(await createAssociatedTokenAccountIdempotentInstruction(adminPk, adminPk, bank.mint));
	        }
	        const ix = await this.program.methods
	            .tokenDeregister()
	            .accounts({
	            group: group.publicKey,
	            admin: adminPk,
	            mintInfo: group.mintInfosMapByTokenIndex.get(bank.tokenIndex)
	                ?.publicKey,
	            dustVault: dustVaultPk,
	            solDestination: this.program.provider.wallet
	                .publicKey,
	        })
	            .remainingAccounts([bank.publicKey, bank.vault].map((pk) => ({ pubkey: pk, isWritable: true, isSigner: false })))
	            .instruction();
	        return await this.sendAndConfirmTransactionForGroup(group, [
	            ...preInstructions,
	            ix,
	        ]);
	    }
	    async getBanksForGroup(group) {
	        return (await this.program.account.bank.all([
	            {
	                memcmp: {
	                    bytes: group.publicKey.toBase58(),
	                    offset: 8,
	                },
	            },
	        ])).map((tuple) => Bank.from(tuple.publicKey, tuple.account));
	    }
	    async getMintInfosForGroup(group) {
	        return (await this.program.account.mintInfo.all([
	            {
	                memcmp: {
	                    bytes: group.publicKey.toBase58(),
	                    offset: 8,
	                },
	            },
	        ])).map((tuple) => {
	            return MintInfo.from(tuple.publicKey, tuple.account);
	        });
	    }
	    async getMintInfoForTokenIndex(group, tokenIndex) {
	        const tokenIndexBuf = Buffer.alloc(2);
	        tokenIndexBuf.writeUInt16LE(tokenIndex);
	        return (await this.program.account.mintInfo.all([
	            {
	                memcmp: {
	                    bytes: group.publicKey.toBase58(),
	                    offset: 8,
	                },
	            },
	            {
	                memcmp: {
	                    bytes: bs58$1.encode(tokenIndexBuf),
	                    offset: 40,
	                },
	            },
	        ])).map((tuple) => {
	            return MintInfo.from(tuple.publicKey, tuple.account);
	        });
	    }
	    // Stub Oracle
	    async stubOracleCreate(group, mintPk, price) {
	        const ix = await this.program.methods
	            .stubOracleCreate({ val: I80F48.fromNumber(price).getData() })
	            .accounts({
	            group: group.publicKey,
	            admin: this.program.provider.wallet.publicKey,
	            mint: mintPk,
	            payer: this.program.provider.wallet.publicKey,
	        })
	            .instruction();
	        return await this.sendAndConfirmTransactionForGroup(group, [ix]);
	    }
	    async stubOracleClose(group, oracle) {
	        const ix = await this.program.methods
	            .stubOracleClose()
	            .accounts({
	            group: group.publicKey,
	            oracle: oracle,
	            solDestination: this.program.provider.wallet
	                .publicKey,
	        })
	            .instruction();
	        return await this.sendAndConfirmTransactionForGroup(group, [ix]);
	    }
	    async stubOracleSet(group, oraclePk, price) {
	        const ix = await this.program.methods
	            .stubOracleSet({ val: I80F48.fromNumber(price).getData() })
	            .accounts({
	            group: group.publicKey,
	            admin: this.program.provider.wallet.publicKey,
	            oracle: oraclePk,
	        })
	            .instruction();
	        return await this.sendAndConfirmTransactionForGroup(group, [ix]);
	    }
	    async getStubOracle(group, mintPk) {
	        const filters = [
	            {
	                memcmp: {
	                    bytes: group.publicKey.toBase58(),
	                    offset: 8,
	                },
	            },
	        ];
	        if (mintPk) {
	            filters.push({
	                memcmp: {
	                    bytes: mintPk.toBase58(),
	                    offset: 40,
	                },
	            });
	        }
	        return (await this.program.account.stubOracle.all(filters)).map((pa) => StubOracle.from(pa.publicKey, pa.account));
	    }
	    // MangoAccount
	    async getOrCreateMangoAccount(group, loadSerum3Oo = false) {
	        const clientOwner = this.program.provider.wallet
	            .publicKey;
	        let mangoAccounts = await this.getMangoAccountsForOwner(group, this.program.provider.wallet.publicKey, loadSerum3Oo);
	        if (mangoAccounts.length === 0) {
	            await this.createMangoAccount(group);
	            mangoAccounts = await this.getMangoAccountsForOwner(group, clientOwner, loadSerum3Oo);
	        }
	        return mangoAccounts.sort((a, b) => a.accountNum - b.accountNum)[0];
	    }
	    async createMangoAccount(group, accountNumber, name, tokenCount, serum3Count, perpCount, perpOoCount) {
	        const ix = await this.program.methods
	            .accountCreate(accountNumber ?? 0, tokenCount ?? 8, serum3Count ?? 8, perpCount ?? 8, perpOoCount ?? 8, name ?? '')
	            .accounts({
	            group: group.publicKey,
	            owner: this.program.provider.wallet.publicKey,
	            payer: this.program.provider.wallet.publicKey,
	        })
	            .instruction();
	        return await this.sendAndConfirmTransactionForGroup(group, [ix]);
	    }
	    async createAndFetchMangoAccount(group, accountNumber, name, tokenCount, serum3Count, perpCount, perpOoCount, loadSerum3Oo = false) {
	        const accNum = accountNumber ?? 0;
	        await this.createMangoAccount(group, accNum, name, tokenCount, serum3Count, perpCount, perpOoCount);
	        return await this.getMangoAccountForOwner(group, this.program.provider.wallet.publicKey, accNum, loadSerum3Oo);
	    }
	    async expandMangoAccount(group, account, tokenCount, serum3Count, perpCount, perpOoCount) {
	        const ix = await this.program.methods
	            .accountExpand(tokenCount, serum3Count, perpCount, perpOoCount)
	            .accounts({
	            group: group.publicKey,
	            account: account.publicKey,
	            owner: this.program.provider.wallet.publicKey,
	            payer: this.program.provider.wallet.publicKey,
	        })
	            .instruction();
	        return await this.sendAndConfirmTransactionForGroup(group, [ix]);
	    }
	    async editMangoAccount(group, mangoAccount, name, delegate) {
	        const ix = await this.program.methods
	            .accountEdit(name ?? null, delegate ?? null)
	            .accounts({
	            group: group.publicKey,
	            account: mangoAccount.publicKey,
	            owner: this.program.provider.wallet.publicKey,
	        })
	            .instruction();
	        return await this.sendAndConfirmTransactionForGroup(group, [ix]);
	    }
	    async computeAccountData(group, mangoAccount) {
	        const healthRemainingAccounts = this.buildHealthRemainingAccounts(AccountRetriever.Fixed, group, [mangoAccount], [], []);
	        const ix = await this.program.methods
	            .computeAccountData()
	            .accounts({
	            group: group.publicKey,
	            account: mangoAccount.publicKey,
	        })
	            .remainingAccounts(healthRemainingAccounts.map((pk) => ({ pubkey: pk, isWritable: false, isSigner: false })))
	            .instruction();
	        return await this.sendAndConfirmTransactionForGroup(group, [ix]);
	    }
	    async toggleMangoAccountFreeze(group, mangoAccount, freeze) {
	        const ix = await this.program.methods
	            .accountToggleFreeze(freeze)
	            .accounts({
	            group: group.publicKey,
	            account: mangoAccount.publicKey,
	            admin: this.program.provider.wallet.publicKey,
	        })
	            .instruction();
	        return await this.sendAndConfirmTransactionForGroup(group, [ix]);
	    }
	    async getMangoAccount(mangoAccount, loadSerum3Oo = false) {
	        const mangoAccountPk = mangoAccount instanceof MangoAccount
	            ? mangoAccount.publicKey
	            : mangoAccount;
	        const mangoAccount_ = MangoAccount.from(mangoAccountPk, await this.program.account.mangoAccount.fetch(mangoAccountPk));
	        if (loadSerum3Oo) {
	            await mangoAccount_?.reloadSerum3OpenOrders(this);
	        }
	        return mangoAccount_;
	    }
	    async getMangoAccountWithSlot(mangoAccountPk, loadSerum3Oo = false) {
	        const resp = await this.program.provider.connection.getAccountInfoAndContext(mangoAccountPk);
	        if (!resp?.value)
	            return;
	        const decodedMangoAccount = this.program.coder.accounts.decode('mangoAccount', resp.value.data);
	        const mangoAccount = MangoAccount.from(mangoAccountPk, decodedMangoAccount);
	        if (loadSerum3Oo) {
	            await mangoAccount?.reloadSerum3OpenOrders(this);
	        }
	        return { slot: resp.context.slot, value: mangoAccount };
	    }
	    async getMangoAccountForOwner(group, ownerPk, accountNumber, loadSerum3Oo = false) {
	        const mangoAccounts = await this.getMangoAccountsForOwner(group, ownerPk, loadSerum3Oo);
	        const foundMangoAccount = mangoAccounts.find((a) => a.accountNum == accountNumber);
	        return foundMangoAccount;
	    }
	    async getMangoAccountsForOwner(group, ownerPk, loadSerum3Oo = false) {
	        const accounts = (await this.program.account.mangoAccount.all([
	            {
	                memcmp: {
	                    bytes: group.publicKey.toBase58(),
	                    offset: 8,
	                },
	            },
	            {
	                memcmp: {
	                    bytes: ownerPk.toBase58(),
	                    offset: 40,
	                },
	            },
	        ])).map((pa) => {
	            return MangoAccount.from(pa.publicKey, pa.account);
	        });
	        if (loadSerum3Oo) {
	            await Promise.all(accounts.map(async (a) => await a.reloadSerum3OpenOrders(this)));
	        }
	        return accounts;
	    }
	    async getMangoAccountsForDelegate(group, delegate, loadSerum3Oo = false) {
	        const accounts = (await this.program.account.mangoAccount.all([
	            {
	                memcmp: {
	                    bytes: group.publicKey.toBase58(),
	                    offset: 8,
	                },
	            },
	            {
	                memcmp: {
	                    bytes: delegate.toBase58(),
	                    offset: 104,
	                },
	            },
	        ])).map((pa) => {
	            return MangoAccount.from(pa.publicKey, pa.account);
	        });
	        if (loadSerum3Oo) {
	            await Promise.all(accounts.map(async (a) => await a.reloadSerum3OpenOrders(this)));
	        }
	        return accounts;
	    }
	    async getAllMangoAccounts(group, loadSerum3Oo = false) {
	        const accounts = (await this.program.account.mangoAccount.all([
	            {
	                memcmp: {
	                    bytes: group.publicKey.toBase58(),
	                    offset: 8,
	                },
	            },
	        ])).map((pa) => {
	            return MangoAccount.from(pa.publicKey, pa.account);
	        });
	        if (loadSerum3Oo) {
	            await Promise.all(accounts.map(async (a) => await a.reloadSerum3OpenOrders(this)));
	        }
	        return accounts;
	    }
	    /**
	     * Note: this ix doesn't settle liabs, reduce open positions, or withdraw tokens to wallet,
	     * it simply closes the account. To close successfully ensure all positions are closed, or
	     * use forceClose flag
	     * @param group
	     * @param mangoAccount
	     * @param forceClose
	     * @returns
	     */
	    async closeMangoAccount(group, mangoAccount, forceClose = false) {
	        const ix = await this.program.methods
	            .accountClose(forceClose)
	            .accounts({
	            group: group.publicKey,
	            account: mangoAccount.publicKey,
	            owner: this.program.provider.wallet.publicKey,
	            solDestination: mangoAccount.owner,
	        })
	            .instruction();
	        return await this.sendAndConfirmTransactionForGroup(group, [ix]);
	    }
	    async emptyAndCloseMangoAccount(group, mangoAccount) {
	        const instructions = [];
	        const healthAccountsToExclude = [];
	        for (const serum3Account of mangoAccount.serum3Active()) {
	            const serum3Market = group.serum3MarketsMapByMarketIndex.get(serum3Account.marketIndex);
	            const closeOOIx = await this.serum3CloseOpenOrdersIx(group, mangoAccount, serum3Market.serumMarketExternal);
	            healthAccountsToExclude.push(serum3Account.openOrders);
	            instructions.push(closeOOIx);
	        }
	        for (const perp of mangoAccount.perpActive()) {
	            const perpMarketIndex = perp.marketIndex;
	            const perpMarket = group.getPerpMarketByMarketIndex(perpMarketIndex);
	            const deactivatingPositionIx = await this.perpDeactivatePositionIx(group, mangoAccount, perpMarketIndex);
	            healthAccountsToExclude.push(perpMarket.publicKey, perpMarket.oracle);
	            instructions.push(deactivatingPositionIx);
	        }
	        for (const index in mangoAccount.tokensActive()) {
	            const indexNum = Number(index);
	            const accountsToExclude = [...healthAccountsToExclude];
	            const token = mangoAccount.tokensActive()[indexNum];
	            const bank = group.getFirstBankByTokenIndex(token.tokenIndex);
	            //to withdraw from all token accounts we need to exclude previous tokens pubkeys
	            //used to build health remaining accounts
	            if (indexNum !== 0) {
	                for (let i = indexNum; i--; i >= 0) {
	                    const prevToken = mangoAccount.tokensActive()[i];
	                    const prevBank = group.getFirstBankByTokenIndex(prevToken.tokenIndex);
	                    accountsToExclude.push(prevBank.publicKey, prevBank.oracle);
	                }
	            }
	            const withdrawIx = await this.tokenWithdrawNativeIx(group, mangoAccount, bank.mint, U64_MAX_BN, false, [...accountsToExclude]);
	            instructions.push(...withdrawIx);
	        }
	        const closeIx = await this.program.methods
	            .accountClose(false)
	            .accounts({
	            group: group.publicKey,
	            account: mangoAccount.publicKey,
	            owner: this.program.provider.wallet.publicKey,
	            solDestination: mangoAccount.owner,
	        })
	            .instruction();
	        instructions.push(closeIx);
	        return await this.sendAndConfirmTransactionForGroup(group, instructions);
	    }
	    async tokenDeposit(group, mangoAccount, mintPk, amount, reduceOnly = false) {
	        const decimals = group.getMintDecimals(mintPk);
	        const nativeAmount = toNative(amount, decimals);
	        return await this.tokenDepositNative(group, mangoAccount, mintPk, nativeAmount, reduceOnly);
	    }
	    async tokenDepositNative(group, mangoAccount, mintPk, nativeAmount, reduceOnly = false) {
	        const bank = group.getFirstBankByMint(mintPk);
	        const tokenAccountPk = await getAssociatedTokenAddress(mintPk, mangoAccount.owner);
	        let wrappedSolAccount;
	        let preInstructions = [];
	        let postInstructions = [];
	        const additionalSigners = [];
	        if (mintPk.equals(tokenInstructions.WRAPPED_SOL_MINT)) {
	            wrappedSolAccount = new require$$0$1.Keypair();
	            const lamports = nativeAmount.add(new anchor.BN(1e7));
	            preInstructions = [
	                require$$0$1.SystemProgram.createAccount({
	                    fromPubkey: mangoAccount.owner,
	                    newAccountPubkey: wrappedSolAccount.publicKey,
	                    lamports: lamports.toNumber(),
	                    space: 165,
	                    programId: splToken$1.TOKEN_PROGRAM_ID,
	                }),
	                tokenInstructions.initializeAccount({
	                    account: wrappedSolAccount.publicKey,
	                    mint: tokenInstructions.WRAPPED_SOL_MINT,
	                    owner: mangoAccount.owner,
	                }),
	            ];
	            postInstructions = [
	                tokenInstructions.closeAccount({
	                    source: wrappedSolAccount.publicKey,
	                    destination: mangoAccount.owner,
	                    owner: mangoAccount.owner,
	                }),
	            ];
	            additionalSigners.push(wrappedSolAccount);
	        }
	        const healthRemainingAccounts = this.buildHealthRemainingAccounts(AccountRetriever.Fixed, group, [mangoAccount], [bank], []);
	        const ix = await this.program.methods
	            .tokenDeposit(new anchor.BN(nativeAmount), reduceOnly)
	            .accounts({
	            group: group.publicKey,
	            account: mangoAccount.publicKey,
	            owner: mangoAccount.owner,
	            bank: bank.publicKey,
	            vault: bank.vault,
	            oracle: bank.oracle,
	            tokenAccount: wrappedSolAccount?.publicKey ?? tokenAccountPk,
	            tokenAuthority: mangoAccount.owner,
	        })
	            .remainingAccounts(healthRemainingAccounts.map((pk) => ({ pubkey: pk, isWritable: false, isSigner: false })))
	            .instruction();
	        return await this.sendAndConfirmTransactionForGroup(group, [...preInstructions, ix, ...postInstructions], { additionalSigners });
	    }
	    async tokenWithdraw(group, mangoAccount, mintPk, amount, allowBorrow) {
	        const nativeAmount = toNative(amount, group.getMintDecimals(mintPk));
	        const ixes = await this.tokenWithdrawNativeIx(group, mangoAccount, mintPk, nativeAmount, allowBorrow);
	        return await this.sendAndConfirmTransactionForGroup(group, ixes);
	    }
	    async tokenWithdrawNativeIx(group, mangoAccount, mintPk, nativeAmount, allowBorrow, healthAccountsToExclude = []) {
	        const bank = group.getFirstBankByMint(mintPk);
	        const tokenAccountPk = await getAssociatedTokenAddress(bank.mint, mangoAccount.owner);
	        // ensure withdraws don't fail with missing ATAs
	        const preInstructions = [
	            await createAssociatedTokenAccountIdempotentInstruction(mangoAccount.owner, mangoAccount.owner, bank.mint),
	        ];
	        const postInstructions = [];
	        if (mintPk.equals(tokenInstructions.WRAPPED_SOL_MINT)) {
	            postInstructions.push(tokenInstructions.closeAccount({
	                source: tokenAccountPk,
	                destination: mangoAccount.owner,
	                owner: mangoAccount.owner,
	            }));
	        }
	        const healthRemainingAccounts = this.buildHealthRemainingAccounts(AccountRetriever.Fixed, group, [mangoAccount], [bank], []);
	        const ix = await this.program.methods
	            .tokenWithdraw(new anchor.BN(nativeAmount), allowBorrow)
	            .accounts({
	            group: group.publicKey,
	            account: mangoAccount.publicKey,
	            owner: mangoAccount.owner,
	            bank: bank.publicKey,
	            vault: bank.vault,
	            oracle: bank.oracle,
	            tokenAccount: tokenAccountPk,
	        })
	            .remainingAccounts(healthRemainingAccounts
	            .filter((accounts) => !healthAccountsToExclude.find((accountsToExclude) => accounts.equals(accountsToExclude)))
	            .map((pk) => ({
	            pubkey: pk,
	            isWritable: false,
	            isSigner: false,
	        })))
	            .instruction();
	        return [...preInstructions, ix, ...postInstructions];
	    }
	    async tokenWithdrawNative(group, mangoAccount, mintPk, nativeAmount, allowBorrow, healthAccountsToExclude = []) {
	        const ixs = await this.tokenWithdrawNativeIx(group, mangoAccount, mintPk, nativeAmount, allowBorrow, healthAccountsToExclude);
	        return await this.sendAndConfirmTransactionForGroup(group, ixs);
	    }
	    // Serum
	    async serum3RegisterMarket(group, serum3MarketExternalPk, baseBank, quoteBank, marketIndex, name) {
	        const ix = await this.program.methods
	            .serum3RegisterMarket(marketIndex, name)
	            .accounts({
	            group: group.publicKey,
	            admin: this.program.provider.wallet.publicKey,
	            serumProgram: OPENBOOK_PROGRAM_ID[this.cluster],
	            serumMarketExternal: serum3MarketExternalPk,
	            baseBank: baseBank.publicKey,
	            quoteBank: quoteBank.publicKey,
	            payer: this.program.provider.wallet.publicKey,
	        })
	            .instruction();
	        return await this.sendAndConfirmTransactionForGroup(group, [ix]);
	    }
	    async serum3deregisterMarket(group, externalMarketPk) {
	        const serum3Market = group.serum3MarketsMapByExternal.get(externalMarketPk.toBase58());
	        const marketIndexBuf = Buffer.alloc(2);
	        marketIndexBuf.writeUInt16LE(serum3Market.marketIndex);
	        const [indexReservation] = await require$$0$1.PublicKey.findProgramAddress([Buffer.from('Serum3Index'), group.publicKey.toBuffer(), marketIndexBuf], this.program.programId);
	        const ix = await this.program.methods
	            .serum3DeregisterMarket()
	            .accounts({
	            group: group.publicKey,
	            serumMarket: serum3Market.publicKey,
	            indexReservation,
	            solDestination: this.program.provider.wallet
	                .publicKey,
	        })
	            .instruction();
	        return await this.sendAndConfirmTransactionForGroup(group, [ix]);
	    }
	    async serum3GetMarkets(group, baseTokenIndex, quoteTokenIndex) {
	        const bumpfbuf = Buffer.alloc(1);
	        bumpfbuf.writeUInt8(255);
	        const filters = [
	            {
	                memcmp: {
	                    bytes: group.publicKey.toBase58(),
	                    offset: 8,
	                },
	            },
	        ];
	        if (baseTokenIndex) {
	            const bbuf = Buffer.alloc(2);
	            bbuf.writeUInt16LE(baseTokenIndex);
	            filters.push({
	                memcmp: {
	                    bytes: bs58$1.encode(bbuf),
	                    offset: 40,
	                },
	            });
	        }
	        if (quoteTokenIndex) {
	            const qbuf = Buffer.alloc(2);
	            qbuf.writeUInt16LE(quoteTokenIndex);
	            filters.push({
	                memcmp: {
	                    bytes: bs58$1.encode(qbuf),
	                    offset: 42,
	                },
	            });
	        }
	        return (await this.program.account.serum3Market.all(filters)).map((tuple) => Serum3Market.from(tuple.publicKey, tuple.account));
	    }
	    async serum3CreateOpenOrders(group, mangoAccount, externalMarketPk) {
	        const serum3Market = group.serum3MarketsMapByExternal.get(externalMarketPk.toBase58());
	        const ix = await this.program.methods
	            .serum3CreateOpenOrders()
	            .accounts({
	            group: group.publicKey,
	            account: mangoAccount.publicKey,
	            serumMarket: serum3Market.publicKey,
	            serumProgram: serum3Market.serumProgram,
	            serumMarketExternal: serum3Market.serumMarketExternal,
	            owner: this.program.provider.wallet.publicKey,
	            payer: this.program.provider.wallet.publicKey,
	        })
	            .instruction();
	        return await this.sendAndConfirmTransactionForGroup(group, [ix]);
	    }
	    async serum3CreateOpenOrdersIx(group, mangoAccount, externalMarketPk) {
	        const serum3Market = group.serum3MarketsMapByExternal.get(externalMarketPk.toBase58());
	        const ix = await this.program.methods
	            .serum3CreateOpenOrders()
	            .accounts({
	            group: group.publicKey,
	            account: mangoAccount.publicKey,
	            serumMarket: serum3Market.publicKey,
	            serumProgram: serum3Market.serumProgram,
	            serumMarketExternal: serum3Market.serumMarketExternal,
	            owner: this.program.provider.wallet.publicKey,
	            payer: this.program.provider.wallet.publicKey,
	        })
	            .instruction();
	        return ix;
	    }
	    async serum3CloseOpenOrdersIx(group, mangoAccount, externalMarketPk) {
	        const serum3Market = group.serum3MarketsMapByExternal.get(externalMarketPk.toBase58());
	        const openOrders = mangoAccount.serum3.find((account) => account.marketIndex === serum3Market.marketIndex)?.openOrders;
	        return await this.program.methods
	            .serum3CloseOpenOrders()
	            .accounts({
	            group: group.publicKey,
	            account: mangoAccount.publicKey,
	            serumMarket: serum3Market.publicKey,
	            serumProgram: serum3Market.serumProgram,
	            serumMarketExternal: serum3Market.serumMarketExternal,
	            openOrders,
	            solDestination: this.program.provider.wallet
	                .publicKey,
	        })
	            .instruction();
	    }
	    async serum3CloseOpenOrders(group, mangoAccount, externalMarketPk) {
	        const ix = await this.serum3CloseOpenOrdersIx(group, mangoAccount, externalMarketPk);
	        return await sendTransaction(this.program.provider, [ix], group.addressLookupTablesList, {
	            postSendTxCallback: this.postSendTxCallback,
	        });
	    }
	    async serum3PlaceOrderIx(group, mangoAccount, externalMarketPk, side, price, size, selfTradeBehavior, orderType, clientOrderId, limit) {
	        const ixs = [];
	        const serum3Market = group.serum3MarketsMapByExternal.get(externalMarketPk.toBase58());
	        let openOrderPk = undefined;
	        const banks = [];
	        const openOrdersForMarket = [];
	        if (!mangoAccount.getSerum3Account(serum3Market.marketIndex)) {
	            const ix = await this.serum3CreateOpenOrdersIx(group, mangoAccount, serum3Market.serumMarketExternal);
	            ixs.push(ix);
	            openOrderPk = await serum3Market.findOoPda(this.program.programId, mangoAccount.publicKey);
	            openOrdersForMarket.push([serum3Market, openOrderPk]);
	            const baseTokenIndex = serum3Market.baseTokenIndex;
	            const quoteTokenIndex = serum3Market.quoteTokenIndex;
	            // only include banks if no deposit has been previously made for same token
	            if (!mangoAccount.getToken(baseTokenIndex)?.isActive()) {
	                banks.push(group.getFirstBankByTokenIndex(baseTokenIndex));
	            }
	            if (!mangoAccount.getToken(quoteTokenIndex)?.isActive()) {
	                banks.push(group.getFirstBankByTokenIndex(quoteTokenIndex));
	            }
	        }
	        const healthRemainingAccounts = this.buildHealthRemainingAccounts(AccountRetriever.Fixed, group, [mangoAccount], banks, [], openOrdersForMarket);
	        const serum3MarketExternal = group.serum3ExternalMarketsMap.get(externalMarketPk.toBase58());
	        const serum3MarketExternalVaultSigner = await generateSerum3MarketExternalVaultSignerAddress(this.cluster, serum3Market, serum3MarketExternal);
	        const limitPrice = serum3MarketExternal.priceNumberToLots(price);
	        const maxBaseQuantity = serum3MarketExternal.baseSizeNumberToLots(size);
	        const isTaker = orderType !== Serum3OrderType.postOnly;
	        const maxQuoteQuantity = new anchor.BN(serum3MarketExternal.decoded.quoteLotSize.toNumber() *
	            (1 + Math.max(serum3Market.getFeeRates(isTaker), 0)) *
	            serum3MarketExternal.baseSizeNumberToLots(size).toNumber() *
	            serum3MarketExternal.priceNumberToLots(price).toNumber());
	        const payerTokenIndex = (() => {
	            if (side == Serum3Side.bid) {
	                return serum3Market.quoteTokenIndex;
	            }
	            else {
	                return serum3Market.baseTokenIndex;
	            }
	        })();
	        const payerBank = group.getFirstBankByTokenIndex(payerTokenIndex);
	        const ix = await this.program.methods
	            .serum3PlaceOrder(side, limitPrice, maxBaseQuantity, maxQuoteQuantity, selfTradeBehavior, orderType, new anchor.BN(clientOrderId), limit)
	            .accounts({
	            group: group.publicKey,
	            account: mangoAccount.publicKey,
	            owner: this.program.provider.wallet.publicKey,
	            openOrders: openOrderPk ||
	                mangoAccount.getSerum3Account(serum3Market.marketIndex)?.openOrders,
	            serumMarket: serum3Market.publicKey,
	            serumProgram: OPENBOOK_PROGRAM_ID[this.cluster],
	            serumMarketExternal: serum3Market.serumMarketExternal,
	            marketBids: serum3MarketExternal.bidsAddress,
	            marketAsks: serum3MarketExternal.asksAddress,
	            marketEventQueue: serum3MarketExternal.decoded.eventQueue,
	            marketRequestQueue: serum3MarketExternal.decoded.requestQueue,
	            marketBaseVault: serum3MarketExternal.decoded.baseVault,
	            marketQuoteVault: serum3MarketExternal.decoded.quoteVault,
	            marketVaultSigner: serum3MarketExternalVaultSigner,
	            payerBank: payerBank.publicKey,
	            payerVault: payerBank.vault,
	            payerOracle: payerBank.oracle,
	        })
	            .remainingAccounts(healthRemainingAccounts.map((pk) => ({ pubkey: pk, isWritable: false, isSigner: false })))
	            .instruction();
	        ixs.push(ix);
	        return ixs;
	    }
	    async serum3PlaceOrder(group, mangoAccount, externalMarketPk, side, price, size, selfTradeBehavior, orderType, clientOrderId, limit) {
	        const placeOrderIxes = await this.serum3PlaceOrderIx(group, mangoAccount, externalMarketPk, side, price, size, selfTradeBehavior, orderType, clientOrderId, limit);
	        const settleIx = await this.serum3SettleFundsIx(group, mangoAccount, externalMarketPk);
	        return await this.sendAndConfirmTransactionForGroup(group, [
	            ...placeOrderIxes,
	            settleIx,
	        ]);
	    }
	    async serum3CancelAllOrders(group, mangoAccount, externalMarketPk, limit) {
	        const serum3Market = group.serum3MarketsMapByExternal.get(externalMarketPk.toBase58());
	        const serum3MarketExternal = group.serum3ExternalMarketsMap.get(externalMarketPk.toBase58());
	        const ix = await this.program.methods
	            .serum3CancelAllOrders(limit ? limit : 10)
	            .accounts({
	            group: group.publicKey,
	            account: mangoAccount.publicKey,
	            owner: this.program.provider.wallet.publicKey,
	            openOrders: mangoAccount.getSerum3Account(serum3Market.marketIndex)
	                ?.openOrders,
	            serumMarket: serum3Market.publicKey,
	            serumProgram: OPENBOOK_PROGRAM_ID[this.cluster],
	            serumMarketExternal: serum3Market.serumMarketExternal,
	            marketBids: serum3MarketExternal.bidsAddress,
	            marketAsks: serum3MarketExternal.asksAddress,
	            marketEventQueue: serum3MarketExternal.decoded.eventQueue,
	        })
	            .instruction();
	        return await this.sendAndConfirmTransactionForGroup(group, [ix]);
	    }
	    async serum3SettleFundsIx(group, mangoAccount, externalMarketPk) {
	        const serum3Market = group.serum3MarketsMapByExternal.get(externalMarketPk.toBase58());
	        const serum3MarketExternal = group.serum3ExternalMarketsMap.get(externalMarketPk.toBase58());
	        const [serum3MarketExternalVaultSigner, openOrderPublicKey] = await Promise.all([
	            generateSerum3MarketExternalVaultSignerAddress(this.cluster, serum3Market, serum3MarketExternal),
	            serum3Market.findOoPda(this.program.programId, mangoAccount.publicKey),
	        ]);
	        const ix = await this.program.methods
	            .serum3SettleFunds()
	            .accounts({
	            group: group.publicKey,
	            account: mangoAccount.publicKey,
	            owner: this.program.provider.wallet.publicKey,
	            openOrders: openOrderPublicKey,
	            serumMarket: serum3Market.publicKey,
	            serumProgram: OPENBOOK_PROGRAM_ID[this.cluster],
	            serumMarketExternal: serum3Market.serumMarketExternal,
	            marketBaseVault: serum3MarketExternal.decoded.baseVault,
	            marketQuoteVault: serum3MarketExternal.decoded.quoteVault,
	            marketVaultSigner: serum3MarketExternalVaultSigner,
	            quoteBank: group.getFirstBankByTokenIndex(serum3Market.quoteTokenIndex)
	                .publicKey,
	            quoteVault: group.getFirstBankByTokenIndex(serum3Market.quoteTokenIndex)
	                .vault,
	            baseBank: group.getFirstBankByTokenIndex(serum3Market.baseTokenIndex)
	                .publicKey,
	            baseVault: group.getFirstBankByTokenIndex(serum3Market.baseTokenIndex)
	                .vault,
	        })
	            .instruction();
	        return ix;
	    }
	    async serum3SettleFunds(group, mangoAccount, externalMarketPk) {
	        const ix = await this.serum3SettleFundsIx(group, mangoAccount, externalMarketPk);
	        return await this.sendAndConfirmTransactionForGroup(group, [ix]);
	    }
	    async serum3CancelOrderIx(group, mangoAccount, externalMarketPk, side, orderId) {
	        const serum3Market = group.serum3MarketsMapByExternal.get(externalMarketPk.toBase58());
	        const serum3MarketExternal = group.serum3ExternalMarketsMap.get(externalMarketPk.toBase58());
	        const ix = await this.program.methods
	            .serum3CancelOrder(side, orderId)
	            .accounts({
	            group: group.publicKey,
	            account: mangoAccount.publicKey,
	            openOrders: mangoAccount.getSerum3Account(serum3Market.marketIndex)
	                ?.openOrders,
	            serumMarket: serum3Market.publicKey,
	            serumProgram: OPENBOOK_PROGRAM_ID[this.cluster],
	            serumMarketExternal: serum3Market.serumMarketExternal,
	            marketBids: serum3MarketExternal.bidsAddress,
	            marketAsks: serum3MarketExternal.asksAddress,
	            marketEventQueue: serum3MarketExternal.decoded.eventQueue,
	        })
	            .instruction();
	        return ix;
	    }
	    async serum3CancelOrder(group, mangoAccount, externalMarketPk, side, orderId) {
	        const ixes = await Promise.all([
	            this.serum3CancelOrderIx(group, mangoAccount, externalMarketPk, side, orderId),
	            this.serum3SettleFundsIx(group, mangoAccount, externalMarketPk),
	        ]);
	        return await this.sendAndConfirmTransactionForGroup(group, ixes);
	    }
	    /// perps
	    async perpCreateMarket(group, oraclePk, perpMarketIndex, name, oracleConfig, baseDecimals, quoteLotSize, baseLotSize, maintBaseAssetWeight, initBaseAssetWeight, maintBaseLiabWeight, initBaseLiabWeight, maintOverallAssetWeight, initOverallAssetWeight, baseLiquidationFee, makerFee, takerFee, feePenalty, minFunding, maxFunding, impactQuantity, groupInsuranceFund, settleFeeFlat, settleFeeAmountThreshold, settleFeeFractionLowHealth, settleTokenIndex, settlePnlLimitFactor, settlePnlLimitWindowSize, positivePnlLiquidationFee) {
	        const bids = new require$$0$1.Keypair();
	        const asks = new require$$0$1.Keypair();
	        const eventQueue = new require$$0$1.Keypair();
	        const bookSideSize = this.program._coder.accounts.size(this.program.account.bookSide._idlAccount);
	        const eventQueueSize = this.program._coder.accounts.size(this.program.account.eventQueue._idlAccount);
	        const ix = await this.program.methods
	            .perpCreateMarket(perpMarketIndex, name, oracleConfig, baseDecimals, new anchor.BN(quoteLotSize), new anchor.BN(baseLotSize), maintBaseAssetWeight, initBaseAssetWeight, maintBaseLiabWeight, initBaseLiabWeight, maintOverallAssetWeight, initOverallAssetWeight, baseLiquidationFee, makerFee, takerFee, minFunding, maxFunding, new anchor.BN(impactQuantity), groupInsuranceFund, feePenalty, settleFeeFlat, settleFeeAmountThreshold, settleFeeFractionLowHealth, settleTokenIndex, settlePnlLimitFactor, new anchor.BN(settlePnlLimitWindowSize), positivePnlLiquidationFee)
	            .accounts({
	            group: group.publicKey,
	            admin: this.program.provider.wallet.publicKey,
	            oracle: oraclePk,
	            bids: bids.publicKey,
	            asks: asks.publicKey,
	            eventQueue: eventQueue.publicKey,
	            payer: this.program.provider.wallet.publicKey,
	        })
	            .instruction();
	        const preInstructions = [
	            // book sides
	            require$$0$1.SystemProgram.createAccount({
	                programId: this.program.programId,
	                space: bookSideSize,
	                lamports: await this.program.provider.connection.getMinimumBalanceForRentExemption(bookSideSize),
	                fromPubkey: this.program.provider.wallet.publicKey,
	                newAccountPubkey: bids.publicKey,
	            }),
	            require$$0$1.SystemProgram.createAccount({
	                programId: this.program.programId,
	                space: bookSideSize,
	                lamports: await this.program.provider.connection.getMinimumBalanceForRentExemption(bookSideSize),
	                fromPubkey: this.program.provider.wallet.publicKey,
	                newAccountPubkey: asks.publicKey,
	            }),
	            // event queue
	            require$$0$1.SystemProgram.createAccount({
	                programId: this.program.programId,
	                space: eventQueueSize,
	                lamports: await this.program.provider.connection.getMinimumBalanceForRentExemption(eventQueueSize),
	                fromPubkey: this.program.provider.wallet.publicKey,
	                newAccountPubkey: eventQueue.publicKey,
	            }),
	        ];
	        return await this.sendAndConfirmTransactionForGroup(group, [...preInstructions, ix], {
	            additionalSigners: [bids, asks, eventQueue],
	        });
	    }
	    async perpEditMarket(group, perpMarketIndex, params) {
	        const perpMarket = group.getPerpMarketByMarketIndex(perpMarketIndex);
	        const ix = await this.program.methods
	            .perpEditMarket(params.oracle, params.oracleConfig, params.baseDecimals, params.maintBaseAssetWeight, params.initBaseAssetWeight, params.maintBaseLiabWeight, params.initBaseLiabWeight, params.maintOverallAssetWeight, params.initOverallAssetWeight, params.baseLiquidationFee, params.makerFee, params.takerFee, params.minFunding, params.maxFunding, params.impactQuantity !== null ? new anchor.BN(params.impactQuantity) : null, params.groupInsuranceFund, params.feePenalty, params.settleFeeFlat, params.settleFeeAmountThreshold, params.settleFeeFractionLowHealth, params.stablePriceDelayIntervalSeconds, params.stablePriceDelayGrowthLimit, params.stablePriceGrowthLimit, params.settlePnlLimitFactor, params.settlePnlLimitWindowSize !== null
	            ? new anchor.BN(params.settlePnlLimitWindowSize)
	            : null, params.reduceOnly, params.resetStablePrice ?? false, params.positivePnlLiquidationFee)
	            .accounts({
	            group: group.publicKey,
	            oracle: params.oracle ?? perpMarket.oracle,
	            admin: this.program.provider.wallet.publicKey,
	            perpMarket: perpMarket.publicKey,
	        })
	            .instruction();
	        return await this.sendAndConfirmTransactionForGroup(group, [ix]);
	    }
	    async perpCloseMarket(group, perpMarketIndex) {
	        const perpMarket = group.getPerpMarketByMarketIndex(perpMarketIndex);
	        const ix = await this.program.methods
	            .perpCloseMarket()
	            .accounts({
	            group: group.publicKey,
	            admin: this.program.provider.wallet.publicKey,
	            perpMarket: perpMarket.publicKey,
	            bids: perpMarket.bids,
	            asks: perpMarket.asks,
	            eventQueue: perpMarket.eventQueue,
	            solDestination: this.program.provider.wallet
	                .publicKey,
	        })
	            .instruction();
	        return await this.sendAndConfirmTransactionForGroup(group, [ix]);
	    }
	    async perpGetMarkets(group) {
	        const bumpfbuf = Buffer.alloc(1);
	        bumpfbuf.writeUInt8(255);
	        const filters = [
	            {
	                memcmp: {
	                    bytes: group.publicKey.toBase58(),
	                    offset: 8,
	                },
	            },
	        ];
	        return (await this.program.account.perpMarket.all(filters)).map((tuple) => PerpMarket.from(tuple.publicKey, tuple.account));
	    }
	    async perpDeactivatePositionIx(group, mangoAccount, perpMarketIndex) {
	        const perpMarket = group.getPerpMarketByMarketIndex(perpMarketIndex);
	        const healthRemainingAccounts = this.buildHealthRemainingAccounts(AccountRetriever.Fixed, group, [mangoAccount], [], []);
	        return await this.program.methods
	            .perpDeactivatePosition()
	            .accounts({
	            group: group.publicKey,
	            account: mangoAccount.publicKey,
	            perpMarket: perpMarket.publicKey,
	            owner: this.program.provider.wallet.publicKey,
	        })
	            .remainingAccounts(healthRemainingAccounts.map((pk) => ({ pubkey: pk, isWritable: false, isSigner: false })))
	            .instruction();
	    }
	    async perpDeactivatePosition(group, mangoAccount, perpMarketIndex) {
	        const ix = await this.perpDeactivatePositionIx(group, mangoAccount, perpMarketIndex);
	        return await this.sendAndConfirmTransactionForGroup(group, [ix]);
	    }
	    // perpPlaceOrder ix returns an optional, custom order id,
	    // but, since we use a customer tx sender, this method
	    // doesn't return it
	    async perpPlaceOrder(group, mangoAccount, perpMarketIndex, side, price, quantity, maxQuoteQuantity, clientOrderId, orderType, reduceOnly, expiryTimestamp, limit) {
	        const ix = await this.perpPlaceOrderIx(group, mangoAccount, perpMarketIndex, side, price, quantity, maxQuoteQuantity, clientOrderId, orderType, reduceOnly, expiryTimestamp, limit);
	        return await this.sendAndConfirmTransactionForGroup(group, [ix]);
	    }
	    async perpPlaceOrderIx(group, mangoAccount, perpMarketIndex, side, price, quantity, maxQuoteQuantity, clientOrderId, orderType, reduceOnly, expiryTimestamp, limit) {
	        const perpMarket = group.getPerpMarketByMarketIndex(perpMarketIndex);
	        const healthRemainingAccounts = this.buildHealthRemainingAccounts(AccountRetriever.Fixed, group, [mangoAccount], 
	        // Settlement token bank, because a position for it may be created
	        [group.getFirstBankByTokenIndex(0)], [perpMarket]);
	        return await this.program.methods
	            .perpPlaceOrder(side, perpMarket.uiPriceToLots(price), perpMarket.uiBaseToLots(quantity), maxQuoteQuantity
	            ? perpMarket.uiQuoteToLots(maxQuoteQuantity)
	            : I64_MAX_BN, new anchor.BN(clientOrderId ? clientOrderId : Date.now()), orderType ? orderType : PerpOrderType.limit, reduceOnly ? reduceOnly : false, new anchor.BN(expiryTimestamp ? expiryTimestamp : 0), limit ? limit : 10)
	            .accounts({
	            group: group.publicKey,
	            account: mangoAccount.publicKey,
	            perpMarket: perpMarket.publicKey,
	            bids: perpMarket.bids,
	            asks: perpMarket.asks,
	            eventQueue: perpMarket.eventQueue,
	            oracle: perpMarket.oracle,
	            owner: this.program.provider.wallet.publicKey,
	        })
	            .remainingAccounts(healthRemainingAccounts.map((pk) => ({ pubkey: pk, isWritable: false, isSigner: false })))
	            .instruction();
	    }
	    async perpPlaceOrderPegged(group, mangoAccount, perpMarketIndex, side, priceOffset, pegLimit, quantity, maxQuoteQuantity, clientOrderId, orderType, reduceOnly, expiryTimestamp, limit) {
	        const ix = await this.perpPlaceOrderPeggedIx(group, mangoAccount, perpMarketIndex, side, priceOffset, pegLimit, quantity, maxQuoteQuantity, clientOrderId, orderType, reduceOnly, expiryTimestamp, limit);
	        return await this.sendAndConfirmTransactionForGroup(group, [ix]);
	    }
	    async perpPlaceOrderPeggedIx(group, mangoAccount, perpMarketIndex, side, priceOffset, pegLimit, quantity, maxQuoteQuantity, clientOrderId, orderType, reduceOnly, expiryTimestamp, limit) {
	        const perpMarket = group.getPerpMarketByMarketIndex(perpMarketIndex);
	        const healthRemainingAccounts = this.buildHealthRemainingAccounts(AccountRetriever.Fixed, group, [mangoAccount], 
	        // Settlement token bank, because a position for it may be created
	        [group.getFirstBankByTokenIndex(0)], [perpMarket]);
	        return await this.program.methods
	            .perpPlaceOrderPegged(side, perpMarket.uiPriceToLots(priceOffset), perpMarket.uiPriceToLots(pegLimit), perpMarket.uiBaseToLots(quantity), maxQuoteQuantity
	            ? perpMarket.uiQuoteToLots(maxQuoteQuantity)
	            : I64_MAX_BN, new anchor.BN(clientOrderId ?? Date.now()), orderType ? orderType : PerpOrderType.limit, reduceOnly ? reduceOnly : false, new anchor.BN(expiryTimestamp ?? 0), limit ? limit : 10, -1)
	            .accounts({
	            group: group.publicKey,
	            account: mangoAccount.publicKey,
	            perpMarket: perpMarket.publicKey,
	            bids: perpMarket.bids,
	            asks: perpMarket.asks,
	            eventQueue: perpMarket.eventQueue,
	            oracle: perpMarket.oracle,
	            owner: this.program.provider.wallet.publicKey,
	        })
	            .remainingAccounts(healthRemainingAccounts.map((pk) => ({ pubkey: pk, isWritable: false, isSigner: false })))
	            .instruction();
	    }
	    async perpCancelOrderIx(group, mangoAccount, perpMarketIndex, orderId) {
	        const perpMarket = group.getPerpMarketByMarketIndex(perpMarketIndex);
	        return await this.program.methods
	            .perpCancelOrder(new anchor.BN(orderId))
	            .accounts({
	            group: group.publicKey,
	            account: mangoAccount.publicKey,
	            owner: this.program.provider.wallet.publicKey,
	            perpMarket: perpMarket.publicKey,
	            bids: perpMarket.bids,
	            asks: perpMarket.asks,
	        })
	            .instruction();
	    }
	    async perpCancelOrder(group, mangoAccount, perpMarketIndex, orderId) {
	        const ix = await this.perpCancelOrderIx(group, mangoAccount, perpMarketIndex, orderId);
	        return await this.sendAndConfirmTransactionForGroup(group, [ix]);
	    }
	    async perpCancelAllOrders(group, mangoAccount, perpMarketIndex, limit) {
	        const ix = await this.perpCancelAllOrdersIx(group, mangoAccount, perpMarketIndex, limit);
	        return await this.sendAndConfirmTransactionForGroup(group, [ix]);
	    }
	    async perpCancelAllOrdersIx(group, mangoAccount, perpMarketIndex, limit) {
	        const perpMarket = group.getPerpMarketByMarketIndex(perpMarketIndex);
	        return await this.program.methods
	            .perpCancelAllOrders(limit)
	            .accounts({
	            group: group.publicKey,
	            account: mangoAccount.publicKey,
	            perpMarket: perpMarket.publicKey,
	            bids: perpMarket.bids,
	            asks: perpMarket.asks,
	            owner: this.program.provider.wallet.publicKey,
	        })
	            .instruction();
	    }
	    async perpSettlePnl(group, profitableAccount, unprofitableAccount, settler, perpMarketIndex) {
	        const perpMarket = group.getPerpMarketByMarketIndex(perpMarketIndex);
	        const healthRemainingAccounts = this.buildHealthRemainingAccounts(AccountRetriever.Scanning, group, [profitableAccount, unprofitableAccount], [group.getFirstBankByTokenIndex(0)], [perpMarket]);
	        const bank = group.banksMapByTokenIndex.get(0)[0];
	        const ix = await this.program.methods
	            .perpSettlePnl()
	            .accounts({
	            group: group.publicKey,
	            accountA: profitableAccount.publicKey,
	            accountB: unprofitableAccount.publicKey,
	            perpMarket: perpMarket.publicKey,
	            oracle: perpMarket.oracle,
	            settleOracle: bank.oracle,
	            settleBank: bank.publicKey,
	            settler: settler.publicKey,
	            settlerOwner: this.program.provider.wallet
	                .publicKey,
	        })
	            .remainingAccounts(healthRemainingAccounts.map((pk) => ({ pubkey: pk, isWritable: false, isSigner: false })))
	            .instruction();
	        return await this.sendAndConfirmTransactionForGroup(group, [ix]);
	    }
	    async perpSettleFees(group, account, perpMarketIndex, maxSettleAmount) {
	        const perpMarket = group.getPerpMarketByMarketIndex(perpMarketIndex);
	        const healthRemainingAccounts = this.buildHealthRemainingAccounts(AccountRetriever.Fixed, group, [account], // Account must be unprofitable
	        [group.getFirstBankByTokenIndex(0)], [perpMarket]);
	        const bank = group.banksMapByTokenIndex.get(0)[0];
	        const ix = await this.program.methods
	            .perpSettleFees(maxSettleAmount)
	            .accounts({
	            group: group.publicKey,
	            account: account.publicKey,
	            perpMarket: perpMarket.publicKey,
	            oracle: perpMarket.oracle,
	            settleOracle: bank.oracle,
	            settleBank: bank.publicKey,
	        })
	            .remainingAccounts(healthRemainingAccounts.map((pk) => ({ pubkey: pk, isWritable: false, isSigner: false })))
	            .instruction();
	        return await this.sendAndConfirmTransactionForGroup(group, [ix]);
	    }
	    async perpConsumeEvents(group, perpMarketIndex, accounts, limit) {
	        const perpMarket = group.getPerpMarketByMarketIndex(perpMarketIndex);
	        const ix = await this.program.methods
	            .perpConsumeEvents(new anchor.BN(limit))
	            .accounts({
	            group: group.publicKey,
	            perpMarket: perpMarket.publicKey,
	            eventQueue: perpMarket.eventQueue,
	        })
	            .remainingAccounts(accounts.map((pk) => ({ pubkey: pk, isWritable: true, isSigner: false })))
	            .instruction();
	        return await this.sendAndConfirmTransactionForGroup(group, [ix]);
	    }
	    async perpConsumeAllEvents(group, perpMarketIndex) {
	        const limit = 8;
	        const perpMarket = group.getPerpMarketByMarketIndex(perpMarketIndex);
	        const eventQueue = await perpMarket.loadEventQueue(this);
	        const unconsumedEvents = eventQueue.getUnconsumedEvents();
	        while (unconsumedEvents.length > 0) {
	            const events = unconsumedEvents.splice(0, limit);
	            const accounts = events
	                .map((ev) => {
	                switch (ev.eventType) {
	                    case PerpEventQueue.FILL_EVENT_TYPE: {
	                        const fill = ev;
	                        return [fill.maker, fill.taker];
	                    }
	                    case PerpEventQueue.OUT_EVENT_TYPE: {
	                        const out = ev;
	                        return [out.owner];
	                    }
	                    case PerpEventQueue.LIQUIDATE_EVENT_TYPE:
	                        return [];
	                    default:
	                        throw new Error(`Unknown event with eventType ${ev.eventType}!`);
	                }
	            })
	                .flat();
	            await this.perpConsumeEvents(group, perpMarketIndex, accounts, limit);
	        }
	    }
	    async marginTrade({ group, mangoAccount, inputMintPk, amountIn, outputMintPk, userDefinedInstructions, userDefinedAlts = [], 
	    // margin trade is a general function
	    // set flash_loan_type to FlashLoanType.swap if you desire the transaction to be recorded as a swap
	    flashLoanType, }) {
	        const inputBank = group.getFirstBankByMint(inputMintPk);
	        const outputBank = group.getFirstBankByMint(outputMintPk);
	        const healthRemainingAccounts = this.buildHealthRemainingAccounts(AccountRetriever.Fixed, group, [mangoAccount], [inputBank, outputBank], []);
	        const parsedHealthAccounts = healthRemainingAccounts.map((pk) => ({
	            pubkey: pk,
	            isWritable: false,
	            isSigner: false,
	        }));
	        /*
	         * Find or create associated token accounts
	         */
	        const inputTokenAccountPk = await getAssociatedTokenAddress(inputBank.mint, mangoAccount.owner);
	        const inputTokenAccExists = await this.program.provider.connection.getAccountInfo(inputTokenAccountPk);
	        const preInstructions = [];
	        if (!inputTokenAccExists) {
	            preInstructions.push(await createAssociatedTokenAccountIdempotentInstruction(mangoAccount.owner, mangoAccount.owner, inputBank.mint));
	        }
	        const outputTokenAccountPk = await getAssociatedTokenAddress(outputBank.mint, mangoAccount.owner);
	        const outputTokenAccExists = await this.program.provider.connection.getAccountInfo(outputTokenAccountPk);
	        if (!outputTokenAccExists) {
	            preInstructions.push(await createAssociatedTokenAccountIdempotentInstruction(mangoAccount.owner, mangoAccount.owner, outputBank.mint));
	        }
	        const inputBankAccount = {
	            pubkey: inputBank.publicKey,
	            isWritable: true,
	            isSigner: false,
	        };
	        const outputBankAccount = {
	            pubkey: outputBank.publicKey,
	            isWritable: true,
	            isSigner: false,
	        };
	        const inputBankVault = {
	            pubkey: inputBank.vault,
	            isWritable: true,
	            isSigner: false,
	        };
	        const outputBankVault = {
	            pubkey: outputBank.vault,
	            isWritable: true,
	            isSigner: false,
	        };
	        const inputATA = {
	            pubkey: inputTokenAccountPk,
	            isWritable: true,
	            isSigner: false,
	        };
	        const outputATA = {
	            pubkey: outputTokenAccountPk,
	            isWritable: false,
	            isSigner: false,
	        };
	        const groupAM = {
	            pubkey: group.publicKey,
	            isWritable: false,
	            isSigner: false,
	        };
	        const flashLoanEndIx = await this.program.methods
	            .flashLoanEnd(flashLoanType)
	            .accounts({
	            account: mangoAccount.publicKey,
	        })
	            .remainingAccounts([
	            ...parsedHealthAccounts,
	            inputBankVault,
	            outputBankVault,
	            inputATA,
	            {
	                isWritable: true,
	                pubkey: outputTokenAccountPk,
	                isSigner: false,
	            },
	            groupAM,
	        ])
	            .instruction();
	        const flashLoanBeginIx = await this.program.methods
	            .flashLoanBegin([
	            toNative(amountIn, inputBank.mintDecimals),
	            new anchor.BN(0) /* we don't care about borrowing the target amount, this is just a dummy */,
	        ])
	            .accounts({
	            account: mangoAccount.publicKey,
	            owner: this.program.provider.wallet.publicKey,
	            instructions: require$$0$1.SYSVAR_INSTRUCTIONS_PUBKEY,
	        })
	            .remainingAccounts([
	            inputBankAccount,
	            outputBankAccount,
	            inputBankVault,
	            outputBankVault,
	            inputATA,
	            outputATA,
	            groupAM,
	        ])
	            .instruction();
	        return await this.sendAndConfirmTransactionForGroup(group, [
	            ...preInstructions,
	            flashLoanBeginIx,
	            ...userDefinedInstructions.filter((ix) => ix.keys.length > 2),
	            flashLoanEndIx,
	        ], { alts: [...group.addressLookupTablesList, ...userDefinedAlts] });
	    }
	    async updateIndexAndRate(group, mintPk) {
	        const bank = group.getFirstBankByMint(mintPk);
	        const mintInfo = group.mintInfosMapByMint.get(mintPk.toString());
	        const ix = await this.program.methods
	            .tokenUpdateIndexAndRate()
	            .accounts({
	            group: group.publicKey,
	            mintInfo: mintInfo.publicKey,
	            oracle: mintInfo.oracle,
	            instructions: require$$0$1.SYSVAR_INSTRUCTIONS_PUBKEY,
	        })
	            .remainingAccounts([
	            {
	                pubkey: bank.publicKey,
	                isWritable: true,
	                isSigner: false,
	            },
	        ])
	            .instruction();
	        return await this.sendAndConfirmTransactionForGroup(group, [ix]);
	    }
	    /// liquidations
	    async liqTokenWithToken(group, liqor, liqee, assetMintPk, liabMintPk, maxLiabTransfer) {
	        const assetBank = group.getFirstBankByMint(assetMintPk);
	        const liabBank = group.getFirstBankByMint(liabMintPk);
	        const healthRemainingAccounts = this.buildHealthRemainingAccounts(AccountRetriever.Scanning, group, [liqor, liqee], [assetBank, liabBank], []);
	        const parsedHealthAccounts = healthRemainingAccounts.map((pk) => ({
	            pubkey: pk,
	            isWritable: pk.equals(assetBank.publicKey) || pk.equals(liabBank.publicKey)
	                ? true
	                : false,
	            isSigner: false,
	        }));
	        const ix = await this.program.methods
	            .liqTokenWithToken(assetBank.tokenIndex, liabBank.tokenIndex, {
	            val: I80F48.fromNumber(maxLiabTransfer).getData(),
	        })
	            .accounts({
	            group: group.publicKey,
	            liqor: liqor.publicKey,
	            liqee: liqee.publicKey,
	            liqorOwner: liqor.owner,
	        })
	            .remainingAccounts(parsedHealthAccounts)
	            .instruction();
	        return await this.sendAndConfirmTransactionForGroup(group, [ix]);
	    }
	    async altSet(group, addressLookupTable, index) {
	        const ix = await this.program.methods
	            .altSet(index)
	            .accounts({
	            group: group.publicKey,
	            admin: this.program.provider.wallet.publicKey,
	            addressLookupTable,
	        })
	            .instruction();
	        return await this.sendAndConfirmTransactionForGroup(group, [ix]);
	    }
	    async altExtend(group, addressLookupTable, index, pks) {
	        const ix = await this.program.methods
	            .altExtend(index, pks)
	            .accounts({
	            group: group.publicKey,
	            admin: this.program.provider.wallet.publicKey,
	            payer: this.program.provider.wallet.publicKey,
	            addressLookupTable,
	        })
	            .instruction();
	        return await this.sendAndConfirmTransactionForGroup(group, [ix]);
	    }
	    async healthRegionBeginIx(group, account, banks = [], perpMarkets = []) {
	        const healthRemainingAccounts = this.buildHealthRemainingAccounts(AccountRetriever.Fixed, group, [account], [...banks], [...perpMarkets]);
	        const parsedHealthAccounts = healthRemainingAccounts.map((pk) => ({
	            pubkey: pk,
	            isWritable: false,
	            isSigner: false,
	        }));
	        return await this.program.methods
	            .healthRegionBegin()
	            .accounts({
	            group: group.publicKey,
	            account: account.publicKey,
	            instructions: require$$0$1.SYSVAR_INSTRUCTIONS_PUBKEY,
	        })
	            .remainingAccounts(parsedHealthAccounts)
	            .instruction();
	    }
	    async healthRegionEndIx(group, account, banks = [], perpMarkets = []) {
	        const healthRemainingAccounts = this.buildHealthRemainingAccounts(AccountRetriever.Fixed, group, [account], [...banks], [...perpMarkets]);
	        const parsedHealthAccounts = healthRemainingAccounts.map((pk) => ({
	            pubkey: pk,
	            isWritable: false,
	            isSigner: false,
	        }));
	        return await this.program.methods
	            .healthRegionEnd()
	            .accounts({ account: account.publicKey })
	            .remainingAccounts(parsedHealthAccounts)
	            .instruction();
	    }
	    /// static
	    static connect(provider, cluster, programId, opts) {
	        const idl = IDL;
	        return new MangoClient(new anchor.Program(idl, programId, provider), programId, cluster, opts);
	    }
	    static connectForGroupName(provider, groupName) {
	        const idl = IDL;
	        const id = Id.fromIdsByName(groupName);
	        return new MangoClient(new anchor.Program(idl, new require$$0$1.PublicKey(id.mangoProgramId), provider), new require$$0$1.PublicKey(id.mangoProgramId), id.cluster);
	    }
	    buildHealthRemainingAccounts(retriever, group, mangoAccounts, banks = [], perpMarkets = [], openOrdersForMarket = []) {
	        if (retriever === AccountRetriever.Fixed) {
	            return this.buildFixedAccountRetrieverHealthAccounts(group, mangoAccounts[0], banks, perpMarkets, openOrdersForMarket);
	        }
	        else {
	            return this.buildScanningAccountRetrieverHealthAccounts(group, mangoAccounts, banks, perpMarkets);
	        }
	    }
	    buildFixedAccountRetrieverHealthAccounts(group, mangoAccount, 
	    // Banks and perpMarkets for whom positions don't exist on mango account,
	    // but user would potentially open new positions.
	    banks, perpMarkets, openOrdersForMarket) {
	        const healthRemainingAccounts = [];
	        const tokenPositionIndices = mangoAccount.tokens.map((t) => t.tokenIndex);
	        for (const bank of banks) {
	            const tokenPositionExists = tokenPositionIndices.indexOf(bank.tokenIndex) > -1;
	            if (!tokenPositionExists) {
	                const inactiveTokenPosition = tokenPositionIndices.findIndex((index) => index === TokenPosition.TokenIndexUnset);
	                if (inactiveTokenPosition != -1) {
	                    tokenPositionIndices[inactiveTokenPosition] = bank.tokenIndex;
	                }
	            }
	        }
	        const mintInfos = tokenPositionIndices
	            .filter((tokenIndex) => tokenIndex !== TokenPosition.TokenIndexUnset)
	            .map((tokenIndex) => group.mintInfosMapByTokenIndex.get(tokenIndex));
	        healthRemainingAccounts.push(...mintInfos.map((mintInfo) => mintInfo.firstBank()));
	        healthRemainingAccounts.push(...mintInfos.map((mintInfo) => mintInfo.oracle));
	        // insert any extra perp markets in the free perp position slots
	        const perpPositionIndices = mangoAccount.perps.map((p) => p.marketIndex);
	        for (const perpMarket of perpMarkets) {
	            const perpPositionExists = perpPositionIndices.indexOf(perpMarket.perpMarketIndex) > -1;
	            if (!perpPositionExists) {
	                const inactivePerpPosition = perpPositionIndices.findIndex((perpIdx) => perpIdx === PerpPosition.PerpMarketIndexUnset);
	                if (inactivePerpPosition != -1) {
	                    perpPositionIndices[inactivePerpPosition] =
	                        perpMarket.perpMarketIndex;
	                }
	            }
	        }
	        const allPerpMarkets = perpPositionIndices
	            .filter((perpIdx) => perpIdx !== PerpPosition.PerpMarketIndexUnset)
	            .map((perpIdx) => group.getPerpMarketByMarketIndex(perpIdx));
	        healthRemainingAccounts.push(...allPerpMarkets.map((perp) => perp.publicKey));
	        healthRemainingAccounts.push(...allPerpMarkets.map((perp) => perp.oracle));
	        // insert any extra open orders accounts in the cooresponding free serum market slot
	        const serumPositionIndices = mangoAccount.serum3.map((s) => ({
	            marketIndex: s.marketIndex,
	            openOrders: s.openOrders,
	        }));
	        for (const [serum3Market, openOrderPk] of openOrdersForMarket) {
	            const ooPositionExists = serumPositionIndices.findIndex((i) => i.marketIndex === serum3Market.marketIndex) > -1;
	            if (!ooPositionExists) {
	                const inactiveSerumPosition = serumPositionIndices.findIndex((serumPos) => serumPos.marketIndex === Serum3Orders.Serum3MarketIndexUnset);
	                if (inactiveSerumPosition != -1) {
	                    serumPositionIndices[inactiveSerumPosition].marketIndex =
	                        serum3Market.marketIndex;
	                    serumPositionIndices[inactiveSerumPosition].openOrders = openOrderPk;
	                }
	            }
	        }
	        healthRemainingAccounts.push(...serumPositionIndices
	            .filter((serumPosition) => serumPosition.marketIndex !== Serum3Orders.Serum3MarketIndexUnset)
	            .map((serumPosition) => serumPosition.openOrders));
	        // debugHealthAccounts(group, mangoAccount, healthRemainingAccounts);
	        return healthRemainingAccounts;
	    }
	    buildScanningAccountRetrieverHealthAccounts(group, mangoAccounts, banks, perpMarkets) {
	        const healthRemainingAccounts = [];
	        let tokenIndices = [];
	        for (const mangoAccount of mangoAccounts) {
	            tokenIndices.push(...mangoAccount.tokens
	                .filter((token) => token.tokenIndex !== 65535)
	                .map((token) => token.tokenIndex));
	        }
	        tokenIndices = [...new Set(tokenIndices)];
	        if (banks?.length) {
	            for (const bank of banks) {
	                tokenIndices.push(bank.tokenIndex);
	            }
	        }
	        const mintInfos = [...new Set(tokenIndices)].map((tokenIndex) => group.mintInfosMapByTokenIndex.get(tokenIndex));
	        healthRemainingAccounts.push(...mintInfos.map((mintInfo) => mintInfo.firstBank()));
	        healthRemainingAccounts.push(...mintInfos.map((mintInfo) => mintInfo.oracle));
	        const perpIndices = [];
	        for (const mangoAccount of mangoAccounts) {
	            perpIndices.push(...mangoAccount.perps
	                .filter((perp) => perp.marketIndex !== 65535)
	                .map((perp) => perp.marketIndex));
	        }
	        perpIndices.push(...perpMarkets.map((perp) => perp.perpMarketIndex));
	        const allPerpMarkets = [...new Set(perpIndices)].map((marketIndex) => group.findPerpMarket(marketIndex));
	        // Add perp accounts
	        healthRemainingAccounts.push(...allPerpMarkets.map((p) => p.publicKey));
	        // Add oracle for each perp
	        healthRemainingAccounts.push(...allPerpMarkets.map((p) => p.oracle));
	        for (const mangoAccount of mangoAccounts) {
	            healthRemainingAccounts.push(...mangoAccount.serum3
	                .filter((serum3Account) => serum3Account.marketIndex !== 65535)
	                .map((serum3Account) => serum3Account.openOrders));
	        }
	        return healthRemainingAccounts;
	    }
	    async modifyPerpOrder(group, mangoAccount, perpMarketIndex, orderId, side, price, quantity, maxQuoteQuantity, clientOrderId, orderType, reduceOnly, expiryTimestamp, limit) {
	        const transactionInstructions = [];
	        const [cancelOrderIx, placeOrderIx] = await Promise.all([
	            this.perpCancelOrderIx(group, mangoAccount, perpMarketIndex, orderId),
	            this.perpPlaceOrderIx(group, mangoAccount, perpMarketIndex, side, price, quantity, maxQuoteQuantity, clientOrderId, orderType, reduceOnly, expiryTimestamp, limit),
	        ]);
	        transactionInstructions.push(cancelOrderIx, placeOrderIx);
	        return await this.sendAndConfirmTransactionForGroup(group, transactionInstructions);
	    }
	    async modifySerum3Order(group, orderId, mangoAccount, externalMarketPk, side, price, size, selfTradeBehavior, orderType, clientOrderId, limit) {
	        const transactionInstructions = [];
	        const [cancelOrderIx, settleIx, placeOrderIx] = await Promise.all([
	            this.serum3CancelOrderIx(group, mangoAccount, externalMarketPk, side, orderId),
	            this.serum3SettleFundsIx(group, mangoAccount, externalMarketPk),
	            this.serum3PlaceOrderIx(group, mangoAccount, externalMarketPk, side, price, size, selfTradeBehavior, orderType, clientOrderId, limit),
	        ]);
	        transactionInstructions.push(cancelOrderIx, settleIx, ...placeOrderIx);
	        return await this.sendAndConfirmTransactionForGroup(group, transactionInstructions);
	    }
	}

	exports.Bank = Bank;
	exports.BookSide = BookSide;
	exports.BookSideType = BookSideType;
	exports.Group = Group;
	exports.HUNDRED_I80F48 = HUNDRED_I80F48;
	exports.HealthType = HealthType;
	exports.I64_MAX_BN = I64_MAX_BN;
	exports.I80F48 = I80F48;
	exports.I80F48Dto = I80F48Dto;
	exports.InnerNode = InnerNode;
	exports.LeafNode = LeafNode;
	exports.MANGO_V4_ID = MANGO_V4_ID;
	exports.MAX_I80F48 = MAX_I80F48;
	exports.MangoAccount = MangoAccount;
	exports.MangoClient = MangoClient;
	exports.MintInfo = MintInfo;
	exports.NullPerpEditParams = NullPerpEditParams;
	exports.NullTokenEditParams = NullTokenEditParams;
	exports.ONE_I80F48 = ONE_I80F48;
	exports.OPENBOOK_PROGRAM_ID = OPENBOOK_PROGRAM_ID;
	exports.PerpEventQueue = PerpEventQueue;
	exports.PerpMarket = PerpMarket;
	exports.PerpOo = PerpOo;
	exports.PerpOoDto = PerpOoDto;
	exports.PerpOrder = PerpOrder;
	exports.PerpOrderSide = PerpOrderSide;
	exports.PerpOrderType = PerpOrderType;
	exports.PerpPosition = PerpPosition;
	exports.PerpPositionDto = PerpPositionDto;
	exports.QUOTE_DECIMALS = QUOTE_DECIMALS;
	exports.RUST_I64_MAX = RUST_I64_MAX;
	exports.RUST_I64_MIN = RUST_I64_MIN;
	exports.RUST_U64_MAX = RUST_U64_MAX;
	exports.Serum3Market = Serum3Market;
	exports.Serum3OrderType = Serum3OrderType;
	exports.Serum3Orders = Serum3Orders;
	exports.Serum3PositionDto = Serum3PositionDto;
	exports.Serum3SelfTradeBehavior = Serum3SelfTradeBehavior;
	exports.Serum3Side = Serum3Side;
	exports.StubOracle = StubOracle;
	exports.TokenPosition = TokenPosition;
	exports.TokenPositionDto = TokenPositionDto;
	exports.TrueIxGateParams = TrueIxGateParams;
	exports.U64_MAX_BN = U64_MAX_BN;
	exports.ZERO_I80F48 = ZERO_I80F48;
	exports.buildIxGate = buildIxGate;
	exports.buildVersionedTx = buildVersionedTx;
	exports.createAssociatedTokenAccountIdempotentInstruction = createAssociatedTokenAccountIdempotentInstruction;
	exports.getAssociatedTokenAddress = getAssociatedTokenAddress;
	exports.toNative = toNative;
	exports.toNativeI80F48 = toNativeI80F48;
	exports.toNativeI80F48ForQuote = toNativeI80F48ForQuote;
	exports.toUiDecimals = toUiDecimals;
	exports.toUiDecimalsForQuote = toUiDecimalsForQuote;
	exports.toUiI80F48 = toUiI80F48;

}));
